/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * BPF Disassembler                                                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static void insertBits(InsnType &field, InsnType bits, unsigned startBit,
                       unsigned numBits) {
  if constexpr (std::is_integral<InsnType>::value) {
    assert(startBit + numBits <= sizeof field * 8);
    (void)numBits;
    field |= (InsnType)bits << startBit;
  } else {
    field.insertBits(bits, startBit, numBits);
  }
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTableBPF64[] = {
/* 0 */       MCD::OPC_ExtractField, 56, 8,  // Inst{63-56} ...
/* 3 */       MCD::OPC_FilterValue, 4, 10, 0, // Skip to: 17
/* 7 */       MCD::OPC_CheckField, 32, 16, 0, 147, 6, // Skip to: 1696
/* 13 */      MCD::OPC_Decode, 196, 2, 0, // Opcode: ADD_ri_32
/* 17 */      MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 25
/* 21 */      MCD::OPC_Decode, 226, 2, 1, // Opcode: JMP
/* 25 */      MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 33
/* 29 */      MCD::OPC_Decode, 227, 2, 2, // Opcode: JMPL
/* 33 */      MCD::OPC_FilterValue, 7, 10, 0, // Skip to: 47
/* 37 */      MCD::OPC_CheckField, 32, 16, 0, 117, 6, // Skip to: 1696
/* 43 */      MCD::OPC_Decode, 195, 2, 3, // Opcode: ADD_ri
/* 47 */      MCD::OPC_FilterValue, 12, 10, 0, // Skip to: 61
/* 51 */      MCD::OPC_CheckField, 32, 16, 0, 103, 6, // Skip to: 1696
/* 57 */      MCD::OPC_Decode, 198, 2, 4, // Opcode: ADD_rr_32
/* 61 */      MCD::OPC_FilterValue, 15, 10, 0, // Skip to: 75
/* 65 */      MCD::OPC_CheckField, 32, 16, 0, 89, 6, // Skip to: 1696
/* 71 */      MCD::OPC_Decode, 197, 2, 5, // Opcode: ADD_rr
/* 75 */      MCD::OPC_FilterValue, 20, 10, 0, // Skip to: 89
/* 79 */      MCD::OPC_CheckField, 32, 16, 0, 75, 6, // Skip to: 1696
/* 85 */      MCD::OPC_Decode, 227, 3, 0, // Opcode: SUB_ri_32
/* 89 */      MCD::OPC_FilterValue, 21, 4, 0, // Skip to: 97
/* 93 */      MCD::OPC_Decode, 222, 2, 6, // Opcode: JEQ_ri
/* 97 */      MCD::OPC_FilterValue, 22, 4, 0, // Skip to: 105
/* 101 */     MCD::OPC_Decode, 223, 2, 7, // Opcode: JEQ_ri_32
/* 105 */     MCD::OPC_FilterValue, 23, 10, 0, // Skip to: 119
/* 109 */     MCD::OPC_CheckField, 32, 16, 0, 45, 6, // Skip to: 1696
/* 115 */     MCD::OPC_Decode, 226, 3, 3, // Opcode: SUB_ri
/* 119 */     MCD::OPC_FilterValue, 24, 21, 0, // Skip to: 144
/* 123 */     MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 126 */     MCD::OPC_FilterValue, 0, 30, 6, // Skip to: 1696
/* 130 */     MCD::OPC_CheckField, 52, 4, 0, 4, 0, // Skip to: 140
/* 136 */     MCD::OPC_Decode, 160, 3, 8, // Opcode: LD_imm64
/* 140 */     MCD::OPC_Decode, 161, 3, 9, // Opcode: LD_pseudo
/* 144 */     MCD::OPC_FilterValue, 28, 10, 0, // Skip to: 158
/* 148 */     MCD::OPC_CheckField, 32, 16, 0, 6, 6, // Skip to: 1696
/* 154 */     MCD::OPC_Decode, 229, 3, 4, // Opcode: SUB_rr_32
/* 158 */     MCD::OPC_FilterValue, 29, 4, 0, // Skip to: 166
/* 162 */     MCD::OPC_Decode, 224, 2, 10, // Opcode: JEQ_rr
/* 166 */     MCD::OPC_FilterValue, 30, 4, 0, // Skip to: 174
/* 170 */     MCD::OPC_Decode, 225, 2, 11, // Opcode: JEQ_rr_32
/* 174 */     MCD::OPC_FilterValue, 31, 10, 0, // Skip to: 188
/* 178 */     MCD::OPC_CheckField, 32, 16, 0, 232, 5, // Skip to: 1696
/* 184 */     MCD::OPC_Decode, 228, 3, 5, // Opcode: SUB_rr
/* 188 */     MCD::OPC_FilterValue, 32, 4, 0, // Skip to: 196
/* 192 */     MCD::OPC_Decode, 156, 3, 2, // Opcode: LD_ABS_W
/* 196 */     MCD::OPC_FilterValue, 36, 10, 0, // Skip to: 210
/* 200 */     MCD::OPC_CheckField, 32, 16, 0, 210, 5, // Skip to: 1696
/* 206 */     MCD::OPC_Decode, 180, 3, 0, // Opcode: MUL_ri_32
/* 210 */     MCD::OPC_FilterValue, 37, 4, 0, // Skip to: 218
/* 214 */     MCD::OPC_Decode, 128, 3, 6, // Opcode: JUGT_ri
/* 218 */     MCD::OPC_FilterValue, 38, 4, 0, // Skip to: 226
/* 222 */     MCD::OPC_Decode, 129, 3, 7, // Opcode: JUGT_ri_32
/* 226 */     MCD::OPC_FilterValue, 39, 10, 0, // Skip to: 240
/* 230 */     MCD::OPC_CheckField, 32, 16, 0, 180, 5, // Skip to: 1696
/* 236 */     MCD::OPC_Decode, 179, 3, 3, // Opcode: MUL_ri
/* 240 */     MCD::OPC_FilterValue, 40, 4, 0, // Skip to: 248
/* 244 */     MCD::OPC_Decode, 155, 3, 2, // Opcode: LD_ABS_H
/* 248 */     MCD::OPC_FilterValue, 44, 10, 0, // Skip to: 262
/* 252 */     MCD::OPC_CheckField, 32, 16, 0, 158, 5, // Skip to: 1696
/* 258 */     MCD::OPC_Decode, 182, 3, 4, // Opcode: MUL_rr_32
/* 262 */     MCD::OPC_FilterValue, 45, 4, 0, // Skip to: 270
/* 266 */     MCD::OPC_Decode, 130, 3, 10, // Opcode: JUGT_rr
/* 270 */     MCD::OPC_FilterValue, 46, 4, 0, // Skip to: 278
/* 274 */     MCD::OPC_Decode, 131, 3, 11, // Opcode: JUGT_rr_32
/* 278 */     MCD::OPC_FilterValue, 47, 10, 0, // Skip to: 292
/* 282 */     MCD::OPC_CheckField, 32, 16, 0, 128, 5, // Skip to: 1696
/* 288 */     MCD::OPC_Decode, 181, 3, 5, // Opcode: MUL_rr
/* 292 */     MCD::OPC_FilterValue, 48, 4, 0, // Skip to: 300
/* 296 */     MCD::OPC_Decode, 154, 3, 2, // Opcode: LD_ABS_B
/* 300 */     MCD::OPC_FilterValue, 52, 19, 0, // Skip to: 323
/* 304 */     MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 307 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 315
/* 311 */     MCD::OPC_Decode, 216, 2, 0, // Opcode: DIV_ri_32
/* 315 */     MCD::OPC_FilterValue, 1, 97, 5, // Skip to: 1696
/* 319 */     MCD::OPC_Decode, 192, 3, 0, // Opcode: SDIV_ri_32
/* 323 */     MCD::OPC_FilterValue, 53, 4, 0, // Skip to: 331
/* 327 */     MCD::OPC_Decode, 252, 2, 6, // Opcode: JUGE_ri
/* 331 */     MCD::OPC_FilterValue, 54, 4, 0, // Skip to: 339
/* 335 */     MCD::OPC_Decode, 253, 2, 7, // Opcode: JUGE_ri_32
/* 339 */     MCD::OPC_FilterValue, 55, 19, 0, // Skip to: 362
/* 343 */     MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 346 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 354
/* 350 */     MCD::OPC_Decode, 215, 2, 3, // Opcode: DIV_ri
/* 354 */     MCD::OPC_FilterValue, 1, 58, 5, // Skip to: 1696
/* 358 */     MCD::OPC_Decode, 191, 3, 3, // Opcode: SDIV_ri
/* 362 */     MCD::OPC_FilterValue, 60, 19, 0, // Skip to: 385
/* 366 */     MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 369 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 377
/* 373 */     MCD::OPC_Decode, 218, 2, 4, // Opcode: DIV_rr_32
/* 377 */     MCD::OPC_FilterValue, 1, 35, 5, // Skip to: 1696
/* 381 */     MCD::OPC_Decode, 194, 3, 4, // Opcode: SDIV_rr_32
/* 385 */     MCD::OPC_FilterValue, 61, 4, 0, // Skip to: 393
/* 389 */     MCD::OPC_Decode, 254, 2, 10, // Opcode: JUGE_rr
/* 393 */     MCD::OPC_FilterValue, 62, 4, 0, // Skip to: 401
/* 397 */     MCD::OPC_Decode, 255, 2, 11, // Opcode: JUGE_rr_32
/* 401 */     MCD::OPC_FilterValue, 63, 19, 0, // Skip to: 424
/* 405 */     MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 408 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 416
/* 412 */     MCD::OPC_Decode, 217, 2, 5, // Opcode: DIV_rr
/* 416 */     MCD::OPC_FilterValue, 1, 252, 4, // Skip to: 1696
/* 420 */     MCD::OPC_Decode, 193, 3, 5, // Opcode: SDIV_rr
/* 424 */     MCD::OPC_FilterValue, 64, 4, 0, // Skip to: 432
/* 428 */     MCD::OPC_Decode, 159, 3, 12, // Opcode: LD_IND_W
/* 432 */     MCD::OPC_FilterValue, 68, 10, 0, // Skip to: 446
/* 436 */     MCD::OPC_CheckField, 32, 16, 0, 230, 4, // Skip to: 1696
/* 442 */     MCD::OPC_Decode, 187, 3, 0, // Opcode: OR_ri_32
/* 446 */     MCD::OPC_FilterValue, 69, 4, 0, // Skip to: 454
/* 450 */     MCD::OPC_Decode, 232, 2, 6, // Opcode: JSET_ri
/* 454 */     MCD::OPC_FilterValue, 70, 4, 0, // Skip to: 462
/* 458 */     MCD::OPC_Decode, 233, 2, 7, // Opcode: JSET_ri_32
/* 462 */     MCD::OPC_FilterValue, 71, 10, 0, // Skip to: 476
/* 466 */     MCD::OPC_CheckField, 32, 16, 0, 200, 4, // Skip to: 1696
/* 472 */     MCD::OPC_Decode, 186, 3, 3, // Opcode: OR_ri
/* 476 */     MCD::OPC_FilterValue, 72, 4, 0, // Skip to: 484
/* 480 */     MCD::OPC_Decode, 158, 3, 12, // Opcode: LD_IND_H
/* 484 */     MCD::OPC_FilterValue, 76, 10, 0, // Skip to: 498
/* 488 */     MCD::OPC_CheckField, 32, 16, 0, 178, 4, // Skip to: 1696
/* 494 */     MCD::OPC_Decode, 189, 3, 4, // Opcode: OR_rr_32
/* 498 */     MCD::OPC_FilterValue, 77, 4, 0, // Skip to: 506
/* 502 */     MCD::OPC_Decode, 234, 2, 10, // Opcode: JSET_rr
/* 506 */     MCD::OPC_FilterValue, 78, 4, 0, // Skip to: 514
/* 510 */     MCD::OPC_Decode, 235, 2, 11, // Opcode: JSET_rr_32
/* 514 */     MCD::OPC_FilterValue, 79, 10, 0, // Skip to: 528
/* 518 */     MCD::OPC_CheckField, 32, 16, 0, 148, 4, // Skip to: 1696
/* 524 */     MCD::OPC_Decode, 188, 3, 5, // Opcode: OR_rr
/* 528 */     MCD::OPC_FilterValue, 80, 4, 0, // Skip to: 536
/* 532 */     MCD::OPC_Decode, 157, 3, 12, // Opcode: LD_IND_B
/* 536 */     MCD::OPC_FilterValue, 84, 10, 0, // Skip to: 550
/* 540 */     MCD::OPC_CheckField, 32, 16, 0, 126, 4, // Skip to: 1696
/* 546 */     MCD::OPC_Decode, 200, 2, 0, // Opcode: AND_ri_32
/* 550 */     MCD::OPC_FilterValue, 85, 4, 0, // Skip to: 558
/* 554 */     MCD::OPC_Decode, 228, 2, 6, // Opcode: JNE_ri
/* 558 */     MCD::OPC_FilterValue, 86, 4, 0, // Skip to: 566
/* 562 */     MCD::OPC_Decode, 229, 2, 7, // Opcode: JNE_ri_32
/* 566 */     MCD::OPC_FilterValue, 87, 10, 0, // Skip to: 580
/* 570 */     MCD::OPC_CheckField, 32, 16, 0, 96, 4, // Skip to: 1696
/* 576 */     MCD::OPC_Decode, 199, 2, 3, // Opcode: AND_ri
/* 580 */     MCD::OPC_FilterValue, 92, 10, 0, // Skip to: 594
/* 584 */     MCD::OPC_CheckField, 32, 16, 0, 82, 4, // Skip to: 1696
/* 590 */     MCD::OPC_Decode, 202, 2, 4, // Opcode: AND_rr_32
/* 594 */     MCD::OPC_FilterValue, 93, 4, 0, // Skip to: 602
/* 598 */     MCD::OPC_Decode, 230, 2, 10, // Opcode: JNE_rr
/* 602 */     MCD::OPC_FilterValue, 94, 4, 0, // Skip to: 610
/* 606 */     MCD::OPC_Decode, 231, 2, 11, // Opcode: JNE_rr_32
/* 610 */     MCD::OPC_FilterValue, 95, 10, 0, // Skip to: 624
/* 614 */     MCD::OPC_CheckField, 32, 16, 0, 52, 4, // Skip to: 1696
/* 620 */     MCD::OPC_Decode, 201, 2, 5, // Opcode: AND_rr
/* 624 */     MCD::OPC_FilterValue, 97, 4, 0, // Skip to: 632
/* 628 */     MCD::OPC_Decode, 150, 3, 13, // Opcode: LDW
/* 632 */     MCD::OPC_FilterValue, 98, 4, 0, // Skip to: 640
/* 636 */     MCD::OPC_Decode, 225, 3, 14, // Opcode: STW_imm
/* 640 */     MCD::OPC_FilterValue, 99, 4, 0, // Skip to: 648
/* 644 */     MCD::OPC_Decode, 222, 3, 15, // Opcode: STW
/* 648 */     MCD::OPC_FilterValue, 100, 10, 0, // Skip to: 662
/* 652 */     MCD::OPC_CheckField, 32, 16, 0, 14, 4, // Skip to: 1696
/* 658 */     MCD::OPC_Decode, 196, 3, 0, // Opcode: SLL_ri_32
/* 662 */     MCD::OPC_FilterValue, 101, 4, 0, // Skip to: 670
/* 666 */     MCD::OPC_Decode, 240, 2, 6, // Opcode: JSGT_ri
/* 670 */     MCD::OPC_FilterValue, 102, 4, 0, // Skip to: 678
/* 674 */     MCD::OPC_Decode, 241, 2, 7, // Opcode: JSGT_ri_32
/* 678 */     MCD::OPC_FilterValue, 103, 10, 0, // Skip to: 692
/* 682 */     MCD::OPC_CheckField, 32, 16, 0, 240, 3, // Skip to: 1696
/* 688 */     MCD::OPC_Decode, 195, 3, 3, // Opcode: SLL_ri
/* 692 */     MCD::OPC_FilterValue, 105, 4, 0, // Skip to: 700
/* 696 */     MCD::OPC_Decode, 146, 3, 13, // Opcode: LDH
/* 700 */     MCD::OPC_FilterValue, 106, 4, 0, // Skip to: 708
/* 704 */     MCD::OPC_Decode, 221, 3, 14, // Opcode: STH_imm
/* 708 */     MCD::OPC_FilterValue, 107, 4, 0, // Skip to: 716
/* 712 */     MCD::OPC_Decode, 218, 3, 15, // Opcode: STH
/* 716 */     MCD::OPC_FilterValue, 108, 10, 0, // Skip to: 730
/* 720 */     MCD::OPC_CheckField, 32, 16, 0, 202, 3, // Skip to: 1696
/* 726 */     MCD::OPC_Decode, 198, 3, 4, // Opcode: SLL_rr_32
/* 730 */     MCD::OPC_FilterValue, 109, 4, 0, // Skip to: 738
/* 734 */     MCD::OPC_Decode, 242, 2, 10, // Opcode: JSGT_rr
/* 738 */     MCD::OPC_FilterValue, 110, 4, 0, // Skip to: 746
/* 742 */     MCD::OPC_Decode, 243, 2, 11, // Opcode: JSGT_rr_32
/* 746 */     MCD::OPC_FilterValue, 111, 10, 0, // Skip to: 760
/* 750 */     MCD::OPC_CheckField, 32, 16, 0, 172, 3, // Skip to: 1696
/* 756 */     MCD::OPC_Decode, 197, 3, 5, // Opcode: SLL_rr
/* 760 */     MCD::OPC_FilterValue, 113, 4, 0, // Skip to: 768
/* 764 */     MCD::OPC_Decode, 140, 3, 13, // Opcode: LDB
/* 768 */     MCD::OPC_FilterValue, 114, 4, 0, // Skip to: 776
/* 772 */     MCD::OPC_Decode, 214, 3, 14, // Opcode: STB_imm
/* 776 */     MCD::OPC_FilterValue, 115, 4, 0, // Skip to: 784
/* 780 */     MCD::OPC_Decode, 211, 3, 15, // Opcode: STB
/* 784 */     MCD::OPC_FilterValue, 116, 10, 0, // Skip to: 798
/* 788 */     MCD::OPC_CheckField, 32, 16, 0, 134, 3, // Skip to: 1696
/* 794 */     MCD::OPC_Decode, 208, 3, 0, // Opcode: SRL_ri_32
/* 798 */     MCD::OPC_FilterValue, 117, 4, 0, // Skip to: 806
/* 802 */     MCD::OPC_Decode, 236, 2, 6, // Opcode: JSGE_ri
/* 806 */     MCD::OPC_FilterValue, 118, 4, 0, // Skip to: 814
/* 810 */     MCD::OPC_Decode, 237, 2, 7, // Opcode: JSGE_ri_32
/* 814 */     MCD::OPC_FilterValue, 119, 10, 0, // Skip to: 828
/* 818 */     MCD::OPC_CheckField, 32, 16, 0, 104, 3, // Skip to: 1696
/* 824 */     MCD::OPC_Decode, 207, 3, 3, // Opcode: SRL_ri
/* 828 */     MCD::OPC_FilterValue, 121, 4, 0, // Skip to: 836
/* 832 */     MCD::OPC_Decode, 144, 3, 13, // Opcode: LDD
/* 836 */     MCD::OPC_FilterValue, 122, 4, 0, // Skip to: 844
/* 840 */     MCD::OPC_Decode, 217, 3, 14, // Opcode: STD_imm
/* 844 */     MCD::OPC_FilterValue, 123, 4, 0, // Skip to: 852
/* 848 */     MCD::OPC_Decode, 215, 3, 15, // Opcode: STD
/* 852 */     MCD::OPC_FilterValue, 124, 10, 0, // Skip to: 866
/* 856 */     MCD::OPC_CheckField, 32, 16, 0, 66, 3, // Skip to: 1696
/* 862 */     MCD::OPC_Decode, 210, 3, 4, // Opcode: SRL_rr_32
/* 866 */     MCD::OPC_FilterValue, 125, 4, 0, // Skip to: 874
/* 870 */     MCD::OPC_Decode, 238, 2, 10, // Opcode: JSGE_rr
/* 874 */     MCD::OPC_FilterValue, 126, 4, 0, // Skip to: 882
/* 878 */     MCD::OPC_Decode, 239, 2, 11, // Opcode: JSGE_rr_32
/* 882 */     MCD::OPC_FilterValue, 127, 10, 0, // Skip to: 896
/* 886 */     MCD::OPC_CheckField, 32, 16, 0, 36, 3, // Skip to: 1696
/* 892 */     MCD::OPC_Decode, 209, 3, 5, // Opcode: SRL_rr
/* 896 */     MCD::OPC_FilterValue, 129, 1, 4, 0, // Skip to: 905
/* 901 */     MCD::OPC_Decode, 153, 3, 13, // Opcode: LDWSX
/* 905 */     MCD::OPC_FilterValue, 132, 1, 4, 0, // Skip to: 914
/* 910 */     MCD::OPC_Decode, 183, 3, 16, // Opcode: NEG_32
/* 914 */     MCD::OPC_FilterValue, 133, 1, 4, 0, // Skip to: 923
/* 919 */     MCD::OPC_Decode, 219, 2, 2, // Opcode: JAL
/* 923 */     MCD::OPC_FilterValue, 135, 1, 4, 0, // Skip to: 932
/* 928 */     MCD::OPC_Decode, 184, 3, 17, // Opcode: NEG_64
/* 932 */     MCD::OPC_FilterValue, 137, 1, 4, 0, // Skip to: 941
/* 937 */     MCD::OPC_Decode, 149, 3, 13, // Opcode: LDHSX
/* 941 */     MCD::OPC_FilterValue, 141, 1, 4, 0, // Skip to: 950
/* 946 */     MCD::OPC_Decode, 220, 2, 18, // Opcode: JALX
/* 950 */     MCD::OPC_FilterValue, 145, 1, 4, 0, // Skip to: 959
/* 955 */     MCD::OPC_Decode, 143, 3, 13, // Opcode: LDBSX
/* 959 */     MCD::OPC_FilterValue, 148, 1, 19, 0, // Skip to: 983
/* 964 */     MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 967 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 975
/* 971 */     MCD::OPC_Decode, 166, 3, 0, // Opcode: MOD_ri_32
/* 975 */     MCD::OPC_FilterValue, 1, 205, 2, // Skip to: 1696
/* 979 */     MCD::OPC_Decode, 200, 3, 0, // Opcode: SMOD_ri_32
/* 983 */     MCD::OPC_FilterValue, 149, 1, 10, 0, // Skip to: 998
/* 988 */     MCD::OPC_CheckField, 0, 32, 0, 190, 2, // Skip to: 1696
/* 994 */     MCD::OPC_Decode, 190, 3, 19, // Opcode: RET
/* 998 */     MCD::OPC_FilterValue, 151, 1, 19, 0, // Skip to: 1022
/* 1003 */    MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 1006 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1014
/* 1010 */    MCD::OPC_Decode, 165, 3, 3, // Opcode: MOD_ri
/* 1014 */    MCD::OPC_FilterValue, 1, 166, 2, // Skip to: 1696
/* 1018 */    MCD::OPC_Decode, 199, 3, 3, // Opcode: SMOD_ri
/* 1022 */    MCD::OPC_FilterValue, 156, 1, 19, 0, // Skip to: 1046
/* 1027 */    MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 1030 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1038
/* 1034 */    MCD::OPC_Decode, 168, 3, 4, // Opcode: MOD_rr_32
/* 1038 */    MCD::OPC_FilterValue, 1, 142, 2, // Skip to: 1696
/* 1042 */    MCD::OPC_Decode, 202, 3, 4, // Opcode: SMOD_rr_32
/* 1046 */    MCD::OPC_FilterValue, 159, 1, 19, 0, // Skip to: 1070
/* 1051 */    MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 1054 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1062
/* 1058 */    MCD::OPC_Decode, 167, 3, 5, // Opcode: MOD_rr
/* 1062 */    MCD::OPC_FilterValue, 1, 118, 2, // Skip to: 1696
/* 1066 */    MCD::OPC_Decode, 201, 3, 5, // Opcode: SMOD_rr
/* 1070 */    MCD::OPC_FilterValue, 164, 1, 10, 0, // Skip to: 1085
/* 1075 */    MCD::OPC_CheckField, 32, 16, 0, 103, 2, // Skip to: 1696
/* 1081 */    MCD::OPC_Decode, 248, 3, 0, // Opcode: XOR_ri_32
/* 1085 */    MCD::OPC_FilterValue, 165, 1, 4, 0, // Skip to: 1094
/* 1090 */    MCD::OPC_Decode, 136, 3, 6, // Opcode: JULT_ri
/* 1094 */    MCD::OPC_FilterValue, 166, 1, 4, 0, // Skip to: 1103
/* 1099 */    MCD::OPC_Decode, 137, 3, 7, // Opcode: JULT_ri_32
/* 1103 */    MCD::OPC_FilterValue, 167, 1, 10, 0, // Skip to: 1118
/* 1108 */    MCD::OPC_CheckField, 32, 16, 0, 70, 2, // Skip to: 1696
/* 1114 */    MCD::OPC_Decode, 247, 3, 3, // Opcode: XOR_ri
/* 1118 */    MCD::OPC_FilterValue, 172, 1, 10, 0, // Skip to: 1133
/* 1123 */    MCD::OPC_CheckField, 32, 16, 0, 55, 2, // Skip to: 1696
/* 1129 */    MCD::OPC_Decode, 250, 3, 4, // Opcode: XOR_rr_32
/* 1133 */    MCD::OPC_FilterValue, 173, 1, 4, 0, // Skip to: 1142
/* 1138 */    MCD::OPC_Decode, 138, 3, 10, // Opcode: JULT_rr
/* 1142 */    MCD::OPC_FilterValue, 174, 1, 4, 0, // Skip to: 1151
/* 1147 */    MCD::OPC_Decode, 139, 3, 11, // Opcode: JULT_rr_32
/* 1151 */    MCD::OPC_FilterValue, 175, 1, 10, 0, // Skip to: 1166
/* 1156 */    MCD::OPC_CheckField, 32, 16, 0, 22, 2, // Skip to: 1696
/* 1162 */    MCD::OPC_Decode, 249, 3, 5, // Opcode: XOR_rr
/* 1166 */    MCD::OPC_FilterValue, 180, 1, 10, 0, // Skip to: 1181
/* 1171 */    MCD::OPC_CheckField, 32, 16, 0, 7, 2, // Skip to: 1696
/* 1177 */    MCD::OPC_Decode, 176, 3, 20, // Opcode: MOV_ri_32
/* 1181 */    MCD::OPC_FilterValue, 181, 1, 4, 0, // Skip to: 1190
/* 1186 */    MCD::OPC_Decode, 132, 3, 6, // Opcode: JULE_ri
/* 1190 */    MCD::OPC_FilterValue, 182, 1, 4, 0, // Skip to: 1199
/* 1195 */    MCD::OPC_Decode, 133, 3, 7, // Opcode: JULE_ri_32
/* 1199 */    MCD::OPC_FilterValue, 183, 1, 10, 0, // Skip to: 1214
/* 1204 */    MCD::OPC_CheckField, 32, 16, 0, 230, 1, // Skip to: 1696
/* 1210 */    MCD::OPC_Decode, 175, 3, 8, // Opcode: MOV_ri
/* 1214 */    MCD::OPC_FilterValue, 188, 1, 27, 0, // Skip to: 1246
/* 1219 */    MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 1222 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1230
/* 1226 */    MCD::OPC_Decode, 178, 3, 21, // Opcode: MOV_rr_32
/* 1230 */    MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 1238
/* 1234 */    MCD::OPC_Decode, 172, 3, 21, // Opcode: MOVSX_rr_32_8
/* 1238 */    MCD::OPC_FilterValue, 16, 198, 1, // Skip to: 1696
/* 1242 */    MCD::OPC_Decode, 171, 3, 21, // Opcode: MOVSX_rr_32_16
/* 1246 */    MCD::OPC_FilterValue, 189, 1, 4, 0, // Skip to: 1255
/* 1251 */    MCD::OPC_Decode, 134, 3, 10, // Opcode: JULE_rr
/* 1255 */    MCD::OPC_FilterValue, 190, 1, 4, 0, // Skip to: 1264
/* 1260 */    MCD::OPC_Decode, 135, 3, 11, // Opcode: JULE_rr_32
/* 1264 */    MCD::OPC_FilterValue, 191, 1, 43, 0, // Skip to: 1312
/* 1269 */    MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 1272 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1280
/* 1276 */    MCD::OPC_Decode, 177, 3, 22, // Opcode: MOV_rr
/* 1280 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1288
/* 1284 */    MCD::OPC_Decode, 194, 2, 23, // Opcode: ADDR_SPACE_CAST
/* 1288 */    MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 1296
/* 1292 */    MCD::OPC_Decode, 173, 3, 22, // Opcode: MOVSX_rr_8
/* 1296 */    MCD::OPC_FilterValue, 16, 4, 0, // Skip to: 1304
/* 1300 */    MCD::OPC_Decode, 169, 3, 22, // Opcode: MOVSX_rr_16
/* 1304 */    MCD::OPC_FilterValue, 32, 132, 1, // Skip to: 1696
/* 1308 */    MCD::OPC_Decode, 170, 3, 22, // Opcode: MOVSX_rr_32
/* 1312 */    MCD::OPC_FilterValue, 195, 1, 10, 0, // Skip to: 1327
/* 1317 */    MCD::OPC_CheckField, 4, 4, 0, 117, 1, // Skip to: 1696
/* 1323 */    MCD::OPC_Decode, 231, 3, 24, // Opcode: XADDW
/* 1327 */    MCD::OPC_FilterValue, 196, 1, 10, 0, // Skip to: 1342
/* 1332 */    MCD::OPC_CheckField, 32, 16, 0, 102, 1, // Skip to: 1696
/* 1338 */    MCD::OPC_Decode, 204, 3, 0, // Opcode: SRA_ri_32
/* 1342 */    MCD::OPC_FilterValue, 197, 1, 4, 0, // Skip to: 1351
/* 1347 */    MCD::OPC_Decode, 248, 2, 6, // Opcode: JSLT_ri
/* 1351 */    MCD::OPC_FilterValue, 198, 1, 4, 0, // Skip to: 1360
/* 1356 */    MCD::OPC_Decode, 249, 2, 7, // Opcode: JSLT_ri_32
/* 1360 */    MCD::OPC_FilterValue, 199, 1, 10, 0, // Skip to: 1375
/* 1365 */    MCD::OPC_CheckField, 32, 16, 0, 69, 1, // Skip to: 1696
/* 1371 */    MCD::OPC_Decode, 203, 3, 3, // Opcode: SRA_ri
/* 1375 */    MCD::OPC_FilterValue, 204, 1, 10, 0, // Skip to: 1390
/* 1380 */    MCD::OPC_CheckField, 32, 16, 0, 54, 1, // Skip to: 1696
/* 1386 */    MCD::OPC_Decode, 206, 3, 4, // Opcode: SRA_rr_32
/* 1390 */    MCD::OPC_FilterValue, 205, 1, 4, 0, // Skip to: 1399
/* 1395 */    MCD::OPC_Decode, 250, 2, 10, // Opcode: JSLT_rr
/* 1399 */    MCD::OPC_FilterValue, 206, 1, 4, 0, // Skip to: 1408
/* 1404 */    MCD::OPC_Decode, 251, 2, 11, // Opcode: JSLT_rr_32
/* 1408 */    MCD::OPC_FilterValue, 207, 1, 10, 0, // Skip to: 1423
/* 1413 */    MCD::OPC_CheckField, 32, 16, 0, 21, 1, // Skip to: 1696
/* 1419 */    MCD::OPC_Decode, 205, 3, 5, // Opcode: SRA_rr
/* 1423 */    MCD::OPC_FilterValue, 212, 1, 27, 0, // Skip to: 1455
/* 1428 */    MCD::OPC_ExtractField, 0, 32,  // Inst{31-0} ...
/* 1431 */    MCD::OPC_FilterValue, 16, 4, 0, // Skip to: 1439
/* 1435 */    MCD::OPC_Decode, 162, 3, 17, // Opcode: LE16
/* 1439 */    MCD::OPC_FilterValue, 32, 4, 0, // Skip to: 1447
/* 1443 */    MCD::OPC_Decode, 163, 3, 17, // Opcode: LE32
/* 1447 */    MCD::OPC_FilterValue, 64, 245, 0, // Skip to: 1696
/* 1451 */    MCD::OPC_Decode, 164, 3, 17, // Opcode: LE64
/* 1455 */    MCD::OPC_FilterValue, 213, 1, 4, 0, // Skip to: 1464
/* 1460 */    MCD::OPC_Decode, 244, 2, 6, // Opcode: JSLE_ri
/* 1464 */    MCD::OPC_FilterValue, 214, 1, 4, 0, // Skip to: 1473
/* 1469 */    MCD::OPC_Decode, 245, 2, 7, // Opcode: JSLE_ri_32
/* 1473 */    MCD::OPC_FilterValue, 215, 1, 27, 0, // Skip to: 1505
/* 1478 */    MCD::OPC_ExtractField, 0, 32,  // Inst{31-0} ...
/* 1481 */    MCD::OPC_FilterValue, 16, 4, 0, // Skip to: 1489
/* 1485 */    MCD::OPC_Decode, 206, 2, 17, // Opcode: BSWAP16
/* 1489 */    MCD::OPC_FilterValue, 32, 4, 0, // Skip to: 1497
/* 1493 */    MCD::OPC_Decode, 207, 2, 17, // Opcode: BSWAP32
/* 1497 */    MCD::OPC_FilterValue, 64, 195, 0, // Skip to: 1696
/* 1501 */    MCD::OPC_Decode, 208, 2, 17, // Opcode: BSWAP64
/* 1505 */    MCD::OPC_FilterValue, 219, 1, 127, 0, // Skip to: 1637
/* 1510 */    MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 1513 */    MCD::OPC_FilterValue, 0, 24, 0, // Skip to: 1541
/* 1517 */    MCD::OPC_CheckField, 0, 4, 1, 4, 0, // Skip to: 1527
/* 1523 */    MCD::OPC_Decode, 237, 3, 24, // Opcode: XFADDD
/* 1527 */    MCD::OPC_CheckField, 8, 1, 1, 4, 0, // Skip to: 1537
/* 1533 */    MCD::OPC_Decode, 145, 3, 13, // Opcode: LDDACQ
/* 1537 */    MCD::OPC_Decode, 230, 3, 24, // Opcode: XADDD
/* 1541 */    MCD::OPC_FilterValue, 1, 10, 0, // Skip to: 1555
/* 1545 */    MCD::OPC_CheckField, 8, 1, 1, 145, 0, // Skip to: 1696
/* 1551 */    MCD::OPC_Decode, 216, 3, 15, // Opcode: STDREL
/* 1555 */    MCD::OPC_FilterValue, 4, 14, 0, // Skip to: 1573
/* 1559 */    MCD::OPC_CheckField, 0, 4, 1, 4, 0, // Skip to: 1569
/* 1565 */    MCD::OPC_Decode, 241, 3, 24, // Opcode: XFORD
/* 1569 */    MCD::OPC_Decode, 245, 3, 24, // Opcode: XORD
/* 1573 */    MCD::OPC_FilterValue, 5, 14, 0, // Skip to: 1591
/* 1577 */    MCD::OPC_CheckField, 0, 4, 1, 4, 0, // Skip to: 1587
/* 1583 */    MCD::OPC_Decode, 239, 3, 24, // Opcode: XFANDD
/* 1587 */    MCD::OPC_Decode, 233, 3, 24, // Opcode: XANDD
/* 1591 */    MCD::OPC_FilterValue, 10, 14, 0, // Skip to: 1609
/* 1595 */    MCD::OPC_CheckField, 0, 4, 1, 4, 0, // Skip to: 1605
/* 1601 */    MCD::OPC_Decode, 243, 3, 24, // Opcode: XFXORD
/* 1605 */    MCD::OPC_Decode, 251, 3, 24, // Opcode: XXORD
/* 1609 */    MCD::OPC_FilterValue, 14, 10, 0, // Skip to: 1623
/* 1613 */    MCD::OPC_CheckField, 0, 4, 1, 77, 0, // Skip to: 1696
/* 1619 */    MCD::OPC_Decode, 235, 3, 24, // Opcode: XCHGD
/* 1623 */    MCD::OPC_FilterValue, 15, 69, 0, // Skip to: 1696
/* 1627 */    MCD::OPC_CheckField, 0, 4, 1, 63, 0, // Skip to: 1696
/* 1633 */    MCD::OPC_Decode, 209, 2, 25, // Opcode: CMPXCHGD
/* 1637 */    MCD::OPC_FilterValue, 220, 1, 27, 0, // Skip to: 1669
/* 1642 */    MCD::OPC_ExtractField, 0, 32,  // Inst{31-0} ...
/* 1645 */    MCD::OPC_FilterValue, 16, 4, 0, // Skip to: 1653
/* 1649 */    MCD::OPC_Decode, 203, 2, 17, // Opcode: BE16
/* 1653 */    MCD::OPC_FilterValue, 32, 4, 0, // Skip to: 1661
/* 1657 */    MCD::OPC_Decode, 204, 2, 17, // Opcode: BE32
/* 1661 */    MCD::OPC_FilterValue, 64, 31, 0, // Skip to: 1696
/* 1665 */    MCD::OPC_Decode, 205, 2, 17, // Opcode: BE64
/* 1669 */    MCD::OPC_FilterValue, 221, 1, 4, 0, // Skip to: 1678
/* 1674 */    MCD::OPC_Decode, 246, 2, 10, // Opcode: JSLE_rr
/* 1678 */    MCD::OPC_FilterValue, 222, 1, 4, 0, // Skip to: 1687
/* 1683 */    MCD::OPC_Decode, 247, 2, 11, // Opcode: JSLE_rr_32
/* 1687 */    MCD::OPC_FilterValue, 229, 1, 4, 0, // Skip to: 1696
/* 1692 */    MCD::OPC_Decode, 221, 2, 1, // Opcode: JCOND
/* 1696 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableBPFALU3264[] = {
/* 0 */       MCD::OPC_ExtractField, 56, 8,  // Inst{63-56} ...
/* 3 */       MCD::OPC_FilterValue, 97, 4, 0, // Skip to: 11
/* 7 */       MCD::OPC_Decode, 151, 3, 26, // Opcode: LDW32
/* 11 */      MCD::OPC_FilterValue, 99, 4, 0, // Skip to: 19
/* 15 */      MCD::OPC_Decode, 223, 3, 27, // Opcode: STW32
/* 19 */      MCD::OPC_FilterValue, 105, 4, 0, // Skip to: 27
/* 23 */      MCD::OPC_Decode, 147, 3, 26, // Opcode: LDH32
/* 27 */      MCD::OPC_FilterValue, 107, 4, 0, // Skip to: 35
/* 31 */      MCD::OPC_Decode, 219, 3, 27, // Opcode: STH32
/* 35 */      MCD::OPC_FilterValue, 113, 4, 0, // Skip to: 43
/* 39 */      MCD::OPC_Decode, 141, 3, 26, // Opcode: LDB32
/* 43 */      MCD::OPC_FilterValue, 115, 4, 0, // Skip to: 51
/* 47 */      MCD::OPC_Decode, 212, 3, 27, // Opcode: STB32
/* 51 */      MCD::OPC_FilterValue, 195, 1, 127, 0, // Skip to: 183
/* 56 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 59 */      MCD::OPC_FilterValue, 0, 24, 0, // Skip to: 87
/* 63 */      MCD::OPC_CheckField, 0, 4, 1, 4, 0, // Skip to: 73
/* 69 */      MCD::OPC_Decode, 238, 3, 28, // Opcode: XFADDW32
/* 73 */      MCD::OPC_CheckField, 8, 1, 1, 4, 0, // Skip to: 83
/* 79 */      MCD::OPC_Decode, 152, 3, 26, // Opcode: LDWACQ32
/* 83 */      MCD::OPC_Decode, 232, 3, 28, // Opcode: XADDW32
/* 87 */      MCD::OPC_FilterValue, 1, 10, 0, // Skip to: 101
/* 91 */      MCD::OPC_CheckField, 8, 1, 1, 134, 0, // Skip to: 231
/* 97 */      MCD::OPC_Decode, 224, 3, 27, // Opcode: STWREL32
/* 101 */     MCD::OPC_FilterValue, 4, 14, 0, // Skip to: 119
/* 105 */     MCD::OPC_CheckField, 0, 4, 1, 4, 0, // Skip to: 115
/* 111 */     MCD::OPC_Decode, 242, 3, 28, // Opcode: XFORW32
/* 115 */     MCD::OPC_Decode, 246, 3, 28, // Opcode: XORW32
/* 119 */     MCD::OPC_FilterValue, 5, 14, 0, // Skip to: 137
/* 123 */     MCD::OPC_CheckField, 0, 4, 1, 4, 0, // Skip to: 133
/* 129 */     MCD::OPC_Decode, 240, 3, 28, // Opcode: XFANDW32
/* 133 */     MCD::OPC_Decode, 234, 3, 28, // Opcode: XANDW32
/* 137 */     MCD::OPC_FilterValue, 10, 14, 0, // Skip to: 155
/* 141 */     MCD::OPC_CheckField, 0, 4, 1, 4, 0, // Skip to: 151
/* 147 */     MCD::OPC_Decode, 244, 3, 28, // Opcode: XFXORW32
/* 151 */     MCD::OPC_Decode, 252, 3, 28, // Opcode: XXORW32
/* 155 */     MCD::OPC_FilterValue, 14, 10, 0, // Skip to: 169
/* 159 */     MCD::OPC_CheckField, 0, 4, 1, 66, 0, // Skip to: 231
/* 165 */     MCD::OPC_Decode, 236, 3, 28, // Opcode: XCHGW32
/* 169 */     MCD::OPC_FilterValue, 15, 58, 0, // Skip to: 231
/* 173 */     MCD::OPC_CheckField, 0, 4, 1, 52, 0, // Skip to: 231
/* 179 */     MCD::OPC_Decode, 210, 2, 29, // Opcode: CMPXCHGW32
/* 183 */     MCD::OPC_FilterValue, 203, 1, 19, 0, // Skip to: 207
/* 188 */     MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 191 */     MCD::OPC_FilterValue, 16, 4, 0, // Skip to: 199
/* 195 */     MCD::OPC_Decode, 148, 3, 26, // Opcode: LDHACQ32
/* 199 */     MCD::OPC_FilterValue, 17, 28, 0, // Skip to: 231
/* 203 */     MCD::OPC_Decode, 220, 3, 27, // Opcode: STHREL32
/* 207 */     MCD::OPC_FilterValue, 211, 1, 19, 0, // Skip to: 231
/* 212 */     MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 215 */     MCD::OPC_FilterValue, 16, 4, 0, // Skip to: 223
/* 219 */     MCD::OPC_Decode, 142, 3, 26, // Opcode: LDBACQ32
/* 223 */     MCD::OPC_FilterValue, 17, 4, 0, // Skip to: 231
/* 227 */     MCD::OPC_Decode, 213, 3, 27, // Opcode: STBREL32
/* 231 */     MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  llvm_unreachable("Invalid index!");
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    insertBits(tmp, fieldFromInstruction(insn, 52, 4), 16, 4);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 19:
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    insertBits(tmp, fieldFromInstruction(insn, 52, 4), 16, 4);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  }
}

static unsigned decodeNumToSkip(const uint8_t *&Ptr) {
  unsigned NumToSkip = *Ptr++;
  NumToSkip |= (*Ptr++) << 8;
  return NumToSkip;
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr++) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr++;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      uint64_t Val = decodeULEB128AndIncUnsafe(Ptr);
      bool Failed = Val != CurFieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the filter operation.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << (Failed ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr;
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      bool Failed = ExpectedValue != FieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // If the actual and expected values don't match, skip.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << (Failed ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);
      // Check the predicate.
      bool Failed = !checkDecoderPredicate(PIdx, Bits);
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Failed ? "FAIL\n" : "PASS\n"));

      break;
    }
    case MCD::OPC_Decode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      uint64_t PositiveMask = decodeULEB128AndIncUnsafe(Ptr);
      uint64_t NegativeMask = decodeULEB128AndIncUnsafe(Ptr);
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // namespace
