/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AArch64PreLegalizerCombinerImpl Combiner Match Table                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AArch64PreLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 193;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 144;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 143;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 198;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 89;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 192;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 88;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 196;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 197;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 94;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 212;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 187;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 131;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 206;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 145;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 189;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 175;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 132;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 127;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 173;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 174;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 161;	 // "commute_shift"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 69;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 124;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 205;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 125;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 172;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 171;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 204;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 207;	 // "unmerge_undef"
        }
        break;
      }
      break;
    }
    break;
  case 14:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 85;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 159;	 // "bitreverse_shl"
      }
      break;
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 170;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 91;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 106;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 54;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 105;	 // "shifts_too_big"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 160;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 68;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 152;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 62;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 142;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 83;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 129;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 58;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 61;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 60;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 59;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 63;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 55;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 188;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 121;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 71;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 90;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 110;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 168;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 153;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 81;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 149;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 123;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 150;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 72;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 128;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 86;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 146;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 135;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 134;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 147;	 // "expand_const_fpowi"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_global_offset", 16) != 0)
          break;
        return 216;	 // "fold_global_offset"
      case 'p':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "trunc_fpext_fold", 16) != 0)
          break;
        return 99;	 // "fptrunc_fpext_fold"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
            break;
          return 56;	 // "select_of_truncate"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
            break;
          return 118;	 // "sext_inreg_of_load"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "uffle_to_extract", 16) != 0)
          break;
        return 217;	 // "shuffle_to_extract"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 16 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 87;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 141;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 166;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 137;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 136;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xt", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "uaddv_to_uaddlv", 15) != 0)
          break;
        return 219;	 // "ext_uaddv_to_uaddlv"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "nd_through_phis", 15) != 0)
          break;
        return 102;	 // "extend_through_phis"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 64;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 211;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 108;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 107;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 84;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 122;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 103;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 194;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 76;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 177;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 98;	 // "bitcast_bitcast_fold"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_redundant_trunc", 19) != 0)
        break;
      return 215;	 // "icmp_redundant_trunc"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 210;	 // "merge_of_x_and_undef"
    case 'r':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "edu", 3) != 0)
        break;
      switch (RuleIdentifier[4]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
          break;
        return 119;	 // "reduce_shl_of_extend"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
          break;
        return 126;	 // "redundant_sext_inreg"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 77;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 209;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 195;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 169;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 138;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xt_addv_to_udot_addv", 20) != 0)
        break;
      return 218;	 // "ext_addv_to_udot_addv"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "constant_to_constant", 20) != 0)
        break;
      return 214;	 // "fconstant_to_constant"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'p':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ush_", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "dd_through_", 11) != 0)
          break;
        switch (RuleIdentifier[17]) {
        default: break;
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 223;	 // "push_add_through_sext"
        case 'z':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 221;	 // "push_add_through_zext"
        }
        break;
      case 's':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "ub_through_", 11) != 0)
          break;
        switch (RuleIdentifier[17]) {
        default: break;
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 222;	 // "push_sub_through_sext"
        case 'z':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 220;	 // "push_sub_through_zext"
        }
        break;
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 93;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 73;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 208;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 199;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 167;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 186;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 157;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 158;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 155;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 112;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 213;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 78;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 176;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 92;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 116;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 96;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 57;	 // "buildvector_of_truncate"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_right_zero", 22) != 0)
        break;
      return 156;	 // "funnel_shift_right_zero"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 139;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 140;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 79;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 74;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 120;	 // "narrow_binop_feeding_and"
    case 's':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "f_sext_inreg", 12) != 0)
          break;
        return 53;	 // "sext_inreg_of_sext_inreg"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "o_zext_inreg", 12) != 0)
          break;
        return 130;	 // "sext_inreg_to_zext_inreg"
      }
      break;
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 148;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 163;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 164;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 95;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 200;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 66;	 // "extract_vec_elt_build_vec"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eg_and_one_to_sext_inreg", 24) != 0)
        break;
      return 117;	 // "neg_and_one_to_sext_inreg"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 101;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 75;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 191;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 154;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 100;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 202;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 190;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 114;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 115;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 97;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 203;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 113;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 133;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 80;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 151;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 165;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 70;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 201;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 111;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_", 22) != 0)
      break;
    switch (RuleIdentifier[22]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
        break;
      return 22;	 // "insert_vector_element_elt_undef"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
        break;
      return 21;	 // "insert_vector_element_idx_undef"
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 162;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 178;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 182;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_all_elts_from_build_vector", 34) != 0)
      break;
    return 67;	 // "extract_all_elts_from_build_vector"
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 180;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 65;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 82;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 183;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 104;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 179;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 184;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 181;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 185;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 224}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AArch64PreLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AArch64PreLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AArch64PreLegalizerCombinerOption;
static cl::list<std::string> AArch64PreLegalizerCombinerDisableOption(
    "aarch64prelegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AArch64PreLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AArch64PreLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AArch64PreLegalizerCombinerOnlyEnableOption(
    "aarch64prelegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AArch64PreLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AArch64PreLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AArch64PreLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AArch64PreLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AArch64PreLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AArch64PreLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 1;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64PreLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64PreLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64PreLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64PreLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasDotProdBit = 0,
};

PredicateBitset AArch64PreLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  return Features;
}

void AArch64PreLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64PreLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AArch64PreLegalizerCombinerImpl::ComplexMatcherMemFn
AArch64PreLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
  GICXXPred_MI_Predicate_GICombiner9,
};
bool AArch64PreLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return MRI.hasOneNonDBGUse(State.MIs[0]->getOperand(2).getReg()) &&
                    Helper.isLegalOrBeforeLegalizer(
                      {TargetOpcode::G_SEXT_INREG, {MRI.getType(State.MIs[1]->getOperand(1).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner9: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
  GICXXPred_Simple_IsRule214Enabled,
  GICXXPred_Simple_IsRule215Enabled,
  GICXXPred_Simple_IsRule216Enabled,
  GICXXPred_Simple_IsRule217Enabled,
  GICXXPred_Simple_IsRule218Enabled,
  GICXXPred_Simple_IsRule219Enabled,
  GICXXPred_Simple_IsRule220Enabled,
  GICXXPred_Simple_IsRule221Enabled,
  GICXXPred_Simple_IsRule222Enabled,
  GICXXPred_Simple_IsRule223Enabled,
};

bool AArch64PreLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AArch64PreLegalizerCombinerImpl::CustomRendererFn
AArch64PreLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AArch64PreLegalizerCombinerImpl::tryCombineAllImpl(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
  GICXXCustomAction_GICombiner151,
  GICXXCustomAction_GICombiner152,
  GICXXCustomAction_GICombiner153,
  GICXXCustomAction_GICombiner154,
  GICXXCustomAction_GICombiner155,
  GICXXCustomAction_GICombiner156,
  GICXXCustomAction_GICombiner157,
};
bool AArch64PreLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantSextInReg(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getValueTracking()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchUDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    SmallVector<Register, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner151:{
    // Match Patterns
    if(![&](){return matchFConstantToConstant(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applyFConstantToConstant(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner152:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchICmpRedundantTrunc(*State.MIs[0], MRI, Helper.getValueTracking(), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyICmpRedundantTrunc(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner153:{
    std::pair<uint64_t, uint64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchFoldGlobalOffset(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyFoldGlobalOffset(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner154:{
    // Match Patterns
    if(![&](){return Helper.matchShuffleToExtract(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShuffleToExtract(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner155:{
    std::tuple<Register, Register, bool> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtAddvToUdotAddv(*State.MIs[0], MRI, STI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtAddvToUdotAddv(*State.MIs[0], MRI, B, Observer, STI, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner156:{
    std::pair<Register, bool> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtUaddvToUaddlv(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtUaddvToUaddlv(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner157:{
    // Match Patterns
    if(![&](){return matchPushAddSubExt(*State.MIs[0], MRI, State.MIs[0]->getOperand(0).getReg(), State.MIs[1]->getOperand(1).getReg(), State.MIs[2]->getOperand(1).getReg());}()) {
      return false;
    }
    // Apply Patterns
    applyPushAddSubExt(*State.MIs[0], MRI, B, State.MIs[1]->getOpcode() == TargetOpcode::G_SEXT, State.MIs[0]->getOperand(0).getReg(), State.MIs[1]->getOperand(1).getReg(), State.MIs[2]->getOperand(1).getReg());
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64PreLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(300), /*)*//*default:*//*Label 98*/ GIMT_Encode4(7351),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(1130), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(1142),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1757),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(2133),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(2299),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(2372),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(2456),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(2501), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(2568),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(2849),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(3094), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(3195), GIMT_Encode4(0),
     /*  210 */ /*TargetOpcode::G_GLOBAL_VALUE*//*Label 12*/ GIMT_Encode4(3207), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 13*/ GIMT_Encode4(3219), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 14*/ GIMT_Encode4(3286),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 15*/ GIMT_Encode4(3360),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 16*/ GIMT_Encode4(3408),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 17*/ GIMT_Encode4(3420),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 18*/ GIMT_Encode4(3432),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 19*/ GIMT_Encode4(3475),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 20*/ GIMT_Encode4(3508),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 21*/ GIMT_Encode4(3551), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 22*/ GIMT_Encode4(3615),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 23*/ GIMT_Encode4(3627),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 24*/ GIMT_Encode4(3639), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 25*/ GIMT_Encode4(3651), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  462 */ /*TargetOpcode::G_ANYEXT*//*Label 26*/ GIMT_Encode4(3663),
     /*  466 */ /*TargetOpcode::G_TRUNC*//*Label 27*/ GIMT_Encode4(3791), GIMT_Encode4(0),
     /*  474 */ /*TargetOpcode::G_FCONSTANT*//*Label 28*/ GIMT_Encode4(4149), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  486 */ /*TargetOpcode::G_SEXT*//*Label 29*/ GIMT_Encode4(4161),
     /*  490 */ /*TargetOpcode::G_SEXT_INREG*//*Label 30*/ GIMT_Encode4(4236),
     /*  494 */ /*TargetOpcode::G_ZEXT*//*Label 31*/ GIMT_Encode4(4302),
     /*  498 */ /*TargetOpcode::G_SHL*//*Label 32*/ GIMT_Encode4(4432),
     /*  502 */ /*TargetOpcode::G_LSHR*//*Label 33*/ GIMT_Encode4(4601),
     /*  506 */ /*TargetOpcode::G_ASHR*//*Label 34*/ GIMT_Encode4(4724),
     /*  510 */ /*TargetOpcode::G_FSHL*//*Label 35*/ GIMT_Encode4(4858),
     /*  514 */ /*TargetOpcode::G_FSHR*//*Label 36*/ GIMT_Encode4(4901),
     /*  518 */ /*TargetOpcode::G_ROTR*//*Label 37*/ GIMT_Encode4(4944),
     /*  522 */ /*TargetOpcode::G_ROTL*//*Label 38*/ GIMT_Encode4(4968),
     /*  526 */ /*TargetOpcode::G_ICMP*//*Label 39*/ GIMT_Encode4(4992),
     /*  530 */ /*TargetOpcode::G_FCMP*//*Label 40*/ GIMT_Encode4(5048), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  542 */ /*TargetOpcode::G_SELECT*//*Label 41*/ GIMT_Encode4(5060),
     /*  546 */ /*TargetOpcode::G_UADDO*//*Label 42*/ GIMT_Encode4(5155),
     /*  550 */ /*TargetOpcode::G_UADDE*//*Label 43*/ GIMT_Encode4(5178),
     /*  554 */ /*TargetOpcode::G_USUBO*//*Label 44*/ GIMT_Encode4(5190),
     /*  558 */ /*TargetOpcode::G_USUBE*//*Label 45*/ GIMT_Encode4(5202),
     /*  562 */ /*TargetOpcode::G_SADDO*//*Label 46*/ GIMT_Encode4(5214),
     /*  566 */ /*TargetOpcode::G_SADDE*//*Label 47*/ GIMT_Encode4(5237),
     /*  570 */ /*TargetOpcode::G_SSUBO*//*Label 48*/ GIMT_Encode4(5249),
     /*  574 */ /*TargetOpcode::G_SSUBE*//*Label 49*/ GIMT_Encode4(5261),
     /*  578 */ /*TargetOpcode::G_UMULO*//*Label 50*/ GIMT_Encode4(5273),
     /*  582 */ /*TargetOpcode::G_SMULO*//*Label 51*/ GIMT_Encode4(5307),
     /*  586 */ /*TargetOpcode::G_UMULH*//*Label 52*/ GIMT_Encode4(5341),
     /*  590 */ /*TargetOpcode::G_SMULH*//*Label 53*/ GIMT_Encode4(5364),
     /*  594 */ /*TargetOpcode::G_UADDSAT*//*Label 54*/ GIMT_Encode4(5376),
     /*  598 */ /*TargetOpcode::G_SADDSAT*//*Label 55*/ GIMT_Encode4(5388), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  610 */ /*TargetOpcode::G_USHLSAT*//*Label 56*/ GIMT_Encode4(5400),
     /*  614 */ /*TargetOpcode::G_SSHLSAT*//*Label 57*/ GIMT_Encode4(5423),
     /*  618 */ /*TargetOpcode::G_SMULFIX*//*Label 58*/ GIMT_Encode4(5446),
     /*  622 */ /*TargetOpcode::G_UMULFIX*//*Label 59*/ GIMT_Encode4(5458),
     /*  626 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 60*/ GIMT_Encode4(5470),
     /*  630 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 61*/ GIMT_Encode4(5482), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  650 */ /*TargetOpcode::G_FADD*//*Label 62*/ GIMT_Encode4(5494),
     /*  654 */ /*TargetOpcode::G_FSUB*//*Label 63*/ GIMT_Encode4(5606),
     /*  658 */ /*TargetOpcode::G_FMUL*//*Label 64*/ GIMT_Encode4(5695),
     /*  662 */ /*TargetOpcode::G_FMA*//*Label 65*/ GIMT_Encode4(5783),
     /*  666 */ /*TargetOpcode::G_FMAD*//*Label 66*/ GIMT_Encode4(5806),
     /*  670 */ /*TargetOpcode::G_FDIV*//*Label 67*/ GIMT_Encode4(5829),
     /*  674 */ /*TargetOpcode::G_FREM*//*Label 68*/ GIMT_Encode4(5863), GIMT_Encode4(0),
     /*  682 */ /*TargetOpcode::G_FPOWI*//*Label 69*/ GIMT_Encode4(5875), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  702 */ /*TargetOpcode::G_FLOG2*//*Label 70*/ GIMT_Encode4(5897), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  718 */ /*TargetOpcode::G_FNEG*//*Label 71*/ GIMT_Encode4(5919), GIMT_Encode4(0),
     /*  726 */ /*TargetOpcode::G_FPTRUNC*//*Label 72*/ GIMT_Encode4(5970),
     /*  730 */ /*TargetOpcode::G_FPTOSI*//*Label 73*/ GIMT_Encode4(6013),
     /*  734 */ /*TargetOpcode::G_FPTOUI*//*Label 74*/ GIMT_Encode4(6035),
     /*  738 */ /*TargetOpcode::G_SITOFP*//*Label 75*/ GIMT_Encode4(6057),
     /*  742 */ /*TargetOpcode::G_UITOFP*//*Label 76*/ GIMT_Encode4(6084), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  754 */ /*TargetOpcode::G_FABS*//*Label 77*/ GIMT_Encode4(6111), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  766 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 78*/ GIMT_Encode4(6190),
     /*  770 */ /*TargetOpcode::G_FMINNUM*//*Label 79*/ GIMT_Encode4(6220),
     /*  774 */ /*TargetOpcode::G_FMAXNUM*//*Label 80*/ GIMT_Encode4(6254),
     /*  778 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 81*/ GIMT_Encode4(6288),
     /*  782 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 82*/ GIMT_Encode4(6300),
     /*  786 */ /*TargetOpcode::G_FMINIMUM*//*Label 83*/ GIMT_Encode4(6312),
     /*  790 */ /*TargetOpcode::G_FMAXIMUM*//*Label 84*/ GIMT_Encode4(6346), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  826 */ /*TargetOpcode::G_PTR_ADD*//*Label 85*/ GIMT_Encode4(6380), GIMT_Encode4(0),
     /*  834 */ /*TargetOpcode::G_SMIN*//*Label 86*/ GIMT_Encode4(6470),
     /*  838 */ /*TargetOpcode::G_SMAX*//*Label 87*/ GIMT_Encode4(6504),
     /*  842 */ /*TargetOpcode::G_UMIN*//*Label 88*/ GIMT_Encode4(6538),
     /*  846 */ /*TargetOpcode::G_UMAX*//*Label 89*/ GIMT_Encode4(6572),
     /*  850 */ /*TargetOpcode::G_ABS*//*Label 90*/ GIMT_Encode4(6606), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  862 */ /*TargetOpcode::G_BR*//*Label 91*/ GIMT_Encode4(6618), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  882 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 92*/ GIMT_Encode4(6630),
     /*  886 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 93*/ GIMT_Encode4(6760),
     /*  890 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 94*/ GIMT_Encode4(7137), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  930 */ /*TargetOpcode::G_BITREVERSE*//*Label 95*/ GIMT_Encode4(7214), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  982 */ /*TargetOpcode::G_FSQRT*//*Label 96*/ GIMT_Encode4(7303), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 1126 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 97*/ GIMT_Encode4(7325),
     /* 1130 */ // Label 0: @1130
     /* 1130 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1141), // Rule ID 13 //
     /* 1135 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /* 1138 */   // MIs[0] d
     /* 1138 */   // No operand predicates
     /* 1138 */   // MIs[0] s
     /* 1138 */   // No operand predicates
     /* 1138 */   // Combiner Rule #13: copy_prop
     /* 1138 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1141 */ // Label 99: @1141
     /* 1141 */ GIM_Reject,
     /* 1142 */ // Label 1: @1142
     /* 1142 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1153), // Rule ID 16 //
     /* 1147 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1150 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /* 1150 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1153 */ // Label 100: @1153
     /* 1153 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1164), // Rule ID 94 //
     /* 1158 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1161 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 1161 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1164 */ // Label 101: @1164
     /* 1164 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1175), // Rule ID 141 //
     /* 1169 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 1172 */   // Combiner Rule #103: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 1172 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 1175 */ // Label 102: @1175
     /* 1175 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1186), // Rule ID 231 //
     /* 1180 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1183 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 1183 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1186 */ // Label 103: @1186
     /* 1186 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1197), // Rule ID 279 //
     /* 1191 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1194 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 1194 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1197 */ // Label 104: @1197
     /* 1197 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1208), // Rule ID 308 //
     /* 1202 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 1205 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 1205 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 1208 */ // Label 105: @1208
     /* 1208 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1242), // Rule ID 0 //
     /* 1213 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 1216 */   // MIs[0] root
     /* 1216 */   // No operand predicates
     /* 1216 */   // MIs[0] sub
     /* 1216 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1220 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1224 */   // MIs[1] Operand 1
     /* 1224 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1228 */   // MIs[1] A
     /* 1228 */   // No operand predicates
     /* 1228 */   // MIs[0] B
     /* 1228 */   // No operand predicates
     /* 1228 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1230 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 1230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1233 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1235 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 1237 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 1241 */   GIR_EraseRootFromParent_Done,
     /* 1242 */ // Label 106: @1242
     /* 1242 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1279), // Rule ID 12 //
     /* 1247 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1250 */   // MIs[0] root
     /* 1250 */   // No operand predicates
     /* 1250 */   // MIs[0] sub
     /* 1250 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1254 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1258 */   // MIs[1] A
     /* 1258 */   // No operand predicates
     /* 1258 */   // MIs[1] c1
     /* 1258 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1262 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1266 */   // MIs[2] imm1
     /* 1266 */   // No operand predicates
     /* 1266 */   // MIs[0] c2
     /* 1266 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1270 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1274 */   // MIs[3] imm2
     /* 1274 */   // No operand predicates
     /* 1274 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1276 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 1276 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1279 */ // Label 107: @1279
     /* 1279 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1313), // Rule ID 3 //
     /* 1284 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1287 */   // MIs[0] root
     /* 1287 */   // No operand predicates
     /* 1287 */   // MIs[0] sub
     /* 1287 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1291 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1295 */   // MIs[1] B
     /* 1295 */   // No operand predicates
     /* 1295 */   // MIs[1] A
     /* 1295 */   // No operand predicates
     /* 1295 */   // MIs[0] A
     /* 1295 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1300 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1305 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1307 */   // Combiner Rule #3: BMinusAPlusA
     /* 1307 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1312 */   GIR_EraseRootFromParent_Done,
     /* 1313 */ // Label 108: @1313
     /* 1313 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1347), // Rule ID 131 //
     /* 1318 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1321 */   // MIs[0] dst
     /* 1321 */   // No operand predicates
     /* 1321 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1321 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1325 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1329 */   // MIs[1] src
     /* 1329 */   // No operand predicates
     /* 1329 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1329 */   // No operand predicates
     /* 1329 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1329 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1334 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1339 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1341 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 1341 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1346 */   GIR_EraseRootFromParent_Done,
     /* 1347 */ // Label 109: @1347
     /* 1347 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1392), // Rule ID 5 //
     /* 1352 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1355 */   // MIs[0] root
     /* 1355 */   // No operand predicates
     /* 1355 */   // MIs[0] sub1
     /* 1355 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1363 */   // MIs[1] A
     /* 1363 */   // No operand predicates
     /* 1363 */   // MIs[1] B
     /* 1363 */   // No operand predicates
     /* 1363 */   // MIs[0] sub2
     /* 1363 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1367 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1371 */   // MIs[2] B
     /* 1371 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1376 */   // MIs[2] C
     /* 1376 */   // No operand predicates
     /* 1376 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1378 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 1378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1381 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1383 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 1387 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1391 */   GIR_EraseRootFromParent_Done,
     /* 1392 */ // Label 110: @1392
     /* 1392 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1437), // Rule ID 4 //
     /* 1397 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1400 */   // MIs[0] root
     /* 1400 */   // No operand predicates
     /* 1400 */   // MIs[0] sub1
     /* 1400 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1404 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1408 */   // MIs[1] A
     /* 1408 */   // No operand predicates
     /* 1408 */   // MIs[1] B
     /* 1408 */   // No operand predicates
     /* 1408 */   // MIs[0] sub2
     /* 1408 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1412 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1416 */   // MIs[2] C
     /* 1416 */   // No operand predicates
     /* 1416 */   // MIs[2] A
     /* 1416 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 1421 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1423 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 1423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1426 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1428 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1432 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1436 */   GIR_EraseRootFromParent_Done,
     /* 1437 */ // Label 111: @1437
     /* 1437 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1466), // Rule ID 370 //
     /* 1442 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule223Enabled),
     /* 1445 */   // MIs[0] dst
     /* 1445 */   // No operand predicates
     /* 1445 */   // MIs[0] ext1
     /* 1445 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1449 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1453 */   // MIs[1] src1
     /* 1453 */   // No operand predicates
     /* 1453 */   // MIs[0] ext2
     /* 1453 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1457 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1461 */   // MIs[2] src2
     /* 1461 */   // No operand predicates
     /* 1461 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1463 */   // Combiner Rule #223: push_add_through_sext
     /* 1463 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1466 */ // Label 112: @1466
     /* 1466 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1501), // Rule ID 39 //
     /* 1471 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 1474 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1480 */   // MIs[0] root
     /* 1480 */   // No operand predicates
     /* 1480 */   // MIs[0] left
     /* 1480 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1484 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1488 */   // MIs[1] imm1
     /* 1488 */   // No operand predicates
     /* 1488 */   // MIs[0] right
     /* 1488 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1492 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1496 */   // MIs[2] imm2
     /* 1496 */   // No operand predicates
     /* 1496 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1498 */   // Combiner Rule #37: add_of_vscale
     /* 1498 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1501 */ // Label 113: @1501
     /* 1501 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1530), // Rule ID 368 //
     /* 1506 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule221Enabled),
     /* 1509 */   // MIs[0] dst
     /* 1509 */   // No operand predicates
     /* 1509 */   // MIs[0] ext1
     /* 1509 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1513 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1517 */   // MIs[1] src1
     /* 1517 */   // No operand predicates
     /* 1517 */   // MIs[0] ext2
     /* 1517 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1521 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1525 */   // MIs[2] src2
     /* 1525 */   // No operand predicates
     /* 1525 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1527 */   // Combiner Rule #221: push_add_through_zext
     /* 1527 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1530 */ // Label 114: @1530
     /* 1530 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1564), // Rule ID 1 //
     /* 1535 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1538 */   // MIs[0] root
     /* 1538 */   // No operand predicates
     /* 1538 */   // MIs[0] A
     /* 1538 */   // No operand predicates
     /* 1538 */   // MIs[0] sub
     /* 1538 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1542 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1546 */   // MIs[1] Operand 1
     /* 1546 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1550 */   // MIs[1] B
     /* 1550 */   // No operand predicates
     /* 1550 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1552 */   // Combiner Rule #1: APlusZeroMinusB
     /* 1552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1555 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1557 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 1559 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1563 */   GIR_EraseRootFromParent_Done,
     /* 1564 */ // Label 115: @1564
     /* 1564 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1598), // Rule ID 2 //
     /* 1569 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 1572 */   // MIs[0] root
     /* 1572 */   // No operand predicates
     /* 1572 */   // MIs[0] A
     /* 1572 */   // No operand predicates
     /* 1572 */   // MIs[0] sub
     /* 1572 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1576 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1580 */   // MIs[1] B
     /* 1580 */   // No operand predicates
     /* 1580 */   // MIs[1] A
     /* 1580 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1585 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1590 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1592 */   // Combiner Rule #2: APlusBMinusB
     /* 1592 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1597 */   GIR_EraseRootFromParent_Done,
     /* 1598 */ // Label 116: @1598
     /* 1598 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1632), // Rule ID 130 //
     /* 1603 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1606 */   // MIs[0] dst
     /* 1606 */   // No operand predicates
     /* 1606 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1606 */   // No operand predicates
     /* 1606 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1606 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1610 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1614 */   // MIs[1] src
     /* 1614 */   // No operand predicates
     /* 1614 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1614 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1619 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1624 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1626 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1626 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1631 */   GIR_EraseRootFromParent_Done,
     /* 1632 */ // Label 117: @1632
     /* 1632 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1677), // Rule ID 6 //
     /* 1637 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1640 */   // MIs[0] root
     /* 1640 */   // No operand predicates
     /* 1640 */   // MIs[0] A
     /* 1640 */   // No operand predicates
     /* 1640 */   // MIs[0] sub1
     /* 1640 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1644 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1648 */   // MIs[1] B
     /* 1648 */   // No operand predicates
     /* 1648 */   // MIs[1] add1
     /* 1648 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1652 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1656 */   // MIs[2] A
     /* 1656 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1661 */   // MIs[2] C
     /* 1661 */   // No operand predicates
     /* 1661 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1663 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 1663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1666 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1668 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1672 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1676 */   GIR_EraseRootFromParent_Done,
     /* 1677 */ // Label 118: @1677
     /* 1677 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1722), // Rule ID 7 //
     /* 1682 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1685 */   // MIs[0] root
     /* 1685 */   // No operand predicates
     /* 1685 */   // MIs[0] A
     /* 1685 */   // No operand predicates
     /* 1685 */   // MIs[0] sub1
     /* 1685 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1689 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1693 */   // MIs[1] B
     /* 1693 */   // No operand predicates
     /* 1693 */   // MIs[1] add1
     /* 1693 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1697 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1701 */   // MIs[2] C
     /* 1701 */   // No operand predicates
     /* 1701 */   // MIs[2] A
     /* 1701 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1706 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1708 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 1708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1711 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1713 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1717 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1721 */   GIR_EraseRootFromParent_Done,
     /* 1722 */ // Label 119: @1722
     /* 1722 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1745), // Rule ID 105 //
     /* 1727 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 1730 */   // MIs[0] dst
     /* 1730 */   // No operand predicates
     /* 1730 */   // MIs[0] lhs
     /* 1730 */   // No operand predicates
     /* 1730 */   // MIs[0] Operand 2
     /* 1730 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1734 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1739 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1739 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1744 */   GIR_EraseRootFromParent_Done,
     /* 1745 */ // Label 120: @1745
     /* 1745 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1756), // Rule ID 149 //
     /* 1750 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 1753 */   // MIs[0] root
     /* 1753 */   // No operand predicates
     /* 1753 */   // MIs[0] src1
     /* 1753 */   // No operand predicates
     /* 1753 */   // MIs[0] src2
     /* 1753 */   // No operand predicates
     /* 1753 */   // Combiner Rule #107: reassoc_comm_binops
     /* 1753 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1756 */ // Label 121: @1756
     /* 1756 */ GIM_Reject,
     /* 1757 */ // Label 2: @1757
     /* 1757 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1768), // Rule ID 95 //
     /* 1762 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1765 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1765 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1768 */ // Label 122: @1768
     /* 1768 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1779), // Rule ID 239 //
     /* 1773 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1776 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1776 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1779 */ // Label 123: @1779
     /* 1779 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1790), // Rule ID 280 //
     /* 1784 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1787 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 1787 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1790 */ // Label 124: @1790
     /* 1790 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1801), // Rule ID 305 //
     /* 1795 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 1798 */   // Combiner Rule #187: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 1798 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 1801 */ // Label 125: @1801
     /* 1801 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1812), // Rule ID 339 //
     /* 1806 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 1809 */   // Combiner Rule #194: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 1809 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 1812 */ // Label 126: @1812
     /* 1812 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1849), // Rule ID 8 //
     /* 1817 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 1820 */   // MIs[0] root
     /* 1820 */   // No operand predicates
     /* 1820 */   // MIs[0] add
     /* 1820 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1824 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1828 */   // MIs[1] A
     /* 1828 */   // No operand predicates
     /* 1828 */   // MIs[1] c1
     /* 1828 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1832 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1836 */   // MIs[2] imm1
     /* 1836 */   // No operand predicates
     /* 1836 */   // MIs[0] c2
     /* 1836 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1840 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1844 */   // MIs[3] imm2
     /* 1844 */   // No operand predicates
     /* 1844 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1846 */   // Combiner Rule #8: APlusC1MinusC2
     /* 1846 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 1849 */ // Label 127: @1849
     /* 1849 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1886), // Rule ID 11 //
     /* 1854 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1857 */   // MIs[0] root
     /* 1857 */   // No operand predicates
     /* 1857 */   // MIs[0] sub1
     /* 1857 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1861 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1865 */   // MIs[1] c1
     /* 1865 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 1869 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1873 */   // MIs[2] imm1
     /* 1873 */   // No operand predicates
     /* 1873 */   // MIs[1] A
     /* 1873 */   // No operand predicates
     /* 1873 */   // MIs[0] c2
     /* 1873 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1877 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1881 */   // MIs[3] imm2
     /* 1881 */   // No operand predicates
     /* 1881 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1883 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 1883 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1886 */ // Label 128: @1886
     /* 1886 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1923), // Rule ID 10 //
     /* 1891 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1894 */   // MIs[0] root
     /* 1894 */   // No operand predicates
     /* 1894 */   // MIs[0] sub1
     /* 1894 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1898 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1902 */   // MIs[1] A
     /* 1902 */   // No operand predicates
     /* 1902 */   // MIs[1] c1
     /* 1902 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1906 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1910 */   // MIs[2] imm1
     /* 1910 */   // No operand predicates
     /* 1910 */   // MIs[0] c2
     /* 1910 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1914 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1918 */   // MIs[3] imm2
     /* 1918 */   // No operand predicates
     /* 1918 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1920 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 1920 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 1923 */ // Label 129: @1923
     /* 1923 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1952), // Rule ID 369 //
     /* 1928 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule222Enabled),
     /* 1931 */   // MIs[0] dst
     /* 1931 */   // No operand predicates
     /* 1931 */   // MIs[0] ext1
     /* 1931 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1935 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1939 */   // MIs[1] src1
     /* 1939 */   // No operand predicates
     /* 1939 */   // MIs[0] ext2
     /* 1939 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1943 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1947 */   // MIs[2] src2
     /* 1947 */   // No operand predicates
     /* 1947 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1949 */   // Combiner Rule #222: push_sub_through_sext
     /* 1949 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1952 */ // Label 130: @1952
     /* 1952 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1981), // Rule ID 367 //
     /* 1957 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule220Enabled),
     /* 1960 */   // MIs[0] dst
     /* 1960 */   // No operand predicates
     /* 1960 */   // MIs[0] ext1
     /* 1960 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1964 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1968 */   // MIs[1] src1
     /* 1968 */   // No operand predicates
     /* 1968 */   // MIs[0] ext2
     /* 1968 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1972 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1976 */   // MIs[2] src2
     /* 1976 */   // No operand predicates
     /* 1976 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1978 */   // Combiner Rule #220: push_sub_through_zext
     /* 1978 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1981 */ // Label 131: @1981
     /* 1981 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2024), // Rule ID 159 //
     /* 1986 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 1989 */   // MIs[0] dst
     /* 1989 */   // No operand predicates
     /* 1989 */   // MIs[0] Operand 1
     /* 1989 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 1993 */   // MIs[0] and
     /* 1993 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1997 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2001 */   // MIs[1] x
     /* 2001 */   // No operand predicates
     /* 2001 */   // MIs[1] Operand 2
     /* 2001 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 2005 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 2009 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011 */   // Combiner Rule #117: neg_and_one_to_sext_inreg
     /* 2011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2014 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 2016 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 2020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2023 */   GIR_EraseRootFromParent_Done,
     /* 2024 */ // Label 132: @2024
     /* 2024 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2061), // Rule ID 9 //
     /* 2029 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 2032 */   // MIs[0] root
     /* 2032 */   // No operand predicates
     /* 2032 */   // MIs[0] c2
     /* 2032 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2040 */   // MIs[1] imm2
     /* 2040 */   // No operand predicates
     /* 2040 */   // MIs[0] add
     /* 2040 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2044 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 2048 */   // MIs[2] A
     /* 2048 */   // No operand predicates
     /* 2048 */   // MIs[2] c1
     /* 2048 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 2052 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2056 */   // MIs[3] imm1
     /* 2056 */   // No operand predicates
     /* 2056 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2058 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 2058 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2061 */ // Label 133: @2061
     /* 2061 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2088), // Rule ID 42 //
     /* 2066 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 2069 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 2075 */   // MIs[0] root
     /* 2075 */   // No operand predicates
     /* 2075 */   // MIs[0] x
     /* 2075 */   // No operand predicates
     /* 2075 */   // MIs[0] right
     /* 2075 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 2083 */   // MIs[1] imm
     /* 2083 */   // No operand predicates
     /* 2083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2085 */   // Combiner Rule #40: sub_of_vscale
     /* 2085 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 2088 */ // Label 134: @2088
     /* 2088 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2111), // Rule ID 104 //
     /* 2093 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2096 */   // MIs[0] dst
     /* 2096 */   // No operand predicates
     /* 2096 */   // MIs[0] lhs
     /* 2096 */   // No operand predicates
     /* 2096 */   // MIs[0] Operand 2
     /* 2096 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2100 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2105 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 2105 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2110 */   GIR_EraseRootFromParent_Done,
     /* 2111 */ // Label 135: @2111
     /* 2111 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2132), // Rule ID 15 //
     /* 2116 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 2119 */   // MIs[0] d
     /* 2119 */   // No operand predicates
     /* 2119 */   // MIs[0] op1
     /* 2119 */   // No operand predicates
     /* 2119 */   // MIs[0] c
     /* 2119 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2123 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2127 */   // MIs[1] imm
     /* 2127 */   // No operand predicates
     /* 2127 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129 */   // Combiner Rule #15: sub_to_add
     /* 2129 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2132 */ // Label 136: @2132
     /* 2132 */ GIM_Reject,
     /* 2133 */ // Label 3: @2133
     /* 2133 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2144), // Rule ID 78 //
     /* 2138 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2141 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 2141 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2144 */ // Label 137: @2144
     /* 2144 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2155), // Rule ID 236 //
     /* 2149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2152 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 2152 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2155 */ // Label 138: @2155
     /* 2155 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2166), // Rule ID 309 //
     /* 2160 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2163 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 2163 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2166 */ // Label 139: @2166
     /* 2166 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2206), // Rule ID 17 //
     /* 2171 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2174 */   // MIs[0] dst
     /* 2174 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 2178 */   // MIs[0] x
     /* 2178 */   // No operand predicates
     /* 2178 */   // MIs[0] Operand 2
     /* 2178 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 2182 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2185 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 2195 */   // Combiner Rule #17: mul_by_neg_one
     /* 2195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 2198 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 2200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 2205 */   GIR_EraseRootFromParent_Done,
     /* 2206 */ // Label 140: @2206
     /* 2206 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2241), // Rule ID 40 //
     /* 2211 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 2214 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 2220 */   // MIs[0] root
     /* 2220 */   // No operand predicates
     /* 2220 */   // MIs[0] left
     /* 2220 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 2228 */   // MIs[1] scale
     /* 2228 */   // No operand predicates
     /* 2228 */   // MIs[0] x
     /* 2228 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2232 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2236 */   // MIs[2] imm1
     /* 2236 */   // No operand predicates
     /* 2236 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2238 */   // Combiner Rule #38: mul_of_vscale
     /* 2238 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 2241 */ // Label 141: @2241
     /* 2241 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2264), // Rule ID 123 //
     /* 2246 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2249 */   // MIs[0] dst
     /* 2249 */   // No operand predicates
     /* 2249 */   // MIs[0] lhs
     /* 2249 */   // No operand predicates
     /* 2249 */   // MIs[0] zero
     /* 2249 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2253 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2258 */   // Combiner Rule #87: binop_right_to_zero
     /* 2258 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2263 */   GIR_EraseRootFromParent_Done,
     /* 2264 */ // Label 142: @2264
     /* 2264 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2287), // Rule ID 128 //
     /* 2269 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 2272 */   // MIs[0] dst
     /* 2272 */   // No operand predicates
     /* 2272 */   // MIs[0] x
     /* 2272 */   // No operand predicates
     /* 2272 */   // MIs[0] Operand 2
     /* 2272 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 2276 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2281 */   // Combiner Rule #92: right_identity_one_int
     /* 2281 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2286 */   GIR_EraseRootFromParent_Done,
     /* 2287 */ // Label 143: @2287
     /* 2287 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2298), // Rule ID 14 //
     /* 2292 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2295 */   // MIs[0] d
     /* 2295 */   // No operand predicates
     /* 2295 */   // MIs[0] op1
     /* 2295 */   // No operand predicates
     /* 2295 */   // MIs[0] op2
     /* 2295 */   // No operand predicates
     /* 2295 */   // Combiner Rule #14: mul_to_shl
     /* 2295 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2298 */ // Label 144: @2298
     /* 2298 */ GIM_Reject,
     /* 2299 */ // Label 4: @2299
     /* 2299 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2310), // Rule ID 119 //
     /* 2304 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2307 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 2307 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2310 */ // Label 145: @2310
     /* 2310 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2321), // Rule ID 211 //
     /* 2315 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2318 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 2318 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2321 */ // Label 146: @2321
     /* 2321 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2332), // Rule ID 242 //
     /* 2326 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2329 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 2329 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2332 */ // Label 147: @2332
     /* 2332 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2343), // Rule ID 260 //
     /* 2337 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 2340 */   // Combiner Rule #172: sdiv_by_const; wip_match_opcode 'G_SDIV'
     /* 2340 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 2343 */ // Label 148: @2343
     /* 2343 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2354), // Rule ID 285 //
     /* 2348 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2351 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 2351 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2354 */ // Label 149: @2354
     /* 2354 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2371), // Rule ID 261 //
     /* 2359 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 2362 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2368 */   // MIs[0] dst
     /* 2368 */   // No operand predicates
     /* 2368 */   // MIs[0] x
     /* 2368 */   // No operand predicates
     /* 2368 */   // MIs[0] y
     /* 2368 */   // No operand predicates
     /* 2368 */   // Combiner Rule #173: sdiv_by_pow2
     /* 2368 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 2371 */ // Label 150: @2371
     /* 2371 */ GIM_Reject,
     /* 2372 */ // Label 5: @2372
     /* 2372 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2383), // Rule ID 81 //
     /* 2377 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2380 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 2380 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2383 */ // Label 151: @2383
     /* 2383 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2394), // Rule ID 120 //
     /* 2388 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2391 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 2391 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2394 */ // Label 152: @2394
     /* 2394 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2405), // Rule ID 212 //
     /* 2399 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2402 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 2402 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2405 */ // Label 153: @2405
     /* 2405 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2416), // Rule ID 241 //
     /* 2410 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2413 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 2413 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2416 */ // Label 154: @2416
     /* 2416 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2427), // Rule ID 259 //
     /* 2421 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 2424 */   // Combiner Rule #171: udiv_by_const; wip_match_opcode 'G_UDIV'
     /* 2424 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 2427 */ // Label 155: @2427
     /* 2427 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2438), // Rule ID 287 //
     /* 2432 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2435 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 2435 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2438 */ // Label 156: @2438
     /* 2438 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2455), // Rule ID 262 //
     /* 2443 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 2446 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2452 */   // MIs[0] dst
     /* 2452 */   // No operand predicates
     /* 2452 */   // MIs[0] x
     /* 2452 */   // No operand predicates
     /* 2452 */   // MIs[0] y
     /* 2452 */   // No operand predicates
     /* 2452 */   // Combiner Rule #174: udiv_by_pow2
     /* 2452 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 2455 */ // Label 157: @2455
     /* 2455 */ GIM_Reject,
     /* 2456 */ // Label 6: @2456
     /* 2456 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2467), // Rule ID 121 //
     /* 2461 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2464 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 2464 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2467 */ // Label 158: @2467
     /* 2467 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2478), // Rule ID 213 //
     /* 2472 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2475 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 2475 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2478 */ // Label 159: @2478
     /* 2478 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2489), // Rule ID 244 //
     /* 2483 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2486 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 2486 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2489 */ // Label 160: @2489
     /* 2489 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2500), // Rule ID 286 //
     /* 2494 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2497 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 2497 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2500 */ // Label 161: @2500
     /* 2500 */ GIM_Reject,
     /* 2501 */ // Label 7: @2501
     /* 2501 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2512), // Rule ID 82 //
     /* 2506 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2509 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 2509 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2512 */ // Label 162: @2512
     /* 2512 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2523), // Rule ID 122 //
     /* 2517 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2520 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 2520 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2523 */ // Label 163: @2523
     /* 2523 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2534), // Rule ID 170 //
     /* 2528 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 2531 */   // Combiner Rule #128: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 2531 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 2534 */ // Label 164: @2534
     /* 2534 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2545), // Rule ID 214 //
     /* 2539 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2542 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 2542 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2545 */ // Label 165: @2545
     /* 2545 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2556), // Rule ID 243 //
     /* 2550 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2553 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 2553 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2556 */ // Label 166: @2556
     /* 2556 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2567), // Rule ID 288 //
     /* 2561 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2564 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 2564 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2567 */ // Label 167: @2567
     /* 2567 */ GIM_Reject,
     /* 2568 */ // Label 8: @2568
     /* 2568 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2579), // Rule ID 73 //
     /* 2573 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 2576 */   // Combiner Rule #69: load_and_mask; wip_match_opcode 'G_AND'
     /* 2576 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 2579 */ // Label 168: @2579
     /* 2579 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2590), // Rule ID 77 //
     /* 2584 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2587 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 2587 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2590 */ // Label 169: @2590
     /* 2590 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2601), // Rule ID 142 //
     /* 2595 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2598 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 2598 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2601 */ // Label 170: @2601
     /* 2601 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2612), // Rule ID 162 //
     /* 2606 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 2609 */   // Combiner Rule #120: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 2609 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 2612 */ // Label 171: @2612
     /* 2612 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2623), // Rule ID 167 //
     /* 2617 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 2620 */   // Combiner Rule #125: redundant_and; wip_match_opcode 'G_AND'
     /* 2620 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 2623 */ // Label 172: @2623
     /* 2623 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2634), // Rule ID 184 //
     /* 2628 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 2631 */   // Combiner Rule #142: overlapping_and; wip_match_opcode 'G_AND'
     /* 2631 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 2634 */ // Label 173: @2634
     /* 2634 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2645), // Rule ID 233 //
     /* 2639 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2642 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 2642 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2645 */ // Label 174: @2645
     /* 2645 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2656), // Rule ID 270 //
     /* 2650 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 2653 */   // Combiner Rule #177: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 2653 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 2656 */ // Label 175: @2656
     /* 2656 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2667), // Rule ID 282 //
     /* 2661 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2664 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 2664 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2667 */ // Label 176: @2667
     /* 2667 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2678), // Rule ID 310 //
     /* 2672 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2675 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 2675 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2678 */ // Label 177: @2678
     /* 2678 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2689), // Rule ID 337 //
     /* 2683 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 2686 */   // Combiner Rule #192: match_ands; wip_match_opcode 'G_AND'
     /* 2686 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 2689 */ // Label 178: @2689
     /* 2689 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2787), // Rule ID 155 //
     /* 2694 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 2697 */   // MIs[0] root
     /* 2697 */   // No operand predicates
     /* 2697 */   // MIs[0] d1
     /* 2697 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2701 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2705 */   // MIs[1] p
     /* 2705 */   // No operand predicates
     /* 2705 */   // MIs[1] s1
     /* 2705 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2709 */   // MIs[1] Operand 3
     /* 2709 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2713 */   // MIs[0] d2
     /* 2713 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2717 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2721 */   // MIs[2] p
     /* 2721 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2726 */   // MIs[2] s2
     /* 2726 */   // No operand predicates
     /* 2726 */   // MIs[2] Operand 3
     /* 2726 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2730 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 2734 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2736 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2739 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2752 */   // Combiner Rule #113: double_icmp_zero_and_combine
     /* 2752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2755 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2760 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2764 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2772 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2776 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2780 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2783 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2786 */   GIR_EraseRootFromParent_Done,
     /* 2787 */ // Label 179: @2787
     /* 2787 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2824), // Rule ID 226 //
     /* 2792 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 2795 */   // MIs[0] root
     /* 2795 */   // No operand predicates
     /* 2795 */   // MIs[0] shift
     /* 2795 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2799 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 2803 */   // MIs[1] x
     /* 2803 */   // No operand predicates
     /* 2803 */   // MIs[1] lsb
     /* 2803 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2807 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2811 */   // MIs[2] imm1
     /* 2811 */   // No operand predicates
     /* 2811 */   // MIs[0] mask
     /* 2811 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2815 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2819 */   // MIs[3] imm2
     /* 2819 */   // No operand predicates
     /* 2819 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2821 */   // Combiner Rule #163: bitfield_extract_from_and
     /* 2821 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 2824 */ // Label 180: @2824
     /* 2824 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2848), // Rule ID 114 //
     /* 2829 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2832 */   // MIs[0] dst
     /* 2832 */   // No operand predicates
     /* 2832 */   // MIs[0] src
     /* 2832 */   // No operand predicates
     /* 2832 */   // MIs[0] src
     /* 2832 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2837 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2842 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 2842 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2847 */   GIR_EraseRootFromParent_Done,
     /* 2848 */ // Label 181: @2848
     /* 2848 */ GIM_Reject,
     /* 2849 */ // Label 9: @2849
     /* 2849 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2860), // Rule ID 79 //
     /* 2854 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2857 */   // Combiner Rule #73: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 2857 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2860 */ // Label 182: @2860
     /* 2860 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2871), // Rule ID 143 //
     /* 2865 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2868 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 2868 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2871 */ // Label 183: @2871
     /* 2871 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2882), // Rule ID 169 //
     /* 2876 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 2879 */   // Combiner Rule #127: redundant_or; wip_match_opcode 'G_OR'
     /* 2879 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 2882 */ // Label 184: @2882
     /* 2882 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2893), // Rule ID 210 //
     /* 2887 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2890 */   // Combiner Rule #152: load_or_combine; wip_match_opcode 'G_OR'
     /* 2890 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2893 */ // Label 185: @2893
     /* 2893 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2904), // Rule ID 215 //
     /* 2898 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 2901 */   // Combiner Rule #154: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 2901 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 2904 */ // Label 186: @2904
     /* 2904 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2915), // Rule ID 237 //
     /* 2909 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2912 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 2912 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2915 */ // Label 187: @2915
     /* 2915 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2926), // Rule ID 283 //
     /* 2920 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2923 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 2923 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2926 */ // Label 188: @2926
     /* 2926 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2937), // Rule ID 311 //
     /* 2931 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2934 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 2934 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2937 */ // Label 189: @2937
     /* 2937 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2948), // Rule ID 338 //
     /* 2942 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 2945 */   // Combiner Rule #193: match_ors; wip_match_opcode 'G_OR'
     /* 2945 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 2948 */ // Label 190: @2948
     /* 2948 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(3046), // Rule ID 156 //
     /* 2953 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 2956 */   // MIs[0] root
     /* 2956 */   // No operand predicates
     /* 2956 */   // MIs[0] d1
     /* 2956 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2964 */   // MIs[1] p
     /* 2964 */   // No operand predicates
     /* 2964 */   // MIs[1] s1
     /* 2964 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2968 */   // MIs[1] Operand 3
     /* 2968 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2972 */   // MIs[0] d2
     /* 2972 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2976 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2980 */   // MIs[2] p
     /* 2980 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2985 */   // MIs[2] s2
     /* 2985 */   // No operand predicates
     /* 2985 */   // MIs[2] Operand 3
     /* 2985 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2989 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 2993 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2995 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2998 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 3008 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 3011 */   // Combiner Rule #114: double_icmp_zero_or_combine
     /* 3011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 3014 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 3019 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 3023 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 3027 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 3031 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 3035 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 3039 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 3042 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 3045 */   GIR_EraseRootFromParent_Done,
     /* 3046 */ // Label 191: @3046
     /* 3046 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(3070), // Rule ID 115 //
     /* 3051 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 3054 */   // MIs[0] dst
     /* 3054 */   // No operand predicates
     /* 3054 */   // MIs[0] src
     /* 3054 */   // No operand predicates
     /* 3054 */   // MIs[0] src
     /* 3054 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 3059 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3064 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 3064 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3069 */   GIR_EraseRootFromParent_Done,
     /* 3070 */ // Label 192: @3070
     /* 3070 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3093), // Rule ID 106 //
     /* 3075 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 3078 */   // MIs[0] dst
     /* 3078 */   // No operand predicates
     /* 3078 */   // MIs[0] lhs
     /* 3078 */   // No operand predicates
     /* 3078 */   // MIs[0] Operand 2
     /* 3078 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3082 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3087 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 3087 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3092 */   GIR_EraseRootFromParent_Done,
     /* 3093 */ // Label 193: @3093
     /* 3093 */ GIM_Reject,
     /* 3094 */ // Label 10: @3094
     /* 3094 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3105), // Rule ID 96 //
     /* 3099 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3102 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 3102 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3105 */ // Label 194: @3105
     /* 3105 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3116), // Rule ID 144 //
     /* 3110 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 3113 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 3113 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 3116 */ // Label 195: @3116
     /* 3116 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3127), // Rule ID 174 //
     /* 3121 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 3124 */   // Combiner Rule #132: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 3124 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 3127 */ // Label 196: @3127
     /* 3127 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(3138), // Rule ID 198 //
     /* 3132 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 3135 */   // Combiner Rule #148: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 3135 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 3138 */ // Label 197: @3138
     /* 3138 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(3149), // Rule ID 240 //
     /* 3143 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 3146 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 3146 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 3149 */ // Label 198: @3149
     /* 3149 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(3160), // Rule ID 284 //
     /* 3154 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 3157 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 3157 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 3160 */ // Label 199: @3160
     /* 3160 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3171), // Rule ID 312 //
     /* 3165 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 3168 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 3168 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 3171 */ // Label 200: @3171
     /* 3171 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(3194), // Rule ID 107 //
     /* 3176 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 3179 */   // MIs[0] dst
     /* 3179 */   // No operand predicates
     /* 3179 */   // MIs[0] lhs
     /* 3179 */   // No operand predicates
     /* 3179 */   // MIs[0] Operand 2
     /* 3179 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3183 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3188 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 3188 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3193 */   GIR_EraseRootFromParent_Done,
     /* 3194 */ // Label 201: @3194
     /* 3194 */ GIM_Reject,
     /* 3195 */ // Label 11: @3195
     /* 3195 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3206), // Rule ID 140 //
     /* 3200 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 3203 */   // Combiner Rule #102: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 3203 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 3206 */ // Label 202: @3206
     /* 3206 */ GIM_Reject,
     /* 3207 */ // Label 12: @3207
     /* 3207 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3218), // Rule ID 363 //
     /* 3212 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 3215 */   // Combiner Rule #216: fold_global_offset; wip_match_opcode 'G_GLOBAL_VALUE'
     /* 3215 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner153),
     /* 3218 */ // Label 203: @3218
     /* 3218 */ GIM_Reject,
     /* 3219 */ // Label 13: @3219
     /* 3219 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3230), // Rule ID 348 //
     /* 3224 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 3227 */   // Combiner Rule #203: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3227 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 3230 */ // Label 204: @3230
     /* 3230 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(3241), // Rule ID 349 //
     /* 3235 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 3238 */   // Combiner Rule #204: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3238 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 3241 */ // Label 205: @3241
     /* 3241 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(3252), // Rule ID 351 //
     /* 3246 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 3249 */   // Combiner Rule #206: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3249 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 3252 */ // Label 206: @3252
     /* 3252 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(3263), // Rule ID 352 //
     /* 3257 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 3260 */   // Combiner Rule #207: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3260 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 3263 */ // Label 207: @3263
     /* 3263 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(3274), // Rule ID 353 //
     /* 3268 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 3271 */   // Combiner Rule #208: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3271 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 3274 */ // Label 208: @3274
     /* 3274 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3285), // Rule ID 354 //
     /* 3279 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 3282 */   // Combiner Rule #209: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3282 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 3285 */ // Label 209: @3285
     /* 3285 */ GIM_Reject,
     /* 3286 */ // Label 14: @3286
     /* 3286 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3297), // Rule ID 350 //
     /* 3291 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 3294 */   // Combiner Rule #205: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 3294 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 3297 */ // Label 210: @3297
     /* 3297 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3359),
     /* 3302 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 3305 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3326), // Rule ID 355 //
     /* 3310 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 3313 */     // MIs[0] root
     /* 3313 */     // No operand predicates
     /* 3313 */     // MIs[0] x
     /* 3313 */     // No operand predicates
     /* 3313 */     // MIs[0] undef
     /* 3313 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3323 */     // Combiner Rule #210: merge_of_x_and_undef
     /* 3323 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 3326 */   // Label 212: @3326
     /* 3326 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(3358), // Rule ID 356 //
     /* 3331 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 3334 */     // MIs[0] root
     /* 3334 */     // No operand predicates
     /* 3334 */     // MIs[0] x
     /* 3334 */     // No operand predicates
     /* 3334 */     // MIs[0] zero
     /* 3334 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3342 */     // MIs[1] Operand 1
     /* 3342 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 3353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3355 */     // Combiner Rule #211: merge_of_x_and_zero
     /* 3355 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 3358 */   // Label 213: @3358
     /* 3358 */   GIM_Reject,
     /* 3359 */ // Label 211: @3359
     /* 3359 */ GIM_Reject,
     /* 3360 */ // Label 15: @3360
     /* 3360 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3371), // Rule ID 69 //
     /* 3365 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3368 */   // Combiner Rule #67: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3368 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3371 */ // Label 214: @3371
     /* 3371 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3382), // Rule ID 98 //
     /* 3376 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 3379 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3379 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3382 */ // Label 215: @3382
     /* 3382 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3393), // Rule ID 133 //
     /* 3387 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3390 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3390 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3393 */ // Label 216: @3393
     /* 3393 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3407), // Rule ID 347 //
     /* 3398 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 3401 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 3404 */   // MIs[0] dst
     /* 3404 */   // No operand predicates
     /* 3404 */   // MIs[0] unused
     /* 3404 */   // No operand predicates
     /* 3404 */   // Combiner Rule #202: combine_use_vector_truncate
     /* 3404 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 3407 */ // Label 217: @3407
     /* 3407 */ GIM_Reject,
     /* 3408 */ // Label 16: @3408
     /* 3408 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3419), // Rule ID 132 //
     /* 3413 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3416 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 3416 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3419 */ // Label 218: @3419
     /* 3419 */ GIM_Reject,
     /* 3420 */ // Label 17: @3420
     /* 3420 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3431), // Rule ID 340 //
     /* 3425 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 3428 */   // Combiner Rule #195: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 3428 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 3431 */ // Label 219: @3431
     /* 3431 */ GIM_Reject,
     /* 3432 */ // Label 18: @3432
     /* 3432 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3453), // Rule ID 125 //
     /* 3437 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3440 */   // MIs[0] dst
     /* 3440 */   // No operand predicates
     /* 3440 */   // MIs[0] t
     /* 3440 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3444 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 3448 */   // MIs[1] ptr
     /* 3448 */   // No operand predicates
     /* 3448 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3450 */   // Combiner Rule #89: i2p_to_p2i
     /* 3450 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 3453 */ // Label 220: @3453
     /* 3453 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3474), // Rule ID 90 //
     /* 3458 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3461 */   // MIs[0] dst
     /* 3461 */   // No operand predicates
     /* 3461 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3461 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3465 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3471 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 3471 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3474 */ // Label 221: @3474
     /* 3474 */ GIM_Reject,
     /* 3475 */ // Label 19: @3475
     /* 3475 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3486), // Rule ID 124 //
     /* 3480 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3483 */   // Combiner Rule #88: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 3483 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 3486 */ // Label 222: @3486
     /* 3486 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3507), // Rule ID 91 //
     /* 3491 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3494 */   // MIs[0] dst
     /* 3494 */   // No operand predicates
     /* 3494 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3494 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3498 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3502 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3504 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 3504 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3507 */ // Label 223: @3507
     /* 3507 */ GIM_Reject,
     /* 3508 */ // Label 20: @3508
     /* 3508 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3529), // Rule ID 136 //
     /* 3513 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 3516 */   // MIs[0] dst
     /* 3516 */   // No operand predicates
     /* 3516 */   // MIs[0] src1
     /* 3516 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3520 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 3524 */   // MIs[1] src0
     /* 3524 */   // No operand predicates
     /* 3524 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3526 */   // Combiner Rule #98: bitcast_bitcast_fold
     /* 3526 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 3529 */ // Label 224: @3529
     /* 3529 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3550), // Rule ID 88 //
     /* 3534 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3537 */   // MIs[0] dst
     /* 3537 */   // No operand predicates
     /* 3537 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3537 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3541 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3545 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3547 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 3547 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3550 */ // Label 225: @3550
     /* 3550 */ GIM_Reject,
     /* 3551 */ // Label 21: @3551
     /* 3551 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3580), // Rule ID 18 //
     /* 3556 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 3559 */   // MIs[0] dst
     /* 3559 */   // No operand predicates
     /* 3559 */   // MIs[0] src
     /* 3559 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3563 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 3567 */   // MIs[1] __idempotent_prop_match_0.x
     /* 3567 */   // No operand predicates
     /* 3567 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3572 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3574 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 3574 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3579 */   GIR_EraseRootFromParent_Done,
     /* 3580 */ // Label 226: @3580
     /* 3580 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3603), // Rule ID 43 //
     /* 3585 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 3588 */   // MIs[0] root
     /* 3588 */   // No operand predicates
     /* 3588 */   // MIs[0] src
     /* 3588 */   // No operand predicates
     /* 3588 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3592 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3597 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 3597 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3602 */   GIR_EraseRootFromParent_Done,
     /* 3603 */ // Label 227: @3603
     /* 3603 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3614), // Rule ID 44 //
     /* 3608 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 3611 */   // MIs[0] dst
     /* 3611 */   // No operand predicates
     /* 3611 */   // MIs[0] src
     /* 3611 */   // No operand predicates
     /* 3611 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 3611 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 3614 */ // Label 228: @3614
     /* 3614 */ GIM_Reject,
     /* 3615 */ // Label 22: @3615
     /* 3615 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3626), // Rule ID 70 //
     /* 3620 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3623 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_LOAD'
     /* 3623 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3626 */ // Label 229: @3626
     /* 3626 */ GIM_Reject,
     /* 3627 */ // Label 23: @3627
     /* 3627 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3638), // Rule ID 71 //
     /* 3632 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3635 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 3635 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3638 */ // Label 230: @3638
     /* 3638 */ GIM_Reject,
     /* 3639 */ // Label 24: @3639
     /* 3639 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3650), // Rule ID 72 //
     /* 3644 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3647 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 3647 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3650 */ // Label 231: @3650
     /* 3650 */ GIM_Reject,
     /* 3651 */ // Label 25: @3651
     /* 3651 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3662), // Rule ID 100 //
     /* 3656 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 3659 */   // Combiner Rule #81: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 3659 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 3662 */ // Label 232: @3662
     /* 3662 */ GIM_Reject,
     /* 3663 */ // Label 26: @3663
     /* 3663 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3674), // Rule ID 126 //
     /* 3668 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 3671 */   // Combiner Rule #90: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 3671 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3674 */ // Label 233: @3674
     /* 3674 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3685), // Rule ID 257 //
     /* 3679 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 3682 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 3682 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 3685 */ // Label 234: @3685
     /* 3685 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3706), // Rule ID 57 //
     /* 3690 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 3693 */   // MIs[0] root
     /* 3693 */   // No operand predicates
     /* 3693 */   // MIs[0] select
     /* 3693 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3697 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3701 */   // MIs[1] cond
     /* 3701 */   // No operand predicates
     /* 3701 */   // MIs[1] true
     /* 3701 */   // No operand predicates
     /* 3701 */   // MIs[1] false
     /* 3701 */   // No operand predicates
     /* 3701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3703 */   // Combiner Rule #55: select_of_anyext
     /* 3703 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3706 */ // Label 235: @3706
     /* 3706 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3727), // Rule ID 52 //
     /* 3711 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 3714 */   // MIs[0] root
     /* 3714 */   // No operand predicates
     /* 3714 */   // MIs[0] second
     /* 3714 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3718 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3722 */   // MIs[1] src
     /* 3722 */   // No operand predicates
     /* 3722 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3724 */   // Combiner Rule #50: anyext_of_anyext
     /* 3724 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3727 */ // Label 236: @3727
     /* 3727 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3748), // Rule ID 54 //
     /* 3732 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 3735 */   // MIs[0] root
     /* 3735 */   // No operand predicates
     /* 3735 */   // MIs[0] second
     /* 3735 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3739 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3743 */   // MIs[1] src
     /* 3743 */   // No operand predicates
     /* 3743 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3745 */   // Combiner Rule #52: anyext_of_sext
     /* 3745 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3748 */ // Label 237: @3748
     /* 3748 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3769), // Rule ID 53 //
     /* 3753 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3756 */   // MIs[0] root
     /* 3756 */   // No operand predicates
     /* 3756 */   // MIs[0] second
     /* 3756 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3764 */   // MIs[1] src
     /* 3764 */   // No operand predicates
     /* 3764 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3766 */   // Combiner Rule #51: anyext_of_zext
     /* 3766 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3769 */ // Label 238: @3769
     /* 3769 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3790), // Rule ID 89 //
     /* 3774 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3777 */   // MIs[0] dst
     /* 3777 */   // No operand predicates
     /* 3777 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3777 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3785 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3787 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 3787 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3790 */ // Label 239: @3790
     /* 3790 */ GIM_Reject,
     /* 3791 */ // Label 27: @3791
     /* 3791 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3802), // Rule ID 134 //
     /* 3796 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 3799 */   // Combiner Rule #96: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3799 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3802 */ // Label 240: @3802
     /* 3802 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3813), // Rule ID 135 //
     /* 3807 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 3810 */   // Combiner Rule #97: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3810 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 3813 */ // Label 241: @3813
     /* 3813 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3824), // Rule ID 173 //
     /* 3818 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 3821 */   // Combiner Rule #131: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 3821 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 3824 */ // Label 242: @3824
     /* 3824 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3845), // Rule ID 58 //
     /* 3829 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 3832 */   // MIs[0] root
     /* 3832 */   // No operand predicates
     /* 3832 */   // MIs[0] select
     /* 3832 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3836 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3840 */   // MIs[1] cond
     /* 3840 */   // No operand predicates
     /* 3840 */   // MIs[1] true
     /* 3840 */   // No operand predicates
     /* 3840 */   // MIs[1] false
     /* 3840 */   // No operand predicates
     /* 3840 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3842 */   // Combiner Rule #56: select_of_truncate
     /* 3842 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3845 */ // Label 243: @3845
     /* 3845 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3874), // Rule ID 60 //
     /* 3850 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3853 */   // MIs[0] root
     /* 3853 */   // No operand predicates
     /* 3853 */   // MIs[0] binop
     /* 3853 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3857 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 3861 */   // MIs[1] x
     /* 3861 */   // No operand predicates
     /* 3861 */   // MIs[1] const
     /* 3861 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3865 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3869 */   // MIs[2] imm
     /* 3869 */   // No operand predicates
     /* 3869 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3871 */   // Combiner Rule #58: narrow_binop_add
     /* 3871 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3874 */ // Label 244: @3874
     /* 3874 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3903), // Rule ID 63 //
     /* 3879 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 3882 */   // MIs[0] root
     /* 3882 */   // No operand predicates
     /* 3882 */   // MIs[0] binop
     /* 3882 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3886 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 3890 */   // MIs[1] x
     /* 3890 */   // No operand predicates
     /* 3890 */   // MIs[1] const
     /* 3890 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3894 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3898 */   // MIs[2] imm
     /* 3898 */   // No operand predicates
     /* 3898 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3900 */   // Combiner Rule #61: narrow_binop_and
     /* 3900 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3903 */ // Label 245: @3903
     /* 3903 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3932), // Rule ID 62 //
     /* 3908 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3911 */   // MIs[0] root
     /* 3911 */   // No operand predicates
     /* 3911 */   // MIs[0] binop
     /* 3911 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 3919 */   // MIs[1] x
     /* 3919 */   // No operand predicates
     /* 3919 */   // MIs[1] const
     /* 3919 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3923 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3927 */   // MIs[2] imm
     /* 3927 */   // No operand predicates
     /* 3927 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3929 */   // Combiner Rule #60: narrow_binop_mul
     /* 3929 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3932 */ // Label 246: @3932
     /* 3932 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3961), // Rule ID 64 //
     /* 3937 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 3940 */   // MIs[0] root
     /* 3940 */   // No operand predicates
     /* 3940 */   // MIs[0] binop
     /* 3940 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3944 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 3948 */   // MIs[1] x
     /* 3948 */   // No operand predicates
     /* 3948 */   // MIs[1] const
     /* 3948 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3952 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3956 */   // MIs[2] imm
     /* 3956 */   // No operand predicates
     /* 3956 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3958 */   // Combiner Rule #62: narrow_binop_or
     /* 3958 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3961 */ // Label 247: @3961
     /* 3961 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3990), // Rule ID 61 //
     /* 3966 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 3969 */   // MIs[0] root
     /* 3969 */   // No operand predicates
     /* 3969 */   // MIs[0] binop
     /* 3969 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3973 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 3977 */   // MIs[1] x
     /* 3977 */   // No operand predicates
     /* 3977 */   // MIs[1] const
     /* 3977 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3981 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3985 */   // MIs[2] imm
     /* 3985 */   // No operand predicates
     /* 3985 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3987 */   // Combiner Rule #59: narrow_binop_sub
     /* 3987 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3990 */ // Label 248: @3990
     /* 3990 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(4019), // Rule ID 65 //
     /* 3995 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 3998 */   // MIs[0] root
     /* 3998 */   // No operand predicates
     /* 3998 */   // MIs[0] binop
     /* 3998 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 4006 */   // MIs[1] x
     /* 4006 */   // No operand predicates
     /* 4006 */   // MIs[1] const
     /* 4006 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 4010 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4014 */   // MIs[2] imm
     /* 4014 */   // No operand predicates
     /* 4014 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4016 */   // Combiner Rule #63: narrow_binop_xor
     /* 4016 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 4019 */ // Label 249: @4019
     /* 4019 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(4040), // Rule ID 47 //
     /* 4024 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 4027 */   // MIs[0] root
     /* 4027 */   // No operand predicates
     /* 4027 */   // MIs[0] ext
     /* 4027 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4031 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4035 */   // MIs[1] src
     /* 4035 */   // No operand predicates
     /* 4035 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4037 */   // Combiner Rule #45: truncate_of_anyext
     /* 4037 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4040 */ // Label 250: @4040
     /* 4040 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(4064), // Rule ID 59 //
     /* 4045 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 4048 */   // MIs[0] root
     /* 4048 */   // No operand predicates
     /* 4048 */   // MIs[0] bv
     /* 4048 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4052 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 4056 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 4059 */   // MIs[1] unused
     /* 4059 */   // No operand predicates
     /* 4059 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4061 */   // Combiner Rule #57: buildvector_of_truncate
     /* 4061 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 4064 */ // Label 251: @4064
     /* 4064 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(4085), // Rule ID 46 //
     /* 4069 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 4072 */   // MIs[0] root
     /* 4072 */   // No operand predicates
     /* 4072 */   // MIs[0] ext
     /* 4072 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4076 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 4080 */   // MIs[1] src
     /* 4080 */   // No operand predicates
     /* 4080 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4082 */   // Combiner Rule #44: truncate_of_sext
     /* 4082 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4085 */ // Label 252: @4085
     /* 4085 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(4106), // Rule ID 45 //
     /* 4090 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 4093 */   // MIs[0] root
     /* 4093 */   // No operand predicates
     /* 4093 */   // MIs[0] ext
     /* 4093 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4097 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4101 */   // MIs[1] src
     /* 4101 */   // No operand predicates
     /* 4101 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4103 */   // Combiner Rule #43: truncate_of_zext
     /* 4103 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4106 */ // Label 253: @4106
     /* 4106 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(4127), // Rule ID 87 //
     /* 4111 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 4114 */   // MIs[0] dst
     /* 4114 */   // No operand predicates
     /* 4114 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 4114 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4118 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 4122 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4124 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 4124 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 4127 */ // Label 254: @4127
     /* 4127 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(4148), // Rule ID 66 //
     /* 4132 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 4135 */   // MIs[0] root
     /* 4135 */   // No operand predicates
     /* 4135 */   // MIs[0] int
     /* 4135 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4143 */   // MIs[1] imm
     /* 4143 */   // No operand predicates
     /* 4143 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4145 */   // Combiner Rule #64: integer_of_truncate
     /* 4145 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 4148 */ // Label 255: @4148
     /* 4148 */ GIM_Reject,
     /* 4149 */ // Label 28: @4149
     /* 4149 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(4160), // Rule ID 361 //
     /* 4154 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 4157 */   // MIs[0] dst
     /* 4157 */   // No operand predicates
     /* 4157 */   // MIs[0] src
     /* 4157 */   // No operand predicates
     /* 4157 */   // Combiner Rule #214: fconstant_to_constant
     /* 4157 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner151),
     /* 4160 */ // Label 256: @4160
     /* 4160 */ GIM_Reject,
     /* 4161 */ // Label 29: @4161
     /* 4161 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(4172), // Rule ID 256 //
     /* 4166 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 4169 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 4169 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 4172 */ // Label 257: @4172
     /* 4172 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(4193), // Rule ID 51 //
     /* 4177 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 4180 */   // MIs[0] root
     /* 4180 */   // No operand predicates
     /* 4180 */   // MIs[0] second
     /* 4180 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4184 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4188 */   // MIs[1] src
     /* 4188 */   // No operand predicates
     /* 4188 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4190 */   // Combiner Rule #49: sext_of_anyext
     /* 4190 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4193 */ // Label 258: @4193
     /* 4193 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(4214), // Rule ID 50 //
     /* 4198 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 4201 */   // MIs[0] root
     /* 4201 */   // No operand predicates
     /* 4201 */   // MIs[0] second
     /* 4201 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4205 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 4209 */   // MIs[1] src
     /* 4209 */   // No operand predicates
     /* 4209 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4211 */   // Combiner Rule #48: sext_of_sext
     /* 4211 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4214 */ // Label 259: @4214
     /* 4214 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(4235), // Rule ID 341 //
     /* 4219 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 4222 */   // MIs[0] root
     /* 4222 */   // No operand predicates
     /* 4222 */   // MIs[0] src
     /* 4222 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4226 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4230 */   // MIs[1] x
     /* 4230 */   // No operand predicates
     /* 4230 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4232 */   // Combiner Rule #196: sext_trunc
     /* 4232 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 4235 */ // Label 260: @4235
     /* 4235 */ GIM_Reject,
     /* 4236 */ // Label 30: @4236
     /* 4236 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(4247), // Rule ID 160 //
     /* 4241 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 4244 */   // Combiner Rule #118: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 4244 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 4247 */ // Label 261: @4247
     /* 4247 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(4258), // Rule ID 168 //
     /* 4252 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 4255 */   // Combiner Rule #126: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 4255 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 4258 */ // Label 262: @4258
     /* 4258 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(4269), // Rule ID 225 //
     /* 4263 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 4266 */   // Combiner Rule #162: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 4266 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 4269 */ // Label 263: @4269
     /* 4269 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(4290), // Rule ID 55 //
     /* 4274 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 4277 */   // MIs[0] dst
     /* 4277 */   // No operand predicates
     /* 4277 */   // MIs[0] x
     /* 4277 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4281 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 4285 */   // MIs[1] src
     /* 4285 */   // No operand predicates
     /* 4285 */   // MIs[1] a
     /* 4285 */   // No operand predicates
     /* 4285 */   // MIs[0] b
     /* 4285 */   // No operand predicates
     /* 4285 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4287 */   // Combiner Rule #53: sext_inreg_of_sext_inreg
     /* 4287 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 4290 */ // Label 264: @4290
     /* 4290 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(4301), // Rule ID 172 //
     /* 4295 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 4298 */   // MIs[0] dst
     /* 4298 */   // No operand predicates
     /* 4298 */   // MIs[0] src
     /* 4298 */   // No operand predicates
     /* 4298 */   // MIs[0] imm
     /* 4298 */   // No operand predicates
     /* 4298 */   // Combiner Rule #130: sext_inreg_to_zext_inreg
     /* 4298 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 4301 */ // Label 265: @4301
     /* 4301 */ GIM_Reject,
     /* 4302 */ // Label 31: @4302
     /* 4302 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(4313), // Rule ID 171 //
     /* 4307 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 4310 */   // Combiner Rule #129: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 4310 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 4313 */ // Label 266: @4313
     /* 4313 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(4324), // Rule ID 255 //
     /* 4318 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 4321 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 4321 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 4324 */ // Label 267: @4324
     /* 4324 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(4345), // Rule ID 56 //
     /* 4329 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 4332 */   // MIs[0] root
     /* 4332 */   // No operand predicates
     /* 4332 */   // MIs[0] select
     /* 4332 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4336 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 4340 */   // MIs[1] cond
     /* 4340 */   // No operand predicates
     /* 4340 */   // MIs[1] true
     /* 4340 */   // No operand predicates
     /* 4340 */   // MIs[1] false
     /* 4340 */   // No operand predicates
     /* 4340 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4342 */   // Combiner Rule #54: select_of_zext
     /* 4342 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 4345 */ // Label 268: @4345
     /* 4345 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(4366), // Rule ID 49 //
     /* 4350 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 4353 */   // MIs[0] root
     /* 4353 */   // No operand predicates
     /* 4353 */   // MIs[0] second
     /* 4353 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4357 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4361 */   // MIs[1] src
     /* 4361 */   // No operand predicates
     /* 4361 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4363 */   // Combiner Rule #47: zext_of_anyext
     /* 4363 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4366 */ // Label 269: @4366
     /* 4366 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(4393), // Rule ID 342 //
     /* 4371 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 4374 */   // MIs[0] root
     /* 4374 */   // No operand predicates
     /* 4374 */   // MIs[0] src
     /* 4374 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4378 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4382 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 4388 */   // MIs[1] x
     /* 4388 */   // No operand predicates
     /* 4388 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4390 */   // Combiner Rule #197: zext_trunc
     /* 4390 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 4393 */ // Label 270: @4393
     /* 4393 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(4414), // Rule ID 48 //
     /* 4398 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 4401 */   // MIs[0] root
     /* 4401 */   // No operand predicates
     /* 4401 */   // MIs[0] second
     /* 4401 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4405 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4409 */   // MIs[1] src
     /* 4409 */   // No operand predicates
     /* 4409 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4411 */   // Combiner Rule #46: zext_of_zext
     /* 4411 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4414 */ // Label 271: @4414
     /* 4414 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(4431), // Rule ID 343 //
     /* 4419 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 4422 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 4428 */   // MIs[0] root
     /* 4428 */   // No operand predicates
     /* 4428 */   // MIs[0] x
     /* 4428 */   // No operand predicates
     /* 4428 */   // Combiner Rule #198: nneg_zext
     /* 4428 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 4431 */ // Label 272: @4431
     /* 4431 */ GIM_Reject,
     /* 4432 */ // Label 32: @4432
     /* 4432 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(4443), // Rule ID 80 //
     /* 4437 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4440 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 4440 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4443 */ // Label 273: @4443
     /* 4443 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(4454), // Rule ID 83 //
     /* 4448 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4451 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 4451 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4454 */ // Label 274: @4454
     /* 4454 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(4465), // Rule ID 116 //
     /* 4459 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4462 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 4462 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4465 */ // Label 275: @4465
     /* 4465 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(4476), // Rule ID 200 //
     /* 4470 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4473 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 4473 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4476 */ // Label 276: @4476
     /* 4476 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(4487), // Rule ID 205 //
     /* 4481 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4484 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 4484 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4487 */ // Label 277: @4487
     /* 4487 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(4498), // Rule ID 224 //
     /* 4492 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 4495 */   // Combiner Rule #161: commute_shift; wip_match_opcode 'G_SHL'
     /* 4495 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 4498 */ // Label 278: @4498
     /* 4498 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(4509), // Rule ID 238 //
     /* 4503 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4506 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 4506 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4509 */ // Label 279: @4509
     /* 4509 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(4520), // Rule ID 291 //
     /* 4514 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4517 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 4517 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4520 */ // Label 280: @4520
     /* 4520 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(4555), // Rule ID 41 //
     /* 4525 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 4528 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 4534 */   // MIs[0] root
     /* 4534 */   // No operand predicates
     /* 4534 */   // MIs[0] left
     /* 4534 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 4542 */   // MIs[1] imm
     /* 4542 */   // No operand predicates
     /* 4542 */   // MIs[0] x
     /* 4542 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 4546 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4550 */   // MIs[2] imm1
     /* 4550 */   // No operand predicates
     /* 4550 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4552 */   // Combiner Rule #39: shl_of_vscale
     /* 4552 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 4555 */ // Label 281: @4555
     /* 4555 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(4578), // Rule ID 108 //
     /* 4560 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4563 */   // MIs[0] dst
     /* 4563 */   // No operand predicates
     /* 4563 */   // MIs[0] lhs
     /* 4563 */   // No operand predicates
     /* 4563 */   // MIs[0] Operand 2
     /* 4563 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4567 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4572 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 4572 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4577 */   GIR_EraseRootFromParent_Done,
     /* 4578 */ // Label 282: @4578
     /* 4578 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(4589), // Rule ID 145 //
     /* 4583 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4586 */   // MIs[0] root
     /* 4586 */   // No operand predicates
     /* 4586 */   // MIs[0] mi.shifted
     /* 4586 */   // No operand predicates
     /* 4586 */   // MIs[0] mi.amt
     /* 4586 */   // No operand predicates
     /* 4586 */   // Combiner Rule #105: shifts_too_big @ [mi[0]]
     /* 4586 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4589 */ // Label 283: @4589
     /* 4589 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(4600), // Rule ID 161 //
     /* 4594 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 4597 */   // MIs[0] dst
     /* 4597 */   // No operand predicates
     /* 4597 */   // MIs[0] src0
     /* 4597 */   // No operand predicates
     /* 4597 */   // MIs[0] src1
     /* 4597 */   // No operand predicates
     /* 4597 */   // Combiner Rule #119: reduce_shl_of_extend
     /* 4597 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 4600 */ // Label 284: @4600
     /* 4600 */ GIM_Reject,
     /* 4601 */ // Label 33: @4601
     /* 4601 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(4612), // Rule ID 85 //
     /* 4606 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4609 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 4609 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4612 */ // Label 285: @4612
     /* 4612 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(4623), // Rule ID 117 //
     /* 4617 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4620 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 4620 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4623 */ // Label 286: @4623
     /* 4623 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(4634), // Rule ID 202 //
     /* 4628 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4631 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 4631 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4634 */ // Label 287: @4634
     /* 4634 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(4645), // Rule ID 207 //
     /* 4639 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4642 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 4642 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4645 */ // Label 288: @4645
     /* 4645 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(4656), // Rule ID 228 //
     /* 4650 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4653 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 4653 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4656 */ // Label 289: @4656
     /* 4656 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(4667), // Rule ID 230 //
     /* 4661 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4664 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 4664 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4667 */ // Label 290: @4667
     /* 4667 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(4678), // Rule ID 235 //
     /* 4672 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4675 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 4675 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4678 */ // Label 291: @4678
     /* 4678 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(4689), // Rule ID 289 //
     /* 4683 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4686 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 4686 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4689 */ // Label 292: @4689
     /* 4689 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(4712), // Rule ID 110 //
     /* 4694 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4697 */   // MIs[0] dst
     /* 4697 */   // No operand predicates
     /* 4697 */   // MIs[0] lhs
     /* 4697 */   // No operand predicates
     /* 4697 */   // MIs[0] Operand 2
     /* 4697 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4701 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4706 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 4706 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4711 */   GIR_EraseRootFromParent_Done,
     /* 4712 */ // Label 293: @4712
     /* 4712 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(4723), // Rule ID 147 //
     /* 4717 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4720 */   // MIs[0] root
     /* 4720 */   // No operand predicates
     /* 4720 */   // MIs[0] mi.shifted
     /* 4720 */   // No operand predicates
     /* 4720 */   // MIs[0] mi.amt
     /* 4720 */   // No operand predicates
     /* 4720 */   // Combiner Rule #105: shifts_too_big @ [mi[2]]
     /* 4720 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4723 */ // Label 294: @4723
     /* 4723 */ GIM_Reject,
     /* 4724 */ // Label 34: @4724
     /* 4724 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(4735), // Rule ID 84 //
     /* 4729 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4732 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 4732 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4735 */ // Label 295: @4735
     /* 4735 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(4746), // Rule ID 118 //
     /* 4740 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4743 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 4743 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4746 */ // Label 296: @4746
     /* 4746 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(4757), // Rule ID 158 //
     /* 4751 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 4754 */   // Combiner Rule #116: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 4754 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 4757 */ // Label 297: @4757
     /* 4757 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(4768), // Rule ID 201 //
     /* 4762 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4765 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 4765 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4768 */ // Label 298: @4768
     /* 4768 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(4779), // Rule ID 206 //
     /* 4773 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4776 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 4776 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4779 */ // Label 299: @4779
     /* 4779 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(4790), // Rule ID 227 //
     /* 4784 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4787 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 4787 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4790 */ // Label 300: @4790
     /* 4790 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(4801), // Rule ID 229 //
     /* 4795 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4798 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 4798 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4801 */ // Label 301: @4801
     /* 4801 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(4812), // Rule ID 234 //
     /* 4806 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4809 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 4809 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4812 */ // Label 302: @4812
     /* 4812 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(4823), // Rule ID 290 //
     /* 4817 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4820 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 4820 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4823 */ // Label 303: @4823
     /* 4823 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(4846), // Rule ID 109 //
     /* 4828 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4831 */   // MIs[0] dst
     /* 4831 */   // No operand predicates
     /* 4831 */   // MIs[0] lhs
     /* 4831 */   // No operand predicates
     /* 4831 */   // MIs[0] Operand 2
     /* 4831 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4835 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4840 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 4840 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4845 */   GIR_EraseRootFromParent_Done,
     /* 4846 */ // Label 304: @4846
     /* 4846 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(4857), // Rule ID 146 //
     /* 4851 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4854 */   // MIs[0] root
     /* 4854 */   // No operand predicates
     /* 4854 */   // MIs[0] mi.shifted
     /* 4854 */   // No operand predicates
     /* 4854 */   // MIs[0] mi.amt
     /* 4854 */   // No operand predicates
     /* 4854 */   // Combiner Rule #105: shifts_too_big @ [mi[1]]
     /* 4854 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4857 */ // Label 305: @4857
     /* 4857 */ GIM_Reject,
     /* 4858 */ // Label 35: @4858
     /* 4858 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(4869), // Rule ID 216 //
     /* 4863 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4866 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 4866 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4869 */ // Label 306: @4869
     /* 4869 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(4880), // Rule ID 220 //
     /* 4874 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4877 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 4877 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4880 */ // Label 307: @4880
     /* 4880 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(4900), // Rule ID 219 //
     /* 4885 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 4888 */   // MIs[0] x
     /* 4888 */   // No operand predicates
     /* 4888 */   // MIs[0] y
     /* 4888 */   // No operand predicates
     /* 4888 */   // MIs[0] z
     /* 4888 */   // No operand predicates
     /* 4888 */   // MIs[0] Operand 3
     /* 4888 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4892 */   // Combiner Rule #157: funnel_shift_left_zero
     /* 4892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4895 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4897 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 4899 */   GIR_EraseRootFromParent_Done,
     /* 4900 */ // Label 308: @4900
     /* 4900 */ GIM_Reject,
     /* 4901 */ // Label 36: @4901
     /* 4901 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(4912), // Rule ID 217 //
     /* 4906 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4909 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 4909 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4912 */ // Label 309: @4912
     /* 4912 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(4923), // Rule ID 221 //
     /* 4917 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4920 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 4920 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4923 */ // Label 310: @4923
     /* 4923 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(4943), // Rule ID 218 //
     /* 4928 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4931 */   // MIs[0] x
     /* 4931 */   // No operand predicates
     /* 4931 */   // MIs[0] y
     /* 4931 */   // No operand predicates
     /* 4931 */   // MIs[0] z
     /* 4931 */   // No operand predicates
     /* 4931 */   // MIs[0] Operand 3
     /* 4931 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4935 */   // Combiner Rule #156: funnel_shift_right_zero
     /* 4935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4938 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4940 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 4942 */   GIR_EraseRootFromParent_Done,
     /* 4943 */ // Label 311: @4943
     /* 4943 */ GIM_Reject,
     /* 4944 */ // Label 37: @4944
     /* 4944 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(4967), // Rule ID 113 //
     /* 4949 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4952 */   // MIs[0] dst
     /* 4952 */   // No operand predicates
     /* 4952 */   // MIs[0] lhs
     /* 4952 */   // No operand predicates
     /* 4952 */   // MIs[0] Operand 2
     /* 4952 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4956 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4961 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 4961 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4966 */   GIR_EraseRootFromParent_Done,
     /* 4967 */ // Label 312: @4967
     /* 4967 */ GIM_Reject,
     /* 4968 */ // Label 38: @4968
     /* 4968 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(4991), // Rule ID 112 //
     /* 4973 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4976 */   // MIs[0] dst
     /* 4976 */   // No operand predicates
     /* 4976 */   // MIs[0] lhs
     /* 4976 */   // No operand predicates
     /* 4976 */   // MIs[0] Operand 2
     /* 4976 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4980 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4985 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 4985 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4990 */   GIR_EraseRootFromParent_Done,
     /* 4991 */ // Label 313: @4991
     /* 4991 */ GIM_Reject,
     /* 4992 */ // Label 39: @4992
     /* 4992 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(5003), // Rule ID 153 //
     /* 4997 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 5000 */   // Combiner Rule #111: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 5000 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 5003 */ // Label 314: @5003
     /* 5003 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(5014), // Rule ID 154 //
     /* 5008 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 5011 */   // Combiner Rule #112: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 5011 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 5014 */ // Label 315: @5014
     /* 5014 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(5025), // Rule ID 157 //
     /* 5019 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 5022 */   // Combiner Rule #115: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 5022 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 5025 */ // Label 316: @5025
     /* 5025 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(5036), // Rule ID 151 //
     /* 5030 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 5033 */   // MIs[0] root
     /* 5033 */   // No operand predicates
     /* 5033 */   // MIs[0] pred
     /* 5033 */   // No operand predicates
     /* 5033 */   // MIs[0] lhs
     /* 5033 */   // No operand predicates
     /* 5033 */   // MIs[0] rhs
     /* 5033 */   // No operand predicates
     /* 5033 */   // Combiner Rule #109: canonicalize_icmp
     /* 5033 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 5036 */ // Label 317: @5036
     /* 5036 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(5047), // Rule ID 362 //
     /* 5041 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule215Enabled),
     /* 5044 */   // MIs[0] dst
     /* 5044 */   // No operand predicates
     /* 5044 */   // MIs[0] tst
     /* 5044 */   // No operand predicates
     /* 5044 */   // MIs[0] src1
     /* 5044 */   // No operand predicates
     /* 5044 */   // MIs[0] src2
     /* 5044 */   // No operand predicates
     /* 5044 */   // Combiner Rule #215: icmp_redundant_trunc
     /* 5044 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner152),
     /* 5047 */ // Label 318: @5047
     /* 5047 */ GIM_Reject,
     /* 5048 */ // Label 40: @5048
     /* 5048 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(5059), // Rule ID 152 //
     /* 5053 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 5056 */   // MIs[0] root
     /* 5056 */   // No operand predicates
     /* 5056 */   // MIs[0] pred
     /* 5056 */   // No operand predicates
     /* 5056 */   // MIs[0] lhs
     /* 5056 */   // No operand predicates
     /* 5056 */   // MIs[0] rhs
     /* 5056 */   // No operand predicates
     /* 5056 */   // Combiner Rule #110: canonicalize_fcmp
     /* 5056 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 5059 */ // Label 319: @5059
     /* 5059 */ GIM_Reject,
     /* 5060 */ // Label 41: @5060
     /* 5060 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(5071), // Rule ID 103 //
     /* 5065 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 5068 */   // Combiner Rule #83: select_same_val; wip_match_opcode 'G_SELECT'
     /* 5068 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 5071 */ // Label 320: @5071
     /* 5071 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(5082), // Rule ID 164 //
     /* 5076 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 5079 */   // Combiner Rule #122: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 5079 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 5082 */ // Label 321: @5082
     /* 5082 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(5093), // Rule ID 166 //
     /* 5087 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 5090 */   // Combiner Rule #124: match_selects; wip_match_opcode 'G_SELECT'
     /* 5090 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 5093 */ // Label 322: @5093
     /* 5093 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(5104), // Rule ID 306 //
     /* 5098 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5101 */   // Combiner Rule #188: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 5101 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 5104 */ // Label 323: @5104
     /* 5104 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(5125), // Rule ID 165 //
     /* 5109 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 5112 */   // MIs[0] root
     /* 5112 */   // No operand predicates
     /* 5112 */   // MIs[0] tst
     /* 5112 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5116 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 5120 */   // MIs[1] tst1
     /* 5120 */   // No operand predicates
     /* 5120 */   // MIs[1] a
     /* 5120 */   // No operand predicates
     /* 5120 */   // MIs[1] b
     /* 5120 */   // No operand predicates
     /* 5120 */   // MIs[0] x
     /* 5120 */   // No operand predicates
     /* 5120 */   // MIs[0] y
     /* 5120 */   // No operand predicates
     /* 5120 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5122 */   // Combiner Rule #123: select_to_iminmax
     /* 5122 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 5125 */ // Label 324: @5125
     /* 5125 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(5154), // Rule ID 163 //
     /* 5130 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 5133 */   // MIs[0] dst
     /* 5133 */   // No operand predicates
     /* 5133 */   // MIs[0] undef
     /* 5133 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5137 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5141 */   // MIs[0] x
     /* 5141 */   // No operand predicates
     /* 5141 */   // MIs[0] y
     /* 5141 */   // No operand predicates
     /* 5141 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 5146 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5148 */   // Combiner Rule #121: select_undef_cmp
     /* 5148 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 5153 */   GIR_EraseRootFromParent_Done,
     /* 5154 */ // Label 325: @5154
     /* 5154 */ GIM_Reject,
     /* 5155 */ // Label 42: @5155
     /* 5155 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(5166), // Rule ID 317 //
     /* 5160 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5163 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 5163 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5166 */ // Label 326: @5166
     /* 5166 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(5177), // Rule ID 358 //
     /* 5171 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 5174 */   // Combiner Rule #212: match_addos; wip_match_opcode 'G_UADDO'
     /* 5174 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 5177 */ // Label 327: @5177
     /* 5177 */ GIM_Reject,
     /* 5178 */ // Label 43: @5178
     /* 5178 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(5189), // Rule ID 189 //
     /* 5183 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5186 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 5186 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5189 */ // Label 328: @5189
     /* 5189 */ GIM_Reject,
     /* 5190 */ // Label 44: @5190
     /* 5190 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(5201), // Rule ID 360 //
     /* 5195 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 5198 */   // Combiner Rule #213: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 5198 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 5201 */ // Label 329: @5201
     /* 5201 */ GIM_Reject,
     /* 5202 */ // Label 45: @5202
     /* 5202 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(5213), // Rule ID 191 //
     /* 5207 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5210 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 5210 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5213 */ // Label 330: @5213
     /* 5213 */ GIM_Reject,
     /* 5214 */ // Label 46: @5214
     /* 5214 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(5225), // Rule ID 318 //
     /* 5219 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5222 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 5222 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5225 */ // Label 331: @5225
     /* 5225 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(5236), // Rule ID 357 //
     /* 5230 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 5233 */   // Combiner Rule #212: match_addos; wip_match_opcode 'G_SADDO'
     /* 5233 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 5236 */ // Label 332: @5236
     /* 5236 */ GIM_Reject,
     /* 5237 */ // Label 47: @5237
     /* 5237 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(5248), // Rule ID 190 //
     /* 5242 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5245 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 5245 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5248 */ // Label 333: @5248
     /* 5248 */ GIM_Reject,
     /* 5249 */ // Label 48: @5249
     /* 5249 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(5260), // Rule ID 359 //
     /* 5254 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 5257 */   // Combiner Rule #213: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 5257 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 5260 */ // Label 334: @5260
     /* 5260 */ GIM_Reject,
     /* 5261 */ // Label 49: @5261
     /* 5261 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(5272), // Rule ID 192 //
     /* 5266 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5269 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 5269 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5272 */ // Label 335: @5272
     /* 5272 */ GIM_Reject,
     /* 5273 */ // Label 50: @5273
     /* 5273 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(5284), // Rule ID 185 //
     /* 5278 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5281 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 5281 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5284 */ // Label 336: @5284
     /* 5284 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(5295), // Rule ID 187 //
     /* 5289 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5292 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 5292 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5295 */ // Label 337: @5295
     /* 5295 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(5306), // Rule ID 319 //
     /* 5300 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5303 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 5303 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5306 */ // Label 338: @5306
     /* 5306 */ GIM_Reject,
     /* 5307 */ // Label 51: @5307
     /* 5307 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(5318), // Rule ID 186 //
     /* 5312 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5315 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 5315 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5318 */ // Label 339: @5318
     /* 5318 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(5329), // Rule ID 188 //
     /* 5323 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5326 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 5326 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5329 */ // Label 340: @5329
     /* 5329 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(5340), // Rule ID 320 //
     /* 5334 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5337 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 5337 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5340 */ // Label 341: @5340
     /* 5340 */ GIM_Reject,
     /* 5341 */ // Label 52: @5341
     /* 5341 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(5352), // Rule ID 263 //
     /* 5346 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5349 */   // Combiner Rule #175: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 5349 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5352 */ // Label 342: @5352
     /* 5352 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(5363), // Rule ID 321 //
     /* 5357 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5360 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 5360 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5363 */ // Label 343: @5363
     /* 5363 */ GIM_Reject,
     /* 5364 */ // Label 53: @5364
     /* 5364 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(5375), // Rule ID 322 //
     /* 5369 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5372 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 5372 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5375 */ // Label 344: @5375
     /* 5375 */ GIM_Reject,
     /* 5376 */ // Label 54: @5376
     /* 5376 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(5387), // Rule ID 323 //
     /* 5381 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5384 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 5384 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5387 */ // Label 345: @5387
     /* 5387 */ GIM_Reject,
     /* 5388 */ // Label 55: @5388
     /* 5388 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(5399), // Rule ID 324 //
     /* 5393 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5396 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 5396 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5399 */ // Label 346: @5399
     /* 5399 */ GIM_Reject,
     /* 5400 */ // Label 56: @5400
     /* 5400 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(5411), // Rule ID 204 //
     /* 5405 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5408 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 5408 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5411 */ // Label 347: @5411
     /* 5411 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(5422), // Rule ID 208 //
     /* 5416 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5419 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 5419 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5422 */ // Label 348: @5422
     /* 5422 */ GIM_Reject,
     /* 5423 */ // Label 57: @5423
     /* 5423 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(5434), // Rule ID 203 //
     /* 5428 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5431 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5431 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5434 */ // Label 349: @5434
     /* 5434 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(5445), // Rule ID 209 //
     /* 5439 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5442 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5442 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5445 */ // Label 350: @5445
     /* 5445 */ GIM_Reject,
     /* 5446 */ // Label 58: @5446
     /* 5446 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(5457), // Rule ID 325 //
     /* 5451 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5454 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 5454 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5457 */ // Label 351: @5457
     /* 5457 */ GIM_Reject,
     /* 5458 */ // Label 59: @5458
     /* 5458 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(5469), // Rule ID 326 //
     /* 5463 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5466 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 5466 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5469 */ // Label 352: @5469
     /* 5469 */ GIM_Reject,
     /* 5470 */ // Label 60: @5470
     /* 5470 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(5481), // Rule ID 327 //
     /* 5475 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5478 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 5478 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5481 */ // Label 353: @5481
     /* 5481 */ GIM_Reject,
     /* 5482 */ // Label 61: @5482
     /* 5482 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(5493), // Rule ID 328 //
     /* 5487 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5490 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 5490 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5493 */ // Label 354: @5493
     /* 5493 */ GIM_Reject,
     /* 5494 */ // Label 62: @5494
     /* 5494 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(5505), // Rule ID 249 //
     /* 5499 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5502 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 5502 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5505 */ // Label 355: @5505
     /* 5505 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(5516), // Rule ID 264 //
     /* 5510 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5513 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 5513 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5516 */ // Label 356: @5516
     /* 5516 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(5527), // Rule ID 271 //
     /* 5521 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 5524 */   // Combiner Rule #178: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5524 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 5527 */ // Label 357: @5527
     /* 5527 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(5538), // Rule ID 272 //
     /* 5532 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 5535 */   // Combiner Rule #179: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5535 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 5538 */ // Label 358: @5538
     /* 5538 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(5549), // Rule ID 273 //
     /* 5543 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 5546 */   // Combiner Rule #180: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5546 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 5549 */ // Label 359: @5549
     /* 5549 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(5560), // Rule ID 274 //
     /* 5554 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 5557 */   // Combiner Rule #181: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5557 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 5560 */ // Label 360: @5560
     /* 5560 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(5571), // Rule ID 297 //
     /* 5565 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5568 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 5568 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5571 */ // Label 361: @5571
     /* 5571 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(5582), // Rule ID 329 //
     /* 5576 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5579 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 5579 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5582 */ // Label 362: @5582
     /* 5582 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(5605), // Rule ID 138 //
     /* 5587 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 5590 */   // MIs[0] dst
     /* 5590 */   // No operand predicates
     /* 5590 */   // MIs[0] x
     /* 5590 */   // No operand predicates
     /* 5590 */   // MIs[0] y
     /* 5590 */   // No operand predicates
     /* 5590 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 5594 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5599 */   // Combiner Rule #100: right_identity_neg_zero_fp
     /* 5599 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5604 */   GIR_EraseRootFromParent_Done,
     /* 5605 */ // Label 363: @5605
     /* 5605 */ GIM_Reject,
     /* 5606 */ // Label 63: @5606
     /* 5606 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(5617), // Rule ID 250 //
     /* 5611 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5614 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 5614 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5617 */ // Label 364: @5617
     /* 5617 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(5628), // Rule ID 265 //
     /* 5622 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5625 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 5625 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5628 */ // Label 365: @5628
     /* 5628 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(5639), // Rule ID 275 //
     /* 5633 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5636 */   // Combiner Rule #182: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5636 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5639 */ // Label 366: @5639
     /* 5639 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(5650), // Rule ID 276 //
     /* 5644 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 5647 */   // Combiner Rule #183: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5647 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 5650 */ // Label 367: @5650
     /* 5650 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(5661), // Rule ID 277 //
     /* 5655 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5658 */   // Combiner Rule #184: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5658 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 5661 */ // Label 368: @5661
     /* 5661 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(5672), // Rule ID 278 //
     /* 5666 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5669 */   // Combiner Rule #185: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5669 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5672 */ // Label 369: @5672
     /* 5672 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(5683), // Rule ID 298 //
     /* 5677 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5680 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 5680 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5683 */ // Label 370: @5683
     /* 5683 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(5694), // Rule ID 307 //
     /* 5688 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5691 */   // Combiner Rule #189: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 5691 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5694 */ // Label 371: @5694
     /* 5694 */ GIM_Reject,
     /* 5695 */ // Label 64: @5695
     /* 5695 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(5706), // Rule ID 251 //
     /* 5700 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5703 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 5703 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5706 */ // Label 372: @5706
     /* 5706 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(5717), // Rule ID 266 //
     /* 5711 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5714 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 5714 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5717 */ // Label 373: @5717
     /* 5717 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(5728), // Rule ID 296 //
     /* 5722 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5725 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 5725 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5728 */ // Label 374: @5728
     /* 5728 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(5739), // Rule ID 330 //
     /* 5733 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5736 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 5736 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5739 */ // Label 375: @5739
     /* 5739 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(5762), // Rule ID 129 //
     /* 5744 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 5747 */   // MIs[0] dst
     /* 5747 */   // No operand predicates
     /* 5747 */   // MIs[0] x
     /* 5747 */   // No operand predicates
     /* 5747 */   // MIs[0] y
     /* 5747 */   // No operand predicates
     /* 5747 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 5751 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5756 */   // Combiner Rule #93: right_identity_one_fp
     /* 5756 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5761 */   GIR_EraseRootFromParent_Done,
     /* 5762 */ // Label 376: @5762
     /* 5762 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(5782), // Rule ID 139 //
     /* 5767 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 5770 */   // MIs[0] dst
     /* 5770 */   // No operand predicates
     /* 5770 */   // MIs[0] x
     /* 5770 */   // No operand predicates
     /* 5770 */   // MIs[0] y
     /* 5770 */   // No operand predicates
     /* 5770 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 5774 */   // Combiner Rule #101: right_identity_neg_one_fp
     /* 5774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5779 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 5781 */   GIR_EraseRootFromParent_Done,
     /* 5782 */ // Label 377: @5782
     /* 5782 */ GIM_Reject,
     /* 5783 */ // Label 65: @5783
     /* 5783 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(5794), // Rule ID 254 //
     /* 5788 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5791 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 5791 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5794 */ // Label 378: @5794
     /* 5794 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(5805), // Rule ID 269 //
     /* 5799 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5802 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 5802 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5805 */ // Label 379: @5805
     /* 5805 */ GIM_Reject,
     /* 5806 */ // Label 66: @5806
     /* 5806 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(5817), // Rule ID 253 //
     /* 5811 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5814 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 5814 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5817 */ // Label 380: @5817
     /* 5817 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(5828), // Rule ID 268 //
     /* 5822 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5825 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 5825 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5828 */ // Label 381: @5828
     /* 5828 */ GIM_Reject,
     /* 5829 */ // Label 67: @5829
     /* 5829 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(5840), // Rule ID 252 //
     /* 5834 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5837 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 5837 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5840 */ // Label 382: @5840
     /* 5840 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(5851), // Rule ID 267 //
     /* 5845 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5848 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 5848 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5851 */ // Label 383: @5851
     /* 5851 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(5862), // Rule ID 299 //
     /* 5856 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5859 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 5859 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5862 */ // Label 384: @5862
     /* 5862 */ GIM_Reject,
     /* 5863 */ // Label 68: @5863
     /* 5863 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(5874), // Rule ID 300 //
     /* 5868 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5871 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 5871 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5874 */ // Label 385: @5874
     /* 5874 */ GIM_Reject,
     /* 5875 */ // Label 69: @5875
     /* 5875 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(5896), // Rule ID 197 //
     /* 5880 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 5883 */   // MIs[0] dst
     /* 5883 */   // No operand predicates
     /* 5883 */   // MIs[0] float
     /* 5883 */   // No operand predicates
     /* 5883 */   // MIs[0] int
     /* 5883 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5887 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 5891 */   // MIs[1] imm
     /* 5891 */   // No operand predicates
     /* 5891 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5893 */   // Combiner Rule #147: expand_const_fpowi
     /* 5893 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 5896 */ // Label 386: @5896
     /* 5896 */ GIM_Reject,
     /* 5897 */ // Label 70: @5897
     /* 5897 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(5918), // Rule ID 179 //
     /* 5902 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 5905 */   // MIs[0] dst
     /* 5905 */   // No operand predicates
     /* 5905 */   // MIs[0] src0
     /* 5905 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5909 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5913 */   // MIs[1] cst
     /* 5913 */   // No operand predicates
     /* 5913 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5915 */   // Combiner Rule #137: constant_fold_flog2
     /* 5915 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5918 */ // Label 387: @5918
     /* 5918 */ GIM_Reject,
     /* 5919 */ // Label 71: @5919
     /* 5919 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(5940), // Rule ID 176 //
     /* 5924 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 5927 */   // MIs[0] dst
     /* 5927 */   // No operand predicates
     /* 5927 */   // MIs[0] src0
     /* 5927 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5935 */   // MIs[1] cst
     /* 5935 */   // No operand predicates
     /* 5935 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5937 */   // Combiner Rule #134: constant_fold_fneg
     /* 5937 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5940 */ // Label 388: @5940
     /* 5940 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(5969), // Rule ID 127 //
     /* 5945 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 5948 */   // MIs[0] dst
     /* 5948 */   // No operand predicates
     /* 5948 */   // MIs[0] t
     /* 5948 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5952 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5956 */   // MIs[1] src
     /* 5956 */   // No operand predicates
     /* 5956 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5961 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5963 */   // Combiner Rule #91: fneg_fneg_fold
     /* 5963 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5968 */   GIR_EraseRootFromParent_Done,
     /* 5969 */ // Label 389: @5969
     /* 5969 */ GIM_Reject,
     /* 5970 */ // Label 72: @5970
     /* 5970 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(5991), // Rule ID 180 //
     /* 5975 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 5978 */   // MIs[0] dst
     /* 5978 */   // No operand predicates
     /* 5978 */   // MIs[0] src0
     /* 5978 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5982 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5986 */   // MIs[1] cst
     /* 5986 */   // No operand predicates
     /* 5986 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5988 */   // Combiner Rule #138: constant_fold_fptrunc
     /* 5988 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5991 */ // Label 390: @5991
     /* 5991 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(6012), // Rule ID 137 //
     /* 5996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 5999 */   // MIs[0] dst
     /* 5999 */   // No operand predicates
     /* 5999 */   // MIs[0] src1
     /* 5999 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6003 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 6007 */   // MIs[1] src0
     /* 6007 */   // No operand predicates
     /* 6007 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6009 */   // Combiner Rule #99: fptrunc_fpext_fold
     /* 6009 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 6012 */ // Label 391: @6012
     /* 6012 */ GIM_Reject,
     /* 6013 */ // Label 73: @6013
     /* 6013 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(6034), // Rule ID 92 //
     /* 6018 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 6021 */   // MIs[0] dst
     /* 6021 */   // No operand predicates
     /* 6021 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 6021 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6025 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6031 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 6031 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 6034 */ // Label 392: @6034
     /* 6034 */ GIM_Reject,
     /* 6035 */ // Label 74: @6035
     /* 6035 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(6056), // Rule ID 93 //
     /* 6040 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 6043 */   // MIs[0] dst
     /* 6043 */   // No operand predicates
     /* 6043 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 6043 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6047 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6053 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 6053 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 6056 */ // Label 393: @6056
     /* 6056 */ GIM_Reject,
     /* 6057 */ // Label 75: @6057
     /* 6057 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(6068), // Rule ID 76 //
     /* 6062 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 6065 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 6065 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 6068 */ // Label 394: @6068
     /* 6068 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(6083), // Rule ID 181 //
     /* 6073 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 6076 */   // MIs[0] dst
     /* 6076 */   // No operand predicates
     /* 6076 */   // MIs[0] Operand 1
     /* 6076 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 6080 */   // Combiner Rule #139: itof_const_zero_fold_si
     /* 6080 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 6083 */ // Label 395: @6083
     /* 6083 */ GIM_Reject,
     /* 6084 */ // Label 76: @6084
     /* 6084 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(6095), // Rule ID 75 //
     /* 6089 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 6092 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 6092 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 6095 */ // Label 396: @6095
     /* 6095 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(6110), // Rule ID 182 //
     /* 6100 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 6103 */   // MIs[0] dst
     /* 6103 */   // No operand predicates
     /* 6103 */   // MIs[0] Operand 1
     /* 6103 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 6107 */   // Combiner Rule #140: itof_const_zero_fold_ui
     /* 6107 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 6110 */ // Label 397: @6110
     /* 6110 */ GIM_Reject,
     /* 6111 */ // Label 77: @6111
     /* 6111 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(6140), // Rule ID 19 //
     /* 6116 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 6119 */   // MIs[0] dst
     /* 6119 */   // No operand predicates
     /* 6119 */   // MIs[0] src
     /* 6119 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6123 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 6127 */   // MIs[1] __idempotent_prop_match_0.x
     /* 6127 */   // No operand predicates
     /* 6127 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6132 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6134 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 6134 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6139 */   GIR_EraseRootFromParent_Done,
     /* 6140 */ // Label 398: @6140
     /* 6140 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(6161), // Rule ID 177 //
     /* 6145 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 6148 */   // MIs[0] dst
     /* 6148 */   // No operand predicates
     /* 6148 */   // MIs[0] src0
     /* 6148 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 6156 */   // MIs[1] cst
     /* 6156 */   // No operand predicates
     /* 6156 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6158 */   // Combiner Rule #135: constant_fold_fabs
     /* 6158 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 6161 */ // Label 399: @6161
     /* 6161 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(6189), // Rule ID 258 //
     /* 6166 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 6169 */   // MIs[0] dst
     /* 6169 */   // No operand predicates
     /* 6169 */   // MIs[0] tmp
     /* 6169 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6173 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 6177 */   // MIs[1] x
     /* 6177 */   // No operand predicates
     /* 6177 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6179 */   // Combiner Rule #170: fabs_fneg_fold
     /* 6179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 6182 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 6184 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 6188 */   GIR_EraseRootFromParent_Done,
     /* 6189 */ // Label 400: @6189
     /* 6189 */ GIM_Reject,
     /* 6190 */ // Label 78: @6190
     /* 6190 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(6219), // Rule ID 20 //
     /* 6195 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 6198 */   // MIs[0] dst
     /* 6198 */   // No operand predicates
     /* 6198 */   // MIs[0] src
     /* 6198 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6202 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 6206 */   // MIs[1] __idempotent_prop_match_0.x
     /* 6206 */   // No operand predicates
     /* 6206 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6211 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6213 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 6213 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6218 */   GIR_EraseRootFromParent_Done,
     /* 6219 */ // Label 401: @6219
     /* 6219 */ GIM_Reject,
     /* 6220 */ // Label 79: @6220
     /* 6220 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(6231), // Rule ID 193 //
     /* 6225 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6228 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 6228 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6231 */ // Label 402: @6231
     /* 6231 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(6242), // Rule ID 301 //
     /* 6236 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6239 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 6239 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6242 */ // Label 403: @6242
     /* 6242 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(6253), // Rule ID 331 //
     /* 6247 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6250 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 6250 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6253 */ // Label 404: @6253
     /* 6253 */ GIM_Reject,
     /* 6254 */ // Label 80: @6254
     /* 6254 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(6265), // Rule ID 194 //
     /* 6259 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6262 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 6262 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6265 */ // Label 405: @6265
     /* 6265 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(6276), // Rule ID 302 //
     /* 6270 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6273 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 6273 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6276 */ // Label 406: @6276
     /* 6276 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(6287), // Rule ID 332 //
     /* 6281 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6284 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 6284 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6287 */ // Label 407: @6287
     /* 6287 */ GIM_Reject,
     /* 6288 */ // Label 81: @6288
     /* 6288 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(6299), // Rule ID 333 //
     /* 6293 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6296 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 6296 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6299 */ // Label 408: @6299
     /* 6299 */ GIM_Reject,
     /* 6300 */ // Label 82: @6300
     /* 6300 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(6311), // Rule ID 334 //
     /* 6305 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6308 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 6308 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6311 */ // Label 409: @6311
     /* 6311 */ GIM_Reject,
     /* 6312 */ // Label 83: @6312
     /* 6312 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(6323), // Rule ID 195 //
     /* 6317 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6320 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 6320 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6323 */ // Label 410: @6323
     /* 6323 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(6334), // Rule ID 303 //
     /* 6328 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6331 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 6331 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6334 */ // Label 411: @6334
     /* 6334 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(6345), // Rule ID 335 //
     /* 6339 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6342 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 6342 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6345 */ // Label 412: @6345
     /* 6345 */ GIM_Reject,
     /* 6346 */ // Label 84: @6346
     /* 6346 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(6357), // Rule ID 196 //
     /* 6351 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6354 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 6354 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6357 */ // Label 413: @6357
     /* 6357 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(6368), // Rule ID 304 //
     /* 6362 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6365 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 6365 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6368 */ // Label 414: @6368
     /* 6368 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(6379), // Rule ID 336 //
     /* 6373 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6376 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 6376 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6379 */ // Label 415: @6379
     /* 6379 */ GIM_Reject,
     /* 6380 */ // Label 85: @6380
     /* 6380 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(6391), // Rule ID 148 //
     /* 6385 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 6388 */   // Combiner Rule #106: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 6388 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 6391 */ // Label 416: @6391
     /* 6391 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(6402), // Rule ID 150 //
     /* 6396 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 6399 */   // Combiner Rule #108: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 6399 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 6402 */ // Label 417: @6402
     /* 6402 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(6413), // Rule ID 183 //
     /* 6407 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 6410 */   // Combiner Rule #141: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 6410 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 6413 */ // Label 418: @6413
     /* 6413 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(6424), // Rule ID 199 //
     /* 6418 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 6421 */   // Combiner Rule #149: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 6421 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 6424 */ // Label 419: @6424
     /* 6424 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(6435), // Rule ID 232 //
     /* 6429 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6432 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 6432 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6435 */ // Label 420: @6435
     /* 6435 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(6446), // Rule ID 281 //
     /* 6440 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6443 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 6443 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6446 */ // Label 421: @6446
     /* 6446 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(6469), // Rule ID 111 //
     /* 6451 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 6454 */   // MIs[0] dst
     /* 6454 */   // No operand predicates
     /* 6454 */   // MIs[0] lhs
     /* 6454 */   // No operand predicates
     /* 6454 */   // MIs[0] Operand 2
     /* 6454 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 6458 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6463 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 6463 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6468 */   GIR_EraseRootFromParent_Done,
     /* 6469 */ // Label 422: @6469
     /* 6469 */ GIM_Reject,
     /* 6470 */ // Label 86: @6470
     /* 6470 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(6481), // Rule ID 245 //
     /* 6475 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6478 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 6478 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6481 */ // Label 423: @6481
     /* 6481 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(6492), // Rule ID 292 //
     /* 6486 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6489 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 6489 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6492 */ // Label 424: @6492
     /* 6492 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(6503), // Rule ID 313 //
     /* 6497 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6500 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 6500 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6503 */ // Label 425: @6503
     /* 6503 */ GIM_Reject,
     /* 6504 */ // Label 87: @6504
     /* 6504 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(6515), // Rule ID 246 //
     /* 6509 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6512 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 6512 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6515 */ // Label 426: @6515
     /* 6515 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(6526), // Rule ID 293 //
     /* 6520 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6523 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 6523 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6526 */ // Label 427: @6526
     /* 6526 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(6537), // Rule ID 314 //
     /* 6531 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6534 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 6534 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6537 */ // Label 428: @6537
     /* 6537 */ GIM_Reject,
     /* 6538 */ // Label 88: @6538
     /* 6538 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(6549), // Rule ID 247 //
     /* 6543 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6546 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 6546 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6549 */ // Label 429: @6549
     /* 6549 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(6560), // Rule ID 294 //
     /* 6554 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6557 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 6557 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6560 */ // Label 430: @6560
     /* 6560 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(6571), // Rule ID 315 //
     /* 6565 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6568 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 6568 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6571 */ // Label 431: @6571
     /* 6571 */ GIM_Reject,
     /* 6572 */ // Label 89: @6572
     /* 6572 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(6583), // Rule ID 248 //
     /* 6577 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6580 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 6580 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6583 */ // Label 432: @6583
     /* 6583 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(6594), // Rule ID 295 //
     /* 6588 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6591 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 6591 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6594 */ // Label 433: @6594
     /* 6594 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(6605), // Rule ID 316 //
     /* 6599 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6602 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 6602 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6605 */ // Label 434: @6605
     /* 6605 */ GIM_Reject,
     /* 6606 */ // Label 90: @6606
     /* 6606 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(6617), // Rule ID 86 //
     /* 6611 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 6614 */   // Combiner Rule #76: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 6614 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 6617 */ // Label 435: @6617
     /* 6617 */ GIM_Reject,
     /* 6618 */ // Label 91: @6618
     /* 6618 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(6629), // Rule ID 175 //
     /* 6623 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 6626 */   // Combiner Rule #133: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 6626 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 6629 */ // Label 436: @6629
     /* 6629 */ GIM_Reject,
     /* 6630 */ // Label 92: @6630
     /* 6630 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(6641), // Rule ID 26 //
     /* 6635 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 6638 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6638 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 6641 */ // Label 437: @6641
     /* 6641 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(6652), // Rule ID 67 //
     /* 6646 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 6649 */   // Combiner Rule #65: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6649 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 6652 */ // Label 438: @6652
     /* 6652 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(6663), // Rule ID 101 //
     /* 6657 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6660 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6660 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6663 */ // Label 439: @6663
     /* 6663 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(6702), // Rule ID 38 //
     /* 6668 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 6671 */   // MIs[0] root
     /* 6671 */   // No operand predicates
     /* 6671 */   // MIs[0] src
     /* 6671 */   // No operand predicates
     /* 6671 */   // MIs[0] elt
     /* 6671 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6675 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 6679 */   // MIs[1] src
     /* 6679 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 6684 */   // MIs[1] idx
     /* 6684 */   // No operand predicates
     /* 6684 */   // MIs[0] idx
     /* 6684 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 6689 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6694 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6696 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 6696 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6701 */   GIR_EraseRootFromParent_Done,
     /* 6702 */ // Label 440: @6702
     /* 6702 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(6735), // Rule ID 24 //
     /* 6707 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 6710 */   // MIs[0] root
     /* 6710 */   // No operand predicates
     /* 6710 */   // MIs[0] src
     /* 6710 */   // No operand predicates
     /* 6710 */   // MIs[0] elt
     /* 6710 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6714 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6718 */   // MIs[0] idx
     /* 6718 */   // No operand predicates
     /* 6718 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 6722 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6727 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6729 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 6729 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6734 */   GIR_EraseRootFromParent_Done,
     /* 6735 */ // Label 441: @6735
     /* 6735 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(6759), // Rule ID 23 //
     /* 6740 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 6743 */   // MIs[0] root
     /* 6743 */   // No operand predicates
     /* 6743 */   // MIs[0] src
     /* 6743 */   // No operand predicates
     /* 6743 */   // MIs[0] elt
     /* 6743 */   // No operand predicates
     /* 6743 */   // MIs[0] idx
     /* 6743 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 6747 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6751 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6753 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 6753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6756 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6758 */   GIR_EraseRootFromParent_Done,
     /* 6759 */ // Label 442: @6759
     /* 6759 */ GIM_Reject,
     /* 6760 */ // Label 93: @6760
     /* 6760 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(6771), // Rule ID 25 //
     /* 6765 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 6768 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6768 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 6771 */ // Label 443: @6771
     /* 6771 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(6782), // Rule ID 68 //
     /* 6776 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 6779 */   // Combiner Rule #66: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6779 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 6782 */ // Label 444: @6782
     /* 6782 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(6793), // Rule ID 74 //
     /* 6787 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 6790 */   // Combiner Rule #70: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6790 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 6793 */ // Label 445: @6793
     /* 6793 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(6804), // Rule ID 102 //
     /* 6798 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6801 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6801 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6804 */ // Label 446: @6804
     /* 6804 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(6828), // Rule ID 36 //
     /* 6809 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 6812 */   // MIs[0] root
     /* 6812 */   // No operand predicates
     /* 6812 */   // MIs[0] src
     /* 6812 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6820 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 6823 */   // MIs[1] x
     /* 6823 */   // No operand predicates
     /* 6823 */   // MIs[1] y
     /* 6823 */   // No operand predicates
     /* 6823 */   // MIs[1] z
     /* 6823 */   // No operand predicates
     /* 6823 */   // MIs[1] a
     /* 6823 */   // No operand predicates
     /* 6823 */   // MIs[1] b
     /* 6823 */   // No operand predicates
     /* 6823 */   // MIs[1] c
     /* 6823 */   // No operand predicates
     /* 6823 */   // MIs[1] d
     /* 6823 */   // No operand predicates
     /* 6823 */   // MIs[1] e
     /* 6823 */   // No operand predicates
     /* 6823 */   // MIs[0] idx
     /* 6823 */   // No operand predicates
     /* 6823 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6825 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 6825 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6828 */ // Label 447: @6828
     /* 6828 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(6852), // Rule ID 35 //
     /* 6833 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 6836 */   // MIs[0] root
     /* 6836 */   // No operand predicates
     /* 6836 */   // MIs[0] src
     /* 6836 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6840 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6844 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 6847 */   // MIs[1] x
     /* 6847 */   // No operand predicates
     /* 6847 */   // MIs[1] y
     /* 6847 */   // No operand predicates
     /* 6847 */   // MIs[1] z
     /* 6847 */   // No operand predicates
     /* 6847 */   // MIs[1] a
     /* 6847 */   // No operand predicates
     /* 6847 */   // MIs[1] b
     /* 6847 */   // No operand predicates
     /* 6847 */   // MIs[1] c
     /* 6847 */   // No operand predicates
     /* 6847 */   // MIs[1] d
     /* 6847 */   // No operand predicates
     /* 6847 */   // MIs[0] idx
     /* 6847 */   // No operand predicates
     /* 6847 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6849 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 6849 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6852 */ // Label 448: @6852
     /* 6852 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(6876), // Rule ID 34 //
     /* 6857 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 6860 */   // MIs[0] root
     /* 6860 */   // No operand predicates
     /* 6860 */   // MIs[0] src
     /* 6860 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6864 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6868 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 6871 */   // MIs[1] x
     /* 6871 */   // No operand predicates
     /* 6871 */   // MIs[1] y
     /* 6871 */   // No operand predicates
     /* 6871 */   // MIs[1] z
     /* 6871 */   // No operand predicates
     /* 6871 */   // MIs[1] a
     /* 6871 */   // No operand predicates
     /* 6871 */   // MIs[1] b
     /* 6871 */   // No operand predicates
     /* 6871 */   // MIs[1] c
     /* 6871 */   // No operand predicates
     /* 6871 */   // MIs[0] idx
     /* 6871 */   // No operand predicates
     /* 6871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6873 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 6873 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6876 */ // Label 449: @6876
     /* 6876 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(6900), // Rule ID 33 //
     /* 6881 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 6884 */   // MIs[0] root
     /* 6884 */   // No operand predicates
     /* 6884 */   // MIs[0] src
     /* 6884 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6888 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6892 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 6895 */   // MIs[1] x
     /* 6895 */   // No operand predicates
     /* 6895 */   // MIs[1] y
     /* 6895 */   // No operand predicates
     /* 6895 */   // MIs[1] z
     /* 6895 */   // No operand predicates
     /* 6895 */   // MIs[1] a
     /* 6895 */   // No operand predicates
     /* 6895 */   // MIs[1] b
     /* 6895 */   // No operand predicates
     /* 6895 */   // MIs[0] idx
     /* 6895 */   // No operand predicates
     /* 6895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6897 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 6897 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6900 */ // Label 450: @6900
     /* 6900 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(6924), // Rule ID 32 //
     /* 6905 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 6908 */   // MIs[0] root
     /* 6908 */   // No operand predicates
     /* 6908 */   // MIs[0] src
     /* 6908 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6916 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 6919 */   // MIs[1] x
     /* 6919 */   // No operand predicates
     /* 6919 */   // MIs[1] y
     /* 6919 */   // No operand predicates
     /* 6919 */   // MIs[1] z
     /* 6919 */   // No operand predicates
     /* 6919 */   // MIs[1] a
     /* 6919 */   // No operand predicates
     /* 6919 */   // MIs[0] idx
     /* 6919 */   // No operand predicates
     /* 6919 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6921 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 6921 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6924 */ // Label 451: @6924
     /* 6924 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(6948), // Rule ID 31 //
     /* 6929 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 6932 */   // MIs[0] root
     /* 6932 */   // No operand predicates
     /* 6932 */   // MIs[0] src
     /* 6932 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6936 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6940 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 6943 */   // MIs[1] x
     /* 6943 */   // No operand predicates
     /* 6943 */   // MIs[1] y
     /* 6943 */   // No operand predicates
     /* 6943 */   // MIs[1] z
     /* 6943 */   // No operand predicates
     /* 6943 */   // MIs[0] idx
     /* 6943 */   // No operand predicates
     /* 6943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6945 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 6945 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6948 */ // Label 452: @6948
     /* 6948 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(6982), // Rule ID 27 //
     /* 6953 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 6956 */   // MIs[0] root
     /* 6956 */   // No operand predicates
     /* 6956 */   // MIs[0] src
     /* 6956 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6964 */   // MIs[1] x
     /* 6964 */   // No operand predicates
     /* 6964 */   // MIs[1] value
     /* 6964 */   // No operand predicates
     /* 6964 */   // MIs[1] idx
     /* 6964 */   // No operand predicates
     /* 6964 */   // MIs[0] idx
     /* 6964 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 6969 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6974 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6976 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 6976 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6981 */   GIR_EraseRootFromParent_Done,
     /* 6982 */ // Label 453: @6982
     /* 6982 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(7003), // Rule ID 28 //
     /* 6987 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 6990 */   // MIs[0] root
     /* 6990 */   // No operand predicates
     /* 6990 */   // MIs[0] src
     /* 6990 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6994 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6998 */   // MIs[1] x
     /* 6998 */   // No operand predicates
     /* 6998 */   // MIs[1] value
     /* 6998 */   // No operand predicates
     /* 6998 */   // MIs[1] idx2
     /* 6998 */   // No operand predicates
     /* 6998 */   // MIs[0] idx1
     /* 6998 */   // No operand predicates
     /* 6998 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7000 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 7000 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 7003 */ // Label 454: @7003
     /* 7003 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(7032), // Rule ID 37 //
     /* 7008 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 7011 */   // MIs[0] root
     /* 7011 */   // No operand predicates
     /* 7011 */   // MIs[0] src
     /* 7011 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 7019 */   // MIs[1] src1
     /* 7019 */   // No operand predicates
     /* 7019 */   // MIs[1] src2
     /* 7019 */   // No operand predicates
     /* 7019 */   // MIs[1] mask
     /* 7019 */   // No operand predicates
     /* 7019 */   // MIs[0] idx
     /* 7019 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 7023 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 7027 */   // MIs[2] imm
     /* 7027 */   // No operand predicates
     /* 7027 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7029 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 7029 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 7032 */ // Label 455: @7032
     /* 7032 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(7056), // Rule ID 30 //
     /* 7037 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 7040 */   // MIs[0] root
     /* 7040 */   // No operand predicates
     /* 7040 */   // MIs[0] src
     /* 7040 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 7048 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 7051 */   // MIs[1] x
     /* 7051 */   // No operand predicates
     /* 7051 */   // MIs[1] y
     /* 7051 */   // No operand predicates
     /* 7051 */   // MIs[0] idx
     /* 7051 */   // No operand predicates
     /* 7051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7053 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 7053 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 7056 */ // Label 456: @7056
     /* 7056 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(7088), // Rule ID 29 //
     /* 7061 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 7064 */   // MIs[0] root
     /* 7064 */   // No operand predicates
     /* 7064 */   // MIs[0] src
     /* 7064 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 7072 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 7075 */   // MIs[1] unused
     /* 7075 */   // No operand predicates
     /* 7075 */   // MIs[0] idx
     /* 7075 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 7079 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 7083 */   // MIs[2] imm
     /* 7083 */   // No operand predicates
     /* 7083 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7085 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 7085 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 7088 */ // Label 457: @7088
     /* 7088 */ GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(7112), // Rule ID 21 //
     /* 7093 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 7096 */   // MIs[0] root
     /* 7096 */   // No operand predicates
     /* 7096 */   // MIs[0] vector
     /* 7096 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7100 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7104 */   // MIs[0] idx
     /* 7104 */   // No operand predicates
     /* 7104 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7106 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 7106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7109 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 7111 */   GIR_EraseRootFromParent_Done,
     /* 7112 */ // Label 458: @7112
     /* 7112 */ GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(7136), // Rule ID 22 //
     /* 7117 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 7120 */   // MIs[0] root
     /* 7120 */   // No operand predicates
     /* 7120 */   // MIs[0] vector
     /* 7120 */   // No operand predicates
     /* 7120 */   // MIs[0] idx
     /* 7120 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 7124 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7130 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 7130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7133 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 7135 */   GIR_EraseRootFromParent_Done,
     /* 7136 */ // Label 459: @7136
     /* 7136 */ GIM_Reject,
     /* 7137 */ // Label 94: @7137
     /* 7137 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(7148), // Rule ID 97 //
     /* 7142 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 7145 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7145 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 7148 */ // Label 460: @7148
     /* 7148 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(7159), // Rule ID 99 //
     /* 7153 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 7156 */   // Combiner Rule #80: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7156 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 7159 */ // Label 461: @7159
     /* 7159 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(7170), // Rule ID 344 //
     /* 7164 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 7167 */   // Combiner Rule #199: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7167 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 7170 */ // Label 462: @7170
     /* 7170 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(7181), // Rule ID 346 //
     /* 7175 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 7178 */   // Combiner Rule #201: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7178 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 7181 */ // Label 463: @7181
     /* 7181 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(7192), // Rule ID 364 //
     /* 7186 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule217Enabled),
     /* 7189 */   // Combiner Rule #217: shuffle_to_extract; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7189 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 7192 */ // Label 464: @7192
     /* 7192 */ GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(7213), // Rule ID 345 //
     /* 7197 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 7200 */   // MIs[0] root
     /* 7200 */   // No operand predicates
     /* 7200 */   // MIs[0] src1
     /* 7200 */   // No operand predicates
     /* 7200 */   // MIs[0] undef
     /* 7200 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 7204 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7208 */   // MIs[0] mask
     /* 7208 */   // No operand predicates
     /* 7208 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7210 */   // Combiner Rule #200: combine_shuffle_undef_rhs
     /* 7210 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 7213 */ // Label 465: @7213
     /* 7213 */ GIM_Reject,
     /* 7214 */ // Label 95: @7214
     /* 7214 */ GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(7258), // Rule ID 223 //
     /* 7219 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 7222 */   // MIs[0] d
     /* 7222 */   // No operand predicates
     /* 7222 */   // MIs[0] src
     /* 7222 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7226 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7230 */   // MIs[1] rev
     /* 7230 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 7234 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 7238 */   // MIs[2] val
     /* 7238 */   // No operand predicates
     /* 7238 */   // MIs[1] amt
     /* 7238 */   // No operand predicates
     /* 7238 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner9),
     /* 7242 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7244 */   // Combiner Rule #160: bitreverse_lshr
     /* 7244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 7247 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7249 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7253 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7257 */   GIR_EraseRootFromParent_Done,
     /* 7258 */ // Label 466: @7258
     /* 7258 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(7302), // Rule ID 222 //
     /* 7263 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 7266 */   // MIs[0] d
     /* 7266 */   // No operand predicates
     /* 7266 */   // MIs[0] src
     /* 7266 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7270 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 7274 */   // MIs[1] rev
     /* 7274 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 7278 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 7282 */   // MIs[2] val
     /* 7282 */   // No operand predicates
     /* 7282 */   // MIs[1] amt
     /* 7282 */   // No operand predicates
     /* 7282 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 7286 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7288 */   // Combiner Rule #159: bitreverse_shl
     /* 7288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7291 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7293 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7297 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7301 */   GIR_EraseRootFromParent_Done,
     /* 7302 */ // Label 467: @7302
     /* 7302 */ GIM_Reject,
     /* 7303 */ // Label 96: @7303
     /* 7303 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(7324), // Rule ID 178 //
     /* 7308 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 7311 */   // MIs[0] dst
     /* 7311 */   // No operand predicates
     /* 7311 */   // MIs[0] src0
     /* 7311 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 7319 */   // MIs[1] cst
     /* 7319 */   // No operand predicates
     /* 7319 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7321 */   // Combiner Rule #136: constant_fold_fsqrt
     /* 7321 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 7324 */ // Label 468: @7324
     /* 7324 */ GIM_Reject,
     /* 7325 */ // Label 97: @7325
     /* 7325 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(7339), // Rule ID 365 //
     /* 7330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 7333 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule218Enabled),
     /* 7336 */   // Combiner Rule #218: ext_addv_to_udot_addv; wip_match_opcode 'G_VECREDUCE_ADD'
     /* 7336 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner155),
     /* 7339 */ // Label 469: @7339
     /* 7339 */ GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(7350), // Rule ID 366 //
     /* 7344 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 7347 */   // Combiner Rule #219: ext_uaddv_to_uaddlv; wip_match_opcode 'G_VECREDUCE_ADD'
     /* 7347 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 7350 */ // Label 470: @7350
     /* 7350 */ GIM_Reject,
     /* 7351 */ // Label 98: @7351
     /* 7351 */ GIM_Reject,
     /* 7352 */ }; // Size: 7352 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

