/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AMDGPUPreLegalizerCombinerImpl Combiner Match Table                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AMDGPUPreLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 193;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 144;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 143;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 198;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 89;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 192;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 88;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 196;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 197;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 94;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 212;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 187;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 131;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 206;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 145;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 189;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 175;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 132;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 127;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 173;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 174;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 161;	 // "commute_shift"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oldable_fneg", 12) != 0)
        break;
      return 216;	 // "foldable_fneg"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 69;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 124;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 205;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 125;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 172;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 171;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 204;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 207;	 // "unmerge_undef"
        }
        break;
      }
      break;
    }
    break;
  case 14:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 85;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 159;	 // "bitreverse_shl"
      }
      break;
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 170;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 91;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 106;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 54;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 105;	 // "shifts_too_big"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 160;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 68;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 152;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 62;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 142;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 83;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 129;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "lamp_i64_to_i16", 15) != 0)
        break;
      return 215;	 // "clamp_i64_to_i16"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 58;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 61;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 60;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 59;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 63;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 55;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 188;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 121;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 71;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 90;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 110;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 168;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 153;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 81;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 149;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 123;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 150;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 72;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 128;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 86;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 146;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 135;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 134;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 147;	 // "expand_const_fpowi"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ptrunc_fpext_fold", 17) != 0)
        break;
      return 99;	 // "fptrunc_fpext_fold"
    case 's':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
          break;
        return 56;	 // "select_of_truncate"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
          break;
        return 118;	 // "sext_inreg_of_load"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 87;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 141;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 166;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 137;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 136;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtend_through_phis", 18) != 0)
        break;
      return 102;	 // "extend_through_phis"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 64;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 211;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 108;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 107;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 84;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 122;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 103;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 194;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 76;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 177;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 98;	 // "bitcast_bitcast_fold"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 210;	 // "merge_of_x_and_undef"
    case 'r':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "edu", 3) != 0)
        break;
      switch (RuleIdentifier[4]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
          break;
        return 119;	 // "reduce_shl_of_extend"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
          break;
        return 126;	 // "redundant_sext_inreg"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 77;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 209;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 195;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 169;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 138;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 93;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 73;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 208;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 199;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 167;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 186;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 157;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 158;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 155;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 112;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 213;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 78;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 176;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 92;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 116;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 96;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 57;	 // "buildvector_of_truncate"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_right_zero", 22) != 0)
        break;
      return 156;	 // "funnel_shift_right_zero"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 139;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 140;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 79;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 74;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 120;	 // "narrow_binop_feeding_and"
    case 's':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "f_sext_inreg", 12) != 0)
          break;
        return 53;	 // "sext_inreg_of_sext_inreg"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "o_zext_inreg", 12) != 0)
          break;
        return 130;	 // "sext_inreg_to_zext_inreg"
      }
      break;
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 148;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 163;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 164;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 95;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 200;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 66;	 // "extract_vec_elt_build_vec"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eg_and_one_to_sext_inreg", 24) != 0)
        break;
      return 117;	 // "neg_and_one_to_sext_inreg"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 101;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 75;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 191;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 154;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 100;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 202;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 190;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 114;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 115;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 97;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 203;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 113;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 133;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 80;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 151;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 165;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 70;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 201;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 111;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_", 22) != 0)
      break;
    switch (RuleIdentifier[22]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
        break;
      return 22;	 // "insert_vector_element_elt_undef"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
        break;
      return 21;	 // "insert_vector_element_idx_undef"
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 162;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 178;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 182;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fmul_with_select_to_fldexp", 33) != 0)
        break;
      return 214;	 // "combine_fmul_with_select_to_fldexp"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_all_elts_from_build_vector", 33) != 0)
        break;
      return 67;	 // "extract_all_elts_from_build_vector"
    }
    break;
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 180;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 65;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 82;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 183;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 104;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 3 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_", 8) != 0)
      break;
    switch (RuleIdentifier[8]) {
    default: break;
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
          break;
        return 179;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
          break;
        return 184;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+9, "huffle_vector_to_build_vector", 29) != 0)
        break;
      return 217;	 // "combine_shuffle_vector_to_build_vector"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 181;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 185;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 218}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AMDGPUPreLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AMDGPUPreLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AMDGPUPreLegalizerCombinerOption;
static cl::list<std::string> AMDGPUPreLegalizerCombinerDisableOption(
    "amdgpuprelegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AMDGPUPreLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AMDGPUPreLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AMDGPUPreLegalizerCombinerOnlyEnableOption(
    "amdgpuprelegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AMDGPUPreLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AMDGPUPreLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AMDGPUPreLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AMDGPUPreLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AMDGPUPreLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AMDGPUPreLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AMDGPUPreLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AMDGPUPreLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AMDGPUPreLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AMDGPUPreLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset AMDGPUPreLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void AMDGPUPreLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AMDGPUSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AMDGPUPreLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AMDGPUPreLegalizerCombinerImpl::ComplexMatcherMemFn
AMDGPUPreLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
  GICXXPred_MI_Predicate_GICombiner9,
};
bool AMDGPUPreLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return MRI.hasOneNonDBGUse(State.MIs[0]->getOperand(2).getReg()) &&
                    Helper.isLegalOrBeforeLegalizer(
                      {TargetOpcode::G_SEXT_INREG, {MRI.getType(State.MIs[1]->getOperand(1).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner9: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPreLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPreLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPreLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
  GICXXPred_Simple_IsRule214Enabled,
  GICXXPred_Simple_IsRule215Enabled,
  GICXXPred_Simple_IsRule216Enabled,
  GICXXPred_Simple_IsRule217Enabled,
};

bool AMDGPUPreLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AMDGPUPreLegalizerCombinerImpl::CustomRendererFn
AMDGPUPreLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AMDGPUPreLegalizerCombinerImpl::tryCombineAllImpl(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
  GICXXCustomAction_GICombiner151,
  GICXXCustomAction_GICombiner152,
  GICXXCustomAction_GICombiner153,
  GICXXCustomAction_GICombiner154,
};
bool AMDGPUPreLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantSextInReg(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getValueTracking()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchUDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    SmallVector<Register, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner151:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineFmulWithSelectToFldexp(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner152:{
    ClampI64ToI16MatchInfo GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchClampI64ToI16(*State.MIs[0], MRI, MF, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyClampI64ToI16(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner153:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldableFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldableFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner154:{
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleToBuildVector(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleToBuildVector(*State.MIs[0]);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AMDGPUPreLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(264), /*)*//*default:*//*Label 95*/ GIMT_Encode4(7073),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(986), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(998),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1555),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(1873),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(2039),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(2112),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(2196),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(2241), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(2308),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(2589),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(2834), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(2935), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 12*/ GIMT_Encode4(2947), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 13*/ GIMT_Encode4(3014),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 14*/ GIMT_Encode4(3088),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 15*/ GIMT_Encode4(3136),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 16*/ GIMT_Encode4(3148),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 17*/ GIMT_Encode4(3160),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 18*/ GIMT_Encode4(3203),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 19*/ GIMT_Encode4(3236),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 20*/ GIMT_Encode4(3279), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(3343),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(3355),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(3367), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(3379), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  462 */ /*TargetOpcode::G_ANYEXT*//*Label 25*/ GIMT_Encode4(3391),
     /*  466 */ /*TargetOpcode::G_TRUNC*//*Label 26*/ GIMT_Encode4(3519), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  486 */ /*TargetOpcode::G_SEXT*//*Label 27*/ GIMT_Encode4(3888),
     /*  490 */ /*TargetOpcode::G_SEXT_INREG*//*Label 28*/ GIMT_Encode4(3963),
     /*  494 */ /*TargetOpcode::G_ZEXT*//*Label 29*/ GIMT_Encode4(4029),
     /*  498 */ /*TargetOpcode::G_SHL*//*Label 30*/ GIMT_Encode4(4159),
     /*  502 */ /*TargetOpcode::G_LSHR*//*Label 31*/ GIMT_Encode4(4328),
     /*  506 */ /*TargetOpcode::G_ASHR*//*Label 32*/ GIMT_Encode4(4451),
     /*  510 */ /*TargetOpcode::G_FSHL*//*Label 33*/ GIMT_Encode4(4585),
     /*  514 */ /*TargetOpcode::G_FSHR*//*Label 34*/ GIMT_Encode4(4628),
     /*  518 */ /*TargetOpcode::G_ROTR*//*Label 35*/ GIMT_Encode4(4671),
     /*  522 */ /*TargetOpcode::G_ROTL*//*Label 36*/ GIMT_Encode4(4695),
     /*  526 */ /*TargetOpcode::G_ICMP*//*Label 37*/ GIMT_Encode4(4719),
     /*  530 */ /*TargetOpcode::G_FCMP*//*Label 38*/ GIMT_Encode4(4764), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  542 */ /*TargetOpcode::G_SELECT*//*Label 39*/ GIMT_Encode4(4776),
     /*  546 */ /*TargetOpcode::G_UADDO*//*Label 40*/ GIMT_Encode4(4871),
     /*  550 */ /*TargetOpcode::G_UADDE*//*Label 41*/ GIMT_Encode4(4894),
     /*  554 */ /*TargetOpcode::G_USUBO*//*Label 42*/ GIMT_Encode4(4906),
     /*  558 */ /*TargetOpcode::G_USUBE*//*Label 43*/ GIMT_Encode4(4918),
     /*  562 */ /*TargetOpcode::G_SADDO*//*Label 44*/ GIMT_Encode4(4930),
     /*  566 */ /*TargetOpcode::G_SADDE*//*Label 45*/ GIMT_Encode4(4953),
     /*  570 */ /*TargetOpcode::G_SSUBO*//*Label 46*/ GIMT_Encode4(4965),
     /*  574 */ /*TargetOpcode::G_SSUBE*//*Label 47*/ GIMT_Encode4(4977),
     /*  578 */ /*TargetOpcode::G_UMULO*//*Label 48*/ GIMT_Encode4(4989),
     /*  582 */ /*TargetOpcode::G_SMULO*//*Label 49*/ GIMT_Encode4(5023),
     /*  586 */ /*TargetOpcode::G_UMULH*//*Label 50*/ GIMT_Encode4(5057),
     /*  590 */ /*TargetOpcode::G_SMULH*//*Label 51*/ GIMT_Encode4(5080),
     /*  594 */ /*TargetOpcode::G_UADDSAT*//*Label 52*/ GIMT_Encode4(5092),
     /*  598 */ /*TargetOpcode::G_SADDSAT*//*Label 53*/ GIMT_Encode4(5104), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  610 */ /*TargetOpcode::G_USHLSAT*//*Label 54*/ GIMT_Encode4(5116),
     /*  614 */ /*TargetOpcode::G_SSHLSAT*//*Label 55*/ GIMT_Encode4(5139),
     /*  618 */ /*TargetOpcode::G_SMULFIX*//*Label 56*/ GIMT_Encode4(5162),
     /*  622 */ /*TargetOpcode::G_UMULFIX*//*Label 57*/ GIMT_Encode4(5174),
     /*  626 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 58*/ GIMT_Encode4(5186),
     /*  630 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 59*/ GIMT_Encode4(5198), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  650 */ /*TargetOpcode::G_FADD*//*Label 60*/ GIMT_Encode4(5210),
     /*  654 */ /*TargetOpcode::G_FSUB*//*Label 61*/ GIMT_Encode4(5322),
     /*  658 */ /*TargetOpcode::G_FMUL*//*Label 62*/ GIMT_Encode4(5411),
     /*  662 */ /*TargetOpcode::G_FMA*//*Label 63*/ GIMT_Encode4(5520),
     /*  666 */ /*TargetOpcode::G_FMAD*//*Label 64*/ GIMT_Encode4(5543),
     /*  670 */ /*TargetOpcode::G_FDIV*//*Label 65*/ GIMT_Encode4(5566),
     /*  674 */ /*TargetOpcode::G_FREM*//*Label 66*/ GIMT_Encode4(5600), GIMT_Encode4(0),
     /*  682 */ /*TargetOpcode::G_FPOWI*//*Label 67*/ GIMT_Encode4(5612), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  702 */ /*TargetOpcode::G_FLOG2*//*Label 68*/ GIMT_Encode4(5634), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  718 */ /*TargetOpcode::G_FNEG*//*Label 69*/ GIMT_Encode4(5656), GIMT_Encode4(0),
     /*  726 */ /*TargetOpcode::G_FPTRUNC*//*Label 70*/ GIMT_Encode4(5718),
     /*  730 */ /*TargetOpcode::G_FPTOSI*//*Label 71*/ GIMT_Encode4(5761),
     /*  734 */ /*TargetOpcode::G_FPTOUI*//*Label 72*/ GIMT_Encode4(5783),
     /*  738 */ /*TargetOpcode::G_SITOFP*//*Label 73*/ GIMT_Encode4(5805),
     /*  742 */ /*TargetOpcode::G_UITOFP*//*Label 74*/ GIMT_Encode4(5832), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  754 */ /*TargetOpcode::G_FABS*//*Label 75*/ GIMT_Encode4(5859), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  766 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 76*/ GIMT_Encode4(5938),
     /*  770 */ /*TargetOpcode::G_FMINNUM*//*Label 77*/ GIMT_Encode4(5968),
     /*  774 */ /*TargetOpcode::G_FMAXNUM*//*Label 78*/ GIMT_Encode4(6002),
     /*  778 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 79*/ GIMT_Encode4(6036),
     /*  782 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 80*/ GIMT_Encode4(6048),
     /*  786 */ /*TargetOpcode::G_FMINIMUM*//*Label 81*/ GIMT_Encode4(6060),
     /*  790 */ /*TargetOpcode::G_FMAXIMUM*//*Label 82*/ GIMT_Encode4(6094), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  826 */ /*TargetOpcode::G_PTR_ADD*//*Label 83*/ GIMT_Encode4(6128), GIMT_Encode4(0),
     /*  834 */ /*TargetOpcode::G_SMIN*//*Label 84*/ GIMT_Encode4(6218),
     /*  838 */ /*TargetOpcode::G_SMAX*//*Label 85*/ GIMT_Encode4(6252),
     /*  842 */ /*TargetOpcode::G_UMIN*//*Label 86*/ GIMT_Encode4(6286),
     /*  846 */ /*TargetOpcode::G_UMAX*//*Label 87*/ GIMT_Encode4(6320),
     /*  850 */ /*TargetOpcode::G_ABS*//*Label 88*/ GIMT_Encode4(6354), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  862 */ /*TargetOpcode::G_BR*//*Label 89*/ GIMT_Encode4(6366), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  882 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(6378),
     /*  886 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(6508),
     /*  890 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 92*/ GIMT_Encode4(6885), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  930 */ /*TargetOpcode::G_BITREVERSE*//*Label 93*/ GIMT_Encode4(6962), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  982 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(7051),
     /*  986 */ // Label 0: @986
     /*  986 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(997), // Rule ID 13 //
     /*  991 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /*  994 */   // MIs[0] d
     /*  994 */   // No operand predicates
     /*  994 */   // MIs[0] s
     /*  994 */   // No operand predicates
     /*  994 */   // Combiner Rule #13: copy_prop
     /*  994 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  997 */ // Label 96: @997
     /*  997 */ GIM_Reject,
     /*  998 */ // Label 1: @998
     /*  998 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1009), // Rule ID 16 //
     /* 1003 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1006 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /* 1006 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1009 */ // Label 97: @1009
     /* 1009 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1020), // Rule ID 94 //
     /* 1014 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1017 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 1017 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1020 */ // Label 98: @1020
     /* 1020 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1031), // Rule ID 141 //
     /* 1025 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 1028 */   // Combiner Rule #103: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 1028 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 1031 */ // Label 99: @1031
     /* 1031 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1042), // Rule ID 231 //
     /* 1036 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1039 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 1039 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1042 */ // Label 100: @1042
     /* 1042 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1053), // Rule ID 279 //
     /* 1047 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1050 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 1050 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1053 */ // Label 101: @1053
     /* 1053 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1064), // Rule ID 308 //
     /* 1058 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 1061 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 1061 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 1064 */ // Label 102: @1064
     /* 1064 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1098), // Rule ID 0 //
     /* 1069 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 1072 */   // MIs[0] root
     /* 1072 */   // No operand predicates
     /* 1072 */   // MIs[0] sub
     /* 1072 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1076 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1080 */   // MIs[1] Operand 1
     /* 1080 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1084 */   // MIs[1] A
     /* 1084 */   // No operand predicates
     /* 1084 */   // MIs[0] B
     /* 1084 */   // No operand predicates
     /* 1084 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1086 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 1086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1089 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1091 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 1093 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 1097 */   GIR_EraseRootFromParent_Done,
     /* 1098 */ // Label 103: @1098
     /* 1098 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1135), // Rule ID 12 //
     /* 1103 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1106 */   // MIs[0] root
     /* 1106 */   // No operand predicates
     /* 1106 */   // MIs[0] sub
     /* 1106 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1110 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1114 */   // MIs[1] A
     /* 1114 */   // No operand predicates
     /* 1114 */   // MIs[1] c1
     /* 1114 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1118 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1122 */   // MIs[2] imm1
     /* 1122 */   // No operand predicates
     /* 1122 */   // MIs[0] c2
     /* 1122 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1126 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1130 */   // MIs[3] imm2
     /* 1130 */   // No operand predicates
     /* 1130 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1132 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 1132 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1135 */ // Label 104: @1135
     /* 1135 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1169), // Rule ID 3 //
     /* 1140 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1143 */   // MIs[0] root
     /* 1143 */   // No operand predicates
     /* 1143 */   // MIs[0] sub
     /* 1143 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1151 */   // MIs[1] B
     /* 1151 */   // No operand predicates
     /* 1151 */   // MIs[1] A
     /* 1151 */   // No operand predicates
     /* 1151 */   // MIs[0] A
     /* 1151 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1156 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1161 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1163 */   // Combiner Rule #3: BMinusAPlusA
     /* 1163 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1168 */   GIR_EraseRootFromParent_Done,
     /* 1169 */ // Label 105: @1169
     /* 1169 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1203), // Rule ID 131 //
     /* 1174 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1177 */   // MIs[0] dst
     /* 1177 */   // No operand predicates
     /* 1177 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1177 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1181 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1185 */   // MIs[1] src
     /* 1185 */   // No operand predicates
     /* 1185 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1185 */   // No operand predicates
     /* 1185 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1185 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1190 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1195 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1197 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 1197 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1202 */   GIR_EraseRootFromParent_Done,
     /* 1203 */ // Label 106: @1203
     /* 1203 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1248), // Rule ID 5 //
     /* 1208 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1211 */   // MIs[0] root
     /* 1211 */   // No operand predicates
     /* 1211 */   // MIs[0] sub1
     /* 1211 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1215 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1219 */   // MIs[1] A
     /* 1219 */   // No operand predicates
     /* 1219 */   // MIs[1] B
     /* 1219 */   // No operand predicates
     /* 1219 */   // MIs[0] sub2
     /* 1219 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1223 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1227 */   // MIs[2] B
     /* 1227 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1232 */   // MIs[2] C
     /* 1232 */   // No operand predicates
     /* 1232 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1234 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 1234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1237 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1239 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 1243 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1247 */   GIR_EraseRootFromParent_Done,
     /* 1248 */ // Label 107: @1248
     /* 1248 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1293), // Rule ID 4 //
     /* 1253 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1256 */   // MIs[0] root
     /* 1256 */   // No operand predicates
     /* 1256 */   // MIs[0] sub1
     /* 1256 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1260 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1264 */   // MIs[1] A
     /* 1264 */   // No operand predicates
     /* 1264 */   // MIs[1] B
     /* 1264 */   // No operand predicates
     /* 1264 */   // MIs[0] sub2
     /* 1264 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1268 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1272 */   // MIs[2] C
     /* 1272 */   // No operand predicates
     /* 1272 */   // MIs[2] A
     /* 1272 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 1277 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1279 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 1279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1282 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1284 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1288 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1292 */   GIR_EraseRootFromParent_Done,
     /* 1293 */ // Label 108: @1293
     /* 1293 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1328), // Rule ID 39 //
     /* 1298 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 1301 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1307 */   // MIs[0] root
     /* 1307 */   // No operand predicates
     /* 1307 */   // MIs[0] left
     /* 1307 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1311 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1315 */   // MIs[1] imm1
     /* 1315 */   // No operand predicates
     /* 1315 */   // MIs[0] right
     /* 1315 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1319 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1323 */   // MIs[2] imm2
     /* 1323 */   // No operand predicates
     /* 1323 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1325 */   // Combiner Rule #37: add_of_vscale
     /* 1325 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1328 */ // Label 109: @1328
     /* 1328 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1362), // Rule ID 1 //
     /* 1333 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1336 */   // MIs[0] root
     /* 1336 */   // No operand predicates
     /* 1336 */   // MIs[0] A
     /* 1336 */   // No operand predicates
     /* 1336 */   // MIs[0] sub
     /* 1336 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1340 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1344 */   // MIs[1] Operand 1
     /* 1344 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1348 */   // MIs[1] B
     /* 1348 */   // No operand predicates
     /* 1348 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1350 */   // Combiner Rule #1: APlusZeroMinusB
     /* 1350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1353 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1355 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 1357 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1361 */   GIR_EraseRootFromParent_Done,
     /* 1362 */ // Label 110: @1362
     /* 1362 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1396), // Rule ID 2 //
     /* 1367 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 1370 */   // MIs[0] root
     /* 1370 */   // No operand predicates
     /* 1370 */   // MIs[0] A
     /* 1370 */   // No operand predicates
     /* 1370 */   // MIs[0] sub
     /* 1370 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1378 */   // MIs[1] B
     /* 1378 */   // No operand predicates
     /* 1378 */   // MIs[1] A
     /* 1378 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1383 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1388 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1390 */   // Combiner Rule #2: APlusBMinusB
     /* 1390 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1395 */   GIR_EraseRootFromParent_Done,
     /* 1396 */ // Label 111: @1396
     /* 1396 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1430), // Rule ID 130 //
     /* 1401 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1404 */   // MIs[0] dst
     /* 1404 */   // No operand predicates
     /* 1404 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1404 */   // No operand predicates
     /* 1404 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1404 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1408 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1412 */   // MIs[1] src
     /* 1412 */   // No operand predicates
     /* 1412 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1412 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1417 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1422 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1424 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1429 */   GIR_EraseRootFromParent_Done,
     /* 1430 */ // Label 112: @1430
     /* 1430 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1475), // Rule ID 6 //
     /* 1435 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1438 */   // MIs[0] root
     /* 1438 */   // No operand predicates
     /* 1438 */   // MIs[0] A
     /* 1438 */   // No operand predicates
     /* 1438 */   // MIs[0] sub1
     /* 1438 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1442 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1446 */   // MIs[1] B
     /* 1446 */   // No operand predicates
     /* 1446 */   // MIs[1] add1
     /* 1446 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1450 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1454 */   // MIs[2] A
     /* 1454 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1459 */   // MIs[2] C
     /* 1459 */   // No operand predicates
     /* 1459 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1461 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 1461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1464 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1466 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1470 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1474 */   GIR_EraseRootFromParent_Done,
     /* 1475 */ // Label 113: @1475
     /* 1475 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1520), // Rule ID 7 //
     /* 1480 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1483 */   // MIs[0] root
     /* 1483 */   // No operand predicates
     /* 1483 */   // MIs[0] A
     /* 1483 */   // No operand predicates
     /* 1483 */   // MIs[0] sub1
     /* 1483 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1487 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1491 */   // MIs[1] B
     /* 1491 */   // No operand predicates
     /* 1491 */   // MIs[1] add1
     /* 1491 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1495 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1499 */   // MIs[2] C
     /* 1499 */   // No operand predicates
     /* 1499 */   // MIs[2] A
     /* 1499 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1504 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1506 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 1506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1509 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1511 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1515 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1519 */   GIR_EraseRootFromParent_Done,
     /* 1520 */ // Label 114: @1520
     /* 1520 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1543), // Rule ID 105 //
     /* 1525 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 1528 */   // MIs[0] dst
     /* 1528 */   // No operand predicates
     /* 1528 */   // MIs[0] lhs
     /* 1528 */   // No operand predicates
     /* 1528 */   // MIs[0] Operand 2
     /* 1528 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1532 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1537 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1537 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1542 */   GIR_EraseRootFromParent_Done,
     /* 1543 */ // Label 115: @1543
     /* 1543 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1554), // Rule ID 149 //
     /* 1548 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 1551 */   // MIs[0] root
     /* 1551 */   // No operand predicates
     /* 1551 */   // MIs[0] src1
     /* 1551 */   // No operand predicates
     /* 1551 */   // MIs[0] src2
     /* 1551 */   // No operand predicates
     /* 1551 */   // Combiner Rule #107: reassoc_comm_binops
     /* 1551 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1554 */ // Label 116: @1554
     /* 1554 */ GIM_Reject,
     /* 1555 */ // Label 2: @1555
     /* 1555 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1566), // Rule ID 95 //
     /* 1560 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1563 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1563 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1566 */ // Label 117: @1566
     /* 1566 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1577), // Rule ID 239 //
     /* 1571 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1574 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1574 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1577 */ // Label 118: @1577
     /* 1577 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1588), // Rule ID 280 //
     /* 1582 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1585 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 1585 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1588 */ // Label 119: @1588
     /* 1588 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1599), // Rule ID 305 //
     /* 1593 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 1596 */   // Combiner Rule #187: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 1596 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 1599 */ // Label 120: @1599
     /* 1599 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1610), // Rule ID 339 //
     /* 1604 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 1607 */   // Combiner Rule #194: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 1607 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 1610 */ // Label 121: @1610
     /* 1610 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1647), // Rule ID 8 //
     /* 1615 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 1618 */   // MIs[0] root
     /* 1618 */   // No operand predicates
     /* 1618 */   // MIs[0] add
     /* 1618 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1622 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1626 */   // MIs[1] A
     /* 1626 */   // No operand predicates
     /* 1626 */   // MIs[1] c1
     /* 1626 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1630 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1634 */   // MIs[2] imm1
     /* 1634 */   // No operand predicates
     /* 1634 */   // MIs[0] c2
     /* 1634 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1638 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1642 */   // MIs[3] imm2
     /* 1642 */   // No operand predicates
     /* 1642 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1644 */   // Combiner Rule #8: APlusC1MinusC2
     /* 1644 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 1647 */ // Label 122: @1647
     /* 1647 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1684), // Rule ID 11 //
     /* 1652 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1655 */   // MIs[0] root
     /* 1655 */   // No operand predicates
     /* 1655 */   // MIs[0] sub1
     /* 1655 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1659 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1663 */   // MIs[1] c1
     /* 1663 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 1667 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1671 */   // MIs[2] imm1
     /* 1671 */   // No operand predicates
     /* 1671 */   // MIs[1] A
     /* 1671 */   // No operand predicates
     /* 1671 */   // MIs[0] c2
     /* 1671 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1675 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1679 */   // MIs[3] imm2
     /* 1679 */   // No operand predicates
     /* 1679 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1681 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 1681 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1684 */ // Label 123: @1684
     /* 1684 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1721), // Rule ID 10 //
     /* 1689 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1692 */   // MIs[0] root
     /* 1692 */   // No operand predicates
     /* 1692 */   // MIs[0] sub1
     /* 1692 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1700 */   // MIs[1] A
     /* 1700 */   // No operand predicates
     /* 1700 */   // MIs[1] c1
     /* 1700 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1704 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1708 */   // MIs[2] imm1
     /* 1708 */   // No operand predicates
     /* 1708 */   // MIs[0] c2
     /* 1708 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1712 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1716 */   // MIs[3] imm2
     /* 1716 */   // No operand predicates
     /* 1716 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1718 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 1718 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 1721 */ // Label 124: @1721
     /* 1721 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1764), // Rule ID 159 //
     /* 1726 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 1729 */   // MIs[0] dst
     /* 1729 */   // No operand predicates
     /* 1729 */   // MIs[0] Operand 1
     /* 1729 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 1733 */   // MIs[0] and
     /* 1733 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1737 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 1741 */   // MIs[1] x
     /* 1741 */   // No operand predicates
     /* 1741 */   // MIs[1] Operand 2
     /* 1741 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 1745 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 1749 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1751 */   // Combiner Rule #117: neg_and_one_to_sext_inreg
     /* 1751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 1754 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1756 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 1760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1763 */   GIR_EraseRootFromParent_Done,
     /* 1764 */ // Label 125: @1764
     /* 1764 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1801), // Rule ID 9 //
     /* 1769 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 1772 */   // MIs[0] root
     /* 1772 */   // No operand predicates
     /* 1772 */   // MIs[0] c2
     /* 1772 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1776 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1780 */   // MIs[1] imm2
     /* 1780 */   // No operand predicates
     /* 1780 */   // MIs[0] add
     /* 1780 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1784 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1788 */   // MIs[2] A
     /* 1788 */   // No operand predicates
     /* 1788 */   // MIs[2] c1
     /* 1788 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 1792 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1796 */   // MIs[3] imm1
     /* 1796 */   // No operand predicates
     /* 1796 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1798 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 1798 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1801 */ // Label 126: @1801
     /* 1801 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1828), // Rule ID 42 //
     /* 1806 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 1809 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1815 */   // MIs[0] root
     /* 1815 */   // No operand predicates
     /* 1815 */   // MIs[0] x
     /* 1815 */   // No operand predicates
     /* 1815 */   // MIs[0] right
     /* 1815 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1823 */   // MIs[1] imm
     /* 1823 */   // No operand predicates
     /* 1823 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1825 */   // Combiner Rule #40: sub_of_vscale
     /* 1825 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 1828 */ // Label 127: @1828
     /* 1828 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1851), // Rule ID 104 //
     /* 1833 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 1836 */   // MIs[0] dst
     /* 1836 */   // No operand predicates
     /* 1836 */   // MIs[0] lhs
     /* 1836 */   // No operand predicates
     /* 1836 */   // MIs[0] Operand 2
     /* 1836 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1840 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1845 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 1845 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1850 */   GIR_EraseRootFromParent_Done,
     /* 1851 */ // Label 128: @1851
     /* 1851 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1872), // Rule ID 15 //
     /* 1856 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 1859 */   // MIs[0] d
     /* 1859 */   // No operand predicates
     /* 1859 */   // MIs[0] op1
     /* 1859 */   // No operand predicates
     /* 1859 */   // MIs[0] c
     /* 1859 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1863 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1867 */   // MIs[1] imm
     /* 1867 */   // No operand predicates
     /* 1867 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1869 */   // Combiner Rule #15: sub_to_add
     /* 1869 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 1872 */ // Label 129: @1872
     /* 1872 */ GIM_Reject,
     /* 1873 */ // Label 3: @1873
     /* 1873 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1884), // Rule ID 78 //
     /* 1878 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 1881 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 1881 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 1884 */ // Label 130: @1884
     /* 1884 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1895), // Rule ID 236 //
     /* 1889 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1892 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 1892 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1895 */ // Label 131: @1895
     /* 1895 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1906), // Rule ID 309 //
     /* 1900 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 1903 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 1903 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 1906 */ // Label 132: @1906
     /* 1906 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1946), // Rule ID 17 //
     /* 1911 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 1914 */   // MIs[0] dst
     /* 1914 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 1918 */   // MIs[0] x
     /* 1918 */   // No operand predicates
     /* 1918 */   // MIs[0] Operand 2
     /* 1918 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 1922 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 1925 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 1935 */   // Combiner Rule #17: mul_by_neg_one
     /* 1935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1938 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1940 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1943 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 1945 */   GIR_EraseRootFromParent_Done,
     /* 1946 */ // Label 133: @1946
     /* 1946 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1981), // Rule ID 40 //
     /* 1951 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 1954 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1960 */   // MIs[0] root
     /* 1960 */   // No operand predicates
     /* 1960 */   // MIs[0] left
     /* 1960 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1964 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1968 */   // MIs[1] scale
     /* 1968 */   // No operand predicates
     /* 1968 */   // MIs[0] x
     /* 1968 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1972 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1976 */   // MIs[2] imm1
     /* 1976 */   // No operand predicates
     /* 1976 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1978 */   // Combiner Rule #38: mul_of_vscale
     /* 1978 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 1981 */ // Label 134: @1981
     /* 1981 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2004), // Rule ID 123 //
     /* 1986 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1989 */   // MIs[0] dst
     /* 1989 */   // No operand predicates
     /* 1989 */   // MIs[0] lhs
     /* 1989 */   // No operand predicates
     /* 1989 */   // MIs[0] zero
     /* 1989 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1993 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1998 */   // Combiner Rule #87: binop_right_to_zero
     /* 1998 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2003 */   GIR_EraseRootFromParent_Done,
     /* 2004 */ // Label 135: @2004
     /* 2004 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2027), // Rule ID 128 //
     /* 2009 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 2012 */   // MIs[0] dst
     /* 2012 */   // No operand predicates
     /* 2012 */   // MIs[0] x
     /* 2012 */   // No operand predicates
     /* 2012 */   // MIs[0] Operand 2
     /* 2012 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 2016 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2021 */   // Combiner Rule #92: right_identity_one_int
     /* 2021 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2026 */   GIR_EraseRootFromParent_Done,
     /* 2027 */ // Label 136: @2027
     /* 2027 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2038), // Rule ID 14 //
     /* 2032 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2035 */   // MIs[0] d
     /* 2035 */   // No operand predicates
     /* 2035 */   // MIs[0] op1
     /* 2035 */   // No operand predicates
     /* 2035 */   // MIs[0] op2
     /* 2035 */   // No operand predicates
     /* 2035 */   // Combiner Rule #14: mul_to_shl
     /* 2035 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2038 */ // Label 137: @2038
     /* 2038 */ GIM_Reject,
     /* 2039 */ // Label 4: @2039
     /* 2039 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2050), // Rule ID 119 //
     /* 2044 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2047 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 2047 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2050 */ // Label 138: @2050
     /* 2050 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2061), // Rule ID 211 //
     /* 2055 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2058 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 2058 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2061 */ // Label 139: @2061
     /* 2061 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2072), // Rule ID 242 //
     /* 2066 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2069 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 2069 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2072 */ // Label 140: @2072
     /* 2072 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2083), // Rule ID 260 //
     /* 2077 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 2080 */   // Combiner Rule #172: sdiv_by_const; wip_match_opcode 'G_SDIV'
     /* 2080 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 2083 */ // Label 141: @2083
     /* 2083 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2094), // Rule ID 285 //
     /* 2088 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2091 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 2091 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2094 */ // Label 142: @2094
     /* 2094 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2111), // Rule ID 261 //
     /* 2099 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 2102 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2108 */   // MIs[0] dst
     /* 2108 */   // No operand predicates
     /* 2108 */   // MIs[0] x
     /* 2108 */   // No operand predicates
     /* 2108 */   // MIs[0] y
     /* 2108 */   // No operand predicates
     /* 2108 */   // Combiner Rule #173: sdiv_by_pow2
     /* 2108 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 2111 */ // Label 143: @2111
     /* 2111 */ GIM_Reject,
     /* 2112 */ // Label 5: @2112
     /* 2112 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2123), // Rule ID 81 //
     /* 2117 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2120 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 2120 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2123 */ // Label 144: @2123
     /* 2123 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2134), // Rule ID 120 //
     /* 2128 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2131 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 2131 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2134 */ // Label 145: @2134
     /* 2134 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2145), // Rule ID 212 //
     /* 2139 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2142 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 2142 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2145 */ // Label 146: @2145
     /* 2145 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2156), // Rule ID 241 //
     /* 2150 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2153 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 2153 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2156 */ // Label 147: @2156
     /* 2156 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2167), // Rule ID 259 //
     /* 2161 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 2164 */   // Combiner Rule #171: udiv_by_const; wip_match_opcode 'G_UDIV'
     /* 2164 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 2167 */ // Label 148: @2167
     /* 2167 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2178), // Rule ID 287 //
     /* 2172 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2175 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 2175 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2178 */ // Label 149: @2178
     /* 2178 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2195), // Rule ID 262 //
     /* 2183 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 2186 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2192 */   // MIs[0] dst
     /* 2192 */   // No operand predicates
     /* 2192 */   // MIs[0] x
     /* 2192 */   // No operand predicates
     /* 2192 */   // MIs[0] y
     /* 2192 */   // No operand predicates
     /* 2192 */   // Combiner Rule #174: udiv_by_pow2
     /* 2192 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 2195 */ // Label 150: @2195
     /* 2195 */ GIM_Reject,
     /* 2196 */ // Label 6: @2196
     /* 2196 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2207), // Rule ID 121 //
     /* 2201 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2204 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 2204 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2207 */ // Label 151: @2207
     /* 2207 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2218), // Rule ID 213 //
     /* 2212 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2215 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 2215 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2218 */ // Label 152: @2218
     /* 2218 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2229), // Rule ID 244 //
     /* 2223 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2226 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 2226 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2229 */ // Label 153: @2229
     /* 2229 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2240), // Rule ID 286 //
     /* 2234 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2237 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 2237 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2240 */ // Label 154: @2240
     /* 2240 */ GIM_Reject,
     /* 2241 */ // Label 7: @2241
     /* 2241 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2252), // Rule ID 82 //
     /* 2246 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2249 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 2249 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2252 */ // Label 155: @2252
     /* 2252 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2263), // Rule ID 122 //
     /* 2257 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2260 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 2260 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2263 */ // Label 156: @2263
     /* 2263 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2274), // Rule ID 170 //
     /* 2268 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 2271 */   // Combiner Rule #128: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 2271 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 2274 */ // Label 157: @2274
     /* 2274 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2285), // Rule ID 214 //
     /* 2279 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2282 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 2282 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2285 */ // Label 158: @2285
     /* 2285 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2296), // Rule ID 243 //
     /* 2290 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2293 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 2293 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2296 */ // Label 159: @2296
     /* 2296 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2307), // Rule ID 288 //
     /* 2301 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2304 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 2304 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2307 */ // Label 160: @2307
     /* 2307 */ GIM_Reject,
     /* 2308 */ // Label 8: @2308
     /* 2308 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2319), // Rule ID 73 //
     /* 2313 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 2316 */   // Combiner Rule #69: load_and_mask; wip_match_opcode 'G_AND'
     /* 2316 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 2319 */ // Label 161: @2319
     /* 2319 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2330), // Rule ID 77 //
     /* 2324 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2327 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 2327 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2330 */ // Label 162: @2330
     /* 2330 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2341), // Rule ID 142 //
     /* 2335 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2338 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 2338 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2341 */ // Label 163: @2341
     /* 2341 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2352), // Rule ID 162 //
     /* 2346 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 2349 */   // Combiner Rule #120: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 2349 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 2352 */ // Label 164: @2352
     /* 2352 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2363), // Rule ID 167 //
     /* 2357 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 2360 */   // Combiner Rule #125: redundant_and; wip_match_opcode 'G_AND'
     /* 2360 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 2363 */ // Label 165: @2363
     /* 2363 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2374), // Rule ID 184 //
     /* 2368 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 2371 */   // Combiner Rule #142: overlapping_and; wip_match_opcode 'G_AND'
     /* 2371 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 2374 */ // Label 166: @2374
     /* 2374 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2385), // Rule ID 233 //
     /* 2379 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2382 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 2382 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2385 */ // Label 167: @2385
     /* 2385 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2396), // Rule ID 270 //
     /* 2390 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 2393 */   // Combiner Rule #177: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 2393 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 2396 */ // Label 168: @2396
     /* 2396 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2407), // Rule ID 282 //
     /* 2401 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2404 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 2404 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2407 */ // Label 169: @2407
     /* 2407 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2418), // Rule ID 310 //
     /* 2412 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2415 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 2415 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2418 */ // Label 170: @2418
     /* 2418 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2429), // Rule ID 337 //
     /* 2423 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 2426 */   // Combiner Rule #192: match_ands; wip_match_opcode 'G_AND'
     /* 2426 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 2429 */ // Label 171: @2429
     /* 2429 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2527), // Rule ID 155 //
     /* 2434 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 2437 */   // MIs[0] root
     /* 2437 */   // No operand predicates
     /* 2437 */   // MIs[0] d1
     /* 2437 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2441 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2445 */   // MIs[1] p
     /* 2445 */   // No operand predicates
     /* 2445 */   // MIs[1] s1
     /* 2445 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2449 */   // MIs[1] Operand 3
     /* 2449 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2453 */   // MIs[0] d2
     /* 2453 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2457 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2461 */   // MIs[2] p
     /* 2461 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2466 */   // MIs[2] s2
     /* 2466 */   // No operand predicates
     /* 2466 */   // MIs[2] Operand 3
     /* 2466 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2470 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 2474 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2476 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2479 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2492 */   // Combiner Rule #113: double_icmp_zero_and_combine
     /* 2492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2495 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2500 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2504 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2512 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2516 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2520 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2523 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2526 */   GIR_EraseRootFromParent_Done,
     /* 2527 */ // Label 172: @2527
     /* 2527 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2564), // Rule ID 226 //
     /* 2532 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 2535 */   // MIs[0] root
     /* 2535 */   // No operand predicates
     /* 2535 */   // MIs[0] shift
     /* 2535 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2539 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 2543 */   // MIs[1] x
     /* 2543 */   // No operand predicates
     /* 2543 */   // MIs[1] lsb
     /* 2543 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2547 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2551 */   // MIs[2] imm1
     /* 2551 */   // No operand predicates
     /* 2551 */   // MIs[0] mask
     /* 2551 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2555 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2559 */   // MIs[3] imm2
     /* 2559 */   // No operand predicates
     /* 2559 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2561 */   // Combiner Rule #163: bitfield_extract_from_and
     /* 2561 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 2564 */ // Label 173: @2564
     /* 2564 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2588), // Rule ID 114 //
     /* 2569 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2572 */   // MIs[0] dst
     /* 2572 */   // No operand predicates
     /* 2572 */   // MIs[0] src
     /* 2572 */   // No operand predicates
     /* 2572 */   // MIs[0] src
     /* 2572 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2577 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2582 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 2582 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2587 */   GIR_EraseRootFromParent_Done,
     /* 2588 */ // Label 174: @2588
     /* 2588 */ GIM_Reject,
     /* 2589 */ // Label 9: @2589
     /* 2589 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2600), // Rule ID 79 //
     /* 2594 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2597 */   // Combiner Rule #73: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 2597 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2600 */ // Label 175: @2600
     /* 2600 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2611), // Rule ID 143 //
     /* 2605 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2608 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 2608 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2611 */ // Label 176: @2611
     /* 2611 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2622), // Rule ID 169 //
     /* 2616 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 2619 */   // Combiner Rule #127: redundant_or; wip_match_opcode 'G_OR'
     /* 2619 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 2622 */ // Label 177: @2622
     /* 2622 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2633), // Rule ID 210 //
     /* 2627 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2630 */   // Combiner Rule #152: load_or_combine; wip_match_opcode 'G_OR'
     /* 2630 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2633 */ // Label 178: @2633
     /* 2633 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2644), // Rule ID 215 //
     /* 2638 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 2641 */   // Combiner Rule #154: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 2641 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 2644 */ // Label 179: @2644
     /* 2644 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2655), // Rule ID 237 //
     /* 2649 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2652 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 2652 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2655 */ // Label 180: @2655
     /* 2655 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2666), // Rule ID 283 //
     /* 2660 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2663 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 2663 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2666 */ // Label 181: @2666
     /* 2666 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2677), // Rule ID 311 //
     /* 2671 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2674 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 2674 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2677 */ // Label 182: @2677
     /* 2677 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2688), // Rule ID 338 //
     /* 2682 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 2685 */   // Combiner Rule #193: match_ors; wip_match_opcode 'G_OR'
     /* 2685 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 2688 */ // Label 183: @2688
     /* 2688 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2786), // Rule ID 156 //
     /* 2693 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 2696 */   // MIs[0] root
     /* 2696 */   // No operand predicates
     /* 2696 */   // MIs[0] d1
     /* 2696 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2704 */   // MIs[1] p
     /* 2704 */   // No operand predicates
     /* 2704 */   // MIs[1] s1
     /* 2704 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2708 */   // MIs[1] Operand 3
     /* 2708 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2712 */   // MIs[0] d2
     /* 2712 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2716 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2720 */   // MIs[2] p
     /* 2720 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2725 */   // MIs[2] s2
     /* 2725 */   // No operand predicates
     /* 2725 */   // MIs[2] Operand 3
     /* 2725 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2729 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 2733 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2735 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2738 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2748 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2751 */   // Combiner Rule #114: double_icmp_zero_or_combine
     /* 2751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2754 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2759 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2763 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2767 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2771 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2775 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2779 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2782 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2785 */   GIR_EraseRootFromParent_Done,
     /* 2786 */ // Label 184: @2786
     /* 2786 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2810), // Rule ID 115 //
     /* 2791 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2794 */   // MIs[0] dst
     /* 2794 */   // No operand predicates
     /* 2794 */   // MIs[0] src
     /* 2794 */   // No operand predicates
     /* 2794 */   // MIs[0] src
     /* 2794 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2799 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2804 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 2804 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2809 */   GIR_EraseRootFromParent_Done,
     /* 2810 */ // Label 185: @2810
     /* 2810 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2833), // Rule ID 106 //
     /* 2815 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2818 */   // MIs[0] dst
     /* 2818 */   // No operand predicates
     /* 2818 */   // MIs[0] lhs
     /* 2818 */   // No operand predicates
     /* 2818 */   // MIs[0] Operand 2
     /* 2818 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2822 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2827 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 2827 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2832 */   GIR_EraseRootFromParent_Done,
     /* 2833 */ // Label 186: @2833
     /* 2833 */ GIM_Reject,
     /* 2834 */ // Label 10: @2834
     /* 2834 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2845), // Rule ID 96 //
     /* 2839 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 2842 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 2842 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 2845 */ // Label 187: @2845
     /* 2845 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2856), // Rule ID 144 //
     /* 2850 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2853 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 2853 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2856 */ // Label 188: @2856
     /* 2856 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2867), // Rule ID 174 //
     /* 2861 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 2864 */   // Combiner Rule #132: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 2864 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 2867 */ // Label 189: @2867
     /* 2867 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2878), // Rule ID 198 //
     /* 2872 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 2875 */   // Combiner Rule #148: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 2875 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 2878 */ // Label 190: @2878
     /* 2878 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2889), // Rule ID 240 //
     /* 2883 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2886 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 2886 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2889 */ // Label 191: @2889
     /* 2889 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2900), // Rule ID 284 //
     /* 2894 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2897 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 2897 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2900 */ // Label 192: @2900
     /* 2900 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2911), // Rule ID 312 //
     /* 2905 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2908 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 2908 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2911 */ // Label 193: @2911
     /* 2911 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2934), // Rule ID 107 //
     /* 2916 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2919 */   // MIs[0] dst
     /* 2919 */   // No operand predicates
     /* 2919 */   // MIs[0] lhs
     /* 2919 */   // No operand predicates
     /* 2919 */   // MIs[0] Operand 2
     /* 2919 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2923 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2928 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 2928 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2933 */   GIR_EraseRootFromParent_Done,
     /* 2934 */ // Label 194: @2934
     /* 2934 */ GIM_Reject,
     /* 2935 */ // Label 11: @2935
     /* 2935 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2946), // Rule ID 140 //
     /* 2940 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 2943 */   // Combiner Rule #102: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 2943 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 2946 */ // Label 195: @2946
     /* 2946 */ GIM_Reject,
     /* 2947 */ // Label 12: @2947
     /* 2947 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(2958), // Rule ID 348 //
     /* 2952 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 2955 */   // Combiner Rule #203: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2955 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 2958 */ // Label 196: @2958
     /* 2958 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(2969), // Rule ID 349 //
     /* 2963 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 2966 */   // Combiner Rule #204: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2966 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 2969 */ // Label 197: @2969
     /* 2969 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(2980), // Rule ID 351 //
     /* 2974 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 2977 */   // Combiner Rule #206: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2977 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 2980 */ // Label 198: @2980
     /* 2980 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(2991), // Rule ID 352 //
     /* 2985 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 2988 */   // Combiner Rule #207: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2988 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 2991 */ // Label 199: @2991
     /* 2991 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3002), // Rule ID 353 //
     /* 2996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 2999 */   // Combiner Rule #208: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2999 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 3002 */ // Label 200: @3002
     /* 3002 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(3013), // Rule ID 354 //
     /* 3007 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 3010 */   // Combiner Rule #209: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3010 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 3013 */ // Label 201: @3013
     /* 3013 */ GIM_Reject,
     /* 3014 */ // Label 13: @3014
     /* 3014 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3025), // Rule ID 350 //
     /* 3019 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 3022 */   // Combiner Rule #205: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 3022 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 3025 */ // Label 202: @3025
     /* 3025 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3087),
     /* 3030 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 3033 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3054), // Rule ID 355 //
     /* 3038 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 3041 */     // MIs[0] root
     /* 3041 */     // No operand predicates
     /* 3041 */     // MIs[0] x
     /* 3041 */     // No operand predicates
     /* 3041 */     // MIs[0] undef
     /* 3041 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3051 */     // Combiner Rule #210: merge_of_x_and_undef
     /* 3051 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 3054 */   // Label 204: @3054
     /* 3054 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(3086), // Rule ID 356 //
     /* 3059 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 3062 */     // MIs[0] root
     /* 3062 */     // No operand predicates
     /* 3062 */     // MIs[0] x
     /* 3062 */     // No operand predicates
     /* 3062 */     // MIs[0] zero
     /* 3062 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3070 */     // MIs[1] Operand 1
     /* 3070 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 3081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3083 */     // Combiner Rule #211: merge_of_x_and_zero
     /* 3083 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 3086 */   // Label 205: @3086
     /* 3086 */   GIM_Reject,
     /* 3087 */ // Label 203: @3087
     /* 3087 */ GIM_Reject,
     /* 3088 */ // Label 14: @3088
     /* 3088 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(3099), // Rule ID 69 //
     /* 3093 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3096 */   // Combiner Rule #67: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3096 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3099 */ // Label 206: @3099
     /* 3099 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(3110), // Rule ID 98 //
     /* 3104 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 3107 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3107 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3110 */ // Label 207: @3110
     /* 3110 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(3121), // Rule ID 133 //
     /* 3115 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3118 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3118 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3121 */ // Label 208: @3121
     /* 3121 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3135), // Rule ID 347 //
     /* 3126 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 3129 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 3132 */   // MIs[0] dst
     /* 3132 */   // No operand predicates
     /* 3132 */   // MIs[0] unused
     /* 3132 */   // No operand predicates
     /* 3132 */   // Combiner Rule #202: combine_use_vector_truncate
     /* 3132 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 3135 */ // Label 209: @3135
     /* 3135 */ GIM_Reject,
     /* 3136 */ // Label 15: @3136
     /* 3136 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3147), // Rule ID 132 //
     /* 3141 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3144 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 3144 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3147 */ // Label 210: @3147
     /* 3147 */ GIM_Reject,
     /* 3148 */ // Label 16: @3148
     /* 3148 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3159), // Rule ID 340 //
     /* 3153 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 3156 */   // Combiner Rule #195: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 3156 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 3159 */ // Label 211: @3159
     /* 3159 */ GIM_Reject,
     /* 3160 */ // Label 17: @3160
     /* 3160 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3181), // Rule ID 125 //
     /* 3165 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3168 */   // MIs[0] dst
     /* 3168 */   // No operand predicates
     /* 3168 */   // MIs[0] t
     /* 3168 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3172 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 3176 */   // MIs[1] ptr
     /* 3176 */   // No operand predicates
     /* 3176 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3178 */   // Combiner Rule #89: i2p_to_p2i
     /* 3178 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 3181 */ // Label 212: @3181
     /* 3181 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(3202), // Rule ID 90 //
     /* 3186 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3189 */   // MIs[0] dst
     /* 3189 */   // No operand predicates
     /* 3189 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3189 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3193 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3197 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3199 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 3199 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3202 */ // Label 213: @3202
     /* 3202 */ GIM_Reject,
     /* 3203 */ // Label 18: @3203
     /* 3203 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3214), // Rule ID 124 //
     /* 3208 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3211 */   // Combiner Rule #88: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 3211 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 3214 */ // Label 214: @3214
     /* 3214 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3235), // Rule ID 91 //
     /* 3219 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3222 */   // MIs[0] dst
     /* 3222 */   // No operand predicates
     /* 3222 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3222 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3226 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3230 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3232 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 3232 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3235 */ // Label 215: @3235
     /* 3235 */ GIM_Reject,
     /* 3236 */ // Label 19: @3236
     /* 3236 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3257), // Rule ID 136 //
     /* 3241 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 3244 */   // MIs[0] dst
     /* 3244 */   // No operand predicates
     /* 3244 */   // MIs[0] src1
     /* 3244 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3248 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 3252 */   // MIs[1] src0
     /* 3252 */   // No operand predicates
     /* 3252 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3254 */   // Combiner Rule #98: bitcast_bitcast_fold
     /* 3254 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 3257 */ // Label 216: @3257
     /* 3257 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3278), // Rule ID 88 //
     /* 3262 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3265 */   // MIs[0] dst
     /* 3265 */   // No operand predicates
     /* 3265 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3265 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3269 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3273 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3275 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 3275 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3278 */ // Label 217: @3278
     /* 3278 */ GIM_Reject,
     /* 3279 */ // Label 20: @3279
     /* 3279 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3308), // Rule ID 18 //
     /* 3284 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 3287 */   // MIs[0] dst
     /* 3287 */   // No operand predicates
     /* 3287 */   // MIs[0] src
     /* 3287 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3291 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 3295 */   // MIs[1] __idempotent_prop_match_0.x
     /* 3295 */   // No operand predicates
     /* 3295 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3300 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3302 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 3302 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3307 */   GIR_EraseRootFromParent_Done,
     /* 3308 */ // Label 218: @3308
     /* 3308 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3331), // Rule ID 43 //
     /* 3313 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 3316 */   // MIs[0] root
     /* 3316 */   // No operand predicates
     /* 3316 */   // MIs[0] src
     /* 3316 */   // No operand predicates
     /* 3316 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3320 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3325 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 3325 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3330 */   GIR_EraseRootFromParent_Done,
     /* 3331 */ // Label 219: @3331
     /* 3331 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3342), // Rule ID 44 //
     /* 3336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 3339 */   // MIs[0] dst
     /* 3339 */   // No operand predicates
     /* 3339 */   // MIs[0] src
     /* 3339 */   // No operand predicates
     /* 3339 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 3339 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 3342 */ // Label 220: @3342
     /* 3342 */ GIM_Reject,
     /* 3343 */ // Label 21: @3343
     /* 3343 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3354), // Rule ID 70 //
     /* 3348 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3351 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_LOAD'
     /* 3351 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3354 */ // Label 221: @3354
     /* 3354 */ GIM_Reject,
     /* 3355 */ // Label 22: @3355
     /* 3355 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3366), // Rule ID 71 //
     /* 3360 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3363 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 3363 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3366 */ // Label 222: @3366
     /* 3366 */ GIM_Reject,
     /* 3367 */ // Label 23: @3367
     /* 3367 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3378), // Rule ID 72 //
     /* 3372 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3375 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 3375 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3378 */ // Label 223: @3378
     /* 3378 */ GIM_Reject,
     /* 3379 */ // Label 24: @3379
     /* 3379 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3390), // Rule ID 100 //
     /* 3384 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 3387 */   // Combiner Rule #81: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 3387 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 3390 */ // Label 224: @3390
     /* 3390 */ GIM_Reject,
     /* 3391 */ // Label 25: @3391
     /* 3391 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3402), // Rule ID 126 //
     /* 3396 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 3399 */   // Combiner Rule #90: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 3399 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3402 */ // Label 225: @3402
     /* 3402 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3413), // Rule ID 257 //
     /* 3407 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 3410 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 3410 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 3413 */ // Label 226: @3413
     /* 3413 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3434), // Rule ID 57 //
     /* 3418 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 3421 */   // MIs[0] root
     /* 3421 */   // No operand predicates
     /* 3421 */   // MIs[0] select
     /* 3421 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3425 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3429 */   // MIs[1] cond
     /* 3429 */   // No operand predicates
     /* 3429 */   // MIs[1] true
     /* 3429 */   // No operand predicates
     /* 3429 */   // MIs[1] false
     /* 3429 */   // No operand predicates
     /* 3429 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3431 */   // Combiner Rule #55: select_of_anyext
     /* 3431 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3434 */ // Label 227: @3434
     /* 3434 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3455), // Rule ID 52 //
     /* 3439 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 3442 */   // MIs[0] root
     /* 3442 */   // No operand predicates
     /* 3442 */   // MIs[0] second
     /* 3442 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3446 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3450 */   // MIs[1] src
     /* 3450 */   // No operand predicates
     /* 3450 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3452 */   // Combiner Rule #50: anyext_of_anyext
     /* 3452 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3455 */ // Label 228: @3455
     /* 3455 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3476), // Rule ID 54 //
     /* 3460 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 3463 */   // MIs[0] root
     /* 3463 */   // No operand predicates
     /* 3463 */   // MIs[0] second
     /* 3463 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3471 */   // MIs[1] src
     /* 3471 */   // No operand predicates
     /* 3471 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3473 */   // Combiner Rule #52: anyext_of_sext
     /* 3473 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3476 */ // Label 229: @3476
     /* 3476 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3497), // Rule ID 53 //
     /* 3481 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3484 */   // MIs[0] root
     /* 3484 */   // No operand predicates
     /* 3484 */   // MIs[0] second
     /* 3484 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3488 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3492 */   // MIs[1] src
     /* 3492 */   // No operand predicates
     /* 3492 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3494 */   // Combiner Rule #51: anyext_of_zext
     /* 3494 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3497 */ // Label 230: @3497
     /* 3497 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3518), // Rule ID 89 //
     /* 3502 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3505 */   // MIs[0] dst
     /* 3505 */   // No operand predicates
     /* 3505 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3505 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3509 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3513 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3515 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 3515 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3518 */ // Label 231: @3518
     /* 3518 */ GIM_Reject,
     /* 3519 */ // Label 26: @3519
     /* 3519 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3530), // Rule ID 134 //
     /* 3524 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 3527 */   // Combiner Rule #96: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3527 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3530 */ // Label 232: @3530
     /* 3530 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3541), // Rule ID 135 //
     /* 3535 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 3538 */   // Combiner Rule #97: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3538 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 3541 */ // Label 233: @3541
     /* 3541 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3552), // Rule ID 173 //
     /* 3546 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 3549 */   // Combiner Rule #131: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 3549 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 3552 */ // Label 234: @3552
     /* 3552 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3563), // Rule ID 362 //
     /* 3557 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule215Enabled),
     /* 3560 */   // Combiner Rule #215: clamp_i64_to_i16; wip_match_opcode 'G_TRUNC'
     /* 3560 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner152),
     /* 3563 */ // Label 235: @3563
     /* 3563 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3584), // Rule ID 58 //
     /* 3568 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 3571 */   // MIs[0] root
     /* 3571 */   // No operand predicates
     /* 3571 */   // MIs[0] select
     /* 3571 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3575 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3579 */   // MIs[1] cond
     /* 3579 */   // No operand predicates
     /* 3579 */   // MIs[1] true
     /* 3579 */   // No operand predicates
     /* 3579 */   // MIs[1] false
     /* 3579 */   // No operand predicates
     /* 3579 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3581 */   // Combiner Rule #56: select_of_truncate
     /* 3581 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3584 */ // Label 236: @3584
     /* 3584 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3613), // Rule ID 60 //
     /* 3589 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3592 */   // MIs[0] root
     /* 3592 */   // No operand predicates
     /* 3592 */   // MIs[0] binop
     /* 3592 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 3600 */   // MIs[1] x
     /* 3600 */   // No operand predicates
     /* 3600 */   // MIs[1] const
     /* 3600 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3604 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3608 */   // MIs[2] imm
     /* 3608 */   // No operand predicates
     /* 3608 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3610 */   // Combiner Rule #58: narrow_binop_add
     /* 3610 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3613 */ // Label 237: @3613
     /* 3613 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3642), // Rule ID 63 //
     /* 3618 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 3621 */   // MIs[0] root
     /* 3621 */   // No operand predicates
     /* 3621 */   // MIs[0] binop
     /* 3621 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 3629 */   // MIs[1] x
     /* 3629 */   // No operand predicates
     /* 3629 */   // MIs[1] const
     /* 3629 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3633 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3637 */   // MIs[2] imm
     /* 3637 */   // No operand predicates
     /* 3637 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3639 */   // Combiner Rule #61: narrow_binop_and
     /* 3639 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3642 */ // Label 238: @3642
     /* 3642 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3671), // Rule ID 62 //
     /* 3647 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3650 */   // MIs[0] root
     /* 3650 */   // No operand predicates
     /* 3650 */   // MIs[0] binop
     /* 3650 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3654 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 3658 */   // MIs[1] x
     /* 3658 */   // No operand predicates
     /* 3658 */   // MIs[1] const
     /* 3658 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3662 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3666 */   // MIs[2] imm
     /* 3666 */   // No operand predicates
     /* 3666 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3668 */   // Combiner Rule #60: narrow_binop_mul
     /* 3668 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3671 */ // Label 239: @3671
     /* 3671 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3700), // Rule ID 64 //
     /* 3676 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 3679 */   // MIs[0] root
     /* 3679 */   // No operand predicates
     /* 3679 */   // MIs[0] binop
     /* 3679 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3683 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 3687 */   // MIs[1] x
     /* 3687 */   // No operand predicates
     /* 3687 */   // MIs[1] const
     /* 3687 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3691 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3695 */   // MIs[2] imm
     /* 3695 */   // No operand predicates
     /* 3695 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3697 */   // Combiner Rule #62: narrow_binop_or
     /* 3697 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3700 */ // Label 240: @3700
     /* 3700 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3729), // Rule ID 61 //
     /* 3705 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 3708 */   // MIs[0] root
     /* 3708 */   // No operand predicates
     /* 3708 */   // MIs[0] binop
     /* 3708 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 3716 */   // MIs[1] x
     /* 3716 */   // No operand predicates
     /* 3716 */   // MIs[1] const
     /* 3716 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3720 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3724 */   // MIs[2] imm
     /* 3724 */   // No operand predicates
     /* 3724 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3726 */   // Combiner Rule #59: narrow_binop_sub
     /* 3726 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3729 */ // Label 241: @3729
     /* 3729 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3758), // Rule ID 65 //
     /* 3734 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 3737 */   // MIs[0] root
     /* 3737 */   // No operand predicates
     /* 3737 */   // MIs[0] binop
     /* 3737 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 3745 */   // MIs[1] x
     /* 3745 */   // No operand predicates
     /* 3745 */   // MIs[1] const
     /* 3745 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3749 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3753 */   // MIs[2] imm
     /* 3753 */   // No operand predicates
     /* 3753 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3755 */   // Combiner Rule #63: narrow_binop_xor
     /* 3755 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3758 */ // Label 242: @3758
     /* 3758 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3779), // Rule ID 47 //
     /* 3763 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 3766 */   // MIs[0] root
     /* 3766 */   // No operand predicates
     /* 3766 */   // MIs[0] ext
     /* 3766 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3770 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3774 */   // MIs[1] src
     /* 3774 */   // No operand predicates
     /* 3774 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3776 */   // Combiner Rule #45: truncate_of_anyext
     /* 3776 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3779 */ // Label 243: @3779
     /* 3779 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3803), // Rule ID 59 //
     /* 3784 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 3787 */   // MIs[0] root
     /* 3787 */   // No operand predicates
     /* 3787 */   // MIs[0] bv
     /* 3787 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3791 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 3795 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 3798 */   // MIs[1] unused
     /* 3798 */   // No operand predicates
     /* 3798 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3800 */   // Combiner Rule #57: buildvector_of_truncate
     /* 3800 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3803 */ // Label 244: @3803
     /* 3803 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3824), // Rule ID 46 //
     /* 3808 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 3811 */   // MIs[0] root
     /* 3811 */   // No operand predicates
     /* 3811 */   // MIs[0] ext
     /* 3811 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3815 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3819 */   // MIs[1] src
     /* 3819 */   // No operand predicates
     /* 3819 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3821 */   // Combiner Rule #44: truncate_of_sext
     /* 3821 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3824 */ // Label 245: @3824
     /* 3824 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3845), // Rule ID 45 //
     /* 3829 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 3832 */   // MIs[0] root
     /* 3832 */   // No operand predicates
     /* 3832 */   // MIs[0] ext
     /* 3832 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3836 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3840 */   // MIs[1] src
     /* 3840 */   // No operand predicates
     /* 3840 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3842 */   // Combiner Rule #43: truncate_of_zext
     /* 3842 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3845 */ // Label 246: @3845
     /* 3845 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3866), // Rule ID 87 //
     /* 3850 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3853 */   // MIs[0] dst
     /* 3853 */   // No operand predicates
     /* 3853 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3853 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3857 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3861 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3863 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 3863 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3866 */ // Label 247: @3866
     /* 3866 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3887), // Rule ID 66 //
     /* 3871 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 3874 */   // MIs[0] root
     /* 3874 */   // No operand predicates
     /* 3874 */   // MIs[0] int
     /* 3874 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3882 */   // MIs[1] imm
     /* 3882 */   // No operand predicates
     /* 3882 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3884 */   // Combiner Rule #64: integer_of_truncate
     /* 3884 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 3887 */ // Label 248: @3887
     /* 3887 */ GIM_Reject,
     /* 3888 */ // Label 27: @3888
     /* 3888 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(3899), // Rule ID 256 //
     /* 3893 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 3896 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 3896 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 3899 */ // Label 249: @3899
     /* 3899 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(3920), // Rule ID 51 //
     /* 3904 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3907 */   // MIs[0] root
     /* 3907 */   // No operand predicates
     /* 3907 */   // MIs[0] second
     /* 3907 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3911 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3915 */   // MIs[1] src
     /* 3915 */   // No operand predicates
     /* 3915 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3917 */   // Combiner Rule #49: sext_of_anyext
     /* 3917 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3920 */ // Label 250: @3920
     /* 3920 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(3941), // Rule ID 50 //
     /* 3925 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3928 */   // MIs[0] root
     /* 3928 */   // No operand predicates
     /* 3928 */   // MIs[0] second
     /* 3928 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3932 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3936 */   // MIs[1] src
     /* 3936 */   // No operand predicates
     /* 3936 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3938 */   // Combiner Rule #48: sext_of_sext
     /* 3938 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3941 */ // Label 251: @3941
     /* 3941 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(3962), // Rule ID 341 //
     /* 3946 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 3949 */   // MIs[0] root
     /* 3949 */   // No operand predicates
     /* 3949 */   // MIs[0] src
     /* 3949 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3953 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 3957 */   // MIs[1] x
     /* 3957 */   // No operand predicates
     /* 3957 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3959 */   // Combiner Rule #196: sext_trunc
     /* 3959 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 3962 */ // Label 252: @3962
     /* 3962 */ GIM_Reject,
     /* 3963 */ // Label 28: @3963
     /* 3963 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(3974), // Rule ID 160 //
     /* 3968 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 3971 */   // Combiner Rule #118: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 3971 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 3974 */ // Label 253: @3974
     /* 3974 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(3985), // Rule ID 168 //
     /* 3979 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 3982 */   // Combiner Rule #126: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 3982 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 3985 */ // Label 254: @3985
     /* 3985 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(3996), // Rule ID 225 //
     /* 3990 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 3993 */   // Combiner Rule #162: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 3993 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 3996 */ // Label 255: @3996
     /* 3996 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(4017), // Rule ID 55 //
     /* 4001 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 4004 */   // MIs[0] dst
     /* 4004 */   // No operand predicates
     /* 4004 */   // MIs[0] x
     /* 4004 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4008 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 4012 */   // MIs[1] src
     /* 4012 */   // No operand predicates
     /* 4012 */   // MIs[1] a
     /* 4012 */   // No operand predicates
     /* 4012 */   // MIs[0] b
     /* 4012 */   // No operand predicates
     /* 4012 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4014 */   // Combiner Rule #53: sext_inreg_of_sext_inreg
     /* 4014 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 4017 */ // Label 256: @4017
     /* 4017 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(4028), // Rule ID 172 //
     /* 4022 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 4025 */   // MIs[0] dst
     /* 4025 */   // No operand predicates
     /* 4025 */   // MIs[0] src
     /* 4025 */   // No operand predicates
     /* 4025 */   // MIs[0] imm
     /* 4025 */   // No operand predicates
     /* 4025 */   // Combiner Rule #130: sext_inreg_to_zext_inreg
     /* 4025 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 4028 */ // Label 257: @4028
     /* 4028 */ GIM_Reject,
     /* 4029 */ // Label 29: @4029
     /* 4029 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(4040), // Rule ID 171 //
     /* 4034 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 4037 */   // Combiner Rule #129: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 4037 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 4040 */ // Label 258: @4040
     /* 4040 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(4051), // Rule ID 255 //
     /* 4045 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 4048 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 4048 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 4051 */ // Label 259: @4051
     /* 4051 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(4072), // Rule ID 56 //
     /* 4056 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 4059 */   // MIs[0] root
     /* 4059 */   // No operand predicates
     /* 4059 */   // MIs[0] select
     /* 4059 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 4067 */   // MIs[1] cond
     /* 4067 */   // No operand predicates
     /* 4067 */   // MIs[1] true
     /* 4067 */   // No operand predicates
     /* 4067 */   // MIs[1] false
     /* 4067 */   // No operand predicates
     /* 4067 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4069 */   // Combiner Rule #54: select_of_zext
     /* 4069 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 4072 */ // Label 260: @4072
     /* 4072 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(4093), // Rule ID 49 //
     /* 4077 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 4080 */   // MIs[0] root
     /* 4080 */   // No operand predicates
     /* 4080 */   // MIs[0] second
     /* 4080 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4084 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4088 */   // MIs[1] src
     /* 4088 */   // No operand predicates
     /* 4088 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4090 */   // Combiner Rule #47: zext_of_anyext
     /* 4090 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4093 */ // Label 261: @4093
     /* 4093 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(4120), // Rule ID 342 //
     /* 4098 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 4101 */   // MIs[0] root
     /* 4101 */   // No operand predicates
     /* 4101 */   // MIs[0] src
     /* 4101 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4105 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4109 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 4115 */   // MIs[1] x
     /* 4115 */   // No operand predicates
     /* 4115 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4117 */   // Combiner Rule #197: zext_trunc
     /* 4117 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 4120 */ // Label 262: @4120
     /* 4120 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(4141), // Rule ID 48 //
     /* 4125 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 4128 */   // MIs[0] root
     /* 4128 */   // No operand predicates
     /* 4128 */   // MIs[0] second
     /* 4128 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4136 */   // MIs[1] src
     /* 4136 */   // No operand predicates
     /* 4136 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4138 */   // Combiner Rule #46: zext_of_zext
     /* 4138 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4141 */ // Label 263: @4141
     /* 4141 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(4158), // Rule ID 343 //
     /* 4146 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 4149 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 4155 */   // MIs[0] root
     /* 4155 */   // No operand predicates
     /* 4155 */   // MIs[0] x
     /* 4155 */   // No operand predicates
     /* 4155 */   // Combiner Rule #198: nneg_zext
     /* 4155 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 4158 */ // Label 264: @4158
     /* 4158 */ GIM_Reject,
     /* 4159 */ // Label 30: @4159
     /* 4159 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(4170), // Rule ID 80 //
     /* 4164 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4167 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 4167 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4170 */ // Label 265: @4170
     /* 4170 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(4181), // Rule ID 83 //
     /* 4175 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4178 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 4178 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4181 */ // Label 266: @4181
     /* 4181 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(4192), // Rule ID 116 //
     /* 4186 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4189 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 4189 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4192 */ // Label 267: @4192
     /* 4192 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(4203), // Rule ID 200 //
     /* 4197 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4200 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 4200 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4203 */ // Label 268: @4203
     /* 4203 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(4214), // Rule ID 205 //
     /* 4208 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4211 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 4211 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4214 */ // Label 269: @4214
     /* 4214 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(4225), // Rule ID 224 //
     /* 4219 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 4222 */   // Combiner Rule #161: commute_shift; wip_match_opcode 'G_SHL'
     /* 4222 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 4225 */ // Label 270: @4225
     /* 4225 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(4236), // Rule ID 238 //
     /* 4230 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4233 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 4233 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4236 */ // Label 271: @4236
     /* 4236 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(4247), // Rule ID 291 //
     /* 4241 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4244 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 4244 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4247 */ // Label 272: @4247
     /* 4247 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(4282), // Rule ID 41 //
     /* 4252 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 4255 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 4261 */   // MIs[0] root
     /* 4261 */   // No operand predicates
     /* 4261 */   // MIs[0] left
     /* 4261 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4265 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 4269 */   // MIs[1] imm
     /* 4269 */   // No operand predicates
     /* 4269 */   // MIs[0] x
     /* 4269 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 4273 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4277 */   // MIs[2] imm1
     /* 4277 */   // No operand predicates
     /* 4277 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4279 */   // Combiner Rule #39: shl_of_vscale
     /* 4279 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 4282 */ // Label 273: @4282
     /* 4282 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(4305), // Rule ID 108 //
     /* 4287 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4290 */   // MIs[0] dst
     /* 4290 */   // No operand predicates
     /* 4290 */   // MIs[0] lhs
     /* 4290 */   // No operand predicates
     /* 4290 */   // MIs[0] Operand 2
     /* 4290 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4294 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4299 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 4299 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4304 */   GIR_EraseRootFromParent_Done,
     /* 4305 */ // Label 274: @4305
     /* 4305 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(4316), // Rule ID 145 //
     /* 4310 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4313 */   // MIs[0] root
     /* 4313 */   // No operand predicates
     /* 4313 */   // MIs[0] mi.shifted
     /* 4313 */   // No operand predicates
     /* 4313 */   // MIs[0] mi.amt
     /* 4313 */   // No operand predicates
     /* 4313 */   // Combiner Rule #105: shifts_too_big @ [mi[0]]
     /* 4313 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4316 */ // Label 275: @4316
     /* 4316 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(4327), // Rule ID 161 //
     /* 4321 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 4324 */   // MIs[0] dst
     /* 4324 */   // No operand predicates
     /* 4324 */   // MIs[0] src0
     /* 4324 */   // No operand predicates
     /* 4324 */   // MIs[0] src1
     /* 4324 */   // No operand predicates
     /* 4324 */   // Combiner Rule #119: reduce_shl_of_extend
     /* 4324 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 4327 */ // Label 276: @4327
     /* 4327 */ GIM_Reject,
     /* 4328 */ // Label 31: @4328
     /* 4328 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(4339), // Rule ID 85 //
     /* 4333 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4336 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 4336 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4339 */ // Label 277: @4339
     /* 4339 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(4350), // Rule ID 117 //
     /* 4344 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4347 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 4347 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4350 */ // Label 278: @4350
     /* 4350 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(4361), // Rule ID 202 //
     /* 4355 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4358 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 4358 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4361 */ // Label 279: @4361
     /* 4361 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(4372), // Rule ID 207 //
     /* 4366 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4369 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 4369 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4372 */ // Label 280: @4372
     /* 4372 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(4383), // Rule ID 228 //
     /* 4377 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4380 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 4380 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4383 */ // Label 281: @4383
     /* 4383 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(4394), // Rule ID 230 //
     /* 4388 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4391 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 4391 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4394 */ // Label 282: @4394
     /* 4394 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(4405), // Rule ID 235 //
     /* 4399 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4402 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 4402 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4405 */ // Label 283: @4405
     /* 4405 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(4416), // Rule ID 289 //
     /* 4410 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4413 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 4413 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4416 */ // Label 284: @4416
     /* 4416 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(4439), // Rule ID 110 //
     /* 4421 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4424 */   // MIs[0] dst
     /* 4424 */   // No operand predicates
     /* 4424 */   // MIs[0] lhs
     /* 4424 */   // No operand predicates
     /* 4424 */   // MIs[0] Operand 2
     /* 4424 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4428 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4433 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 4433 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4438 */   GIR_EraseRootFromParent_Done,
     /* 4439 */ // Label 285: @4439
     /* 4439 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(4450), // Rule ID 147 //
     /* 4444 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4447 */   // MIs[0] root
     /* 4447 */   // No operand predicates
     /* 4447 */   // MIs[0] mi.shifted
     /* 4447 */   // No operand predicates
     /* 4447 */   // MIs[0] mi.amt
     /* 4447 */   // No operand predicates
     /* 4447 */   // Combiner Rule #105: shifts_too_big @ [mi[2]]
     /* 4447 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4450 */ // Label 286: @4450
     /* 4450 */ GIM_Reject,
     /* 4451 */ // Label 32: @4451
     /* 4451 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(4462), // Rule ID 84 //
     /* 4456 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4459 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 4459 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4462 */ // Label 287: @4462
     /* 4462 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(4473), // Rule ID 118 //
     /* 4467 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4470 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 4470 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4473 */ // Label 288: @4473
     /* 4473 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(4484), // Rule ID 158 //
     /* 4478 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 4481 */   // Combiner Rule #116: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 4481 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 4484 */ // Label 289: @4484
     /* 4484 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(4495), // Rule ID 201 //
     /* 4489 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4492 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 4492 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4495 */ // Label 290: @4495
     /* 4495 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(4506), // Rule ID 206 //
     /* 4500 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4503 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 4503 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4506 */ // Label 291: @4506
     /* 4506 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(4517), // Rule ID 227 //
     /* 4511 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4514 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 4514 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4517 */ // Label 292: @4517
     /* 4517 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(4528), // Rule ID 229 //
     /* 4522 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4525 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 4525 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4528 */ // Label 293: @4528
     /* 4528 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(4539), // Rule ID 234 //
     /* 4533 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4536 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 4536 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4539 */ // Label 294: @4539
     /* 4539 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(4550), // Rule ID 290 //
     /* 4544 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4547 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 4547 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4550 */ // Label 295: @4550
     /* 4550 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(4573), // Rule ID 109 //
     /* 4555 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4558 */   // MIs[0] dst
     /* 4558 */   // No operand predicates
     /* 4558 */   // MIs[0] lhs
     /* 4558 */   // No operand predicates
     /* 4558 */   // MIs[0] Operand 2
     /* 4558 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4562 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4567 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 4567 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4572 */   GIR_EraseRootFromParent_Done,
     /* 4573 */ // Label 296: @4573
     /* 4573 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(4584), // Rule ID 146 //
     /* 4578 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4581 */   // MIs[0] root
     /* 4581 */   // No operand predicates
     /* 4581 */   // MIs[0] mi.shifted
     /* 4581 */   // No operand predicates
     /* 4581 */   // MIs[0] mi.amt
     /* 4581 */   // No operand predicates
     /* 4581 */   // Combiner Rule #105: shifts_too_big @ [mi[1]]
     /* 4581 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4584 */ // Label 297: @4584
     /* 4584 */ GIM_Reject,
     /* 4585 */ // Label 33: @4585
     /* 4585 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(4596), // Rule ID 216 //
     /* 4590 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4593 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 4593 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4596 */ // Label 298: @4596
     /* 4596 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(4607), // Rule ID 220 //
     /* 4601 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4604 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 4604 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4607 */ // Label 299: @4607
     /* 4607 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(4627), // Rule ID 219 //
     /* 4612 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 4615 */   // MIs[0] x
     /* 4615 */   // No operand predicates
     /* 4615 */   // MIs[0] y
     /* 4615 */   // No operand predicates
     /* 4615 */   // MIs[0] z
     /* 4615 */   // No operand predicates
     /* 4615 */   // MIs[0] Operand 3
     /* 4615 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4619 */   // Combiner Rule #157: funnel_shift_left_zero
     /* 4619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4622 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4624 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 4626 */   GIR_EraseRootFromParent_Done,
     /* 4627 */ // Label 300: @4627
     /* 4627 */ GIM_Reject,
     /* 4628 */ // Label 34: @4628
     /* 4628 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(4639), // Rule ID 217 //
     /* 4633 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4636 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 4636 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4639 */ // Label 301: @4639
     /* 4639 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(4650), // Rule ID 221 //
     /* 4644 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4647 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 4647 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4650 */ // Label 302: @4650
     /* 4650 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(4670), // Rule ID 218 //
     /* 4655 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4658 */   // MIs[0] x
     /* 4658 */   // No operand predicates
     /* 4658 */   // MIs[0] y
     /* 4658 */   // No operand predicates
     /* 4658 */   // MIs[0] z
     /* 4658 */   // No operand predicates
     /* 4658 */   // MIs[0] Operand 3
     /* 4658 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4662 */   // Combiner Rule #156: funnel_shift_right_zero
     /* 4662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4665 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4667 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 4669 */   GIR_EraseRootFromParent_Done,
     /* 4670 */ // Label 303: @4670
     /* 4670 */ GIM_Reject,
     /* 4671 */ // Label 35: @4671
     /* 4671 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(4694), // Rule ID 113 //
     /* 4676 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4679 */   // MIs[0] dst
     /* 4679 */   // No operand predicates
     /* 4679 */   // MIs[0] lhs
     /* 4679 */   // No operand predicates
     /* 4679 */   // MIs[0] Operand 2
     /* 4679 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4683 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4688 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 4688 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4693 */   GIR_EraseRootFromParent_Done,
     /* 4694 */ // Label 304: @4694
     /* 4694 */ GIM_Reject,
     /* 4695 */ // Label 36: @4695
     /* 4695 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(4718), // Rule ID 112 //
     /* 4700 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4703 */   // MIs[0] dst
     /* 4703 */   // No operand predicates
     /* 4703 */   // MIs[0] lhs
     /* 4703 */   // No operand predicates
     /* 4703 */   // MIs[0] Operand 2
     /* 4703 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4707 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4712 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 4712 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4717 */   GIR_EraseRootFromParent_Done,
     /* 4718 */ // Label 305: @4718
     /* 4718 */ GIM_Reject,
     /* 4719 */ // Label 37: @4719
     /* 4719 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(4730), // Rule ID 153 //
     /* 4724 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 4727 */   // Combiner Rule #111: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 4727 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 4730 */ // Label 306: @4730
     /* 4730 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(4741), // Rule ID 154 //
     /* 4735 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 4738 */   // Combiner Rule #112: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 4738 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 4741 */ // Label 307: @4741
     /* 4741 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(4752), // Rule ID 157 //
     /* 4746 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 4749 */   // Combiner Rule #115: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 4749 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 4752 */ // Label 308: @4752
     /* 4752 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(4763), // Rule ID 151 //
     /* 4757 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 4760 */   // MIs[0] root
     /* 4760 */   // No operand predicates
     /* 4760 */   // MIs[0] pred
     /* 4760 */   // No operand predicates
     /* 4760 */   // MIs[0] lhs
     /* 4760 */   // No operand predicates
     /* 4760 */   // MIs[0] rhs
     /* 4760 */   // No operand predicates
     /* 4760 */   // Combiner Rule #109: canonicalize_icmp
     /* 4760 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 4763 */ // Label 309: @4763
     /* 4763 */ GIM_Reject,
     /* 4764 */ // Label 38: @4764
     /* 4764 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(4775), // Rule ID 152 //
     /* 4769 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 4772 */   // MIs[0] root
     /* 4772 */   // No operand predicates
     /* 4772 */   // MIs[0] pred
     /* 4772 */   // No operand predicates
     /* 4772 */   // MIs[0] lhs
     /* 4772 */   // No operand predicates
     /* 4772 */   // MIs[0] rhs
     /* 4772 */   // No operand predicates
     /* 4772 */   // Combiner Rule #110: canonicalize_fcmp
     /* 4772 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 4775 */ // Label 310: @4775
     /* 4775 */ GIM_Reject,
     /* 4776 */ // Label 39: @4776
     /* 4776 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(4787), // Rule ID 103 //
     /* 4781 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4784 */   // Combiner Rule #83: select_same_val; wip_match_opcode 'G_SELECT'
     /* 4784 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4787 */ // Label 311: @4787
     /* 4787 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(4798), // Rule ID 164 //
     /* 4792 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 4795 */   // Combiner Rule #122: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 4795 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 4798 */ // Label 312: @4798
     /* 4798 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(4809), // Rule ID 166 //
     /* 4803 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 4806 */   // Combiner Rule #124: match_selects; wip_match_opcode 'G_SELECT'
     /* 4806 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 4809 */ // Label 313: @4809
     /* 4809 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(4820), // Rule ID 306 //
     /* 4814 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 4817 */   // Combiner Rule #188: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 4817 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 4820 */ // Label 314: @4820
     /* 4820 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(4841), // Rule ID 165 //
     /* 4825 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 4828 */   // MIs[0] root
     /* 4828 */   // No operand predicates
     /* 4828 */   // MIs[0] tst
     /* 4828 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4832 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 4836 */   // MIs[1] tst1
     /* 4836 */   // No operand predicates
     /* 4836 */   // MIs[1] a
     /* 4836 */   // No operand predicates
     /* 4836 */   // MIs[1] b
     /* 4836 */   // No operand predicates
     /* 4836 */   // MIs[0] x
     /* 4836 */   // No operand predicates
     /* 4836 */   // MIs[0] y
     /* 4836 */   // No operand predicates
     /* 4836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4838 */   // Combiner Rule #123: select_to_iminmax
     /* 4838 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 4841 */ // Label 315: @4841
     /* 4841 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(4870), // Rule ID 163 //
     /* 4846 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 4849 */   // MIs[0] dst
     /* 4849 */   // No operand predicates
     /* 4849 */   // MIs[0] undef
     /* 4849 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4853 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 4857 */   // MIs[0] x
     /* 4857 */   // No operand predicates
     /* 4857 */   // MIs[0] y
     /* 4857 */   // No operand predicates
     /* 4857 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 4862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4864 */   // Combiner Rule #121: select_undef_cmp
     /* 4864 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 4869 */   GIR_EraseRootFromParent_Done,
     /* 4870 */ // Label 316: @4870
     /* 4870 */ GIM_Reject,
     /* 4871 */ // Label 40: @4871
     /* 4871 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(4882), // Rule ID 317 //
     /* 4876 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 4879 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 4879 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 4882 */ // Label 317: @4882
     /* 4882 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(4893), // Rule ID 358 //
     /* 4887 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 4890 */   // Combiner Rule #212: match_addos; wip_match_opcode 'G_UADDO'
     /* 4890 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 4893 */ // Label 318: @4893
     /* 4893 */ GIM_Reject,
     /* 4894 */ // Label 41: @4894
     /* 4894 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(4905), // Rule ID 189 //
     /* 4899 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 4902 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 4902 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 4905 */ // Label 319: @4905
     /* 4905 */ GIM_Reject,
     /* 4906 */ // Label 42: @4906
     /* 4906 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(4917), // Rule ID 360 //
     /* 4911 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 4914 */   // Combiner Rule #213: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 4914 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 4917 */ // Label 320: @4917
     /* 4917 */ GIM_Reject,
     /* 4918 */ // Label 43: @4918
     /* 4918 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(4929), // Rule ID 191 //
     /* 4923 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 4926 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 4926 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 4929 */ // Label 321: @4929
     /* 4929 */ GIM_Reject,
     /* 4930 */ // Label 44: @4930
     /* 4930 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(4941), // Rule ID 318 //
     /* 4935 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 4938 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 4938 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 4941 */ // Label 322: @4941
     /* 4941 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(4952), // Rule ID 357 //
     /* 4946 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 4949 */   // Combiner Rule #212: match_addos; wip_match_opcode 'G_SADDO'
     /* 4949 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 4952 */ // Label 323: @4952
     /* 4952 */ GIM_Reject,
     /* 4953 */ // Label 45: @4953
     /* 4953 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(4964), // Rule ID 190 //
     /* 4958 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 4961 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 4961 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 4964 */ // Label 324: @4964
     /* 4964 */ GIM_Reject,
     /* 4965 */ // Label 46: @4965
     /* 4965 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(4976), // Rule ID 359 //
     /* 4970 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 4973 */   // Combiner Rule #213: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 4973 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 4976 */ // Label 325: @4976
     /* 4976 */ GIM_Reject,
     /* 4977 */ // Label 47: @4977
     /* 4977 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(4988), // Rule ID 192 //
     /* 4982 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 4985 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 4985 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 4988 */ // Label 326: @4988
     /* 4988 */ GIM_Reject,
     /* 4989 */ // Label 48: @4989
     /* 4989 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(5000), // Rule ID 185 //
     /* 4994 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 4997 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 4997 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5000 */ // Label 327: @5000
     /* 5000 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(5011), // Rule ID 187 //
     /* 5005 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5008 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 5008 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5011 */ // Label 328: @5011
     /* 5011 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(5022), // Rule ID 319 //
     /* 5016 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5019 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 5019 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5022 */ // Label 329: @5022
     /* 5022 */ GIM_Reject,
     /* 5023 */ // Label 49: @5023
     /* 5023 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(5034), // Rule ID 186 //
     /* 5028 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5031 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 5031 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5034 */ // Label 330: @5034
     /* 5034 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(5045), // Rule ID 188 //
     /* 5039 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5042 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 5042 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5045 */ // Label 331: @5045
     /* 5045 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(5056), // Rule ID 320 //
     /* 5050 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5053 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 5053 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5056 */ // Label 332: @5056
     /* 5056 */ GIM_Reject,
     /* 5057 */ // Label 50: @5057
     /* 5057 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(5068), // Rule ID 263 //
     /* 5062 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5065 */   // Combiner Rule #175: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 5065 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5068 */ // Label 333: @5068
     /* 5068 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(5079), // Rule ID 321 //
     /* 5073 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5076 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 5076 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5079 */ // Label 334: @5079
     /* 5079 */ GIM_Reject,
     /* 5080 */ // Label 51: @5080
     /* 5080 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(5091), // Rule ID 322 //
     /* 5085 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5088 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 5088 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5091 */ // Label 335: @5091
     /* 5091 */ GIM_Reject,
     /* 5092 */ // Label 52: @5092
     /* 5092 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(5103), // Rule ID 323 //
     /* 5097 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5100 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 5100 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5103 */ // Label 336: @5103
     /* 5103 */ GIM_Reject,
     /* 5104 */ // Label 53: @5104
     /* 5104 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(5115), // Rule ID 324 //
     /* 5109 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5112 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 5112 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5115 */ // Label 337: @5115
     /* 5115 */ GIM_Reject,
     /* 5116 */ // Label 54: @5116
     /* 5116 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(5127), // Rule ID 204 //
     /* 5121 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5124 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 5124 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5127 */ // Label 338: @5127
     /* 5127 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(5138), // Rule ID 208 //
     /* 5132 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5135 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 5135 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5138 */ // Label 339: @5138
     /* 5138 */ GIM_Reject,
     /* 5139 */ // Label 55: @5139
     /* 5139 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(5150), // Rule ID 203 //
     /* 5144 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5147 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5147 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5150 */ // Label 340: @5150
     /* 5150 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(5161), // Rule ID 209 //
     /* 5155 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5158 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5158 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5161 */ // Label 341: @5161
     /* 5161 */ GIM_Reject,
     /* 5162 */ // Label 56: @5162
     /* 5162 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(5173), // Rule ID 325 //
     /* 5167 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5170 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 5170 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5173 */ // Label 342: @5173
     /* 5173 */ GIM_Reject,
     /* 5174 */ // Label 57: @5174
     /* 5174 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(5185), // Rule ID 326 //
     /* 5179 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5182 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 5182 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5185 */ // Label 343: @5185
     /* 5185 */ GIM_Reject,
     /* 5186 */ // Label 58: @5186
     /* 5186 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(5197), // Rule ID 327 //
     /* 5191 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5194 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 5194 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5197 */ // Label 344: @5197
     /* 5197 */ GIM_Reject,
     /* 5198 */ // Label 59: @5198
     /* 5198 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(5209), // Rule ID 328 //
     /* 5203 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5206 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 5206 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5209 */ // Label 345: @5209
     /* 5209 */ GIM_Reject,
     /* 5210 */ // Label 60: @5210
     /* 5210 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(5221), // Rule ID 249 //
     /* 5215 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5218 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 5218 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5221 */ // Label 346: @5221
     /* 5221 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(5232), // Rule ID 264 //
     /* 5226 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5229 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 5229 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5232 */ // Label 347: @5232
     /* 5232 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(5243), // Rule ID 271 //
     /* 5237 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 5240 */   // Combiner Rule #178: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5240 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 5243 */ // Label 348: @5243
     /* 5243 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(5254), // Rule ID 272 //
     /* 5248 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 5251 */   // Combiner Rule #179: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5251 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 5254 */ // Label 349: @5254
     /* 5254 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(5265), // Rule ID 273 //
     /* 5259 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 5262 */   // Combiner Rule #180: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5262 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 5265 */ // Label 350: @5265
     /* 5265 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(5276), // Rule ID 274 //
     /* 5270 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 5273 */   // Combiner Rule #181: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5273 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 5276 */ // Label 351: @5276
     /* 5276 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(5287), // Rule ID 297 //
     /* 5281 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5284 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 5284 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5287 */ // Label 352: @5287
     /* 5287 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(5298), // Rule ID 329 //
     /* 5292 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5295 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 5295 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5298 */ // Label 353: @5298
     /* 5298 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(5321), // Rule ID 138 //
     /* 5303 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 5306 */   // MIs[0] dst
     /* 5306 */   // No operand predicates
     /* 5306 */   // MIs[0] x
     /* 5306 */   // No operand predicates
     /* 5306 */   // MIs[0] y
     /* 5306 */   // No operand predicates
     /* 5306 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 5310 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5315 */   // Combiner Rule #100: right_identity_neg_zero_fp
     /* 5315 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5320 */   GIR_EraseRootFromParent_Done,
     /* 5321 */ // Label 354: @5321
     /* 5321 */ GIM_Reject,
     /* 5322 */ // Label 61: @5322
     /* 5322 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(5333), // Rule ID 250 //
     /* 5327 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5330 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 5330 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5333 */ // Label 355: @5333
     /* 5333 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(5344), // Rule ID 265 //
     /* 5338 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5341 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 5341 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5344 */ // Label 356: @5344
     /* 5344 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(5355), // Rule ID 275 //
     /* 5349 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5352 */   // Combiner Rule #182: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5352 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5355 */ // Label 357: @5355
     /* 5355 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(5366), // Rule ID 276 //
     /* 5360 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 5363 */   // Combiner Rule #183: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5363 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 5366 */ // Label 358: @5366
     /* 5366 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(5377), // Rule ID 277 //
     /* 5371 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5374 */   // Combiner Rule #184: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5374 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 5377 */ // Label 359: @5377
     /* 5377 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(5388), // Rule ID 278 //
     /* 5382 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5385 */   // Combiner Rule #185: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5385 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5388 */ // Label 360: @5388
     /* 5388 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(5399), // Rule ID 298 //
     /* 5393 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5396 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 5396 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5399 */ // Label 361: @5399
     /* 5399 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(5410), // Rule ID 307 //
     /* 5404 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5407 */   // Combiner Rule #189: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 5407 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5410 */ // Label 362: @5410
     /* 5410 */ GIM_Reject,
     /* 5411 */ // Label 62: @5411
     /* 5411 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(5422), // Rule ID 251 //
     /* 5416 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5419 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 5419 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5422 */ // Label 363: @5422
     /* 5422 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(5433), // Rule ID 266 //
     /* 5427 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5430 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 5430 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5433 */ // Label 364: @5433
     /* 5433 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(5444), // Rule ID 296 //
     /* 5438 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5441 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 5441 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5444 */ // Label 365: @5444
     /* 5444 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(5455), // Rule ID 330 //
     /* 5449 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5452 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 5452 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5455 */ // Label 366: @5455
     /* 5455 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(5476), // Rule ID 361 //
     /* 5460 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 5463 */   // MIs[0] dst
     /* 5463 */   // No operand predicates
     /* 5463 */   // MIs[0] x
     /* 5463 */   // No operand predicates
     /* 5463 */   // MIs[0] select
     /* 5463 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 5471 */   // MIs[1] y
     /* 5471 */   // No operand predicates
     /* 5471 */   // MIs[1] A
     /* 5471 */   // No operand predicates
     /* 5471 */   // MIs[1] B
     /* 5471 */   // No operand predicates
     /* 5471 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5473 */   // Combiner Rule #214: combine_fmul_with_select_to_fldexp
     /* 5473 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner151),
     /* 5476 */ // Label 367: @5476
     /* 5476 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(5499), // Rule ID 129 //
     /* 5481 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 5484 */   // MIs[0] dst
     /* 5484 */   // No operand predicates
     /* 5484 */   // MIs[0] x
     /* 5484 */   // No operand predicates
     /* 5484 */   // MIs[0] y
     /* 5484 */   // No operand predicates
     /* 5484 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 5488 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5493 */   // Combiner Rule #93: right_identity_one_fp
     /* 5493 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5498 */   GIR_EraseRootFromParent_Done,
     /* 5499 */ // Label 368: @5499
     /* 5499 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(5519), // Rule ID 139 //
     /* 5504 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 5507 */   // MIs[0] dst
     /* 5507 */   // No operand predicates
     /* 5507 */   // MIs[0] x
     /* 5507 */   // No operand predicates
     /* 5507 */   // MIs[0] y
     /* 5507 */   // No operand predicates
     /* 5507 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 5511 */   // Combiner Rule #101: right_identity_neg_one_fp
     /* 5511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5514 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5516 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 5518 */   GIR_EraseRootFromParent_Done,
     /* 5519 */ // Label 369: @5519
     /* 5519 */ GIM_Reject,
     /* 5520 */ // Label 63: @5520
     /* 5520 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(5531), // Rule ID 254 //
     /* 5525 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5528 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 5528 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5531 */ // Label 370: @5531
     /* 5531 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(5542), // Rule ID 269 //
     /* 5536 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5539 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 5539 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5542 */ // Label 371: @5542
     /* 5542 */ GIM_Reject,
     /* 5543 */ // Label 64: @5543
     /* 5543 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(5554), // Rule ID 253 //
     /* 5548 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5551 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 5551 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5554 */ // Label 372: @5554
     /* 5554 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(5565), // Rule ID 268 //
     /* 5559 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5562 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 5562 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5565 */ // Label 373: @5565
     /* 5565 */ GIM_Reject,
     /* 5566 */ // Label 65: @5566
     /* 5566 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(5577), // Rule ID 252 //
     /* 5571 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5574 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 5574 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5577 */ // Label 374: @5577
     /* 5577 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(5588), // Rule ID 267 //
     /* 5582 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5585 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 5585 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5588 */ // Label 375: @5588
     /* 5588 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(5599), // Rule ID 299 //
     /* 5593 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5596 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 5596 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5599 */ // Label 376: @5599
     /* 5599 */ GIM_Reject,
     /* 5600 */ // Label 66: @5600
     /* 5600 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(5611), // Rule ID 300 //
     /* 5605 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5608 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 5608 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5611 */ // Label 377: @5611
     /* 5611 */ GIM_Reject,
     /* 5612 */ // Label 67: @5612
     /* 5612 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(5633), // Rule ID 197 //
     /* 5617 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 5620 */   // MIs[0] dst
     /* 5620 */   // No operand predicates
     /* 5620 */   // MIs[0] float
     /* 5620 */   // No operand predicates
     /* 5620 */   // MIs[0] int
     /* 5620 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 5628 */   // MIs[1] imm
     /* 5628 */   // No operand predicates
     /* 5628 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5630 */   // Combiner Rule #147: expand_const_fpowi
     /* 5630 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 5633 */ // Label 378: @5633
     /* 5633 */ GIM_Reject,
     /* 5634 */ // Label 68: @5634
     /* 5634 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(5655), // Rule ID 179 //
     /* 5639 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 5642 */   // MIs[0] dst
     /* 5642 */   // No operand predicates
     /* 5642 */   // MIs[0] src0
     /* 5642 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5646 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5650 */   // MIs[1] cst
     /* 5650 */   // No operand predicates
     /* 5650 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5652 */   // Combiner Rule #137: constant_fold_flog2
     /* 5652 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5655 */ // Label 379: @5655
     /* 5655 */ GIM_Reject,
     /* 5656 */ // Label 69: @5656
     /* 5656 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(5667), // Rule ID 363 //
     /* 5661 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 5664 */   // Combiner Rule #216: foldable_fneg; wip_match_opcode 'G_FNEG'
     /* 5664 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner153),
     /* 5667 */ // Label 380: @5667
     /* 5667 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(5688), // Rule ID 176 //
     /* 5672 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 5675 */   // MIs[0] dst
     /* 5675 */   // No operand predicates
     /* 5675 */   // MIs[0] src0
     /* 5675 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5679 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5683 */   // MIs[1] cst
     /* 5683 */   // No operand predicates
     /* 5683 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5685 */   // Combiner Rule #134: constant_fold_fneg
     /* 5685 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5688 */ // Label 381: @5688
     /* 5688 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(5717), // Rule ID 127 //
     /* 5693 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 5696 */   // MIs[0] dst
     /* 5696 */   // No operand predicates
     /* 5696 */   // MIs[0] t
     /* 5696 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5704 */   // MIs[1] src
     /* 5704 */   // No operand predicates
     /* 5704 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5709 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5711 */   // Combiner Rule #91: fneg_fneg_fold
     /* 5711 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5716 */   GIR_EraseRootFromParent_Done,
     /* 5717 */ // Label 382: @5717
     /* 5717 */ GIM_Reject,
     /* 5718 */ // Label 70: @5718
     /* 5718 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(5739), // Rule ID 180 //
     /* 5723 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 5726 */   // MIs[0] dst
     /* 5726 */   // No operand predicates
     /* 5726 */   // MIs[0] src0
     /* 5726 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5730 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5734 */   // MIs[1] cst
     /* 5734 */   // No operand predicates
     /* 5734 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5736 */   // Combiner Rule #138: constant_fold_fptrunc
     /* 5736 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5739 */ // Label 383: @5739
     /* 5739 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(5760), // Rule ID 137 //
     /* 5744 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 5747 */   // MIs[0] dst
     /* 5747 */   // No operand predicates
     /* 5747 */   // MIs[0] src1
     /* 5747 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5751 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 5755 */   // MIs[1] src0
     /* 5755 */   // No operand predicates
     /* 5755 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5757 */   // Combiner Rule #99: fptrunc_fpext_fold
     /* 5757 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 5760 */ // Label 384: @5760
     /* 5760 */ GIM_Reject,
     /* 5761 */ // Label 71: @5761
     /* 5761 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(5782), // Rule ID 92 //
     /* 5766 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 5769 */   // MIs[0] dst
     /* 5769 */   // No operand predicates
     /* 5769 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5769 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5773 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5779 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 5779 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 5782 */ // Label 385: @5782
     /* 5782 */ GIM_Reject,
     /* 5783 */ // Label 72: @5783
     /* 5783 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(5804), // Rule ID 93 //
     /* 5788 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 5791 */   // MIs[0] dst
     /* 5791 */   // No operand predicates
     /* 5791 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5791 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5795 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5799 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5801 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 5801 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 5804 */ // Label 386: @5804
     /* 5804 */ GIM_Reject,
     /* 5805 */ // Label 73: @5805
     /* 5805 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(5816), // Rule ID 76 //
     /* 5810 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 5813 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 5813 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 5816 */ // Label 387: @5816
     /* 5816 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(5831), // Rule ID 181 //
     /* 5821 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 5824 */   // MIs[0] dst
     /* 5824 */   // No operand predicates
     /* 5824 */   // MIs[0] Operand 1
     /* 5824 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 5828 */   // Combiner Rule #139: itof_const_zero_fold_si
     /* 5828 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 5831 */ // Label 388: @5831
     /* 5831 */ GIM_Reject,
     /* 5832 */ // Label 74: @5832
     /* 5832 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(5843), // Rule ID 75 //
     /* 5837 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 5840 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 5840 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 5843 */ // Label 389: @5843
     /* 5843 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(5858), // Rule ID 182 //
     /* 5848 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 5851 */   // MIs[0] dst
     /* 5851 */   // No operand predicates
     /* 5851 */   // MIs[0] Operand 1
     /* 5851 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 5855 */   // Combiner Rule #140: itof_const_zero_fold_ui
     /* 5855 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 5858 */ // Label 390: @5858
     /* 5858 */ GIM_Reject,
     /* 5859 */ // Label 75: @5859
     /* 5859 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(5888), // Rule ID 19 //
     /* 5864 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 5867 */   // MIs[0] dst
     /* 5867 */   // No operand predicates
     /* 5867 */   // MIs[0] src
     /* 5867 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5871 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 5875 */   // MIs[1] __idempotent_prop_match_0.x
     /* 5875 */   // No operand predicates
     /* 5875 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5880 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5882 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 5882 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5887 */   GIR_EraseRootFromParent_Done,
     /* 5888 */ // Label 391: @5888
     /* 5888 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(5909), // Rule ID 177 //
     /* 5893 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 5896 */   // MIs[0] dst
     /* 5896 */   // No operand predicates
     /* 5896 */   // MIs[0] src0
     /* 5896 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5900 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5904 */   // MIs[1] cst
     /* 5904 */   // No operand predicates
     /* 5904 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5906 */   // Combiner Rule #135: constant_fold_fabs
     /* 5906 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5909 */ // Label 392: @5909
     /* 5909 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(5937), // Rule ID 258 //
     /* 5914 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 5917 */   // MIs[0] dst
     /* 5917 */   // No operand predicates
     /* 5917 */   // MIs[0] tmp
     /* 5917 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5925 */   // MIs[1] x
     /* 5925 */   // No operand predicates
     /* 5925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5927 */   // Combiner Rule #170: fabs_fneg_fold
     /* 5927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 5930 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5932 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 5936 */   GIR_EraseRootFromParent_Done,
     /* 5937 */ // Label 393: @5937
     /* 5937 */ GIM_Reject,
     /* 5938 */ // Label 76: @5938
     /* 5938 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(5967), // Rule ID 20 //
     /* 5943 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 5946 */   // MIs[0] dst
     /* 5946 */   // No operand predicates
     /* 5946 */   // MIs[0] src
     /* 5946 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 5954 */   // MIs[1] __idempotent_prop_match_0.x
     /* 5954 */   // No operand predicates
     /* 5954 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5959 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5961 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 5961 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5966 */   GIR_EraseRootFromParent_Done,
     /* 5967 */ // Label 394: @5967
     /* 5967 */ GIM_Reject,
     /* 5968 */ // Label 77: @5968
     /* 5968 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(5979), // Rule ID 193 //
     /* 5973 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 5976 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 5976 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 5979 */ // Label 395: @5979
     /* 5979 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(5990), // Rule ID 301 //
     /* 5984 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5987 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 5987 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5990 */ // Label 396: @5990
     /* 5990 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(6001), // Rule ID 331 //
     /* 5995 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5998 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 5998 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6001 */ // Label 397: @6001
     /* 6001 */ GIM_Reject,
     /* 6002 */ // Label 78: @6002
     /* 6002 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(6013), // Rule ID 194 //
     /* 6007 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6010 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 6010 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6013 */ // Label 398: @6013
     /* 6013 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(6024), // Rule ID 302 //
     /* 6018 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6021 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 6021 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6024 */ // Label 399: @6024
     /* 6024 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(6035), // Rule ID 332 //
     /* 6029 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6032 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 6032 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6035 */ // Label 400: @6035
     /* 6035 */ GIM_Reject,
     /* 6036 */ // Label 79: @6036
     /* 6036 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(6047), // Rule ID 333 //
     /* 6041 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6044 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 6044 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6047 */ // Label 401: @6047
     /* 6047 */ GIM_Reject,
     /* 6048 */ // Label 80: @6048
     /* 6048 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(6059), // Rule ID 334 //
     /* 6053 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6056 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 6056 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6059 */ // Label 402: @6059
     /* 6059 */ GIM_Reject,
     /* 6060 */ // Label 81: @6060
     /* 6060 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(6071), // Rule ID 195 //
     /* 6065 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6068 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 6068 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6071 */ // Label 403: @6071
     /* 6071 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(6082), // Rule ID 303 //
     /* 6076 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6079 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 6079 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6082 */ // Label 404: @6082
     /* 6082 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(6093), // Rule ID 335 //
     /* 6087 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6090 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 6090 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6093 */ // Label 405: @6093
     /* 6093 */ GIM_Reject,
     /* 6094 */ // Label 82: @6094
     /* 6094 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(6105), // Rule ID 196 //
     /* 6099 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6102 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 6102 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6105 */ // Label 406: @6105
     /* 6105 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(6116), // Rule ID 304 //
     /* 6110 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6113 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 6113 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6116 */ // Label 407: @6116
     /* 6116 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(6127), // Rule ID 336 //
     /* 6121 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6124 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 6124 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6127 */ // Label 408: @6127
     /* 6127 */ GIM_Reject,
     /* 6128 */ // Label 83: @6128
     /* 6128 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(6139), // Rule ID 148 //
     /* 6133 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 6136 */   // Combiner Rule #106: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 6136 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 6139 */ // Label 409: @6139
     /* 6139 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(6150), // Rule ID 150 //
     /* 6144 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 6147 */   // Combiner Rule #108: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 6147 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 6150 */ // Label 410: @6150
     /* 6150 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(6161), // Rule ID 183 //
     /* 6155 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 6158 */   // Combiner Rule #141: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 6158 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 6161 */ // Label 411: @6161
     /* 6161 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(6172), // Rule ID 199 //
     /* 6166 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 6169 */   // Combiner Rule #149: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 6169 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 6172 */ // Label 412: @6172
     /* 6172 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(6183), // Rule ID 232 //
     /* 6177 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6180 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 6180 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6183 */ // Label 413: @6183
     /* 6183 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(6194), // Rule ID 281 //
     /* 6188 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6191 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 6191 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6194 */ // Label 414: @6194
     /* 6194 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(6217), // Rule ID 111 //
     /* 6199 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 6202 */   // MIs[0] dst
     /* 6202 */   // No operand predicates
     /* 6202 */   // MIs[0] lhs
     /* 6202 */   // No operand predicates
     /* 6202 */   // MIs[0] Operand 2
     /* 6202 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 6206 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6211 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 6211 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6216 */   GIR_EraseRootFromParent_Done,
     /* 6217 */ // Label 415: @6217
     /* 6217 */ GIM_Reject,
     /* 6218 */ // Label 84: @6218
     /* 6218 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(6229), // Rule ID 245 //
     /* 6223 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6226 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 6226 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6229 */ // Label 416: @6229
     /* 6229 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(6240), // Rule ID 292 //
     /* 6234 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6237 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 6237 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6240 */ // Label 417: @6240
     /* 6240 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(6251), // Rule ID 313 //
     /* 6245 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6248 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 6248 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6251 */ // Label 418: @6251
     /* 6251 */ GIM_Reject,
     /* 6252 */ // Label 85: @6252
     /* 6252 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(6263), // Rule ID 246 //
     /* 6257 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6260 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 6260 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6263 */ // Label 419: @6263
     /* 6263 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(6274), // Rule ID 293 //
     /* 6268 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6271 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 6271 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6274 */ // Label 420: @6274
     /* 6274 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(6285), // Rule ID 314 //
     /* 6279 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6282 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 6282 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6285 */ // Label 421: @6285
     /* 6285 */ GIM_Reject,
     /* 6286 */ // Label 86: @6286
     /* 6286 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(6297), // Rule ID 247 //
     /* 6291 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6294 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 6294 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6297 */ // Label 422: @6297
     /* 6297 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(6308), // Rule ID 294 //
     /* 6302 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6305 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 6305 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6308 */ // Label 423: @6308
     /* 6308 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(6319), // Rule ID 315 //
     /* 6313 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6316 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 6316 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6319 */ // Label 424: @6319
     /* 6319 */ GIM_Reject,
     /* 6320 */ // Label 87: @6320
     /* 6320 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(6331), // Rule ID 248 //
     /* 6325 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6328 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 6328 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6331 */ // Label 425: @6331
     /* 6331 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(6342), // Rule ID 295 //
     /* 6336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6339 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 6339 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6342 */ // Label 426: @6342
     /* 6342 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(6353), // Rule ID 316 //
     /* 6347 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6350 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 6350 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6353 */ // Label 427: @6353
     /* 6353 */ GIM_Reject,
     /* 6354 */ // Label 88: @6354
     /* 6354 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(6365), // Rule ID 86 //
     /* 6359 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 6362 */   // Combiner Rule #76: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 6362 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 6365 */ // Label 428: @6365
     /* 6365 */ GIM_Reject,
     /* 6366 */ // Label 89: @6366
     /* 6366 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(6377), // Rule ID 175 //
     /* 6371 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 6374 */   // Combiner Rule #133: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 6374 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 6377 */ // Label 429: @6377
     /* 6377 */ GIM_Reject,
     /* 6378 */ // Label 90: @6378
     /* 6378 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(6389), // Rule ID 26 //
     /* 6383 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 6386 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6386 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 6389 */ // Label 430: @6389
     /* 6389 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(6400), // Rule ID 67 //
     /* 6394 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 6397 */   // Combiner Rule #65: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6397 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 6400 */ // Label 431: @6400
     /* 6400 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(6411), // Rule ID 101 //
     /* 6405 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6408 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6408 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6411 */ // Label 432: @6411
     /* 6411 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(6450), // Rule ID 38 //
     /* 6416 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 6419 */   // MIs[0] root
     /* 6419 */   // No operand predicates
     /* 6419 */   // MIs[0] src
     /* 6419 */   // No operand predicates
     /* 6419 */   // MIs[0] elt
     /* 6419 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6423 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 6427 */   // MIs[1] src
     /* 6427 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 6432 */   // MIs[1] idx
     /* 6432 */   // No operand predicates
     /* 6432 */   // MIs[0] idx
     /* 6432 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 6437 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6442 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6444 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 6444 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6449 */   GIR_EraseRootFromParent_Done,
     /* 6450 */ // Label 433: @6450
     /* 6450 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(6483), // Rule ID 24 //
     /* 6455 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 6458 */   // MIs[0] root
     /* 6458 */   // No operand predicates
     /* 6458 */   // MIs[0] src
     /* 6458 */   // No operand predicates
     /* 6458 */   // MIs[0] elt
     /* 6458 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6462 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6466 */   // MIs[0] idx
     /* 6466 */   // No operand predicates
     /* 6466 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 6470 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6475 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6477 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 6477 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6482 */   GIR_EraseRootFromParent_Done,
     /* 6483 */ // Label 434: @6483
     /* 6483 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(6507), // Rule ID 23 //
     /* 6488 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 6491 */   // MIs[0] root
     /* 6491 */   // No operand predicates
     /* 6491 */   // MIs[0] src
     /* 6491 */   // No operand predicates
     /* 6491 */   // MIs[0] elt
     /* 6491 */   // No operand predicates
     /* 6491 */   // MIs[0] idx
     /* 6491 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 6495 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6499 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6501 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 6501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6504 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6506 */   GIR_EraseRootFromParent_Done,
     /* 6507 */ // Label 435: @6507
     /* 6507 */ GIM_Reject,
     /* 6508 */ // Label 91: @6508
     /* 6508 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(6519), // Rule ID 25 //
     /* 6513 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 6516 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6516 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 6519 */ // Label 436: @6519
     /* 6519 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(6530), // Rule ID 68 //
     /* 6524 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 6527 */   // Combiner Rule #66: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6527 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 6530 */ // Label 437: @6530
     /* 6530 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(6541), // Rule ID 74 //
     /* 6535 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 6538 */   // Combiner Rule #70: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6538 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 6541 */ // Label 438: @6541
     /* 6541 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(6552), // Rule ID 102 //
     /* 6546 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6549 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6549 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6552 */ // Label 439: @6552
     /* 6552 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(6576), // Rule ID 36 //
     /* 6557 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 6560 */   // MIs[0] root
     /* 6560 */   // No operand predicates
     /* 6560 */   // MIs[0] src
     /* 6560 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6564 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6568 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 6571 */   // MIs[1] x
     /* 6571 */   // No operand predicates
     /* 6571 */   // MIs[1] y
     /* 6571 */   // No operand predicates
     /* 6571 */   // MIs[1] z
     /* 6571 */   // No operand predicates
     /* 6571 */   // MIs[1] a
     /* 6571 */   // No operand predicates
     /* 6571 */   // MIs[1] b
     /* 6571 */   // No operand predicates
     /* 6571 */   // MIs[1] c
     /* 6571 */   // No operand predicates
     /* 6571 */   // MIs[1] d
     /* 6571 */   // No operand predicates
     /* 6571 */   // MIs[1] e
     /* 6571 */   // No operand predicates
     /* 6571 */   // MIs[0] idx
     /* 6571 */   // No operand predicates
     /* 6571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6573 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 6573 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6576 */ // Label 440: @6576
     /* 6576 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(6600), // Rule ID 35 //
     /* 6581 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 6584 */   // MIs[0] root
     /* 6584 */   // No operand predicates
     /* 6584 */   // MIs[0] src
     /* 6584 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6588 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6592 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 6595 */   // MIs[1] x
     /* 6595 */   // No operand predicates
     /* 6595 */   // MIs[1] y
     /* 6595 */   // No operand predicates
     /* 6595 */   // MIs[1] z
     /* 6595 */   // No operand predicates
     /* 6595 */   // MIs[1] a
     /* 6595 */   // No operand predicates
     /* 6595 */   // MIs[1] b
     /* 6595 */   // No operand predicates
     /* 6595 */   // MIs[1] c
     /* 6595 */   // No operand predicates
     /* 6595 */   // MIs[1] d
     /* 6595 */   // No operand predicates
     /* 6595 */   // MIs[0] idx
     /* 6595 */   // No operand predicates
     /* 6595 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6597 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 6597 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6600 */ // Label 441: @6600
     /* 6600 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(6624), // Rule ID 34 //
     /* 6605 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 6608 */   // MIs[0] root
     /* 6608 */   // No operand predicates
     /* 6608 */   // MIs[0] src
     /* 6608 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6612 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6616 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 6619 */   // MIs[1] x
     /* 6619 */   // No operand predicates
     /* 6619 */   // MIs[1] y
     /* 6619 */   // No operand predicates
     /* 6619 */   // MIs[1] z
     /* 6619 */   // No operand predicates
     /* 6619 */   // MIs[1] a
     /* 6619 */   // No operand predicates
     /* 6619 */   // MIs[1] b
     /* 6619 */   // No operand predicates
     /* 6619 */   // MIs[1] c
     /* 6619 */   // No operand predicates
     /* 6619 */   // MIs[0] idx
     /* 6619 */   // No operand predicates
     /* 6619 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6621 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 6621 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6624 */ // Label 442: @6624
     /* 6624 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(6648), // Rule ID 33 //
     /* 6629 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 6632 */   // MIs[0] root
     /* 6632 */   // No operand predicates
     /* 6632 */   // MIs[0] src
     /* 6632 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6636 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6640 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 6643 */   // MIs[1] x
     /* 6643 */   // No operand predicates
     /* 6643 */   // MIs[1] y
     /* 6643 */   // No operand predicates
     /* 6643 */   // MIs[1] z
     /* 6643 */   // No operand predicates
     /* 6643 */   // MIs[1] a
     /* 6643 */   // No operand predicates
     /* 6643 */   // MIs[1] b
     /* 6643 */   // No operand predicates
     /* 6643 */   // MIs[0] idx
     /* 6643 */   // No operand predicates
     /* 6643 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6645 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 6645 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6648 */ // Label 443: @6648
     /* 6648 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(6672), // Rule ID 32 //
     /* 6653 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 6656 */   // MIs[0] root
     /* 6656 */   // No operand predicates
     /* 6656 */   // MIs[0] src
     /* 6656 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6664 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 6667 */   // MIs[1] x
     /* 6667 */   // No operand predicates
     /* 6667 */   // MIs[1] y
     /* 6667 */   // No operand predicates
     /* 6667 */   // MIs[1] z
     /* 6667 */   // No operand predicates
     /* 6667 */   // MIs[1] a
     /* 6667 */   // No operand predicates
     /* 6667 */   // MIs[0] idx
     /* 6667 */   // No operand predicates
     /* 6667 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6669 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 6669 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6672 */ // Label 444: @6672
     /* 6672 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(6696), // Rule ID 31 //
     /* 6677 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 6680 */   // MIs[0] root
     /* 6680 */   // No operand predicates
     /* 6680 */   // MIs[0] src
     /* 6680 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6684 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6688 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 6691 */   // MIs[1] x
     /* 6691 */   // No operand predicates
     /* 6691 */   // MIs[1] y
     /* 6691 */   // No operand predicates
     /* 6691 */   // MIs[1] z
     /* 6691 */   // No operand predicates
     /* 6691 */   // MIs[0] idx
     /* 6691 */   // No operand predicates
     /* 6691 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6693 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 6693 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6696 */ // Label 445: @6696
     /* 6696 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(6730), // Rule ID 27 //
     /* 6701 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 6704 */   // MIs[0] root
     /* 6704 */   // No operand predicates
     /* 6704 */   // MIs[0] src
     /* 6704 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6712 */   // MIs[1] x
     /* 6712 */   // No operand predicates
     /* 6712 */   // MIs[1] value
     /* 6712 */   // No operand predicates
     /* 6712 */   // MIs[1] idx
     /* 6712 */   // No operand predicates
     /* 6712 */   // MIs[0] idx
     /* 6712 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 6717 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6722 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6724 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 6724 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6729 */   GIR_EraseRootFromParent_Done,
     /* 6730 */ // Label 446: @6730
     /* 6730 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(6751), // Rule ID 28 //
     /* 6735 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 6738 */   // MIs[0] root
     /* 6738 */   // No operand predicates
     /* 6738 */   // MIs[0] src
     /* 6738 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6746 */   // MIs[1] x
     /* 6746 */   // No operand predicates
     /* 6746 */   // MIs[1] value
     /* 6746 */   // No operand predicates
     /* 6746 */   // MIs[1] idx2
     /* 6746 */   // No operand predicates
     /* 6746 */   // MIs[0] idx1
     /* 6746 */   // No operand predicates
     /* 6746 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6748 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 6748 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 6751 */ // Label 447: @6751
     /* 6751 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(6780), // Rule ID 37 //
     /* 6756 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 6759 */   // MIs[0] root
     /* 6759 */   // No operand predicates
     /* 6759 */   // MIs[0] src
     /* 6759 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6763 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 6767 */   // MIs[1] src1
     /* 6767 */   // No operand predicates
     /* 6767 */   // MIs[1] src2
     /* 6767 */   // No operand predicates
     /* 6767 */   // MIs[1] mask
     /* 6767 */   // No operand predicates
     /* 6767 */   // MIs[0] idx
     /* 6767 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6771 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6775 */   // MIs[2] imm
     /* 6775 */   // No operand predicates
     /* 6775 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6777 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 6777 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 6780 */ // Label 448: @6780
     /* 6780 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(6804), // Rule ID 30 //
     /* 6785 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 6788 */   // MIs[0] root
     /* 6788 */   // No operand predicates
     /* 6788 */   // MIs[0] src
     /* 6788 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6792 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6796 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 6799 */   // MIs[1] x
     /* 6799 */   // No operand predicates
     /* 6799 */   // MIs[1] y
     /* 6799 */   // No operand predicates
     /* 6799 */   // MIs[0] idx
     /* 6799 */   // No operand predicates
     /* 6799 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6801 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 6801 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6804 */ // Label 449: @6804
     /* 6804 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(6836), // Rule ID 29 //
     /* 6809 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 6812 */   // MIs[0] root
     /* 6812 */   // No operand predicates
     /* 6812 */   // MIs[0] src
     /* 6812 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 6820 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 6823 */   // MIs[1] unused
     /* 6823 */   // No operand predicates
     /* 6823 */   // MIs[0] idx
     /* 6823 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6827 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6831 */   // MIs[2] imm
     /* 6831 */   // No operand predicates
     /* 6831 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6833 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 6833 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 6836 */ // Label 450: @6836
     /* 6836 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(6860), // Rule ID 21 //
     /* 6841 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 6844 */   // MIs[0] root
     /* 6844 */   // No operand predicates
     /* 6844 */   // MIs[0] vector
     /* 6844 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6848 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6852 */   // MIs[0] idx
     /* 6852 */   // No operand predicates
     /* 6852 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6854 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 6854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6857 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6859 */   GIR_EraseRootFromParent_Done,
     /* 6860 */ // Label 451: @6860
     /* 6860 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(6884), // Rule ID 22 //
     /* 6865 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 6868 */   // MIs[0] root
     /* 6868 */   // No operand predicates
     /* 6868 */   // MIs[0] vector
     /* 6868 */   // No operand predicates
     /* 6868 */   // MIs[0] idx
     /* 6868 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6876 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6878 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 6878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6881 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6883 */   GIR_EraseRootFromParent_Done,
     /* 6884 */ // Label 452: @6884
     /* 6884 */ GIM_Reject,
     /* 6885 */ // Label 92: @6885
     /* 6885 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(6896), // Rule ID 97 //
     /* 6890 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 6893 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6893 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 6896 */ // Label 453: @6896
     /* 6896 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(6907), // Rule ID 99 //
     /* 6901 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 6904 */   // Combiner Rule #80: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6904 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 6907 */ // Label 454: @6907
     /* 6907 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(6918), // Rule ID 344 //
     /* 6912 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 6915 */   // Combiner Rule #199: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6915 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 6918 */ // Label 455: @6918
     /* 6918 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(6929), // Rule ID 346 //
     /* 6923 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 6926 */   // Combiner Rule #201: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6926 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 6929 */ // Label 456: @6929
     /* 6929 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(6950), // Rule ID 345 //
     /* 6934 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 6937 */   // MIs[0] root
     /* 6937 */   // No operand predicates
     /* 6937 */   // MIs[0] src1
     /* 6937 */   // No operand predicates
     /* 6937 */   // MIs[0] undef
     /* 6937 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6945 */   // MIs[0] mask
     /* 6945 */   // No operand predicates
     /* 6945 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6947 */   // Combiner Rule #200: combine_shuffle_undef_rhs
     /* 6947 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 6950 */ // Label 457: @6950
     /* 6950 */ GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(6961), // Rule ID 364 //
     /* 6955 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule217Enabled),
     /* 6958 */   // MIs[0] dst
     /* 6958 */   // No operand predicates
     /* 6958 */   // MIs[0] src1
     /* 6958 */   // No operand predicates
     /* 6958 */   // MIs[0] src2
     /* 6958 */   // No operand predicates
     /* 6958 */   // MIs[0] mask
     /* 6958 */   // No operand predicates
     /* 6958 */   // Combiner Rule #217: combine_shuffle_vector_to_build_vector
     /* 6958 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 6961 */ // Label 458: @6961
     /* 6961 */ GIM_Reject,
     /* 6962 */ // Label 93: @6962
     /* 6962 */ GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(7006), // Rule ID 223 //
     /* 6967 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 6970 */   // MIs[0] d
     /* 6970 */   // No operand predicates
     /* 6970 */   // MIs[0] src
     /* 6970 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6974 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 6978 */   // MIs[1] rev
     /* 6978 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 6982 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 6986 */   // MIs[2] val
     /* 6986 */   // No operand predicates
     /* 6986 */   // MIs[1] amt
     /* 6986 */   // No operand predicates
     /* 6986 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner9),
     /* 6990 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6992 */   // Combiner Rule #160: bitreverse_lshr
     /* 6992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 6995 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 6997 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7001 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7005 */   GIR_EraseRootFromParent_Done,
     /* 7006 */ // Label 459: @7006
     /* 7006 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(7050), // Rule ID 222 //
     /* 7011 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 7014 */   // MIs[0] d
     /* 7014 */   // No operand predicates
     /* 7014 */   // MIs[0] src
     /* 7014 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7018 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 7022 */   // MIs[1] rev
     /* 7022 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 7026 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 7030 */   // MIs[2] val
     /* 7030 */   // No operand predicates
     /* 7030 */   // MIs[1] amt
     /* 7030 */   // No operand predicates
     /* 7030 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 7034 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7036 */   // Combiner Rule #159: bitreverse_shl
     /* 7036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7039 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7041 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7045 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7049 */   GIR_EraseRootFromParent_Done,
     /* 7050 */ // Label 460: @7050
     /* 7050 */ GIM_Reject,
     /* 7051 */ // Label 94: @7051
     /* 7051 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(7072), // Rule ID 178 //
     /* 7056 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 7059 */   // MIs[0] dst
     /* 7059 */   // No operand predicates
     /* 7059 */   // MIs[0] src0
     /* 7059 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 7067 */   // MIs[1] cst
     /* 7067 */   // No operand predicates
     /* 7067 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7069 */   // Combiner Rule #136: constant_fold_fsqrt
     /* 7069 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 7072 */ // Label 461: @7072
     /* 7072 */ GIM_Reject,
     /* 7073 */ // Label 95: @7073
     /* 7073 */ GIM_Reject,
     /* 7074 */ }; // Size: 7074 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

