/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the PPC target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 41;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(PPCInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(PPCInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static PPCInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static PPCInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s1,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s64,
  GILLT_v4s32,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_v256s1,
  GILLT_v512s1,
  GILLT_v1024s1,
};
const static size_t NumTypeObjects = 11;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getFixed(256), 1),
  LLT::vector(ElementCount::getFixed(512), 1),
  LLT::vector(ElementCount::getFixed(1024), 1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_In32BitModeBit = 1,
  Feature_In64BitModeBit = 9,
  Feature_HasOnlyMSYNCBit = 23,
  Feature_HasSYNCBit = 22,
  Feature_HasSPEBit = 8,
  Feature_HasICBTBit = 21,
  Feature_HasBPERMDBit = 10,
  Feature_HasExtDivBit = 3,
  Feature_IsISA2_06Bit = 11,
  Feature_IsISA2_07Bit = 40,
  Feature_IsISA3_0Bit = 2,
  Feature_HasFPUBit = 0,
  Feature_PCRelativeMemopsBit = 37,
  Feature_IsNotISA3_1Bit = 39,
  Feature_IsAIXBit = 24,
  Feature_NotAIXBit = 25,
  Feature_IsISAFutureBit = 18,
  Feature_IsNotISAFutureBit = 19,
  Feature_HasAltivecBit = 4,
  Feature_HasP8AltivecBit = 5,
  Feature_HasP8CryptoBit = 6,
  Feature_HasP9AltivecBit = 7,
  Feature_HasVSXBit = 12,
  Feature_IsLittleEndianBit = 26,
  Feature_IsBigEndianBit = 27,
  Feature_IsPPC64Bit = 31,
  Feature_HasOnlySwappingMemOpsBit = 29,
  Feature_NoP8VectorBit = 30,
  Feature_HasP8VectorBit = 13,
  Feature_HasDirectMoveBit = 14,
  Feature_NoP9VectorBit = 28,
  Feature_HasP9VectorBit = 15,
  Feature_NoP9AltivecBit = 32,
  Feature_NoP10VectorBit = 33,
  Feature_HasP10VectorBit = 36,
  Feature_HasHTMBit = 34,
  Feature_MMABit = 20,
  Feature_IsPPC32Bit = 38,
  Feature_PrefixInstrsBit = 16,
  Feature_IsISA3_1Bit = 17,
  Feature_PairedVectorMemopsBit = 35,
};

PredicateBitset PPCInstructionSelector::
computeAvailableModuleFeatures(const PPCSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!Subtarget->isPPC64())
    Features.set(Feature_In32BitModeBit);
  if (Subtarget->isPPC64())
    Features.set(Feature_In64BitModeBit);
  if (Subtarget->hasOnlyMSYNC())
    Features.set(Feature_HasOnlyMSYNCBit);
  if (!Subtarget->hasOnlyMSYNC())
    Features.set(Feature_HasSYNCBit);
  if (Subtarget->hasSPE())
    Features.set(Feature_HasSPEBit);
  if (Subtarget->hasICBT())
    Features.set(Feature_HasICBTBit);
  if (Subtarget->hasBPERMD())
    Features.set(Feature_HasBPERMDBit);
  if (Subtarget->hasExtDiv())
    Features.set(Feature_HasExtDivBit);
  if (Subtarget->isISA2_06())
    Features.set(Feature_IsISA2_06Bit);
  if (Subtarget->isISA2_07())
    Features.set(Feature_IsISA2_07Bit);
  if (Subtarget->isISA3_0())
    Features.set(Feature_IsISA3_0Bit);
  if (Subtarget->hasFPU())
    Features.set(Feature_HasFPUBit);
  if (Subtarget->hasPCRelativeMemops())
    Features.set(Feature_PCRelativeMemopsBit);
  if (!Subtarget->isISA3_1())
    Features.set(Feature_IsNotISA3_1Bit);
  if (Subtarget->isAIXABI())
    Features.set(Feature_IsAIXBit);
  if (!Subtarget->isAIXABI())
    Features.set(Feature_NotAIXBit);
  if (Subtarget->isISAFuture())
    Features.set(Feature_IsISAFutureBit);
  if (!Subtarget->isISAFuture())
    Features.set(Feature_IsNotISAFutureBit);
  if (Subtarget->hasAltivec())
    Features.set(Feature_HasAltivecBit);
  if (Subtarget->hasP8Altivec())
    Features.set(Feature_HasP8AltivecBit);
  if (Subtarget->hasP8Crypto())
    Features.set(Feature_HasP8CryptoBit);
  if (Subtarget->hasP9Altivec())
    Features.set(Feature_HasP9AltivecBit);
  if (Subtarget->hasVSX())
    Features.set(Feature_HasVSXBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLittleEndianBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBigEndianBit);
  if (Subtarget->isPPC64())
    Features.set(Feature_IsPPC64Bit);
  if (!Subtarget->hasP9Vector())
    Features.set(Feature_HasOnlySwappingMemOpsBit);
  if (!Subtarget->hasP8Vector())
    Features.set(Feature_NoP8VectorBit);
  if (Subtarget->hasP8Vector())
    Features.set(Feature_HasP8VectorBit);
  if (Subtarget->hasDirectMove())
    Features.set(Feature_HasDirectMoveBit);
  if (!Subtarget->hasP9Vector())
    Features.set(Feature_NoP9VectorBit);
  if (Subtarget->hasP9Vector())
    Features.set(Feature_HasP9VectorBit);
  if (!Subtarget->hasP9Altivec())
    Features.set(Feature_NoP9AltivecBit);
  if (!Subtarget->hasP10Vector())
    Features.set(Feature_NoP10VectorBit);
  if (Subtarget->hasP10Vector())
    Features.set(Feature_HasP10VectorBit);
  if (Subtarget->hasHTM())
    Features.set(Feature_HasHTMBit);
  if (Subtarget->hasMMA())
    Features.set(Feature_MMABit);
  if (!Subtarget->isPPC64())
    Features.set(Feature_IsPPC32Bit);
  if (Subtarget->hasPrefixInstrs())
    Features.set(Feature_PrefixInstrsBit);
  if (Subtarget->isISA3_1())
    Features.set(Feature_IsISA3_1Bit);
  if (Subtarget->pairedVectorMemops())
    Features.set(Feature_PairedVectorMemopsBit);
  return Features;
}

void PPCInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const PPCSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset PPCInstructionSelector::
computeAvailableFunctionFeatures(const PPCSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAltivec,
  GIFBS_HasBPERMD,
  GIFBS_HasExtDiv,
  GIFBS_HasFPU,
  GIFBS_HasHTM,
  GIFBS_HasOnlyMSYNC,
  GIFBS_HasP8Altivec,
  GIFBS_HasP8Crypto,
  GIFBS_HasP9Altivec,
  GIFBS_HasSPE,
  GIFBS_HasSYNC,
  GIFBS_HasVSX,
  GIFBS_In32BitMode,
  GIFBS_In64BitMode,
  GIFBS_IsAIX,
  GIFBS_IsISA3_0,
  GIFBS_IsISA3_1,
  GIFBS_IsISAFuture,
  GIFBS_IsNotISA3_1,
  GIFBS_NotAIX,
  GIFBS_PairedVectorMemops,
  GIFBS_HasDirectMove_HasVSX,
  GIFBS_HasFPU_IsISA3_1,
  GIFBS_HasP10Vector_PrefixInstrs,
  GIFBS_HasP8Altivec_HasVSX,
  GIFBS_HasP8Vector_HasVSX,
  GIFBS_HasP9Vector_HasVSX,
  GIFBS_HasVSX_IsISA3_1,
  GIFBS_In64BitMode_IsISA3_0,
  GIFBS_IsISAFuture_MMA,
  GIFBS_IsNotISAFuture_MMA,
  GIFBS_HasP8Altivec_HasVSX_IsBigEndian,
  GIFBS_HasP8Altivec_HasVSX_IsLittleEndian,
  GIFBS_IsISAFuture_MMA_PrefixInstrs,
  GIFBS_IsNotISAFuture_MMA_PrefixInstrs,
  GIFBS_HasDirectMove_HasVSX_IsISA3_0_IsLittleEndian,
  GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector,
  GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32,
  GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsISA3_0_IsPPC64,
  GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAltivecBit, },
  {Feature_HasBPERMDBit, },
  {Feature_HasExtDivBit, },
  {Feature_HasFPUBit, },
  {Feature_HasHTMBit, },
  {Feature_HasOnlyMSYNCBit, },
  {Feature_HasP8AltivecBit, },
  {Feature_HasP8CryptoBit, },
  {Feature_HasP9AltivecBit, },
  {Feature_HasSPEBit, },
  {Feature_HasSYNCBit, },
  {Feature_HasVSXBit, },
  {Feature_In32BitModeBit, },
  {Feature_In64BitModeBit, },
  {Feature_IsAIXBit, },
  {Feature_IsISA3_0Bit, },
  {Feature_IsISA3_1Bit, },
  {Feature_IsISAFutureBit, },
  {Feature_IsNotISA3_1Bit, },
  {Feature_NotAIXBit, },
  {Feature_PairedVectorMemopsBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, },
  {Feature_HasFPUBit, Feature_IsISA3_1Bit, },
  {Feature_HasP10VectorBit, Feature_PrefixInstrsBit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, },
  {Feature_HasP8VectorBit, Feature_HasVSXBit, },
  {Feature_HasP9VectorBit, Feature_HasVSXBit, },
  {Feature_HasVSXBit, Feature_IsISA3_1Bit, },
  {Feature_In64BitModeBit, Feature_IsISA3_0Bit, },
  {Feature_IsISAFutureBit, Feature_MMABit, },
  {Feature_IsNotISAFutureBit, Feature_MMABit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, Feature_IsBigEndianBit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, Feature_IsLittleEndianBit, },
  {Feature_IsISAFutureBit, Feature_MMABit, Feature_PrefixInstrsBit, },
  {Feature_IsNotISAFutureBit, Feature_MMABit, Feature_PrefixInstrsBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsISA3_0Bit, Feature_IsLittleEndianBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsLittleEndianBit, Feature_NoP9VectorBit, },
  {Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsISA3_1Bit, Feature_IsPPC32Bit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsISA3_0Bit, Feature_IsPPC64Bit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsPPC64Bit, Feature_NoP9VectorBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

PPCInstructionSelector::ComplexMatcherMemFn
PPCInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool PPCInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_Msk2Imm = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_Msk4Imm,
  GICXXPred_I64_Predicate_Msk8Imm,
  GICXXPred_I64_Predicate_i32immNonAllOneNonZero,
  GICXXPred_I64_Predicate_imm32SExt16,
  GICXXPred_I64_Predicate_imm64SExt16,
  GICXXPred_I64_Predicate_imm64ZExt32,
  GICXXPred_I64_Predicate_immNonAllOneAnyExt8,
  GICXXPred_I64_Predicate_immSExt5NonZero,
};
bool PPCInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_Msk2Imm: {
     return isUInt<2>(Imm); 
  }
  case GICXXPred_I64_Predicate_Msk4Imm: {
     return isUInt<4>(Imm); 
  }
  case GICXXPred_I64_Predicate_Msk8Imm: {
     return isUInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i32immNonAllOneNonZero: {
     return Imm && (Imm != -1); 
  }
  case GICXXPred_I64_Predicate_imm32SExt16: {
    
      // imm32SExt16 predicate - True if the i32 immediate fits in a 16-bit
      // sign extended field.  Used by instructions like 'addi'.
      return (int32_t)Imm == (short)Imm;
    
    llvm_unreachable("imm32SExt16 should have returned");
  }
  case GICXXPred_I64_Predicate_imm64SExt16: {
    
      // imm64SExt16 predicate - True if the i64 immediate fits in a 16-bit
      // sign extended field.  Used by instructions like 'addi'.
      return (int64_t)Imm == (short)Imm;
    
    llvm_unreachable("imm64SExt16 should have returned");
  }
  case GICXXPred_I64_Predicate_imm64ZExt32: {
    
      // imm64ZExt32 predicate - True if the i64 immediate fits in a 32-bit
      // zero extended field.
      return isUInt<32>(Imm);
    
    llvm_unreachable("imm64ZExt32 should have returned");
  }
  case GICXXPred_I64_Predicate_immNonAllOneAnyExt8: {
    
      return (isInt<8>(Imm) && (Imm != -1)) || (isUInt<8>(Imm) && (Imm != 0xFF));
    
  }
  case GICXXPred_I64_Predicate_immSExt5NonZero: {
     return Imm && isInt<5>(Imm); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool PPCInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool PPCInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool PPCInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("PPCInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
PPCInstructionSelector::CustomRendererFn
PPCInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool PPCInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool PPCInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("PPCInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *PPCInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(289), /*)*//*default:*//*Label 83*/ GIMT_Encode4(211165),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(954),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(1363),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(1804),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(2086),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(2242),
     /*     30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(2398),
     /*     34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(2560), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(2722),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(5283),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(48425), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 10*/ GIMT_Encode4(57532), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 11*/ GIMT_Encode4(58499), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 12*/ GIMT_Encode4(60776),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 13*/ GIMT_Encode4(61051),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 14*/ GIMT_Encode4(61301),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 15*/ GIMT_Encode4(61432), GIMT_Encode4(0),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 16*/ GIMT_Encode4(61563), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 17*/ GIMT_Encode4(61583), GIMT_Encode4(0),
     /*    302 */ /*TargetOpcode::G_BRCOND*//*Label 18*/ GIMT_Encode4(61708), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 19*/ GIMT_Encode4(61771),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 20*/ GIMT_Encode4(90891), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 21*/ GIMT_Encode4(93783),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 22*/ GIMT_Encode4(114539),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 23*/ GIMT_Encode4(114725), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 24*/ GIMT_Encode4(114877),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 25*/ GIMT_Encode4(129909),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 26*/ GIMT_Encode4(130262),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 27*/ GIMT_Encode4(151732),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 28*/ GIMT_Encode4(152088),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 29*/ GIMT_Encode4(152510), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    390 */ /*TargetOpcode::G_ROTL*//*Label 30*/ GIMT_Encode4(152880),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 31*/ GIMT_Encode4(153188),
     /*    398 */ /*TargetOpcode::G_FCMP*//*Label 32*/ GIMT_Encode4(157190), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 33*/ GIMT_Encode4(160641), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 34*/ GIMT_Encode4(161765),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 35*/ GIMT_Encode4(161895),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 36*/ GIMT_Encode4(162025),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 37*/ GIMT_Encode4(162127),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 38*/ GIMT_Encode4(162229),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 39*/ GIMT_Encode4(162331), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 40*/ GIMT_Encode4(162433),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 41*/ GIMT_Encode4(162728),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 42*/ GIMT_Encode4(163023),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 43*/ GIMT_Encode4(163373), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 44*/ GIMT_Encode4(163954), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 45*/ GIMT_Encode4(164224),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 46*/ GIMT_Encode4(166695),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 47*/ GIMT_Encode4(166859),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 48*/ GIMT_Encode4(167016),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 49*/ GIMT_Encode4(167279),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 50*/ GIMT_Encode4(167542),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 51*/ GIMT_Encode4(167789), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 52*/ GIMT_Encode4(168036),
     /*    626 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 53*/ GIMT_Encode4(168328), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 54*/ GIMT_Encode4(168644),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 55*/ GIMT_Encode4(168724),
     /*    646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 56*/ GIMT_Encode4(168804),
     /*    650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 57*/ GIMT_Encode4(169386), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 58*/ GIMT_Encode4(169968),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 59*/ GIMT_Encode4(170148),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 60*/ GIMT_Encode4(170328),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 61*/ GIMT_Encode4(170508), GIMT_Encode4(0),
     /*    722 */ /*TargetOpcode::G_LROUND*//*Label 62*/ GIMT_Encode4(170688),
     /*    726 */ /*TargetOpcode::G_LLROUND*//*Label 63*/ GIMT_Encode4(170990),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 64*/ GIMT_Encode4(171155), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 65*/ GIMT_Encode4(171171), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTTZ*//*Label 66*/ GIMT_Encode4(171289), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 67*/ GIMT_Encode4(171467), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 68*/ GIMT_Encode4(171639),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 69*/ GIMT_Encode4(171811),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 70*/ GIMT_Encode4(172075),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 71*/ GIMT_Encode4(208081), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 72*/ GIMT_Encode4(208356),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 73*/ GIMT_Encode4(208573),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 74*/ GIMT_Encode4(208848),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 75*/ GIMT_Encode4(209060), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 76*/ GIMT_Encode4(209297),
     /*    894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 77*/ GIMT_Encode4(209567),
     /*    898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 78*/ GIMT_Encode4(209837),
     /*    902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 79*/ GIMT_Encode4(210107), GIMT_Encode4(0),
     /*    910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 80*/ GIMT_Encode4(210377),
     /*    914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 81*/ GIMT_Encode4(210935), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 82*/ GIMT_Encode4(211152),
     /*    954 */ // Label 0: @954
     /*    954 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 92*/ GIMT_Encode4(1362),
     /*    965 */ /*GILLT_s1*//*Label 84*/ GIMT_Encode4(997),
     /*    969 */ /*GILLT_s32*//*Label 85*/ GIMT_Encode4(1020),
     /*    973 */ /*GILLT_s64*//*Label 86*/ GIMT_Encode4(1080),
     /*    977 */ /*GILLT_s128*//*Label 87*/ GIMT_Encode4(1140),
     /*    981 */ /*GILLT_v2s64*//*Label 88*/ GIMT_Encode4(1166),
     /*    985 */ /*GILLT_v4s32*//*Label 89*/ GIMT_Encode4(1192),
     /*    989 */ /*GILLT_v8s16*//*Label 90*/ GIMT_Encode4(1218),
     /*    993 */ /*GILLT_v16s8*//*Label 91*/ GIMT_Encode4(1336),
     /*    997 */ // Label 84: @997
     /*    997 */ GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1019), // Rule ID 3661 //
     /*   1002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   1005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1012 */   // (add:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*   1017 */   GIR_RootConstrainSelectedInstOperands,
     /*   1018 */   // GIR_Coverage, 3661,
     /*   1018 */   GIR_Done,
     /*   1019 */ // Label 93: @1019
     /*   1019 */ GIM_Reject,
     /*   1020 */ // Label 85: @1020
     /*   1020 */ GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1079),
     /*   1025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1035 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1066), // Rule ID 107 //
     /*   1040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1052 */     // MIs[1] Operand 1
     /*   1052 */     // No operand predicates
     /*   1052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1054 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D)  =>  (ADDI:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] }):$D)
     /*   1054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*   1057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1059 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1064 */     GIR_RootConstrainSelectedInstOperands,
     /*   1065 */     // GIR_Coverage, 107,
     /*   1065 */     GIR_EraseRootFromParent_Done,
     /*   1066 */   // Label 95: @1066
     /*   1066 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1078), // Rule ID 199 //
     /*   1071 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (ADD4:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ADD4),
     /*   1076 */     GIR_RootConstrainSelectedInstOperands,
     /*   1077 */     // GIR_Coverage, 199,
     /*   1077 */     GIR_Done,
     /*   1078 */   // Label 96: @1078
     /*   1078 */   GIM_Reject,
     /*   1079 */ // Label 94: @1079
     /*   1079 */ GIM_Reject,
     /*   1080 */ // Label 86: @1080
     /*   1080 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1139),
     /*   1085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1095 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1126), // Rule ID 659 //
     /*   1100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1112 */     // MIs[1] Operand 1
     /*   1112 */     // No operand predicates
     /*   1112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1114 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D)  =>  (ADDI8:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] }):$D)
     /*   1114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*   1117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1119 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1124 */     GIR_RootConstrainSelectedInstOperands,
     /*   1125 */     // GIR_Coverage, 659,
     /*   1125 */     GIR_EraseRootFromParent_Done,
     /*   1126 */   // Label 98: @1126
     /*   1126 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1138), // Rule ID 655 //
     /*   1131 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (ADD8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ADD8),
     /*   1136 */     GIR_RootConstrainSelectedInstOperands,
     /*   1137 */     // GIR_Coverage, 655,
     /*   1137 */     GIR_Done,
     /*   1138 */   // Label 99: @1138
     /*   1138 */   GIM_Reject,
     /*   1139 */ // Label 97: @1139
     /*   1139 */ GIM_Reject,
     /*   1140 */ // Label 87: @1140
     /*   1140 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1165), // Rule ID 470 //
     /*   1145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   1151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   1154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1158 */   // (add:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VADDUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   1158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUQM),
     /*   1163 */   GIR_RootConstrainSelectedInstOperands,
     /*   1164 */   // GIR_Coverage, 470,
     /*   1164 */   GIR_Done,
     /*   1165 */ // Label 100: @1165
     /*   1165 */ GIM_Reject,
     /*   1166 */ // Label 88: @1166
     /*   1166 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1191), // Rule ID 469 //
     /*   1171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   1180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1184 */   // (add:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VADDUDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   1184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUDM),
     /*   1189 */   GIR_RootConstrainSelectedInstOperands,
     /*   1190 */   // GIR_Coverage, 469,
     /*   1190 */   GIR_Done,
     /*   1191 */ // Label 101: @1191
     /*   1191 */ GIM_Reject,
     /*   1192 */ // Label 89: @1192
     /*   1192 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1217), // Rule ID 303 //
     /*   1197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   1203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   1206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1210 */   // (add:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   1210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUWM),
     /*   1215 */   GIR_RootConstrainSelectedInstOperands,
     /*   1216 */   // GIR_Coverage, 303,
     /*   1216 */   GIR_Done,
     /*   1217 */ // Label 102: @1217
     /*   1217 */ GIM_Reject,
     /*   1218 */ // Label 90: @1218
     /*   1218 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1335),
     /*   1223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1233 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1276), // Rule ID 1290 //
     /*   1238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   1249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1259 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB), v8i16:{ *:[v8i16] }:$vC)  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vC)
     /*   1259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   1262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   1268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   1272 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   1274 */     GIR_RootConstrainSelectedInstOperands,
     /*   1275 */     // GIR_Coverage, 1290,
     /*   1275 */     GIR_EraseRootFromParent_Done,
     /*   1276 */   // Label 104: @1276
     /*   1276 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1319), // Rule ID 4936 //
     /*   1281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   1292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1302 */     // (add:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vC, (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB))  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vC)
     /*   1302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   1305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   1311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   1315 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   1317 */     GIR_RootConstrainSelectedInstOperands,
     /*   1318 */     // GIR_Coverage, 4936,
     /*   1318 */     GIR_EraseRootFromParent_Done,
     /*   1319 */   // Label 105: @1319
     /*   1319 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1334), // Rule ID 302 //
     /*   1324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1327 */     // (add:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*   1327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUHM),
     /*   1332 */     GIR_RootConstrainSelectedInstOperands,
     /*   1333 */     // GIR_Coverage, 302,
     /*   1333 */     GIR_Done,
     /*   1334 */   // Label 106: @1334
     /*   1334 */   GIM_Reject,
     /*   1335 */ // Label 103: @1335
     /*   1335 */ GIM_Reject,
     /*   1336 */ // Label 91: @1336
     /*   1336 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1361), // Rule ID 301 //
     /*   1341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   1347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   1350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1354 */   // (add:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDUBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*   1354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUBM),
     /*   1359 */   GIR_RootConstrainSelectedInstOperands,
     /*   1360 */   // GIR_Coverage, 301,
     /*   1360 */   GIR_Done,
     /*   1361 */ // Label 107: @1361
     /*   1361 */ GIM_Reject,
     /*   1362 */ // Label 92: @1362
     /*   1362 */ GIM_Reject,
     /*   1363 */ // Label 1: @1363
     /*   1363 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 116*/ GIMT_Encode4(1803),
     /*   1374 */ /*GILLT_s1*//*Label 108*/ GIMT_Encode4(1406),
     /*   1378 */ /*GILLT_s32*//*Label 109*/ GIMT_Encode4(1429),
     /*   1382 */ /*GILLT_s64*//*Label 110*/ GIMT_Encode4(1514),
     /*   1386 */ /*GILLT_s128*//*Label 111*/ GIMT_Encode4(1599),
     /*   1390 */ /*GILLT_v2s64*//*Label 112*/ GIMT_Encode4(1625),
     /*   1394 */ /*GILLT_v4s32*//*Label 113*/ GIMT_Encode4(1688),
     /*   1398 */ /*GILLT_v8s16*//*Label 114*/ GIMT_Encode4(1751),
     /*   1402 */ /*GILLT_v16s8*//*Label 115*/ GIMT_Encode4(1777),
     /*   1406 */ // Label 108: @1406
     /*   1406 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1428), // Rule ID 3662 //
     /*   1411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   1414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1421 */   // (sub:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*   1426 */   GIR_RootConstrainSelectedInstOperands,
     /*   1427 */   // GIR_Coverage, 3662,
     /*   1427 */   GIR_Done,
     /*   1428 */ // Label 117: @1428
     /*   1428 */ GIM_Reject,
     /*   1429 */ // Label 109: @1429
     /*   1429 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1513),
     /*   1434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1444 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1462), // Rule ID 211 //
     /*   1449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   1453 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$RA)  =>  (NEG:{ *:[i32] } i32:{ *:[i32] }:$RA)
     /*   1453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*   1456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1458 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1460 */     GIR_RootConstrainSelectedInstOperands,
     /*   1461 */     // GIR_Coverage, 211,
     /*   1461 */     GIR_EraseRootFromParent_Done,
     /*   1462 */   // Label 119: @1462
     /*   1462 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1496), // Rule ID 1211 //
     /*   1467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1479 */     // MIs[1] Operand 1
     /*   1479 */     // No operand predicates
     /*   1479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1481 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, i32:{ *:[i32] }:$in)  =>  (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm)
     /*   1481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*   1484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1486 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*   1488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   1491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /*   1494 */     GIR_RootConstrainSelectedInstOperands,
     /*   1495 */     // GIR_Coverage, 1211,
     /*   1495 */     GIR_EraseRootFromParent_Done,
     /*   1496 */   // Label 120: @1496
     /*   1496 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1512), // Rule ID 209 //
     /*   1501 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$RB, i32:{ *:[i32] }:$RA)  =>  (SUBF:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBF),
     /*   1504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1506 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1508 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*   1510 */     GIR_RootConstrainSelectedInstOperands,
     /*   1511 */     // GIR_Coverage, 209,
     /*   1511 */     GIR_EraseRootFromParent_Done,
     /*   1512 */   // Label 121: @1512
     /*   1512 */   GIM_Reject,
     /*   1513 */ // Label 118: @1513
     /*   1513 */ GIM_Reject,
     /*   1514 */ // Label 110: @1514
     /*   1514 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1598),
     /*   1519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1529 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1547), // Rule ID 665 //
     /*   1534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   1538 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, i64:{ *:[i64] }:$RA)  =>  (NEG8:{ *:[i64] } i64:{ *:[i64] }:$RA)
     /*   1538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*   1541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1543 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1545 */     GIR_RootConstrainSelectedInstOperands,
     /*   1546 */     // GIR_Coverage, 665,
     /*   1546 */     GIR_EraseRootFromParent_Done,
     /*   1547 */   // Label 123: @1547
     /*   1547 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1581), // Rule ID 1533 //
     /*   1552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1564 */     // MIs[1] Operand 1
     /*   1564 */     // No operand predicates
     /*   1564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1566 */     // (sub:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, i64:{ *:[i64] }:$in)  =>  (SUBFIC8:{ *:[i64] }:{ *:[i32] } ?:{ *:[i64] }:$in, (imm:{ *:[i64] }):$imm)
     /*   1566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBFIC8),
     /*   1569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1571 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*   1573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   1576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /*   1579 */     GIR_RootConstrainSelectedInstOperands,
     /*   1580 */     // GIR_Coverage, 1533,
     /*   1580 */     GIR_EraseRootFromParent_Done,
     /*   1581 */   // Label 124: @1581
     /*   1581 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1597), // Rule ID 664 //
     /*   1586 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$RB, i64:{ *:[i64] }:$RA)  =>  (SUBF8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBF8),
     /*   1589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1591 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1593 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*   1595 */     GIR_RootConstrainSelectedInstOperands,
     /*   1596 */     // GIR_Coverage, 664,
     /*   1596 */     GIR_EraseRootFromParent_Done,
     /*   1597 */   // Label 125: @1597
     /*   1597 */   GIM_Reject,
     /*   1598 */ // Label 122: @1598
     /*   1598 */ GIM_Reject,
     /*   1599 */ // Label 111: @1599
     /*   1599 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1624), // Rule ID 475 //
     /*   1604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   1610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   1613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1617 */   // (sub:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VSUBUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   1617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUQM),
     /*   1622 */   GIR_RootConstrainSelectedInstOperands,
     /*   1623 */   // GIR_Coverage, 475,
     /*   1623 */   GIR_Done,
     /*   1624 */ // Label 126: @1624
     /*   1624 */ GIM_Reject,
     /*   1625 */ // Label 112: @1625
     /*   1625 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1687),
     /*   1630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   1636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1640 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1671), // Rule ID 542 //
     /*   1645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*   1648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1652 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   1658 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*   1660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1662 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VNEGD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*   1662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNEGD),
     /*   1665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   1667 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*   1669 */     GIR_RootConstrainSelectedInstOperands,
     /*   1670 */     // GIR_Coverage, 542,
     /*   1670 */     GIR_EraseRootFromParent_Done,
     /*   1671 */   // Label 128: @1671
     /*   1671 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1686), // Rule ID 474 //
     /*   1676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1679 */     // (sub:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VSUBUDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   1679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUDM),
     /*   1684 */     GIR_RootConstrainSelectedInstOperands,
     /*   1685 */     // GIR_Coverage, 474,
     /*   1685 */     GIR_Done,
     /*   1686 */   // Label 129: @1686
     /*   1686 */   GIM_Reject,
     /*   1687 */ // Label 127: @1687
     /*   1687 */ GIM_Reject,
     /*   1688 */ // Label 113: @1688
     /*   1688 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1750),
     /*   1693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   1696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   1699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1703 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1734), // Rule ID 541 //
     /*   1708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*   1711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1715 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   1721 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*   1723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1725 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VNEGW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*   1725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNEGW),
     /*   1728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   1730 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*   1732 */     GIR_RootConstrainSelectedInstOperands,
     /*   1733 */     // GIR_Coverage, 541,
     /*   1733 */     GIR_EraseRootFromParent_Done,
     /*   1734 */   // Label 131: @1734
     /*   1734 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1749), // Rule ID 373 //
     /*   1739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1742 */     // (sub:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   1742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUWM),
     /*   1747 */     GIR_RootConstrainSelectedInstOperands,
     /*   1748 */     // GIR_Coverage, 373,
     /*   1748 */     GIR_Done,
     /*   1749 */   // Label 132: @1749
     /*   1749 */   GIM_Reject,
     /*   1750 */ // Label 130: @1750
     /*   1750 */ GIM_Reject,
     /*   1751 */ // Label 114: @1751
     /*   1751 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1776), // Rule ID 372 //
     /*   1756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1769 */   // (sub:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*   1769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUHM),
     /*   1774 */   GIR_RootConstrainSelectedInstOperands,
     /*   1775 */   // GIR_Coverage, 372,
     /*   1775 */   GIR_Done,
     /*   1776 */ // Label 133: @1776
     /*   1776 */ GIM_Reject,
     /*   1777 */ // Label 115: @1777
     /*   1777 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1802), // Rule ID 371 //
     /*   1782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   1788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   1791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1795 */   // (sub:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBUBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*   1795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUBM),
     /*   1800 */   GIR_RootConstrainSelectedInstOperands,
     /*   1801 */   // GIR_Coverage, 371,
     /*   1801 */   GIR_Done,
     /*   1802 */ // Label 134: @1802
     /*   1802 */ GIM_Reject,
     /*   1803 */ // Label 116: @1803
     /*   1803 */ GIM_Reject,
     /*   1804 */ // Label 2: @1804
     /*   1804 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(7), /*)*//*default:*//*Label 141*/ GIMT_Encode4(2085),
     /*   1815 */ /*GILLT_s1*//*Label 135*/ GIMT_Encode4(1843),
     /*   1819 */ /*GILLT_s32*//*Label 136*/ GIMT_Encode4(1866),
     /*   1823 */ /*GILLT_s64*//*Label 137*/ GIMT_Encode4(1926), GIMT_Encode4(0),
     /*   1831 */ /*GILLT_v2s64*//*Label 138*/ GIMT_Encode4(1986),
     /*   1835 */ /*GILLT_v4s32*//*Label 139*/ GIMT_Encode4(2012),
     /*   1839 */ /*GILLT_v8s16*//*Label 140*/ GIMT_Encode4(2038),
     /*   1843 */ // Label 135: @1843
     /*   1843 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(1865), // Rule ID 3663 //
     /*   1848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   1851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1858 */   // (mul:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRAND:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /*   1863 */   GIR_RootConstrainSelectedInstOperands,
     /*   1864 */   // GIR_Coverage, 3663,
     /*   1864 */   GIR_Done,
     /*   1865 */ // Label 142: @1865
     /*   1865 */ GIM_Reject,
     /*   1866 */ // Label 136: @1866
     /*   1866 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(1925),
     /*   1871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1881 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(1912), // Rule ID 111 //
     /*   1886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1898 */     // MIs[1] Operand 1
     /*   1898 */     // No operand predicates
     /*   1898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1900 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D)  =>  (MULLI:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] }):$D)
     /*   1900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULLI),
     /*   1903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1905 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1910 */     GIR_RootConstrainSelectedInstOperands,
     /*   1911 */     // GIR_Coverage, 111,
     /*   1911 */     GIR_EraseRootFromParent_Done,
     /*   1912 */   // Label 144: @1912
     /*   1912 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(1924), // Rule ID 208 //
     /*   1917 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULLW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULLW),
     /*   1922 */     GIR_RootConstrainSelectedInstOperands,
     /*   1923 */     // GIR_Coverage, 208,
     /*   1923 */     GIR_Done,
     /*   1924 */   // Label 145: @1924
     /*   1924 */   GIM_Reject,
     /*   1925 */ // Label 143: @1925
     /*   1925 */ GIM_Reject,
     /*   1926 */ // Label 137: @1926
     /*   1926 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(1985),
     /*   1931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1941 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(1972), // Rule ID 702 //
     /*   1946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1958 */     // MIs[1] Operand 1
     /*   1958 */     // No operand predicates
     /*   1958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1960 */     // (mul:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D)  =>  (MULLI8:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] }):$D)
     /*   1960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULLI8),
     /*   1963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1965 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1970 */     GIR_RootConstrainSelectedInstOperands,
     /*   1971 */     // GIR_Coverage, 702,
     /*   1971 */     GIR_EraseRootFromParent_Done,
     /*   1972 */   // Label 147: @1972
     /*   1972 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(1984), // Rule ID 701 //
     /*   1977 */     // (mul:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULLD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULLD),
     /*   1982 */     GIR_RootConstrainSelectedInstOperands,
     /*   1983 */     // GIR_Coverage, 701,
     /*   1983 */     GIR_Done,
     /*   1984 */   // Label 148: @1984
     /*   1984 */   GIM_Reject,
     /*   1985 */ // Label 146: @1985
     /*   1985 */ GIM_Reject,
     /*   1986 */ // Label 138: @1986
     /*   1986 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2011), // Rule ID 1120 //
     /*   1991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   1994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2004 */   // (mul:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULLD),
     /*   2009 */   GIR_RootConstrainSelectedInstOperands,
     /*   2010 */   // GIR_Coverage, 1120,
     /*   2010 */   GIR_Done,
     /*   2011 */ // Label 149: @2011
     /*   2011 */ GIM_Reject,
     /*   2012 */ // Label 139: @2012
     /*   2012 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2037), // Rule ID 461 //
     /*   2017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   2020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2030 */   // (mul:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULUWM),
     /*   2035 */   GIR_RootConstrainSelectedInstOperands,
     /*   2036 */   // GIR_Coverage, 461,
     /*   2036 */   GIR_Done,
     /*   2037 */ // Label 150: @2037
     /*   2037 */ GIM_Reject,
     /*   2038 */ // Label 140: @2038
     /*   2038 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2084), // Rule ID 1289 //
     /*   2043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   2046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   2049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   2052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2056 */   // (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, (V_SET0H:{ *:[v8i16] }))
     /*   2056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*   2059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::V_SET0H),
     /*   2063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   2068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   2070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   2073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   2075 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   2077 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /*   2079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   2082 */   GIR_RootConstrainSelectedInstOperands,
     /*   2083 */   // GIR_Coverage, 1289,
     /*   2083 */   GIR_EraseRootFromParent_Done,
     /*   2084 */ // Label 151: @2084
     /*   2084 */ GIM_Reject,
     /*   2085 */ // Label 141: @2085
     /*   2085 */ GIM_Reject,
     /*   2086 */ // Label 3: @2086
     /*   2086 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 157*/ GIMT_Encode4(2241),
     /*   2097 */ /*GILLT_s32*//*Label 152*/ GIMT_Encode4(2117),
     /*   2101 */ /*GILLT_s64*//*Label 153*/ GIMT_Encode4(2140),
     /*   2105 */ /*GILLT_s128*//*Label 154*/ GIMT_Encode4(2163),
     /*   2109 */ /*GILLT_v2s64*//*Label 155*/ GIMT_Encode4(2189),
     /*   2113 */ /*GILLT_v4s32*//*Label 156*/ GIMT_Encode4(2215),
     /*   2117 */ // Label 152: @2117
     /*   2117 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2139), // Rule ID 202 //
     /*   2122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2132 */   // (sdiv:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (DIVW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVW),
     /*   2137 */   GIR_RootConstrainSelectedInstOperands,
     /*   2138 */   // GIR_Coverage, 202,
     /*   2138 */   GIR_Done,
     /*   2139 */ // Label 158: @2139
     /*   2139 */ GIM_Reject,
     /*   2140 */ // Label 153: @2140
     /*   2140 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2162), // Rule ID 693 //
     /*   2145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2155 */   // (sdiv:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (DIVD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVD),
     /*   2160 */   GIR_RootConstrainSelectedInstOperands,
     /*   2161 */   // GIR_Coverage, 693,
     /*   2161 */   GIR_Done,
     /*   2162 */ // Label 159: @2162
     /*   2162 */ GIM_Reject,
     /*   2163 */ // Label 154: @2163
     /*   2163 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2188), // Rule ID 1144 //
     /*   2168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2181 */   // (sdiv:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVSQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSQ),
     /*   2186 */   GIR_RootConstrainSelectedInstOperands,
     /*   2187 */   // GIR_Coverage, 1144,
     /*   2187 */   GIR_Done,
     /*   2188 */ // Label 160: @2188
     /*   2188 */ GIM_Reject,
     /*   2189 */ // Label 155: @2189
     /*   2189 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2214), // Rule ID 1131 //
     /*   2194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2207 */   // (sdiv:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSD),
     /*   2212 */   GIR_RootConstrainSelectedInstOperands,
     /*   2213 */   // GIR_Coverage, 1131,
     /*   2213 */   GIR_Done,
     /*   2214 */ // Label 161: @2214
     /*   2214 */ GIM_Reject,
     /*   2215 */ // Label 156: @2215
     /*   2215 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2240), // Rule ID 1129 //
     /*   2220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2233 */   // (sdiv:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSW),
     /*   2238 */   GIR_RootConstrainSelectedInstOperands,
     /*   2239 */   // GIR_Coverage, 1129,
     /*   2239 */   GIR_Done,
     /*   2240 */ // Label 162: @2240
     /*   2240 */ GIM_Reject,
     /*   2241 */ // Label 157: @2241
     /*   2241 */ GIM_Reject,
     /*   2242 */ // Label 4: @2242
     /*   2242 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 168*/ GIMT_Encode4(2397),
     /*   2253 */ /*GILLT_s32*//*Label 163*/ GIMT_Encode4(2273),
     /*   2257 */ /*GILLT_s64*//*Label 164*/ GIMT_Encode4(2296),
     /*   2261 */ /*GILLT_s128*//*Label 165*/ GIMT_Encode4(2319),
     /*   2265 */ /*GILLT_v2s64*//*Label 166*/ GIMT_Encode4(2345),
     /*   2269 */ /*GILLT_v4s32*//*Label 167*/ GIMT_Encode4(2371),
     /*   2273 */ // Label 163: @2273
     /*   2273 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2295), // Rule ID 203 //
     /*   2278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2288 */   // (udiv:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (DIVWU:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVWU),
     /*   2293 */   GIR_RootConstrainSelectedInstOperands,
     /*   2294 */   // GIR_Coverage, 203,
     /*   2294 */   GIR_Done,
     /*   2295 */ // Label 169: @2295
     /*   2295 */ GIM_Reject,
     /*   2296 */ // Label 164: @2296
     /*   2296 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2318), // Rule ID 694 //
     /*   2301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2311 */   // (udiv:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (DIVDU:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVDU),
     /*   2316 */   GIR_RootConstrainSelectedInstOperands,
     /*   2317 */   // GIR_Coverage, 694,
     /*   2317 */   GIR_Done,
     /*   2318 */ // Label 170: @2318
     /*   2318 */ GIM_Reject,
     /*   2319 */ // Label 165: @2319
     /*   2319 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2344), // Rule ID 1145 //
     /*   2324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2337 */   // (udiv:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUQ),
     /*   2342 */   GIR_RootConstrainSelectedInstOperands,
     /*   2343 */   // GIR_Coverage, 1145,
     /*   2343 */   GIR_Done,
     /*   2344 */ // Label 171: @2344
     /*   2344 */ GIM_Reject,
     /*   2345 */ // Label 166: @2345
     /*   2345 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2370), // Rule ID 1132 //
     /*   2350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2363 */   // (udiv:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUD),
     /*   2368 */   GIR_RootConstrainSelectedInstOperands,
     /*   2369 */   // GIR_Coverage, 1132,
     /*   2369 */   GIR_Done,
     /*   2370 */ // Label 172: @2370
     /*   2370 */ GIM_Reject,
     /*   2371 */ // Label 167: @2371
     /*   2371 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2396), // Rule ID 1130 //
     /*   2376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2389 */   // (udiv:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUW),
     /*   2394 */   GIR_RootConstrainSelectedInstOperands,
     /*   2395 */   // GIR_Coverage, 1130,
     /*   2395 */   GIR_Done,
     /*   2396 */ // Label 173: @2396
     /*   2396 */ GIM_Reject,
     /*   2397 */ // Label 168: @2397
     /*   2397 */ GIM_Reject,
     /*   2398 */ // Label 5: @2398
     /*   2398 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 179*/ GIMT_Encode4(2559),
     /*   2409 */ /*GILLT_s32*//*Label 174*/ GIMT_Encode4(2429),
     /*   2413 */ /*GILLT_s64*//*Label 175*/ GIMT_Encode4(2455),
     /*   2417 */ /*GILLT_s128*//*Label 176*/ GIMT_Encode4(2481),
     /*   2421 */ /*GILLT_v2s64*//*Label 177*/ GIMT_Encode4(2507),
     /*   2425 */ /*GILLT_v4s32*//*Label 178*/ GIMT_Encode4(2533),
     /*   2429 */ // Label 174: @2429
     /*   2429 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2454), // Rule ID 197 //
     /*   2434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2447 */   // (srem:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MODSW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODSW),
     /*   2452 */   GIR_RootConstrainSelectedInstOperands,
     /*   2453 */   // GIR_Coverage, 197,
     /*   2453 */   GIR_Done,
     /*   2454 */ // Label 180: @2454
     /*   2454 */ GIM_Reject,
     /*   2455 */ // Label 175: @2455
     /*   2455 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2480), // Rule ID 698 //
     /*   2460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2473 */   // (srem:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MODSD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODSD),
     /*   2478 */   GIR_RootConstrainSelectedInstOperands,
     /*   2479 */   // GIR_Coverage, 698,
     /*   2479 */   GIR_Done,
     /*   2480 */ // Label 181: @2480
     /*   2480 */ GIM_Reject,
     /*   2481 */ // Label 176: @2481
     /*   2481 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2506), // Rule ID 1154 //
     /*   2486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2499 */   // (srem:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VMODSQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSQ),
     /*   2504 */   GIR_RootConstrainSelectedInstOperands,
     /*   2505 */   // GIR_Coverage, 1154,
     /*   2505 */   GIR_Done,
     /*   2506 */ // Label 182: @2506
     /*   2506 */ GIM_Reject,
     /*   2507 */ // Label 177: @2507
     /*   2507 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2532), // Rule ID 1127 //
     /*   2512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2525 */   // (srem:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMODSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSD),
     /*   2530 */   GIR_RootConstrainSelectedInstOperands,
     /*   2531 */   // GIR_Coverage, 1127,
     /*   2531 */   GIR_Done,
     /*   2532 */ // Label 183: @2532
     /*   2532 */ GIM_Reject,
     /*   2533 */ // Label 178: @2533
     /*   2533 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2558), // Rule ID 1125 //
     /*   2538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2551 */   // (srem:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMODSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSW),
     /*   2556 */   GIR_RootConstrainSelectedInstOperands,
     /*   2557 */   // GIR_Coverage, 1125,
     /*   2557 */   GIR_Done,
     /*   2558 */ // Label 184: @2558
     /*   2558 */ GIM_Reject,
     /*   2559 */ // Label 179: @2559
     /*   2559 */ GIM_Reject,
     /*   2560 */ // Label 6: @2560
     /*   2560 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 190*/ GIMT_Encode4(2721),
     /*   2571 */ /*GILLT_s32*//*Label 185*/ GIMT_Encode4(2591),
     /*   2575 */ /*GILLT_s64*//*Label 186*/ GIMT_Encode4(2617),
     /*   2579 */ /*GILLT_s128*//*Label 187*/ GIMT_Encode4(2643),
     /*   2583 */ /*GILLT_v2s64*//*Label 188*/ GIMT_Encode4(2669),
     /*   2587 */ /*GILLT_v4s32*//*Label 189*/ GIMT_Encode4(2695),
     /*   2591 */ // Label 185: @2591
     /*   2591 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2616), // Rule ID 198 //
     /*   2596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2609 */   // (urem:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MODUW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2609 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODUW),
     /*   2614 */   GIR_RootConstrainSelectedInstOperands,
     /*   2615 */   // GIR_Coverage, 198,
     /*   2615 */   GIR_Done,
     /*   2616 */ // Label 191: @2616
     /*   2616 */ GIM_Reject,
     /*   2617 */ // Label 186: @2617
     /*   2617 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2642), // Rule ID 699 //
     /*   2622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2635 */   // (urem:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MODUD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODUD),
     /*   2640 */   GIR_RootConstrainSelectedInstOperands,
     /*   2641 */   // GIR_Coverage, 699,
     /*   2641 */   GIR_Done,
     /*   2642 */ // Label 192: @2642
     /*   2642 */ GIM_Reject,
     /*   2643 */ // Label 187: @2643
     /*   2643 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2668), // Rule ID 1155 //
     /*   2648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2661 */   // (urem:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VMODUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUQ),
     /*   2666 */   GIR_RootConstrainSelectedInstOperands,
     /*   2667 */   // GIR_Coverage, 1155,
     /*   2667 */   GIR_Done,
     /*   2668 */ // Label 193: @2668
     /*   2668 */ GIM_Reject,
     /*   2669 */ // Label 188: @2669
     /*   2669 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2694), // Rule ID 1128 //
     /*   2674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2687 */   // (urem:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMODUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUD),
     /*   2692 */   GIR_RootConstrainSelectedInstOperands,
     /*   2693 */   // GIR_Coverage, 1128,
     /*   2693 */   GIR_Done,
     /*   2694 */ // Label 194: @2694
     /*   2694 */ GIM_Reject,
     /*   2695 */ // Label 189: @2695
     /*   2695 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2720), // Rule ID 1126 //
     /*   2700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2713 */   // (urem:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMODUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2713 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUW),
     /*   2718 */   GIR_RootConstrainSelectedInstOperands,
     /*   2719 */   // GIR_Coverage, 1126,
     /*   2719 */   GIR_Done,
     /*   2720 */ // Label 195: @2720
     /*   2720 */ GIM_Reject,
     /*   2721 */ // Label 190: @2721
     /*   2721 */ GIM_Reject,
     /*   2722 */ // Label 7: @2722
     /*   2722 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 200*/ GIMT_Encode4(5282),
     /*   2733 */ /*GILLT_s1*//*Label 196*/ GIMT_Encode4(2757),
     /*   2737 */ /*GILLT_s32*//*Label 197*/ GIMT_Encode4(2866),
     /*   2741 */ /*GILLT_s64*//*Label 198*/ GIMT_Encode4(2975), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   2753 */ /*GILLT_v4s32*//*Label 199*/ GIMT_Encode4(3084),
     /*   2757 */ // Label 196: @2757
     /*   2757 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(2865),
     /*   2762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   2765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   2768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   2772 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(2812), // Rule ID 4913 //
     /*   2777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   2789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   2793 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2799 */     // (and:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRA)  =>  (CRANDC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /*   2802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   2804 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRA
     /*   2806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   2810 */     GIR_RootConstrainSelectedInstOperands,
     /*   2811 */     // GIR_Coverage, 4913,
     /*   2811 */     GIR_EraseRootFromParent_Done,
     /*   2812 */   // Label 202: @2812
     /*   2812 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(2852), // Rule ID 182 //
     /*   2817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   2829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   2833 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2839 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }))  =>  (CRANDC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /*   2842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   2844 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*   2846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   2850 */     GIR_RootConstrainSelectedInstOperands,
     /*   2851 */     // GIR_Coverage, 182,
     /*   2851 */     GIR_EraseRootFromParent_Done,
     /*   2852 */   // Label 203: @2852
     /*   2852 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(2864), // Rule ID 175 //
     /*   2857 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CRAND:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /*   2862 */     GIR_RootConstrainSelectedInstOperands,
     /*   2863 */     // GIR_Coverage, 175,
     /*   2863 */     GIR_Done,
     /*   2864 */   // Label 204: @2864
     /*   2864 */   GIM_Reject,
     /*   2865 */ // Label 201: @2865
     /*   2865 */ GIM_Reject,
     /*   2866 */ // Label 197: @2866
     /*   2866 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(2974),
     /*   2871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2881 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(2921), // Rule ID 4907 //
     /*   2886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2902 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2908 */     // (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }), i32:{ *:[i32] }:$RST)  =>  (ANDC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*   2911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   2913 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   2915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   2919 */     GIR_RootConstrainSelectedInstOperands,
     /*   2920 */     // GIR_Coverage, 4907,
     /*   2920 */     GIR_EraseRootFromParent_Done,
     /*   2921 */   // Label 206: @2921
     /*   2921 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(2961), // Rule ID 123 //
     /*   2926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2942 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2948 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$RST, (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }))  =>  (ANDC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*   2951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   2953 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   2955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   2959 */     GIR_RootConstrainSelectedInstOperands,
     /*   2960 */     // GIR_Coverage, 123,
     /*   2960 */     GIR_EraseRootFromParent_Done,
     /*   2961 */   // Label 207: @2961
     /*   2961 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(2973), // Rule ID 122 //
     /*   2966 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (AND:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::AND),
     /*   2971 */     GIR_RootConstrainSelectedInstOperands,
     /*   2972 */     // GIR_Coverage, 122,
     /*   2972 */     GIR_Done,
     /*   2973 */   // Label 208: @2973
     /*   2973 */   GIM_Reject,
     /*   2974 */ // Label 205: @2974
     /*   2974 */ GIM_Reject,
     /*   2975 */ // Label 198: @2975
     /*   2975 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3083),
     /*   2980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2990 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3030), // Rule ID 4920 //
     /*   2995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   3011 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   3015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3017 */     // (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }), i64:{ *:[i64] }:$RST)  =>  (ANDC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*   3020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   3022 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   3024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   3028 */     GIR_RootConstrainSelectedInstOperands,
     /*   3029 */     // GIR_Coverage, 4920,
     /*   3029 */     GIR_EraseRootFromParent_Done,
     /*   3030 */   // Label 210: @3030
     /*   3030 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3070), // Rule ID 643 //
     /*   3035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   3051 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   3055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3057 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$RST, (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }))  =>  (ANDC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*   3060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   3062 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   3064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   3068 */     GIR_RootConstrainSelectedInstOperands,
     /*   3069 */     // GIR_Coverage, 643,
     /*   3069 */     GIR_EraseRootFromParent_Done,
     /*   3070 */   // Label 211: @3070
     /*   3070 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3082), // Rule ID 642 //
     /*   3075 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (AND8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /*   3080 */     GIR_RootConstrainSelectedInstOperands,
     /*   3081 */     // GIR_Coverage, 642,
     /*   3081 */     GIR_Done,
     /*   3082 */   // Label 212: @3082
     /*   3082 */   GIM_Reject,
     /*   3083 */ // Label 209: @3083
     /*   3083 */ GIM_Reject,
     /*   3084 */ // Label 199: @3084
     /*   3084 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5281),
     /*   3089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3095 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3173), // Rule ID 5268 //
     /*   3100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3143 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3149 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3153 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   3166 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   3168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3171 */     GIR_RootConstrainSelectedInstOperands,
     /*   3172 */     // GIR_Coverage, 5268,
     /*   3172 */     GIR_EraseRootFromParent_Done,
     /*   3173 */   // Label 214: @3173
     /*   3173 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3251), // Rule ID 5269 //
     /*   3178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3221 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3227 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3231 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3244 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   3246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3249 */     GIR_RootConstrainSelectedInstOperands,
     /*   3250 */     // GIR_Coverage, 5269,
     /*   3250 */     GIR_EraseRootFromParent_Done,
     /*   3251 */   // Label 215: @3251
     /*   3251 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3331), // Rule ID 5270 //
     /*   3256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   3283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3299 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3305 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3309 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3329 */     GIR_RootConstrainSelectedInstOperands,
     /*   3330 */     // GIR_Coverage, 5270,
     /*   3330 */     GIR_EraseRootFromParent_Done,
     /*   3331 */   // Label 216: @3331
     /*   3331 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3411), // Rule ID 5273 //
     /*   3336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   3363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3379 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3385 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3389 */     // (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 112:{ *:[i32] })
     /*   3389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/112,
     /*   3409 */     GIR_RootConstrainSelectedInstOperands,
     /*   3410 */     // GIR_Coverage, 5273,
     /*   3410 */     GIR_EraseRootFromParent_Done,
     /*   3411 */   // Label 217: @3411
     /*   3411 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3489), // Rule ID 4957 //
     /*   3416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3459 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3467 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3469 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 14:{ *:[i32] })
     /*   3469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3474 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3487 */     GIR_RootConstrainSelectedInstOperands,
     /*   3488 */     // GIR_Coverage, 4957,
     /*   3488 */     GIR_EraseRootFromParent_Done,
     /*   3489 */   // Label 218: @3489
     /*   3489 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3567), // Rule ID 4951 //
     /*   3494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3537 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3543 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3547 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 8:{ *:[i32] })
     /*   3547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3552 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*   3565 */     GIR_RootConstrainSelectedInstOperands,
     /*   3566 */     // GIR_Coverage, 4951,
     /*   3566 */     GIR_EraseRootFromParent_Done,
     /*   3567 */   // Label 219: @3567
     /*   3567 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3645), // Rule ID 4955 //
     /*   3572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3615 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3621 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3625 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3630 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3643 */     GIR_RootConstrainSelectedInstOperands,
     /*   3644 */     // GIR_Coverage, 4955,
     /*   3644 */     GIR_EraseRootFromParent_Done,
     /*   3645 */   // Label 220: @3645
     /*   3645 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3723), // Rule ID 4954 //
     /*   3650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3693 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3699 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3701 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3703 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3708 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3721 */     GIR_RootConstrainSelectedInstOperands,
     /*   3722 */     // GIR_Coverage, 4954,
     /*   3722 */     GIR_EraseRootFromParent_Done,
     /*   3723 */   // Label 221: @3723
     /*   3723 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3801), // Rule ID 4956 //
     /*   3728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3771 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3777 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3781 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3786 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*   3796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3799 */     GIR_RootConstrainSelectedInstOperands,
     /*   3800 */     // GIR_Coverage, 4956,
     /*   3800 */     GIR_EraseRootFromParent_Done,
     /*   3801 */   // Label 222: @3801
     /*   3801 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3881), // Rule ID 3398 //
     /*   3806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3833 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3839 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   3841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   3845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3849 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3853 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3859 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   3868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   3872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   3876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3879 */     GIR_RootConstrainSelectedInstOperands,
     /*   3880 */     // GIR_Coverage, 3398,
     /*   3880 */     GIR_EraseRootFromParent_Done,
     /*   3881 */   // Label 223: @3881
     /*   3881 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3961), // Rule ID 3399 //
     /*   3886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3913 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3919 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   3921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   3925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3929 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3933 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3939 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 112:{ *:[i32] })
     /*   3939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   3948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   3952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   3956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/112,
     /*   3959 */     GIR_RootConstrainSelectedInstOperands,
     /*   3960 */     // GIR_Coverage, 3399,
     /*   3960 */     GIR_EraseRootFromParent_Done,
     /*   3961 */   // Label 224: @3961
     /*   3961 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(4041), // Rule ID 3397 //
     /*   3966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3993 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3999 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   4001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   4005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4013 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4019 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 96:{ *:[i32] })
     /*   4019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   4028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   4032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   4036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/96,
     /*   4039 */     GIR_RootConstrainSelectedInstOperands,
     /*   4040 */     // GIR_Coverage, 3397,
     /*   4040 */     GIR_EraseRootFromParent_Done,
     /*   4041 */   // Label 225: @4041
     /*   4041 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(4121), // Rule ID 5267 //
     /*   4046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   4073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4089 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4095 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4099 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 96:{ *:[i32] })
     /*   4099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/96,
     /*   4119 */     GIR_RootConstrainSelectedInstOperands,
     /*   4120 */     // GIR_Coverage, 5267,
     /*   4120 */     GIR_EraseRootFromParent_Done,
     /*   4121 */   // Label 226: @4121
     /*   4121 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(4199), // Rule ID 5271 //
     /*   4126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4161 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4169 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4175 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4179 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   4179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   4192 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   4194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   4197 */     GIR_RootConstrainSelectedInstOperands,
     /*   4198 */     // GIR_Coverage, 5271,
     /*   4198 */     GIR_EraseRootFromParent_Done,
     /*   4199 */   // Label 227: @4199
     /*   4199 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(4277), // Rule ID 5272 //
     /*   4204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4247 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4253 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4257 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   4257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4270 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   4272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   4275 */     GIR_RootConstrainSelectedInstOperands,
     /*   4276 */     // GIR_Coverage, 5272,
     /*   4276 */     GIR_EraseRootFromParent_Done,
     /*   4277 */   // Label 228: @4277
     /*   4277 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(4355), // Rule ID 3385 //
     /*   4282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4325 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4331 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4335 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 14:{ *:[i32] })
     /*   4335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4340 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4353 */     GIR_RootConstrainSelectedInstOperands,
     /*   4354 */     // GIR_Coverage, 3385,
     /*   4354 */     GIR_EraseRootFromParent_Done,
     /*   4355 */   // Label 229: @4355
     /*   4355 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(4433), // Rule ID 3383 //
     /*   4360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4403 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4409 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4413 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 8:{ *:[i32] })
     /*   4413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4418 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*   4431 */     GIR_RootConstrainSelectedInstOperands,
     /*   4432 */     // GIR_Coverage, 3383,
     /*   4432 */     GIR_EraseRootFromParent_Done,
     /*   4433 */   // Label 230: @4433
     /*   4433 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(4511), // Rule ID 4952 //
     /*   4438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4481 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4487 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4491 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4496 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4509 */     GIR_RootConstrainSelectedInstOperands,
     /*   4510 */     // GIR_Coverage, 4952,
     /*   4510 */     GIR_EraseRootFromParent_Done,
     /*   4511 */   // Label 231: @4511
     /*   4511 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(4589), // Rule ID 3384 //
     /*   4516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4559 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4565 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4567 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4569 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4574 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4587 */     GIR_RootConstrainSelectedInstOperands,
     /*   4588 */     // GIR_Coverage, 3384,
     /*   4588 */     GIR_EraseRootFromParent_Done,
     /*   4589 */   // Label 232: @4589
     /*   4589 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(4667), // Rule ID 4953 //
     /*   4594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4637 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4643 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4647 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4652 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*   4662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4665 */     GIR_RootConstrainSelectedInstOperands,
     /*   4666 */     // GIR_Coverage, 4953,
     /*   4666 */     GIR_EraseRootFromParent_Done,
     /*   4667 */   // Label 233: @4667
     /*   4667 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(4722), // Rule ID 4928 //
     /*   4672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   4675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4699 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4705 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   4707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4709 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XA)  =>  (XXLANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   4709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLANDC),
     /*   4712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4714 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*   4716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*   4720 */     GIR_RootConstrainSelectedInstOperands,
     /*   4721 */     // GIR_Coverage, 4928,
     /*   4721 */     GIR_EraseRootFromParent_Done,
     /*   4722 */   // Label 234: @4722
     /*   4722 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(4777), // Rule ID 929 //
     /*   4727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   4730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4754 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4760 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   4762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4764 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }))  =>  (XXLANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   4764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLANDC),
     /*   4767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4769 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /*   4771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*   4775 */     GIR_RootConstrainSelectedInstOperands,
     /*   4776 */     // GIR_Coverage, 929,
     /*   4776 */     GIR_EraseRootFromParent_Done,
     /*   4777 */   // Label 235: @4777
     /*   4777 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(4827), // Rule ID 4948 //
     /*   4782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4807 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 1:{ *:[i32] })
     /*   4807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   4816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   4820 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   4822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   4825 */     GIR_RootConstrainSelectedInstOperands,
     /*   4826 */     // GIR_Coverage, 4948,
     /*   4826 */     GIR_EraseRootFromParent_Done,
     /*   4827 */   // Label 236: @4827
     /*   4827 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(4877), // Rule ID 4950 //
     /*   4832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4857 */     // (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 7:{ *:[i32] })
     /*   4857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4862 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   4864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   4875 */     GIR_RootConstrainSelectedInstOperands,
     /*   4876 */     // GIR_Coverage, 4950,
     /*   4876 */     GIR_EraseRootFromParent_Done,
     /*   4877 */   // Label 237: @4877
     /*   4877 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(4927), // Rule ID 4949 //
     /*   4882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4907 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 6:{ *:[i32] })
     /*   4907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4912 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   4914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   4925 */     GIR_RootConstrainSelectedInstOperands,
     /*   4926 */     // GIR_Coverage, 4949,
     /*   4926 */     GIR_EraseRootFromParent_Done,
     /*   4927 */   // Label 238: @4927
     /*   4927 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(4977), // Rule ID 3380 //
     /*   4932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4957 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 1:{ *:[i32] })
     /*   4957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4962 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   4975 */     GIR_RootConstrainSelectedInstOperands,
     /*   4976 */     // GIR_Coverage, 3380,
     /*   4976 */     GIR_EraseRootFromParent_Done,
     /*   4977 */   // Label 239: @4977
     /*   4977 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(5027), // Rule ID 3382 //
     /*   4982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5007 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 7:{ *:[i32] })
     /*   5007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5012 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   5014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   5018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   5025 */     GIR_RootConstrainSelectedInstOperands,
     /*   5026 */     // GIR_Coverage, 3382,
     /*   5026 */     GIR_EraseRootFromParent_Done,
     /*   5027 */   // Label 240: @5027
     /*   5027 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(5077), // Rule ID 3381 //
     /*   5032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5057 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 6:{ *:[i32] })
     /*   5057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5062 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   5064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   5068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   5075 */     GIR_RootConstrainSelectedInstOperands,
     /*   5076 */     // GIR_Coverage, 3381,
     /*   5076 */     GIR_EraseRootFromParent_Done,
     /*   5077 */   // Label 241: @5077
     /*   5077 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(5096), // Rule ID 928 //
     /*   5082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   5085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5089 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   5089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLAND),
     /*   5094 */     GIR_RootConstrainSelectedInstOperands,
     /*   5095 */     // GIR_Coverage, 928,
     /*   5095 */     GIR_Done,
     /*   5096 */   // Label 242: @5096
     /*   5096 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(5151), // Rule ID 4916 //
     /*   5101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5128 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5134 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5138 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VA)  =>  (VANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5143 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*   5145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*   5149 */     GIR_RootConstrainSelectedInstOperands,
     /*   5150 */     // GIR_Coverage, 4916,
     /*   5150 */     GIR_EraseRootFromParent_Done,
     /*   5151 */   // Label 243: @5151
     /*   5151 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(5206), // Rule ID 312 //
     /*   5156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5183 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5189 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5193 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }))  =>  (VANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5198 */     GIR_RootToRootCopy, /*OpIdx*/1, // VA
     /*   5200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*   5204 */     GIR_RootConstrainSelectedInstOperands,
     /*   5205 */     // GIR_Coverage, 312,
     /*   5205 */     GIR_EraseRootFromParent_Done,
     /*   5206 */   // Label 244: @5206
     /*   5206 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(5261), // Rule ID 1378 //
     /*   5211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5238 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5244 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5248 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, immAllOnesV:{ *:[v4i32] }))  =>  (VANDC:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*   5248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5253 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*   5255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*   5259 */     GIR_RootConstrainSelectedInstOperands,
     /*   5260 */     // GIR_Coverage, 1378,
     /*   5260 */     GIR_EraseRootFromParent_Done,
     /*   5261 */   // Label 245: @5261
     /*   5261 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(5280), // Rule ID 311 //
     /*   5266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5273 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VAND),
     /*   5278 */     GIR_RootConstrainSelectedInstOperands,
     /*   5279 */     // GIR_Coverage, 311,
     /*   5279 */     GIR_Done,
     /*   5280 */   // Label 246: @5280
     /*   5280 */   GIM_Reject,
     /*   5281 */ // Label 213: @5281
     /*   5281 */ GIM_Reject,
     /*   5282 */ // Label 200: @5282
     /*   5282 */ GIM_Reject,
     /*   5283 */ // Label 8: @5283
     /*   5283 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 251*/ GIMT_Encode4(48424),
     /*   5294 */ /*GILLT_s1*//*Label 247*/ GIMT_Encode4(5318),
     /*   5298 */ /*GILLT_s32*//*Label 248*/ GIMT_Encode4(5427),
     /*   5302 */ /*GILLT_s64*//*Label 249*/ GIMT_Encode4(5536), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   5314 */ /*GILLT_v4s32*//*Label 250*/ GIMT_Encode4(5645),
     /*   5318 */ // Label 247: @5318
     /*   5318 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(5426),
     /*   5323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   5326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   5329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   5333 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(5373), // Rule ID 4914 //
     /*   5338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   5350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   5354 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5360 */     // (or:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRA)  =>  (CRORC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /*   5363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   5365 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRA
     /*   5367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   5371 */     GIR_RootConstrainSelectedInstOperands,
     /*   5372 */     // GIR_Coverage, 4914,
     /*   5372 */     GIR_EraseRootFromParent_Done,
     /*   5373 */   // Label 253: @5373
     /*   5373 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(5413), // Rule ID 183 //
     /*   5378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   5390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   5394 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5400 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }))  =>  (CRORC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /*   5403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   5405 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*   5407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   5411 */     GIR_RootConstrainSelectedInstOperands,
     /*   5412 */     // GIR_Coverage, 183,
     /*   5412 */     GIR_EraseRootFromParent_Done,
     /*   5413 */   // Label 254: @5413
     /*   5413 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(5425), // Rule ID 177 //
     /*   5418 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CROR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CROR),
     /*   5423 */     GIR_RootConstrainSelectedInstOperands,
     /*   5424 */     // GIR_Coverage, 177,
     /*   5424 */     GIR_Done,
     /*   5425 */   // Label 255: @5425
     /*   5425 */   GIM_Reject,
     /*   5426 */ // Label 252: @5426
     /*   5426 */ GIM_Reject,
     /*   5427 */ // Label 248: @5427
     /*   5427 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(5535),
     /*   5432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   5435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   5438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   5442 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(5482), // Rule ID 4908 //
     /*   5447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5463 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5469 */     // (or:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }), i32:{ *:[i32] }:$RST)  =>  (ORC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*   5472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5474 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   5476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5480 */     GIR_RootConstrainSelectedInstOperands,
     /*   5481 */     // GIR_Coverage, 4908,
     /*   5481 */     GIR_EraseRootFromParent_Done,
     /*   5482 */   // Label 257: @5482
     /*   5482 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(5522), // Rule ID 126 //
     /*   5487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5503 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5509 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$RST, (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }))  =>  (ORC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*   5512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5514 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   5516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5520 */     GIR_RootConstrainSelectedInstOperands,
     /*   5521 */     // GIR_Coverage, 126,
     /*   5521 */     GIR_EraseRootFromParent_Done,
     /*   5522 */   // Label 258: @5522
     /*   5522 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(5534), // Rule ID 124 //
     /*   5527 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (OR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::OR),
     /*   5532 */     GIR_RootConstrainSelectedInstOperands,
     /*   5533 */     // GIR_Coverage, 124,
     /*   5533 */     GIR_Done,
     /*   5534 */   // Label 259: @5534
     /*   5534 */   GIM_Reject,
     /*   5535 */ // Label 256: @5535
     /*   5535 */ GIM_Reject,
     /*   5536 */ // Label 249: @5536
     /*   5536 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(5644),
     /*   5541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   5544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   5547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   5551 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(5591), // Rule ID 4921 //
     /*   5556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5572 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5578 */     // (or:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }), i64:{ *:[i64] }:$RST)  =>  (ORC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*   5581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5583 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   5585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5589 */     GIR_RootConstrainSelectedInstOperands,
     /*   5590 */     // GIR_Coverage, 4921,
     /*   5590 */     GIR_EraseRootFromParent_Done,
     /*   5591 */   // Label 261: @5591
     /*   5591 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(5631), // Rule ID 646 //
     /*   5596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5612 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5618 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$RST, (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }))  =>  (ORC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*   5621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5623 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   5625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5629 */     GIR_RootConstrainSelectedInstOperands,
     /*   5630 */     // GIR_Coverage, 646,
     /*   5630 */     GIR_EraseRootFromParent_Done,
     /*   5631 */   // Label 262: @5631
     /*   5631 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(5643), // Rule ID 644 //
     /*   5636 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (OR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5636 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /*   5641 */     GIR_RootConstrainSelectedInstOperands,
     /*   5642 */     // GIR_Coverage, 644,
     /*   5642 */     GIR_Done,
     /*   5643 */   // Label 263: @5643
     /*   5643 */   GIM_Reject,
     /*   5644 */ // Label 260: @5644
     /*   5644 */ GIM_Reject,
     /*   5645 */ // Label 250: @5645
     /*   5645 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(48423),
     /*   5650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5656 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(5794), // Rule ID 4968 //
     /*   5661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5708 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5712 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5716 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5720 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5724 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5728 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   5732 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5736 */     // MIs[5] vA
     /*   5736 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   5741 */     // MIs[5] vB
     /*   5741 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5746 */     // MIs[4] vC
     /*   5746 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   5751 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   5755 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5761 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   5763 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   5765 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   5765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   5774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   5778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5782 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   5792 */     GIR_RootConstrainSelectedInstOperands,
     /*   5793 */     // GIR_Coverage, 4968,
     /*   5793 */     GIR_EraseRootFromParent_Done,
     /*   5794 */   // Label 265: @5794
     /*   5794 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(5932), // Rule ID 4969 //
     /*   5799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5846 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5850 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5854 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5858 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5862 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5866 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   5870 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5874 */     // MIs[5] vB
     /*   5874 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5879 */     // MIs[5] vA
     /*   5879 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   5884 */     // MIs[4] vC
     /*   5884 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   5889 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   5893 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5899 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   5901 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   5903 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   5903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   5912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   5916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5920 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   5930 */     GIR_RootConstrainSelectedInstOperands,
     /*   5931 */     // GIR_Coverage, 4969,
     /*   5931 */     GIR_EraseRootFromParent_Done,
     /*   5932 */   // Label 266: @5932
     /*   5932 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(6070), // Rule ID 4970 //
     /*   5937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5984 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5988 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5996 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6000 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6004 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6008 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6012 */     // MIs[5] vA
     /*   6012 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6017 */     // MIs[5] vC
     /*   6017 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6022 */     // MIs[4] vB
     /*   6022 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6027 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6031 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6037 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6039 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6041 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6058 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6068 */     GIR_RootConstrainSelectedInstOperands,
     /*   6069 */     // GIR_Coverage, 4970,
     /*   6069 */     GIR_EraseRootFromParent_Done,
     /*   6070 */   // Label 267: @6070
     /*   6070 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(6208), // Rule ID 4971 //
     /*   6075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6122 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6126 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6130 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6134 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6138 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6142 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6146 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6150 */     // MIs[5] vC
     /*   6150 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6155 */     // MIs[5] vA
     /*   6155 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6160 */     // MIs[4] vB
     /*   6160 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6165 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6169 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6175 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6177 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6179 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6196 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6206 */     GIR_RootConstrainSelectedInstOperands,
     /*   6207 */     // GIR_Coverage, 4971,
     /*   6207 */     GIR_EraseRootFromParent_Done,
     /*   6208 */   // Label 268: @6208
     /*   6208 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(6346), // Rule ID 4972 //
     /*   6213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6260 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6264 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6272 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6276 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6280 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6284 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6288 */     // MIs[5] vB
     /*   6288 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6293 */     // MIs[5] vC
     /*   6293 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6298 */     // MIs[4] vA
     /*   6298 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6303 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6307 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6315 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6317 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6334 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6344 */     GIR_RootConstrainSelectedInstOperands,
     /*   6345 */     // GIR_Coverage, 4972,
     /*   6345 */     GIR_EraseRootFromParent_Done,
     /*   6346 */   // Label 269: @6346
     /*   6346 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(6484), // Rule ID 4973 //
     /*   6351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6398 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6402 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6406 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6410 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6414 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6418 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6422 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6426 */     // MIs[5] vC
     /*   6426 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6431 */     // MIs[5] vB
     /*   6431 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6436 */     // MIs[4] vA
     /*   6436 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6441 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6445 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6451 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6453 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6455 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6472 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6482 */     GIR_RootConstrainSelectedInstOperands,
     /*   6483 */     // GIR_Coverage, 4973,
     /*   6483 */     GIR_EraseRootFromParent_Done,
     /*   6484 */   // Label 270: @6484
     /*   6484 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(6622), // Rule ID 4980 //
     /*   6489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6536 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6540 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6544 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6548 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6552 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6556 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6560 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6564 */     // MIs[5] vA
     /*   6564 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6569 */     // MIs[5] vB
     /*   6569 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6574 */     // MIs[4] vC
     /*   6574 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6579 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6583 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6589 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6591 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6593 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6610 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6620 */     GIR_RootConstrainSelectedInstOperands,
     /*   6621 */     // GIR_Coverage, 4980,
     /*   6621 */     GIR_EraseRootFromParent_Done,
     /*   6622 */   // Label 271: @6622
     /*   6622 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(6760), // Rule ID 4981 //
     /*   6627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6674 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6678 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6682 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6686 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6690 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6694 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6698 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6702 */     // MIs[5] vB
     /*   6702 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6707 */     // MIs[5] vA
     /*   6707 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6712 */     // MIs[4] vC
     /*   6712 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6717 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6721 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6727 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6729 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6731 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6748 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6758 */     GIR_RootConstrainSelectedInstOperands,
     /*   6759 */     // GIR_Coverage, 4981,
     /*   6759 */     GIR_EraseRootFromParent_Done,
     /*   6760 */   // Label 272: @6760
     /*   6760 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(6898), // Rule ID 4982 //
     /*   6765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6800 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6812 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6816 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6820 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6824 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6828 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6832 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6836 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6840 */     // MIs[5] vA
     /*   6840 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6845 */     // MIs[5] vC
     /*   6845 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6850 */     // MIs[4] vB
     /*   6850 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6855 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6859 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6865 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6867 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6869 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6886 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6896 */     GIR_RootConstrainSelectedInstOperands,
     /*   6897 */     // GIR_Coverage, 4982,
     /*   6897 */     GIR_EraseRootFromParent_Done,
     /*   6898 */   // Label 273: @6898
     /*   6898 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(7036), // Rule ID 4983 //
     /*   6903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6950 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6954 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6958 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6962 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6966 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6970 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6974 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6978 */     // MIs[5] vC
     /*   6978 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6983 */     // MIs[5] vA
     /*   6983 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6988 */     // MIs[4] vB
     /*   6988 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6993 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6997 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7003 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7005 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7007 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7024 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7034 */     GIR_RootConstrainSelectedInstOperands,
     /*   7035 */     // GIR_Coverage, 4983,
     /*   7035 */     GIR_EraseRootFromParent_Done,
     /*   7036 */   // Label 274: @7036
     /*   7036 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(7174), // Rule ID 4984 //
     /*   7041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7088 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7092 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7096 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7100 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7104 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7108 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7112 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7116 */     // MIs[5] vB
     /*   7116 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7121 */     // MIs[5] vC
     /*   7121 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7126 */     // MIs[4] vA
     /*   7126 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7131 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7135 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7141 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7143 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7145 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7162 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7172 */     GIR_RootConstrainSelectedInstOperands,
     /*   7173 */     // GIR_Coverage, 4984,
     /*   7173 */     GIR_EraseRootFromParent_Done,
     /*   7174 */   // Label 275: @7174
     /*   7174 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(7312), // Rule ID 4985 //
     /*   7179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7226 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7230 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7234 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7238 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7242 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7246 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7250 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7254 */     // MIs[5] vC
     /*   7254 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7259 */     // MIs[5] vB
     /*   7259 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7264 */     // MIs[4] vA
     /*   7264 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7269 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7273 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7281 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7283 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7300 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7310 */     GIR_RootConstrainSelectedInstOperands,
     /*   7311 */     // GIR_Coverage, 4985,
     /*   7311 */     GIR_EraseRootFromParent_Done,
     /*   7312 */   // Label 276: @7312
     /*   7312 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(7450), // Rule ID 4992 //
     /*   7317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7364 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7368 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7372 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7376 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7380 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7384 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7388 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7392 */     // MIs[5] vA
     /*   7392 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7397 */     // MIs[5] vB
     /*   7397 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7402 */     // MIs[4] vC
     /*   7402 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7407 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7411 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7417 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7419 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7421 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7438 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7448 */     GIR_RootConstrainSelectedInstOperands,
     /*   7449 */     // GIR_Coverage, 4992,
     /*   7449 */     GIR_EraseRootFromParent_Done,
     /*   7450 */   // Label 277: @7450
     /*   7450 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(7588), // Rule ID 4993 //
     /*   7455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7506 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7510 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7514 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7518 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7522 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7526 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7530 */     // MIs[5] vB
     /*   7530 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7535 */     // MIs[5] vA
     /*   7535 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7540 */     // MIs[4] vC
     /*   7540 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7545 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7549 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7555 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7557 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7559 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7576 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7586 */     GIR_RootConstrainSelectedInstOperands,
     /*   7587 */     // GIR_Coverage, 4993,
     /*   7587 */     GIR_EraseRootFromParent_Done,
     /*   7588 */   // Label 278: @7588
     /*   7588 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(7726), // Rule ID 4994 //
     /*   7593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7640 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7644 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7648 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7652 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7656 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7660 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7664 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7668 */     // MIs[5] vA
     /*   7668 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7673 */     // MIs[5] vC
     /*   7673 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7678 */     // MIs[4] vB
     /*   7678 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7683 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7687 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7693 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7695 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7697 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7714 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7724 */     GIR_RootConstrainSelectedInstOperands,
     /*   7725 */     // GIR_Coverage, 4994,
     /*   7725 */     GIR_EraseRootFromParent_Done,
     /*   7726 */   // Label 279: @7726
     /*   7726 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(7864), // Rule ID 4995 //
     /*   7731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7778 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7782 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7794 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7798 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7802 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7806 */     // MIs[5] vC
     /*   7806 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7811 */     // MIs[5] vA
     /*   7811 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7816 */     // MIs[4] vB
     /*   7816 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7821 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7825 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7831 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7833 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7835 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7852 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7862 */     GIR_RootConstrainSelectedInstOperands,
     /*   7863 */     // GIR_Coverage, 4995,
     /*   7863 */     GIR_EraseRootFromParent_Done,
     /*   7864 */   // Label 280: @7864
     /*   7864 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(8002), // Rule ID 4996 //
     /*   7869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7916 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7920 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7928 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7932 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7936 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7940 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7944 */     // MIs[5] vB
     /*   7944 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7949 */     // MIs[5] vC
     /*   7949 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7954 */     // MIs[4] vA
     /*   7954 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7959 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7963 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7969 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7971 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7973 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7990 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8000 */     GIR_RootConstrainSelectedInstOperands,
     /*   8001 */     // GIR_Coverage, 4996,
     /*   8001 */     GIR_EraseRootFromParent_Done,
     /*   8002 */   // Label 281: @8002
     /*   8002 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(8140), // Rule ID 4997 //
     /*   8007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8054 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8058 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8062 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8066 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8070 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8074 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8078 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8082 */     // MIs[5] vC
     /*   8082 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8087 */     // MIs[5] vB
     /*   8087 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8092 */     // MIs[4] vA
     /*   8092 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8097 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8101 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8107 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8109 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8111 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   8120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   8128 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8138 */     GIR_RootConstrainSelectedInstOperands,
     /*   8139 */     // GIR_Coverage, 4997,
     /*   8139 */     GIR_EraseRootFromParent_Done,
     /*   8140 */   // Label 282: @8140
     /*   8140 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(8278), // Rule ID 5004 //
     /*   8145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8192 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8196 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8208 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8212 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8216 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8220 */     // MIs[5] vA
     /*   8220 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8225 */     // MIs[5] vB
     /*   8225 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8230 */     // MIs[4] vC
     /*   8230 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8235 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8239 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8247 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8249 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8266 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8276 */     GIR_RootConstrainSelectedInstOperands,
     /*   8277 */     // GIR_Coverage, 5004,
     /*   8277 */     GIR_EraseRootFromParent_Done,
     /*   8278 */   // Label 283: @8278
     /*   8278 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(8416), // Rule ID 5005 //
     /*   8283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8334 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8342 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8346 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8350 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8354 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8358 */     // MIs[5] vB
     /*   8358 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8363 */     // MIs[5] vA
     /*   8363 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8368 */     // MIs[4] vC
     /*   8368 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8373 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8377 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8383 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8385 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8387 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8404 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8414 */     GIR_RootConstrainSelectedInstOperands,
     /*   8415 */     // GIR_Coverage, 5005,
     /*   8415 */     GIR_EraseRootFromParent_Done,
     /*   8416 */   // Label 284: @8416
     /*   8416 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(8554), // Rule ID 5006 //
     /*   8421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8472 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8476 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8480 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8484 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8488 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8492 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8496 */     // MIs[5] vA
     /*   8496 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8501 */     // MIs[5] vC
     /*   8501 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8506 */     // MIs[4] vB
     /*   8506 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8511 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8515 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8521 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8523 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8525 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8542 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8552 */     GIR_RootConstrainSelectedInstOperands,
     /*   8553 */     // GIR_Coverage, 5006,
     /*   8553 */     GIR_EraseRootFromParent_Done,
     /*   8554 */   // Label 285: @8554
     /*   8554 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(8692), // Rule ID 5007 //
     /*   8559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8606 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8610 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8614 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8618 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8622 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8626 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8630 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8634 */     // MIs[5] vC
     /*   8634 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8639 */     // MIs[5] vA
     /*   8639 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8644 */     // MIs[4] vB
     /*   8644 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8649 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8653 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8659 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8661 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8663 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8680 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8690 */     GIR_RootConstrainSelectedInstOperands,
     /*   8691 */     // GIR_Coverage, 5007,
     /*   8691 */     GIR_EraseRootFromParent_Done,
     /*   8692 */   // Label 286: @8692
     /*   8692 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(8830), // Rule ID 5008 //
     /*   8697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8744 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8748 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8752 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8756 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8760 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8764 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8768 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8772 */     // MIs[5] vB
     /*   8772 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8777 */     // MIs[5] vC
     /*   8777 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8782 */     // MIs[4] vA
     /*   8782 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8787 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8791 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8797 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8799 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8801 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8818 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8828 */     GIR_RootConstrainSelectedInstOperands,
     /*   8829 */     // GIR_Coverage, 5008,
     /*   8829 */     GIR_EraseRootFromParent_Done,
     /*   8830 */   // Label 287: @8830
     /*   8830 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(8968), // Rule ID 5009 //
     /*   8835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8882 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8886 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8890 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8894 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8898 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8902 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8906 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8910 */     // MIs[5] vC
     /*   8910 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8915 */     // MIs[5] vB
     /*   8915 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8920 */     // MIs[4] vA
     /*   8920 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8925 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8929 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8935 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8937 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8939 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8956 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8966 */     GIR_RootConstrainSelectedInstOperands,
     /*   8967 */     // GIR_Coverage, 5009,
     /*   8967 */     GIR_EraseRootFromParent_Done,
     /*   8968 */   // Label 288: @8968
     /*   8968 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(9106), // Rule ID 5016 //
     /*   8973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9028 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9032 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9036 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9040 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9044 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9048 */     // MIs[5] vA
     /*   9048 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9053 */     // MIs[5] vB
     /*   9053 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9058 */     // MIs[4] vC
     /*   9058 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9063 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9067 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9073 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9075 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9077 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9094 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9104 */     GIR_RootConstrainSelectedInstOperands,
     /*   9105 */     // GIR_Coverage, 5016,
     /*   9105 */     GIR_EraseRootFromParent_Done,
     /*   9106 */   // Label 289: @9106
     /*   9106 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(9244), // Rule ID 5017 //
     /*   9111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9158 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9162 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9166 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9170 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9174 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9178 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9182 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9186 */     // MIs[5] vB
     /*   9186 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9191 */     // MIs[5] vA
     /*   9191 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9196 */     // MIs[4] vC
     /*   9196 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9201 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9205 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9211 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9213 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9215 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9232 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9242 */     GIR_RootConstrainSelectedInstOperands,
     /*   9243 */     // GIR_Coverage, 5017,
     /*   9243 */     GIR_EraseRootFromParent_Done,
     /*   9244 */   // Label 290: @9244
     /*   9244 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(9382), // Rule ID 5018 //
     /*   9249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9296 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9300 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9304 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9308 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9312 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9316 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9320 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9324 */     // MIs[5] vA
     /*   9324 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9329 */     // MIs[5] vC
     /*   9329 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9334 */     // MIs[4] vB
     /*   9334 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9339 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9343 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9349 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9351 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9353 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9370 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9380 */     GIR_RootConstrainSelectedInstOperands,
     /*   9381 */     // GIR_Coverage, 5018,
     /*   9381 */     GIR_EraseRootFromParent_Done,
     /*   9382 */   // Label 291: @9382
     /*   9382 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(9520), // Rule ID 5019 //
     /*   9387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9434 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9438 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9446 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9450 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9454 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9458 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9462 */     // MIs[5] vC
     /*   9462 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9467 */     // MIs[5] vA
     /*   9467 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9472 */     // MIs[4] vB
     /*   9472 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9477 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9481 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9487 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9489 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9491 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9508 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9518 */     GIR_RootConstrainSelectedInstOperands,
     /*   9519 */     // GIR_Coverage, 5019,
     /*   9519 */     GIR_EraseRootFromParent_Done,
     /*   9520 */   // Label 292: @9520
     /*   9520 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(9658), // Rule ID 5020 //
     /*   9525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9576 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9580 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9584 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9588 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9592 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9596 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9600 */     // MIs[5] vB
     /*   9600 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9605 */     // MIs[5] vC
     /*   9605 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9610 */     // MIs[4] vA
     /*   9610 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9615 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9619 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9625 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9627 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9629 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9646 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9656 */     GIR_RootConstrainSelectedInstOperands,
     /*   9657 */     // GIR_Coverage, 5020,
     /*   9657 */     GIR_EraseRootFromParent_Done,
     /*   9658 */   // Label 293: @9658
     /*   9658 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(9796), // Rule ID 5021 //
     /*   9663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9710 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9714 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9718 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9722 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9726 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9730 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9734 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9738 */     // MIs[5] vC
     /*   9738 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9743 */     // MIs[5] vB
     /*   9743 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9748 */     // MIs[4] vA
     /*   9748 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9753 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9757 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9763 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9765 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9767 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9784 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9794 */     GIR_RootConstrainSelectedInstOperands,
     /*   9795 */     // GIR_Coverage, 5021,
     /*   9795 */     GIR_EraseRootFromParent_Done,
     /*   9796 */   // Label 294: @9796
     /*   9796 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(9934), // Rule ID 5028 //
     /*   9801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9852 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9856 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9860 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9864 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9868 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9872 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9876 */     // MIs[5] vA
     /*   9876 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9881 */     // MIs[5] vB
     /*   9881 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9886 */     // MIs[4] vC
     /*   9886 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9891 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9895 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9901 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9903 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9905 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   9918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   9922 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9932 */     GIR_RootConstrainSelectedInstOperands,
     /*   9933 */     // GIR_Coverage, 5028,
     /*   9933 */     GIR_EraseRootFromParent_Done,
     /*   9934 */   // Label 295: @9934
     /*   9934 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(10072), // Rule ID 5029 //
     /*   9939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9986 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9990 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9994 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9998 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10002 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10006 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10010 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10014 */     // MIs[5] vB
     /*  10014 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10019 */     // MIs[5] vA
     /*  10019 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10024 */     // MIs[4] vC
     /*  10024 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10029 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10033 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10039 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10041 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10043 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10060 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10070 */     GIR_RootConstrainSelectedInstOperands,
     /*  10071 */     // GIR_Coverage, 5029,
     /*  10071 */     GIR_EraseRootFromParent_Done,
     /*  10072 */   // Label 296: @10072
     /*  10072 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(10210), // Rule ID 5030 //
     /*  10077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10128 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10132 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10136 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10140 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10144 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10148 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10152 */     // MIs[5] vA
     /*  10152 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10157 */     // MIs[5] vC
     /*  10157 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10162 */     // MIs[4] vB
     /*  10162 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10167 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10171 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10177 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10179 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10181 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10198 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10208 */     GIR_RootConstrainSelectedInstOperands,
     /*  10209 */     // GIR_Coverage, 5030,
     /*  10209 */     GIR_EraseRootFromParent_Done,
     /*  10210 */   // Label 297: @10210
     /*  10210 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(10348), // Rule ID 5031 //
     /*  10215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10262 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10266 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10270 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10274 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10278 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10282 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10286 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10290 */     // MIs[5] vC
     /*  10290 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10295 */     // MIs[5] vA
     /*  10295 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10300 */     // MIs[4] vB
     /*  10300 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10305 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10309 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10315 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10317 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10319 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10336 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10346 */     GIR_RootConstrainSelectedInstOperands,
     /*  10347 */     // GIR_Coverage, 5031,
     /*  10347 */     GIR_EraseRootFromParent_Done,
     /*  10348 */   // Label 298: @10348
     /*  10348 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(10486), // Rule ID 5032 //
     /*  10353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10400 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10404 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10412 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10416 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10420 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10424 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10428 */     // MIs[5] vB
     /*  10428 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10433 */     // MIs[5] vC
     /*  10433 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10438 */     // MIs[4] vA
     /*  10438 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10443 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10447 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10453 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10455 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10457 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10474 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10484 */     GIR_RootConstrainSelectedInstOperands,
     /*  10485 */     // GIR_Coverage, 5032,
     /*  10485 */     GIR_EraseRootFromParent_Done,
     /*  10486 */   // Label 299: @10486
     /*  10486 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(10624), // Rule ID 5033 //
     /*  10491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10538 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10542 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10546 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10550 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10554 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10558 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10562 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10566 */     // MIs[5] vC
     /*  10566 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10571 */     // MIs[5] vB
     /*  10571 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10576 */     // MIs[4] vA
     /*  10576 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10581 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10585 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10591 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10593 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10595 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10612 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10622 */     GIR_RootConstrainSelectedInstOperands,
     /*  10623 */     // GIR_Coverage, 5033,
     /*  10623 */     GIR_EraseRootFromParent_Done,
     /*  10624 */   // Label 300: @10624
     /*  10624 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(10762), // Rule ID 4974 //
     /*  10629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10676 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10680 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10684 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10688 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10692 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10696 */     // MIs[4] vC
     /*  10696 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10701 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10705 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10709 */     // MIs[5] vA
     /*  10709 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10714 */     // MIs[5] vB
     /*  10714 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10719 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10723 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10731 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10733 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  10742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  10750 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10760 */     GIR_RootConstrainSelectedInstOperands,
     /*  10761 */     // GIR_Coverage, 4974,
     /*  10761 */     GIR_EraseRootFromParent_Done,
     /*  10762 */   // Label 301: @10762
     /*  10762 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(10900), // Rule ID 4975 //
     /*  10767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10818 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10822 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10826 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10830 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10834 */     // MIs[4] vC
     /*  10834 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10839 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10843 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10847 */     // MIs[5] vB
     /*  10847 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10852 */     // MIs[5] vA
     /*  10852 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10857 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10861 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10867 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10869 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10871 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  10880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  10888 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10898 */     GIR_RootConstrainSelectedInstOperands,
     /*  10899 */     // GIR_Coverage, 4975,
     /*  10899 */     GIR_EraseRootFromParent_Done,
     /*  10900 */   // Label 302: @10900
     /*  10900 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(11038), // Rule ID 4976 //
     /*  10905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10952 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10956 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10960 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10964 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10968 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10972 */     // MIs[4] vB
     /*  10972 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10977 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10981 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10985 */     // MIs[5] vA
     /*  10985 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10990 */     // MIs[5] vC
     /*  10990 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10995 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10999 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11007 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11009 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11026 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11036 */     GIR_RootConstrainSelectedInstOperands,
     /*  11037 */     // GIR_Coverage, 4976,
     /*  11037 */     GIR_EraseRootFromParent_Done,
     /*  11038 */   // Label 303: @11038
     /*  11038 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(11176), // Rule ID 4977 //
     /*  11043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11090 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11094 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11098 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11102 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11106 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11110 */     // MIs[4] vB
     /*  11110 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11115 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11119 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11123 */     // MIs[5] vC
     /*  11123 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11128 */     // MIs[5] vA
     /*  11128 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11133 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11137 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11143 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11145 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11147 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11164 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11174 */     GIR_RootConstrainSelectedInstOperands,
     /*  11175 */     // GIR_Coverage, 4977,
     /*  11175 */     GIR_EraseRootFromParent_Done,
     /*  11176 */   // Label 304: @11176
     /*  11176 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(11314), // Rule ID 4978 //
     /*  11181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11228 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11232 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11236 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11240 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11244 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11248 */     // MIs[4] vA
     /*  11248 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11253 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11257 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11261 */     // MIs[5] vB
     /*  11261 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11266 */     // MIs[5] vC
     /*  11266 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11271 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11275 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11281 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11283 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11285 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11302 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11312 */     GIR_RootConstrainSelectedInstOperands,
     /*  11313 */     // GIR_Coverage, 4978,
     /*  11313 */     GIR_EraseRootFromParent_Done,
     /*  11314 */   // Label 305: @11314
     /*  11314 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(11452), // Rule ID 4979 //
     /*  11319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11366 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11370 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11374 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11378 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11382 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11386 */     // MIs[4] vA
     /*  11386 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11391 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11395 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11399 */     // MIs[5] vC
     /*  11399 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11404 */     // MIs[5] vB
     /*  11404 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11409 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11413 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11419 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11421 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11423 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11440 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11450 */     GIR_RootConstrainSelectedInstOperands,
     /*  11451 */     // GIR_Coverage, 4979,
     /*  11451 */     GIR_EraseRootFromParent_Done,
     /*  11452 */   // Label 306: @11452
     /*  11452 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(11590), // Rule ID 4986 //
     /*  11457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11504 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11508 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11512 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11516 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11520 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11524 */     // MIs[4] vC
     /*  11524 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11529 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11533 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11537 */     // MIs[5] vA
     /*  11537 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11542 */     // MIs[5] vB
     /*  11542 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11547 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11551 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11559 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11561 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11578 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11588 */     GIR_RootConstrainSelectedInstOperands,
     /*  11589 */     // GIR_Coverage, 4986,
     /*  11589 */     GIR_EraseRootFromParent_Done,
     /*  11590 */   // Label 307: @11590
     /*  11590 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(11728), // Rule ID 4987 //
     /*  11595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11642 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11646 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11650 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11654 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11658 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11662 */     // MIs[4] vC
     /*  11662 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11667 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11671 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11675 */     // MIs[5] vB
     /*  11675 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11680 */     // MIs[5] vA
     /*  11680 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11685 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11689 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11695 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11697 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11699 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11716 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11726 */     GIR_RootConstrainSelectedInstOperands,
     /*  11727 */     // GIR_Coverage, 4987,
     /*  11727 */     GIR_EraseRootFromParent_Done,
     /*  11728 */   // Label 308: @11728
     /*  11728 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(11866), // Rule ID 4988 //
     /*  11733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11780 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11784 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11788 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11792 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11796 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11800 */     // MIs[4] vB
     /*  11800 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11805 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11809 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11813 */     // MIs[5] vA
     /*  11813 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11818 */     // MIs[5] vC
     /*  11818 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11823 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11827 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11833 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11835 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11837 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11854 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11864 */     GIR_RootConstrainSelectedInstOperands,
     /*  11865 */     // GIR_Coverage, 4988,
     /*  11865 */     GIR_EraseRootFromParent_Done,
     /*  11866 */   // Label 309: @11866
     /*  11866 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(12004), // Rule ID 4989 //
     /*  11871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11918 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11922 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11926 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11930 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11934 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11938 */     // MIs[4] vB
     /*  11938 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11943 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11947 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11951 */     // MIs[5] vC
     /*  11951 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11956 */     // MIs[5] vA
     /*  11956 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11961 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11965 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11971 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11973 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11975 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11992 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12002 */     GIR_RootConstrainSelectedInstOperands,
     /*  12003 */     // GIR_Coverage, 4989,
     /*  12003 */     GIR_EraseRootFromParent_Done,
     /*  12004 */   // Label 310: @12004
     /*  12004 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(12142), // Rule ID 4990 //
     /*  12009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12056 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12060 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12064 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12068 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12072 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12076 */     // MIs[4] vA
     /*  12076 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12081 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12085 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12089 */     // MIs[5] vB
     /*  12089 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12094 */     // MIs[5] vC
     /*  12094 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12099 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12103 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12109 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12111 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12113 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  12122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  12126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  12130 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12140 */     GIR_RootConstrainSelectedInstOperands,
     /*  12141 */     // GIR_Coverage, 4990,
     /*  12141 */     GIR_EraseRootFromParent_Done,
     /*  12142 */   // Label 311: @12142
     /*  12142 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(12280), // Rule ID 4991 //
     /*  12147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12198 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12202 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12206 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12210 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12214 */     // MIs[4] vA
     /*  12214 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12219 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12223 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12227 */     // MIs[5] vC
     /*  12227 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12232 */     // MIs[5] vB
     /*  12232 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12237 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12241 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12249 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12251 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  12260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  12264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  12268 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12278 */     GIR_RootConstrainSelectedInstOperands,
     /*  12279 */     // GIR_Coverage, 4991,
     /*  12279 */     GIR_EraseRootFromParent_Done,
     /*  12280 */   // Label 312: @12280
     /*  12280 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(12418), // Rule ID 4998 //
     /*  12285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12332 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12336 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12340 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12344 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12348 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12352 */     // MIs[4] vC
     /*  12352 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12357 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12361 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12365 */     // MIs[5] vA
     /*  12365 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12370 */     // MIs[5] vB
     /*  12370 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12375 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12379 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12385 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12387 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12389 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12406 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12416 */     GIR_RootConstrainSelectedInstOperands,
     /*  12417 */     // GIR_Coverage, 4998,
     /*  12417 */     GIR_EraseRootFromParent_Done,
     /*  12418 */   // Label 313: @12418
     /*  12418 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(12556), // Rule ID 4999 //
     /*  12423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12466 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12470 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12474 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12478 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12482 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12486 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12490 */     // MIs[4] vC
     /*  12490 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12495 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12499 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12503 */     // MIs[5] vB
     /*  12503 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12508 */     // MIs[5] vA
     /*  12508 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12513 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12517 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12523 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12525 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12527 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12544 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12554 */     GIR_RootConstrainSelectedInstOperands,
     /*  12555 */     // GIR_Coverage, 4999,
     /*  12555 */     GIR_EraseRootFromParent_Done,
     /*  12556 */   // Label 314: @12556
     /*  12556 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(12694), // Rule ID 5000 //
     /*  12561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12608 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12612 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12620 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12624 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12628 */     // MIs[4] vB
     /*  12628 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12633 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12637 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12641 */     // MIs[5] vA
     /*  12641 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12646 */     // MIs[5] vC
     /*  12646 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12651 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12655 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12661 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12663 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12665 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12682 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12692 */     GIR_RootConstrainSelectedInstOperands,
     /*  12693 */     // GIR_Coverage, 5000,
     /*  12693 */     GIR_EraseRootFromParent_Done,
     /*  12694 */   // Label 315: @12694
     /*  12694 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(12832), // Rule ID 5001 //
     /*  12699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12746 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12750 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12754 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12758 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12762 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12766 */     // MIs[4] vB
     /*  12766 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12771 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12775 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12779 */     // MIs[5] vC
     /*  12779 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12784 */     // MIs[5] vA
     /*  12784 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12789 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12793 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12799 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12801 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12803 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12820 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12830 */     GIR_RootConstrainSelectedInstOperands,
     /*  12831 */     // GIR_Coverage, 5001,
     /*  12831 */     GIR_EraseRootFromParent_Done,
     /*  12832 */   // Label 316: @12832
     /*  12832 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(12970), // Rule ID 5002 //
     /*  12837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12884 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12888 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12896 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12900 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12904 */     // MIs[4] vA
     /*  12904 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12909 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12913 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12917 */     // MIs[5] vB
     /*  12917 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12922 */     // MIs[5] vC
     /*  12922 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12927 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12931 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12937 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12939 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12941 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12958 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12968 */     GIR_RootConstrainSelectedInstOperands,
     /*  12969 */     // GIR_Coverage, 5002,
     /*  12969 */     GIR_EraseRootFromParent_Done,
     /*  12970 */   // Label 317: @12970
     /*  12970 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(13108), // Rule ID 5003 //
     /*  12975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13022 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13026 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13030 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13034 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13038 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13042 */     // MIs[4] vA
     /*  13042 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13047 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13051 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13055 */     // MIs[5] vC
     /*  13055 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13060 */     // MIs[5] vB
     /*  13060 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13065 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13069 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13075 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13077 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13079 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  13088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  13096 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13106 */     GIR_RootConstrainSelectedInstOperands,
     /*  13107 */     // GIR_Coverage, 5003,
     /*  13107 */     GIR_EraseRootFromParent_Done,
     /*  13108 */   // Label 318: @13108
     /*  13108 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(13246), // Rule ID 5010 //
     /*  13113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13160 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13164 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13168 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13172 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13176 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13180 */     // MIs[4] vC
     /*  13180 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13185 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13189 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13193 */     // MIs[5] vA
     /*  13193 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13198 */     // MIs[5] vB
     /*  13198 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13203 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13207 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13213 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13215 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13217 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13234 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13244 */     GIR_RootConstrainSelectedInstOperands,
     /*  13245 */     // GIR_Coverage, 5010,
     /*  13245 */     GIR_EraseRootFromParent_Done,
     /*  13246 */   // Label 319: @13246
     /*  13246 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(13384), // Rule ID 5011 //
     /*  13251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13298 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13302 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13310 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13314 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13318 */     // MIs[4] vC
     /*  13318 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13323 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13327 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13331 */     // MIs[5] vB
     /*  13331 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13336 */     // MIs[5] vA
     /*  13336 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13341 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13345 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13351 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13353 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13355 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13372 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13382 */     GIR_RootConstrainSelectedInstOperands,
     /*  13383 */     // GIR_Coverage, 5011,
     /*  13383 */     GIR_EraseRootFromParent_Done,
     /*  13384 */   // Label 320: @13384
     /*  13384 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(13522), // Rule ID 5012 //
     /*  13389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13436 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13440 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13444 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13448 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13452 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13456 */     // MIs[4] vB
     /*  13456 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13461 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13465 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13469 */     // MIs[5] vA
     /*  13469 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13474 */     // MIs[5] vC
     /*  13474 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13479 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13483 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13489 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13491 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13493 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13510 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13520 */     GIR_RootConstrainSelectedInstOperands,
     /*  13521 */     // GIR_Coverage, 5012,
     /*  13521 */     GIR_EraseRootFromParent_Done,
     /*  13522 */   // Label 321: @13522
     /*  13522 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(13660), // Rule ID 5013 //
     /*  13527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13574 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13578 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13582 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13586 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13590 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13594 */     // MIs[4] vB
     /*  13594 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13599 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13603 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13607 */     // MIs[5] vC
     /*  13607 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13612 */     // MIs[5] vA
     /*  13612 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13617 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13621 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13627 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13629 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13631 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13648 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13658 */     GIR_RootConstrainSelectedInstOperands,
     /*  13659 */     // GIR_Coverage, 5013,
     /*  13659 */     GIR_EraseRootFromParent_Done,
     /*  13660 */   // Label 322: @13660
     /*  13660 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(13798), // Rule ID 5014 //
     /*  13665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13712 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13716 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13720 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13724 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13728 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13732 */     // MIs[4] vA
     /*  13732 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13737 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13741 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13745 */     // MIs[5] vB
     /*  13745 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13750 */     // MIs[5] vC
     /*  13750 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13755 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13759 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13765 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13767 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13769 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13786 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13796 */     GIR_RootConstrainSelectedInstOperands,
     /*  13797 */     // GIR_Coverage, 5014,
     /*  13797 */     GIR_EraseRootFromParent_Done,
     /*  13798 */   // Label 323: @13798
     /*  13798 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(13936), // Rule ID 5015 //
     /*  13803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13842 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13846 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13850 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13854 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13858 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13862 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13866 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13870 */     // MIs[4] vA
     /*  13870 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13875 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13879 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13883 */     // MIs[5] vC
     /*  13883 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13888 */     // MIs[5] vB
     /*  13888 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13893 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13897 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13903 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13905 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13907 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13924 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13934 */     GIR_RootConstrainSelectedInstOperands,
     /*  13935 */     // GIR_Coverage, 5015,
     /*  13935 */     GIR_EraseRootFromParent_Done,
     /*  13936 */   // Label 324: @13936
     /*  13936 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(14074), // Rule ID 5022 //
     /*  13941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13992 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13996 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14000 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14004 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14008 */     // MIs[4] vC
     /*  14008 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14013 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14017 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14021 */     // MIs[5] vA
     /*  14021 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14026 */     // MIs[5] vB
     /*  14026 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14031 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14035 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14041 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14043 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14045 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14062 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14072 */     GIR_RootConstrainSelectedInstOperands,
     /*  14073 */     // GIR_Coverage, 5022,
     /*  14073 */     GIR_EraseRootFromParent_Done,
     /*  14074 */   // Label 325: @14074
     /*  14074 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(14212), // Rule ID 5023 //
     /*  14079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14126 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14130 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14134 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14138 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14142 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14146 */     // MIs[4] vC
     /*  14146 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14151 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14155 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14159 */     // MIs[5] vB
     /*  14159 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14164 */     // MIs[5] vA
     /*  14164 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14169 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14173 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14179 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14181 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14183 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14200 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14210 */     GIR_RootConstrainSelectedInstOperands,
     /*  14211 */     // GIR_Coverage, 5023,
     /*  14211 */     GIR_EraseRootFromParent_Done,
     /*  14212 */   // Label 326: @14212
     /*  14212 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(14350), // Rule ID 5024 //
     /*  14217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14264 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14268 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14272 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14276 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14280 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14284 */     // MIs[4] vB
     /*  14284 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14289 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14293 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14297 */     // MIs[5] vA
     /*  14297 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14302 */     // MIs[5] vC
     /*  14302 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14307 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14311 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14317 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14319 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14321 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14338 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14348 */     GIR_RootConstrainSelectedInstOperands,
     /*  14349 */     // GIR_Coverage, 5024,
     /*  14349 */     GIR_EraseRootFromParent_Done,
     /*  14350 */   // Label 327: @14350
     /*  14350 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(14488), // Rule ID 5025 //
     /*  14355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14402 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14406 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14410 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14414 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14418 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14422 */     // MIs[4] vB
     /*  14422 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14427 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14431 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14435 */     // MIs[5] vC
     /*  14435 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14440 */     // MIs[5] vA
     /*  14440 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14445 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14449 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14455 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14457 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14459 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14476 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14486 */     GIR_RootConstrainSelectedInstOperands,
     /*  14487 */     // GIR_Coverage, 5025,
     /*  14487 */     GIR_EraseRootFromParent_Done,
     /*  14488 */   // Label 328: @14488
     /*  14488 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(14626), // Rule ID 5026 //
     /*  14493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14540 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14544 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14548 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14552 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14556 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14560 */     // MIs[4] vA
     /*  14560 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14565 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14569 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14573 */     // MIs[5] vB
     /*  14573 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14578 */     // MIs[5] vC
     /*  14578 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14583 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14587 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14593 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14595 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14597 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14614 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14624 */     GIR_RootConstrainSelectedInstOperands,
     /*  14625 */     // GIR_Coverage, 5026,
     /*  14625 */     GIR_EraseRootFromParent_Done,
     /*  14626 */   // Label 329: @14626
     /*  14626 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(14764), // Rule ID 5027 //
     /*  14631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14682 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14686 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14690 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14694 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14698 */     // MIs[4] vA
     /*  14698 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14703 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14707 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14711 */     // MIs[5] vC
     /*  14711 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14716 */     // MIs[5] vB
     /*  14716 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14721 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14725 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14731 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14733 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14735 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14752 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14762 */     GIR_RootConstrainSelectedInstOperands,
     /*  14763 */     // GIR_Coverage, 5027,
     /*  14763 */     GIR_EraseRootFromParent_Done,
     /*  14764 */   // Label 330: @14764
     /*  14764 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(14902), // Rule ID 5034 //
     /*  14769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14816 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14820 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14824 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14828 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14832 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14836 */     // MIs[4] vC
     /*  14836 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14841 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14845 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14849 */     // MIs[5] vA
     /*  14849 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14854 */     // MIs[5] vB
     /*  14854 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14859 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14863 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14869 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14871 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14873 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  14886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  14890 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14900 */     GIR_RootConstrainSelectedInstOperands,
     /*  14901 */     // GIR_Coverage, 5034,
     /*  14901 */     GIR_EraseRootFromParent_Done,
     /*  14902 */   // Label 331: @14902
     /*  14902 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15040), // Rule ID 5035 //
     /*  14907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14962 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14966 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14970 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14974 */     // MIs[4] vC
     /*  14974 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14979 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14983 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14987 */     // MIs[5] vB
     /*  14987 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14992 */     // MIs[5] vA
     /*  14992 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14997 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15001 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15007 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15009 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15011 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15028 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15038 */     GIR_RootConstrainSelectedInstOperands,
     /*  15039 */     // GIR_Coverage, 5035,
     /*  15039 */     GIR_EraseRootFromParent_Done,
     /*  15040 */   // Label 332: @15040
     /*  15040 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(15178), // Rule ID 5036 //
     /*  15045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15092 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15096 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15100 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15104 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15108 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15112 */     // MIs[4] vB
     /*  15112 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15117 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15121 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15125 */     // MIs[5] vA
     /*  15125 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15130 */     // MIs[5] vC
     /*  15130 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15135 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15139 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15145 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15147 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15149 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15166 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15176 */     GIR_RootConstrainSelectedInstOperands,
     /*  15177 */     // GIR_Coverage, 5036,
     /*  15177 */     GIR_EraseRootFromParent_Done,
     /*  15178 */   // Label 333: @15178
     /*  15178 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(15316), // Rule ID 5037 //
     /*  15183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15230 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15234 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15238 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15242 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15246 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15250 */     // MIs[4] vB
     /*  15250 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15255 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15259 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15263 */     // MIs[5] vC
     /*  15263 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15268 */     // MIs[5] vA
     /*  15268 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15273 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15277 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15283 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15285 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15287 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15304 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15314 */     GIR_RootConstrainSelectedInstOperands,
     /*  15315 */     // GIR_Coverage, 5037,
     /*  15315 */     GIR_EraseRootFromParent_Done,
     /*  15316 */   // Label 334: @15316
     /*  15316 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(15454), // Rule ID 5038 //
     /*  15321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15368 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15372 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15376 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15380 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15384 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15388 */     // MIs[4] vA
     /*  15388 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15393 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15397 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15401 */     // MIs[5] vB
     /*  15401 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15406 */     // MIs[5] vC
     /*  15406 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15411 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15415 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15423 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15425 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15442 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15452 */     GIR_RootConstrainSelectedInstOperands,
     /*  15453 */     // GIR_Coverage, 5038,
     /*  15453 */     GIR_EraseRootFromParent_Done,
     /*  15454 */   // Label 335: @15454
     /*  15454 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(15592), // Rule ID 5039 //
     /*  15459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15506 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15510 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15514 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15518 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15522 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15526 */     // MIs[4] vA
     /*  15526 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15531 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15535 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15539 */     // MIs[5] vC
     /*  15539 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15544 */     // MIs[5] vB
     /*  15544 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15549 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15553 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15559 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15561 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15563 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15580 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15590 */     GIR_RootConstrainSelectedInstOperands,
     /*  15591 */     // GIR_Coverage, 5039,
     /*  15591 */     GIR_EraseRootFromParent_Done,
     /*  15592 */   // Label 336: @15592
     /*  15592 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(15730), // Rule ID 5040 //
     /*  15597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15644 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15648 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15652 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15656 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15660 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15664 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15668 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15672 */     // MIs[5] vA
     /*  15672 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15677 */     // MIs[5] vB
     /*  15677 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15682 */     // MIs[4] vC
     /*  15682 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15687 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15691 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15699 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15701 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15718 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15728 */     GIR_RootConstrainSelectedInstOperands,
     /*  15729 */     // GIR_Coverage, 5040,
     /*  15729 */     GIR_EraseRootFromParent_Done,
     /*  15730 */   // Label 337: @15730
     /*  15730 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(15868), // Rule ID 5041 //
     /*  15735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15782 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15786 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15790 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15794 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15798 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15802 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15806 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15810 */     // MIs[5] vB
     /*  15810 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15815 */     // MIs[5] vA
     /*  15815 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15820 */     // MIs[4] vC
     /*  15820 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15825 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15829 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15835 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15837 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15839 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15856 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15866 */     GIR_RootConstrainSelectedInstOperands,
     /*  15867 */     // GIR_Coverage, 5041,
     /*  15867 */     GIR_EraseRootFromParent_Done,
     /*  15868 */   // Label 338: @15868
     /*  15868 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(16006), // Rule ID 5042 //
     /*  15873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15924 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15928 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15932 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15936 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15940 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15944 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15948 */     // MIs[5] vA
     /*  15948 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15953 */     // MIs[5] vC
     /*  15953 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15958 */     // MIs[4] vB
     /*  15958 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15963 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15967 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15973 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15975 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15977 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15994 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16004 */     GIR_RootConstrainSelectedInstOperands,
     /*  16005 */     // GIR_Coverage, 5042,
     /*  16005 */     GIR_EraseRootFromParent_Done,
     /*  16006 */   // Label 339: @16006
     /*  16006 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(16144), // Rule ID 5043 //
     /*  16011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16058 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16062 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16066 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16070 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16074 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16078 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16082 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16086 */     // MIs[5] vC
     /*  16086 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16091 */     // MIs[5] vA
     /*  16091 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16096 */     // MIs[4] vB
     /*  16096 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16101 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16105 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16111 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16113 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16115 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16132 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16142 */     GIR_RootConstrainSelectedInstOperands,
     /*  16143 */     // GIR_Coverage, 5043,
     /*  16143 */     GIR_EraseRootFromParent_Done,
     /*  16144 */   // Label 340: @16144
     /*  16144 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(16282), // Rule ID 5044 //
     /*  16149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16200 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16204 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16208 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16212 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16216 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16220 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16224 */     // MIs[5] vB
     /*  16224 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16229 */     // MIs[5] vC
     /*  16229 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16234 */     // MIs[4] vA
     /*  16234 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16239 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16243 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16249 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16251 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16253 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16270 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16280 */     GIR_RootConstrainSelectedInstOperands,
     /*  16281 */     // GIR_Coverage, 5044,
     /*  16281 */     GIR_EraseRootFromParent_Done,
     /*  16282 */   // Label 341: @16282
     /*  16282 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(16420), // Rule ID 5045 //
     /*  16287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16334 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16338 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16342 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16346 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16350 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16354 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16358 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16362 */     // MIs[5] vC
     /*  16362 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16367 */     // MIs[5] vB
     /*  16367 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16372 */     // MIs[4] vA
     /*  16372 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16377 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16381 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16387 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16389 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16391 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16408 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16418 */     GIR_RootConstrainSelectedInstOperands,
     /*  16419 */     // GIR_Coverage, 5045,
     /*  16419 */     GIR_EraseRootFromParent_Done,
     /*  16420 */   // Label 342: @16420
     /*  16420 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(16558), // Rule ID 5052 //
     /*  16425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16472 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16476 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16480 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16484 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16488 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16492 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16496 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16500 */     // MIs[5] vA
     /*  16500 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16505 */     // MIs[5] vB
     /*  16505 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16510 */     // MIs[4] vC
     /*  16510 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16515 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16519 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16527 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16529 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16546 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16556 */     GIR_RootConstrainSelectedInstOperands,
     /*  16557 */     // GIR_Coverage, 5052,
     /*  16557 */     GIR_EraseRootFromParent_Done,
     /*  16558 */   // Label 343: @16558
     /*  16558 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(16696), // Rule ID 5053 //
     /*  16563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16610 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16614 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16622 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16626 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16630 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16634 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16638 */     // MIs[5] vB
     /*  16638 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16643 */     // MIs[5] vA
     /*  16643 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16648 */     // MIs[4] vC
     /*  16648 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16653 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16657 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16663 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16665 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16667 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16684 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16694 */     GIR_RootConstrainSelectedInstOperands,
     /*  16695 */     // GIR_Coverage, 5053,
     /*  16695 */     GIR_EraseRootFromParent_Done,
     /*  16696 */   // Label 344: @16696
     /*  16696 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(16834), // Rule ID 5054 //
     /*  16701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16748 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16752 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16756 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16760 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16764 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16768 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16772 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16776 */     // MIs[5] vA
     /*  16776 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16781 */     // MIs[5] vC
     /*  16781 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16786 */     // MIs[4] vB
     /*  16786 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16791 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16795 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16801 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16803 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16805 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16822 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16832 */     GIR_RootConstrainSelectedInstOperands,
     /*  16833 */     // GIR_Coverage, 5054,
     /*  16833 */     GIR_EraseRootFromParent_Done,
     /*  16834 */   // Label 345: @16834
     /*  16834 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(16972), // Rule ID 5055 //
     /*  16839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16886 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16890 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16894 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16898 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16902 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16906 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16910 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16914 */     // MIs[5] vC
     /*  16914 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16919 */     // MIs[5] vA
     /*  16919 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16924 */     // MIs[4] vB
     /*  16924 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16929 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16933 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16939 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16941 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16943 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16960 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16970 */     GIR_RootConstrainSelectedInstOperands,
     /*  16971 */     // GIR_Coverage, 5055,
     /*  16971 */     GIR_EraseRootFromParent_Done,
     /*  16972 */   // Label 346: @16972
     /*  16972 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(17110), // Rule ID 5056 //
     /*  16977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17024 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17028 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17032 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17036 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17040 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17044 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17048 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17052 */     // MIs[5] vB
     /*  17052 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17057 */     // MIs[5] vC
     /*  17057 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17062 */     // MIs[4] vA
     /*  17062 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17067 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17071 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17077 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17079 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17081 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  17090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  17094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  17098 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17108 */     GIR_RootConstrainSelectedInstOperands,
     /*  17109 */     // GIR_Coverage, 5056,
     /*  17109 */     GIR_EraseRootFromParent_Done,
     /*  17110 */   // Label 347: @17110
     /*  17110 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(17248), // Rule ID 5057 //
     /*  17115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17162 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17166 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17170 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17174 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17178 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17182 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17186 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17190 */     // MIs[5] vC
     /*  17190 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17195 */     // MIs[5] vB
     /*  17195 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17200 */     // MIs[4] vA
     /*  17200 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17205 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17209 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17215 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17217 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17219 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  17228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  17232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  17236 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17246 */     GIR_RootConstrainSelectedInstOperands,
     /*  17247 */     // GIR_Coverage, 5057,
     /*  17247 */     GIR_EraseRootFromParent_Done,
     /*  17248 */   // Label 348: @17248
     /*  17248 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(17386), // Rule ID 5064 //
     /*  17253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17300 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17304 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17308 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17312 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17316 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17320 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17324 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17328 */     // MIs[5] vA
     /*  17328 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17333 */     // MIs[5] vB
     /*  17333 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17338 */     // MIs[4] vC
     /*  17338 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17343 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17347 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17353 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17355 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17357 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17374 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17384 */     GIR_RootConstrainSelectedInstOperands,
     /*  17385 */     // GIR_Coverage, 5064,
     /*  17385 */     GIR_EraseRootFromParent_Done,
     /*  17386 */   // Label 349: @17386
     /*  17386 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(17524), // Rule ID 5065 //
     /*  17391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17438 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17442 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17446 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17450 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17454 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17458 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17462 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17466 */     // MIs[5] vB
     /*  17466 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17471 */     // MIs[5] vA
     /*  17471 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17476 */     // MIs[4] vC
     /*  17476 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17481 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17485 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17491 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17493 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17495 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17512 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17522 */     GIR_RootConstrainSelectedInstOperands,
     /*  17523 */     // GIR_Coverage, 5065,
     /*  17523 */     GIR_EraseRootFromParent_Done,
     /*  17524 */   // Label 350: @17524
     /*  17524 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(17662), // Rule ID 5066 //
     /*  17529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17576 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17580 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17584 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17588 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17592 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17596 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17600 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17604 */     // MIs[5] vA
     /*  17604 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17609 */     // MIs[5] vC
     /*  17609 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17614 */     // MIs[4] vB
     /*  17614 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17619 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17623 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17629 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17631 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17633 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17650 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17660 */     GIR_RootConstrainSelectedInstOperands,
     /*  17661 */     // GIR_Coverage, 5066,
     /*  17661 */     GIR_EraseRootFromParent_Done,
     /*  17662 */   // Label 351: @17662
     /*  17662 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(17800), // Rule ID 5067 //
     /*  17667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17722 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17726 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17730 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17734 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17738 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17742 */     // MIs[5] vC
     /*  17742 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17747 */     // MIs[5] vA
     /*  17747 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17752 */     // MIs[4] vB
     /*  17752 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17757 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17761 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17767 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17769 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17771 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17788 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17798 */     GIR_RootConstrainSelectedInstOperands,
     /*  17799 */     // GIR_Coverage, 5067,
     /*  17799 */     GIR_EraseRootFromParent_Done,
     /*  17800 */   // Label 352: @17800
     /*  17800 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(17938), // Rule ID 5068 //
     /*  17805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17852 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17856 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17860 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17864 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17868 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17872 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17876 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17880 */     // MIs[5] vB
     /*  17880 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17885 */     // MIs[5] vC
     /*  17885 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17890 */     // MIs[4] vA
     /*  17890 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17895 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17899 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17905 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17907 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17909 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17926 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17936 */     GIR_RootConstrainSelectedInstOperands,
     /*  17937 */     // GIR_Coverage, 5068,
     /*  17937 */     GIR_EraseRootFromParent_Done,
     /*  17938 */   // Label 353: @17938
     /*  17938 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(18076), // Rule ID 5069 //
     /*  17943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17990 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17994 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18002 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18006 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18010 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18014 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18018 */     // MIs[5] vC
     /*  18018 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18023 */     // MIs[5] vB
     /*  18023 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18028 */     // MIs[4] vA
     /*  18028 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18033 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18037 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18045 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18047 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  18056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  18064 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18074 */     GIR_RootConstrainSelectedInstOperands,
     /*  18075 */     // GIR_Coverage, 5069,
     /*  18075 */     GIR_EraseRootFromParent_Done,
     /*  18076 */   // Label 354: @18076
     /*  18076 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(18214), // Rule ID 5076 //
     /*  18081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18128 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18132 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18136 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18140 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18144 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18148 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18152 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18156 */     // MIs[5] vA
     /*  18156 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18161 */     // MIs[5] vB
     /*  18161 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18166 */     // MIs[4] vC
     /*  18166 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18171 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18175 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18181 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18183 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18185 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18202 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18212 */     GIR_RootConstrainSelectedInstOperands,
     /*  18213 */     // GIR_Coverage, 5076,
     /*  18213 */     GIR_EraseRootFromParent_Done,
     /*  18214 */   // Label 355: @18214
     /*  18214 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(18352), // Rule ID 5077 //
     /*  18219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18274 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18278 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18282 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18286 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18290 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18294 */     // MIs[5] vB
     /*  18294 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18299 */     // MIs[5] vA
     /*  18299 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18304 */     // MIs[4] vC
     /*  18304 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18309 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18313 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18319 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18321 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18323 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18340 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18350 */     GIR_RootConstrainSelectedInstOperands,
     /*  18351 */     // GIR_Coverage, 5077,
     /*  18351 */     GIR_EraseRootFromParent_Done,
     /*  18352 */   // Label 356: @18352
     /*  18352 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(18490), // Rule ID 5078 //
     /*  18357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18404 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18408 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18420 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18424 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18428 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18432 */     // MIs[5] vA
     /*  18432 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18437 */     // MIs[5] vC
     /*  18437 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18442 */     // MIs[4] vB
     /*  18442 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18447 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18451 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18457 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18459 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18461 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18478 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18488 */     GIR_RootConstrainSelectedInstOperands,
     /*  18489 */     // GIR_Coverage, 5078,
     /*  18489 */     GIR_EraseRootFromParent_Done,
     /*  18490 */   // Label 357: @18490
     /*  18490 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(18628), // Rule ID 5079 //
     /*  18495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18542 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18546 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18558 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18562 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18566 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18570 */     // MIs[5] vC
     /*  18570 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18575 */     // MIs[5] vA
     /*  18575 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18580 */     // MIs[4] vB
     /*  18580 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18585 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18589 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18597 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18599 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18616 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18626 */     GIR_RootConstrainSelectedInstOperands,
     /*  18627 */     // GIR_Coverage, 5079,
     /*  18627 */     GIR_EraseRootFromParent_Done,
     /*  18628 */   // Label 358: @18628
     /*  18628 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(18766), // Rule ID 5080 //
     /*  18633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18680 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18684 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18688 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18692 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18696 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18700 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18704 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18708 */     // MIs[5] vB
     /*  18708 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18713 */     // MIs[5] vC
     /*  18713 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18718 */     // MIs[4] vA
     /*  18718 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18723 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18727 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18733 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18735 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18737 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18754 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18764 */     GIR_RootConstrainSelectedInstOperands,
     /*  18765 */     // GIR_Coverage, 5080,
     /*  18765 */     GIR_EraseRootFromParent_Done,
     /*  18766 */   // Label 359: @18766
     /*  18766 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(18904), // Rule ID 5081 //
     /*  18771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18818 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18822 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18826 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18830 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18834 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18838 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18842 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18846 */     // MIs[5] vC
     /*  18846 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18851 */     // MIs[5] vB
     /*  18851 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18856 */     // MIs[4] vA
     /*  18856 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18861 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18865 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18871 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18873 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18875 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18892 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18902 */     GIR_RootConstrainSelectedInstOperands,
     /*  18903 */     // GIR_Coverage, 5081,
     /*  18903 */     GIR_EraseRootFromParent_Done,
     /*  18904 */   // Label 360: @18904
     /*  18904 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19042), // Rule ID 5088 //
     /*  18909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18956 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18960 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18964 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18968 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18972 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18976 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18980 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18984 */     // MIs[5] vA
     /*  18984 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18989 */     // MIs[5] vB
     /*  18989 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18994 */     // MIs[4] vC
     /*  18994 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18999 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19003 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19009 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19011 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19013 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19030 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19040 */     GIR_RootConstrainSelectedInstOperands,
     /*  19041 */     // GIR_Coverage, 5088,
     /*  19041 */     GIR_EraseRootFromParent_Done,
     /*  19042 */   // Label 361: @19042
     /*  19042 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(19180), // Rule ID 5089 //
     /*  19047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19094 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19098 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19102 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19106 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19110 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19114 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19118 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19122 */     // MIs[5] vB
     /*  19122 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19127 */     // MIs[5] vA
     /*  19127 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19132 */     // MIs[4] vC
     /*  19132 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19137 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19141 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19147 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19149 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19151 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19168 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19178 */     GIR_RootConstrainSelectedInstOperands,
     /*  19179 */     // GIR_Coverage, 5089,
     /*  19179 */     GIR_EraseRootFromParent_Done,
     /*  19180 */   // Label 362: @19180
     /*  19180 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19318), // Rule ID 5090 //
     /*  19185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19232 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19236 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19240 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19244 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19248 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19252 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19256 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19260 */     // MIs[5] vA
     /*  19260 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19265 */     // MIs[5] vC
     /*  19265 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19270 */     // MIs[4] vB
     /*  19270 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19275 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19279 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19285 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19287 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19289 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19306 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19316 */     GIR_RootConstrainSelectedInstOperands,
     /*  19317 */     // GIR_Coverage, 5090,
     /*  19317 */     GIR_EraseRootFromParent_Done,
     /*  19318 */   // Label 363: @19318
     /*  19318 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19456), // Rule ID 5091 //
     /*  19323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19370 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19374 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19378 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19382 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19386 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19390 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19394 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19398 */     // MIs[5] vC
     /*  19398 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19403 */     // MIs[5] vA
     /*  19403 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19408 */     // MIs[4] vB
     /*  19408 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19413 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19417 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19423 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19425 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19427 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19444 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19454 */     GIR_RootConstrainSelectedInstOperands,
     /*  19455 */     // GIR_Coverage, 5091,
     /*  19455 */     GIR_EraseRootFromParent_Done,
     /*  19456 */   // Label 364: @19456
     /*  19456 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(19594), // Rule ID 5092 //
     /*  19461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19508 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19512 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19516 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19520 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19524 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19528 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19532 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19536 */     // MIs[5] vB
     /*  19536 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19541 */     // MIs[5] vC
     /*  19541 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19546 */     // MIs[4] vA
     /*  19546 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19551 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19555 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19561 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19563 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19565 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19582 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19592 */     GIR_RootConstrainSelectedInstOperands,
     /*  19593 */     // GIR_Coverage, 5092,
     /*  19593 */     GIR_EraseRootFromParent_Done,
     /*  19594 */   // Label 365: @19594
     /*  19594 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19732), // Rule ID 5093 //
     /*  19599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19646 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19650 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19654 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19658 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19662 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19666 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19670 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19674 */     // MIs[5] vC
     /*  19674 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19679 */     // MIs[5] vB
     /*  19679 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19684 */     // MIs[4] vA
     /*  19684 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19689 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19693 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19699 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19701 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19703 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19720 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19730 */     GIR_RootConstrainSelectedInstOperands,
     /*  19731 */     // GIR_Coverage, 5093,
     /*  19731 */     GIR_EraseRootFromParent_Done,
     /*  19732 */   // Label 366: @19732
     /*  19732 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(19870), // Rule ID 5099 //
     /*  19737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19788 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19792 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19796 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19800 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19804 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19808 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19812 */     // MIs[5] vA
     /*  19812 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19817 */     // MIs[5] vB
     /*  19817 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19822 */     // MIs[4] vC
     /*  19822 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19827 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19831 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19837 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19839 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19841 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  19854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  19858 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19868 */     GIR_RootConstrainSelectedInstOperands,
     /*  19869 */     // GIR_Coverage, 5099,
     /*  19869 */     GIR_EraseRootFromParent_Done,
     /*  19870 */   // Label 367: @19870
     /*  19870 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20008), // Rule ID 5100 //
     /*  19875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19922 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19926 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19930 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19934 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19938 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19942 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19946 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19950 */     // MIs[5] vB
     /*  19950 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19955 */     // MIs[5] vA
     /*  19955 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19960 */     // MIs[4] vC
     /*  19960 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19965 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19969 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19975 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19977 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19979 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  19992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  19996 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20006 */     GIR_RootConstrainSelectedInstOperands,
     /*  20007 */     // GIR_Coverage, 5100,
     /*  20007 */     GIR_EraseRootFromParent_Done,
     /*  20008 */   // Label 368: @20008
     /*  20008 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20146), // Rule ID 5101 //
     /*  20013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20060 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20064 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20068 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20072 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20076 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20080 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20084 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20088 */     // MIs[5] vA
     /*  20088 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20093 */     // MIs[5] vC
     /*  20093 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20098 */     // MIs[4] vB
     /*  20098 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20103 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20107 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20113 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20115 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20117 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20134 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20144 */     GIR_RootConstrainSelectedInstOperands,
     /*  20145 */     // GIR_Coverage, 5101,
     /*  20145 */     GIR_EraseRootFromParent_Done,
     /*  20146 */   // Label 369: @20146
     /*  20146 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20284), // Rule ID 5102 //
     /*  20151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20186 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20198 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20202 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20206 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20210 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20214 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20218 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20222 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20226 */     // MIs[5] vC
     /*  20226 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20231 */     // MIs[5] vA
     /*  20231 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20236 */     // MIs[4] vB
     /*  20236 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20241 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20245 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20251 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20253 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20255 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20272 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20282 */     GIR_RootConstrainSelectedInstOperands,
     /*  20283 */     // GIR_Coverage, 5102,
     /*  20283 */     GIR_EraseRootFromParent_Done,
     /*  20284 */   // Label 370: @20284
     /*  20284 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20422), // Rule ID 5103 //
     /*  20289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20336 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20340 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20344 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20348 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20352 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20356 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20360 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20364 */     // MIs[5] vB
     /*  20364 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20369 */     // MIs[5] vC
     /*  20369 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20374 */     // MIs[4] vA
     /*  20374 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20379 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20383 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20391 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20393 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20410 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20420 */     GIR_RootConstrainSelectedInstOperands,
     /*  20421 */     // GIR_Coverage, 5103,
     /*  20421 */     GIR_EraseRootFromParent_Done,
     /*  20422 */   // Label 371: @20422
     /*  20422 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20560), // Rule ID 5104 //
     /*  20427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20474 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20478 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20482 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20486 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20490 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20494 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20498 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20502 */     // MIs[5] vC
     /*  20502 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20507 */     // MIs[5] vB
     /*  20507 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20512 */     // MIs[4] vA
     /*  20512 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20517 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20521 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20527 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20529 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20531 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20548 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20558 */     GIR_RootConstrainSelectedInstOperands,
     /*  20559 */     // GIR_Coverage, 5104,
     /*  20559 */     GIR_EraseRootFromParent_Done,
     /*  20560 */   // Label 372: @20560
     /*  20560 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(20698), // Rule ID 3392 //
     /*  20565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20612 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20616 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20620 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20624 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20628 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20632 */     // MIs[4] vA
     /*  20632 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20637 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20641 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20645 */     // MIs[5] vB
     /*  20645 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20650 */     // MIs[5] vC
     /*  20650 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20655 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20659 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20665 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20667 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20669 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  20682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  20686 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20696 */     GIR_RootConstrainSelectedInstOperands,
     /*  20697 */     // GIR_Coverage, 3392,
     /*  20697 */     GIR_EraseRootFromParent_Done,
     /*  20698 */   // Label 373: @20698
     /*  20698 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(20836), // Rule ID 5046 //
     /*  20703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20738 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20750 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20754 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20758 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20762 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20766 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20770 */     // MIs[4] vC
     /*  20770 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20775 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20779 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20783 */     // MIs[5] vA
     /*  20783 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20788 */     // MIs[5] vB
     /*  20788 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20793 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20797 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20803 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20805 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20807 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  20816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  20824 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20834 */     GIR_RootConstrainSelectedInstOperands,
     /*  20835 */     // GIR_Coverage, 5046,
     /*  20835 */     GIR_EraseRootFromParent_Done,
     /*  20836 */   // Label 374: @20836
     /*  20836 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(20974), // Rule ID 5047 //
     /*  20841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20896 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20900 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20904 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20908 */     // MIs[4] vC
     /*  20908 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20913 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20917 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20921 */     // MIs[5] vB
     /*  20921 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20926 */     // MIs[5] vA
     /*  20926 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20931 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20935 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20941 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20943 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20945 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  20954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  20962 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20972 */     GIR_RootConstrainSelectedInstOperands,
     /*  20973 */     // GIR_Coverage, 5047,
     /*  20973 */     GIR_EraseRootFromParent_Done,
     /*  20974 */   // Label 375: @20974
     /*  20974 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21112), // Rule ID 5048 //
     /*  20979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21026 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21030 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21034 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21038 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21042 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21046 */     // MIs[4] vB
     /*  21046 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21051 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21055 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21059 */     // MIs[5] vA
     /*  21059 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21064 */     // MIs[5] vC
     /*  21064 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21069 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21073 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21079 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21081 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21083 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21100 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21110 */     GIR_RootConstrainSelectedInstOperands,
     /*  21111 */     // GIR_Coverage, 5048,
     /*  21111 */     GIR_EraseRootFromParent_Done,
     /*  21112 */   // Label 376: @21112
     /*  21112 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21250), // Rule ID 5049 //
     /*  21117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21168 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21180 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21184 */     // MIs[4] vB
     /*  21184 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21189 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21193 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21197 */     // MIs[5] vC
     /*  21197 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21202 */     // MIs[5] vA
     /*  21202 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21207 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21211 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21219 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21221 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21238 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21248 */     GIR_RootConstrainSelectedInstOperands,
     /*  21249 */     // GIR_Coverage, 5049,
     /*  21249 */     GIR_EraseRootFromParent_Done,
     /*  21250 */   // Label 377: @21250
     /*  21250 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21388), // Rule ID 5050 //
     /*  21255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21290 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21302 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21306 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21310 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21314 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21318 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21322 */     // MIs[4] vA
     /*  21322 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21327 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21331 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21335 */     // MIs[5] vB
     /*  21335 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21340 */     // MIs[5] vC
     /*  21340 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21345 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21349 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21355 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21357 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21359 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21376 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21386 */     GIR_RootConstrainSelectedInstOperands,
     /*  21387 */     // GIR_Coverage, 5050,
     /*  21387 */     GIR_EraseRootFromParent_Done,
     /*  21388 */   // Label 378: @21388
     /*  21388 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21526), // Rule ID 5051 //
     /*  21393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21440 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21444 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21448 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21452 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21456 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21460 */     // MIs[4] vA
     /*  21460 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21465 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21469 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21473 */     // MIs[5] vC
     /*  21473 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21478 */     // MIs[5] vB
     /*  21478 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21483 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21487 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21493 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21495 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21497 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21514 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21524 */     GIR_RootConstrainSelectedInstOperands,
     /*  21525 */     // GIR_Coverage, 5051,
     /*  21525 */     GIR_EraseRootFromParent_Done,
     /*  21526 */   // Label 379: @21526
     /*  21526 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21664), // Rule ID 5058 //
     /*  21531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21578 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21582 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21586 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21590 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21594 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21598 */     // MIs[4] vC
     /*  21598 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21603 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21607 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21611 */     // MIs[5] vA
     /*  21611 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21616 */     // MIs[5] vB
     /*  21616 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21621 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21625 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21631 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21633 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21635 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21652 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21662 */     GIR_RootConstrainSelectedInstOperands,
     /*  21663 */     // GIR_Coverage, 5058,
     /*  21663 */     GIR_EraseRootFromParent_Done,
     /*  21664 */   // Label 380: @21664
     /*  21664 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(21802), // Rule ID 5059 //
     /*  21669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21716 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21720 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21724 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21728 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21732 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21736 */     // MIs[4] vC
     /*  21736 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21741 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21745 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21749 */     // MIs[5] vB
     /*  21749 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21754 */     // MIs[5] vA
     /*  21754 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21759 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21763 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21769 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21771 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21773 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21790 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21800 */     GIR_RootConstrainSelectedInstOperands,
     /*  21801 */     // GIR_Coverage, 5059,
     /*  21801 */     GIR_EraseRootFromParent_Done,
     /*  21802 */   // Label 381: @21802
     /*  21802 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(21940), // Rule ID 5060 //
     /*  21807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21854 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21858 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21862 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21866 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21870 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21874 */     // MIs[4] vB
     /*  21874 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21879 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21883 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21887 */     // MIs[5] vA
     /*  21887 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21892 */     // MIs[5] vC
     /*  21892 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21897 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21901 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21909 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21911 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21928 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21938 */     GIR_RootConstrainSelectedInstOperands,
     /*  21939 */     // GIR_Coverage, 5060,
     /*  21939 */     GIR_EraseRootFromParent_Done,
     /*  21940 */   // Label 382: @21940
     /*  21940 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22078), // Rule ID 5061 //
     /*  21945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21992 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21996 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22000 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22004 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22008 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22012 */     // MIs[4] vB
     /*  22012 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22017 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22021 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22025 */     // MIs[5] vC
     /*  22025 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22030 */     // MIs[5] vA
     /*  22030 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22035 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22039 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22045 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22047 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22049 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22066 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22076 */     GIR_RootConstrainSelectedInstOperands,
     /*  22077 */     // GIR_Coverage, 5061,
     /*  22077 */     GIR_EraseRootFromParent_Done,
     /*  22078 */   // Label 383: @22078
     /*  22078 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22216), // Rule ID 5062 //
     /*  22083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22130 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22134 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22142 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22146 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22150 */     // MIs[4] vA
     /*  22150 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22155 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22159 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22163 */     // MIs[5] vB
     /*  22163 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22168 */     // MIs[5] vC
     /*  22168 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22173 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22177 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22183 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22185 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22187 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22204 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22214 */     GIR_RootConstrainSelectedInstOperands,
     /*  22215 */     // GIR_Coverage, 5062,
     /*  22215 */     GIR_EraseRootFromParent_Done,
     /*  22216 */   // Label 384: @22216
     /*  22216 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22354), // Rule ID 5063 //
     /*  22221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22268 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22272 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22276 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22280 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22284 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22288 */     // MIs[4] vA
     /*  22288 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22293 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22297 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22301 */     // MIs[5] vC
     /*  22301 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22306 */     // MIs[5] vB
     /*  22306 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22311 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22315 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22321 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22323 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22325 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22342 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22352 */     GIR_RootConstrainSelectedInstOperands,
     /*  22353 */     // GIR_Coverage, 5063,
     /*  22353 */     GIR_EraseRootFromParent_Done,
     /*  22354 */   // Label 385: @22354
     /*  22354 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22492), // Rule ID 5070 //
     /*  22359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22406 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22410 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22414 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22418 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22422 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22426 */     // MIs[4] vC
     /*  22426 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22431 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22435 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22439 */     // MIs[5] vA
     /*  22439 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22444 */     // MIs[5] vB
     /*  22444 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22449 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22453 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22461 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22463 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22480 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22490 */     GIR_RootConstrainSelectedInstOperands,
     /*  22491 */     // GIR_Coverage, 5070,
     /*  22491 */     GIR_EraseRootFromParent_Done,
     /*  22492 */   // Label 386: @22492
     /*  22492 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22630), // Rule ID 5071 //
     /*  22497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22544 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22548 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22552 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22556 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22560 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22564 */     // MIs[4] vC
     /*  22564 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22569 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22573 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22577 */     // MIs[5] vB
     /*  22577 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22582 */     // MIs[5] vA
     /*  22582 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22587 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22591 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22597 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22599 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22601 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22618 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22628 */     GIR_RootConstrainSelectedInstOperands,
     /*  22629 */     // GIR_Coverage, 5071,
     /*  22629 */     GIR_EraseRootFromParent_Done,
     /*  22630 */   // Label 387: @22630
     /*  22630 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22768), // Rule ID 5072 //
     /*  22635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22682 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22686 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22690 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22694 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22698 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22702 */     // MIs[4] vB
     /*  22702 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22707 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22711 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22715 */     // MIs[5] vA
     /*  22715 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22720 */     // MIs[5] vC
     /*  22720 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22725 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22729 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22737 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22739 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22756 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22766 */     GIR_RootConstrainSelectedInstOperands,
     /*  22767 */     // GIR_Coverage, 5072,
     /*  22767 */     GIR_EraseRootFromParent_Done,
     /*  22768 */   // Label 388: @22768
     /*  22768 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22906), // Rule ID 5073 //
     /*  22773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22820 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22824 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22828 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22832 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22836 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22840 */     // MIs[4] vB
     /*  22840 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22845 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22849 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22853 */     // MIs[5] vC
     /*  22853 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22858 */     // MIs[5] vA
     /*  22858 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22863 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22867 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22873 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22875 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22877 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22894 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22904 */     GIR_RootConstrainSelectedInstOperands,
     /*  22905 */     // GIR_Coverage, 5073,
     /*  22905 */     GIR_EraseRootFromParent_Done,
     /*  22906 */   // Label 389: @22906
     /*  22906 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23044), // Rule ID 5074 //
     /*  22911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22978 */     // MIs[4] vA
     /*  22978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22983 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22987 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22991 */     // MIs[5] vB
     /*  22991 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22996 */     // MIs[5] vC
     /*  22996 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23001 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23005 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23011 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23013 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23015 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  23024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  23032 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23042 */     GIR_RootConstrainSelectedInstOperands,
     /*  23043 */     // GIR_Coverage, 5074,
     /*  23043 */     GIR_EraseRootFromParent_Done,
     /*  23044 */   // Label 390: @23044
     /*  23044 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23182), // Rule ID 5075 //
     /*  23049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23096 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23100 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23108 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23112 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23116 */     // MIs[4] vA
     /*  23116 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23121 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23125 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23129 */     // MIs[5] vC
     /*  23129 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23134 */     // MIs[5] vB
     /*  23134 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23139 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23143 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23149 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23151 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23153 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  23162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  23170 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23180 */     GIR_RootConstrainSelectedInstOperands,
     /*  23181 */     // GIR_Coverage, 5075,
     /*  23181 */     GIR_EraseRootFromParent_Done,
     /*  23182 */   // Label 391: @23182
     /*  23182 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23320), // Rule ID 5082 //
     /*  23187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23234 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23238 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23242 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23246 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23250 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23254 */     // MIs[4] vC
     /*  23254 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23259 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23263 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23267 */     // MIs[5] vA
     /*  23267 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23272 */     // MIs[5] vB
     /*  23272 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23277 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23281 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23287 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23289 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23291 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23308 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23318 */     GIR_RootConstrainSelectedInstOperands,
     /*  23319 */     // GIR_Coverage, 5082,
     /*  23319 */     GIR_EraseRootFromParent_Done,
     /*  23320 */   // Label 392: @23320
     /*  23320 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23458), // Rule ID 5083 //
     /*  23325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23372 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23376 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23380 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23384 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23388 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23392 */     // MIs[4] vC
     /*  23392 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23397 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23401 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23405 */     // MIs[5] vB
     /*  23405 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23410 */     // MIs[5] vA
     /*  23410 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23415 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23419 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23425 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23427 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23429 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23446 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23456 */     GIR_RootConstrainSelectedInstOperands,
     /*  23457 */     // GIR_Coverage, 5083,
     /*  23457 */     GIR_EraseRootFromParent_Done,
     /*  23458 */   // Label 393: @23458
     /*  23458 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23596), // Rule ID 5084 //
     /*  23463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23510 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23514 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23518 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23522 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23526 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23530 */     // MIs[4] vB
     /*  23530 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23535 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23539 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23543 */     // MIs[5] vA
     /*  23543 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23548 */     // MIs[5] vC
     /*  23548 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23553 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23557 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23563 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23565 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23567 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23584 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23594 */     GIR_RootConstrainSelectedInstOperands,
     /*  23595 */     // GIR_Coverage, 5084,
     /*  23595 */     GIR_EraseRootFromParent_Done,
     /*  23596 */   // Label 394: @23596
     /*  23596 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23734), // Rule ID 5085 //
     /*  23601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23644 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23648 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23652 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23656 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23660 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23664 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23668 */     // MIs[4] vB
     /*  23668 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23673 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23677 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23681 */     // MIs[5] vC
     /*  23681 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23686 */     // MIs[5] vA
     /*  23686 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23691 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23695 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23701 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23703 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23705 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23722 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23732 */     GIR_RootConstrainSelectedInstOperands,
     /*  23733 */     // GIR_Coverage, 5085,
     /*  23733 */     GIR_EraseRootFromParent_Done,
     /*  23734 */   // Label 395: @23734
     /*  23734 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23872), // Rule ID 5086 //
     /*  23739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23786 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23790 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23794 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23798 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23802 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23806 */     // MIs[4] vA
     /*  23806 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23811 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23815 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23819 */     // MIs[5] vB
     /*  23819 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23824 */     // MIs[5] vC
     /*  23824 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23829 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23833 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23839 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23841 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23843 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23860 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23870 */     GIR_RootConstrainSelectedInstOperands,
     /*  23871 */     // GIR_Coverage, 5086,
     /*  23871 */     GIR_EraseRootFromParent_Done,
     /*  23872 */   // Label 396: @23872
     /*  23872 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24010), // Rule ID 5087 //
     /*  23877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23924 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23928 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23932 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23936 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23940 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23944 */     // MIs[4] vA
     /*  23944 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23949 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23953 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23957 */     // MIs[5] vC
     /*  23957 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23962 */     // MIs[5] vB
     /*  23962 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23967 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23971 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23977 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23979 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23981 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23998 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24008 */     GIR_RootConstrainSelectedInstOperands,
     /*  24009 */     // GIR_Coverage, 5087,
     /*  24009 */     GIR_EraseRootFromParent_Done,
     /*  24010 */   // Label 397: @24010
     /*  24010 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24148), // Rule ID 5094 //
     /*  24015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24066 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24070 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24074 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24078 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24082 */     // MIs[4] vC
     /*  24082 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24087 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24091 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24095 */     // MIs[5] vA
     /*  24095 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24100 */     // MIs[5] vB
     /*  24100 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24105 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24109 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24115 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24117 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24119 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24136 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24146 */     GIR_RootConstrainSelectedInstOperands,
     /*  24147 */     // GIR_Coverage, 5094,
     /*  24147 */     GIR_EraseRootFromParent_Done,
     /*  24148 */   // Label 398: @24148
     /*  24148 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24286), // Rule ID 5095 //
     /*  24153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24200 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24204 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24208 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24212 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24216 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24220 */     // MIs[4] vC
     /*  24220 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24225 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24229 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24233 */     // MIs[5] vB
     /*  24233 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24238 */     // MIs[5] vA
     /*  24238 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24243 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24247 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24253 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24255 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24257 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24274 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24284 */     GIR_RootConstrainSelectedInstOperands,
     /*  24285 */     // GIR_Coverage, 5095,
     /*  24285 */     GIR_EraseRootFromParent_Done,
     /*  24286 */   // Label 399: @24286
     /*  24286 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24424), // Rule ID 5096 //
     /*  24291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24338 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24342 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24346 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24350 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24354 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24358 */     // MIs[4] vB
     /*  24358 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24363 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24367 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24371 */     // MIs[5] vA
     /*  24371 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24376 */     // MIs[5] vC
     /*  24376 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24381 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24385 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24391 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24393 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24395 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24412 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24422 */     GIR_RootConstrainSelectedInstOperands,
     /*  24423 */     // GIR_Coverage, 5096,
     /*  24423 */     GIR_EraseRootFromParent_Done,
     /*  24424 */   // Label 400: @24424
     /*  24424 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24562), // Rule ID 5097 //
     /*  24429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24476 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24480 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24484 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24488 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24492 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24496 */     // MIs[4] vB
     /*  24496 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24501 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24505 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24509 */     // MIs[5] vC
     /*  24509 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24514 */     // MIs[5] vA
     /*  24514 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24519 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24523 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24529 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24531 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24533 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24550 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24560 */     GIR_RootConstrainSelectedInstOperands,
     /*  24561 */     // GIR_Coverage, 5097,
     /*  24561 */     GIR_EraseRootFromParent_Done,
     /*  24562 */   // Label 401: @24562
     /*  24562 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24700), // Rule ID 5098 //
     /*  24567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24614 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24618 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24622 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24626 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24630 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24634 */     // MIs[4] vA
     /*  24634 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24639 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24643 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24647 */     // MIs[5] vC
     /*  24647 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24652 */     // MIs[5] vB
     /*  24652 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24657 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24661 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24667 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24669 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24671 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24688 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24698 */     GIR_RootConstrainSelectedInstOperands,
     /*  24699 */     // GIR_Coverage, 5098,
     /*  24699 */     GIR_EraseRootFromParent_Done,
     /*  24700 */   // Label 402: @24700
     /*  24700 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24838), // Rule ID 5105 //
     /*  24705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24752 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24756 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24760 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24764 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24768 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24772 */     // MIs[4] vC
     /*  24772 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24777 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24781 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24785 */     // MIs[5] vA
     /*  24785 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24790 */     // MIs[5] vB
     /*  24790 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24795 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24799 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24805 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24807 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24809 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  24822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  24826 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24836 */     GIR_RootConstrainSelectedInstOperands,
     /*  24837 */     // GIR_Coverage, 5105,
     /*  24837 */     GIR_EraseRootFromParent_Done,
     /*  24838 */   // Label 403: @24838
     /*  24838 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24976), // Rule ID 5106 //
     /*  24843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24890 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24894 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24898 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24902 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24906 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24910 */     // MIs[4] vC
     /*  24910 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24915 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24919 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24923 */     // MIs[5] vB
     /*  24923 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24928 */     // MIs[5] vA
     /*  24928 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24933 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24937 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24943 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24945 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24947 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  24960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  24964 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24974 */     GIR_RootConstrainSelectedInstOperands,
     /*  24975 */     // GIR_Coverage, 5106,
     /*  24975 */     GIR_EraseRootFromParent_Done,
     /*  24976 */   // Label 404: @24976
     /*  24976 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(25114), // Rule ID 5107 //
     /*  24981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25028 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25032 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25036 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25040 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25044 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25048 */     // MIs[4] vB
     /*  25048 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25053 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25057 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25061 */     // MIs[5] vA
     /*  25061 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25066 */     // MIs[5] vC
     /*  25066 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25071 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25075 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25083 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25085 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25102 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25112 */     GIR_RootConstrainSelectedInstOperands,
     /*  25113 */     // GIR_Coverage, 5107,
     /*  25113 */     GIR_EraseRootFromParent_Done,
     /*  25114 */   // Label 405: @25114
     /*  25114 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(25252), // Rule ID 5108 //
     /*  25119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25166 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25170 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25174 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25178 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25182 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25186 */     // MIs[4] vB
     /*  25186 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25191 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25195 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25199 */     // MIs[5] vC
     /*  25199 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25204 */     // MIs[5] vA
     /*  25204 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25209 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25213 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25219 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25221 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25223 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25240 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25250 */     GIR_RootConstrainSelectedInstOperands,
     /*  25251 */     // GIR_Coverage, 5108,
     /*  25251 */     GIR_EraseRootFromParent_Done,
     /*  25252 */   // Label 406: @25252
     /*  25252 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(25390), // Rule ID 5109 //
     /*  25257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25304 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25308 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25312 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25316 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25320 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25324 */     // MIs[4] vA
     /*  25324 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25329 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25333 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25337 */     // MIs[5] vB
     /*  25337 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25342 */     // MIs[5] vC
     /*  25342 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25347 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25351 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25357 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25359 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25361 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25378 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25388 */     GIR_RootConstrainSelectedInstOperands,
     /*  25389 */     // GIR_Coverage, 5109,
     /*  25389 */     GIR_EraseRootFromParent_Done,
     /*  25390 */   // Label 407: @25390
     /*  25390 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(25528), // Rule ID 5110 //
     /*  25395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25442 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25446 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25450 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25454 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25458 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25462 */     // MIs[4] vA
     /*  25462 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25467 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25471 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25475 */     // MIs[5] vC
     /*  25475 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25480 */     // MIs[5] vB
     /*  25480 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25485 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25489 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25495 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25497 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25499 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25516 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25526 */     GIR_RootConstrainSelectedInstOperands,
     /*  25527 */     // GIR_Coverage, 5110,
     /*  25527 */     GIR_EraseRootFromParent_Done,
     /*  25528 */   // Label 408: @25528
     /*  25528 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(25666), // Rule ID 5111 //
     /*  25533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25580 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25584 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25592 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25598 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25600 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25604 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25608 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25612 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25616 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25620 */     // MIs[6] vA
     /*  25620 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25625 */     // MIs[6] vB
     /*  25625 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25630 */     // MIs[5] vC
     /*  25630 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25635 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25637 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25654 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25664 */     GIR_RootConstrainSelectedInstOperands,
     /*  25665 */     // GIR_Coverage, 5111,
     /*  25665 */     GIR_EraseRootFromParent_Done,
     /*  25666 */   // Label 409: @25666
     /*  25666 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(25804), // Rule ID 5112 //
     /*  25671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25718 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25722 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25726 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25730 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25736 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25738 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25742 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25746 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25750 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25754 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25758 */     // MIs[6] vB
     /*  25758 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25763 */     // MIs[6] vA
     /*  25763 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25768 */     // MIs[5] vC
     /*  25768 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25773 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25775 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25792 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25802 */     GIR_RootConstrainSelectedInstOperands,
     /*  25803 */     // GIR_Coverage, 5112,
     /*  25803 */     GIR_EraseRootFromParent_Done,
     /*  25804 */   // Label 410: @25804
     /*  25804 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(25942), // Rule ID 5113 //
     /*  25809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25856 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25860 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25864 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25868 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25874 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25876 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25880 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25884 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25888 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25892 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25896 */     // MIs[6] vA
     /*  25896 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25901 */     // MIs[6] vC
     /*  25901 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25906 */     // MIs[5] vB
     /*  25906 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25911 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25913 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25930 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25940 */     GIR_RootConstrainSelectedInstOperands,
     /*  25941 */     // GIR_Coverage, 5113,
     /*  25941 */     GIR_EraseRootFromParent_Done,
     /*  25942 */   // Label 411: @25942
     /*  25942 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(26080), // Rule ID 5114 //
     /*  25947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25994 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25998 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26002 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26006 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26014 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26018 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26022 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26026 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26030 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26034 */     // MIs[6] vC
     /*  26034 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26039 */     // MIs[6] vA
     /*  26039 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26044 */     // MIs[5] vB
     /*  26044 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26049 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26051 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26068 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26078 */     GIR_RootConstrainSelectedInstOperands,
     /*  26079 */     // GIR_Coverage, 5114,
     /*  26079 */     GIR_EraseRootFromParent_Done,
     /*  26080 */   // Label 412: @26080
     /*  26080 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(26218), // Rule ID 5115 //
     /*  26085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26132 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26136 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26140 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26144 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26150 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26152 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26156 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26160 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26164 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26168 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26172 */     // MIs[6] vB
     /*  26172 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26177 */     // MIs[6] vC
     /*  26177 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26182 */     // MIs[5] vA
     /*  26182 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26187 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26189 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26206 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26216 */     GIR_RootConstrainSelectedInstOperands,
     /*  26217 */     // GIR_Coverage, 5115,
     /*  26217 */     GIR_EraseRootFromParent_Done,
     /*  26218 */   // Label 413: @26218
     /*  26218 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(26356), // Rule ID 5116 //
     /*  26223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26270 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26274 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26278 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26282 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26288 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26290 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26294 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26298 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26302 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26306 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26310 */     // MIs[6] vC
     /*  26310 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26315 */     // MIs[6] vB
     /*  26315 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26320 */     // MIs[5] vA
     /*  26320 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26325 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26327 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26344 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26354 */     GIR_RootConstrainSelectedInstOperands,
     /*  26355 */     // GIR_Coverage, 5116,
     /*  26355 */     GIR_EraseRootFromParent_Done,
     /*  26356 */   // Label 414: @26356
     /*  26356 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(26494), // Rule ID 5123 //
     /*  26361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26408 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26412 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26416 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26420 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26426 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26428 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26432 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26436 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26440 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26444 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26448 */     // MIs[6] vA
     /*  26448 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26453 */     // MIs[6] vB
     /*  26453 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26458 */     // MIs[5] vC
     /*  26458 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26463 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26465 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26482 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26492 */     GIR_RootConstrainSelectedInstOperands,
     /*  26493 */     // GIR_Coverage, 5123,
     /*  26493 */     GIR_EraseRootFromParent_Done,
     /*  26494 */   // Label 415: @26494
     /*  26494 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(26632), // Rule ID 5124 //
     /*  26499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26546 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26550 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26554 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26558 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26566 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26570 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26574 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26578 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26582 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26586 */     // MIs[6] vB
     /*  26586 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26591 */     // MIs[6] vA
     /*  26591 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26596 */     // MIs[5] vC
     /*  26596 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26601 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26603 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26620 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26630 */     GIR_RootConstrainSelectedInstOperands,
     /*  26631 */     // GIR_Coverage, 5124,
     /*  26631 */     GIR_EraseRootFromParent_Done,
     /*  26632 */   // Label 416: @26632
     /*  26632 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(26770), // Rule ID 5125 //
     /*  26637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26684 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26688 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26692 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26696 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26702 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26704 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26708 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26712 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26716 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26720 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26724 */     // MIs[6] vA
     /*  26724 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26729 */     // MIs[6] vC
     /*  26729 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26734 */     // MIs[5] vB
     /*  26734 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26739 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26741 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26758 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26768 */     GIR_RootConstrainSelectedInstOperands,
     /*  26769 */     // GIR_Coverage, 5125,
     /*  26769 */     GIR_EraseRootFromParent_Done,
     /*  26770 */   // Label 417: @26770
     /*  26770 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(26908), // Rule ID 5126 //
     /*  26775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26826 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26830 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26834 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26840 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26842 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26846 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26850 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26854 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26858 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26862 */     // MIs[6] vC
     /*  26862 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26867 */     // MIs[6] vA
     /*  26867 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26872 */     // MIs[5] vB
     /*  26872 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26877 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26879 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26896 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26906 */     GIR_RootConstrainSelectedInstOperands,
     /*  26907 */     // GIR_Coverage, 5126,
     /*  26907 */     GIR_EraseRootFromParent_Done,
     /*  26908 */   // Label 418: @26908
     /*  26908 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(27046), // Rule ID 5127 //
     /*  26913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26960 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26964 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26968 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26972 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26978 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26980 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26984 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26988 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26992 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26996 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27000 */     // MIs[6] vB
     /*  27000 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27005 */     // MIs[6] vC
     /*  27005 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27010 */     // MIs[5] vA
     /*  27010 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27015 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27017 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  27026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  27030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  27034 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27044 */     GIR_RootConstrainSelectedInstOperands,
     /*  27045 */     // GIR_Coverage, 5127,
     /*  27045 */     GIR_EraseRootFromParent_Done,
     /*  27046 */   // Label 419: @27046
     /*  27046 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(27184), // Rule ID 5128 //
     /*  27051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27098 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27102 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27106 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27110 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27118 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27122 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27126 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27130 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27134 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27138 */     // MIs[6] vC
     /*  27138 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27143 */     // MIs[6] vB
     /*  27143 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27148 */     // MIs[5] vA
     /*  27148 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27153 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27155 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  27164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  27168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  27172 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27182 */     GIR_RootConstrainSelectedInstOperands,
     /*  27183 */     // GIR_Coverage, 5128,
     /*  27183 */     GIR_EraseRootFromParent_Done,
     /*  27184 */   // Label 420: @27184
     /*  27184 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(27322), // Rule ID 5135 //
     /*  27189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27236 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27240 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27244 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27248 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27254 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27256 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27260 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27264 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27268 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27272 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27276 */     // MIs[6] vA
     /*  27276 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27281 */     // MIs[6] vB
     /*  27281 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27286 */     // MIs[5] vC
     /*  27286 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27291 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27293 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27310 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27320 */     GIR_RootConstrainSelectedInstOperands,
     /*  27321 */     // GIR_Coverage, 5135,
     /*  27321 */     GIR_EraseRootFromParent_Done,
     /*  27322 */   // Label 421: @27322
     /*  27322 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(27460), // Rule ID 5136 //
     /*  27327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27374 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27378 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27382 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27386 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27394 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27398 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27402 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27406 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27410 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27414 */     // MIs[6] vB
     /*  27414 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27419 */     // MIs[6] vA
     /*  27419 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27424 */     // MIs[5] vC
     /*  27424 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27429 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27431 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27448 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27458 */     GIR_RootConstrainSelectedInstOperands,
     /*  27459 */     // GIR_Coverage, 5136,
     /*  27459 */     GIR_EraseRootFromParent_Done,
     /*  27460 */   // Label 422: @27460
     /*  27460 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(27598), // Rule ID 5137 //
     /*  27465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27512 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27516 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27520 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27524 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27530 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27532 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27536 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27540 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27544 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27548 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27552 */     // MIs[6] vA
     /*  27552 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27557 */     // MIs[6] vC
     /*  27557 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27562 */     // MIs[5] vB
     /*  27562 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27567 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27569 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27586 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27596 */     GIR_RootConstrainSelectedInstOperands,
     /*  27597 */     // GIR_Coverage, 5137,
     /*  27597 */     GIR_EraseRootFromParent_Done,
     /*  27598 */   // Label 423: @27598
     /*  27598 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(27736), // Rule ID 5138 //
     /*  27603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27650 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27654 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27658 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27662 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27668 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27670 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27674 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27678 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27682 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27686 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27690 */     // MIs[6] vC
     /*  27690 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27695 */     // MIs[6] vA
     /*  27695 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27700 */     // MIs[5] vB
     /*  27700 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27705 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27707 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27724 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27734 */     GIR_RootConstrainSelectedInstOperands,
     /*  27735 */     // GIR_Coverage, 5138,
     /*  27735 */     GIR_EraseRootFromParent_Done,
     /*  27736 */   // Label 424: @27736
     /*  27736 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(27874), // Rule ID 5139 //
     /*  27741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27788 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27792 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27796 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27800 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27806 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27808 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27812 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27816 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27820 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27824 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27828 */     // MIs[6] vB
     /*  27828 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27833 */     // MIs[6] vC
     /*  27833 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27838 */     // MIs[5] vA
     /*  27838 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27843 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27845 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27862 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27872 */     GIR_RootConstrainSelectedInstOperands,
     /*  27873 */     // GIR_Coverage, 5139,
     /*  27873 */     GIR_EraseRootFromParent_Done,
     /*  27874 */   // Label 425: @27874
     /*  27874 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(28012), // Rule ID 5140 //
     /*  27879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27926 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27930 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27934 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27938 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27944 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27946 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27950 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27954 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27958 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27962 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27966 */     // MIs[6] vC
     /*  27966 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27971 */     // MIs[6] vB
     /*  27971 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27976 */     // MIs[5] vA
     /*  27976 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27981 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27983 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  28000 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28010 */     GIR_RootConstrainSelectedInstOperands,
     /*  28011 */     // GIR_Coverage, 5140,
     /*  28011 */     GIR_EraseRootFromParent_Done,
     /*  28012 */   // Label 426: @28012
     /*  28012 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(28150), // Rule ID 5147 //
     /*  28017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28064 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28068 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28072 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28076 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28082 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28084 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28088 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28092 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28096 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28100 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28104 */     // MIs[6] vA
     /*  28104 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28109 */     // MIs[6] vB
     /*  28109 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28114 */     // MIs[5] vC
     /*  28114 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28119 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28121 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28138 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28148 */     GIR_RootConstrainSelectedInstOperands,
     /*  28149 */     // GIR_Coverage, 5147,
     /*  28149 */     GIR_EraseRootFromParent_Done,
     /*  28150 */   // Label 427: @28150
     /*  28150 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(28288), // Rule ID 5148 //
     /*  28155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28202 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28206 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28210 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28214 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28220 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28222 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28226 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28230 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28234 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28238 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28242 */     // MIs[6] vB
     /*  28242 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28247 */     // MIs[6] vA
     /*  28247 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28252 */     // MIs[5] vC
     /*  28252 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28257 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28259 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28276 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28286 */     GIR_RootConstrainSelectedInstOperands,
     /*  28287 */     // GIR_Coverage, 5148,
     /*  28287 */     GIR_EraseRootFromParent_Done,
     /*  28288 */   // Label 428: @28288
     /*  28288 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(28426), // Rule ID 5149 //
     /*  28293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28340 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28344 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28348 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28352 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28358 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28360 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28364 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28368 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28372 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28376 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28380 */     // MIs[6] vA
     /*  28380 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28385 */     // MIs[6] vC
     /*  28385 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28390 */     // MIs[5] vB
     /*  28390 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28395 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28397 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28414 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28424 */     GIR_RootConstrainSelectedInstOperands,
     /*  28425 */     // GIR_Coverage, 5149,
     /*  28425 */     GIR_EraseRootFromParent_Done,
     /*  28426 */   // Label 429: @28426
     /*  28426 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(28564), // Rule ID 5150 //
     /*  28431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28478 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28482 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28486 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28490 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28496 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28498 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28502 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28506 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28510 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28514 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28518 */     // MIs[6] vC
     /*  28518 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28523 */     // MIs[6] vA
     /*  28523 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28528 */     // MIs[5] vB
     /*  28528 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28533 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28535 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28552 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28562 */     GIR_RootConstrainSelectedInstOperands,
     /*  28563 */     // GIR_Coverage, 5150,
     /*  28563 */     GIR_EraseRootFromParent_Done,
     /*  28564 */   // Label 430: @28564
     /*  28564 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(28702), // Rule ID 5151 //
     /*  28569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28616 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28620 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28624 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28628 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28634 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28636 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28640 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28644 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28648 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28652 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28656 */     // MIs[6] vB
     /*  28656 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28661 */     // MIs[6] vC
     /*  28661 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28666 */     // MIs[5] vA
     /*  28666 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28671 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28673 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28690 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28700 */     GIR_RootConstrainSelectedInstOperands,
     /*  28701 */     // GIR_Coverage, 5151,
     /*  28701 */     GIR_EraseRootFromParent_Done,
     /*  28702 */   // Label 431: @28702
     /*  28702 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(28840), // Rule ID 5152 //
     /*  28707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28754 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28758 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28762 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28766 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28772 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28774 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28778 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28782 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28786 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28790 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28794 */     // MIs[6] vC
     /*  28794 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28799 */     // MIs[6] vB
     /*  28799 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28804 */     // MIs[5] vA
     /*  28804 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28809 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28811 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28828 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28838 */     GIR_RootConstrainSelectedInstOperands,
     /*  28839 */     // GIR_Coverage, 5152,
     /*  28839 */     GIR_EraseRootFromParent_Done,
     /*  28840 */   // Label 432: @28840
     /*  28840 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(28978), // Rule ID 5159 //
     /*  28845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28896 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28900 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28904 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28910 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28912 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28916 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28920 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28924 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28928 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28932 */     // MIs[6] vA
     /*  28932 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28937 */     // MIs[6] vB
     /*  28937 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28942 */     // MIs[5] vC
     /*  28942 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28947 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28949 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  28958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  28962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  28966 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28976 */     GIR_RootConstrainSelectedInstOperands,
     /*  28977 */     // GIR_Coverage, 5159,
     /*  28977 */     GIR_EraseRootFromParent_Done,
     /*  28978 */   // Label 433: @28978
     /*  28978 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(29116), // Rule ID 5160 //
     /*  28983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29030 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29034 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29038 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29042 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29048 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29050 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29054 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29058 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29062 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29066 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29070 */     // MIs[6] vB
     /*  29070 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29075 */     // MIs[6] vA
     /*  29075 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29080 */     // MIs[5] vC
     /*  29080 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29085 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29087 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29104 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29114 */     GIR_RootConstrainSelectedInstOperands,
     /*  29115 */     // GIR_Coverage, 5160,
     /*  29115 */     GIR_EraseRootFromParent_Done,
     /*  29116 */   // Label 434: @29116
     /*  29116 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(29254), // Rule ID 5161 //
     /*  29121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29168 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29172 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29176 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29180 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29186 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29188 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29192 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29196 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29200 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29204 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29208 */     // MIs[6] vA
     /*  29208 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29213 */     // MIs[6] vC
     /*  29213 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29218 */     // MIs[5] vB
     /*  29218 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29223 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29225 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29242 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29252 */     GIR_RootConstrainSelectedInstOperands,
     /*  29253 */     // GIR_Coverage, 5161,
     /*  29253 */     GIR_EraseRootFromParent_Done,
     /*  29254 */   // Label 435: @29254
     /*  29254 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(29392), // Rule ID 5162 //
     /*  29259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29306 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29310 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29314 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29318 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29324 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29326 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29330 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29334 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29338 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29342 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29346 */     // MIs[6] vC
     /*  29346 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29351 */     // MIs[6] vA
     /*  29351 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29356 */     // MIs[5] vB
     /*  29356 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29361 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29363 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29380 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29390 */     GIR_RootConstrainSelectedInstOperands,
     /*  29391 */     // GIR_Coverage, 5162,
     /*  29391 */     GIR_EraseRootFromParent_Done,
     /*  29392 */   // Label 436: @29392
     /*  29392 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(29530), // Rule ID 5163 //
     /*  29397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29444 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29448 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29452 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29456 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29462 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29464 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29468 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29472 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29476 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29480 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29484 */     // MIs[6] vB
     /*  29484 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29489 */     // MIs[6] vC
     /*  29489 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29494 */     // MIs[5] vA
     /*  29494 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29499 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29501 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29518 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29528 */     GIR_RootConstrainSelectedInstOperands,
     /*  29529 */     // GIR_Coverage, 5163,
     /*  29529 */     GIR_EraseRootFromParent_Done,
     /*  29530 */   // Label 437: @29530
     /*  29530 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(29668), // Rule ID 5164 //
     /*  29535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29570 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29582 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29586 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29590 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29594 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29600 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29602 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29606 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29610 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29614 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29618 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29622 */     // MIs[6] vC
     /*  29622 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29627 */     // MIs[6] vB
     /*  29627 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29632 */     // MIs[5] vA
     /*  29632 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29637 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29639 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29656 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29666 */     GIR_RootConstrainSelectedInstOperands,
     /*  29667 */     // GIR_Coverage, 5164,
     /*  29667 */     GIR_EraseRootFromParent_Done,
     /*  29668 */   // Label 438: @29668
     /*  29668 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(29806), // Rule ID 5171 //
     /*  29673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29712 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29716 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29720 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29724 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29732 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29738 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29740 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29744 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29748 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29752 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29756 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29760 */     // MIs[6] vA
     /*  29760 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29765 */     // MIs[6] vB
     /*  29765 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29770 */     // MIs[5] vC
     /*  29770 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29775 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29777 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  29790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  29794 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29804 */     GIR_RootConstrainSelectedInstOperands,
     /*  29805 */     // GIR_Coverage, 5171,
     /*  29805 */     GIR_EraseRootFromParent_Done,
     /*  29806 */   // Label 439: @29806
     /*  29806 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(29944), // Rule ID 5172 //
     /*  29811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29858 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29862 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29866 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29870 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29876 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29878 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29882 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29886 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29890 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29894 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29898 */     // MIs[6] vB
     /*  29898 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29903 */     // MIs[6] vA
     /*  29903 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29908 */     // MIs[5] vC
     /*  29908 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29913 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29915 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  29928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  29932 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29942 */     GIR_RootConstrainSelectedInstOperands,
     /*  29943 */     // GIR_Coverage, 5172,
     /*  29943 */     GIR_EraseRootFromParent_Done,
     /*  29944 */   // Label 440: @29944
     /*  29944 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(30082), // Rule ID 5173 //
     /*  29949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30000 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30004 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30008 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30014 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30016 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30020 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30024 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30028 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30032 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30036 */     // MIs[6] vA
     /*  30036 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30041 */     // MIs[6] vC
     /*  30041 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30046 */     // MIs[5] vB
     /*  30046 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30051 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30053 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30070 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30080 */     GIR_RootConstrainSelectedInstOperands,
     /*  30081 */     // GIR_Coverage, 5173,
     /*  30081 */     GIR_EraseRootFromParent_Done,
     /*  30082 */   // Label 441: @30082
     /*  30082 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(30220), // Rule ID 5174 //
     /*  30087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30134 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30138 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30142 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30146 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30152 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30154 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30158 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30162 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30166 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30170 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30174 */     // MIs[6] vC
     /*  30174 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30179 */     // MIs[6] vA
     /*  30179 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30184 */     // MIs[5] vB
     /*  30184 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30189 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30191 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30208 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30218 */     GIR_RootConstrainSelectedInstOperands,
     /*  30219 */     // GIR_Coverage, 5174,
     /*  30219 */     GIR_EraseRootFromParent_Done,
     /*  30220 */   // Label 442: @30220
     /*  30220 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(30358), // Rule ID 5175 //
     /*  30225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30272 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30276 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30280 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30284 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30290 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30292 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30296 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30300 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30304 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30308 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30312 */     // MIs[6] vB
     /*  30312 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30317 */     // MIs[6] vC
     /*  30317 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30322 */     // MIs[5] vA
     /*  30322 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30327 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30329 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30346 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30356 */     GIR_RootConstrainSelectedInstOperands,
     /*  30357 */     // GIR_Coverage, 5175,
     /*  30357 */     GIR_EraseRootFromParent_Done,
     /*  30358 */   // Label 443: @30358
     /*  30358 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(30496), // Rule ID 5176 //
     /*  30363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30414 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30418 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30422 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30428 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30430 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30434 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30438 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30442 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30446 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30450 */     // MIs[6] vC
     /*  30450 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30455 */     // MIs[6] vB
     /*  30455 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30460 */     // MIs[5] vA
     /*  30460 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30465 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30467 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30484 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30494 */     GIR_RootConstrainSelectedInstOperands,
     /*  30495 */     // GIR_Coverage, 5176,
     /*  30495 */     GIR_EraseRootFromParent_Done,
     /*  30496 */   // Label 444: @30496
     /*  30496 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(30634), // Rule ID 5117 //
     /*  30501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30548 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30552 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30556 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30560 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30566 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30568 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30572 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30576 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30580 */     // MIs[5] vC
     /*  30580 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30585 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30589 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30593 */     // MIs[6] vA
     /*  30593 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30598 */     // MIs[6] vB
     /*  30598 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30603 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30605 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30622 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30632 */     GIR_RootConstrainSelectedInstOperands,
     /*  30633 */     // GIR_Coverage, 5117,
     /*  30633 */     GIR_EraseRootFromParent_Done,
     /*  30634 */   // Label 445: @30634
     /*  30634 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(30772), // Rule ID 5118 //
     /*  30639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30674 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30686 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30690 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30694 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30698 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30706 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30710 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30714 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30718 */     // MIs[5] vC
     /*  30718 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30723 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30727 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30731 */     // MIs[6] vB
     /*  30731 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30736 */     // MIs[6] vA
     /*  30736 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30741 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30743 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30760 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30770 */     GIR_RootConstrainSelectedInstOperands,
     /*  30771 */     // GIR_Coverage, 5118,
     /*  30771 */     GIR_EraseRootFromParent_Done,
     /*  30772 */   // Label 446: @30772
     /*  30772 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(30910), // Rule ID 5119 //
     /*  30777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30824 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30828 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30832 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30836 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30842 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30844 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30848 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30852 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30856 */     // MIs[5] vB
     /*  30856 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30861 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30865 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30869 */     // MIs[6] vA
     /*  30869 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30874 */     // MIs[6] vC
     /*  30874 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30879 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30881 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30898 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30908 */     GIR_RootConstrainSelectedInstOperands,
     /*  30909 */     // GIR_Coverage, 5119,
     /*  30909 */     GIR_EraseRootFromParent_Done,
     /*  30910 */   // Label 447: @30910
     /*  30910 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(31048), // Rule ID 5120 //
     /*  30915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30962 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30966 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30970 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30974 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30980 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30982 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30986 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30990 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30994 */     // MIs[5] vB
     /*  30994 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30999 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31003 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31007 */     // MIs[6] vC
     /*  31007 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31012 */     // MIs[6] vA
     /*  31012 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31017 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31019 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31036 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31046 */     GIR_RootConstrainSelectedInstOperands,
     /*  31047 */     // GIR_Coverage, 5120,
     /*  31047 */     GIR_EraseRootFromParent_Done,
     /*  31048 */   // Label 448: @31048
     /*  31048 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(31186), // Rule ID 5121 //
     /*  31053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31104 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31108 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31112 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31118 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31120 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31124 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31128 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31132 */     // MIs[5] vA
     /*  31132 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31137 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31141 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31145 */     // MIs[6] vB
     /*  31145 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31150 */     // MIs[6] vC
     /*  31150 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31155 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31157 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31174 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31184 */     GIR_RootConstrainSelectedInstOperands,
     /*  31185 */     // GIR_Coverage, 5121,
     /*  31185 */     GIR_EraseRootFromParent_Done,
     /*  31186 */   // Label 449: @31186
     /*  31186 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(31324), // Rule ID 5122 //
     /*  31191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31238 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31242 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31246 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31250 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31256 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31258 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31262 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31266 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31270 */     // MIs[5] vA
     /*  31270 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31275 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31279 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31283 */     // MIs[6] vC
     /*  31283 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31288 */     // MIs[6] vB
     /*  31288 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31293 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31295 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31312 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31322 */     GIR_RootConstrainSelectedInstOperands,
     /*  31323 */     // GIR_Coverage, 5122,
     /*  31323 */     GIR_EraseRootFromParent_Done,
     /*  31324 */   // Label 450: @31324
     /*  31324 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(31462), // Rule ID 5129 //
     /*  31329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31376 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31380 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31384 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31388 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31394 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31396 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31400 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31404 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31408 */     // MIs[5] vC
     /*  31408 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31413 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31417 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31421 */     // MIs[6] vA
     /*  31421 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31426 */     // MIs[6] vB
     /*  31426 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31431 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31433 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31450 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31460 */     GIR_RootConstrainSelectedInstOperands,
     /*  31461 */     // GIR_Coverage, 5129,
     /*  31461 */     GIR_EraseRootFromParent_Done,
     /*  31462 */   // Label 451: @31462
     /*  31462 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(31600), // Rule ID 5130 //
     /*  31467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31514 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31518 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31522 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31526 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31534 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31538 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31542 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31546 */     // MIs[5] vC
     /*  31546 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31551 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31555 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31559 */     // MIs[6] vB
     /*  31559 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31564 */     // MIs[6] vA
     /*  31564 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31569 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31571 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31588 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31598 */     GIR_RootConstrainSelectedInstOperands,
     /*  31599 */     // GIR_Coverage, 5130,
     /*  31599 */     GIR_EraseRootFromParent_Done,
     /*  31600 */   // Label 452: @31600
     /*  31600 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(31738), // Rule ID 5131 //
     /*  31605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31652 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31656 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31660 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31664 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31670 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31672 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31676 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31680 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31684 */     // MIs[5] vB
     /*  31684 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31689 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31693 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31697 */     // MIs[6] vA
     /*  31697 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31702 */     // MIs[6] vC
     /*  31702 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31707 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31709 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31726 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31736 */     GIR_RootConstrainSelectedInstOperands,
     /*  31737 */     // GIR_Coverage, 5131,
     /*  31737 */     GIR_EraseRootFromParent_Done,
     /*  31738 */   // Label 453: @31738
     /*  31738 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(31876), // Rule ID 5132 //
     /*  31743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31794 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31798 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31802 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31810 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31814 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31818 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31822 */     // MIs[5] vB
     /*  31822 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31827 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31831 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31835 */     // MIs[6] vC
     /*  31835 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31840 */     // MIs[6] vA
     /*  31840 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31845 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31847 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31864 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31874 */     GIR_RootConstrainSelectedInstOperands,
     /*  31875 */     // GIR_Coverage, 5132,
     /*  31875 */     GIR_EraseRootFromParent_Done,
     /*  31876 */   // Label 454: @31876
     /*  31876 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(32014), // Rule ID 5133 //
     /*  31881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31916 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31928 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31932 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31936 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31940 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31946 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31948 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31952 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31956 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31960 */     // MIs[5] vA
     /*  31960 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31965 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31969 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31973 */     // MIs[6] vB
     /*  31973 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31978 */     // MIs[6] vC
     /*  31978 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31983 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31985 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  32002 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32012 */     GIR_RootConstrainSelectedInstOperands,
     /*  32013 */     // GIR_Coverage, 5133,
     /*  32013 */     GIR_EraseRootFromParent_Done,
     /*  32014 */   // Label 455: @32014
     /*  32014 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(32152), // Rule ID 5134 //
     /*  32019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32066 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32070 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32074 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32078 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32084 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32086 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32090 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32094 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32098 */     // MIs[5] vA
     /*  32098 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32103 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32107 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32111 */     // MIs[6] vC
     /*  32111 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32116 */     // MIs[6] vB
     /*  32116 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32121 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32123 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  32132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  32136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  32140 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32150 */     GIR_RootConstrainSelectedInstOperands,
     /*  32151 */     // GIR_Coverage, 5134,
     /*  32151 */     GIR_EraseRootFromParent_Done,
     /*  32152 */   // Label 456: @32152
     /*  32152 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(32290), // Rule ID 5141 //
     /*  32157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32204 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32208 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32212 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32216 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32222 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32224 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32228 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32232 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32236 */     // MIs[5] vC
     /*  32236 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32241 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32245 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32249 */     // MIs[6] vA
     /*  32249 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32254 */     // MIs[6] vB
     /*  32254 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32259 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32261 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32278 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32288 */     GIR_RootConstrainSelectedInstOperands,
     /*  32289 */     // GIR_Coverage, 5141,
     /*  32289 */     GIR_EraseRootFromParent_Done,
     /*  32290 */   // Label 457: @32290
     /*  32290 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(32428), // Rule ID 5142 //
     /*  32295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32342 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32346 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32350 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32354 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32360 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32362 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32366 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32370 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32374 */     // MIs[5] vC
     /*  32374 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32379 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32383 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32387 */     // MIs[6] vB
     /*  32387 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32392 */     // MIs[6] vA
     /*  32392 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32397 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32399 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32416 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32426 */     GIR_RootConstrainSelectedInstOperands,
     /*  32427 */     // GIR_Coverage, 5142,
     /*  32427 */     GIR_EraseRootFromParent_Done,
     /*  32428 */   // Label 458: @32428
     /*  32428 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(32566), // Rule ID 5143 //
     /*  32433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32480 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32484 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32488 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32492 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32498 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32500 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32504 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32508 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32512 */     // MIs[5] vB
     /*  32512 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32517 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32521 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32525 */     // MIs[6] vA
     /*  32525 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32530 */     // MIs[6] vC
     /*  32530 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32535 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32537 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32554 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32564 */     GIR_RootConstrainSelectedInstOperands,
     /*  32565 */     // GIR_Coverage, 5143,
     /*  32565 */     GIR_EraseRootFromParent_Done,
     /*  32566 */   // Label 459: @32566
     /*  32566 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(32704), // Rule ID 5144 //
     /*  32571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32618 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32622 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32626 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32630 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32638 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32642 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32646 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32650 */     // MIs[5] vB
     /*  32650 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32655 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32659 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32663 */     // MIs[6] vC
     /*  32663 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32668 */     // MIs[6] vA
     /*  32668 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32673 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32675 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32692 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32702 */     GIR_RootConstrainSelectedInstOperands,
     /*  32703 */     // GIR_Coverage, 5144,
     /*  32703 */     GIR_EraseRootFromParent_Done,
     /*  32704 */   // Label 460: @32704
     /*  32704 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(32842), // Rule ID 5145 //
     /*  32709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32756 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32760 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32764 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32768 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32774 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32776 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32780 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32784 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32788 */     // MIs[5] vA
     /*  32788 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32793 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32797 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32801 */     // MIs[6] vB
     /*  32801 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32806 */     // MIs[6] vC
     /*  32806 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32811 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32813 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32830 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32840 */     GIR_RootConstrainSelectedInstOperands,
     /*  32841 */     // GIR_Coverage, 5145,
     /*  32841 */     GIR_EraseRootFromParent_Done,
     /*  32842 */   // Label 461: @32842
     /*  32842 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(32980), // Rule ID 5146 //
     /*  32847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32894 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32898 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32902 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32906 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32912 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32914 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32918 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32922 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32926 */     // MIs[5] vA
     /*  32926 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32931 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32935 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32939 */     // MIs[6] vC
     /*  32939 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32944 */     // MIs[6] vB
     /*  32944 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32949 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32951 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32968 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32978 */     GIR_RootConstrainSelectedInstOperands,
     /*  32979 */     // GIR_Coverage, 5146,
     /*  32979 */     GIR_EraseRootFromParent_Done,
     /*  32980 */   // Label 462: @32980
     /*  32980 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(33118), // Rule ID 5153 //
     /*  32985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33032 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33036 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33040 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33044 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33050 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33052 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33056 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33060 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33064 */     // MIs[5] vC
     /*  33064 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33069 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33073 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33077 */     // MIs[6] vA
     /*  33077 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33082 */     // MIs[6] vB
     /*  33082 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33087 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33089 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33106 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33116 */     GIR_RootConstrainSelectedInstOperands,
     /*  33117 */     // GIR_Coverage, 5153,
     /*  33117 */     GIR_EraseRootFromParent_Done,
     /*  33118 */   // Label 463: @33118
     /*  33118 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(33256), // Rule ID 5154 //
     /*  33123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33158 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33170 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33174 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33178 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33182 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33188 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33190 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33194 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33198 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33202 */     // MIs[5] vC
     /*  33202 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33207 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33211 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33215 */     // MIs[6] vB
     /*  33215 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33220 */     // MIs[6] vA
     /*  33220 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33225 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33227 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33244 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33254 */     GIR_RootConstrainSelectedInstOperands,
     /*  33255 */     // GIR_Coverage, 5154,
     /*  33255 */     GIR_EraseRootFromParent_Done,
     /*  33256 */   // Label 464: @33256
     /*  33256 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(33394), // Rule ID 5155 //
     /*  33261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33308 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33312 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33316 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33320 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33326 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33328 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33332 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33336 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33340 */     // MIs[5] vB
     /*  33340 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33345 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33349 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33353 */     // MIs[6] vA
     /*  33353 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33358 */     // MIs[6] vC
     /*  33358 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33363 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33365 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33382 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33392 */     GIR_RootConstrainSelectedInstOperands,
     /*  33393 */     // GIR_Coverage, 5155,
     /*  33393 */     GIR_EraseRootFromParent_Done,
     /*  33394 */   // Label 465: @33394
     /*  33394 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(33532), // Rule ID 5156 //
     /*  33399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33446 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33450 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33454 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33458 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33464 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33466 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33470 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33474 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33478 */     // MIs[5] vB
     /*  33478 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33483 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33487 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33491 */     // MIs[6] vC
     /*  33491 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33496 */     // MIs[6] vA
     /*  33496 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33501 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33503 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33520 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33530 */     GIR_RootConstrainSelectedInstOperands,
     /*  33531 */     // GIR_Coverage, 5156,
     /*  33531 */     GIR_EraseRootFromParent_Done,
     /*  33532 */   // Label 466: @33532
     /*  33532 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(33670), // Rule ID 5157 //
     /*  33537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33584 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33588 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33592 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33596 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33602 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33604 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33608 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33612 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33616 */     // MIs[5] vA
     /*  33616 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33621 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33625 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33629 */     // MIs[6] vB
     /*  33629 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33634 */     // MIs[6] vC
     /*  33634 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33639 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33641 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33658 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33668 */     GIR_RootConstrainSelectedInstOperands,
     /*  33669 */     // GIR_Coverage, 5157,
     /*  33669 */     GIR_EraseRootFromParent_Done,
     /*  33670 */   // Label 467: @33670
     /*  33670 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(33808), // Rule ID 5158 //
     /*  33675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33722 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33726 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33734 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33740 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33742 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33746 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33750 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33754 */     // MIs[5] vA
     /*  33754 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33759 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33763 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33767 */     // MIs[6] vC
     /*  33767 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33772 */     // MIs[6] vB
     /*  33772 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33777 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33779 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33796 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33806 */     GIR_RootConstrainSelectedInstOperands,
     /*  33807 */     // GIR_Coverage, 5158,
     /*  33807 */     GIR_EraseRootFromParent_Done,
     /*  33808 */   // Label 468: @33808
     /*  33808 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(33946), // Rule ID 5165 //
     /*  33813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33860 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33864 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33868 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33872 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33878 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33880 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33884 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33888 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33892 */     // MIs[5] vC
     /*  33892 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33897 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33901 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33905 */     // MIs[6] vA
     /*  33905 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33910 */     // MIs[6] vB
     /*  33910 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33915 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33917 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  33926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  33930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  33934 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33944 */     GIR_RootConstrainSelectedInstOperands,
     /*  33945 */     // GIR_Coverage, 5165,
     /*  33945 */     GIR_EraseRootFromParent_Done,
     /*  33946 */   // Label 469: @33946
     /*  33946 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(34084), // Rule ID 5166 //
     /*  33951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33998 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34002 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34006 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34010 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34016 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34018 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34022 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34026 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34030 */     // MIs[5] vC
     /*  34030 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34035 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34039 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34043 */     // MIs[6] vB
     /*  34043 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34048 */     // MIs[6] vA
     /*  34048 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34053 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34055 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34072 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34082 */     GIR_RootConstrainSelectedInstOperands,
     /*  34083 */     // GIR_Coverage, 5166,
     /*  34083 */     GIR_EraseRootFromParent_Done,
     /*  34084 */   // Label 470: @34084
     /*  34084 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(34222), // Rule ID 5167 //
     /*  34089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34136 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34140 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34144 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34148 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34154 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34156 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34160 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34164 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34168 */     // MIs[5] vB
     /*  34168 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34173 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34177 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34181 */     // MIs[6] vA
     /*  34181 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34186 */     // MIs[6] vC
     /*  34186 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34191 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34193 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34210 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34220 */     GIR_RootConstrainSelectedInstOperands,
     /*  34221 */     // GIR_Coverage, 5167,
     /*  34221 */     GIR_EraseRootFromParent_Done,
     /*  34222 */   // Label 471: @34222
     /*  34222 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(34360), // Rule ID 5168 //
     /*  34227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34278 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34282 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34286 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34292 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34294 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34298 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34302 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34306 */     // MIs[5] vB
     /*  34306 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34311 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34315 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34319 */     // MIs[6] vC
     /*  34319 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34324 */     // MIs[6] vA
     /*  34324 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34329 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34331 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34348 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34358 */     GIR_RootConstrainSelectedInstOperands,
     /*  34359 */     // GIR_Coverage, 5168,
     /*  34359 */     GIR_EraseRootFromParent_Done,
     /*  34360 */   // Label 472: @34360
     /*  34360 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(34498), // Rule ID 5169 //
     /*  34365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34412 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34416 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34420 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34424 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34432 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34436 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34440 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34444 */     // MIs[5] vA
     /*  34444 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34449 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34453 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34457 */     // MIs[6] vB
     /*  34457 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34462 */     // MIs[6] vC
     /*  34462 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34467 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34469 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34486 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34496 */     GIR_RootConstrainSelectedInstOperands,
     /*  34497 */     // GIR_Coverage, 5169,
     /*  34497 */     GIR_EraseRootFromParent_Done,
     /*  34498 */   // Label 473: @34498
     /*  34498 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(34636), // Rule ID 5170 //
     /*  34503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34550 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34554 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34558 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34562 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34568 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34570 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34574 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34578 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34582 */     // MIs[5] vA
     /*  34582 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34587 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34591 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34595 */     // MIs[6] vC
     /*  34595 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34600 */     // MIs[6] vB
     /*  34600 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34605 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34607 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34624 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34634 */     GIR_RootConstrainSelectedInstOperands,
     /*  34635 */     // GIR_Coverage, 5170,
     /*  34635 */     GIR_EraseRootFromParent_Done,
     /*  34636 */   // Label 474: @34636
     /*  34636 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(34774), // Rule ID 5177 //
     /*  34641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34688 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34692 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34696 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34700 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34706 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34708 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34712 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34716 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34720 */     // MIs[5] vC
     /*  34720 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34725 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34729 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34733 */     // MIs[6] vA
     /*  34733 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34738 */     // MIs[6] vB
     /*  34738 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34743 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34745 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  34758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  34762 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34772 */     GIR_RootConstrainSelectedInstOperands,
     /*  34773 */     // GIR_Coverage, 5177,
     /*  34773 */     GIR_EraseRootFromParent_Done,
     /*  34774 */   // Label 475: @34774
     /*  34774 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(34912), // Rule ID 5178 //
     /*  34779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34826 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34830 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34834 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34838 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34846 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34850 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34854 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34858 */     // MIs[5] vC
     /*  34858 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34863 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34867 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34871 */     // MIs[6] vB
     /*  34871 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34876 */     // MIs[6] vA
     /*  34876 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34881 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34883 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  34896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  34900 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34910 */     GIR_RootConstrainSelectedInstOperands,
     /*  34911 */     // GIR_Coverage, 5178,
     /*  34911 */     GIR_EraseRootFromParent_Done,
     /*  34912 */   // Label 476: @34912
     /*  34912 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(35050), // Rule ID 5179 //
     /*  34917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34964 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34968 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34972 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34976 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34982 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34984 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34988 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34992 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34996 */     // MIs[5] vB
     /*  34996 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35001 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35005 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35009 */     // MIs[6] vA
     /*  35009 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35014 */     // MIs[6] vC
     /*  35014 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35019 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35021 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35038 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35048 */     GIR_RootConstrainSelectedInstOperands,
     /*  35049 */     // GIR_Coverage, 5179,
     /*  35049 */     GIR_EraseRootFromParent_Done,
     /*  35050 */   // Label 477: @35050
     /*  35050 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(35188), // Rule ID 5180 //
     /*  35055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35102 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35106 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35110 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35114 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35120 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35122 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35126 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35130 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35134 */     // MIs[5] vB
     /*  35134 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35139 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35143 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35147 */     // MIs[6] vC
     /*  35147 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35152 */     // MIs[6] vA
     /*  35152 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35157 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35159 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35176 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35186 */     GIR_RootConstrainSelectedInstOperands,
     /*  35187 */     // GIR_Coverage, 5180,
     /*  35187 */     GIR_EraseRootFromParent_Done,
     /*  35188 */   // Label 478: @35188
     /*  35188 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(35326), // Rule ID 5181 //
     /*  35193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35240 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35244 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35260 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35264 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35268 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35272 */     // MIs[5] vA
     /*  35272 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35277 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35281 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35285 */     // MIs[6] vB
     /*  35285 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35290 */     // MIs[6] vC
     /*  35290 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35295 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35297 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35314 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35324 */     GIR_RootConstrainSelectedInstOperands,
     /*  35325 */     // GIR_Coverage, 5181,
     /*  35325 */     GIR_EraseRootFromParent_Done,
     /*  35326 */   // Label 479: @35326
     /*  35326 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(35464), // Rule ID 5182 //
     /*  35331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35378 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35382 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35386 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35390 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35396 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35398 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35402 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35406 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35410 */     // MIs[5] vA
     /*  35410 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35415 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35419 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35423 */     // MIs[6] vC
     /*  35423 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35428 */     // MIs[6] vB
     /*  35428 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35433 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35435 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35452 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35462 */     GIR_RootConstrainSelectedInstOperands,
     /*  35463 */     // GIR_Coverage, 5182,
     /*  35463 */     GIR_EraseRootFromParent_Done,
     /*  35464 */   // Label 480: @35464
     /*  35464 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(35602), // Rule ID 5183 //
     /*  35469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35516 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35524 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35528 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35534 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35536 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35540 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35544 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35548 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35552 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35556 */     // MIs[6] vA
     /*  35556 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35561 */     // MIs[6] vB
     /*  35561 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35566 */     // MIs[5] vC
     /*  35566 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35571 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35573 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35590 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35600 */     GIR_RootConstrainSelectedInstOperands,
     /*  35601 */     // GIR_Coverage, 5183,
     /*  35601 */     GIR_EraseRootFromParent_Done,
     /*  35602 */   // Label 481: @35602
     /*  35602 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(35740), // Rule ID 5184 //
     /*  35607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35654 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35658 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35662 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35666 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35672 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35674 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35678 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35682 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35686 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35690 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35694 */     // MIs[6] vB
     /*  35694 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35699 */     // MIs[6] vA
     /*  35699 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35704 */     // MIs[5] vC
     /*  35704 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35709 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35711 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35728 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35738 */     GIR_RootConstrainSelectedInstOperands,
     /*  35739 */     // GIR_Coverage, 5184,
     /*  35739 */     GIR_EraseRootFromParent_Done,
     /*  35740 */   // Label 482: @35740
     /*  35740 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(35878), // Rule ID 5185 //
     /*  35745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35792 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35796 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35800 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35804 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35810 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35812 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35816 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35820 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35824 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35828 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35832 */     // MIs[6] vA
     /*  35832 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35837 */     // MIs[6] vC
     /*  35837 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35842 */     // MIs[5] vB
     /*  35842 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35847 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35849 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35866 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35876 */     GIR_RootConstrainSelectedInstOperands,
     /*  35877 */     // GIR_Coverage, 5185,
     /*  35877 */     GIR_EraseRootFromParent_Done,
     /*  35878 */   // Label 483: @35878
     /*  35878 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(36016), // Rule ID 5186 //
     /*  35883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35934 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35942 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35950 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35954 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35958 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35962 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35966 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35970 */     // MIs[6] vC
     /*  35970 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35975 */     // MIs[6] vA
     /*  35975 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35980 */     // MIs[5] vB
     /*  35980 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35985 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35987 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  36000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36004 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36014 */     GIR_RootConstrainSelectedInstOperands,
     /*  36015 */     // GIR_Coverage, 5186,
     /*  36015 */     GIR_EraseRootFromParent_Done,
     /*  36016 */   // Label 484: @36016
     /*  36016 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(36154), // Rule ID 5187 //
     /*  36021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36068 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36072 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36076 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36080 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36086 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36088 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36092 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36096 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36100 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36104 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36108 */     // MIs[6] vB
     /*  36108 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36113 */     // MIs[6] vC
     /*  36113 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36118 */     // MIs[5] vA
     /*  36118 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36123 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36125 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  36134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  36138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36142 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36152 */     GIR_RootConstrainSelectedInstOperands,
     /*  36153 */     // GIR_Coverage, 5187,
     /*  36153 */     GIR_EraseRootFromParent_Done,
     /*  36154 */   // Label 485: @36154
     /*  36154 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(36292), // Rule ID 5188 //
     /*  36159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36194 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36206 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36210 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36214 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36218 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36226 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36230 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36234 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36238 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36242 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36246 */     // MIs[6] vC
     /*  36246 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36251 */     // MIs[6] vB
     /*  36251 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36256 */     // MIs[5] vA
     /*  36256 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36261 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36263 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  36272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  36276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36280 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36290 */     GIR_RootConstrainSelectedInstOperands,
     /*  36291 */     // GIR_Coverage, 5188,
     /*  36291 */     GIR_EraseRootFromParent_Done,
     /*  36292 */   // Label 486: @36292
     /*  36292 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(36430), // Rule ID 5195 //
     /*  36297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36344 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36348 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36352 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36356 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36362 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36364 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36368 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36372 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36376 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36380 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36384 */     // MIs[6] vA
     /*  36384 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36389 */     // MIs[6] vB
     /*  36389 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36394 */     // MIs[5] vC
     /*  36394 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36399 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36401 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36418 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36428 */     GIR_RootConstrainSelectedInstOperands,
     /*  36429 */     // GIR_Coverage, 5195,
     /*  36429 */     GIR_EraseRootFromParent_Done,
     /*  36430 */   // Label 487: @36430
     /*  36430 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(36568), // Rule ID 5196 //
     /*  36435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36482 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36486 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36490 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36494 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36500 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36502 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36506 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36510 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36514 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36518 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36522 */     // MIs[6] vB
     /*  36522 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36527 */     // MIs[6] vA
     /*  36527 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36532 */     // MIs[5] vC
     /*  36532 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36537 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36539 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36556 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36566 */     GIR_RootConstrainSelectedInstOperands,
     /*  36567 */     // GIR_Coverage, 5196,
     /*  36567 */     GIR_EraseRootFromParent_Done,
     /*  36568 */   // Label 488: @36568
     /*  36568 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(36706), // Rule ID 5197 //
     /*  36573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36620 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36624 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36628 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36632 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36638 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36640 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36644 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36648 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36652 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36656 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36660 */     // MIs[6] vA
     /*  36660 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36665 */     // MIs[6] vC
     /*  36665 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36670 */     // MIs[5] vB
     /*  36670 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36675 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36677 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36694 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36704 */     GIR_RootConstrainSelectedInstOperands,
     /*  36705 */     // GIR_Coverage, 5197,
     /*  36705 */     GIR_EraseRootFromParent_Done,
     /*  36706 */   // Label 489: @36706
     /*  36706 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(36844), // Rule ID 5198 //
     /*  36711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36758 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36762 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36766 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36770 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36776 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36778 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36782 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36786 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36790 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36794 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36798 */     // MIs[6] vC
     /*  36798 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36803 */     // MIs[6] vA
     /*  36803 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36808 */     // MIs[5] vB
     /*  36808 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36813 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36815 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36832 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36842 */     GIR_RootConstrainSelectedInstOperands,
     /*  36843 */     // GIR_Coverage, 5198,
     /*  36843 */     GIR_EraseRootFromParent_Done,
     /*  36844 */   // Label 490: @36844
     /*  36844 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(36982), // Rule ID 5199 //
     /*  36849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36896 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36900 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36908 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36916 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36920 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36924 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36928 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36932 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36936 */     // MIs[6] vB
     /*  36936 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36941 */     // MIs[6] vC
     /*  36941 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36946 */     // MIs[5] vA
     /*  36946 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36951 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36953 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36970 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36980 */     GIR_RootConstrainSelectedInstOperands,
     /*  36981 */     // GIR_Coverage, 5199,
     /*  36981 */     GIR_EraseRootFromParent_Done,
     /*  36982 */   // Label 491: @36982
     /*  36982 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(37120), // Rule ID 5200 //
     /*  36987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37034 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37038 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37046 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37052 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37054 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37058 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37062 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37066 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37070 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37074 */     // MIs[6] vC
     /*  37074 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37079 */     // MIs[6] vB
     /*  37079 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37084 */     // MIs[5] vA
     /*  37084 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37089 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37091 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  37100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  37104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  37108 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37118 */     GIR_RootConstrainSelectedInstOperands,
     /*  37119 */     // GIR_Coverage, 5200,
     /*  37119 */     GIR_EraseRootFromParent_Done,
     /*  37120 */   // Label 492: @37120
     /*  37120 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(37258), // Rule ID 5207 //
     /*  37125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37172 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37176 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37180 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37184 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37190 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37192 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37196 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37200 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37204 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37208 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37212 */     // MIs[6] vA
     /*  37212 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37217 */     // MIs[6] vB
     /*  37217 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37222 */     // MIs[5] vC
     /*  37222 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37227 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37229 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37246 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37256 */     GIR_RootConstrainSelectedInstOperands,
     /*  37257 */     // GIR_Coverage, 5207,
     /*  37257 */     GIR_EraseRootFromParent_Done,
     /*  37258 */   // Label 493: @37258
     /*  37258 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(37396), // Rule ID 5208 //
     /*  37263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37310 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37314 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37318 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37322 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37330 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37334 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37338 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37342 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37346 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37350 */     // MIs[6] vB
     /*  37350 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37355 */     // MIs[6] vA
     /*  37355 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37360 */     // MIs[5] vC
     /*  37360 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37365 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37367 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37384 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37394 */     GIR_RootConstrainSelectedInstOperands,
     /*  37395 */     // GIR_Coverage, 5208,
     /*  37395 */     GIR_EraseRootFromParent_Done,
     /*  37396 */   // Label 494: @37396
     /*  37396 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(37534), // Rule ID 5209 //
     /*  37401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37448 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37452 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37460 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37466 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37468 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37472 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37476 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37480 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37484 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37488 */     // MIs[6] vA
     /*  37488 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37493 */     // MIs[6] vC
     /*  37493 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37498 */     // MIs[5] vB
     /*  37498 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37503 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37505 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37522 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37532 */     GIR_RootConstrainSelectedInstOperands,
     /*  37533 */     // GIR_Coverage, 5209,
     /*  37533 */     GIR_EraseRootFromParent_Done,
     /*  37534 */   // Label 495: @37534
     /*  37534 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(37672), // Rule ID 5210 //
     /*  37539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37586 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37590 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37594 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37598 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37604 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37606 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37610 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37614 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37618 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37622 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37626 */     // MIs[6] vC
     /*  37626 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37631 */     // MIs[6] vA
     /*  37631 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37636 */     // MIs[5] vB
     /*  37636 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37641 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37643 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37660 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37670 */     GIR_RootConstrainSelectedInstOperands,
     /*  37671 */     // GIR_Coverage, 5210,
     /*  37671 */     GIR_EraseRootFromParent_Done,
     /*  37672 */   // Label 496: @37672
     /*  37672 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(37810), // Rule ID 5211 //
     /*  37677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37724 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37728 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37736 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37742 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37744 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37748 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37752 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37756 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37760 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37764 */     // MIs[6] vB
     /*  37764 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37769 */     // MIs[6] vC
     /*  37769 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37774 */     // MIs[5] vA
     /*  37774 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37779 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37781 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37798 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37808 */     GIR_RootConstrainSelectedInstOperands,
     /*  37809 */     // GIR_Coverage, 5211,
     /*  37809 */     GIR_EraseRootFromParent_Done,
     /*  37810 */   // Label 497: @37810
     /*  37810 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(37948), // Rule ID 5212 //
     /*  37815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37862 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37870 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37874 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37880 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37882 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37886 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37890 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37894 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37898 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37902 */     // MIs[6] vC
     /*  37902 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37907 */     // MIs[6] vB
     /*  37907 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37912 */     // MIs[5] vA
     /*  37912 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37917 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37919 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37936 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37946 */     GIR_RootConstrainSelectedInstOperands,
     /*  37947 */     // GIR_Coverage, 5212,
     /*  37947 */     GIR_EraseRootFromParent_Done,
     /*  37948 */   // Label 498: @37948
     /*  37948 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(38086), // Rule ID 5219 //
     /*  37953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38000 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38004 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38008 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38012 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38018 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38020 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38024 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38028 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38032 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38036 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38040 */     // MIs[6] vA
     /*  38040 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38045 */     // MIs[6] vB
     /*  38045 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38050 */     // MIs[5] vC
     /*  38050 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38055 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38057 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38074 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38084 */     GIR_RootConstrainSelectedInstOperands,
     /*  38085 */     // GIR_Coverage, 5219,
     /*  38085 */     GIR_EraseRootFromParent_Done,
     /*  38086 */   // Label 499: @38086
     /*  38086 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(38224), // Rule ID 5220 //
     /*  38091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38138 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38142 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38146 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38150 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38156 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38158 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38162 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38166 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38170 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38174 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38178 */     // MIs[6] vB
     /*  38178 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38183 */     // MIs[6] vA
     /*  38183 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38188 */     // MIs[5] vC
     /*  38188 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38193 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38195 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38212 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38222 */     GIR_RootConstrainSelectedInstOperands,
     /*  38223 */     // GIR_Coverage, 5220,
     /*  38223 */     GIR_EraseRootFromParent_Done,
     /*  38224 */   // Label 500: @38224
     /*  38224 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(38362), // Rule ID 5221 //
     /*  38229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38276 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38280 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38284 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38288 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38294 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38296 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38300 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38304 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38308 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38312 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38316 */     // MIs[6] vA
     /*  38316 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38321 */     // MIs[6] vC
     /*  38321 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38326 */     // MIs[5] vB
     /*  38326 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38331 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38333 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38350 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38360 */     GIR_RootConstrainSelectedInstOperands,
     /*  38361 */     // GIR_Coverage, 5221,
     /*  38361 */     GIR_EraseRootFromParent_Done,
     /*  38362 */   // Label 501: @38362
     /*  38362 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(38500), // Rule ID 5222 //
     /*  38367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38414 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38418 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38422 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38426 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38432 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38434 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38438 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38442 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38446 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38450 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38454 */     // MIs[6] vC
     /*  38454 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38459 */     // MIs[6] vA
     /*  38459 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38464 */     // MIs[5] vB
     /*  38464 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38469 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38471 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38488 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38498 */     GIR_RootConstrainSelectedInstOperands,
     /*  38499 */     // GIR_Coverage, 5222,
     /*  38499 */     GIR_EraseRootFromParent_Done,
     /*  38500 */   // Label 502: @38500
     /*  38500 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(38638), // Rule ID 5223 //
     /*  38505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38552 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38556 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38560 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38564 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38570 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38572 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38576 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38580 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38584 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38588 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38592 */     // MIs[6] vB
     /*  38592 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38597 */     // MIs[6] vC
     /*  38597 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38602 */     // MIs[5] vA
     /*  38602 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38607 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38609 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38626 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38636 */     GIR_RootConstrainSelectedInstOperands,
     /*  38637 */     // GIR_Coverage, 5223,
     /*  38637 */     GIR_EraseRootFromParent_Done,
     /*  38638 */   // Label 503: @38638
     /*  38638 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(38776), // Rule ID 5224 //
     /*  38643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38690 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38694 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38698 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38702 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38708 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38710 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38714 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38718 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38722 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38726 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38730 */     // MIs[6] vC
     /*  38730 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38735 */     // MIs[6] vB
     /*  38735 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38740 */     // MIs[5] vA
     /*  38740 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38745 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38747 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38764 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38774 */     GIR_RootConstrainSelectedInstOperands,
     /*  38775 */     // GIR_Coverage, 5224,
     /*  38775 */     GIR_EraseRootFromParent_Done,
     /*  38776 */   // Label 504: @38776
     /*  38776 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(38914), // Rule ID 5231 //
     /*  38781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38828 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38832 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38836 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38840 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38846 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38848 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38852 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38856 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38860 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38864 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38868 */     // MIs[6] vA
     /*  38868 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38873 */     // MIs[6] vB
     /*  38873 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38878 */     // MIs[5] vC
     /*  38878 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38883 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38885 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  38894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  38898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  38902 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38912 */     GIR_RootConstrainSelectedInstOperands,
     /*  38913 */     // GIR_Coverage, 5231,
     /*  38913 */     GIR_EraseRootFromParent_Done,
     /*  38914 */   // Label 505: @38914
     /*  38914 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(39052), // Rule ID 5232 //
     /*  38919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38970 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38974 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38978 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38984 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38986 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38990 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38994 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38998 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39002 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39006 */     // MIs[6] vB
     /*  39006 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39011 */     // MIs[6] vA
     /*  39011 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39016 */     // MIs[5] vC
     /*  39016 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39021 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39023 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39040 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39050 */     GIR_RootConstrainSelectedInstOperands,
     /*  39051 */     // GIR_Coverage, 5232,
     /*  39051 */     GIR_EraseRootFromParent_Done,
     /*  39052 */   // Label 506: @39052
     /*  39052 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(39190), // Rule ID 5233 //
     /*  39057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39104 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39108 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39112 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39116 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39122 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39124 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39128 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39132 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39136 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39140 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39144 */     // MIs[6] vA
     /*  39144 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39149 */     // MIs[6] vC
     /*  39149 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39154 */     // MIs[5] vB
     /*  39154 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39159 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39161 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39178 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39188 */     GIR_RootConstrainSelectedInstOperands,
     /*  39189 */     // GIR_Coverage, 5233,
     /*  39189 */     GIR_EraseRootFromParent_Done,
     /*  39190 */   // Label 507: @39190
     /*  39190 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(39328), // Rule ID 5234 //
     /*  39195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39242 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39246 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39250 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39254 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39260 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39262 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39266 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39270 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39274 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39278 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39282 */     // MIs[6] vC
     /*  39282 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39287 */     // MIs[6] vA
     /*  39287 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39292 */     // MIs[5] vB
     /*  39292 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39297 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39299 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39316 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39326 */     GIR_RootConstrainSelectedInstOperands,
     /*  39327 */     // GIR_Coverage, 5234,
     /*  39327 */     GIR_EraseRootFromParent_Done,
     /*  39328 */   // Label 508: @39328
     /*  39328 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(39466), // Rule ID 5235 //
     /*  39333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39380 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39384 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39388 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39392 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39398 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39400 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39404 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39408 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39412 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39416 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39420 */     // MIs[6] vB
     /*  39420 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39425 */     // MIs[6] vC
     /*  39425 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39430 */     // MIs[5] vA
     /*  39430 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39435 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39437 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39454 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39464 */     GIR_RootConstrainSelectedInstOperands,
     /*  39465 */     // GIR_Coverage, 5235,
     /*  39465 */     GIR_EraseRootFromParent_Done,
     /*  39466 */   // Label 509: @39466
     /*  39466 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(39604), // Rule ID 5236 //
     /*  39471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39518 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39522 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39526 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39530 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39538 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39542 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39546 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39550 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39554 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39558 */     // MIs[6] vC
     /*  39558 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39563 */     // MIs[6] vB
     /*  39563 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39568 */     // MIs[5] vA
     /*  39568 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39573 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39575 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39592 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39602 */     GIR_RootConstrainSelectedInstOperands,
     /*  39603 */     // GIR_Coverage, 5236,
     /*  39603 */     GIR_EraseRootFromParent_Done,
     /*  39604 */   // Label 510: @39604
     /*  39604 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(39742), // Rule ID 5243 //
     /*  39609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39656 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39660 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39664 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39668 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39674 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39676 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39680 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39684 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39688 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39692 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39696 */     // MIs[6] vA
     /*  39696 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39701 */     // MIs[6] vB
     /*  39701 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39706 */     // MIs[5] vC
     /*  39706 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39711 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39713 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  39726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  39730 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39740 */     GIR_RootConstrainSelectedInstOperands,
     /*  39741 */     // GIR_Coverage, 5243,
     /*  39741 */     GIR_EraseRootFromParent_Done,
     /*  39742 */   // Label 511: @39742
     /*  39742 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(39880), // Rule ID 5244 //
     /*  39747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39794 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39798 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39802 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39806 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39812 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39814 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39818 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39822 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39826 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39830 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39834 */     // MIs[6] vB
     /*  39834 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39839 */     // MIs[6] vA
     /*  39839 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39844 */     // MIs[5] vC
     /*  39844 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39849 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39851 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  39864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  39868 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39878 */     GIR_RootConstrainSelectedInstOperands,
     /*  39879 */     // GIR_Coverage, 5244,
     /*  39879 */     GIR_EraseRootFromParent_Done,
     /*  39880 */   // Label 512: @39880
     /*  39880 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(40018), // Rule ID 5245 //
     /*  39885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39932 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39936 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39940 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39944 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39950 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39952 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39956 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39960 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39964 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39968 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39972 */     // MIs[6] vA
     /*  39972 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39977 */     // MIs[6] vC
     /*  39977 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39982 */     // MIs[5] vB
     /*  39982 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39987 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39989 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40006 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40016 */     GIR_RootConstrainSelectedInstOperands,
     /*  40017 */     // GIR_Coverage, 5245,
     /*  40017 */     GIR_EraseRootFromParent_Done,
     /*  40018 */   // Label 513: @40018
     /*  40018 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(40156), // Rule ID 5246 //
     /*  40023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40070 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40074 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40078 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40082 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40090 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40094 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40098 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40102 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40106 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40110 */     // MIs[6] vC
     /*  40110 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40115 */     // MIs[6] vA
     /*  40115 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40120 */     // MIs[5] vB
     /*  40120 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40125 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40127 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40144 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40154 */     GIR_RootConstrainSelectedInstOperands,
     /*  40155 */     // GIR_Coverage, 5246,
     /*  40155 */     GIR_EraseRootFromParent_Done,
     /*  40156 */   // Label 514: @40156
     /*  40156 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(40294), // Rule ID 5247 //
     /*  40161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40208 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40212 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40216 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40220 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40226 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40228 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40232 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40236 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40240 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40244 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40248 */     // MIs[6] vB
     /*  40248 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40253 */     // MIs[6] vC
     /*  40253 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40258 */     // MIs[5] vA
     /*  40258 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40263 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40265 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40282 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40292 */     GIR_RootConstrainSelectedInstOperands,
     /*  40293 */     // GIR_Coverage, 5247,
     /*  40293 */     GIR_EraseRootFromParent_Done,
     /*  40294 */   // Label 515: @40294
     /*  40294 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(40432), // Rule ID 5248 //
     /*  40299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40346 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40350 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40354 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40358 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40366 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40370 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40374 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40378 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40382 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40386 */     // MIs[6] vC
     /*  40386 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40391 */     // MIs[6] vB
     /*  40391 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40396 */     // MIs[5] vA
     /*  40396 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40401 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40403 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40420 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40430 */     GIR_RootConstrainSelectedInstOperands,
     /*  40431 */     // GIR_Coverage, 5248,
     /*  40431 */     GIR_EraseRootFromParent_Done,
     /*  40432 */   // Label 516: @40432
     /*  40432 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(40570), // Rule ID 5189 //
     /*  40437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40484 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40488 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40492 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40496 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40502 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40504 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40508 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40512 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40516 */     // MIs[5] vC
     /*  40516 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40521 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40525 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40529 */     // MIs[6] vA
     /*  40529 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40534 */     // MIs[6] vB
     /*  40534 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40539 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40541 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40558 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40568 */     GIR_RootConstrainSelectedInstOperands,
     /*  40569 */     // GIR_Coverage, 5189,
     /*  40569 */     GIR_EraseRootFromParent_Done,
     /*  40570 */   // Label 517: @40570
     /*  40570 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(40708), // Rule ID 5190 //
     /*  40575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40614 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40618 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40622 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40626 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40630 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40634 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40640 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40642 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40646 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40650 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40654 */     // MIs[5] vC
     /*  40654 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40659 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40663 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40667 */     // MIs[6] vB
     /*  40667 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40672 */     // MIs[6] vA
     /*  40672 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40677 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40679 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40696 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40706 */     GIR_RootConstrainSelectedInstOperands,
     /*  40707 */     // GIR_Coverage, 5190,
     /*  40707 */     GIR_EraseRootFromParent_Done,
     /*  40708 */   // Label 518: @40708
     /*  40708 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(40846), // Rule ID 5191 //
     /*  40713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40772 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40778 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40780 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40784 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40788 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40792 */     // MIs[5] vB
     /*  40792 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40797 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40801 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40805 */     // MIs[6] vA
     /*  40805 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40810 */     // MIs[6] vC
     /*  40810 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40815 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40817 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40834 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40844 */     GIR_RootConstrainSelectedInstOperands,
     /*  40845 */     // GIR_Coverage, 5191,
     /*  40845 */     GIR_EraseRootFromParent_Done,
     /*  40846 */   // Label 519: @40846
     /*  40846 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(40984), // Rule ID 5192 //
     /*  40851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40898 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40902 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40906 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40910 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40916 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40918 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40922 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40926 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40930 */     // MIs[5] vB
     /*  40930 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40935 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40939 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40943 */     // MIs[6] vC
     /*  40943 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40948 */     // MIs[6] vA
     /*  40948 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40953 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40955 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40972 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40982 */     GIR_RootConstrainSelectedInstOperands,
     /*  40983 */     // GIR_Coverage, 5192,
     /*  40983 */     GIR_EraseRootFromParent_Done,
     /*  40984 */   // Label 520: @40984
     /*  40984 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(41122), // Rule ID 5193 //
     /*  40989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41036 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41040 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41044 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41048 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41054 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41056 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41060 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41064 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41068 */     // MIs[5] vA
     /*  41068 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41073 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41077 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41081 */     // MIs[6] vB
     /*  41081 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41086 */     // MIs[6] vC
     /*  41086 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41091 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41093 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  41102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  41106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41110 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41120 */     GIR_RootConstrainSelectedInstOperands,
     /*  41121 */     // GIR_Coverage, 5193,
     /*  41121 */     GIR_EraseRootFromParent_Done,
     /*  41122 */   // Label 521: @41122
     /*  41122 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(41260), // Rule ID 5194 //
     /*  41127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41174 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41178 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41182 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41186 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41192 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41194 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41198 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41202 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41206 */     // MIs[5] vA
     /*  41206 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41211 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41215 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41219 */     // MIs[6] vC
     /*  41219 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41224 */     // MIs[6] vB
     /*  41224 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41229 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41231 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  41240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  41244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41248 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41258 */     GIR_RootConstrainSelectedInstOperands,
     /*  41259 */     // GIR_Coverage, 5194,
     /*  41259 */     GIR_EraseRootFromParent_Done,
     /*  41260 */   // Label 522: @41260
     /*  41260 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(41398), // Rule ID 5201 //
     /*  41265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41312 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41316 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41324 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41330 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41332 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41336 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41340 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41344 */     // MIs[5] vC
     /*  41344 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41349 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41353 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41357 */     // MIs[6] vA
     /*  41357 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41362 */     // MIs[6] vB
     /*  41362 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41367 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41369 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41386 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41396 */     GIR_RootConstrainSelectedInstOperands,
     /*  41397 */     // GIR_Coverage, 5201,
     /*  41397 */     GIR_EraseRootFromParent_Done,
     /*  41398 */   // Label 523: @41398
     /*  41398 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(41536), // Rule ID 5202 //
     /*  41403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41450 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41454 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41458 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41462 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41468 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41470 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41474 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41478 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41482 */     // MIs[5] vC
     /*  41482 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41487 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41491 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41495 */     // MIs[6] vB
     /*  41495 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41500 */     // MIs[6] vA
     /*  41500 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41505 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41507 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41524 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41534 */     GIR_RootConstrainSelectedInstOperands,
     /*  41535 */     // GIR_Coverage, 5202,
     /*  41535 */     GIR_EraseRootFromParent_Done,
     /*  41536 */   // Label 524: @41536
     /*  41536 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(41674), // Rule ID 5203 //
     /*  41541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41588 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41592 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41596 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41600 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41606 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41608 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41612 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41616 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41620 */     // MIs[5] vB
     /*  41620 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41625 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41629 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41633 */     // MIs[6] vA
     /*  41633 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41638 */     // MIs[6] vC
     /*  41638 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41643 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41645 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41662 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41672 */     GIR_RootConstrainSelectedInstOperands,
     /*  41673 */     // GIR_Coverage, 5203,
     /*  41673 */     GIR_EraseRootFromParent_Done,
     /*  41674 */   // Label 525: @41674
     /*  41674 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(41812), // Rule ID 5204 //
     /*  41679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41730 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41734 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41738 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41744 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41746 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41750 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41754 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41758 */     // MIs[5] vB
     /*  41758 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41763 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41767 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41771 */     // MIs[6] vC
     /*  41771 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41776 */     // MIs[6] vA
     /*  41776 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41781 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41783 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41800 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41810 */     GIR_RootConstrainSelectedInstOperands,
     /*  41811 */     // GIR_Coverage, 5204,
     /*  41811 */     GIR_EraseRootFromParent_Done,
     /*  41812 */   // Label 526: @41812
     /*  41812 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(41950), // Rule ID 5205 //
     /*  41817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41868 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41872 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41876 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41882 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41884 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41888 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41892 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41896 */     // MIs[5] vA
     /*  41896 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41901 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41905 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41909 */     // MIs[6] vB
     /*  41909 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41914 */     // MIs[6] vC
     /*  41914 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41919 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41921 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41938 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41948 */     GIR_RootConstrainSelectedInstOperands,
     /*  41949 */     // GIR_Coverage, 5205,
     /*  41949 */     GIR_EraseRootFromParent_Done,
     /*  41950 */   // Label 527: @41950
     /*  41950 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(42088), // Rule ID 5206 //
     /*  41955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42002 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42006 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42010 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42014 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42022 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42026 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42030 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42034 */     // MIs[5] vA
     /*  42034 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42039 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42043 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42047 */     // MIs[6] vC
     /*  42047 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42052 */     // MIs[6] vB
     /*  42052 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42057 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42059 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  42068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  42072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  42076 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42086 */     GIR_RootConstrainSelectedInstOperands,
     /*  42087 */     // GIR_Coverage, 5206,
     /*  42087 */     GIR_EraseRootFromParent_Done,
     /*  42088 */   // Label 528: @42088
     /*  42088 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(42226), // Rule ID 5213 //
     /*  42093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42140 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42144 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42148 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42152 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42158 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42160 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42164 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42168 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42172 */     // MIs[5] vC
     /*  42172 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42177 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42181 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42185 */     // MIs[6] vA
     /*  42185 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42190 */     // MIs[6] vB
     /*  42190 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42195 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42197 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42214 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42224 */     GIR_RootConstrainSelectedInstOperands,
     /*  42225 */     // GIR_Coverage, 5213,
     /*  42225 */     GIR_EraseRootFromParent_Done,
     /*  42226 */   // Label 529: @42226
     /*  42226 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(42364), // Rule ID 5214 //
     /*  42231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42278 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42282 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42286 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42290 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42296 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42298 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42302 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42306 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42310 */     // MIs[5] vC
     /*  42310 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42315 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42319 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42323 */     // MIs[6] vB
     /*  42323 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42328 */     // MIs[6] vA
     /*  42328 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42333 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42335 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42352 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42362 */     GIR_RootConstrainSelectedInstOperands,
     /*  42363 */     // GIR_Coverage, 5214,
     /*  42363 */     GIR_EraseRootFromParent_Done,
     /*  42364 */   // Label 530: @42364
     /*  42364 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(42502), // Rule ID 5215 //
     /*  42369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42416 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42420 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42424 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42428 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42434 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42436 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42440 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42444 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42448 */     // MIs[5] vB
     /*  42448 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42453 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42457 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42461 */     // MIs[6] vA
     /*  42461 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42466 */     // MIs[6] vC
     /*  42466 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42471 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42473 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42490 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42500 */     GIR_RootConstrainSelectedInstOperands,
     /*  42501 */     // GIR_Coverage, 5215,
     /*  42501 */     GIR_EraseRootFromParent_Done,
     /*  42502 */   // Label 531: @42502
     /*  42502 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(42640), // Rule ID 5216 //
     /*  42507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42554 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42558 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42562 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42566 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42572 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42574 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42578 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42582 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42586 */     // MIs[5] vB
     /*  42586 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42591 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42595 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42599 */     // MIs[6] vC
     /*  42599 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42604 */     // MIs[6] vA
     /*  42604 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42609 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42611 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42628 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42638 */     GIR_RootConstrainSelectedInstOperands,
     /*  42639 */     // GIR_Coverage, 5216,
     /*  42639 */     GIR_EraseRootFromParent_Done,
     /*  42640 */   // Label 532: @42640
     /*  42640 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(42778), // Rule ID 5217 //
     /*  42645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42692 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42696 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42700 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42704 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42710 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42712 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42716 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42720 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42724 */     // MIs[5] vA
     /*  42724 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42729 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42733 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42737 */     // MIs[6] vB
     /*  42737 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42742 */     // MIs[6] vC
     /*  42742 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42747 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42749 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42766 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42776 */     GIR_RootConstrainSelectedInstOperands,
     /*  42777 */     // GIR_Coverage, 5217,
     /*  42777 */     GIR_EraseRootFromParent_Done,
     /*  42778 */   // Label 533: @42778
     /*  42778 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(42916), // Rule ID 5218 //
     /*  42783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42826 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42830 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42834 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42838 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42842 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42848 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42850 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42854 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42858 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42862 */     // MIs[5] vA
     /*  42862 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42867 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42871 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42875 */     // MIs[6] vC
     /*  42875 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42880 */     // MIs[6] vB
     /*  42880 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42885 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42887 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42904 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42914 */     GIR_RootConstrainSelectedInstOperands,
     /*  42915 */     // GIR_Coverage, 5218,
     /*  42915 */     GIR_EraseRootFromParent_Done,
     /*  42916 */   // Label 534: @42916
     /*  42916 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(43054), // Rule ID 5225 //
     /*  42921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42968 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42972 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42976 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42980 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42986 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42988 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42992 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42996 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43000 */     // MIs[5] vC
     /*  43000 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43005 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43009 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43013 */     // MIs[6] vA
     /*  43013 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43018 */     // MIs[6] vB
     /*  43018 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43023 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43025 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43042 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43052 */     GIR_RootConstrainSelectedInstOperands,
     /*  43053 */     // GIR_Coverage, 5225,
     /*  43053 */     GIR_EraseRootFromParent_Done,
     /*  43054 */   // Label 535: @43054
     /*  43054 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(43192), // Rule ID 5226 //
     /*  43059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43106 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43110 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43114 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43118 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43124 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43126 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43130 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43134 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43138 */     // MIs[5] vC
     /*  43138 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43143 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43147 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43151 */     // MIs[6] vB
     /*  43151 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43156 */     // MIs[6] vA
     /*  43156 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43161 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43163 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43180 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43190 */     GIR_RootConstrainSelectedInstOperands,
     /*  43191 */     // GIR_Coverage, 5226,
     /*  43191 */     GIR_EraseRootFromParent_Done,
     /*  43192 */   // Label 536: @43192
     /*  43192 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(43330), // Rule ID 5227 //
     /*  43197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43244 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43248 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43252 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43256 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43262 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43264 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43268 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43272 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43276 */     // MIs[5] vB
     /*  43276 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43281 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43285 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43289 */     // MIs[6] vA
     /*  43289 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43294 */     // MIs[6] vC
     /*  43294 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43299 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43301 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43318 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43328 */     GIR_RootConstrainSelectedInstOperands,
     /*  43329 */     // GIR_Coverage, 5227,
     /*  43329 */     GIR_EraseRootFromParent_Done,
     /*  43330 */   // Label 537: @43330
     /*  43330 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(43468), // Rule ID 5228 //
     /*  43335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43382 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43390 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43394 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43400 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43402 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43406 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43410 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43414 */     // MIs[5] vB
     /*  43414 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43419 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43423 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43427 */     // MIs[6] vC
     /*  43427 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43432 */     // MIs[6] vA
     /*  43432 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43437 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43439 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43456 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43466 */     GIR_RootConstrainSelectedInstOperands,
     /*  43467 */     // GIR_Coverage, 5228,
     /*  43467 */     GIR_EraseRootFromParent_Done,
     /*  43468 */   // Label 538: @43468
     /*  43468 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(43606), // Rule ID 5229 //
     /*  43473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43520 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43524 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43528 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43532 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43538 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43540 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43544 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43548 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43552 */     // MIs[5] vA
     /*  43552 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43557 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43561 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43565 */     // MIs[6] vB
     /*  43565 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43570 */     // MIs[6] vC
     /*  43570 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43575 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43577 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43594 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43604 */     GIR_RootConstrainSelectedInstOperands,
     /*  43605 */     // GIR_Coverage, 5229,
     /*  43605 */     GIR_EraseRootFromParent_Done,
     /*  43606 */   // Label 539: @43606
     /*  43606 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(43744), // Rule ID 5230 //
     /*  43611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43658 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43662 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43666 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43670 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43676 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43678 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43682 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43686 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43690 */     // MIs[5] vA
     /*  43690 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43695 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43699 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43703 */     // MIs[6] vC
     /*  43703 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43708 */     // MIs[6] vB
     /*  43708 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43713 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43715 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43732 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43742 */     GIR_RootConstrainSelectedInstOperands,
     /*  43743 */     // GIR_Coverage, 5230,
     /*  43743 */     GIR_EraseRootFromParent_Done,
     /*  43744 */   // Label 540: @43744
     /*  43744 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(43882), // Rule ID 5237 //
     /*  43749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43800 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43804 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43808 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43814 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43816 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43820 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43824 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43828 */     // MIs[5] vC
     /*  43828 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43833 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43837 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43841 */     // MIs[6] vA
     /*  43841 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43846 */     // MIs[6] vB
     /*  43846 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43851 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43853 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  43862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  43866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  43870 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43880 */     GIR_RootConstrainSelectedInstOperands,
     /*  43881 */     // GIR_Coverage, 5237,
     /*  43881 */     GIR_EraseRootFromParent_Done,
     /*  43882 */   // Label 541: @43882
     /*  43882 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(44020), // Rule ID 5238 //
     /*  43887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43934 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43938 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43942 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43946 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43952 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43954 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43958 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43962 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43966 */     // MIs[5] vC
     /*  43966 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43971 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43975 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43979 */     // MIs[6] vB
     /*  43979 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43984 */     // MIs[6] vA
     /*  43984 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43989 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43991 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44008 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44018 */     GIR_RootConstrainSelectedInstOperands,
     /*  44019 */     // GIR_Coverage, 5238,
     /*  44019 */     GIR_EraseRootFromParent_Done,
     /*  44020 */   // Label 542: @44020
     /*  44020 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(44158), // Rule ID 5239 //
     /*  44025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44072 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44076 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44080 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44084 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44090 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44092 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44096 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44100 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44104 */     // MIs[5] vB
     /*  44104 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44109 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44113 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44117 */     // MIs[6] vA
     /*  44117 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44122 */     // MIs[6] vC
     /*  44122 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44127 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44129 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44146 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44156 */     GIR_RootConstrainSelectedInstOperands,
     /*  44157 */     // GIR_Coverage, 5239,
     /*  44157 */     GIR_EraseRootFromParent_Done,
     /*  44158 */   // Label 543: @44158
     /*  44158 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(44296), // Rule ID 5240 //
     /*  44163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44210 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44214 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44222 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44230 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44234 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44238 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44242 */     // MIs[5] vB
     /*  44242 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44247 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44251 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44255 */     // MIs[6] vC
     /*  44255 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44260 */     // MIs[6] vA
     /*  44260 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44265 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44267 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44284 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44294 */     GIR_RootConstrainSelectedInstOperands,
     /*  44295 */     // GIR_Coverage, 5240,
     /*  44295 */     GIR_EraseRootFromParent_Done,
     /*  44296 */   // Label 544: @44296
     /*  44296 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(44434), // Rule ID 5241 //
     /*  44301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44348 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44352 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44356 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44360 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44366 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44368 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44372 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44376 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44380 */     // MIs[5] vA
     /*  44380 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44385 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44389 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44393 */     // MIs[6] vB
     /*  44393 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44398 */     // MIs[6] vC
     /*  44398 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44403 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44405 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44422 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44432 */     GIR_RootConstrainSelectedInstOperands,
     /*  44433 */     // GIR_Coverage, 5241,
     /*  44433 */     GIR_EraseRootFromParent_Done,
     /*  44434 */   // Label 545: @44434
     /*  44434 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(44572), // Rule ID 5242 //
     /*  44439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44490 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44494 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44498 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44504 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44506 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44510 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44514 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44518 */     // MIs[5] vA
     /*  44518 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44523 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44527 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44531 */     // MIs[6] vC
     /*  44531 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44536 */     // MIs[6] vB
     /*  44536 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44541 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44543 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44560 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44570 */     GIR_RootConstrainSelectedInstOperands,
     /*  44571 */     // GIR_Coverage, 5242,
     /*  44571 */     GIR_EraseRootFromParent_Done,
     /*  44572 */   // Label 546: @44572
     /*  44572 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(44710), // Rule ID 5249 //
     /*  44577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44624 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44628 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44632 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44636 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44642 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44644 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44648 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44652 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44656 */     // MIs[5] vC
     /*  44656 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44661 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44665 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44669 */     // MIs[6] vA
     /*  44669 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44674 */     // MIs[6] vB
     /*  44674 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44679 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44681 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44698 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44708 */     GIR_RootConstrainSelectedInstOperands,
     /*  44709 */     // GIR_Coverage, 5249,
     /*  44709 */     GIR_EraseRootFromParent_Done,
     /*  44710 */   // Label 547: @44710
     /*  44710 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(44848), // Rule ID 5250 //
     /*  44715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44750 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44762 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44766 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44770 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44774 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44782 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44786 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44790 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44794 */     // MIs[5] vC
     /*  44794 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44799 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44803 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44807 */     // MIs[6] vB
     /*  44807 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44812 */     // MIs[6] vA
     /*  44812 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44817 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44819 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44836 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44846 */     GIR_RootConstrainSelectedInstOperands,
     /*  44847 */     // GIR_Coverage, 5250,
     /*  44847 */     GIR_EraseRootFromParent_Done,
     /*  44848 */   // Label 548: @44848
     /*  44848 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(44986), // Rule ID 5251 //
     /*  44853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44904 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44912 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44918 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44920 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44924 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44928 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44932 */     // MIs[5] vB
     /*  44932 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44937 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44941 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44945 */     // MIs[6] vA
     /*  44945 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44950 */     // MIs[6] vC
     /*  44950 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44955 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44957 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44974 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44984 */     GIR_RootConstrainSelectedInstOperands,
     /*  44985 */     // GIR_Coverage, 5251,
     /*  44985 */     GIR_EraseRootFromParent_Done,
     /*  44986 */   // Label 549: @44986
     /*  44986 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(45124), // Rule ID 5252 //
     /*  44991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45042 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45046 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45050 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45058 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45062 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45066 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45070 */     // MIs[5] vB
     /*  45070 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45075 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45079 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45083 */     // MIs[6] vC
     /*  45083 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45088 */     // MIs[6] vA
     /*  45088 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45093 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45095 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45112 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45122 */     GIR_RootConstrainSelectedInstOperands,
     /*  45123 */     // GIR_Coverage, 5252,
     /*  45123 */     GIR_EraseRootFromParent_Done,
     /*  45124 */   // Label 550: @45124
     /*  45124 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(45262), // Rule ID 5253 //
     /*  45129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  45132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45176 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45180 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45184 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45188 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45194 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45196 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45200 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45204 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45208 */     // MIs[5] vA
     /*  45208 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45213 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45217 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45221 */     // MIs[6] vB
     /*  45221 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45226 */     // MIs[6] vC
     /*  45226 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45231 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45233 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45250 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45260 */     GIR_RootConstrainSelectedInstOperands,
     /*  45261 */     // GIR_Coverage, 5253,
     /*  45261 */     GIR_EraseRootFromParent_Done,
     /*  45262 */   // Label 551: @45262
     /*  45262 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(45400), // Rule ID 5254 //
     /*  45267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  45270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45314 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45318 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45326 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45334 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45338 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45342 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45346 */     // MIs[5] vA
     /*  45346 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45351 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45355 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45359 */     // MIs[6] vC
     /*  45359 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45364 */     // MIs[6] vB
     /*  45364 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45369 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45371 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45388 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45398 */     GIR_RootConstrainSelectedInstOperands,
     /*  45399 */     // GIR_Coverage, 5254,
     /*  45399 */     GIR_EraseRootFromParent_Done,
     /*  45400 */   // Label 552: @45400
     /*  45400 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(45494), // Rule ID 4941 //
     /*  45405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45448 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45454 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45464 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45468 */     // MIs[4] C
     /*  45468 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45473 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45475 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /*  45484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // B
     /*  45488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45492 */     GIR_RootConstrainSelectedInstOperands,
     /*  45493 */     // GIR_Coverage, 4941,
     /*  45493 */     GIR_EraseRootFromParent_Done,
     /*  45494 */   // Label 553: @45494
     /*  45494 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(45588), // Rule ID 1581 //
     /*  45499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45542 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45548 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45558 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45562 */     // MIs[4] C
     /*  45562 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45567 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45569 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /*  45578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // B
     /*  45582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45586 */     GIR_RootConstrainSelectedInstOperands,
     /*  45587 */     // GIR_Coverage, 1581,
     /*  45587 */     GIR_EraseRootFromParent_Done,
     /*  45588 */   // Label 554: @45588
     /*  45588 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(45682), // Rule ID 4943 //
     /*  45593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45636 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45642 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45644 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45648 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45652 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45656 */     // MIs[4] C
     /*  45656 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45661 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45663 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  45672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // B
     /*  45676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45680 */     GIR_RootConstrainSelectedInstOperands,
     /*  45681 */     // GIR_Coverage, 4943,
     /*  45681 */     GIR_EraseRootFromParent_Done,
     /*  45682 */   // Label 555: @45682
     /*  45682 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(45776), // Rule ID 4942 //
     /*  45687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45730 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45736 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45746 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45750 */     // MIs[4] C
     /*  45750 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45755 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45757 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  45766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // B
     /*  45770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45774 */     GIR_RootConstrainSelectedInstOperands,
     /*  45775 */     // GIR_Coverage, 4942,
     /*  45775 */     GIR_EraseRootFromParent_Done,
     /*  45776 */   // Label 556: @45776
     /*  45776 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(45870), // Rule ID 4944 //
     /*  45781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45828 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45832 */     // MIs[3] C
     /*  45832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45837 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45841 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45849 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45851 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // A
     /*  45860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*  45864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // C
     /*  45868 */     GIR_RootConstrainSelectedInstOperands,
     /*  45869 */     // GIR_Coverage, 4944,
     /*  45869 */     GIR_EraseRootFromParent_Done,
     /*  45870 */   // Label 557: @45870
     /*  45870 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(45964), // Rule ID 4946 //
     /*  45875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45922 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45926 */     // MIs[3] C
     /*  45926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45931 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45935 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45941 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45943 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45945 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // A
     /*  45954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  45958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // C
     /*  45962 */     GIR_RootConstrainSelectedInstOperands,
     /*  45963 */     // GIR_Coverage, 4946,
     /*  45963 */     GIR_EraseRootFromParent_Done,
     /*  45964 */   // Label 558: @45964
     /*  45964 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(46058), // Rule ID 4945 //
     /*  45969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46016 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46020 */     // MIs[3] C
     /*  46020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  46025 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46029 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46035 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  46037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46039 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  46039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  46042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // A
     /*  46048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*  46052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // C
     /*  46056 */     GIR_RootConstrainSelectedInstOperands,
     /*  46057 */     // GIR_Coverage, 4945,
     /*  46057 */     GIR_EraseRootFromParent_Done,
     /*  46058 */   // Label 559: @46058
     /*  46058 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(46152), // Rule ID 4947 //
     /*  46063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  46066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46110 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46114 */     // MIs[3] C
     /*  46114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  46119 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46123 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  46131 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46133 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  46133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  46136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // A
     /*  46142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  46146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // C
     /*  46150 */     GIR_RootConstrainSelectedInstOperands,
     /*  46151 */     // GIR_Coverage, 4947,
     /*  46151 */     GIR_EraseRootFromParent_Done,
     /*  46152 */   // Label 560: @46152
     /*  46152 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(46239), // Rule ID 4967 //
     /*  46157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46200 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46210 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 241:{ *:[i32] })
     /*  46210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46227 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(241),
     /*  46237 */     GIR_RootConstrainSelectedInstOperands,
     /*  46238 */     // GIR_Coverage, 4967,
     /*  46238 */     GIR_EraseRootFromParent_Done,
     /*  46239 */   // Label 561: @46239
     /*  46239 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(46324), // Rule ID 4961 //
     /*  46244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46287 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46293 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46297 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  46310 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  46312 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46322 */     GIR_RootConstrainSelectedInstOperands,
     /*  46323 */     // GIR_Coverage, 4961,
     /*  46323 */     GIR_EraseRootFromParent_Done,
     /*  46324 */   // Label 562: @46324
     /*  46324 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(46409), // Rule ID 4962 //
     /*  46329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46372 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46378 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46382 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46395 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  46397 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46407 */     GIR_RootConstrainSelectedInstOperands,
     /*  46408 */     // GIR_Coverage, 4962,
     /*  46408 */     GIR_EraseRootFromParent_Done,
     /*  46409 */   // Label 563: @46409
     /*  46409 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(46496), // Rule ID 4963 //
     /*  46414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46457 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46463 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46467 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46484 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46494 */     GIR_RootConstrainSelectedInstOperands,
     /*  46495 */     // GIR_Coverage, 4963,
     /*  46495 */     GIR_EraseRootFromParent_Done,
     /*  46496 */   // Label 564: @46496
     /*  46496 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(46581), // Rule ID 5282 //
     /*  46501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46544 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46550 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46554 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 239:{ *:[i32] })
     /*  46554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46559 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46569 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(239),
     /*  46579 */     GIR_RootConstrainSelectedInstOperands,
     /*  46580 */     // GIR_Coverage, 5282,
     /*  46580 */     GIR_EraseRootFromParent_Done,
     /*  46581 */   // Label 565: @46581
     /*  46581 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(46666), // Rule ID 5283 //
     /*  46586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46629 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46635 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46637 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46639 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 143:{ *:[i32] })
     /*  46639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46644 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46654 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(143),
     /*  46664 */     GIR_RootConstrainSelectedInstOperands,
     /*  46665 */     // GIR_Coverage, 5283,
     /*  46665 */     GIR_EraseRootFromParent_Done,
     /*  46666 */   // Label 566: @46666
     /*  46666 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(46751), // Rule ID 5280 //
     /*  46671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46714 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46720 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46724 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46729 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46739 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46749 */     GIR_RootConstrainSelectedInstOperands,
     /*  46750 */     // GIR_Coverage, 5280,
     /*  46750 */     GIR_EraseRootFromParent_Done,
     /*  46751 */   // Label 567: @46751
     /*  46751 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(46836), // Rule ID 5279 //
     /*  46756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46799 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46805 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46809 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46814 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46824 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46834 */     GIR_RootConstrainSelectedInstOperands,
     /*  46835 */     // GIR_Coverage, 5279,
     /*  46835 */     GIR_EraseRootFromParent_Done,
     /*  46836 */   // Label 568: @46836
     /*  46836 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(46921), // Rule ID 5281 //
     /*  46841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46884 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46890 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46894 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46899 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  46909 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46919 */     GIR_RootConstrainSelectedInstOperands,
     /*  46920 */     // GIR_Coverage, 5281,
     /*  46920 */     GIR_EraseRootFromParent_Done,
     /*  46921 */   // Label 569: @46921
     /*  46921 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(47008), // Rule ID 3391 //
     /*  46926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46953 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46959 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46969 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46973 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46979 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 241:{ *:[i32] })
     /*  46979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  46988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  46992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  46996 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(241),
     /*  47006 */     GIR_RootConstrainSelectedInstOperands,
     /*  47007 */     // GIR_Coverage, 3391,
     /*  47007 */     GIR_EraseRootFromParent_Done,
     /*  47008 */   // Label 570: @47008
     /*  47008 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(47095), // Rule ID 3389 //
     /*  47013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47040 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47046 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47056 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47060 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47066 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  47075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  47079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  47083 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47093 */     GIR_RootConstrainSelectedInstOperands,
     /*  47094 */     // GIR_Coverage, 3389,
     /*  47094 */     GIR_EraseRootFromParent_Done,
     /*  47095 */   // Label 571: @47095
     /*  47095 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(47182), // Rule ID 3390 //
     /*  47100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47127 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47133 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47147 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47153 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 246:{ *:[i32] })
     /*  47153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  47162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  47166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  47170 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(246),
     /*  47180 */     GIR_RootConstrainSelectedInstOperands,
     /*  47181 */     // GIR_Coverage, 3390,
     /*  47181 */     GIR_EraseRootFromParent_Done,
     /*  47182 */   // Label 572: @47182
     /*  47182 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(47269), // Rule ID 4966 //
     /*  47187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47230 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47236 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47240 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 246:{ *:[i32] })
     /*  47240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  47253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  47257 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(246),
     /*  47267 */     GIR_RootConstrainSelectedInstOperands,
     /*  47268 */     // GIR_Coverage, 4966,
     /*  47268 */     GIR_EraseRootFromParent_Done,
     /*  47269 */   // Label 573: @47269
     /*  47269 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(47354), // Rule ID 4964 //
     /*  47274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47317 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47323 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47327 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  47340 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*  47342 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47352 */     GIR_RootConstrainSelectedInstOperands,
     /*  47353 */     // GIR_Coverage, 4964,
     /*  47353 */     GIR_EraseRootFromParent_Done,
     /*  47354 */   // Label 574: @47354
     /*  47354 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(47439), // Rule ID 4965 //
     /*  47359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47402 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47408 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47412 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  47425 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*  47427 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47437 */     GIR_RootConstrainSelectedInstOperands,
     /*  47438 */     // GIR_Coverage, 4965,
     /*  47438 */     GIR_EraseRootFromParent_Done,
     /*  47439 */   // Label 575: @47439
     /*  47439 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(47524), // Rule ID 3404 //
     /*  47444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47487 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47493 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47497 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 239:{ *:[i32] })
     /*  47497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47502 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47512 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(239),
     /*  47522 */     GIR_RootConstrainSelectedInstOperands,
     /*  47523 */     // GIR_Coverage, 3404,
     /*  47523 */     GIR_EraseRootFromParent_Done,
     /*  47524 */   // Label 576: @47524
     /*  47524 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(47609), // Rule ID 3405 //
     /*  47529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47572 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47578 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47582 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 143:{ *:[i32] })
     /*  47582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47587 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47597 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(143),
     /*  47607 */     GIR_RootConstrainSelectedInstOperands,
     /*  47608 */     // GIR_Coverage, 3405,
     /*  47608 */     GIR_EraseRootFromParent_Done,
     /*  47609 */   // Label 577: @47609
     /*  47609 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(47694), // Rule ID 5277 //
     /*  47614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47657 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47663 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47667 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47672 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  47682 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47692 */     GIR_RootConstrainSelectedInstOperands,
     /*  47693 */     // GIR_Coverage, 5277,
     /*  47693 */     GIR_EraseRootFromParent_Done,
     /*  47694 */   // Label 578: @47694
     /*  47694 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(47779), // Rule ID 3403 //
     /*  47699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47742 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47752 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47757 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47767 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47777 */     GIR_RootConstrainSelectedInstOperands,
     /*  47778 */     // GIR_Coverage, 3403,
     /*  47778 */     GIR_EraseRootFromParent_Done,
     /*  47779 */   // Label 579: @47779
     /*  47779 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(47864), // Rule ID 5278 //
     /*  47784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47827 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47833 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47837 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47842 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  47852 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47862 */     GIR_RootConstrainSelectedInstOperands,
     /*  47863 */     // GIR_Coverage, 5278,
     /*  47863 */     GIR_EraseRootFromParent_Done,
     /*  47864 */   // Label 580: @47864
     /*  47864 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(47919), // Rule ID 4931 //
     /*  47869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  47872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47896 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47902 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47906 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XA)  =>  (XXLORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  47906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLORC),
     /*  47909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47911 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  47913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*  47917 */     GIR_RootConstrainSelectedInstOperands,
     /*  47918 */     // GIR_Coverage, 4931,
     /*  47918 */     GIR_EraseRootFromParent_Done,
     /*  47919 */   // Label 581: @47919
     /*  47919 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(47974), // Rule ID 942 //
     /*  47924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  47927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47951 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47957 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47961 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }))  =>  (XXLORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  47961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLORC),
     /*  47964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47966 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /*  47968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*  47972 */     GIR_RootConstrainSelectedInstOperands,
     /*  47973 */     // GIR_Coverage, 942,
     /*  47973 */     GIR_EraseRootFromParent_Done,
     /*  47974 */   // Label 582: @47974
     /*  47974 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(48024), // Rule ID 5276 //
     /*  47979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48004 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 31:{ *:[i32] })
     /*  48004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48009 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  48011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  48022 */     GIR_RootConstrainSelectedInstOperands,
     /*  48023 */     // GIR_Coverage, 5276,
     /*  48023 */     GIR_EraseRootFromParent_Done,
     /*  48024 */   // Label 583: @48024
     /*  48024 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(48074), // Rule ID 5275 //
     /*  48029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  48044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48054 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 127:{ *:[i32] })
     /*  48054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  48063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  48067 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  48069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/127,
     /*  48072 */     GIR_RootConstrainSelectedInstOperands,
     /*  48073 */     // GIR_Coverage, 5275,
     /*  48073 */     GIR_EraseRootFromParent_Done,
     /*  48074 */   // Label 584: @48074
     /*  48074 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(48124), // Rule ID 5284 //
     /*  48079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48104 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 111:{ *:[i32] })
     /*  48104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48109 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  48111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/111,
     /*  48122 */     GIR_RootConstrainSelectedInstOperands,
     /*  48123 */     // GIR_Coverage, 5284,
     /*  48123 */     GIR_EraseRootFromParent_Done,
     /*  48124 */   // Label 585: @48124
     /*  48124 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(48174), // Rule ID 3402 //
     /*  48129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48154 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 31:{ *:[i32] })
     /*  48154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48159 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  48172 */     GIR_RootConstrainSelectedInstOperands,
     /*  48173 */     // GIR_Coverage, 3402,
     /*  48173 */     GIR_EraseRootFromParent_Done,
     /*  48174 */   // Label 586: @48174
     /*  48174 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(48224), // Rule ID 3401 //
     /*  48179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  48194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48204 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 127:{ *:[i32] })
     /*  48204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48209 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/127,
     /*  48222 */     GIR_RootConstrainSelectedInstOperands,
     /*  48223 */     // GIR_Coverage, 3401,
     /*  48223 */     GIR_EraseRootFromParent_Done,
     /*  48224 */   // Label 587: @48224
     /*  48224 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(48274), // Rule ID 3406 //
     /*  48229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48254 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 111:{ *:[i32] })
     /*  48254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48259 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/111,
     /*  48272 */     GIR_RootConstrainSelectedInstOperands,
     /*  48273 */     // GIR_Coverage, 3406,
     /*  48273 */     GIR_EraseRootFromParent_Done,
     /*  48274 */   // Label 588: @48274
     /*  48274 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(48293), // Rule ID 931 //
     /*  48279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  48282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48286 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  48286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLOR),
     /*  48291 */     GIR_RootConstrainSelectedInstOperands,
     /*  48292 */     // GIR_Coverage, 931,
     /*  48292 */     GIR_Done,
     /*  48293 */   // Label 589: @48293
     /*  48293 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(48348), // Rule ID 4919 //
     /*  48298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  48301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48325 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48331 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  48333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48335 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VA)  =>  (VORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VORC),
     /*  48338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  48340 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  48342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*  48346 */     GIR_RootConstrainSelectedInstOperands,
     /*  48347 */     // GIR_Coverage, 4919,
     /*  48347 */     GIR_EraseRootFromParent_Done,
     /*  48348 */   // Label 590: @48348
     /*  48348 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(48403), // Rule ID 489 //
     /*  48353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  48356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48380 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48386 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  48388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48390 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }))  =>  (VORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VORC),
     /*  48393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  48395 */     GIR_RootToRootCopy, /*OpIdx*/1, // VA
     /*  48397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*  48401 */     GIR_RootConstrainSelectedInstOperands,
     /*  48402 */     // GIR_Coverage, 489,
     /*  48402 */     GIR_EraseRootFromParent_Done,
     /*  48403 */   // Label 591: @48403
     /*  48403 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(48422), // Rule ID 386 //
     /*  48408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  48411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48415 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VOR),
     /*  48420 */     GIR_RootConstrainSelectedInstOperands,
     /*  48421 */     // GIR_Coverage, 386,
     /*  48421 */     GIR_Done,
     /*  48422 */   // Label 592: @48422
     /*  48422 */   GIM_Reject,
     /*  48423 */ // Label 264: @48423
     /*  48423 */ GIM_Reject,
     /*  48424 */ // Label 251: @48424
     /*  48424 */ GIM_Reject,
     /*  48425 */ // Label 9: @48425
     /*  48425 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 597*/ GIMT_Encode4(57531),
     /*  48436 */ /*GILLT_s1*//*Label 593*/ GIMT_Encode4(48460),
     /*  48440 */ /*GILLT_s32*//*Label 594*/ GIMT_Encode4(53897),
     /*  48444 */ /*GILLT_s64*//*Label 595*/ GIMT_Encode4(54152), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48456 */ /*GILLT_v4s32*//*Label 596*/ GIMT_Encode4(54407),
     /*  48460 */ // Label 593: @48460
     /*  48460 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(53896),
     /*  48465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  48468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  48471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48475 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(48566), // Rule ID 3028 //
     /*  48480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48495 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48499 */     // MIs[1] Operand 1
     /*  48499 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  48504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48512 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48516 */     // MIs[2] Operand 1
     /*  48516 */     // No operand predicates
     /*  48516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48522 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /*  48522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48548 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  48555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48565 */     // GIR_Coverage, 3028,
     /*  48565 */     GIR_EraseRootFromParent_Done,
     /*  48566 */   // Label 599: @48566
     /*  48566 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(48657), // Rule ID 3044 //
     /*  48571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48586 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48590 */     // MIs[1] Operand 1
     /*  48590 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  48595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48603 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48607 */     // MIs[2] Operand 1
     /*  48607 */     // No operand predicates
     /*  48607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48613 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /*  48613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48639 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  48646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48656 */     // GIR_Coverage, 3044,
     /*  48656 */     GIR_EraseRootFromParent_Done,
     /*  48657 */   // Label 600: @48657
     /*  48657 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(48748), // Rule ID 3052 //
     /*  48662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48677 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48681 */     // MIs[1] Operand 1
     /*  48681 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  48686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48694 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48698 */     // MIs[2] Operand 1
     /*  48698 */     // No operand predicates
     /*  48698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48704 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /*  48704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48730 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  48737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48747 */     // GIR_Coverage, 3052,
     /*  48747 */     GIR_EraseRootFromParent_Done,
     /*  48748 */   // Label 601: @48748
     /*  48748 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(48839), // Rule ID 3124 //
     /*  48753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48768 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48772 */     // MIs[1] Operand 1
     /*  48772 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  48777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48785 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48789 */     // MIs[2] Operand 1
     /*  48789 */     // No operand predicates
     /*  48789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48795 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /*  48795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48807 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48821 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  48828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48838 */     // GIR_Coverage, 3124,
     /*  48838 */     GIR_EraseRootFromParent_Done,
     /*  48839 */   // Label 602: @48839
     /*  48839 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(48930), // Rule ID 3140 //
     /*  48844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48859 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48863 */     // MIs[1] Operand 1
     /*  48863 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  48868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48876 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48880 */     // MIs[2] Operand 1
     /*  48880 */     // No operand predicates
     /*  48880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48886 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /*  48886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48912 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  48919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48929 */     // GIR_Coverage, 3140,
     /*  48929 */     GIR_EraseRootFromParent_Done,
     /*  48930 */   // Label 603: @48930
     /*  48930 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(49021), // Rule ID 3148 //
     /*  48935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48950 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48954 */     // MIs[1] Operand 1
     /*  48954 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  48959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48967 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48971 */     // MIs[2] Operand 1
     /*  48971 */     // No operand predicates
     /*  48971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48977 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /*  48977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49020 */     // GIR_Coverage, 3148,
     /*  49020 */     GIR_EraseRootFromParent_Done,
     /*  49021 */   // Label 604: @49021
     /*  49021 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(49112), // Rule ID 3810 //
     /*  49026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49041 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49045 */     // MIs[1] Operand 1
     /*  49045 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  49050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49058 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49062 */     // MIs[2] Operand 1
     /*  49062 */     // No operand predicates
     /*  49062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49068 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /*  49068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49080 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49094 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49111 */     // GIR_Coverage, 3810,
     /*  49111 */     GIR_EraseRootFromParent_Done,
     /*  49112 */   // Label 605: @49112
     /*  49112 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(49203), // Rule ID 3826 //
     /*  49117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49132 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49136 */     // MIs[1] Operand 1
     /*  49136 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  49141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49149 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49153 */     // MIs[2] Operand 1
     /*  49153 */     // No operand predicates
     /*  49153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49159 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /*  49159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49185 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49202 */     // GIR_Coverage, 3826,
     /*  49202 */     GIR_EraseRootFromParent_Done,
     /*  49203 */   // Label 606: @49203
     /*  49203 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(49294), // Rule ID 3834 //
     /*  49208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49223 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49227 */     // MIs[1] Operand 1
     /*  49227 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  49232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49240 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49244 */     // MIs[2] Operand 1
     /*  49244 */     // No operand predicates
     /*  49244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49250 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /*  49250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49276 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49293 */     // GIR_Coverage, 3834,
     /*  49293 */     GIR_EraseRootFromParent_Done,
     /*  49294 */   // Label 607: @49294
     /*  49294 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(49385), // Rule ID 3906 //
     /*  49299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49314 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49318 */     // MIs[1] Operand 1
     /*  49318 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  49323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49331 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49335 */     // MIs[2] Operand 1
     /*  49335 */     // No operand predicates
     /*  49335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49341 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /*  49341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49367 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49379 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49384 */     // GIR_Coverage, 3906,
     /*  49384 */     GIR_EraseRootFromParent_Done,
     /*  49385 */   // Label 608: @49385
     /*  49385 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(49476), // Rule ID 3922 //
     /*  49390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49405 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49409 */     // MIs[1] Operand 1
     /*  49409 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  49414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49422 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49426 */     // MIs[2] Operand 1
     /*  49426 */     // No operand predicates
     /*  49426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49432 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /*  49432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49458 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49475 */     // GIR_Coverage, 3922,
     /*  49475 */     GIR_EraseRootFromParent_Done,
     /*  49476 */   // Label 609: @49476
     /*  49476 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(49567), // Rule ID 3930 //
     /*  49481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49496 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49500 */     // MIs[1] Operand 1
     /*  49500 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  49505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49513 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49517 */     // MIs[2] Operand 1
     /*  49517 */     // No operand predicates
     /*  49517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49523 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /*  49523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49535 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49549 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49566 */     // GIR_Coverage, 3930,
     /*  49566 */     GIR_EraseRootFromParent_Done,
     /*  49567 */   // Label 610: @49567
     /*  49567 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(49647), // Rule ID 3172 //
     /*  49572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49587 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49591 */     // MIs[1] Operand 1
     /*  49591 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  49596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49602 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /*  49602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49629 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49646 */     // GIR_Coverage, 3172,
     /*  49646 */     GIR_EraseRootFromParent_Done,
     /*  49647 */   // Label 611: @49647
     /*  49647 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(49727), // Rule ID 3188 //
     /*  49652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49671 */     // MIs[1] Operand 1
     /*  49671 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  49676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49682 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  49682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49698 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49709 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49726 */     // GIR_Coverage, 3188,
     /*  49726 */     GIR_EraseRootFromParent_Done,
     /*  49727 */   // Label 612: @49727
     /*  49727 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(49807), // Rule ID 3204 //
     /*  49732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49747 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49751 */     // MIs[1] Operand 1
     /*  49751 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  49756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49762 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /*  49762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49789 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49806 */     // GIR_Coverage, 3204,
     /*  49806 */     GIR_EraseRootFromParent_Done,
     /*  49807 */   // Label 613: @49807
     /*  49807 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(49887), // Rule ID 3220 //
     /*  49812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49827 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49831 */     // MIs[1] Operand 1
     /*  49831 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  49836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49842 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /*  49842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49869 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  49876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49886 */     // GIR_Coverage, 3220,
     /*  49886 */     GIR_EraseRootFromParent_Done,
     /*  49887 */   // Label 614: @49887
     /*  49887 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(49967), // Rule ID 3228 //
     /*  49892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49907 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49911 */     // MIs[1] Operand 1
     /*  49911 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  49916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49922 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /*  49922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  49929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49949 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49966 */     // GIR_Coverage, 3228,
     /*  49966 */     GIR_EraseRootFromParent_Done,
     /*  49967 */   // Label 615: @49967
     /*  49967 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(50047), // Rule ID 3244 //
     /*  49972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49987 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49991 */     // MIs[1] Operand 1
     /*  49991 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  49996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50002 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  50002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50029 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50046 */     // GIR_Coverage, 3244,
     /*  50046 */     GIR_EraseRootFromParent_Done,
     /*  50047 */   // Label 616: @50047
     /*  50047 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(50127), // Rule ID 3260 //
     /*  50052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50067 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50071 */     // MIs[1] Operand 1
     /*  50071 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50082 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /*  50082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50109 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50126 */     // GIR_Coverage, 3260,
     /*  50126 */     GIR_EraseRootFromParent_Done,
     /*  50127 */   // Label 617: @50127
     /*  50127 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(50207), // Rule ID 3276 //
     /*  50132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50147 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50151 */     // MIs[1] Operand 1
     /*  50151 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50162 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /*  50162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50189 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50206 */     // GIR_Coverage, 3276,
     /*  50206 */     GIR_EraseRootFromParent_Done,
     /*  50207 */   // Label 618: @50207
     /*  50207 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(50287), // Rule ID 3284 //
     /*  50212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50227 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50231 */     // MIs[1] Operand 1
     /*  50231 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50242 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /*  50242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50269 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50286 */     // GIR_Coverage, 3284,
     /*  50286 */     GIR_EraseRootFromParent_Done,
     /*  50287 */   // Label 619: @50287
     /*  50287 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(50367), // Rule ID 3300 //
     /*  50292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50307 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50311 */     // MIs[1] Operand 1
     /*  50311 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50322 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /*  50322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50334 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50349 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50366 */     // GIR_Coverage, 3300,
     /*  50366 */     GIR_EraseRootFromParent_Done,
     /*  50367 */   // Label 620: @50367
     /*  50367 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(50447), // Rule ID 3316 //
     /*  50372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50387 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50391 */     // MIs[1] Operand 1
     /*  50391 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50402 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /*  50402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50429 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50446 */     // GIR_Coverage, 3316,
     /*  50446 */     GIR_EraseRootFromParent_Done,
     /*  50447 */   // Label 621: @50447
     /*  50447 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(50527), // Rule ID 3332 //
     /*  50452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50467 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50471 */     // MIs[1] Operand 1
     /*  50471 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50482 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /*  50482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50509 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50526 */     // GIR_Coverage, 3332,
     /*  50526 */     GIR_EraseRootFromParent_Done,
     /*  50527 */   // Label 622: @50527
     /*  50527 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(50607), // Rule ID 4010 //
     /*  50532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50547 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50551 */     // MIs[1] Operand 1
     /*  50551 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50562 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /*  50562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50574 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50589 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50606 */     // GIR_Coverage, 4010,
     /*  50606 */     GIR_EraseRootFromParent_Done,
     /*  50607 */   // Label 623: @50607
     /*  50607 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(50687), // Rule ID 4042 //
     /*  50612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50627 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50631 */     // MIs[1] Operand 1
     /*  50631 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50642 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  50642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50669 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50686 */     // GIR_Coverage, 4042,
     /*  50686 */     GIR_EraseRootFromParent_Done,
     /*  50687 */   // Label 624: @50687
     /*  50687 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(50767), // Rule ID 4074 //
     /*  50692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50707 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50711 */     // MIs[1] Operand 1
     /*  50711 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50722 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /*  50722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50749 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50766 */     // GIR_Coverage, 4074,
     /*  50766 */     GIR_EraseRootFromParent_Done,
     /*  50767 */   // Label 625: @50767
     /*  50767 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(50847), // Rule ID 4106 //
     /*  50772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50787 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50791 */     // MIs[1] Operand 1
     /*  50791 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50802 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /*  50802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50829 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50846 */     // GIR_Coverage, 4106,
     /*  50846 */     GIR_EraseRootFromParent_Done,
     /*  50847 */   // Label 626: @50847
     /*  50847 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(50927), // Rule ID 4122 //
     /*  50852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50867 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50871 */     // MIs[1] Operand 1
     /*  50871 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50882 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /*  50882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50926 */     // GIR_Coverage, 4122,
     /*  50926 */     GIR_EraseRootFromParent_Done,
     /*  50927 */   // Label 627: @50927
     /*  50927 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(51007), // Rule ID 4154 //
     /*  50932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50947 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50951 */     // MIs[1] Operand 1
     /*  50951 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50962 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  50962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50989 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51006 */     // GIR_Coverage, 4154,
     /*  51006 */     GIR_EraseRootFromParent_Done,
     /*  51007 */   // Label 628: @51007
     /*  51007 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(51087), // Rule ID 4186 //
     /*  51012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51027 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51031 */     // MIs[1] Operand 1
     /*  51031 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51042 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /*  51042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  51049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51069 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  51076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51086 */     // GIR_Coverage, 4186,
     /*  51086 */     GIR_EraseRootFromParent_Done,
     /*  51087 */   // Label 629: @51087
     /*  51087 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(51167), // Rule ID 4218 //
     /*  51092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51107 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51111 */     // MIs[1] Operand 1
     /*  51111 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  51116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51122 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /*  51122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  51129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51138 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51149 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  51156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51166 */     // GIR_Coverage, 4218,
     /*  51166 */     GIR_EraseRootFromParent_Done,
     /*  51167 */   // Label 630: @51167
     /*  51167 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(51247), // Rule ID 4248 //
     /*  51172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51191 */     // MIs[1] Operand 1
     /*  51191 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51202 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /*  51202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51229 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  51236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51246 */     // GIR_Coverage, 4248,
     /*  51246 */     GIR_EraseRootFromParent_Done,
     /*  51247 */   // Label 631: @51247
     /*  51247 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(51327), // Rule ID 4280 //
     /*  51252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51271 */     // MIs[1] Operand 1
     /*  51271 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51282 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /*  51282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51309 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51326 */     // GIR_Coverage, 4280,
     /*  51326 */     GIR_EraseRootFromParent_Done,
     /*  51327 */   // Label 632: @51327
     /*  51327 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(51407), // Rule ID 4312 //
     /*  51332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51347 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51351 */     // MIs[1] Operand 1
     /*  51351 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51362 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /*  51362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  51396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51406 */     // GIR_Coverage, 4312,
     /*  51406 */     GIR_EraseRootFromParent_Done,
     /*  51407 */   // Label 633: @51407
     /*  51407 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(51487), // Rule ID 4344 //
     /*  51412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51427 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51431 */     // MIs[1] Operand 1
     /*  51431 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  51436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51442 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /*  51442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51469 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  51476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51486 */     // GIR_Coverage, 4344,
     /*  51486 */     GIR_EraseRootFromParent_Done,
     /*  51487 */   // Label 634: @51487
     /*  51487 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(51567), // Rule ID 4575 //
     /*  51492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51507 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51511 */     // MIs[1] Operand 1
     /*  51511 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51522 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /*  51529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51549 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51566 */     // GIR_Coverage, 4575,
     /*  51566 */     GIR_EraseRootFromParent_Done,
     /*  51567 */   // Label 635: @51567
     /*  51567 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(51647), // Rule ID 4607 //
     /*  51572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51587 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51591 */     // MIs[1] Operand 1
     /*  51591 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51602 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /*  51609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51629 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51646 */     // GIR_Coverage, 4607,
     /*  51646 */     GIR_EraseRootFromParent_Done,
     /*  51647 */   // Label 636: @51647
     /*  51647 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(51727), // Rule ID 4639 //
     /*  51652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51671 */     // MIs[1] Operand 1
     /*  51671 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51682 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /*  51689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51698 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51709 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51726 */     // GIR_Coverage, 4639,
     /*  51726 */     GIR_EraseRootFromParent_Done,
     /*  51727 */   // Label 637: @51727
     /*  51727 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(51807), // Rule ID 4683 //
     /*  51732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51747 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51751 */     // MIs[1] Operand 1
     /*  51751 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51762 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /*  51769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51789 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51806 */     // GIR_Coverage, 4683,
     /*  51806 */     GIR_EraseRootFromParent_Done,
     /*  51807 */   // Label 638: @51807
     /*  51807 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(51887), // Rule ID 4715 //
     /*  51812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51827 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51831 */     // MIs[1] Operand 1
     /*  51831 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51842 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /*  51849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51869 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51886 */     // GIR_Coverage, 4715,
     /*  51886 */     GIR_EraseRootFromParent_Done,
     /*  51887 */   // Label 639: @51887
     /*  51887 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(51967), // Rule ID 4747 //
     /*  51892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51907 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51911 */     // MIs[1] Operand 1
     /*  51911 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51922 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /*  51929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51949 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51966 */     // GIR_Coverage, 4747,
     /*  51966 */     GIR_EraseRootFromParent_Done,
     /*  51967 */   // Label 640: @51967
     /*  51967 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(52047), // Rule ID 2974 //
     /*  51972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  51975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  51983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51987 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51991 */     // MIs[1] Operand 1
     /*  51991 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  51996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52002 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52029 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52046 */     // GIR_Coverage, 2974,
     /*  52046 */     GIR_EraseRootFromParent_Done,
     /*  52047 */   // Label 641: @52047
     /*  52047 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(52127), // Rule ID 2988 //
     /*  52052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52067 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52071 */     // MIs[1] Operand 1
     /*  52071 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52082 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52109 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52126 */     // GIR_Coverage, 2988,
     /*  52126 */     GIR_EraseRootFromParent_Done,
     /*  52127 */   // Label 642: @52127
     /*  52127 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(52207), // Rule ID 2996 //
     /*  52132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52147 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52151 */     // MIs[1] Operand 1
     /*  52151 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52162 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52189 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52206 */     // GIR_Coverage, 2996,
     /*  52206 */     GIR_EraseRootFromParent_Done,
     /*  52207 */   // Label 643: @52207
     /*  52207 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(52287), // Rule ID 3004 //
     /*  52212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52227 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52231 */     // MIs[1] Operand 1
     /*  52231 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  52236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52242 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52269 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52286 */     // GIR_Coverage, 3004,
     /*  52286 */     GIR_EraseRootFromParent_Done,
     /*  52287 */   // Label 644: @52287
     /*  52287 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(52367), // Rule ID 3012 //
     /*  52292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52307 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52311 */     // MIs[1] Operand 1
     /*  52311 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  52316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52322 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /*  52322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52334 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52349 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  52356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52366 */     // GIR_Coverage, 3012,
     /*  52366 */     GIR_EraseRootFromParent_Done,
     /*  52367 */   // Label 645: @52367
     /*  52367 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(52447), // Rule ID 3076 //
     /*  52372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52387 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52391 */     // MIs[1] Operand 1
     /*  52391 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  52396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52402 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  52402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  52409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52429 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52446 */     // GIR_Coverage, 3076,
     /*  52446 */     GIR_EraseRootFromParent_Done,
     /*  52447 */   // Label 646: @52447
     /*  52447 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(52527), // Rule ID 3084 //
     /*  52452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52467 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52471 */     // MIs[1] Operand 1
     /*  52471 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52482 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  52482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52509 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52526 */     // GIR_Coverage, 3084,
     /*  52526 */     GIR_EraseRootFromParent_Done,
     /*  52527 */   // Label 647: @52527
     /*  52527 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(52607), // Rule ID 3092 //
     /*  52532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52547 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52551 */     // MIs[1] Operand 1
     /*  52551 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52562 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  52562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  52569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52574 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52589 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52606 */     // GIR_Coverage, 3092,
     /*  52606 */     GIR_EraseRootFromParent_Done,
     /*  52607 */   // Label 648: @52607
     /*  52607 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(52687), // Rule ID 3100 //
     /*  52612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52627 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52631 */     // MIs[1] Operand 1
     /*  52631 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  52636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52642 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  52642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52669 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52686 */     // GIR_Coverage, 3100,
     /*  52686 */     GIR_EraseRootFromParent_Done,
     /*  52687 */   // Label 649: @52687
     /*  52687 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(52767), // Rule ID 3108 //
     /*  52692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52707 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52711 */     // MIs[1] Operand 1
     /*  52711 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  52716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52722 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /*  52722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52749 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  52756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52766 */     // GIR_Coverage, 3108,
     /*  52766 */     GIR_EraseRootFromParent_Done,
     /*  52767 */   // Label 650: @52767
     /*  52767 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(52847), // Rule ID 3858 //
     /*  52772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52787 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52791 */     // MIs[1] Operand 1
     /*  52791 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  52796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52802 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52829 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52846 */     // GIR_Coverage, 3858,
     /*  52846 */     GIR_EraseRootFromParent_Done,
     /*  52847 */   // Label 651: @52847
     /*  52847 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(52927), // Rule ID 3866 //
     /*  52852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52867 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52871 */     // MIs[1] Operand 1
     /*  52871 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52882 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52926 */     // GIR_Coverage, 3866,
     /*  52926 */     GIR_EraseRootFromParent_Done,
     /*  52927 */   // Label 652: @52927
     /*  52927 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(53007), // Rule ID 3874 //
     /*  52932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52947 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52951 */     // MIs[1] Operand 1
     /*  52951 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52962 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52989 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53006 */     // GIR_Coverage, 3874,
     /*  53006 */     GIR_EraseRootFromParent_Done,
     /*  53007 */   // Label 653: @53007
     /*  53007 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(53087), // Rule ID 3882 //
     /*  53012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53027 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  53031 */     // MIs[1] Operand 1
     /*  53031 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  53036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53042 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  53042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  53049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53069 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53086 */     // GIR_Coverage, 3882,
     /*  53086 */     GIR_EraseRootFromParent_Done,
     /*  53087 */   // Label 654: @53087
     /*  53087 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(53167), // Rule ID 3890 //
     /*  53092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53107 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  53111 */     // MIs[1] Operand 1
     /*  53111 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  53116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53122 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /*  53122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  53129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53138 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53149 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  53156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53166 */     // GIR_Coverage, 3890,
     /*  53166 */     GIR_EraseRootFromParent_Done,
     /*  53167 */   // Label 655: @53167
     /*  53167 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(53247), // Rule ID 3954 //
     /*  53172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53191 */     // MIs[1] Operand 1
     /*  53191 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  53196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53202 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  53202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  53209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53229 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  53236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53246 */     // GIR_Coverage, 3954,
     /*  53246 */     GIR_EraseRootFromParent_Done,
     /*  53247 */   // Label 656: @53247
     /*  53247 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(53327), // Rule ID 3962 //
     /*  53252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53271 */     // MIs[1] Operand 1
     /*  53271 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  53276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53282 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  53282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53309 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  53316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53326 */     // GIR_Coverage, 3962,
     /*  53326 */     GIR_EraseRootFromParent_Done,
     /*  53327 */   // Label 657: @53327
     /*  53327 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(53407), // Rule ID 3970 //
     /*  53332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53347 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53351 */     // MIs[1] Operand 1
     /*  53351 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  53356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53362 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  53362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  53369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53406 */     // GIR_Coverage, 3970,
     /*  53406 */     GIR_EraseRootFromParent_Done,
     /*  53407 */   // Label 658: @53407
     /*  53407 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(53487), // Rule ID 3978 //
     /*  53412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53427 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53431 */     // MIs[1] Operand 1
     /*  53431 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  53436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53442 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  53442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53469 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53486 */     // GIR_Coverage, 3978,
     /*  53486 */     GIR_EraseRootFromParent_Done,
     /*  53487 */   // Label 659: @53487
     /*  53487 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(53567), // Rule ID 3986 //
     /*  53492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53507 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53511 */     // MIs[1] Operand 1
     /*  53511 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  53516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53522 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /*  53522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53549 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  53556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53566 */     // GIR_Coverage, 3986,
     /*  53566 */     GIR_EraseRootFromParent_Done,
     /*  53567 */   // Label 660: @53567
     /*  53567 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(53609), // Rule ID 176 //
     /*  53572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53594 */     // (xor:{ *:[i1] } (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CRNAND:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNAND),
     /*  53597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53607 */     GIR_RootConstrainSelectedInstOperands,
     /*  53608 */     // GIR_Coverage, 176,
     /*  53608 */     GIR_EraseRootFromParent_Done,
     /*  53609 */   // Label 661: @53609
     /*  53609 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(53651), // Rule ID 179 //
     /*  53614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53636 */     // (xor:{ *:[i1] } (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CRNOR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOR),
     /*  53639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53649 */     GIR_RootConstrainSelectedInstOperands,
     /*  53650 */     // GIR_Coverage, 179,
     /*  53650 */     GIR_EraseRootFromParent_Done,
     /*  53651 */   // Label 662: @53651
     /*  53651 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(53691), // Rule ID 4911 //
     /*  53656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53678 */     // (xor:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRB)  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53687 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRB
     /*  53689 */     GIR_RootConstrainSelectedInstOperands,
     /*  53690 */     // GIR_Coverage, 4911,
     /*  53690 */     GIR_EraseRootFromParent_Done,
     /*  53691 */   // Label 663: @53691
     /*  53691 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(53733), // Rule ID 180 //
     /*  53696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53718 */     // (xor:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53731 */     GIR_RootConstrainSelectedInstOperands,
     /*  53732 */     // GIR_Coverage, 180,
     /*  53732 */     GIR_EraseRootFromParent_Done,
     /*  53733 */   // Label 664: @53733
     /*  53733 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(53770), // Rule ID 4847 //
     /*  53738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  53746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53756 */     // (xor:{ *:[i1] } (trunc:{ *:[i1] } i32:{ *:[i32] }:$in), -1:{ *:[i1] })  =>  (ANDI_rec_1_EQ_BIT:{ *:[i1] }:{ *:[i32] } ?:{ *:[i32] }:$in)
     /*  53756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT),
     /*  53759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /*  53765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  53768 */     GIR_RootConstrainSelectedInstOperands,
     /*  53769 */     // GIR_Coverage, 4847,
     /*  53769 */     GIR_EraseRootFromParent_Done,
     /*  53770 */   // Label 665: @53770
     /*  53770 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(53807), // Rule ID 4848 //
     /*  53775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  53783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53793 */     // (xor:{ *:[i1] } (trunc:{ *:[i1] } i64:{ *:[i64] }:$in), -1:{ *:[i1] })  =>  (ANDI_rec_1_EQ_BIT8:{ *:[i1] }:{ *:[i32] } ?:{ *:[i64] }:$in)
     /*  53793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT8),
     /*  53796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /*  53802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  53805 */     GIR_RootConstrainSelectedInstOperands,
     /*  53806 */     // GIR_Coverage, 4848,
     /*  53806 */     GIR_EraseRootFromParent_Done,
     /*  53807 */   // Label 666: @53807
     /*  53807 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(53847), // Rule ID 4912 //
     /*  53812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53828 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53834 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] }))  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53843 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRB
     /*  53845 */     GIR_RootConstrainSelectedInstOperands,
     /*  53846 */     // GIR_Coverage, 4912,
     /*  53846 */     GIR_EraseRootFromParent_Done,
     /*  53847 */   // Label 667: @53847
     /*  53847 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(53865), // Rule ID 181 //
     /*  53852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53856 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] })  =>  (CRNOT:{ *:[i1] } i1:{ *:[i1] }:$CRA)
     /*  53856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /*  53859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53861 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*  53863 */     GIR_RootConstrainSelectedInstOperands,
     /*  53864 */     // GIR_Coverage, 181,
     /*  53864 */     GIR_EraseRootFromParent_Done,
     /*  53865 */   // Label 668: @53865
     /*  53865 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(53883), // Rule ID 2902 //
     /*  53870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53874 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$in, -1:{ *:[i1] })  =>  (CRNOT:{ *:[i1] } ?:{ *:[i1] }:$in)
     /*  53874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /*  53877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53879 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  53881 */     GIR_RootConstrainSelectedInstOperands,
     /*  53882 */     // GIR_Coverage, 2902,
     /*  53882 */     GIR_EraseRootFromParent_Done,
     /*  53883 */   // Label 669: @53883
     /*  53883 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(53895), // Rule ID 178 //
     /*  53888 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CRXOR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*  53893 */     GIR_RootConstrainSelectedInstOperands,
     /*  53894 */     // GIR_Coverage, 178,
     /*  53894 */     GIR_Done,
     /*  53895 */   // Label 670: @53895
     /*  53895 */   GIM_Reject,
     /*  53896 */ // Label 598: @53896
     /*  53896 */ GIM_Reject,
     /*  53897 */ // Label 594: @53897
     /*  53897 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(54151),
     /*  53902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  53912 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(53954), // Rule ID 121 //
     /*  53917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53939 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (NAND:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  53939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /*  53942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  53944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  53948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  53952 */     GIR_RootConstrainSelectedInstOperands,
     /*  53953 */     // GIR_Coverage, 121,
     /*  53953 */     GIR_EraseRootFromParent_Done,
     /*  53954 */   // Label 672: @53954
     /*  53954 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(53996), // Rule ID 125 //
     /*  53959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53981 */     // (xor:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  53981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  53984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  53986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  53990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  53994 */     GIR_RootConstrainSelectedInstOperands,
     /*  53995 */     // GIR_Coverage, 125,
     /*  53995 */     GIR_EraseRootFromParent_Done,
     /*  53996 */   // Label 673: @53996
     /*  53996 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(54036), // Rule ID 4909 //
     /*  54001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54017 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54023 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, -1:{ *:[i32] }), i32:{ *:[i32] }:$RB)  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54032 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  54034 */     GIR_RootConstrainSelectedInstOperands,
     /*  54035 */     // GIR_Coverage, 4909,
     /*  54035 */     GIR_EraseRootFromParent_Done,
     /*  54036 */   // Label 674: @54036
     /*  54036 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(54078), // Rule ID 127 //
     /*  54041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54063 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54076 */     GIR_RootConstrainSelectedInstOperands,
     /*  54077 */     // GIR_Coverage, 127,
     /*  54077 */     GIR_EraseRootFromParent_Done,
     /*  54078 */   // Label 675: @54078
     /*  54078 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(54118), // Rule ID 4910 //
     /*  54083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54099 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54105 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, -1:{ *:[i32] }))  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54114 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*  54116 */     GIR_RootConstrainSelectedInstOperands,
     /*  54117 */     // GIR_Coverage, 4910,
     /*  54117 */     GIR_EraseRootFromParent_Done,
     /*  54118 */   // Label 676: @54118
     /*  54118 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(54138), // Rule ID 1207 //
     /*  54123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54127 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } ?:{ *:[i32] }:$in, ?:{ *:[i32] }:$in)
     /*  54127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  54130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54132 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54134 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54136 */     GIR_RootConstrainSelectedInstOperands,
     /*  54137 */     // GIR_Coverage, 1207,
     /*  54137 */     GIR_EraseRootFromParent_Done,
     /*  54138 */   // Label 677: @54138
     /*  54138 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(54150), // Rule ID 128 //
     /*  54143 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (XOR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XOR),
     /*  54148 */     GIR_RootConstrainSelectedInstOperands,
     /*  54149 */     // GIR_Coverage, 128,
     /*  54149 */     GIR_Done,
     /*  54150 */   // Label 678: @54150
     /*  54150 */   GIM_Reject,
     /*  54151 */ // Label 671: @54151
     /*  54151 */ GIM_Reject,
     /*  54152 */ // Label 595: @54152
     /*  54152 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(54406),
     /*  54157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  54160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  54167 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(54209), // Rule ID 641 //
     /*  54172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54194 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (NAND8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /*  54197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54207 */     GIR_RootConstrainSelectedInstOperands,
     /*  54208 */     // GIR_Coverage, 641,
     /*  54208 */     GIR_EraseRootFromParent_Done,
     /*  54209 */   // Label 680: @54209
     /*  54209 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(54251), // Rule ID 645 //
     /*  54214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54236 */     // (xor:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (NOR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  54239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54249 */     GIR_RootConstrainSelectedInstOperands,
     /*  54250 */     // GIR_Coverage, 645,
     /*  54250 */     GIR_EraseRootFromParent_Done,
     /*  54251 */   // Label 681: @54251
     /*  54251 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(54291), // Rule ID 4922 //
     /*  54256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54272 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54278 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, -1:{ *:[i64] }), i64:{ *:[i64] }:$RB)  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54287 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  54289 */     GIR_RootConstrainSelectedInstOperands,
     /*  54290 */     // GIR_Coverage, 4922,
     /*  54290 */     GIR_EraseRootFromParent_Done,
     /*  54291 */   // Label 682: @54291
     /*  54291 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(54333), // Rule ID 647 //
     /*  54296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54318 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54331 */     GIR_RootConstrainSelectedInstOperands,
     /*  54332 */     // GIR_Coverage, 647,
     /*  54332 */     GIR_EraseRootFromParent_Done,
     /*  54333 */   // Label 683: @54333
     /*  54333 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(54373), // Rule ID 4923 //
     /*  54338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54354 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54360 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, -1:{ *:[i64] }))  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54369 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*  54371 */     GIR_RootConstrainSelectedInstOperands,
     /*  54372 */     // GIR_Coverage, 4923,
     /*  54372 */     GIR_EraseRootFromParent_Done,
     /*  54373 */   // Label 684: @54373
     /*  54373 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(54393), // Rule ID 1519 //
     /*  54378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54382 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$in, -1:{ *:[i64] })  =>  (NOR8:{ *:[i64] } ?:{ *:[i64] }:$in, ?:{ *:[i64] }:$in)
     /*  54382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  54385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54387 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54389 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54391 */     GIR_RootConstrainSelectedInstOperands,
     /*  54392 */     // GIR_Coverage, 1519,
     /*  54392 */     GIR_EraseRootFromParent_Done,
     /*  54393 */   // Label 685: @54393
     /*  54393 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(54405), // Rule ID 648 //
     /*  54398 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (XOR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XOR8),
     /*  54403 */     GIR_RootConstrainSelectedInstOperands,
     /*  54404 */     // GIR_Coverage, 648,
     /*  54404 */     GIR_Done,
     /*  54405 */   // Label 686: @54405
     /*  54405 */   GIM_Reject,
     /*  54406 */ // Label 679: @54406
     /*  54406 */ GIM_Reject,
     /*  54407 */ // Label 596: @54407
     /*  54407 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(57530),
     /*  54412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54418 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(54505), // Rule ID 4958 //
     /*  54423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54466 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54472 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54476 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 254:{ *:[i32] })
     /*  54476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  54485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  54489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  54493 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /*  54503 */     GIR_RootConstrainSelectedInstOperands,
     /*  54504 */     // GIR_Coverage, 4958,
     /*  54504 */     GIR_EraseRootFromParent_Done,
     /*  54505 */   // Label 688: @54505
     /*  54505 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(54592), // Rule ID 4960 //
     /*  54510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54553 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54559 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54563 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 248:{ *:[i32] })
     /*  54563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  54572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54580 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(248),
     /*  54590 */     GIR_RootConstrainSelectedInstOperands,
     /*  54591 */     // GIR_Coverage, 4960,
     /*  54591 */     GIR_EraseRootFromParent_Done,
     /*  54592 */   // Label 689: @54592
     /*  54592 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(54679), // Rule ID 4959 //
     /*  54597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54640 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54646 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54648 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54650 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 249:{ *:[i32] })
     /*  54650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  54659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54667 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(249),
     /*  54677 */     GIR_RootConstrainSelectedInstOperands,
     /*  54678 */     // GIR_Coverage, 4959,
     /*  54678 */     GIR_EraseRootFromParent_Done,
     /*  54679 */   // Label 690: @54679
     /*  54679 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(54766), // Rule ID 3386 //
     /*  54684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54727 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54733 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54737 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 254:{ *:[i32] })
     /*  54737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54754 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /*  54764 */     GIR_RootConstrainSelectedInstOperands,
     /*  54765 */     // GIR_Coverage, 3386,
     /*  54765 */     GIR_EraseRootFromParent_Done,
     /*  54766 */   // Label 691: @54766
     /*  54766 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(54853), // Rule ID 3388 //
     /*  54771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54814 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54824 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 248:{ *:[i32] })
     /*  54824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54841 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(248),
     /*  54851 */     GIR_RootConstrainSelectedInstOperands,
     /*  54852 */     // GIR_Coverage, 3388,
     /*  54852 */     GIR_EraseRootFromParent_Done,
     /*  54853 */   // Label 692: @54853
     /*  54853 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(54940), // Rule ID 3387 //
     /*  54858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54901 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54911 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 249:{ *:[i32] })
     /*  54911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54928 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(249),
     /*  54938 */     GIR_RootConstrainSelectedInstOperands,
     /*  54939 */     // GIR_Coverage, 3387,
     /*  54939 */     GIR_EraseRootFromParent_Done,
     /*  54940 */   // Label 693: @54940
     /*  54940 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(55027), // Rule ID 5258 //
     /*  54945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  54972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54988 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54998 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  54998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  55007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  55011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55015 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55025 */     GIR_RootConstrainSelectedInstOperands,
     /*  55026 */     // GIR_Coverage, 5258,
     /*  55026 */     GIR_EraseRootFromParent_Done,
     /*  55027 */   // Label 694: @55027
     /*  55027 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(55114), // Rule ID 5266 //
     /*  55032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55075 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55083 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55085 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 224:{ *:[i32] })
     /*  55085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55102 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(224),
     /*  55112 */     GIR_RootConstrainSelectedInstOperands,
     /*  55113 */     // GIR_Coverage, 5266,
     /*  55113 */     GIR_EraseRootFromParent_Done,
     /*  55114 */   // Label 695: @55114
     /*  55114 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(55201), // Rule ID 5265 //
     /*  55119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55162 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55172 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 128:{ *:[i32] })
     /*  55172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  55181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  55185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55189 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  55199 */     GIR_RootConstrainSelectedInstOperands,
     /*  55200 */     // GIR_Coverage, 5265,
     /*  55200 */     GIR_EraseRootFromParent_Done,
     /*  55201 */   // Label 696: @55201
     /*  55201 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(55288), // Rule ID 5274 //
     /*  55206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55249 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55259 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 144:{ *:[i32] })
     /*  55259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55276 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(144),
     /*  55286 */     GIR_RootConstrainSelectedInstOperands,
     /*  55287 */     // GIR_Coverage, 5274,
     /*  55287 */     GIR_EraseRootFromParent_Done,
     /*  55288 */   // Label 697: @55288
     /*  55288 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(55375), // Rule ID 3396 //
     /*  55293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55336 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55342 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55344 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55346 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 224:{ *:[i32] })
     /*  55346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55363 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(224),
     /*  55373 */     GIR_RootConstrainSelectedInstOperands,
     /*  55374 */     // GIR_Coverage, 3396,
     /*  55374 */     GIR_EraseRootFromParent_Done,
     /*  55375 */   // Label 698: @55375
     /*  55375 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(55462), // Rule ID 3395 //
     /*  55380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55423 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55429 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55433 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 128:{ *:[i32] })
     /*  55433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55450 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  55460 */     GIR_RootConstrainSelectedInstOperands,
     /*  55461 */     // GIR_Coverage, 3395,
     /*  55461 */     GIR_EraseRootFromParent_Done,
     /*  55462 */   // Label 699: @55462
     /*  55462 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(55549), // Rule ID 3400 //
     /*  55467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55510 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55516 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55520 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 144:{ *:[i32] })
     /*  55520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55537 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(144),
     /*  55547 */     GIR_RootConstrainSelectedInstOperands,
     /*  55548 */     // GIR_Coverage, 3400,
     /*  55548 */     GIR_EraseRootFromParent_Done,
     /*  55549 */   // Label 700: @55549
     /*  55549 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(55636), // Rule ID 5263 //
     /*  55554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  55581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55597 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55603 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55607 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  55616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  55620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55624 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55634 */     GIR_RootConstrainSelectedInstOperands,
     /*  55635 */     // GIR_Coverage, 5263,
     /*  55635 */     GIR_EraseRootFromParent_Done,
     /*  55636 */   // Label 701: @55636
     /*  55636 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(55721), // Rule ID 5257 //
     /*  55641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  55684 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55690 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55694 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  55694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55699 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  55701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55709 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55719 */     GIR_RootConstrainSelectedInstOperands,
     /*  55720 */     // GIR_Coverage, 5257,
     /*  55720 */     GIR_EraseRootFromParent_Done,
     /*  55721 */   // Label 702: @55721
     /*  55721 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(55808), // Rule ID 5255 //
     /*  55726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55769 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55775 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55779 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  55779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55796 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55806 */     GIR_RootConstrainSelectedInstOperands,
     /*  55807 */     // GIR_Coverage, 5255,
     /*  55807 */     GIR_EraseRootFromParent_Done,
     /*  55808 */   // Label 703: @55808
     /*  55808 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(55893), // Rule ID 5262 //
     /*  55813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  55856 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55862 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55866 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55871 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  55873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55881 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55891 */     GIR_RootConstrainSelectedInstOperands,
     /*  55892 */     // GIR_Coverage, 5262,
     /*  55892 */     GIR_EraseRootFromParent_Done,
     /*  55893 */   // Label 704: @55893
     /*  55893 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(55980), // Rule ID 5260 //
     /*  55898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55951 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55968 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55978 */     GIR_RootConstrainSelectedInstOperands,
     /*  55979 */     // GIR_Coverage, 5260,
     /*  55979 */     GIR_EraseRootFromParent_Done,
     /*  55980 */   // Label 705: @55980
     /*  55980 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(56067), // Rule ID 3393 //
     /*  55985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56028 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56034 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56038 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56055 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56065 */     GIR_RootConstrainSelectedInstOperands,
     /*  56066 */     // GIR_Coverage, 3393,
     /*  56066 */     GIR_EraseRootFromParent_Done,
     /*  56067 */   // Label 706: @56067
     /*  56067 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(56154), // Rule ID 3394 //
     /*  56072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56115 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56125 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56142 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56152 */     GIR_RootConstrainSelectedInstOperands,
     /*  56153 */     // GIR_Coverage, 3394,
     /*  56153 */     GIR_EraseRootFromParent_Done,
     /*  56154 */   // Label 707: @56154
     /*  56154 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(56241), // Rule ID 5256 //
     /*  56159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56186 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56192 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56202 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56206 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56212 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  56225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  56229 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56239 */     GIR_RootConstrainSelectedInstOperands,
     /*  56240 */     // GIR_Coverage, 5256,
     /*  56240 */     GIR_EraseRootFromParent_Done,
     /*  56241 */   // Label 708: @56241
     /*  56241 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(56328), // Rule ID 5261 //
     /*  56246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56273 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56289 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56293 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56299 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  56312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  56316 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56326 */     GIR_RootConstrainSelectedInstOperands,
     /*  56327 */     // GIR_Coverage, 5261,
     /*  56327 */     GIR_EraseRootFromParent_Done,
     /*  56328 */   // Label 709: @56328
     /*  56328 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(56413), // Rule ID 5259 //
     /*  56333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  56376 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56382 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56384 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56386 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56391 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  56393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56401 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56411 */     GIR_RootConstrainSelectedInstOperands,
     /*  56412 */     // GIR_Coverage, 5259,
     /*  56412 */     GIR_EraseRootFromParent_Done,
     /*  56413 */   // Label 710: @56413
     /*  56413 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(56498), // Rule ID 5264 //
     /*  56418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  56461 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56467 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56471 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56476 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  56478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56486 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56496 */     GIR_RootConstrainSelectedInstOperands,
     /*  56497 */     // GIR_Coverage, 5264,
     /*  56497 */     GIR_EraseRootFromParent_Done,
     /*  56498 */   // Label 711: @56498
     /*  56498 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(56555), // Rule ID 940 //
     /*  56503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56530 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56540 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLNAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNAND),
     /*  56543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56553 */     GIR_RootConstrainSelectedInstOperands,
     /*  56554 */     // GIR_Coverage, 940,
     /*  56554 */     GIR_EraseRootFromParent_Done,
     /*  56555 */   // Label 712: @56555
     /*  56555 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(56612), // Rule ID 930 //
     /*  56560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  56563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56587 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56593 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56597 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLNOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  56600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56610 */     GIR_RootConstrainSelectedInstOperands,
     /*  56611 */     // GIR_Coverage, 930,
     /*  56611 */     GIR_EraseRootFromParent_Done,
     /*  56612 */   // Label 713: @56612
     /*  56612 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(56667), // Rule ID 4929 //
     /*  56617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56644 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56654 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XB)  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56663 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  56665 */     GIR_RootConstrainSelectedInstOperands,
     /*  56666 */     // GIR_Coverage, 4929,
     /*  56666 */     GIR_EraseRootFromParent_Done,
     /*  56667 */   // Label 714: @56667
     /*  56667 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(56724), // Rule ID 939 //
     /*  56672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56699 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56705 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56709 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56722 */     GIR_RootConstrainSelectedInstOperands,
     /*  56723 */     // GIR_Coverage, 939,
     /*  56723 */     GIR_EraseRootFromParent_Done,
     /*  56724 */   // Label 715: @56724
     /*  56724 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(56779), // Rule ID 4930 //
     /*  56729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56756 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56762 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56766 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, immAllOnesV:{ *:[v4i32] }))  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56775 */     GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /*  56777 */     GIR_RootConstrainSelectedInstOperands,
     /*  56778 */     // GIR_Coverage, 4930,
     /*  56778 */     GIR_EraseRootFromParent_Done,
     /*  56779 */   // Label 716: @56779
     /*  56779 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(56816), // Rule ID 1580 //
     /*  56784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  56787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56795 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56801 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  56803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56805 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, immAllOnesV:{ *:[v4i32] })  =>  (XXLNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$A)
     /*  56805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  56808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56810 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  56812 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  56814 */     GIR_RootConstrainSelectedInstOperands,
     /*  56815 */     // GIR_Coverage, 1580,
     /*  56815 */     GIR_EraseRootFromParent_Done,
     /*  56816 */   // Label 717: @56816
     /*  56816 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(56866), // Rule ID 5286 //
     /*  56821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56846 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 30:{ *:[i32] })
     /*  56846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56851 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  56853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  56857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  56861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/30,
     /*  56864 */     GIR_RootConstrainSelectedInstOperands,
     /*  56865 */     // GIR_Coverage, 5286,
     /*  56865 */     GIR_EraseRootFromParent_Done,
     /*  56866 */   // Label 718: @56866
     /*  56866 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(56916), // Rule ID 5287 //
     /*  56871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56896 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 120:{ *:[i32] })
     /*  56896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56901 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  56903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  56907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  56911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/120,
     /*  56914 */     GIR_RootConstrainSelectedInstOperands,
     /*  56915 */     // GIR_Coverage, 5287,
     /*  56915 */     GIR_EraseRootFromParent_Done,
     /*  56916 */   // Label 719: @56916
     /*  56916 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(56966), // Rule ID 5285 //
     /*  56921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56946 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 105:{ *:[i32] })
     /*  56946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  56959 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  56961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/105,
     /*  56964 */     GIR_RootConstrainSelectedInstOperands,
     /*  56965 */     // GIR_Coverage, 5285,
     /*  56965 */     GIR_EraseRootFromParent_Done,
     /*  56966 */   // Label 720: @56966
     /*  56966 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(57016), // Rule ID 3408 //
     /*  56971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56996 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 30:{ *:[i32] })
     /*  56996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57001 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  57007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/30,
     /*  57014 */     GIR_RootConstrainSelectedInstOperands,
     /*  57015 */     // GIR_Coverage, 3408,
     /*  57015 */     GIR_EraseRootFromParent_Done,
     /*  57016 */   // Label 721: @57016
     /*  57016 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(57066), // Rule ID 3409 //
     /*  57021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57046 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 120:{ *:[i32] })
     /*  57046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  57049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57051 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  57057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/120,
     /*  57064 */     GIR_RootConstrainSelectedInstOperands,
     /*  57065 */     // GIR_Coverage, 3409,
     /*  57065 */     GIR_EraseRootFromParent_Done,
     /*  57066 */   // Label 722: @57066
     /*  57066 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(57116), // Rule ID 3407 //
     /*  57071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57096 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 105:{ *:[i32] })
     /*  57096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  57099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57101 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  57107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/105,
     /*  57114 */     GIR_RootConstrainSelectedInstOperands,
     /*  57115 */     // GIR_Coverage, 3407,
     /*  57115 */     GIR_EraseRootFromParent_Done,
     /*  57116 */   // Label 723: @57116
     /*  57116 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(57135), // Rule ID 932 //
     /*  57121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  57124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57128 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLXOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  57128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLXOR),
     /*  57133 */     GIR_RootConstrainSelectedInstOperands,
     /*  57134 */     // GIR_Coverage, 932,
     /*  57134 */     GIR_Done,
     /*  57135 */   // Label 724: @57135
     /*  57135 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(57192), // Rule ID 488 //
     /*  57140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57167 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57177 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VNAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNAND),
     /*  57180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57190 */     GIR_RootConstrainSelectedInstOperands,
     /*  57191 */     // GIR_Coverage, 488,
     /*  57191 */     GIR_EraseRootFromParent_Done,
     /*  57192 */   // Label 725: @57192
     /*  57192 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(57249), // Rule ID 385 //
     /*  57197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57224 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57230 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57234 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57247 */     GIR_RootConstrainSelectedInstOperands,
     /*  57248 */     // GIR_Coverage, 385,
     /*  57248 */     GIR_EraseRootFromParent_Done,
     /*  57249 */   // Label 726: @57249
     /*  57249 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(57306), // Rule ID 1377 //
     /*  57254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57281 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57287 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57291 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B), immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*  57291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  57300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  57304 */     GIR_RootConstrainSelectedInstOperands,
     /*  57305 */     // GIR_Coverage, 1377,
     /*  57305 */     GIR_EraseRootFromParent_Done,
     /*  57306 */   // Label 727: @57306
     /*  57306 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(57361), // Rule ID 4917 //
     /*  57311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57338 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57344 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57348 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VB)  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57357 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  57359 */     GIR_RootConstrainSelectedInstOperands,
     /*  57360 */     // GIR_Coverage, 4917,
     /*  57360 */     GIR_EraseRootFromParent_Done,
     /*  57361 */   // Label 728: @57361
     /*  57361 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(57418), // Rule ID 487 //
     /*  57366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57393 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57399 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57403 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57416 */     GIR_RootConstrainSelectedInstOperands,
     /*  57417 */     // GIR_Coverage, 487,
     /*  57417 */     GIR_EraseRootFromParent_Done,
     /*  57418 */   // Label 729: @57418
     /*  57418 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(57473), // Rule ID 4918 //
     /*  57423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57450 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57456 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57460 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, immAllOnesV:{ *:[v4i32] }))  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57469 */     GIR_RootToRootCopy, /*OpIdx*/1, // VB
     /*  57471 */     GIR_RootConstrainSelectedInstOperands,
     /*  57472 */     // GIR_Coverage, 4918,
     /*  57472 */     GIR_EraseRootFromParent_Done,
     /*  57473 */   // Label 730: @57473
     /*  57473 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(57510), // Rule ID 1376 //
     /*  57478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57489 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57495 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  57497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57499 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vA)
     /*  57499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57504 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57506 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57508 */     GIR_RootConstrainSelectedInstOperands,
     /*  57509 */     // GIR_Coverage, 1376,
     /*  57509 */     GIR_EraseRootFromParent_Done,
     /*  57510 */   // Label 731: @57510
     /*  57510 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(57529), // Rule ID 387 //
     /*  57515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57522 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VXOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VXOR),
     /*  57527 */     GIR_RootConstrainSelectedInstOperands,
     /*  57528 */     // GIR_Coverage, 387,
     /*  57528 */     GIR_Done,
     /*  57529 */   // Label 732: @57529
     /*  57529 */   GIM_Reject,
     /*  57530 */ // Label 687: @57530
     /*  57530 */ GIM_Reject,
     /*  57531 */ // Label 597: @57531
     /*  57531 */ GIM_Reject,
     /*  57532 */ // Label 10: @57532
     /*  57532 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(57832),
     /*  57537 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  57540 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  57546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57553 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(57675), // Rule ID 2124 //
     /*  57558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector),
     /*  57561 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$A, i64:{ *:[i64] }:$B)  =>  (XXPERMDI:{ *:[v2i64] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$A), sub_64:{ *:[i32] }), (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$B), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  57561 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  57564 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57568 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57573 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // B
     /*  57577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  57579 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  57582 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57586 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57591 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  57594 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  57597 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  57600 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57605 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57610 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  57613 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57617 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57622 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  57626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  57628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  57631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57640 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  57643 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  57646 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  57649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /*  57662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  57673 */     GIR_RootConstrainSelectedInstOperands,
     /*  57674 */     // GIR_Coverage, 2124,
     /*  57674 */     GIR_EraseRootFromParent_Done,
     /*  57675 */   // Label 734: @57675
     /*  57675 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(57797), // Rule ID 2127 //
     /*  57680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector),
     /*  57683 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$A, i64:{ *:[i64] }:$B)  =>  (XXPERMDI:{ *:[v2i64] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$B), sub_64:{ *:[i32] }), (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$A), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  57683 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  57686 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57690 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57695 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  57699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  57701 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  57704 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57708 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57713 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  57716 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  57719 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  57722 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57727 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57732 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  57735 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57739 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57744 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // B
     /*  57748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  57750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  57753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  57765 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  57768 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  57771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /*  57784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  57795 */     GIR_RootConstrainSelectedInstOperands,
     /*  57796 */     // GIR_Coverage, 2127,
     /*  57796 */     GIR_EraseRootFromParent_Done,
     /*  57797 */   // Label 735: @57797
     /*  57797 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(57812), // Rule ID 2872 //
     /*  57802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsISA3_0_IsPPC64),
     /*  57805 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$rB, i64:{ *:[i64] }:$rA)  =>  (MTVSRDD:{ *:[v2i64] } ?:{ *:[i64] }:$rB, ?:{ *:[i64] }:$rA)
     /*  57805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MTVSRDD),
     /*  57810 */     GIR_RootConstrainSelectedInstOperands,
     /*  57811 */     // GIR_Coverage, 2872,
     /*  57811 */     GIR_Done,
     /*  57812 */   // Label 736: @57812
     /*  57812 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(57831), // Rule ID 2876 //
     /*  57817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsISA3_0_IsLittleEndian),
     /*  57820 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$rA, i64:{ *:[i64] }:$rB)  =>  (MTVSRDD:{ *:[v2i64] } ?:{ *:[i64] }:$rB, ?:{ *:[i64] }:$rA)
     /*  57820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRDD),
     /*  57823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rB
     /*  57827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rA
     /*  57829 */     GIR_RootConstrainSelectedInstOperands,
     /*  57830 */     // GIR_Coverage, 2876,
     /*  57830 */     GIR_EraseRootFromParent_Done,
     /*  57831 */   // Label 737: @57831
     /*  57831 */   GIM_Reject,
     /*  57832 */ // Label 733: @57832
     /*  57832 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(58357),
     /*  57837 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  57840 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  57846 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(57897), // Rule ID 2038 //
     /*  57851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  57854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExt5NonZero),
     /*  57870 */     // MIs[1] Operand 1
     /*  57870 */     // No operand predicates
     /*  57870 */     // MIs[0] A
     /*  57870 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57875 */     // MIs[0] A
     /*  57875 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57880 */     // MIs[0] A
     /*  57880 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57887 */     // (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A)  =>  (VSPLTISW:{ *:[v4i32] } (imm:{ *:[i32] }):$A)
     /*  57887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSPLTISW),
     /*  57890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // A
     /*  57895 */     GIR_RootConstrainSelectedInstOperands,
     /*  57896 */     // GIR_Coverage, 2038,
     /*  57896 */     GIR_EraseRootFromParent_Done,
     /*  57897 */   // Label 739: @57897
     /*  57897 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(57948), // Rule ID 3375 //
     /*  57902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32immNonAllOneNonZero),
     /*  57921 */     // MIs[1] Operand 1
     /*  57921 */     // No operand predicates
     /*  57921 */     // MIs[0] A
     /*  57921 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57926 */     // MIs[0] A
     /*  57926 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57931 */     // MIs[0] A
     /*  57931 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57938 */     // (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A)  =>  (XXSPLTIW:{ *:[v4i32] } (imm:{ *:[i32] }):$A)
     /*  57938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTIW),
     /*  57941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // A
     /*  57946 */     GIR_RootConstrainSelectedInstOperands,
     /*  57947 */     // GIR_Coverage, 3375,
     /*  57947 */     GIR_EraseRootFromParent_Done,
     /*  57948 */   // Label 740: @57948
     /*  57948 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(58084), // Rule ID 1728 //
     /*  57953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  57956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  57962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  57965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  57977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  57981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  57989 */     // MIs[2] A
     /*  57989 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  57994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  57998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  58002 */     // MIs[3] A
     /*  58002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  58007 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/4, // MIs[4]
     /*  58011 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  58015 */     // MIs[4] A
     /*  58015 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  58020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58022 */     // (build_vector:{ *:[v4f32] } (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A))  =>  (XXSPLTW:{ *:[v4f32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (XSCVDPSP:{ *:[f64] } f64:{ *:[f64] }:$A), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  58022 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58025 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSP),
     /*  58029 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58034 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  58038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58052 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58055 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58058 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58082 */     GIR_RootConstrainSelectedInstOperands,
     /*  58083 */     // GIR_Coverage, 1728,
     /*  58083 */     GIR_EraseRootFromParent_Done,
     /*  58084 */   // Label 741: @58084
     /*  58084 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(58142), // Rule ID 1729 //
     /*  58089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  58092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58096 */     // MIs[0] A
     /*  58096 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58101 */     // MIs[0] A
     /*  58101 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58106 */     // MIs[0] A
     /*  58106 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58111 */     // (build_vector:{ *:[v4f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A)  =>  (XXSPLTW:{ *:[v4f32] } (XSCVDPSPN:{ *:[v4f32] } ?:{ *:[f32] }:$A), 0:{ *:[i32] })
     /*  58111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSPN),
     /*  58118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58123 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58140 */     GIR_RootConstrainSelectedInstOperands,
     /*  58141 */     // GIR_Coverage, 1729,
     /*  58141 */     GIR_EraseRootFromParent_Done,
     /*  58142 */   // Label 742: @58142
     /*  58142 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(58231), // Rule ID 2126 //
     /*  58147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector),
     /*  58150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58154 */     // MIs[0] A
     /*  58154 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58159 */     // MIs[0] A
     /*  58159 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58164 */     // MIs[0] A
     /*  58164 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58169 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (XXSPLTW:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$A), sub_64:{ *:[i32] }), 1:{ *:[i32] })
     /*  58169 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58172 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /*  58176 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58181 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58199 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58202 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58205 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  58229 */     GIR_RootConstrainSelectedInstOperands,
     /*  58230 */     // GIR_Coverage, 2126,
     /*  58230 */     GIR_EraseRootFromParent_Done,
     /*  58231 */   // Label 743: @58231
     /*  58231 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(58320), // Rule ID 2129 //
     /*  58236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector),
     /*  58239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58243 */     // MIs[0] A
     /*  58243 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58248 */     // MIs[0] A
     /*  58248 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58253 */     // MIs[0] A
     /*  58253 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58258 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (XXSPLTW:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$A), sub_64:{ *:[i32] }), 1:{ *:[i32] })
     /*  58258 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58261 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /*  58265 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58270 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58288 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58291 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58294 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  58318 */     GIR_RootConstrainSelectedInstOperands,
     /*  58319 */     // GIR_Coverage, 2129,
     /*  58319 */     GIR_EraseRootFromParent_Done,
     /*  58320 */   // Label 744: @58320
     /*  58320 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(58356), // Rule ID 2262 //
     /*  58325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  58328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58332 */     // MIs[0] A
     /*  58332 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58337 */     // MIs[0] A
     /*  58337 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58342 */     // MIs[0] A
     /*  58342 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58347 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (MTVSRWS:{ *:[v4i32] } ?:{ *:[i32] }:$A)
     /*  58347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRWS),
     /*  58350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58352 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  58354 */     GIR_RootConstrainSelectedInstOperands,
     /*  58355 */     // GIR_Coverage, 2262,
     /*  58355 */     GIR_EraseRootFromParent_Done,
     /*  58356 */   // Label 745: @58356
     /*  58356 */   GIM_Reject,
     /*  58357 */ // Label 738: @58357
     /*  58357 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(58498), // Rule ID 2263 //
     /*  58362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  58365 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/17,
     /*  58368 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  58374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58378 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  58386 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immNonAllOneAnyExt8),
     /*  58390 */   // MIs[1] Operand 1
     /*  58390 */   // No operand predicates
     /*  58390 */   // MIs[0] A
     /*  58390 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58395 */   // MIs[0] A
     /*  58395 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58400 */   // MIs[0] A
     /*  58400 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58405 */   // MIs[0] A
     /*  58405 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/5, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58410 */   // MIs[0] A
     /*  58410 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/6, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58415 */   // MIs[0] A
     /*  58415 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/7, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58420 */   // MIs[0] A
     /*  58420 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/8, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58425 */   // MIs[0] A
     /*  58425 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/9, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58430 */   // MIs[0] A
     /*  58430 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/10, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58435 */   // MIs[0] A
     /*  58435 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/11, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58440 */   // MIs[0] A
     /*  58440 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/12, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58445 */   // MIs[0] A
     /*  58445 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/13, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58450 */   // MIs[0] A
     /*  58450 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/14, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58455 */   // MIs[0] A
     /*  58455 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/15, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58460 */   // MIs[0] A
     /*  58460 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/16, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58465 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58467 */   // (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXSPLTIB:{ *:[v4i32] } (imm:{ *:[i32] }):$A), VSRC:{ *:[i32] })
     /*  58467 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58470 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSPLTIB),
     /*  58474 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58479 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // A
     /*  58482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58497 */   // GIR_Coverage, 2263,
     /*  58497 */   GIR_EraseRootFromParent_Done,
     /*  58498 */ // Label 746: @58498
     /*  58498 */ GIM_Reject,
     /*  58499 */ // Label 11: @58499
     /*  58499 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 754*/ GIMT_Encode4(60775),
     /*  58510 */ /*GILLT_s32*//*Label 747*/ GIMT_Encode4(58538),
     /*  58514 */ /*GILLT_s64*//*Label 748*/ GIMT_Encode4(58611),
     /*  58518 */ /*GILLT_s128*//*Label 749*/ GIMT_Encode4(58659),
     /*  58522 */ /*GILLT_v2s64*//*Label 750*/ GIMT_Encode4(59063),
     /*  58526 */ /*GILLT_v4s32*//*Label 751*/ GIMT_Encode4(59625),
     /*  58530 */ /*GILLT_v8s16*//*Label 752*/ GIMT_Encode4(60176),
     /*  58534 */ /*GILLT_v16s8*//*Label 753*/ GIMT_Encode4(60504),
     /*  58538 */ // Label 747: @58538
     /*  58538 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(58610), // Rule ID 2022 //
     /*  58543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  58549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  58553 */   // (bitconvert:{ *:[i32] } f32:{ *:[f32] }:$A)  =>  (MFVSRWZ:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f64] } (XSCVDPSPN:{ *:[v4i32] } ?:{ *:[f32] }:$A), sub_64:{ *:[i32] }))
     /*  58553 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  58556 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSPN),
     /*  58560 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58565 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  58574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58583 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_64),
     /*  58590 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  58595 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /*  58603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  58605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58608 */   GIR_RootConstrainSelectedInstOperands,
     /*  58609 */   // GIR_Coverage, 2022,
     /*  58609 */   GIR_EraseRootFromParent_Done,
     /*  58610 */ // Label 755: @58610
     /*  58610 */ GIM_Reject,
     /*  58611 */ // Label 748: @58611
     /*  58611 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(58658),
     /*  58616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  58619 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(58638), // Rule ID 2024 //
     /*  58624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  58631 */     // (bitconvert:{ *:[i64] } f64:{ *:[f64] }:$A)  =>  (MFVSRD:{ *:[i64] } ?:{ *:[f64] }:$A)
     /*  58631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  58636 */     GIR_RootConstrainSelectedInstOperands,
     /*  58637 */     // GIR_Coverage, 2024,
     /*  58637 */     GIR_Done,
     /*  58638 */   // Label 757: @58638
     /*  58638 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(58657), // Rule ID 2025 //
     /*  58643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58650 */     // (bitconvert:{ *:[f64] } i64:{ *:[i64] }:$S)  =>  (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$S)
     /*  58650 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  58655 */     GIR_RootConstrainSelectedInstOperands,
     /*  58656 */     // GIR_Coverage, 2025,
     /*  58656 */     GIR_Done,
     /*  58657 */   // Label 758: @58657
     /*  58657 */   GIM_Reject,
     /*  58658 */ // Label 756: @58658
     /*  58658 */ GIM_Reject,
     /*  58659 */ // Label 749: @58659
     /*  58659 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(58716), // Rule ID 1928 //
     /*  58664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  58667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58674 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58678 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58684 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  58686 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58688 */   // (bitconvert:{ *:[v1i128] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  58688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  58695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58715 */   // GIR_Coverage, 1928,
     /*  58715 */   GIR_EraseRootFromParent_Done,
     /*  58716 */ // Label 759: @58716
     /*  58716 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(58742), // Rule ID 1615 //
     /*  58721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  58724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  58727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58731 */   // (bitconvert:{ *:[v1i128] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  58731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58736 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58741 */   // GIR_Coverage, 1615,
     /*  58741 */   GIR_Done,
     /*  58742 */ // Label 760: @58742
     /*  58742 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(58774), // Rule ID 1330 //
     /*  58747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58761 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58764 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58766 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58768 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58773 */   // GIR_Coverage, 1330,
     /*  58773 */   GIR_EraseRootFromParent_Done,
     /*  58774 */ // Label 761: @58774
     /*  58774 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(58806), // Rule ID 1331 //
     /*  58779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  58785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58793 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58796 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58798 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58800 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58805 */   // GIR_Coverage, 1331,
     /*  58805 */   GIR_EraseRootFromParent_Done,
     /*  58806 */ // Label 762: @58806
     /*  58806 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(58838), // Rule ID 1332 //
     /*  58811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58825 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58828 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58830 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58832 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58837 */   // GIR_Coverage, 1332,
     /*  58837 */   GIR_EraseRootFromParent_Done,
     /*  58838 */ // Label 763: @58838
     /*  58838 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(58870), // Rule ID 1333 //
     /*  58843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58857 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58860 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58862 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58864 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58869 */   // GIR_Coverage, 1333,
     /*  58869 */   GIR_EraseRootFromParent_Done,
     /*  58870 */ // Label 764: @58870
     /*  58870 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(58902), // Rule ID 1334 //
     /*  58875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  58881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58889 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58892 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58894 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58896 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58901 */   // GIR_Coverage, 1334,
     /*  58901 */   GIR_EraseRootFromParent_Done,
     /*  58902 */ // Label 765: @58902
     /*  58902 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(58934), // Rule ID 1335 //
     /*  58907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58921 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58924 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58926 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58928 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58933 */   // GIR_Coverage, 1335,
     /*  58933 */   GIR_EraseRootFromParent_Done,
     /*  58934 */ // Label 766: @58934
     /*  58934 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(58966), // Rule ID 1336 //
     /*  58939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  58945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58953 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58956 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58958 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58960 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58965 */   // GIR_Coverage, 1336,
     /*  58965 */   GIR_EraseRootFromParent_Done,
     /*  58966 */ // Label 767: @58966
     /*  58966 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(58998), // Rule ID 1337 //
     /*  58971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58985 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58988 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58990 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58992 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58997 */   // GIR_Coverage, 1337,
     /*  58997 */   GIR_EraseRootFromParent_Done,
     /*  58998 */ // Label 768: @58998
     /*  58998 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(59030), // Rule ID 1338 //
     /*  59003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59017 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  59017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59020 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59022 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59024 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59029 */   // GIR_Coverage, 1338,
     /*  59029 */   GIR_EraseRootFromParent_Done,
     /*  59030 */ // Label 769: @59030
     /*  59030 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(59062), // Rule ID 1339 //
     /*  59035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59049 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v2f64] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  59049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59052 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59054 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59061 */   // GIR_Coverage, 1339,
     /*  59061 */   GIR_EraseRootFromParent_Done,
     /*  59062 */ // Label 770: @59062
     /*  59062 */ GIM_Reject,
     /*  59063 */ // Label 750: @59063
     /*  59063 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(59120), // Rule ID 1929 //
     /*  59068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  59071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59078 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59082 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59088 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  59090 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59092 */   // (bitconvert:{ *:[v2i64] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  59092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  59095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  59099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59114 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59119 */   // GIR_Coverage, 1929,
     /*  59119 */   GIR_EraseRootFromParent_Done,
     /*  59120 */ // Label 771: @59120
     /*  59120 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(59146), // Rule ID 1596 //
     /*  59125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59135 */   // (bitconvert:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v4f32] }:$A, VSRC:{ *:[i32] })
     /*  59135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59145 */   // GIR_Coverage, 1596,
     /*  59145 */   GIR_Done,
     /*  59146 */ // Label 772: @59146
     /*  59146 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(59172), // Rule ID 1597 //
     /*  59151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59161 */   // (bitconvert:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v4i32] }:$A, VSRC:{ *:[i32] })
     /*  59161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59166 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59171 */   // GIR_Coverage, 1597,
     /*  59171 */   GIR_Done,
     /*  59172 */ // Label 773: @59172
     /*  59172 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(59198), // Rule ID 1598 //
     /*  59177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59187 */   // (bitconvert:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })
     /*  59187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59197 */   // GIR_Coverage, 1598,
     /*  59197 */   GIR_Done,
     /*  59198 */ // Label 774: @59198
     /*  59198 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(59224), // Rule ID 1599 //
     /*  59203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59213 */   // (bitconvert:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] })
     /*  59213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59218 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59223 */   // GIR_Coverage, 1599,
     /*  59223 */   GIR_Done,
     /*  59224 */ // Label 775: @59224
     /*  59224 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(59250), // Rule ID 1604 //
     /*  59229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59239 */   // (bitconvert:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v4f32] }:$A, VSRC:{ *:[i32] })
     /*  59239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59244 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59249 */   // GIR_Coverage, 1604,
     /*  59249 */   GIR_Done,
     /*  59250 */ // Label 776: @59250
     /*  59250 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(59276), // Rule ID 1605 //
     /*  59255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59265 */   // (bitconvert:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v4i32] }:$A, VSRC:{ *:[i32] })
     /*  59265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59270 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59275 */   // GIR_Coverage, 1605,
     /*  59275 */   GIR_Done,
     /*  59276 */ // Label 777: @59276
     /*  59276 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(59302), // Rule ID 1606 //
     /*  59281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59291 */   // (bitconvert:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })
     /*  59291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59296 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59301 */   // GIR_Coverage, 1606,
     /*  59301 */   GIR_Done,
     /*  59302 */ // Label 778: @59302
     /*  59302 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(59328), // Rule ID 1607 //
     /*  59307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59317 */   // (bitconvert:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] })
     /*  59317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59327 */   // GIR_Coverage, 1607,
     /*  59327 */   GIR_Done,
     /*  59328 */ // Label 779: @59328
     /*  59328 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(59354), // Rule ID 1612 //
     /*  59333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59343 */   // (bitconvert:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59348 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59353 */   // GIR_Coverage, 1612,
     /*  59353 */   GIR_Done,
     /*  59354 */ // Label 780: @59354
     /*  59354 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(59380), // Rule ID 1613 //
     /*  59359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59369 */   // (bitconvert:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59374 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59379 */   // GIR_Coverage, 1613,
     /*  59379 */   GIR_Done,
     /*  59380 */ // Label 781: @59380
     /*  59380 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(59406), // Rule ID 1614 //
     /*  59385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59395 */   // (bitconvert:{ *:[v2f64] } v1i128:{ *:[v1i128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v1i128] }:$A, VRRC:{ *:[i32] })
     /*  59395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59405 */   // GIR_Coverage, 1614,
     /*  59405 */   GIR_Done,
     /*  59406 */ // Label 782: @59406
     /*  59406 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(59432), // Rule ID 1616 //
     /*  59411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59421 */   // (bitconvert:{ *:[v2i64] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  59421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59431 */   // GIR_Coverage, 1616,
     /*  59431 */   GIR_Done,
     /*  59432 */ // Label 783: @59432
     /*  59432 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(59464), // Rule ID 1325 //
     /*  59437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59451 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59463 */   // GIR_Coverage, 1325,
     /*  59463 */   GIR_EraseRootFromParent_Done,
     /*  59464 */ // Label 784: @59464
     /*  59464 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(59496), // Rule ID 1326 //
     /*  59469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59483 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59486 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59488 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59495 */   // GIR_Coverage, 1326,
     /*  59495 */   GIR_EraseRootFromParent_Done,
     /*  59496 */ // Label 785: @59496
     /*  59496 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(59528), // Rule ID 1327 //
     /*  59501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59515 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59518 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59520 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59527 */   // GIR_Coverage, 1327,
     /*  59527 */   GIR_EraseRootFromParent_Done,
     /*  59528 */ // Label 786: @59528
     /*  59528 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(59560), // Rule ID 1328 //
     /*  59533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59547 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59550 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59552 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59559 */   // GIR_Coverage, 1328,
     /*  59559 */   GIR_EraseRootFromParent_Done,
     /*  59560 */ // Label 787: @59560
     /*  59560 */ GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(59592), // Rule ID 1329 //
     /*  59565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59579 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59582 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59584 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59586 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59591 */   // GIR_Coverage, 1329,
     /*  59591 */   GIR_EraseRootFromParent_Done,
     /*  59592 */ // Label 788: @59592
     /*  59592 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(59624), // Rule ID 1344 //
     /*  59597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59611 */   // (bitconvert:{ *:[v2f64] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v2f64] }:$src
     /*  59611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59614 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59616 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59623 */   // GIR_Coverage, 1344,
     /*  59623 */   GIR_EraseRootFromParent_Done,
     /*  59624 */ // Label 789: @59624
     /*  59624 */ GIM_Reject,
     /*  59625 */ // Label 751: @59625
     /*  59625 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(59661), // Rule ID 941 //
     /*  59630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  59633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59640 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59644 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59650 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  59652 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59654 */   // (bitconvert:{ *:[v4i32] } immAllOnesV:{ *:[v16i8] })  =>  (XXLEQVOnes:{ *:[v4i32] })
     /*  59654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  59657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  59659 */   GIR_RootConstrainSelectedInstOperands,
     /*  59660 */   // GIR_Coverage, 941,
     /*  59660 */   GIR_EraseRootFromParent_Done,
     /*  59661 */ // Label 790: @59661
     /*  59661 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(59687), // Rule ID 1600 //
     /*  59666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59676 */   // (bitconvert:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59686 */   // GIR_Coverage, 1600,
     /*  59686 */   GIR_Done,
     /*  59687 */ // Label 791: @59687
     /*  59687 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(59713), // Rule ID 1601 //
     /*  59692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59702 */   // (bitconvert:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59712 */   // GIR_Coverage, 1601,
     /*  59712 */   GIR_Done,
     /*  59713 */ // Label 792: @59713
     /*  59713 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(59739), // Rule ID 1608 //
     /*  59718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59728 */   // (bitconvert:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59733 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59738 */   // GIR_Coverage, 1608,
     /*  59738 */   GIR_Done,
     /*  59739 */ // Label 793: @59739
     /*  59739 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(59765), // Rule ID 1609 //
     /*  59744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59754 */   // (bitconvert:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59764 */   // GIR_Coverage, 1609,
     /*  59764 */   GIR_Done,
     /*  59765 */ // Label 794: @59765
     /*  59765 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(59791), // Rule ID 1617 //
     /*  59770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59780 */   // (bitconvert:{ *:[v4i32] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  59780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59785 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59790 */   // GIR_Coverage, 1617,
     /*  59790 */   GIR_Done,
     /*  59791 */ // Label 795: @59791
     /*  59791 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(59823), // Rule ID 1315 //
     /*  59796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59810 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59813 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59815 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59817 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59822 */   // GIR_Coverage, 1315,
     /*  59822 */   GIR_EraseRootFromParent_Done,
     /*  59823 */ // Label 796: @59823
     /*  59823 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(59855), // Rule ID 1316 //
     /*  59828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59842 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59845 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59847 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59849 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59854 */   // GIR_Coverage, 1316,
     /*  59854 */   GIR_EraseRootFromParent_Done,
     /*  59855 */ // Label 797: @59855
     /*  59855 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(59887), // Rule ID 1317 //
     /*  59860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59874 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59877 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59879 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59881 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59886 */   // GIR_Coverage, 1317,
     /*  59886 */   GIR_EraseRootFromParent_Done,
     /*  59887 */ // Label 798: @59887
     /*  59887 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(59919), // Rule ID 1318 //
     /*  59892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59906 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59909 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59911 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59913 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59918 */   // GIR_Coverage, 1318,
     /*  59918 */   GIR_EraseRootFromParent_Done,
     /*  59919 */ // Label 799: @59919
     /*  59919 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(59951), // Rule ID 1319 //
     /*  59924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59938 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59941 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59943 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59945 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59950 */   // GIR_Coverage, 1319,
     /*  59950 */   GIR_EraseRootFromParent_Done,
     /*  59951 */ // Label 800: @59951
     /*  59951 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(59983), // Rule ID 1320 //
     /*  59956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59970 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  59970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59973 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59975 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59977 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59982 */   // GIR_Coverage, 1320,
     /*  59982 */   GIR_EraseRootFromParent_Done,
     /*  59983 */ // Label 801: @59983
     /*  59983 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(60015), // Rule ID 1321 //
     /*  59988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60002 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60005 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60007 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60009 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60014 */   // GIR_Coverage, 1321,
     /*  60014 */   GIR_EraseRootFromParent_Done,
     /*  60015 */ // Label 802: @60015
     /*  60015 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(60047), // Rule ID 1322 //
     /*  60020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60034 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60037 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60039 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60046 */   // GIR_Coverage, 1322,
     /*  60046 */   GIR_EraseRootFromParent_Done,
     /*  60047 */ // Label 803: @60047
     /*  60047 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(60079), // Rule ID 1323 //
     /*  60052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60066 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60069 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60071 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60078 */   // GIR_Coverage, 1323,
     /*  60078 */   GIR_EraseRootFromParent_Done,
     /*  60079 */ // Label 804: @60079
     /*  60079 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(60111), // Rule ID 1324 //
     /*  60084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60098 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60101 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60103 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60110 */   // GIR_Coverage, 1324,
     /*  60110 */   GIR_EraseRootFromParent_Done,
     /*  60111 */ // Label 805: @60111
     /*  60111 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(60143), // Rule ID 1342 //
     /*  60116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60130 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  60130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60133 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60137 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60142 */   // GIR_Coverage, 1342,
     /*  60142 */   GIR_EraseRootFromParent_Done,
     /*  60143 */ // Label 806: @60143
     /*  60143 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(60175), // Rule ID 1343 //
     /*  60148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60162 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60165 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60167 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60174 */   // GIR_Coverage, 1343,
     /*  60174 */   GIR_EraseRootFromParent_Done,
     /*  60175 */ // Label 807: @60175
     /*  60175 */ GIM_Reject,
     /*  60176 */ // Label 752: @60176
     /*  60176 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(60233), // Rule ID 1930 //
     /*  60181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  60184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  60187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60191 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60195 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60201 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  60203 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60205 */   // (bitconvert:{ *:[v8i16] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  60205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  60208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  60212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60232 */   // GIR_Coverage, 1930,
     /*  60232 */   GIR_EraseRootFromParent_Done,
     /*  60233 */ // Label 808: @60233
     /*  60233 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(60259), // Rule ID 1602 //
     /*  60238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60248 */   // (bitconvert:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  60248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60253 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60258 */   // GIR_Coverage, 1602,
     /*  60258 */   GIR_Done,
     /*  60259 */ // Label 809: @60259
     /*  60259 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(60285), // Rule ID 1610 //
     /*  60264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60274 */   // (bitconvert:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  60274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60279 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60284 */   // GIR_Coverage, 1610,
     /*  60284 */   GIR_Done,
     /*  60285 */ // Label 810: @60285
     /*  60285 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(60311), // Rule ID 1618 //
     /*  60290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60300 */   // (bitconvert:{ *:[v8i16] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  60300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60305 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60310 */   // GIR_Coverage, 1618,
     /*  60310 */   GIR_Done,
     /*  60311 */ // Label 811: @60311
     /*  60311 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(60343), // Rule ID 1310 //
     /*  60316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  60322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60330 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60333 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60335 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60337 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60342 */   // GIR_Coverage, 1310,
     /*  60342 */   GIR_EraseRootFromParent_Done,
     /*  60343 */ // Label 812: @60343
     /*  60343 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(60375), // Rule ID 1311 //
     /*  60348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60362 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60365 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60367 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60369 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60374 */   // GIR_Coverage, 1311,
     /*  60374 */   GIR_EraseRootFromParent_Done,
     /*  60375 */ // Label 813: @60375
     /*  60375 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(60407), // Rule ID 1312 //
     /*  60380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60394 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60397 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60399 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60406 */   // GIR_Coverage, 1312,
     /*  60406 */   GIR_EraseRootFromParent_Done,
     /*  60407 */ // Label 814: @60407
     /*  60407 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(60439), // Rule ID 1313 //
     /*  60412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60426 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60429 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60431 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60433 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60438 */   // GIR_Coverage, 1313,
     /*  60438 */   GIR_EraseRootFromParent_Done,
     /*  60439 */ // Label 815: @60439
     /*  60439 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(60471), // Rule ID 1314 //
     /*  60444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60458 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60461 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60463 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60465 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60470 */   // GIR_Coverage, 1314,
     /*  60470 */   GIR_EraseRootFromParent_Done,
     /*  60471 */ // Label 816: @60471
     /*  60471 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(60503), // Rule ID 1341 //
     /*  60476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60490 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60493 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60495 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60497 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60502 */   // GIR_Coverage, 1341,
     /*  60502 */   GIR_EraseRootFromParent_Done,
     /*  60503 */ // Label 817: @60503
     /*  60503 */ GIM_Reject,
     /*  60504 */ // Label 753: @60504
     /*  60504 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(60530), // Rule ID 1603 //
     /*  60509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60519 */   // (bitconvert:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  60519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60529 */   // GIR_Coverage, 1603,
     /*  60529 */   GIR_Done,
     /*  60530 */ // Label 818: @60530
     /*  60530 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(60556), // Rule ID 1611 //
     /*  60535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60545 */   // (bitconvert:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  60545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60550 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60555 */   // GIR_Coverage, 1611,
     /*  60555 */   GIR_Done,
     /*  60556 */ // Label 819: @60556
     /*  60556 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(60582), // Rule ID 1619 //
     /*  60561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60571 */   // (bitconvert:{ *:[v16i8] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  60571 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60581 */   // GIR_Coverage, 1619,
     /*  60581 */   GIR_Done,
     /*  60582 */ // Label 820: @60582
     /*  60582 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(60614), // Rule ID 1305 //
     /*  60587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  60593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60601 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60604 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60606 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60608 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60613 */   // GIR_Coverage, 1305,
     /*  60613 */   GIR_EraseRootFromParent_Done,
     /*  60614 */ // Label 821: @60614
     /*  60614 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(60646), // Rule ID 1306 //
     /*  60619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60633 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60636 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60638 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60640 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60645 */   // GIR_Coverage, 1306,
     /*  60645 */   GIR_EraseRootFromParent_Done,
     /*  60646 */ // Label 822: @60646
     /*  60646 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(60678), // Rule ID 1307 //
     /*  60651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60665 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60668 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60670 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60677 */   // GIR_Coverage, 1307,
     /*  60677 */   GIR_EraseRootFromParent_Done,
     /*  60678 */ // Label 823: @60678
     /*  60678 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(60710), // Rule ID 1308 //
     /*  60683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60697 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60700 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60702 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60709 */   // GIR_Coverage, 1308,
     /*  60709 */   GIR_EraseRootFromParent_Done,
     /*  60710 */ // Label 824: @60710
     /*  60710 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(60742), // Rule ID 1309 //
     /*  60715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60729 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60732 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60734 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60736 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60741 */   // GIR_Coverage, 1309,
     /*  60741 */   GIR_EraseRootFromParent_Done,
     /*  60742 */ // Label 825: @60742
     /*  60742 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(60774), // Rule ID 1340 //
     /*  60747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60761 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60764 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60766 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60768 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60773 */   // GIR_Coverage, 1340,
     /*  60773 */   GIR_EraseRootFromParent_Done,
     /*  60774 */ // Label 826: @60774
     /*  60774 */ GIM_Reject,
     /*  60775 */ // Label 754: @60775
     /*  60775 */ GIM_Reject,
     /*  60776 */ // Label 12: @60776
     /*  60776 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 832*/ GIMT_Encode4(61050),
     /*  60787 */ /*GILLT_s32*//*Label 827*/ GIMT_Encode4(60807),
     /*  60791 */ /*GILLT_s64*//*Label 828*/ GIMT_Encode4(60900),
     /*  60795 */ /*GILLT_s128*//*Label 829*/ GIMT_Encode4(60948),
     /*  60799 */ /*GILLT_v2s64*//*Label 830*/ GIMT_Encode4(60979),
     /*  60803 */ /*GILLT_v4s32*//*Label 831*/ GIMT_Encode4(61002),
     /*  60807 */ // Label 827: @60807
     /*  60807 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(60899),
     /*  60812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  60815 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(60879), // Rule ID 1706 //
     /*  60820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  60827 */     // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIZ:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /*  60827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  60830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  60843 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  60848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  60851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIZ),
     /*  60855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  60878 */     // GIR_Coverage, 1706,
     /*  60878 */     GIR_EraseRootFromParent_Done,
     /*  60879 */   // Label 834: @60879
     /*  60879 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(60898), // Rule ID 150 //
     /*  60884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  60887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  60891 */     // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIZS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /*  60891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIZS),
     /*  60896 */     GIR_RootConstrainSelectedInstOperands,
     /*  60897 */     // GIR_Coverage, 150,
     /*  60897 */     GIR_Done,
     /*  60898 */   // Label 835: @60898
     /*  60898 */   GIM_Reject,
     /*  60899 */ // Label 833: @60899
     /*  60899 */ GIM_Reject,
     /*  60900 */ // Label 828: @60900
     /*  60900 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(60947),
     /*  60905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  60908 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(60927), // Rule ID 911 //
     /*  60913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  60920 */     // (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIZ:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /*  60920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIZ),
     /*  60925 */     GIR_RootConstrainSelectedInstOperands,
     /*  60926 */     // GIR_Coverage, 911,
     /*  60926 */     GIR_Done,
     /*  60927 */   // Label 837: @60927
     /*  60927 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(60946), // Rule ID 148 //
     /*  60932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  60935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  60939 */     // (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIZD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /*  60939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIZD),
     /*  60944 */     GIR_RootConstrainSelectedInstOperands,
     /*  60945 */     // GIR_Coverage, 148,
     /*  60945 */     GIR_Done,
     /*  60946 */   // Label 838: @60946
     /*  60946 */   GIM_Reject,
     /*  60947 */ // Label 836: @60947
     /*  60947 */ GIM_Reject,
     /*  60948 */ // Label 829: @60948
     /*  60948 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(60978), // Rule ID 2157 //
     /*  60953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  60956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60963 */   // (ftrunc:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 1:{ *:[i32] })
     /*  60963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /*  60966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  60968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60971 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /*  60973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60976 */   GIR_RootConstrainSelectedInstOperands,
     /*  60977 */   // GIR_Coverage, 2157,
     /*  60977 */   GIR_EraseRootFromParent_Done,
     /*  60978 */ // Label 839: @60978
     /*  60978 */ GIM_Reject,
     /*  60979 */ // Label 830: @60979
     /*  60979 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(61001), // Rule ID 919 //
     /*  60984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60994 */   // (ftrunc:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIZ:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /*  60994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIZ),
     /*  60999 */   GIR_RootConstrainSelectedInstOperands,
     /*  61000 */   // GIR_Coverage, 919,
     /*  61000 */   GIR_Done,
     /*  61001 */ // Label 840: @61001
     /*  61001 */ GIM_Reject,
     /*  61002 */ // Label 831: @61002
     /*  61002 */ GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(61049),
     /*  61007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  61010 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(61029), // Rule ID 927 //
     /*  61015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61022 */     // (ftrunc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIZ:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  61022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIZ),
     /*  61027 */     GIR_RootConstrainSelectedInstOperands,
     /*  61028 */     // GIR_Coverage, 927,
     /*  61028 */     GIR_Done,
     /*  61029 */   // Label 842: @61029
     /*  61029 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(61048), // Rule ID 1415 //
     /*  61034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  61037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  61041 */     // (ftrunc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIZ:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /*  61041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIZ),
     /*  61046 */     GIR_RootConstrainSelectedInstOperands,
     /*  61047 */     // GIR_Coverage, 1415,
     /*  61047 */     GIR_Done,
     /*  61048 */   // Label 843: @61048
     /*  61048 */   GIM_Reject,
     /*  61049 */ // Label 841: @61049
     /*  61049 */ GIM_Reject,
     /*  61050 */ // Label 832: @61050
     /*  61050 */ GIM_Reject,
     /*  61051 */ // Label 13: @61051
     /*  61051 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 849*/ GIMT_Encode4(61300),
     /*  61062 */ /*GILLT_s32*//*Label 844*/ GIMT_Encode4(61082),
     /*  61066 */ /*GILLT_s64*//*Label 845*/ GIMT_Encode4(61175),
     /*  61070 */ /*GILLT_s128*//*Label 846*/ GIMT_Encode4(61223),
     /*  61074 */ /*GILLT_v2s64*//*Label 847*/ GIMT_Encode4(61254),
     /*  61078 */ /*GILLT_v4s32*//*Label 848*/ GIMT_Encode4(61277),
     /*  61082 */ // Label 844: @61082
     /*  61082 */ GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(61174),
     /*  61087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  61090 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(61154), // Rule ID 1700 //
     /*  61095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61102 */     // (fround:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /*  61102 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61105 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61109 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61114 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61118 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /*  61130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61135 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61153 */     // GIR_Coverage, 1700,
     /*  61153 */     GIR_EraseRootFromParent_Done,
     /*  61154 */   // Label 851: @61154
     /*  61154 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(61173), // Rule ID 142 //
     /*  61159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  61162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  61166 */     // (fround:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRINS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /*  61166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRINS),
     /*  61171 */     GIR_RootConstrainSelectedInstOperands,
     /*  61172 */     // GIR_Coverage, 142,
     /*  61172 */     GIR_Done,
     /*  61173 */   // Label 852: @61173
     /*  61173 */   GIM_Reject,
     /*  61174 */ // Label 850: @61174
     /*  61174 */ GIM_Reject,
     /*  61175 */ // Label 845: @61175
     /*  61175 */ GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(61222),
     /*  61180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61183 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(61202), // Rule ID 905 //
     /*  61188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61195 */     // (fround:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPI:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /*  61195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /*  61200 */     GIR_RootConstrainSelectedInstOperands,
     /*  61201 */     // GIR_Coverage, 905,
     /*  61201 */     GIR_Done,
     /*  61202 */   // Label 854: @61202
     /*  61202 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(61221), // Rule ID 140 //
     /*  61207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  61210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61214 */     // (fround:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIND:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /*  61214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIND),
     /*  61219 */     GIR_RootConstrainSelectedInstOperands,
     /*  61220 */     // GIR_Coverage, 140,
     /*  61220 */     GIR_Done,
     /*  61221 */   // Label 855: @61221
     /*  61221 */   GIM_Reject,
     /*  61222 */ // Label 853: @61222
     /*  61222 */ GIM_Reject,
     /*  61223 */ // Label 846: @61223
     /*  61223 */ GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(61253), // Rule ID 2155 //
     /*  61228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  61231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  61234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  61238 */   // (fround:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 0:{ *:[i32] })
     /*  61238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /*  61241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  61243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61246 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /*  61248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61251 */   GIR_RootConstrainSelectedInstOperands,
     /*  61252 */   // GIR_Coverage, 2155,
     /*  61252 */   GIR_EraseRootFromParent_Done,
     /*  61253 */ // Label 856: @61253
     /*  61253 */ GIM_Reject,
     /*  61254 */ // Label 847: @61254
     /*  61254 */ GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(61276), // Rule ID 913 //
     /*  61259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61269 */   // (fround:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPI:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /*  61269 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPI),
     /*  61274 */   GIR_RootConstrainSelectedInstOperands,
     /*  61275 */   // GIR_Coverage, 913,
     /*  61275 */   GIR_Done,
     /*  61276 */ // Label 857: @61276
     /*  61276 */ GIM_Reject,
     /*  61277 */ // Label 848: @61277
     /*  61277 */ GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(61299), // Rule ID 921 //
     /*  61282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  61288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61292 */   // (fround:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPI:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  61292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPI),
     /*  61297 */   GIR_RootConstrainSelectedInstOperands,
     /*  61298 */   // GIR_Coverage, 921,
     /*  61298 */   GIR_Done,
     /*  61299 */ // Label 858: @61299
     /*  61299 */ GIM_Reject,
     /*  61300 */ // Label 849: @61300
     /*  61300 */ GIM_Reject,
     /*  61301 */ // Label 14: @61301
     /*  61301 */ GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(61431),
     /*  61306 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61309 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 862*/ GIMT_Encode4(61430),
     /*  61320 */   /*GILLT_s32*//*Label 860*/ GIMT_Encode4(61328),
     /*  61324 */   /*GILLT_s64*//*Label 861*/ GIMT_Encode4(61389),
     /*  61328 */   // Label 860: @61328
     /*  61328 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(61388), // Rule ID 2027 //
     /*  61333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61340 */     // (lrint:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, F8RC:{ *:[i32] })))
     /*  61340 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61343 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61347 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61352 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61386 */     GIR_RootConstrainSelectedInstOperands,
     /*  61387 */     // GIR_Coverage, 2027,
     /*  61387 */     GIR_EraseRootFromParent_Done,
     /*  61388 */   // Label 863: @61388
     /*  61388 */   GIM_Reject,
     /*  61389 */   // Label 861: @61389
     /*  61389 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(61429), // Rule ID 2026 //
     /*  61394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61401 */     // (lrint:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } ?:{ *:[f64] }:$S))
     /*  61401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61413 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61427 */     GIR_RootConstrainSelectedInstOperands,
     /*  61428 */     // GIR_Coverage, 2026,
     /*  61428 */     GIR_EraseRootFromParent_Done,
     /*  61429 */   // Label 864: @61429
     /*  61429 */   GIM_Reject,
     /*  61430 */   // Label 862: @61430
     /*  61430 */   GIM_Reject,
     /*  61431 */ // Label 859: @61431
     /*  61431 */ GIM_Reject,
     /*  61432 */ // Label 15: @61432
     /*  61432 */ GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(61562),
     /*  61437 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61440 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 868*/ GIMT_Encode4(61561),
     /*  61451 */   /*GILLT_s32*//*Label 866*/ GIMT_Encode4(61459),
     /*  61455 */   /*GILLT_s64*//*Label 867*/ GIMT_Encode4(61520),
     /*  61459 */   // Label 866: @61459
     /*  61459 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(61519), // Rule ID 2029 //
     /*  61464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61471 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, F8RC:{ *:[i32] })))
     /*  61471 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61474 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61478 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61483 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61487 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61504 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61517 */     GIR_RootConstrainSelectedInstOperands,
     /*  61518 */     // GIR_Coverage, 2029,
     /*  61518 */     GIR_EraseRootFromParent_Done,
     /*  61519 */   // Label 869: @61519
     /*  61519 */   GIM_Reject,
     /*  61520 */   // Label 867: @61520
     /*  61520 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(61560), // Rule ID 2028 //
     /*  61525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61532 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } ?:{ *:[f64] }:$S))
     /*  61532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61558 */     GIR_RootConstrainSelectedInstOperands,
     /*  61559 */     // GIR_Coverage, 2028,
     /*  61559 */     GIR_EraseRootFromParent_Done,
     /*  61560 */   // Label 870: @61560
     /*  61560 */   GIM_Reject,
     /*  61561 */   // Label 868: @61561
     /*  61561 */   GIM_Reject,
     /*  61562 */ // Label 865: @61562
     /*  61562 */ GIM_Reject,
     /*  61563 */ // Label 16: @61563
     /*  61563 */ GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(61582), // Rule ID 635 //
     /*  61568 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61575 */   // (readcyclecounter:{ *:[i64] })  =>  (MFTB8:{ *:[i64] })
     /*  61575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MFTB8),
     /*  61580 */   GIR_RootConstrainSelectedInstOperands,
     /*  61581 */   // GIR_Coverage, 635,
     /*  61581 */   GIR_Done,
     /*  61582 */ // Label 871: @61582
     /*  61582 */ GIM_Reject,
     /*  61583 */ // Label 17: @61583
     /*  61583 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 874*/ GIMT_Encode4(61658),
     /*  61594 */ /*GILLT_s32*//*Label 872*/ GIMT_Encode4(61602),
     /*  61598 */ /*GILLT_s64*//*Label 873*/ GIMT_Encode4(61630),
     /*  61602 */ // Label 872: @61602
     /*  61602 */ GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(61629), // Rule ID 1265 //
     /*  61607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61610 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  61614 */   // MIs[0] Operand 1
     /*  61614 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61617 */   // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (SYNC 0:{ *:[i32] })
     /*  61617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61623 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61627 */   GIR_RootConstrainSelectedInstOperands,
     /*  61628 */   // GIR_Coverage, 1265,
     /*  61628 */   GIR_EraseRootFromParent_Done,
     /*  61629 */ // Label 875: @61629
     /*  61629 */ GIM_Reject,
     /*  61630 */ // Label 873: @61630
     /*  61630 */ GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(61657), // Rule ID 1264 //
     /*  61635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61638 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  61642 */   // MIs[0] Operand 1
     /*  61642 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61645 */   // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (SYNC 0:{ *:[i32] })
     /*  61645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61655 */   GIR_RootConstrainSelectedInstOperands,
     /*  61656 */   // GIR_Coverage, 1264,
     /*  61656 */   GIR_EraseRootFromParent_Done,
     /*  61657 */ // Label 876: @61657
     /*  61657 */ GIM_Reject,
     /*  61658 */ // Label 874: @61658
     /*  61658 */ GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(61707),
     /*  61663 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  61666 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61669 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(61689), // Rule ID 1266 //
     /*  61674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61677 */     // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (SYNC 1:{ *:[i32] })
     /*  61677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61687 */     GIR_RootConstrainSelectedInstOperands,
     /*  61688 */     // GIR_Coverage, 1266,
     /*  61688 */     GIR_EraseRootFromParent_Done,
     /*  61689 */   // Label 878: @61689
     /*  61689 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(61706), // Rule ID 1267 //
     /*  61694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  61697 */     // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (MSYNC)
     /*  61697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  61700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61704 */     GIR_RootConstrainSelectedInstOperands,
     /*  61705 */     // GIR_Coverage, 1267,
     /*  61705 */     GIR_EraseRootFromParent_Done,
     /*  61706 */   // Label 879: @61706
     /*  61706 */   GIM_Reject,
     /*  61707 */ // Label 877: @61707
     /*  61707 */ GIM_Reject,
     /*  61708 */ // Label 18: @61708
     /*  61708 */ GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(61770),
     /*  61713 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  61716 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /*  61719 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(61757), // Rule ID 17 //
     /*  61724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  61736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  61740 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61746 */     // (brcond (xor:{ *:[i1] } i1:{ *:[i1] }:$BI, -1:{ *:[i1] }), (bb:{ *:[Other] }):$BD)  =>  (BCn i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)
     /*  61746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCn),
     /*  61749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // BI
     /*  61753 */     GIR_RootToRootCopy, /*OpIdx*/1, // BD
     /*  61755 */     GIR_RootConstrainSelectedInstOperands,
     /*  61756 */     // GIR_Coverage, 17,
     /*  61756 */     GIR_EraseRootFromParent_Done,
     /*  61757 */   // Label 881: @61757
     /*  61757 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(61769), // Rule ID 16 //
     /*  61762 */     // (brcond i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)  =>  (BC i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)
     /*  61762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BC),
     /*  61767 */     GIR_RootConstrainSelectedInstOperands,
     /*  61768 */     // GIR_Coverage, 16,
     /*  61768 */     GIR_Done,
     /*  61769 */   // Label 882: @61769
     /*  61769 */   GIM_Reject,
     /*  61770 */ // Label 880: @61770
     /*  61770 */ GIM_Reject,
     /*  61771 */ // Label 19: @61771
     /*  61771 */ GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(61919),
     /*  61776 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  61779 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(61806), // Rule ID 1163 //
     /*  61784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  61787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmsetdmrz),
     /*  61792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  61795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  61799 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10645:{ *:[iPTR] })  =>  (DMSETDMRZ:{ *:[v1024i1] })
     /*  61799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMSETDMRZ),
     /*  61802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61804 */     GIR_RootConstrainSelectedInstOperands,
     /*  61805 */     // GIR_Coverage, 1163,
     /*  61805 */     GIR_EraseRootFromParent_Done,
     /*  61806 */   // Label 884: @61806
     /*  61806 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(61833), // Rule ID 1166 //
     /*  61811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  61814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxsetaccz),
     /*  61819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  61822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  61826 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10737:{ *:[iPTR] })  =>  (XXSETACCZ:{ *:[v512i1] })
     /*  61826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSETACCZ),
     /*  61829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61831 */     GIR_RootConstrainSelectedInstOperands,
     /*  61832 */     // GIR_Coverage, 1166,
     /*  61832 */     GIR_EraseRootFromParent_Done,
     /*  61833 */   // Label 885: @61833
     /*  61833 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(61860), // Rule ID 1167 //
     /*  61838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  61841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxsetaccz),
     /*  61846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  61849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  61853 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10737:{ *:[iPTR] })  =>  (XXSETACCZW:{ *:[v512i1] })
     /*  61853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSETACCZW),
     /*  61856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61858 */     GIR_RootConstrainSelectedInstOperands,
     /*  61859 */     // GIR_Coverage, 1167,
     /*  61859 */     GIR_EraseRootFromParent_Done,
     /*  61860 */   // Label 886: @61860
     /*  61860 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(61884), // Rule ID 4896 //
     /*  61865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfmsr),
     /*  61870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  61877 */     // (intrinsic_wo_chain:{ *:[i32] } 10636:{ *:[iPTR] })  =>  (MFMSR:{ *:[i32] })
     /*  61877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFMSR),
     /*  61880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  61882 */     GIR_RootConstrainSelectedInstOperands,
     /*  61883 */     // GIR_Coverage, 4896,
     /*  61883 */     GIR_EraseRootFromParent_Done,
     /*  61884 */   // Label 887: @61884
     /*  61884 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(61918), // Rule ID 4897 //
     /*  61889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mftbu),
     /*  61894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  61901 */     // (intrinsic_wo_chain:{ *:[i32] } 10638:{ *:[iPTR] })  =>  (MFTB:{ *:[i32] } 269:{ *:[i32] })
     /*  61901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFTB),
     /*  61904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  61906 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(269),
     /*  61916 */     GIR_RootConstrainSelectedInstOperands,
     /*  61917 */     // GIR_Coverage, 4897,
     /*  61917 */     GIR_EraseRootFromParent_Done,
     /*  61918 */   // Label 888: @61918
     /*  61918 */   GIM_Reject,
     /*  61919 */ // Label 883: @61919
     /*  61919 */ GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(65595),
     /*  61924 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  61927 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(61963), // Rule ID 1748 //
     /*  61932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrte),
     /*  61940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61954 */     // (intrinsic_wo_chain:{ *:[f64] } 10611:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XB)  =>  (XSRSQRTEDP:{ *:[f64] } ?:{ *:[f64] }:$XB)
     /*  61954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSQRTEDP),
     /*  61957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  61959 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  61961 */     GIR_RootConstrainSelectedInstOperands,
     /*  61962 */     // GIR_Coverage, 1748,
     /*  61962 */     GIR_EraseRootFromParent_Done,
     /*  61963 */   // Label 890: @61963
     /*  61963 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(61999), // Rule ID 1939 //
     /*  61968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  61971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrtes),
     /*  61976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61990 */     // (intrinsic_wo_chain:{ *:[f32] } 10612:{ *:[iPTR] }, vssrc:{ *:[f32] }:$XB)  =>  (XSRSQRTESP:{ *:[f32] } ?:{ *:[f32] }:$XB)
     /*  61990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSQRTESP),
     /*  61993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  61995 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  61997 */     GIR_RootConstrainSelectedInstOperands,
     /*  61998 */     // GIR_Coverage, 1939,
     /*  61998 */     GIR_EraseRootFromParent_Done,
     /*  61999 */   // Label 891: @61999
     /*  61999 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(62031), // Rule ID 872 //
     /*  62004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpsp),
     /*  62012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62022 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10830:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSP:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSP),
     /*  62025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62027 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62029 */     GIR_RootConstrainSelectedInstOperands,
     /*  62030 */     // GIR_Coverage, 872,
     /*  62030 */     GIR_EraseRootFromParent_Done,
     /*  62031 */   // Label 892: @62031
     /*  62031 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(62063), // Rule ID 875 //
     /*  62036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpsxws),
     /*  62044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62054 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10831:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSXWS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSXWS),
     /*  62057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62059 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62061 */     GIR_RootConstrainSelectedInstOperands,
     /*  62062 */     // GIR_Coverage, 875,
     /*  62062 */     GIR_EraseRootFromParent_Done,
     /*  62063 */   // Label 893: @62063
     /*  62063 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(62095), // Rule ID 878 //
     /*  62068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpuxws),
     /*  62076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62086 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10832:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPUXWS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPUXWS),
     /*  62089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62091 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62093 */     GIR_RootConstrainSelectedInstOperands,
     /*  62094 */     // GIR_Coverage, 878,
     /*  62094 */     GIR_EraseRootFromParent_Done,
     /*  62095 */   // Label 894: @62095
     /*  62095 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(62127), // Rule ID 879 //
     /*  62100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspdp),
     /*  62108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62118 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10835:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPDP:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPDP),
     /*  62121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62123 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62125 */     GIR_RootConstrainSelectedInstOperands,
     /*  62126 */     // GIR_Coverage, 879,
     /*  62126 */     GIR_EraseRootFromParent_Done,
     /*  62127 */   // Label 895: @62127
     /*  62127 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(62159), // Rule ID 880 //
     /*  62132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspsxds),
     /*  62140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62150 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10837:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPSXDS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPSXDS),
     /*  62153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62155 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62157 */     GIR_RootConstrainSelectedInstOperands,
     /*  62158 */     // GIR_Coverage, 880,
     /*  62158 */     GIR_EraseRootFromParent_Done,
     /*  62159 */   // Label 896: @62159
     /*  62159 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(62191), // Rule ID 883 //
     /*  62164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspuxds),
     /*  62172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62182 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10838:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPUXDS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPUXDS),
     /*  62185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62187 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62189 */     GIR_RootConstrainSelectedInstOperands,
     /*  62190 */     // GIR_Coverage, 883,
     /*  62190 */     GIR_EraseRootFromParent_Done,
     /*  62191 */   // Label 897: @62191
     /*  62191 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(62223), // Rule ID 888 //
     /*  62196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsxdsp),
     /*  62204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62214 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10839:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVSXDSP:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$XB)
     /*  62214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSXDSP),
     /*  62217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62219 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62221 */     GIR_RootConstrainSelectedInstOperands,
     /*  62222 */     // GIR_Coverage, 888,
     /*  62222 */     GIR_EraseRootFromParent_Done,
     /*  62223 */   // Label 898: @62223
     /*  62223 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(62255), // Rule ID 893 //
     /*  62228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvuxdsp),
     /*  62236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62246 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10841:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVUXDSP:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$XB)
     /*  62246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVUXDSP),
     /*  62249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62251 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62253 */     GIR_RootConstrainSelectedInstOperands,
     /*  62254 */     // GIR_Coverage, 893,
     /*  62254 */     GIR_EraseRootFromParent_Done,
     /*  62255 */   // Label 899: @62255
     /*  62255 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(62287), // Rule ID 896 //
     /*  62260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsxwdp),
     /*  62268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62278 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10840:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVSXWDP:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$XB)
     /*  62278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSXWDP),
     /*  62281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62283 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62285 */     GIR_RootConstrainSelectedInstOperands,
     /*  62286 */     // GIR_Coverage, 896,
     /*  62286 */     GIR_EraseRootFromParent_Done,
     /*  62287 */   // Label 900: @62287
     /*  62287 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(62319), // Rule ID 897 //
     /*  62292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvuxwdp),
     /*  62300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62310 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10842:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVUXWDP:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$XB)
     /*  62310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVUXWDP),
     /*  62313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62315 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62317 */     GIR_RootConstrainSelectedInstOperands,
     /*  62318 */     // GIR_Coverage, 897,
     /*  62318 */     GIR_EraseRootFromParent_Done,
     /*  62319 */   // Label 901: @62319
     /*  62319 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(62351), // Rule ID 1005 //
     /*  62324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_sqrtf128_round_to_odd),
     /*  62332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  62335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  62338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  62342 */     // (intrinsic_wo_chain:{ *:[f128] } 10766:{ *:[iPTR] }, f128:{ *:[f128] }:$RB)  =>  (XSSQRTQPO:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /*  62342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQPO),
     /*  62345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  62347 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  62349 */     GIR_RootConstrainSelectedInstOperands,
     /*  62350 */     // GIR_Coverage, 1005,
     /*  62350 */     GIR_EraseRootFromParent_Done,
     /*  62351 */   // Label 902: @62351
     /*  62351 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(62383), // Rule ID 1012 //
     /*  62356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_truncf128_round_to_odd),
     /*  62364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  62370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VFRCRegClassID),
     /*  62374 */     // (intrinsic_wo_chain:{ *:[f64] } 10793:{ *:[iPTR] }, f128:{ *:[f128] }:$RB)  =>  (XSCVQPDPO:{ *:[f64] } f128:{ *:[f128] }:$RB)
     /*  62374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDPO),
     /*  62377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  62379 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  62381 */     GIR_RootConstrainSelectedInstOperands,
     /*  62382 */     // GIR_Coverage, 1012,
     /*  62382 */     GIR_EraseRootFromParent_Done,
     /*  62383 */   // Label 903: @62383
     /*  62383 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(62415), // Rule ID 1021 //
     /*  62388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsphp),
     /*  62396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62406 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10836:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPHP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPHP),
     /*  62409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62411 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62413 */     GIR_RootConstrainSelectedInstOperands,
     /*  62414 */     // GIR_Coverage, 1021,
     /*  62414 */     GIR_EraseRootFromParent_Done,
     /*  62415 */   // Label 904: @62415
     /*  62415 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(62447), // Rule ID 1025 //
     /*  62420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxexpdp),
     /*  62428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62438 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10864:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVXEXPDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /*  62438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXEXPDP),
     /*  62441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62443 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62445 */     GIR_RootConstrainSelectedInstOperands,
     /*  62446 */     // GIR_Coverage, 1025,
     /*  62446 */     GIR_EraseRootFromParent_Done,
     /*  62447 */   // Label 905: @62447
     /*  62447 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(62479), // Rule ID 1026 //
     /*  62452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxexpsp),
     /*  62460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62470 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10865:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVXEXPSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXEXPSP),
     /*  62473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62475 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62477 */     GIR_RootConstrainSelectedInstOperands,
     /*  62478 */     // GIR_Coverage, 1026,
     /*  62478 */     GIR_EraseRootFromParent_Done,
     /*  62479 */   // Label 906: @62479
     /*  62479 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(62511), // Rule ID 1027 //
     /*  62484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxsigdp),
     /*  62492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62502 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10866:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVXSIGDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /*  62502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXSIGDP),
     /*  62505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62507 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62509 */     GIR_RootConstrainSelectedInstOperands,
     /*  62510 */     // GIR_Coverage, 1027,
     /*  62510 */     GIR_EraseRootFromParent_Done,
     /*  62511 */   // Label 907: @62511
     /*  62511 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(62543), // Rule ID 1028 //
     /*  62516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxsigsp),
     /*  62524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62534 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10867:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVXSIGSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXSIGSP),
     /*  62537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62539 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62541 */     GIR_RootConstrainSelectedInstOperands,
     /*  62542 */     // GIR_Coverage, 1028,
     /*  62542 */     GIR_EraseRootFromParent_Done,
     /*  62543 */   // Label 908: @62543
     /*  62543 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(62598), // Rule ID 1656 //
     /*  62548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtsqrtdp),
     /*  62556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62566 */     // (intrinsic_wo_chain:{ *:[i32] } 10860:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTSQRTDP:{ *:[i32] } ?:{ *:[v2f64] }:$A), GPRC:{ *:[i32] })
     /*  62566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  62569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTSQRTDP),
     /*  62573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62597 */     // GIR_Coverage, 1656,
     /*  62597 */     GIR_EraseRootFromParent_Done,
     /*  62598 */   // Label 909: @62598
     /*  62598 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(62653), // Rule ID 1657 //
     /*  62603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtsqrtsp),
     /*  62611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62621 */     // (intrinsic_wo_chain:{ *:[i32] } 10861:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTSQRTSP:{ *:[i32] } ?:{ *:[v4f32] }:$A), GPRC:{ *:[i32] })
     /*  62621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  62624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTSQRTSP),
     /*  62628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62652 */     // GIR_Coverage, 1657,
     /*  62652 */     GIR_EraseRootFromParent_Done,
     /*  62653 */   // Label 910: @62653
     /*  62653 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(62685), // Rule ID 1658 //
     /*  62658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvresp),
     /*  62666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62676 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10853:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (XVRESP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A)
     /*  62676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRESP),
     /*  62679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62681 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62683 */     GIR_RootConstrainSelectedInstOperands,
     /*  62684 */     // GIR_Coverage, 1658,
     /*  62684 */     GIR_EraseRootFromParent_Done,
     /*  62685 */   // Label 911: @62685
     /*  62685 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(62717), // Rule ID 1659 //
     /*  62690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvredp),
     /*  62698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62708 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10852:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (XVREDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A)
     /*  62708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVREDP),
     /*  62711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62713 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62715 */     GIR_RootConstrainSelectedInstOperands,
     /*  62716 */     // GIR_Coverage, 1659,
     /*  62716 */     GIR_EraseRootFromParent_Done,
     /*  62717 */   // Label 912: @62717
     /*  62717 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(62749), // Rule ID 1660 //
     /*  62722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvrsqrtesp),
     /*  62730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62740 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10856:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (XVRSQRTESP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A)
     /*  62740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRSQRTESP),
     /*  62743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62745 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62747 */     GIR_RootConstrainSelectedInstOperands,
     /*  62748 */     // GIR_Coverage, 1660,
     /*  62748 */     GIR_EraseRootFromParent_Done,
     /*  62749 */   // Label 913: @62749
     /*  62749 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(62781), // Rule ID 1661 //
     /*  62754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvrsqrtedp),
     /*  62762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62772 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10855:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (XVRSQRTEDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A)
     /*  62772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRSQRTEDP),
     /*  62775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62777 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62779 */     GIR_RootConstrainSelectedInstOperands,
     /*  62780 */     // GIR_Coverage, 1661,
     /*  62780 */     GIR_EraseRootFromParent_Done,
     /*  62781 */   // Label 914: @62781
     /*  62781 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(62813), // Rule ID 1747 //
     /*  62786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fre),
     /*  62794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62804 */     // (intrinsic_wo_chain:{ *:[f64] } 10609:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSREDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  62804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSREDP),
     /*  62807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62809 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62811 */     GIR_RootConstrainSelectedInstOperands,
     /*  62812 */     // GIR_Coverage, 1747,
     /*  62812 */     GIR_EraseRootFromParent_Done,
     /*  62813 */   // Label 915: @62813
     /*  62813 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(62845), // Rule ID 1749 //
     /*  62818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabs),
     /*  62826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62836 */     // (intrinsic_wo_chain:{ *:[f64] } 10604:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSNABSDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  62836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /*  62839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62841 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62843 */     GIR_RootConstrainSelectedInstOperands,
     /*  62844 */     // GIR_Coverage, 1749,
     /*  62844 */     GIR_EraseRootFromParent_Done,
     /*  62845 */   // Label 916: @62845
     /*  62845 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(62877), // Rule ID 1750 //
     /*  62850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabss),
     /*  62858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  62868 */     // (intrinsic_wo_chain:{ *:[f32] } 10605:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (XSNABSDPs:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  62868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDPs),
     /*  62871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62873 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62875 */     GIR_RootConstrainSelectedInstOperands,
     /*  62876 */     // GIR_Coverage, 1750,
     /*  62876 */     GIR_EraseRootFromParent_Done,
     /*  62877 */   // Label 917: @62877
     /*  62877 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(62909), // Rule ID 1934 //
     /*  62882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  62885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fres),
     /*  62890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  62900 */     // (intrinsic_wo_chain:{ *:[f32] } 10610:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (XSRESP:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  62900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRESP),
     /*  62903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62905 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62907 */     GIR_RootConstrainSelectedInstOperands,
     /*  62908 */     // GIR_Coverage, 1934,
     /*  62908 */     GIR_EraseRootFromParent_Done,
     /*  62909 */   // Label 918: @62909
     /*  62909 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(62993), // Rule ID 1935 //
     /*  62914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  62917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_extract_exp),
     /*  62922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62932 */     // (intrinsic_wo_chain:{ *:[i32] } 10589:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (EXTRACT_SUBREG:{ *:[i32] } (XSXEXPDP:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f64] }:$A, VSFRC:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  62932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  62935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62944 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  62956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSXEXPDP),
     /*  62960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62965 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  62968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62975 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  62982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  62992 */     // GIR_Coverage, 1935,
     /*  62992 */     GIR_EraseRootFromParent_Done,
     /*  62993 */   // Label 919: @62993
     /*  62993 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(63047), // Rule ID 1936 //
     /*  62998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  63001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_extract_sig),
     /*  63006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  63016 */     // (intrinsic_wo_chain:{ *:[i64] } 10590:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSXSIGDP:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f64] }:$A, VSFRC:{ *:[i32] }))
     /*  63016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  63019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  63032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  63037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSXSIGDP),
     /*  63040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  63042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63045 */     GIR_RootConstrainSelectedInstOperands,
     /*  63046 */     // GIR_Coverage, 1936,
     /*  63046 */     GIR_EraseRootFromParent_Done,
     /*  63047 */   // Label 920: @63047
     /*  63047 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(63101), // Rule ID 2151 //
     /*  63052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  63055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvhpsp),
     /*  63060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  63070 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10833:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$A)  =>  (XVCVHPSP:{ *:[v4f32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] }))
     /*  63070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  63086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  63091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVHPSP),
     /*  63094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  63096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63099 */     GIR_RootConstrainSelectedInstOperands,
     /*  63100 */     // GIR_Coverage, 2151,
     /*  63100 */     GIR_EraseRootFromParent_Done,
     /*  63101 */   // Label 921: @63101
     /*  63101 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(63181), // Rule ID 2165 //
     /*  63106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  63109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_scalar_extract_expq),
     /*  63114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  63120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  63124 */     // (intrinsic_wo_chain:{ *:[i64] } 10757:{ *:[iPTR] }, f128:{ *:[f128] }:$vA)  =>  (MFVSRD:{ *:[i64] } (EXTRACT_SUBREG:{ *:[f64] } (XSXEXPQP:{ *:[v2i64] } ?:{ *:[f128] }:$vA), sub_64:{ *:[i32] }))
     /*  63124 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  63127 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSXEXPQP),
     /*  63131 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63136 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vA
     /*  63140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  63142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  63145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63154 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_64),
     /*  63161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /*  63166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  63174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63179 */     GIR_RootConstrainSelectedInstOperands,
     /*  63180 */     // GIR_Coverage, 2165,
     /*  63180 */     GIR_EraseRootFromParent_Done,
     /*  63181 */   // Label 922: @63181
     /*  63181 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(63224), // Rule ID 1093 //
     /*  63186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  63189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrbm),
     /*  63194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63212 */     // MIs[1] Operand 1
     /*  63212 */     // No operand predicates
     /*  63212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63214 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10254:{ *:[iPTR] }, (imm:{ *:[i64] }):$D)  =>  (MTVSRBMI:{ *:[v16i8] } (imm:{ *:[i64] }):$D)
     /*  63214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRBMI),
     /*  63217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  63219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*  63222 */     GIR_RootConstrainSelectedInstOperands,
     /*  63223 */     // GIR_Coverage, 1093,
     /*  63223 */     GIR_EraseRootFromParent_Done,
     /*  63224 */   // Label 923: @63224
     /*  63224 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(63257), // Rule ID 4850 //
     /*  63229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrte),
     /*  63234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  63244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  63248 */     // (intrinsic_wo_chain:{ *:[f64] } 10611:{ *:[iPTR] }, f8rc:{ *:[f64] }:$frB)  =>  (FRSQRTE:{ *:[f64] } ?:{ *:[f64] }:$frB)
     /*  63248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRSQRTE),
     /*  63251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  63253 */     GIR_RootToRootCopy, /*OpIdx*/2, // frB
     /*  63255 */     GIR_RootConstrainSelectedInstOperands,
     /*  63256 */     // GIR_Coverage, 4850,
     /*  63256 */     GIR_EraseRootFromParent_Done,
     /*  63257 */   // Label 924: @63257
     /*  63257 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(63290), // Rule ID 4851 //
     /*  63262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrtes),
     /*  63267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  63277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  63281 */     // (intrinsic_wo_chain:{ *:[f32] } 10612:{ *:[iPTR] }, f4rc:{ *:[f32] }:$frB)  =>  (FRSQRTES:{ *:[f32] } ?:{ *:[f32] }:$frB)
     /*  63281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRSQRTES),
     /*  63284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  63286 */     GIR_RootToRootCopy, /*OpIdx*/2, // frB
     /*  63288 */     GIR_RootConstrainSelectedInstOperands,
     /*  63289 */     // GIR_Coverage, 4851,
     /*  63289 */     GIR_EraseRootFromParent_Done,
     /*  63290 */   // Label 925: @63290
     /*  63290 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(63319), // Rule ID 73 //
     /*  63295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_popcntb),
     /*  63300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63310 */     // (intrinsic_wo_chain:{ *:[i32] } 10752:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (POPCNTB:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::POPCNTB),
     /*  63313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63315 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63317 */     GIR_RootConstrainSelectedInstOperands,
     /*  63318 */     // GIR_Coverage, 73,
     /*  63318 */     GIR_EraseRootFromParent_Done,
     /*  63319 */   // Label 926: @63319
     /*  63319 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(63348), // Rule ID 74 //
     /*  63324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cdtbcd),
     /*  63329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63339 */     // (intrinsic_wo_chain:{ *:[i32] } 10548:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (CDTBCD:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CDTBCD),
     /*  63342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63344 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63346 */     GIR_RootConstrainSelectedInstOperands,
     /*  63347 */     // GIR_Coverage, 74,
     /*  63347 */     GIR_EraseRootFromParent_Done,
     /*  63348 */   // Label 927: @63348
     /*  63348 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(63377), // Rule ID 75 //
     /*  63353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cbcdtd),
     /*  63358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63368 */     // (intrinsic_wo_chain:{ *:[i32] } 10546:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (CBCDTD:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CBCDTD),
     /*  63371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63373 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63375 */     GIR_RootConstrainSelectedInstOperands,
     /*  63376 */     // GIR_Coverage, 75,
     /*  63376 */     GIR_EraseRootFromParent_Done,
     /*  63377 */   // Label 928: @63377
     /*  63377 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(63409), // Rule ID 321 //
     /*  63382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexptefp),
     /*  63390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63400 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10361:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VEXPTEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPTEFP),
     /*  63403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63405 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63407 */     GIR_RootConstrainSelectedInstOperands,
     /*  63408 */     // GIR_Coverage, 321,
     /*  63408 */     GIR_EraseRootFromParent_Done,
     /*  63409 */   // Label 929: @63409
     /*  63409 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(63441), // Rule ID 322 //
     /*  63414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vlogefp),
     /*  63422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63432 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10399:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VLOGEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VLOGEFP),
     /*  63435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63437 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63439 */     GIR_RootConstrainSelectedInstOperands,
     /*  63440 */     // GIR_Coverage, 322,
     /*  63440 */     GIR_EraseRootFromParent_Done,
     /*  63441 */   // Label 930: @63441
     /*  63441 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(63473), // Rule ID 363 //
     /*  63446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrefp),
     /*  63454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63464 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10467:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VREFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VREFP),
     /*  63467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63469 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63471 */     GIR_RootConstrainSelectedInstOperands,
     /*  63472 */     // GIR_Coverage, 363,
     /*  63472 */     GIR_EraseRootFromParent_Done,
     /*  63473 */   // Label 931: @63473
     /*  63473 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(63505), // Rule ID 364 //
     /*  63478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfim),
     /*  63486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63496 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10468:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIM:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIM),
     /*  63499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63501 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63503 */     GIR_RootConstrainSelectedInstOperands,
     /*  63504 */     // GIR_Coverage, 364,
     /*  63504 */     GIR_EraseRootFromParent_Done,
     /*  63505 */   // Label 932: @63505
     /*  63505 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(63537), // Rule ID 365 //
     /*  63510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfin),
     /*  63518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63528 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10469:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIN:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIN),
     /*  63531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63533 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63535 */     GIR_RootConstrainSelectedInstOperands,
     /*  63536 */     // GIR_Coverage, 365,
     /*  63536 */     GIR_EraseRootFromParent_Done,
     /*  63537 */   // Label 933: @63537
     /*  63537 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(63569), // Rule ID 366 //
     /*  63542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfip),
     /*  63550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63560 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10470:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIP),
     /*  63563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63565 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63567 */     GIR_RootConstrainSelectedInstOperands,
     /*  63568 */     // GIR_Coverage, 366,
     /*  63568 */     GIR_EraseRootFromParent_Done,
     /*  63569 */   // Label 934: @63569
     /*  63569 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(63601), // Rule ID 367 //
     /*  63574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfiz),
     /*  63582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63592 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10471:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIZ:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIZ),
     /*  63595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63597 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63599 */     GIR_RootConstrainSelectedInstOperands,
     /*  63600 */     // GIR_Coverage, 367,
     /*  63600 */     GIR_EraseRootFromParent_Done,
     /*  63601 */   // Label 935: @63601
     /*  63601 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(63633), // Rule ID 368 //
     /*  63606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrsqrtefp),
     /*  63614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63624 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10482:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRSQRTEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRSQRTEFP),
     /*  63627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63629 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63631 */     GIR_RootConstrainSelectedInstOperands,
     /*  63632 */     // GIR_Coverage, 368,
     /*  63632 */     GIR_EraseRootFromParent_Done,
     /*  63633 */   // Label 936: @63633
     /*  63633 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(63665), // Rule ID 419 //
     /*  63638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhpx),
     /*  63646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63656 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10524:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKHPX:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHPX),
     /*  63659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63661 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63663 */     GIR_RootConstrainSelectedInstOperands,
     /*  63664 */     // GIR_Coverage, 419,
     /*  63664 */     GIR_EraseRootFromParent_Done,
     /*  63665 */   // Label 937: @63665
     /*  63665 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(63697), // Rule ID 420 //
     /*  63670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsb),
     /*  63678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63688 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10525:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VUPKHSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VB)
     /*  63688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSB),
     /*  63691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63693 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63695 */     GIR_RootConstrainSelectedInstOperands,
     /*  63696 */     // GIR_Coverage, 420,
     /*  63696 */     GIR_EraseRootFromParent_Done,
     /*  63697 */   // Label 938: @63697
     /*  63697 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(63729), // Rule ID 421 //
     /*  63702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsh),
     /*  63710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63720 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10526:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKHSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSH),
     /*  63723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63725 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63727 */     GIR_RootConstrainSelectedInstOperands,
     /*  63728 */     // GIR_Coverage, 421,
     /*  63728 */     GIR_EraseRootFromParent_Done,
     /*  63729 */   // Label 939: @63729
     /*  63729 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(63761), // Rule ID 422 //
     /*  63734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklpx),
     /*  63742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63752 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10528:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKLPX:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLPX),
     /*  63755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63757 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63759 */     GIR_RootConstrainSelectedInstOperands,
     /*  63760 */     // GIR_Coverage, 422,
     /*  63760 */     GIR_EraseRootFromParent_Done,
     /*  63761 */   // Label 940: @63761
     /*  63761 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(63793), // Rule ID 423 //
     /*  63766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsb),
     /*  63774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63784 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10529:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VUPKLSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VB)
     /*  63784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSB),
     /*  63787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63789 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63791 */     GIR_RootConstrainSelectedInstOperands,
     /*  63792 */     // GIR_Coverage, 423,
     /*  63792 */     GIR_EraseRootFromParent_Done,
     /*  63793 */   // Label 941: @63793
     /*  63793 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(63825), // Rule ID 424 //
     /*  63798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsh),
     /*  63806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63816 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10530:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKLSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSH),
     /*  63819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63821 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63823 */     GIR_RootConstrainSelectedInstOperands,
     /*  63824 */     // GIR_Coverage, 424,
     /*  63824 */     GIR_EraseRootFromParent_Done,
     /*  63825 */   // Label 942: @63825
     /*  63825 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(63857), // Rule ID 504 //
     /*  63830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsw),
     /*  63838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63848 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10527:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VUPKHSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  63848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSW),
     /*  63851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63853 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63855 */     GIR_RootConstrainSelectedInstOperands,
     /*  63856 */     // GIR_Coverage, 504,
     /*  63856 */     GIR_EraseRootFromParent_Done,
     /*  63857 */   // Label 943: @63857
     /*  63857 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(63889), // Rule ID 505 //
     /*  63862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsw),
     /*  63870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63880 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10531:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VUPKLSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  63880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSW),
     /*  63883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63885 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63887 */     GIR_RootConstrainSelectedInstOperands,
     /*  63888 */     // GIR_Coverage, 505,
     /*  63888 */     GIR_EraseRootFromParent_Done,
     /*  63889 */   // Label 944: @63889
     /*  63889 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(63921), // Rule ID 506 //
     /*  63894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vgbbd),
     /*  63902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63912 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10381:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VGBBD:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  63912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VGBBD),
     /*  63915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63917 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63919 */     GIR_RootConstrainSelectedInstOperands,
     /*  63920 */     // GIR_Coverage, 506,
     /*  63920 */     GIR_EraseRootFromParent_Done,
     /*  63921 */   // Label 945: @63921
     /*  63921 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(63953), // Rule ID 514 //
     /*  63926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  63929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vsbox),
     /*  63934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  63940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63944 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10236:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA)  =>  (VSBOX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA)
     /*  63944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSBOX),
     /*  63947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63949 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  63951 */     GIR_RootConstrainSelectedInstOperands,
     /*  63952 */     // GIR_Coverage, 514,
     /*  63952 */     GIR_EraseRootFromParent_Done,
     /*  63953 */   // Label 946: @63953
     /*  63953 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(63985), // Rule ID 530 //
     /*  63958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  63961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclzlsbb),
     /*  63966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63976 */     // (intrinsic_wo_chain:{ *:[i32] } 10291:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VCLZLSBB:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  63976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLZLSBB),
     /*  63979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63981 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63983 */     GIR_RootConstrainSelectedInstOperands,
     /*  63984 */     // GIR_Coverage, 530,
     /*  63984 */     GIR_EraseRootFromParent_Done,
     /*  63985 */   // Label 947: @63985
     /*  63985 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(64017), // Rule ID 531 //
     /*  63990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  63993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctzlsbb),
     /*  63998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64008 */     // (intrinsic_wo_chain:{ *:[i32] } 10349:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VCTZLSBB:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTZLSBB),
     /*  64011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64013 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64015 */     GIR_RootConstrainSelectedInstOperands,
     /*  64016 */     // GIR_Coverage, 531,
     /*  64016 */     GIR_EraseRootFromParent_Done,
     /*  64017 */   // Label 948: @64017
     /*  64017 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(64049), // Rule ID 536 //
     /*  64022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsb2w),
     /*  64030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64040 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10376:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTSB2W:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2W),
     /*  64043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64045 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64047 */     GIR_RootConstrainSelectedInstOperands,
     /*  64048 */     // GIR_Coverage, 536,
     /*  64048 */     GIR_EraseRootFromParent_Done,
     /*  64049 */   // Label 949: @64049
     /*  64049 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(64081), // Rule ID 537 //
     /*  64054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsh2w),
     /*  64062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64072 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10379:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTSH2W:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  64072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2W),
     /*  64075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64077 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64079 */     GIR_RootConstrainSelectedInstOperands,
     /*  64080 */     // GIR_Coverage, 537,
     /*  64080 */     GIR_EraseRootFromParent_Done,
     /*  64081 */   // Label 950: @64081
     /*  64081 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(64113), // Rule ID 538 //
     /*  64086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsb2d),
     /*  64094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64104 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10375:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTSB2D:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$VB)
     /*  64104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2D),
     /*  64107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64109 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64111 */     GIR_RootConstrainSelectedInstOperands,
     /*  64112 */     // GIR_Coverage, 538,
     /*  64112 */     GIR_EraseRootFromParent_Done,
     /*  64113 */   // Label 951: @64113
     /*  64113 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(64145), // Rule ID 539 //
     /*  64118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsh2d),
     /*  64126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64136 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10378:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTSH2D:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$VB)
     /*  64136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2D),
     /*  64139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64141 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64143 */     GIR_RootConstrainSelectedInstOperands,
     /*  64144 */     // GIR_Coverage, 539,
     /*  64144 */     GIR_EraseRootFromParent_Done,
     /*  64145 */   // Label 952: @64145
     /*  64145 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(64177), // Rule ID 540 //
     /*  64150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsw2d),
     /*  64158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64168 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10380:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXTSW2D:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  64168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSW2D),
     /*  64171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64173 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64175 */     GIR_RootConstrainSelectedInstOperands,
     /*  64176 */     // GIR_Coverage, 540,
     /*  64176 */     GIR_EraseRootFromParent_Done,
     /*  64177 */   // Label 953: @64177
     /*  64177 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(64209), // Rule ID 543 //
     /*  64182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybw),
     /*  64190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64200 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10466:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VPRTYBW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBW),
     /*  64203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64205 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64207 */     GIR_RootConstrainSelectedInstOperands,
     /*  64208 */     // GIR_Coverage, 543,
     /*  64208 */     GIR_EraseRootFromParent_Done,
     /*  64209 */   // Label 954: @64209
     /*  64209 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(64241), // Rule ID 544 //
     /*  64214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybd),
     /*  64222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64232 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10464:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VPRTYBD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*  64232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBD),
     /*  64235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64237 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64239 */     GIR_RootConstrainSelectedInstOperands,
     /*  64240 */     // GIR_Coverage, 544,
     /*  64240 */     GIR_EraseRootFromParent_Done,
     /*  64241 */   // Label 955: @64241
     /*  64241 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(64273), // Rule ID 545 //
     /*  64246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybq),
     /*  64254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64264 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10465:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VPRTYBQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VB)
     /*  64264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBQ),
     /*  64267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64269 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64271 */     GIR_RootConstrainSelectedInstOperands,
     /*  64272 */     // GIR_Coverage, 545,
     /*  64272 */     GIR_EraseRootFromParent_Done,
     /*  64273 */   // Label 956: @64273
     /*  64273 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(64302), // Rule ID 689 //
     /*  64278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_popcntb),
     /*  64283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64293 */     // (intrinsic_wo_chain:{ *:[i64] } 10752:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (POPCNTB8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::POPCNTB8),
     /*  64296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64298 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64300 */     GIR_RootConstrainSelectedInstOperands,
     /*  64301 */     // GIR_Coverage, 689,
     /*  64301 */     GIR_EraseRootFromParent_Done,
     /*  64302 */   // Label 957: @64302
     /*  64302 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(64331), // Rule ID 690 //
     /*  64307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cdtbcdd),
     /*  64312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64322 */     // (intrinsic_wo_chain:{ *:[i64] } 10549:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (CDTBCD8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CDTBCD8),
     /*  64325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64327 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64329 */     GIR_RootConstrainSelectedInstOperands,
     /*  64330 */     // GIR_Coverage, 690,
     /*  64330 */     GIR_EraseRootFromParent_Done,
     /*  64331 */   // Label 958: @64331
     /*  64331 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(64360), // Rule ID 691 //
     /*  64336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cbcdtdd),
     /*  64341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64351 */     // (intrinsic_wo_chain:{ *:[i64] } 10547:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (CBCDTD8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CBCDTD8),
     /*  64354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64356 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64358 */     GIR_RootConstrainSelectedInstOperands,
     /*  64359 */     // GIR_Coverage, 691,
     /*  64359 */     GIR_EraseRootFromParent_Done,
     /*  64360 */   // Label 959: @64360
     /*  64360 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(64392), // Rule ID 1058 //
     /*  64365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstribr),
     /*  64373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64383 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10503:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VSTRIBR:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIBR),
     /*  64386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64388 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64390 */     GIR_RootConstrainSelectedInstOperands,
     /*  64391 */     // GIR_Coverage, 1058,
     /*  64391 */     GIR_EraseRootFromParent_Done,
     /*  64392 */   // Label 960: @64392
     /*  64392 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(64424), // Rule ID 1059 //
     /*  64397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstribl),
     /*  64405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64415 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10501:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VSTRIBL:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIBL),
     /*  64418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64420 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64422 */     GIR_RootConstrainSelectedInstOperands,
     /*  64423 */     // GIR_Coverage, 1059,
     /*  64423 */     GIR_EraseRootFromParent_Done,
     /*  64424 */   // Label 961: @64424
     /*  64424 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(64456), // Rule ID 1060 //
     /*  64429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstrihr),
     /*  64437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64447 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10507:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VSTRIHR:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIHR),
     /*  64450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64452 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64454 */     GIR_RootConstrainSelectedInstOperands,
     /*  64455 */     // GIR_Coverage, 1060,
     /*  64455 */     GIR_EraseRootFromParent_Done,
     /*  64456 */   // Label 962: @64456
     /*  64456 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(64488), // Rule ID 1061 //
     /*  64461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstrihl),
     /*  64469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64479 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10505:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VSTRIHL:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIHL),
     /*  64482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64484 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64486 */     GIR_RootConstrainSelectedInstOperands,
     /*  64487 */     // GIR_Coverage, 1061,
     /*  64487 */     GIR_EraseRootFromParent_Done,
     /*  64488 */   // Label 963: @64488
     /*  64488 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(64520), // Rule ID 1078 //
     /*  64493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractbm),
     /*  64501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64511 */     // (intrinsic_wo_chain:{ *:[i32] } 10370:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTRACTBM:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTBM),
     /*  64514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64516 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64518 */     GIR_RootConstrainSelectedInstOperands,
     /*  64519 */     // GIR_Coverage, 1078,
     /*  64519 */     GIR_EraseRootFromParent_Done,
     /*  64520 */   // Label 964: @64520
     /*  64520 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(64552), // Rule ID 1079 //
     /*  64525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextracthm),
     /*  64533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64543 */     // (intrinsic_wo_chain:{ *:[i32] } 10372:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTRACTHM:{ *:[i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  64543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTHM),
     /*  64546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64548 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64550 */     GIR_RootConstrainSelectedInstOperands,
     /*  64551 */     // GIR_Coverage, 1079,
     /*  64551 */     GIR_EraseRootFromParent_Done,
     /*  64552 */   // Label 965: @64552
     /*  64552 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(64584), // Rule ID 1080 //
     /*  64557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractwm),
     /*  64565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64575 */     // (intrinsic_wo_chain:{ *:[i32] } 10374:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXTRACTWM:{ *:[i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTWM),
     /*  64578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64580 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64582 */     GIR_RootConstrainSelectedInstOperands,
     /*  64583 */     // GIR_Coverage, 1080,
     /*  64583 */     GIR_EraseRootFromParent_Done,
     /*  64584 */   // Label 966: @64584
     /*  64584 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(64616), // Rule ID 1081 //
     /*  64589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractdm),
     /*  64597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64607 */     // (intrinsic_wo_chain:{ *:[i32] } 10371:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXTRACTDM:{ *:[i32] } v2i64:{ *:[v2i64] }:$VB)
     /*  64607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTDM),
     /*  64610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64612 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64614 */     GIR_RootConstrainSelectedInstOperands,
     /*  64615 */     // GIR_Coverage, 1081,
     /*  64615 */     GIR_EraseRootFromParent_Done,
     /*  64616 */   // Label 967: @64616
     /*  64616 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(64648), // Rule ID 1082 //
     /*  64621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractqm),
     /*  64629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64639 */     // (intrinsic_wo_chain:{ *:[i32] } 10373:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VEXTRACTQM:{ *:[i32] } v1i128:{ *:[v1i128] }:$VB)
     /*  64639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTQM),
     /*  64642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64644 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64646 */     GIR_RootConstrainSelectedInstOperands,
     /*  64647 */     // GIR_Coverage, 1082,
     /*  64647 */     GIR_EraseRootFromParent_Done,
     /*  64648 */   // Label 968: @64648
     /*  64648 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(64680), // Rule ID 1083 //
     /*  64653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandbm),
     /*  64661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64671 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10356:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXPANDBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDBM),
     /*  64674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64676 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64678 */     GIR_RootConstrainSelectedInstOperands,
     /*  64679 */     // GIR_Coverage, 1083,
     /*  64679 */     GIR_EraseRootFromParent_Done,
     /*  64680 */   // Label 969: @64680
     /*  64680 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(64712), // Rule ID 1084 //
     /*  64685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandhm),
     /*  64693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64703 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10358:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXPANDHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDHM),
     /*  64706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64708 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64710 */     GIR_RootConstrainSelectedInstOperands,
     /*  64711 */     // GIR_Coverage, 1084,
     /*  64711 */     GIR_EraseRootFromParent_Done,
     /*  64712 */   // Label 970: @64712
     /*  64712 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(64744), // Rule ID 1085 //
     /*  64717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandwm),
     /*  64725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64735 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10360:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXPANDWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDWM),
     /*  64738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64740 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64742 */     GIR_RootConstrainSelectedInstOperands,
     /*  64743 */     // GIR_Coverage, 1085,
     /*  64743 */     GIR_EraseRootFromParent_Done,
     /*  64744 */   // Label 971: @64744
     /*  64744 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(64776), // Rule ID 1086 //
     /*  64749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpanddm),
     /*  64757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64767 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10357:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXPANDDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*  64767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDDM),
     /*  64770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64772 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64774 */     GIR_RootConstrainSelectedInstOperands,
     /*  64775 */     // GIR_Coverage, 1086,
     /*  64775 */     GIR_EraseRootFromParent_Done,
     /*  64776 */   // Label 972: @64776
     /*  64776 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(64808), // Rule ID 1087 //
     /*  64781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandqm),
     /*  64789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64799 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10359:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VEXPANDQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VB)
     /*  64799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDQM),
     /*  64802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64804 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64806 */     GIR_RootConstrainSelectedInstOperands,
     /*  64807 */     // GIR_Coverage, 1087,
     /*  64807 */     GIR_EraseRootFromParent_Done,
     /*  64808 */   // Label 973: @64808
     /*  64808 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(64840), // Rule ID 1088 //
     /*  64813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrbm),
     /*  64821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64831 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10254:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRBM:{ *:[v16i8] } i64:{ *:[i64] }:$VB)
     /*  64831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRBM),
     /*  64834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64836 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64838 */     GIR_RootConstrainSelectedInstOperands,
     /*  64839 */     // GIR_Coverage, 1088,
     /*  64839 */     GIR_EraseRootFromParent_Done,
     /*  64840 */   // Label 974: @64840
     /*  64840 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(64872), // Rule ID 1089 //
     /*  64845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrhm),
     /*  64853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64863 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10256:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRHM:{ *:[v8i16] } i64:{ *:[i64] }:$VB)
     /*  64863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRHM),
     /*  64866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64868 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64870 */     GIR_RootConstrainSelectedInstOperands,
     /*  64871 */     // GIR_Coverage, 1089,
     /*  64871 */     GIR_EraseRootFromParent_Done,
     /*  64872 */   // Label 975: @64872
     /*  64872 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(64904), // Rule ID 1090 //
     /*  64877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrwm),
     /*  64885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64895 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10258:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRWM:{ *:[v4i32] } i64:{ *:[i64] }:$VB)
     /*  64895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRWM),
     /*  64898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64900 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64902 */     GIR_RootConstrainSelectedInstOperands,
     /*  64903 */     // GIR_Coverage, 1090,
     /*  64903 */     GIR_EraseRootFromParent_Done,
     /*  64904 */   // Label 976: @64904
     /*  64904 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(64936), // Rule ID 1091 //
     /*  64909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrdm),
     /*  64917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64927 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10255:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRDM:{ *:[v2i64] } i64:{ *:[i64] }:$VB)
     /*  64927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRDM),
     /*  64930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64932 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64934 */     GIR_RootConstrainSelectedInstOperands,
     /*  64935 */     // GIR_Coverage, 1091,
     /*  64935 */     GIR_EraseRootFromParent_Done,
     /*  64936 */   // Label 977: @64936
     /*  64936 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(64968), // Rule ID 1092 //
     /*  64941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrqm),
     /*  64949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64959 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10257:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRQM:{ *:[v1i128] } i64:{ *:[i64] }:$VB)
     /*  64959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRQM),
     /*  64962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64964 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64966 */     GIR_RootConstrainSelectedInstOperands,
     /*  64967 */     // GIR_Coverage, 1092,
     /*  64967 */     GIR_EraseRootFromParent_Done,
     /*  64968 */   // Label 978: @64968
     /*  64968 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(65000), // Rule ID 1156 //
     /*  64973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsd2q),
     /*  64981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64991 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10377:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXTSD2Q:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VB)
     /*  64991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSD2Q),
     /*  64994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64996 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64998 */     GIR_RootConstrainSelectedInstOperands,
     /*  64999 */     // GIR_Coverage, 1156,
     /*  64999 */     GIR_EraseRootFromParent_Done,
     /*  65000 */   // Label 979: @65000
     /*  65000 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(65032), // Rule ID 1161 //
     /*  65005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  65008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmmr),
     /*  65013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  65016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  65019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  65023 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10644:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$AB)  =>  (DMMR:{ *:[v1024i1] } v1024i1:{ *:[v1024i1] }:$AB)
     /*  65023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMMR),
     /*  65026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  65028 */     GIR_RootToRootCopy, /*OpIdx*/2, // AB
     /*  65030 */     GIR_RootConstrainSelectedInstOperands,
     /*  65031 */     // GIR_Coverage, 1161,
     /*  65031 */     GIR_EraseRootFromParent_Done,
     /*  65032 */   // Label 980: @65032
     /*  65032 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(65064), // Rule ID 1164 //
     /*  65037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  65040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxmfacc),
     /*  65045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  65048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  65051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  65055 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10735:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$AT)  =>  (XXMFACC:{ *:[v512i1] } v512i1:{ *:[v512i1] }:$AT)
     /*  65055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXMFACC),
     /*  65058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[ATo]
     /*  65060 */     GIR_RootToRootCopy, /*OpIdx*/2, // AT
     /*  65062 */     GIR_RootConstrainSelectedInstOperands,
     /*  65063 */     // GIR_Coverage, 1164,
     /*  65063 */     GIR_EraseRootFromParent_Done,
     /*  65064 */   // Label 981: @65064
     /*  65064 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(65096), // Rule ID 1165 //
     /*  65069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  65072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxmtacc),
     /*  65077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  65080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  65083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  65087 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10736:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi)  =>  (XXMTACC:{ *:[v512i1] } v512i1:{ *:[v512i1] }:$ATi)
     /*  65087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXMTACC),
     /*  65090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  65092 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  65094 */     GIR_RootConstrainSelectedInstOperands,
     /*  65095 */     // GIR_Coverage, 1165,
     /*  65095 */     GIR_EraseRootFromParent_Done,
     /*  65096 */   // Label 982: @65096
     /*  65096 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(65125), // Rule ID 1280 //
     /*  65101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fre),
     /*  65106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65116 */     // (intrinsic_wo_chain:{ *:[f64] } 10609:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FRE:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRE),
     /*  65119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65121 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65123 */     GIR_RootConstrainSelectedInstOperands,
     /*  65124 */     // GIR_Coverage, 1280,
     /*  65124 */     GIR_EraseRootFromParent_Done,
     /*  65125 */   // Label 983: @65125
     /*  65125 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(65154), // Rule ID 1281 //
     /*  65130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fres),
     /*  65135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  65145 */     // (intrinsic_wo_chain:{ *:[f32] } 10610:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (FRES:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  65145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRES),
     /*  65148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65150 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65152 */     GIR_RootConstrainSelectedInstOperands,
     /*  65153 */     // GIR_Coverage, 1281,
     /*  65153 */     GIR_EraseRootFromParent_Done,
     /*  65154 */   // Label 984: @65154
     /*  65154 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(65183), // Rule ID 1282 //
     /*  65159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabs),
     /*  65164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65174 */     // (intrinsic_wo_chain:{ *:[f64] } 10604:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FNABSD:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSD),
     /*  65177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65179 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65181 */     GIR_RootConstrainSelectedInstOperands,
     /*  65182 */     // GIR_Coverage, 1282,
     /*  65182 */     GIR_EraseRootFromParent_Done,
     /*  65183 */   // Label 985: @65183
     /*  65183 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(65212), // Rule ID 1283 //
     /*  65188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabss),
     /*  65193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  65203 */     // (intrinsic_wo_chain:{ *:[f32] } 10605:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (FNABSS:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  65203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSS),
     /*  65206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65208 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65210 */     GIR_RootConstrainSelectedInstOperands,
     /*  65211 */     // GIR_Coverage, 1283,
     /*  65211 */     GIR_EraseRootFromParent_Done,
     /*  65212 */   // Label 986: @65212
     /*  65212 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(65287), // Rule ID 3357 //
     /*  65217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /*  65220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspbf16),
     /*  65225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65235 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10834:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XVCVSPBF16:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /*  65235 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  65238 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65242 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65247 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  65251 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVCVSPBF16),
     /*  65263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65268 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65286 */     // GIR_Coverage, 3357,
     /*  65286 */     GIR_EraseRootFromParent_Done,
     /*  65287 */   // Label 987: @65287
     /*  65287 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(65362), // Rule ID 3358 //
     /*  65292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /*  65295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvbf16spn),
     /*  65300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65310 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10829:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XVCVBF16SPN:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /*  65310 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  65313 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65317 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65322 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  65326 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVCVBF16SPN),
     /*  65338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65343 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65361 */     // GIR_Coverage, 3358,
     /*  65361 */     GIR_EraseRootFromParent_Done,
     /*  65362 */   // Label 988: @65362
     /*  65362 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(65391), // Rule ID 4888 //
     /*  65367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fcfid),
     /*  65372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65382 */     // (intrinsic_wo_chain:{ *:[f64] } 10591:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVSXDDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSXDDP),
     /*  65385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65387 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65389 */     GIR_RootConstrainSelectedInstOperands,
     /*  65390 */     // GIR_Coverage, 4888,
     /*  65390 */     GIR_EraseRootFromParent_Done,
     /*  65391 */   // Label 989: @65391
     /*  65391 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(65420), // Rule ID 4889 //
     /*  65396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fcfud),
     /*  65401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65411 */     // (intrinsic_wo_chain:{ *:[f64] } 10592:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVUXDDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUXDDP),
     /*  65414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65416 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65418 */     GIR_RootConstrainSelectedInstOperands,
     /*  65419 */     // GIR_Coverage, 4889,
     /*  65419 */     GIR_EraseRootFromParent_Done,
     /*  65420 */   // Label 990: @65420
     /*  65420 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(65449), // Rule ID 4890 //
     /*  65425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctid),
     /*  65430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65440 */     // (intrinsic_wo_chain:{ *:[f64] } 10593:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FCTID:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  65443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65445 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65447 */     GIR_RootConstrainSelectedInstOperands,
     /*  65448 */     // GIR_Coverage, 4890,
     /*  65448 */     GIR_EraseRootFromParent_Done,
     /*  65449 */   // Label 991: @65449
     /*  65449 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(65478), // Rule ID 4891 //
     /*  65454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctidz),
     /*  65459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65469 */     // (intrinsic_wo_chain:{ *:[f64] } 10594:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPSXDS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSXDS),
     /*  65472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65474 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65476 */     GIR_RootConstrainSelectedInstOperands,
     /*  65477 */     // GIR_Coverage, 4891,
     /*  65477 */     GIR_EraseRootFromParent_Done,
     /*  65478 */   // Label 992: @65478
     /*  65478 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(65507), // Rule ID 4892 //
     /*  65483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctiw),
     /*  65488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65498 */     // (intrinsic_wo_chain:{ *:[f64] } 10595:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FCTIW:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /*  65501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65503 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65505 */     GIR_RootConstrainSelectedInstOperands,
     /*  65506 */     // GIR_Coverage, 4892,
     /*  65506 */     GIR_EraseRootFromParent_Done,
     /*  65507 */   // Label 993: @65507
     /*  65507 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(65536), // Rule ID 4893 //
     /*  65512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctiwz),
     /*  65517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65527 */     // (intrinsic_wo_chain:{ *:[f64] } 10596:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPSXWS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSXWS),
     /*  65530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65532 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65534 */     GIR_RootConstrainSelectedInstOperands,
     /*  65535 */     // GIR_Coverage, 4893,
     /*  65535 */     GIR_EraseRootFromParent_Done,
     /*  65536 */   // Label 994: @65536
     /*  65536 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(65565), // Rule ID 4894 //
     /*  65541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctudz),
     /*  65546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65556 */     // (intrinsic_wo_chain:{ *:[f64] } 10597:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPUXDS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPUXDS),
     /*  65559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65561 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65563 */     GIR_RootConstrainSelectedInstOperands,
     /*  65564 */     // GIR_Coverage, 4894,
     /*  65564 */     GIR_EraseRootFromParent_Done,
     /*  65565 */   // Label 995: @65565
     /*  65565 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(65594), // Rule ID 4895 //
     /*  65570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctuwz),
     /*  65575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65585 */     // (intrinsic_wo_chain:{ *:[f64] } 10598:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPUXWS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPUXWS),
     /*  65588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65590 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65592 */     GIR_RootConstrainSelectedInstOperands,
     /*  65593 */     // GIR_Coverage, 4895,
     /*  65593 */     GIR_EraseRootFromParent_Done,
     /*  65594 */   // Label 996: @65594
     /*  65594 */   GIM_Reject,
     /*  65595 */ // Label 889: @65595
     /*  65595 */ GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(74231),
     /*  65600 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  65603 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(65674), // Rule ID 2167 //
     /*  65608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxextractuw),
     /*  65616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  65625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  65633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65637 */     // MIs[1] Operand 1
     /*  65637 */     // No operand predicates
     /*  65637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65639 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10873:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$A, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXEXTRACTUW:{ *:[f64] } ?:{ *:[v2i64] }:$A, (imm:{ *:[i32] }):$IMM), VSRC:{ *:[i32] })
     /*  65639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  65642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXEXTRACTUW),
     /*  65646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65651 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  65655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  65658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65673 */     // GIR_Coverage, 2167,
     /*  65673 */     GIR_EraseRootFromParent_Done,
     /*  65674 */   // Label 998: @65674
     /*  65674 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(65711), // Rule ID 1029 //
     /*  65679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtstdcsp),
     /*  65687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65697 */     // MIs[0] DCMX
     /*  65697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  65700 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10863:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB, (timm:{ *:[i32] }):$DCMX)  =>  (XVTSTDCSP:{ *:[v4i32] } (timm:{ *:[i32] }):$DCMX, v4f32:{ *:[v4f32] }:$XB)
     /*  65700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVTSTDCSP),
     /*  65703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65705 */     GIR_RootToRootCopy, /*OpIdx*/3, // DCMX
     /*  65707 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  65709 */     GIR_RootConstrainSelectedInstOperands,
     /*  65710 */     // GIR_Coverage, 1029,
     /*  65710 */     GIR_EraseRootFromParent_Done,
     /*  65711 */   // Label 999: @65711
     /*  65711 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(65748), // Rule ID 1030 //
     /*  65716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtstdcdp),
     /*  65724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65734 */     // MIs[0] DCMX
     /*  65734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  65737 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10862:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB, (timm:{ *:[i32] }):$DCMX)  =>  (XVTSTDCDP:{ *:[v2i64] } (timm:{ *:[i32] }):$DCMX, v2f64:{ *:[v2f64] }:$XB)
     /*  65737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVTSTDCDP),
     /*  65740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65742 */     GIR_RootToRootCopy, /*OpIdx*/3, // DCMX
     /*  65744 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  65746 */     GIR_RootConstrainSelectedInstOperands,
     /*  65747 */     // GIR_Coverage, 1030,
     /*  65747 */     GIR_EraseRootFromParent_Done,
     /*  65748 */   // Label 1000: @65748
     /*  65748 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(65793), // Rule ID 898 //
     /*  65753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xsmaxdp),
     /*  65761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  65770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65782 */     // (intrinsic_wo_chain:{ *:[f64] } 10815:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)  =>  (XSMAXDP:{ *:[f64] } vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)
     /*  65782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /*  65785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65787 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65789 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65791 */     GIR_RootConstrainSelectedInstOperands,
     /*  65792 */     // GIR_Coverage, 898,
     /*  65792 */     GIR_EraseRootFromParent_Done,
     /*  65793 */   // Label 1001: @65793
     /*  65793 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(65838), // Rule ID 899 //
     /*  65798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xsmindp),
     /*  65806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  65815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65827 */     // (intrinsic_wo_chain:{ *:[f64] } 10816:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)  =>  (XSMINDP:{ *:[f64] } vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)
     /*  65827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /*  65830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65832 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65834 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65836 */     GIR_RootConstrainSelectedInstOperands,
     /*  65837 */     // GIR_Coverage, 899,
     /*  65837 */     GIR_EraseRootFromParent_Done,
     /*  65838 */   // Label 1002: @65838
     /*  65838 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(65883), // Rule ID 900 //
     /*  65843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmaxdp),
     /*  65851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  65860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65872 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10847:{ *:[iPTR] }, vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)  =>  (XVMAXDP:{ *:[v2f64] } vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)
     /*  65872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMAXDP),
     /*  65875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65877 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65879 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65881 */     GIR_RootConstrainSelectedInstOperands,
     /*  65882 */     // GIR_Coverage, 900,
     /*  65882 */     GIR_EraseRootFromParent_Done,
     /*  65883 */   // Label 1003: @65883
     /*  65883 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(65928), // Rule ID 901 //
     /*  65888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmindp),
     /*  65896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  65905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65917 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10849:{ *:[iPTR] }, vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)  =>  (XVMINDP:{ *:[v2f64] } vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)
     /*  65917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMINDP),
     /*  65920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65922 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65924 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65926 */     GIR_RootConstrainSelectedInstOperands,
     /*  65927 */     // GIR_Coverage, 901,
     /*  65927 */     GIR_EraseRootFromParent_Done,
     /*  65928 */   // Label 1004: @65928
     /*  65928 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(65973), // Rule ID 902 //
     /*  65933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmaxsp),
     /*  65941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65962 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10848:{ *:[iPTR] }, vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)  =>  (XVMAXSP:{ *:[v4f32] } vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)
     /*  65962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMAXSP),
     /*  65965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65967 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65969 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65971 */     GIR_RootConstrainSelectedInstOperands,
     /*  65972 */     // GIR_Coverage, 902,
     /*  65972 */     GIR_EraseRootFromParent_Done,
     /*  65973 */   // Label 1005: @65973
     /*  65973 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(66018), // Rule ID 903 //
     /*  65978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvminsp),
     /*  65986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66007 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10850:{ *:[iPTR] }, vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)  =>  (XVMINSP:{ *:[v4f32] } vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)
     /*  66007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMINSP),
     /*  66010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66012 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66014 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66016 */     GIR_RootConstrainSelectedInstOperands,
     /*  66017 */     // GIR_Coverage, 903,
     /*  66017 */     GIR_EraseRootFromParent_Done,
     /*  66018 */   // Label 1006: @66018
     /*  66018 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(66055), // Rule ID 827 //
     /*  66023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpeqdp),
     /*  66031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66044 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10817:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPEQDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPEQDP),
     /*  66047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66049 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66051 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66053 */     GIR_RootConstrainSelectedInstOperands,
     /*  66054 */     // GIR_Coverage, 827,
     /*  66054 */     GIR_EraseRootFromParent_Done,
     /*  66055 */   // Label 1007: @66055
     /*  66055 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(66092), // Rule ID 829 //
     /*  66060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpeqsp),
     /*  66068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66081 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10819:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPEQSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPEQSP),
     /*  66084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66086 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66088 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66090 */     GIR_RootConstrainSelectedInstOperands,
     /*  66091 */     // GIR_Coverage, 829,
     /*  66091 */     GIR_EraseRootFromParent_Done,
     /*  66092 */   // Label 1008: @66092
     /*  66092 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(66129), // Rule ID 831 //
     /*  66097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgedp),
     /*  66105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66118 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10821:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPGEDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGEDP),
     /*  66121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66123 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66125 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66127 */     GIR_RootConstrainSelectedInstOperands,
     /*  66128 */     // GIR_Coverage, 831,
     /*  66128 */     GIR_EraseRootFromParent_Done,
     /*  66129 */   // Label 1009: @66129
     /*  66129 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(66166), // Rule ID 833 //
     /*  66134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgesp),
     /*  66142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66155 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10823:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPGESP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGESP),
     /*  66158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66160 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66162 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66164 */     GIR_RootConstrainSelectedInstOperands,
     /*  66165 */     // GIR_Coverage, 833,
     /*  66165 */     GIR_EraseRootFromParent_Done,
     /*  66166 */   // Label 1010: @66166
     /*  66166 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(66203), // Rule ID 835 //
     /*  66171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgtdp),
     /*  66179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66192 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10825:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPGTDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGTDP),
     /*  66195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66197 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66199 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66201 */     GIR_RootConstrainSelectedInstOperands,
     /*  66202 */     // GIR_Coverage, 835,
     /*  66202 */     GIR_EraseRootFromParent_Done,
     /*  66203 */   // Label 1011: @66203
     /*  66203 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(66240), // Rule ID 837 //
     /*  66208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgtsp),
     /*  66216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66229 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10827:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPGTSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGTSP),
     /*  66232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66234 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66236 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66238 */     GIR_RootConstrainSelectedInstOperands,
     /*  66239 */     // GIR_Coverage, 837,
     /*  66239 */     GIR_EraseRootFromParent_Done,
     /*  66240 */   // Label 1012: @66240
     /*  66240 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(66277), // Rule ID 1001 //
     /*  66245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addf128_round_to_odd),
     /*  66253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66266 */     // (intrinsic_wo_chain:{ *:[f128] } 10223:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSADDQPO),
     /*  66269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66271 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66273 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66275 */     GIR_RootConstrainSelectedInstOperands,
     /*  66276 */     // GIR_Coverage, 1001,
     /*  66276 */     GIR_EraseRootFromParent_Done,
     /*  66277 */   // Label 1013: @66277
     /*  66277 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(66314), // Rule ID 1002 //
     /*  66282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulf128_round_to_odd),
     /*  66290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66303 */     // (intrinsic_wo_chain:{ *:[f128] } 10744:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMULQPO),
     /*  66306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66308 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66310 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66312 */     GIR_RootConstrainSelectedInstOperands,
     /*  66313 */     // GIR_Coverage, 1002,
     /*  66313 */     GIR_EraseRootFromParent_Done,
     /*  66314 */   // Label 1014: @66314
     /*  66314 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(66351), // Rule ID 1003 //
     /*  66319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_subf128_round_to_odd),
     /*  66327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66340 */     // (intrinsic_wo_chain:{ *:[f128] } 10775:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSSUBQPO),
     /*  66343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66345 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66347 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66349 */     GIR_RootConstrainSelectedInstOperands,
     /*  66350 */     // GIR_Coverage, 1003,
     /*  66350 */     GIR_EraseRootFromParent_Done,
     /*  66351 */   // Label 1015: @66351
     /*  66351 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(66388), // Rule ID 1004 //
     /*  66356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divf128_round_to_odd),
     /*  66364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66377 */     // (intrinsic_wo_chain:{ *:[f128] } 10585:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSDIVQPO),
     /*  66380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66382 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66384 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66386 */     GIR_RootConstrainSelectedInstOperands,
     /*  66387 */     // GIR_Coverage, 1004,
     /*  66387 */     GIR_EraseRootFromParent_Done,
     /*  66388 */   // Label 1016: @66388
     /*  66388 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(66425), // Rule ID 1023 //
     /*  66393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xviexpdp),
     /*  66401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66414 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10845:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB)  =>  (XVIEXPDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB)
     /*  66414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVIEXPDP),
     /*  66417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66419 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66421 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66423 */     GIR_RootConstrainSelectedInstOperands,
     /*  66424 */     // GIR_Coverage, 1023,
     /*  66424 */     GIR_EraseRootFromParent_Done,
     /*  66425 */   // Label 1017: @66425
     /*  66425 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(66462), // Rule ID 1024 //
     /*  66430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xviexpsp),
     /*  66438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66451 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10846:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XVIEXPSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  66451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVIEXPSP),
     /*  66454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66456 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66458 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66460 */     GIR_RootConstrainSelectedInstOperands,
     /*  66461 */     // GIR_Coverage, 1024,
     /*  66461 */     GIR_EraseRootFromParent_Done,
     /*  66462 */   // Label 1018: @66462
     /*  66462 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(66499), // Rule ID 1652 //
     /*  66467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvdivsp),
     /*  66475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66488 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10844:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B)  =>  (XVDIVSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B)
     /*  66488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /*  66491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66493 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66495 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66497 */     GIR_RootConstrainSelectedInstOperands,
     /*  66498 */     // GIR_Coverage, 1652,
     /*  66498 */     GIR_EraseRootFromParent_Done,
     /*  66499 */   // Label 1019: @66499
     /*  66499 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(66536), // Rule ID 1653 //
     /*  66504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvdivdp),
     /*  66512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66525 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10843:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A, v2f64:{ *:[v2f64] }:$B)  =>  (XVDIVDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A, ?:{ *:[v2f64] }:$B)
     /*  66525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /*  66528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66530 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66532 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66534 */     GIR_RootConstrainSelectedInstOperands,
     /*  66535 */     // GIR_Coverage, 1653,
     /*  66535 */     GIR_EraseRootFromParent_Done,
     /*  66536 */   // Label 1020: @66536
     /*  66536 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(66598), // Rule ID 1654 //
     /*  66541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtdivdp),
     /*  66549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66562 */     // (intrinsic_wo_chain:{ *:[i32] } 10857:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A, v2f64:{ *:[v2f64] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTDIVDP:{ *:[i32] } ?:{ *:[v2f64] }:$A, ?:{ *:[v2f64] }:$B), GPRC:{ *:[i32] })
     /*  66562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTDIVDP),
     /*  66569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66574 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66597 */     // GIR_Coverage, 1654,
     /*  66597 */     GIR_EraseRootFromParent_Done,
     /*  66598 */   // Label 1021: @66598
     /*  66598 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(66660), // Rule ID 1655 //
     /*  66603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtdivsp),
     /*  66611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66624 */     // (intrinsic_wo_chain:{ *:[i32] } 10858:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTDIVSP:{ *:[i32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B), GPRC:{ *:[i32] })
     /*  66624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTDIVSP),
     /*  66631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66659 */     // GIR_Coverage, 1655,
     /*  66659 */     GIR_EraseRootFromParent_Done,
     /*  66660 */   // Label 1022: @66660
     /*  66660 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(66697), // Rule ID 1899 //
     /*  66665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  66668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxleqv),
     /*  66673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66686 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10879:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B)  =>  (XXLEQV:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*  66686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  66689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66691 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66693 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66695 */     GIR_RootConstrainSelectedInstOperands,
     /*  66696 */     // GIR_Coverage, 1899,
     /*  66696 */     GIR_EraseRootFromParent_Done,
     /*  66697 */   // Label 1023: @66697
     /*  66697 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(66779), // Rule ID 1937 //
     /*  66702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  66705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_insert_exp),
     /*  66710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  66713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  66716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  66719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  66723 */     // (intrinsic_wo_chain:{ *:[f64] } 10620:{ *:[iPTR] }, f64:{ *:[f64] }:$A, i64:{ *:[i64] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f64] } (XSIEXPDP:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[i64] } ?:{ *:[f64] }:$A, G8RC:{ *:[i32] }), ?:{ *:[i64] }:$B), F8RC:{ *:[i32] })
     /*  66723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  66726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66735 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  66744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSIEXPDP),
     /*  66751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66756 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  66759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  66778 */     // GIR_Coverage, 1937,
     /*  66778 */     GIR_EraseRootFromParent_Done,
     /*  66779 */   // Label 1024: @66779
     /*  66779 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(66835), // Rule ID 2164 //
     /*  66784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_scalar_insert_exp_qp),
     /*  66792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  66801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66805 */     // (intrinsic_wo_chain:{ *:[f128] } 10758:{ *:[iPTR] }, f128:{ *:[f128] }:$vA, i64:{ *:[i64] }:$vB)  =>  (XSIEXPQP:{ *:[f128] } ?:{ *:[f128] }:$vA, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$vB))
     /*  66805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  66808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  66812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vB
     /*  66821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSIEXPQP),
     /*  66826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  66828 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  66830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66833 */     GIR_RootConstrainSelectedInstOperands,
     /*  66834 */     // GIR_Coverage, 2164,
     /*  66834 */     GIR_EraseRootFromParent_Done,
     /*  66835 */   // Label 1025: @66835
     /*  66835 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(66926), // Rule ID 3347 //
     /*  66840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  66843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtlsbb),
     /*  66848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  66857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  66865 */     // (intrinsic_wo_chain:{ *:[i32] } 10859:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XB, 1:{ *:[i32] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (XVTLSBB:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] })), sub_lt:{ *:[i32] })
     /*  66865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  66868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66877 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XB
     /*  66881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTLSBB),
     /*  66893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66898 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  66901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66908 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  66915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  66925 */     // GIR_Coverage, 3347,
     /*  66925 */     GIR_EraseRootFromParent_Done,
     /*  66926 */   // Label 1026: @66926
     /*  66926 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(67017), // Rule ID 3348 //
     /*  66931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  66934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtlsbb),
     /*  66939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  66948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  66956 */     // (intrinsic_wo_chain:{ *:[i32] } 10859:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XB, 0:{ *:[i32] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (XVTLSBB:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] })), sub_eq:{ *:[i32] })
     /*  66956 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  66959 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66963 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66968 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XB
     /*  66972 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTLSBB),
     /*  66984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66989 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  66992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66999 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  67006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  67011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  67016 */     // GIR_Coverage, 3348,
     /*  67016 */     GIR_EraseRootFromParent_Done,
     /*  67017 */   // Label 1027: @67017
     /*  67017 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(67060), // Rule ID 317 //
     /*  67022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfsx),
     /*  67030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67040 */     // MIs[0] Operand 3
     /*  67040 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67051 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10285:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, 0:{ *:[i32] })  =>  (VCFSX_0:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$VB)
     /*  67051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFSX_0),
     /*  67054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67056 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67058 */     GIR_RootConstrainSelectedInstOperands,
     /*  67059 */     // GIR_Coverage, 317,
     /*  67059 */     GIR_EraseRootFromParent_Done,
     /*  67060 */   // Label 1028: @67060
     /*  67060 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(67103), // Rule ID 318 //
     /*  67065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctuxs),
     /*  67073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67083 */     // MIs[0] Operand 3
     /*  67083 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67094 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10347:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, 0:{ *:[i32] })  =>  (VCTUXS_0:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$VB)
     /*  67094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTUXS_0),
     /*  67097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67099 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67101 */     GIR_RootConstrainSelectedInstOperands,
     /*  67102 */     // GIR_Coverage, 318,
     /*  67102 */     GIR_EraseRootFromParent_Done,
     /*  67103 */   // Label 1029: @67103
     /*  67103 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(67146), // Rule ID 319 //
     /*  67108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfux),
     /*  67116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67126 */     // MIs[0] Operand 3
     /*  67126 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67137 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10287:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, 0:{ *:[i32] })  =>  (VCFUX_0:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$VB)
     /*  67137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUX_0),
     /*  67140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67142 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67144 */     GIR_RootConstrainSelectedInstOperands,
     /*  67145 */     // GIR_Coverage, 319,
     /*  67145 */     GIR_EraseRootFromParent_Done,
     /*  67146 */   // Label 1030: @67146
     /*  67146 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(67189), // Rule ID 320 //
     /*  67151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctsxs),
     /*  67159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67169 */     // MIs[0] Operand 3
     /*  67169 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67180 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10346:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, 0:{ *:[i32] })  =>  (VCTSXS_0:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$VB)
     /*  67180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTSXS_0),
     /*  67183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67185 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67187 */     GIR_RootConstrainSelectedInstOperands,
     /*  67188 */     // GIR_Coverage, 320,
     /*  67188 */     GIR_EraseRootFromParent_Done,
     /*  67189 */   // Label 1031: @67189
     /*  67189 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(67260), // Rule ID 3343 //
     /*  67194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvbm),
     /*  67202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67223 */     // MIs[1] Operand 1
     /*  67223 */     // No operand predicates
     /*  67223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67225 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10874:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXGENPCVBM:{ *:[v4i32] } ?:{ *:[v16i8] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVBM),
     /*  67232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67237 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67259 */     // GIR_Coverage, 3343,
     /*  67259 */     GIR_EraseRootFromParent_Done,
     /*  67260 */   // Label 1032: @67260
     /*  67260 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(67331), // Rule ID 3344 //
     /*  67265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvhm),
     /*  67273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67294 */     // MIs[1] Operand 1
     /*  67294 */     // No operand predicates
     /*  67294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67296 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10876:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXGENPCVHM:{ *:[v4i32] } ?:{ *:[v8i16] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVHM),
     /*  67303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67308 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67330 */     // GIR_Coverage, 3344,
     /*  67330 */     GIR_EraseRootFromParent_Done,
     /*  67331 */   // Label 1033: @67331
     /*  67331 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(67402), // Rule ID 3345 //
     /*  67336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvwm),
     /*  67344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67365 */     // MIs[1] Operand 1
     /*  67365 */     // No operand predicates
     /*  67365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67367 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10877:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (XXGENPCVWM:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVWM),
     /*  67374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67379 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67401 */     // GIR_Coverage, 3345,
     /*  67401 */     GIR_EraseRootFromParent_Done,
     /*  67402 */   // Label 1034: @67402
     /*  67402 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(67473), // Rule ID 3346 //
     /*  67407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvdm),
     /*  67415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  67418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67436 */     // MIs[1] Operand 1
     /*  67436 */     // No operand predicates
     /*  67436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67438 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10875:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXGENPCVDM:{ *:[v4i32] } ?:{ *:[v2i64] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVDM),
     /*  67445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67472 */     // GIR_Coverage, 3346,
     /*  67472 */     GIR_EraseRootFromParent_Done,
     /*  67473 */   // Label 1035: @67473
     /*  67473 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(67510), // Rule ID 313 //
     /*  67478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfsx),
     /*  67486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67496 */     // MIs[0] VA
     /*  67496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67499 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10285:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCFSX:{ *:[v4f32] } (timm:{ *:[i32] }):$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  67499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFSX),
     /*  67502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67504 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67506 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67508 */     GIR_RootConstrainSelectedInstOperands,
     /*  67509 */     // GIR_Coverage, 313,
     /*  67509 */     GIR_EraseRootFromParent_Done,
     /*  67510 */   // Label 1036: @67510
     /*  67510 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(67547), // Rule ID 314 //
     /*  67515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfux),
     /*  67523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67533 */     // MIs[0] VA
     /*  67533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67536 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10287:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCFUX:{ *:[v4f32] } (timm:{ *:[i32] }):$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  67536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUX),
     /*  67539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67541 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67543 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67545 */     GIR_RootConstrainSelectedInstOperands,
     /*  67546 */     // GIR_Coverage, 314,
     /*  67546 */     GIR_EraseRootFromParent_Done,
     /*  67547 */   // Label 1037: @67547
     /*  67547 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(67584), // Rule ID 315 //
     /*  67552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctsxs),
     /*  67560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67570 */     // MIs[0] VA
     /*  67570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67573 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10346:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCTSXS:{ *:[v4i32] } (timm:{ *:[i32] }):$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  67573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTSXS),
     /*  67576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67578 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67580 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67582 */     GIR_RootConstrainSelectedInstOperands,
     /*  67583 */     // GIR_Coverage, 315,
     /*  67583 */     GIR_EraseRootFromParent_Done,
     /*  67584 */   // Label 1038: @67584
     /*  67584 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(67621), // Rule ID 316 //
     /*  67589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctuxs),
     /*  67597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67607 */     // MIs[0] VA
     /*  67607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67610 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10347:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCTUXS:{ *:[v4i32] } (timm:{ *:[i32] }):$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  67610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTUXS),
     /*  67613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67615 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67617 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67619 */     GIR_RootConstrainSelectedInstOperands,
     /*  67620 */     // GIR_Coverage, 316,
     /*  67620 */     GIR_EraseRootFromParent_Done,
     /*  67621 */   // Label 1039: @67621
     /*  67621 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(67658), // Rule ID 1094 //
     /*  67626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbb),
     /*  67634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67644 */     // MIs[0] MP
     /*  67644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67647 */     // (intrinsic_wo_chain:{ *:[i64] } 10342:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBB:{ *:[i64] } v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBB),
     /*  67650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67652 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67654 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67656 */     GIR_RootConstrainSelectedInstOperands,
     /*  67657 */     // GIR_Coverage, 1094,
     /*  67657 */     GIR_EraseRootFromParent_Done,
     /*  67658 */   // Label 1040: @67658
     /*  67658 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(67695), // Rule ID 1095 //
     /*  67663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbh),
     /*  67671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67681 */     // MIs[0] MP
     /*  67681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67684 */     // (intrinsic_wo_chain:{ *:[i64] } 10344:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBH:{ *:[i64] } v8i16:{ *:[v8i16] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBH),
     /*  67687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67689 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67691 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67693 */     GIR_RootConstrainSelectedInstOperands,
     /*  67694 */     // GIR_Coverage, 1095,
     /*  67694 */     GIR_EraseRootFromParent_Done,
     /*  67695 */   // Label 1041: @67695
     /*  67695 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(67732), // Rule ID 1096 //
     /*  67700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbw),
     /*  67708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67718 */     // MIs[0] MP
     /*  67718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67721 */     // (intrinsic_wo_chain:{ *:[i64] } 10345:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBW:{ *:[i64] } v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBW),
     /*  67724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67726 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67728 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67730 */     GIR_RootConstrainSelectedInstOperands,
     /*  67731 */     // GIR_Coverage, 1096,
     /*  67731 */     GIR_EraseRootFromParent_Done,
     /*  67732 */   // Label 1042: @67732
     /*  67732 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(67769), // Rule ID 1097 //
     /*  67737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbd),
     /*  67745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67755 */     // MIs[0] MP
     /*  67755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67758 */     // (intrinsic_wo_chain:{ *:[i64] } 10343:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBD:{ *:[i64] } v2i64:{ *:[v2i64] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBD),
     /*  67761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67763 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67765 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67767 */     GIR_RootConstrainSelectedInstOperands,
     /*  67768 */     // GIR_Coverage, 1097,
     /*  67768 */     GIR_EraseRootFromParent_Done,
     /*  67769 */   // Label 1043: @67769
     /*  67769 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(67806), // Rule ID 1111 //
     /*  67774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vgnb),
     /*  67782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  67788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67792 */     // MIs[0] N
     /*  67792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67795 */     // (intrinsic_wo_chain:{ *:[i64] } 10382:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB, (timm:{ *:[i32] }):$N)  =>  (VGNB:{ *:[i64] } v1i128:{ *:[v1i128] }:$VB, (timm:{ *:[i32] }):$N)
     /*  67795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VGNB),
     /*  67798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67800 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67802 */     GIR_RootToRootCopy, /*OpIdx*/3, // N
     /*  67804 */     GIR_RootConstrainSelectedInstOperands,
     /*  67805 */     // GIR_Coverage, 1111,
     /*  67805 */     GIR_EraseRootFromParent_Done,
     /*  67806 */   // Label 1044: @67806
     /*  67806 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(67851), // Rule ID 204 //
     /*  67811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  67814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divwe),
     /*  67819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  67822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  67825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67840 */     // (intrinsic_wo_chain:{ *:[i32] } 10586:{ *:[iPTR] }, gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)  =>  (DIVWE:{ *:[i32] } gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)
     /*  67840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVWE),
     /*  67843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  67845 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  67847 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  67849 */     GIR_RootConstrainSelectedInstOperands,
     /*  67850 */     // GIR_Coverage, 204,
     /*  67850 */     GIR_EraseRootFromParent_Done,
     /*  67851 */   // Label 1045: @67851
     /*  67851 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(67896), // Rule ID 205 //
     /*  67856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  67859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divweu),
     /*  67864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  67867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  67870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67885 */     // (intrinsic_wo_chain:{ *:[i32] } 10587:{ *:[iPTR] }, gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)  =>  (DIVWEU:{ *:[i32] } gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)
     /*  67885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVWEU),
     /*  67888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  67890 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  67892 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  67894 */     GIR_RootConstrainSelectedInstOperands,
     /*  67895 */     // GIR_Coverage, 205,
     /*  67895 */     GIR_EraseRootFromParent_Done,
     /*  67896 */   // Label 1046: @67896
     /*  67896 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(67941), // Rule ID 686 //
     /*  67901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBPERMD),
     /*  67904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bpermd),
     /*  67909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  67915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  67918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67930 */     // (intrinsic_wo_chain:{ *:[i64] } 10545:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RST, g8rc:{ *:[i64] }:$RB)  =>  (BPERMD:{ *:[i64] } g8rc:{ *:[i64] }:$RST, g8rc:{ *:[i64] }:$RB)
     /*  67930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BPERMD),
     /*  67933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  67935 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  67937 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  67939 */     GIR_RootConstrainSelectedInstOperands,
     /*  67940 */     // GIR_Coverage, 686,
     /*  67940 */     GIR_EraseRootFromParent_Done,
     /*  67941 */   // Label 1047: @67941
     /*  67941 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(67986), // Rule ID 695 //
     /*  67946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  67949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divde),
     /*  67954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  67960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  67963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67975 */     // (intrinsic_wo_chain:{ *:[i64] } 10583:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)  =>  (DIVDE:{ *:[i64] } g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)
     /*  67975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVDE),
     /*  67978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  67980 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  67982 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  67984 */     GIR_RootConstrainSelectedInstOperands,
     /*  67985 */     // GIR_Coverage, 695,
     /*  67985 */     GIR_EraseRootFromParent_Done,
     /*  67986 */   // Label 1048: @67986
     /*  67986 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(68031), // Rule ID 700 //
     /*  67991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  67994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divdeu),
     /*  67999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68020 */     // (intrinsic_wo_chain:{ *:[i64] } 10584:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)  =>  (DIVDEU:{ *:[i64] } g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)
     /*  68020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVDEU),
     /*  68023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68025 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68027 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68029 */     GIR_RootConstrainSelectedInstOperands,
     /*  68030 */     // GIR_Coverage, 700,
     /*  68030 */     GIR_EraseRootFromParent_Done,
     /*  68031 */   // Label 1049: @68031
     /*  68031 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(68097), // Rule ID 1558 //
     /*  68036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  68039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpeqb),
     /*  68044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68065 */     // (intrinsic_wo_chain:{ *:[i64] } 10553:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (SETB8:{ *:[i64] } (CMPEQB:{ *:[i32] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b))
     /*  68065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  68068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPEQB),
     /*  68072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // a
     /*  68081 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // b
     /*  68085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  68087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETB8),
     /*  68090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68095 */     GIR_RootConstrainSelectedInstOperands,
     /*  68096 */     // GIR_Coverage, 1558,
     /*  68096 */     GIR_EraseRootFromParent_Done,
     /*  68097 */   // Label 1050: @68097
     /*  68097 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(68163), // Rule ID 1559 //
     /*  68102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  68105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setb),
     /*  68110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68131 */     // (intrinsic_wo_chain:{ *:[i64] } 10763:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (SETB8:{ *:[i64] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b))
     /*  68131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  68134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  68138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // a
     /*  68147 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // b
     /*  68151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  68153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETB8),
     /*  68156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68161 */     GIR_RootConstrainSelectedInstOperands,
     /*  68162 */     // GIR_Coverage, 1559,
     /*  68162 */     GIR_EraseRootFromParent_Done,
     /*  68163 */   // Label 1051: @68163
     /*  68163 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(68208), // Rule ID 1563 //
     /*  68168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  68171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhd),
     /*  68176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68197 */     // (intrinsic_wo_chain:{ *:[i64] } 10745:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (MULHD:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHD),
     /*  68200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68202 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68204 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68206 */     GIR_RootConstrainSelectedInstOperands,
     /*  68207 */     // GIR_Coverage, 1563,
     /*  68207 */     GIR_EraseRootFromParent_Done,
     /*  68208 */   // Label 1052: @68208
     /*  68208 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(68253), // Rule ID 1564 //
     /*  68213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  68216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhdu),
     /*  68221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68242 */     // (intrinsic_wo_chain:{ *:[i64] } 10746:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (MULHDU:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHDU),
     /*  68245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68247 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68249 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68251 */     GIR_RootConstrainSelectedInstOperands,
     /*  68252 */     // GIR_Coverage, 1564,
     /*  68252 */     GIR_EraseRootFromParent_Done,
     /*  68253 */   // Label 1053: @68253
     /*  68253 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(68295), // Rule ID 1567 //
     /*  68258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpb),
     /*  68263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68284 */     // (intrinsic_wo_chain:{ *:[i64] } 10552:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (CMPB8:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CMPB8),
     /*  68287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  68289 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68291 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68293 */     GIR_RootConstrainSelectedInstOperands,
     /*  68294 */     // GIR_Coverage, 1567,
     /*  68294 */     GIR_EraseRootFromParent_Done,
     /*  68295 */   // Label 1054: @68295
     /*  68295 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(68337), // Rule ID 4874 //
     /*  68300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhw),
     /*  68305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68326 */     // (intrinsic_wo_chain:{ *:[i32] } 10747:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (MULHW:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHW),
     /*  68329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68331 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68333 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68335 */     GIR_RootConstrainSelectedInstOperands,
     /*  68336 */     // GIR_Coverage, 4874,
     /*  68336 */     GIR_EraseRootFromParent_Done,
     /*  68337 */   // Label 1055: @68337
     /*  68337 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(68379), // Rule ID 4875 //
     /*  68342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhwu),
     /*  68347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68368 */     // (intrinsic_wo_chain:{ *:[i32] } 10748:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (MULHWU:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHWU),
     /*  68371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68373 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68375 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68377 */     GIR_RootConstrainSelectedInstOperands,
     /*  68378 */     // GIR_Coverage, 4875,
     /*  68378 */     GIR_EraseRootFromParent_Done,
     /*  68379 */   // Label 1056: @68379
     /*  68379 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(68421), // Rule ID 4876 //
     /*  68384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpb),
     /*  68389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68410 */     // (intrinsic_wo_chain:{ *:[i32] } 10552:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (CMPB:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CMPB),
     /*  68413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  68415 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68417 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68419 */     GIR_RootConstrainSelectedInstOperands,
     /*  68420 */     // GIR_Coverage, 4876,
     /*  68420 */     GIR_EraseRootFromParent_Done,
     /*  68421 */   // Label 1057: @68421
     /*  68421 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(68455), // Rule ID 76 //
     /*  68426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addg6s),
     /*  68431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68444 */     // (intrinsic_wo_chain:{ *:[i32] } 10224:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (ADDG6S:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  68444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDG6S),
     /*  68447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68449 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68451 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68453 */     GIR_RootConstrainSelectedInstOperands,
     /*  68454 */     // GIR_Coverage, 76,
     /*  68454 */     GIR_EraseRootFromParent_Done,
     /*  68455 */   // Label 1058: @68455
     /*  68455 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(68492), // Rule ID 304 //
     /*  68460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddcuw),
     /*  68468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68481 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10268:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDCUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDCUW),
     /*  68484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68486 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68488 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68490 */     GIR_RootConstrainSelectedInstOperands,
     /*  68491 */     // GIR_Coverage, 304,
     /*  68491 */     GIR_EraseRootFromParent_Done,
     /*  68492 */   // Label 1059: @68492
     /*  68492 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(68529), // Rule ID 305 //
     /*  68497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddsbs),
     /*  68505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68518 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10271:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDSBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSBS),
     /*  68521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68523 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68525 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68527 */     GIR_RootConstrainSelectedInstOperands,
     /*  68528 */     // GIR_Coverage, 305,
     /*  68528 */     GIR_EraseRootFromParent_Done,
     /*  68529 */   // Label 1060: @68529
     /*  68529 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(68566), // Rule ID 306 //
     /*  68534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddshs),
     /*  68542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68555 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10272:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSHS),
     /*  68558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68560 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68562 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68564 */     GIR_RootConstrainSelectedInstOperands,
     /*  68565 */     // GIR_Coverage, 306,
     /*  68565 */     GIR_EraseRootFromParent_Done,
     /*  68566 */   // Label 1061: @68566
     /*  68566 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(68603), // Rule ID 307 //
     /*  68571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddsws),
     /*  68579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68592 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10273:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSWS),
     /*  68595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68597 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68599 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68601 */     GIR_RootConstrainSelectedInstOperands,
     /*  68602 */     // GIR_Coverage, 307,
     /*  68602 */     GIR_EraseRootFromParent_Done,
     /*  68603 */   // Label 1062: @68603
     /*  68603 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(68640), // Rule ID 308 //
     /*  68608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddubs),
     /*  68616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68629 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10274:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDUBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUBS),
     /*  68632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68634 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68636 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68638 */     GIR_RootConstrainSelectedInstOperands,
     /*  68639 */     // GIR_Coverage, 308,
     /*  68639 */     GIR_EraseRootFromParent_Done,
     /*  68640 */   // Label 1063: @68640
     /*  68640 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(68677), // Rule ID 309 //
     /*  68645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vadduhs),
     /*  68653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68666 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10275:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDUHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUHS),
     /*  68669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68671 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68673 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68675 */     GIR_RootConstrainSelectedInstOperands,
     /*  68676 */     // GIR_Coverage, 309,
     /*  68676 */     GIR_EraseRootFromParent_Done,
     /*  68677 */   // Label 1064: @68677
     /*  68677 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(68714), // Rule ID 310 //
     /*  68682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vadduws),
     /*  68690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68703 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10276:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDUWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUWS),
     /*  68706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68708 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68710 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68712 */     GIR_RootConstrainSelectedInstOperands,
     /*  68713 */     // GIR_Coverage, 310,
     /*  68713 */     GIR_EraseRootFromParent_Done,
     /*  68714 */   // Label 1065: @68714
     /*  68714 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(68751), // Rule ID 323 //
     /*  68719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsb),
     /*  68727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68740 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10277:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VAVGSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSB),
     /*  68743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68745 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68747 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68749 */     GIR_RootConstrainSelectedInstOperands,
     /*  68750 */     // GIR_Coverage, 323,
     /*  68750 */     GIR_EraseRootFromParent_Done,
     /*  68751 */   // Label 1066: @68751
     /*  68751 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(68788), // Rule ID 324 //
     /*  68756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsh),
     /*  68764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68777 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10278:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VAVGSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSH),
     /*  68780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68782 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68784 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68786 */     GIR_RootConstrainSelectedInstOperands,
     /*  68787 */     // GIR_Coverage, 324,
     /*  68787 */     GIR_EraseRootFromParent_Done,
     /*  68788 */   // Label 1067: @68788
     /*  68788 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(68825), // Rule ID 325 //
     /*  68793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsw),
     /*  68801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68814 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10279:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAVGSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSW),
     /*  68817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68819 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68821 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68823 */     GIR_RootConstrainSelectedInstOperands,
     /*  68824 */     // GIR_Coverage, 325,
     /*  68824 */     GIR_EraseRootFromParent_Done,
     /*  68825 */   // Label 1068: @68825
     /*  68825 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(68862), // Rule ID 326 //
     /*  68830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgub),
     /*  68838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68851 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10280:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VAVGUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUB),
     /*  68854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68856 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68858 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68860 */     GIR_RootConstrainSelectedInstOperands,
     /*  68861 */     // GIR_Coverage, 326,
     /*  68861 */     GIR_EraseRootFromParent_Done,
     /*  68862 */   // Label 1069: @68862
     /*  68862 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(68899), // Rule ID 327 //
     /*  68867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavguh),
     /*  68875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68888 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10281:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VAVGUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUH),
     /*  68891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68893 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68895 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68897 */     GIR_RootConstrainSelectedInstOperands,
     /*  68898 */     // GIR_Coverage, 327,
     /*  68898 */     GIR_EraseRootFromParent_Done,
     /*  68899 */   // Label 1070: @68899
     /*  68899 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(68936), // Rule ID 328 //
     /*  68904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavguw),
     /*  68912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68925 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10282:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAVGUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUW),
     /*  68928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68930 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68932 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68934 */     GIR_RootConstrainSelectedInstOperands,
     /*  68935 */     // GIR_Coverage, 328,
     /*  68935 */     GIR_EraseRootFromParent_Done,
     /*  68936 */   // Label 1071: @68936
     /*  68936 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(68973), // Rule ID 329 //
     /*  68941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxfp),
     /*  68949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68962 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10401:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VMAXFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  68962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXFP),
     /*  68965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68967 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68969 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68971 */     GIR_RootConstrainSelectedInstOperands,
     /*  68972 */     // GIR_Coverage, 329,
     /*  68972 */     GIR_EraseRootFromParent_Done,
     /*  68973 */   // Label 1072: @68973
     /*  68973 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(69010), // Rule ID 330 //
     /*  68978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsb),
     /*  68986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68999 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10402:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMAXSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSB),
     /*  69002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69004 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69006 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69008 */     GIR_RootConstrainSelectedInstOperands,
     /*  69009 */     // GIR_Coverage, 330,
     /*  69009 */     GIR_EraseRootFromParent_Done,
     /*  69010 */   // Label 1073: @69010
     /*  69010 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(69047), // Rule ID 331 //
     /*  69015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsh),
     /*  69023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69036 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10404:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMAXSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSH),
     /*  69039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69041 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69043 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69045 */     GIR_RootConstrainSelectedInstOperands,
     /*  69046 */     // GIR_Coverage, 331,
     /*  69046 */     GIR_EraseRootFromParent_Done,
     /*  69047 */   // Label 1074: @69047
     /*  69047 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(69084), // Rule ID 332 //
     /*  69052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsw),
     /*  69060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69073 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10405:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMAXSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSW),
     /*  69076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69078 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69080 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69082 */     GIR_RootConstrainSelectedInstOperands,
     /*  69083 */     // GIR_Coverage, 332,
     /*  69083 */     GIR_EraseRootFromParent_Done,
     /*  69084 */   // Label 1075: @69084
     /*  69084 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(69121), // Rule ID 333 //
     /*  69089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxub),
     /*  69097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69110 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10406:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMAXUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUB),
     /*  69113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69115 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69117 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69119 */     GIR_RootConstrainSelectedInstOperands,
     /*  69120 */     // GIR_Coverage, 333,
     /*  69120 */     GIR_EraseRootFromParent_Done,
     /*  69121 */   // Label 1076: @69121
     /*  69121 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(69158), // Rule ID 334 //
     /*  69126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxuh),
     /*  69134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69147 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10408:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMAXUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUH),
     /*  69150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69152 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69154 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69156 */     GIR_RootConstrainSelectedInstOperands,
     /*  69157 */     // GIR_Coverage, 334,
     /*  69157 */     GIR_EraseRootFromParent_Done,
     /*  69158 */   // Label 1077: @69158
     /*  69158 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(69195), // Rule ID 335 //
     /*  69163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxuw),
     /*  69171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69184 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10409:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMAXUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUW),
     /*  69187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69189 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69191 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69193 */     GIR_RootConstrainSelectedInstOperands,
     /*  69194 */     // GIR_Coverage, 335,
     /*  69194 */     GIR_EraseRootFromParent_Done,
     /*  69195 */   // Label 1078: @69195
     /*  69195 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(69232), // Rule ID 336 //
     /*  69200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminfp),
     /*  69208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69221 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10412:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VMINFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  69221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINFP),
     /*  69224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69226 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69228 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69230 */     GIR_RootConstrainSelectedInstOperands,
     /*  69231 */     // GIR_Coverage, 336,
     /*  69231 */     GIR_EraseRootFromParent_Done,
     /*  69232 */   // Label 1079: @69232
     /*  69232 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(69269), // Rule ID 337 //
     /*  69237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsb),
     /*  69245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69258 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10413:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMINSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSB),
     /*  69261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69263 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69265 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69267 */     GIR_RootConstrainSelectedInstOperands,
     /*  69268 */     // GIR_Coverage, 337,
     /*  69268 */     GIR_EraseRootFromParent_Done,
     /*  69269 */   // Label 1080: @69269
     /*  69269 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(69306), // Rule ID 338 //
     /*  69274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsh),
     /*  69282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69295 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10415:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMINSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSH),
     /*  69298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69300 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69302 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69304 */     GIR_RootConstrainSelectedInstOperands,
     /*  69305 */     // GIR_Coverage, 338,
     /*  69305 */     GIR_EraseRootFromParent_Done,
     /*  69306 */   // Label 1081: @69306
     /*  69306 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(69343), // Rule ID 339 //
     /*  69311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsw),
     /*  69319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69332 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10416:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMINSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSW),
     /*  69335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69337 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69339 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69341 */     GIR_RootConstrainSelectedInstOperands,
     /*  69342 */     // GIR_Coverage, 339,
     /*  69342 */     GIR_EraseRootFromParent_Done,
     /*  69343 */   // Label 1082: @69343
     /*  69343 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(69380), // Rule ID 340 //
     /*  69348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminub),
     /*  69356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69369 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10417:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMINUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUB),
     /*  69372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69374 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69376 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69378 */     GIR_RootConstrainSelectedInstOperands,
     /*  69379 */     // GIR_Coverage, 340,
     /*  69379 */     GIR_EraseRootFromParent_Done,
     /*  69380 */   // Label 1083: @69380
     /*  69380 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(69417), // Rule ID 341 //
     /*  69385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminuh),
     /*  69393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69406 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10419:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMINUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUH),
     /*  69409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69411 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69413 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69415 */     GIR_RootConstrainSelectedInstOperands,
     /*  69416 */     // GIR_Coverage, 341,
     /*  69416 */     GIR_EraseRootFromParent_Done,
     /*  69417 */   // Label 1084: @69417
     /*  69417 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(69454), // Rule ID 342 //
     /*  69422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminuw),
     /*  69430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69443 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10420:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMINUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUW),
     /*  69446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69448 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69450 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69452 */     GIR_RootConstrainSelectedInstOperands,
     /*  69453 */     // GIR_Coverage, 342,
     /*  69453 */     GIR_EraseRootFromParent_Done,
     /*  69454 */   // Label 1085: @69454
     /*  69454 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(69491), // Rule ID 355 //
     /*  69459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesb),
     /*  69467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69480 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10430:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULESB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESB),
     /*  69483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69485 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69487 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69489 */     GIR_RootConstrainSelectedInstOperands,
     /*  69490 */     // GIR_Coverage, 355,
     /*  69490 */     GIR_EraseRootFromParent_Done,
     /*  69491 */   // Label 1086: @69491
     /*  69491 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(69528), // Rule ID 356 //
     /*  69496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesh),
     /*  69504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69517 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10432:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULESH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESH),
     /*  69520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69522 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69524 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69526 */     GIR_RootConstrainSelectedInstOperands,
     /*  69527 */     // GIR_Coverage, 356,
     /*  69527 */     GIR_EraseRootFromParent_Done,
     /*  69528 */   // Label 1087: @69528
     /*  69528 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(69565), // Rule ID 357 //
     /*  69533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleub),
     /*  69541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69554 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10434:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULEUB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUB),
     /*  69557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69559 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69561 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69563 */     GIR_RootConstrainSelectedInstOperands,
     /*  69564 */     // GIR_Coverage, 357,
     /*  69564 */     GIR_EraseRootFromParent_Done,
     /*  69565 */   // Label 1088: @69565
     /*  69565 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(69602), // Rule ID 358 //
     /*  69570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleuh),
     /*  69578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69591 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10436:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULEUH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUH),
     /*  69594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69596 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69598 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69600 */     GIR_RootConstrainSelectedInstOperands,
     /*  69601 */     // GIR_Coverage, 358,
     /*  69601 */     GIR_EraseRootFromParent_Done,
     /*  69602 */   // Label 1089: @69602
     /*  69602 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(69639), // Rule ID 359 //
     /*  69607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosb),
     /*  69615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69628 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10442:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULOSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSB),
     /*  69631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69633 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69635 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69637 */     GIR_RootConstrainSelectedInstOperands,
     /*  69638 */     // GIR_Coverage, 359,
     /*  69638 */     GIR_EraseRootFromParent_Done,
     /*  69639 */   // Label 1090: @69639
     /*  69639 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(69676), // Rule ID 360 //
     /*  69644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosh),
     /*  69652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69665 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10444:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULOSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSH),
     /*  69668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69670 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69672 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69674 */     GIR_RootConstrainSelectedInstOperands,
     /*  69675 */     // GIR_Coverage, 360,
     /*  69675 */     GIR_EraseRootFromParent_Done,
     /*  69676 */   // Label 1091: @69676
     /*  69676 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(69713), // Rule ID 361 //
     /*  69681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuloub),
     /*  69689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69702 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10446:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULOUB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUB),
     /*  69705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69707 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69709 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69711 */     GIR_RootConstrainSelectedInstOperands,
     /*  69712 */     // GIR_Coverage, 361,
     /*  69712 */     GIR_EraseRootFromParent_Done,
     /*  69713 */   // Label 1092: @69713
     /*  69713 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(69750), // Rule ID 362 //
     /*  69718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulouh),
     /*  69726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69739 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10448:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULOUH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUH),
     /*  69742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69744 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69746 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69748 */     GIR_RootConstrainSelectedInstOperands,
     /*  69749 */     // GIR_Coverage, 362,
     /*  69749 */     GIR_EraseRootFromParent_Done,
     /*  69750 */   // Label 1093: @69750
     /*  69750 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(69787), // Rule ID 369 //
     /*  69755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubcuw),
     /*  69763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69776 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10510:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBCUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBCUW),
     /*  69779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69781 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69783 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69785 */     GIR_RootConstrainSelectedInstOperands,
     /*  69786 */     // GIR_Coverage, 369,
     /*  69786 */     GIR_EraseRootFromParent_Done,
     /*  69787 */   // Label 1094: @69787
     /*  69787 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(69824), // Rule ID 374 //
     /*  69792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubsbs),
     /*  69800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69813 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10513:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBSBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSBS),
     /*  69816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69818 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69820 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69822 */     GIR_RootConstrainSelectedInstOperands,
     /*  69823 */     // GIR_Coverage, 374,
     /*  69823 */     GIR_EraseRootFromParent_Done,
     /*  69824 */   // Label 1095: @69824
     /*  69824 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(69861), // Rule ID 375 //
     /*  69829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubshs),
     /*  69837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69850 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10514:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSHS),
     /*  69853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69855 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69857 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69859 */     GIR_RootConstrainSelectedInstOperands,
     /*  69860 */     // GIR_Coverage, 375,
     /*  69860 */     GIR_EraseRootFromParent_Done,
     /*  69861 */   // Label 1096: @69861
     /*  69861 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(69898), // Rule ID 376 //
     /*  69866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubsws),
     /*  69874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69887 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10515:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSWS),
     /*  69890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69892 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69894 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69896 */     GIR_RootConstrainSelectedInstOperands,
     /*  69897 */     // GIR_Coverage, 376,
     /*  69897 */     GIR_EraseRootFromParent_Done,
     /*  69898 */   // Label 1097: @69898
     /*  69898 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(69935), // Rule ID 377 //
     /*  69903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsububs),
     /*  69911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69924 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10516:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBUBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUBS),
     /*  69927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69929 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69931 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69933 */     GIR_RootConstrainSelectedInstOperands,
     /*  69934 */     // GIR_Coverage, 377,
     /*  69934 */     GIR_EraseRootFromParent_Done,
     /*  69935 */   // Label 1098: @69935
     /*  69935 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(69972), // Rule ID 378 //
     /*  69940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubuhs),
     /*  69948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69961 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10517:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBUHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUHS),
     /*  69964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69966 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69968 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69970 */     GIR_RootConstrainSelectedInstOperands,
     /*  69971 */     // GIR_Coverage, 378,
     /*  69971 */     GIR_EraseRootFromParent_Done,
     /*  69972 */   // Label 1099: @69972
     /*  69972 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(70009), // Rule ID 379 //
     /*  69977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubuws),
     /*  69985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69998 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10518:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBUWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUWS),
     /*  70001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70003 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70005 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70007 */     GIR_RootConstrainSelectedInstOperands,
     /*  70008 */     // GIR_Coverage, 379,
     /*  70008 */     GIR_EraseRootFromParent_Done,
     /*  70009 */   // Label 1100: @70009
     /*  70009 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(70046), // Rule ID 388 //
     /*  70014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlb),
     /*  70022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70035 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10472:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLB),
     /*  70038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70040 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70042 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70044 */     GIR_RootConstrainSelectedInstOperands,
     /*  70045 */     // GIR_Coverage, 388,
     /*  70045 */     GIR_EraseRootFromParent_Done,
     /*  70046 */   // Label 1101: @70046
     /*  70046 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(70083), // Rule ID 389 //
     /*  70051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlh),
     /*  70059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70072 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10476:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VRLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLH),
     /*  70075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70077 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70079 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70081 */     GIR_RootConstrainSelectedInstOperands,
     /*  70082 */     // GIR_Coverage, 389,
     /*  70082 */     GIR_EraseRootFromParent_Done,
     /*  70083 */   // Label 1102: @70083
     /*  70083 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(70120), // Rule ID 390 //
     /*  70088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlw),
     /*  70096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70109 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10479:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VRLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLW),
     /*  70112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70114 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70116 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70118 */     GIR_RootConstrainSelectedInstOperands,
     /*  70119 */     // GIR_Coverage, 390,
     /*  70119 */     GIR_EraseRootFromParent_Done,
     /*  70120 */   // Label 1103: @70120
     /*  70120 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(70157), // Rule ID 391 //
     /*  70125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsl),
     /*  70133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70146 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10484:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSL:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSL),
     /*  70149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70151 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70153 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70155 */     GIR_RootConstrainSelectedInstOperands,
     /*  70156 */     // GIR_Coverage, 391,
     /*  70156 */     GIR_EraseRootFromParent_Done,
     /*  70157 */   // Label 1104: @70157
     /*  70157 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(70194), // Rule ID 392 //
     /*  70162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslo),
     /*  70170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70183 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10488:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSLO:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLO),
     /*  70186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70188 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70190 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70192 */     GIR_RootConstrainSelectedInstOperands,
     /*  70193 */     // GIR_Coverage, 392,
     /*  70193 */     GIR_EraseRootFromParent_Done,
     /*  70194 */   // Label 1105: @70194
     /*  70194 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(70231), // Rule ID 393 //
     /*  70199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslb),
     /*  70207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70220 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10485:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLB),
     /*  70223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70225 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70227 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70229 */     GIR_RootConstrainSelectedInstOperands,
     /*  70230 */     // GIR_Coverage, 393,
     /*  70230 */     GIR_EraseRootFromParent_Done,
     /*  70231 */   // Label 1106: @70231
     /*  70231 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(70268), // Rule ID 394 //
     /*  70236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslh),
     /*  70244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70257 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10487:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLH),
     /*  70260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70262 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70264 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70266 */     GIR_RootConstrainSelectedInstOperands,
     /*  70267 */     // GIR_Coverage, 394,
     /*  70267 */     GIR_EraseRootFromParent_Done,
     /*  70268 */   // Label 1107: @70268
     /*  70268 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(70305), // Rule ID 395 //
     /*  70273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslw),
     /*  70281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70294 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10490:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /*  70297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70299 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70301 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70303 */     GIR_RootConstrainSelectedInstOperands,
     /*  70304 */     // GIR_Coverage, 395,
     /*  70304 */     GIR_EraseRootFromParent_Done,
     /*  70305 */   // Label 1108: @70305
     /*  70305 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(70342), // Rule ID 399 //
     /*  70310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsr),
     /*  70318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70331 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10491:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSR),
     /*  70334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70336 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70338 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70340 */     GIR_RootConstrainSelectedInstOperands,
     /*  70341 */     // GIR_Coverage, 399,
     /*  70341 */     GIR_EraseRootFromParent_Done,
     /*  70342 */   // Label 1109: @70342
     /*  70342 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(70379), // Rule ID 400 //
     /*  70347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsro),
     /*  70355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70368 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10498:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRO:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRO),
     /*  70371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70373 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70375 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70377 */     GIR_RootConstrainSelectedInstOperands,
     /*  70378 */     // GIR_Coverage, 400,
     /*  70378 */     GIR_EraseRootFromParent_Done,
     /*  70379 */   // Label 1110: @70379
     /*  70379 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(70416), // Rule ID 401 //
     /*  70384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrab),
     /*  70392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70405 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10492:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRAB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAB),
     /*  70408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70410 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70412 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70414 */     GIR_RootConstrainSelectedInstOperands,
     /*  70415 */     // GIR_Coverage, 401,
     /*  70415 */     GIR_EraseRootFromParent_Done,
     /*  70416 */   // Label 1111: @70416
     /*  70416 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(70453), // Rule ID 402 //
     /*  70421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrah),
     /*  70429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70442 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10493:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSRAH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAH),
     /*  70445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70447 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70449 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70451 */     GIR_RootConstrainSelectedInstOperands,
     /*  70452 */     // GIR_Coverage, 402,
     /*  70452 */     GIR_EraseRootFromParent_Done,
     /*  70453 */   // Label 1112: @70453
     /*  70453 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(70490), // Rule ID 403 //
     /*  70458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsraw),
     /*  70466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70479 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10494:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRAW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAW),
     /*  70482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70484 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70486 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70488 */     GIR_RootConstrainSelectedInstOperands,
     /*  70489 */     // GIR_Coverage, 403,
     /*  70489 */     GIR_EraseRootFromParent_Done,
     /*  70490 */   // Label 1113: @70490
     /*  70490 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(70527), // Rule ID 404 //
     /*  70495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrb),
     /*  70503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70516 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10495:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRB),
     /*  70519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70521 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70523 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70525 */     GIR_RootConstrainSelectedInstOperands,
     /*  70526 */     // GIR_Coverage, 404,
     /*  70526 */     GIR_EraseRootFromParent_Done,
     /*  70527 */   // Label 1114: @70527
     /*  70527 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(70564), // Rule ID 405 //
     /*  70532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrh),
     /*  70540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70553 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10497:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSRH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRH),
     /*  70556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70558 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70560 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70562 */     GIR_RootConstrainSelectedInstOperands,
     /*  70563 */     // GIR_Coverage, 405,
     /*  70563 */     GIR_EraseRootFromParent_Done,
     /*  70564 */   // Label 1115: @70564
     /*  70564 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(70601), // Rule ID 406 //
     /*  70569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrw),
     /*  70577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70590 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10500:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRW),
     /*  70593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70595 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70597 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70599 */     GIR_RootConstrainSelectedInstOperands,
     /*  70600 */     // GIR_Coverage, 406,
     /*  70600 */     GIR_EraseRootFromParent_Done,
     /*  70601 */   // Label 1116: @70601
     /*  70601 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(70638), // Rule ID 410 //
     /*  70606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkpx),
     /*  70614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70627 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10454:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKPX:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKPX),
     /*  70630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70632 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70634 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70636 */     GIR_RootConstrainSelectedInstOperands,
     /*  70637 */     // GIR_Coverage, 410,
     /*  70637 */     GIR_EraseRootFromParent_Done,
     /*  70638 */   // Label 1117: @70638
     /*  70638 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(70675), // Rule ID 457 //
     /*  70643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesw),
     /*  70651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70664 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10433:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULESW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESW),
     /*  70667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70669 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70671 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70673 */     GIR_RootConstrainSelectedInstOperands,
     /*  70674 */     // GIR_Coverage, 457,
     /*  70674 */     GIR_EraseRootFromParent_Done,
     /*  70675 */   // Label 1118: @70675
     /*  70675 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(70712), // Rule ID 458 //
     /*  70680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleuw),
     /*  70688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70701 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10437:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULEUW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUW),
     /*  70704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70706 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70708 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70710 */     GIR_RootConstrainSelectedInstOperands,
     /*  70711 */     // GIR_Coverage, 458,
     /*  70711 */     GIR_EraseRootFromParent_Done,
     /*  70712 */   // Label 1119: @70712
     /*  70712 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(70749), // Rule ID 459 //
     /*  70717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosw),
     /*  70725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70738 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10445:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULOSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSW),
     /*  70741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70743 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70745 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70747 */     GIR_RootConstrainSelectedInstOperands,
     /*  70748 */     // GIR_Coverage, 459,
     /*  70748 */     GIR_EraseRootFromParent_Done,
     /*  70749 */   // Label 1120: @70749
     /*  70749 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(70786), // Rule ID 460 //
     /*  70754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulouw),
     /*  70762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70775 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10449:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULOUW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUW),
     /*  70778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70780 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70782 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70784 */     GIR_RootConstrainSelectedInstOperands,
     /*  70785 */     // GIR_Coverage, 460,
     /*  70785 */     GIR_EraseRootFromParent_Done,
     /*  70786 */   // Label 1121: @70786
     /*  70786 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(70823), // Rule ID 462 //
     /*  70791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsd),
     /*  70799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70812 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10403:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMAXSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSD),
     /*  70815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70817 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70819 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70821 */     GIR_RootConstrainSelectedInstOperands,
     /*  70822 */     // GIR_Coverage, 462,
     /*  70822 */     GIR_EraseRootFromParent_Done,
     /*  70823 */   // Label 1122: @70823
     /*  70823 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(70860), // Rule ID 463 //
     /*  70828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxud),
     /*  70836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70849 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10407:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMAXUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUD),
     /*  70852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70854 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70856 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70858 */     GIR_RootConstrainSelectedInstOperands,
     /*  70859 */     // GIR_Coverage, 463,
     /*  70859 */     GIR_EraseRootFromParent_Done,
     /*  70860 */   // Label 1123: @70860
     /*  70860 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(70897), // Rule ID 464 //
     /*  70865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsd),
     /*  70873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70886 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10414:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMINSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSD),
     /*  70889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70891 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70893 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70895 */     GIR_RootConstrainSelectedInstOperands,
     /*  70896 */     // GIR_Coverage, 464,
     /*  70896 */     GIR_EraseRootFromParent_Done,
     /*  70897 */   // Label 1124: @70897
     /*  70897 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(70934), // Rule ID 465 //
     /*  70902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminud),
     /*  70910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70923 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10418:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMINUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUD),
     /*  70926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70928 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70930 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70932 */     GIR_RootConstrainSelectedInstOperands,
     /*  70933 */     // GIR_Coverage, 465,
     /*  70933 */     GIR_EraseRootFromParent_Done,
     /*  70934 */   // Label 1125: @70934
     /*  70934 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(70971), // Rule ID 468 //
     /*  70939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrld),
     /*  70947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70960 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10473:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VRLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLD),
     /*  70963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70965 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70967 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70969 */     GIR_RootConstrainSelectedInstOperands,
     /*  70970 */     // GIR_Coverage, 468,
     /*  70970 */     GIR_EraseRootFromParent_Done,
     /*  70971 */   // Label 1126: @70971
     /*  70971 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(71008), // Rule ID 472 //
     /*  70976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddcuq),
     /*  70984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  70987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  70990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  70993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70997 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10267:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VADDCUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  70997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDCUQ),
     /*  71000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71002 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71004 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71006 */     GIR_RootConstrainSelectedInstOperands,
     /*  71007 */     // GIR_Coverage, 472,
     /*  71007 */     GIR_EraseRootFromParent_Done,
     /*  71008 */   // Label 1127: @71008
     /*  71008 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(71045), // Rule ID 477 //
     /*  71013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubcuq),
     /*  71021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  71024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  71027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  71030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71034 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10509:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VSUBCUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  71034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBCUQ),
     /*  71037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71039 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71041 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71043 */     GIR_RootConstrainSelectedInstOperands,
     /*  71044 */     // GIR_Coverage, 477,
     /*  71044 */     GIR_EraseRootFromParent_Done,
     /*  71045 */   // Label 1128: @71045
     /*  71045 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(71082), // Rule ID 496 //
     /*  71050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumb),
     /*  71058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71071 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10232:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VPMSUMB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMB),
     /*  71074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71076 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71078 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71080 */     GIR_RootConstrainSelectedInstOperands,
     /*  71081 */     // GIR_Coverage, 496,
     /*  71081 */     GIR_EraseRootFromParent_Done,
     /*  71082 */   // Label 1129: @71082
     /*  71082 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(71119), // Rule ID 497 //
     /*  71087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumh),
     /*  71095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71108 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10234:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPMSUMH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  71108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMH),
     /*  71111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71113 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71115 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71117 */     GIR_RootConstrainSelectedInstOperands,
     /*  71118 */     // GIR_Coverage, 497,
     /*  71118 */     GIR_EraseRootFromParent_Done,
     /*  71119 */   // Label 1130: @71119
     /*  71119 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(71156), // Rule ID 498 //
     /*  71124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumw),
     /*  71132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71145 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10235:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPMSUMW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMW),
     /*  71148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71150 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71152 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71154 */     GIR_RootConstrainSelectedInstOperands,
     /*  71155 */     // GIR_Coverage, 498,
     /*  71155 */     GIR_EraseRootFromParent_Done,
     /*  71156 */   // Label 1131: @71156
     /*  71156 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(71193), // Rule ID 499 //
     /*  71161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumd),
     /*  71169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71182 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10233:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPMSUMD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMD),
     /*  71185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71187 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71189 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71191 */     GIR_RootConstrainSelectedInstOperands,
     /*  71192 */     // GIR_Coverage, 499,
     /*  71192 */     GIR_EraseRootFromParent_Done,
     /*  71193 */   // Label 1132: @71193
     /*  71193 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(71230), // Rule ID 507 //
     /*  71198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vbpermq),
     /*  71206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71219 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10284:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VBPERMQ:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VBPERMQ),
     /*  71222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71224 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71226 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71228 */     GIR_RootConstrainSelectedInstOperands,
     /*  71229 */     // GIR_Coverage, 507,
     /*  71229 */     GIR_EraseRootFromParent_Done,
     /*  71230 */   // Label 1133: @71230
     /*  71230 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(71267), // Rule ID 510 //
     /*  71235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vcipher),
     /*  71243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71256 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10226:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCIPHER:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCIPHER),
     /*  71259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71261 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71263 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71265 */     GIR_RootConstrainSelectedInstOperands,
     /*  71266 */     // GIR_Coverage, 510,
     /*  71266 */     GIR_EraseRootFromParent_Done,
     /*  71267 */   // Label 1134: @71267
     /*  71267 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(71304), // Rule ID 511 //
     /*  71272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vcipherlast),
     /*  71280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71293 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10227:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCIPHERLAST:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCIPHERLAST),
     /*  71296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71298 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71300 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71302 */     GIR_RootConstrainSelectedInstOperands,
     /*  71303 */     // GIR_Coverage, 511,
     /*  71303 */     GIR_EraseRootFromParent_Done,
     /*  71304 */   // Label 1135: @71304
     /*  71304 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(71341), // Rule ID 512 //
     /*  71309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vncipher),
     /*  71317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71330 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10228:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VNCIPHER:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNCIPHER),
     /*  71333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71335 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71337 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71339 */     GIR_RootConstrainSelectedInstOperands,
     /*  71340 */     // GIR_Coverage, 512,
     /*  71340 */     GIR_EraseRootFromParent_Done,
     /*  71341 */   // Label 1136: @71341
     /*  71341 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(71378), // Rule ID 513 //
     /*  71346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vncipherlast),
     /*  71354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71367 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10229:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VNCIPHERLAST:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNCIPHERLAST),
     /*  71370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71372 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71374 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71376 */     GIR_RootConstrainSelectedInstOperands,
     /*  71377 */     // GIR_Coverage, 513,
     /*  71377 */     GIR_EraseRootFromParent_Done,
     /*  71378 */   // Label 1137: @71378
     /*  71378 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(71415), // Rule ID 546 //
     /*  71383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vbpermd),
     /*  71391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71404 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10283:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VBPERMD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VBPERMD),
     /*  71407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71409 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71411 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71413 */     GIR_RootConstrainSelectedInstOperands,
     /*  71414 */     // GIR_Coverage, 546,
     /*  71414 */     GIR_EraseRootFromParent_Done,
     /*  71415 */   // Label 1138: @71415
     /*  71415 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(71452), // Rule ID 547 //
     /*  71420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlwnm),
     /*  71428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71441 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10481:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VRLWNM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLWNM),
     /*  71444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71446 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71448 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71450 */     GIR_RootConstrainSelectedInstOperands,
     /*  71451 */     // GIR_Coverage, 547,
     /*  71451 */     GIR_EraseRootFromParent_Done,
     /*  71452 */   // Label 1139: @71452
     /*  71452 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(71489), // Rule ID 549 //
     /*  71457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrldnm),
     /*  71465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71478 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10475:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VRLDNM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLDNM),
     /*  71481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71483 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71485 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71487 */     GIR_RootConstrainSelectedInstOperands,
     /*  71488 */     // GIR_Coverage, 549,
     /*  71488 */     GIR_EraseRootFromParent_Done,
     /*  71489 */   // Label 1140: @71489
     /*  71489 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(71526), // Rule ID 551 //
     /*  71494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslv),
     /*  71502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71515 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10489:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSLV:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLV),
     /*  71518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71520 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71522 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71524 */     GIR_RootConstrainSelectedInstOperands,
     /*  71525 */     // GIR_Coverage, 551,
     /*  71525 */     GIR_EraseRootFromParent_Done,
     /*  71526 */   // Label 1141: @71526
     /*  71526 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(71563), // Rule ID 552 //
     /*  71531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrv),
     /*  71539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71552 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10499:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRV:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRV),
     /*  71555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71557 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71559 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71561 */     GIR_RootConstrainSelectedInstOperands,
     /*  71562 */     // GIR_Coverage, 552,
     /*  71562 */     GIR_EraseRootFromParent_Done,
     /*  71563 */   // Label 1142: @71563
     /*  71563 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(71600), // Rule ID 553 //
     /*  71568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsdub),
     /*  71576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71589 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10264:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VABSDUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUB),
     /*  71592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71594 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71596 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71598 */     GIR_RootConstrainSelectedInstOperands,
     /*  71599 */     // GIR_Coverage, 553,
     /*  71599 */     GIR_EraseRootFromParent_Done,
     /*  71600 */   // Label 1143: @71600
     /*  71600 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(71637), // Rule ID 554 //
     /*  71605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsduh),
     /*  71613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71626 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10265:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VABSDUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  71626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUH),
     /*  71629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71631 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71633 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71635 */     GIR_RootConstrainSelectedInstOperands,
     /*  71636 */     // GIR_Coverage, 554,
     /*  71636 */     GIR_EraseRootFromParent_Done,
     /*  71637 */   // Label 1144: @71637
     /*  71637 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(71674), // Rule ID 555 //
     /*  71642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsduw),
     /*  71650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71663 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10266:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VABSDUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUW),
     /*  71666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71668 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71670 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71672 */     GIR_RootConstrainSelectedInstOperands,
     /*  71673 */     // GIR_Coverage, 555,
     /*  71673 */     GIR_EraseRootFromParent_Done,
     /*  71674 */   // Label 1145: @71674
     /*  71674 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(71708), // Rule ID 692 //
     /*  71679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addg6sd),
     /*  71684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71697 */     // (intrinsic_wo_chain:{ *:[i64] } 10225:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (ADDG6S8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*  71697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDG6S8),
     /*  71700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  71702 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  71704 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71706 */     GIR_RootConstrainSelectedInstOperands,
     /*  71707 */     // GIR_Coverage, 692,
     /*  71707 */     GIR_EraseRootFromParent_Done,
     /*  71708 */   // Label 1146: @71708
     /*  71708 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(71745), // Rule ID 1106 //
     /*  71713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpdepd),
     /*  71721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71734 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10451:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPDEPD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPDEPD),
     /*  71737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71739 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71741 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71743 */     GIR_RootConstrainSelectedInstOperands,
     /*  71744 */     // GIR_Coverage, 1106,
     /*  71744 */     GIR_EraseRootFromParent_Done,
     /*  71745 */   // Label 1147: @71745
     /*  71745 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71782), // Rule ID 1107 //
     /*  71750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpextd),
     /*  71758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71771 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10453:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPEXTD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPEXTD),
     /*  71774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71776 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71778 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71780 */     GIR_RootConstrainSelectedInstOperands,
     /*  71781 */     // GIR_Coverage, 1107,
     /*  71781 */     GIR_EraseRootFromParent_Done,
     /*  71782 */   // Label 1148: @71782
     /*  71782 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(71819), // Rule ID 1108 //
     /*  71787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_pdepd),
     /*  71795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71808 */     // (intrinsic_wo_chain:{ *:[i64] } 10750:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (PDEPD:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  71808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PDEPD),
     /*  71811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  71813 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  71815 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71817 */     GIR_RootConstrainSelectedInstOperands,
     /*  71818 */     // GIR_Coverage, 1108,
     /*  71818 */     GIR_EraseRootFromParent_Done,
     /*  71819 */   // Label 1149: @71819
     /*  71819 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(71856), // Rule ID 1109 //
     /*  71824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_pextd),
     /*  71832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71845 */     // (intrinsic_wo_chain:{ *:[i64] } 10751:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (PEXTD:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  71845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PEXTD),
     /*  71848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  71850 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  71852 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71854 */     GIR_RootConstrainSelectedInstOperands,
     /*  71855 */     // GIR_Coverage, 1109,
     /*  71855 */     GIR_EraseRootFromParent_Done,
     /*  71856 */   // Label 1150: @71856
     /*  71856 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(71893), // Rule ID 1110 //
     /*  71861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfuged),
     /*  71869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71882 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10286:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCFUGED:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUGED),
     /*  71885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71887 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71889 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71891 */     GIR_RootConstrainSelectedInstOperands,
     /*  71892 */     // GIR_Coverage, 1110,
     /*  71892 */     GIR_EraseRootFromParent_Done,
     /*  71893 */   // Label 1151: @71893
     /*  71893 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(71930), // Rule ID 1112 //
     /*  71898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cfuged),
     /*  71906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71919 */     // (intrinsic_wo_chain:{ *:[i64] } 10551:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CFUGED:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  71919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CFUGED),
     /*  71922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  71924 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  71926 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71928 */     GIR_RootConstrainSelectedInstOperands,
     /*  71929 */     // GIR_Coverage, 1112,
     /*  71929 */     GIR_EraseRootFromParent_Done,
     /*  71930 */   // Label 1152: @71930
     /*  71930 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71967), // Rule ID 1114 //
     /*  71935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclzdm),
     /*  71943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71956 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10290:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCLZDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLZDM),
     /*  71959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71961 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71963 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71965 */     GIR_RootConstrainSelectedInstOperands,
     /*  71966 */     // GIR_Coverage, 1114,
     /*  71966 */     GIR_EraseRootFromParent_Done,
     /*  71967 */   // Label 1153: @71967
     /*  71967 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(72004), // Rule ID 1115 //
     /*  71972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctzdm),
     /*  71980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71993 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10348:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCTZDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTZDM),
     /*  71996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71998 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72000 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72002 */     GIR_RootConstrainSelectedInstOperands,
     /*  72003 */     // GIR_Coverage, 1115,
     /*  72003 */     GIR_EraseRootFromParent_Done,
     /*  72004 */   // Label 1154: @72004
     /*  72004 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(72041), // Rule ID 1116 //
     /*  72009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cntlzdm),
     /*  72017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72030 */     // (intrinsic_wo_chain:{ *:[i64] } 10556:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CNTLZDM:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CNTLZDM),
     /*  72033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72035 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72037 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72039 */     GIR_RootConstrainSelectedInstOperands,
     /*  72040 */     // GIR_Coverage, 1116,
     /*  72040 */     GIR_EraseRootFromParent_Done,
     /*  72041 */   // Label 1155: @72041
     /*  72041 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(72078), // Rule ID 1117 //
     /*  72046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cnttzdm),
     /*  72054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72067 */     // (intrinsic_wo_chain:{ *:[i64] } 10557:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CNTTZDM:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CNTTZDM),
     /*  72070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72072 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72074 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72076 */     GIR_RootConstrainSelectedInstOperands,
     /*  72077 */     // GIR_Coverage, 1117,
     /*  72077 */     GIR_EraseRootFromParent_Done,
     /*  72078 */   // Label 1156: @72078
     /*  72078 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(72115), // Rule ID 1118 //
     /*  72083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclrlb),
     /*  72091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72104 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10288:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VCLRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)
     /*  72104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLRLB),
     /*  72107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72109 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72111 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72113 */     GIR_RootConstrainSelectedInstOperands,
     /*  72114 */     // GIR_Coverage, 1118,
     /*  72114 */     GIR_EraseRootFromParent_Done,
     /*  72115 */   // Label 1157: @72115
     /*  72115 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(72152), // Rule ID 1119 //
     /*  72120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclrrb),
     /*  72128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72141 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10289:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VCLRRB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)
     /*  72141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLRRB),
     /*  72144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72146 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72148 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72150 */     GIR_RootConstrainSelectedInstOperands,
     /*  72151 */     // GIR_Coverage, 1119,
     /*  72151 */     GIR_EraseRootFromParent_Done,
     /*  72152 */   // Label 1158: @72152
     /*  72152 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(72189), // Rule ID 1133 //
     /*  72157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesw),
     /*  72165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72178 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10352:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVESW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  72178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESW),
     /*  72181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72183 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72185 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72187 */     GIR_RootConstrainSelectedInstOperands,
     /*  72188 */     // GIR_Coverage, 1133,
     /*  72188 */     GIR_EraseRootFromParent_Done,
     /*  72189 */   // Label 1159: @72189
     /*  72189 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(72226), // Rule ID 1134 //
     /*  72194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveuw),
     /*  72202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72215 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10355:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVEUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  72215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUW),
     /*  72218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72220 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72222 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72224 */     GIR_RootConstrainSelectedInstOperands,
     /*  72225 */     // GIR_Coverage, 1134,
     /*  72225 */     GIR_EraseRootFromParent_Done,
     /*  72226 */   // Label 1160: @72226
     /*  72226 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(72263), // Rule ID 1135 //
     /*  72231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesd),
     /*  72239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72252 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10350:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVESD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESD),
     /*  72255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72257 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72259 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72261 */     GIR_RootConstrainSelectedInstOperands,
     /*  72262 */     // GIR_Coverage, 1135,
     /*  72262 */     GIR_EraseRootFromParent_Done,
     /*  72263 */   // Label 1161: @72263
     /*  72263 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(72300), // Rule ID 1136 //
     /*  72268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveud),
     /*  72276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72289 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10353:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVEUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUD),
     /*  72292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72294 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72296 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72298 */     GIR_RootConstrainSelectedInstOperands,
     /*  72299 */     // GIR_Coverage, 1136,
     /*  72299 */     GIR_EraseRootFromParent_Done,
     /*  72300 */   // Label 1162: @72300
     /*  72300 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(72337), // Rule ID 1139 //
     /*  72305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesd),
     /*  72313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72326 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10431:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULESD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESD),
     /*  72329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72331 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72333 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72335 */     GIR_RootConstrainSelectedInstOperands,
     /*  72336 */     // GIR_Coverage, 1139,
     /*  72336 */     GIR_EraseRootFromParent_Done,
     /*  72337 */   // Label 1163: @72337
     /*  72337 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72374), // Rule ID 1140 //
     /*  72342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleud),
     /*  72350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72363 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10435:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULEUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUD),
     /*  72366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72368 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72370 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72372 */     GIR_RootConstrainSelectedInstOperands,
     /*  72373 */     // GIR_Coverage, 1140,
     /*  72373 */     GIR_EraseRootFromParent_Done,
     /*  72374 */   // Label 1164: @72374
     /*  72374 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(72411), // Rule ID 1141 //
     /*  72379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosd),
     /*  72387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72400 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10443:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULOSD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSD),
     /*  72403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72405 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72407 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72409 */     GIR_RootConstrainSelectedInstOperands,
     /*  72410 */     // GIR_Coverage, 1141,
     /*  72410 */     GIR_EraseRootFromParent_Done,
     /*  72411 */   // Label 1165: @72411
     /*  72411 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(72448), // Rule ID 1142 //
     /*  72416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuloud),
     /*  72424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72437 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10447:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULOUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUD),
     /*  72440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72442 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72444 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72446 */     GIR_RootConstrainSelectedInstOperands,
     /*  72447 */     // GIR_Coverage, 1142,
     /*  72447 */     GIR_EraseRootFromParent_Done,
     /*  72448 */   // Label 1166: @72448
     /*  72448 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(72485), // Rule ID 1146 //
     /*  72453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesq),
     /*  72461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72474 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10351:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVESQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESQ),
     /*  72477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72479 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72481 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72483 */     GIR_RootConstrainSelectedInstOperands,
     /*  72484 */     // GIR_Coverage, 1146,
     /*  72484 */     GIR_EraseRootFromParent_Done,
     /*  72485 */   // Label 1167: @72485
     /*  72485 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(72522), // Rule ID 1147 //
     /*  72490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveuq),
     /*  72498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72511 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10354:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVEUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUQ),
     /*  72514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72516 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72518 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72520 */     GIR_RootConstrainSelectedInstOperands,
     /*  72521 */     // GIR_Coverage, 1147,
     /*  72521 */     GIR_EraseRootFromParent_Done,
     /*  72522 */   // Label 1168: @72522
     /*  72522 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72559), // Rule ID 1157 //
     /*  72527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlqnm),
     /*  72535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72548 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10478:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VRLQNM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLQNM),
     /*  72551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72553 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72555 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72557 */     GIR_RootConstrainSelectedInstOperands,
     /*  72558 */     // GIR_Coverage, 1157,
     /*  72558 */     GIR_EraseRootFromParent_Done,
     /*  72559 */   // Label 1169: @72559
     /*  72559 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72596), // Rule ID 1162 //
     /*  72564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  72567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxor),
     /*  72572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  72575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  72578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v1024s1,
     /*  72581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  72585 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10646:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB)  =>  (DMXOR:{ *:[v1024i1] } v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB)
     /*  72585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXOR),
     /*  72588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72590 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  72592 */     GIR_RootToRootCopy, /*OpIdx*/3, // AB
     /*  72594 */     GIR_RootConstrainSelectedInstOperands,
     /*  72595 */     // GIR_Coverage, 1162,
     /*  72595 */     GIR_EraseRootFromParent_Done,
     /*  72596 */   // Label 1170: @72596
     /*  72596 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72653), // Rule ID 2904 //
     /*  72601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_PairedVectorMemops),
     /*  72604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_assemble_pair),
     /*  72609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v256s1,
     /*  72612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRpRCRegClassID),
     /*  72622 */     // (intrinsic_wo_chain:{ *:[v256i1] } 10799:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vs1, v16i8:{ *:[v16i8] }:$vs0)  =>  (REG_SEQUENCE:{ *:[v256i1] } VSRpRC:{ *:[i32] }, ?:{ *:[v16i8] }:$vs0, sub_vsx1:{ *:[i32] }, ?:{ *:[v16i8] }:$vs1, sub_vsx0:{ *:[i32] })
     /*  72622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  72625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72627 */     GIR_RootToRootCopy, /*OpIdx*/3, // vs0
     /*  72629 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/22,
     /*  72632 */     GIR_RootToRootCopy, /*OpIdx*/2, // vs1
     /*  72634 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/21,
     /*  72637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRpRCRegClassID),
     /*  72642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72652 */     // GIR_Coverage, 2904,
     /*  72652 */     GIR_EraseRootFromParent_Done,
     /*  72653 */   // Label 1171: @72653
     /*  72653 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72690), // Rule ID 3339 //
     /*  72658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhsw),
     /*  72666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72679 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10439:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VMULHSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /*  72679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHSW),
     /*  72682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72684 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72686 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72688 */     GIR_RootConstrainSelectedInstOperands,
     /*  72689 */     // GIR_Coverage, 3339,
     /*  72689 */     GIR_EraseRootFromParent_Done,
     /*  72690 */   // Label 1172: @72690
     /*  72690 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72727), // Rule ID 3340 //
     /*  72695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhuw),
     /*  72703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72716 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10441:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VMULHUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /*  72716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHUW),
     /*  72719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72721 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72723 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72725 */     GIR_RootConstrainSelectedInstOperands,
     /*  72726 */     // GIR_Coverage, 3340,
     /*  72726 */     GIR_EraseRootFromParent_Done,
     /*  72727 */   // Label 1173: @72727
     /*  72727 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72764), // Rule ID 3341 //
     /*  72732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhsd),
     /*  72740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72753 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10438:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VMULHSD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /*  72753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHSD),
     /*  72756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72758 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72760 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72762 */     GIR_RootConstrainSelectedInstOperands,
     /*  72763 */     // GIR_Coverage, 3341,
     /*  72763 */     GIR_EraseRootFromParent_Done,
     /*  72764 */   // Label 1174: @72764
     /*  72764 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72801), // Rule ID 3342 //
     /*  72769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhud),
     /*  72777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72790 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10440:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VMULHUD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /*  72790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHUD),
     /*  72793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72795 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72797 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72799 */     GIR_RootConstrainSelectedInstOperands,
     /*  72800 */     // GIR_Coverage, 3342,
     /*  72800 */     GIR_EraseRootFromParent_Done,
     /*  72801 */   // Label 1175: @72801
     /*  72801 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72860), // Rule ID 3509 //
     /*  72806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  72809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvi8gerx4),
     /*  72814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  72817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  72820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  72827 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10657:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVI8GERX4:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  72827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  72830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72839 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  72843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVI8GERX4),
     /*  72851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72853 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  72855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  72858 */     GIR_RootConstrainSelectedInstOperands,
     /*  72859 */     // GIR_Coverage, 3509,
     /*  72859 */     GIR_EraseRootFromParent_Done,
     /*  72860 */   // Label 1176: @72860
     /*  72860 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72919), // Rule ID 3512 //
     /*  72865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  72868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2),
     /*  72873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  72876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  72879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  72886 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10647:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  72886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  72889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  72902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2),
     /*  72910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72912 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  72914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  72917 */     GIR_RootConstrainSelectedInstOperands,
     /*  72918 */     // GIR_Coverage, 3512,
     /*  72918 */     GIR_EraseRootFromParent_Done,
     /*  72919 */   // Label 1177: @72919
     /*  72919 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72978), // Rule ID 3517 //
     /*  72924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  72927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2),
     /*  72932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  72935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  72938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  72945 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10652:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  72945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  72948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72957 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  72961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2),
     /*  72969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72971 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  72973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  72976 */     GIR_RootConstrainSelectedInstOperands,
     /*  72977 */     // GIR_Coverage, 3517,
     /*  72977 */     GIR_EraseRootFromParent_Done,
     /*  72978 */   // Label 1178: @72978
     /*  72978 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(73059), // Rule ID 3535 //
     /*  72983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  72986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8),
     /*  72991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  72994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73004 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10730:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73004 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73007 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73011 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73016 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8),
     /*  73049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73057 */     GIR_RootConstrainSelectedInstOperands,
     /*  73058 */     // GIR_Coverage, 3535,
     /*  73058 */     GIR_EraseRootFromParent_Done,
     /*  73059 */   // Label 1179: @73059
     /*  73059 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(73140), // Rule ID 3537 //
     /*  73064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4),
     /*  73072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73085 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10732:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73085 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73088 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73092 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73097 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73101 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4),
     /*  73130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73138 */     GIR_RootConstrainSelectedInstOperands,
     /*  73139 */     // GIR_Coverage, 3537,
     /*  73139 */     GIR_EraseRootFromParent_Done,
     /*  73140 */   // Label 1180: @73140
     /*  73140 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(73221), // Rule ID 3539 //
     /*  73145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2s),
     /*  73153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73166 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10728:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2S:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73166 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73169 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73173 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73178 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73182 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73199 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2S),
     /*  73211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73219 */     GIR_RootConstrainSelectedInstOperands,
     /*  73220 */     // GIR_Coverage, 3539,
     /*  73220 */     GIR_EraseRootFromParent_Done,
     /*  73221 */   // Label 1181: @73221
     /*  73221 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73302), // Rule ID 3541 //
     /*  73226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8),
     /*  73234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73247 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10730:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73247 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73250 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73254 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73259 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73263 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8W),
     /*  73292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73300 */     GIR_RootConstrainSelectedInstOperands,
     /*  73301 */     // GIR_Coverage, 3541,
     /*  73301 */     GIR_EraseRootFromParent_Done,
     /*  73302 */   // Label 1182: @73302
     /*  73302 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73383), // Rule ID 3543 //
     /*  73307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4),
     /*  73315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73328 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10732:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73340 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73361 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4W),
     /*  73373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73381 */     GIR_RootConstrainSelectedInstOperands,
     /*  73382 */     // GIR_Coverage, 3543,
     /*  73382 */     GIR_EraseRootFromParent_Done,
     /*  73383 */   // Label 1183: @73383
     /*  73383 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73464), // Rule ID 3545 //
     /*  73388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2s),
     /*  73396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73409 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10728:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73409 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73412 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73416 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73421 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73425 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SW),
     /*  73454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73462 */     GIR_RootConstrainSelectedInstOperands,
     /*  73463 */     // GIR_Coverage, 3545,
     /*  73463 */     GIR_EraseRootFromParent_Done,
     /*  73464 */   // Label 1184: @73464
     /*  73464 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73545), // Rule ID 3547 //
     /*  73469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2),
     /*  73477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73490 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10711:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73490 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73493 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73497 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73502 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73506 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2),
     /*  73535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73543 */     GIR_RootConstrainSelectedInstOperands,
     /*  73544 */     // GIR_Coverage, 3547,
     /*  73544 */     GIR_EraseRootFromParent_Done,
     /*  73545 */   // Label 1185: @73545
     /*  73545 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73626), // Rule ID 3552 //
     /*  73550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2),
     /*  73558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73571 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10711:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73571 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73574 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73578 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73583 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73587 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2W),
     /*  73616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73624 */     GIR_RootConstrainSelectedInstOperands,
     /*  73625 */     // GIR_Coverage, 3552,
     /*  73625 */     GIR_EraseRootFromParent_Done,
     /*  73626 */   // Label 1186: @73626
     /*  73626 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73707), // Rule ID 3557 //
     /*  73631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32ger),
     /*  73639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73652 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10716:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GER:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73652 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73655 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73659 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73664 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GER),
     /*  73697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73705 */     GIR_RootConstrainSelectedInstOperands,
     /*  73706 */     // GIR_Coverage, 3557,
     /*  73706 */     GIR_EraseRootFromParent_Done,
     /*  73707 */   // Label 1187: @73707
     /*  73707 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73766), // Rule ID 3562 //
     /*  73712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64ger),
     /*  73720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  73726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73733 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10721:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GER:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73745 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GER),
     /*  73757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73759 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  73761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73764 */     GIR_RootConstrainSelectedInstOperands,
     /*  73765 */     // GIR_Coverage, 3562,
     /*  73765 */     GIR_EraseRootFromParent_Done,
     /*  73766 */   // Label 1188: @73766
     /*  73766 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73847), // Rule ID 3567 //
     /*  73771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2),
     /*  73779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73792 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10706:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73792 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73795 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73799 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73804 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73808 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2),
     /*  73837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73845 */     GIR_RootConstrainSelectedInstOperands,
     /*  73846 */     // GIR_Coverage, 3567,
     /*  73846 */     GIR_EraseRootFromParent_Done,
     /*  73847 */   // Label 1189: @73847
     /*  73847 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(73928), // Rule ID 3572 //
     /*  73852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2),
     /*  73860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73873 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10726:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73873 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73876 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73880 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73885 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73889 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2),
     /*  73918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73926 */     GIR_RootConstrainSelectedInstOperands,
     /*  73927 */     // GIR_Coverage, 3572,
     /*  73927 */     GIR_EraseRootFromParent_Done,
     /*  73928 */   // Label 1190: @73928
     /*  73928 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(74009), // Rule ID 3575 //
     /*  73933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32ger),
     /*  73941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73954 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10716:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73954 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73957 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73961 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73966 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73970 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERW),
     /*  73999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74007 */     GIR_RootConstrainSelectedInstOperands,
     /*  74008 */     // GIR_Coverage, 3575,
     /*  74008 */     GIR_EraseRootFromParent_Done,
     /*  74009 */   // Label 1191: @74009
     /*  74009 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(74068), // Rule ID 3580 //
     /*  74014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64ger),
     /*  74022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  74028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74035 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10721:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERW:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERW),
     /*  74059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74061 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  74063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74066 */     GIR_RootConstrainSelectedInstOperands,
     /*  74067 */     // GIR_Coverage, 3580,
     /*  74067 */     GIR_EraseRootFromParent_Done,
     /*  74068 */   // Label 1192: @74068
     /*  74068 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(74149), // Rule ID 3585 //
     /*  74073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2),
     /*  74081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74094 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10706:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74094 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  74097 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74101 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74106 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74110 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74127 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2W),
     /*  74139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74147 */     GIR_RootConstrainSelectedInstOperands,
     /*  74148 */     // GIR_Coverage, 3585,
     /*  74148 */     GIR_EraseRootFromParent_Done,
     /*  74149 */   // Label 1193: @74149
     /*  74149 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74230), // Rule ID 3590 //
     /*  74154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2),
     /*  74162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74175 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10726:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74175 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  74178 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74182 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74187 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2W),
     /*  74220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74228 */     GIR_RootConstrainSelectedInstOperands,
     /*  74229 */     // GIR_Coverage, 3590,
     /*  74229 */     GIR_EraseRootFromParent_Done,
     /*  74230 */   // Label 1194: @74230
     /*  74230 */   GIM_Reject,
     /*  74231 */ // Label 997: @74231
     /*  74231 */ GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(81559),
     /*  74236 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  74239 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74297), // Rule ID 1007 //
     /*  74244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /*  74252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  74255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  74258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  74261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  74264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  74272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /*  74276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /*  74280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74282 */     // (intrinsic_wo_chain:{ *:[f128] } 10601:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  74282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQPO),
     /*  74285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  74287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /*  74291 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  74293 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  74295 */     GIR_RootConstrainSelectedInstOperands,
     /*  74296 */     // GIR_Coverage, 1007,
     /*  74296 */     GIR_EraseRootFromParent_Done,
     /*  74297 */   // Label 1196: @74297
     /*  74297 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74350), // Rule ID 2166 //
     /*  74302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxinsertw),
     /*  74310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  74330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  74334 */     // MIs[1] Operand 1
     /*  74334 */     // No operand predicates
     /*  74334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74336 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10878:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v2i64:{ *:[v2i64] }:$B, (imm:{ *:[i32] }):$IMM)  =>  (XXINSERTW:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v2i64] }:$B, (imm:{ *:[i32] }):$IMM)
     /*  74336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXINSERTW),
     /*  74339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74341 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74343 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // IMM
     /*  74348 */     GIR_RootConstrainSelectedInstOperands,
     /*  74349 */     // GIR_Coverage, 2166,
     /*  74349 */     GIR_EraseRootFromParent_Done,
     /*  74350 */   // Label 1197: @74350
     /*  74350 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74392), // Rule ID 1006 //
     /*  74355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /*  74363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  74366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  74369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  74372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  74375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74379 */     // (intrinsic_wo_chain:{ *:[f128] } 10601:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  74379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQPO),
     /*  74382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  74384 */     GIR_RootToRootCopy, /*OpIdx*/4, // RSTi
     /*  74386 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  74388 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  74390 */     GIR_RootConstrainSelectedInstOperands,
     /*  74391 */     // GIR_Coverage, 1006,
     /*  74391 */     GIR_EraseRootFromParent_Done,
     /*  74392 */   // Label 1198: @74392
     /*  74392 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74434), // Rule ID 1745 //
     /*  74397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  74400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsub),
     /*  74405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  74421 */     // (intrinsic_wo_chain:{ *:[f64] } 10602:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (XSMSUBMDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  74421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBMDP),
     /*  74424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74426 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74428 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74430 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74432 */     GIR_RootConstrainSelectedInstOperands,
     /*  74433 */     // GIR_Coverage, 1745,
     /*  74433 */     GIR_EraseRootFromParent_Done,
     /*  74434 */   // Label 1199: @74434
     /*  74434 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74476), // Rule ID 1746 //
     /*  74439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  74442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadd),
     /*  74447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  74463 */     // (intrinsic_wo_chain:{ *:[f64] } 10606:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (XSNMADDMDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  74463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDMDP),
     /*  74466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74468 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74470 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74472 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74474 */     GIR_RootConstrainSelectedInstOperands,
     /*  74475 */     // GIR_Coverage, 1746,
     /*  74475 */     GIR_EraseRootFromParent_Done,
     /*  74476 */   // Label 1200: @74476
     /*  74476 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74518), // Rule ID 1932 //
     /*  74481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  74484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsubs),
     /*  74489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  74492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  74505 */     // (intrinsic_wo_chain:{ *:[f32] } 10603:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (XSMSUBMSP:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  74505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBMSP),
     /*  74508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74510 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74512 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74514 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74516 */     GIR_RootConstrainSelectedInstOperands,
     /*  74517 */     // GIR_Coverage, 1932,
     /*  74517 */     GIR_EraseRootFromParent_Done,
     /*  74518 */   // Label 1201: @74518
     /*  74518 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74560), // Rule ID 1933 //
     /*  74523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  74526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadds),
     /*  74531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  74534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  74547 */     // (intrinsic_wo_chain:{ *:[f32] } 10607:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (XSNMADDMSP:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  74547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDMSP),
     /*  74550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74552 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74554 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74556 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74558 */     GIR_RootConstrainSelectedInstOperands,
     /*  74559 */     // GIR_Coverage, 1933,
     /*  74559 */     GIR_EraseRootFromParent_Done,
     /*  74560 */   // Label 1202: @74560
     /*  74560 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74602), // Rule ID 508 //
     /*  74565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  74568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vshasigmaw),
     /*  74573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74583 */     // MIs[0] ST
     /*  74583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  74586 */     // MIs[0] SIX
     /*  74586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74589 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10238:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)  =>  (VSHASIGMAW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)
     /*  74589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSHASIGMAW),
     /*  74592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74594 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  74596 */     GIR_RootToRootCopy, /*OpIdx*/3, // ST
     /*  74598 */     GIR_RootToRootCopy, /*OpIdx*/4, // SIX
     /*  74600 */     GIR_RootConstrainSelectedInstOperands,
     /*  74601 */     // GIR_Coverage, 508,
     /*  74601 */     GIR_EraseRootFromParent_Done,
     /*  74602 */   // Label 1203: @74602
     /*  74602 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74644), // Rule ID 509 //
     /*  74607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  74610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vshasigmad),
     /*  74615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74625 */     // MIs[0] ST
     /*  74625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  74628 */     // MIs[0] SIX
     /*  74628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74631 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10237:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)  =>  (VSHASIGMAD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)
     /*  74631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSHASIGMAD),
     /*  74634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74636 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  74638 */     GIR_RootToRootCopy, /*OpIdx*/3, // ST
     /*  74640 */     GIR_RootToRootCopy, /*OpIdx*/4, // SIX
     /*  74642 */     GIR_RootConstrainSelectedInstOperands,
     /*  74643 */     // GIR_Coverage, 509,
     /*  74643 */     GIR_EraseRootFromParent_Done,
     /*  74644 */   // Label 1204: @74644
     /*  74644 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(74686), // Rule ID 1056 //
     /*  74649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsldbi),
     /*  74657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74670 */     // MIs[0] SD
     /*  74670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74673 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10486:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)  =>  (VSLDBI:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)
     /*  74673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLDBI),
     /*  74676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  74678 */     GIR_RootToRootCopy, /*OpIdx*/2, // VRA
     /*  74680 */     GIR_RootToRootCopy, /*OpIdx*/3, // VRB
     /*  74682 */     GIR_RootToRootCopy, /*OpIdx*/4, // SD
     /*  74684 */     GIR_RootConstrainSelectedInstOperands,
     /*  74685 */     // GIR_Coverage, 1056,
     /*  74685 */     GIR_EraseRootFromParent_Done,
     /*  74686 */   // Label 1205: @74686
     /*  74686 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(74728), // Rule ID 1057 //
     /*  74691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrdbi),
     /*  74699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74712 */     // MIs[0] SD
     /*  74712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74715 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10496:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)  =>  (VSRDBI:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)
     /*  74715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRDBI),
     /*  74718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  74720 */     GIR_RootToRootCopy, /*OpIdx*/2, // VRA
     /*  74722 */     GIR_RootToRootCopy, /*OpIdx*/3, // VRB
     /*  74724 */     GIR_RootToRootCopy, /*OpIdx*/4, // SD
     /*  74726 */     GIR_RootConstrainSelectedInstOperands,
     /*  74727 */     // GIR_Coverage, 1057,
     /*  74727 */     GIR_EraseRootFromParent_Done,
     /*  74728 */   // Label 1206: @74728
     /*  74728 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(74770), // Rule ID 1062 //
     /*  74733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsw),
     /*  74741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74754 */     // MIs[0] VA
     /*  74754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74757 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10394:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VINSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, (timm:{ *:[i32] }):$VA, i32:{ *:[i32] }:$VB)
     /*  74757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSW),
     /*  74760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74762 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  74764 */     GIR_RootToRootCopy, /*OpIdx*/4, // VA
     /*  74766 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  74768 */     GIR_RootConstrainSelectedInstOperands,
     /*  74769 */     // GIR_Coverage, 1062,
     /*  74769 */     GIR_EraseRootFromParent_Done,
     /*  74770 */   // Label 1207: @74770
     /*  74770 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(74812), // Rule ID 1063 //
     /*  74775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsd),
     /*  74783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74796 */     // MIs[0] VA
     /*  74796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74799 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10387:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VINSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, (timm:{ *:[i32] }):$VA, i64:{ *:[i64] }:$VB)
     /*  74799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSD),
     /*  74802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74804 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  74806 */     GIR_RootToRootCopy, /*OpIdx*/4, // VA
     /*  74808 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  74810 */     GIR_RootConstrainSelectedInstOperands,
     /*  74811 */     // GIR_Coverage, 1063,
     /*  74811 */     GIR_EraseRootFromParent_Done,
     /*  74812 */   // Label 1208: @74812
     /*  74812 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(74857), // Rule ID 1444 //
     /*  74817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  74820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bcdadd),
     /*  74825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74838 */     // MIs[0] PS
     /*  74838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74841 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10541:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, (timm:{ *:[i32] }):$PS)  =>  (BCDADD_rec:{ *:[v16i8] }:{ *:[i32] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB, ?:{ *:[i32] }:$PS)
     /*  74841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDADD_rec),
     /*  74844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74846 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  74848 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  74850 */     GIR_RootToRootCopy, /*OpIdx*/4, // PS
     /*  74852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  74855 */     GIR_RootConstrainSelectedInstOperands,
     /*  74856 */     // GIR_Coverage, 1444,
     /*  74856 */     GIR_EraseRootFromParent_Done,
     /*  74857 */   // Label 1209: @74857
     /*  74857 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(74902), // Rule ID 1445 //
     /*  74862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  74865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bcdsub),
     /*  74870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74883 */     // MIs[0] PS
     /*  74883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74886 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10543:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, (timm:{ *:[i32] }):$PS)  =>  (BCDSUB_rec:{ *:[v16i8] }:{ *:[i32] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB, ?:{ *:[i32] }:$PS)
     /*  74886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDSUB_rec),
     /*  74889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74891 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  74893 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  74895 */     GIR_RootToRootCopy, /*OpIdx*/4, // PS
     /*  74897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  74900 */     GIR_RootConstrainSelectedInstOperands,
     /*  74901 */     // GIR_Coverage, 1445,
     /*  74901 */     GIR_EraseRootFromParent_Done,
     /*  74902 */   // Label 1210: @74902
     /*  74902 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(74956), // Rule ID 1560 //
     /*  74907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  74910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddhd),
     /*  74915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74943 */     // (intrinsic_wo_chain:{ *:[i64] } 10629:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDHD:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  74943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDHD),
     /*  74946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  74948 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  74950 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  74952 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  74954 */     GIR_RootConstrainSelectedInstOperands,
     /*  74955 */     // GIR_Coverage, 1560,
     /*  74955 */     GIR_EraseRootFromParent_Done,
     /*  74956 */   // Label 1211: @74956
     /*  74956 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75010), // Rule ID 1561 //
     /*  74961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  74964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddhdu),
     /*  74969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74997 */     // (intrinsic_wo_chain:{ *:[i64] } 10630:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDHDU:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  74997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDHDU),
     /*  75000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75002 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  75004 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  75006 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  75008 */     GIR_RootConstrainSelectedInstOperands,
     /*  75009 */     // GIR_Coverage, 1561,
     /*  75009 */     GIR_EraseRootFromParent_Done,
     /*  75010 */   // Label 1212: @75010
     /*  75010 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75064), // Rule ID 1562 //
     /*  75015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  75018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddld),
     /*  75023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  75032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  75035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75051 */     // (intrinsic_wo_chain:{ *:[i64] } 10631:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDLD8:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  75051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDLD8),
     /*  75054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75056 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  75058 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  75060 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  75062 */     GIR_RootConstrainSelectedInstOperands,
     /*  75063 */     // GIR_Coverage, 1562,
     /*  75063 */     GIR_EraseRootFromParent_Done,
     /*  75064 */   // Label 1213: @75064
     /*  75064 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75115), // Rule ID 4849 //
     /*  75069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fsel),
     /*  75074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  75083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  75086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75102 */     // (intrinsic_wo_chain:{ *:[f64] } 10613:{ *:[iPTR] }, f8rc:{ *:[f64] }:$FRA, f8rc:{ *:[f64] }:$FRC, f8rc:{ *:[f64] }:$FRB)  =>  (FSELD:{ *:[f64] } ?:{ *:[f64] }:$FRA, ?:{ *:[f64] }:$FRC, ?:{ *:[f64] }:$FRB)
     /*  75102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FSELD),
     /*  75105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  75107 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRA
     /*  75109 */     GIR_RootToRootCopy, /*OpIdx*/3, // FRC
     /*  75111 */     GIR_RootToRootCopy, /*OpIdx*/4, // FRB
     /*  75113 */     GIR_RootConstrainSelectedInstOperands,
     /*  75114 */     // GIR_Coverage, 4849,
     /*  75114 */     GIR_EraseRootFromParent_Done,
     /*  75115 */   // Label 1214: @75115
     /*  75115 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(75157), // Rule ID 296 //
     /*  75120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmladduhm),
     /*  75128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75144 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10421:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMLADDUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  75144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*  75147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75149 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75151 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75153 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75155 */     GIR_RootConstrainSelectedInstOperands,
     /*  75156 */     // GIR_Coverage, 296,
     /*  75156 */     GIR_EraseRootFromParent_Done,
     /*  75157 */   // Label 1215: @75157
     /*  75157 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(75199), // Rule ID 297 //
     /*  75162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vperm),
     /*  75170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75186 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10452:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v16i8:{ *:[v16i8] }:$RC)  =>  (VPERM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v16i8:{ *:[v16i8] }:$RC)
     /*  75186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERM),
     /*  75189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75191 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75193 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75195 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75197 */     GIR_RootConstrainSelectedInstOperands,
     /*  75198 */     // GIR_Coverage, 297,
     /*  75198 */     GIR_EraseRootFromParent_Done,
     /*  75199 */   // Label 1216: @75199
     /*  75199 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(75241), // Rule ID 298 //
     /*  75204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsel),
     /*  75212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75228 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10483:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VSEL:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /*  75231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75233 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75235 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75237 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75239 */     GIR_RootConstrainSelectedInstOperands,
     /*  75240 */     // GIR_Coverage, 298,
     /*  75240 */     GIR_EraseRootFromParent_Done,
     /*  75241 */   // Label 1217: @75241
     /*  75241 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(75283), // Rule ID 349 //
     /*  75246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsummbm),
     /*  75254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75270 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10423:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMMBM:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMMBM),
     /*  75273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75275 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75277 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75279 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75281 */     GIR_RootConstrainSelectedInstOperands,
     /*  75282 */     // GIR_Coverage, 349,
     /*  75282 */     GIR_EraseRootFromParent_Done,
     /*  75283 */   // Label 1218: @75283
     /*  75283 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(75325), // Rule ID 350 //
     /*  75288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumshm),
     /*  75296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75312 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10424:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMSHM:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMSHM),
     /*  75315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75317 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75319 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75321 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75323 */     GIR_RootConstrainSelectedInstOperands,
     /*  75324 */     // GIR_Coverage, 350,
     /*  75324 */     GIR_EraseRootFromParent_Done,
     /*  75325 */   // Label 1219: @75325
     /*  75325 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(75367), // Rule ID 351 //
     /*  75330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumubm),
     /*  75338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75354 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10426:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUBM:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUBM),
     /*  75357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75359 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75361 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75363 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75365 */     GIR_RootConstrainSelectedInstOperands,
     /*  75366 */     // GIR_Coverage, 351,
     /*  75366 */     GIR_EraseRootFromParent_Done,
     /*  75367 */   // Label 1220: @75367
     /*  75367 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(75409), // Rule ID 352 //
     /*  75372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumuhm),
     /*  75380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75396 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10428:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUHM:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUHM),
     /*  75399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75401 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75403 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75405 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75407 */     GIR_RootConstrainSelectedInstOperands,
     /*  75408 */     // GIR_Coverage, 352,
     /*  75408 */     GIR_EraseRootFromParent_Done,
     /*  75409 */   // Label 1221: @75409
     /*  75409 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(75451), // Rule ID 471 //
     /*  75414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddeuqm),
     /*  75422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75438 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10270:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VADDEUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDEUQM),
     /*  75441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75443 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75445 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75447 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75449 */     GIR_RootConstrainSelectedInstOperands,
     /*  75450 */     // GIR_Coverage, 471,
     /*  75450 */     GIR_EraseRootFromParent_Done,
     /*  75451 */   // Label 1222: @75451
     /*  75451 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(75493), // Rule ID 473 //
     /*  75456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddecuq),
     /*  75464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75480 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10269:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VADDECUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDECUQ),
     /*  75483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75485 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75487 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75489 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75491 */     GIR_RootConstrainSelectedInstOperands,
     /*  75492 */     // GIR_Coverage, 473,
     /*  75492 */     GIR_EraseRootFromParent_Done,
     /*  75493 */   // Label 1223: @75493
     /*  75493 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(75535), // Rule ID 476 //
     /*  75498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubeuqm),
     /*  75506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75522 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10512:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VSUBEUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBEUQM),
     /*  75525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75527 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75529 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75531 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75533 */     GIR_RootConstrainSelectedInstOperands,
     /*  75534 */     // GIR_Coverage, 476,
     /*  75534 */     GIR_EraseRootFromParent_Done,
     /*  75535 */   // Label 1224: @75535
     /*  75535 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(75577), // Rule ID 478 //
     /*  75540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubecuq),
     /*  75548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75564 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10511:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VSUBECUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBECUQ),
     /*  75567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75569 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75571 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75573 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75575 */     GIR_RootConstrainSelectedInstOperands,
     /*  75576 */     // GIR_Coverage, 478,
     /*  75576 */     GIR_EraseRootFromParent_Done,
     /*  75577 */   // Label 1225: @75577
     /*  75577 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(75619), // Rule ID 515 //
     /*  75582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumudm),
     /*  75590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  75599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75606 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10427:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VMSUMUDM:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUDM),
     /*  75609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75611 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75613 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75615 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75617 */     GIR_RootConstrainSelectedInstOperands,
     /*  75618 */     // GIR_Coverage, 515,
     /*  75618 */     GIR_EraseRootFromParent_Done,
     /*  75619 */   // Label 1226: @75619
     /*  75619 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(75661), // Rule ID 548 //
     /*  75624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlwmi),
     /*  75632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75648 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10480:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB, v4i32:{ *:[v4i32] }:$VDi)  =>  (VRLWMI:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB, v4i32:{ *:[v4i32] }:$VDi)
     /*  75648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLWMI),
     /*  75651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75653 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  75655 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  75657 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  75659 */     GIR_RootConstrainSelectedInstOperands,
     /*  75660 */     // GIR_Coverage, 548,
     /*  75660 */     GIR_EraseRootFromParent_Done,
     /*  75661 */   // Label 1227: @75661
     /*  75661 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(75703), // Rule ID 550 //
     /*  75666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrldmi),
     /*  75674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  75683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  75686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75690 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10474:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB, v2i64:{ *:[v2i64] }:$VDi)  =>  (VRLDMI:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB, v2i64:{ *:[v2i64] }:$VDi)
     /*  75690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLDMI),
     /*  75693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75695 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  75697 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  75699 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  75701 */     GIR_RootConstrainSelectedInstOperands,
     /*  75702 */     // GIR_Coverage, 550,
     /*  75702 */     GIR_EraseRootFromParent_Done,
     /*  75703 */   // Label 1228: @75703
     /*  75703 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(75745), // Rule ID 1064 //
     /*  75708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbvlx),
     /*  75716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75732 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10385:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VINSBVLX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  75732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBVLX),
     /*  75735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75737 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75739 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75741 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75743 */     GIR_RootConstrainSelectedInstOperands,
     /*  75744 */     // GIR_Coverage, 1064,
     /*  75744 */     GIR_EraseRootFromParent_Done,
     /*  75745 */   // Label 1229: @75745
     /*  75745 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(75787), // Rule ID 1065 //
     /*  75750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbvrx),
     /*  75758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75774 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10386:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VINSBVRX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  75774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBVRX),
     /*  75777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75779 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75781 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75783 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75785 */     GIR_RootConstrainSelectedInstOperands,
     /*  75786 */     // GIR_Coverage, 1065,
     /*  75786 */     GIR_EraseRootFromParent_Done,
     /*  75787 */   // Label 1230: @75787
     /*  75787 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(75829), // Rule ID 1066 //
     /*  75792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshvlx),
     /*  75800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75816 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10392:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VINSHVLX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  75816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHVLX),
     /*  75819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75821 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75823 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75825 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75827 */     GIR_RootConstrainSelectedInstOperands,
     /*  75828 */     // GIR_Coverage, 1066,
     /*  75828 */     GIR_EraseRootFromParent_Done,
     /*  75829 */   // Label 1231: @75829
     /*  75829 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(75871), // Rule ID 1067 //
     /*  75834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshvrx),
     /*  75842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75858 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10393:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VINSHVRX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  75858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHVRX),
     /*  75861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75863 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75865 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75867 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75869 */     GIR_RootConstrainSelectedInstOperands,
     /*  75870 */     // GIR_Coverage, 1067,
     /*  75870 */     GIR_EraseRootFromParent_Done,
     /*  75871 */   // Label 1232: @75871
     /*  75871 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(75913), // Rule ID 1068 //
     /*  75876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswvlx),
     /*  75884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75900 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10397:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VINSWVLX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  75900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWVLX),
     /*  75903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75905 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75907 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75909 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75911 */     GIR_RootConstrainSelectedInstOperands,
     /*  75912 */     // GIR_Coverage, 1068,
     /*  75912 */     GIR_EraseRootFromParent_Done,
     /*  75913 */   // Label 1233: @75913
     /*  75913 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(75955), // Rule ID 1069 //
     /*  75918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswvrx),
     /*  75926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75942 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10398:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VINSWVRX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  75942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWVRX),
     /*  75945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75947 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75949 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75951 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75953 */     GIR_RootConstrainSelectedInstOperands,
     /*  75954 */     // GIR_Coverage, 1069,
     /*  75954 */     GIR_EraseRootFromParent_Done,
     /*  75955 */   // Label 1234: @75955
     /*  75955 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(75997), // Rule ID 1070 //
     /*  75960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsblx),
     /*  75968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75984 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10383:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSBLX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  75984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBLX),
     /*  75987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75989 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75991 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75993 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75995 */     GIR_RootConstrainSelectedInstOperands,
     /*  75996 */     // GIR_Coverage, 1070,
     /*  75996 */     GIR_EraseRootFromParent_Done,
     /*  75997 */   // Label 1235: @75997
     /*  75997 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(76039), // Rule ID 1071 //
     /*  76002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbrx),
     /*  76010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76026 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10384:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSBRX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBRX),
     /*  76029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76031 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76033 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76035 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76037 */     GIR_RootConstrainSelectedInstOperands,
     /*  76038 */     // GIR_Coverage, 1071,
     /*  76038 */     GIR_EraseRootFromParent_Done,
     /*  76039 */   // Label 1236: @76039
     /*  76039 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(76081), // Rule ID 1072 //
     /*  76044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshlx),
     /*  76052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76068 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10390:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSHLX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHLX),
     /*  76071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76073 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76075 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76077 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76079 */     GIR_RootConstrainSelectedInstOperands,
     /*  76080 */     // GIR_Coverage, 1072,
     /*  76080 */     GIR_EraseRootFromParent_Done,
     /*  76081 */   // Label 1237: @76081
     /*  76081 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(76123), // Rule ID 1073 //
     /*  76086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshrx),
     /*  76094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76110 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10391:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSHRX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHRX),
     /*  76113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76115 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76117 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76119 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76121 */     GIR_RootConstrainSelectedInstOperands,
     /*  76122 */     // GIR_Coverage, 1073,
     /*  76122 */     GIR_EraseRootFromParent_Done,
     /*  76123 */   // Label 1238: @76123
     /*  76123 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(76165), // Rule ID 1074 //
     /*  76128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswlx),
     /*  76136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76152 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10395:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSWLX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWLX),
     /*  76155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76157 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76159 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76161 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76163 */     GIR_RootConstrainSelectedInstOperands,
     /*  76164 */     // GIR_Coverage, 1074,
     /*  76164 */     GIR_EraseRootFromParent_Done,
     /*  76165 */   // Label 1239: @76165
     /*  76165 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(76207), // Rule ID 1075 //
     /*  76170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswrx),
     /*  76178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76194 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10396:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSWRX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWRX),
     /*  76197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76199 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76201 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76203 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76205 */     GIR_RootConstrainSelectedInstOperands,
     /*  76206 */     // GIR_Coverage, 1075,
     /*  76206 */     GIR_EraseRootFromParent_Done,
     /*  76207 */   // Label 1240: @76207
     /*  76207 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(76249), // Rule ID 1076 //
     /*  76212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsdlx),
     /*  76220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76236 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10388:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)  =>  (VINSDLX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)
     /*  76236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSDLX),
     /*  76239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76241 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76243 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76245 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76247 */     GIR_RootConstrainSelectedInstOperands,
     /*  76248 */     // GIR_Coverage, 1076,
     /*  76248 */     GIR_EraseRootFromParent_Done,
     /*  76249 */   // Label 1241: @76249
     /*  76249 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(76291), // Rule ID 1077 //
     /*  76254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsdrx),
     /*  76262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76278 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10389:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)  =>  (VINSDRX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)
     /*  76278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSDRX),
     /*  76281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76283 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76285 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76287 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76289 */     GIR_RootConstrainSelectedInstOperands,
     /*  76290 */     // GIR_Coverage, 1077,
     /*  76290 */     GIR_EraseRootFromParent_Done,
     /*  76291 */   // Label 1242: @76291
     /*  76291 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(76333), // Rule ID 1098 //
     /*  76296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextdubvlx),
     /*  76304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76320 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10364:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUBVLX:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUBVLX),
     /*  76323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76325 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76327 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76329 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76331 */     GIR_RootConstrainSelectedInstOperands,
     /*  76332 */     // GIR_Coverage, 1098,
     /*  76332 */     GIR_EraseRootFromParent_Done,
     /*  76333 */   // Label 1243: @76333
     /*  76333 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(76375), // Rule ID 1099 //
     /*  76338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextdubvrx),
     /*  76346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76362 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10365:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUBVRX:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUBVRX),
     /*  76365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76367 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76369 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76371 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76373 */     GIR_RootConstrainSelectedInstOperands,
     /*  76374 */     // GIR_Coverage, 1099,
     /*  76374 */     GIR_EraseRootFromParent_Done,
     /*  76375 */   // Label 1244: @76375
     /*  76375 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(76417), // Rule ID 1100 //
     /*  76380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduhvlx),
     /*  76388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76404 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10366:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUHVLX:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUHVLX),
     /*  76407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76409 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76411 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76413 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76415 */     GIR_RootConstrainSelectedInstOperands,
     /*  76416 */     // GIR_Coverage, 1100,
     /*  76416 */     GIR_EraseRootFromParent_Done,
     /*  76417 */   // Label 1245: @76417
     /*  76417 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(76459), // Rule ID 1101 //
     /*  76422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduhvrx),
     /*  76430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76446 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10367:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUHVRX:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUHVRX),
     /*  76449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76451 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76453 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76455 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76457 */     GIR_RootConstrainSelectedInstOperands,
     /*  76458 */     // GIR_Coverage, 1101,
     /*  76458 */     GIR_EraseRootFromParent_Done,
     /*  76459 */   // Label 1246: @76459
     /*  76459 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(76501), // Rule ID 1102 //
     /*  76464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduwvlx),
     /*  76472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76488 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10368:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUWVLX:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUWVLX),
     /*  76491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76493 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76495 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76497 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76499 */     GIR_RootConstrainSelectedInstOperands,
     /*  76500 */     // GIR_Coverage, 1102,
     /*  76500 */     GIR_EraseRootFromParent_Done,
     /*  76501 */   // Label 1247: @76501
     /*  76501 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(76543), // Rule ID 1103 //
     /*  76506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduwvrx),
     /*  76514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76530 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10369:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUWVRX:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUWVRX),
     /*  76533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76535 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76537 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76539 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76541 */     GIR_RootConstrainSelectedInstOperands,
     /*  76542 */     // GIR_Coverage, 1103,
     /*  76542 */     GIR_EraseRootFromParent_Done,
     /*  76543 */   // Label 1248: @76543
     /*  76543 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(76585), // Rule ID 1104 //
     /*  76548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextddvlx),
     /*  76556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76572 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10362:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDDVLX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDDVLX),
     /*  76575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76577 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76579 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76581 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76583 */     GIR_RootConstrainSelectedInstOperands,
     /*  76584 */     // GIR_Coverage, 1104,
     /*  76584 */     GIR_EraseRootFromParent_Done,
     /*  76585 */   // Label 1249: @76585
     /*  76585 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(76627), // Rule ID 1105 //
     /*  76590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextddvrx),
     /*  76598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76614 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10363:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDDVRX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDDVRX),
     /*  76617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76619 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76621 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76623 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76625 */     GIR_RootConstrainSelectedInstOperands,
     /*  76626 */     // GIR_Coverage, 1105,
     /*  76626 */     GIR_EraseRootFromParent_Done,
     /*  76627 */   // Label 1250: @76627
     /*  76627 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(76669), // Rule ID 1143 //
     /*  76632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumcud),
     /*  76640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  76643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  76652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76656 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10422:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VMSUMCUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  76656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMCUD),
     /*  76659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76661 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76663 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76665 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76667 */     GIR_RootConstrainSelectedInstOperands,
     /*  76668 */     // GIR_Coverage, 1143,
     /*  76668 */     GIR_EraseRootFromParent_Done,
     /*  76669 */   // Label 1251: @76669
     /*  76669 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(76711), // Rule ID 1158 //
     /*  76674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlqmi),
     /*  76682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  76685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  76688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  76691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  76694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76698 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10477:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB, v1i128:{ *:[v1i128] }:$VDi)  =>  (VRLQMI:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB, v1i128:{ *:[v1i128] }:$VDi)
     /*  76698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLQMI),
     /*  76701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76703 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  76705 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  76707 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  76709 */     GIR_RootConstrainSelectedInstOperands,
     /*  76710 */     // GIR_Coverage, 1158,
     /*  76710 */     GIR_EraseRootFromParent_Done,
     /*  76711 */   // Label 1252: @76711
     /*  76711 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(76750), // Rule ID 1276 //
     /*  76716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsub),
     /*  76721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  76724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  76727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  76737 */     // (intrinsic_wo_chain:{ *:[f64] } 10602:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (FMSUB:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  76737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /*  76740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76742 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76744 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76746 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76748 */     GIR_RootConstrainSelectedInstOperands,
     /*  76749 */     // GIR_Coverage, 1276,
     /*  76749 */     GIR_EraseRootFromParent_Done,
     /*  76750 */   // Label 1253: @76750
     /*  76750 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(76789), // Rule ID 1277 //
     /*  76755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsubs),
     /*  76760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  76776 */     // (intrinsic_wo_chain:{ *:[f32] } 10603:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (FMSUBS:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  76776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /*  76779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76781 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76783 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76785 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76787 */     GIR_RootConstrainSelectedInstOperands,
     /*  76788 */     // GIR_Coverage, 1277,
     /*  76788 */     GIR_EraseRootFromParent_Done,
     /*  76789 */   // Label 1254: @76789
     /*  76789 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(76828), // Rule ID 1278 //
     /*  76794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadd),
     /*  76799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  76802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  76805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  76815 */     // (intrinsic_wo_chain:{ *:[f64] } 10606:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (FNMADD:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  76815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /*  76818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76820 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76822 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76824 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76826 */     GIR_RootConstrainSelectedInstOperands,
     /*  76827 */     // GIR_Coverage, 1278,
     /*  76827 */     GIR_EraseRootFromParent_Done,
     /*  76828 */   // Label 1255: @76828
     /*  76828 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(76867), // Rule ID 1279 //
     /*  76833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadds),
     /*  76838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  76854 */     // (intrinsic_wo_chain:{ *:[f32] } 10607:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (FNMADDS:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  76854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /*  76857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76859 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76861 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76863 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76865 */     GIR_RootConstrainSelectedInstOperands,
     /*  76866 */     // GIR_Coverage, 1279,
     /*  76866 */     GIR_EraseRootFromParent_Done,
     /*  76867 */   // Label 1256: @76867
     /*  76867 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(76909), // Rule ID 1381 //
     /*  76872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  76875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaddfp),
     /*  76880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76896 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10400:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B, v4f32:{ *:[v4f32] }:$C)  =>  (VMADDFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B, ?:{ *:[v4f32] }:$C)
     /*  76896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /*  76899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76901 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76903 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76905 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76907 */     GIR_RootConstrainSelectedInstOperands,
     /*  76908 */     // GIR_Coverage, 1381,
     /*  76908 */     GIR_EraseRootFromParent_Done,
     /*  76909 */   // Label 1257: @76909
     /*  76909 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(76951), // Rule ID 1382 //
     /*  76914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  76917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vnmsubfp),
     /*  76922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76938 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10450:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B, v4f32:{ *:[v4f32] }:$C)  =>  (VNMSUBFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B, ?:{ *:[v4f32] }:$C)
     /*  76938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNMSUBFP),
     /*  76941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76943 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76945 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76947 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76949 */     GIR_RootConstrainSelectedInstOperands,
     /*  76950 */     // GIR_Coverage, 1382,
     /*  76950 */     GIR_EraseRootFromParent_Done,
     /*  76951 */   // Label 1258: @76951
     /*  76951 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(77056), // Rule ID 1577 //
     /*  76956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX_IsLittleEndian),
     /*  76959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor),
     /*  76964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76980 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10230:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, (XXLNOR:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$c, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$c, VSRC:{ *:[i32] })))
     /*  76980 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  76983 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  76987 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76992 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // c
     /*  76996 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77001 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77004 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77008 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77013 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // c
     /*  77017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  77029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77034 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77037 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  77045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77047 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  77049 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  77051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77054 */     GIR_RootConstrainSelectedInstOperands,
     /*  77055 */     // GIR_Coverage, 1577,
     /*  77055 */     GIR_EraseRootFromParent_Done,
     /*  77056 */   // Label 1259: @77056
     /*  77056 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(77098), // Rule ID 1578 //
     /*  77061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX_IsBigEndian),
     /*  77064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor),
     /*  77069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77085 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10230:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, ?:{ *:[v16i8] }:$c)
     /*  77085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  77088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77090 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  77092 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  77094 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  77096 */     GIR_RootConstrainSelectedInstOperands,
     /*  77097 */     // GIR_Coverage, 1578,
     /*  77097 */     GIR_EraseRootFromParent_Done,
     /*  77098 */   // Label 1260: @77098
     /*  77098 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(77140), // Rule ID 1579 //
     /*  77103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX),
     /*  77106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor_be),
     /*  77111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77127 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10231:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, ?:{ *:[v16i8] }:$c)
     /*  77127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  77130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77132 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  77134 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  77136 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  77138 */     GIR_RootConstrainSelectedInstOperands,
     /*  77139 */     // GIR_Coverage, 1579,
     /*  77139 */     GIR_EraseRootFromParent_Done,
     /*  77140 */   // Label 1261: @77140
     /*  77140 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(77269), // Rule ID 3425 //
     /*  77145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvb),
     /*  77153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77169 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10868:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$A, v16i8:{ *:[v16i8] }:$B, v16i8:{ *:[v16i8] }:$C)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXBLENDVB:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$C, VSRC:{ *:[i32] })), VSRC:{ *:[i32] })
     /*  77169 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  77172 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77176 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77181 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  77185 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77190 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  77193 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77197 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77202 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  77206 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77211 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77214 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77218 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77223 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  77227 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVB),
     /*  77239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77244 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77247 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77250 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  77253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77268 */     // GIR_Coverage, 3425,
     /*  77268 */     GIR_EraseRootFromParent_Done,
     /*  77269 */   // Label 1262: @77269
     /*  77269 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(77398), // Rule ID 3426 //
     /*  77274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvh),
     /*  77282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  77294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77298 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10870:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$A, v8i16:{ *:[v8i16] }:$B, v8i16:{ *:[v8i16] }:$C)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXBLENDVH:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$C, VSRC:{ *:[i32] })), VSRC:{ *:[i32] })
     /*  77298 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  77301 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77305 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77310 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  77314 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77319 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  77322 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77326 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77331 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  77335 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77340 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77343 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77347 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77352 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  77356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVH),
     /*  77368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77376 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77379 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  77382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77397 */     // GIR_Coverage, 3426,
     /*  77397 */     GIR_EraseRootFromParent_Done,
     /*  77398 */   // Label 1263: @77398
     /*  77398 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(77440), // Rule ID 3427 //
     /*  77403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvw),
     /*  77411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  77423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77427 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10871:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C)  =>  (XXBLENDVW:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  77427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVW),
     /*  77430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  77432 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77434 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77436 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77438 */     GIR_RootConstrainSelectedInstOperands,
     /*  77439 */     // GIR_Coverage, 3427,
     /*  77439 */     GIR_EraseRootFromParent_Done,
     /*  77440 */   // Label 1264: @77440
     /*  77440 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(77482), // Rule ID 3428 //
     /*  77445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvd),
     /*  77453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  77456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  77465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77469 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10869:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$A, v2i64:{ *:[v2i64] }:$B, v2i64:{ *:[v2i64] }:$C)  =>  (XXBLENDVD:{ *:[v2i64] } ?:{ *:[v2i64] }:$A, ?:{ *:[v2i64] }:$B, ?:{ *:[v2i64] }:$C)
     /*  77469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVD),
     /*  77472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  77474 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77476 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77478 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77480 */     GIR_RootConstrainSelectedInstOperands,
     /*  77481 */     // GIR_Coverage, 3428,
     /*  77481 */     GIR_EraseRootFromParent_Done,
     /*  77482 */   // Label 1265: @77482
     /*  77482 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(77546), // Rule ID 3510 //
     /*  77487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvi8gerx4pp),
     /*  77495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77511 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10658:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVI8GERX4PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVI8GERX4PP),
     /*  77535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77537 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77539 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77544 */     GIR_RootConstrainSelectedInstOperands,
     /*  77545 */     // GIR_Coverage, 3510,
     /*  77545 */     GIR_EraseRootFromParent_Done,
     /*  77546 */   // Label 1266: @77546
     /*  77546 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(77610), // Rule ID 3511 //
     /*  77551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvi8gerx4spp),
     /*  77559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77575 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10659:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVI8GERX4SPP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVI8GERX4SPP),
     /*  77599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77601 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77603 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77608 */     GIR_RootConstrainSelectedInstOperands,
     /*  77609 */     // GIR_Coverage, 3511,
     /*  77609 */     GIR_EraseRootFromParent_Done,
     /*  77610 */   // Label 1267: @77610
     /*  77610 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(77674), // Rule ID 3513 //
     /*  77615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2pp),
     /*  77623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77639 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10651:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77651 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2PP),
     /*  77663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77665 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77667 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77672 */     GIR_RootConstrainSelectedInstOperands,
     /*  77673 */     // GIR_Coverage, 3513,
     /*  77673 */     GIR_EraseRootFromParent_Done,
     /*  77674 */   // Label 1268: @77674
     /*  77674 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(77738), // Rule ID 3514 //
     /*  77679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2pn),
     /*  77687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77703 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10650:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2PN),
     /*  77727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77729 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77731 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77736 */     GIR_RootConstrainSelectedInstOperands,
     /*  77737 */     // GIR_Coverage, 3514,
     /*  77737 */     GIR_EraseRootFromParent_Done,
     /*  77738 */   // Label 1269: @77738
     /*  77738 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(77802), // Rule ID 3515 //
     /*  77743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2np),
     /*  77751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77767 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10649:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2NP),
     /*  77791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77793 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77795 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77800 */     GIR_RootConstrainSelectedInstOperands,
     /*  77801 */     // GIR_Coverage, 3515,
     /*  77801 */     GIR_EraseRootFromParent_Done,
     /*  77802 */   // Label 1270: @77802
     /*  77802 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(77866), // Rule ID 3516 //
     /*  77807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2nn),
     /*  77815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77831 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10648:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77843 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2NN),
     /*  77855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77857 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77859 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77864 */     GIR_RootConstrainSelectedInstOperands,
     /*  77865 */     // GIR_Coverage, 3516,
     /*  77865 */     GIR_EraseRootFromParent_Done,
     /*  77866 */   // Label 1271: @77866
     /*  77866 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(77930), // Rule ID 3518 //
     /*  77871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2pp),
     /*  77879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77895 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10656:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77907 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2PP),
     /*  77919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77921 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77923 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77928 */     GIR_RootConstrainSelectedInstOperands,
     /*  77929 */     // GIR_Coverage, 3518,
     /*  77929 */     GIR_EraseRootFromParent_Done,
     /*  77930 */   // Label 1272: @77930
     /*  77930 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(77994), // Rule ID 3519 //
     /*  77935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2pn),
     /*  77943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77959 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10655:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77971 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2PN),
     /*  77983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77985 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77987 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77992 */     GIR_RootConstrainSelectedInstOperands,
     /*  77993 */     // GIR_Coverage, 3519,
     /*  77993 */     GIR_EraseRootFromParent_Done,
     /*  77994 */   // Label 1273: @77994
     /*  77994 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(78058), // Rule ID 3520 //
     /*  77999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2np),
     /*  78007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78023 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10654:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78035 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2NP),
     /*  78047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78049 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78051 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78056 */     GIR_RootConstrainSelectedInstOperands,
     /*  78057 */     // GIR_Coverage, 3520,
     /*  78057 */     GIR_EraseRootFromParent_Done,
     /*  78058 */   // Label 1274: @78058
     /*  78058 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(78122), // Rule ID 3521 //
     /*  78063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2nn),
     /*  78071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78087 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10653:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2NN),
     /*  78111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78113 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78115 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78120 */     GIR_RootConstrainSelectedInstOperands,
     /*  78121 */     // GIR_Coverage, 3521,
     /*  78121 */     GIR_EraseRootFromParent_Done,
     /*  78122 */   // Label 1275: @78122
     /*  78122 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(78208), // Rule ID 3536 //
     /*  78127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8pp),
     /*  78135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78151 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10731:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78151 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78154 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78158 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78163 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78167 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8PP),
     /*  78196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78198 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78206 */     GIR_RootConstrainSelectedInstOperands,
     /*  78207 */     // GIR_Coverage, 3536,
     /*  78207 */     GIR_EraseRootFromParent_Done,
     /*  78208 */   // Label 1276: @78208
     /*  78208 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(78294), // Rule ID 3538 //
     /*  78213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4pp),
     /*  78221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78237 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10733:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78237 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78240 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78244 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78249 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78253 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78270 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4PP),
     /*  78282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78284 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78292 */     GIR_RootConstrainSelectedInstOperands,
     /*  78293 */     // GIR_Coverage, 3538,
     /*  78293 */     GIR_EraseRootFromParent_Done,
     /*  78294 */   // Label 1277: @78294
     /*  78294 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(78380), // Rule ID 3540 //
     /*  78299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2spp),
     /*  78307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78323 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10729:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78323 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78326 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78330 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78335 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78339 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SPP),
     /*  78368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78370 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78378 */     GIR_RootConstrainSelectedInstOperands,
     /*  78379 */     // GIR_Coverage, 3540,
     /*  78379 */     GIR_EraseRootFromParent_Done,
     /*  78380 */   // Label 1278: @78380
     /*  78380 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(78466), // Rule ID 3542 //
     /*  78385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8pp),
     /*  78393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78409 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10731:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78409 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78412 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78416 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78421 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78425 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8WPP),
     /*  78454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78456 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78464 */     GIR_RootConstrainSelectedInstOperands,
     /*  78465 */     // GIR_Coverage, 3542,
     /*  78465 */     GIR_EraseRootFromParent_Done,
     /*  78466 */   // Label 1279: @78466
     /*  78466 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(78552), // Rule ID 3544 //
     /*  78471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4pp),
     /*  78479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78495 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10733:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78495 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78498 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78502 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78507 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78511 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78528 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4WPP),
     /*  78540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78542 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78550 */     GIR_RootConstrainSelectedInstOperands,
     /*  78551 */     // GIR_Coverage, 3544,
     /*  78551 */     GIR_EraseRootFromParent_Done,
     /*  78552 */   // Label 1280: @78552
     /*  78552 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(78638), // Rule ID 3546 //
     /*  78557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2spp),
     /*  78565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78581 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10729:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78581 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78584 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78588 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78593 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SWPP),
     /*  78626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78628 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78636 */     GIR_RootConstrainSelectedInstOperands,
     /*  78637 */     // GIR_Coverage, 3546,
     /*  78637 */     GIR_EraseRootFromParent_Done,
     /*  78638 */   // Label 1281: @78638
     /*  78638 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(78724), // Rule ID 3548 //
     /*  78643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pp),
     /*  78651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78667 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10715:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78667 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78670 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78674 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2PP),
     /*  78712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78714 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78722 */     GIR_RootConstrainSelectedInstOperands,
     /*  78723 */     // GIR_Coverage, 3548,
     /*  78723 */     GIR_EraseRootFromParent_Done,
     /*  78724 */   // Label 1282: @78724
     /*  78724 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(78810), // Rule ID 3549 //
     /*  78729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pn),
     /*  78737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78753 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10714:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78753 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78756 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78760 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78765 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78769 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2PN),
     /*  78798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78800 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78808 */     GIR_RootConstrainSelectedInstOperands,
     /*  78809 */     // GIR_Coverage, 3549,
     /*  78809 */     GIR_EraseRootFromParent_Done,
     /*  78810 */   // Label 1283: @78810
     /*  78810 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(78896), // Rule ID 3550 //
     /*  78815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2np),
     /*  78823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78839 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10713:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78855 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2NP),
     /*  78884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78886 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78894 */     GIR_RootConstrainSelectedInstOperands,
     /*  78895 */     // GIR_Coverage, 3550,
     /*  78895 */     GIR_EraseRootFromParent_Done,
     /*  78896 */   // Label 1284: @78896
     /*  78896 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(78982), // Rule ID 3551 //
     /*  78901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2nn),
     /*  78909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78925 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10712:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78937 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78941 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2NN),
     /*  78970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78972 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78980 */     GIR_RootConstrainSelectedInstOperands,
     /*  78981 */     // GIR_Coverage, 3551,
     /*  78981 */     GIR_EraseRootFromParent_Done,
     /*  78982 */   // Label 1285: @78982
     /*  78982 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(79068), // Rule ID 3553 //
     /*  78987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pp),
     /*  78995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79011 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10715:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79011 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79014 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79018 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79023 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79027 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WPP),
     /*  79056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79058 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79066 */     GIR_RootConstrainSelectedInstOperands,
     /*  79067 */     // GIR_Coverage, 3553,
     /*  79067 */     GIR_EraseRootFromParent_Done,
     /*  79068 */   // Label 1286: @79068
     /*  79068 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(79154), // Rule ID 3554 //
     /*  79073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pn),
     /*  79081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79097 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10714:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79097 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79100 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79104 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79109 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79113 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WPN),
     /*  79142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79144 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79152 */     GIR_RootConstrainSelectedInstOperands,
     /*  79153 */     // GIR_Coverage, 3554,
     /*  79153 */     GIR_EraseRootFromParent_Done,
     /*  79154 */   // Label 1287: @79154
     /*  79154 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(79240), // Rule ID 3555 //
     /*  79159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2np),
     /*  79167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79183 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10713:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79183 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79186 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79190 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79195 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79199 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WNP),
     /*  79228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79230 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79238 */     GIR_RootConstrainSelectedInstOperands,
     /*  79239 */     // GIR_Coverage, 3555,
     /*  79239 */     GIR_EraseRootFromParent_Done,
     /*  79240 */   // Label 1288: @79240
     /*  79240 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(79326), // Rule ID 3556 //
     /*  79245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2nn),
     /*  79253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79269 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10712:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79269 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79272 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79276 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79281 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79285 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79302 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WNN),
     /*  79314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79316 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79324 */     GIR_RootConstrainSelectedInstOperands,
     /*  79325 */     // GIR_Coverage, 3556,
     /*  79325 */     GIR_EraseRootFromParent_Done,
     /*  79326 */   // Label 1289: @79326
     /*  79326 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(79412), // Rule ID 3558 //
     /*  79331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpp),
     /*  79339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79355 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10720:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79355 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79358 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79362 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79367 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79388 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERPP),
     /*  79400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79402 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79410 */     GIR_RootConstrainSelectedInstOperands,
     /*  79411 */     // GIR_Coverage, 3558,
     /*  79411 */     GIR_EraseRootFromParent_Done,
     /*  79412 */   // Label 1290: @79412
     /*  79412 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(79498), // Rule ID 3559 //
     /*  79417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpn),
     /*  79425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79441 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10719:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79441 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79444 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79448 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79453 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79457 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79474 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERPN),
     /*  79486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79488 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79496 */     GIR_RootConstrainSelectedInstOperands,
     /*  79497 */     // GIR_Coverage, 3559,
     /*  79497 */     GIR_EraseRootFromParent_Done,
     /*  79498 */   // Label 1291: @79498
     /*  79498 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(79584), // Rule ID 3560 //
     /*  79503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernp),
     /*  79511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79527 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10718:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79527 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79530 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79534 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79539 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79543 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79560 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERNP),
     /*  79572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79574 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79582 */     GIR_RootConstrainSelectedInstOperands,
     /*  79583 */     // GIR_Coverage, 3560,
     /*  79583 */     GIR_EraseRootFromParent_Done,
     /*  79584 */   // Label 1292: @79584
     /*  79584 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(79670), // Rule ID 3561 //
     /*  79589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernn),
     /*  79597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79613 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10717:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79613 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79616 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79620 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79625 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERNN),
     /*  79658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79660 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79668 */     GIR_RootConstrainSelectedInstOperands,
     /*  79669 */     // GIR_Coverage, 3561,
     /*  79669 */     GIR_EraseRootFromParent_Done,
     /*  79670 */   // Label 1293: @79670
     /*  79670 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(79734), // Rule ID 3563 //
     /*  79675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpp),
     /*  79683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  79692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79699 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10725:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERPP),
     /*  79723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79725 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79727 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  79729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79732 */     GIR_RootConstrainSelectedInstOperands,
     /*  79733 */     // GIR_Coverage, 3563,
     /*  79733 */     GIR_EraseRootFromParent_Done,
     /*  79734 */   // Label 1294: @79734
     /*  79734 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(79798), // Rule ID 3564 //
     /*  79739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpn),
     /*  79747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  79756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79763 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10724:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79775 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERPN),
     /*  79787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79789 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79791 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  79793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79796 */     GIR_RootConstrainSelectedInstOperands,
     /*  79797 */     // GIR_Coverage, 3564,
     /*  79797 */     GIR_EraseRootFromParent_Done,
     /*  79798 */   // Label 1295: @79798
     /*  79798 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(79862), // Rule ID 3565 //
     /*  79803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernp),
     /*  79811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  79820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79827 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10723:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79839 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNP),
     /*  79851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79853 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79855 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  79857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79860 */     GIR_RootConstrainSelectedInstOperands,
     /*  79861 */     // GIR_Coverage, 3565,
     /*  79861 */     GIR_EraseRootFromParent_Done,
     /*  79862 */   // Label 1296: @79862
     /*  79862 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(79926), // Rule ID 3566 //
     /*  79867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernn),
     /*  79875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  79884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79891 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10722:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNN),
     /*  79915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79917 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79919 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  79921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79924 */     GIR_RootConstrainSelectedInstOperands,
     /*  79925 */     // GIR_Coverage, 3566,
     /*  79925 */     GIR_EraseRootFromParent_Done,
     /*  79926 */   // Label 1297: @79926
     /*  79926 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(80012), // Rule ID 3568 //
     /*  79931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pp),
     /*  79939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79955 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10710:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79955 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79958 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79962 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79967 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2PP),
     /*  80000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80002 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80010 */     GIR_RootConstrainSelectedInstOperands,
     /*  80011 */     // GIR_Coverage, 3568,
     /*  80011 */     GIR_EraseRootFromParent_Done,
     /*  80012 */   // Label 1298: @80012
     /*  80012 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(80098), // Rule ID 3569 //
     /*  80017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pn),
     /*  80025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80041 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10709:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80041 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80044 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80048 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80053 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80074 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2PN),
     /*  80086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80088 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80096 */     GIR_RootConstrainSelectedInstOperands,
     /*  80097 */     // GIR_Coverage, 3569,
     /*  80097 */     GIR_EraseRootFromParent_Done,
     /*  80098 */   // Label 1299: @80098
     /*  80098 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(80184), // Rule ID 3570 //
     /*  80103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2np),
     /*  80111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80127 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10708:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80127 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80130 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80134 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80139 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80143 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80160 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2NP),
     /*  80172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80174 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80182 */     GIR_RootConstrainSelectedInstOperands,
     /*  80183 */     // GIR_Coverage, 3570,
     /*  80183 */     GIR_EraseRootFromParent_Done,
     /*  80184 */   // Label 1300: @80184
     /*  80184 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(80270), // Rule ID 3571 //
     /*  80189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2nn),
     /*  80197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80213 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10707:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80213 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80216 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80220 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80225 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80229 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2NN),
     /*  80258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80260 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80268 */     GIR_RootConstrainSelectedInstOperands,
     /*  80269 */     // GIR_Coverage, 3571,
     /*  80269 */     GIR_EraseRootFromParent_Done,
     /*  80270 */   // Label 1301: @80270
     /*  80270 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(80356), // Rule ID 3573 //
     /*  80275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2pp),
     /*  80283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80299 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10727:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80299 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80302 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80306 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80311 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80315 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2PP),
     /*  80344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80346 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80354 */     GIR_RootConstrainSelectedInstOperands,
     /*  80355 */     // GIR_Coverage, 3573,
     /*  80355 */     GIR_EraseRootFromParent_Done,
     /*  80356 */   // Label 1302: @80356
     /*  80356 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(80442), // Rule ID 3574 //
     /*  80361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4spp),
     /*  80369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80385 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10734:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80397 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80401 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4SPP),
     /*  80430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80432 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80440 */     GIR_RootConstrainSelectedInstOperands,
     /*  80441 */     // GIR_Coverage, 3574,
     /*  80441 */     GIR_EraseRootFromParent_Done,
     /*  80442 */   // Label 1303: @80442
     /*  80442 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(80528), // Rule ID 3576 //
     /*  80447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpp),
     /*  80455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80471 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10720:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80471 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80474 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80478 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80483 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80487 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWPP),
     /*  80516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80518 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80526 */     GIR_RootConstrainSelectedInstOperands,
     /*  80527 */     // GIR_Coverage, 3576,
     /*  80527 */     GIR_EraseRootFromParent_Done,
     /*  80528 */   // Label 1304: @80528
     /*  80528 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(80614), // Rule ID 3577 //
     /*  80533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpn),
     /*  80541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80557 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10719:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80557 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80560 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80564 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80569 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80573 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWPN),
     /*  80602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80604 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80612 */     GIR_RootConstrainSelectedInstOperands,
     /*  80613 */     // GIR_Coverage, 3577,
     /*  80613 */     GIR_EraseRootFromParent_Done,
     /*  80614 */   // Label 1305: @80614
     /*  80614 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(80700), // Rule ID 3578 //
     /*  80619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernp),
     /*  80627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80643 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10718:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80643 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80646 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80650 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80655 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80659 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWNP),
     /*  80688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80690 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80698 */     GIR_RootConstrainSelectedInstOperands,
     /*  80699 */     // GIR_Coverage, 3578,
     /*  80699 */     GIR_EraseRootFromParent_Done,
     /*  80700 */   // Label 1306: @80700
     /*  80700 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(80786), // Rule ID 3579 //
     /*  80705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernn),
     /*  80713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80729 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10717:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80729 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80732 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80736 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80741 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWNN),
     /*  80774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80776 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80784 */     GIR_RootConstrainSelectedInstOperands,
     /*  80785 */     // GIR_Coverage, 3579,
     /*  80785 */     GIR_EraseRootFromParent_Done,
     /*  80786 */   // Label 1307: @80786
     /*  80786 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(80850), // Rule ID 3581 //
     /*  80791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpp),
     /*  80799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80815 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10725:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80827 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWPP),
     /*  80839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80841 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80843 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80848 */     GIR_RootConstrainSelectedInstOperands,
     /*  80849 */     // GIR_Coverage, 3581,
     /*  80849 */     GIR_EraseRootFromParent_Done,
     /*  80850 */   // Label 1308: @80850
     /*  80850 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(80914), // Rule ID 3582 //
     /*  80855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpn),
     /*  80863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80879 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10724:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80891 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWPN),
     /*  80903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80905 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80907 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80912 */     GIR_RootConstrainSelectedInstOperands,
     /*  80913 */     // GIR_Coverage, 3582,
     /*  80913 */     GIR_EraseRootFromParent_Done,
     /*  80914 */   // Label 1309: @80914
     /*  80914 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(80978), // Rule ID 3583 //
     /*  80919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernp),
     /*  80927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80943 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10723:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80955 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNP),
     /*  80967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80969 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80971 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80976 */     GIR_RootConstrainSelectedInstOperands,
     /*  80977 */     // GIR_Coverage, 3583,
     /*  80977 */     GIR_EraseRootFromParent_Done,
     /*  80978 */   // Label 1310: @80978
     /*  80978 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(81042), // Rule ID 3584 //
     /*  80983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernn),
     /*  80991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  81000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81007 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10722:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWNN),
     /*  81031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81033 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81035 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  81037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81040 */     GIR_RootConstrainSelectedInstOperands,
     /*  81041 */     // GIR_Coverage, 3584,
     /*  81041 */     GIR_EraseRootFromParent_Done,
     /*  81042 */   // Label 1311: @81042
     /*  81042 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(81128), // Rule ID 3586 //
     /*  81047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pp),
     /*  81055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81071 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10710:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81087 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WPP),
     /*  81116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81118 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81126 */     GIR_RootConstrainSelectedInstOperands,
     /*  81127 */     // GIR_Coverage, 3586,
     /*  81127 */     GIR_EraseRootFromParent_Done,
     /*  81128 */   // Label 1312: @81128
     /*  81128 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(81214), // Rule ID 3587 //
     /*  81133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pn),
     /*  81141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81157 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10709:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81157 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81160 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81164 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81169 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81173 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WPN),
     /*  81202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81204 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81212 */     GIR_RootConstrainSelectedInstOperands,
     /*  81213 */     // GIR_Coverage, 3587,
     /*  81213 */     GIR_EraseRootFromParent_Done,
     /*  81214 */   // Label 1313: @81214
     /*  81214 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(81300), // Rule ID 3588 //
     /*  81219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2np),
     /*  81227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81243 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10708:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81243 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81246 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81250 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81255 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81259 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WNP),
     /*  81288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81290 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81298 */     GIR_RootConstrainSelectedInstOperands,
     /*  81299 */     // GIR_Coverage, 3588,
     /*  81299 */     GIR_EraseRootFromParent_Done,
     /*  81300 */   // Label 1314: @81300
     /*  81300 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(81386), // Rule ID 3589 //
     /*  81305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2nn),
     /*  81313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81329 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10707:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81329 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81332 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81336 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81341 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81345 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WNN),
     /*  81374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81376 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81384 */     GIR_RootConstrainSelectedInstOperands,
     /*  81385 */     // GIR_Coverage, 3589,
     /*  81385 */     GIR_EraseRootFromParent_Done,
     /*  81386 */   // Label 1315: @81386
     /*  81386 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(81472), // Rule ID 3591 //
     /*  81391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2pp),
     /*  81399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81415 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10727:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81415 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81418 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81422 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81427 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81431 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81448 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2WPP),
     /*  81460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81462 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81470 */     GIR_RootConstrainSelectedInstOperands,
     /*  81471 */     // GIR_Coverage, 3591,
     /*  81471 */     GIR_EraseRootFromParent_Done,
     /*  81472 */   // Label 1316: @81472
     /*  81472 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(81558), // Rule ID 3592 //
     /*  81477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4spp),
     /*  81485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81501 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10734:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4WSPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81501 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81504 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81508 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81513 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81517 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4WSPP),
     /*  81546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81548 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81556 */     GIR_RootConstrainSelectedInstOperands,
     /*  81557 */     // GIR_Coverage, 3592,
     /*  81557 */     GIR_EraseRootFromParent_Done,
     /*  81558 */   // Label 1317: @81558
     /*  81558 */   GIM_Reject,
     /*  81559 */ // Label 1195: @81559
     /*  81559 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(82183),
     /*  81564 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  81567 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(81686), // Rule ID 3604 //
     /*  81572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32ger),
     /*  81580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81611 */     // MIs[1] Operand 1
     /*  81611 */     // No operand predicates
     /*  81611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81619 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81623 */     // MIs[2] Operand 1
     /*  81623 */     // No operand predicates
     /*  81623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81625 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10687:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GER:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  81625 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81628 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81632 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81637 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81641 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  81662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GER),
     /*  81670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81684 */     GIR_RootConstrainSelectedInstOperands,
     /*  81685 */     // GIR_Coverage, 3604,
     /*  81685 */     GIR_EraseRootFromParent_Done,
     /*  81686 */   // Label 1319: @81686
     /*  81686 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(81783), // Rule ID 3609 //
     /*  81691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64ger),
     /*  81699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  81705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81730 */     // MIs[1] Operand 1
     /*  81730 */     // No operand predicates
     /*  81730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81738 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  81742 */     // MIs[2] Operand 1
     /*  81742 */     // No operand predicates
     /*  81742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81744 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10692:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GER:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  81744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GER),
     /*  81768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81770 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  81772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81781 */     GIR_RootConstrainSelectedInstOperands,
     /*  81782 */     // GIR_Coverage, 3609,
     /*  81782 */     GIR_EraseRootFromParent_Done,
     /*  81783 */   // Label 1320: @81783
     /*  81783 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(81902), // Rule ID 3633 //
     /*  81788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  81791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32ger),
     /*  81796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81827 */     // MIs[1] Operand 1
     /*  81827 */     // No operand predicates
     /*  81827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81835 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81839 */     // MIs[2] Operand 1
     /*  81839 */     // No operand predicates
     /*  81839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81841 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10687:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  81841 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81844 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81848 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81853 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81857 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  81878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERW),
     /*  81886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81900 */     GIR_RootConstrainSelectedInstOperands,
     /*  81901 */     // GIR_Coverage, 3633,
     /*  81901 */     GIR_EraseRootFromParent_Done,
     /*  81902 */   // Label 1321: @81902
     /*  81902 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(81999), // Rule ID 3638 //
     /*  81907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  81910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64ger),
     /*  81915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  81921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81946 */     // MIs[1] Operand 1
     /*  81946 */     // No operand predicates
     /*  81946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81954 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  81958 */     // MIs[2] Operand 1
     /*  81958 */     // No operand predicates
     /*  81958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81960 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10692:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERW:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  81960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81972 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERW),
     /*  81984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81986 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  81988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81997 */     GIR_RootConstrainSelectedInstOperands,
     /*  81998 */     // GIR_Coverage, 3638,
     /*  81998 */     GIR_EraseRootFromParent_Done,
     /*  81999 */   // Label 1322: @81999
     /*  81999 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(82046), // Rule ID 1113 //
     /*  82004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  82007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxeval),
     /*  82012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  82015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  82018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  82021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  82024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82028 */     // MIs[0] IMM
     /*  82028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  82031 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10872:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB, v2i64:{ *:[v2i64] }:$XC, (timm:{ *:[i32] }):$IMM)  =>  (XXEVAL:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB, v2i64:{ *:[v2i64] }:$XC, (timm:{ *:[i32] }):$IMM)
     /*  82031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  82034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  82036 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  82038 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  82040 */     GIR_RootToRootCopy, /*OpIdx*/4, // XC
     /*  82042 */     GIR_RootToRootCopy, /*OpIdx*/5, // IMM
     /*  82044 */     GIR_RootConstrainSelectedInstOperands,
     /*  82045 */     // GIR_Coverage, 1113,
     /*  82045 */     GIR_EraseRootFromParent_Done,
     /*  82046 */   // Label 1323: @82046
     /*  82046 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(82182), // Rule ID 3424 //
     /*  82051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  82054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxpermx),
     /*  82059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  82062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  82071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82075 */     // MIs[0] D
     /*  82075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  82078 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10880:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$A, v16i8:{ *:[v16i8] }:$B, v16i8:{ *:[v16i8] }:$C, (timm:{ *:[i32] }):$D)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXPERMX:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$C, VSRC:{ *:[i32] }), ?:{ *:[i32] }:$D), VSRC:{ *:[i32] })
     /*  82078 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  82081 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82085 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82090 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  82094 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82099 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  82102 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82106 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82111 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  82115 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82120 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82123 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82127 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82132 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  82136 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMX),
     /*  82148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82153 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82156 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  82159 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  82162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // D
     /*  82166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82181 */     // GIR_Coverage, 3424,
     /*  82181 */     GIR_EraseRootFromParent_Done,
     /*  82182 */   // Label 1324: @82182
     /*  82182 */   GIM_Reject,
     /*  82183 */ // Label 1318: @82183
     /*  82183 */ GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(85989),
     /*  82188 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  82191 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(82306), // Rule ID 3522 //
     /*  82196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvi8gerx4),
     /*  82204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  82207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  82226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82238 */     // MIs[1] Operand 1
     /*  82238 */     // No operand predicates
     /*  82238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82246 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82250 */     // MIs[2] Operand 1
     /*  82250 */     // No operand predicates
     /*  82250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82258 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82262 */     // MIs[3] Operand 1
     /*  82262 */     // No operand predicates
     /*  82262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82264 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10674:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMDMXVI8GERX4:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  82264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVI8GERX4),
     /*  82288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82290 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  82292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82304 */     GIR_RootConstrainSelectedInstOperands,
     /*  82305 */     // GIR_Coverage, 3522,
     /*  82305 */     GIR_EraseRootFromParent_Done,
     /*  82306 */   // Label 1326: @82306
     /*  82306 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(82421), // Rule ID 3525 //
     /*  82311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2),
     /*  82319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  82322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  82341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82353 */     // MIs[1] Operand 1
     /*  82353 */     // No operand predicates
     /*  82353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82361 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82365 */     // MIs[2] Operand 1
     /*  82365 */     // No operand predicates
     /*  82365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82373 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82377 */     // MIs[3] Operand 1
     /*  82377 */     // No operand predicates
     /*  82377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82379 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10664:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2),
     /*  82403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82405 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  82407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82419 */     GIR_RootConstrainSelectedInstOperands,
     /*  82420 */     // GIR_Coverage, 3525,
     /*  82420 */     GIR_EraseRootFromParent_Done,
     /*  82421 */   // Label 1327: @82421
     /*  82421 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(82536), // Rule ID 3530 //
     /*  82426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2),
     /*  82434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  82437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  82456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82464 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82468 */     // MIs[1] Operand 1
     /*  82468 */     // No operand predicates
     /*  82468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82476 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82480 */     // MIs[2] Operand 1
     /*  82480 */     // No operand predicates
     /*  82480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82488 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82492 */     // MIs[3] Operand 1
     /*  82492 */     // No operand predicates
     /*  82492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82494 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10669:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2),
     /*  82518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82520 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  82522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82534 */     GIR_RootConstrainSelectedInstOperands,
     /*  82535 */     // GIR_Coverage, 3530,
     /*  82535 */     GIR_EraseRootFromParent_Done,
     /*  82536 */   // Label 1328: @82536
     /*  82536 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(82673), // Rule ID 3593 //
     /*  82541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  82544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8),
     /*  82549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82583 */     // MIs[1] Operand 1
     /*  82583 */     // No operand predicates
     /*  82583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82591 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82595 */     // MIs[2] Operand 1
     /*  82595 */     // No operand predicates
     /*  82595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82603 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82607 */     // MIs[3] Operand 1
     /*  82607 */     // No operand predicates
     /*  82607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82609 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10701:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  82609 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82612 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82616 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82621 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82625 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8),
     /*  82654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82671 */     GIR_RootConstrainSelectedInstOperands,
     /*  82672 */     // GIR_Coverage, 3593,
     /*  82672 */     GIR_EraseRootFromParent_Done,
     /*  82673 */   // Label 1329: @82673
     /*  82673 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(82810), // Rule ID 3595 //
     /*  82678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  82681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4),
     /*  82686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82720 */     // MIs[1] Operand 1
     /*  82720 */     // No operand predicates
     /*  82720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82728 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82732 */     // MIs[2] Operand 1
     /*  82732 */     // No operand predicates
     /*  82732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82740 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82744 */     // MIs[3] Operand 1
     /*  82744 */     // No operand predicates
     /*  82744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82746 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10703:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  82746 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82749 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82753 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82758 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82762 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4),
     /*  82791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82808 */     GIR_RootConstrainSelectedInstOperands,
     /*  82809 */     // GIR_Coverage, 3595,
     /*  82809 */     GIR_EraseRootFromParent_Done,
     /*  82810 */   // Label 1330: @82810
     /*  82810 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(82947), // Rule ID 3597 //
     /*  82815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  82818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2s),
     /*  82823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82857 */     // MIs[1] Operand 1
     /*  82857 */     // No operand predicates
     /*  82857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82865 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82869 */     // MIs[2] Operand 1
     /*  82869 */     // No operand predicates
     /*  82869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82877 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82881 */     // MIs[3] Operand 1
     /*  82881 */     // No operand predicates
     /*  82881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82883 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10699:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2S:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82883 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82886 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82890 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82895 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82899 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2S),
     /*  82928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82945 */     GIR_RootConstrainSelectedInstOperands,
     /*  82946 */     // GIR_Coverage, 3597,
     /*  82946 */     GIR_EraseRootFromParent_Done,
     /*  82947 */   // Label 1331: @82947
     /*  82947 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(83084), // Rule ID 3599 //
     /*  82952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  82955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2),
     /*  82960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82994 */     // MIs[1] Operand 1
     /*  82994 */     // No operand predicates
     /*  82994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83002 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83006 */     // MIs[2] Operand 1
     /*  83006 */     // No operand predicates
     /*  83006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83014 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83018 */     // MIs[3] Operand 1
     /*  83018 */     // No operand predicates
     /*  83018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83020 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10682:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83020 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83023 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83027 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83032 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83053 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2),
     /*  83065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83082 */     GIR_RootConstrainSelectedInstOperands,
     /*  83083 */     // GIR_Coverage, 3599,
     /*  83083 */     GIR_EraseRootFromParent_Done,
     /*  83084 */   // Label 1332: @83084
     /*  83084 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(83221), // Rule ID 3614 //
     /*  83089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2),
     /*  83097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83131 */     // MIs[1] Operand 1
     /*  83131 */     // No operand predicates
     /*  83131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83139 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83143 */     // MIs[2] Operand 1
     /*  83143 */     // No operand predicates
     /*  83143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83151 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83155 */     // MIs[3] Operand 1
     /*  83155 */     // No operand predicates
     /*  83155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83157 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10677:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83157 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83160 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83164 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83169 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83173 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2),
     /*  83202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83219 */     GIR_RootConstrainSelectedInstOperands,
     /*  83220 */     // GIR_Coverage, 3614,
     /*  83220 */     GIR_EraseRootFromParent_Done,
     /*  83221 */   // Label 1333: @83221
     /*  83221 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(83358), // Rule ID 3619 //
     /*  83226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2),
     /*  83234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83268 */     // MIs[1] Operand 1
     /*  83268 */     // No operand predicates
     /*  83268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83276 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83280 */     // MIs[2] Operand 1
     /*  83280 */     // No operand predicates
     /*  83280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83288 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83292 */     // MIs[3] Operand 1
     /*  83292 */     // No operand predicates
     /*  83292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83294 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10697:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83294 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83297 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83301 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83306 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83310 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83327 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2),
     /*  83339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83356 */     GIR_RootConstrainSelectedInstOperands,
     /*  83357 */     // GIR_Coverage, 3619,
     /*  83357 */     GIR_EraseRootFromParent_Done,
     /*  83358 */   // Label 1334: @83358
     /*  83358 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(83495), // Rule ID 3622 //
     /*  83363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8),
     /*  83371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83405 */     // MIs[1] Operand 1
     /*  83405 */     // No operand predicates
     /*  83405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83413 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83417 */     // MIs[2] Operand 1
     /*  83417 */     // No operand predicates
     /*  83417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83425 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  83429 */     // MIs[3] Operand 1
     /*  83429 */     // No operand predicates
     /*  83429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83431 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10701:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  83431 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83434 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83438 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83443 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83447 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83464 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8W),
     /*  83476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83493 */     GIR_RootConstrainSelectedInstOperands,
     /*  83494 */     // GIR_Coverage, 3622,
     /*  83494 */     GIR_EraseRootFromParent_Done,
     /*  83495 */   // Label 1335: @83495
     /*  83495 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(83632), // Rule ID 3624 //
     /*  83500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4),
     /*  83508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83542 */     // MIs[1] Operand 1
     /*  83542 */     // No operand predicates
     /*  83542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83550 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83554 */     // MIs[2] Operand 1
     /*  83554 */     // No operand predicates
     /*  83554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83562 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83566 */     // MIs[3] Operand 1
     /*  83566 */     // No operand predicates
     /*  83566 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83568 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10703:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  83568 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83571 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83575 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83580 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4W),
     /*  83613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83630 */     GIR_RootConstrainSelectedInstOperands,
     /*  83631 */     // GIR_Coverage, 3624,
     /*  83631 */     GIR_EraseRootFromParent_Done,
     /*  83632 */   // Label 1336: @83632
     /*  83632 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(83769), // Rule ID 3626 //
     /*  83637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2s),
     /*  83645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83679 */     // MIs[1] Operand 1
     /*  83679 */     // No operand predicates
     /*  83679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83687 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83691 */     // MIs[2] Operand 1
     /*  83691 */     // No operand predicates
     /*  83691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83699 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83703 */     // MIs[3] Operand 1
     /*  83703 */     // No operand predicates
     /*  83703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83705 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10699:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83717 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83721 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SW),
     /*  83750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83767 */     GIR_RootConstrainSelectedInstOperands,
     /*  83768 */     // GIR_Coverage, 3626,
     /*  83768 */     GIR_EraseRootFromParent_Done,
     /*  83769 */   // Label 1337: @83769
     /*  83769 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(83906), // Rule ID 3628 //
     /*  83774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2),
     /*  83782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83816 */     // MIs[1] Operand 1
     /*  83816 */     // No operand predicates
     /*  83816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83824 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83828 */     // MIs[2] Operand 1
     /*  83828 */     // No operand predicates
     /*  83828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83836 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83840 */     // MIs[3] Operand 1
     /*  83840 */     // No operand predicates
     /*  83840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83842 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10682:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83842 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83845 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83849 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83854 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83875 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2W),
     /*  83887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83904 */     GIR_RootConstrainSelectedInstOperands,
     /*  83905 */     // GIR_Coverage, 3628,
     /*  83905 */     GIR_EraseRootFromParent_Done,
     /*  83906 */   // Label 1338: @83906
     /*  83906 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(84043), // Rule ID 3643 //
     /*  83911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2),
     /*  83919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83953 */     // MIs[1] Operand 1
     /*  83953 */     // No operand predicates
     /*  83953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83961 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83965 */     // MIs[2] Operand 1
     /*  83965 */     // No operand predicates
     /*  83965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83973 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83977 */     // MIs[3] Operand 1
     /*  83977 */     // No operand predicates
     /*  83977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83979 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10677:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83979 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83982 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83986 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83991 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83995 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  84016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2W),
     /*  84024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  84041 */     GIR_RootConstrainSelectedInstOperands,
     /*  84042 */     // GIR_Coverage, 3643,
     /*  84042 */     GIR_EraseRootFromParent_Done,
     /*  84043 */   // Label 1339: @84043
     /*  84043 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(84180), // Rule ID 3648 //
     /*  84048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2),
     /*  84056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  84082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84090 */     // MIs[1] Operand 1
     /*  84090 */     // No operand predicates
     /*  84090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  84094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84098 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84102 */     // MIs[2] Operand 1
     /*  84102 */     // No operand predicates
     /*  84102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  84106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84110 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84114 */     // MIs[3] Operand 1
     /*  84114 */     // No operand predicates
     /*  84114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84116 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10697:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  84116 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84119 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84123 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84128 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  84132 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84149 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  84153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2W),
     /*  84161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  84178 */     GIR_RootConstrainSelectedInstOperands,
     /*  84179 */     // GIR_Coverage, 3648,
     /*  84179 */     GIR_EraseRootFromParent_Done,
     /*  84180 */   // Label 1340: @84180
     /*  84180 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(84304), // Rule ID 3605 //
     /*  84185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpp),
     /*  84193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84227 */     // MIs[1] Operand 1
     /*  84227 */     // No operand predicates
     /*  84227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84235 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84239 */     // MIs[2] Operand 1
     /*  84239 */     // No operand predicates
     /*  84239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84241 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10691:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84241 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84244 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84248 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84253 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84257 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERPP),
     /*  84286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84288 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84302 */     GIR_RootConstrainSelectedInstOperands,
     /*  84303 */     // GIR_Coverage, 3605,
     /*  84303 */     GIR_EraseRootFromParent_Done,
     /*  84304 */   // Label 1341: @84304
     /*  84304 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(84428), // Rule ID 3606 //
     /*  84309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpn),
     /*  84317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84351 */     // MIs[1] Operand 1
     /*  84351 */     // No operand predicates
     /*  84351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84359 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84363 */     // MIs[2] Operand 1
     /*  84363 */     // No operand predicates
     /*  84363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84365 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10690:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84365 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84368 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84372 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84377 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERPN),
     /*  84410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84412 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84426 */     GIR_RootConstrainSelectedInstOperands,
     /*  84427 */     // GIR_Coverage, 3606,
     /*  84427 */     GIR_EraseRootFromParent_Done,
     /*  84428 */   // Label 1342: @84428
     /*  84428 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(84552), // Rule ID 3607 //
     /*  84433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernp),
     /*  84441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84475 */     // MIs[1] Operand 1
     /*  84475 */     // No operand predicates
     /*  84475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84483 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84487 */     // MIs[2] Operand 1
     /*  84487 */     // No operand predicates
     /*  84487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84489 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10689:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84489 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84492 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84496 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84501 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERNP),
     /*  84534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84536 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84550 */     GIR_RootConstrainSelectedInstOperands,
     /*  84551 */     // GIR_Coverage, 3607,
     /*  84551 */     GIR_EraseRootFromParent_Done,
     /*  84552 */   // Label 1343: @84552
     /*  84552 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(84676), // Rule ID 3608 //
     /*  84557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernn),
     /*  84565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84599 */     // MIs[1] Operand 1
     /*  84599 */     // No operand predicates
     /*  84599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84607 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84611 */     // MIs[2] Operand 1
     /*  84611 */     // No operand predicates
     /*  84611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84613 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10688:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84613 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84616 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84620 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84625 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERNN),
     /*  84658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84660 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84674 */     GIR_RootConstrainSelectedInstOperands,
     /*  84675 */     // GIR_Coverage, 3608,
     /*  84675 */     GIR_EraseRootFromParent_Done,
     /*  84676 */   // Label 1344: @84676
     /*  84676 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(84778), // Rule ID 3610 //
     /*  84681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpp),
     /*  84689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  84698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84723 */     // MIs[1] Operand 1
     /*  84723 */     // No operand predicates
     /*  84723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84731 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84735 */     // MIs[2] Operand 1
     /*  84735 */     // No operand predicates
     /*  84735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84737 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10696:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  84737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84749 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERPP),
     /*  84761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84763 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84765 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  84767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84776 */     GIR_RootConstrainSelectedInstOperands,
     /*  84777 */     // GIR_Coverage, 3610,
     /*  84777 */     GIR_EraseRootFromParent_Done,
     /*  84778 */   // Label 1345: @84778
     /*  84778 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(84880), // Rule ID 3611 //
     /*  84783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpn),
     /*  84791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  84800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84825 */     // MIs[1] Operand 1
     /*  84825 */     // No operand predicates
     /*  84825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84833 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84837 */     // MIs[2] Operand 1
     /*  84837 */     // No operand predicates
     /*  84837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84839 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10695:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  84839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84851 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERPN),
     /*  84863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84865 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84867 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  84869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84878 */     GIR_RootConstrainSelectedInstOperands,
     /*  84879 */     // GIR_Coverage, 3611,
     /*  84879 */     GIR_EraseRootFromParent_Done,
     /*  84880 */   // Label 1346: @84880
     /*  84880 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(84982), // Rule ID 3612 //
     /*  84885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernp),
     /*  84893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  84902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84927 */     // MIs[1] Operand 1
     /*  84927 */     // No operand predicates
     /*  84927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84935 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84939 */     // MIs[2] Operand 1
     /*  84939 */     // No operand predicates
     /*  84939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84941 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10694:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  84941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84953 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERNP),
     /*  84965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84967 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84969 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  84971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84980 */     GIR_RootConstrainSelectedInstOperands,
     /*  84981 */     // GIR_Coverage, 3612,
     /*  84981 */     GIR_EraseRootFromParent_Done,
     /*  84982 */   // Label 1347: @84982
     /*  84982 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(85084), // Rule ID 3613 //
     /*  84987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernn),
     /*  84995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85029 */     // MIs[1] Operand 1
     /*  85029 */     // No operand predicates
     /*  85029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85037 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85041 */     // MIs[2] Operand 1
     /*  85041 */     // No operand predicates
     /*  85041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85043 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10693:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85055 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERNN),
     /*  85067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85069 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85071 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85082 */     GIR_RootConstrainSelectedInstOperands,
     /*  85083 */     // GIR_Coverage, 3613,
     /*  85083 */     GIR_EraseRootFromParent_Done,
     /*  85084 */   // Label 1348: @85084
     /*  85084 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(85208), // Rule ID 3634 //
     /*  85089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpp),
     /*  85097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85131 */     // MIs[1] Operand 1
     /*  85131 */     // No operand predicates
     /*  85131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85139 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85143 */     // MIs[2] Operand 1
     /*  85143 */     // No operand predicates
     /*  85143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85145 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10691:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85145 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85148 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85152 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85157 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85161 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWPP),
     /*  85190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85192 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85206 */     GIR_RootConstrainSelectedInstOperands,
     /*  85207 */     // GIR_Coverage, 3634,
     /*  85207 */     GIR_EraseRootFromParent_Done,
     /*  85208 */   // Label 1349: @85208
     /*  85208 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(85332), // Rule ID 3635 //
     /*  85213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpn),
     /*  85221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85255 */     // MIs[1] Operand 1
     /*  85255 */     // No operand predicates
     /*  85255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85263 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85267 */     // MIs[2] Operand 1
     /*  85267 */     // No operand predicates
     /*  85267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85269 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10690:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85269 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85272 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85276 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85281 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85285 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85302 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWPN),
     /*  85314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85316 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85330 */     GIR_RootConstrainSelectedInstOperands,
     /*  85331 */     // GIR_Coverage, 3635,
     /*  85331 */     GIR_EraseRootFromParent_Done,
     /*  85332 */   // Label 1350: @85332
     /*  85332 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(85456), // Rule ID 3636 //
     /*  85337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernp),
     /*  85345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85379 */     // MIs[1] Operand 1
     /*  85379 */     // No operand predicates
     /*  85379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85391 */     // MIs[2] Operand 1
     /*  85391 */     // No operand predicates
     /*  85391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85393 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10689:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85393 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85396 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85400 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85405 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85409 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWNP),
     /*  85438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85440 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85454 */     GIR_RootConstrainSelectedInstOperands,
     /*  85455 */     // GIR_Coverage, 3636,
     /*  85455 */     GIR_EraseRootFromParent_Done,
     /*  85456 */   // Label 1351: @85456
     /*  85456 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(85580), // Rule ID 3637 //
     /*  85461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernn),
     /*  85469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85503 */     // MIs[1] Operand 1
     /*  85503 */     // No operand predicates
     /*  85503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85511 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85515 */     // MIs[2] Operand 1
     /*  85515 */     // No operand predicates
     /*  85515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85517 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10688:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85517 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85520 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85524 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85529 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85533 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85550 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWNN),
     /*  85562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85564 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85578 */     GIR_RootConstrainSelectedInstOperands,
     /*  85579 */     // GIR_Coverage, 3637,
     /*  85579 */     GIR_EraseRootFromParent_Done,
     /*  85580 */   // Label 1352: @85580
     /*  85580 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(85682), // Rule ID 3639 //
     /*  85585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpp),
     /*  85593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85627 */     // MIs[1] Operand 1
     /*  85627 */     // No operand predicates
     /*  85627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85635 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85639 */     // MIs[2] Operand 1
     /*  85639 */     // No operand predicates
     /*  85639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85641 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10696:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85653 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWPP),
     /*  85665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85667 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85669 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85680 */     GIR_RootConstrainSelectedInstOperands,
     /*  85681 */     // GIR_Coverage, 3639,
     /*  85681 */     GIR_EraseRootFromParent_Done,
     /*  85682 */   // Label 1353: @85682
     /*  85682 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(85784), // Rule ID 3640 //
     /*  85687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpn),
     /*  85695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85729 */     // MIs[1] Operand 1
     /*  85729 */     // No operand predicates
     /*  85729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85737 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85741 */     // MIs[2] Operand 1
     /*  85741 */     // No operand predicates
     /*  85741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85743 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10695:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWPN),
     /*  85767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85769 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85771 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85782 */     GIR_RootConstrainSelectedInstOperands,
     /*  85783 */     // GIR_Coverage, 3640,
     /*  85783 */     GIR_EraseRootFromParent_Done,
     /*  85784 */   // Label 1354: @85784
     /*  85784 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(85886), // Rule ID 3641 //
     /*  85789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernp),
     /*  85797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85831 */     // MIs[1] Operand 1
     /*  85831 */     // No operand predicates
     /*  85831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85839 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85843 */     // MIs[2] Operand 1
     /*  85843 */     // No operand predicates
     /*  85843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85845 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10694:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWNP),
     /*  85869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85871 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85873 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85884 */     GIR_RootConstrainSelectedInstOperands,
     /*  85885 */     // GIR_Coverage, 3641,
     /*  85885 */     GIR_EraseRootFromParent_Done,
     /*  85886 */   // Label 1355: @85886
     /*  85886 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(85988), // Rule ID 3642 //
     /*  85891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernn),
     /*  85899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85933 */     // MIs[1] Operand 1
     /*  85933 */     // No operand predicates
     /*  85933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85941 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85945 */     // MIs[2] Operand 1
     /*  85945 */     // No operand predicates
     /*  85945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85947 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10693:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85959 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWNN),
     /*  85971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85973 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85975 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85986 */     GIR_RootConstrainSelectedInstOperands,
     /*  85987 */     // GIR_Coverage, 3642,
     /*  85987 */     GIR_EraseRootFromParent_Done,
     /*  85988 */   // Label 1356: @85988
     /*  85988 */   GIM_Reject,
     /*  85989 */ // Label 1325: @85989
     /*  85989 */ GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(90890),
     /*  85994 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  85997 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(86117), // Rule ID 3523 //
     /*  86002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvi8gerx4pp),
     /*  86010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86047 */     // MIs[1] Operand 1
     /*  86047 */     // No operand predicates
     /*  86047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86055 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86059 */     // MIs[2] Operand 1
     /*  86059 */     // No operand predicates
     /*  86059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86067 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86071 */     // MIs[3] Operand 1
     /*  86071 */     // No operand predicates
     /*  86071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86073 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10675:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMDMXVI8GERX4PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  86073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVI8GERX4PP),
     /*  86097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86099 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86101 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86115 */     GIR_RootConstrainSelectedInstOperands,
     /*  86116 */     // GIR_Coverage, 3523,
     /*  86116 */     GIR_EraseRootFromParent_Done,
     /*  86117 */   // Label 1358: @86117
     /*  86117 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(86237), // Rule ID 3524 //
     /*  86122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvi8gerx4spp),
     /*  86130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86167 */     // MIs[1] Operand 1
     /*  86167 */     // No operand predicates
     /*  86167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86175 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86179 */     // MIs[2] Operand 1
     /*  86179 */     // No operand predicates
     /*  86179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86187 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86191 */     // MIs[3] Operand 1
     /*  86191 */     // No operand predicates
     /*  86191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86193 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10676:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMDMXVI8GERX4SPP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  86193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVI8GERX4SPP),
     /*  86217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86219 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86221 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86235 */     GIR_RootConstrainSelectedInstOperands,
     /*  86236 */     // GIR_Coverage, 3524,
     /*  86236 */     GIR_EraseRootFromParent_Done,
     /*  86237 */   // Label 1359: @86237
     /*  86237 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(86357), // Rule ID 3526 //
     /*  86242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2pp),
     /*  86250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86287 */     // MIs[1] Operand 1
     /*  86287 */     // No operand predicates
     /*  86287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86295 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86299 */     // MIs[2] Operand 1
     /*  86299 */     // No operand predicates
     /*  86299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86307 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86311 */     // MIs[3] Operand 1
     /*  86311 */     // No operand predicates
     /*  86311 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86313 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10668:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2PP),
     /*  86337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86339 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86341 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86355 */     GIR_RootConstrainSelectedInstOperands,
     /*  86356 */     // GIR_Coverage, 3526,
     /*  86356 */     GIR_EraseRootFromParent_Done,
     /*  86357 */   // Label 1360: @86357
     /*  86357 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(86477), // Rule ID 3527 //
     /*  86362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2pn),
     /*  86370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86407 */     // MIs[1] Operand 1
     /*  86407 */     // No operand predicates
     /*  86407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86415 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86419 */     // MIs[2] Operand 1
     /*  86419 */     // No operand predicates
     /*  86419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86427 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86431 */     // MIs[3] Operand 1
     /*  86431 */     // No operand predicates
     /*  86431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86433 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10667:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86445 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2PN),
     /*  86457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86459 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86461 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86475 */     GIR_RootConstrainSelectedInstOperands,
     /*  86476 */     // GIR_Coverage, 3527,
     /*  86476 */     GIR_EraseRootFromParent_Done,
     /*  86477 */   // Label 1361: @86477
     /*  86477 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(86597), // Rule ID 3528 //
     /*  86482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2np),
     /*  86490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86527 */     // MIs[1] Operand 1
     /*  86527 */     // No operand predicates
     /*  86527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86535 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86539 */     // MIs[2] Operand 1
     /*  86539 */     // No operand predicates
     /*  86539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86547 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86551 */     // MIs[3] Operand 1
     /*  86551 */     // No operand predicates
     /*  86551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86553 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10666:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2NP),
     /*  86577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86579 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86581 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86595 */     GIR_RootConstrainSelectedInstOperands,
     /*  86596 */     // GIR_Coverage, 3528,
     /*  86596 */     GIR_EraseRootFromParent_Done,
     /*  86597 */   // Label 1362: @86597
     /*  86597 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(86717), // Rule ID 3529 //
     /*  86602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2nn),
     /*  86610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86647 */     // MIs[1] Operand 1
     /*  86647 */     // No operand predicates
     /*  86647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86655 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86659 */     // MIs[2] Operand 1
     /*  86659 */     // No operand predicates
     /*  86659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86667 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86671 */     // MIs[3] Operand 1
     /*  86671 */     // No operand predicates
     /*  86671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86673 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10665:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2NN),
     /*  86697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86699 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86701 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86715 */     GIR_RootConstrainSelectedInstOperands,
     /*  86716 */     // GIR_Coverage, 3529,
     /*  86716 */     GIR_EraseRootFromParent_Done,
     /*  86717 */   // Label 1363: @86717
     /*  86717 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(86837), // Rule ID 3531 //
     /*  86722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2pp),
     /*  86730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86767 */     // MIs[1] Operand 1
     /*  86767 */     // No operand predicates
     /*  86767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86775 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86779 */     // MIs[2] Operand 1
     /*  86779 */     // No operand predicates
     /*  86779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86787 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86791 */     // MIs[3] Operand 1
     /*  86791 */     // No operand predicates
     /*  86791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86793 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10673:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2PP),
     /*  86817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86819 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86821 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86835 */     GIR_RootConstrainSelectedInstOperands,
     /*  86836 */     // GIR_Coverage, 3531,
     /*  86836 */     GIR_EraseRootFromParent_Done,
     /*  86837 */   // Label 1364: @86837
     /*  86837 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(86957), // Rule ID 3532 //
     /*  86842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2pn),
     /*  86850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86887 */     // MIs[1] Operand 1
     /*  86887 */     // No operand predicates
     /*  86887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86895 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86899 */     // MIs[2] Operand 1
     /*  86899 */     // No operand predicates
     /*  86899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86903 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86907 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86911 */     // MIs[3] Operand 1
     /*  86911 */     // No operand predicates
     /*  86911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86913 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10672:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86925 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2PN),
     /*  86937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86939 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86941 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86955 */     GIR_RootConstrainSelectedInstOperands,
     /*  86956 */     // GIR_Coverage, 3532,
     /*  86956 */     GIR_EraseRootFromParent_Done,
     /*  86957 */   // Label 1365: @86957
     /*  86957 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(87077), // Rule ID 3533 //
     /*  86962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2np),
     /*  86970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87007 */     // MIs[1] Operand 1
     /*  87007 */     // No operand predicates
     /*  87007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87015 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87019 */     // MIs[2] Operand 1
     /*  87019 */     // No operand predicates
     /*  87019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87027 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87031 */     // MIs[3] Operand 1
     /*  87031 */     // No operand predicates
     /*  87031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87033 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10671:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87045 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2NP),
     /*  87057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87059 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87061 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87075 */     GIR_RootConstrainSelectedInstOperands,
     /*  87076 */     // GIR_Coverage, 3533,
     /*  87076 */     GIR_EraseRootFromParent_Done,
     /*  87077 */   // Label 1366: @87077
     /*  87077 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(87197), // Rule ID 3534 //
     /*  87082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2nn),
     /*  87090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  87093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  87096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  87099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  87115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87127 */     // MIs[1] Operand 1
     /*  87127 */     // No operand predicates
     /*  87127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87135 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87139 */     // MIs[2] Operand 1
     /*  87139 */     // No operand predicates
     /*  87139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87147 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87151 */     // MIs[3] Operand 1
     /*  87151 */     // No operand predicates
     /*  87151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87153 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10670:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87165 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2NN),
     /*  87177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87179 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87181 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87195 */     GIR_RootConstrainSelectedInstOperands,
     /*  87196 */     // GIR_Coverage, 3534,
     /*  87196 */     GIR_EraseRootFromParent_Done,
     /*  87197 */   // Label 1367: @87197
     /*  87197 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(87339), // Rule ID 3594 //
     /*  87202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8pp),
     /*  87210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87247 */     // MIs[1] Operand 1
     /*  87247 */     // No operand predicates
     /*  87247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87255 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87259 */     // MIs[2] Operand 1
     /*  87259 */     // No operand predicates
     /*  87259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87267 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87271 */     // MIs[3] Operand 1
     /*  87271 */     // No operand predicates
     /*  87271 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87273 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10702:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  87273 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87276 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87280 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87285 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8PP),
     /*  87318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87320 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87337 */     GIR_RootConstrainSelectedInstOperands,
     /*  87338 */     // GIR_Coverage, 3594,
     /*  87338 */     GIR_EraseRootFromParent_Done,
     /*  87339 */   // Label 1368: @87339
     /*  87339 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(87481), // Rule ID 3596 //
     /*  87344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4pp),
     /*  87352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87389 */     // MIs[1] Operand 1
     /*  87389 */     // No operand predicates
     /*  87389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87397 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87401 */     // MIs[2] Operand 1
     /*  87401 */     // No operand predicates
     /*  87401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87409 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87413 */     // MIs[3] Operand 1
     /*  87413 */     // No operand predicates
     /*  87413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87415 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10704:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  87415 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87418 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87422 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87427 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87431 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87448 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4PP),
     /*  87460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87462 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87479 */     GIR_RootConstrainSelectedInstOperands,
     /*  87480 */     // GIR_Coverage, 3596,
     /*  87480 */     GIR_EraseRootFromParent_Done,
     /*  87481 */   // Label 1369: @87481
     /*  87481 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(87623), // Rule ID 3598 //
     /*  87486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2spp),
     /*  87494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87531 */     // MIs[1] Operand 1
     /*  87531 */     // No operand predicates
     /*  87531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87539 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87543 */     // MIs[2] Operand 1
     /*  87543 */     // No operand predicates
     /*  87543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87551 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87555 */     // MIs[3] Operand 1
     /*  87555 */     // No operand predicates
     /*  87555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87557 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10700:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87557 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87560 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87564 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87569 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87573 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SPP),
     /*  87602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87604 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87621 */     GIR_RootConstrainSelectedInstOperands,
     /*  87622 */     // GIR_Coverage, 3598,
     /*  87622 */     GIR_EraseRootFromParent_Done,
     /*  87623 */   // Label 1370: @87623
     /*  87623 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(87765), // Rule ID 3600 //
     /*  87628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pp),
     /*  87636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87673 */     // MIs[1] Operand 1
     /*  87673 */     // No operand predicates
     /*  87673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87681 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87685 */     // MIs[2] Operand 1
     /*  87685 */     // No operand predicates
     /*  87685 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87689 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87693 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87697 */     // MIs[3] Operand 1
     /*  87697 */     // No operand predicates
     /*  87697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87699 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10686:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87699 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87702 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87706 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87711 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87715 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87732 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2PP),
     /*  87744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87746 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87763 */     GIR_RootConstrainSelectedInstOperands,
     /*  87764 */     // GIR_Coverage, 3600,
     /*  87764 */     GIR_EraseRootFromParent_Done,
     /*  87765 */   // Label 1371: @87765
     /*  87765 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(87907), // Rule ID 3601 //
     /*  87770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pn),
     /*  87778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87815 */     // MIs[1] Operand 1
     /*  87815 */     // No operand predicates
     /*  87815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87823 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87827 */     // MIs[2] Operand 1
     /*  87827 */     // No operand predicates
     /*  87827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87835 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87839 */     // MIs[3] Operand 1
     /*  87839 */     // No operand predicates
     /*  87839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87841 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10685:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87841 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87844 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87848 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87853 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87857 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2PN),
     /*  87886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87888 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87905 */     GIR_RootConstrainSelectedInstOperands,
     /*  87906 */     // GIR_Coverage, 3601,
     /*  87906 */     GIR_EraseRootFromParent_Done,
     /*  87907 */   // Label 1372: @87907
     /*  87907 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(88049), // Rule ID 3602 //
     /*  87912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2np),
     /*  87920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87957 */     // MIs[1] Operand 1
     /*  87957 */     // No operand predicates
     /*  87957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87965 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87969 */     // MIs[2] Operand 1
     /*  87969 */     // No operand predicates
     /*  87969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87977 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87981 */     // MIs[3] Operand 1
     /*  87981 */     // No operand predicates
     /*  87981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87983 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10684:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87983 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87986 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87990 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87995 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2NP),
     /*  88028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88030 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88047 */     GIR_RootConstrainSelectedInstOperands,
     /*  88048 */     // GIR_Coverage, 3602,
     /*  88048 */     GIR_EraseRootFromParent_Done,
     /*  88049 */   // Label 1373: @88049
     /*  88049 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(88191), // Rule ID 3603 //
     /*  88054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2nn),
     /*  88062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88099 */     // MIs[1] Operand 1
     /*  88099 */     // No operand predicates
     /*  88099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88107 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88111 */     // MIs[2] Operand 1
     /*  88111 */     // No operand predicates
     /*  88111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88119 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88123 */     // MIs[3] Operand 1
     /*  88123 */     // No operand predicates
     /*  88123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88125 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10683:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88125 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88128 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88132 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88137 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88141 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2NN),
     /*  88170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88172 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88189 */     GIR_RootConstrainSelectedInstOperands,
     /*  88190 */     // GIR_Coverage, 3603,
     /*  88190 */     GIR_EraseRootFromParent_Done,
     /*  88191 */   // Label 1374: @88191
     /*  88191 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(88333), // Rule ID 3615 //
     /*  88196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pp),
     /*  88204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88241 */     // MIs[1] Operand 1
     /*  88241 */     // No operand predicates
     /*  88241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88249 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88253 */     // MIs[2] Operand 1
     /*  88253 */     // No operand predicates
     /*  88253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88261 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88265 */     // MIs[3] Operand 1
     /*  88265 */     // No operand predicates
     /*  88265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88267 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10681:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88267 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88270 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88274 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88279 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2PP),
     /*  88312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88314 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88331 */     GIR_RootConstrainSelectedInstOperands,
     /*  88332 */     // GIR_Coverage, 3615,
     /*  88332 */     GIR_EraseRootFromParent_Done,
     /*  88333 */   // Label 1375: @88333
     /*  88333 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(88475), // Rule ID 3616 //
     /*  88338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pn),
     /*  88346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88383 */     // MIs[1] Operand 1
     /*  88383 */     // No operand predicates
     /*  88383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88391 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88395 */     // MIs[2] Operand 1
     /*  88395 */     // No operand predicates
     /*  88395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88403 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88407 */     // MIs[3] Operand 1
     /*  88407 */     // No operand predicates
     /*  88407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88409 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10680:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88409 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88412 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88416 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88421 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88425 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2PN),
     /*  88454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88456 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88473 */     GIR_RootConstrainSelectedInstOperands,
     /*  88474 */     // GIR_Coverage, 3616,
     /*  88474 */     GIR_EraseRootFromParent_Done,
     /*  88475 */   // Label 1376: @88475
     /*  88475 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(88617), // Rule ID 3617 //
     /*  88480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2np),
     /*  88488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88525 */     // MIs[1] Operand 1
     /*  88525 */     // No operand predicates
     /*  88525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88533 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88537 */     // MIs[2] Operand 1
     /*  88537 */     // No operand predicates
     /*  88537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88545 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88549 */     // MIs[3] Operand 1
     /*  88549 */     // No operand predicates
     /*  88549 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88551 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10679:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88551 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88554 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88558 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88563 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88567 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2NP),
     /*  88596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88598 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88615 */     GIR_RootConstrainSelectedInstOperands,
     /*  88616 */     // GIR_Coverage, 3617,
     /*  88616 */     GIR_EraseRootFromParent_Done,
     /*  88617 */   // Label 1377: @88617
     /*  88617 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(88759), // Rule ID 3618 //
     /*  88622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2nn),
     /*  88630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88667 */     // MIs[1] Operand 1
     /*  88667 */     // No operand predicates
     /*  88667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88675 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88679 */     // MIs[2] Operand 1
     /*  88679 */     // No operand predicates
     /*  88679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88687 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88691 */     // MIs[3] Operand 1
     /*  88691 */     // No operand predicates
     /*  88691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88693 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10678:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88693 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88696 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88700 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88705 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88709 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2NN),
     /*  88738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88740 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88757 */     GIR_RootConstrainSelectedInstOperands,
     /*  88758 */     // GIR_Coverage, 3618,
     /*  88758 */     GIR_EraseRootFromParent_Done,
     /*  88759 */   // Label 1378: @88759
     /*  88759 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(88901), // Rule ID 3620 //
     /*  88764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4spp),
     /*  88772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88809 */     // MIs[1] Operand 1
     /*  88809 */     // No operand predicates
     /*  88809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88817 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88821 */     // MIs[2] Operand 1
     /*  88821 */     // No operand predicates
     /*  88821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88829 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88833 */     // MIs[3] Operand 1
     /*  88833 */     // No operand predicates
     /*  88833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88835 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10705:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI8GER4SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88835 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88838 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88842 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88847 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4SPP),
     /*  88880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88882 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88899 */     GIR_RootConstrainSelectedInstOperands,
     /*  88900 */     // GIR_Coverage, 3620,
     /*  88900 */     GIR_EraseRootFromParent_Done,
     /*  88901 */   // Label 1379: @88901
     /*  88901 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(89043), // Rule ID 3621 //
     /*  88906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2pp),
     /*  88914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88951 */     // MIs[1] Operand 1
     /*  88951 */     // No operand predicates
     /*  88951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88959 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88963 */     // MIs[2] Operand 1
     /*  88963 */     // No operand predicates
     /*  88963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88971 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88975 */     // MIs[3] Operand 1
     /*  88975 */     // No operand predicates
     /*  88975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88977 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10698:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88989 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88993 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2PP),
     /*  89022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89024 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89041 */     GIR_RootConstrainSelectedInstOperands,
     /*  89042 */     // GIR_Coverage, 3621,
     /*  89042 */     GIR_EraseRootFromParent_Done,
     /*  89043 */   // Label 1380: @89043
     /*  89043 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(89185), // Rule ID 3623 //
     /*  89048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8pp),
     /*  89056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89093 */     // MIs[1] Operand 1
     /*  89093 */     // No operand predicates
     /*  89093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89101 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89105 */     // MIs[2] Operand 1
     /*  89105 */     // No operand predicates
     /*  89105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89113 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  89117 */     // MIs[3] Operand 1
     /*  89117 */     // No operand predicates
     /*  89117 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89119 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10702:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  89119 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89122 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89126 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89131 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89135 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8WPP),
     /*  89164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89166 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89183 */     GIR_RootConstrainSelectedInstOperands,
     /*  89184 */     // GIR_Coverage, 3623,
     /*  89184 */     GIR_EraseRootFromParent_Done,
     /*  89185 */   // Label 1381: @89185
     /*  89185 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(89327), // Rule ID 3625 //
     /*  89190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4pp),
     /*  89198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89235 */     // MIs[1] Operand 1
     /*  89235 */     // No operand predicates
     /*  89235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89243 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89247 */     // MIs[2] Operand 1
     /*  89247 */     // No operand predicates
     /*  89247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89255 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89259 */     // MIs[3] Operand 1
     /*  89259 */     // No operand predicates
     /*  89259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89261 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10704:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  89261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89273 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4WPP),
     /*  89306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89308 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89325 */     GIR_RootConstrainSelectedInstOperands,
     /*  89326 */     // GIR_Coverage, 3625,
     /*  89326 */     GIR_EraseRootFromParent_Done,
     /*  89327 */   // Label 1382: @89327
     /*  89327 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(89469), // Rule ID 3627 //
     /*  89332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2spp),
     /*  89340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89377 */     // MIs[1] Operand 1
     /*  89377 */     // No operand predicates
     /*  89377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89385 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89389 */     // MIs[2] Operand 1
     /*  89389 */     // No operand predicates
     /*  89389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89397 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89401 */     // MIs[3] Operand 1
     /*  89401 */     // No operand predicates
     /*  89401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89403 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10700:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89403 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89406 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89410 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89415 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89419 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SWPP),
     /*  89448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89450 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89467 */     GIR_RootConstrainSelectedInstOperands,
     /*  89468 */     // GIR_Coverage, 3627,
     /*  89468 */     GIR_EraseRootFromParent_Done,
     /*  89469 */   // Label 1383: @89469
     /*  89469 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(89611), // Rule ID 3629 //
     /*  89474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pp),
     /*  89482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89519 */     // MIs[1] Operand 1
     /*  89519 */     // No operand predicates
     /*  89519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89527 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89531 */     // MIs[2] Operand 1
     /*  89531 */     // No operand predicates
     /*  89531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89539 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89543 */     // MIs[3] Operand 1
     /*  89543 */     // No operand predicates
     /*  89543 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89545 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10686:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89545 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89548 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89552 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89557 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89561 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WPP),
     /*  89590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89592 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89609 */     GIR_RootConstrainSelectedInstOperands,
     /*  89610 */     // GIR_Coverage, 3629,
     /*  89610 */     GIR_EraseRootFromParent_Done,
     /*  89611 */   // Label 1384: @89611
     /*  89611 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(89753), // Rule ID 3630 //
     /*  89616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pn),
     /*  89624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89661 */     // MIs[1] Operand 1
     /*  89661 */     // No operand predicates
     /*  89661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89669 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89673 */     // MIs[2] Operand 1
     /*  89673 */     // No operand predicates
     /*  89673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89677 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89681 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89685 */     // MIs[3] Operand 1
     /*  89685 */     // No operand predicates
     /*  89685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89687 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10685:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WPN),
     /*  89732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89734 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89751 */     GIR_RootConstrainSelectedInstOperands,
     /*  89752 */     // GIR_Coverage, 3630,
     /*  89752 */     GIR_EraseRootFromParent_Done,
     /*  89753 */   // Label 1385: @89753
     /*  89753 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(89895), // Rule ID 3631 //
     /*  89758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2np),
     /*  89766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89803 */     // MIs[1] Operand 1
     /*  89803 */     // No operand predicates
     /*  89803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89811 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89815 */     // MIs[2] Operand 1
     /*  89815 */     // No operand predicates
     /*  89815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89823 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89827 */     // MIs[3] Operand 1
     /*  89827 */     // No operand predicates
     /*  89827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89829 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10684:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89829 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89832 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89836 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89841 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89845 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WNP),
     /*  89874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89876 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89893 */     GIR_RootConstrainSelectedInstOperands,
     /*  89894 */     // GIR_Coverage, 3631,
     /*  89894 */     GIR_EraseRootFromParent_Done,
     /*  89895 */   // Label 1386: @89895
     /*  89895 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(90037), // Rule ID 3632 //
     /*  89900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2nn),
     /*  89908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89945 */     // MIs[1] Operand 1
     /*  89945 */     // No operand predicates
     /*  89945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89953 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89957 */     // MIs[2] Operand 1
     /*  89957 */     // No operand predicates
     /*  89957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89965 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89969 */     // MIs[3] Operand 1
     /*  89969 */     // No operand predicates
     /*  89969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89971 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10683:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89971 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89974 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89978 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89987 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90004 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WNN),
     /*  90016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90018 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90035 */     GIR_RootConstrainSelectedInstOperands,
     /*  90036 */     // GIR_Coverage, 3632,
     /*  90036 */     GIR_EraseRootFromParent_Done,
     /*  90037 */   // Label 1387: @90037
     /*  90037 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(90179), // Rule ID 3644 //
     /*  90042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pp),
     /*  90050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90087 */     // MIs[1] Operand 1
     /*  90087 */     // No operand predicates
     /*  90087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90099 */     // MIs[2] Operand 1
     /*  90099 */     // No operand predicates
     /*  90099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90107 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90111 */     // MIs[3] Operand 1
     /*  90111 */     // No operand predicates
     /*  90111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90113 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10681:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90113 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90116 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90120 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90125 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90129 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WPP),
     /*  90158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90160 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90177 */     GIR_RootConstrainSelectedInstOperands,
     /*  90178 */     // GIR_Coverage, 3644,
     /*  90178 */     GIR_EraseRootFromParent_Done,
     /*  90179 */   // Label 1388: @90179
     /*  90179 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(90321), // Rule ID 3645 //
     /*  90184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pn),
     /*  90192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90229 */     // MIs[1] Operand 1
     /*  90229 */     // No operand predicates
     /*  90229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90237 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90241 */     // MIs[2] Operand 1
     /*  90241 */     // No operand predicates
     /*  90241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90249 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90253 */     // MIs[3] Operand 1
     /*  90253 */     // No operand predicates
     /*  90253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90255 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10680:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90267 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90271 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90288 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WPN),
     /*  90300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90302 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90319 */     GIR_RootConstrainSelectedInstOperands,
     /*  90320 */     // GIR_Coverage, 3645,
     /*  90320 */     GIR_EraseRootFromParent_Done,
     /*  90321 */   // Label 1389: @90321
     /*  90321 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(90463), // Rule ID 3646 //
     /*  90326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2np),
     /*  90334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90371 */     // MIs[1] Operand 1
     /*  90371 */     // No operand predicates
     /*  90371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90379 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90383 */     // MIs[2] Operand 1
     /*  90383 */     // No operand predicates
     /*  90383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90391 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90395 */     // MIs[3] Operand 1
     /*  90395 */     // No operand predicates
     /*  90395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90397 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10679:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90397 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90400 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90404 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90409 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90413 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WNP),
     /*  90442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90444 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90461 */     GIR_RootConstrainSelectedInstOperands,
     /*  90462 */     // GIR_Coverage, 3646,
     /*  90462 */     GIR_EraseRootFromParent_Done,
     /*  90463 */   // Label 1390: @90463
     /*  90463 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(90605), // Rule ID 3647 //
     /*  90468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2nn),
     /*  90476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90513 */     // MIs[1] Operand 1
     /*  90513 */     // No operand predicates
     /*  90513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90521 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90525 */     // MIs[2] Operand 1
     /*  90525 */     // No operand predicates
     /*  90525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90533 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90537 */     // MIs[3] Operand 1
     /*  90537 */     // No operand predicates
     /*  90537 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90539 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10678:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90539 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90542 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90546 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90551 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90555 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WNN),
     /*  90584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90586 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90603 */     GIR_RootConstrainSelectedInstOperands,
     /*  90604 */     // GIR_Coverage, 3647,
     /*  90604 */     GIR_EraseRootFromParent_Done,
     /*  90605 */   // Label 1391: @90605
     /*  90605 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(90747), // Rule ID 3649 //
     /*  90610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4spp),
     /*  90618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90655 */     // MIs[1] Operand 1
     /*  90655 */     // No operand predicates
     /*  90655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90663 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90667 */     // MIs[2] Operand 1
     /*  90667 */     // No operand predicates
     /*  90667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90675 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90679 */     // MIs[3] Operand 1
     /*  90679 */     // No operand predicates
     /*  90679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90681 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10705:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI8GER4WSPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90681 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90684 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90688 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90693 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90714 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4WSPP),
     /*  90726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90728 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90745 */     GIR_RootConstrainSelectedInstOperands,
     /*  90746 */     // GIR_Coverage, 3649,
     /*  90746 */     GIR_EraseRootFromParent_Done,
     /*  90747 */   // Label 1392: @90747
     /*  90747 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(90889), // Rule ID 3650 //
     /*  90752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2pp),
     /*  90760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  90785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90797 */     // MIs[1] Operand 1
     /*  90797 */     // No operand predicates
     /*  90797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90805 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90809 */     // MIs[2] Operand 1
     /*  90809 */     // No operand predicates
     /*  90809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90817 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90821 */     // MIs[3] Operand 1
     /*  90821 */     // No operand predicates
     /*  90821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90823 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10698:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90823 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90826 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90830 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90839 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2WPP),
     /*  90868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90870 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90887 */     GIR_RootConstrainSelectedInstOperands,
     /*  90888 */     // GIR_Coverage, 3650,
     /*  90888 */     GIR_EraseRootFromParent_Done,
     /*  90889 */   // Label 1393: @90889
     /*  90889 */   GIM_Reject,
     /*  90890 */ // Label 1357: @90890
     /*  90890 */ GIM_Reject,
     /*  90891 */ // Label 20: @90891
     /*  90891 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(91230),
     /*  90896 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  90899 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(90918), // Rule ID 106 //
     /*  90904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_eieio),
     /*  90909 */     // (intrinsic_void 10588:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  90909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  90912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90916 */     GIR_RootConstrainSelectedInstOperands,
     /*  90917 */     // GIR_Coverage, 106,
     /*  90917 */     GIR_EraseRootFromParent_Done,
     /*  90918 */   // Label 1395: @90918
     /*  90918 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(90943), // Rule ID 1195 //
     /*  90923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  90926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_sync),
     /*  90931 */     // (intrinsic_void 10776:{ *:[iPTR] })  =>  (SYNC 0:{ *:[i32] })
     /*  90931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  90934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90941 */     GIR_RootConstrainSelectedInstOperands,
     /*  90942 */     // GIR_Coverage, 1195,
     /*  90942 */     GIR_EraseRootFromParent_Done,
     /*  90943 */   // Label 1396: @90943
     /*  90943 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(90968), // Rule ID 1196 //
     /*  90948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  90951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_sync),
     /*  90956 */     // (intrinsic_void 10623:{ *:[iPTR] })  =>  (SYNC 0:{ *:[i32] })
     /*  90956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  90959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90966 */     GIR_RootConstrainSelectedInstOperands,
     /*  90967 */     // GIR_Coverage, 1196,
     /*  90967 */     GIR_EraseRootFromParent_Done,
     /*  90968 */   // Label 1397: @90968
     /*  90968 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(90993), // Rule ID 1197 //
     /*  90973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  90976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_lwsync),
     /*  90981 */     // (intrinsic_void 10628:{ *:[iPTR] })  =>  (SYNC 1:{ *:[i32] })
     /*  90981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  90984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  90987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90991 */     GIR_RootConstrainSelectedInstOperands,
     /*  90992 */     // GIR_Coverage, 1197,
     /*  90992 */     GIR_EraseRootFromParent_Done,
     /*  90993 */   // Label 1398: @90993
     /*  90993 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(91018), // Rule ID 1198 //
     /*  90998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  91001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_lwsync),
     /*  91006 */     // (intrinsic_void 10622:{ *:[iPTR] })  =>  (SYNC 1:{ *:[i32] })
     /*  91006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  91009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  91012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91016 */     GIR_RootConstrainSelectedInstOperands,
     /*  91017 */     // GIR_Coverage, 1198,
     /*  91017 */     GIR_EraseRootFromParent_Done,
     /*  91018 */   // Label 1399: @91018
     /*  91018 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(91040), // Rule ID 1199 //
     /*  91023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_sync),
     /*  91031 */     // (intrinsic_void 10776:{ *:[iPTR] })  =>  (MSYNC)
     /*  91031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91038 */     GIR_RootConstrainSelectedInstOperands,
     /*  91039 */     // GIR_Coverage, 1199,
     /*  91039 */     GIR_EraseRootFromParent_Done,
     /*  91040 */   // Label 1400: @91040
     /*  91040 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(91062), // Rule ID 1200 //
     /*  91045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_sync),
     /*  91053 */     // (intrinsic_void 10623:{ *:[iPTR] })  =>  (MSYNC)
     /*  91053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91060 */     GIR_RootConstrainSelectedInstOperands,
     /*  91061 */     // GIR_Coverage, 1200,
     /*  91061 */     GIR_EraseRootFromParent_Done,
     /*  91062 */   // Label 1401: @91062
     /*  91062 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(91084), // Rule ID 1201 //
     /*  91067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_lwsync),
     /*  91075 */     // (intrinsic_void 10628:{ *:[iPTR] })  =>  (MSYNC)
     /*  91075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91082 */     GIR_RootConstrainSelectedInstOperands,
     /*  91083 */     // GIR_Coverage, 1201,
     /*  91083 */     GIR_EraseRootFromParent_Done,
     /*  91084 */   // Label 1402: @91084
     /*  91084 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(91106), // Rule ID 1202 //
     /*  91089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_lwsync),
     /*  91097 */     // (intrinsic_void 10622:{ *:[iPTR] })  =>  (MSYNC)
     /*  91097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91104 */     GIR_RootConstrainSelectedInstOperands,
     /*  91105 */     // GIR_Coverage, 1202,
     /*  91105 */     GIR_EraseRootFromParent_Done,
     /*  91106 */   // Label 1403: @91106
     /*  91106 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(91125), // Rule ID 1203 //
     /*  91111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_eieio),
     /*  91116 */     // (intrinsic_void 10588:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  91116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  91119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91123 */     GIR_RootConstrainSelectedInstOperands,
     /*  91124 */     // GIR_Coverage, 1203,
     /*  91124 */     GIR_EraseRootFromParent_Done,
     /*  91125 */   // Label 1404: @91125
     /*  91125 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(91144), // Rule ID 1204 //
     /*  91130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_eieio),
     /*  91135 */     // (intrinsic_void 10621:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  91135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  91138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91142 */     GIR_RootConstrainSelectedInstOperands,
     /*  91143 */     // GIR_Coverage, 1204,
     /*  91143 */     GIR_EraseRootFromParent_Done,
     /*  91144 */   // Label 1405: @91144
     /*  91144 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(91166), // Rule ID 1230 //
     /*  91149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_fence),
     /*  91154 */     // (intrinsic_void 10599:{ *:[iPTR] })  =>  (FENCE)
     /*  91154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FENCE),
     /*  91157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  91160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91164 */     GIR_RootConstrainSelectedInstOperands,
     /*  91165 */     // GIR_Coverage, 1230,
     /*  91165 */     GIR_EraseRootFromParent_Done,
     /*  91166 */   // Label 1406: @91166
     /*  91166 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(91188), // Rule ID 1284 //
     /*  91171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsAIX),
     /*  91174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dssall),
     /*  91179 */     // (intrinsic_void 10240:{ *:[iPTR] })  =>  (NOP)
     /*  91179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOP),
     /*  91182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91186 */     GIR_RootConstrainSelectedInstOperands,
     /*  91187 */     // GIR_Coverage, 1284,
     /*  91187 */     GIR_EraseRootFromParent_Done,
     /*  91188 */   // Label 1407: @91188
     /*  91188 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(91210), // Rule ID 1285 //
     /*  91193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotAIX),
     /*  91196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dssall),
     /*  91201 */     // (intrinsic_void 10240:{ *:[iPTR] })  =>  (DSSALL)
     /*  91201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSSALL),
     /*  91204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91208 */     GIR_RootConstrainSelectedInstOperands,
     /*  91209 */     // GIR_Coverage, 1285,
     /*  91209 */     GIR_EraseRootFromParent_Done,
     /*  91210 */   // Label 1408: @91210
     /*  91210 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(91229), // Rule ID 4852 //
     /*  91215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_isync),
     /*  91220 */     // (intrinsic_void 10624:{ *:[iPTR] })  =>  (ISYNC)
     /*  91220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ISYNC),
     /*  91223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91227 */     GIR_RootConstrainSelectedInstOperands,
     /*  91228 */     // GIR_Coverage, 4852,
     /*  91228 */     GIR_EraseRootFromParent_Done,
     /*  91229 */   // Label 1409: @91229
     /*  91229 */   GIM_Reject,
     /*  91230 */ // Label 1394: @91230
     /*  91230 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(92113),
     /*  91235 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91238 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(91277), // Rule ID 269 //
     /*  91243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dss),
     /*  91251 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91262 */     // MIs[1] Operand 1
     /*  91262 */     // No operand predicates
     /*  91262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91264 */     // (intrinsic_void 10239:{ *:[iPTR] }, (imm:{ *:[i32] }):$STRM)  =>  (DSS (imm:{ *:[i32] }):$STRM)
     /*  91264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSS),
     /*  91267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  91270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91275 */     GIR_RootConstrainSelectedInstOperands,
     /*  91276 */     // GIR_Coverage, 269,
     /*  91276 */     GIR_EraseRootFromParent_Done,
     /*  91277 */   // Label 1411: @91277
     /*  91277 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(91303), // Rule ID 193 //
     /*  91282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  91285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsb0),
     /*  91290 */     // MIs[0] FM
     /*  91290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  91293 */     // (intrinsic_void 10738:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM)  =>  (MTFSB0 (timm:{ *:[i32] }):$FM)
     /*  91293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSB0),
     /*  91296 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  91298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  91301 */     GIR_RootConstrainSelectedInstOperands,
     /*  91302 */     // GIR_Coverage, 193,
     /*  91302 */     GIR_EraseRootFromParent_Done,
     /*  91303 */   // Label 1412: @91303
     /*  91303 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(91329), // Rule ID 194 //
     /*  91308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  91311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsb1),
     /*  91316 */     // MIs[0] FM
     /*  91316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  91319 */     // (intrinsic_void 10739:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM)  =>  (MTFSB1 (timm:{ *:[i32] }):$FM)
     /*  91319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSB1),
     /*  91322 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  91324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  91327 */     GIR_RootConstrainSelectedInstOperands,
     /*  91328 */     // GIR_Coverage, 194,
     /*  91328 */     GIR_EraseRootFromParent_Done,
     /*  91329 */   // Label 1413: @91329
     /*  91329 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(91356), // Rule ID 278 //
     /*  91334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mfvscr),
     /*  91342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  91349 */     // (intrinsic_w_chain:{ *:[v8i16] } 10252:{ *:[iPTR] })  =>  (MFVSCR:{ *:[v8i16] })
     /*  91349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSCR),
     /*  91352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  91354 */     GIR_RootConstrainSelectedInstOperands,
     /*  91355 */     // GIR_Coverage, 278,
     /*  91355 */     GIR_EraseRootFromParent_Done,
     /*  91356 */   // Label 1414: @91356
     /*  91356 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(91380), // Rule ID 1231 //
     /*  91361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_readflm),
     /*  91366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  91373 */     // (intrinsic_w_chain:{ *:[f64] } 10753:{ *:[iPTR] })  =>  (MFFS:{ *:[f64] })
     /*  91373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFFS),
     /*  91376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91378 */     GIR_RootConstrainSelectedInstOperands,
     /*  91379 */     // GIR_Coverage, 1231,
     /*  91379 */     GIR_EraseRootFromParent_Done,
     /*  91380 */   // Label 1415: @91380
     /*  91380 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(91408), // Rule ID 1232 //
     /*  91385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mffsl),
     /*  91390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  91397 */     // (intrinsic_w_chain:{ *:[f64] } 10635:{ *:[iPTR] })  =>  (MFFSL:{ *:[f64] })
     /*  91397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFFSL),
     /*  91400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91406 */     GIR_RootConstrainSelectedInstOperands,
     /*  91407 */     // GIR_Coverage, 1232,
     /*  91407 */     GIR_EraseRootFromParent_Done,
     /*  91408 */   // Label 1416: @91408
     /*  91408 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(91472), // Rule ID 1568 //
     /*  91413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  91416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darn32),
     /*  91421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  91424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91428 */     // (intrinsic_w_chain:{ *:[i32] } 10565:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (DARN:{ *:[i64] } 0:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  91428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  91431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  91435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91440 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  91443 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91454 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  91461 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91466 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91471 */     // GIR_Coverage, 1568,
     /*  91471 */     GIR_EraseRootFromParent_Done,
     /*  91472 */   // Label 1417: @91472
     /*  91472 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(91506), // Rule ID 1569 //
     /*  91477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  91480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darn),
     /*  91485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91492 */     // (intrinsic_w_chain:{ *:[i64] } 10564:{ *:[iPTR] })  =>  (DARN:{ *:[i64] } 1:{ *:[i32] })
     /*  91492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  91495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  91497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  91500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91504 */     GIR_RootConstrainSelectedInstOperands,
     /*  91505 */     // GIR_Coverage, 1569,
     /*  91505 */     GIR_EraseRootFromParent_Done,
     /*  91506 */   // Label 1418: @91506
     /*  91506 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(91540), // Rule ID 1570 //
     /*  91511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  91514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darnraw),
     /*  91519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91526 */     // (intrinsic_w_chain:{ *:[i64] } 10566:{ *:[iPTR] })  =>  (DARN:{ *:[i64] } 2:{ *:[i32] })
     /*  91526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  91529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  91531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  91534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91538 */     GIR_RootConstrainSelectedInstOperands,
     /*  91539 */     // GIR_Coverage, 1570,
     /*  91539 */     GIR_EraseRootFromParent_Done,
     /*  91540 */   // Label 1419: @91540
     /*  91540 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(91571), // Rule ID 2886 //
     /*  91545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tcheck),
     /*  91553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  91556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91560 */     // (intrinsic_w_chain:{ *:[i32] } 10783:{ *:[iPTR] })  =>  (TCHECK_RET:{ *:[i32] })
     /*  91560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TCHECK_RET),
     /*  91563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /*  91565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91569 */     GIR_RootConstrainSelectedInstOperands,
     /*  91570 */     // GIR_Coverage, 2886,
     /*  91570 */     GIR_EraseRootFromParent_Done,
     /*  91571 */   // Label 1420: @91571
     /*  91571 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(91612), // Rule ID 2890 //
     /*  91576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_texasr),
     /*  91584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91591 */     // (intrinsic_w_chain:{ *:[i64] } 10615:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 130:{ *:[i32] })
     /*  91591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91596 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(130),
     /*  91606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91610 */     GIR_RootConstrainSelectedInstOperands,
     /*  91611 */     // GIR_Coverage, 2890,
     /*  91611 */     GIR_EraseRootFromParent_Done,
     /*  91612 */   // Label 1421: @91612
     /*  91612 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(91653), // Rule ID 2891 //
     /*  91617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_texasru),
     /*  91625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91632 */     // (intrinsic_w_chain:{ *:[i64] } 10616:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 131:{ *:[i32] })
     /*  91632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91637 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
     /*  91647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91651 */     GIR_RootConstrainSelectedInstOperands,
     /*  91652 */     // GIR_Coverage, 2891,
     /*  91652 */     GIR_EraseRootFromParent_Done,
     /*  91653 */   // Label 1422: @91653
     /*  91653 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(91694), // Rule ID 2892 //
     /*  91658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_tfhar),
     /*  91666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91673 */     // (intrinsic_w_chain:{ *:[i64] } 10617:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 128:{ *:[i32] })
     /*  91673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91678 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  91688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91692 */     GIR_RootConstrainSelectedInstOperands,
     /*  91693 */     // GIR_Coverage, 2892,
     /*  91693 */     GIR_EraseRootFromParent_Done,
     /*  91694 */   // Label 1423: @91694
     /*  91694 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(91735), // Rule ID 2893 //
     /*  91699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_tfiar),
     /*  91707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91714 */     // (intrinsic_w_chain:{ *:[i64] } 10618:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 129:{ *:[i32] })
     /*  91714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91719 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(129),
     /*  91729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91733 */     GIR_RootConstrainSelectedInstOperands,
     /*  91734 */     // GIR_Coverage, 2893,
     /*  91734 */     GIR_EraseRootFromParent_Done,
     /*  91735 */   // Label 1424: @91735
     /*  91735 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(91766), // Rule ID 4900 //
     /*  91740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtmsr),
     /*  91745 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91752 */     // (intrinsic_void 10742:{ *:[iPTR] }, gprc:{ *:[i32] }:$RS)  =>  (MTMSR ?:{ *:[i32] }:$RS, 0:{ *:[i32] })
     /*  91752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTMSR),
     /*  91755 */     GIR_RootToRootCopy, /*OpIdx*/1, // RS
     /*  91757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91764 */     GIR_RootConstrainSelectedInstOperands,
     /*  91765 */     // GIR_Coverage, 4900,
     /*  91765 */     GIR_EraseRootFromParent_Done,
     /*  91766 */   // Label 1425: @91766
     /*  91766 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(91793), // Rule ID 189 //
     /*  91771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::set_loop_iterations),
     /*  91776 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91779 */     // (intrinsic_void 323:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (MTCTRloop:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  91779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTCTRloop),
     /*  91782 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*  91784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR*/0,
     /*  91787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91791 */     GIR_RootConstrainSelectedInstOperands,
     /*  91792 */     // GIR_Coverage, 189,
     /*  91792 */     GIR_EraseRootFromParent_Done,
     /*  91793 */   // Label 1426: @91793
     /*  91793 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(91816), // Rule ID 279 //
     /*  91798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_mtvscr),
     /*  91806 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91809 */     // (intrinsic_void 10253:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (MTVSCR v4i32:{ *:[v4i32] }:$VB)
     /*  91809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSCR),
     /*  91812 */     GIR_RootToRootCopy, /*OpIdx*/1, // VB
     /*  91814 */     GIR_RootConstrainSelectedInstOperands,
     /*  91815 */     // GIR_Coverage, 279,
     /*  91815 */     GIR_EraseRootFromParent_Done,
     /*  91816 */   // Label 1427: @91816
     /*  91816 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(91843), // Rule ID 633 //
     /*  91821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::set_loop_iterations),
     /*  91826 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91829 */     // (intrinsic_void 323:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (MTCTR8loop:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  91829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTCTR8loop),
     /*  91832 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*  91834 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR8*/0,
     /*  91837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91841 */     GIR_RootConstrainSelectedInstOperands,
     /*  91842 */     // GIR_Coverage, 633,
     /*  91842 */     GIR_EraseRootFromParent_Done,
     /*  91843 */   // Label 1428: @91843
     /*  91843 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(91880), // Rule ID 2894 //
     /*  91848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_texasr),
     /*  91856 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91859 */     // (intrinsic_void 10759:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 130:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  91859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  91862 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(130),
     /*  91872 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  91874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91878 */     GIR_RootConstrainSelectedInstOperands,
     /*  91879 */     // GIR_Coverage, 2894,
     /*  91879 */     GIR_EraseRootFromParent_Done,
     /*  91880 */   // Label 1429: @91880
     /*  91880 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(91917), // Rule ID 2895 //
     /*  91885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_texasru),
     /*  91893 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91896 */     // (intrinsic_void 10760:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 131:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  91896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  91899 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
     /*  91909 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  91911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91915 */     GIR_RootConstrainSelectedInstOperands,
     /*  91916 */     // GIR_Coverage, 2895,
     /*  91916 */     GIR_EraseRootFromParent_Done,
     /*  91917 */   // Label 1430: @91917
     /*  91917 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91954), // Rule ID 2896 //
     /*  91922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_tfhar),
     /*  91930 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91933 */     // (intrinsic_void 10761:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 128:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  91933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  91936 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  91946 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  91948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91952 */     GIR_RootConstrainSelectedInstOperands,
     /*  91953 */     // GIR_Coverage, 2896,
     /*  91953 */     GIR_EraseRootFromParent_Done,
     /*  91954 */   // Label 1431: @91954
     /*  91954 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(91991), // Rule ID 2897 //
     /*  91959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_tfiar),
     /*  91967 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91970 */     // (intrinsic_void 10762:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 129:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  91970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  91973 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(129),
     /*  91983 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  91985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91989 */     GIR_RootConstrainSelectedInstOperands,
     /*  91990 */     // GIR_Coverage, 2897,
     /*  91990 */     GIR_EraseRootFromParent_Done,
     /*  91991 */   // Label 1432: @91991
     /*  91991 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(92019), // Rule ID 2888 //
     /*  91996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_trechkpt),
     /*  92004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92007 */     // (intrinsic_w_chain:{ *:[i32] } 10790:{ *:[iPTR] })  =>  (TRECHKPT:{ *:[i32] })
     /*  92007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TRECHKPT),
     /*  92010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92017 */     GIR_RootConstrainSelectedInstOperands,
     /*  92018 */     // GIR_Coverage, 2888,
     /*  92018 */     GIR_EraseRootFromParent_Done,
     /*  92019 */   // Label 1433: @92019
     /*  92019 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(92050), // Rule ID 2898 //
     /*  92024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tendall),
     /*  92032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92035 */     // (intrinsic_w_chain:{ *:[i32] } 10786:{ *:[iPTR] })  =>  (TEND:{ *:[i32] } 1:{ *:[i32] })
     /*  92035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TEND),
     /*  92038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  92041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92048 */     GIR_RootConstrainSelectedInstOperands,
     /*  92049 */     // GIR_Coverage, 2898,
     /*  92049 */     GIR_EraseRootFromParent_Done,
     /*  92050 */   // Label 1434: @92050
     /*  92050 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(92081), // Rule ID 2899 //
     /*  92055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tresume),
     /*  92063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92066 */     // (intrinsic_w_chain:{ *:[i32] } 10792:{ *:[iPTR] })  =>  (TSR:{ *:[i32] } 1:{ *:[i32] })
     /*  92066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TSR),
     /*  92069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  92072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92079 */     GIR_RootConstrainSelectedInstOperands,
     /*  92080 */     // GIR_Coverage, 2899,
     /*  92080 */     GIR_EraseRootFromParent_Done,
     /*  92081 */   // Label 1435: @92081
     /*  92081 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(92112), // Rule ID 2900 //
     /*  92086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tsuspend),
     /*  92094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92097 */     // (intrinsic_w_chain:{ *:[i32] } 10795:{ *:[iPTR] })  =>  (TSR:{ *:[i32] } 0:{ *:[i32] })
     /*  92097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TSR),
     /*  92100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92110 */     GIR_RootConstrainSelectedInstOperands,
     /*  92111 */     // GIR_Coverage, 2900,
     /*  92111 */     GIR_EraseRootFromParent_Done,
     /*  92112 */   // Label 1436: @92112
     /*  92112 */   GIM_Reject,
     /*  92113 */ // Label 1410: @92113
     /*  92113 */ GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(92639),
     /*  92118 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  92121 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(92152), // Rule ID 1172 //
     /*  92126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  92129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsfi),
     /*  92134 */     // MIs[0] BF
     /*  92134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92137 */     // MIs[0] U
     /*  92137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92140 */     // (intrinsic_void 10741:{ *:[iPTR] }, (timm:{ *:[i32] }):$BF, (timm:{ *:[i32] }):$U)  =>  (MTFSFIb (timm:{ *:[i32] }):$BF, (timm:{ *:[i32] }):$U)
     /*  92140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSFIb),
     /*  92143 */     GIR_RootToRootCopy, /*OpIdx*/1, // BF
     /*  92145 */     GIR_RootToRootCopy, /*OpIdx*/2, // U
     /*  92147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92150 */     GIR_RootConstrainSelectedInstOperands,
     /*  92151 */     // GIR_Coverage, 1172,
     /*  92151 */     GIR_EraseRootFromParent_Done,
     /*  92152 */   // Label 1438: @92152
     /*  92152 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(92200), // Rule ID 12 //
     /*  92157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setrnd),
     /*  92162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92180 */     // MIs[1] Operand 1
     /*  92180 */     // No operand predicates
     /*  92180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92182 */     // (intrinsic_w_chain:{ *:[f64] } 10765:{ *:[iPTR] }, (imm:{ *:[i32] }):$RND)  =>  (SETRNDi:{ *:[f64] } (imm:{ *:[i32] }):$RND)
     /*  92182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETRNDi),
     /*  92185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  92187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // RND
     /*  92190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92198 */     GIR_RootConstrainSelectedInstOperands,
     /*  92199 */     // GIR_Coverage, 12,
     /*  92199 */     GIR_EraseRootFromParent_Done,
     /*  92200 */   // Label 1439: @92200
     /*  92200 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(92248), // Rule ID 190 //
     /*  92205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::loop_decrement),
     /*  92210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  92213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  92220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92228 */     // MIs[1] Operand 1
     /*  92228 */     // No operand predicates
     /*  92228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92230 */     // (intrinsic_w_chain:{ *:[i1] } 221:{ *:[iPTR] }, (imm:{ *:[i32] }):$stride)  =>  (DecreaseCTRloop:{ *:[i1] }:{ *:[i32] } (imm:{ *:[i32] }):$stride)
     /*  92230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DecreaseCTRloop),
     /*  92233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  92235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // stride
     /*  92238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR*/0,
     /*  92241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92246 */     GIR_RootConstrainSelectedInstOperands,
     /*  92247 */     // GIR_Coverage, 190,
     /*  92247 */     GIR_EraseRootFromParent_Done,
     /*  92248 */   // Label 1440: @92248
     /*  92248 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(92296), // Rule ID 634 //
     /*  92253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::loop_decrement),
     /*  92258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  92261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  92268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92276 */     // MIs[1] Operand 1
     /*  92276 */     // No operand predicates
     /*  92276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92278 */     // (intrinsic_w_chain:{ *:[i1] } 221:{ *:[iPTR] }, (imm:{ *:[i64] }):$stride)  =>  (DecreaseCTR8loop:{ *:[i1] }:{ *:[i64] } (imm:{ *:[i64] }):$stride)
     /*  92278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DecreaseCTR8loop),
     /*  92281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  92283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // stride
     /*  92286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR8*/0,
     /*  92289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92294 */     GIR_RootConstrainSelectedInstOperands,
     /*  92295 */     // GIR_Coverage, 634,
     /*  92295 */     GIR_EraseRootFromParent_Done,
     /*  92296 */   // Label 1441: @92296
     /*  92296 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(92329), // Rule ID 1173 //
     /*  92301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fixed_addr_ld),
     /*  92306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92313 */     // MIs[0] imm
     /*  92313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92316 */     // (intrinsic_w_chain:{ *:[i32] } 10600:{ *:[iPTR] }, (timm:{ *:[i32] }):$imm)  =>  (PPCLdFixedAddr:{ *:[i32] } (timm:{ *:[i32] }):$imm)
     /*  92316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PPCLdFixedAddr),
     /*  92319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  92321 */     GIR_RootToRootCopy, /*OpIdx*/2, // imm
     /*  92323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92327 */     GIR_RootConstrainSelectedInstOperands,
     /*  92328 */     // GIR_Coverage, 1173,
     /*  92328 */     GIR_EraseRootFromParent_Done,
     /*  92329 */   // Label 1442: @92329
     /*  92329 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(92362), // Rule ID 1573 //
     /*  92334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfspr),
     /*  92339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92346 */     // MIs[0] SPR
     /*  92346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92349 */     // (intrinsic_w_chain:{ *:[i64] } 10637:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR)  =>  (MFSPR8:{ *:[i64] } ?:{ *:[i32] }:$SPR)
     /*  92349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  92352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  92354 */     GIR_RootToRootCopy, /*OpIdx*/2, // SPR
     /*  92356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92360 */     GIR_RootConstrainSelectedInstOperands,
     /*  92361 */     // GIR_Coverage, 1573,
     /*  92361 */     GIR_EraseRootFromParent_Done,
     /*  92362 */   // Label 1443: @92362
     /*  92362 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(92395), // Rule ID 4898 //
     /*  92367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfspr),
     /*  92372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92379 */     // MIs[0] SPR
     /*  92379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92382 */     // (intrinsic_w_chain:{ *:[i32] } 10637:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR)  =>  (MFSPR:{ *:[i32] } ?:{ *:[i32] }:$SPR)
     /*  92382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR),
     /*  92385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  92387 */     GIR_RootToRootCopy, /*OpIdx*/2, // SPR
     /*  92389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92393 */     GIR_RootConstrainSelectedInstOperands,
     /*  92394 */     // GIR_Coverage, 4898,
     /*  92394 */     GIR_EraseRootFromParent_Done,
     /*  92395 */   // Label 1444: @92395
     /*  92395 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(92428), // Rule ID 1574 //
     /*  92400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtspr),
     /*  92405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92408 */     // MIs[0] SPR
     /*  92408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92415 */     // (intrinsic_void 10743:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR, g8rc:{ *:[i64] }:$RT)  =>  (MTSPR8 ?:{ *:[i32] }:$SPR, ?:{ *:[i64] }:$RT)
     /*  92415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  92418 */     GIR_RootToRootCopy, /*OpIdx*/1, // SPR
     /*  92420 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  92422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92426 */     GIR_RootConstrainSelectedInstOperands,
     /*  92427 */     // GIR_Coverage, 1574,
     /*  92427 */     GIR_EraseRootFromParent_Done,
     /*  92428 */   // Label 1445: @92428
     /*  92428 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(92461), // Rule ID 4899 //
     /*  92433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtspr),
     /*  92438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92441 */     // MIs[0] SPR
     /*  92441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92448 */     // (intrinsic_void 10743:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR, gprc:{ *:[i32] }:$RT)  =>  (MTSPR ?:{ *:[i32] }:$SPR, ?:{ *:[i32] }:$RT)
     /*  92448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR),
     /*  92451 */     GIR_RootToRootCopy, /*OpIdx*/1, // SPR
     /*  92453 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  92455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92459 */     GIR_RootConstrainSelectedInstOperands,
     /*  92460 */     // GIR_Coverage, 4899,
     /*  92460 */     GIR_EraseRootFromParent_Done,
     /*  92461 */   // Label 1446: @92461
     /*  92461 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(92492), // Rule ID 195 //
     /*  92466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  92469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsf),
     /*  92474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92477 */     // MIs[0] FM
     /*  92477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92480 */     // (intrinsic_void 10740:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM, f64:{ *:[f64] }:$RT)  =>  (MTFSFb (timm:{ *:[i32] }):$FM, f64:{ *:[f64] }:$RT)
     /*  92480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSFb),
     /*  92483 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  92485 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  92487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92490 */     GIR_RootConstrainSelectedInstOperands,
     /*  92491 */     // GIR_Coverage, 195,
     /*  92491 */     GIR_EraseRootFromParent_Done,
     /*  92492 */   // Label 1447: @92492
     /*  92492 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(92532), // Rule ID 13 //
     /*  92497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setrnd),
     /*  92502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92516 */     // (intrinsic_w_chain:{ *:[f64] } 10765:{ *:[iPTR] }, gprc:{ *:[i32] }:$in)  =>  (SETRND:{ *:[f64] } gprc:{ *:[i32] }:$in)
     /*  92516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETRND),
     /*  92519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  92521 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  92523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92530 */     GIR_RootConstrainSelectedInstOperands,
     /*  92531 */     // GIR_Coverage, 13,
     /*  92531 */     GIR_EraseRootFromParent_Done,
     /*  92532 */   // Label 1448: @92532
     /*  92532 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(92572), // Rule ID 14 //
     /*  92537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setflm),
     /*  92542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92556 */     // (intrinsic_w_chain:{ *:[f64] } 10764:{ *:[iPTR] }, f8rc:{ *:[f64] }:$FLM)  =>  (SETFLM:{ *:[f64] } f8rc:{ *:[f64] }:$FLM)
     /*  92556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETFLM),
     /*  92559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  92561 */     GIR_RootToRootCopy, /*OpIdx*/2, // FLM
     /*  92563 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92570 */     GIR_RootConstrainSelectedInstOperands,
     /*  92571 */     // GIR_Coverage, 14,
     /*  92571 */     GIR_EraseRootFromParent_Done,
     /*  92572 */   // Label 1449: @92572
     /*  92572 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(92605), // Rule ID 2881 //
     /*  92577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tabort),
     /*  92585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92591 */     // (intrinsic_w_chain:{ *:[i32] } 10777:{ *:[iPTR] }, i32:{ *:[i32] }:$R)  =>  (TABORT:{ *:[i32] } ?:{ *:[i32] }:$R)
     /*  92591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TABORT),
     /*  92594 */     GIR_RootToRootCopy, /*OpIdx*/2, // R
     /*  92596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92603 */     GIR_RootConstrainSelectedInstOperands,
     /*  92604 */     // GIR_Coverage, 2881,
     /*  92604 */     GIR_EraseRootFromParent_Done,
     /*  92605 */   // Label 1450: @92605
     /*  92605 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(92638), // Rule ID 2887 //
     /*  92610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_treclaim),
     /*  92618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92624 */     // (intrinsic_w_chain:{ *:[i32] } 10791:{ *:[iPTR] }, i32:{ *:[i32] }:$RA)  =>  (TRECLAIM:{ *:[i32] } ?:{ *:[i32] }:$RA)
     /*  92624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TRECLAIM),
     /*  92627 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  92629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92636 */     GIR_RootConstrainSelectedInstOperands,
     /*  92637 */     // GIR_Coverage, 2887,
     /*  92637 */     GIR_EraseRootFromParent_Done,
     /*  92638 */   // Label 1451: @92638
     /*  92638 */   GIM_Reject,
     /*  92639 */ // Label 1437: @92639
     /*  92639 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(93566),
     /*  92644 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  92647 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(92697), // Rule ID 270 //
     /*  92652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dst),
     /*  92660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92666 */     // MIs[0] RA
     /*  92666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  92670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92678 */     // MIs[1] Operand 1
     /*  92678 */     // No operand predicates
     /*  92678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92680 */     // (intrinsic_void 10241:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DST (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DST),
     /*  92683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92686 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92688 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92695 */     GIR_RootConstrainSelectedInstOperands,
     /*  92696 */     // GIR_Coverage, 270,
     /*  92696 */     GIR_EraseRootFromParent_Done,
     /*  92697 */   // Label 1453: @92697
     /*  92697 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(92747), // Rule ID 271 //
     /*  92702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstt),
     /*  92710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92716 */     // MIs[0] RA
     /*  92716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  92720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92728 */     // MIs[1] Operand 1
     /*  92728 */     // No operand predicates
     /*  92728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92730 */     // (intrinsic_void 10244:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTT (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTT),
     /*  92733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92736 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92738 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92745 */     GIR_RootConstrainSelectedInstOperands,
     /*  92746 */     // GIR_Coverage, 271,
     /*  92746 */     GIR_EraseRootFromParent_Done,
     /*  92747 */   // Label 1454: @92747
     /*  92747 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(92797), // Rule ID 272 //
     /*  92752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstst),
     /*  92760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92766 */     // MIs[0] RA
     /*  92766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  92770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92778 */     // MIs[1] Operand 1
     /*  92778 */     // No operand predicates
     /*  92778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92780 */     // (intrinsic_void 10242:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTST (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTST),
     /*  92783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92786 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92788 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92795 */     GIR_RootConstrainSelectedInstOperands,
     /*  92796 */     // GIR_Coverage, 272,
     /*  92796 */     GIR_EraseRootFromParent_Done,
     /*  92797 */   // Label 1455: @92797
     /*  92797 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(92847), // Rule ID 273 //
     /*  92802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dststt),
     /*  92810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92816 */     // MIs[0] RA
     /*  92816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  92820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92828 */     // MIs[1] Operand 1
     /*  92828 */     // No operand predicates
     /*  92828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92830 */     // (intrinsic_void 10243:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTSTT (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTSTT),
     /*  92833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92836 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92838 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92845 */     GIR_RootConstrainSelectedInstOperands,
     /*  92846 */     // GIR_Coverage, 273,
     /*  92846 */     GIR_EraseRootFromParent_Done,
     /*  92847 */   // Label 1456: @92847
     /*  92847 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(92897), // Rule ID 274 //
     /*  92852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dst),
     /*  92860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92866 */     // MIs[0] RA
     /*  92866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92878 */     // MIs[1] Operand 1
     /*  92878 */     // No operand predicates
     /*  92878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92880 */     // (intrinsic_void 10241:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DST64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DST64),
     /*  92883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92886 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92888 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92895 */     GIR_RootConstrainSelectedInstOperands,
     /*  92896 */     // GIR_Coverage, 274,
     /*  92896 */     GIR_EraseRootFromParent_Done,
     /*  92897 */   // Label 1457: @92897
     /*  92897 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(92947), // Rule ID 275 //
     /*  92902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstt),
     /*  92910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92916 */     // MIs[0] RA
     /*  92916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92928 */     // MIs[1] Operand 1
     /*  92928 */     // No operand predicates
     /*  92928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92930 */     // (intrinsic_void 10244:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTT64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTT64),
     /*  92933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92936 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92938 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92945 */     GIR_RootConstrainSelectedInstOperands,
     /*  92946 */     // GIR_Coverage, 275,
     /*  92946 */     GIR_EraseRootFromParent_Done,
     /*  92947 */   // Label 1458: @92947
     /*  92947 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(92997), // Rule ID 276 //
     /*  92952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstst),
     /*  92960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92966 */     // MIs[0] RA
     /*  92966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92978 */     // MIs[1] Operand 1
     /*  92978 */     // No operand predicates
     /*  92978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92980 */     // (intrinsic_void 10242:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTST64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTST64),
     /*  92983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92986 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92988 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92995 */     GIR_RootConstrainSelectedInstOperands,
     /*  92996 */     // GIR_Coverage, 276,
     /*  92996 */     GIR_EraseRootFromParent_Done,
     /*  92997 */   // Label 1459: @92997
     /*  92997 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(93047), // Rule ID 277 //
     /*  93002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dststt),
     /*  93010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93016 */     // MIs[0] RA
     /*  93016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  93020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93028 */     // MIs[1] Operand 1
     /*  93028 */     // No operand predicates
     /*  93028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93030 */     // (intrinsic_void 10243:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTSTT64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTSTT64),
     /*  93033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93036 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93038 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93045 */     GIR_RootConstrainSelectedInstOperands,
     /*  93046 */     // GIR_Coverage, 277,
     /*  93046 */     GIR_EraseRootFromParent_Done,
     /*  93047 */   // Label 1460: @93047
     /*  93047 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(93084), // Rule ID 380 //
     /*  93052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsumsws),
     /*  93060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93073 */     // (intrinsic_w_chain:{ *:[v4i32] } 10523:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUMSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUMSWS),
     /*  93076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93078 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93080 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93082 */     GIR_RootConstrainSelectedInstOperands,
     /*  93083 */     // GIR_Coverage, 380,
     /*  93083 */     GIR_EraseRootFromParent_Done,
     /*  93084 */   // Label 1461: @93084
     /*  93084 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(93121), // Rule ID 381 //
     /*  93089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum2sws),
     /*  93097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93110 */     // (intrinsic_w_chain:{ *:[v4i32] } 10519:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM2SWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM2SWS),
     /*  93113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93115 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93117 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93119 */     GIR_RootConstrainSelectedInstOperands,
     /*  93120 */     // GIR_Coverage, 381,
     /*  93120 */     GIR_EraseRootFromParent_Done,
     /*  93121 */   // Label 1462: @93121
     /*  93121 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(93158), // Rule ID 382 //
     /*  93126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4sbs),
     /*  93134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93147 */     // (intrinsic_w_chain:{ *:[v4i32] } 10520:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4SBS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4SBS),
     /*  93150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93152 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93154 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93156 */     GIR_RootConstrainSelectedInstOperands,
     /*  93157 */     // GIR_Coverage, 382,
     /*  93157 */     GIR_EraseRootFromParent_Done,
     /*  93158 */   // Label 1463: @93158
     /*  93158 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(93195), // Rule ID 383 //
     /*  93163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4shs),
     /*  93171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93184 */     // (intrinsic_w_chain:{ *:[v4i32] } 10521:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4SHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4SHS),
     /*  93187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93189 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93191 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93193 */     GIR_RootConstrainSelectedInstOperands,
     /*  93194 */     // GIR_Coverage, 383,
     /*  93194 */     GIR_EraseRootFromParent_Done,
     /*  93195 */   // Label 1464: @93195
     /*  93195 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(93232), // Rule ID 384 //
     /*  93200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4ubs),
     /*  93208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93221 */     // (intrinsic_w_chain:{ *:[v4i32] } 10522:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4UBS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4UBS),
     /*  93224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93226 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93228 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93230 */     GIR_RootConstrainSelectedInstOperands,
     /*  93231 */     // GIR_Coverage, 384,
     /*  93231 */     GIR_EraseRootFromParent_Done,
     /*  93232 */   // Label 1465: @93232
     /*  93232 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(93269), // Rule ID 411 //
     /*  93237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkshss),
     /*  93245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93258 */     // (intrinsic_w_chain:{ *:[v16i8] } 10457:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKSHSS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  93258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSHSS),
     /*  93261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93263 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93265 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93267 */     GIR_RootConstrainSelectedInstOperands,
     /*  93268 */     // GIR_Coverage, 411,
     /*  93268 */     GIR_EraseRootFromParent_Done,
     /*  93269 */   // Label 1466: @93269
     /*  93269 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(93306), // Rule ID 412 //
     /*  93274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkshus),
     /*  93282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93295 */     // (intrinsic_w_chain:{ *:[v16i8] } 10458:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKSHUS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  93295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSHUS),
     /*  93298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93300 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93302 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93304 */     GIR_RootConstrainSelectedInstOperands,
     /*  93305 */     // GIR_Coverage, 412,
     /*  93305 */     GIR_EraseRootFromParent_Done,
     /*  93306 */   // Label 1467: @93306
     /*  93306 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(93343), // Rule ID 413 //
     /*  93311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkswss),
     /*  93319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93332 */     // (intrinsic_w_chain:{ *:[v8i16] } 10459:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKSWSS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSWSS),
     /*  93335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93337 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93339 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93341 */     GIR_RootConstrainSelectedInstOperands,
     /*  93342 */     // GIR_Coverage, 413,
     /*  93342 */     GIR_EraseRootFromParent_Done,
     /*  93343 */   // Label 1468: @93343
     /*  93343 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(93380), // Rule ID 414 //
     /*  93348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkswus),
     /*  93356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93369 */     // (intrinsic_w_chain:{ *:[v8i16] } 10460:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKSWUS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSWUS),
     /*  93372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93374 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93376 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93378 */     GIR_RootConstrainSelectedInstOperands,
     /*  93379 */     // GIR_Coverage, 414,
     /*  93379 */     GIR_EraseRootFromParent_Done,
     /*  93380 */   // Label 1469: @93380
     /*  93380 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(93417), // Rule ID 415 //
     /*  93385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkuhus),
     /*  93393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93406 */     // (intrinsic_w_chain:{ *:[v16i8] } 10462:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKUHUS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  93406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUHUS),
     /*  93409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93411 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93413 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93415 */     GIR_RootConstrainSelectedInstOperands,
     /*  93416 */     // GIR_Coverage, 415,
     /*  93416 */     GIR_EraseRootFromParent_Done,
     /*  93417 */   // Label 1470: @93417
     /*  93417 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(93454), // Rule ID 416 //
     /*  93422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkuwus),
     /*  93430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93443 */     // (intrinsic_w_chain:{ *:[v8i16] } 10463:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKUWUS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUWUS),
     /*  93446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93448 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93450 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93452 */     GIR_RootConstrainSelectedInstOperands,
     /*  93453 */     // GIR_Coverage, 416,
     /*  93453 */     GIR_EraseRootFromParent_Done,
     /*  93454 */   // Label 1471: @93454
     /*  93454 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(93491), // Rule ID 500 //
     /*  93459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  93462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpksdss),
     /*  93467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93480 */     // (intrinsic_w_chain:{ *:[v4i32] } 10455:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKSDSS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  93480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSDSS),
     /*  93483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93485 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93487 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93489 */     GIR_RootConstrainSelectedInstOperands,
     /*  93490 */     // GIR_Coverage, 500,
     /*  93490 */     GIR_EraseRootFromParent_Done,
     /*  93491 */   // Label 1472: @93491
     /*  93491 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(93528), // Rule ID 501 //
     /*  93496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  93499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpksdus),
     /*  93504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93517 */     // (intrinsic_w_chain:{ *:[v4i32] } 10456:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKSDUS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  93517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSDUS),
     /*  93520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93522 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93524 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93526 */     GIR_RootConstrainSelectedInstOperands,
     /*  93527 */     // GIR_Coverage, 501,
     /*  93527 */     GIR_EraseRootFromParent_Done,
     /*  93528 */   // Label 1473: @93528
     /*  93528 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(93565), // Rule ID 502 //
     /*  93533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  93536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkudus),
     /*  93541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93554 */     // (intrinsic_w_chain:{ *:[v4i32] } 10461:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKUDUS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  93554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUDUS),
     /*  93557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93559 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93561 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93563 */     GIR_RootConstrainSelectedInstOperands,
     /*  93564 */     // GIR_Coverage, 502,
     /*  93564 */     GIR_EraseRootFromParent_Done,
     /*  93565 */   // Label 1474: @93565
     /*  93565 */   GIM_Reject,
     /*  93566 */ // Label 1452: @93566
     /*  93566 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(93782),
     /*  93571 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  93574 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(93613), // Rule ID 762 //
     /*  93579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addex),
     /*  93584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  93587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  93590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  93593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  93597 */     // MIs[0] CY
     /*  93597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  93600 */     // (intrinsic_w_chain:{ *:[i64] } 10222:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB, (timm:{ *:[i32] }):$CY)  =>  (ADDEX8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB, (timm:{ *:[i32] }):$CY)
     /*  93600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDEX8),
     /*  93603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93605 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93607 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93609 */     GIR_RootToRootCopy, /*OpIdx*/4, // CY
     /*  93611 */     GIR_RootConstrainSelectedInstOperands,
     /*  93612 */     // GIR_Coverage, 762,
     /*  93612 */     GIR_EraseRootFromParent_Done,
     /*  93613 */   // Label 1476: @93613
     /*  93613 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(93655), // Rule ID 294 //
     /*  93618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmhaddshs),
     /*  93626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  93638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93642 */     // (intrinsic_w_chain:{ *:[v8i16] } 10410:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMHADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  93642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMHADDSHS),
     /*  93645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93647 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93649 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93651 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  93653 */     GIR_RootConstrainSelectedInstOperands,
     /*  93654 */     // GIR_Coverage, 294,
     /*  93654 */     GIR_EraseRootFromParent_Done,
     /*  93655 */   // Label 1477: @93655
     /*  93655 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(93697), // Rule ID 295 //
     /*  93660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmhraddshs),
     /*  93668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  93680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93684 */     // (intrinsic_w_chain:{ *:[v8i16] } 10411:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMHRADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  93684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMHRADDSHS),
     /*  93687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93689 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93691 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93693 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  93695 */     GIR_RootConstrainSelectedInstOperands,
     /*  93696 */     // GIR_Coverage, 295,
     /*  93696 */     GIR_EraseRootFromParent_Done,
     /*  93697 */   // Label 1478: @93697
     /*  93697 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(93739), // Rule ID 353 //
     /*  93702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumshs),
     /*  93710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  93722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93726 */     // (intrinsic_w_chain:{ *:[v4i32] } 10425:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMSHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  93726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMSHS),
     /*  93729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93731 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93733 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93735 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  93737 */     GIR_RootConstrainSelectedInstOperands,
     /*  93738 */     // GIR_Coverage, 353,
     /*  93738 */     GIR_EraseRootFromParent_Done,
     /*  93739 */   // Label 1479: @93739
     /*  93739 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(93781), // Rule ID 354 //
     /*  93744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumuhs),
     /*  93752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  93764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93768 */     // (intrinsic_w_chain:{ *:[v4i32] } 10429:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  93768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUHS),
     /*  93771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93773 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93775 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93777 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  93779 */     GIR_RootConstrainSelectedInstOperands,
     /*  93780 */     // GIR_Coverage, 354,
     /*  93780 */     GIR_EraseRootFromParent_Done,
     /*  93781 */   // Label 1480: @93781
     /*  93781 */   GIM_Reject,
     /*  93782 */ // Label 1475: @93782
     /*  93782 */ GIM_Reject,
     /*  93783 */ // Label 21: @93783
     /*  93783 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1483*/ GIMT_Encode4(114538),
     /*  93794 */ /*GILLT_s32*//*Label 1481*/ GIMT_Encode4(93802),
     /*  93798 */ /*GILLT_s64*//*Label 1482*/ GIMT_Encode4(104023),
     /*  93802 */ // Label 1481: @93802
     /*  93802 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(104022),
     /*  93807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  93810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  93814 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(93926), // Rule ID 5292 //
     /*  93819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  93831 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  93835 */     // MIs[1] Operand 1
     /*  93835 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  93840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  93844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  93852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  93856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  93860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  93864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  93868 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  93872 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  93876 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  93880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93882 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  93882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  93885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  93889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  93898 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  93901 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /*  93904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  93909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  93911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  93915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93924 */     GIR_RootConstrainSelectedInstOperands,
     /*  93925 */     // GIR_Coverage, 5292,
     /*  93925 */     GIR_EraseRootFromParent_Done,
     /*  93926 */   // Label 1485: @93926
     /*  93926 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(94065), // Rule ID 5295 //
     /*  93931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  93943 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  93947 */     // MIs[1] Operand 1
     /*  93947 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  93952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  93956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  93964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  93968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  93972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  93976 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  93980 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  93984 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  93988 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  93992 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93994 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  93994 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  93997 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94001 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94006 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94010 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /*  94013 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94034 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94037 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94047 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94064 */     // GIR_Coverage, 5295,
     /*  94064 */     GIR_EraseRootFromParent_Done,
     /*  94065 */   // Label 1486: @94065
     /*  94065 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(94198), // Rule ID 5300 //
     /*  94070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94082 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94086 */     // MIs[1] Operand 1
     /*  94086 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94115 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94119 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94123 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94127 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94133 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94133 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94136 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94140 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94145 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94149 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*  94152 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  94164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94169 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94173 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  94182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94196 */     GIR_RootConstrainSelectedInstOperands,
     /*  94197 */     // GIR_Coverage, 5300,
     /*  94197 */     GIR_EraseRootFromParent_Done,
     /*  94198 */   // Label 1487: @94198
     /*  94198 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(94358), // Rule ID 5303 //
     /*  94203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94215 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94219 */     // MIs[1] Operand 1
     /*  94219 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  94236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  94240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94248 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  94252 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94256 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94260 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94266 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94266 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  94269 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94273 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94278 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94282 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /*  94285 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /*  94288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  94290 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  94293 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  94297 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94302 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94306 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94324 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94327 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  94330 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94340 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94357 */     // GIR_Coverage, 5303,
     /*  94357 */     GIR_EraseRootFromParent_Done,
     /*  94358 */   // Label 1488: @94358
     /*  94358 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(94470), // Rule ID 3773 //
     /*  94363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94375 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94379 */     // MIs[1] Operand 1
     /*  94379 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94408 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94412 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94416 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94420 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94424 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94426 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94438 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94442 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  94445 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /*  94448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  94453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94468 */     GIR_RootConstrainSelectedInstOperands,
     /*  94469 */     // GIR_Coverage, 3773,
     /*  94469 */     GIR_EraseRootFromParent_Done,
     /*  94470 */   // Label 1489: @94470
     /*  94470 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(94609), // Rule ID 3776 //
     /*  94475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94487 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94491 */     // MIs[1] Operand 1
     /*  94491 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  94508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  94512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94520 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  94524 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94528 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94532 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94538 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94538 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94541 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94545 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94550 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94554 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /*  94557 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94574 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94578 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94581 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94591 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94608 */     // GIR_Coverage, 3776,
     /*  94608 */     GIR_EraseRootFromParent_Done,
     /*  94609 */   // Label 1490: @94609
     /*  94609 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(94742), // Rule ID 3781 //
     /*  94614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94626 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94630 */     // MIs[1] Operand 1
     /*  94630 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94659 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94663 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94667 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94671 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94677 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94677 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94680 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94684 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94689 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94693 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*  94696 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  94708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  94726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94740 */     GIR_RootConstrainSelectedInstOperands,
     /*  94741 */     // GIR_Coverage, 3781,
     /*  94741 */     GIR_EraseRootFromParent_Done,
     /*  94742 */   // Label 1491: @94742
     /*  94742 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(94902), // Rule ID 3784 //
     /*  94747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94759 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94763 */     // MIs[1] Operand 1
     /*  94763 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  94780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  94784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94792 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  94796 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94800 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94808 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94810 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94810 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  94813 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94817 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94822 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94826 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /*  94829 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /*  94832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  94834 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  94837 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  94841 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94846 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94850 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94868 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94871 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  94874 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94884 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94891 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94901 */     // GIR_Coverage, 3784,
     /*  94901 */     GIR_EraseRootFromParent_Done,
     /*  94902 */   // Label 1492: @94902
     /*  94902 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(94971), // Rule ID 3693 //
     /*  94907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94919 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94923 */     // MIs[1] Operand 1
     /*  94923 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94928 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94934 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  94941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  94955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /*  94963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94969 */     GIR_RootConstrainSelectedInstOperands,
     /*  94970 */     // GIR_Coverage, 3693,
     /*  94970 */     GIR_EraseRootFromParent_Done,
     /*  94971 */   // Label 1493: @94971
     /*  94971 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(95067), // Rule ID 3696 //
     /*  94976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94988 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94992 */     // MIs[1] Operand 1
     /*  94992 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94997 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95003 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95003 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95006 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  95010 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95015 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95033 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95036 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /*  95039 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95049 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95066 */     // GIR_Coverage, 3696,
     /*  95066 */     GIR_EraseRootFromParent_Done,
     /*  95067 */   // Label 1494: @95067
     /*  95067 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(95174), // Rule ID 3701 //
     /*  95072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95084 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95088 */     // MIs[1] Operand 1
     /*  95088 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  95093 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95099 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95099 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  95102 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  95106 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95111 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95117 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95120 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  95124 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95129 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  95142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95147 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95150 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  95153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /*  95166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95172 */     GIR_RootConstrainSelectedInstOperands,
     /*  95173 */     // GIR_Coverage, 3701,
     /*  95173 */     GIR_EraseRootFromParent_Done,
     /*  95174 */   // Label 1495: @95174
     /*  95174 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(95308), // Rule ID 3704 //
     /*  95179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95191 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95195 */     // MIs[1] Operand 1
     /*  95195 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  95200 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95206 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95206 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  95209 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  95213 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95218 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  95224 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  95227 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  95231 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95236 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95242 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95245 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  95249 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95254 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  95257 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  95260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95274 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95277 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /*  95280 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95290 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95307 */     // GIR_Coverage, 3704,
     /*  95307 */     GIR_EraseRootFromParent_Done,
     /*  95308 */   // Label 1496: @95308
     /*  95308 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(95360), // Rule ID 3709 //
     /*  95313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95325 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95329 */     // MIs[1] Operand 1
     /*  95329 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  95334 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95340 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  95352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95358 */     GIR_RootConstrainSelectedInstOperands,
     /*  95359 */     // GIR_Coverage, 3709,
     /*  95359 */     GIR_EraseRootFromParent_Done,
     /*  95360 */   // Label 1497: @95360
     /*  95360 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(95439), // Rule ID 3712 //
     /*  95365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95377 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95381 */     // MIs[1] Operand 1
     /*  95381 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  95386 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95392 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95408 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  95411 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95421 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95438 */     // GIR_Coverage, 3712,
     /*  95438 */     GIR_EraseRootFromParent_Done,
     /*  95439 */   // Label 1498: @95439
     /*  95439 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(95512), // Rule ID 3717 //
     /*  95444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95460 */     // MIs[1] Operand 1
     /*  95460 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  95465 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95471 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  95478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95483 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95487 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  95504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95510 */     GIR_RootConstrainSelectedInstOperands,
     /*  95511 */     // GIR_Coverage, 3717,
     /*  95511 */     GIR_EraseRootFromParent_Done,
     /*  95512 */   // Label 1499: @95512
     /*  95512 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(95612), // Rule ID 3720 //
     /*  95517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95529 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95533 */     // MIs[1] Operand 1
     /*  95533 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  95538 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95544 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95544 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95547 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  95551 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95556 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95560 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95578 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95581 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  95584 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95594 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95606 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95611 */     // GIR_Coverage, 3720,
     /*  95611 */     GIR_EraseRootFromParent_Done,
     /*  95612 */   // Label 1500: @95612
     /*  95612 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(95702), // Rule ID 3725 //
     /*  95617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95629 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95633 */     // MIs[1] Operand 1
     /*  95633 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  95638 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95644 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95644 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*  95651 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95656 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*  95669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95674 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  95694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95700 */     GIR_RootConstrainSelectedInstOperands,
     /*  95701 */     // GIR_Coverage, 3725,
     /*  95701 */     GIR_EraseRootFromParent_Done,
     /*  95702 */   // Label 1501: @95702
     /*  95702 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(95819), // Rule ID 3728 //
     /*  95707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95719 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95723 */     // MIs[1] Operand 1
     /*  95723 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  95728 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95734 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95734 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  95737 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*  95741 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95746 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95752 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95755 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*  95759 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95764 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  95767 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95785 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95788 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  95791 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95801 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95818 */     // GIR_Coverage, 3728,
     /*  95818 */     GIR_EraseRootFromParent_Done,
     /*  95819 */   // Label 1502: @95819
     /*  95819 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(95909), // Rule ID 3733 //
     /*  95824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95836 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95840 */     // MIs[1] Operand 1
     /*  95840 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  95845 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95851 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95851 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95854 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*  95858 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95863 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*  95876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95881 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95885 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  95901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95907 */     GIR_RootConstrainSelectedInstOperands,
     /*  95908 */     // GIR_Coverage, 3733,
     /*  95908 */     GIR_EraseRootFromParent_Done,
     /*  95909 */   // Label 1503: @95909
     /*  95909 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(96026), // Rule ID 3736 //
     /*  95914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95926 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95930 */     // MIs[1] Operand 1
     /*  95930 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  95935 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95941 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95941 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  95944 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*  95948 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95953 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95959 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95962 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*  95966 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95971 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95975 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  95978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95992 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95995 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  95998 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96008 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96025 */     // GIR_Coverage, 3736,
     /*  96025 */     GIR_EraseRootFromParent_Done,
     /*  96026 */   // Label 1504: @96026
     /*  96026 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(96119), // Rule ID 3741 //
     /*  96031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96043 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96047 */     // MIs[1] Operand 1
     /*  96047 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  96052 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96058 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96058 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96061 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*  96065 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96070 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96074 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /*  96077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND),
     /*  96086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96095 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96117 */     GIR_RootConstrainSelectedInstOperands,
     /*  96118 */     // GIR_Coverage, 3741,
     /*  96118 */     GIR_EraseRootFromParent_Done,
     /*  96119 */   // Label 1505: @96119
     /*  96119 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(96239), // Rule ID 3744 //
     /*  96124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96136 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96140 */     // MIs[1] Operand 1
     /*  96140 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  96145 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96151 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96151 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  96154 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*  96158 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96163 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96167 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  96170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96172 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96175 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /*  96179 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96184 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96188 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  96191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96205 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96208 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96211 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96221 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96238 */     // GIR_Coverage, 3744,
     /*  96238 */     GIR_EraseRootFromParent_Done,
     /*  96239 */   // Label 1506: @96239
     /*  96239 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(96332), // Rule ID 3749 //
     /*  96244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96256 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96260 */     // MIs[1] Operand 1
     /*  96260 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  96265 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96271 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96271 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96274 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*  96278 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96283 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96287 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /*  96290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /*  96299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96304 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96308 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96330 */     GIR_RootConstrainSelectedInstOperands,
     /*  96331 */     // GIR_Coverage, 3749,
     /*  96331 */     GIR_EraseRootFromParent_Done,
     /*  96332 */   // Label 1507: @96332
     /*  96332 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(96452), // Rule ID 3752 //
     /*  96337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96349 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96353 */     // MIs[1] Operand 1
     /*  96353 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  96358 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96364 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96364 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  96367 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*  96371 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96376 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96380 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  96383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /*  96392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96397 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96401 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  96404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96418 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96421 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96424 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96434 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96451 */     // GIR_Coverage, 3752,
     /*  96451 */     GIR_EraseRootFromParent_Done,
     /*  96452 */   // Label 1508: @96452
     /*  96452 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(96525), // Rule ID 3757 //
     /*  96457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96469 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96473 */     // MIs[1] Operand 1
     /*  96473 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  96478 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96484 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  96491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96496 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96500 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96523 */     GIR_RootConstrainSelectedInstOperands,
     /*  96524 */     // GIR_Coverage, 3757,
     /*  96524 */     GIR_EraseRootFromParent_Done,
     /*  96525 */   // Label 1509: @96525
     /*  96525 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(96625), // Rule ID 3760 //
     /*  96530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96542 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96546 */     // MIs[1] Operand 1
     /*  96546 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  96551 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96557 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96557 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96560 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  96564 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96569 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96573 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96591 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96594 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96597 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96607 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96624 */     // GIR_Coverage, 3760,
     /*  96624 */     GIR_EraseRootFromParent_Done,
     /*  96625 */   // Label 1510: @96625
     /*  96625 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(96677), // Rule ID 3765 //
     /*  96630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96642 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96646 */     // MIs[1] Operand 1
     /*  96646 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  96651 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96657 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96675 */     GIR_RootConstrainSelectedInstOperands,
     /*  96676 */     // GIR_Coverage, 3765,
     /*  96676 */     GIR_EraseRootFromParent_Done,
     /*  96677 */   // Label 1511: @96677
     /*  96677 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(96756), // Rule ID 3768 //
     /*  96682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96694 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96698 */     // MIs[1] Operand 1
     /*  96698 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  96703 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96709 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96725 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96728 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96738 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96755 */     // GIR_Coverage, 3768,
     /*  96755 */     GIR_EraseRootFromParent_Done,
     /*  96756 */   // Label 1512: @96756
     /*  96756 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(96859), // Rule ID 3033 //
     /*  96761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  96764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96776 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96780 */     // MIs[1] Operand 1
     /*  96780 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  96785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  96789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  96793 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  96797 */     // MIs[2] Operand 1
     /*  96797 */     // No operand predicates
     /*  96797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  96799 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /*  96799 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96802 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  96806 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96811 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  96818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96832 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  96839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96857 */     GIR_RootConstrainSelectedInstOperands,
     /*  96858 */     // GIR_Coverage, 3033,
     /*  96858 */     GIR_EraseRootFromParent_Done,
     /*  96859 */   // Label 1513: @96859
     /*  96859 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(96962), // Rule ID 3049 //
     /*  96864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  96867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96879 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96883 */     // MIs[1] Operand 1
     /*  96883 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  96888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  96892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  96896 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  96900 */     // MIs[2] Operand 1
     /*  96900 */     // No operand predicates
     /*  96900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  96902 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /*  96902 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96905 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  96909 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96914 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  96921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96935 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  96942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96960 */     GIR_RootConstrainSelectedInstOperands,
     /*  96961 */     // GIR_Coverage, 3049,
     /*  96961 */     GIR_EraseRootFromParent_Done,
     /*  96962 */   // Label 1514: @96962
     /*  96962 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(97065), // Rule ID 3057 //
     /*  96967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  96970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96982 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96986 */     // MIs[1] Operand 1
     /*  96986 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  96991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  96995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  96999 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97003 */     // MIs[2] Operand 1
     /*  97003 */     // No operand predicates
     /*  97003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97005 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /*  97005 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97008 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97012 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97017 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97038 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  97045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97063 */     GIR_RootConstrainSelectedInstOperands,
     /*  97064 */     // GIR_Coverage, 3057,
     /*  97064 */     GIR_EraseRootFromParent_Done,
     /*  97065 */   // Label 1515: @97065
     /*  97065 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(97168), // Rule ID 3129 //
     /*  97070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97085 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97089 */     // MIs[1] Operand 1
     /*  97089 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  97094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97102 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97106 */     // MIs[2] Operand 1
     /*  97106 */     // No operand predicates
     /*  97106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97108 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /*  97108 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97111 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97115 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97120 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97141 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97166 */     GIR_RootConstrainSelectedInstOperands,
     /*  97167 */     // GIR_Coverage, 3129,
     /*  97167 */     GIR_EraseRootFromParent_Done,
     /*  97168 */   // Label 1516: @97168
     /*  97168 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(97271), // Rule ID 3145 //
     /*  97173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97188 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97192 */     // MIs[1] Operand 1
     /*  97192 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97205 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97209 */     // MIs[2] Operand 1
     /*  97209 */     // No operand predicates
     /*  97209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97211 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /*  97211 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97214 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97218 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97223 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97244 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  97251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97269 */     GIR_RootConstrainSelectedInstOperands,
     /*  97270 */     // GIR_Coverage, 3145,
     /*  97270 */     GIR_EraseRootFromParent_Done,
     /*  97271 */   // Label 1517: @97271
     /*  97271 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(97374), // Rule ID 3153 //
     /*  97276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97291 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97295 */     // MIs[1] Operand 1
     /*  97295 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  97300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97308 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97312 */     // MIs[2] Operand 1
     /*  97312 */     // No operand predicates
     /*  97312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97314 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /*  97314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97326 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97347 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  97354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97372 */     GIR_RootConstrainSelectedInstOperands,
     /*  97373 */     // GIR_Coverage, 3153,
     /*  97373 */     GIR_EraseRootFromParent_Done,
     /*  97374 */   // Label 1518: @97374
     /*  97374 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(97517), // Rule ID 3815 //
     /*  97379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97394 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97398 */     // MIs[1] Operand 1
     /*  97398 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  97403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97411 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97415 */     // MIs[2] Operand 1
     /*  97415 */     // No operand predicates
     /*  97415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97417 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97438 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97441 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97445 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97450 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97455 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97458 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97462 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97467 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97484 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97515 */     GIR_RootConstrainSelectedInstOperands,
     /*  97516 */     // GIR_Coverage, 3815,
     /*  97516 */     GIR_EraseRootFromParent_Done,
     /*  97517 */   // Label 1519: @97517
     /*  97517 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(97660), // Rule ID 3831 //
     /*  97522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97537 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97541 */     // MIs[1] Operand 1
     /*  97541 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97554 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97558 */     // MIs[2] Operand 1
     /*  97558 */     // No operand predicates
     /*  97558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97560 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97560 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97563 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97567 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97572 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97581 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97584 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97588 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97593 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97598 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97601 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97605 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97610 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97627 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  97634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97658 */     GIR_RootConstrainSelectedInstOperands,
     /*  97659 */     // GIR_Coverage, 3831,
     /*  97659 */     GIR_EraseRootFromParent_Done,
     /*  97660 */   // Label 1520: @97660
     /*  97660 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(97803), // Rule ID 3839 //
     /*  97665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97680 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97684 */     // MIs[1] Operand 1
     /*  97684 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  97689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97697 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97701 */     // MIs[2] Operand 1
     /*  97701 */     // No operand predicates
     /*  97701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97703 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97703 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97706 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97710 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97715 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97724 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97727 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97731 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97736 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97741 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97744 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97748 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97753 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97770 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  97777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97801 */     GIR_RootConstrainSelectedInstOperands,
     /*  97802 */     // GIR_Coverage, 3839,
     /*  97802 */     GIR_EraseRootFromParent_Done,
     /*  97803 */   // Label 1521: @97803
     /*  97803 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(97946), // Rule ID 3911 //
     /*  97808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97823 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97827 */     // MIs[1] Operand 1
     /*  97827 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  97832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97840 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97844 */     // MIs[2] Operand 1
     /*  97844 */     // No operand predicates
     /*  97844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97846 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97846 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97849 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97853 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97858 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97867 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97870 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97874 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97879 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97884 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97887 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97891 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97896 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97913 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97944 */     GIR_RootConstrainSelectedInstOperands,
     /*  97945 */     // GIR_Coverage, 3911,
     /*  97945 */     GIR_EraseRootFromParent_Done,
     /*  97946 */   // Label 1522: @97946
     /*  97946 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(98089), // Rule ID 3927 //
     /*  97951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97966 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97970 */     // MIs[1] Operand 1
     /*  97970 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97983 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97987 */     // MIs[2] Operand 1
     /*  97987 */     // No operand predicates
     /*  97987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97989 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98001 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  98008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98010 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98013 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98017 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98022 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98027 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98030 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98034 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98039 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98056 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98087 */     GIR_RootConstrainSelectedInstOperands,
     /*  98088 */     // GIR_Coverage, 3927,
     /*  98088 */     GIR_EraseRootFromParent_Done,
     /*  98089 */   // Label 1523: @98089
     /*  98089 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(98232), // Rule ID 3935 //
     /*  98094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  98097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  98105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98109 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98113 */     // MIs[1] Operand 1
     /*  98113 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  98118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98126 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  98130 */     // MIs[2] Operand 1
     /*  98130 */     // No operand predicates
     /*  98130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98132 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98132 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98135 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  98139 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98144 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  98151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98153 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98156 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98160 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98165 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98170 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98173 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98177 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98182 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98199 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  98206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98230 */     GIR_RootConstrainSelectedInstOperands,
     /*  98231 */     // GIR_Coverage, 3935,
     /*  98231 */     GIR_EraseRootFromParent_Done,
     /*  98232 */   // Label 1524: @98232
     /*  98232 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(98324), // Rule ID 3177 //
     /*  98237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98252 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98256 */     // MIs[1] Operand 1
     /*  98256 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  98261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98263 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /*  98263 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98266 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98270 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98275 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98279 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98297 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  98304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98322 */     GIR_RootConstrainSelectedInstOperands,
     /*  98323 */     // GIR_Coverage, 3177,
     /*  98323 */     GIR_EraseRootFromParent_Done,
     /*  98324 */   // Label 1525: @98324
     /*  98324 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(98416), // Rule ID 3193 //
     /*  98329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98344 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98348 */     // MIs[1] Operand 1
     /*  98348 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  98353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98355 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /*  98355 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98358 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98362 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98367 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98389 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98414 */     GIR_RootConstrainSelectedInstOperands,
     /*  98415 */     // GIR_Coverage, 3193,
     /*  98415 */     GIR_EraseRootFromParent_Done,
     /*  98416 */   // Label 1526: @98416
     /*  98416 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(98508), // Rule ID 3209 //
     /*  98421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98436 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98440 */     // MIs[1] Operand 1
     /*  98440 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  98445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98447 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /*  98447 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98450 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98454 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98463 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98481 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  98488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98506 */     GIR_RootConstrainSelectedInstOperands,
     /*  98507 */     // GIR_Coverage, 3209,
     /*  98507 */     GIR_EraseRootFromParent_Done,
     /*  98508 */   // Label 1527: @98508
     /*  98508 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(98600), // Rule ID 3225 //
     /*  98513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98528 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98532 */     // MIs[1] Operand 1
     /*  98532 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  98537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98539 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /*  98539 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98542 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98546 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98551 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98555 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98573 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  98580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98598 */     GIR_RootConstrainSelectedInstOperands,
     /*  98599 */     // GIR_Coverage, 3225,
     /*  98599 */     GIR_EraseRootFromParent_Done,
     /*  98600 */   // Label 1528: @98600
     /*  98600 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(98692), // Rule ID 3233 //
     /*  98605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98620 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98624 */     // MIs[1] Operand 1
     /*  98624 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  98629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98631 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /*  98631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  98638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98647 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98665 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  98672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98690 */     GIR_RootConstrainSelectedInstOperands,
     /*  98691 */     // GIR_Coverage, 3233,
     /*  98691 */     GIR_EraseRootFromParent_Done,
     /*  98692 */   // Label 1529: @98692
     /*  98692 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(98784), // Rule ID 3249 //
     /*  98697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98712 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98716 */     // MIs[1] Operand 1
     /*  98716 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  98721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98723 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /*  98723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  98730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98735 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98739 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98757 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98782 */     GIR_RootConstrainSelectedInstOperands,
     /*  98783 */     // GIR_Coverage, 3249,
     /*  98783 */     GIR_EraseRootFromParent_Done,
     /*  98784 */   // Label 1530: @98784
     /*  98784 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(98876), // Rule ID 3265 //
     /*  98789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98804 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98808 */     // MIs[1] Operand 1
     /*  98808 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  98813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98815 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /*  98815 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98818 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  98822 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98827 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98831 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98849 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  98856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98874 */     GIR_RootConstrainSelectedInstOperands,
     /*  98875 */     // GIR_Coverage, 3265,
     /*  98875 */     GIR_EraseRootFromParent_Done,
     /*  98876 */   // Label 1531: @98876
     /*  98876 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(98968), // Rule ID 3281 //
     /*  98881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98896 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98900 */     // MIs[1] Operand 1
     /*  98900 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  98905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98907 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /*  98907 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98910 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  98914 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98919 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98923 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98941 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  98948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98966 */     GIR_RootConstrainSelectedInstOperands,
     /*  98967 */     // GIR_Coverage, 3281,
     /*  98967 */     GIR_EraseRootFromParent_Done,
     /*  98968 */   // Label 1532: @98968
     /*  98968 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(99060), // Rule ID 3289 //
     /*  98973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  98988 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  98992 */     // MIs[1] Operand 1
     /*  98992 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  98997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98999 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /*  98999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99011 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99015 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99033 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99058 */     GIR_RootConstrainSelectedInstOperands,
     /*  99059 */     // GIR_Coverage, 3289,
     /*  99059 */     GIR_EraseRootFromParent_Done,
     /*  99060 */   // Label 1533: @99060
     /*  99060 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(99152), // Rule ID 3305 //
     /*  99065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99080 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99084 */     // MIs[1] Operand 1
     /*  99084 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  99089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99091 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /*  99091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99103 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99107 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99125 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99150 */     GIR_RootConstrainSelectedInstOperands,
     /*  99151 */     // GIR_Coverage, 3305,
     /*  99151 */     GIR_EraseRootFromParent_Done,
     /*  99152 */   // Label 1534: @99152
     /*  99152 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(99244), // Rule ID 3321 //
     /*  99157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99172 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99176 */     // MIs[1] Operand 1
     /*  99176 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  99181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99183 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /*  99183 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99186 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99190 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99195 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99199 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99217 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  99224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99242 */     GIR_RootConstrainSelectedInstOperands,
     /*  99243 */     // GIR_Coverage, 3321,
     /*  99243 */     GIR_EraseRootFromParent_Done,
     /*  99244 */   // Label 1535: @99244
     /*  99244 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(99336), // Rule ID 3337 //
     /*  99249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99264 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99268 */     // MIs[1] Operand 1
     /*  99268 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  99273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99275 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /*  99275 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99278 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99282 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99287 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99291 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99309 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  99316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99334 */     GIR_RootConstrainSelectedInstOperands,
     /*  99335 */     // GIR_Coverage, 3337,
     /*  99335 */     GIR_EraseRootFromParent_Done,
     /*  99336 */   // Label 1536: @99336
     /*  99336 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(99468), // Rule ID 4020 //
     /*  99341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99356 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99360 */     // MIs[1] Operand 1
     /*  99360 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  99365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99367 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99379 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99383 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99389 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99392 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99396 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99401 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99406 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99409 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99413 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99418 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99435 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99466 */     GIR_RootConstrainSelectedInstOperands,
     /*  99467 */     // GIR_Coverage, 4020,
     /*  99467 */     GIR_EraseRootFromParent_Done,
     /*  99468 */   // Label 1537: @99468
     /*  99468 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(99600), // Rule ID 4052 //
     /*  99473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99488 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99492 */     // MIs[1] Operand 1
     /*  99492 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  99497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99499 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99511 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99515 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99521 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99524 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99528 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99533 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99550 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99567 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99598 */     GIR_RootConstrainSelectedInstOperands,
     /*  99599 */     // GIR_Coverage, 4052,
     /*  99599 */     GIR_EraseRootFromParent_Done,
     /*  99600 */   // Label 1538: @99600
     /*  99600 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(99732), // Rule ID 4084 //
     /*  99605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99620 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99624 */     // MIs[1] Operand 1
     /*  99624 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  99629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99631 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99647 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99653 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99656 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99660 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99665 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99670 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99673 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99677 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99682 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99699 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  99706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99730 */     GIR_RootConstrainSelectedInstOperands,
     /*  99731 */     // GIR_Coverage, 4084,
     /*  99731 */     GIR_EraseRootFromParent_Done,
     /*  99732 */   // Label 1539: @99732
     /*  99732 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(99864), // Rule ID 4116 //
     /*  99737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99756 */     // MIs[1] Operand 1
     /*  99756 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  99761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99763 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99763 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99766 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99770 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99775 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99779 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99785 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99788 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99792 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99797 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99802 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99805 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99809 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99814 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99831 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  99838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99862 */     GIR_RootConstrainSelectedInstOperands,
     /*  99863 */     // GIR_Coverage, 4116,
     /*  99863 */     GIR_EraseRootFromParent_Done,
     /*  99864 */   // Label 1540: @99864
     /*  99864 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(99996), // Rule ID 4132 //
     /*  99869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  99884 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  99888 */     // MIs[1] Operand 1
     /*  99888 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  99893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99895 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99895 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99898 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  99902 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99907 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99911 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99917 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99920 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99924 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99929 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99934 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99937 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99941 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99946 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99963 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99994 */     GIR_RootConstrainSelectedInstOperands,
     /*  99995 */     // GIR_Coverage, 4132,
     /*  99995 */     GIR_EraseRootFromParent_Done,
     /*  99996 */   // Label 1541: @99996
     /*  99996 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(100128), // Rule ID 4164 //
     /* 100001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100016 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100020 */     // MIs[1] Operand 1
     /* 100020 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 100025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100027 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100027 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100030 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100034 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100039 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100043 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100049 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100052 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100056 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100061 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100066 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100069 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100073 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100078 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100095 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 100102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100126 */     GIR_RootConstrainSelectedInstOperands,
     /* 100127 */     // GIR_Coverage, 4164,
     /* 100127 */     GIR_EraseRootFromParent_Done,
     /* 100128 */   // Label 1542: @100128
     /* 100128 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(100260), // Rule ID 4196 //
     /* 100133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100148 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100152 */     // MIs[1] Operand 1
     /* 100152 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 100157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100159 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100159 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100162 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100166 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100171 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100175 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100181 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100184 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100188 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100193 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100198 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100201 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100205 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100210 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100227 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 100234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100258 */     GIR_RootConstrainSelectedInstOperands,
     /* 100259 */     // GIR_Coverage, 4196,
     /* 100259 */     GIR_EraseRootFromParent_Done,
     /* 100260 */   // Label 1543: @100260
     /* 100260 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(100392), // Rule ID 4228 //
     /* 100265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100280 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100284 */     // MIs[1] Operand 1
     /* 100284 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 100289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100291 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100291 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100294 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100298 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100303 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100307 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100313 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100316 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100320 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100325 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100330 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100333 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100337 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100342 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100359 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 100366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100390 */     GIR_RootConstrainSelectedInstOperands,
     /* 100391 */     // GIR_Coverage, 4228,
     /* 100391 */     GIR_EraseRootFromParent_Done,
     /* 100392 */   // Label 1544: @100392
     /* 100392 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(100524), // Rule ID 4258 //
     /* 100397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100412 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 100416 */     // MIs[1] Operand 1
     /* 100416 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 100421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100423 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100423 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100426 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 100430 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100435 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100439 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100445 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100448 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100452 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100457 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100462 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100465 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100469 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100474 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100491 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 100498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100522 */     GIR_RootConstrainSelectedInstOperands,
     /* 100523 */     // GIR_Coverage, 4258,
     /* 100523 */     GIR_EraseRootFromParent_Done,
     /* 100524 */   // Label 1545: @100524
     /* 100524 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(100656), // Rule ID 4290 //
     /* 100529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100544 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 100548 */     // MIs[1] Operand 1
     /* 100548 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 100553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100555 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100555 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100558 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 100562 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100567 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100571 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100577 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100580 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100584 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100589 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100594 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100597 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100601 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100606 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100623 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 100630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100654 */     GIR_RootConstrainSelectedInstOperands,
     /* 100655 */     // GIR_Coverage, 4290,
     /* 100655 */     GIR_EraseRootFromParent_Done,
     /* 100656 */   // Label 1546: @100656
     /* 100656 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(100788), // Rule ID 4322 //
     /* 100661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100676 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 100680 */     // MIs[1] Operand 1
     /* 100680 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 100685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100687 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 100694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100703 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100709 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100712 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100716 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100721 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100726 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100729 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100733 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100738 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100755 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 100762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100786 */     GIR_RootConstrainSelectedInstOperands,
     /* 100787 */     // GIR_Coverage, 4322,
     /* 100787 */     GIR_EraseRootFromParent_Done,
     /* 100788 */   // Label 1547: @100788
     /* 100788 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(100920), // Rule ID 4354 //
     /* 100793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100808 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 100812 */     // MIs[1] Operand 1
     /* 100812 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 100817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100819 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100819 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100822 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 100826 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100831 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100841 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100844 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100848 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100853 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100858 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100861 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100865 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100870 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100887 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 100894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100918 */     GIR_RootConstrainSelectedInstOperands,
     /* 100919 */     // GIR_Coverage, 4354,
     /* 100919 */     GIR_EraseRootFromParent_Done,
     /* 100920 */   // Label 1548: @100920
     /* 100920 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(101052), // Rule ID 4585 //
     /* 100925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 100928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 100940 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100944 */     // MIs[1] Operand 1
     /* 100944 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 100949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100951 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100951 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100954 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 100958 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100963 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100967 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100973 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100976 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100980 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100985 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100990 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100993 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100997 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101002 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101019 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101050 */     GIR_RootConstrainSelectedInstOperands,
     /* 101051 */     // GIR_Coverage, 4585,
     /* 101051 */     GIR_EraseRootFromParent_Done,
     /* 101052 */   // Label 1549: @101052
     /* 101052 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(101184), // Rule ID 4617 //
     /* 101057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101072 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101076 */     // MIs[1] Operand 1
     /* 101076 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 101081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101083 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101083 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101086 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 101090 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101095 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101099 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101105 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101108 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101112 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101117 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101134 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101151 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101182 */     GIR_RootConstrainSelectedInstOperands,
     /* 101183 */     // GIR_Coverage, 4617,
     /* 101183 */     GIR_EraseRootFromParent_Done,
     /* 101184 */   // Label 1550: @101184
     /* 101184 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(101316), // Rule ID 4649 //
     /* 101189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101204 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101208 */     // MIs[1] Operand 1
     /* 101208 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 101213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101215 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101215 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101218 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 101222 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101227 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101231 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101237 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101240 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101244 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101249 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101254 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101257 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101261 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101266 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101283 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101314 */     GIR_RootConstrainSelectedInstOperands,
     /* 101315 */     // GIR_Coverage, 4649,
     /* 101315 */     GIR_EraseRootFromParent_Done,
     /* 101316 */   // Label 1551: @101316
     /* 101316 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(101448), // Rule ID 4693 //
     /* 101321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101340 */     // MIs[1] Operand 1
     /* 101340 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 101345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101347 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 101354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101363 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101369 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101372 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101376 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101381 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101386 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101389 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101393 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101398 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101415 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101446 */     GIR_RootConstrainSelectedInstOperands,
     /* 101447 */     // GIR_Coverage, 4693,
     /* 101447 */     GIR_EraseRootFromParent_Done,
     /* 101448 */   // Label 1552: @101448
     /* 101448 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(101580), // Rule ID 4725 //
     /* 101453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101468 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101472 */     // MIs[1] Operand 1
     /* 101472 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 101477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101479 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 101486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101491 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101495 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101501 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101504 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101508 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101513 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101518 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101521 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101525 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101530 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101547 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101578 */     GIR_RootConstrainSelectedInstOperands,
     /* 101579 */     // GIR_Coverage, 4725,
     /* 101579 */     GIR_EraseRootFromParent_Done,
     /* 101580 */   // Label 1553: @101580
     /* 101580 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(101712), // Rule ID 4757 //
     /* 101585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101600 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101604 */     // MIs[1] Operand 1
     /* 101604 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 101609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101611 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101611 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101614 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 101618 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101623 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101627 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101633 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101636 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101640 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101645 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101650 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101653 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101657 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101662 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101679 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101710 */     GIR_RootConstrainSelectedInstOperands,
     /* 101711 */     // GIR_Coverage, 4757,
     /* 101711 */     GIR_EraseRootFromParent_Done,
     /* 101712 */   // Label 1554: @101712
     /* 101712 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(101804), // Rule ID 2979 //
     /* 101717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 101720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101732 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101736 */     // MIs[1] Operand 1
     /* 101736 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 101741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101743 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 101743 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101746 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 101750 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101755 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101759 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101777 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 101784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 101797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 101799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101802 */     GIR_RootConstrainSelectedInstOperands,
     /* 101803 */     // GIR_Coverage, 2979,
     /* 101803 */     GIR_EraseRootFromParent_Done,
     /* 101804 */   // Label 1555: @101804
     /* 101804 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(101896), // Rule ID 2993 //
     /* 101809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 101812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101824 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101828 */     // MIs[1] Operand 1
     /* 101828 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 101833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101835 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 101835 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101838 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 101842 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101847 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101869 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 101876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 101889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 101891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101894 */     GIR_RootConstrainSelectedInstOperands,
     /* 101895 */     // GIR_Coverage, 2993,
     /* 101895 */     GIR_EraseRootFromParent_Done,
     /* 101896 */   // Label 1556: @101896
     /* 101896 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(101988), // Rule ID 3001 //
     /* 101901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 101904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101916 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101920 */     // MIs[1] Operand 1
     /* 101920 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 101925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101927 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 101927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 101934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101943 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101961 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 101981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 101983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101986 */     GIR_RootConstrainSelectedInstOperands,
     /* 101987 */     // GIR_Coverage, 3001,
     /* 101987 */     GIR_EraseRootFromParent_Done,
     /* 101988 */   // Label 1557: @101988
     /* 101988 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(102080), // Rule ID 3009 //
     /* 101993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 101996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102008 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102012 */     // MIs[1] Operand 1
     /* 102012 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 102017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102019 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 102019 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102022 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 102026 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102031 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102035 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102053 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102078 */     GIR_RootConstrainSelectedInstOperands,
     /* 102079 */     // GIR_Coverage, 3009,
     /* 102079 */     GIR_EraseRootFromParent_Done,
     /* 102080 */   // Label 1558: @102080
     /* 102080 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(102172), // Rule ID 3017 //
     /* 102085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102100 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102104 */     // MIs[1] Operand 1
     /* 102104 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 102109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102111 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 102111 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102114 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 102118 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102123 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102127 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102145 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 102152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102170 */     GIR_RootConstrainSelectedInstOperands,
     /* 102171 */     // GIR_Coverage, 3017,
     /* 102171 */     GIR_EraseRootFromParent_Done,
     /* 102172 */   // Label 1559: @102172
     /* 102172 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(102264), // Rule ID 3081 //
     /* 102177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102192 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102196 */     // MIs[1] Operand 1
     /* 102196 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 102201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102203 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 102203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 102210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102215 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102237 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102262 */     GIR_RootConstrainSelectedInstOperands,
     /* 102263 */     // GIR_Coverage, 3081,
     /* 102263 */     GIR_EraseRootFromParent_Done,
     /* 102264 */   // Label 1560: @102264
     /* 102264 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(102356), // Rule ID 3089 //
     /* 102269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102284 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102288 */     // MIs[1] Operand 1
     /* 102288 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 102293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102295 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 102295 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102298 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 102302 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102307 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102311 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102329 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102354 */     GIR_RootConstrainSelectedInstOperands,
     /* 102355 */     // GIR_Coverage, 3089,
     /* 102355 */     GIR_EraseRootFromParent_Done,
     /* 102356 */   // Label 1561: @102356
     /* 102356 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(102448), // Rule ID 3097 //
     /* 102361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102376 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102380 */     // MIs[1] Operand 1
     /* 102380 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 102385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102387 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 102387 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102390 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 102394 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102399 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102403 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102421 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102446 */     GIR_RootConstrainSelectedInstOperands,
     /* 102447 */     // GIR_Coverage, 3097,
     /* 102447 */     GIR_EraseRootFromParent_Done,
     /* 102448 */   // Label 1562: @102448
     /* 102448 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(102540), // Rule ID 3105 //
     /* 102453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102468 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102472 */     // MIs[1] Operand 1
     /* 102472 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 102477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102479 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 102479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 102486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102491 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102495 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102513 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102538 */     GIR_RootConstrainSelectedInstOperands,
     /* 102539 */     // GIR_Coverage, 3105,
     /* 102539 */     GIR_EraseRootFromParent_Done,
     /* 102540 */   // Label 1563: @102540
     /* 102540 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(102632), // Rule ID 3113 //
     /* 102545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102560 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102564 */     // MIs[1] Operand 1
     /* 102564 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 102569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102571 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 102571 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102574 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 102578 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102583 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102605 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 102612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102630 */     GIR_RootConstrainSelectedInstOperands,
     /* 102631 */     // GIR_Coverage, 3113,
     /* 102631 */     GIR_EraseRootFromParent_Done,
     /* 102632 */   // Label 1564: @102632
     /* 102632 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(102764), // Rule ID 3863 //
     /* 102637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 102640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102652 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102656 */     // MIs[1] Operand 1
     /* 102656 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 102661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102663 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 102663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 102670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102685 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 102688 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 102692 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102697 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 102700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102702 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 102705 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 102709 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102714 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 102717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102731 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 102751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 102762 */     GIR_RootConstrainSelectedInstOperands,
     /* 102763 */     // GIR_Coverage, 3863,
     /* 102763 */     GIR_EraseRootFromParent_Done,
     /* 102764 */   // Label 1565: @102764
     /* 102764 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(102896), // Rule ID 3871 //
     /* 102769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 102772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102784 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102788 */     // MIs[1] Operand 1
     /* 102788 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 102793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102795 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 102795 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102798 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 102802 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102807 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102811 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102817 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 102820 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 102824 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102829 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 102832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102834 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 102837 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 102841 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102846 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 102849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102863 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 102883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 102894 */     GIR_RootConstrainSelectedInstOperands,
     /* 102895 */     // GIR_Coverage, 3871,
     /* 102895 */     GIR_EraseRootFromParent_Done,
     /* 102896 */   // Label 1566: @102896
     /* 102896 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(103028), // Rule ID 3879 //
     /* 102901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 102904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102916 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102920 */     // MIs[1] Operand 1
     /* 102920 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 102925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102927 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 102927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 102934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102943 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102949 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 102952 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 102956 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102961 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 102964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102966 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 102969 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 102973 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102978 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 102981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102995 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 103002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103026 */     GIR_RootConstrainSelectedInstOperands,
     /* 103027 */     // GIR_Coverage, 3879,
     /* 103027 */     GIR_EraseRootFromParent_Done,
     /* 103028 */   // Label 1567: @103028
     /* 103028 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(103160), // Rule ID 3887 //
     /* 103033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103048 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103052 */     // MIs[1] Operand 1
     /* 103052 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 103057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103059 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103059 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103062 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 103066 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103071 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103075 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103081 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103084 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103088 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103093 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103098 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103101 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103105 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103110 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103127 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 103134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103158 */     GIR_RootConstrainSelectedInstOperands,
     /* 103159 */     // GIR_Coverage, 3887,
     /* 103159 */     GIR_EraseRootFromParent_Done,
     /* 103160 */   // Label 1568: @103160
     /* 103160 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(103292), // Rule ID 3895 //
     /* 103165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103180 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103184 */     // MIs[1] Operand 1
     /* 103184 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 103189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103191 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103191 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103194 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 103198 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103203 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103213 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103216 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103220 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103225 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103230 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103233 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103237 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103242 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103259 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 103266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103290 */     GIR_RootConstrainSelectedInstOperands,
     /* 103291 */     // GIR_Coverage, 3895,
     /* 103291 */     GIR_EraseRootFromParent_Done,
     /* 103292 */   // Label 1569: @103292
     /* 103292 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(103424), // Rule ID 3959 //
     /* 103297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103312 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103316 */     // MIs[1] Operand 1
     /* 103316 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 103321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103323 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103323 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103326 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 103330 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103335 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103345 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103348 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103352 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103357 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103362 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103365 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103369 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103374 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103391 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 103398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103422 */     GIR_RootConstrainSelectedInstOperands,
     /* 103423 */     // GIR_Coverage, 3959,
     /* 103423 */     GIR_EraseRootFromParent_Done,
     /* 103424 */   // Label 1570: @103424
     /* 103424 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(103556), // Rule ID 3967 //
     /* 103429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103444 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103448 */     // MIs[1] Operand 1
     /* 103448 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 103453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103455 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103455 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103458 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 103462 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103467 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103471 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103477 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103480 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103484 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103489 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103494 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103497 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103501 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103506 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103523 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 103530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103554 */     GIR_RootConstrainSelectedInstOperands,
     /* 103555 */     // GIR_Coverage, 3967,
     /* 103555 */     GIR_EraseRootFromParent_Done,
     /* 103556 */   // Label 1571: @103556
     /* 103556 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(103688), // Rule ID 3975 //
     /* 103561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103576 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103580 */     // MIs[1] Operand 1
     /* 103580 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 103585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103587 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103587 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103590 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 103594 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103599 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103603 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103609 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103612 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103616 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103621 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103626 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103629 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103633 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103638 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103655 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 103662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103686 */     GIR_RootConstrainSelectedInstOperands,
     /* 103687 */     // GIR_Coverage, 3975,
     /* 103687 */     GIR_EraseRootFromParent_Done,
     /* 103688 */   // Label 1572: @103688
     /* 103688 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(103820), // Rule ID 3983 //
     /* 103693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103708 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103712 */     // MIs[1] Operand 1
     /* 103712 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 103717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103719 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103719 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103722 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 103726 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103731 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103735 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103741 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103744 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103748 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103753 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103758 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103761 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103765 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103770 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103787 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 103794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103799 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103818 */     GIR_RootConstrainSelectedInstOperands,
     /* 103819 */     // GIR_Coverage, 3983,
     /* 103819 */     GIR_EraseRootFromParent_Done,
     /* 103820 */   // Label 1573: @103820
     /* 103820 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(103952), // Rule ID 3991 //
     /* 103825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103840 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103844 */     // MIs[1] Operand 1
     /* 103844 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 103849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103851 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103851 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103854 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 103858 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103863 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103867 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103873 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103876 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103880 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103885 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103890 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103893 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103897 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103902 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103919 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 103926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103950 */     GIR_RootConstrainSelectedInstOperands,
     /* 103951 */     // GIR_Coverage, 3991,
     /* 103951 */     GIR_EraseRootFromParent_Done,
     /* 103952 */   // Label 1574: @103952
     /* 103952 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(103967), // Rule ID 2985 //
     /* 103957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 103960 */     // (anyext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 103960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC),
     /* 103965 */     GIR_RootConstrainSelectedInstOperands,
     /* 103966 */     // GIR_Coverage, 2985,
     /* 103966 */     GIR_Done,
     /* 103967 */   // Label 1575: @103967
     /* 103967 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(104021), // Rule ID 3669 //
     /* 103972 */     // (anyext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } 1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 103972 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103975 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103979 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103984 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 103987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104001 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 104004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 104009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104011 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 104013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104019 */     GIR_RootConstrainSelectedInstOperands,
     /* 104020 */     // GIR_Coverage, 3669,
     /* 104020 */     GIR_EraseRootFromParent_Done,
     /* 104021 */   // Label 1576: @104021
     /* 104021 */   GIM_Reject,
     /* 104022 */ // Label 1484: @104022
     /* 104022 */ GIM_Reject,
     /* 104023 */ // Label 1482: @104023
     /* 104023 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(114537),
     /* 104028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 104031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104035 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(104144), // Rule ID 5293 //
     /* 104040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104052 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104056 */     // MIs[1] Operand 1
     /* 104056 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104085 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104089 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104093 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104097 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104103 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 104103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104119 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 104122 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 104125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 104130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104142 */     GIR_RootConstrainSelectedInstOperands,
     /* 104143 */     // GIR_Coverage, 5293,
     /* 104143 */     GIR_EraseRootFromParent_Done,
     /* 104144 */   // Label 1578: @104144
     /* 104144 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(104307), // Rule ID 5294 //
     /* 104149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104161 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104165 */     // MIs[1] Operand 1
     /* 104165 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 104182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 104186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 104198 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104202 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104206 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104212 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104212 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104215 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104219 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104224 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104228 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 104231 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 104234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104236 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104239 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 104243 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104248 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104252 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 104255 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104258 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104301 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104306 */     // GIR_Coverage, 5294,
     /* 104306 */     GIR_EraseRootFromParent_Done,
     /* 104307 */   // Label 1579: @104307
     /* 104307 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(104437), // Rule ID 5301 //
     /* 104312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104324 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104328 */     // MIs[1] Operand 1
     /* 104328 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 104333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104361 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104365 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104369 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104375 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 104375 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104378 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104382 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104387 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104391 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 104394 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 104397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 104406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104415 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 104424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104435 */     GIR_RootConstrainSelectedInstOperands,
     /* 104436 */     // GIR_Coverage, 5301,
     /* 104436 */     GIR_EraseRootFromParent_Done,
     /* 104437 */   // Label 1580: @104437
     /* 104437 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(104621), // Rule ID 5302 //
     /* 104442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104454 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104458 */     // MIs[1] Operand 1
     /* 104458 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 104463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 104475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 104479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104487 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 104491 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104495 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104499 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104505 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104505 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 104508 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104512 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104517 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104521 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 104524 */     GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 104527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104529 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104532 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 104536 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104541 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104545 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104551 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104554 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 104558 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104563 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 104566 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 104569 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104572 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104620 */     // GIR_Coverage, 5302,
     /* 104620 */     GIR_EraseRootFromParent_Done,
     /* 104621 */   // Label 1581: @104621
     /* 104621 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(104730), // Rule ID 3774 //
     /* 104626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104638 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104642 */     // MIs[1] Operand 1
     /* 104642 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 104667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104671 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104675 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104679 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104683 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104689 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 104689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104705 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 104708 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 104711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 104716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 104722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104728 */     GIR_RootConstrainSelectedInstOperands,
     /* 104729 */     // GIR_Coverage, 3774,
     /* 104729 */     GIR_EraseRootFromParent_Done,
     /* 104730 */   // Label 1582: @104730
     /* 104730 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(104893), // Rule ID 3775 //
     /* 104735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104747 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104751 */     // MIs[1] Operand 1
     /* 104751 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 104768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 104772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 104776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104780 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 104784 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104788 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104792 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104796 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104798 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104798 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104801 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104805 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104810 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104814 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 104817 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 104820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104822 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104825 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 104829 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104834 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 104838 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 104841 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104844 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104892 */     // GIR_Coverage, 3775,
     /* 104892 */     GIR_EraseRootFromParent_Done,
     /* 104893 */   // Label 1583: @104893
     /* 104893 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(105023), // Rule ID 3782 //
     /* 104898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104910 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104914 */     // MIs[1] Operand 1
     /* 104914 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 104919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 104939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104943 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104947 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104951 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104955 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104959 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104961 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 104961 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104964 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104968 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104973 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104977 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 104980 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 104983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 104992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 105010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105021 */     GIR_RootConstrainSelectedInstOperands,
     /* 105022 */     // GIR_Coverage, 3782,
     /* 105022 */     GIR_EraseRootFromParent_Done,
     /* 105023 */   // Label 1584: @105023
     /* 105023 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(105207), // Rule ID 3783 //
     /* 105028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105040 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105044 */     // MIs[1] Operand 1
     /* 105044 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 105053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 105057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 105061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 105065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 105069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 105073 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 105077 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 105081 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 105085 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105091 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105091 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 105094 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 105098 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105103 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 105107 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 105110 */     GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 105113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105115 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105118 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 105122 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105127 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105131 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105137 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105140 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 105144 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105149 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105152 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 105155 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105158 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105206 */     // GIR_Coverage, 3783,
     /* 105206 */     GIR_EraseRootFromParent_Done,
     /* 105207 */   // Label 1585: @105207
     /* 105207 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(105273), // Rule ID 3694 //
     /* 105212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105224 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105228 */     // MIs[1] Operand 1
     /* 105228 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105233 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105239 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 105239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 105246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105251 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 105260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 105268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105271 */     GIR_RootConstrainSelectedInstOperands,
     /* 105272 */     // GIR_Coverage, 3694,
     /* 105272 */     GIR_EraseRootFromParent_Done,
     /* 105273 */   // Label 1586: @105273
     /* 105273 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(105393), // Rule ID 3695 //
     /* 105278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105290 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105294 */     // MIs[1] Operand 1
     /* 105294 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105299 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105305 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105305 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105308 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 105312 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105317 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105323 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105326 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 105330 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105335 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105338 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 105341 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105344 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105392 */     // GIR_Coverage, 3695,
     /* 105392 */     GIR_EraseRootFromParent_Done,
     /* 105393 */   // Label 1587: @105393
     /* 105393 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(105497), // Rule ID 3702 //
     /* 105398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105410 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105414 */     // MIs[1] Operand 1
     /* 105414 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 105419 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105425 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 105425 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 105428 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 105432 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105437 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 105446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 105450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105455 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 105468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105473 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105476 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 105479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 105484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 105492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105495 */     GIR_RootConstrainSelectedInstOperands,
     /* 105496 */     // GIR_Coverage, 3702,
     /* 105496 */     GIR_EraseRootFromParent_Done,
     /* 105497 */   // Label 1588: @105497
     /* 105497 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(105655), // Rule ID 3703 //
     /* 105502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105514 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105518 */     // MIs[1] Operand 1
     /* 105518 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 105523 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105529 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105529 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 105532 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 105536 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105541 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 105547 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 105550 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 105554 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105559 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105565 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105568 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 105572 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105577 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 105580 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 105583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105585 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105588 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 105592 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105597 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105600 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 105603 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105606 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105654 */     // GIR_Coverage, 3703,
     /* 105654 */     GIR_EraseRootFromParent_Done,
     /* 105655 */   // Label 1589: @105655
     /* 105655 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(105704), // Rule ID 3710 //
     /* 105660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105672 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105676 */     // MIs[1] Operand 1
     /* 105676 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 105681 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105687 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 105687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 105690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105702 */     GIR_RootConstrainSelectedInstOperands,
     /* 105703 */     // GIR_Coverage, 3710,
     /* 105703 */     GIR_EraseRootFromParent_Done,
     /* 105704 */   // Label 1590: @105704
     /* 105704 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(105807), // Rule ID 3711 //
     /* 105709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105721 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105725 */     // MIs[1] Operand 1
     /* 105725 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 105730 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105736 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105736 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105739 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 105743 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105748 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105752 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 105755 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105758 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105806 */     // GIR_Coverage, 3711,
     /* 105806 */     GIR_EraseRootFromParent_Done,
     /* 105807 */   // Label 1591: @105807
     /* 105807 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(105877), // Rule ID 3718 //
     /* 105812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105824 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105828 */     // MIs[1] Operand 1
     /* 105828 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 105833 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105839 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 105839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 105846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105851 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105855 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 105864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105875 */     GIR_RootConstrainSelectedInstOperands,
     /* 105876 */     // GIR_Coverage, 3718,
     /* 105876 */     GIR_EraseRootFromParent_Done,
     /* 105877 */   // Label 1592: @105877
     /* 105877 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(106001), // Rule ID 3719 //
     /* 105882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105894 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105898 */     // MIs[1] Operand 1
     /* 105898 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 105903 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105909 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105909 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105912 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 105916 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105921 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105925 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105931 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105934 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 105938 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105943 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105946 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 105949 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105952 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106000 */     // GIR_Coverage, 3719,
     /* 106000 */     GIR_EraseRootFromParent_Done,
     /* 106001 */   // Label 1593: @106001
     /* 106001 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(106088), // Rule ID 3726 //
     /* 106006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106018 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106022 */     // MIs[1] Operand 1
     /* 106022 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 106027 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106033 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106033 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106036 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 106040 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106045 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 106058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106086 */     GIR_RootConstrainSelectedInstOperands,
     /* 106087 */     // GIR_Coverage, 3726,
     /* 106087 */     GIR_EraseRootFromParent_Done,
     /* 106088 */   // Label 1594: @106088
     /* 106088 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(106229), // Rule ID 3727 //
     /* 106093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106105 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106109 */     // MIs[1] Operand 1
     /* 106109 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 106114 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106120 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106120 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106123 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 106127 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106132 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106138 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106141 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 106145 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106150 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106153 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106159 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106162 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106166 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106171 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106174 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106177 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106180 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106218 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106228 */     // GIR_Coverage, 3727,
     /* 106228 */     GIR_EraseRootFromParent_Done,
     /* 106229 */   // Label 1595: @106229
     /* 106229 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(106316), // Rule ID 3734 //
     /* 106234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106246 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106250 */     // MIs[1] Operand 1
     /* 106250 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 106255 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106261 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 106268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106273 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 106286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106291 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106295 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106314 */     GIR_RootConstrainSelectedInstOperands,
     /* 106315 */     // GIR_Coverage, 3734,
     /* 106315 */     GIR_EraseRootFromParent_Done,
     /* 106316 */   // Label 1596: @106316
     /* 106316 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(106457), // Rule ID 3735 //
     /* 106321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106333 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106337 */     // MIs[1] Operand 1
     /* 106337 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 106342 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106348 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106348 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106351 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 106355 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106360 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106366 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106369 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 106373 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106378 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106382 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106387 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106390 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106394 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106399 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106402 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106405 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106408 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106456 */     // GIR_Coverage, 3735,
     /* 106456 */     GIR_EraseRootFromParent_Done,
     /* 106457 */   // Label 1597: @106457
     /* 106457 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(106547), // Rule ID 3742 //
     /* 106462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106474 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106478 */     // MIs[1] Operand 1
     /* 106478 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 106483 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106489 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106489 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106492 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 106496 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106501 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106505 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 106517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106526 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106545 */     GIR_RootConstrainSelectedInstOperands,
     /* 106546 */     // GIR_Coverage, 3742,
     /* 106546 */     GIR_EraseRootFromParent_Done,
     /* 106547 */   // Label 1598: @106547
     /* 106547 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(106691), // Rule ID 3743 //
     /* 106552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106564 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106568 */     // MIs[1] Operand 1
     /* 106568 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 106573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106579 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106579 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106582 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 106586 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106591 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106595 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 106598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106600 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106603 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 106607 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106612 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106616 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106633 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106636 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106639 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106642 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106675 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106680 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106690 */     // GIR_Coverage, 3743,
     /* 106690 */     GIR_EraseRootFromParent_Done,
     /* 106691 */   // Label 1599: @106691
     /* 106691 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(106781), // Rule ID 3750 //
     /* 106696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106708 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106712 */     // MIs[1] Operand 1
     /* 106712 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 106717 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106723 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 106730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106735 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106739 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 106751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106760 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106779 */     GIR_RootConstrainSelectedInstOperands,
     /* 106780 */     // GIR_Coverage, 3750,
     /* 106780 */     GIR_EraseRootFromParent_Done,
     /* 106781 */   // Label 1600: @106781
     /* 106781 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(106925), // Rule ID 3751 //
     /* 106786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106798 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106802 */     // MIs[1] Operand 1
     /* 106802 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 106807 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106813 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106813 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106816 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 106820 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106825 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106829 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 106832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106834 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106837 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 106841 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106846 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106850 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106855 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106858 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106862 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106867 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106870 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106873 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106876 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106924 */     // GIR_Coverage, 3751,
     /* 106924 */     GIR_EraseRootFromParent_Done,
     /* 106925 */   // Label 1601: @106925
     /* 106925 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(106995), // Rule ID 3758 //
     /* 106930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106942 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106946 */     // MIs[1] Operand 1
     /* 106946 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 106951 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106957 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 106964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106969 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106993 */     GIR_RootConstrainSelectedInstOperands,
     /* 106994 */     // GIR_Coverage, 3758,
     /* 106994 */     GIR_EraseRootFromParent_Done,
     /* 106995 */   // Label 1602: @106995
     /* 106995 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(107119), // Rule ID 3759 //
     /* 107000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107012 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107016 */     // MIs[1] Operand 1
     /* 107016 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 107021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107027 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 107027 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 107030 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 107034 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107039 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107043 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 107049 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107052 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 107056 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107061 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107064 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 107067 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107070 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 107118 */     // GIR_Coverage, 3759,
     /* 107118 */     GIR_EraseRootFromParent_Done,
     /* 107119 */   // Label 1603: @107119
     /* 107119 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(107168), // Rule ID 3766 //
     /* 107124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107136 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107140 */     // MIs[1] Operand 1
     /* 107140 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107145 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107151 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 107151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 107154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 107156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 107166 */     GIR_RootConstrainSelectedInstOperands,
     /* 107167 */     // GIR_Coverage, 3766,
     /* 107167 */     GIR_EraseRootFromParent_Done,
     /* 107168 */   // Label 1604: @107168
     /* 107168 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(107271), // Rule ID 3767 //
     /* 107173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107185 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107189 */     // MIs[1] Operand 1
     /* 107189 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107194 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107200 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 107200 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107203 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 107207 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107212 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107216 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 107219 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107222 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 107270 */     // GIR_Coverage, 3767,
     /* 107270 */     GIR_EraseRootFromParent_Done,
     /* 107271 */   // Label 1605: @107271
     /* 107271 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(107374), // Rule ID 3034 //
     /* 107276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107291 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107295 */     // MIs[1] Operand 1
     /* 107295 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107308 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107312 */     // MIs[2] Operand 1
     /* 107312 */     // No operand predicates
     /* 107312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107314 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 107314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107326 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107347 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 107354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107372 */     GIR_RootConstrainSelectedInstOperands,
     /* 107373 */     // GIR_Coverage, 3034,
     /* 107373 */     GIR_EraseRootFromParent_Done,
     /* 107374 */   // Label 1606: @107374
     /* 107374 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(107477), // Rule ID 3050 //
     /* 107379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107394 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107398 */     // MIs[1] Operand 1
     /* 107398 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107411 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107415 */     // MIs[2] Operand 1
     /* 107415 */     // No operand predicates
     /* 107415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107417 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 107417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107450 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 107457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107475 */     GIR_RootConstrainSelectedInstOperands,
     /* 107476 */     // GIR_Coverage, 3050,
     /* 107476 */     GIR_EraseRootFromParent_Done,
     /* 107477 */   // Label 1607: @107477
     /* 107477 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(107580), // Rule ID 3058 //
     /* 107482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107497 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107501 */     // MIs[1] Operand 1
     /* 107501 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 107506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107514 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107518 */     // MIs[2] Operand 1
     /* 107518 */     // No operand predicates
     /* 107518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107520 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 107520 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107523 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107527 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107532 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107553 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 107560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107578 */     GIR_RootConstrainSelectedInstOperands,
     /* 107579 */     // GIR_Coverage, 3058,
     /* 107579 */     GIR_EraseRootFromParent_Done,
     /* 107580 */   // Label 1608: @107580
     /* 107580 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(107683), // Rule ID 3130 //
     /* 107585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107600 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107604 */     // MIs[1] Operand 1
     /* 107604 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107617 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 107621 */     // MIs[2] Operand 1
     /* 107621 */     // No operand predicates
     /* 107621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107623 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 107623 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107626 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 107630 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107656 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 107663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107681 */     GIR_RootConstrainSelectedInstOperands,
     /* 107682 */     // GIR_Coverage, 3130,
     /* 107682 */     GIR_EraseRootFromParent_Done,
     /* 107683 */   // Label 1609: @107683
     /* 107683 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(107786), // Rule ID 3146 //
     /* 107688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107703 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107707 */     // MIs[1] Operand 1
     /* 107707 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107720 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 107724 */     // MIs[2] Operand 1
     /* 107724 */     // No operand predicates
     /* 107724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107726 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 107726 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107729 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 107733 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107738 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107759 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 107766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107784 */     GIR_RootConstrainSelectedInstOperands,
     /* 107785 */     // GIR_Coverage, 3146,
     /* 107785 */     GIR_EraseRootFromParent_Done,
     /* 107786 */   // Label 1610: @107786
     /* 107786 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(107889), // Rule ID 3154 //
     /* 107791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107806 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107810 */     // MIs[1] Operand 1
     /* 107810 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 107815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107823 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 107827 */     // MIs[2] Operand 1
     /* 107827 */     // No operand predicates
     /* 107827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107829 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 107829 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107832 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 107836 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107841 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107862 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 107869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107887 */     GIR_RootConstrainSelectedInstOperands,
     /* 107888 */     // GIR_Coverage, 3154,
     /* 107888 */     GIR_EraseRootFromParent_Done,
     /* 107889 */   // Label 1611: @107889
     /* 107889 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(108032), // Rule ID 3816 //
     /* 107894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 107897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107909 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107913 */     // MIs[1] Operand 1
     /* 107913 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107926 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107930 */     // MIs[2] Operand 1
     /* 107930 */     // No operand predicates
     /* 107930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107932 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 107932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107944 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107953 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 107956 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 107960 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107965 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 107968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 107970 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 107973 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 107977 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107982 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 107985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 107987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107999 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 108006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108030 */     GIR_RootConstrainSelectedInstOperands,
     /* 108031 */     // GIR_Coverage, 3816,
     /* 108031 */     GIR_EraseRootFromParent_Done,
     /* 108032 */   // Label 1612: @108032
     /* 108032 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(108175), // Rule ID 3832 //
     /* 108037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108052 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108056 */     // MIs[1] Operand 1
     /* 108056 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 108061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108069 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 108073 */     // MIs[2] Operand 1
     /* 108073 */     // No operand predicates
     /* 108073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108075 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108075 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108078 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 108082 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108096 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108099 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108103 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108108 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108113 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108116 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108120 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108125 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108142 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108173 */     GIR_RootConstrainSelectedInstOperands,
     /* 108174 */     // GIR_Coverage, 3832,
     /* 108174 */     GIR_EraseRootFromParent_Done,
     /* 108175 */   // Label 1613: @108175
     /* 108175 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(108318), // Rule ID 3840 //
     /* 108180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108195 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108199 */     // MIs[1] Operand 1
     /* 108199 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 108204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108212 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 108216 */     // MIs[2] Operand 1
     /* 108216 */     // No operand predicates
     /* 108216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108218 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108218 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108221 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 108225 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108230 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108239 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108242 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108246 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108251 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108256 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108259 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108263 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108268 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108285 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 108292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108316 */     GIR_RootConstrainSelectedInstOperands,
     /* 108317 */     // GIR_Coverage, 3840,
     /* 108317 */     GIR_EraseRootFromParent_Done,
     /* 108318 */   // Label 1614: @108318
     /* 108318 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(108461), // Rule ID 3912 //
     /* 108323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108338 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108342 */     // MIs[1] Operand 1
     /* 108342 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 108347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108355 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108359 */     // MIs[2] Operand 1
     /* 108359 */     // No operand predicates
     /* 108359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108361 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108361 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108364 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108368 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108373 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108382 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108385 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108389 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108394 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108399 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108402 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108406 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108411 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108428 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 108435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108459 */     GIR_RootConstrainSelectedInstOperands,
     /* 108460 */     // GIR_Coverage, 3912,
     /* 108460 */     GIR_EraseRootFromParent_Done,
     /* 108461 */   // Label 1615: @108461
     /* 108461 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(108604), // Rule ID 3928 //
     /* 108466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108481 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108485 */     // MIs[1] Operand 1
     /* 108485 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 108490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108498 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108502 */     // MIs[2] Operand 1
     /* 108502 */     // No operand predicates
     /* 108502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108504 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108504 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108507 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108511 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108516 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108525 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108528 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108532 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108537 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108542 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108545 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108549 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108554 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108571 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108602 */     GIR_RootConstrainSelectedInstOperands,
     /* 108603 */     // GIR_Coverage, 3928,
     /* 108603 */     GIR_EraseRootFromParent_Done,
     /* 108604 */   // Label 1616: @108604
     /* 108604 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(108747), // Rule ID 3936 //
     /* 108609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108624 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108628 */     // MIs[1] Operand 1
     /* 108628 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 108633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108645 */     // MIs[2] Operand 1
     /* 108645 */     // No operand predicates
     /* 108645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108647 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108647 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108650 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108654 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108659 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108668 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108671 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108675 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108680 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108685 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108688 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108692 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108697 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108714 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 108721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108745 */     GIR_RootConstrainSelectedInstOperands,
     /* 108746 */     // GIR_Coverage, 3936,
     /* 108746 */     GIR_EraseRootFromParent_Done,
     /* 108747 */   // Label 1617: @108747
     /* 108747 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(108839), // Rule ID 3178 //
     /* 108752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 108755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 108763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108767 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108771 */     // MIs[1] Operand 1
     /* 108771 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 108776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108778 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 108778 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108781 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 108785 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108790 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108794 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 108798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108812 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 108819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 108832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 108834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108837 */     GIR_RootConstrainSelectedInstOperands,
     /* 108838 */     // GIR_Coverage, 3178,
     /* 108838 */     GIR_EraseRootFromParent_Done,
     /* 108839 */   // Label 1618: @108839
     /* 108839 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(108931), // Rule ID 3194 //
     /* 108844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 108847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 108855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108859 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108863 */     // MIs[1] Operand 1
     /* 108863 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 108868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108870 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 108870 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108873 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 108877 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108882 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108886 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 108890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108904 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 108924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 108926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108929 */     GIR_RootConstrainSelectedInstOperands,
     /* 108930 */     // GIR_Coverage, 3194,
     /* 108930 */     GIR_EraseRootFromParent_Done,
     /* 108931 */   // Label 1619: @108931
     /* 108931 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(109023), // Rule ID 3210 //
     /* 108936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 108939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 108947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108951 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108955 */     // MIs[1] Operand 1
     /* 108955 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 108960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108962 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 108962 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108965 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 108969 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108974 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108978 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 108982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108996 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 109003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109021 */     GIR_RootConstrainSelectedInstOperands,
     /* 109022 */     // GIR_Coverage, 3210,
     /* 109022 */     GIR_EraseRootFromParent_Done,
     /* 109023 */   // Label 1620: @109023
     /* 109023 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(109115), // Rule ID 3226 //
     /* 109028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109043 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109047 */     // MIs[1] Operand 1
     /* 109047 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 109052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109054 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 109054 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109057 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 109061 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109066 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109070 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109088 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 109095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109113 */     GIR_RootConstrainSelectedInstOperands,
     /* 109114 */     // GIR_Coverage, 3226,
     /* 109114 */     GIR_EraseRootFromParent_Done,
     /* 109115 */   // Label 1621: @109115
     /* 109115 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(109207), // Rule ID 3234 //
     /* 109120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109135 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109139 */     // MIs[1] Operand 1
     /* 109139 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109146 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 109146 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109149 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109153 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109158 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109162 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109180 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109205 */     GIR_RootConstrainSelectedInstOperands,
     /* 109206 */     // GIR_Coverage, 3234,
     /* 109206 */     GIR_EraseRootFromParent_Done,
     /* 109207 */   // Label 1622: @109207
     /* 109207 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(109299), // Rule ID 3250 //
     /* 109212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109227 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109231 */     // MIs[1] Operand 1
     /* 109231 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 109236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109238 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 109238 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109241 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109245 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109250 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109254 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109272 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109297 */     GIR_RootConstrainSelectedInstOperands,
     /* 109298 */     // GIR_Coverage, 3250,
     /* 109298 */     GIR_EraseRootFromParent_Done,
     /* 109299 */   // Label 1623: @109299
     /* 109299 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(109391), // Rule ID 3266 //
     /* 109304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109319 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109323 */     // MIs[1] Operand 1
     /* 109323 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 109328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109330 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 109330 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109333 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109337 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109342 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109346 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109364 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 109371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109389 */     GIR_RootConstrainSelectedInstOperands,
     /* 109390 */     // GIR_Coverage, 3266,
     /* 109390 */     GIR_EraseRootFromParent_Done,
     /* 109391 */   // Label 1624: @109391
     /* 109391 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(109483), // Rule ID 3282 //
     /* 109396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109411 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109415 */     // MIs[1] Operand 1
     /* 109415 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 109420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109422 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 109422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109434 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109438 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109456 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 109463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109481 */     GIR_RootConstrainSelectedInstOperands,
     /* 109482 */     // GIR_Coverage, 3282,
     /* 109482 */     GIR_EraseRootFromParent_Done,
     /* 109483 */   // Label 1625: @109483
     /* 109483 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(109575), // Rule ID 3290 //
     /* 109488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 109503 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 109507 */     // MIs[1] Operand 1
     /* 109507 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109514 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 109514 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109517 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 109521 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109526 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109530 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109548 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109573 */     GIR_RootConstrainSelectedInstOperands,
     /* 109574 */     // GIR_Coverage, 3290,
     /* 109574 */     GIR_EraseRootFromParent_Done,
     /* 109575 */   // Label 1626: @109575
     /* 109575 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(109667), // Rule ID 3306 //
     /* 109580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 109595 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 109599 */     // MIs[1] Operand 1
     /* 109599 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 109604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109606 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 109606 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109609 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 109613 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109618 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109622 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109640 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109665 */     GIR_RootConstrainSelectedInstOperands,
     /* 109666 */     // GIR_Coverage, 3306,
     /* 109666 */     GIR_EraseRootFromParent_Done,
     /* 109667 */   // Label 1627: @109667
     /* 109667 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(109759), // Rule ID 3322 //
     /* 109672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 109687 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 109691 */     // MIs[1] Operand 1
     /* 109691 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 109696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109698 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 109698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 109705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109710 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109714 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109732 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 109739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109757 */     GIR_RootConstrainSelectedInstOperands,
     /* 109758 */     // GIR_Coverage, 3322,
     /* 109758 */     GIR_EraseRootFromParent_Done,
     /* 109759 */   // Label 1628: @109759
     /* 109759 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(109851), // Rule ID 3338 //
     /* 109764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 109779 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 109783 */     // MIs[1] Operand 1
     /* 109783 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 109788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109790 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 109790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 109797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109802 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109806 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109824 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 109831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109849 */     GIR_RootConstrainSelectedInstOperands,
     /* 109850 */     // GIR_Coverage, 3338,
     /* 109850 */     GIR_EraseRootFromParent_Done,
     /* 109851 */   // Label 1629: @109851
     /* 109851 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(109983), // Rule ID 4022 //
     /* 109856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 109859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109871 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109875 */     // MIs[1] Operand 1
     /* 109875 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109882 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 109882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 109889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109894 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109898 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109904 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 109907 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109911 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109916 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 109919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 109921 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 109924 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109928 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109933 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 109936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 109938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109950 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 109970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 109978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 109981 */     GIR_RootConstrainSelectedInstOperands,
     /* 109982 */     // GIR_Coverage, 4022,
     /* 109982 */     GIR_EraseRootFromParent_Done,
     /* 109983 */   // Label 1630: @109983
     /* 109983 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(110115), // Rule ID 4054 //
     /* 109988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 109991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110003 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110007 */     // MIs[1] Operand 1
     /* 110007 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 110012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110014 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110026 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110030 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110036 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110039 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110043 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110048 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110053 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110056 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110060 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110065 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110082 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 110089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110113 */     GIR_RootConstrainSelectedInstOperands,
     /* 110114 */     // GIR_Coverage, 4054,
     /* 110114 */     GIR_EraseRootFromParent_Done,
     /* 110115 */   // Label 1631: @110115
     /* 110115 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(110247), // Rule ID 4086 //
     /* 110120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110135 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110139 */     // MIs[1] Operand 1
     /* 110139 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 110144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110146 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110146 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110149 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110153 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110158 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110162 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110168 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110171 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110175 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110180 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110185 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110188 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110192 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110197 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110214 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 110221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110245 */     GIR_RootConstrainSelectedInstOperands,
     /* 110246 */     // GIR_Coverage, 4086,
     /* 110246 */     GIR_EraseRootFromParent_Done,
     /* 110247 */   // Label 1632: @110247
     /* 110247 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(110379), // Rule ID 4118 //
     /* 110252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110271 */     // MIs[1] Operand 1
     /* 110271 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 110276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110278 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110290 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110294 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110300 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110303 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110307 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110312 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110317 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110320 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110324 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110329 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110346 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 110353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110377 */     GIR_RootConstrainSelectedInstOperands,
     /* 110378 */     // GIR_Coverage, 4118,
     /* 110378 */     GIR_EraseRootFromParent_Done,
     /* 110379 */   // Label 1633: @110379
     /* 110379 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(110511), // Rule ID 4134 //
     /* 110384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110399 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110403 */     // MIs[1] Operand 1
     /* 110403 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 110408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110410 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110410 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110413 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 110417 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110422 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110426 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110432 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110435 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110439 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110444 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110449 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110452 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110456 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110461 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110478 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 110485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110509 */     GIR_RootConstrainSelectedInstOperands,
     /* 110510 */     // GIR_Coverage, 4134,
     /* 110510 */     GIR_EraseRootFromParent_Done,
     /* 110511 */   // Label 1634: @110511
     /* 110511 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(110643), // Rule ID 4166 //
     /* 110516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110531 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110535 */     // MIs[1] Operand 1
     /* 110535 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 110540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110542 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110542 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110545 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 110549 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110554 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110558 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110564 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110567 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110571 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110576 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110581 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110584 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110588 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110593 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110610 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 110617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110641 */     GIR_RootConstrainSelectedInstOperands,
     /* 110642 */     // GIR_Coverage, 4166,
     /* 110642 */     GIR_EraseRootFromParent_Done,
     /* 110643 */   // Label 1635: @110643
     /* 110643 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(110775), // Rule ID 4198 //
     /* 110648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110663 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110667 */     // MIs[1] Operand 1
     /* 110667 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 110672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110674 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110674 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110677 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 110681 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110686 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110690 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110696 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110699 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110703 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110708 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110713 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110716 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110720 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110725 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110742 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 110749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110773 */     GIR_RootConstrainSelectedInstOperands,
     /* 110774 */     // GIR_Coverage, 4198,
     /* 110774 */     GIR_EraseRootFromParent_Done,
     /* 110775 */   // Label 1636: @110775
     /* 110775 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(110907), // Rule ID 4230 //
     /* 110780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110795 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110799 */     // MIs[1] Operand 1
     /* 110799 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 110804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110806 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110806 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110809 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 110813 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110818 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110822 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110828 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110831 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110835 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110840 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110845 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110848 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110852 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110857 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110874 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 110881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110905 */     GIR_RootConstrainSelectedInstOperands,
     /* 110906 */     // GIR_Coverage, 4230,
     /* 110906 */     GIR_EraseRootFromParent_Done,
     /* 110907 */   // Label 1637: @110907
     /* 110907 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(111039), // Rule ID 4260 //
     /* 110912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 110927 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 110931 */     // MIs[1] Operand 1
     /* 110931 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 110936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110938 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110938 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110941 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 110945 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110950 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110954 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110960 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110963 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110967 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110972 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110977 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110980 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110984 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110989 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111006 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 111013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111037 */     GIR_RootConstrainSelectedInstOperands,
     /* 111038 */     // GIR_Coverage, 4260,
     /* 111038 */     GIR_EraseRootFromParent_Done,
     /* 111039 */   // Label 1638: @111039
     /* 111039 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(111171), // Rule ID 4292 //
     /* 111044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111059 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111063 */     // MIs[1] Operand 1
     /* 111063 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 111068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111070 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111070 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111073 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111077 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111082 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111086 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111092 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111095 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111099 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111104 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111109 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111112 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111116 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111121 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111138 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111169 */     GIR_RootConstrainSelectedInstOperands,
     /* 111170 */     // GIR_Coverage, 4292,
     /* 111170 */     GIR_EraseRootFromParent_Done,
     /* 111171 */   // Label 1639: @111171
     /* 111171 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(111303), // Rule ID 4324 //
     /* 111176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111191 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111195 */     // MIs[1] Operand 1
     /* 111195 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 111200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111202 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111202 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111205 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111209 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111214 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111218 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111224 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111227 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111231 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111236 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111241 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111244 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111248 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111253 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111270 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 111277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111301 */     GIR_RootConstrainSelectedInstOperands,
     /* 111302 */     // GIR_Coverage, 4324,
     /* 111302 */     GIR_EraseRootFromParent_Done,
     /* 111303 */   // Label 1640: @111303
     /* 111303 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(111435), // Rule ID 4356 //
     /* 111308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111323 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111327 */     // MIs[1] Operand 1
     /* 111327 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 111332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111334 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111334 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111337 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111341 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111346 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111350 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111356 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111359 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111363 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111368 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111373 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111376 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111380 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111385 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111402 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 111409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111433 */     GIR_RootConstrainSelectedInstOperands,
     /* 111434 */     // GIR_Coverage, 4356,
     /* 111434 */     GIR_EraseRootFromParent_Done,
     /* 111435 */   // Label 1641: @111435
     /* 111435 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(111567), // Rule ID 4587 //
     /* 111440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 111455 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 111459 */     // MIs[1] Operand 1
     /* 111459 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 111464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111466 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 111473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111478 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111482 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111488 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111491 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111495 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111500 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111505 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111508 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111512 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111517 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111534 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111565 */     GIR_RootConstrainSelectedInstOperands,
     /* 111566 */     // GIR_Coverage, 4587,
     /* 111566 */     GIR_EraseRootFromParent_Done,
     /* 111567 */   // Label 1642: @111567
     /* 111567 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(111699), // Rule ID 4619 //
     /* 111572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 111587 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 111591 */     // MIs[1] Operand 1
     /* 111591 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 111596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111598 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111598 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111601 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 111605 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111610 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111614 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111620 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111623 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111627 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111632 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111637 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111640 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111644 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111649 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111666 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111697 */     GIR_RootConstrainSelectedInstOperands,
     /* 111698 */     // GIR_Coverage, 4619,
     /* 111698 */     GIR_EraseRootFromParent_Done,
     /* 111699 */   // Label 1643: @111699
     /* 111699 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(111831), // Rule ID 4651 //
     /* 111704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 111719 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 111723 */     // MIs[1] Operand 1
     /* 111723 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 111728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111730 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111730 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111733 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 111737 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111742 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111746 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111752 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111755 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111759 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111764 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111769 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111772 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111776 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111781 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111798 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111829 */     GIR_RootConstrainSelectedInstOperands,
     /* 111830 */     // GIR_Coverage, 4651,
     /* 111830 */     GIR_EraseRootFromParent_Done,
     /* 111831 */   // Label 1644: @111831
     /* 111831 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(111963), // Rule ID 4695 //
     /* 111836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111851 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 111855 */     // MIs[1] Operand 1
     /* 111855 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 111860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111862 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111862 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111865 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 111869 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111874 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111878 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111884 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111887 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111891 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111896 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111901 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111904 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111908 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111913 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111930 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111961 */     GIR_RootConstrainSelectedInstOperands,
     /* 111962 */     // GIR_Coverage, 4695,
     /* 111962 */     GIR_EraseRootFromParent_Done,
     /* 111963 */   // Label 1645: @111963
     /* 111963 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(112095), // Rule ID 4727 //
     /* 111968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111983 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 111987 */     // MIs[1] Operand 1
     /* 111987 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 111992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111994 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111994 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111997 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 112001 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112006 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112010 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112016 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 112019 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112023 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112028 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 112031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 112033 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 112036 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112040 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112045 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 112048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 112050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112062 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112093 */     GIR_RootConstrainSelectedInstOperands,
     /* 112094 */     // GIR_Coverage, 4727,
     /* 112094 */     GIR_EraseRootFromParent_Done,
     /* 112095 */   // Label 1646: @112095
     /* 112095 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(112227), // Rule ID 4759 //
     /* 112100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 112103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 112111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112115 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112119 */     // MIs[1] Operand 1
     /* 112119 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 112124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112126 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 112126 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112129 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 112133 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112138 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112142 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112148 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 112151 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112155 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112160 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 112163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 112165 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 112168 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112172 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112177 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 112180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 112182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112194 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112225 */     GIR_RootConstrainSelectedInstOperands,
     /* 112226 */     // GIR_Coverage, 4759,
     /* 112226 */     GIR_EraseRootFromParent_Done,
     /* 112227 */   // Label 1647: @112227
     /* 112227 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(112319), // Rule ID 2980 //
     /* 112232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112247 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112251 */     // MIs[1] Operand 1
     /* 112251 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 112256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112258 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 112258 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112261 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 112265 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112270 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112274 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112292 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112317 */     GIR_RootConstrainSelectedInstOperands,
     /* 112318 */     // GIR_Coverage, 2980,
     /* 112318 */     GIR_EraseRootFromParent_Done,
     /* 112319 */   // Label 1648: @112319
     /* 112319 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(112411), // Rule ID 2994 //
     /* 112324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112339 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112343 */     // MIs[1] Operand 1
     /* 112343 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 112348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112350 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 112350 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112353 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 112357 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112362 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112366 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112384 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112409 */     GIR_RootConstrainSelectedInstOperands,
     /* 112410 */     // GIR_Coverage, 2994,
     /* 112410 */     GIR_EraseRootFromParent_Done,
     /* 112411 */   // Label 1649: @112411
     /* 112411 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(112503), // Rule ID 3002 //
     /* 112416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112431 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112435 */     // MIs[1] Operand 1
     /* 112435 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 112440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112442 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 112442 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112445 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 112449 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112454 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112458 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112476 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112501 */     GIR_RootConstrainSelectedInstOperands,
     /* 112502 */     // GIR_Coverage, 3002,
     /* 112502 */     GIR_EraseRootFromParent_Done,
     /* 112503 */   // Label 1650: @112503
     /* 112503 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(112595), // Rule ID 3010 //
     /* 112508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112523 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112527 */     // MIs[1] Operand 1
     /* 112527 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 112532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112534 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 112534 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112537 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 112541 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112546 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112550 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112568 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112593 */     GIR_RootConstrainSelectedInstOperands,
     /* 112594 */     // GIR_Coverage, 3010,
     /* 112594 */     GIR_EraseRootFromParent_Done,
     /* 112595 */   // Label 1651: @112595
     /* 112595 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(112687), // Rule ID 3018 //
     /* 112600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112615 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112619 */     // MIs[1] Operand 1
     /* 112619 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 112624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112626 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 112626 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112629 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 112633 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112638 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112642 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112660 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 112667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112685 */     GIR_RootConstrainSelectedInstOperands,
     /* 112686 */     // GIR_Coverage, 3018,
     /* 112686 */     GIR_EraseRootFromParent_Done,
     /* 112687 */   // Label 1652: @112687
     /* 112687 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(112779), // Rule ID 3082 //
     /* 112692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112707 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112711 */     // MIs[1] Operand 1
     /* 112711 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 112716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112718 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 112718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 112725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112730 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112734 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112752 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112777 */     GIR_RootConstrainSelectedInstOperands,
     /* 112778 */     // GIR_Coverage, 3082,
     /* 112778 */     GIR_EraseRootFromParent_Done,
     /* 112779 */   // Label 1653: @112779
     /* 112779 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(112871), // Rule ID 3090 //
     /* 112784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112799 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112803 */     // MIs[1] Operand 1
     /* 112803 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 112808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112810 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 112810 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112813 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 112817 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112822 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112826 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112844 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112869 */     GIR_RootConstrainSelectedInstOperands,
     /* 112870 */     // GIR_Coverage, 3090,
     /* 112870 */     GIR_EraseRootFromParent_Done,
     /* 112871 */   // Label 1654: @112871
     /* 112871 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(112963), // Rule ID 3098 //
     /* 112876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112891 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112895 */     // MIs[1] Operand 1
     /* 112895 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 112900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112902 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 112902 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112905 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 112909 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112914 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112918 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112936 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112961 */     GIR_RootConstrainSelectedInstOperands,
     /* 112962 */     // GIR_Coverage, 3098,
     /* 112962 */     GIR_EraseRootFromParent_Done,
     /* 112963 */   // Label 1655: @112963
     /* 112963 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(113055), // Rule ID 3106 //
     /* 112968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112983 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112987 */     // MIs[1] Operand 1
     /* 112987 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 112992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112994 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 112994 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112997 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 113001 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113006 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113010 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113028 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113053 */     GIR_RootConstrainSelectedInstOperands,
     /* 113054 */     // GIR_Coverage, 3106,
     /* 113054 */     GIR_EraseRootFromParent_Done,
     /* 113055 */   // Label 1656: @113055
     /* 113055 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(113147), // Rule ID 3114 //
     /* 113060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 113063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113075 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113079 */     // MIs[1] Operand 1
     /* 113079 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 113084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113086 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 113086 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113089 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 113093 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113098 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113102 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113120 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 113127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113145 */     GIR_RootConstrainSelectedInstOperands,
     /* 113146 */     // GIR_Coverage, 3114,
     /* 113146 */     GIR_EraseRootFromParent_Done,
     /* 113147 */   // Label 1657: @113147
     /* 113147 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(113279), // Rule ID 3864 //
     /* 113152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113167 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113171 */     // MIs[1] Operand 1
     /* 113171 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 113176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113178 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113178 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113181 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 113185 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113190 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113194 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113200 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113203 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113207 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113212 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113217 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113220 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113224 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113229 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113246 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113277 */     GIR_RootConstrainSelectedInstOperands,
     /* 113278 */     // GIR_Coverage, 3864,
     /* 113278 */     GIR_EraseRootFromParent_Done,
     /* 113279 */   // Label 1658: @113279
     /* 113279 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(113411), // Rule ID 3872 //
     /* 113284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113299 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113303 */     // MIs[1] Operand 1
     /* 113303 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 113308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113310 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113310 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113313 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 113317 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113322 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113326 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113332 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113335 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113339 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113344 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113349 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113352 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113356 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113361 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113378 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113409 */     GIR_RootConstrainSelectedInstOperands,
     /* 113410 */     // GIR_Coverage, 3872,
     /* 113410 */     GIR_EraseRootFromParent_Done,
     /* 113411 */   // Label 1659: @113411
     /* 113411 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(113543), // Rule ID 3880 //
     /* 113416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113431 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113435 */     // MIs[1] Operand 1
     /* 113435 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 113440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113442 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113442 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113445 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 113449 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113454 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113458 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113464 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113467 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113471 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113476 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113481 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113484 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113488 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113493 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113510 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113541 */     GIR_RootConstrainSelectedInstOperands,
     /* 113542 */     // GIR_Coverage, 3880,
     /* 113542 */     GIR_EraseRootFromParent_Done,
     /* 113543 */   // Label 1660: @113543
     /* 113543 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(113675), // Rule ID 3888 //
     /* 113548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113563 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113567 */     // MIs[1] Operand 1
     /* 113567 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 113572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113574 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113574 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113577 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 113581 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113586 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113590 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113596 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113599 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113603 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113608 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113613 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113616 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113620 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113625 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113642 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113673 */     GIR_RootConstrainSelectedInstOperands,
     /* 113674 */     // GIR_Coverage, 3888,
     /* 113674 */     GIR_EraseRootFromParent_Done,
     /* 113675 */   // Label 1661: @113675
     /* 113675 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(113807), // Rule ID 3896 //
     /* 113680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113695 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113699 */     // MIs[1] Operand 1
     /* 113699 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 113704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113706 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113706 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113709 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 113713 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113718 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113722 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113728 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113731 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113735 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113740 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113745 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113748 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113752 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113757 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113774 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 113781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113805 */     GIR_RootConstrainSelectedInstOperands,
     /* 113806 */     // GIR_Coverage, 3896,
     /* 113806 */     GIR_EraseRootFromParent_Done,
     /* 113807 */   // Label 1662: @113807
     /* 113807 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(113939), // Rule ID 3960 //
     /* 113812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113827 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113831 */     // MIs[1] Operand 1
     /* 113831 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 113836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113838 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 113845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113850 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113854 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113860 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113863 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113867 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113872 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113877 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113880 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113884 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113889 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113906 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113937 */     GIR_RootConstrainSelectedInstOperands,
     /* 113938 */     // GIR_Coverage, 3960,
     /* 113938 */     GIR_EraseRootFromParent_Done,
     /* 113939 */   // Label 1663: @113939
     /* 113939 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(114071), // Rule ID 3968 //
     /* 113944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113959 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113963 */     // MIs[1] Operand 1
     /* 113963 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 113968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113970 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113970 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113973 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 113977 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113982 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113986 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113992 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113995 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113999 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114004 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114009 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114012 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114016 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114021 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114038 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 114045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114069 */     GIR_RootConstrainSelectedInstOperands,
     /* 114070 */     // GIR_Coverage, 3968,
     /* 114070 */     GIR_EraseRootFromParent_Done,
     /* 114071 */   // Label 1664: @114071
     /* 114071 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(114203), // Rule ID 3976 //
     /* 114076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114091 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114095 */     // MIs[1] Operand 1
     /* 114095 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 114100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114102 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114102 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114105 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 114109 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114114 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114118 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114124 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114127 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114131 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114136 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114141 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114144 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114148 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114153 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114170 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 114177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114201 */     GIR_RootConstrainSelectedInstOperands,
     /* 114202 */     // GIR_Coverage, 3976,
     /* 114202 */     GIR_EraseRootFromParent_Done,
     /* 114203 */   // Label 1665: @114203
     /* 114203 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(114335), // Rule ID 3984 //
     /* 114208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114223 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114227 */     // MIs[1] Operand 1
     /* 114227 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 114232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114234 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114234 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114237 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 114241 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114246 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114250 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114256 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114259 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114263 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114268 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114273 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114276 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114280 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114285 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114302 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 114309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114333 */     GIR_RootConstrainSelectedInstOperands,
     /* 114334 */     // GIR_Coverage, 3984,
     /* 114334 */     GIR_EraseRootFromParent_Done,
     /* 114335 */   // Label 1666: @114335
     /* 114335 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(114467), // Rule ID 3992 //
     /* 114340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114355 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114359 */     // MIs[1] Operand 1
     /* 114359 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 114364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114366 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114366 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114369 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 114373 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114378 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114382 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114388 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114391 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114395 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114400 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114405 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114408 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114412 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114417 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114434 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 114441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114465 */     GIR_RootConstrainSelectedInstOperands,
     /* 114466 */     // GIR_Coverage, 3992,
     /* 114466 */     GIR_EraseRootFromParent_Done,
     /* 114467 */   // Label 1667: @114467
     /* 114467 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(114482), // Rule ID 2986 //
     /* 114472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 114475 */     // (anyext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 114475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC8),
     /* 114480 */     GIR_RootConstrainSelectedInstOperands,
     /* 114481 */     // GIR_Coverage, 2986,
     /* 114481 */     GIR_Done,
     /* 114482 */   // Label 1668: @114482
     /* 114482 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(114536), // Rule ID 3670 //
     /* 114487 */     // (anyext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } 1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 114487 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 114490 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114494 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114499 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 114502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114516 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 114519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114526 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 114528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 114534 */     GIR_RootConstrainSelectedInstOperands,
     /* 114535 */     // GIR_Coverage, 3670,
     /* 114535 */     GIR_EraseRootFromParent_Done,
     /* 114536 */   // Label 1669: @114536
     /* 114536 */   GIM_Reject,
     /* 114537 */ // Label 1577: @114537
     /* 114537 */ GIM_Reject,
     /* 114538 */ // Label 1483: @114538
     /* 114538 */ GIM_Reject,
     /* 114539 */ // Label 22: @114539
     /* 114539 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(114724),
     /* 114544 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 114547 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1673*/ GIMT_Encode4(114658),
     /* 114558 */   /*GILLT_s32*//*Label 1671*/ GIMT_Encode4(114566),
     /* 114562 */   /*GILLT_s64*//*Label 1672*/ GIMT_Encode4(114612),
     /* 114566 */   // Label 1671: @114566
     /* 114566 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(114611), // Rule ID 1168 //
     /* 114571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 114583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 114587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 114591 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 114595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114597 */     // (trunc:{ *:[i1] } (xor:{ *:[i32] } i32:{ *:[i32] }:$in, -1:{ *:[i32] }))  =>  (ANDI_rec_1_EQ_BIT:{ *:[i1] }:{ *:[i32] } i32:{ *:[i32] }:$in)
     /* 114597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT),
     /* 114600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /* 114606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /* 114609 */     GIR_RootConstrainSelectedInstOperands,
     /* 114610 */     // GIR_Coverage, 1168,
     /* 114610 */     GIR_EraseRootFromParent_Done,
     /* 114611 */   // Label 1674: @114611
     /* 114611 */   GIM_Reject,
     /* 114612 */   // Label 1672: @114612
     /* 114612 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(114657), // Rule ID 1170 //
     /* 114617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 114629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114637 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 114641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114643 */     // (trunc:{ *:[i1] } (xor:{ *:[i64] } i64:{ *:[i64] }:$in, -1:{ *:[i64] }))  =>  (ANDI_rec_1_EQ_BIT8:{ *:[i1] }:{ *:[i32] } i64:{ *:[i64] }:$in)
     /* 114643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT8),
     /* 114646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /* 114652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /* 114655 */     GIR_RootConstrainSelectedInstOperands,
     /* 114656 */     // GIR_Coverage, 1170,
     /* 114656 */     GIR_EraseRootFromParent_Done,
     /* 114657 */   // Label 1675: @114657
     /* 114657 */   GIM_Reject,
     /* 114658 */   // Label 1673: @114658
     /* 114658 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1678*/ GIMT_Encode4(114723),
     /* 114669 */   /*GILLT_s32*//*Label 1676*/ GIMT_Encode4(114677),
     /* 114673 */   /*GILLT_s64*//*Label 1677*/ GIMT_Encode4(114700),
     /* 114677 */   // Label 1676: @114677
     /* 114677 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(114699), // Rule ID 1169 //
     /* 114682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114686 */     // (trunc:{ *:[i1] } i32:{ *:[i32] }:$in)  =>  (ANDI_rec_1_GT_BIT:{ *:[i1] }:{ *:[i32] } i32:{ *:[i32] }:$in)
     /* 114686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_GT_BIT),
     /* 114691 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CR0), GIMT_Encode2(RegState::Dead),
     /* 114697 */     GIR_RootConstrainSelectedInstOperands,
     /* 114698 */     // GIR_Coverage, 1169,
     /* 114698 */     GIR_Done,
     /* 114699 */   // Label 1679: @114699
     /* 114699 */   GIM_Reject,
     /* 114700 */   // Label 1677: @114700
     /* 114700 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(114722), // Rule ID 1171 //
     /* 114705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114709 */     // (trunc:{ *:[i1] } i64:{ *:[i64] }:$in)  =>  (ANDI_rec_1_GT_BIT8:{ *:[i1] }:{ *:[i32] } i64:{ *:[i64] }:$in)
     /* 114709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_GT_BIT8),
     /* 114714 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CR0), GIMT_Encode2(RegState::Dead),
     /* 114720 */     GIR_RootConstrainSelectedInstOperands,
     /* 114721 */     // GIR_Coverage, 1171,
     /* 114721 */     GIR_Done,
     /* 114722 */   // Label 1680: @114722
     /* 114722 */   GIM_Reject,
     /* 114723 */   // Label 1678: @114723
     /* 114723 */   GIM_Reject,
     /* 114724 */ // Label 1670: @114724
     /* 114724 */ GIM_Reject,
     /* 114725 */ // Label 23: @114725
     /* 114725 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 1684*/ GIMT_Encode4(114876),
     /* 114736 */ /*GILLT_s1*//*Label 1681*/ GIMT_Encode4(114748),
     /* 114740 */ /*GILLT_s32*//*Label 1682*/ GIMT_Encode4(114828),
     /* 114744 */ /*GILLT_s64*//*Label 1683*/ GIMT_Encode4(114852),
     /* 114748 */ // Label 1681: @114748
     /* 114748 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(114827),
     /* 114753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114757 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(114780), // Rule ID 184 //
     /* 114762 */     // MIs[0] Operand 1
     /* 114762 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 114773 */     // 1:{ *:[i1] }  =>  (CRSET:{ *:[i1] })
     /* 114773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRSET),
     /* 114776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 114778 */     GIR_RootConstrainSelectedInstOperands,
     /* 114779 */     // GIR_Coverage, 184,
     /* 114779 */     GIR_EraseRootFromParent_Done,
     /* 114780 */   // Label 1686: @114780
     /* 114780 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(114803), // Rule ID 185 //
     /* 114785 */     // MIs[0] Operand 1
     /* 114785 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 114796 */     // 0:{ *:[i1] }  =>  (CRUNSET:{ *:[i1] })
     /* 114796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRUNSET),
     /* 114799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 114801 */     GIR_RootConstrainSelectedInstOperands,
     /* 114802 */     // GIR_Coverage, 185,
     /* 114802 */     GIR_EraseRootFromParent_Done,
     /* 114803 */   // Label 1687: @114803
     /* 114803 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(114826), // Rule ID 3664 //
     /* 114808 */     // MIs[0] Operand 1
     /* 114808 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 114819 */     // -1:{ *:[i1] }  =>  (CRSET:{ *:[i1] })
     /* 114819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRSET),
     /* 114822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 114824 */     GIR_RootConstrainSelectedInstOperands,
     /* 114825 */     // GIR_Coverage, 3664,
     /* 114825 */     GIR_EraseRootFromParent_Done,
     /* 114826 */   // Label 1688: @114826
     /* 114826 */   GIM_Reject,
     /* 114827 */ // Label 1685: @114827
     /* 114827 */ GIM_Reject,
     /* 114828 */ // Label 1682: @114828
     /* 114828 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(114851), // Rule ID 113 //
     /* 114833 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 114837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 114841 */   // MIs[0] Operand 1
     /* 114841 */   // No operand predicates
     /* 114841 */   // (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D  =>  (LI:{ *:[i32] } (imm:{ *:[i32] }):$D)
     /* 114841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 114844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114846 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // D
     /* 114849 */   GIR_RootConstrainSelectedInstOperands,
     /* 114850 */   // GIR_Coverage, 113,
     /* 114850 */   GIR_EraseRootFromParent_Done,
     /* 114851 */ // Label 1689: @114851
     /* 114851 */ GIM_Reject,
     /* 114852 */ // Label 1683: @114852
     /* 114852 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(114875), // Rule ID 639 //
     /* 114857 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 114861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 114865 */   // MIs[0] Operand 1
     /* 114865 */   // No operand predicates
     /* 114865 */   // (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D  =>  (LI8:{ *:[i64] } (imm:{ *:[i64] }):$D)
     /* 114865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114870 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // D
     /* 114873 */   GIR_RootConstrainSelectedInstOperands,
     /* 114874 */   // GIR_Coverage, 639,
     /* 114874 */   GIR_EraseRootFromParent_Done,
     /* 114875 */ // Label 1690: @114875
     /* 114875 */ GIM_Reject,
     /* 114876 */ // Label 1684: @114876
     /* 114876 */ GIM_Reject,
     /* 114877 */ // Label 24: @114877
     /* 114877 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1693*/ GIMT_Encode4(129908),
     /* 114888 */ /*GILLT_s32*//*Label 1691*/ GIMT_Encode4(114896),
     /* 114892 */ /*GILLT_s64*//*Label 1692*/ GIMT_Encode4(122175),
     /* 114896 */ // Label 1691: @114896
     /* 114896 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(122174),
     /* 114901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 114904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 114908 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(115011), // Rule ID 3031 //
     /* 114913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 114916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 114928 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 114932 */     // MIs[1] Operand 1
     /* 114932 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 114937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 114941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114945 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 114949 */     // MIs[2] Operand 1
     /* 114949 */     // No operand predicates
     /* 114949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114951 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 114951 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114954 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 114958 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114963 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 114970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114984 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 114991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115009 */     GIR_RootConstrainSelectedInstOperands,
     /* 115010 */     // GIR_Coverage, 3031,
     /* 115010 */     GIR_EraseRootFromParent_Done,
     /* 115011 */   // Label 1695: @115011
     /* 115011 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(115114), // Rule ID 3047 //
     /* 115016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115031 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115035 */     // MIs[1] Operand 1
     /* 115035 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 115040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115048 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115052 */     // MIs[2] Operand 1
     /* 115052 */     // No operand predicates
     /* 115052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115054 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 115054 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115057 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115061 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115066 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115087 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 115094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115112 */     GIR_RootConstrainSelectedInstOperands,
     /* 115113 */     // GIR_Coverage, 3047,
     /* 115113 */     GIR_EraseRootFromParent_Done,
     /* 115114 */   // Label 1696: @115114
     /* 115114 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(115217), // Rule ID 3055 //
     /* 115119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115134 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115138 */     // MIs[1] Operand 1
     /* 115138 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 115143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115151 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115155 */     // MIs[2] Operand 1
     /* 115155 */     // No operand predicates
     /* 115155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115157 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 115157 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115160 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115164 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115169 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115190 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 115197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115215 */     GIR_RootConstrainSelectedInstOperands,
     /* 115216 */     // GIR_Coverage, 3055,
     /* 115216 */     GIR_EraseRootFromParent_Done,
     /* 115217 */   // Label 1697: @115217
     /* 115217 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(115320), // Rule ID 3127 //
     /* 115222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115237 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115241 */     // MIs[1] Operand 1
     /* 115241 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 115246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115254 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115258 */     // MIs[2] Operand 1
     /* 115258 */     // No operand predicates
     /* 115258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115260 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 115260 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115263 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 115267 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115272 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115293 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 115300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115318 */     GIR_RootConstrainSelectedInstOperands,
     /* 115319 */     // GIR_Coverage, 3127,
     /* 115319 */     GIR_EraseRootFromParent_Done,
     /* 115320 */   // Label 1698: @115320
     /* 115320 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(115423), // Rule ID 3143 //
     /* 115325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115340 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115344 */     // MIs[1] Operand 1
     /* 115344 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 115349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115357 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115361 */     // MIs[2] Operand 1
     /* 115361 */     // No operand predicates
     /* 115361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115363 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 115363 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115366 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 115370 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115396 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 115403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115421 */     GIR_RootConstrainSelectedInstOperands,
     /* 115422 */     // GIR_Coverage, 3143,
     /* 115422 */     GIR_EraseRootFromParent_Done,
     /* 115423 */   // Label 1699: @115423
     /* 115423 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(115526), // Rule ID 3151 //
     /* 115428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115443 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115447 */     // MIs[1] Operand 1
     /* 115447 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 115452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115460 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115464 */     // MIs[2] Operand 1
     /* 115464 */     // No operand predicates
     /* 115464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115466 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 115466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 115473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115478 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115499 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 115506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115524 */     GIR_RootConstrainSelectedInstOperands,
     /* 115525 */     // GIR_Coverage, 3151,
     /* 115525 */     GIR_EraseRootFromParent_Done,
     /* 115526 */   // Label 1700: @115526
     /* 115526 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(115669), // Rule ID 3812 //
     /* 115531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 115534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115546 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115550 */     // MIs[1] Operand 1
     /* 115550 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 115555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115563 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115567 */     // MIs[2] Operand 1
     /* 115567 */     // No operand predicates
     /* 115567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115569 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115590 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115593 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115597 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115602 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115607 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115610 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115614 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115619 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115636 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 115643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115667 */     GIR_RootConstrainSelectedInstOperands,
     /* 115668 */     // GIR_Coverage, 3812,
     /* 115668 */     GIR_EraseRootFromParent_Done,
     /* 115669 */   // Label 1701: @115669
     /* 115669 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(115812), // Rule ID 3828 //
     /* 115674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 115677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115689 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115693 */     // MIs[1] Operand 1
     /* 115693 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 115698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115706 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115710 */     // MIs[2] Operand 1
     /* 115710 */     // No operand predicates
     /* 115710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115712 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115712 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115715 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115719 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115724 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115733 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115736 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115740 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115745 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115750 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115753 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115757 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115762 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115779 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 115786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115810 */     GIR_RootConstrainSelectedInstOperands,
     /* 115811 */     // GIR_Coverage, 3828,
     /* 115811 */     GIR_EraseRootFromParent_Done,
     /* 115812 */   // Label 1702: @115812
     /* 115812 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(115955), // Rule ID 3836 //
     /* 115817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 115820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115832 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115836 */     // MIs[1] Operand 1
     /* 115836 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 115841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115849 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115853 */     // MIs[2] Operand 1
     /* 115853 */     // No operand predicates
     /* 115853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115855 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115855 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115858 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115862 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115867 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115876 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115879 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115883 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115888 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115893 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115896 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115900 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115905 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115922 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 115929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115953 */     GIR_RootConstrainSelectedInstOperands,
     /* 115954 */     // GIR_Coverage, 3836,
     /* 115954 */     GIR_EraseRootFromParent_Done,
     /* 115955 */   // Label 1703: @115955
     /* 115955 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(116098), // Rule ID 3908 //
     /* 115960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 115963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115975 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115979 */     // MIs[1] Operand 1
     /* 115979 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 115984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115992 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115996 */     // MIs[2] Operand 1
     /* 115996 */     // No operand predicates
     /* 115996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115998 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115998 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116001 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 116005 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116010 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116019 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116022 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116026 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116031 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116036 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116039 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116043 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116048 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116065 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 116072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116096 */     GIR_RootConstrainSelectedInstOperands,
     /* 116097 */     // GIR_Coverage, 3908,
     /* 116097 */     GIR_EraseRootFromParent_Done,
     /* 116098 */   // Label 1704: @116098
     /* 116098 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(116241), // Rule ID 3924 //
     /* 116103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 116106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 116114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116118 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116122 */     // MIs[1] Operand 1
     /* 116122 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 116127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116135 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 116139 */     // MIs[2] Operand 1
     /* 116139 */     // No operand predicates
     /* 116139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116141 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116141 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116144 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 116148 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116153 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116162 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116165 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116169 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116174 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116179 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116182 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116186 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116191 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116208 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116239 */     GIR_RootConstrainSelectedInstOperands,
     /* 116240 */     // GIR_Coverage, 3924,
     /* 116240 */     GIR_EraseRootFromParent_Done,
     /* 116241 */   // Label 1705: @116241
     /* 116241 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(116384), // Rule ID 3932 //
     /* 116246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 116249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 116257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116261 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116265 */     // MIs[1] Operand 1
     /* 116265 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 116270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 116282 */     // MIs[2] Operand 1
     /* 116282 */     // No operand predicates
     /* 116282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116284 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116284 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116287 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 116291 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116296 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116305 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116308 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116312 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116317 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116322 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116325 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116329 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116334 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116351 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 116358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116382 */     GIR_RootConstrainSelectedInstOperands,
     /* 116383 */     // GIR_Coverage, 3932,
     /* 116383 */     GIR_EraseRootFromParent_Done,
     /* 116384 */   // Label 1706: @116384
     /* 116384 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(116476), // Rule ID 3175 //
     /* 116389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116404 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116408 */     // MIs[1] Operand 1
     /* 116408 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 116413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116415 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 116415 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116418 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116422 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116427 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116431 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116449 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 116456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116474 */     GIR_RootConstrainSelectedInstOperands,
     /* 116475 */     // GIR_Coverage, 3175,
     /* 116475 */     GIR_EraseRootFromParent_Done,
     /* 116476 */   // Label 1707: @116476
     /* 116476 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(116568), // Rule ID 3191 //
     /* 116481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116496 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116500 */     // MIs[1] Operand 1
     /* 116500 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 116505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116507 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 116507 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116510 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116514 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116519 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116523 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116541 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116566 */     GIR_RootConstrainSelectedInstOperands,
     /* 116567 */     // GIR_Coverage, 3191,
     /* 116567 */     GIR_EraseRootFromParent_Done,
     /* 116568 */   // Label 1708: @116568
     /* 116568 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(116660), // Rule ID 3207 //
     /* 116573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116588 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116592 */     // MIs[1] Operand 1
     /* 116592 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 116597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116599 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 116599 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116602 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116606 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116611 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116615 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116633 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 116640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116658 */     GIR_RootConstrainSelectedInstOperands,
     /* 116659 */     // GIR_Coverage, 3207,
     /* 116659 */     GIR_EraseRootFromParent_Done,
     /* 116660 */   // Label 1709: @116660
     /* 116660 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(116752), // Rule ID 3223 //
     /* 116665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116680 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116684 */     // MIs[1] Operand 1
     /* 116684 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 116689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116691 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 116691 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116694 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116698 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116703 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116707 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116725 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 116732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116750 */     GIR_RootConstrainSelectedInstOperands,
     /* 116751 */     // GIR_Coverage, 3223,
     /* 116751 */     GIR_EraseRootFromParent_Done,
     /* 116752 */   // Label 1710: @116752
     /* 116752 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(116844), // Rule ID 3231 //
     /* 116757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116772 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116776 */     // MIs[1] Operand 1
     /* 116776 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 116781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116783 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 116783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 116790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116795 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116817 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 116824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116842 */     GIR_RootConstrainSelectedInstOperands,
     /* 116843 */     // GIR_Coverage, 3231,
     /* 116843 */     GIR_EraseRootFromParent_Done,
     /* 116844 */   // Label 1711: @116844
     /* 116844 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(116936), // Rule ID 3247 //
     /* 116849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116864 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116868 */     // MIs[1] Operand 1
     /* 116868 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 116873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116875 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 116875 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116878 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 116882 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116887 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116891 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116909 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116934 */     GIR_RootConstrainSelectedInstOperands,
     /* 116935 */     // GIR_Coverage, 3247,
     /* 116935 */     GIR_EraseRootFromParent_Done,
     /* 116936 */   // Label 1712: @116936
     /* 116936 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(117028), // Rule ID 3263 //
     /* 116941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116956 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116960 */     // MIs[1] Operand 1
     /* 116960 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 116965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116967 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 116967 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116970 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 116974 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116979 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117001 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 117008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117026 */     GIR_RootConstrainSelectedInstOperands,
     /* 117027 */     // GIR_Coverage, 3263,
     /* 117027 */     GIR_EraseRootFromParent_Done,
     /* 117028 */   // Label 1713: @117028
     /* 117028 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(117120), // Rule ID 3279 //
     /* 117033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117048 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117052 */     // MIs[1] Operand 1
     /* 117052 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 117057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117059 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 117059 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117062 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 117066 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117071 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117075 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117093 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 117100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117118 */     GIR_RootConstrainSelectedInstOperands,
     /* 117119 */     // GIR_Coverage, 3279,
     /* 117119 */     GIR_EraseRootFromParent_Done,
     /* 117120 */   // Label 1714: @117120
     /* 117120 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(117212), // Rule ID 3287 //
     /* 117125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117140 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117144 */     // MIs[1] Operand 1
     /* 117144 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 117149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117151 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 117151 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117154 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117158 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117163 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117167 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117185 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 117192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117210 */     GIR_RootConstrainSelectedInstOperands,
     /* 117211 */     // GIR_Coverage, 3287,
     /* 117211 */     GIR_EraseRootFromParent_Done,
     /* 117212 */   // Label 1715: @117212
     /* 117212 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(117304), // Rule ID 3303 //
     /* 117217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117232 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117236 */     // MIs[1] Operand 1
     /* 117236 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 117241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117243 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 117243 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117246 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117250 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117255 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117259 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117277 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117302 */     GIR_RootConstrainSelectedInstOperands,
     /* 117303 */     // GIR_Coverage, 3303,
     /* 117303 */     GIR_EraseRootFromParent_Done,
     /* 117304 */   // Label 1716: @117304
     /* 117304 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(117396), // Rule ID 3319 //
     /* 117309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117324 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117328 */     // MIs[1] Operand 1
     /* 117328 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 117333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117335 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 117335 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117338 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117342 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117347 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117351 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117369 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 117376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117394 */     GIR_RootConstrainSelectedInstOperands,
     /* 117395 */     // GIR_Coverage, 3319,
     /* 117395 */     GIR_EraseRootFromParent_Done,
     /* 117396 */   // Label 1717: @117396
     /* 117396 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(117488), // Rule ID 3335 //
     /* 117401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117416 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117420 */     // MIs[1] Operand 1
     /* 117420 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 117425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117427 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 117427 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117430 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117434 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117439 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117443 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117461 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 117468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117486 */     GIR_RootConstrainSelectedInstOperands,
     /* 117487 */     // GIR_Coverage, 3335,
     /* 117487 */     GIR_EraseRootFromParent_Done,
     /* 117488 */   // Label 1718: @117488
     /* 117488 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(117620), // Rule ID 4014 //
     /* 117493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 117496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117508 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117512 */     // MIs[1] Operand 1
     /* 117512 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 117517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117519 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117519 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117522 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117526 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117531 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117535 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117541 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117544 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117548 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117553 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117558 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 117561 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117565 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117570 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 117573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117587 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 117594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 117607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 117615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 117618 */     GIR_RootConstrainSelectedInstOperands,
     /* 117619 */     // GIR_Coverage, 4014,
     /* 117619 */     GIR_EraseRootFromParent_Done,
     /* 117620 */   // Label 1719: @117620
     /* 117620 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(117752), // Rule ID 4046 //
     /* 117625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 117628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117640 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117644 */     // MIs[1] Operand 1
     /* 117644 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 117649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117651 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117651 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117654 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117658 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117663 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117667 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117673 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117676 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117680 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117685 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117690 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 117693 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117697 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117702 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 117705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117719 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 117739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 117747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 117750 */     GIR_RootConstrainSelectedInstOperands,
     /* 117751 */     // GIR_Coverage, 4046,
     /* 117751 */     GIR_EraseRootFromParent_Done,
     /* 117752 */   // Label 1720: @117752
     /* 117752 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(117884), // Rule ID 4078 //
     /* 117757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 117760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117772 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117776 */     // MIs[1] Operand 1
     /* 117776 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 117781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117783 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117795 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117805 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117808 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117812 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117817 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117822 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 117825 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117829 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117834 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 117837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117851 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 117858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 117871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 117879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 117882 */     GIR_RootConstrainSelectedInstOperands,
     /* 117883 */     // GIR_Coverage, 4078,
     /* 117883 */     GIR_EraseRootFromParent_Done,
     /* 117884 */   // Label 1721: @117884
     /* 117884 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(118016), // Rule ID 4110 //
     /* 117889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 117892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117904 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117908 */     // MIs[1] Operand 1
     /* 117908 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 117913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117915 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117915 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117918 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117922 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117927 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117931 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117937 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117940 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117944 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117949 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117954 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 117957 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117961 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117966 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 117969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117983 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 117990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118014 */     GIR_RootConstrainSelectedInstOperands,
     /* 118015 */     // GIR_Coverage, 4110,
     /* 118015 */     GIR_EraseRootFromParent_Done,
     /* 118016 */   // Label 1722: @118016
     /* 118016 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(118148), // Rule ID 4126 //
     /* 118021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118036 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118040 */     // MIs[1] Operand 1
     /* 118040 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 118045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118047 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118047 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118050 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118054 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118059 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118063 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118069 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118072 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118076 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118081 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118086 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118089 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118093 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118098 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118115 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 118122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118146 */     GIR_RootConstrainSelectedInstOperands,
     /* 118147 */     // GIR_Coverage, 4126,
     /* 118147 */     GIR_EraseRootFromParent_Done,
     /* 118148 */   // Label 1723: @118148
     /* 118148 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(118280), // Rule ID 4158 //
     /* 118153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118168 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118172 */     // MIs[1] Operand 1
     /* 118172 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 118177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118179 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118179 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118182 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118186 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118191 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118195 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118201 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118204 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118208 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118213 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118218 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118221 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118225 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118230 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118247 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 118254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118278 */     GIR_RootConstrainSelectedInstOperands,
     /* 118279 */     // GIR_Coverage, 4158,
     /* 118279 */     GIR_EraseRootFromParent_Done,
     /* 118280 */   // Label 1724: @118280
     /* 118280 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(118412), // Rule ID 4190 //
     /* 118285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118300 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118304 */     // MIs[1] Operand 1
     /* 118304 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 118309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118311 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118311 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118314 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118318 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118323 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118333 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118336 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118340 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118345 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118350 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118353 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118357 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118362 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118379 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 118386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118410 */     GIR_RootConstrainSelectedInstOperands,
     /* 118411 */     // GIR_Coverage, 4190,
     /* 118411 */     GIR_EraseRootFromParent_Done,
     /* 118412 */   // Label 1725: @118412
     /* 118412 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(118544), // Rule ID 4222 //
     /* 118417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118432 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118436 */     // MIs[1] Operand 1
     /* 118436 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 118441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118443 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118455 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118465 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118468 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118472 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118477 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118482 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118485 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118489 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118494 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118511 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 118518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118542 */     GIR_RootConstrainSelectedInstOperands,
     /* 118543 */     // GIR_Coverage, 4222,
     /* 118543 */     GIR_EraseRootFromParent_Done,
     /* 118544 */   // Label 1726: @118544
     /* 118544 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(118676), // Rule ID 4252 //
     /* 118549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 118564 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 118568 */     // MIs[1] Operand 1
     /* 118568 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 118573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118575 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 118582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118591 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118597 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118600 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118604 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118609 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118614 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118617 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118621 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118626 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118643 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 118650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118674 */     GIR_RootConstrainSelectedInstOperands,
     /* 118675 */     // GIR_Coverage, 4252,
     /* 118675 */     GIR_EraseRootFromParent_Done,
     /* 118676 */   // Label 1727: @118676
     /* 118676 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(118808), // Rule ID 4284 //
     /* 118681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 118696 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 118700 */     // MIs[1] Operand 1
     /* 118700 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 118705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118707 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118707 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118710 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 118714 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118719 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118723 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118729 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118732 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118736 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118741 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118746 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118749 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118753 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118758 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118775 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 118782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118806 */     GIR_RootConstrainSelectedInstOperands,
     /* 118807 */     // GIR_Coverage, 4284,
     /* 118807 */     GIR_EraseRootFromParent_Done,
     /* 118808 */   // Label 1728: @118808
     /* 118808 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(118940), // Rule ID 4316 //
     /* 118813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 118828 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 118832 */     // MIs[1] Operand 1
     /* 118832 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 118837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118839 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 118846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118861 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118864 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118868 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118873 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118878 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118881 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118885 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118890 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118907 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 118914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118938 */     GIR_RootConstrainSelectedInstOperands,
     /* 118939 */     // GIR_Coverage, 4316,
     /* 118939 */     GIR_EraseRootFromParent_Done,
     /* 118940 */   // Label 1729: @118940
     /* 118940 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(119072), // Rule ID 4348 //
     /* 118945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 118960 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 118964 */     // MIs[1] Operand 1
     /* 118964 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 118969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118971 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118971 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118974 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 118978 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118987 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118993 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118996 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119000 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119005 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119010 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119013 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119017 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119022 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119039 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 119046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119070 */     GIR_RootConstrainSelectedInstOperands,
     /* 119071 */     // GIR_Coverage, 4348,
     /* 119071 */     GIR_EraseRootFromParent_Done,
     /* 119072 */   // Label 1730: @119072
     /* 119072 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(119204), // Rule ID 4579 //
     /* 119077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119092 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119096 */     // MIs[1] Operand 1
     /* 119096 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 119101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119103 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119103 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119106 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 119110 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119125 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119128 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119132 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119137 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119142 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119145 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119149 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119154 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119171 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119202 */     GIR_RootConstrainSelectedInstOperands,
     /* 119203 */     // GIR_Coverage, 4579,
     /* 119203 */     GIR_EraseRootFromParent_Done,
     /* 119204 */   // Label 1731: @119204
     /* 119204 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(119336), // Rule ID 4611 //
     /* 119209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119224 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119228 */     // MIs[1] Operand 1
     /* 119228 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 119233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119235 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119235 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119238 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 119242 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119247 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119251 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119257 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119260 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119264 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119269 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119274 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119277 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119281 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119286 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119303 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119334 */     GIR_RootConstrainSelectedInstOperands,
     /* 119335 */     // GIR_Coverage, 4611,
     /* 119335 */     GIR_EraseRootFromParent_Done,
     /* 119336 */   // Label 1732: @119336
     /* 119336 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(119468), // Rule ID 4643 //
     /* 119341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119356 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119360 */     // MIs[1] Operand 1
     /* 119360 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 119365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119367 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 119374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119379 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119383 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119389 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119392 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119396 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119401 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119406 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119409 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119413 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119418 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119435 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119466 */     GIR_RootConstrainSelectedInstOperands,
     /* 119467 */     // GIR_Coverage, 4643,
     /* 119467 */     GIR_EraseRootFromParent_Done,
     /* 119468 */   // Label 1733: @119468
     /* 119468 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(119600), // Rule ID 4687 //
     /* 119473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119488 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119492 */     // MIs[1] Operand 1
     /* 119492 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 119497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119499 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 119506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119511 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119515 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119521 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119524 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119528 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119533 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119550 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119567 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119598 */     GIR_RootConstrainSelectedInstOperands,
     /* 119599 */     // GIR_Coverage, 4687,
     /* 119599 */     GIR_EraseRootFromParent_Done,
     /* 119600 */   // Label 1734: @119600
     /* 119600 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(119732), // Rule ID 4719 //
     /* 119605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119620 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119624 */     // MIs[1] Operand 1
     /* 119624 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 119629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119631 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 119638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119647 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119653 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119656 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119660 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119665 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119670 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119673 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119677 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119682 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119699 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119730 */     GIR_RootConstrainSelectedInstOperands,
     /* 119731 */     // GIR_Coverage, 4719,
     /* 119731 */     GIR_EraseRootFromParent_Done,
     /* 119732 */   // Label 1735: @119732
     /* 119732 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(119864), // Rule ID 4751 //
     /* 119737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119756 */     // MIs[1] Operand 1
     /* 119756 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 119761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119763 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119763 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119766 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 119770 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119775 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119779 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119785 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119788 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119792 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119797 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119802 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119805 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119809 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119814 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119831 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119862 */     GIR_RootConstrainSelectedInstOperands,
     /* 119863 */     // GIR_Coverage, 4751,
     /* 119863 */     GIR_EraseRootFromParent_Done,
     /* 119864 */   // Label 1736: @119864
     /* 119864 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(119956), // Rule ID 2977 //
     /* 119869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 119872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 119880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119884 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119888 */     // MIs[1] Operand 1
     /* 119888 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 119893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119895 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 119895 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119898 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 119902 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119907 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119911 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119929 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 119936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 119949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 119951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119954 */     GIR_RootConstrainSelectedInstOperands,
     /* 119955 */     // GIR_Coverage, 2977,
     /* 119955 */     GIR_EraseRootFromParent_Done,
     /* 119956 */   // Label 1737: @119956
     /* 119956 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(120048), // Rule ID 2991 //
     /* 119961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 119964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 119972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119976 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119980 */     // MIs[1] Operand 1
     /* 119980 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 119985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119987 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 119987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 119994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119999 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120003 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120021 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120046 */     GIR_RootConstrainSelectedInstOperands,
     /* 120047 */     // GIR_Coverage, 2991,
     /* 120047 */     GIR_EraseRootFromParent_Done,
     /* 120048 */   // Label 1738: @120048
     /* 120048 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(120140), // Rule ID 2999 //
     /* 120053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120068 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120072 */     // MIs[1] Operand 1
     /* 120072 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 120077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120079 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 120079 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120082 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 120086 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120091 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120095 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120113 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120138 */     GIR_RootConstrainSelectedInstOperands,
     /* 120139 */     // GIR_Coverage, 2999,
     /* 120139 */     GIR_EraseRootFromParent_Done,
     /* 120140 */   // Label 1739: @120140
     /* 120140 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(120232), // Rule ID 3007 //
     /* 120145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120160 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120164 */     // MIs[1] Operand 1
     /* 120164 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 120169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120171 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 120171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 120178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120183 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120187 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120205 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120230 */     GIR_RootConstrainSelectedInstOperands,
     /* 120231 */     // GIR_Coverage, 3007,
     /* 120231 */     GIR_EraseRootFromParent_Done,
     /* 120232 */   // Label 1740: @120232
     /* 120232 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(120324), // Rule ID 3015 //
     /* 120237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120252 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120256 */     // MIs[1] Operand 1
     /* 120256 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 120261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120263 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 120263 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120266 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 120270 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120275 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120279 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120297 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 120304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120322 */     GIR_RootConstrainSelectedInstOperands,
     /* 120323 */     // GIR_Coverage, 3015,
     /* 120323 */     GIR_EraseRootFromParent_Done,
     /* 120324 */   // Label 1741: @120324
     /* 120324 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(120416), // Rule ID 3079 //
     /* 120329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120344 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120348 */     // MIs[1] Operand 1
     /* 120348 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 120353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120355 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 120355 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120358 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 120362 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120367 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120389 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120414 */     GIR_RootConstrainSelectedInstOperands,
     /* 120415 */     // GIR_Coverage, 3079,
     /* 120415 */     GIR_EraseRootFromParent_Done,
     /* 120416 */   // Label 1742: @120416
     /* 120416 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(120508), // Rule ID 3087 //
     /* 120421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120436 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120440 */     // MIs[1] Operand 1
     /* 120440 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 120445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120447 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 120447 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120450 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 120454 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120463 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120481 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120506 */     GIR_RootConstrainSelectedInstOperands,
     /* 120507 */     // GIR_Coverage, 3087,
     /* 120507 */     GIR_EraseRootFromParent_Done,
     /* 120508 */   // Label 1743: @120508
     /* 120508 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(120600), // Rule ID 3095 //
     /* 120513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120528 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120532 */     // MIs[1] Operand 1
     /* 120532 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 120537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120539 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 120539 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120542 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 120546 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120551 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120555 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120573 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120598 */     GIR_RootConstrainSelectedInstOperands,
     /* 120599 */     // GIR_Coverage, 3095,
     /* 120599 */     GIR_EraseRootFromParent_Done,
     /* 120600 */   // Label 1744: @120600
     /* 120600 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(120692), // Rule ID 3103 //
     /* 120605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120620 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120624 */     // MIs[1] Operand 1
     /* 120624 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 120629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120631 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 120631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 120638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120647 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120665 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120690 */     GIR_RootConstrainSelectedInstOperands,
     /* 120691 */     // GIR_Coverage, 3103,
     /* 120691 */     GIR_EraseRootFromParent_Done,
     /* 120692 */   // Label 1745: @120692
     /* 120692 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(120784), // Rule ID 3111 //
     /* 120697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120712 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120716 */     // MIs[1] Operand 1
     /* 120716 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 120721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120723 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 120723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 120730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120735 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120739 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120757 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 120764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120782 */     GIR_RootConstrainSelectedInstOperands,
     /* 120783 */     // GIR_Coverage, 3111,
     /* 120783 */     GIR_EraseRootFromParent_Done,
     /* 120784 */   // Label 1746: @120784
     /* 120784 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(120916), // Rule ID 3860 //
     /* 120789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 120792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120804 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120808 */     // MIs[1] Operand 1
     /* 120808 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 120813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120815 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 120815 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120818 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 120822 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120827 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120831 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120837 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 120840 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 120844 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120849 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 120852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 120854 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 120857 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 120861 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120866 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 120869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 120871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120883 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 120903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 120911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 120914 */     GIR_RootConstrainSelectedInstOperands,
     /* 120915 */     // GIR_Coverage, 3860,
     /* 120915 */     GIR_EraseRootFromParent_Done,
     /* 120916 */   // Label 1747: @120916
     /* 120916 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(121048), // Rule ID 3868 //
     /* 120921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 120924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120936 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120940 */     // MIs[1] Operand 1
     /* 120940 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 120945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120947 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 120947 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120950 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 120954 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120959 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120963 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120969 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 120972 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 120976 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120981 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 120984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 120986 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 120989 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 120993 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120998 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121015 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121046 */     GIR_RootConstrainSelectedInstOperands,
     /* 121047 */     // GIR_Coverage, 3868,
     /* 121047 */     GIR_EraseRootFromParent_Done,
     /* 121048 */   // Label 1748: @121048
     /* 121048 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(121180), // Rule ID 3876 //
     /* 121053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121068 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121072 */     // MIs[1] Operand 1
     /* 121072 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 121077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121079 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121079 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121082 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 121086 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121091 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121095 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121101 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121104 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121108 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121113 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121118 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121121 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121125 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121130 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121147 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121178 */     GIR_RootConstrainSelectedInstOperands,
     /* 121179 */     // GIR_Coverage, 3876,
     /* 121179 */     GIR_EraseRootFromParent_Done,
     /* 121180 */   // Label 1749: @121180
     /* 121180 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(121312), // Rule ID 3884 //
     /* 121185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121200 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121204 */     // MIs[1] Operand 1
     /* 121204 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 121209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121211 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121211 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121214 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 121218 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121223 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121227 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121233 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121236 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121240 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121245 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121250 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121253 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121257 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121262 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121279 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121310 */     GIR_RootConstrainSelectedInstOperands,
     /* 121311 */     // GIR_Coverage, 3884,
     /* 121311 */     GIR_EraseRootFromParent_Done,
     /* 121312 */   // Label 1750: @121312
     /* 121312 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(121444), // Rule ID 3892 //
     /* 121317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121332 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121336 */     // MIs[1] Operand 1
     /* 121336 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 121341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121343 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121343 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121346 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 121350 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121355 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121365 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121368 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121372 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121377 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121382 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121385 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121389 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121394 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121411 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 121418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121442 */     GIR_RootConstrainSelectedInstOperands,
     /* 121443 */     // GIR_Coverage, 3892,
     /* 121443 */     GIR_EraseRootFromParent_Done,
     /* 121444 */   // Label 1751: @121444
     /* 121444 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(121576), // Rule ID 3956 //
     /* 121449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121464 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121468 */     // MIs[1] Operand 1
     /* 121468 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 121473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121475 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121475 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121478 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 121482 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121491 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121497 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121500 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121504 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121509 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121514 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121517 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121521 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121526 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121543 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121574 */     GIR_RootConstrainSelectedInstOperands,
     /* 121575 */     // GIR_Coverage, 3956,
     /* 121575 */     GIR_EraseRootFromParent_Done,
     /* 121576 */   // Label 1752: @121576
     /* 121576 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(121708), // Rule ID 3964 //
     /* 121581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121596 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121600 */     // MIs[1] Operand 1
     /* 121600 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 121605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121607 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121607 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121610 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 121614 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121619 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121623 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121629 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121632 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121636 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121641 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121646 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121649 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121653 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121658 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121675 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121706 */     GIR_RootConstrainSelectedInstOperands,
     /* 121707 */     // GIR_Coverage, 3964,
     /* 121707 */     GIR_EraseRootFromParent_Done,
     /* 121708 */   // Label 1753: @121708
     /* 121708 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(121840), // Rule ID 3972 //
     /* 121713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121728 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121732 */     // MIs[1] Operand 1
     /* 121732 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 121737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121739 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121739 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121742 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 121746 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121751 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121755 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121761 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121764 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121768 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121773 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121778 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121781 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121785 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121790 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121807 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121838 */     GIR_RootConstrainSelectedInstOperands,
     /* 121839 */     // GIR_Coverage, 3972,
     /* 121839 */     GIR_EraseRootFromParent_Done,
     /* 121840 */   // Label 1754: @121840
     /* 121840 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(121972), // Rule ID 3980 //
     /* 121845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121860 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121864 */     // MIs[1] Operand 1
     /* 121864 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 121869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121871 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 121878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121883 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121887 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121893 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121896 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121900 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121905 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121910 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121913 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121917 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121922 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121939 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121970 */     GIR_RootConstrainSelectedInstOperands,
     /* 121971 */     // GIR_Coverage, 3980,
     /* 121971 */     GIR_EraseRootFromParent_Done,
     /* 121972 */   // Label 1755: @121972
     /* 121972 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(122104), // Rule ID 3988 //
     /* 121977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121992 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121996 */     // MIs[1] Operand 1
     /* 121996 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 122001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122003 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 122003 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122006 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 122010 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122015 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122019 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122025 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 122028 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122032 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122037 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122042 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 122045 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122049 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122054 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122071 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 122078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122102 */     GIR_RootConstrainSelectedInstOperands,
     /* 122103 */     // GIR_Coverage, 3988,
     /* 122103 */     GIR_EraseRootFromParent_Done,
     /* 122104 */   // Label 1756: @122104
     /* 122104 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(122119), // Rule ID 2983 //
     /* 122109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122112 */     // (sext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETNBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 122112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETNBC),
     /* 122117 */     GIR_RootConstrainSelectedInstOperands,
     /* 122118 */     // GIR_Coverage, 2983,
     /* 122118 */     GIR_Done,
     /* 122119 */   // Label 1757: @122119
     /* 122119 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(122173), // Rule ID 3666 //
     /* 122124 */     // (sext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } -1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 122124 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122127 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122131 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122136 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 122139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122153 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 122156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122163 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 122165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 122171 */     GIR_RootConstrainSelectedInstOperands,
     /* 122172 */     // GIR_Coverage, 3666,
     /* 122172 */     GIR_EraseRootFromParent_Done,
     /* 122173 */   // Label 1758: @122173
     /* 122173 */   GIM_Reject,
     /* 122174 */ // Label 1694: @122174
     /* 122174 */ GIM_Reject,
     /* 122175 */ // Label 1692: @122175
     /* 122175 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(122285), // Rule ID 3032 //
     /* 122180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122190 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122194 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122198 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122202 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122206 */   // MIs[1] Operand 1
     /* 122206 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 122211 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122215 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122219 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122223 */   // MIs[2] Operand 1
     /* 122223 */   // No operand predicates
     /* 122223 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122225 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 122225 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122228 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122232 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122237 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122241 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122258 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 122265 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122270 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122283 */   GIR_RootConstrainSelectedInstOperands,
     /* 122284 */   // GIR_Coverage, 3032,
     /* 122284 */   GIR_EraseRootFromParent_Done,
     /* 122285 */ // Label 1759: @122285
     /* 122285 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(122395), // Rule ID 3048 //
     /* 122290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122300 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122304 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122308 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122312 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122316 */   // MIs[1] Operand 1
     /* 122316 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 122321 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122325 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122329 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122333 */   // MIs[2] Operand 1
     /* 122333 */   // No operand predicates
     /* 122333 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122335 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 122335 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122338 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122342 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122347 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122351 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122356 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122359 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122363 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122368 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 122375 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122380 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122393 */   GIR_RootConstrainSelectedInstOperands,
     /* 122394 */   // GIR_Coverage, 3048,
     /* 122394 */   GIR_EraseRootFromParent_Done,
     /* 122395 */ // Label 1760: @122395
     /* 122395 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(122505), // Rule ID 3056 //
     /* 122400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122410 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122414 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122418 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122422 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122426 */   // MIs[1] Operand 1
     /* 122426 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 122431 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122435 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122439 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122443 */   // MIs[2] Operand 1
     /* 122443 */   // No operand predicates
     /* 122443 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122445 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 122445 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122448 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122452 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122457 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122461 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122466 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122469 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122473 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122478 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 122485 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122490 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122503 */   GIR_RootConstrainSelectedInstOperands,
     /* 122504 */   // GIR_Coverage, 3056,
     /* 122504 */   GIR_EraseRootFromParent_Done,
     /* 122505 */ // Label 1761: @122505
     /* 122505 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(122615), // Rule ID 3128 //
     /* 122510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122520 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122524 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122528 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122532 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122536 */   // MIs[1] Operand 1
     /* 122536 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 122541 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122545 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122549 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 122553 */   // MIs[2] Operand 1
     /* 122553 */   // No operand predicates
     /* 122553 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122555 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 122555 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122558 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 122562 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122567 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122571 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122588 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 122595 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122600 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122613 */   GIR_RootConstrainSelectedInstOperands,
     /* 122614 */   // GIR_Coverage, 3128,
     /* 122614 */   GIR_EraseRootFromParent_Done,
     /* 122615 */ // Label 1762: @122615
     /* 122615 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(122725), // Rule ID 3144 //
     /* 122620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122630 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122634 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122638 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122642 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122646 */   // MIs[1] Operand 1
     /* 122646 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 122651 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122655 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122659 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 122663 */   // MIs[2] Operand 1
     /* 122663 */   // No operand predicates
     /* 122663 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122665 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 122665 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122668 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 122672 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122677 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122681 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122698 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 122705 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122710 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122723 */   GIR_RootConstrainSelectedInstOperands,
     /* 122724 */   // GIR_Coverage, 3144,
     /* 122724 */   GIR_EraseRootFromParent_Done,
     /* 122725 */ // Label 1763: @122725
     /* 122725 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(122835), // Rule ID 3152 //
     /* 122730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122740 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122744 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122748 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122752 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122756 */   // MIs[1] Operand 1
     /* 122756 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 122761 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122765 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122769 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 122773 */   // MIs[2] Operand 1
     /* 122773 */   // No operand predicates
     /* 122773 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122775 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 122775 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122778 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 122782 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122787 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122791 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122808 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 122815 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122820 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122833 */   GIR_RootConstrainSelectedInstOperands,
     /* 122834 */   // GIR_Coverage, 3152,
     /* 122834 */   GIR_EraseRootFromParent_Done,
     /* 122835 */ // Label 1764: @122835
     /* 122835 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(122985), // Rule ID 3814 //
     /* 122840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 122843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122858 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122862 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122866 */   // MIs[1] Operand 1
     /* 122866 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 122871 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122875 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122879 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122883 */   // MIs[2] Operand 1
     /* 122883 */   // No operand predicates
     /* 122883 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122885 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 122885 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122888 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122892 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122897 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122901 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122904 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122906 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 122909 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 122913 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122918 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122923 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 122926 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 122930 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122935 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122952 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 122959 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122964 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 122972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122974 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122983 */   GIR_RootConstrainSelectedInstOperands,
     /* 122984 */   // GIR_Coverage, 3814,
     /* 122984 */   GIR_EraseRootFromParent_Done,
     /* 122985 */ // Label 1765: @122985
     /* 122985 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(123135), // Rule ID 3830 //
     /* 122990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 122993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123000 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123004 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123008 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123012 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123016 */   // MIs[1] Operand 1
     /* 123016 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 123021 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123025 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123029 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 123033 */   // MIs[2] Operand 1
     /* 123033 */   // No operand predicates
     /* 123033 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123035 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123035 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123038 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 123042 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123047 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123051 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123056 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123059 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123063 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123068 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123071 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123073 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123076 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123080 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123085 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123102 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123109 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123114 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123124 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123133 */   GIR_RootConstrainSelectedInstOperands,
     /* 123134 */   // GIR_Coverage, 3830,
     /* 123134 */   GIR_EraseRootFromParent_Done,
     /* 123135 */ // Label 1766: @123135
     /* 123135 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(123285), // Rule ID 3838 //
     /* 123140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123150 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123154 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123158 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123162 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123166 */   // MIs[1] Operand 1
     /* 123166 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 123171 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123175 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123179 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 123183 */   // MIs[2] Operand 1
     /* 123183 */   // No operand predicates
     /* 123183 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123185 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123185 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123188 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 123192 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123197 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123201 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123206 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123209 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123213 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123218 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123223 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123226 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123230 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123235 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123240 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123243 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123247 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123252 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 123259 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123274 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123283 */   GIR_RootConstrainSelectedInstOperands,
     /* 123284 */   // GIR_Coverage, 3838,
     /* 123284 */   GIR_EraseRootFromParent_Done,
     /* 123285 */ // Label 1767: @123285
     /* 123285 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(123435), // Rule ID 3910 //
     /* 123290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123300 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123304 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123308 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123312 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123316 */   // MIs[1] Operand 1
     /* 123316 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 123321 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123325 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123329 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123333 */   // MIs[2] Operand 1
     /* 123333 */   // No operand predicates
     /* 123333 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123335 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123335 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123338 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123342 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123347 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123351 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123356 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123359 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123363 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123368 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123373 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123376 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123380 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123385 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123390 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123393 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123397 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123402 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 123409 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123414 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123427 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123433 */   GIR_RootConstrainSelectedInstOperands,
     /* 123434 */   // GIR_Coverage, 3910,
     /* 123434 */   GIR_EraseRootFromParent_Done,
     /* 123435 */ // Label 1768: @123435
     /* 123435 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(123585), // Rule ID 3926 //
     /* 123440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123450 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123454 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123458 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123462 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123466 */   // MIs[1] Operand 1
     /* 123466 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 123471 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123475 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123479 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123483 */   // MIs[2] Operand 1
     /* 123483 */   // No operand predicates
     /* 123483 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123485 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123485 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123488 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123492 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123497 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123501 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123506 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123509 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123513 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123518 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123523 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123526 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123530 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123535 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123552 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123559 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123564 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123577 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123580 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123583 */   GIR_RootConstrainSelectedInstOperands,
     /* 123584 */   // GIR_Coverage, 3926,
     /* 123584 */   GIR_EraseRootFromParent_Done,
     /* 123585 */ // Label 1769: @123585
     /* 123585 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(123735), // Rule ID 3934 //
     /* 123590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123600 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123604 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123608 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123612 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123616 */   // MIs[1] Operand 1
     /* 123616 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 123621 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123625 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123629 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123633 */   // MIs[2] Operand 1
     /* 123633 */   // No operand predicates
     /* 123633 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123635 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123635 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123638 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123642 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123647 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123651 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123656 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123659 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123663 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123668 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123673 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123676 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123680 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123685 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123690 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123693 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123697 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123702 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 123709 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123714 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123733 */   GIR_RootConstrainSelectedInstOperands,
     /* 123734 */   // GIR_Coverage, 3934,
     /* 123734 */   GIR_EraseRootFromParent_Done,
     /* 123735 */ // Label 1770: @123735
     /* 123735 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(123834), // Rule ID 3176 //
     /* 123740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 123743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 123758 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123762 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123766 */   // MIs[1] Operand 1
     /* 123766 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 123771 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123773 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 123773 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123776 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 123780 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123785 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123789 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 123793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123795 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123798 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123802 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123807 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 123814 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123819 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 123827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 123829 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123832 */   GIR_RootConstrainSelectedInstOperands,
     /* 123833 */   // GIR_Coverage, 3176,
     /* 123833 */   GIR_EraseRootFromParent_Done,
     /* 123834 */ // Label 1771: @123834
     /* 123834 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(123933), // Rule ID 3192 //
     /* 123839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 123842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123849 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123853 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 123857 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123861 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123865 */   // MIs[1] Operand 1
     /* 123865 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 123870 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123872 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 123872 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123875 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 123879 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123884 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123888 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 123892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123894 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123897 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123901 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123906 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123913 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123918 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 123926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 123928 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123931 */   GIR_RootConstrainSelectedInstOperands,
     /* 123932 */   // GIR_Coverage, 3192,
     /* 123932 */   GIR_EraseRootFromParent_Done,
     /* 123933 */ // Label 1772: @123933
     /* 123933 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(124032), // Rule ID 3208 //
     /* 123938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 123941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123948 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123952 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 123956 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123960 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123964 */   // MIs[1] Operand 1
     /* 123964 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 123969 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123971 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 123971 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123974 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 123978 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123983 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123987 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 123991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124005 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 124012 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124017 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124030 */   GIR_RootConstrainSelectedInstOperands,
     /* 124031 */   // GIR_Coverage, 3208,
     /* 124031 */   GIR_EraseRootFromParent_Done,
     /* 124032 */ // Label 1773: @124032
     /* 124032 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(124131), // Rule ID 3224 //
     /* 124037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124047 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124051 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124055 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124059 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124063 */   // MIs[1] Operand 1
     /* 124063 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 124068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124070 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 124070 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124073 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 124077 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124082 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124086 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124104 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 124111 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124116 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124129 */   GIR_RootConstrainSelectedInstOperands,
     /* 124130 */   // GIR_Coverage, 3224,
     /* 124130 */   GIR_EraseRootFromParent_Done,
     /* 124131 */ // Label 1774: @124131
     /* 124131 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(124230), // Rule ID 3232 //
     /* 124136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124146 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124150 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124154 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124158 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124162 */   // MIs[1] Operand 1
     /* 124162 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124167 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124169 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 124169 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124172 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124176 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124181 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124185 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124203 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 124210 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124215 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124228 */   GIR_RootConstrainSelectedInstOperands,
     /* 124229 */   // GIR_Coverage, 3232,
     /* 124229 */   GIR_EraseRootFromParent_Done,
     /* 124230 */ // Label 1775: @124230
     /* 124230 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(124329), // Rule ID 3248 //
     /* 124235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124245 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124249 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124253 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124257 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124261 */   // MIs[1] Operand 1
     /* 124261 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 124266 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124268 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 124268 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124271 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124275 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124280 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124284 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124302 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124309 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124314 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124324 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124327 */   GIR_RootConstrainSelectedInstOperands,
     /* 124328 */   // GIR_Coverage, 3248,
     /* 124328 */   GIR_EraseRootFromParent_Done,
     /* 124329 */ // Label 1776: @124329
     /* 124329 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(124428), // Rule ID 3264 //
     /* 124334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124344 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124348 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124352 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124356 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124360 */   // MIs[1] Operand 1
     /* 124360 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 124365 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124367 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 124367 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124370 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124374 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124379 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124383 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124389 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124392 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124396 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124401 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 124408 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124413 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124426 */   GIR_RootConstrainSelectedInstOperands,
     /* 124427 */   // GIR_Coverage, 3264,
     /* 124427 */   GIR_EraseRootFromParent_Done,
     /* 124428 */ // Label 1777: @124428
     /* 124428 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(124527), // Rule ID 3280 //
     /* 124433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124443 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124447 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124451 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124455 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124459 */   // MIs[1] Operand 1
     /* 124459 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 124464 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124466 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 124466 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124469 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124473 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124478 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124482 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124488 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124491 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124495 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124500 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 124507 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124512 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124525 */   GIR_RootConstrainSelectedInstOperands,
     /* 124526 */   // GIR_Coverage, 3280,
     /* 124526 */   GIR_EraseRootFromParent_Done,
     /* 124527 */ // Label 1778: @124527
     /* 124527 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(124626), // Rule ID 3288 //
     /* 124532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124542 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124546 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124550 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 124554 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 124558 */   // MIs[1] Operand 1
     /* 124558 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124563 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124565 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 124565 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124568 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 124572 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124577 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124581 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124599 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 124606 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124611 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124621 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124624 */   GIR_RootConstrainSelectedInstOperands,
     /* 124625 */   // GIR_Coverage, 3288,
     /* 124625 */   GIR_EraseRootFromParent_Done,
     /* 124626 */ // Label 1779: @124626
     /* 124626 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(124725), // Rule ID 3304 //
     /* 124631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124641 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124645 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124649 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 124653 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 124657 */   // MIs[1] Operand 1
     /* 124657 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 124662 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124664 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 124664 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124667 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 124671 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124676 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124680 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124698 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124705 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124710 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124723 */   GIR_RootConstrainSelectedInstOperands,
     /* 124724 */   // GIR_Coverage, 3304,
     /* 124724 */   GIR_EraseRootFromParent_Done,
     /* 124725 */ // Label 1780: @124725
     /* 124725 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(124824), // Rule ID 3320 //
     /* 124730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124740 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124744 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124748 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 124752 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 124756 */   // MIs[1] Operand 1
     /* 124756 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 124761 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124763 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 124763 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124766 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 124770 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124775 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124779 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124797 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 124804 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124809 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124819 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124822 */   GIR_RootConstrainSelectedInstOperands,
     /* 124823 */   // GIR_Coverage, 3320,
     /* 124823 */   GIR_EraseRootFromParent_Done,
     /* 124824 */ // Label 1781: @124824
     /* 124824 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(124923), // Rule ID 3336 //
     /* 124829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124839 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124843 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124847 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 124851 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 124855 */   // MIs[1] Operand 1
     /* 124855 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 124860 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124862 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 124862 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124865 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 124869 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124874 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124878 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124896 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 124903 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124908 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124921 */   GIR_RootConstrainSelectedInstOperands,
     /* 124922 */   // GIR_Coverage, 3336,
     /* 124922 */   GIR_EraseRootFromParent_Done,
     /* 124923 */ // Label 1782: @124923
     /* 124923 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(125062), // Rule ID 4018 //
     /* 124928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 124931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124938 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124942 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124946 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124950 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124954 */   // MIs[1] Operand 1
     /* 124954 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124959 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124961 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 124961 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124964 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 124968 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124973 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124977 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124983 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 124986 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124990 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124995 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 124998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125000 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125003 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125007 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125012 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125017 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125020 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125024 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125029 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 125036 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125041 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125051 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125057 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125060 */   GIR_RootConstrainSelectedInstOperands,
     /* 125061 */   // GIR_Coverage, 4018,
     /* 125061 */   GIR_EraseRootFromParent_Done,
     /* 125062 */ // Label 1783: @125062
     /* 125062 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(125201), // Rule ID 4050 //
     /* 125067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125077 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125081 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125085 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125089 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125093 */   // MIs[1] Operand 1
     /* 125093 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 125098 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125100 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125100 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125103 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125107 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125112 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125116 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125122 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125125 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125129 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125134 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125139 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125142 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125146 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125151 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125154 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125156 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125159 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125163 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125168 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 125175 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125180 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125190 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125193 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125199 */   GIR_RootConstrainSelectedInstOperands,
     /* 125200 */   // GIR_Coverage, 4050,
     /* 125200 */   GIR_EraseRootFromParent_Done,
     /* 125201 */ // Label 1784: @125201
     /* 125201 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(125340), // Rule ID 4082 //
     /* 125206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125216 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125220 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125224 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125228 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125232 */   // MIs[1] Operand 1
     /* 125232 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 125237 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125239 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125239 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125242 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125246 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125251 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125255 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125261 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125264 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125268 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125273 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125278 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125281 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125285 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125290 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125307 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 125314 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125319 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125329 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125338 */   GIR_RootConstrainSelectedInstOperands,
     /* 125339 */   // GIR_Coverage, 4082,
     /* 125339 */   GIR_EraseRootFromParent_Done,
     /* 125340 */ // Label 1785: @125340
     /* 125340 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(125479), // Rule ID 4114 //
     /* 125345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125355 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125363 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125367 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125371 */   // MIs[1] Operand 1
     /* 125371 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 125376 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125378 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125378 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125381 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125385 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125390 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125394 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125400 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125403 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125407 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125412 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125417 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125420 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125424 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125429 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125446 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 125453 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125474 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125477 */   GIR_RootConstrainSelectedInstOperands,
     /* 125478 */   // GIR_Coverage, 4114,
     /* 125478 */   GIR_EraseRootFromParent_Done,
     /* 125479 */ // Label 1786: @125479
     /* 125479 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(125618), // Rule ID 4130 //
     /* 125484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125494 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125498 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125502 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125506 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125510 */   // MIs[1] Operand 1
     /* 125510 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 125515 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125517 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125517 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125520 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 125524 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125529 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125533 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125539 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125542 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125546 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125551 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125556 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125559 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125563 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125568 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125585 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 125592 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125597 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125616 */   GIR_RootConstrainSelectedInstOperands,
     /* 125617 */   // GIR_Coverage, 4130,
     /* 125617 */   GIR_EraseRootFromParent_Done,
     /* 125618 */ // Label 1787: @125618
     /* 125618 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(125757), // Rule ID 4162 //
     /* 125623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125641 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125645 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125649 */   // MIs[1] Operand 1
     /* 125649 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 125654 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125656 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125656 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125659 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 125663 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125668 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125672 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125678 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125681 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125685 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125690 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125695 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125698 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125702 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125707 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125712 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125715 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125719 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125724 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 125731 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125736 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125755 */   GIR_RootConstrainSelectedInstOperands,
     /* 125756 */   // GIR_Coverage, 4162,
     /* 125756 */   GIR_EraseRootFromParent_Done,
     /* 125757 */ // Label 1788: @125757
     /* 125757 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(125896), // Rule ID 4194 //
     /* 125762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125772 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125776 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125780 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125784 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125788 */   // MIs[1] Operand 1
     /* 125788 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 125793 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125795 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125795 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125798 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 125802 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125807 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125811 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125817 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125820 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125824 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125829 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125834 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125837 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125841 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125846 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125863 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 125870 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125875 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125894 */   GIR_RootConstrainSelectedInstOperands,
     /* 125895 */   // GIR_Coverage, 4194,
     /* 125895 */   GIR_EraseRootFromParent_Done,
     /* 125896 */ // Label 1789: @125896
     /* 125896 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(126035), // Rule ID 4226 //
     /* 125901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125911 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125919 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125923 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125927 */   // MIs[1] Operand 1
     /* 125927 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 125932 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125934 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125934 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125937 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 125941 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125946 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125950 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125956 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125959 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125963 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125968 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125973 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125976 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125980 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125985 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125990 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125993 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125997 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126002 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 126009 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126014 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126033 */   GIR_RootConstrainSelectedInstOperands,
     /* 126034 */   // GIR_Coverage, 4226,
     /* 126034 */   GIR_EraseRootFromParent_Done,
     /* 126035 */ // Label 1790: @126035
     /* 126035 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(126174), // Rule ID 4256 //
     /* 126040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126050 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126054 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126058 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126062 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126066 */   // MIs[1] Operand 1
     /* 126066 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 126071 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126073 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126073 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126076 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126080 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126085 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126089 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126095 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126098 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126102 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126107 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126112 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126115 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126119 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126124 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126129 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126132 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126136 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126141 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 126148 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126153 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126169 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126172 */   GIR_RootConstrainSelectedInstOperands,
     /* 126173 */   // GIR_Coverage, 4256,
     /* 126173 */   GIR_EraseRootFromParent_Done,
     /* 126174 */ // Label 1791: @126174
     /* 126174 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(126313), // Rule ID 4288 //
     /* 126179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126189 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126193 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126197 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126201 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126205 */   // MIs[1] Operand 1
     /* 126205 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 126210 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126212 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126212 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126215 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126219 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126224 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126228 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126234 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126237 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126241 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126246 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126251 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126254 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126258 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126263 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126280 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126287 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126292 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126311 */   GIR_RootConstrainSelectedInstOperands,
     /* 126312 */   // GIR_Coverage, 4288,
     /* 126312 */   GIR_EraseRootFromParent_Done,
     /* 126313 */ // Label 1792: @126313
     /* 126313 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(126452), // Rule ID 4320 //
     /* 126318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126328 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126332 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126336 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126340 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126344 */   // MIs[1] Operand 1
     /* 126344 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 126349 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126351 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126351 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126354 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126358 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126363 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126367 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126373 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126376 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126380 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126385 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126390 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126393 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126397 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126402 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126419 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 126426 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126431 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126450 */   GIR_RootConstrainSelectedInstOperands,
     /* 126451 */   // GIR_Coverage, 4320,
     /* 126451 */   GIR_EraseRootFromParent_Done,
     /* 126452 */ // Label 1793: @126452
     /* 126452 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(126591), // Rule ID 4352 //
     /* 126457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126479 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126483 */   // MIs[1] Operand 1
     /* 126483 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 126488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126490 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126490 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126493 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126497 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126502 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126506 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126512 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126515 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126519 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126524 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126529 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126532 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126536 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126541 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126558 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 126565 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126570 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126580 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126589 */   GIR_RootConstrainSelectedInstOperands,
     /* 126590 */   // GIR_Coverage, 4352,
     /* 126590 */   GIR_EraseRootFromParent_Done,
     /* 126591 */ // Label 1794: @126591
     /* 126591 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(126730), // Rule ID 4583 //
     /* 126596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 126599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126606 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126610 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126614 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 126618 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 126622 */   // MIs[1] Operand 1
     /* 126622 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 126627 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126629 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126629 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126632 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 126636 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126641 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126645 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126651 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126654 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126658 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126663 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126668 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126671 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126675 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126680 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126697 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126704 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126709 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126728 */   GIR_RootConstrainSelectedInstOperands,
     /* 126729 */   // GIR_Coverage, 4583,
     /* 126729 */   GIR_EraseRootFromParent_Done,
     /* 126730 */ // Label 1795: @126730
     /* 126730 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(126869), // Rule ID 4615 //
     /* 126735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 126738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126745 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126749 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126753 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 126757 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 126761 */   // MIs[1] Operand 1
     /* 126761 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 126766 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126768 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126768 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126771 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 126775 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126780 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126784 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126790 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126793 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126797 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126802 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126807 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126810 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126814 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126819 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126822 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126824 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126827 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126831 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126836 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126843 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126848 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126861 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126867 */   GIR_RootConstrainSelectedInstOperands,
     /* 126868 */   // GIR_Coverage, 4615,
     /* 126868 */   GIR_EraseRootFromParent_Done,
     /* 126869 */ // Label 1796: @126869
     /* 126869 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(127008), // Rule ID 4647 //
     /* 126874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 126877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126884 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126888 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126892 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 126896 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 126900 */   // MIs[1] Operand 1
     /* 126900 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 126905 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126907 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126907 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126910 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 126914 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126919 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126923 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126929 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126932 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126936 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126941 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126946 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126949 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126953 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126958 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126963 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126966 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126970 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126975 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126982 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126987 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127000 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127006 */   GIR_RootConstrainSelectedInstOperands,
     /* 127007 */   // GIR_Coverage, 4647,
     /* 127007 */   GIR_EraseRootFromParent_Done,
     /* 127008 */ // Label 1797: @127008
     /* 127008 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(127147), // Rule ID 4691 //
     /* 127013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127023 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127027 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127031 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127035 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127039 */   // MIs[1] Operand 1
     /* 127039 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 127044 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127046 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127046 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127049 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 127053 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127058 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127062 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127068 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127071 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127075 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127080 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127085 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127088 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127092 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127097 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127114 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127121 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127126 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127145 */   GIR_RootConstrainSelectedInstOperands,
     /* 127146 */   // GIR_Coverage, 4691,
     /* 127146 */   GIR_EraseRootFromParent_Done,
     /* 127147 */ // Label 1798: @127147
     /* 127147 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(127286), // Rule ID 4723 //
     /* 127152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127170 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127174 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127178 */   // MIs[1] Operand 1
     /* 127178 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 127183 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127185 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127185 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127188 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 127192 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127197 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127201 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127207 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127210 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127214 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127219 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127224 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127227 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127231 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127236 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127253 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127260 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127265 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127275 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127278 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127284 */   GIR_RootConstrainSelectedInstOperands,
     /* 127285 */   // GIR_Coverage, 4723,
     /* 127285 */   GIR_EraseRootFromParent_Done,
     /* 127286 */ // Label 1799: @127286
     /* 127286 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(127425), // Rule ID 4755 //
     /* 127291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127301 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127305 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127309 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127313 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127317 */   // MIs[1] Operand 1
     /* 127317 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 127322 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127324 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127324 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127327 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 127331 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127336 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127340 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127346 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127349 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127353 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127358 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127363 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127366 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127370 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127375 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127392 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127399 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127404 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127420 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127423 */   GIR_RootConstrainSelectedInstOperands,
     /* 127424 */   // GIR_Coverage, 4755,
     /* 127424 */   GIR_EraseRootFromParent_Done,
     /* 127425 */ // Label 1800: @127425
     /* 127425 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(127524), // Rule ID 2978 //
     /* 127430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127440 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127444 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127448 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127452 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127456 */   // MIs[1] Operand 1
     /* 127456 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 127461 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127463 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 127463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 127470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127475 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127479 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127497 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 127504 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127519 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127522 */   GIR_RootConstrainSelectedInstOperands,
     /* 127523 */   // GIR_Coverage, 2978,
     /* 127523 */   GIR_EraseRootFromParent_Done,
     /* 127524 */ // Label 1801: @127524
     /* 127524 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(127623), // Rule ID 2992 //
     /* 127529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127539 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127543 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127547 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127551 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127555 */   // MIs[1] Operand 1
     /* 127555 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 127560 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127562 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 127562 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127565 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 127569 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127574 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127578 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127596 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 127603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127608 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127621 */   GIR_RootConstrainSelectedInstOperands,
     /* 127622 */   // GIR_Coverage, 2992,
     /* 127622 */   GIR_EraseRootFromParent_Done,
     /* 127623 */ // Label 1802: @127623
     /* 127623 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(127722), // Rule ID 3000 //
     /* 127628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127638 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127642 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127646 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127650 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127654 */   // MIs[1] Operand 1
     /* 127654 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 127659 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127661 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 127661 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127664 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 127668 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127673 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127677 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127683 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127686 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127690 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127695 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127702 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127707 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127720 */   GIR_RootConstrainSelectedInstOperands,
     /* 127721 */   // GIR_Coverage, 3000,
     /* 127721 */   GIR_EraseRootFromParent_Done,
     /* 127722 */ // Label 1803: @127722
     /* 127722 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(127821), // Rule ID 3008 //
     /* 127727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127737 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127745 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127749 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127753 */   // MIs[1] Operand 1
     /* 127753 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 127758 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127760 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 127760 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127763 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 127767 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127772 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127776 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127794 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127801 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127806 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127819 */   GIR_RootConstrainSelectedInstOperands,
     /* 127820 */   // GIR_Coverage, 3008,
     /* 127820 */   GIR_EraseRootFromParent_Done,
     /* 127821 */ // Label 1804: @127821
     /* 127821 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(127920), // Rule ID 3016 //
     /* 127826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127836 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127840 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127844 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127848 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127852 */   // MIs[1] Operand 1
     /* 127852 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 127857 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127859 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 127859 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127862 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 127866 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127871 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127875 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127893 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 127900 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127905 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127915 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127918 */   GIR_RootConstrainSelectedInstOperands,
     /* 127919 */   // GIR_Coverage, 3016,
     /* 127919 */   GIR_EraseRootFromParent_Done,
     /* 127920 */ // Label 1805: @127920
     /* 127920 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(128019), // Rule ID 3080 //
     /* 127925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127935 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127939 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127943 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127947 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127951 */   // MIs[1] Operand 1
     /* 127951 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 127956 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127958 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 127958 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127961 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 127965 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127970 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127974 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127980 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127983 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127987 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127992 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 127999 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128004 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128014 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128017 */   GIR_RootConstrainSelectedInstOperands,
     /* 128018 */   // GIR_Coverage, 3080,
     /* 128018 */   GIR_EraseRootFromParent_Done,
     /* 128019 */ // Label 1806: @128019
     /* 128019 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(128118), // Rule ID 3088 //
     /* 128024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128034 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128042 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128046 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128050 */   // MIs[1] Operand 1
     /* 128050 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 128055 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128057 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 128057 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128060 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 128064 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128069 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128073 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128079 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128082 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128086 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128091 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128098 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128103 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128113 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128116 */   GIR_RootConstrainSelectedInstOperands,
     /* 128117 */   // GIR_Coverage, 3088,
     /* 128117 */   GIR_EraseRootFromParent_Done,
     /* 128118 */ // Label 1807: @128118
     /* 128118 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(128217), // Rule ID 3096 //
     /* 128123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128133 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128137 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128141 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128145 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128149 */   // MIs[1] Operand 1
     /* 128149 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 128154 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128156 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 128156 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128159 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 128163 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128168 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128172 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128190 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128197 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128202 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128215 */   GIR_RootConstrainSelectedInstOperands,
     /* 128216 */   // GIR_Coverage, 3096,
     /* 128216 */   GIR_EraseRootFromParent_Done,
     /* 128217 */ // Label 1808: @128217
     /* 128217 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(128316), // Rule ID 3104 //
     /* 128222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128240 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128244 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128248 */   // MIs[1] Operand 1
     /* 128248 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 128253 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128255 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 128255 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128258 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 128262 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128267 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128271 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128277 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128280 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128284 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128289 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128296 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128301 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128314 */   GIR_RootConstrainSelectedInstOperands,
     /* 128315 */   // GIR_Coverage, 3104,
     /* 128315 */   GIR_EraseRootFromParent_Done,
     /* 128316 */ // Label 1809: @128316
     /* 128316 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(128415), // Rule ID 3112 //
     /* 128321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128339 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128343 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128347 */   // MIs[1] Operand 1
     /* 128347 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 128352 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128354 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 128354 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128357 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 128361 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128366 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128370 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128376 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128379 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128383 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128388 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 128395 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128400 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128413 */   GIR_RootConstrainSelectedInstOperands,
     /* 128414 */   // GIR_Coverage, 3112,
     /* 128414 */   GIR_EraseRootFromParent_Done,
     /* 128415 */ // Label 1810: @128415
     /* 128415 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(128554), // Rule ID 3862 //
     /* 128420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128430 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128434 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128438 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128442 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128446 */   // MIs[1] Operand 1
     /* 128446 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 128451 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128453 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 128453 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128456 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 128460 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128465 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128469 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128473 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128475 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 128478 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128482 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128487 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 128490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 128492 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 128495 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128499 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128504 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 128507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128509 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128512 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128516 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128521 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128528 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128533 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 128541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 128549 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 128552 */   GIR_RootConstrainSelectedInstOperands,
     /* 128553 */   // GIR_Coverage, 3862,
     /* 128553 */   GIR_EraseRootFromParent_Done,
     /* 128554 */ // Label 1811: @128554
     /* 128554 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(128693), // Rule ID 3870 //
     /* 128559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128569 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128573 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128577 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128581 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128585 */   // MIs[1] Operand 1
     /* 128585 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 128590 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128592 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 128592 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128595 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 128599 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128604 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128608 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128614 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 128617 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128621 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128626 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 128629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 128631 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 128634 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128638 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128643 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 128646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128648 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128651 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128655 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128660 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128667 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128672 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 128680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 128688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 128691 */   GIR_RootConstrainSelectedInstOperands,
     /* 128692 */   // GIR_Coverage, 3870,
     /* 128692 */   GIR_EraseRootFromParent_Done,
     /* 128693 */ // Label 1812: @128693
     /* 128693 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(128832), // Rule ID 3878 //
     /* 128698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128708 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128716 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128720 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128724 */   // MIs[1] Operand 1
     /* 128724 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 128729 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128731 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 128731 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128734 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 128738 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128743 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128747 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128753 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 128756 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128760 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128765 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 128768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 128770 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 128773 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128777 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128782 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 128785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128799 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128806 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128811 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 128819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128824 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 128827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 128830 */   GIR_RootConstrainSelectedInstOperands,
     /* 128831 */   // GIR_Coverage, 3878,
     /* 128831 */   GIR_EraseRootFromParent_Done,
     /* 128832 */ // Label 1813: @128832
     /* 128832 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(128971), // Rule ID 3886 //
     /* 128837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128847 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128855 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128859 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128863 */   // MIs[1] Operand 1
     /* 128863 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 128868 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128870 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 128870 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128873 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 128877 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128882 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128886 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128892 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 128895 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128899 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128904 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 128907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 128909 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 128912 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128916 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128921 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 128924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128938 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128945 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128950 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 128958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128960 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128963 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 128966 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 128969 */   GIR_RootConstrainSelectedInstOperands,
     /* 128970 */   // GIR_Coverage, 3886,
     /* 128970 */   GIR_EraseRootFromParent_Done,
     /* 128971 */ // Label 1814: @128971
     /* 128971 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(129110), // Rule ID 3894 //
     /* 128976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128986 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128990 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128994 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128998 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 129002 */   // MIs[1] Operand 1
     /* 129002 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 129007 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129009 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129009 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129012 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 129016 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129021 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129025 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129031 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129034 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129038 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129043 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129048 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129051 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129055 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129060 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129065 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129068 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129072 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129077 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 129084 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129089 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129102 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129108 */   GIR_RootConstrainSelectedInstOperands,
     /* 129109 */   // GIR_Coverage, 3894,
     /* 129109 */   GIR_EraseRootFromParent_Done,
     /* 129110 */ // Label 1815: @129110
     /* 129110 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(129249), // Rule ID 3958 //
     /* 129115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129125 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129129 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129133 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129137 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129141 */   // MIs[1] Operand 1
     /* 129141 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 129146 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129148 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129148 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129151 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 129155 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129160 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129164 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129170 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129173 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129177 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129182 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129187 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129190 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129194 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129199 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129216 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 129223 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129228 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129247 */   GIR_RootConstrainSelectedInstOperands,
     /* 129248 */   // GIR_Coverage, 3958,
     /* 129248 */   GIR_EraseRootFromParent_Done,
     /* 129249 */ // Label 1816: @129249
     /* 129249 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(129388), // Rule ID 3966 //
     /* 129254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129264 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129272 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129276 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129280 */   // MIs[1] Operand 1
     /* 129280 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 129285 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129287 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129287 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129290 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 129294 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129299 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129303 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129309 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129312 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129316 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129321 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129326 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129329 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129333 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129338 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129343 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129346 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129350 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129355 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 129362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129367 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129386 */   GIR_RootConstrainSelectedInstOperands,
     /* 129387 */   // GIR_Coverage, 3966,
     /* 129387 */   GIR_EraseRootFromParent_Done,
     /* 129388 */ // Label 1817: @129388
     /* 129388 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(129527), // Rule ID 3974 //
     /* 129393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129403 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129407 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129411 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129415 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129419 */   // MIs[1] Operand 1
     /* 129419 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 129424 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129426 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129426 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129429 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 129433 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129438 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129442 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129448 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129451 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129455 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129460 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129465 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129468 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129472 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129477 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129494 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 129501 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129506 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129519 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129525 */   GIR_RootConstrainSelectedInstOperands,
     /* 129526 */   // GIR_Coverage, 3974,
     /* 129526 */   GIR_EraseRootFromParent_Done,
     /* 129527 */ // Label 1818: @129527
     /* 129527 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(129666), // Rule ID 3982 //
     /* 129532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129542 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129546 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129550 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129554 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129558 */   // MIs[1] Operand 1
     /* 129558 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 129563 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129565 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129565 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129568 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 129572 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129577 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129581 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129587 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129590 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129594 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129599 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129602 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129604 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129607 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129611 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129616 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129621 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129624 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129628 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129633 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 129640 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129645 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129655 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129658 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129661 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129664 */   GIR_RootConstrainSelectedInstOperands,
     /* 129665 */   // GIR_Coverage, 3982,
     /* 129665 */   GIR_EraseRootFromParent_Done,
     /* 129666 */ // Label 1819: @129666
     /* 129666 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(129805), // Rule ID 3990 //
     /* 129671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129689 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129693 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129697 */   // MIs[1] Operand 1
     /* 129697 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 129702 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129704 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129704 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129707 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 129711 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129716 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129720 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129726 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129729 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129733 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129738 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129741 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129743 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129746 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129750 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129755 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129760 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129763 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129767 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129772 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 129779 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129784 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129797 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129800 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129803 */   GIR_RootConstrainSelectedInstOperands,
     /* 129804 */   // GIR_Coverage, 3990,
     /* 129804 */   GIR_EraseRootFromParent_Done,
     /* 129805 */ // Label 1820: @129805
     /* 129805 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(129824), // Rule ID 680 //
     /* 129810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129817 */   // (sext:{ *:[i64] } i32:{ *:[i32] }:$RST)  =>  (EXTSW_32_64:{ *:[i64] } i32:{ *:[i32] }:$RST)
     /* 129817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EXTSW_32_64),
     /* 129822 */   GIR_RootConstrainSelectedInstOperands,
     /* 129823 */   // GIR_Coverage, 680,
     /* 129823 */   GIR_Done,
     /* 129824 */ // Label 1821: @129824
     /* 129824 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(129846), // Rule ID 2984 //
     /* 129829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 129832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129839 */   // (sext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETNBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 129839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETNBC8),
     /* 129844 */   GIR_RootConstrainSelectedInstOperands,
     /* 129845 */   // GIR_Coverage, 2984,
     /* 129845 */   GIR_Done,
     /* 129846 */ // Label 1822: @129846
     /* 129846 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(129907), // Rule ID 3668 //
     /* 129851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129858 */   // (sext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } -1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 129858 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 129861 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129865 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129870 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 129873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129887 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 129890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129897 */   GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 129899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 129905 */   GIR_RootConstrainSelectedInstOperands,
     /* 129906 */   // GIR_Coverage, 3668,
     /* 129906 */   GIR_EraseRootFromParent_Done,
     /* 129907 */ // Label 1823: @129907
     /* 129907 */ GIM_Reject,
     /* 129908 */ // Label 1693: @129908
     /* 129908 */ GIM_Reject,
     /* 129909 */ // Label 25: @129909
     /* 129909 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 1828*/ GIMT_Encode4(130261),
     /* 129920 */ /*GILLT_s32*//*Label 1824*/ GIMT_Encode4(129940),
     /* 129924 */ /*GILLT_s64*//*Label 1825*/ GIMT_Encode4(130004), GIMT_Encode4(0),
     /* 129932 */ /*GILLT_v2s64*//*Label 1826*/ GIMT_Encode4(130093),
     /* 129936 */ /*GILLT_v4s32*//*Label 1827*/ GIMT_Encode4(130191),
     /* 129940 */ // Label 1824: @129940
     /* 129940 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(130003),
     /* 129945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 129952 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(129977), // Rule ID 135 //
     /* 129957 */     // MIs[0] Operand 2
     /* 129957 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 129968 */     // (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$RST, i8:{ *:[Other] })  =>  (EXTSB:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 129968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSB),
     /* 129971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 129973 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 129975 */     GIR_RootConstrainSelectedInstOperands,
     /* 129976 */     // GIR_Coverage, 135,
     /* 129976 */     GIR_EraseRootFromParent_Done,
     /* 129977 */   // Label 1830: @129977
     /* 129977 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(130002), // Rule ID 136 //
     /* 129982 */     // MIs[0] Operand 2
     /* 129982 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 129993 */     // (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$RST, i16:{ *:[Other] })  =>  (EXTSH:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 129993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSH),
     /* 129996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 129998 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130000 */     GIR_RootConstrainSelectedInstOperands,
     /* 130001 */     // GIR_Coverage, 136,
     /* 130001 */     GIR_EraseRootFromParent_Done,
     /* 130002 */   // Label 1831: @130002
     /* 130002 */   GIM_Reject,
     /* 130003 */ // Label 1829: @130003
     /* 130003 */ GIM_Reject,
     /* 130004 */ // Label 1825: @130004
     /* 130004 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(130092),
     /* 130009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 130012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130016 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(130041), // Rule ID 677 //
     /* 130021 */     // MIs[0] Operand 2
     /* 130021 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130032 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i8:{ *:[Other] })  =>  (EXTSB8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 130032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSB8),
     /* 130035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130037 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130039 */     GIR_RootConstrainSelectedInstOperands,
     /* 130040 */     // GIR_Coverage, 677,
     /* 130040 */     GIR_EraseRootFromParent_Done,
     /* 130041 */   // Label 1833: @130041
     /* 130041 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(130066), // Rule ID 678 //
     /* 130046 */     // MIs[0] Operand 2
     /* 130046 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130057 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i16:{ *:[Other] })  =>  (EXTSH8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 130057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSH8),
     /* 130060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130062 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130064 */     GIR_RootConstrainSelectedInstOperands,
     /* 130065 */     // GIR_Coverage, 678,
     /* 130065 */     GIR_EraseRootFromParent_Done,
     /* 130066 */   // Label 1834: @130066
     /* 130066 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(130091), // Rule ID 679 //
     /* 130071 */     // MIs[0] Operand 2
     /* 130071 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 130082 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i32:{ *:[Other] })  =>  (EXTSW:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 130082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSW),
     /* 130085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130087 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130089 */     GIR_RootConstrainSelectedInstOperands,
     /* 130090 */     // GIR_Coverage, 679,
     /* 130090 */     GIR_EraseRootFromParent_Done,
     /* 130091 */   // Label 1835: @130091
     /* 130091 */   GIM_Reject,
     /* 130092 */ // Label 1832: @130092
     /* 130092 */ GIM_Reject,
     /* 130093 */ // Label 1826: @130093
     /* 130093 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(130190),
     /* 130098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 130101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 130105 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(130133), // Rule ID 1450 //
     /* 130110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130113 */     // MIs[0] Operand 2
     /* 130113 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130124 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i8:{ *:[Other] })  =>  (VEXTSB2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 130124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2D),
     /* 130127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130129 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130131 */     GIR_RootConstrainSelectedInstOperands,
     /* 130132 */     // GIR_Coverage, 1450,
     /* 130132 */     GIR_EraseRootFromParent_Done,
     /* 130133 */   // Label 1837: @130133
     /* 130133 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(130161), // Rule ID 1451 //
     /* 130138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130141 */     // MIs[0] Operand 2
     /* 130141 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130152 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i16:{ *:[Other] })  =>  (VEXTSH2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 130152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2D),
     /* 130155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130157 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130159 */     GIR_RootConstrainSelectedInstOperands,
     /* 130160 */     // GIR_Coverage, 1451,
     /* 130160 */     GIR_EraseRootFromParent_Done,
     /* 130161 */   // Label 1838: @130161
     /* 130161 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(130189), // Rule ID 1452 //
     /* 130166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130169 */     // MIs[0] Operand 2
     /* 130169 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 130180 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i32:{ *:[Other] })  =>  (VEXTSW2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 130180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSW2D),
     /* 130183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130185 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130187 */     GIR_RootConstrainSelectedInstOperands,
     /* 130188 */     // GIR_Coverage, 1452,
     /* 130188 */     GIR_EraseRootFromParent_Done,
     /* 130189 */   // Label 1839: @130189
     /* 130189 */   GIM_Reject,
     /* 130190 */ // Label 1836: @130190
     /* 130190 */ GIM_Reject,
     /* 130191 */ // Label 1827: @130191
     /* 130191 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(130260),
     /* 130196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 130199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 130203 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(130231), // Rule ID 1448 //
     /* 130208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130211 */     // MIs[0] Operand 2
     /* 130211 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130222 */     // (sext_inreg:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VRB, v4i8:{ *:[Other] })  =>  (VEXTSB2W:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB)
     /* 130222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2W),
     /* 130225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130227 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130229 */     GIR_RootConstrainSelectedInstOperands,
     /* 130230 */     // GIR_Coverage, 1448,
     /* 130230 */     GIR_EraseRootFromParent_Done,
     /* 130231 */   // Label 1841: @130231
     /* 130231 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(130259), // Rule ID 1449 //
     /* 130236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130239 */     // MIs[0] Operand 2
     /* 130239 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130250 */     // (sext_inreg:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VRB, v4i16:{ *:[Other] })  =>  (VEXTSH2W:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB)
     /* 130250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2W),
     /* 130253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130255 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130257 */     GIR_RootConstrainSelectedInstOperands,
     /* 130258 */     // GIR_Coverage, 1449,
     /* 130258 */     GIR_EraseRootFromParent_Done,
     /* 130259 */   // Label 1842: @130259
     /* 130259 */   GIM_Reject,
     /* 130260 */ // Label 1840: @130260
     /* 130260 */ GIM_Reject,
     /* 130261 */ // Label 1828: @130261
     /* 130261 */ GIM_Reject,
     /* 130262 */ // Label 26: @130262
     /* 130262 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1845*/ GIMT_Encode4(151731),
     /* 130273 */ /*GILLT_s32*//*Label 1843*/ GIMT_Encode4(130281),
     /* 130277 */ /*GILLT_s64*//*Label 1844*/ GIMT_Encode4(140502),
     /* 130281 */ // Label 1843: @130281
     /* 130281 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(140501),
     /* 130286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 130289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130293 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(130405), // Rule ID 5288 //
     /* 130298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130310 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130314 */     // MIs[1] Operand 1
     /* 130314 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 130331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 130335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130343 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 130347 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130351 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130355 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130361 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130373 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130377 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 130380 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 130383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 130388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130403 */     GIR_RootConstrainSelectedInstOperands,
     /* 130404 */     // GIR_Coverage, 5288,
     /* 130404 */     GIR_EraseRootFromParent_Done,
     /* 130405 */   // Label 1847: @130405
     /* 130405 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(130544), // Rule ID 5291 //
     /* 130410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130422 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130426 */     // MIs[1] Operand 1
     /* 130426 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 130443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 130447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 130459 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130463 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130467 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130471 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130473 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 130473 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130476 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130480 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130485 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130489 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 130492 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 130495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 130504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130509 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130513 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130516 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 130519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130526 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 130533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130543 */     // GIR_Coverage, 5291,
     /* 130543 */     GIR_EraseRootFromParent_Done,
     /* 130544 */   // Label 1848: @130544
     /* 130544 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(130677), // Rule ID 5296 //
     /* 130549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130561 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130565 */     // MIs[1] Operand 1
     /* 130565 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 130570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 130582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 130586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130594 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 130598 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130602 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130606 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130612 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130612 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130615 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130619 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130624 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130628 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /* 130631 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 130634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 130643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 130661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 130669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130675 */     GIR_RootConstrainSelectedInstOperands,
     /* 130676 */     // GIR_Coverage, 5296,
     /* 130676 */     GIR_EraseRootFromParent_Done,
     /* 130677 */   // Label 1849: @130677
     /* 130677 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(130837), // Rule ID 5299 //
     /* 130682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130694 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130698 */     // MIs[1] Operand 1
     /* 130698 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 130703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 130715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 130719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130727 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 130731 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130735 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130739 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130745 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 130745 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 130748 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130752 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130757 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130761 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /* 130764 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 130767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130769 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 130772 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 130776 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130781 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130785 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 130798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130803 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130806 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 130809 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 130812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130819 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 130826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130836 */     // GIR_Coverage, 5299,
     /* 130836 */     GIR_EraseRootFromParent_Done,
     /* 130837 */   // Label 1850: @130837
     /* 130837 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(130949), // Rule ID 3769 //
     /* 130842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130854 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130858 */     // MIs[1] Operand 1
     /* 130858 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 130875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 130879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 130883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130887 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 130891 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130895 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130899 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130905 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130921 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 130924 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 130927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 130932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 130938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130947 */     GIR_RootConstrainSelectedInstOperands,
     /* 130948 */     // GIR_Coverage, 3769,
     /* 130948 */     GIR_EraseRootFromParent_Done,
     /* 130949 */   // Label 1851: @130949
     /* 130949 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(131088), // Rule ID 3772 //
     /* 130954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130966 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130970 */     // MIs[1] Operand 1
     /* 130970 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 130987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 130991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 130995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130999 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 131003 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131007 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131011 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131017 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131017 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131020 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131024 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131029 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131033 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 131036 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 131039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 131048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131053 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131057 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131070 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131087 */     // GIR_Coverage, 3772,
     /* 131087 */     GIR_EraseRootFromParent_Done,
     /* 131088 */   // Label 1852: @131088
     /* 131088 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(131221), // Rule ID 3777 //
     /* 131093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131105 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131109 */     // MIs[1] Operand 1
     /* 131109 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 131126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 131130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 131134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131138 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 131142 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131146 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131150 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131156 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131156 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131159 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131163 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131168 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131172 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /* 131175 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 131178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 131187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131192 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131196 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 131205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 131213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131219 */     GIR_RootConstrainSelectedInstOperands,
     /* 131220 */     // GIR_Coverage, 3777,
     /* 131220 */     GIR_EraseRootFromParent_Done,
     /* 131221 */   // Label 1853: @131221
     /* 131221 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(131381), // Rule ID 3780 //
     /* 131226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131238 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131242 */     // MIs[1] Operand 1
     /* 131242 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 131259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 131263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 131267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131271 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 131275 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131279 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131283 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131289 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131289 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131292 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131296 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131301 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131305 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /* 131308 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 131311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131313 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 131316 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 131320 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131325 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131329 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 131342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131350 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 131353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131363 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131380 */     // GIR_Coverage, 3780,
     /* 131380 */     GIR_EraseRootFromParent_Done,
     /* 131381 */   // Label 1854: @131381
     /* 131381 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(131450), // Rule ID 3689 //
     /* 131386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131398 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131402 */     // MIs[1] Operand 1
     /* 131402 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131407 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131413 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 131420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 131434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /* 131442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131448 */     GIR_RootConstrainSelectedInstOperands,
     /* 131449 */     // GIR_Coverage, 3689,
     /* 131449 */     GIR_EraseRootFromParent_Done,
     /* 131450 */   // Label 1855: @131450
     /* 131450 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(131546), // Rule ID 3692 //
     /* 131455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131467 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131471 */     // MIs[1] Operand 1
     /* 131471 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131476 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131482 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 131485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 131489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131494 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 131507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131512 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131515 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /* 131518 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131528 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131545 */     // GIR_Coverage, 3692,
     /* 131545 */     GIR_EraseRootFromParent_Done,
     /* 131546 */   // Label 1856: @131546
     /* 131546 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(131653), // Rule ID 3697 //
     /* 131551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131563 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131567 */     // MIs[1] Operand 1
     /* 131567 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131572 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131578 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131578 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131581 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 131585 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131590 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131596 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131599 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 131603 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131608 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 131621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131626 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131629 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 131632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 131637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /* 131645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131651 */     GIR_RootConstrainSelectedInstOperands,
     /* 131652 */     // GIR_Coverage, 3697,
     /* 131652 */     GIR_EraseRootFromParent_Done,
     /* 131653 */   // Label 1857: @131653
     /* 131653 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(131787), // Rule ID 3700 //
     /* 131658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131670 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131674 */     // MIs[1] Operand 1
     /* 131674 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131679 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131685 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131685 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 131688 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 131692 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131697 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 131703 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 131706 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 131710 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131715 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131721 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 131724 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 131728 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131733 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131736 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 131739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 131748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131753 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131756 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /* 131759 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131769 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131786 */     // GIR_Coverage, 3700,
     /* 131786 */     GIR_EraseRootFromParent_Done,
     /* 131787 */   // Label 1858: @131787
     /* 131787 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(131839), // Rule ID 3705 //
     /* 131792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131804 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131808 */     // MIs[1] Operand 1
     /* 131808 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 131813 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131819 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 131822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 131831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131837 */     GIR_RootConstrainSelectedInstOperands,
     /* 131838 */     // GIR_Coverage, 3705,
     /* 131838 */     GIR_EraseRootFromParent_Done,
     /* 131839 */   // Label 1859: @131839
     /* 131839 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(131918), // Rule ID 3708 //
     /* 131844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131856 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131860 */     // MIs[1] Operand 1
     /* 131860 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 131865 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131871 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 131878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 131890 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131900 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131917 */     // GIR_Coverage, 3708,
     /* 131917 */     GIR_EraseRootFromParent_Done,
     /* 131918 */   // Label 1860: @131918
     /* 131918 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(131991), // Rule ID 3713 //
     /* 131923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131935 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131939 */     // MIs[1] Operand 1
     /* 131939 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 131944 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131950 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 131957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 131975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 131983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131989 */     GIR_RootConstrainSelectedInstOperands,
     /* 131990 */     // GIR_Coverage, 3713,
     /* 131990 */     GIR_EraseRootFromParent_Done,
     /* 131991 */   // Label 1861: @131991
     /* 131991 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(132091), // Rule ID 3716 //
     /* 131996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132008 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132012 */     // MIs[1] Operand 1
     /* 132012 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 132017 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132023 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132023 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132026 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 132030 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132035 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132039 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132057 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132063 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132073 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132090 */     // GIR_Coverage, 3716,
     /* 132090 */     GIR_EraseRootFromParent_Done,
     /* 132091 */   // Label 1862: @132091
     /* 132091 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(132181), // Rule ID 3721 //
     /* 132096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132108 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132112 */     // MIs[1] Operand 1
     /* 132112 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132117 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132123 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132123 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132126 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 132130 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132135 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 132148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132153 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132179 */     GIR_RootConstrainSelectedInstOperands,
     /* 132180 */     // GIR_Coverage, 3721,
     /* 132180 */     GIR_EraseRootFromParent_Done,
     /* 132181 */   // Label 1863: @132181
     /* 132181 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(132298), // Rule ID 3724 //
     /* 132186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132198 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132202 */     // MIs[1] Operand 1
     /* 132202 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132213 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132213 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132216 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 132220 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132225 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132231 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132234 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 132238 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132243 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132246 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132264 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132267 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132270 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132280 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132292 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132297 */     // GIR_Coverage, 3724,
     /* 132297 */     GIR_EraseRootFromParent_Done,
     /* 132298 */   // Label 1864: @132298
     /* 132298 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(132388), // Rule ID 3729 //
     /* 132303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132315 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132319 */     // MIs[1] Operand 1
     /* 132319 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 132324 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132330 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132330 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132333 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 132337 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132342 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 132355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132386 */     GIR_RootConstrainSelectedInstOperands,
     /* 132387 */     // GIR_Coverage, 3729,
     /* 132387 */     GIR_EraseRootFromParent_Done,
     /* 132388 */   // Label 1865: @132388
     /* 132388 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(132505), // Rule ID 3732 //
     /* 132393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132405 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132409 */     // MIs[1] Operand 1
     /* 132409 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 132414 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132420 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132420 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132423 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 132427 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132432 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132438 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132441 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 132445 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132450 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132454 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132471 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132474 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132477 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132487 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132499 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132504 */     // GIR_Coverage, 3732,
     /* 132504 */     GIR_EraseRootFromParent_Done,
     /* 132505 */   // Label 1866: @132505
     /* 132505 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(132598), // Rule ID 3737 //
     /* 132510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132522 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132526 */     // MIs[1] Operand 1
     /* 132526 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 132531 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132537 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132537 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132540 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 132544 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132549 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132553 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 132556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 132565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132574 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132596 */     GIR_RootConstrainSelectedInstOperands,
     /* 132597 */     // GIR_Coverage, 3737,
     /* 132597 */     GIR_EraseRootFromParent_Done,
     /* 132598 */   // Label 1867: @132598
     /* 132598 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(132718), // Rule ID 3740 //
     /* 132603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132615 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132619 */     // MIs[1] Operand 1
     /* 132619 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 132624 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132630 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132630 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132633 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 132637 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132642 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132646 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 132649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132651 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132654 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 132658 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132663 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132667 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132687 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132690 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132700 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132717 */     // GIR_Coverage, 3740,
     /* 132717 */     GIR_EraseRootFromParent_Done,
     /* 132718 */   // Label 1868: @132718
     /* 132718 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(132811), // Rule ID 3745 //
     /* 132723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132735 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132739 */     // MIs[1] Operand 1
     /* 132739 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 132744 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132750 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132750 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132753 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 132757 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132762 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132766 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 132769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 132778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132783 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132787 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132809 */     GIR_RootConstrainSelectedInstOperands,
     /* 132810 */     // GIR_Coverage, 3745,
     /* 132810 */     GIR_EraseRootFromParent_Done,
     /* 132811 */   // Label 1869: @132811
     /* 132811 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(132931), // Rule ID 3748 //
     /* 132816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132828 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132832 */     // MIs[1] Operand 1
     /* 132832 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 132837 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132843 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132843 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132846 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 132850 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132855 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132859 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 132862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132864 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132867 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 132871 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132876 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132880 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132897 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132903 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132913 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132930 */     // GIR_Coverage, 3748,
     /* 132930 */     GIR_EraseRootFromParent_Done,
     /* 132931 */   // Label 1870: @132931
     /* 132931 */   GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(133004), // Rule ID 3753 //
     /* 132936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132948 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132952 */     // MIs[1] Operand 1
     /* 132952 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132957 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132963 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 132970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133002 */     GIR_RootConstrainSelectedInstOperands,
     /* 133003 */     // GIR_Coverage, 3753,
     /* 133003 */     GIR_EraseRootFromParent_Done,
     /* 133004 */   // Label 1871: @133004
     /* 133004 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(133104), // Rule ID 3756 //
     /* 133009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133021 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133025 */     // MIs[1] Operand 1
     /* 133025 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 133030 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133036 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 133036 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 133039 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 133043 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133048 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133052 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 133061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 133065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133070 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133073 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 133076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 133079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133086 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 133093 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 133098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 133103 */     // GIR_Coverage, 3756,
     /* 133103 */     GIR_EraseRootFromParent_Done,
     /* 133104 */   // Label 1872: @133104
     /* 133104 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(133156), // Rule ID 3761 //
     /* 133109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133121 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133125 */     // MIs[1] Operand 1
     /* 133125 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133130 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133136 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 133136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 133139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 133141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133154 */     GIR_RootConstrainSelectedInstOperands,
     /* 133155 */     // GIR_Coverage, 3761,
     /* 133155 */     GIR_EraseRootFromParent_Done,
     /* 133156 */   // Label 1873: @133156
     /* 133156 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(133235), // Rule ID 3764 //
     /* 133161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133173 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133177 */     // MIs[1] Operand 1
     /* 133177 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133182 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133188 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 133188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 133191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 133195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133204 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 133207 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 133210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133217 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 133224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 133229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 133234 */     // GIR_Coverage, 3764,
     /* 133234 */     GIR_EraseRootFromParent_Done,
     /* 133235 */   // Label 1874: @133235
     /* 133235 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(133338), // Rule ID 3029 //
     /* 133240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133255 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133259 */     // MIs[1] Operand 1
     /* 133259 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133272 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133276 */     // MIs[2] Operand 1
     /* 133276 */     // No operand predicates
     /* 133276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133278 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 133278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133290 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133311 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 133318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133336 */     GIR_RootConstrainSelectedInstOperands,
     /* 133337 */     // GIR_Coverage, 3029,
     /* 133337 */     GIR_EraseRootFromParent_Done,
     /* 133338 */   // Label 1875: @133338
     /* 133338 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(133441), // Rule ID 3045 //
     /* 133343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133358 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133362 */     // MIs[1] Operand 1
     /* 133362 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133375 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133379 */     // MIs[2] Operand 1
     /* 133379 */     // No operand predicates
     /* 133379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133381 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 133381 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133384 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133388 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133393 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133414 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 133421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133439 */     GIR_RootConstrainSelectedInstOperands,
     /* 133440 */     // GIR_Coverage, 3045,
     /* 133440 */     GIR_EraseRootFromParent_Done,
     /* 133441 */   // Label 1876: @133441
     /* 133441 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(133544), // Rule ID 3053 //
     /* 133446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133461 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133465 */     // MIs[1] Operand 1
     /* 133465 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 133470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133478 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133482 */     // MIs[2] Operand 1
     /* 133482 */     // No operand predicates
     /* 133482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133484 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 133484 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133487 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133491 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133496 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133517 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 133524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133542 */     GIR_RootConstrainSelectedInstOperands,
     /* 133543 */     // GIR_Coverage, 3053,
     /* 133543 */     GIR_EraseRootFromParent_Done,
     /* 133544 */   // Label 1877: @133544
     /* 133544 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(133647), // Rule ID 3125 //
     /* 133549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133564 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133568 */     // MIs[1] Operand 1
     /* 133568 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 133585 */     // MIs[2] Operand 1
     /* 133585 */     // No operand predicates
     /* 133585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133587 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 133587 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133590 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 133594 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133599 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133620 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 133627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133645 */     GIR_RootConstrainSelectedInstOperands,
     /* 133646 */     // GIR_Coverage, 3125,
     /* 133646 */     GIR_EraseRootFromParent_Done,
     /* 133647 */   // Label 1878: @133647
     /* 133647 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(133750), // Rule ID 3141 //
     /* 133652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133671 */     // MIs[1] Operand 1
     /* 133671 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133684 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 133688 */     // MIs[2] Operand 1
     /* 133688 */     // No operand predicates
     /* 133688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133690 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 133690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 133697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133702 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133723 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 133730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133748 */     GIR_RootConstrainSelectedInstOperands,
     /* 133749 */     // GIR_Coverage, 3141,
     /* 133749 */     GIR_EraseRootFromParent_Done,
     /* 133750 */   // Label 1879: @133750
     /* 133750 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(133853), // Rule ID 3149 //
     /* 133755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133770 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133774 */     // MIs[1] Operand 1
     /* 133774 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 133779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133787 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 133791 */     // MIs[2] Operand 1
     /* 133791 */     // No operand predicates
     /* 133791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133793 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 133793 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133796 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 133800 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133805 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133826 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 133833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133851 */     GIR_RootConstrainSelectedInstOperands,
     /* 133852 */     // GIR_Coverage, 3149,
     /* 133852 */     GIR_EraseRootFromParent_Done,
     /* 133853 */   // Label 1880: @133853
     /* 133853 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(133996), // Rule ID 3811 //
     /* 133858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 133861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133873 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133877 */     // MIs[1] Operand 1
     /* 133877 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133890 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133894 */     // MIs[2] Operand 1
     /* 133894 */     // No operand predicates
     /* 133894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133896 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 133896 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133899 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133903 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133908 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133917 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 133920 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133924 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133929 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 133932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133934 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 133937 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133941 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133946 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 133949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133963 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 133970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 133983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 133991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 133994 */     GIR_RootConstrainSelectedInstOperands,
     /* 133995 */     // GIR_Coverage, 3811,
     /* 133995 */     GIR_EraseRootFromParent_Done,
     /* 133996 */   // Label 1881: @133996
     /* 133996 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(134139), // Rule ID 3827 //
     /* 134001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134016 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134020 */     // MIs[1] Operand 1
     /* 134020 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 134025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134033 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 134037 */     // MIs[2] Operand 1
     /* 134037 */     // No operand predicates
     /* 134037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134039 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 134046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134051 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134060 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134063 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134067 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134072 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134077 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134080 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134084 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134089 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134106 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134137 */     GIR_RootConstrainSelectedInstOperands,
     /* 134138 */     // GIR_Coverage, 3827,
     /* 134138 */     GIR_EraseRootFromParent_Done,
     /* 134139 */   // Label 1882: @134139
     /* 134139 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(134282), // Rule ID 3835 //
     /* 134144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134159 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134163 */     // MIs[1] Operand 1
     /* 134163 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 134168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134176 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 134180 */     // MIs[2] Operand 1
     /* 134180 */     // No operand predicates
     /* 134180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134182 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134182 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134185 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 134189 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134194 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134203 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134206 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134210 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134215 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134220 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134223 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134227 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134232 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134249 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 134256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134280 */     GIR_RootConstrainSelectedInstOperands,
     /* 134281 */     // GIR_Coverage, 3835,
     /* 134281 */     GIR_EraseRootFromParent_Done,
     /* 134282 */   // Label 1883: @134282
     /* 134282 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(134425), // Rule ID 3907 //
     /* 134287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134302 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134306 */     // MIs[1] Operand 1
     /* 134306 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 134311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134319 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134323 */     // MIs[2] Operand 1
     /* 134323 */     // No operand predicates
     /* 134323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134325 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134325 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134328 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134332 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134337 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134346 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134349 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134353 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134358 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134363 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134366 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134370 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134375 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134392 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 134399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134423 */     GIR_RootConstrainSelectedInstOperands,
     /* 134424 */     // GIR_Coverage, 3907,
     /* 134424 */     GIR_EraseRootFromParent_Done,
     /* 134425 */   // Label 1884: @134425
     /* 134425 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(134568), // Rule ID 3923 //
     /* 134430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134445 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134449 */     // MIs[1] Operand 1
     /* 134449 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 134454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134462 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134466 */     // MIs[2] Operand 1
     /* 134466 */     // No operand predicates
     /* 134466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134468 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134468 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134471 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134475 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134480 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134489 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134492 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134496 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134501 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134506 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134509 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134513 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134518 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134535 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134566 */     GIR_RootConstrainSelectedInstOperands,
     /* 134567 */     // GIR_Coverage, 3923,
     /* 134567 */     GIR_EraseRootFromParent_Done,
     /* 134568 */   // Label 1885: @134568
     /* 134568 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(134711), // Rule ID 3931 //
     /* 134573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134588 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134592 */     // MIs[1] Operand 1
     /* 134592 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 134597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134605 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134609 */     // MIs[2] Operand 1
     /* 134609 */     // No operand predicates
     /* 134609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134611 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134611 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134614 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134618 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134623 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134632 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134635 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134639 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134644 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134649 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134652 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134656 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134661 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134678 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 134685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134709 */     GIR_RootConstrainSelectedInstOperands,
     /* 134710 */     // GIR_Coverage, 3931,
     /* 134710 */     GIR_EraseRootFromParent_Done,
     /* 134711 */   // Label 1886: @134711
     /* 134711 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(134803), // Rule ID 3173 //
     /* 134716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 134719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134731 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134735 */     // MIs[1] Operand 1
     /* 134735 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 134740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134742 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 134742 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134745 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 134749 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134754 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134758 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 134762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134776 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 134783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 134796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 134798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134801 */     GIR_RootConstrainSelectedInstOperands,
     /* 134802 */     // GIR_Coverage, 3173,
     /* 134802 */     GIR_EraseRootFromParent_Done,
     /* 134803 */   // Label 1887: @134803
     /* 134803 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(134895), // Rule ID 3189 //
     /* 134808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 134811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134823 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134827 */     // MIs[1] Operand 1
     /* 134827 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 134832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134834 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 134834 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134837 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 134841 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134846 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134850 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 134854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134868 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 134888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 134890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134893 */     GIR_RootConstrainSelectedInstOperands,
     /* 134894 */     // GIR_Coverage, 3189,
     /* 134894 */     GIR_EraseRootFromParent_Done,
     /* 134895 */   // Label 1888: @134895
     /* 134895 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(134987), // Rule ID 3205 //
     /* 134900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 134903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134915 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134919 */     // MIs[1] Operand 1
     /* 134919 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 134924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134926 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 134926 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134929 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 134933 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134938 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134942 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 134946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134960 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 134967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 134980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 134982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134985 */     GIR_RootConstrainSelectedInstOperands,
     /* 134986 */     // GIR_Coverage, 3205,
     /* 134986 */     GIR_EraseRootFromParent_Done,
     /* 134987 */   // Label 1889: @134987
     /* 134987 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(135079), // Rule ID 3221 //
     /* 134992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 134995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135007 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135011 */     // MIs[1] Operand 1
     /* 135011 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 135016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135018 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 135018 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135021 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135025 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135030 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135034 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135052 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 135059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135077 */     GIR_RootConstrainSelectedInstOperands,
     /* 135078 */     // GIR_Coverage, 3221,
     /* 135078 */     GIR_EraseRootFromParent_Done,
     /* 135079 */   // Label 1890: @135079
     /* 135079 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(135171), // Rule ID 3229 //
     /* 135084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135099 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135103 */     // MIs[1] Operand 1
     /* 135103 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 135108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135110 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 135110 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135122 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135126 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135144 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135169 */     GIR_RootConstrainSelectedInstOperands,
     /* 135170 */     // GIR_Coverage, 3229,
     /* 135170 */     GIR_EraseRootFromParent_Done,
     /* 135171 */   // Label 1891: @135171
     /* 135171 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(135263), // Rule ID 3245 //
     /* 135176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135191 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135195 */     // MIs[1] Operand 1
     /* 135195 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135202 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 135202 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135205 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135209 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135214 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135218 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135236 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135261 */     GIR_RootConstrainSelectedInstOperands,
     /* 135262 */     // GIR_Coverage, 3245,
     /* 135262 */     GIR_EraseRootFromParent_Done,
     /* 135263 */   // Label 1892: @135263
     /* 135263 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(135355), // Rule ID 3261 //
     /* 135268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135283 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135287 */     // MIs[1] Operand 1
     /* 135287 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 135292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135294 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 135294 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135297 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135301 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135306 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135310 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135328 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 135335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135353 */     GIR_RootConstrainSelectedInstOperands,
     /* 135354 */     // GIR_Coverage, 3261,
     /* 135354 */     GIR_EraseRootFromParent_Done,
     /* 135355 */   // Label 1893: @135355
     /* 135355 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(135447), // Rule ID 3277 //
     /* 135360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135375 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135379 */     // MIs[1] Operand 1
     /* 135379 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 135384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135386 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 135386 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135389 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135393 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135398 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135402 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135420 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 135427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135445 */     GIR_RootConstrainSelectedInstOperands,
     /* 135446 */     // GIR_Coverage, 3277,
     /* 135446 */     GIR_EraseRootFromParent_Done,
     /* 135447 */   // Label 1894: @135447
     /* 135447 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(135539), // Rule ID 3285 //
     /* 135452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135467 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135471 */     // MIs[1] Operand 1
     /* 135471 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 135476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135478 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 135478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135490 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135494 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135512 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135537 */     GIR_RootConstrainSelectedInstOperands,
     /* 135538 */     // GIR_Coverage, 3285,
     /* 135538 */     GIR_EraseRootFromParent_Done,
     /* 135539 */   // Label 1895: @135539
     /* 135539 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(135631), // Rule ID 3301 //
     /* 135544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135559 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135563 */     // MIs[1] Operand 1
     /* 135563 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135570 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 135570 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135573 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135577 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135582 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135586 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135604 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135629 */     GIR_RootConstrainSelectedInstOperands,
     /* 135630 */     // GIR_Coverage, 3301,
     /* 135630 */     GIR_EraseRootFromParent_Done,
     /* 135631 */   // Label 1896: @135631
     /* 135631 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(135723), // Rule ID 3317 //
     /* 135636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135651 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135655 */     // MIs[1] Operand 1
     /* 135655 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 135660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135662 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 135662 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135665 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135669 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135674 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135696 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 135703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135721 */     GIR_RootConstrainSelectedInstOperands,
     /* 135722 */     // GIR_Coverage, 3317,
     /* 135722 */     GIR_EraseRootFromParent_Done,
     /* 135723 */   // Label 1897: @135723
     /* 135723 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(135815), // Rule ID 3333 //
     /* 135728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135743 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135747 */     // MIs[1] Operand 1
     /* 135747 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 135752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135754 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 135754 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135757 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135761 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135766 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135770 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135788 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 135795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135813 */     GIR_RootConstrainSelectedInstOperands,
     /* 135814 */     // GIR_Coverage, 3333,
     /* 135814 */     GIR_EraseRootFromParent_Done,
     /* 135815 */   // Label 1898: @135815
     /* 135815 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(135947), // Rule ID 4012 //
     /* 135820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 135823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135835 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135839 */     // MIs[1] Operand 1
     /* 135839 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 135844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135846 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 135846 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135849 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135853 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135858 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135862 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135868 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 135871 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135875 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135880 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 135883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135885 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 135888 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135892 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135897 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 135900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135914 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 135934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 135942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 135945 */     GIR_RootConstrainSelectedInstOperands,
     /* 135946 */     // GIR_Coverage, 4012,
     /* 135946 */     GIR_EraseRootFromParent_Done,
     /* 135947 */   // Label 1899: @135947
     /* 135947 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(136079), // Rule ID 4044 //
     /* 135952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 135955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135967 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135971 */     // MIs[1] Operand 1
     /* 135971 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135978 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 135978 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135981 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135985 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135990 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135994 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136000 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136003 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136007 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136012 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136017 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136020 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136024 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136029 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136046 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 136053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136077 */     GIR_RootConstrainSelectedInstOperands,
     /* 136078 */     // GIR_Coverage, 4044,
     /* 136078 */     GIR_EraseRootFromParent_Done,
     /* 136079 */   // Label 1900: @136079
     /* 136079 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(136211), // Rule ID 4076 //
     /* 136084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136099 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136103 */     // MIs[1] Operand 1
     /* 136103 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 136108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136110 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136110 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 136117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136122 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136126 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136132 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136135 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136139 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136144 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136149 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136152 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136156 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136161 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136178 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 136185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136209 */     GIR_RootConstrainSelectedInstOperands,
     /* 136210 */     // GIR_Coverage, 4076,
     /* 136210 */     GIR_EraseRootFromParent_Done,
     /* 136211 */   // Label 1901: @136211
     /* 136211 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(136343), // Rule ID 4108 //
     /* 136216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136231 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136235 */     // MIs[1] Operand 1
     /* 136235 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 136240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136242 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136242 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136245 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 136249 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136254 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136258 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136264 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136267 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136271 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136276 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136281 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136284 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136288 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136293 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136310 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 136317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136341 */     GIR_RootConstrainSelectedInstOperands,
     /* 136342 */     // GIR_Coverage, 4108,
     /* 136342 */     GIR_EraseRootFromParent_Done,
     /* 136343 */   // Label 1902: @136343
     /* 136343 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(136475), // Rule ID 4124 //
     /* 136348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136363 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136367 */     // MIs[1] Operand 1
     /* 136367 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 136372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136374 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136374 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136377 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136381 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136386 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136390 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136396 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136399 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136403 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136408 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136413 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136416 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136420 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136425 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136442 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 136449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136473 */     GIR_RootConstrainSelectedInstOperands,
     /* 136474 */     // GIR_Coverage, 4124,
     /* 136474 */     GIR_EraseRootFromParent_Done,
     /* 136475 */   // Label 1903: @136475
     /* 136475 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(136607), // Rule ID 4156 //
     /* 136480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136495 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136499 */     // MIs[1] Operand 1
     /* 136499 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 136504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136506 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136518 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136522 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136528 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136531 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136535 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136540 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136545 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136548 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136552 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136557 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136574 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 136581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136605 */     GIR_RootConstrainSelectedInstOperands,
     /* 136606 */     // GIR_Coverage, 4156,
     /* 136606 */     GIR_EraseRootFromParent_Done,
     /* 136607 */   // Label 1904: @136607
     /* 136607 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(136739), // Rule ID 4188 //
     /* 136612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136627 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136631 */     // MIs[1] Operand 1
     /* 136631 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 136636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136638 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136638 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136641 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136645 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136650 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136654 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136660 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136663 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136667 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136672 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136677 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136680 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136684 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136689 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136706 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 136713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136737 */     GIR_RootConstrainSelectedInstOperands,
     /* 136738 */     // GIR_Coverage, 4188,
     /* 136738 */     GIR_EraseRootFromParent_Done,
     /* 136739 */   // Label 1905: @136739
     /* 136739 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(136871), // Rule ID 4220 //
     /* 136744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136759 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136763 */     // MIs[1] Operand 1
     /* 136763 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 136768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136770 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136770 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136773 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136777 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136782 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136786 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136792 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136795 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136799 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136804 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136809 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136812 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136816 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136821 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136838 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 136845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136869 */     GIR_RootConstrainSelectedInstOperands,
     /* 136870 */     // GIR_Coverage, 4220,
     /* 136870 */     GIR_EraseRootFromParent_Done,
     /* 136871 */   // Label 1906: @136871
     /* 136871 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(137003), // Rule ID 4250 //
     /* 136876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 136891 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 136895 */     // MIs[1] Operand 1
     /* 136895 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 136900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136902 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136902 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136905 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 136909 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136914 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136918 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136924 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136927 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136931 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136936 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136941 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136944 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136948 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136953 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136970 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 136977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137001 */     GIR_RootConstrainSelectedInstOperands,
     /* 137002 */     // GIR_Coverage, 4250,
     /* 137002 */     GIR_EraseRootFromParent_Done,
     /* 137003 */   // Label 1907: @137003
     /* 137003 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(137135), // Rule ID 4282 //
     /* 137008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137023 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137027 */     // MIs[1] Operand 1
     /* 137027 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 137032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137034 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137034 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137037 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137041 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137046 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137056 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137059 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137063 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137068 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137073 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137076 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137080 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137085 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137102 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137133 */     GIR_RootConstrainSelectedInstOperands,
     /* 137134 */     // GIR_Coverage, 4282,
     /* 137134 */     GIR_EraseRootFromParent_Done,
     /* 137135 */   // Label 1908: @137135
     /* 137135 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(137267), // Rule ID 4314 //
     /* 137140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137155 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137159 */     // MIs[1] Operand 1
     /* 137159 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 137164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137166 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137166 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137169 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137173 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137178 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137182 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137188 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137191 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137195 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137200 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137205 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137208 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137212 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137217 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137234 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 137241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137265 */     GIR_RootConstrainSelectedInstOperands,
     /* 137266 */     // GIR_Coverage, 4314,
     /* 137266 */     GIR_EraseRootFromParent_Done,
     /* 137267 */   // Label 1909: @137267
     /* 137267 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(137399), // Rule ID 4346 //
     /* 137272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137287 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137291 */     // MIs[1] Operand 1
     /* 137291 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 137296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137298 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137298 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137301 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137305 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137310 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137314 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137320 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137323 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137327 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137332 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137337 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137340 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137344 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137349 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137366 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 137373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137397 */     GIR_RootConstrainSelectedInstOperands,
     /* 137398 */     // GIR_Coverage, 4346,
     /* 137398 */     GIR_EraseRootFromParent_Done,
     /* 137399 */   // Label 1910: @137399
     /* 137399 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(137531), // Rule ID 4577 //
     /* 137404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 137419 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 137423 */     // MIs[1] Operand 1
     /* 137423 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 137428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137430 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137430 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137433 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 137437 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137442 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137446 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137452 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137455 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137459 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137464 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137469 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137472 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137476 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137481 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137498 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137529 */     GIR_RootConstrainSelectedInstOperands,
     /* 137530 */     // GIR_Coverage, 4577,
     /* 137530 */     GIR_EraseRootFromParent_Done,
     /* 137531 */   // Label 1911: @137531
     /* 137531 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(137663), // Rule ID 4609 //
     /* 137536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 137551 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 137555 */     // MIs[1] Operand 1
     /* 137555 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 137560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137562 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 137569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137578 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137584 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137587 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137591 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137596 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137601 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137604 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137608 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137613 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137630 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137661 */     GIR_RootConstrainSelectedInstOperands,
     /* 137662 */     // GIR_Coverage, 4609,
     /* 137662 */     GIR_EraseRootFromParent_Done,
     /* 137663 */   // Label 1912: @137663
     /* 137663 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(137795), // Rule ID 4641 //
     /* 137668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 137683 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 137687 */     // MIs[1] Operand 1
     /* 137687 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 137692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137694 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137694 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137697 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 137701 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137706 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137710 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137716 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137719 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137723 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137728 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137733 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137736 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137740 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137745 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137762 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137793 */     GIR_RootConstrainSelectedInstOperands,
     /* 137794 */     // GIR_Coverage, 4641,
     /* 137794 */     GIR_EraseRootFromParent_Done,
     /* 137795 */   // Label 1913: @137795
     /* 137795 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(137927), // Rule ID 4685 //
     /* 137800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137815 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 137819 */     // MIs[1] Operand 1
     /* 137819 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 137824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137826 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137826 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137829 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 137833 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137838 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137842 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137848 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137851 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137855 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137860 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137865 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137868 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137872 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137877 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137894 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137925 */     GIR_RootConstrainSelectedInstOperands,
     /* 137926 */     // GIR_Coverage, 4685,
     /* 137926 */     GIR_EraseRootFromParent_Done,
     /* 137927 */   // Label 1914: @137927
     /* 137927 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(138059), // Rule ID 4717 //
     /* 137932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137947 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 137951 */     // MIs[1] Operand 1
     /* 137951 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 137956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137958 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137958 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137961 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 137965 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137970 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137974 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137980 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137983 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137987 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137992 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137997 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138000 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138004 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138009 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 138012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138026 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 138046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 138054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 138057 */     GIR_RootConstrainSelectedInstOperands,
     /* 138058 */     // GIR_Coverage, 4717,
     /* 138058 */     GIR_EraseRootFromParent_Done,
     /* 138059 */   // Label 1915: @138059
     /* 138059 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(138191), // Rule ID 4749 //
     /* 138064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 138067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 138075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138079 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138083 */     // MIs[1] Operand 1
     /* 138083 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 138088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138090 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 138090 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138093 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 138097 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138102 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138106 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138112 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 138115 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138119 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138124 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 138127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138129 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138132 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138136 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138141 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 138144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138158 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 138178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 138186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 138189 */     GIR_RootConstrainSelectedInstOperands,
     /* 138190 */     // GIR_Coverage, 4749,
     /* 138190 */     GIR_EraseRootFromParent_Done,
     /* 138191 */   // Label 1916: @138191
     /* 138191 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(138283), // Rule ID 2975 //
     /* 138196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138211 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138215 */     // MIs[1] Operand 1
     /* 138215 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 138220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138222 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 138222 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138225 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 138229 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138234 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138238 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138256 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 138263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138281 */     GIR_RootConstrainSelectedInstOperands,
     /* 138282 */     // GIR_Coverage, 2975,
     /* 138282 */     GIR_EraseRootFromParent_Done,
     /* 138283 */   // Label 1917: @138283
     /* 138283 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(138375), // Rule ID 2989 //
     /* 138288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138303 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138307 */     // MIs[1] Operand 1
     /* 138307 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 138312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138314 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 138314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 138321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138326 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138330 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138348 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 138355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138373 */     GIR_RootConstrainSelectedInstOperands,
     /* 138374 */     // GIR_Coverage, 2989,
     /* 138374 */     GIR_EraseRootFromParent_Done,
     /* 138375 */   // Label 1918: @138375
     /* 138375 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(138467), // Rule ID 2997 //
     /* 138380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138395 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138399 */     // MIs[1] Operand 1
     /* 138399 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 138404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138406 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 138406 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138409 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 138413 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138418 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138422 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138440 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138465 */     GIR_RootConstrainSelectedInstOperands,
     /* 138466 */     // GIR_Coverage, 2997,
     /* 138466 */     GIR_EraseRootFromParent_Done,
     /* 138467 */   // Label 1919: @138467
     /* 138467 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(138559), // Rule ID 3005 //
     /* 138472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138487 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138491 */     // MIs[1] Operand 1
     /* 138491 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 138496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138498 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 138498 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138501 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 138505 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138510 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138514 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138532 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138557 */     GIR_RootConstrainSelectedInstOperands,
     /* 138558 */     // GIR_Coverage, 3005,
     /* 138558 */     GIR_EraseRootFromParent_Done,
     /* 138559 */   // Label 1920: @138559
     /* 138559 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(138651), // Rule ID 3013 //
     /* 138564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138579 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138583 */     // MIs[1] Operand 1
     /* 138583 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 138588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138590 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 138590 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138593 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 138597 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138602 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138606 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138624 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 138631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138649 */     GIR_RootConstrainSelectedInstOperands,
     /* 138650 */     // GIR_Coverage, 3013,
     /* 138650 */     GIR_EraseRootFromParent_Done,
     /* 138651 */   // Label 1921: @138651
     /* 138651 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(138743), // Rule ID 3077 //
     /* 138656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138671 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138675 */     // MIs[1] Operand 1
     /* 138675 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 138680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138682 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 138682 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138685 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 138689 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138694 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138698 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138716 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 138723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138741 */     GIR_RootConstrainSelectedInstOperands,
     /* 138742 */     // GIR_Coverage, 3077,
     /* 138742 */     GIR_EraseRootFromParent_Done,
     /* 138743 */   // Label 1922: @138743
     /* 138743 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(138835), // Rule ID 3085 //
     /* 138748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138763 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138767 */     // MIs[1] Operand 1
     /* 138767 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 138772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138774 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 138774 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138777 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 138781 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138786 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138790 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138808 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 138815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138833 */     GIR_RootConstrainSelectedInstOperands,
     /* 138834 */     // GIR_Coverage, 3085,
     /* 138834 */     GIR_EraseRootFromParent_Done,
     /* 138835 */   // Label 1923: @138835
     /* 138835 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(138927), // Rule ID 3093 //
     /* 138840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138855 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138859 */     // MIs[1] Operand 1
     /* 138859 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 138864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138866 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 138866 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138869 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 138873 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138878 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138882 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138900 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138925 */     GIR_RootConstrainSelectedInstOperands,
     /* 138926 */     // GIR_Coverage, 3093,
     /* 138926 */     GIR_EraseRootFromParent_Done,
     /* 138927 */   // Label 1924: @138927
     /* 138927 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(139019), // Rule ID 3101 //
     /* 138932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138947 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138951 */     // MIs[1] Operand 1
     /* 138951 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 138956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138958 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 138958 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138961 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 138965 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138970 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138974 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138992 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139017 */     GIR_RootConstrainSelectedInstOperands,
     /* 139018 */     // GIR_Coverage, 3101,
     /* 139018 */     GIR_EraseRootFromParent_Done,
     /* 139019 */   // Label 1925: @139019
     /* 139019 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(139111), // Rule ID 3109 //
     /* 139024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 139027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139039 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139043 */     // MIs[1] Operand 1
     /* 139043 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 139048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139050 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 139050 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139053 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 139057 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139062 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139066 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139084 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 139091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139109 */     GIR_RootConstrainSelectedInstOperands,
     /* 139110 */     // GIR_Coverage, 3109,
     /* 139110 */     GIR_EraseRootFromParent_Done,
     /* 139111 */   // Label 1926: @139111
     /* 139111 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(139243), // Rule ID 3859 //
     /* 139116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139131 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139135 */     // MIs[1] Operand 1
     /* 139135 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 139140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139142 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 139149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139154 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139158 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139164 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139167 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139171 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139176 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139181 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139184 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139188 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139193 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139210 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139241 */     GIR_RootConstrainSelectedInstOperands,
     /* 139242 */     // GIR_Coverage, 3859,
     /* 139242 */     GIR_EraseRootFromParent_Done,
     /* 139243 */   // Label 1927: @139243
     /* 139243 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(139375), // Rule ID 3867 //
     /* 139248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139263 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139267 */     // MIs[1] Operand 1
     /* 139267 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 139272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139274 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139274 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139277 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 139281 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139286 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139290 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139296 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139299 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139303 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139308 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139313 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139316 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139320 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139325 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139342 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139373 */     GIR_RootConstrainSelectedInstOperands,
     /* 139374 */     // GIR_Coverage, 3867,
     /* 139374 */     GIR_EraseRootFromParent_Done,
     /* 139375 */   // Label 1928: @139375
     /* 139375 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(139507), // Rule ID 3875 //
     /* 139380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139395 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139399 */     // MIs[1] Operand 1
     /* 139399 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 139404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139406 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139406 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139409 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 139413 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139418 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139422 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139428 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139431 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139435 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139440 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139445 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139448 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139452 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139457 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139474 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 139481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139505 */     GIR_RootConstrainSelectedInstOperands,
     /* 139506 */     // GIR_Coverage, 3875,
     /* 139506 */     GIR_EraseRootFromParent_Done,
     /* 139507 */   // Label 1929: @139507
     /* 139507 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(139639), // Rule ID 3883 //
     /* 139512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139527 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139531 */     // MIs[1] Operand 1
     /* 139531 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 139536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139538 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139538 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139541 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 139545 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139550 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139554 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139560 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139563 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139567 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139572 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139577 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139580 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139584 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139589 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139606 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 139613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139637 */     GIR_RootConstrainSelectedInstOperands,
     /* 139638 */     // GIR_Coverage, 3883,
     /* 139638 */     GIR_EraseRootFromParent_Done,
     /* 139639 */   // Label 1930: @139639
     /* 139639 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(139771), // Rule ID 3891 //
     /* 139644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139659 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139663 */     // MIs[1] Operand 1
     /* 139663 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 139668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139670 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139670 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139673 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 139677 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139682 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139686 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139692 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139695 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139699 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139704 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139709 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139712 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139716 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139721 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139738 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 139745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139769 */     GIR_RootConstrainSelectedInstOperands,
     /* 139770 */     // GIR_Coverage, 3891,
     /* 139770 */     GIR_EraseRootFromParent_Done,
     /* 139771 */   // Label 1931: @139771
     /* 139771 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(139903), // Rule ID 3955 //
     /* 139776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139791 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139795 */     // MIs[1] Operand 1
     /* 139795 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 139800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139802 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139802 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139805 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 139809 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139814 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139818 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139824 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139827 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139831 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139836 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139841 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139844 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139848 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139853 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139870 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139901 */     GIR_RootConstrainSelectedInstOperands,
     /* 139902 */     // GIR_Coverage, 3955,
     /* 139902 */     GIR_EraseRootFromParent_Done,
     /* 139903 */   // Label 1932: @139903
     /* 139903 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(140035), // Rule ID 3963 //
     /* 139908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139923 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139927 */     // MIs[1] Operand 1
     /* 139927 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 139932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139934 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139934 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139937 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 139941 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139946 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139950 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139956 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139959 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139963 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139968 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139973 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139976 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139980 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139985 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140002 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 140009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140033 */     GIR_RootConstrainSelectedInstOperands,
     /* 140034 */     // GIR_Coverage, 3963,
     /* 140034 */     GIR_EraseRootFromParent_Done,
     /* 140035 */   // Label 1933: @140035
     /* 140035 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(140167), // Rule ID 3971 //
     /* 140040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140055 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140059 */     // MIs[1] Operand 1
     /* 140059 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 140064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140066 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140066 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140069 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 140073 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140078 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140082 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140088 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140091 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140095 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140100 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140105 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140108 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140112 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140117 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140134 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 140141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140165 */     GIR_RootConstrainSelectedInstOperands,
     /* 140166 */     // GIR_Coverage, 3971,
     /* 140166 */     GIR_EraseRootFromParent_Done,
     /* 140167 */   // Label 1934: @140167
     /* 140167 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(140299), // Rule ID 3979 //
     /* 140172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140191 */     // MIs[1] Operand 1
     /* 140191 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 140196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140198 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140198 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140201 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 140205 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140210 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140214 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140220 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140223 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140227 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140232 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140237 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140240 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140244 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140249 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140266 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 140273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140297 */     GIR_RootConstrainSelectedInstOperands,
     /* 140298 */     // GIR_Coverage, 3979,
     /* 140298 */     GIR_EraseRootFromParent_Done,
     /* 140299 */   // Label 1935: @140299
     /* 140299 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(140431), // Rule ID 3987 //
     /* 140304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140319 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140323 */     // MIs[1] Operand 1
     /* 140323 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 140328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140330 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140330 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140333 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 140337 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140342 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140346 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140352 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140355 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140359 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140364 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140369 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140372 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140376 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140381 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140398 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 140405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140429 */     GIR_RootConstrainSelectedInstOperands,
     /* 140430 */     // GIR_Coverage, 3987,
     /* 140430 */     GIR_EraseRootFromParent_Done,
     /* 140431 */   // Label 1936: @140431
     /* 140431 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(140446), // Rule ID 2981 //
     /* 140436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 140439 */     // (zext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 140439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC),
     /* 140444 */     GIR_RootConstrainSelectedInstOperands,
     /* 140445 */     // GIR_Coverage, 2981,
     /* 140445 */     GIR_Done,
     /* 140446 */   // Label 1937: @140446
     /* 140446 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(140500), // Rule ID 3665 //
     /* 140451 */     // (zext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } 1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 140451 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140454 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140458 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140463 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 140466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140480 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 140483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140490 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 140492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 140498 */     GIR_RootConstrainSelectedInstOperands,
     /* 140499 */     // GIR_Coverage, 3665,
     /* 140499 */     GIR_EraseRootFromParent_Done,
     /* 140500 */   // Label 1938: @140500
     /* 140500 */   GIM_Reject,
     /* 140501 */ // Label 1846: @140501
     /* 140501 */ GIM_Reject,
     /* 140502 */ // Label 1844: @140502
     /* 140502 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(140618), // Rule ID 5289 //
     /* 140507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140514 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140518 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140522 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140526 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140530 */   // MIs[1] Operand 1
     /* 140530 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 140535 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140539 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 140543 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 140547 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 140551 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 140555 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 140559 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 140563 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 140567 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 140571 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140575 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 140577 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 140577 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140580 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 140584 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140589 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 140593 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 140596 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 140599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 140604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 140606 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 140610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 140616 */   GIR_RootConstrainSelectedInstOperands,
     /* 140617 */   // GIR_Coverage, 5289,
     /* 140617 */   GIR_EraseRootFromParent_Done,
     /* 140618 */ // Label 1939: @140618
     /* 140618 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(140788), // Rule ID 5290 //
     /* 140623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140630 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140634 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140638 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 140642 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 140646 */   // MIs[1] Operand 1
     /* 140646 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 140651 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140655 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 140659 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 140663 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 140667 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 140671 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 140675 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 140679 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 140683 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 140687 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140691 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 140693 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 140693 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140696 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 140700 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140705 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 140709 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 140712 */   GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 140715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140717 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140720 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 140724 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140729 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 140733 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 140736 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 140739 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 140742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 140761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 140769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140772 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140777 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140782 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 140787 */   // GIR_Coverage, 5290,
     /* 140787 */   GIR_EraseRootFromParent_Done,
     /* 140788 */ // Label 1940: @140788
     /* 140788 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(140925), // Rule ID 5297 //
     /* 140793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140800 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140804 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140808 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140812 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140816 */   // MIs[1] Operand 1
     /* 140816 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 140821 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140825 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 140829 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 140833 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 140837 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 140841 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 140845 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 140849 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 140853 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 140857 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140861 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 140863 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 140863 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140866 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 140870 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140875 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 140879 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 140882 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 140885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140887 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140890 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 140894 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140899 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 140903 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 140907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 140912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 140914 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 140920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 140923 */   GIR_RootConstrainSelectedInstOperands,
     /* 140924 */   // GIR_Coverage, 5297,
     /* 140924 */   GIR_EraseRootFromParent_Done,
     /* 140925 */ // Label 1941: @140925
     /* 140925 */ GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(141116), // Rule ID 5298 //
     /* 140930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140937 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140945 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 140949 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 140953 */   // MIs[1] Operand 1
     /* 140953 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 140958 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140962 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 140966 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 140970 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 140974 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 140978 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 140982 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 140986 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 140990 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 140994 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140998 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141000 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141000 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 141003 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141007 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141012 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141016 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 141019 */   GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 141022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 141024 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141027 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 141031 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141036 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141040 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141046 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141049 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141053 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141058 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141061 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 141064 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141067 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141084 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141100 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141115 */   // GIR_Coverage, 5298,
     /* 141115 */   GIR_EraseRootFromParent_Done,
     /* 141116 */ // Label 1942: @141116
     /* 141116 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(141232), // Rule ID 3770 //
     /* 141121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141136 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141140 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141144 */   // MIs[1] Operand 1
     /* 141144 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 141149 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141153 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141157 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 141161 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 141165 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141169 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141173 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 141177 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141181 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141185 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141189 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141191 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 141191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 141194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141203 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141207 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 141210 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 141213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 141218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141220 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141230 */   GIR_RootConstrainSelectedInstOperands,
     /* 141231 */   // GIR_Coverage, 3770,
     /* 141231 */   GIR_EraseRootFromParent_Done,
     /* 141232 */ // Label 1943: @141232
     /* 141232 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(141402), // Rule ID 3771 //
     /* 141237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141244 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141248 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141252 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141256 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141260 */   // MIs[1] Operand 1
     /* 141260 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 141265 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141269 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141273 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 141277 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 141281 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141285 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141289 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 141293 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141297 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141301 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141305 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141307 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141307 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141310 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141314 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141319 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141323 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 141326 */   GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 141329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141331 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141334 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141338 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141343 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141347 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141350 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141353 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141358 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141361 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141365 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141386 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141391 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141401 */   // GIR_Coverage, 3771,
     /* 141401 */   GIR_EraseRootFromParent_Done,
     /* 141402 */ // Label 1944: @141402
     /* 141402 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(141539), // Rule ID 3778 //
     /* 141407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141422 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141426 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141430 */   // MIs[1] Operand 1
     /* 141430 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141435 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141439 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141443 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 141447 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 141451 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141455 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141459 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 141463 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141467 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141471 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141475 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141477 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 141477 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141480 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141484 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141489 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141493 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 141496 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 141499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 141508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141513 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141517 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 141526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141531 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141537 */   GIR_RootConstrainSelectedInstOperands,
     /* 141538 */   // GIR_Coverage, 3778,
     /* 141538 */   GIR_EraseRootFromParent_Done,
     /* 141539 */ // Label 1945: @141539
     /* 141539 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(141730), // Rule ID 3779 //
     /* 141544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141551 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141555 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141559 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141563 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141567 */   // MIs[1] Operand 1
     /* 141567 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141572 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141576 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141580 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 141584 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 141588 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141592 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141596 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 141600 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141604 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141608 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141612 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141614 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141614 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 141617 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141621 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141626 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141630 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 141633 */   GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 141636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 141638 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141641 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 141645 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141650 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141654 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141660 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141663 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141667 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141672 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141675 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 141678 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141681 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141708 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141724 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141729 */   // GIR_Coverage, 3779,
     /* 141729 */   GIR_EraseRootFromParent_Done,
     /* 141730 */ // Label 1946: @141730
     /* 141730 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(141813), // Rule ID 3350 //
     /* 141735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 141738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 141741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141745 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141749 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 141753 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 141757 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141761 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 141765 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 141769 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 141773 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 141777 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 141779 */   // (zext:{ *:[i64] } (srl:{ *:[i32] } (bswap:{ *:[i32] } i32:{ *:[i32] }:$RS), 16:{ *:[i32] }))  =>  (RLDICL_32_64:{ *:[i64] } (BRH:{ *:[i32] } ?:{ *:[i32] }:$RS), 0:{ *:[i32] }, 48:{ *:[i32] })
     /* 141779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 141782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::BRH),
     /* 141786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141791 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // RS
     /* 141795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32_64),
     /* 141800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141802 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 141811 */   GIR_RootConstrainSelectedInstOperands,
     /* 141812 */   // GIR_Coverage, 3350,
     /* 141812 */   GIR_EraseRootFromParent_Done,
     /* 141813 */ // Label 1947: @141813
     /* 141813 */ GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(141886), // Rule ID 3690 //
     /* 141818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141825 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141829 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141833 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141837 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141841 */   // MIs[1] Operand 1
     /* 141841 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141846 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141850 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141852 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 141852 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141855 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 141859 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141864 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 141873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141875 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 141881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141884 */   GIR_RootConstrainSelectedInstOperands,
     /* 141885 */   // GIR_Coverage, 3690,
     /* 141885 */   GIR_EraseRootFromParent_Done,
     /* 141886 */ // Label 1948: @141886
     /* 141886 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(142013), // Rule ID 3691 //
     /* 141891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141898 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141906 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141910 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141914 */   // MIs[1] Operand 1
     /* 141914 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141919 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141923 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141925 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141925 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141928 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 141932 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141937 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141943 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141946 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 141950 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141955 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141958 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 141961 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141964 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141988 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142002 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142007 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142012 */   // GIR_Coverage, 3691,
     /* 142012 */   GIR_EraseRootFromParent_Done,
     /* 142013 */ // Label 1949: @142013
     /* 142013 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(142124), // Rule ID 3698 //
     /* 142018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142033 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142037 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142041 */   // MIs[1] Operand 1
     /* 142041 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 142046 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142050 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142052 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 142052 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142055 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 142059 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142064 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142070 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 142073 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 142077 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142082 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142088 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 142095 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142100 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142103 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142113 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 142119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142122 */   GIR_RootConstrainSelectedInstOperands,
     /* 142123 */   // GIR_Coverage, 3698,
     /* 142123 */   GIR_EraseRootFromParent_Done,
     /* 142124 */ // Label 1950: @142124
     /* 142124 */ GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(142289), // Rule ID 3699 //
     /* 142129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142136 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142140 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142144 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142148 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142152 */   // MIs[1] Operand 1
     /* 142152 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 142157 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142161 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142163 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142163 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 142166 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 142170 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142175 */   GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 142181 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 142184 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 142188 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142193 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 142199 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142202 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 142206 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142211 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 142214 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 142217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142219 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142222 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142226 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142231 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 142234 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 142237 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142240 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142245 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142248 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142252 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142273 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142278 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142288 */   // GIR_Coverage, 3699,
     /* 142288 */   GIR_EraseRootFromParent_Done,
     /* 142289 */ // Label 1951: @142289
     /* 142289 */ GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(142345), // Rule ID 3706 //
     /* 142294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142301 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142305 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142309 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142313 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142317 */   // MIs[1] Operand 1
     /* 142317 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 142322 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142326 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142328 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 142328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142333 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142343 */   GIR_RootConstrainSelectedInstOperands,
     /* 142344 */   // GIR_Coverage, 3706,
     /* 142344 */   GIR_EraseRootFromParent_Done,
     /* 142345 */ // Label 1952: @142345
     /* 142345 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(142455), // Rule ID 3707 //
     /* 142350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142365 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142369 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142373 */   // MIs[1] Operand 1
     /* 142373 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 142378 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142382 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142384 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142384 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142387 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142391 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142396 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142400 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 142403 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142406 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142439 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142444 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142449 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142454 */   // GIR_Coverage, 3707,
     /* 142454 */   GIR_EraseRootFromParent_Done,
     /* 142455 */ // Label 1953: @142455
     /* 142455 */ GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(142532), // Rule ID 3714 //
     /* 142460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142479 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142483 */   // MIs[1] Operand 1
     /* 142483 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 142488 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142492 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142494 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 142494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 142501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142506 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142510 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142521 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142530 */   GIR_RootConstrainSelectedInstOperands,
     /* 142531 */   // GIR_Coverage, 3714,
     /* 142531 */   GIR_EraseRootFromParent_Done,
     /* 142532 */ // Label 1954: @142532
     /* 142532 */ GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(142663), // Rule ID 3715 //
     /* 142537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142544 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142548 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142552 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142556 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142560 */   // MIs[1] Operand 1
     /* 142560 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 142565 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142569 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142571 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142571 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142574 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 142578 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142583 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142587 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142593 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142596 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142600 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142605 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 142608 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 142611 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142614 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142619 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142622 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142626 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142638 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142652 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142657 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142662 */   // GIR_Coverage, 3715,
     /* 142662 */   GIR_EraseRootFromParent_Done,
     /* 142663 */ // Label 1955: @142663
     /* 142663 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(142757), // Rule ID 3722 //
     /* 142668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142675 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142679 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142683 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142687 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142691 */   // MIs[1] Operand 1
     /* 142691 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 142696 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142700 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142702 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 142702 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 142705 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 142709 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142714 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142720 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142723 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 142727 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142732 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142735 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142755 */   GIR_RootConstrainSelectedInstOperands,
     /* 142756 */   // GIR_Coverage, 3722,
     /* 142756 */   GIR_EraseRootFromParent_Done,
     /* 142757 */ // Label 1956: @142757
     /* 142757 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(142905), // Rule ID 3723 //
     /* 142762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142769 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142773 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142777 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142781 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142785 */   // MIs[1] Operand 1
     /* 142785 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 142790 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142794 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142796 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142796 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 142799 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 142803 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142808 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 142814 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142817 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 142821 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142826 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 142829 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142835 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142838 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142842 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142847 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 142850 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 142853 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142856 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142880 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142889 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142899 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142904 */   // GIR_Coverage, 3723,
     /* 142904 */   GIR_EraseRootFromParent_Done,
     /* 142905 */ // Label 1957: @142905
     /* 142905 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(142999), // Rule ID 3730 //
     /* 142910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142917 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142925 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142929 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142933 */   // MIs[1] Operand 1
     /* 142933 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 142938 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142942 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142944 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 142944 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 142947 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 142951 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142956 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142962 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142965 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 142969 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142974 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142978 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142988 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142997 */   GIR_RootConstrainSelectedInstOperands,
     /* 142998 */   // GIR_Coverage, 3730,
     /* 142998 */   GIR_EraseRootFromParent_Done,
     /* 142999 */ // Label 1958: @142999
     /* 142999 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(143147), // Rule ID 3731 //
     /* 143004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143011 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143019 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143023 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143027 */   // MIs[1] Operand 1
     /* 143027 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 143032 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 143036 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143038 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143038 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143041 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 143045 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143050 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143056 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143059 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 143063 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143068 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143072 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143077 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143080 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143084 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143089 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143092 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143095 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143098 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143103 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143106 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143110 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143125 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143131 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143146 */   // GIR_Coverage, 3731,
     /* 143146 */   GIR_EraseRootFromParent_Done,
     /* 143147 */ // Label 1959: @143147
     /* 143147 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(143244), // Rule ID 3738 //
     /* 143152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143159 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143163 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143167 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143171 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143175 */   // MIs[1] Operand 1
     /* 143175 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 143180 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143184 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143186 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143186 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 143189 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 143193 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143198 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143202 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 143214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143219 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143223 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143242 */   GIR_RootConstrainSelectedInstOperands,
     /* 143243 */   // GIR_Coverage, 3738,
     /* 143243 */   GIR_EraseRootFromParent_Done,
     /* 143244 */ // Label 1960: @143244
     /* 143244 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(143395), // Rule ID 3739 //
     /* 143249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143256 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143260 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143264 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143268 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143272 */   // MIs[1] Operand 1
     /* 143272 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 143277 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143283 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143283 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143286 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 143290 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143295 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143299 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 143302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143304 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143307 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 143311 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143316 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143320 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143323 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143325 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143328 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143332 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143337 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143340 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143343 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143346 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143379 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143384 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143394 */   // GIR_Coverage, 3739,
     /* 143394 */   GIR_EraseRootFromParent_Done,
     /* 143395 */ // Label 1961: @143395
     /* 143395 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(143492), // Rule ID 3746 //
     /* 143400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143407 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143411 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143415 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143419 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143423 */   // MIs[1] Operand 1
     /* 143423 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 143428 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143432 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143434 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143434 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 143437 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 143441 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143446 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143450 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 143462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143467 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143471 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143490 */   GIR_RootConstrainSelectedInstOperands,
     /* 143491 */   // GIR_Coverage, 3746,
     /* 143491 */   GIR_EraseRootFromParent_Done,
     /* 143492 */ // Label 1962: @143492
     /* 143492 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(143643), // Rule ID 3747 //
     /* 143497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143504 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143508 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143512 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143516 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143520 */   // MIs[1] Operand 1
     /* 143520 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 143525 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143529 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143531 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143531 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143534 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 143538 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143543 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143547 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 143550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143552 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143555 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 143559 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143564 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143568 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143573 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143576 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143580 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143585 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143588 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143591 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143594 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143599 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143602 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143606 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143621 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143627 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143637 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143642 */   // GIR_Coverage, 3747,
     /* 143642 */   GIR_EraseRootFromParent_Done,
     /* 143643 */ // Label 1963: @143643
     /* 143643 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(143720), // Rule ID 3754 //
     /* 143648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143655 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143659 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143663 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143667 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143671 */   // MIs[1] Operand 1
     /* 143671 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 143676 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143680 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143682 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 143689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143694 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143698 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143718 */   GIR_RootConstrainSelectedInstOperands,
     /* 143719 */   // GIR_Coverage, 3754,
     /* 143719 */   GIR_EraseRootFromParent_Done,
     /* 143720 */ // Label 1964: @143720
     /* 143720 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(143851), // Rule ID 3755 //
     /* 143725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143740 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143744 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143748 */   // MIs[1] Operand 1
     /* 143748 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 143753 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143757 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143759 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143759 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143762 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 143766 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143771 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143775 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143781 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143784 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143788 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143793 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143796 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143799 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143802 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143826 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143829 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143850 */   // GIR_Coverage, 3755,
     /* 143850 */   GIR_EraseRootFromParent_Done,
     /* 143851 */ // Label 1965: @143851
     /* 143851 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(143907), // Rule ID 3762 //
     /* 143856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143863 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143867 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143871 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143875 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143879 */   // MIs[1] Operand 1
     /* 143879 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 143884 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143888 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143890 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143895 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143905 */   GIR_RootConstrainSelectedInstOperands,
     /* 143906 */   // GIR_Coverage, 3762,
     /* 143906 */   GIR_EraseRootFromParent_Done,
     /* 143907 */ // Label 1966: @143907
     /* 143907 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(144017), // Rule ID 3763 //
     /* 143912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143927 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143931 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143935 */   // MIs[1] Operand 1
     /* 143935 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 143940 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143944 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143946 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143946 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143949 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143953 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143958 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143962 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143965 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143968 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 144001 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 144016 */   // GIR_Coverage, 3763,
     /* 144016 */   GIR_EraseRootFromParent_Done,
     /* 144017 */ // Label 1967: @144017
     /* 144017 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(144127), // Rule ID 3030 //
     /* 144022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144040 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144044 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144048 */   // MIs[1] Operand 1
     /* 144048 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 144053 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144057 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144061 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144065 */   // MIs[2] Operand 1
     /* 144065 */   // No operand predicates
     /* 144065 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144067 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 144067 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144070 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144074 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144079 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144083 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144088 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144095 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144100 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 144107 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144112 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144125 */   GIR_RootConstrainSelectedInstOperands,
     /* 144126 */   // GIR_Coverage, 3030,
     /* 144126 */   GIR_EraseRootFromParent_Done,
     /* 144127 */ // Label 1968: @144127
     /* 144127 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(144237), // Rule ID 3046 //
     /* 144132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144142 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144150 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144154 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144158 */   // MIs[1] Operand 1
     /* 144158 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144163 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144167 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144171 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144175 */   // MIs[2] Operand 1
     /* 144175 */   // No operand predicates
     /* 144175 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144177 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 144177 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144180 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144184 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144189 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144193 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144198 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144201 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144205 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144210 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 144217 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144222 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144235 */   GIR_RootConstrainSelectedInstOperands,
     /* 144236 */   // GIR_Coverage, 3046,
     /* 144236 */   GIR_EraseRootFromParent_Done,
     /* 144237 */ // Label 1969: @144237
     /* 144237 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(144347), // Rule ID 3054 //
     /* 144242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144260 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144264 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144268 */   // MIs[1] Operand 1
     /* 144268 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 144273 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144277 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144281 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144285 */   // MIs[2] Operand 1
     /* 144285 */   // No operand predicates
     /* 144285 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144287 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 144287 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144290 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144294 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144299 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144303 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144308 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144311 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144315 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144320 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 144327 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144332 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144342 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144345 */   GIR_RootConstrainSelectedInstOperands,
     /* 144346 */   // GIR_Coverage, 3054,
     /* 144346 */   GIR_EraseRootFromParent_Done,
     /* 144347 */ // Label 1970: @144347
     /* 144347 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(144457), // Rule ID 3126 //
     /* 144352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144362 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144370 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144374 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144378 */   // MIs[1] Operand 1
     /* 144378 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 144383 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144387 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144391 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 144395 */   // MIs[2] Operand 1
     /* 144395 */   // No operand predicates
     /* 144395 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144397 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 144397 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144400 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 144404 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144409 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144413 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144418 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144421 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144425 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144430 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 144437 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144442 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144455 */   GIR_RootConstrainSelectedInstOperands,
     /* 144456 */   // GIR_Coverage, 3126,
     /* 144456 */   GIR_EraseRootFromParent_Done,
     /* 144457 */ // Label 1971: @144457
     /* 144457 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(144567), // Rule ID 3142 //
     /* 144462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144472 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144476 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144480 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144484 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144488 */   // MIs[1] Operand 1
     /* 144488 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144493 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144497 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144501 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 144505 */   // MIs[2] Operand 1
     /* 144505 */   // No operand predicates
     /* 144505 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144507 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 144507 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144510 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 144514 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144519 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144523 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144540 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 144547 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144552 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144565 */   GIR_RootConstrainSelectedInstOperands,
     /* 144566 */   // GIR_Coverage, 3142,
     /* 144566 */   GIR_EraseRootFromParent_Done,
     /* 144567 */ // Label 1972: @144567
     /* 144567 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(144677), // Rule ID 3150 //
     /* 144572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144582 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144590 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144594 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144598 */   // MIs[1] Operand 1
     /* 144598 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 144603 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144607 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144611 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 144615 */   // MIs[2] Operand 1
     /* 144615 */   // No operand predicates
     /* 144615 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144617 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 144617 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144620 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 144624 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144629 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144633 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144638 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144641 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144645 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144650 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 144657 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144662 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144675 */   GIR_RootConstrainSelectedInstOperands,
     /* 144676 */   // GIR_Coverage, 3150,
     /* 144676 */   GIR_EraseRootFromParent_Done,
     /* 144677 */ // Label 1973: @144677
     /* 144677 */ GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(144827), // Rule ID 3813 //
     /* 144682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 144685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144692 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144700 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144704 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144708 */   // MIs[1] Operand 1
     /* 144708 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 144713 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144717 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144721 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144725 */   // MIs[2] Operand 1
     /* 144725 */   // No operand predicates
     /* 144725 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144727 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 144727 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144730 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144734 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144739 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144743 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144748 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 144751 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144755 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144760 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 144763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 144765 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144768 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144772 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144777 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 144780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144794 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 144801 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144806 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 144814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144819 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 144822 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 144825 */   GIR_RootConstrainSelectedInstOperands,
     /* 144826 */   // GIR_Coverage, 3813,
     /* 144826 */   GIR_EraseRootFromParent_Done,
     /* 144827 */ // Label 1974: @144827
     /* 144827 */ GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(144977), // Rule ID 3829 //
     /* 144832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 144835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144850 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144854 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144858 */   // MIs[1] Operand 1
     /* 144858 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144863 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144867 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144871 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144875 */   // MIs[2] Operand 1
     /* 144875 */   // No operand predicates
     /* 144875 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144877 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 144877 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144880 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144884 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144889 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144893 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144898 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 144901 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144905 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144910 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 144913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 144915 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144918 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144922 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144927 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 144930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144944 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 144951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144956 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 144964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144966 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 144972 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 144975 */   GIR_RootConstrainSelectedInstOperands,
     /* 144976 */   // GIR_Coverage, 3829,
     /* 144976 */   GIR_EraseRootFromParent_Done,
     /* 144977 */ // Label 1975: @144977
     /* 144977 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(145127), // Rule ID 3837 //
     /* 144982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 144985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144992 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144996 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145000 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145004 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145008 */   // MIs[1] Operand 1
     /* 145008 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 145013 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145017 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145021 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 145025 */   // MIs[2] Operand 1
     /* 145025 */   // No operand predicates
     /* 145025 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145027 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145027 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145030 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 145034 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145039 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145043 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145048 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145051 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145055 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145060 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145065 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145068 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145072 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145077 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145094 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 145101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145106 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145116 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145119 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145125 */   GIR_RootConstrainSelectedInstOperands,
     /* 145126 */   // GIR_Coverage, 3837,
     /* 145126 */   GIR_EraseRootFromParent_Done,
     /* 145127 */ // Label 1976: @145127
     /* 145127 */ GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(145277), // Rule ID 3909 //
     /* 145132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145142 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145150 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145154 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145158 */   // MIs[1] Operand 1
     /* 145158 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 145163 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145167 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145171 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 145175 */   // MIs[2] Operand 1
     /* 145175 */   // No operand predicates
     /* 145175 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145177 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145177 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145180 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 145184 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145189 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145193 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145198 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145201 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145205 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145210 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145215 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145218 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145222 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145227 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145232 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145235 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145239 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145244 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 145251 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145256 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145266 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145275 */   GIR_RootConstrainSelectedInstOperands,
     /* 145276 */   // GIR_Coverage, 3909,
     /* 145276 */   GIR_EraseRootFromParent_Done,
     /* 145277 */ // Label 1977: @145277
     /* 145277 */ GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(145427), // Rule ID 3925 //
     /* 145282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145300 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145304 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145308 */   // MIs[1] Operand 1
     /* 145308 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 145313 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145317 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145321 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 145325 */   // MIs[2] Operand 1
     /* 145325 */   // No operand predicates
     /* 145325 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145327 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145327 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145330 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 145334 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145339 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145343 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145348 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145351 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145355 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145360 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145365 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145368 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145372 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145377 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145394 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 145401 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145406 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145416 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145419 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145425 */   GIR_RootConstrainSelectedInstOperands,
     /* 145426 */   // GIR_Coverage, 3925,
     /* 145426 */   GIR_EraseRootFromParent_Done,
     /* 145427 */ // Label 1978: @145427
     /* 145427 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(145577), // Rule ID 3933 //
     /* 145432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145442 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145446 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145450 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145454 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145458 */   // MIs[1] Operand 1
     /* 145458 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 145463 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145467 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145471 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 145475 */   // MIs[2] Operand 1
     /* 145475 */   // No operand predicates
     /* 145475 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145477 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145477 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145480 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 145484 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145489 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145493 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145498 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145501 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145505 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145510 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145515 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145518 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145522 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145527 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145532 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145535 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145539 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145544 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 145551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145556 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145569 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145575 */   GIR_RootConstrainSelectedInstOperands,
     /* 145576 */   // GIR_Coverage, 3933,
     /* 145576 */   GIR_EraseRootFromParent_Done,
     /* 145577 */ // Label 1979: @145577
     /* 145577 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(145676), // Rule ID 3174 //
     /* 145582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 145585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145600 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145604 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145608 */   // MIs[1] Operand 1
     /* 145608 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 145613 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145615 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 145615 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145618 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 145622 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145627 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145631 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145637 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145640 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145644 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145649 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 145656 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145661 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 145669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 145671 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145674 */   GIR_RootConstrainSelectedInstOperands,
     /* 145675 */   // GIR_Coverage, 3174,
     /* 145675 */   GIR_EraseRootFromParent_Done,
     /* 145676 */ // Label 1980: @145676
     /* 145676 */ GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(145775), // Rule ID 3190 //
     /* 145681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 145684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145691 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145695 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145699 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145703 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145707 */   // MIs[1] Operand 1
     /* 145707 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 145712 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145714 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 145714 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145717 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 145721 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145726 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145730 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145736 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145739 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145743 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145748 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 145755 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145760 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 145768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 145770 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145773 */   GIR_RootConstrainSelectedInstOperands,
     /* 145774 */   // GIR_Coverage, 3190,
     /* 145774 */   GIR_EraseRootFromParent_Done,
     /* 145775 */ // Label 1981: @145775
     /* 145775 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(145874), // Rule ID 3206 //
     /* 145780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 145783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145790 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145794 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145798 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145802 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145806 */   // MIs[1] Operand 1
     /* 145806 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 145811 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145813 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 145813 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145816 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 145820 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145825 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145829 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145847 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 145854 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145859 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 145867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 145869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145872 */   GIR_RootConstrainSelectedInstOperands,
     /* 145873 */   // GIR_Coverage, 3206,
     /* 145873 */   GIR_EraseRootFromParent_Done,
     /* 145874 */ // Label 1982: @145874
     /* 145874 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(145973), // Rule ID 3222 //
     /* 145879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 145882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145889 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145893 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145897 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145901 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145905 */   // MIs[1] Operand 1
     /* 145905 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 145910 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145912 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 145912 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145915 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 145919 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145924 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145928 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145946 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 145953 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145958 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 145966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 145968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145971 */   GIR_RootConstrainSelectedInstOperands,
     /* 145972 */   // GIR_Coverage, 3222,
     /* 145972 */   GIR_EraseRootFromParent_Done,
     /* 145973 */ // Label 1983: @145973
     /* 145973 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(146072), // Rule ID 3230 //
     /* 145978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 145981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145988 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145996 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146000 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146004 */   // MIs[1] Operand 1
     /* 146004 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 146009 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146011 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 146011 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146014 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146018 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146023 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146027 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146033 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146036 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146040 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146045 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 146052 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146057 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146070 */   GIR_RootConstrainSelectedInstOperands,
     /* 146071 */   // GIR_Coverage, 3230,
     /* 146071 */   GIR_EraseRootFromParent_Done,
     /* 146072 */ // Label 1984: @146072
     /* 146072 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(146171), // Rule ID 3246 //
     /* 146077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146087 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146095 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146099 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146103 */   // MIs[1] Operand 1
     /* 146103 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146108 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146110 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 146110 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146113 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146117 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146122 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146126 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146144 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146151 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146156 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146169 */   GIR_RootConstrainSelectedInstOperands,
     /* 146170 */   // GIR_Coverage, 3246,
     /* 146170 */   GIR_EraseRootFromParent_Done,
     /* 146171 */ // Label 1985: @146171
     /* 146171 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(146270), // Rule ID 3262 //
     /* 146176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146194 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146198 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146202 */   // MIs[1] Operand 1
     /* 146202 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 146207 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146209 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 146209 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146212 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146216 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146221 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146225 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146231 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146234 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146238 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146243 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 146250 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146255 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146265 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146268 */   GIR_RootConstrainSelectedInstOperands,
     /* 146269 */   // GIR_Coverage, 3262,
     /* 146269 */   GIR_EraseRootFromParent_Done,
     /* 146270 */ // Label 1986: @146270
     /* 146270 */ GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(146369), // Rule ID 3278 //
     /* 146275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146293 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146297 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146301 */   // MIs[1] Operand 1
     /* 146301 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 146306 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146308 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 146308 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146311 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146315 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146320 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146324 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146342 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 146349 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146354 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146364 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146367 */   GIR_RootConstrainSelectedInstOperands,
     /* 146368 */   // GIR_Coverage, 3278,
     /* 146368 */   GIR_EraseRootFromParent_Done,
     /* 146369 */ // Label 1987: @146369
     /* 146369 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(146468), // Rule ID 3286 //
     /* 146374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146384 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146388 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146392 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146396 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146400 */   // MIs[1] Operand 1
     /* 146400 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 146405 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146407 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 146407 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146410 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146414 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146419 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146423 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146441 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 146448 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146453 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146466 */   GIR_RootConstrainSelectedInstOperands,
     /* 146467 */   // GIR_Coverage, 3286,
     /* 146467 */   GIR_EraseRootFromParent_Done,
     /* 146468 */ // Label 1988: @146468
     /* 146468 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(146567), // Rule ID 3302 //
     /* 146473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146483 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146487 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146491 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146495 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146499 */   // MIs[1] Operand 1
     /* 146499 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146504 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146506 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 146506 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146509 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146513 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146518 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146522 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146540 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146547 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146552 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146565 */   GIR_RootConstrainSelectedInstOperands,
     /* 146566 */   // GIR_Coverage, 3302,
     /* 146566 */   GIR_EraseRootFromParent_Done,
     /* 146567 */ // Label 1989: @146567
     /* 146567 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(146666), // Rule ID 3318 //
     /* 146572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146582 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146590 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146594 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146598 */   // MIs[1] Operand 1
     /* 146598 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 146603 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146605 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 146605 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146608 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146612 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146617 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146621 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146627 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146630 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146634 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146639 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 146646 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146651 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146661 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146664 */   GIR_RootConstrainSelectedInstOperands,
     /* 146665 */   // GIR_Coverage, 3318,
     /* 146665 */   GIR_EraseRootFromParent_Done,
     /* 146666 */ // Label 1990: @146666
     /* 146666 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(146765), // Rule ID 3334 //
     /* 146671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146689 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146693 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146697 */   // MIs[1] Operand 1
     /* 146697 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 146702 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146704 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 146704 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146707 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146711 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146716 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146720 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146726 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146729 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146733 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146738 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 146745 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146750 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146763 */   GIR_RootConstrainSelectedInstOperands,
     /* 146764 */   // GIR_Coverage, 3334,
     /* 146764 */   GIR_EraseRootFromParent_Done,
     /* 146765 */ // Label 1991: @146765
     /* 146765 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(146904), // Rule ID 4016 //
     /* 146770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 146773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146780 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146784 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146788 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146792 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146796 */   // MIs[1] Operand 1
     /* 146796 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 146801 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146803 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 146803 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146806 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 146810 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146815 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146819 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146825 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 146828 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146832 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146837 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 146840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 146842 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 146845 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146849 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146854 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 146857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146871 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 146878 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146883 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 146891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146893 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 146899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 146902 */   GIR_RootConstrainSelectedInstOperands,
     /* 146903 */   // GIR_Coverage, 4016,
     /* 146903 */   GIR_EraseRootFromParent_Done,
     /* 146904 */ // Label 1992: @146904
     /* 146904 */ GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(147043), // Rule ID 4048 //
     /* 146909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 146912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146927 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146931 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146935 */   // MIs[1] Operand 1
     /* 146935 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146940 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146942 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 146942 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146945 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 146949 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146954 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146958 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146964 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 146967 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146971 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146976 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 146979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 146981 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 146984 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146988 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146993 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 146996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147010 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 147017 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147022 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147032 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147041 */   GIR_RootConstrainSelectedInstOperands,
     /* 147042 */   // GIR_Coverage, 4048,
     /* 147042 */   GIR_EraseRootFromParent_Done,
     /* 147043 */ // Label 1993: @147043
     /* 147043 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(147182), // Rule ID 4080 //
     /* 147048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147058 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147062 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147066 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147070 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147074 */   // MIs[1] Operand 1
     /* 147074 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 147079 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147081 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147081 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147084 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 147088 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147093 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147097 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147103 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147106 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147110 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147115 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147120 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147123 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147127 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147132 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147137 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147140 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147144 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147149 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 147156 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147161 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147171 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147177 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147180 */   GIR_RootConstrainSelectedInstOperands,
     /* 147181 */   // GIR_Coverage, 4080,
     /* 147181 */   GIR_EraseRootFromParent_Done,
     /* 147182 */ // Label 1994: @147182
     /* 147182 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(147321), // Rule ID 4112 //
     /* 147187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147197 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147201 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147205 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147209 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147213 */   // MIs[1] Operand 1
     /* 147213 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 147218 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147220 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147220 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147223 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 147227 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147232 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147236 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147242 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147245 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147249 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147254 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147259 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147262 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147266 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147271 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147288 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 147295 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147300 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147313 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147319 */   GIR_RootConstrainSelectedInstOperands,
     /* 147320 */   // GIR_Coverage, 4112,
     /* 147320 */   GIR_EraseRootFromParent_Done,
     /* 147321 */ // Label 1995: @147321
     /* 147321 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(147460), // Rule ID 4128 //
     /* 147326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147336 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147340 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147344 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147348 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147352 */   // MIs[1] Operand 1
     /* 147352 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 147357 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147359 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147359 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147362 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147366 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147371 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147375 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147381 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147384 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147388 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147393 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147398 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147401 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147405 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147410 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147413 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147427 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 147434 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147439 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147449 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147458 */   GIR_RootConstrainSelectedInstOperands,
     /* 147459 */   // GIR_Coverage, 4128,
     /* 147459 */   GIR_EraseRootFromParent_Done,
     /* 147460 */ // Label 1996: @147460
     /* 147460 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(147599), // Rule ID 4160 //
     /* 147465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147475 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147483 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147487 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147491 */   // MIs[1] Operand 1
     /* 147491 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 147496 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147498 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147498 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147501 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147505 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147510 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147514 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147520 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147523 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147527 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147532 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147537 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147540 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147544 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147549 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147554 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147557 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147561 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147566 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 147573 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147578 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147588 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147597 */   GIR_RootConstrainSelectedInstOperands,
     /* 147598 */   // GIR_Coverage, 4160,
     /* 147598 */   GIR_EraseRootFromParent_Done,
     /* 147599 */ // Label 1997: @147599
     /* 147599 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(147738), // Rule ID 4192 //
     /* 147604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147614 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147618 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147622 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147626 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147630 */   // MIs[1] Operand 1
     /* 147630 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 147635 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147637 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147637 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147640 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147644 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147649 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147653 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147659 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147662 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147666 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147671 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147676 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147679 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147683 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147688 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147705 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 147712 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147717 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147736 */   GIR_RootConstrainSelectedInstOperands,
     /* 147737 */   // GIR_Coverage, 4192,
     /* 147737 */   GIR_EraseRootFromParent_Done,
     /* 147738 */ // Label 1998: @147738
     /* 147738 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(147877), // Rule ID 4224 //
     /* 147743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147753 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147757 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147761 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147765 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147769 */   // MIs[1] Operand 1
     /* 147769 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 147774 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147776 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147776 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147779 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147783 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147788 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147792 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147798 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147801 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147805 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147810 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147815 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147818 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147822 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147827 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147832 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147835 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147839 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147844 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 147851 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147856 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147875 */   GIR_RootConstrainSelectedInstOperands,
     /* 147876 */   // GIR_Coverage, 4224,
     /* 147876 */   GIR_EraseRootFromParent_Done,
     /* 147877 */ // Label 1999: @147877
     /* 147877 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(148016), // Rule ID 4254 //
     /* 147882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147892 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147896 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147900 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 147904 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 147908 */   // MIs[1] Operand 1
     /* 147908 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 147913 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147915 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147915 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147918 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 147922 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147927 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147931 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147937 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147940 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147944 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147949 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147954 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147957 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147961 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147966 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147971 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147974 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147978 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147983 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 147990 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148005 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148014 */   GIR_RootConstrainSelectedInstOperands,
     /* 148015 */   // GIR_Coverage, 4254,
     /* 148015 */   GIR_EraseRootFromParent_Done,
     /* 148016 */ // Label 2000: @148016
     /* 148016 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(148155), // Rule ID 4286 //
     /* 148021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148031 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148035 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148039 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148043 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148047 */   // MIs[1] Operand 1
     /* 148047 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 148052 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148054 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148054 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148057 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148061 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148066 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148070 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148076 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148079 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148083 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148088 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148093 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148096 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148100 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148105 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148122 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148129 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148134 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148147 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148153 */   GIR_RootConstrainSelectedInstOperands,
     /* 148154 */   // GIR_Coverage, 4286,
     /* 148154 */   GIR_EraseRootFromParent_Done,
     /* 148155 */ // Label 2001: @148155
     /* 148155 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(148294), // Rule ID 4318 //
     /* 148160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148178 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148182 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148186 */   // MIs[1] Operand 1
     /* 148186 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 148191 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148193 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148193 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148196 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148200 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148205 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148209 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148215 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148218 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148222 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148227 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148232 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148235 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148239 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148244 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148247 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148261 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 148268 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148273 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148286 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148292 */   GIR_RootConstrainSelectedInstOperands,
     /* 148293 */   // GIR_Coverage, 4318,
     /* 148293 */   GIR_EraseRootFromParent_Done,
     /* 148294 */ // Label 2002: @148294
     /* 148294 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(148433), // Rule ID 4350 //
     /* 148299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148309 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148313 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148317 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148321 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148325 */   // MIs[1] Operand 1
     /* 148325 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 148330 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148332 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148332 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148335 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148339 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148344 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148348 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148354 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148357 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148361 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148366 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148371 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148374 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148378 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148383 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148400 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 148407 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148412 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148431 */   GIR_RootConstrainSelectedInstOperands,
     /* 148432 */   // GIR_Coverage, 4350,
     /* 148432 */   GIR_EraseRootFromParent_Done,
     /* 148433 */ // Label 2003: @148433
     /* 148433 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(148572), // Rule ID 4581 //
     /* 148438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148456 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 148460 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 148464 */   // MIs[1] Operand 1
     /* 148464 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 148469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148471 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148471 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148474 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 148478 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148483 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148487 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148493 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148496 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148500 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148505 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148510 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148513 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148517 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148522 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148527 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148530 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148534 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148539 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148546 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148570 */   GIR_RootConstrainSelectedInstOperands,
     /* 148571 */   // GIR_Coverage, 4581,
     /* 148571 */   GIR_EraseRootFromParent_Done,
     /* 148572 */ // Label 2004: @148572
     /* 148572 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(148711), // Rule ID 4613 //
     /* 148577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148587 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148591 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148595 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 148599 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 148603 */   // MIs[1] Operand 1
     /* 148603 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 148608 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148610 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148610 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148613 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 148617 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148622 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148626 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148632 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148635 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148639 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148644 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148649 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148652 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148656 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148661 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148666 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148669 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148673 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148678 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148685 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148690 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148703 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148709 */   GIR_RootConstrainSelectedInstOperands,
     /* 148710 */   // GIR_Coverage, 4613,
     /* 148710 */   GIR_EraseRootFromParent_Done,
     /* 148711 */ // Label 2005: @148711
     /* 148711 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(148850), // Rule ID 4645 //
     /* 148716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148726 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148730 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148734 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 148738 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 148742 */   // MIs[1] Operand 1
     /* 148742 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 148747 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148749 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148749 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148752 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 148756 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148761 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148765 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148771 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148774 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148778 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148783 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148788 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148791 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148795 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148800 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148805 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148808 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148812 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148817 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148829 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148848 */   GIR_RootConstrainSelectedInstOperands,
     /* 148849 */   // GIR_Coverage, 4645,
     /* 148849 */   GIR_EraseRootFromParent_Done,
     /* 148850 */ // Label 2006: @148850
     /* 148850 */ GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(148989), // Rule ID 4689 //
     /* 148855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148865 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148869 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148873 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 148877 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 148881 */   // MIs[1] Operand 1
     /* 148881 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 148886 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148888 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148888 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148891 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 148895 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148900 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148904 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148910 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148913 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148917 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148922 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148927 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148930 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148934 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148939 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148956 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148963 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148968 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148978 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148981 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148984 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148987 */   GIR_RootConstrainSelectedInstOperands,
     /* 148988 */   // GIR_Coverage, 4689,
     /* 148988 */   GIR_EraseRootFromParent_Done,
     /* 148989 */ // Label 2007: @148989
     /* 148989 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(149128), // Rule ID 4721 //
     /* 148994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149004 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149008 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 149012 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149016 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149020 */   // MIs[1] Operand 1
     /* 149020 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 149025 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149027 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 149027 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149030 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 149034 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149039 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149043 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149049 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 149052 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149056 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149061 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149066 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149069 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149073 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149078 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149081 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149083 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149086 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149090 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149095 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149102 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149107 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149120 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149126 */   GIR_RootConstrainSelectedInstOperands,
     /* 149127 */   // GIR_Coverage, 4721,
     /* 149127 */   GIR_EraseRootFromParent_Done,
     /* 149128 */ // Label 2008: @149128
     /* 149128 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(149267), // Rule ID 4753 //
     /* 149133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 149136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 149151 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149155 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149159 */   // MIs[1] Operand 1
     /* 149159 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 149164 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149166 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 149166 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149169 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 149173 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149178 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149182 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149188 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 149191 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149195 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149200 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149205 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149208 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149212 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149217 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149234 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149241 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149246 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149256 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149259 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149265 */   GIR_RootConstrainSelectedInstOperands,
     /* 149266 */   // GIR_Coverage, 4753,
     /* 149266 */   GIR_EraseRootFromParent_Done,
     /* 149267 */ // Label 2009: @149267
     /* 149267 */ GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(149366), // Rule ID 2976 //
     /* 149272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149282 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149286 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149290 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149294 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149298 */   // MIs[1] Operand 1
     /* 149298 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 149303 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149305 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 149305 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149308 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 149312 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149317 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149321 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149339 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 149346 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149351 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149364 */   GIR_RootConstrainSelectedInstOperands,
     /* 149365 */   // GIR_Coverage, 2976,
     /* 149365 */   GIR_EraseRootFromParent_Done,
     /* 149366 */ // Label 2010: @149366
     /* 149366 */ GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(149465), // Rule ID 2990 //
     /* 149371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149381 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149385 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149389 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149393 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149397 */   // MIs[1] Operand 1
     /* 149397 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 149402 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149404 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 149404 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149407 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 149411 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149416 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149420 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149438 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 149445 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149450 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149460 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149463 */   GIR_RootConstrainSelectedInstOperands,
     /* 149464 */   // GIR_Coverage, 2990,
     /* 149464 */   GIR_EraseRootFromParent_Done,
     /* 149465 */ // Label 2011: @149465
     /* 149465 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(149564), // Rule ID 2998 //
     /* 149470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149480 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149484 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149488 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149492 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149496 */   // MIs[1] Operand 1
     /* 149496 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 149501 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149503 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 149503 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149506 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 149510 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149515 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149519 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149537 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149544 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149549 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149559 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149562 */   GIR_RootConstrainSelectedInstOperands,
     /* 149563 */   // GIR_Coverage, 2998,
     /* 149563 */   GIR_EraseRootFromParent_Done,
     /* 149564 */ // Label 2012: @149564
     /* 149564 */ GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(149663), // Rule ID 3006 //
     /* 149569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149579 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149583 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149587 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149591 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149595 */   // MIs[1] Operand 1
     /* 149595 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 149600 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149602 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 149602 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149605 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 149609 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149614 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149618 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149636 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149643 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149648 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149658 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149661 */   GIR_RootConstrainSelectedInstOperands,
     /* 149662 */   // GIR_Coverage, 3006,
     /* 149662 */   GIR_EraseRootFromParent_Done,
     /* 149663 */ // Label 2013: @149663
     /* 149663 */ GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(149762), // Rule ID 3014 //
     /* 149668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149678 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149682 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149686 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149690 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149694 */   // MIs[1] Operand 1
     /* 149694 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 149699 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149701 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 149701 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149704 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 149708 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149713 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149717 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149735 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 149742 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149747 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149760 */   GIR_RootConstrainSelectedInstOperands,
     /* 149761 */   // GIR_Coverage, 3014,
     /* 149761 */   GIR_EraseRootFromParent_Done,
     /* 149762 */ // Label 2014: @149762
     /* 149762 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(149861), // Rule ID 3078 //
     /* 149767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149777 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149785 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149789 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149793 */   // MIs[1] Operand 1
     /* 149793 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 149798 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149800 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 149800 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149803 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 149807 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149812 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149816 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149834 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 149841 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149846 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149856 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149859 */   GIR_RootConstrainSelectedInstOperands,
     /* 149860 */   // GIR_Coverage, 3078,
     /* 149860 */   GIR_EraseRootFromParent_Done,
     /* 149861 */ // Label 2015: @149861
     /* 149861 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(149960), // Rule ID 3086 //
     /* 149866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149876 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149884 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149888 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149892 */   // MIs[1] Operand 1
     /* 149892 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 149897 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149899 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 149899 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149902 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 149906 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149911 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149915 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149933 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 149940 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149945 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149958 */   GIR_RootConstrainSelectedInstOperands,
     /* 149959 */   // GIR_Coverage, 3086,
     /* 149959 */   GIR_EraseRootFromParent_Done,
     /* 149960 */ // Label 2016: @149960
     /* 149960 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(150059), // Rule ID 3094 //
     /* 149965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149975 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149979 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149983 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149987 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149991 */   // MIs[1] Operand 1
     /* 149991 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 149996 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149998 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 149998 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150001 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 150005 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150010 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150014 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150020 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150023 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150027 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150032 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150039 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150044 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150057 */   GIR_RootConstrainSelectedInstOperands,
     /* 150058 */   // GIR_Coverage, 3094,
     /* 150058 */   GIR_EraseRootFromParent_Done,
     /* 150059 */ // Label 2017: @150059
     /* 150059 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(150158), // Rule ID 3102 //
     /* 150064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150074 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150078 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150082 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150086 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150090 */   // MIs[1] Operand 1
     /* 150090 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 150095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150097 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 150097 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150100 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 150104 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150109 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150113 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150131 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150138 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150143 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150153 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150156 */   GIR_RootConstrainSelectedInstOperands,
     /* 150157 */   // GIR_Coverage, 3102,
     /* 150157 */   GIR_EraseRootFromParent_Done,
     /* 150158 */ // Label 2018: @150158
     /* 150158 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(150257), // Rule ID 3110 //
     /* 150163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150173 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150177 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150181 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150185 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150189 */   // MIs[1] Operand 1
     /* 150189 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 150194 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150196 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 150196 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150199 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 150203 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150208 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150212 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150230 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 150237 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150242 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150255 */   GIR_RootConstrainSelectedInstOperands,
     /* 150256 */   // GIR_Coverage, 3110,
     /* 150256 */   GIR_EraseRootFromParent_Done,
     /* 150257 */ // Label 2019: @150257
     /* 150257 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(150396), // Rule ID 3861 //
     /* 150262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150272 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150276 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150280 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150284 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150288 */   // MIs[1] Operand 1
     /* 150288 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 150293 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150295 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150295 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150298 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 150302 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150307 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150311 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150317 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150320 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150324 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150329 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150334 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150337 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150341 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150346 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150363 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 150370 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150375 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150385 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150388 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150394 */   GIR_RootConstrainSelectedInstOperands,
     /* 150395 */   // GIR_Coverage, 3861,
     /* 150395 */   GIR_EraseRootFromParent_Done,
     /* 150396 */ // Label 2020: @150396
     /* 150396 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(150535), // Rule ID 3869 //
     /* 150401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150411 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150415 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150419 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150423 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150427 */   // MIs[1] Operand 1
     /* 150427 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 150432 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150434 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150434 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150437 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 150441 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150446 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150450 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150456 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150459 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150463 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150468 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150473 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150476 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150480 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150485 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150502 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 150509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150533 */   GIR_RootConstrainSelectedInstOperands,
     /* 150534 */   // GIR_Coverage, 3869,
     /* 150534 */   GIR_EraseRootFromParent_Done,
     /* 150535 */ // Label 2021: @150535
     /* 150535 */ GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(150674), // Rule ID 3877 //
     /* 150540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150550 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150554 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150558 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150562 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150566 */   // MIs[1] Operand 1
     /* 150566 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 150571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150573 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150573 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150576 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 150580 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150585 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150589 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150595 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150598 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150602 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150607 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150612 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150615 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150619 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150624 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150641 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150648 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150653 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150672 */   GIR_RootConstrainSelectedInstOperands,
     /* 150673 */   // GIR_Coverage, 3877,
     /* 150673 */   GIR_EraseRootFromParent_Done,
     /* 150674 */ // Label 2022: @150674
     /* 150674 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(150813), // Rule ID 3885 //
     /* 150679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150697 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150701 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150705 */   // MIs[1] Operand 1
     /* 150705 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 150710 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150712 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150712 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150715 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 150719 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150724 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150728 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150734 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150737 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150741 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150746 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150751 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150754 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150758 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150763 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150780 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150787 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150792 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150802 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150805 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150811 */   GIR_RootConstrainSelectedInstOperands,
     /* 150812 */   // GIR_Coverage, 3885,
     /* 150812 */   GIR_EraseRootFromParent_Done,
     /* 150813 */ // Label 2023: @150813
     /* 150813 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(150952), // Rule ID 3893 //
     /* 150818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150828 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150832 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150836 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150840 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150844 */   // MIs[1] Operand 1
     /* 150844 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 150849 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150851 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150851 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150854 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 150858 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150863 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150867 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150873 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150876 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150880 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150885 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150890 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150893 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150897 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150902 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150919 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 150926 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150931 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150950 */   GIR_RootConstrainSelectedInstOperands,
     /* 150951 */   // GIR_Coverage, 3893,
     /* 150951 */   GIR_EraseRootFromParent_Done,
     /* 150952 */ // Label 2024: @150952
     /* 150952 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(151091), // Rule ID 3957 //
     /* 150957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150967 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150971 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150975 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150979 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150983 */   // MIs[1] Operand 1
     /* 150983 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 150988 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150990 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150990 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150993 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 150997 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151002 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151006 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151012 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151015 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151019 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151024 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151029 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151032 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151036 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151041 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151058 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 151065 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151070 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151086 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151089 */   GIR_RootConstrainSelectedInstOperands,
     /* 151090 */   // GIR_Coverage, 3957,
     /* 151090 */   GIR_EraseRootFromParent_Done,
     /* 151091 */ // Label 2025: @151091
     /* 151091 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(151230), // Rule ID 3965 //
     /* 151096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151106 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151110 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151114 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151118 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151122 */   // MIs[1] Operand 1
     /* 151122 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 151127 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151129 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151129 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151132 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 151136 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151141 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151145 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151151 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151154 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151158 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151163 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151168 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151171 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151175 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151180 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151185 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151188 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151192 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151197 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 151204 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151209 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151222 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151228 */   GIR_RootConstrainSelectedInstOperands,
     /* 151229 */   // GIR_Coverage, 3965,
     /* 151229 */   GIR_EraseRootFromParent_Done,
     /* 151230 */ // Label 2026: @151230
     /* 151230 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(151369), // Rule ID 3973 //
     /* 151235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151245 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151249 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151253 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151257 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151261 */   // MIs[1] Operand 1
     /* 151261 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 151266 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151268 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151268 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151271 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 151275 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151280 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151284 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151290 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151293 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151297 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151302 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151307 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151310 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151314 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151319 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151336 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151343 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151348 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151364 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151367 */   GIR_RootConstrainSelectedInstOperands,
     /* 151368 */   // GIR_Coverage, 3973,
     /* 151368 */   GIR_EraseRootFromParent_Done,
     /* 151369 */ // Label 2027: @151369
     /* 151369 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(151508), // Rule ID 3981 //
     /* 151374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151384 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151388 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151392 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151396 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151400 */   // MIs[1] Operand 1
     /* 151400 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 151405 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151407 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151407 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151410 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 151414 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151419 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151423 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151429 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151432 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151436 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151441 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151446 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151449 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151453 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151458 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151463 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151466 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151470 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151475 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151482 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151487 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151503 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151506 */   GIR_RootConstrainSelectedInstOperands,
     /* 151507 */   // GIR_Coverage, 3981,
     /* 151507 */   GIR_EraseRootFromParent_Done,
     /* 151508 */ // Label 2028: @151508
     /* 151508 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(151647), // Rule ID 3989 //
     /* 151513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151523 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151527 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151531 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151535 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151539 */   // MIs[1] Operand 1
     /* 151539 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 151544 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151546 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151546 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151549 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 151553 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151558 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151562 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151568 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151571 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151575 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151580 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151585 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151588 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151592 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151597 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151600 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151602 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151605 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151609 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151614 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 151621 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151626 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151642 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151645 */   GIR_RootConstrainSelectedInstOperands,
     /* 151646 */   // GIR_Coverage, 3989,
     /* 151646 */   GIR_EraseRootFromParent_Done,
     /* 151647 */ // Label 2029: @151647
     /* 151647 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(151669), // Rule ID 2982 //
     /* 151652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 151655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151662 */   // (zext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 151662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC8),
     /* 151667 */   GIR_RootConstrainSelectedInstOperands,
     /* 151668 */   // GIR_Coverage, 2982,
     /* 151668 */   GIR_Done,
     /* 151669 */ // Label 2030: @151669
     /* 151669 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(151730), // Rule ID 3667 //
     /* 151674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151681 */   // (zext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } 1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 151681 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 151684 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151688 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151693 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 151696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 151701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151710 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 151713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151720 */   GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 151722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 151728 */   GIR_RootConstrainSelectedInstOperands,
     /* 151729 */   // GIR_Coverage, 3667,
     /* 151729 */   GIR_EraseRootFromParent_Done,
     /* 151730 */ // Label 2031: @151730
     /* 151730 */ GIM_Reject,
     /* 151731 */ // Label 1845: @151731
     /* 151731 */ GIM_Reject,
     /* 151732 */ // Label 27: @151732
     /* 151732 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2039*/ GIMT_Encode4(152087),
     /* 151743 */ /*GILLT_s32*//*Label 2032*/ GIMT_Encode4(151771),
     /* 151747 */ /*GILLT_s64*//*Label 2033*/ GIMT_Encode4(151794),
     /* 151751 */ /*GILLT_s128*//*Label 2034*/ GIMT_Encode4(151817),
     /* 151755 */ /*GILLT_v2s64*//*Label 2035*/ GIMT_Encode4(151983),
     /* 151759 */ /*GILLT_v4s32*//*Label 2036*/ GIMT_Encode4(152009),
     /* 151763 */ /*GILLT_v8s16*//*Label 2037*/ GIMT_Encode4(152035),
     /* 151767 */ /*GILLT_v16s8*//*Label 2038*/ GIMT_Encode4(152061),
     /* 151771 */ // Label 2032: @151771
     /* 151771 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(151793), // Rule ID 1251 //
     /* 151776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 151779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 151786 */   // (shl:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SLW:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 151786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SLW),
     /* 151791 */   GIR_RootConstrainSelectedInstOperands,
     /* 151792 */   // GIR_Coverage, 1251,
     /* 151792 */   GIR_Done,
     /* 151793 */ // Label 2040: @151793
     /* 151793 */ GIM_Reject,
     /* 151794 */ // Label 2033: @151794
     /* 151794 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(151816), // Rule ID 1532 //
     /* 151799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 151802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151809 */   // (shl:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SLD:{ *:[i64] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 151809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SLD),
     /* 151814 */   GIR_RootConstrainSelectedInstOperands,
     /* 151815 */   // GIR_Coverage, 1532,
     /* 151815 */   GIR_Done,
     /* 151816 */ // Label 2041: @151816
     /* 151816 */ GIM_Reject,
     /* 151817 */ // Label 2034: @151817
     /* 151817 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(151982),
     /* 151822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 151825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 151828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 151832 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(151917), // Rule ID 3369 //
     /* 151837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 151840 */     // (shl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSLQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 151840 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 151843 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151847 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151852 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 151856 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 151861 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 151864 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151868 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151873 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 151877 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 151882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 151885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 151889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151894 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151897 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 151903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLQ),
     /* 151908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 151910 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 151912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151915 */     GIR_RootConstrainSelectedInstOperands,
     /* 151916 */     // GIR_Coverage, 3369,
     /* 151916 */     GIR_EraseRootFromParent_Done,
     /* 151917 */   // Label 2043: @151917
     /* 151917 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(151981), // Rule ID 1390 //
     /* 151922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 151925 */     // (shl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VSL:{ *:[v1i128] } (VSLO:{ *:[v16i8] } ?:{ *:[v1i128] }:$vA, ?:{ *:[v1i128] }:$vB), (VSPLTB:{ *:[v16i8] } 15:{ *:[i32] }, ?:{ *:[v1i128] }:$vB))
     /* 151925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::VSPLTB),
     /* 151932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151937 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 151940 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 151944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSLO),
     /* 151953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 151962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 151966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSL),
     /* 151971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 151973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 151979 */     GIR_RootConstrainSelectedInstOperands,
     /* 151980 */     // GIR_Coverage, 1390,
     /* 151980 */     GIR_EraseRootFromParent_Done,
     /* 151981 */   // Label 2044: @151981
     /* 151981 */   GIM_Reject,
     /* 151982 */ // Label 2042: @151982
     /* 151982 */ GIM_Reject,
     /* 151983 */ // Label 2035: @151983
     /* 151983 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(152008), // Rule ID 1438 //
     /* 151988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 151991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 151994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152001 */   // (shl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSLD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 152001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLD),
     /* 152006 */   GIR_RootConstrainSelectedInstOperands,
     /* 152007 */   // GIR_Coverage, 1438,
     /* 152007 */   GIR_Done,
     /* 152008 */ // Label 2045: @152008
     /* 152008 */ GIM_Reject,
     /* 152009 */ // Label 2036: @152009
     /* 152009 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(152034), // Rule ID 1389 //
     /* 152014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152027 */   // (shl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSLW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 152027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /* 152032 */   GIR_RootConstrainSelectedInstOperands,
     /* 152033 */   // GIR_Coverage, 1389,
     /* 152033 */   GIR_Done,
     /* 152034 */ // Label 2046: @152034
     /* 152034 */ GIM_Reject,
     /* 152035 */ // Label 2037: @152035
     /* 152035 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(152060), // Rule ID 1388 //
     /* 152040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152053 */   // (shl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSLH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 152053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLH),
     /* 152058 */   GIR_RootConstrainSelectedInstOperands,
     /* 152059 */   // GIR_Coverage, 1388,
     /* 152059 */   GIR_Done,
     /* 152060 */ // Label 2047: @152060
     /* 152060 */ GIM_Reject,
     /* 152061 */ // Label 2038: @152061
     /* 152061 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(152086), // Rule ID 1387 //
     /* 152066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 152072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152079 */   // (shl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSLB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 152079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLB),
     /* 152084 */   GIR_RootConstrainSelectedInstOperands,
     /* 152085 */   // GIR_Coverage, 1387,
     /* 152085 */   GIR_Done,
     /* 152086 */ // Label 2048: @152086
     /* 152086 */ GIM_Reject,
     /* 152087 */ // Label 2039: @152087
     /* 152087 */ GIM_Reject,
     /* 152088 */ // Label 28: @152088
     /* 152088 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2056*/ GIMT_Encode4(152509),
     /* 152099 */ /*GILLT_s32*//*Label 2049*/ GIMT_Encode4(152127),
     /* 152103 */ /*GILLT_s64*//*Label 2050*/ GIMT_Encode4(152216),
     /* 152107 */ /*GILLT_s128*//*Label 2051*/ GIMT_Encode4(152239),
     /* 152111 */ /*GILLT_v2s64*//*Label 2052*/ GIMT_Encode4(152405),
     /* 152115 */ /*GILLT_v4s32*//*Label 2053*/ GIMT_Encode4(152431),
     /* 152119 */ /*GILLT_v8s16*//*Label 2054*/ GIMT_Encode4(152457),
     /* 152123 */ /*GILLT_v16s8*//*Label 2055*/ GIMT_Encode4(152483),
     /* 152127 */ // Label 2049: @152127
     /* 152127 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(152215),
     /* 152132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 152142 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(152202), // Rule ID 3349 //
     /* 152147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 152150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 152158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 152162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 152166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152168 */     // (srl:{ *:[i32] } (bswap:{ *:[i32] } i32:{ *:[i32] }:$RS), 16:{ *:[i32] })  =>  (RLDICL_32:{ *:[i32] } (BRH:{ *:[i32] } ?:{ *:[i32] }:$RS), 0:{ *:[i32] }, 48:{ *:[i32] })
     /* 152168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 152171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::BRH),
     /* 152175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152180 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // RS
     /* 152184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32),
     /* 152189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 152200 */     GIR_RootConstrainSelectedInstOperands,
     /* 152201 */     // GIR_Coverage, 3349,
     /* 152201 */     GIR_EraseRootFromParent_Done,
     /* 152202 */   // Label 2058: @152202
     /* 152202 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(152214), // Rule ID 1250 //
     /* 152207 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRW:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRW),
     /* 152212 */     GIR_RootConstrainSelectedInstOperands,
     /* 152213 */     // GIR_Coverage, 1250,
     /* 152213 */     GIR_Done,
     /* 152214 */   // Label 2059: @152214
     /* 152214 */   GIM_Reject,
     /* 152215 */ // Label 2057: @152215
     /* 152215 */ GIM_Reject,
     /* 152216 */ // Label 2050: @152216
     /* 152216 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(152238), // Rule ID 1531 //
     /* 152221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 152224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 152231 */   // (srl:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRD:{ *:[i64] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRD),
     /* 152236 */   GIR_RootConstrainSelectedInstOperands,
     /* 152237 */   // GIR_Coverage, 1531,
     /* 152237 */   GIR_Done,
     /* 152238 */ // Label 2060: @152238
     /* 152238 */ GIM_Reject,
     /* 152239 */ // Label 2051: @152239
     /* 152239 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(152404),
     /* 152244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 152247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 152250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152254 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(152339), // Rule ID 3371 //
     /* 152259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 152262 */     // (srl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSRQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 152262 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 152265 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152269 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152274 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152278 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152283 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 152286 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152290 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152295 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152299 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 152307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 152311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152316 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152319 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152322 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 152325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRQ),
     /* 152330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152332 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 152334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152337 */     GIR_RootConstrainSelectedInstOperands,
     /* 152338 */     // GIR_Coverage, 3371,
     /* 152338 */     GIR_EraseRootFromParent_Done,
     /* 152339 */   // Label 2062: @152339
     /* 152339 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(152403), // Rule ID 1398 //
     /* 152344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152347 */     // (srl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VSR:{ *:[v1i128] } (VSRO:{ *:[v16i8] } ?:{ *:[v1i128] }:$vA, ?:{ *:[v1i128] }:$vB), (VSPLTB:{ *:[v16i8] } 15:{ *:[i32] }, ?:{ *:[v1i128] }:$vB))
     /* 152347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::VSPLTB),
     /* 152354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152359 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 152362 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 152366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSRO),
     /* 152375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 152384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 152388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSR),
     /* 152393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 152401 */     GIR_RootConstrainSelectedInstOperands,
     /* 152402 */     // GIR_Coverage, 1398,
     /* 152402 */     GIR_EraseRootFromParent_Done,
     /* 152403 */   // Label 2063: @152403
     /* 152403 */   GIM_Reject,
     /* 152404 */ // Label 2061: @152404
     /* 152404 */ GIM_Reject,
     /* 152405 */ // Label 2052: @152405
     /* 152405 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(152430), // Rule ID 1440 //
     /* 152410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 152413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152423 */   // (srl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSRD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 152423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRD),
     /* 152428 */   GIR_RootConstrainSelectedInstOperands,
     /* 152429 */   // GIR_Coverage, 1440,
     /* 152429 */   GIR_Done,
     /* 152430 */ // Label 2064: @152430
     /* 152430 */ GIM_Reject,
     /* 152431 */ // Label 2053: @152431
     /* 152431 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(152456), // Rule ID 1397 //
     /* 152436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152449 */   // (srl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSRW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 152449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRW),
     /* 152454 */   GIR_RootConstrainSelectedInstOperands,
     /* 152455 */   // GIR_Coverage, 1397,
     /* 152455 */   GIR_Done,
     /* 152456 */ // Label 2065: @152456
     /* 152456 */ GIM_Reject,
     /* 152457 */ // Label 2054: @152457
     /* 152457 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(152482), // Rule ID 1396 //
     /* 152462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152475 */   // (srl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSRH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 152475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRH),
     /* 152480 */   GIR_RootConstrainSelectedInstOperands,
     /* 152481 */   // GIR_Coverage, 1396,
     /* 152481 */   GIR_Done,
     /* 152482 */ // Label 2066: @152482
     /* 152482 */ GIM_Reject,
     /* 152483 */ // Label 2055: @152483
     /* 152483 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(152508), // Rule ID 1395 //
     /* 152488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 152494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152501 */   // (srl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSRB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 152501 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRB),
     /* 152506 */   GIR_RootConstrainSelectedInstOperands,
     /* 152507 */   // GIR_Coverage, 1395,
     /* 152507 */   GIR_Done,
     /* 152508 */ // Label 2067: @152508
     /* 152508 */ GIM_Reject,
     /* 152509 */ // Label 2056: @152509
     /* 152509 */ GIM_Reject,
     /* 152510 */ // Label 29: @152510
     /* 152510 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2075*/ GIMT_Encode4(152879),
     /* 152521 */ /*GILLT_s32*//*Label 2068*/ GIMT_Encode4(152549),
     /* 152525 */ /*GILLT_s64*//*Label 2069*/ GIMT_Encode4(152614),
     /* 152529 */ /*GILLT_s128*//*Label 2070*/ GIMT_Encode4(152679),
     /* 152533 */ /*GILLT_v2s64*//*Label 2071*/ GIMT_Encode4(152775),
     /* 152537 */ /*GILLT_v4s32*//*Label 2072*/ GIMT_Encode4(152801),
     /* 152541 */ /*GILLT_v8s16*//*Label 2073*/ GIMT_Encode4(152827),
     /* 152545 */ /*GILLT_v16s8*//*Label 2074*/ GIMT_Encode4(152853),
     /* 152549 */ // Label 2068: @152549
     /* 152549 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(152613),
     /* 152554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 152564 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(152594), // Rule ID 132 //
     /* 152569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152577 */     // MIs[1] Operand 1
     /* 152577 */     // No operand predicates
     /* 152577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152579 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$RST, (imm:{ *:[i32] }):$RB)  =>  (SRAWI:{ *:[i32] }:{ *:[i32] } i32:{ *:[i32] }:$RST, (imm:{ *:[i32] }):$RB)
     /* 152579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SRAWI),
     /* 152582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152584 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 152586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // RB
     /* 152589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /* 152592 */     GIR_RootConstrainSelectedInstOperands,
     /* 152593 */     // GIR_Coverage, 132,
     /* 152593 */     GIR_EraseRootFromParent_Done,
     /* 152594 */   // Label 2077: @152594
     /* 152594 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(152612), // Rule ID 1249 //
     /* 152599 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRAW:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRAW),
     /* 152604 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CARRY), GIMT_Encode2(RegState::Dead),
     /* 152610 */     GIR_RootConstrainSelectedInstOperands,
     /* 152611 */     // GIR_Coverage, 1249,
     /* 152611 */     GIR_Done,
     /* 152612 */   // Label 2078: @152612
     /* 152612 */   GIM_Reject,
     /* 152613 */ // Label 2076: @152613
     /* 152613 */ GIM_Reject,
     /* 152614 */ // Label 2069: @152614
     /* 152614 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(152678),
     /* 152619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 152622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 152629 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(152659), // Rule ID 681 //
     /* 152634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152642 */     // MIs[1] Operand 1
     /* 152642 */     // No operand predicates
     /* 152642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152644 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$RS, (imm:{ *:[i32] }):$SH)  =>  (SRADI:{ *:[i64] }:{ *:[i32] } i64:{ *:[i64] }:$RS, (imm:{ *:[i32] }):$SH)
     /* 152644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SRADI),
     /* 152647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152649 */     GIR_RootToRootCopy, /*OpIdx*/1, // RS
     /* 152651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SH
     /* 152654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /* 152657 */     GIR_RootConstrainSelectedInstOperands,
     /* 152658 */     // GIR_Coverage, 681,
     /* 152658 */     GIR_EraseRootFromParent_Done,
     /* 152659 */   // Label 2080: @152659
     /* 152659 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(152677), // Rule ID 1530 //
     /* 152664 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRAD:{ *:[i64] }:{ *:[i32] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRAD),
     /* 152669 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CARRY), GIMT_Encode2(RegState::Dead),
     /* 152675 */     GIR_RootConstrainSelectedInstOperands,
     /* 152676 */     // GIR_Coverage, 1530,
     /* 152676 */     GIR_Done,
     /* 152677 */   // Label 2081: @152677
     /* 152677 */   GIM_Reject,
     /* 152678 */ // Label 2079: @152678
     /* 152678 */ GIM_Reject,
     /* 152679 */ // Label 2070: @152679
     /* 152679 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(152774), // Rule ID 3373 //
     /* 152684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 152687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 152690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 152693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152697 */   // (sra:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSRAQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 152697 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 152700 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152704 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152709 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152713 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152718 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 152721 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152725 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152730 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152734 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 152742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 152746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152751 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152754 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152757 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 152760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAQ),
     /* 152765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152767 */   GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 152769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152772 */   GIR_RootConstrainSelectedInstOperands,
     /* 152773 */   // GIR_Coverage, 3373,
     /* 152773 */   GIR_EraseRootFromParent_Done,
     /* 152774 */ // Label 2082: @152774
     /* 152774 */ GIM_Reject,
     /* 152775 */ // Label 2071: @152775
     /* 152775 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(152800), // Rule ID 1442 //
     /* 152780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 152783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152793 */   // (sra:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSRAD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 152793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAD),
     /* 152798 */   GIR_RootConstrainSelectedInstOperands,
     /* 152799 */   // GIR_Coverage, 1442,
     /* 152799 */   GIR_Done,
     /* 152800 */ // Label 2083: @152800
     /* 152800 */ GIM_Reject,
     /* 152801 */ // Label 2072: @152801
     /* 152801 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(152826), // Rule ID 1405 //
     /* 152806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152819 */   // (sra:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSRAW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 152819 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAW),
     /* 152824 */   GIR_RootConstrainSelectedInstOperands,
     /* 152825 */   // GIR_Coverage, 1405,
     /* 152825 */   GIR_Done,
     /* 152826 */ // Label 2084: @152826
     /* 152826 */ GIM_Reject,
     /* 152827 */ // Label 2073: @152827
     /* 152827 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(152852), // Rule ID 1404 //
     /* 152832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152845 */   // (sra:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSRAH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 152845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAH),
     /* 152850 */   GIR_RootConstrainSelectedInstOperands,
     /* 152851 */   // GIR_Coverage, 1404,
     /* 152851 */   GIR_Done,
     /* 152852 */ // Label 2085: @152852
     /* 152852 */ GIM_Reject,
     /* 152853 */ // Label 2074: @152853
     /* 152853 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(152878), // Rule ID 1403 //
     /* 152858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 152864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152871 */   // (sra:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSRAB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 152871 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAB),
     /* 152876 */   GIR_RootConstrainSelectedInstOperands,
     /* 152877 */   // GIR_Coverage, 1403,
     /* 152877 */   GIR_Done,
     /* 152878 */ // Label 2086: @152878
     /* 152878 */ GIM_Reject,
     /* 152879 */ // Label 2075: @152879
     /* 152879 */ GIM_Reject,
     /* 152880 */ // Label 30: @152880
     /* 152880 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2094*/ GIMT_Encode4(153187),
     /* 152891 */ /*GILLT_s32*//*Label 2087*/ GIMT_Encode4(152919),
     /* 152895 */ /*GILLT_s64*//*Label 2088*/ GIMT_Encode4(152991),
     /* 152899 */ /*GILLT_s128*//*Label 2089*/ GIMT_Encode4(153057),
     /* 152903 */ /*GILLT_v2s64*//*Label 2090*/ GIMT_Encode4(153083),
     /* 152907 */ /*GILLT_v4s32*//*Label 2091*/ GIMT_Encode4(153109),
     /* 152911 */ /*GILLT_v8s16*//*Label 2092*/ GIMT_Encode4(153135),
     /* 152915 */ /*GILLT_v16s8*//*Label 2093*/ GIMT_Encode4(153161),
     /* 152919 */ // Label 2087: @152919
     /* 152919 */ GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(152990),
     /* 152924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 152934 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(152967), // Rule ID 1215 //
     /* 152939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152947 */     // MIs[1] Operand 1
     /* 152947 */     // No operand predicates
     /* 152947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152949 */     // (rotl:{ *:[i32] } i32:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm)  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm, 0:{ *:[i32] }, 31:{ *:[i32] })
     /* 152949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 152952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152954 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 152956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 152959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 152965 */     GIR_RootConstrainSelectedInstOperands,
     /* 152966 */     // GIR_Coverage, 1215,
     /* 152966 */     GIR_EraseRootFromParent_Done,
     /* 152967 */   // Label 2096: @152967
     /* 152967 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(152989), // Rule ID 1214 //
     /* 152972 */     // (rotl:{ *:[i32] } i32:{ *:[i32] }:$in, i32:{ *:[i32] }:$sh)  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$in, ?:{ *:[i32] }:$sh, 0:{ *:[i32] }, 31:{ *:[i32] })
     /* 152972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 152975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152977 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 152979 */     GIR_RootToRootCopy, /*OpIdx*/2, // sh
     /* 152981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 152987 */     GIR_RootConstrainSelectedInstOperands,
     /* 152988 */     // GIR_Coverage, 1214,
     /* 152988 */     GIR_EraseRootFromParent_Done,
     /* 152989 */   // Label 2097: @152989
     /* 152989 */   GIM_Reject,
     /* 152990 */ // Label 2095: @152990
     /* 152990 */ GIM_Reject,
     /* 152991 */ // Label 2088: @152991
     /* 152991 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(153056),
     /* 152996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 152999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 153006 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(153036), // Rule ID 1537 //
     /* 153011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153019 */     // MIs[1] Operand 1
     /* 153019 */     // No operand predicates
     /* 153019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153021 */     // (rotl:{ *:[i64] } i64:{ *:[i64] }:$in, (imm:{ *:[i32] }):$imm)  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$in, (imm:{ *:[i32] }):$imm, 0:{ *:[i32] })
     /* 153021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 153024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 153026 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 153028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 153031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153034 */     GIR_RootConstrainSelectedInstOperands,
     /* 153035 */     // GIR_Coverage, 1537,
     /* 153035 */     GIR_EraseRootFromParent_Done,
     /* 153036 */   // Label 2099: @153036
     /* 153036 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(153055), // Rule ID 1536 //
     /* 153041 */     // (rotl:{ *:[i64] } i64:{ *:[i64] }:$in, i32:{ *:[i32] }:$sh)  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$in, ?:{ *:[i32] }:$sh, 0:{ *:[i32] })
     /* 153041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 153044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 153046 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 153048 */     GIR_RootToRootCopy, /*OpIdx*/2, // sh
     /* 153050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153053 */     GIR_RootConstrainSelectedInstOperands,
     /* 153054 */     // GIR_Coverage, 1536,
     /* 153054 */     GIR_EraseRootFromParent_Done,
     /* 153055 */   // Label 2100: @153055
     /* 153055 */   GIM_Reject,
     /* 153056 */ // Label 2098: @153056
     /* 153056 */ GIM_Reject,
     /* 153057 */ // Label 2089: @153057
     /* 153057 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(153082), // Rule ID 3355 //
     /* 153062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 153068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 153071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153075 */   // (rotl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VRLQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)
     /* 153075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLQ),
     /* 153080 */   GIR_RootConstrainSelectedInstOperands,
     /* 153081 */   // GIR_Coverage, 3355,
     /* 153081 */   GIR_Done,
     /* 153082 */ // Label 2101: @153082
     /* 153082 */ GIM_Reject,
     /* 153083 */ // Label 2090: @153083
     /* 153083 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(153108), // Rule ID 1437 //
     /* 153088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 153091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153101 */   // (rotl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VRLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)
     /* 153101 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLD),
     /* 153106 */   GIR_RootConstrainSelectedInstOperands,
     /* 153107 */   // GIR_Coverage, 1437,
     /* 153107 */   GIR_Done,
     /* 153108 */ // Label 2102: @153108
     /* 153108 */ GIM_Reject,
     /* 153109 */ // Label 2091: @153109
     /* 153109 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(153134), // Rule ID 1288 //
     /* 153114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153127 */   // (rotl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VRLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)
     /* 153127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLW),
     /* 153132 */   GIR_RootConstrainSelectedInstOperands,
     /* 153133 */   // GIR_Coverage, 1288,
     /* 153133 */   GIR_Done,
     /* 153134 */ // Label 2103: @153134
     /* 153134 */ GIM_Reject,
     /* 153135 */ // Label 2092: @153135
     /* 153135 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(153160), // Rule ID 1287 //
     /* 153140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153153 */   // (rotl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VRLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)
     /* 153153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLH),
     /* 153158 */   GIR_RootConstrainSelectedInstOperands,
     /* 153159 */   // GIR_Coverage, 1287,
     /* 153159 */   GIR_Done,
     /* 153160 */ // Label 2104: @153160
     /* 153160 */ GIM_Reject,
     /* 153161 */ // Label 2093: @153161
     /* 153161 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(153186), // Rule ID 1286 //
     /* 153166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 153172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 153175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153179 */   // (rotl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)
     /* 153179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLB),
     /* 153184 */   GIR_RootConstrainSelectedInstOperands,
     /* 153185 */   // GIR_Coverage, 1286,
     /* 153185 */   GIR_Done,
     /* 153186 */ // Label 2105: @153186
     /* 153186 */ GIM_Reject,
     /* 153187 */ // Label 2094: @153187
     /* 153187 */ GIM_Reject,
     /* 153188 */ // Label 31: @153188
     /* 153188 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(157189),
     /* 153193 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 153196 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2109*/ GIMT_Encode4(153765),
     /* 153207 */   /*GILLT_s32*//*Label 2107*/ GIMT_Encode4(153215),
     /* 153211 */   /*GILLT_s64*//*Label 2108*/ GIMT_Encode4(153490),
     /* 153215 */   // Label 2107: @153215
     /* 153215 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(153489),
     /* 153220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153227 */     GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(153314), // Rule ID 3027 //
     /* 153232 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153235 */       // MIs[0] Operand 1
     /* 153235 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 153240 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153244 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153248 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153252 */       // MIs[1] Operand 1
     /* 153252 */       // No operand predicates
     /* 153252 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153254 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 153254 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153257 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153261 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153266 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153270 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153273 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153275 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153278 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153282 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153287 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153294 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153299 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153304 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153307 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153309 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153312 */       GIR_RootConstrainSelectedInstOperands,
     /* 153313 */       // GIR_Coverage, 3027,
     /* 153313 */       GIR_EraseRootFromParent_Done,
     /* 153314 */     // Label 2111: @153314
     /* 153314 */     GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(153401), // Rule ID 3043 //
     /* 153319 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153322 */       // MIs[0] Operand 1
     /* 153322 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 153327 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153331 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153335 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153339 */       // MIs[1] Operand 1
     /* 153339 */       // No operand predicates
     /* 153339 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153341 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 153341 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153344 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153348 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153353 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153357 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153360 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153362 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153365 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153369 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153374 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153381 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153386 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153391 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153394 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153396 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153399 */       GIR_RootConstrainSelectedInstOperands,
     /* 153400 */       // GIR_Coverage, 3043,
     /* 153400 */       GIR_EraseRootFromParent_Done,
     /* 153401 */     // Label 2112: @153401
     /* 153401 */     GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(153488), // Rule ID 3051 //
     /* 153406 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153409 */       // MIs[0] Operand 1
     /* 153409 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 153414 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153418 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153422 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153426 */       // MIs[1] Operand 1
     /* 153426 */       // No operand predicates
     /* 153426 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153428 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 153428 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153431 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153435 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153440 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153444 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153447 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153449 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153452 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153456 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153461 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 153468 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153473 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153478 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153481 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153483 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153486 */       GIR_RootConstrainSelectedInstOperands,
     /* 153487 */       // GIR_Coverage, 3051,
     /* 153487 */       GIR_EraseRootFromParent_Done,
     /* 153488 */     // Label 2113: @153488
     /* 153488 */     GIM_Reject,
     /* 153489 */   // Label 2110: @153489
     /* 153489 */   GIM_Reject,
     /* 153490 */   // Label 2108: @153490
     /* 153490 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(153764),
     /* 153495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 153498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153502 */     GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(153589), // Rule ID 3123 //
     /* 153507 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153510 */       // MIs[0] Operand 1
     /* 153510 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 153515 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153519 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153523 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 153527 */       // MIs[1] Operand 1
     /* 153527 */       // No operand predicates
     /* 153527 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153529 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 153529 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153532 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 153536 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153541 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153545 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153548 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153550 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153553 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153557 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153562 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153569 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153574 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153579 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153582 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153584 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153587 */       GIR_RootConstrainSelectedInstOperands,
     /* 153588 */       // GIR_Coverage, 3123,
     /* 153588 */       GIR_EraseRootFromParent_Done,
     /* 153589 */     // Label 2115: @153589
     /* 153589 */     GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(153676), // Rule ID 3139 //
     /* 153594 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153597 */       // MIs[0] Operand 1
     /* 153597 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 153602 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153606 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153610 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 153614 */       // MIs[1] Operand 1
     /* 153614 */       // No operand predicates
     /* 153614 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153616 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 153616 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153619 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 153623 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153628 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153632 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153635 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153637 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153640 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153644 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153649 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153656 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153661 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153666 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153669 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153671 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153674 */       GIR_RootConstrainSelectedInstOperands,
     /* 153675 */       // GIR_Coverage, 3139,
     /* 153675 */       GIR_EraseRootFromParent_Done,
     /* 153676 */     // Label 2116: @153676
     /* 153676 */     GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(153763), // Rule ID 3147 //
     /* 153681 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153684 */       // MIs[0] Operand 1
     /* 153684 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 153689 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153693 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153697 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 153701 */       // MIs[1] Operand 1
     /* 153701 */       // No operand predicates
     /* 153701 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153703 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 153703 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153706 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 153710 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153715 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153719 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153722 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153724 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153727 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153731 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153736 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 153743 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153748 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153753 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153756 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153758 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153761 */       GIR_RootConstrainSelectedInstOperands,
     /* 153762 */       // GIR_Coverage, 3147,
     /* 153762 */       GIR_EraseRootFromParent_Done,
     /* 153763 */     // Label 2117: @153763
     /* 153763 */     GIM_Reject,
     /* 153764 */   // Label 2114: @153764
     /* 153764 */   GIM_Reject,
     /* 153765 */   // Label 2109: @153765
     /* 153765 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2120*/ GIMT_Encode4(154220),
     /* 153776 */   /*GILLT_s32*//*Label 2118*/ GIMT_Encode4(153784),
     /* 153780 */   /*GILLT_s64*//*Label 2119*/ GIMT_Encode4(154002),
     /* 153784 */   // Label 2118: @153784
     /* 153784 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(154001),
     /* 153789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153796 */     GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(153864), // Rule ID 3786 //
     /* 153801 */       // MIs[0] Operand 1
     /* 153801 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 153806 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153810 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153814 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153818 */       // MIs[1] Operand 1
     /* 153818 */       // No operand predicates
     /* 153818 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153820 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /* 153820 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153823 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153827 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153832 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153836 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 153839 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153841 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153844 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153846 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153853 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153858 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153863 */       // GIR_Coverage, 3786,
     /* 153863 */       GIR_EraseRootFromParent_Done,
     /* 153864 */     // Label 2122: @153864
     /* 153864 */     GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(153932), // Rule ID 3788 //
     /* 153869 */       // MIs[0] Operand 1
     /* 153869 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 153874 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153878 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153882 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153886 */       // MIs[1] Operand 1
     /* 153886 */       // No operand predicates
     /* 153886 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153888 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /* 153888 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153891 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153895 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153900 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153904 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 153907 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153909 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153912 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153914 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153921 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153926 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153931 */       // GIR_Coverage, 3788,
     /* 153931 */       GIR_EraseRootFromParent_Done,
     /* 153932 */     // Label 2123: @153932
     /* 153932 */     GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(154000), // Rule ID 3789 //
     /* 153937 */       // MIs[0] Operand 1
     /* 153937 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 153942 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153946 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153950 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153954 */       // MIs[1] Operand 1
     /* 153954 */       // No operand predicates
     /* 153954 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153956 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /* 153956 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153959 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153963 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153968 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153972 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 153975 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153977 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153980 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153982 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 153989 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153994 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153999 */       // GIR_Coverage, 3789,
     /* 153999 */       GIR_EraseRootFromParent_Done,
     /* 154000 */     // Label 2124: @154000
     /* 154000 */     GIM_Reject,
     /* 154001 */   // Label 2121: @154001
     /* 154001 */   GIM_Reject,
     /* 154002 */   // Label 2119: @154002
     /* 154002 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(154219),
     /* 154007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 154010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154014 */     GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(154082), // Rule ID 3798 //
     /* 154019 */       // MIs[0] Operand 1
     /* 154019 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 154024 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154028 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154032 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154036 */       // MIs[1] Operand 1
     /* 154036 */       // No operand predicates
     /* 154036 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154038 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /* 154038 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154041 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154045 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154050 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154054 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154057 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154059 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154062 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154064 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154071 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154076 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154081 */       // GIR_Coverage, 3798,
     /* 154081 */       GIR_EraseRootFromParent_Done,
     /* 154082 */     // Label 2126: @154082
     /* 154082 */     GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(154150), // Rule ID 3800 //
     /* 154087 */       // MIs[0] Operand 1
     /* 154087 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 154092 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154096 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154100 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154104 */       // MIs[1] Operand 1
     /* 154104 */       // No operand predicates
     /* 154104 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154106 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /* 154106 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154109 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154113 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154118 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154122 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154125 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154127 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154130 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154132 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154139 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154144 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154149 */       // GIR_Coverage, 3800,
     /* 154149 */       GIR_EraseRootFromParent_Done,
     /* 154150 */     // Label 2127: @154150
     /* 154150 */     GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(154218), // Rule ID 3801 //
     /* 154155 */       // MIs[0] Operand 1
     /* 154155 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 154160 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154164 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154168 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154172 */       // MIs[1] Operand 1
     /* 154172 */       // No operand predicates
     /* 154172 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154174 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /* 154174 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154177 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154181 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154186 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154190 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154193 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154195 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154198 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154200 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154207 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154212 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154217 */       // GIR_Coverage, 3801,
     /* 154217 */       GIR_EraseRootFromParent_Done,
     /* 154218 */     // Label 2128: @154218
     /* 154218 */     GIM_Reject,
     /* 154219 */   // Label 2125: @154219
     /* 154219 */   GIM_Reject,
     /* 154220 */   // Label 2120: @154220
     /* 154220 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2131*/ GIMT_Encode4(154789),
     /* 154231 */   /*GILLT_s32*//*Label 2129*/ GIMT_Encode4(154239),
     /* 154235 */   /*GILLT_s64*//*Label 2130*/ GIMT_Encode4(154514),
     /* 154239 */   // Label 2129: @154239
     /* 154239 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(154513),
     /* 154244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154251 */     GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(154338), // Rule ID 3809 //
     /* 154256 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154259 */       // MIs[0] Operand 1
     /* 154259 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 154264 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154268 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154272 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154276 */       // MIs[1] Operand 1
     /* 154276 */       // No operand predicates
     /* 154276 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154278 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 154278 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154281 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154285 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154290 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154294 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154297 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154299 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154302 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154306 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154311 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154318 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154323 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154328 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154331 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154333 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154336 */       GIR_RootConstrainSelectedInstOperands,
     /* 154337 */       // GIR_Coverage, 3809,
     /* 154337 */       GIR_EraseRootFromParent_Done,
     /* 154338 */     // Label 2133: @154338
     /* 154338 */     GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(154425), // Rule ID 3825 //
     /* 154343 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154346 */       // MIs[0] Operand 1
     /* 154346 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 154351 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154355 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154359 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154363 */       // MIs[1] Operand 1
     /* 154363 */       // No operand predicates
     /* 154363 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154365 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 154365 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154368 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154372 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154377 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154381 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154384 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154386 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154389 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154393 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154398 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154410 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154415 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154418 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154420 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154423 */       GIR_RootConstrainSelectedInstOperands,
     /* 154424 */       // GIR_Coverage, 3825,
     /* 154424 */       GIR_EraseRootFromParent_Done,
     /* 154425 */     // Label 2134: @154425
     /* 154425 */     GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(154512), // Rule ID 3833 //
     /* 154430 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154433 */       // MIs[0] Operand 1
     /* 154433 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 154438 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154442 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154446 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154450 */       // MIs[1] Operand 1
     /* 154450 */       // No operand predicates
     /* 154450 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154452 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 154452 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154455 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154459 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154464 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154468 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154471 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154473 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154476 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154480 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154485 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154492 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154497 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154502 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154505 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154507 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154510 */       GIR_RootConstrainSelectedInstOperands,
     /* 154511 */       // GIR_Coverage, 3833,
     /* 154511 */       GIR_EraseRootFromParent_Done,
     /* 154512 */     // Label 2135: @154512
     /* 154512 */     GIM_Reject,
     /* 154513 */   // Label 2132: @154513
     /* 154513 */   GIM_Reject,
     /* 154514 */   // Label 2130: @154514
     /* 154514 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(154788),
     /* 154519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 154522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154526 */     GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(154613), // Rule ID 3905 //
     /* 154531 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154534 */       // MIs[0] Operand 1
     /* 154534 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 154539 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154543 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154547 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154551 */       // MIs[1] Operand 1
     /* 154551 */       // No operand predicates
     /* 154551 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154553 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 154553 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154556 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154560 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154565 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154569 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154572 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154574 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154577 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154581 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154586 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154593 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154598 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154603 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154606 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154608 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154611 */       GIR_RootConstrainSelectedInstOperands,
     /* 154612 */       // GIR_Coverage, 3905,
     /* 154612 */       GIR_EraseRootFromParent_Done,
     /* 154613 */     // Label 2137: @154613
     /* 154613 */     GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(154700), // Rule ID 3921 //
     /* 154618 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154621 */       // MIs[0] Operand 1
     /* 154621 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 154626 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154630 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154634 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154638 */       // MIs[1] Operand 1
     /* 154638 */       // No operand predicates
     /* 154638 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154640 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 154640 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154643 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154647 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154652 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154656 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154659 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154661 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154664 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154668 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154673 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154680 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154685 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154690 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154693 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154695 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154698 */       GIR_RootConstrainSelectedInstOperands,
     /* 154699 */       // GIR_Coverage, 3921,
     /* 154699 */       GIR_EraseRootFromParent_Done,
     /* 154700 */     // Label 2138: @154700
     /* 154700 */     GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(154787), // Rule ID 3929 //
     /* 154705 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154708 */       // MIs[0] Operand 1
     /* 154708 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 154713 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154717 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154721 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154725 */       // MIs[1] Operand 1
     /* 154725 */       // No operand predicates
     /* 154725 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154727 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 154727 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154730 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154734 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154739 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154743 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154746 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154748 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154751 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154755 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154760 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154767 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154772 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154777 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154780 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154782 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154785 */       GIR_RootConstrainSelectedInstOperands,
     /* 154786 */       // GIR_Coverage, 3929,
     /* 154786 */       GIR_EraseRootFromParent_Done,
     /* 154787 */     // Label 2139: @154787
     /* 154787 */     GIM_Reject,
     /* 154788 */   // Label 2136: @154788
     /* 154788 */   GIM_Reject,
     /* 154789 */   // Label 2131: @154789
     /* 154789 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2143*/ GIMT_Encode4(155804),
     /* 154800 */   /*GILLT_s1*//*Label 2140*/ GIMT_Encode4(154812),
     /* 154804 */   /*GILLT_s32*//*Label 2141*/ GIMT_Encode4(155036),
     /* 154808 */   /*GILLT_s64*//*Label 2142*/ GIMT_Encode4(155420),
     /* 154812 */   // Label 2140: @154812
     /* 154812 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(155035),
     /* 154817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s1,
     /* 154820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154824 */     GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(154845), // Rule ID 3671 //
     /* 154829 */       // MIs[0] Operand 1
     /* 154829 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 154834 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETLT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 154834 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 154837 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154839 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154841 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154843 */       GIR_RootConstrainSelectedInstOperands,
     /* 154844 */       // GIR_Coverage, 3671,
     /* 154844 */       GIR_EraseRootFromParent_Done,
     /* 154845 */     // Label 2145: @154845
     /* 154845 */     GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(154866), // Rule ID 3672 //
     /* 154850 */       // MIs[0] Operand 1
     /* 154850 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 154855 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETULT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 154855 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 154858 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154860 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154862 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154864 */       GIR_RootConstrainSelectedInstOperands,
     /* 154865 */       // GIR_Coverage, 3672,
     /* 154865 */       GIR_EraseRootFromParent_Done,
     /* 154866 */     // Label 2146: @154866
     /* 154866 */     GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(154887), // Rule ID 3673 //
     /* 154871 */       // MIs[0] Operand 1
     /* 154871 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 154876 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETLE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 154876 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 154879 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154881 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154883 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154885 */       GIR_RootConstrainSelectedInstOperands,
     /* 154886 */       // GIR_Coverage, 3673,
     /* 154886 */       GIR_EraseRootFromParent_Done,
     /* 154887 */     // Label 2147: @154887
     /* 154887 */     GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(154908), // Rule ID 3674 //
     /* 154892 */       // MIs[0] Operand 1
     /* 154892 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 154897 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETULE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 154897 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 154900 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154902 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154904 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154906 */       GIR_RootConstrainSelectedInstOperands,
     /* 154907 */       // GIR_Coverage, 3674,
     /* 154907 */       GIR_EraseRootFromParent_Done,
     /* 154908 */     // Label 2148: @154908
     /* 154908 */     GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(154929), // Rule ID 3675 //
     /* 154913 */       // MIs[0] Operand 1
     /* 154913 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 154918 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETEQ:{ *:[Other] })  =>  (CREQV:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 154918 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /* 154921 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154923 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154925 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154927 */       GIR_RootConstrainSelectedInstOperands,
     /* 154928 */       // GIR_Coverage, 3675,
     /* 154928 */       GIR_EraseRootFromParent_Done,
     /* 154929 */     // Label 2149: @154929
     /* 154929 */     GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(154950), // Rule ID 3676 //
     /* 154934 */       // MIs[0] Operand 1
     /* 154934 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 154939 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETGE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 154939 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 154942 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154944 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154946 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154948 */       GIR_RootConstrainSelectedInstOperands,
     /* 154949 */       // GIR_Coverage, 3676,
     /* 154949 */       GIR_EraseRootFromParent_Done,
     /* 154950 */     // Label 2150: @154950
     /* 154950 */     GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(154971), // Rule ID 3677 //
     /* 154955 */       // MIs[0] Operand 1
     /* 154955 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 154960 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETUGE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 154960 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 154963 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154965 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154967 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154969 */       GIR_RootConstrainSelectedInstOperands,
     /* 154970 */       // GIR_Coverage, 3677,
     /* 154970 */       GIR_EraseRootFromParent_Done,
     /* 154971 */     // Label 2151: @154971
     /* 154971 */     GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(154992), // Rule ID 3678 //
     /* 154976 */       // MIs[0] Operand 1
     /* 154976 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 154981 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETGT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 154981 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 154984 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154986 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 154988 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 154990 */       GIR_RootConstrainSelectedInstOperands,
     /* 154991 */       // GIR_Coverage, 3678,
     /* 154991 */       GIR_EraseRootFromParent_Done,
     /* 154992 */     // Label 2152: @154992
     /* 154992 */     GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(155013), // Rule ID 3679 //
     /* 154997 */       // MIs[0] Operand 1
     /* 154997 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 155002 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETUGT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155002 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 155005 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155007 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155009 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155011 */       GIR_RootConstrainSelectedInstOperands,
     /* 155012 */       // GIR_Coverage, 3679,
     /* 155012 */       GIR_EraseRootFromParent_Done,
     /* 155013 */     // Label 2153: @155013
     /* 155013 */     GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(155034), // Rule ID 3680 //
     /* 155018 */       // MIs[0] Operand 1
     /* 155018 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 155023 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETNE:{ *:[Other] })  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155023 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /* 155026 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155028 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155030 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155032 */       GIR_RootConstrainSelectedInstOperands,
     /* 155033 */       // GIR_Coverage, 3680,
     /* 155033 */       GIR_EraseRootFromParent_Done,
     /* 155034 */     // Label 2154: @155034
     /* 155034 */     GIM_Reject,
     /* 155035 */   // Label 2144: @155035
     /* 155035 */   GIM_Reject,
     /* 155036 */   // Label 2141: @155036
     /* 155036 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(155419),
     /* 155041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155048 */     GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(155122), // Rule ID 2973 //
     /* 155053 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155056 */       // MIs[0] Operand 1
     /* 155056 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 155061 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 155061 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155064 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 155068 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155073 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155077 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155081 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155083 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155086 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155090 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155095 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155102 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155107 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155112 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155115 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155117 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155120 */       GIR_RootConstrainSelectedInstOperands,
     /* 155121 */       // GIR_Coverage, 2973,
     /* 155121 */       GIR_EraseRootFromParent_Done,
     /* 155122 */     // Label 2156: @155122
     /* 155122 */     GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(155196), // Rule ID 2987 //
     /* 155127 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155130 */       // MIs[0] Operand 1
     /* 155130 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 155135 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 155135 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155138 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155142 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155147 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155151 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155155 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155157 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155160 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155164 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155169 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155176 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155181 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155186 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155189 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155191 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155194 */       GIR_RootConstrainSelectedInstOperands,
     /* 155195 */       // GIR_Coverage, 2987,
     /* 155195 */       GIR_EraseRootFromParent_Done,
     /* 155196 */     // Label 2157: @155196
     /* 155196 */     GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(155270), // Rule ID 2995 //
     /* 155201 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155204 */       // MIs[0] Operand 1
     /* 155204 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 155209 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 155209 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155212 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 155216 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155221 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155225 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155229 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155231 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155234 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155238 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155243 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155250 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155255 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155260 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155263 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155265 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155268 */       GIR_RootConstrainSelectedInstOperands,
     /* 155269 */       // GIR_Coverage, 2995,
     /* 155269 */       GIR_EraseRootFromParent_Done,
     /* 155270 */     // Label 2158: @155270
     /* 155270 */     GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(155344), // Rule ID 3003 //
     /* 155275 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155278 */       // MIs[0] Operand 1
     /* 155278 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 155283 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 155283 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155286 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155290 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155295 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155299 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155303 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155305 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155308 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155312 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155317 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155324 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155329 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155334 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155337 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155339 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155342 */       GIR_RootConstrainSelectedInstOperands,
     /* 155343 */       // GIR_Coverage, 3003,
     /* 155343 */       GIR_EraseRootFromParent_Done,
     /* 155344 */     // Label 2159: @155344
     /* 155344 */     GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(155418), // Rule ID 3011 //
     /* 155349 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155352 */       // MIs[0] Operand 1
     /* 155352 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 155357 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 155357 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155360 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155364 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155369 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155373 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155377 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155379 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155382 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155386 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155391 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 155398 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155403 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155408 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155411 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155413 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155416 */       GIR_RootConstrainSelectedInstOperands,
     /* 155417 */       // GIR_Coverage, 3011,
     /* 155417 */       GIR_EraseRootFromParent_Done,
     /* 155418 */     // Label 2160: @155418
     /* 155418 */     GIM_Reject,
     /* 155419 */   // Label 2155: @155419
     /* 155419 */   GIM_Reject,
     /* 155420 */   // Label 2142: @155420
     /* 155420 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(155803),
     /* 155425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155432 */     GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(155506), // Rule ID 3075 //
     /* 155437 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155440 */       // MIs[0] Operand 1
     /* 155440 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 155445 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 155445 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155448 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 155452 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155457 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155461 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155465 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155467 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155470 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155474 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155479 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155486 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155491 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155496 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155499 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155501 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155504 */       GIR_RootConstrainSelectedInstOperands,
     /* 155505 */       // GIR_Coverage, 3075,
     /* 155505 */       GIR_EraseRootFromParent_Done,
     /* 155506 */     // Label 2162: @155506
     /* 155506 */     GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(155580), // Rule ID 3083 //
     /* 155511 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155514 */       // MIs[0] Operand 1
     /* 155514 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 155519 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 155519 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155522 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 155526 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155531 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155535 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155539 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155541 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155544 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155548 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155553 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155560 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155565 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155570 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155573 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155575 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155578 */       GIR_RootConstrainSelectedInstOperands,
     /* 155579 */       // GIR_Coverage, 3083,
     /* 155579 */       GIR_EraseRootFromParent_Done,
     /* 155580 */     // Label 2163: @155580
     /* 155580 */     GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(155654), // Rule ID 3091 //
     /* 155585 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155588 */       // MIs[0] Operand 1
     /* 155588 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 155593 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 155593 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155596 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 155600 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155605 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155609 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155613 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155615 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155618 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155622 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155627 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155634 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155639 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155644 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155647 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155649 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155652 */       GIR_RootConstrainSelectedInstOperands,
     /* 155653 */       // GIR_Coverage, 3091,
     /* 155653 */       GIR_EraseRootFromParent_Done,
     /* 155654 */     // Label 2164: @155654
     /* 155654 */     GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(155728), // Rule ID 3099 //
     /* 155659 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155662 */       // MIs[0] Operand 1
     /* 155662 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 155667 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 155667 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155670 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 155674 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155679 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155683 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155687 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155689 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155692 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155696 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155701 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155708 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155713 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155718 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155721 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155723 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155726 */       GIR_RootConstrainSelectedInstOperands,
     /* 155727 */       // GIR_Coverage, 3099,
     /* 155727 */       GIR_EraseRootFromParent_Done,
     /* 155728 */     // Label 2165: @155728
     /* 155728 */     GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(155802), // Rule ID 3107 //
     /* 155733 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155736 */       // MIs[0] Operand 1
     /* 155736 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 155741 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 155741 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155744 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 155748 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155753 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155757 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155761 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155763 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155766 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155770 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155775 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 155782 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155787 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155792 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155795 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155797 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155800 */       GIR_RootConstrainSelectedInstOperands,
     /* 155801 */       // GIR_Coverage, 3107,
     /* 155801 */       GIR_EraseRootFromParent_Done,
     /* 155802 */     // Label 2166: @155802
     /* 155802 */     GIM_Reject,
     /* 155803 */   // Label 2161: @155803
     /* 155803 */   GIM_Reject,
     /* 155804 */   // Label 2143: @155804
     /* 155804 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2169*/ GIMT_Encode4(156401),
     /* 155815 */   /*GILLT_s32*//*Label 2167*/ GIMT_Encode4(155823),
     /* 155819 */   /*GILLT_s64*//*Label 2168*/ GIMT_Encode4(156112),
     /* 155823 */   // Label 2167: @155823
     /* 155823 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(156111),
     /* 155828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155835 */     GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(155890), // Rule ID 3792 //
     /* 155840 */       // MIs[0] Operand 1
     /* 155840 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 155845 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /* 155845 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155848 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 155852 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155857 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155861 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155865 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155867 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155870 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155872 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155879 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155884 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155889 */       // GIR_Coverage, 3792,
     /* 155889 */       GIR_EraseRootFromParent_Done,
     /* 155890 */     // Label 2171: @155890
     /* 155890 */     GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(155945), // Rule ID 3793 //
     /* 155895 */       // MIs[0] Operand 1
     /* 155895 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 155900 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /* 155900 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155903 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155907 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155912 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155916 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155920 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155922 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155925 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155927 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155934 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155939 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155944 */       // GIR_Coverage, 3793,
     /* 155944 */       GIR_EraseRootFromParent_Done,
     /* 155945 */     // Label 2172: @155945
     /* 155945 */     GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(156000), // Rule ID 3794 //
     /* 155950 */       // MIs[0] Operand 1
     /* 155950 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 155955 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /* 155955 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155958 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 155962 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155967 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155971 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155975 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155977 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155980 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155982 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155989 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155994 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155999 */       // GIR_Coverage, 3794,
     /* 155999 */       GIR_EraseRootFromParent_Done,
     /* 156000 */     // Label 2173: @156000
     /* 156000 */     GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(156055), // Rule ID 3795 //
     /* 156005 */       // MIs[0] Operand 1
     /* 156005 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 156010 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /* 156010 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156013 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156017 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156022 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156026 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156030 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156032 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156035 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156037 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156044 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156049 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156054 */       // GIR_Coverage, 3795,
     /* 156054 */       GIR_EraseRootFromParent_Done,
     /* 156055 */     // Label 2174: @156055
     /* 156055 */     GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(156110), // Rule ID 3796 //
     /* 156060 */       // MIs[0] Operand 1
     /* 156060 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 156065 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /* 156065 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156068 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156072 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156077 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156081 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156085 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156087 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156090 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156092 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156099 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156104 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156109 */       // GIR_Coverage, 3796,
     /* 156109 */       GIR_EraseRootFromParent_Done,
     /* 156110 */     // Label 2175: @156110
     /* 156110 */     GIM_Reject,
     /* 156111 */   // Label 2170: @156111
     /* 156111 */   GIM_Reject,
     /* 156112 */   // Label 2168: @156112
     /* 156112 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(156400),
     /* 156117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156124 */     GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(156179), // Rule ID 3804 //
     /* 156129 */       // MIs[0] Operand 1
     /* 156129 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 156134 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /* 156134 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156137 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 156141 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156146 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156150 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156154 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156156 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156159 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156161 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156168 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156173 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156178 */       // GIR_Coverage, 3804,
     /* 156178 */       GIR_EraseRootFromParent_Done,
     /* 156179 */     // Label 2177: @156179
     /* 156179 */     GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(156234), // Rule ID 3805 //
     /* 156184 */       // MIs[0] Operand 1
     /* 156184 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 156189 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /* 156189 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156192 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156196 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156201 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156205 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156209 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156211 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156214 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156216 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156223 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156228 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156233 */       // GIR_Coverage, 3805,
     /* 156233 */       GIR_EraseRootFromParent_Done,
     /* 156234 */     // Label 2178: @156234
     /* 156234 */     GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(156289), // Rule ID 3806 //
     /* 156239 */       // MIs[0] Operand 1
     /* 156239 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 156244 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /* 156244 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156247 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 156251 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156256 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156260 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156264 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156266 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156269 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156271 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156278 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156283 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156288 */       // GIR_Coverage, 3806,
     /* 156288 */       GIR_EraseRootFromParent_Done,
     /* 156289 */     // Label 2179: @156289
     /* 156289 */     GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(156344), // Rule ID 3807 //
     /* 156294 */       // MIs[0] Operand 1
     /* 156294 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 156299 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /* 156299 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156302 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156306 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156311 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156315 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156319 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156321 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156324 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156326 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156333 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156338 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156343 */       // GIR_Coverage, 3807,
     /* 156343 */       GIR_EraseRootFromParent_Done,
     /* 156344 */     // Label 2180: @156344
     /* 156344 */     GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(156399), // Rule ID 3808 //
     /* 156349 */       // MIs[0] Operand 1
     /* 156349 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 156354 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /* 156354 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156357 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156361 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156366 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156370 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156374 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156376 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156379 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156381 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156388 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156393 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156398 */       // GIR_Coverage, 3808,
     /* 156398 */       GIR_EraseRootFromParent_Done,
     /* 156399 */     // Label 2181: @156399
     /* 156399 */     GIM_Reject,
     /* 156400 */   // Label 2176: @156400
     /* 156400 */   GIM_Reject,
     /* 156401 */   // Label 2169: @156401
     /* 156401 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2184*/ GIMT_Encode4(157188),
     /* 156412 */   /*GILLT_s32*//*Label 2182*/ GIMT_Encode4(156420),
     /* 156416 */   /*GILLT_s64*//*Label 2183*/ GIMT_Encode4(156804),
     /* 156420 */   // Label 2182: @156420
     /* 156420 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(156803),
     /* 156425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156432 */     GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(156506), // Rule ID 3857 //
     /* 156437 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156440 */       // MIs[0] Operand 1
     /* 156440 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 156445 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 156445 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156448 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 156452 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156457 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156461 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156465 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156467 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156470 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156474 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156479 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156486 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156491 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156496 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156499 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156501 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156504 */       GIR_RootConstrainSelectedInstOperands,
     /* 156505 */       // GIR_Coverage, 3857,
     /* 156505 */       GIR_EraseRootFromParent_Done,
     /* 156506 */     // Label 2186: @156506
     /* 156506 */     GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(156580), // Rule ID 3865 //
     /* 156511 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156514 */       // MIs[0] Operand 1
     /* 156514 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 156519 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 156519 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156522 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156526 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156531 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156535 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156539 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156541 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156544 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156548 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156553 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156560 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156565 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156570 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156573 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156575 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156578 */       GIR_RootConstrainSelectedInstOperands,
     /* 156579 */       // GIR_Coverage, 3865,
     /* 156579 */       GIR_EraseRootFromParent_Done,
     /* 156580 */     // Label 2187: @156580
     /* 156580 */     GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(156654), // Rule ID 3873 //
     /* 156585 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156588 */       // MIs[0] Operand 1
     /* 156588 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 156593 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 156593 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156596 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 156600 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156605 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156609 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156613 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156615 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156618 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156622 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156627 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156634 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156639 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156644 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156647 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156649 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156652 */       GIR_RootConstrainSelectedInstOperands,
     /* 156653 */       // GIR_Coverage, 3873,
     /* 156653 */       GIR_EraseRootFromParent_Done,
     /* 156654 */     // Label 2188: @156654
     /* 156654 */     GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(156728), // Rule ID 3881 //
     /* 156659 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156662 */       // MIs[0] Operand 1
     /* 156662 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 156667 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 156667 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156670 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156674 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156679 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156683 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156687 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156689 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156692 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156696 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156701 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156708 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156713 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156718 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156721 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156723 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156726 */       GIR_RootConstrainSelectedInstOperands,
     /* 156727 */       // GIR_Coverage, 3881,
     /* 156727 */       GIR_EraseRootFromParent_Done,
     /* 156728 */     // Label 2189: @156728
     /* 156728 */     GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(156802), // Rule ID 3889 //
     /* 156733 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156736 */       // MIs[0] Operand 1
     /* 156736 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 156741 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 156741 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156744 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156748 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156753 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156757 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156761 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156763 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156766 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156770 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156775 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156782 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156787 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156792 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156795 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156797 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156800 */       GIR_RootConstrainSelectedInstOperands,
     /* 156801 */       // GIR_Coverage, 3889,
     /* 156801 */       GIR_EraseRootFromParent_Done,
     /* 156802 */     // Label 2190: @156802
     /* 156802 */     GIM_Reject,
     /* 156803 */   // Label 2185: @156803
     /* 156803 */   GIM_Reject,
     /* 156804 */   // Label 2183: @156804
     /* 156804 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(157187),
     /* 156809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156816 */     GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(156890), // Rule ID 3953 //
     /* 156821 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156824 */       // MIs[0] Operand 1
     /* 156824 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 156829 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 156829 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156832 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 156836 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156841 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156845 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156849 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156851 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156854 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156858 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156863 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156870 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156875 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156880 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156883 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156885 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156888 */       GIR_RootConstrainSelectedInstOperands,
     /* 156889 */       // GIR_Coverage, 3953,
     /* 156889 */       GIR_EraseRootFromParent_Done,
     /* 156890 */     // Label 2192: @156890
     /* 156890 */     GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(156964), // Rule ID 3961 //
     /* 156895 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156898 */       // MIs[0] Operand 1
     /* 156898 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 156903 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 156903 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156906 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156910 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156915 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156919 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156923 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156925 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156928 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156932 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156937 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156944 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156949 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156954 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156957 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156959 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156962 */       GIR_RootConstrainSelectedInstOperands,
     /* 156963 */       // GIR_Coverage, 3961,
     /* 156963 */       GIR_EraseRootFromParent_Done,
     /* 156964 */     // Label 2193: @156964
     /* 156964 */     GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(157038), // Rule ID 3969 //
     /* 156969 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156972 */       // MIs[0] Operand 1
     /* 156972 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 156977 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 156977 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156980 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 156984 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156989 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156993 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156997 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156999 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157002 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157006 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157011 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157018 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157023 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157028 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157031 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157033 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157036 */       GIR_RootConstrainSelectedInstOperands,
     /* 157037 */       // GIR_Coverage, 3969,
     /* 157037 */       GIR_EraseRootFromParent_Done,
     /* 157038 */     // Label 2194: @157038
     /* 157038 */     GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(157112), // Rule ID 3977 //
     /* 157043 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157046 */       // MIs[0] Operand 1
     /* 157046 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 157051 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 157051 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157054 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 157058 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157063 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157067 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157071 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157073 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157076 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157080 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157085 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157092 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157097 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157102 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157105 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157107 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157110 */       GIR_RootConstrainSelectedInstOperands,
     /* 157111 */       // GIR_Coverage, 3977,
     /* 157111 */       GIR_EraseRootFromParent_Done,
     /* 157112 */     // Label 2195: @157112
     /* 157112 */     GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(157186), // Rule ID 3985 //
     /* 157117 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157120 */       // MIs[0] Operand 1
     /* 157120 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 157125 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 157125 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157128 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 157132 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157137 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157141 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157145 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157147 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157150 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157154 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157159 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157166 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157171 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157176 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157179 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157181 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157184 */       GIR_RootConstrainSelectedInstOperands,
     /* 157185 */       // GIR_Coverage, 3985,
     /* 157185 */       GIR_EraseRootFromParent_Done,
     /* 157186 */     // Label 2196: @157186
     /* 157186 */     GIM_Reject,
     /* 157187 */   // Label 2191: @157187
     /* 157187 */   GIM_Reject,
     /* 157188 */   // Label 2184: @157188
     /* 157188 */   GIM_Reject,
     /* 157189 */ // Label 2106: @157189
     /* 157189 */ GIM_Reject,
     /* 157190 */ // Label 32: @157190
     /* 157190 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(160640),
     /* 157195 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 157198 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2201*/ GIMT_Encode4(158151),
     /* 157209 */   /*GILLT_s32*//*Label 2198*/ GIMT_Encode4(157221),
     /* 157213 */   /*GILLT_s64*//*Label 2199*/ GIMT_Encode4(157531),
     /* 157217 */   /*GILLT_s128*//*Label 2200*/ GIMT_Encode4(157841),
     /* 157221 */   // Label 2198: @157221
     /* 157221 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(157530),
     /* 157226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157233 */     GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(157307), // Rule ID 3171 //
     /* 157238 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157241 */       // MIs[0] Operand 1
     /* 157241 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 157246 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 157246 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157249 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157253 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157258 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157262 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157266 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157268 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157271 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157275 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157280 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157287 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157292 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157297 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157300 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157302 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157305 */       GIR_RootConstrainSelectedInstOperands,
     /* 157306 */       // GIR_Coverage, 3171,
     /* 157306 */       GIR_EraseRootFromParent_Done,
     /* 157307 */     // Label 2203: @157307
     /* 157307 */     GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(157381), // Rule ID 3187 //
     /* 157312 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157315 */       // MIs[0] Operand 1
     /* 157315 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 157320 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 157320 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157323 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157327 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157332 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157336 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157340 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157342 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157345 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157349 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157354 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157361 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157366 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157371 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157374 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157376 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157379 */       GIR_RootConstrainSelectedInstOperands,
     /* 157380 */       // GIR_Coverage, 3187,
     /* 157380 */       GIR_EraseRootFromParent_Done,
     /* 157381 */     // Label 2204: @157381
     /* 157381 */     GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(157455), // Rule ID 3203 //
     /* 157386 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157389 */       // MIs[0] Operand 1
     /* 157389 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 157394 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 157394 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157397 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157401 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157406 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157410 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157414 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157416 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157419 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157423 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157428 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157435 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157440 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157445 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157448 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157450 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157453 */       GIR_RootConstrainSelectedInstOperands,
     /* 157454 */       // GIR_Coverage, 3203,
     /* 157454 */       GIR_EraseRootFromParent_Done,
     /* 157455 */     // Label 2205: @157455
     /* 157455 */     GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(157529), // Rule ID 3219 //
     /* 157460 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157463 */       // MIs[0] Operand 1
     /* 157463 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 157468 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 157468 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157471 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157475 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157480 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157484 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157488 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157490 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157493 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157497 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157502 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 157509 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157514 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157519 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157522 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157524 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157527 */       GIR_RootConstrainSelectedInstOperands,
     /* 157528 */       // GIR_Coverage, 3219,
     /* 157528 */       GIR_EraseRootFromParent_Done,
     /* 157529 */     // Label 2206: @157529
     /* 157529 */     GIM_Reject,
     /* 157530 */   // Label 2202: @157530
     /* 157530 */   GIM_Reject,
     /* 157531 */   // Label 2199: @157531
     /* 157531 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(157840),
     /* 157536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157543 */     GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(157617), // Rule ID 3227 //
     /* 157548 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157551 */       // MIs[0] Operand 1
     /* 157551 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 157556 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 157556 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157559 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 157563 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157568 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157572 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157576 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157578 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157581 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157585 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157590 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157597 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157602 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157607 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157610 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157612 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157615 */       GIR_RootConstrainSelectedInstOperands,
     /* 157616 */       // GIR_Coverage, 3227,
     /* 157616 */       GIR_EraseRootFromParent_Done,
     /* 157617 */     // Label 2208: @157617
     /* 157617 */     GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(157691), // Rule ID 3243 //
     /* 157622 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157625 */       // MIs[0] Operand 1
     /* 157625 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 157630 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 157630 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157633 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 157637 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157642 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157646 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157650 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157652 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157655 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157659 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157664 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157671 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157676 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157681 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157684 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157686 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157689 */       GIR_RootConstrainSelectedInstOperands,
     /* 157690 */       // GIR_Coverage, 3243,
     /* 157690 */       GIR_EraseRootFromParent_Done,
     /* 157691 */     // Label 2209: @157691
     /* 157691 */     GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(157765), // Rule ID 3259 //
     /* 157696 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157699 */       // MIs[0] Operand 1
     /* 157699 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 157704 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 157704 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157707 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 157711 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157716 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157720 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157724 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157726 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157729 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157733 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157738 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157745 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157750 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157755 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157758 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157760 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157763 */       GIR_RootConstrainSelectedInstOperands,
     /* 157764 */       // GIR_Coverage, 3259,
     /* 157764 */       GIR_EraseRootFromParent_Done,
     /* 157765 */     // Label 2210: @157765
     /* 157765 */     GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(157839), // Rule ID 3275 //
     /* 157770 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157773 */       // MIs[0] Operand 1
     /* 157773 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 157778 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 157778 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157781 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 157785 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157790 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157794 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157798 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157800 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157803 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157807 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157812 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 157819 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157824 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157829 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157832 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157834 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157837 */       GIR_RootConstrainSelectedInstOperands,
     /* 157838 */       // GIR_Coverage, 3275,
     /* 157838 */       GIR_EraseRootFromParent_Done,
     /* 157839 */     // Label 2211: @157839
     /* 157839 */     GIM_Reject,
     /* 157840 */   // Label 2207: @157840
     /* 157840 */   GIM_Reject,
     /* 157841 */   // Label 2200: @157841
     /* 157841 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(158150),
     /* 157846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 157849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157853 */     GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(157927), // Rule ID 3283 //
     /* 157858 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157861 */       // MIs[0] Operand 1
     /* 157861 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 157866 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 157866 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157869 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 157873 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157878 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157882 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157886 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157888 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157891 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157895 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157900 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157907 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157912 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157917 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157920 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157922 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157925 */       GIR_RootConstrainSelectedInstOperands,
     /* 157926 */       // GIR_Coverage, 3283,
     /* 157926 */       GIR_EraseRootFromParent_Done,
     /* 157927 */     // Label 2213: @157927
     /* 157927 */     GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(158001), // Rule ID 3299 //
     /* 157932 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157935 */       // MIs[0] Operand 1
     /* 157935 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 157940 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 157940 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157943 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 157947 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157952 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157956 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157960 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157962 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157965 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157969 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157974 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157981 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157986 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157991 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157994 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157996 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157999 */       GIR_RootConstrainSelectedInstOperands,
     /* 158000 */       // GIR_Coverage, 3299,
     /* 158000 */       GIR_EraseRootFromParent_Done,
     /* 158001 */     // Label 2214: @158001
     /* 158001 */     GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(158075), // Rule ID 3315 //
     /* 158006 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158009 */       // MIs[0] Operand 1
     /* 158009 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 158014 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 158014 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158017 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 158021 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158026 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158030 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158034 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158036 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158039 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158043 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158048 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158055 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158060 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158065 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158068 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158070 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158073 */       GIR_RootConstrainSelectedInstOperands,
     /* 158074 */       // GIR_Coverage, 3315,
     /* 158074 */       GIR_EraseRootFromParent_Done,
     /* 158075 */     // Label 2215: @158075
     /* 158075 */     GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(158149), // Rule ID 3331 //
     /* 158080 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158083 */       // MIs[0] Operand 1
     /* 158083 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 158088 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 158088 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158091 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 158095 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158100 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158104 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158108 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158110 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158113 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158117 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158122 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 158129 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158134 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158139 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158142 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158144 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158147 */       GIR_RootConstrainSelectedInstOperands,
     /* 158148 */       // GIR_Coverage, 3331,
     /* 158148 */       GIR_EraseRootFromParent_Done,
     /* 158149 */     // Label 2216: @158149
     /* 158149 */     GIM_Reject,
     /* 158150 */   // Label 2212: @158150
     /* 158150 */   GIM_Reject,
     /* 158151 */   // Label 2201: @158151
     /* 158151 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2220*/ GIMT_Encode4(159800),
     /* 158162 */   /*GILLT_s32*//*Label 2217*/ GIMT_Encode4(158174),
     /* 158166 */   /*GILLT_s64*//*Label 2218*/ GIMT_Encode4(158716),
     /* 158170 */   /*GILLT_s128*//*Label 2219*/ GIMT_Encode4(159258),
     /* 158174 */   // Label 2217: @158174
     /* 158174 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(158715),
     /* 158179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158186 */     GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(158244), // Rule ID 3994 //
     /* 158191 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158194 */       // MIs[0] Operand 1
     /* 158194 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 158199 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /* 158199 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158202 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158206 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158211 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158215 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158219 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158221 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158224 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158226 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 158233 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158238 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158243 */       // GIR_Coverage, 3994,
     /* 158243 */       GIR_EraseRootFromParent_Done,
     /* 158244 */     // Label 2222: @158244
     /* 158244 */     GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(158302), // Rule ID 3998 //
     /* 158249 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158252 */       // MIs[0] Operand 1
     /* 158252 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 158257 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 158257 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158260 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158264 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158269 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158273 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158277 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158279 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158282 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158284 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158291 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158296 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158301 */       // GIR_Coverage, 3998,
     /* 158301 */       GIR_EraseRootFromParent_Done,
     /* 158302 */     // Label 2223: @158302
     /* 158302 */     GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(158360), // Rule ID 4002 //
     /* 158307 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158310 */       // MIs[0] Operand 1
     /* 158310 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 158315 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /* 158315 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158318 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158322 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158327 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158331 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158335 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158337 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158340 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158342 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158349 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158354 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158359 */       // GIR_Coverage, 4002,
     /* 158359 */       GIR_EraseRootFromParent_Done,
     /* 158360 */     // Label 2224: @158360
     /* 158360 */     GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(158418), // Rule ID 4006 //
     /* 158365 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158368 */       // MIs[0] Operand 1
     /* 158368 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 158373 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /* 158373 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158376 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158380 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158385 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158389 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158393 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158395 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158398 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158400 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 158407 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158412 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158417 */       // GIR_Coverage, 4006,
     /* 158417 */       GIR_EraseRootFromParent_Done,
     /* 158418 */     // Label 2225: @158418
     /* 158418 */     GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(158492), // Rule ID 4008 //
     /* 158423 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158426 */       // MIs[0] Operand 1
     /* 158426 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 158431 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 158431 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158434 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158438 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158443 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158447 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158451 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158453 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158456 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158460 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158465 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 158472 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158477 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158482 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158485 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158487 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158490 */       GIR_RootConstrainSelectedInstOperands,
     /* 158491 */       // GIR_Coverage, 4008,
     /* 158491 */       GIR_EraseRootFromParent_Done,
     /* 158492 */     // Label 2226: @158492
     /* 158492 */     GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(158566), // Rule ID 4040 //
     /* 158497 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158500 */       // MIs[0] Operand 1
     /* 158500 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 158505 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 158505 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158508 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158512 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158517 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158521 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158525 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158527 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158530 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158534 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158539 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158546 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158551 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158556 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158559 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158561 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158564 */       GIR_RootConstrainSelectedInstOperands,
     /* 158565 */       // GIR_Coverage, 4040,
     /* 158565 */       GIR_EraseRootFromParent_Done,
     /* 158566 */     // Label 2227: @158566
     /* 158566 */     GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(158640), // Rule ID 4072 //
     /* 158571 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158574 */       // MIs[0] Operand 1
     /* 158574 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 158579 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 158579 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158582 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158586 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158591 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158595 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158599 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158601 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158604 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158608 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158613 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158620 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158625 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158630 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158633 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158635 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158638 */       GIR_RootConstrainSelectedInstOperands,
     /* 158639 */       // GIR_Coverage, 4072,
     /* 158639 */       GIR_EraseRootFromParent_Done,
     /* 158640 */     // Label 2228: @158640
     /* 158640 */     GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(158714), // Rule ID 4104 //
     /* 158645 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158648 */       // MIs[0] Operand 1
     /* 158648 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 158653 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 158653 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158656 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158660 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158665 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158669 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158673 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158675 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158678 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158682 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158687 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 158694 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158699 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158704 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158707 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158709 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158712 */       GIR_RootConstrainSelectedInstOperands,
     /* 158713 */       // GIR_Coverage, 4104,
     /* 158713 */       GIR_EraseRootFromParent_Done,
     /* 158714 */     // Label 2229: @158714
     /* 158714 */     GIM_Reject,
     /* 158715 */   // Label 2221: @158715
     /* 158715 */   GIM_Reject,
     /* 158716 */   // Label 2218: @158716
     /* 158716 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(159257),
     /* 158721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158728 */     GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(158802), // Rule ID 4120 //
     /* 158733 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158736 */       // MIs[0] Operand 1
     /* 158736 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 158741 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 158741 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158744 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 158748 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158753 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158757 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158761 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158763 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158766 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158770 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158775 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 158782 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158787 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158792 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158795 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158797 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158800 */       GIR_RootConstrainSelectedInstOperands,
     /* 158801 */       // GIR_Coverage, 4120,
     /* 158801 */       GIR_EraseRootFromParent_Done,
     /* 158802 */     // Label 2231: @158802
     /* 158802 */     GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(158876), // Rule ID 4152 //
     /* 158807 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158810 */       // MIs[0] Operand 1
     /* 158810 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 158815 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 158815 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158818 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 158822 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158827 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158831 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158835 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158837 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158840 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158844 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158849 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158856 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158861 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158866 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158869 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158871 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158874 */       GIR_RootConstrainSelectedInstOperands,
     /* 158875 */       // GIR_Coverage, 4152,
     /* 158875 */       GIR_EraseRootFromParent_Done,
     /* 158876 */     // Label 2232: @158876
     /* 158876 */     GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(158950), // Rule ID 4184 //
     /* 158881 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158884 */       // MIs[0] Operand 1
     /* 158884 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 158889 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 158889 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158892 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 158896 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158901 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158905 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158909 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158911 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158914 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158918 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158923 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158930 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158935 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158940 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158943 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158945 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158948 */       GIR_RootConstrainSelectedInstOperands,
     /* 158949 */       // GIR_Coverage, 4184,
     /* 158949 */       GIR_EraseRootFromParent_Done,
     /* 158950 */     // Label 2233: @158950
     /* 158950 */     GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(159024), // Rule ID 4216 //
     /* 158955 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158958 */       // MIs[0] Operand 1
     /* 158958 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 158963 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 158963 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158966 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 158970 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158975 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158979 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158983 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158985 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158988 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158992 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158997 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159004 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159009 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159014 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159017 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159019 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159022 */       GIR_RootConstrainSelectedInstOperands,
     /* 159023 */       // GIR_Coverage, 4216,
     /* 159023 */       GIR_EraseRootFromParent_Done,
     /* 159024 */     // Label 2234: @159024
     /* 159024 */     GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(159082), // Rule ID 4232 //
     /* 159029 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159032 */       // MIs[0] Operand 1
     /* 159032 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 159037 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /* 159037 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159040 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159044 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159049 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159053 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159057 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159059 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159062 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159064 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159071 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159076 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159081 */       // GIR_Coverage, 4232,
     /* 159081 */       GIR_EraseRootFromParent_Done,
     /* 159082 */     // Label 2235: @159082
     /* 159082 */     GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(159140), // Rule ID 4236 //
     /* 159087 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159090 */       // MIs[0] Operand 1
     /* 159090 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 159095 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 159095 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159098 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159102 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159107 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159111 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159115 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159117 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159120 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159122 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159129 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159134 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159139 */       // GIR_Coverage, 4236,
     /* 159139 */       GIR_EraseRootFromParent_Done,
     /* 159140 */     // Label 2236: @159140
     /* 159140 */     GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(159198), // Rule ID 4240 //
     /* 159145 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159148 */       // MIs[0] Operand 1
     /* 159148 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 159153 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /* 159153 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159156 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159160 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159165 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159169 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159173 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159175 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159178 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159180 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 159187 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159192 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159197 */       // GIR_Coverage, 4240,
     /* 159197 */       GIR_EraseRootFromParent_Done,
     /* 159198 */     // Label 2237: @159198
     /* 159198 */     GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(159256), // Rule ID 4244 //
     /* 159203 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159206 */       // MIs[0] Operand 1
     /* 159206 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 159211 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /* 159211 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159214 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159218 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159223 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159227 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159231 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159233 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159236 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159238 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159245 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159250 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159255 */       // GIR_Coverage, 4244,
     /* 159255 */       GIR_EraseRootFromParent_Done,
     /* 159256 */     // Label 2238: @159256
     /* 159256 */     GIM_Reject,
     /* 159257 */   // Label 2230: @159257
     /* 159257 */   GIM_Reject,
     /* 159258 */   // Label 2219: @159258
     /* 159258 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(159799),
     /* 159263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 159266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159270 */     GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(159344), // Rule ID 4246 //
     /* 159275 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159278 */       // MIs[0] Operand 1
     /* 159278 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 159283 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 159283 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159286 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159290 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159295 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159299 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159303 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159305 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159308 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159312 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159317 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159324 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159329 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159334 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159337 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159339 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159342 */       GIR_RootConstrainSelectedInstOperands,
     /* 159343 */       // GIR_Coverage, 4246,
     /* 159343 */       GIR_EraseRootFromParent_Done,
     /* 159344 */     // Label 2240: @159344
     /* 159344 */     GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(159418), // Rule ID 4278 //
     /* 159349 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159352 */       // MIs[0] Operand 1
     /* 159352 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 159357 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 159357 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159360 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159364 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159369 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159373 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159377 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159379 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159382 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159386 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159391 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159398 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159403 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159408 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159411 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159413 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159416 */       GIR_RootConstrainSelectedInstOperands,
     /* 159417 */       // GIR_Coverage, 4278,
     /* 159417 */       GIR_EraseRootFromParent_Done,
     /* 159418 */     // Label 2241: @159418
     /* 159418 */     GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(159492), // Rule ID 4310 //
     /* 159423 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159426 */       // MIs[0] Operand 1
     /* 159426 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 159431 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 159431 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159434 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159438 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159443 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159447 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159451 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159453 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159456 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159460 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159465 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 159472 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159477 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159482 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159485 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159487 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159490 */       GIR_RootConstrainSelectedInstOperands,
     /* 159491 */       // GIR_Coverage, 4310,
     /* 159491 */       GIR_EraseRootFromParent_Done,
     /* 159492 */     // Label 2242: @159492
     /* 159492 */     GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(159566), // Rule ID 4342 //
     /* 159497 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159500 */       // MIs[0] Operand 1
     /* 159500 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 159505 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 159505 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159508 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159512 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159517 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159521 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159525 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159527 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159530 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159534 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159539 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159546 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159551 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159556 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159559 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159561 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159564 */       GIR_RootConstrainSelectedInstOperands,
     /* 159565 */       // GIR_Coverage, 4342,
     /* 159565 */       GIR_EraseRootFromParent_Done,
     /* 159566 */     // Label 2243: @159566
     /* 159566 */     GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(159624), // Rule ID 4358 //
     /* 159571 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159574 */       // MIs[0] Operand 1
     /* 159574 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 159579 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /* 159579 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159582 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159586 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159591 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159595 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159599 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159601 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159604 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159606 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159613 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159618 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159623 */       // GIR_Coverage, 4358,
     /* 159623 */       GIR_EraseRootFromParent_Done,
     /* 159624 */     // Label 2244: @159624
     /* 159624 */     GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(159682), // Rule ID 4362 //
     /* 159629 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159632 */       // MIs[0] Operand 1
     /* 159632 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 159637 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /* 159637 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159640 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159644 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159649 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159653 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159657 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159659 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159662 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159664 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159671 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159676 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159681 */       // GIR_Coverage, 4362,
     /* 159681 */       GIR_EraseRootFromParent_Done,
     /* 159682 */     // Label 2245: @159682
     /* 159682 */     GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(159740), // Rule ID 4366 //
     /* 159687 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159690 */       // MIs[0] Operand 1
     /* 159690 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 159695 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /* 159695 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159698 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159702 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159707 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159711 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159715 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159717 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159720 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159722 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 159729 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159734 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159739 */       // GIR_Coverage, 4366,
     /* 159739 */       GIR_EraseRootFromParent_Done,
     /* 159740 */     // Label 2246: @159740
     /* 159740 */     GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(159798), // Rule ID 4370 //
     /* 159745 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159748 */       // MIs[0] Operand 1
     /* 159748 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 159753 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /* 159753 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159756 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159760 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159765 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159769 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159773 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159775 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159778 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159780 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159787 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159792 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159797 */       // GIR_Coverage, 4370,
     /* 159797 */       GIR_EraseRootFromParent_Done,
     /* 159798 */     // Label 2247: @159798
     /* 159798 */     GIM_Reject,
     /* 159799 */   // Label 2239: @159799
     /* 159799 */   GIM_Reject,
     /* 159800 */   // Label 2220: @159800
     /* 159800 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2250*/ GIMT_Encode4(160639),
     /* 159811 */   /*GILLT_s32*//*Label 2248*/ GIMT_Encode4(159819),
     /* 159815 */   /*GILLT_s64*//*Label 2249*/ GIMT_Encode4(160229),
     /* 159819 */   // Label 2248: @159819
     /* 159819 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(160228),
     /* 159824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159831 */     GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(159889), // Rule ID 4561 //
     /* 159836 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 159839 */       // MIs[0] Operand 1
     /* 159839 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 159844 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 159844 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159847 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 159851 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159856 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159860 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159864 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159866 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159869 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159871 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159878 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159883 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159888 */       // GIR_Coverage, 4561,
     /* 159888 */       GIR_EraseRootFromParent_Done,
     /* 159889 */     // Label 2252: @159889
     /* 159889 */     GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(159947), // Rule ID 4565 //
     /* 159894 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 159897 */       // MIs[0] Operand 1
     /* 159897 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 159902 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 159902 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159905 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 159909 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159914 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159918 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159922 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159924 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159927 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159929 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159936 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159941 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159946 */       // GIR_Coverage, 4565,
     /* 159946 */       GIR_EraseRootFromParent_Done,
     /* 159947 */     // Label 2253: @159947
     /* 159947 */     GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(160005), // Rule ID 4569 //
     /* 159952 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 159955 */       // MIs[0] Operand 1
     /* 159955 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 159960 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 159960 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159963 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 159967 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159972 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159976 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159980 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159982 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159985 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159987 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159994 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159999 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160004 */       // GIR_Coverage, 4569,
     /* 160004 */       GIR_EraseRootFromParent_Done,
     /* 160005 */     // Label 2254: @160005
     /* 160005 */     GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(160079), // Rule ID 4573 //
     /* 160010 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160013 */       // MIs[0] Operand 1
     /* 160013 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 160018 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 160018 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160021 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 160025 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160030 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160034 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160038 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160040 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160043 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160047 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160052 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160059 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160064 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160069 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160072 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160074 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160077 */       GIR_RootConstrainSelectedInstOperands,
     /* 160078 */       // GIR_Coverage, 4573,
     /* 160078 */       GIR_EraseRootFromParent_Done,
     /* 160079 */     // Label 2255: @160079
     /* 160079 */     GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(160153), // Rule ID 4605 //
     /* 160084 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160087 */       // MIs[0] Operand 1
     /* 160087 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 160092 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 160092 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160095 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 160099 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160104 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160108 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160112 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160114 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160117 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160121 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160126 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160133 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160138 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160143 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160146 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160148 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160151 */       GIR_RootConstrainSelectedInstOperands,
     /* 160152 */       // GIR_Coverage, 4605,
     /* 160152 */       GIR_EraseRootFromParent_Done,
     /* 160153 */     // Label 2256: @160153
     /* 160153 */     GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(160227), // Rule ID 4637 //
     /* 160158 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160161 */       // MIs[0] Operand 1
     /* 160161 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 160166 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 160166 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160169 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 160173 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160178 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160182 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160186 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160188 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160191 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160195 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160200 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160207 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160212 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160217 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160220 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160222 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160225 */       GIR_RootConstrainSelectedInstOperands,
     /* 160226 */       // GIR_Coverage, 4637,
     /* 160226 */       GIR_EraseRootFromParent_Done,
     /* 160227 */     // Label 2257: @160227
     /* 160227 */     GIM_Reject,
     /* 160228 */   // Label 2251: @160228
     /* 160228 */   GIM_Reject,
     /* 160229 */   // Label 2249: @160229
     /* 160229 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(160638),
     /* 160234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160241 */     GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(160299), // Rule ID 4669 //
     /* 160246 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160249 */       // MIs[0] Operand 1
     /* 160249 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 160254 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 160254 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160257 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 160261 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160266 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160270 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160274 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160276 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160279 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160281 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160288 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160293 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160298 */       // GIR_Coverage, 4669,
     /* 160298 */       GIR_EraseRootFromParent_Done,
     /* 160299 */     // Label 2259: @160299
     /* 160299 */     GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(160357), // Rule ID 4673 //
     /* 160304 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160307 */       // MIs[0] Operand 1
     /* 160307 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 160312 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 160312 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160315 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 160319 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160324 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160328 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160332 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160334 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160337 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160339 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160346 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160351 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160356 */       // GIR_Coverage, 4673,
     /* 160356 */       GIR_EraseRootFromParent_Done,
     /* 160357 */     // Label 2260: @160357
     /* 160357 */     GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(160415), // Rule ID 4677 //
     /* 160362 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160365 */       // MIs[0] Operand 1
     /* 160365 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 160370 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 160370 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160373 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 160377 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160382 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160386 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160390 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160392 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160395 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160397 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160404 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160409 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160414 */       // GIR_Coverage, 4677,
     /* 160414 */       GIR_EraseRootFromParent_Done,
     /* 160415 */     // Label 2261: @160415
     /* 160415 */     GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(160489), // Rule ID 4681 //
     /* 160420 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160423 */       // MIs[0] Operand 1
     /* 160423 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 160428 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 160428 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160431 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 160435 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160440 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160444 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160448 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160450 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160453 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160457 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160462 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160469 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160474 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160479 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160482 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160484 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160487 */       GIR_RootConstrainSelectedInstOperands,
     /* 160488 */       // GIR_Coverage, 4681,
     /* 160488 */       GIR_EraseRootFromParent_Done,
     /* 160489 */     // Label 2262: @160489
     /* 160489 */     GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(160563), // Rule ID 4713 //
     /* 160494 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160497 */       // MIs[0] Operand 1
     /* 160497 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 160502 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 160502 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160505 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 160509 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160514 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160518 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160522 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160524 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160527 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160531 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160536 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160543 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160548 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160553 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160556 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160558 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160561 */       GIR_RootConstrainSelectedInstOperands,
     /* 160562 */       // GIR_Coverage, 4713,
     /* 160562 */       GIR_EraseRootFromParent_Done,
     /* 160563 */     // Label 2263: @160563
     /* 160563 */     GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(160637), // Rule ID 4745 //
     /* 160568 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160571 */       // MIs[0] Operand 1
     /* 160571 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 160576 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 160576 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160579 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 160583 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160588 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160592 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160596 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160598 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160601 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160605 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160610 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160617 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160622 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160627 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160630 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160632 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160635 */       GIR_RootConstrainSelectedInstOperands,
     /* 160636 */       // GIR_Coverage, 4745,
     /* 160636 */       GIR_EraseRootFromParent_Done,
     /* 160637 */     // Label 2264: @160637
     /* 160637 */     GIM_Reject,
     /* 160638 */   // Label 2258: @160638
     /* 160638 */   GIM_Reject,
     /* 160639 */   // Label 2250: @160639
     /* 160639 */   GIM_Reject,
     /* 160640 */ // Label 2197: @160640
     /* 160640 */ GIM_Reject,
     /* 160641 */ // Label 33: @160641
     /* 160641 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2273*/ GIMT_Encode4(161764),
     /* 160652 */ /*GILLT_s1*//*Label 2265*/ GIMT_Encode4(160684),
     /* 160656 */ /*GILLT_s32*//*Label 2266*/ GIMT_Encode4(160777),
     /* 160660 */ /*GILLT_s64*//*Label 2267*/ GIMT_Encode4(160866),
     /* 160664 */ /*GILLT_s128*//*Label 2268*/ GIMT_Encode4(160955),
     /* 160668 */ /*GILLT_v2s64*//*Label 2269*/ GIMT_Encode4(161139),
     /* 160672 */ /*GILLT_v4s32*//*Label 2270*/ GIMT_Encode4(161304),
     /* 160676 */ /*GILLT_v8s16*//*Label 2271*/ GIMT_Encode4(161466),
     /* 160680 */ /*GILLT_v16s8*//*Label 2272*/ GIMT_Encode4(161615),
     /* 160684 */ // Label 2265: @160684
     /* 160684 */ GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(160776), // Rule ID 4776 //
     /* 160689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 160692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 160695 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s1,
     /* 160698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160702 */   // (select:{ *:[i1] } i1:{ *:[i1] }:$cond, i1:{ *:[i1] }:$tval, i1:{ *:[i1] }:$fval)  =>  (CROR:{ *:[i1] } (CRAND:{ *:[i1] } ?:{ *:[i1] }:$cond, ?:{ *:[i1] }:$tval), (CRAND:{ *:[i1] } (CRNOT:{ *:[i1] } ?:{ *:[i1] }:$cond), ?:{ *:[i1] }:$fval))
     /* 160702 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 160705 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160709 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160714 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 160718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 160720 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 160723 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /* 160727 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160732 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 160735 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // fval
     /* 160739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /* 160748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160753 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 160757 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // tval
     /* 160761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CROR),
     /* 160766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160768 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 160774 */   GIR_RootConstrainSelectedInstOperands,
     /* 160775 */   // GIR_Coverage, 4776,
     /* 160775 */   GIR_EraseRootFromParent_Done,
     /* 160776 */ // Label 2274: @160776
     /* 160776 */ GIM_Reject,
     /* 160777 */ // Label 2266: @160777
     /* 160777 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(160865),
     /* 160782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 160785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160788 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160791 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(160810), // Rule ID 1051 //
     /* 160796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 160803 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_VSSRC:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 160803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSSRC),
     /* 160808 */     GIR_RootConstrainSelectedInstOperands,
     /* 160809 */     // GIR_Coverage, 1051,
     /* 160809 */     GIR_Done,
     /* 160810 */   // Label 2276: @160810
     /* 160810 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(160826), // Rule ID 5 //
     /* 160815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 160819 */     // (select:{ *:[i32] } i1:{ *:[i1] }:$cond, i32:{ *:[i32] }:$T, i32:{ *:[i32] }:$F)  =>  (SELECT_I4:{ *:[i32] } i1:{ *:[i1] }:$cond, i32:{ *:[i32] }:$T, i32:{ *:[i32] }:$F)
     /* 160819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 160824 */     GIR_RootConstrainSelectedInstOperands,
     /* 160825 */     // GIR_Coverage, 5,
     /* 160825 */     GIR_Done,
     /* 160826 */   // Label 2277: @160826
     /* 160826 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(160845), // Rule ID 7 //
     /* 160831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 160834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 160838 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_F4:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 160838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F4),
     /* 160843 */     GIR_RootConstrainSelectedInstOperands,
     /* 160844 */     // GIR_Coverage, 7,
     /* 160844 */     GIR_Done,
     /* 160845 */   // Label 2278: @160845
     /* 160845 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(160864), // Rule ID 606 //
     /* 160850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 160857 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_SPE4:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 160857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_SPE4),
     /* 160862 */     GIR_RootConstrainSelectedInstOperands,
     /* 160863 */     // GIR_Coverage, 606,
     /* 160863 */     GIR_Done,
     /* 160864 */   // Label 2279: @160864
     /* 160864 */   GIM_Reject,
     /* 160865 */ // Label 2275: @160865
     /* 160865 */ GIM_Reject,
     /* 160866 */ // Label 2267: @160866
     /* 160866 */ GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(160954),
     /* 160871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 160874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160877 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160880 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(160899), // Rule ID 1050 //
     /* 160885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 160892 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_VSFRC:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 160892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSFRC),
     /* 160897 */     GIR_RootConstrainSelectedInstOperands,
     /* 160898 */     // GIR_Coverage, 1050,
     /* 160898 */     GIR_Done,
     /* 160899 */   // Label 2281: @160899
     /* 160899 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(160915), // Rule ID 6 //
     /* 160904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 160908 */     // (select:{ *:[i64] } i1:{ *:[i1] }:$cond, i64:{ *:[i64] }:$T, i64:{ *:[i64] }:$F)  =>  (SELECT_I8:{ *:[i64] } i1:{ *:[i1] }:$cond, i64:{ *:[i64] }:$T, i64:{ *:[i64] }:$F)
     /* 160908 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 160913 */     GIR_RootConstrainSelectedInstOperands,
     /* 160914 */     // GIR_Coverage, 6,
     /* 160914 */     GIR_Done,
     /* 160915 */   // Label 2282: @160915
     /* 160915 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(160934), // Rule ID 8 //
     /* 160920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 160923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 160927 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_F8:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 160927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F8),
     /* 160932 */     GIR_RootConstrainSelectedInstOperands,
     /* 160933 */     // GIR_Coverage, 8,
     /* 160933 */     GIR_Done,
     /* 160934 */   // Label 2283: @160934
     /* 160934 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(160953), // Rule ID 607 //
     /* 160939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 160946 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_SPE:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 160946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_SPE),
     /* 160951 */     GIR_RootConstrainSelectedInstOperands,
     /* 160952 */     // GIR_Coverage, 607,
     /* 160952 */     GIR_Done,
     /* 160953 */   // Label 2284: @160953
     /* 160953 */   GIM_Reject,
     /* 160954 */ // Label 2280: @160954
     /* 160954 */ GIM_Reject,
     /* 160955 */ // Label 2268: @160955
     /* 160955 */ GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(161076), // Rule ID 1668 //
     /* 160960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 160966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 160969 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 160972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 160976 */   // (vselect:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB, v1i128:{ *:[v1i128] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 160976 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 160979 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160983 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160988 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 160992 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 160997 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 161000 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161004 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161009 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 161013 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161018 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 161021 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161025 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161030 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 161034 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 161042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161051 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 161054 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 161057 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 161060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161075 */   // GIR_Coverage, 1668,
     /* 161075 */   GIR_EraseRootFromParent_Done,
     /* 161076 */ // Label 2285: @161076
     /* 161076 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(161104), // Rule ID 9 //
     /* 161081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 161090 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 161093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161097 */   // (select:{ *:[f128] } i1:{ *:[i1] }:$cond, f128:{ *:[f128] }:$T, f128:{ *:[f128] }:$F)  =>  (SELECT_F16:{ *:[f128] } i1:{ *:[i1] }:$cond, f128:{ *:[f128] }:$T, f128:{ *:[f128] }:$F)
     /* 161097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F16),
     /* 161102 */   GIR_RootConstrainSelectedInstOperands,
     /* 161103 */   // GIR_Coverage, 9,
     /* 161103 */   GIR_Done,
     /* 161104 */ // Label 2286: @161104
     /* 161104 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(161138), // Rule ID 1423 //
     /* 161109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 161115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 161118 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 161121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161125 */   // (vselect:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB, v1i128:{ *:[v1i128] }:$vC)  =>  (VSEL:{ *:[v1i128] } ?:{ *:[v1i128] }:$vC, ?:{ *:[v1i128] }:$vB, ?:{ *:[v1i128] }:$vA)
     /* 161125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161130 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161132 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161134 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161136 */   GIR_RootConstrainSelectedInstOperands,
     /* 161137 */   // GIR_Coverage, 1423,
     /* 161137 */   GIR_EraseRootFromParent_Done,
     /* 161138 */ // Label 2287: @161138
     /* 161138 */ GIM_Reject,
     /* 161139 */ // Label 2269: @161139
     /* 161139 */ GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(161167), // Rule ID 1049 //
     /* 161144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161153 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161160 */   // (select:{ *:[v2f64] } i1:{ *:[i1] }:$cond, v2f64:{ *:[v2f64] }:$T, v2f64:{ *:[v2f64] }:$F)  =>  (SELECT_VSRC:{ *:[v2f64] } i1:{ *:[i1] }:$cond, v2f64:{ *:[v2f64] }:$T, v2f64:{ *:[v2f64] }:$F)
     /* 161160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSRC),
     /* 161165 */   GIR_RootConstrainSelectedInstOperands,
     /* 161166 */   // GIR_Coverage, 1049,
     /* 161166 */   GIR_Done,
     /* 161167 */ // Label 2288: @161167
     /* 161167 */ GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(161201), // Rule ID 1665 //
     /* 161172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161181 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161188 */   // (vselect:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB, v2i64:{ *:[v2i64] }:$vC)  =>  (XXSEL:{ *:[v2i64] } ?:{ *:[v2i64] }:$vC, ?:{ *:[v2i64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161193 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161195 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161197 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161199 */   GIR_RootConstrainSelectedInstOperands,
     /* 161200 */   // GIR_Coverage, 1665,
     /* 161200 */   GIR_EraseRootFromParent_Done,
     /* 161201 */ // Label 2289: @161201
     /* 161201 */ GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(161235), // Rule ID 1667 //
     /* 161206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161215 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161222 */   // (vselect:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$vA, v2f64:{ *:[v2f64] }:$vB, v2f64:{ *:[v2f64] }:$vC)  =>  (XXSEL:{ *:[v2f64] } ?:{ *:[v2f64] }:$vC, ?:{ *:[v2f64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161227 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161229 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161231 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161233 */   GIR_RootConstrainSelectedInstOperands,
     /* 161234 */   // GIR_Coverage, 1667,
     /* 161234 */   GIR_EraseRootFromParent_Done,
     /* 161235 */ // Label 2290: @161235
     /* 161235 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(161269), // Rule ID 1420 //
     /* 161240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161249 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161256 */   // (vselect:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB, v2i64:{ *:[v2i64] }:$vC)  =>  (VSEL:{ *:[v2i64] } ?:{ *:[v2i64] }:$vC, ?:{ *:[v2i64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161261 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161263 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161265 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161267 */   GIR_RootConstrainSelectedInstOperands,
     /* 161268 */   // GIR_Coverage, 1420,
     /* 161268 */   GIR_EraseRootFromParent_Done,
     /* 161269 */ // Label 2291: @161269
     /* 161269 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(161303), // Rule ID 1422 //
     /* 161274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161283 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161290 */   // (vselect:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$vA, v2f64:{ *:[v2f64] }:$vB, v2f64:{ *:[v2f64] }:$vC)  =>  (VSEL:{ *:[v2f64] } ?:{ *:[v2f64] }:$vC, ?:{ *:[v2f64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161295 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161297 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161299 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161301 */   GIR_RootConstrainSelectedInstOperands,
     /* 161302 */   // GIR_Coverage, 1422,
     /* 161302 */   GIR_EraseRootFromParent_Done,
     /* 161303 */ // Label 2292: @161303
     /* 161303 */ GIM_Reject,
     /* 161304 */ // Label 2270: @161304
     /* 161304 */ GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(161338), // Rule ID 1664 //
     /* 161309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161318 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161325 */   // (vselect:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vC, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161330 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161332 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161334 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161336 */   GIR_RootConstrainSelectedInstOperands,
     /* 161337 */   // GIR_Coverage, 1664,
     /* 161337 */   GIR_EraseRootFromParent_Done,
     /* 161338 */ // Label 2293: @161338
     /* 161338 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(161372), // Rule ID 1666 //
     /* 161343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161352 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161359 */   // (vselect:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA, v4f32:{ *:[v4f32] }:$vB, v4f32:{ *:[v4f32] }:$vC)  =>  (XXSEL:{ *:[v4f32] } ?:{ *:[v4f32] }:$vC, ?:{ *:[v4f32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161364 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161366 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161368 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161370 */   GIR_RootConstrainSelectedInstOperands,
     /* 161371 */   // GIR_Coverage, 1666,
     /* 161371 */   GIR_EraseRootFromParent_Done,
     /* 161372 */ // Label 2294: @161372
     /* 161372 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(161397), // Rule ID 10 //
     /* 161377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161383 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161390 */   // (select:{ *:[v4i32] } i1:{ *:[i1] }:$cond, v4i32:{ *:[v4i32] }:$T, v4i32:{ *:[v4i32] }:$F)  =>  (SELECT_VRRC:{ *:[v4i32] } i1:{ *:[i1] }:$cond, v4i32:{ *:[v4i32] }:$T, v4i32:{ *:[v4i32] }:$F)
     /* 161390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VRRC),
     /* 161395 */   GIR_RootConstrainSelectedInstOperands,
     /* 161396 */   // GIR_Coverage, 10,
     /* 161396 */   GIR_Done,
     /* 161397 */ // Label 2295: @161397
     /* 161397 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(161431), // Rule ID 1419 //
     /* 161402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161411 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161418 */   // (vselect:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)  =>  (VSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vC, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161423 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161425 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161427 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161429 */   GIR_RootConstrainSelectedInstOperands,
     /* 161430 */   // GIR_Coverage, 1419,
     /* 161430 */   GIR_EraseRootFromParent_Done,
     /* 161431 */ // Label 2296: @161431
     /* 161431 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(161465), // Rule ID 1421 //
     /* 161436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161445 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161452 */   // (vselect:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA, v4f32:{ *:[v4f32] }:$vB, v4f32:{ *:[v4f32] }:$vC)  =>  (VSEL:{ *:[v4f32] } ?:{ *:[v4f32] }:$vC, ?:{ *:[v4f32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161457 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161459 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161461 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161463 */   GIR_RootConstrainSelectedInstOperands,
     /* 161464 */   // GIR_Coverage, 1421,
     /* 161464 */   GIR_EraseRootFromParent_Done,
     /* 161465 */ // Label 2297: @161465
     /* 161465 */ GIM_Reject,
     /* 161466 */ // Label 2271: @161466
     /* 161466 */ GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(161614),
     /* 161471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161477 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 161480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161484 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(161592), // Rule ID 1663 //
     /* 161489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161492 */     // (vselect:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB, v8i16:{ *:[v8i16] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 161492 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 161495 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161499 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161504 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 161508 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161513 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 161516 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161520 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161525 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 161529 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161534 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 161537 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161541 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161546 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 161550 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 161558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161567 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 161570 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 161573 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 161576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161591 */     // GIR_Coverage, 1663,
     /* 161591 */     GIR_EraseRootFromParent_Done,
     /* 161592 */   // Label 2299: @161592
     /* 161592 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(161613), // Rule ID 1418 //
     /* 161597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161600 */     // (vselect:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB, v8i16:{ *:[v8i16] }:$vC)  =>  (VSEL:{ *:[v8i16] } ?:{ *:[v8i16] }:$vC, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vA)
     /* 161600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161605 */     GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161607 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161609 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161611 */     GIR_RootConstrainSelectedInstOperands,
     /* 161612 */     // GIR_Coverage, 1418,
     /* 161612 */     GIR_EraseRootFromParent_Done,
     /* 161613 */   // Label 2300: @161613
     /* 161613 */   GIM_Reject,
     /* 161614 */ // Label 2298: @161614
     /* 161614 */ GIM_Reject,
     /* 161615 */ // Label 2272: @161615
     /* 161615 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(161763),
     /* 161620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 161623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 161629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161633 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(161741), // Rule ID 1662 //
     /* 161638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161641 */     // (vselect:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, v16i8:{ *:[v16i8] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 161641 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 161644 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161648 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161653 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 161657 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161662 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 161665 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161669 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161674 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 161678 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161683 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 161686 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161690 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161695 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 161699 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 161707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 161719 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 161722 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 161725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161740 */     // GIR_Coverage, 1662,
     /* 161740 */     GIR_EraseRootFromParent_Done,
     /* 161741 */   // Label 2302: @161741
     /* 161741 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(161762), // Rule ID 1417 //
     /* 161746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161749 */     // (vselect:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, v16i8:{ *:[v16i8] }:$vC)  =>  (VSEL:{ *:[v16i8] } ?:{ *:[v16i8] }:$vC, ?:{ *:[v16i8] }:$vB, ?:{ *:[v16i8] }:$vA)
     /* 161749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161754 */     GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161756 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161758 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161760 */     GIR_RootConstrainSelectedInstOperands,
     /* 161761 */     // GIR_Coverage, 1417,
     /* 161761 */     GIR_EraseRootFromParent_Done,
     /* 161762 */   // Label 2303: @161762
     /* 161762 */   GIM_Reject,
     /* 161763 */ // Label 2301: @161763
     /* 161763 */ GIM_Reject,
     /* 161764 */ // Label 2273: @161764
     /* 161764 */ GIM_Reject,
     /* 161765 */ // Label 34: @161765
     /* 161765 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2308*/ GIMT_Encode4(161894),
     /* 161776 */ /*GILLT_s32*//*Label 2304*/ GIMT_Encode4(161796),
     /* 161780 */ /*GILLT_s64*//*Label 2305*/ GIMT_Encode4(161819), GIMT_Encode4(0),
     /* 161788 */ /*GILLT_v2s64*//*Label 2306*/ GIMT_Encode4(161842),
     /* 161792 */ /*GILLT_v4s32*//*Label 2307*/ GIMT_Encode4(161868),
     /* 161796 */ // Label 2304: @161796
     /* 161796 */ GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(161818), // Rule ID 207 //
     /* 161801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 161804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 161811 */   // (mulhu:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULHWU:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /* 161811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHWU),
     /* 161816 */   GIR_RootConstrainSelectedInstOperands,
     /* 161817 */   // GIR_Coverage, 207,
     /* 161817 */   GIR_Done,
     /* 161818 */ // Label 2309: @161818
     /* 161818 */ GIM_Reject,
     /* 161819 */ // Label 2305: @161819
     /* 161819 */ GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(161841), // Rule ID 673 //
     /* 161824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 161827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 161834 */   // (mulhu:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULHDU:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /* 161834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHDU),
     /* 161839 */   GIR_RootConstrainSelectedInstOperands,
     /* 161840 */   // GIR_Coverage, 673,
     /* 161840 */   GIR_Done,
     /* 161841 */ // Label 2310: @161841
     /* 161841 */ GIM_Reject,
     /* 161842 */ // Label 2306: @161842
     /* 161842 */ GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(161867), // Rule ID 1124 //
     /* 161847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 161850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161860 */   // (mulhu:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULHUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /* 161860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHUD),
     /* 161865 */   GIR_RootConstrainSelectedInstOperands,
     /* 161866 */   // GIR_Coverage, 1124,
     /* 161866 */   GIR_Done,
     /* 161867 */ // Label 2311: @161867
     /* 161867 */ GIM_Reject,
     /* 161868 */ // Label 2307: @161868
     /* 161868 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(161893), // Rule ID 1122 //
     /* 161873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 161876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161886 */   // (mulhu:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULHUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /* 161886 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHUW),
     /* 161891 */   GIR_RootConstrainSelectedInstOperands,
     /* 161892 */   // GIR_Coverage, 1122,
     /* 161892 */   GIR_Done,
     /* 161893 */ // Label 2312: @161893
     /* 161893 */ GIM_Reject,
     /* 161894 */ // Label 2308: @161894
     /* 161894 */ GIM_Reject,
     /* 161895 */ // Label 35: @161895
     /* 161895 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2317*/ GIMT_Encode4(162024),
     /* 161906 */ /*GILLT_s32*//*Label 2313*/ GIMT_Encode4(161926),
     /* 161910 */ /*GILLT_s64*//*Label 2314*/ GIMT_Encode4(161949), GIMT_Encode4(0),
     /* 161918 */ /*GILLT_v2s64*//*Label 2315*/ GIMT_Encode4(161972),
     /* 161922 */ /*GILLT_v4s32*//*Label 2316*/ GIMT_Encode4(161998),
     /* 161926 */ // Label 2313: @161926
     /* 161926 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(161948), // Rule ID 206 //
     /* 161931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 161934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 161941 */   // (mulhs:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULHW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /* 161941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHW),
     /* 161946 */   GIR_RootConstrainSelectedInstOperands,
     /* 161947 */   // GIR_Coverage, 206,
     /* 161947 */   GIR_Done,
     /* 161948 */ // Label 2318: @161948
     /* 161948 */ GIM_Reject,
     /* 161949 */ // Label 2314: @161949
     /* 161949 */ GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(161971), // Rule ID 672 //
     /* 161954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 161957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 161964 */   // (mulhs:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULHD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /* 161964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHD),
     /* 161969 */   GIR_RootConstrainSelectedInstOperands,
     /* 161970 */   // GIR_Coverage, 672,
     /* 161970 */   GIR_Done,
     /* 161971 */ // Label 2319: @161971
     /* 161971 */ GIM_Reject,
     /* 161972 */ // Label 2315: @161972
     /* 161972 */ GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(161997), // Rule ID 1123 //
     /* 161977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 161980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161990 */   // (mulhs:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULHSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /* 161990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHSD),
     /* 161995 */   GIR_RootConstrainSelectedInstOperands,
     /* 161996 */   // GIR_Coverage, 1123,
     /* 161996 */   GIR_Done,
     /* 161997 */ // Label 2320: @161997
     /* 161997 */ GIM_Reject,
     /* 161998 */ // Label 2316: @161998
     /* 161998 */ GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(162023), // Rule ID 1121 //
     /* 162003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 162006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162016 */   // (mulhs:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULHSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /* 162016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHSW),
     /* 162021 */   GIR_RootConstrainSelectedInstOperands,
     /* 162022 */   // GIR_Coverage, 1121,
     /* 162022 */   GIR_Done,
     /* 162023 */ // Label 2321: @162023
     /* 162023 */ GIM_Reject,
     /* 162024 */ // Label 2317: @162024
     /* 162024 */ GIM_Reject,
     /* 162025 */ // Label 36: @162025
     /* 162025 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2325*/ GIMT_Encode4(162126),
     /* 162036 */ /*GILLT_v4s32*//*Label 2322*/ GIMT_Encode4(162048),
     /* 162040 */ /*GILLT_v8s16*//*Label 2323*/ GIMT_Encode4(162074),
     /* 162044 */ /*GILLT_v16s8*//*Label 2324*/ GIMT_Encode4(162100),
     /* 162048 */ // Label 2322: @162048
     /* 162048 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(162073), // Rule ID 1296 //
     /* 162053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162066 */   // (uaddsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VADDUWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUWS),
     /* 162071 */   GIR_RootConstrainSelectedInstOperands,
     /* 162072 */   // GIR_Coverage, 1296,
     /* 162072 */   GIR_Done,
     /* 162073 */ // Label 2326: @162073
     /* 162073 */ GIM_Reject,
     /* 162074 */ // Label 2323: @162074
     /* 162074 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(162099), // Rule ID 1294 //
     /* 162079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162092 */   // (uaddsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VADDUHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162092 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUHS),
     /* 162097 */   GIR_RootConstrainSelectedInstOperands,
     /* 162098 */   // GIR_Coverage, 1294,
     /* 162098 */   GIR_Done,
     /* 162099 */ // Label 2327: @162099
     /* 162099 */ GIM_Reject,
     /* 162100 */ // Label 2324: @162100
     /* 162100 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(162125), // Rule ID 1292 //
     /* 162105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162118 */   // (uaddsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VADDUBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUBS),
     /* 162123 */   GIR_RootConstrainSelectedInstOperands,
     /* 162124 */   // GIR_Coverage, 1292,
     /* 162124 */   GIR_Done,
     /* 162125 */ // Label 2328: @162125
     /* 162125 */ GIM_Reject,
     /* 162126 */ // Label 2325: @162126
     /* 162126 */ GIM_Reject,
     /* 162127 */ // Label 37: @162127
     /* 162127 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2332*/ GIMT_Encode4(162228),
     /* 162138 */ /*GILLT_v4s32*//*Label 2329*/ GIMT_Encode4(162150),
     /* 162142 */ /*GILLT_v8s16*//*Label 2330*/ GIMT_Encode4(162176),
     /* 162146 */ /*GILLT_v16s8*//*Label 2331*/ GIMT_Encode4(162202),
     /* 162150 */ // Label 2329: @162150
     /* 162150 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(162175), // Rule ID 1295 //
     /* 162155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162168 */   // (saddsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VADDSWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSWS),
     /* 162173 */   GIR_RootConstrainSelectedInstOperands,
     /* 162174 */   // GIR_Coverage, 1295,
     /* 162174 */   GIR_Done,
     /* 162175 */ // Label 2333: @162175
     /* 162175 */ GIM_Reject,
     /* 162176 */ // Label 2330: @162176
     /* 162176 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(162201), // Rule ID 1293 //
     /* 162181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162194 */   // (saddsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VADDSHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSHS),
     /* 162199 */   GIR_RootConstrainSelectedInstOperands,
     /* 162200 */   // GIR_Coverage, 1293,
     /* 162200 */   GIR_Done,
     /* 162201 */ // Label 2334: @162201
     /* 162201 */ GIM_Reject,
     /* 162202 */ // Label 2331: @162202
     /* 162202 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(162227), // Rule ID 1291 //
     /* 162207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162220 */   // (saddsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VADDSBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSBS),
     /* 162225 */   GIR_RootConstrainSelectedInstOperands,
     /* 162226 */   // GIR_Coverage, 1291,
     /* 162226 */   GIR_Done,
     /* 162227 */ // Label 2335: @162227
     /* 162227 */ GIM_Reject,
     /* 162228 */ // Label 2332: @162228
     /* 162228 */ GIM_Reject,
     /* 162229 */ // Label 38: @162229
     /* 162229 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2339*/ GIMT_Encode4(162330),
     /* 162240 */ /*GILLT_v4s32*//*Label 2336*/ GIMT_Encode4(162252),
     /* 162244 */ /*GILLT_v8s16*//*Label 2337*/ GIMT_Encode4(162278),
     /* 162248 */ /*GILLT_v16s8*//*Label 2338*/ GIMT_Encode4(162304),
     /* 162252 */ // Label 2336: @162252
     /* 162252 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(162277), // Rule ID 1302 //
     /* 162257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162270 */   // (usubsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSUBUWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUWS),
     /* 162275 */   GIR_RootConstrainSelectedInstOperands,
     /* 162276 */   // GIR_Coverage, 1302,
     /* 162276 */   GIR_Done,
     /* 162277 */ // Label 2340: @162277
     /* 162277 */ GIM_Reject,
     /* 162278 */ // Label 2337: @162278
     /* 162278 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(162303), // Rule ID 1300 //
     /* 162283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162296 */   // (usubsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSUBUHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUHS),
     /* 162301 */   GIR_RootConstrainSelectedInstOperands,
     /* 162302 */   // GIR_Coverage, 1300,
     /* 162302 */   GIR_Done,
     /* 162303 */ // Label 2341: @162303
     /* 162303 */ GIM_Reject,
     /* 162304 */ // Label 2338: @162304
     /* 162304 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(162329), // Rule ID 1298 //
     /* 162309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162322 */   // (usubsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSUBUBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUBS),
     /* 162327 */   GIR_RootConstrainSelectedInstOperands,
     /* 162328 */   // GIR_Coverage, 1298,
     /* 162328 */   GIR_Done,
     /* 162329 */ // Label 2342: @162329
     /* 162329 */ GIM_Reject,
     /* 162330 */ // Label 2339: @162330
     /* 162330 */ GIM_Reject,
     /* 162331 */ // Label 39: @162331
     /* 162331 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2346*/ GIMT_Encode4(162432),
     /* 162342 */ /*GILLT_v4s32*//*Label 2343*/ GIMT_Encode4(162354),
     /* 162346 */ /*GILLT_v8s16*//*Label 2344*/ GIMT_Encode4(162380),
     /* 162350 */ /*GILLT_v16s8*//*Label 2345*/ GIMT_Encode4(162406),
     /* 162354 */ // Label 2343: @162354
     /* 162354 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(162379), // Rule ID 1301 //
     /* 162359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162372 */   // (ssubsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSUBSWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSWS),
     /* 162377 */   GIR_RootConstrainSelectedInstOperands,
     /* 162378 */   // GIR_Coverage, 1301,
     /* 162378 */   GIR_Done,
     /* 162379 */ // Label 2347: @162379
     /* 162379 */ GIM_Reject,
     /* 162380 */ // Label 2344: @162380
     /* 162380 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(162405), // Rule ID 1299 //
     /* 162385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162398 */   // (ssubsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSUBSHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSHS),
     /* 162403 */   GIR_RootConstrainSelectedInstOperands,
     /* 162404 */   // GIR_Coverage, 1299,
     /* 162404 */   GIR_Done,
     /* 162405 */ // Label 2348: @162405
     /* 162405 */ GIM_Reject,
     /* 162406 */ // Label 2345: @162406
     /* 162406 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(162431), // Rule ID 1297 //
     /* 162411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162424 */   // (ssubsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSUBSBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSBS),
     /* 162429 */   GIR_RootConstrainSelectedInstOperands,
     /* 162430 */   // GIR_Coverage, 1297,
     /* 162430 */   GIR_Done,
     /* 162431 */ // Label 2349: @162431
     /* 162431 */ GIM_Reject,
     /* 162432 */ // Label 2346: @162432
     /* 162432 */ GIM_Reject,
     /* 162433 */ // Label 40: @162433
     /* 162433 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2355*/ GIMT_Encode4(162727),
     /* 162444 */ /*GILLT_s32*//*Label 2350*/ GIMT_Encode4(162464),
     /* 162448 */ /*GILLT_s64*//*Label 2351*/ GIMT_Encode4(162538),
     /* 162452 */ /*GILLT_s128*//*Label 2352*/ GIMT_Encode4(162616),
     /* 162456 */ /*GILLT_v2s64*//*Label 2353*/ GIMT_Encode4(162642),
     /* 162460 */ /*GILLT_v4s32*//*Label 2354*/ GIMT_Encode4(162672),
     /* 162464 */ // Label 2350: @162464
     /* 162464 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(162537),
     /* 162469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 162472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162475 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(162494), // Rule ID 949 //
     /* 162480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 162483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 162487 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSADDSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 162487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDSP),
     /* 162492 */     GIR_RootConstrainSelectedInstOperands,
     /* 162493 */     // GIR_Coverage, 949,
     /* 162493 */     GIR_Done,
     /* 162494 */   // Label 2357: @162494
     /* 162494 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(162517), // Rule ID 239 //
     /* 162499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 162506 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 162506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADDS),
     /* 162511 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162515 */     GIR_RootConstrainSelectedInstOperands,
     /* 162516 */     // GIR_Coverage, 239,
     /* 162516 */     GIR_Done,
     /* 162517 */   // Label 2358: @162517
     /* 162517 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(162536), // Rule ID 579 //
     /* 162522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 162529 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSADD:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 162529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSADD),
     /* 162534 */     GIR_RootConstrainSelectedInstOperands,
     /* 162535 */     // GIR_Coverage, 579,
     /* 162535 */     GIR_Done,
     /* 162536 */   // Label 2359: @162536
     /* 162536 */   GIM_Reject,
     /* 162537 */ // Label 2356: @162537
     /* 162537 */ GIM_Reject,
     /* 162538 */ // Label 2351: @162538
     /* 162538 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(162615),
     /* 162543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 162546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162549 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(162572), // Rule ID 766 //
     /* 162554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162561 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSADDDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 162561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDDP),
     /* 162566 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162570 */     GIR_RootConstrainSelectedInstOperands,
     /* 162571 */     // GIR_Coverage, 766,
     /* 162571 */     GIR_Done,
     /* 162572 */   // Label 2361: @162572
     /* 162572 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(162595), // Rule ID 237 //
     /* 162577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 162584 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 162584 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADD),
     /* 162589 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162593 */     GIR_RootConstrainSelectedInstOperands,
     /* 162594 */     // GIR_Coverage, 237,
     /* 162594 */     GIR_Done,
     /* 162595 */   // Label 2362: @162595
     /* 162595 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(162614), // Rule ID 558 //
     /* 162600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 162607 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDADD:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 162607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDADD),
     /* 162612 */     GIR_RootConstrainSelectedInstOperands,
     /* 162613 */     // GIR_Coverage, 558,
     /* 162613 */     GIR_Done,
     /* 162614 */   // Label 2363: @162614
     /* 162614 */   GIM_Reject,
     /* 162615 */ // Label 2360: @162615
     /* 162615 */ GIM_Reject,
     /* 162616 */ // Label 2352: @162616
     /* 162616 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(162641), // Rule ID 984 //
     /* 162621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 162624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 162627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 162630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162634 */   // (fadd:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 162634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDQP),
     /* 162639 */   GIR_RootConstrainSelectedInstOperands,
     /* 162640 */   // GIR_Coverage, 984,
     /* 162640 */   GIR_Done,
     /* 162641 */ // Label 2364: @162641
     /* 162641 */ GIM_Reject,
     /* 162642 */ // Label 2353: @162642
     /* 162642 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(162671), // Rule ID 770 //
     /* 162647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 162660 */   // (fadd:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVADDDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 162660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDDP),
     /* 162665 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162669 */   GIR_RootConstrainSelectedInstOperands,
     /* 162670 */   // GIR_Coverage, 770,
     /* 162670 */   GIR_Done,
     /* 162671 */ // Label 2365: @162671
     /* 162671 */ GIM_Reject,
     /* 162672 */ // Label 2354: @162672
     /* 162672 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(162726),
     /* 162677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162683 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(162706), // Rule ID 772 //
     /* 162688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 162695 */     // (fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVADDSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 162695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDSP),
     /* 162700 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162704 */     GIR_RootConstrainSelectedInstOperands,
     /* 162705 */     // GIR_Coverage, 772,
     /* 162705 */     GIR_Done,
     /* 162706 */   // Label 2367: @162706
     /* 162706 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(162725), // Rule ID 300 //
     /* 162711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162718 */     // (fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VADDFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /* 162718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDFP),
     /* 162723 */     GIR_RootConstrainSelectedInstOperands,
     /* 162724 */     // GIR_Coverage, 300,
     /* 162724 */     GIR_Done,
     /* 162725 */   // Label 2368: @162725
     /* 162725 */   GIM_Reject,
     /* 162726 */ // Label 2366: @162726
     /* 162726 */ GIM_Reject,
     /* 162727 */ // Label 2355: @162727
     /* 162727 */ GIM_Reject,
     /* 162728 */ // Label 41: @162728
     /* 162728 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2374*/ GIMT_Encode4(163022),
     /* 162739 */ /*GILLT_s32*//*Label 2369*/ GIMT_Encode4(162759),
     /* 162743 */ /*GILLT_s64*//*Label 2370*/ GIMT_Encode4(162833),
     /* 162747 */ /*GILLT_s128*//*Label 2371*/ GIMT_Encode4(162911),
     /* 162751 */ /*GILLT_v2s64*//*Label 2372*/ GIMT_Encode4(162937),
     /* 162755 */ /*GILLT_v4s32*//*Label 2373*/ GIMT_Encode4(162967),
     /* 162759 */ // Label 2369: @162759
     /* 162759 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(162832),
     /* 162764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 162767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162770 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(162789), // Rule ID 953 //
     /* 162775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 162778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 162782 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSSUBSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 162782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBSP),
     /* 162787 */     GIR_RootConstrainSelectedInstOperands,
     /* 162788 */     // GIR_Coverage, 953,
     /* 162788 */     GIR_Done,
     /* 162789 */   // Label 2376: @162789
     /* 162789 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(162812), // Rule ID 251 //
     /* 162794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 162801 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 162801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUBS),
     /* 162806 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162810 */     GIR_RootConstrainSelectedInstOperands,
     /* 162811 */     // GIR_Coverage, 251,
     /* 162811 */     GIR_Done,
     /* 162812 */   // Label 2377: @162812
     /* 162812 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(162831), // Rule ID 597 //
     /* 162817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 162824 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSSUB:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 162824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSSUB),
     /* 162829 */     GIR_RootConstrainSelectedInstOperands,
     /* 162830 */     // GIR_Coverage, 597,
     /* 162830 */     GIR_Done,
     /* 162831 */   // Label 2378: @162831
     /* 162831 */   GIM_Reject,
     /* 162832 */ // Label 2375: @162832
     /* 162832 */ GIM_Reject,
     /* 162833 */ // Label 2370: @162833
     /* 162833 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(162910),
     /* 162838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 162841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162844 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(162867), // Rule ID 778 //
     /* 162849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162856 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSSUBDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 162856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBDP),
     /* 162861 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162865 */     GIR_RootConstrainSelectedInstOperands,
     /* 162866 */     // GIR_Coverage, 778,
     /* 162866 */     GIR_Done,
     /* 162867 */   // Label 2380: @162867
     /* 162867 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(162890), // Rule ID 249 //
     /* 162872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 162879 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 162879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUB),
     /* 162884 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162888 */     GIR_RootConstrainSelectedInstOperands,
     /* 162889 */     // GIR_Coverage, 249,
     /* 162889 */     GIR_Done,
     /* 162890 */   // Label 2381: @162890
     /* 162890 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(162909), // Rule ID 576 //
     /* 162895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 162902 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDSUB:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 162902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDSUB),
     /* 162907 */     GIR_RootConstrainSelectedInstOperands,
     /* 162908 */     // GIR_Coverage, 576,
     /* 162908 */     GIR_Done,
     /* 162909 */   // Label 2382: @162909
     /* 162909 */   GIM_Reject,
     /* 162910 */ // Label 2379: @162910
     /* 162910 */ GIM_Reject,
     /* 162911 */ // Label 2371: @162911
     /* 162911 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(162936), // Rule ID 988 //
     /* 162916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 162919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 162922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 162925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162929 */   // (fsub:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 162929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBQP),
     /* 162934 */   GIR_RootConstrainSelectedInstOperands,
     /* 162935 */   // GIR_Coverage, 988,
     /* 162935 */   GIR_Done,
     /* 162936 */ // Label 2383: @162936
     /* 162936 */ GIM_Reject,
     /* 162937 */ // Label 2372: @162937
     /* 162937 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(162966), // Rule ID 780 //
     /* 162942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 162955 */   // (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVSUBDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 162955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBDP),
     /* 162960 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162964 */   GIR_RootConstrainSelectedInstOperands,
     /* 162965 */   // GIR_Coverage, 780,
     /* 162965 */   GIR_Done,
     /* 162966 */ // Label 2384: @162966
     /* 162966 */ GIM_Reject,
     /* 162967 */ // Label 2373: @162967
     /* 162967 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(163021),
     /* 162972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162978 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(163001), // Rule ID 782 //
     /* 162983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 162990 */     // (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVSUBSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 162990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBSP),
     /* 162995 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162999 */     GIR_RootConstrainSelectedInstOperands,
     /* 163000 */     // GIR_Coverage, 782,
     /* 163000 */     GIR_Done,
     /* 163001 */   // Label 2386: @163001
     /* 163001 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(163020), // Rule ID 370 //
     /* 163006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 163009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163013 */     // (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VSUBFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /* 163013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBFP),
     /* 163018 */     GIR_RootConstrainSelectedInstOperands,
     /* 163019 */     // GIR_Coverage, 370,
     /* 163019 */     GIR_Done,
     /* 163020 */   // Label 2387: @163020
     /* 163020 */   GIM_Reject,
     /* 163021 */ // Label 2385: @163021
     /* 163021 */ GIM_Reject,
     /* 163022 */ // Label 2374: @163022
     /* 163022 */ GIM_Reject,
     /* 163023 */ // Label 42: @163023
     /* 163023 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2393*/ GIMT_Encode4(163372),
     /* 163034 */ /*GILLT_s32*//*Label 2388*/ GIMT_Encode4(163054),
     /* 163038 */ /*GILLT_s64*//*Label 2389*/ GIMT_Encode4(163128),
     /* 163042 */ /*GILLT_s128*//*Label 2390*/ GIMT_Encode4(163206),
     /* 163046 */ /*GILLT_v2s64*//*Label 2391*/ GIMT_Encode4(163232),
     /* 163050 */ /*GILLT_v4s32*//*Label 2392*/ GIMT_Encode4(163262),
     /* 163054 */ // Label 2388: @163054
     /* 163054 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(163127),
     /* 163059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 163062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163065 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(163084), // Rule ID 951 //
     /* 163070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163077 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSMULSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULSP),
     /* 163082 */     GIR_RootConstrainSelectedInstOperands,
     /* 163083 */     // GIR_Coverage, 951,
     /* 163083 */     GIR_Done,
     /* 163084 */   // Label 2395: @163084
     /* 163084 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(163107), // Rule ID 247 //
     /* 163089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163096 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)  =>  (FMULS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)
     /* 163096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMULS),
     /* 163101 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163105 */     GIR_RootConstrainSelectedInstOperands,
     /* 163106 */     // GIR_Coverage, 247,
     /* 163106 */     GIR_Done,
     /* 163107 */   // Label 2396: @163107
     /* 163107 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(163126), // Rule ID 593 //
     /* 163112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 163119 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSMUL:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 163119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSMUL),
     /* 163124 */     GIR_RootConstrainSelectedInstOperands,
     /* 163125 */     // GIR_Coverage, 593,
     /* 163125 */     GIR_Done,
     /* 163126 */   // Label 2397: @163126
     /* 163126 */   GIM_Reject,
     /* 163127 */ // Label 2394: @163127
     /* 163127 */ GIM_Reject,
     /* 163128 */ // Label 2389: @163128
     /* 163128 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(163205),
     /* 163133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 163136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163139 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(163162), // Rule ID 768 //
     /* 163144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163151 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSMULDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULDP),
     /* 163156 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163160 */     GIR_RootConstrainSelectedInstOperands,
     /* 163161 */     // GIR_Coverage, 768,
     /* 163161 */     GIR_Done,
     /* 163162 */   // Label 2399: @163162
     /* 163162 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(163185), // Rule ID 245 //
     /* 163167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163174 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)  =>  (FMUL:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)
     /* 163174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMUL),
     /* 163179 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163183 */     GIR_RootConstrainSelectedInstOperands,
     /* 163184 */     // GIR_Coverage, 245,
     /* 163184 */     GIR_Done,
     /* 163185 */   // Label 2400: @163185
     /* 163185 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(163204), // Rule ID 572 //
     /* 163190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 163197 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDMUL:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 163197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDMUL),
     /* 163202 */     GIR_RootConstrainSelectedInstOperands,
     /* 163203 */     // GIR_Coverage, 572,
     /* 163203 */     GIR_Done,
     /* 163204 */   // Label 2401: @163204
     /* 163204 */   GIM_Reject,
     /* 163205 */ // Label 2398: @163205
     /* 163205 */ GIM_Reject,
     /* 163206 */ // Label 2390: @163206
     /* 163206 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(163231), // Rule ID 986 //
     /* 163211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 163217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 163220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163224 */   // (fmul:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULQP),
     /* 163229 */   GIR_RootConstrainSelectedInstOperands,
     /* 163230 */   // GIR_Coverage, 986,
     /* 163230 */   GIR_Done,
     /* 163231 */ // Label 2402: @163231
     /* 163231 */ GIM_Reject,
     /* 163232 */ // Label 2391: @163232
     /* 163232 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(163261), // Rule ID 774 //
     /* 163237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163250 */   // (fmul:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVMULDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163250 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULDP),
     /* 163255 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163259 */   GIR_RootConstrainSelectedInstOperands,
     /* 163260 */   // GIR_Coverage, 774,
     /* 163260 */   GIR_Done,
     /* 163261 */ // Label 2403: @163261
     /* 163261 */ GIM_Reject,
     /* 163262 */ // Label 2392: @163262
     /* 163262 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(163371),
     /* 163267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163273 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(163296), // Rule ID 776 //
     /* 163278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163285 */     // (fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVMULSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 163285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULSP),
     /* 163290 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163294 */     GIR_RootConstrainSelectedInstOperands,
     /* 163295 */     // GIR_Coverage, 776,
     /* 163295 */     GIR_Done,
     /* 163296 */   // Label 2405: @163296
     /* 163296 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(163370), // Rule ID 1379 //
     /* 163301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 163304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163308 */     // (fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA, v4f32:{ *:[v4f32] }:$vB)  =>  (VMADDFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA, ?:{ *:[v4f32] }:$vB, (VSLW:{ *:[v4i32] } (V_SETALLONES:{ *:[v4i32] }), (V_SETALLONES:{ *:[v4i32] })))
     /* 163308 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 163311 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::V_SETALLONES),
     /* 163315 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 163322 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 163325 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::V_SETALLONES),
     /* 163329 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 163339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /* 163343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163348 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 163351 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 163354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /* 163359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 163361 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 163363 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 163365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163368 */     GIR_RootConstrainSelectedInstOperands,
     /* 163369 */     // GIR_Coverage, 1379,
     /* 163369 */     GIR_EraseRootFromParent_Done,
     /* 163370 */   // Label 2406: @163370
     /* 163370 */   GIM_Reject,
     /* 163371 */ // Label 2404: @163371
     /* 163371 */ GIM_Reject,
     /* 163372 */ // Label 2393: @163372
     /* 163372 */ GIM_Reject,
     /* 163373 */ // Label 43: @163373
     /* 163373 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2412*/ GIMT_Encode4(163953),
     /* 163384 */ /*GILLT_s32*//*Label 2407*/ GIMT_Encode4(163404),
     /* 163388 */ /*GILLT_s64*//*Label 2408*/ GIMT_Encode4(163550),
     /* 163392 */ /*GILLT_s128*//*Label 2409*/ GIMT_Encode4(163696),
     /* 163396 */ /*GILLT_v2s64*//*Label 2410*/ GIMT_Encode4(163774),
     /* 163400 */ /*GILLT_v4s32*//*Label 2411*/ GIMT_Encode4(163852),
     /* 163404 */ // Label 2407: @163404
     /* 163404 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(163549),
     /* 163409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 163412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163415 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163418 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(163459), // Rule ID 965 //
     /* 163423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 163442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163444 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi))  =>  (XSMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBASP),
     /* 163447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 163453 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163455 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163457 */     GIR_RootConstrainSelectedInstOperands,
     /* 163458 */     // GIR_Coverage, 965,
     /* 163458 */     GIR_EraseRootFromParent_Done,
     /* 163459 */   // Label 2414: @163459
     /* 163459 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(163484), // Rule ID 963 //
     /* 163464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163471 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi)  =>  (XSMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDASP),
     /* 163474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163476 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 163478 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163480 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163482 */     GIR_RootConstrainSelectedInstOperands,
     /* 163483 */     // GIR_Coverage, 963,
     /* 163483 */     GIR_EraseRootFromParent_Done,
     /* 163484 */   // Label 2415: @163484
     /* 163484 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(163525), // Rule ID 225 //
     /* 163489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 163508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163510 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB))  =>  (FMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 163510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /* 163513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 163515 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 163517 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 163519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 163523 */     GIR_RootConstrainSelectedInstOperands,
     /* 163524 */     // GIR_Coverage, 225,
     /* 163524 */     GIR_EraseRootFromParent_Done,
     /* 163525 */   // Label 2416: @163525
     /* 163525 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(163548), // Rule ID 221 //
     /* 163530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163537 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)  =>  (FMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 163537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADDS),
     /* 163542 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163546 */     GIR_RootConstrainSelectedInstOperands,
     /* 163547 */     // GIR_Coverage, 221,
     /* 163547 */     GIR_Done,
     /* 163548 */   // Label 2417: @163548
     /* 163548 */   GIM_Reject,
     /* 163549 */ // Label 2413: @163549
     /* 163549 */ GIM_Reject,
     /* 163550 */ // Label 2408: @163550
     /* 163550 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(163695),
     /* 163555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 163558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163561 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 163564 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(163605), // Rule ID 786 //
     /* 163569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 163588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163590 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi))  =>  (XSMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBADP),
     /* 163593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 163599 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163601 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163603 */     GIR_RootConstrainSelectedInstOperands,
     /* 163604 */     // GIR_Coverage, 786,
     /* 163604 */     GIR_EraseRootFromParent_Done,
     /* 163605 */   // Label 2419: @163605
     /* 163605 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(163630), // Rule ID 784 //
     /* 163610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163617 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi)  =>  (XSMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDADP),
     /* 163620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163622 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 163624 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163626 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163628 */     GIR_RootConstrainSelectedInstOperands,
     /* 163629 */     // GIR_Coverage, 784,
     /* 163629 */     GIR_EraseRootFromParent_Done,
     /* 163630 */   // Label 2420: @163630
     /* 163630 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(163671), // Rule ID 223 //
     /* 163635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 163654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163656 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB))  =>  (FMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 163656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /* 163659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 163661 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 163663 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 163665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 163669 */     GIR_RootConstrainSelectedInstOperands,
     /* 163670 */     // GIR_Coverage, 223,
     /* 163670 */     GIR_EraseRootFromParent_Done,
     /* 163671 */   // Label 2421: @163671
     /* 163671 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(163694), // Rule ID 219 //
     /* 163676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163683 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)  =>  (FMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 163683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADD),
     /* 163688 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163692 */     GIR_RootConstrainSelectedInstOperands,
     /* 163693 */     // GIR_Coverage, 219,
     /* 163693 */     GIR_Done,
     /* 163694 */   // Label 2422: @163694
     /* 163694 */   GIM_Reject,
     /* 163695 */ // Label 2418: @163695
     /* 163695 */ GIM_Reject,
     /* 163696 */ // Label 2409: @163696
     /* 163696 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(163773),
     /* 163701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 163704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 163707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 163710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163714 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(163751), // Rule ID 996 //
     /* 163719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 163734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163736 */     // (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQP),
     /* 163739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 163741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /* 163745 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 163747 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 163749 */     GIR_RootConstrainSelectedInstOperands,
     /* 163750 */     // GIR_Coverage, 996,
     /* 163750 */     GIR_EraseRootFromParent_Done,
     /* 163751 */   // Label 2424: @163751
     /* 163751 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(163772), // Rule ID 994 //
     /* 163756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163759 */     // (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQP),
     /* 163762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 163764 */     GIR_RootToRootCopy, /*OpIdx*/3, // RSTi
     /* 163766 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 163768 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 163770 */     GIR_RootConstrainSelectedInstOperands,
     /* 163771 */     // GIR_Coverage, 994,
     /* 163771 */     GIR_EraseRootFromParent_Done,
     /* 163772 */   // Label 2425: @163772
     /* 163772 */   GIM_Reject,
     /* 163773 */ // Label 2423: @163773
     /* 163773 */ GIM_Reject,
     /* 163774 */ // Label 2410: @163774
     /* 163774 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(163851),
     /* 163779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163785 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163792 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(163829), // Rule ID 796 //
     /* 163797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163814 */     // (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi))  =>  (XVMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBADP),
     /* 163817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 163823 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163825 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163827 */     GIR_RootConstrainSelectedInstOperands,
     /* 163828 */     // GIR_Coverage, 796,
     /* 163828 */     GIR_EraseRootFromParent_Done,
     /* 163829 */   // Label 2427: @163829
     /* 163829 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(163850), // Rule ID 792 //
     /* 163834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163837 */     // (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi)  =>  (XVMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDADP),
     /* 163840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163842 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 163844 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163846 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163848 */     GIR_RootConstrainSelectedInstOperands,
     /* 163849 */     // GIR_Coverage, 792,
     /* 163849 */     GIR_EraseRootFromParent_Done,
     /* 163850 */   // Label 2428: @163850
     /* 163850 */   GIM_Reject,
     /* 163851 */ // Label 2426: @163851
     /* 163851 */ GIM_Reject,
     /* 163852 */ // Label 2411: @163852
     /* 163852 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(163952),
     /* 163857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163863 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163866 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(163907), // Rule ID 798 //
     /* 163871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163892 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi))  =>  (XVMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 163892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBASP),
     /* 163895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 163901 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163903 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163905 */     GIR_RootConstrainSelectedInstOperands,
     /* 163906 */     // GIR_Coverage, 798,
     /* 163906 */     GIR_EraseRootFromParent_Done,
     /* 163907 */   // Label 2430: @163907
     /* 163907 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(163932), // Rule ID 794 //
     /* 163912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163919 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi)  =>  (XVMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 163919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDASP),
     /* 163922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163924 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 163926 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163928 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163930 */     GIR_RootConstrainSelectedInstOperands,
     /* 163931 */     // GIR_Coverage, 794,
     /* 163931 */     GIR_EraseRootFromParent_Done,
     /* 163932 */   // Label 2431: @163932
     /* 163932 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(163951), // Rule ID 292 //
     /* 163937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 163940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163944 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)  =>  (VMADDFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)
     /* 163944 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /* 163949 */     GIR_RootConstrainSelectedInstOperands,
     /* 163950 */     // GIR_Coverage, 292,
     /* 163950 */     GIR_Done,
     /* 163951 */   // Label 2432: @163951
     /* 163951 */   GIM_Reject,
     /* 163952 */ // Label 2429: @163952
     /* 163952 */ GIM_Reject,
     /* 163953 */ // Label 2412: @163953
     /* 163953 */ GIM_Reject,
     /* 163954 */ // Label 44: @163954
     /* 163954 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2438*/ GIMT_Encode4(164223),
     /* 163965 */ /*GILLT_s32*//*Label 2433*/ GIMT_Encode4(163985),
     /* 163969 */ /*GILLT_s64*//*Label 2434*/ GIMT_Encode4(164059),
     /* 163973 */ /*GILLT_s128*//*Label 2435*/ GIMT_Encode4(164137),
     /* 163977 */ /*GILLT_v2s64*//*Label 2436*/ GIMT_Encode4(164163),
     /* 163981 */ /*GILLT_v4s32*//*Label 2437*/ GIMT_Encode4(164193),
     /* 163985 */ // Label 2433: @163985
     /* 163985 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(164058),
     /* 163990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 163993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163996 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(164015), // Rule ID 955 //
     /* 164001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164008 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSDIVSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVSP),
     /* 164013 */     GIR_RootConstrainSelectedInstOperands,
     /* 164014 */     // GIR_Coverage, 955,
     /* 164014 */     GIR_Done,
     /* 164015 */   // Label 2440: @164015
     /* 164015 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(164038), // Rule ID 243 //
     /* 164020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164027 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FDIVS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 164027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIVS),
     /* 164032 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164036 */     GIR_RootConstrainSelectedInstOperands,
     /* 164037 */     // GIR_Coverage, 243,
     /* 164037 */     GIR_Done,
     /* 164038 */   // Label 2441: @164038
     /* 164038 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(164057), // Rule ID 591 //
     /* 164043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 164050 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSDIV:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 164050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSDIV),
     /* 164055 */     GIR_RootConstrainSelectedInstOperands,
     /* 164056 */     // GIR_Coverage, 591,
     /* 164056 */     GIR_Done,
     /* 164057 */   // Label 2442: @164057
     /* 164057 */   GIM_Reject,
     /* 164058 */ // Label 2439: @164058
     /* 164058 */ GIM_Reject,
     /* 164059 */ // Label 2434: @164059
     /* 164059 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(164136),
     /* 164064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 164067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164070 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(164093), // Rule ID 807 //
     /* 164075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164082 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSDIVDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 164082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVDP),
     /* 164087 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164091 */     GIR_RootConstrainSelectedInstOperands,
     /* 164092 */     // GIR_Coverage, 807,
     /* 164092 */     GIR_Done,
     /* 164093 */   // Label 2444: @164093
     /* 164093 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(164116), // Rule ID 241 //
     /* 164098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 164105 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FDIV:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 164105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIV),
     /* 164110 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164114 */     GIR_RootConstrainSelectedInstOperands,
     /* 164115 */     // GIR_Coverage, 241,
     /* 164115 */     GIR_Done,
     /* 164116 */   // Label 2445: @164116
     /* 164116 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(164135), // Rule ID 570 //
     /* 164121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 164128 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDDIV:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 164128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDDIV),
     /* 164133 */     GIR_RootConstrainSelectedInstOperands,
     /* 164134 */     // GIR_Coverage, 570,
     /* 164134 */     GIR_Done,
     /* 164135 */   // Label 2446: @164135
     /* 164135 */   GIM_Reject,
     /* 164136 */ // Label 2443: @164136
     /* 164136 */ GIM_Reject,
     /* 164137 */ // Label 2435: @164137
     /* 164137 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(164162), // Rule ID 990 //
     /* 164142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 164148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 164151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 164155 */   // (fdiv:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 164155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVQP),
     /* 164160 */   GIR_RootConstrainSelectedInstOperands,
     /* 164161 */   // GIR_Coverage, 990,
     /* 164161 */   GIR_Done,
     /* 164162 */ // Label 2447: @164162
     /* 164162 */ GIM_Reject,
     /* 164163 */ // Label 2436: @164163
     /* 164163 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(164192), // Rule ID 816 //
     /* 164168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 164174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164181 */   // (fdiv:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVDIVDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 164181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /* 164186 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164190 */   GIR_RootConstrainSelectedInstOperands,
     /* 164191 */   // GIR_Coverage, 816,
     /* 164191 */   GIR_Done,
     /* 164192 */ // Label 2448: @164192
     /* 164192 */ GIM_Reject,
     /* 164193 */ // Label 2437: @164193
     /* 164193 */ GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(164222), // Rule ID 818 //
     /* 164198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164211 */   // (fdiv:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVDIVSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 164211 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /* 164216 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164220 */   GIR_RootConstrainSelectedInstOperands,
     /* 164221 */   // GIR_Coverage, 818,
     /* 164221 */   GIR_Done,
     /* 164222 */ // Label 2449: @164222
     /* 164222 */ GIM_Reject,
     /* 164223 */ // Label 2438: @164223
     /* 164223 */ GIM_Reject,
     /* 164224 */ // Label 45: @164224
     /* 164224 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2455*/ GIMT_Encode4(166694),
     /* 164235 */ /*GILLT_s32*//*Label 2450*/ GIMT_Encode4(164255),
     /* 164239 */ /*GILLT_s64*//*Label 2451*/ GIMT_Encode4(165028),
     /* 164243 */ /*GILLT_s128*//*Label 2452*/ GIMT_Encode4(165682),
     /* 164247 */ /*GILLT_v2s64*//*Label 2453*/ GIMT_Encode4(166090),
     /* 164251 */ /*GILLT_v4s32*//*Label 2454*/ GIMT_Encode4(166376),
     /* 164255 */ // Label 2450: @164255
     /* 164255 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(165027),
     /* 164260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 164263 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(164328), // Rule ID 969 //
     /* 164268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164291 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 164307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164309 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi)))  =>  (XSNMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBASP),
     /* 164312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 164318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164326 */     GIR_RootConstrainSelectedInstOperands,
     /* 164327 */     // GIR_Coverage, 969,
     /* 164327 */     GIR_EraseRootFromParent_Done,
     /* 164328 */   // Label 2457: @164328
     /* 164328 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(164393), // Rule ID 968 //
     /* 164333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 164348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164356 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 164372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164374 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi)))  =>  (XSNMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBASP),
     /* 164377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 164383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164391 */     GIR_RootConstrainSelectedInstOperands,
     /* 164392 */     // GIR_Coverage, 968,
     /* 164392 */     GIR_EraseRootFromParent_Done,
     /* 164393 */   // Label 2458: @164393
     /* 164393 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(164446), // Rule ID 967 //
     /* 164398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164421 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164427 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi))  =>  (XSNMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDASP),
     /* 164430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 164436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164444 */     GIR_RootConstrainSelectedInstOperands,
     /* 164445 */     // GIR_Coverage, 967,
     /* 164445 */     GIR_EraseRootFromParent_Done,
     /* 164446 */   // Label 2459: @164446
     /* 164446 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(164499), // Rule ID 966 //
     /* 164451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 164466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164474 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164480 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi))  =>  (XSNMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDASP),
     /* 164483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 164489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164497 */     GIR_RootConstrainSelectedInstOperands,
     /* 164498 */     // GIR_Coverage, 966,
     /* 164498 */     GIR_EraseRootFromParent_Done,
     /* 164499 */   // Label 2460: @164499
     /* 164499 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(164536), // Rule ID 841 //
     /* 164504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 164519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164525 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$XB))  =>  (XSNABSDPs:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 164525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDPs),
     /* 164528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 164534 */     GIR_RootConstrainSelectedInstOperands,
     /* 164535 */     // GIR_Coverage, 841,
     /* 164535 */     GIR_EraseRootFromParent_Done,
     /* 164536 */   // Label 2461: @164536
     /* 164536 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(164614), // Rule ID 1678 //
     /* 164541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 164556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164562 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$S))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSNABSDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 164562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 164565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // S
     /* 164578 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /* 164590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164595 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 164598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164613 */     // GIR_Coverage, 1678,
     /* 164613 */     GIR_EraseRootFromParent_Done,
     /* 164614 */   // Label 2462: @164614
     /* 164614 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(164678), // Rule ID 1919 //
     /* 164619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164626 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSNEGDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 164626 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 164629 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164633 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164638 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 164642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSNEGDP),
     /* 164654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164659 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 164662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164677 */     // GIR_Coverage, 1919,
     /* 164677 */     GIR_EraseRootFromParent_Done,
     /* 164678 */   // Label 2463: @164678
     /* 164678 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(164743), // Rule ID 233 //
     /* 164683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164706 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 164722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164724 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB)))  =>  (FNMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 164724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUBS),
     /* 164727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 164729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 164733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 164737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 164741 */     GIR_RootConstrainSelectedInstOperands,
     /* 164742 */     // GIR_Coverage, 233,
     /* 164742 */     GIR_EraseRootFromParent_Done,
     /* 164743 */   // Label 2464: @164743
     /* 164743 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(164808), // Rule ID 232 //
     /* 164748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 164763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164771 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 164787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164789 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB)))  =>  (FNMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 164789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUBS),
     /* 164792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 164794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 164798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 164802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 164806 */     GIR_RootConstrainSelectedInstOperands,
     /* 164807 */     // GIR_Coverage, 232,
     /* 164807 */     GIR_EraseRootFromParent_Done,
     /* 164808 */   // Label 2465: @164808
     /* 164808 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(164861), // Rule ID 229 //
     /* 164813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164836 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164842 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB))  =>  (FNMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 164842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /* 164845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 164847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 164851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 164855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 164859 */     GIR_RootConstrainSelectedInstOperands,
     /* 164860 */     // GIR_Coverage, 229,
     /* 164860 */     GIR_EraseRootFromParent_Done,
     /* 164861 */   // Label 2466: @164861
     /* 164861 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(164914), // Rule ID 228 //
     /* 164866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 164881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164889 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164895 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB))  =>  (FNMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 164895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /* 164898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 164900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 164904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 164908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 164912 */     GIR_RootConstrainSelectedInstOperands,
     /* 164913 */     // GIR_Coverage, 228,
     /* 164913 */     GIR_EraseRootFromParent_Done,
     /* 164914 */   // Label 2467: @164914
     /* 164914 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(164951), // Rule ID 165 //
     /* 164919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 164934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164940 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$RB))  =>  (FNABSS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 164940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSS),
     /* 164943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 164945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 164949 */     GIR_RootConstrainSelectedInstOperands,
     /* 164950 */     // GIR_Coverage, 165,
     /* 164950 */     GIR_EraseRootFromParent_Done,
     /* 164951 */   // Label 2468: @164951
     /* 164951 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(164988), // Rule ID 594 //
     /* 164956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 164963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 164971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164977 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$RA))  =>  (EFSNABS:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 164977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EFSNABS),
     /* 164980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 164982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 164986 */     GIR_RootConstrainSelectedInstOperands,
     /* 164987 */     // GIR_Coverage, 594,
     /* 164987 */     GIR_EraseRootFromParent_Done,
     /* 164988 */   // Label 2469: @164988
     /* 164988 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(165007), // Rule ID 167 //
     /* 164993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165000 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FNEGS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 165000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FNEGS),
     /* 165005 */     GIR_RootConstrainSelectedInstOperands,
     /* 165006 */     // GIR_Coverage, 167,
     /* 165006 */     GIR_Done,
     /* 165007 */   // Label 2470: @165007
     /* 165007 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(165026), // Rule ID 595 //
     /* 165012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 165019 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$RA)  =>  (EFSNEG:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 165019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSNEG),
     /* 165024 */     GIR_RootConstrainSelectedInstOperands,
     /* 165025 */     // GIR_Coverage, 595,
     /* 165025 */     GIR_Done,
     /* 165026 */   // Label 2471: @165026
     /* 165026 */   GIM_Reject,
     /* 165027 */ // Label 2456: @165027
     /* 165027 */ GIM_Reject,
     /* 165028 */ // Label 2451: @165028
     /* 165028 */ GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(165681),
     /* 165033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 165036 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(165101), // Rule ID 790 //
     /* 165041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165064 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165082 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi)))  =>  (XSNMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBADP),
     /* 165085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 165091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165099 */     GIR_RootConstrainSelectedInstOperands,
     /* 165100 */     // GIR_Coverage, 790,
     /* 165100 */     GIR_EraseRootFromParent_Done,
     /* 165101 */   // Label 2473: @165101
     /* 165101 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(165166), // Rule ID 789 //
     /* 165106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165129 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165147 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi)))  =>  (XSNMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBADP),
     /* 165150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 165156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165164 */     GIR_RootConstrainSelectedInstOperands,
     /* 165165 */     // GIR_Coverage, 789,
     /* 165165 */     GIR_EraseRootFromParent_Done,
     /* 165166 */   // Label 2474: @165166
     /* 165166 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(165219), // Rule ID 788 //
     /* 165171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165194 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165200 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi))  =>  (XSNMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDADP),
     /* 165203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 165209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165217 */     GIR_RootConstrainSelectedInstOperands,
     /* 165218 */     // GIR_Coverage, 788,
     /* 165218 */     GIR_EraseRootFromParent_Done,
     /* 165219 */   // Label 2475: @165219
     /* 165219 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(165272), // Rule ID 787 //
     /* 165224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165247 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165253 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi))  =>  (XSNMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDADP),
     /* 165256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 165262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165270 */     GIR_RootConstrainSelectedInstOperands,
     /* 165271 */     // GIR_Coverage, 787,
     /* 165271 */     GIR_EraseRootFromParent_Done,
     /* 165272 */   // Label 2476: @165272
     /* 165272 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(165309), // Rule ID 840 //
     /* 165277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165298 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$XB))  =>  (XSNABSDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 165298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /* 165301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 165307 */     GIR_RootConstrainSelectedInstOperands,
     /* 165308 */     // GIR_Coverage, 840,
     /* 165308 */     GIR_EraseRootFromParent_Done,
     /* 165309 */   // Label 2477: @165309
     /* 165309 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(165332), // Rule ID 842 //
     /* 165314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165321 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSNEGDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 165321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSNEGDP),
     /* 165326 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 165330 */     GIR_RootConstrainSelectedInstOperands,
     /* 165331 */     // GIR_Coverage, 842,
     /* 165331 */     GIR_Done,
     /* 165332 */   // Label 2478: @165332
     /* 165332 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(165397), // Rule ID 231 //
     /* 165337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165360 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165378 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB)))  =>  (FNMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUB),
     /* 165381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 165395 */     GIR_RootConstrainSelectedInstOperands,
     /* 165396 */     // GIR_Coverage, 231,
     /* 165396 */     GIR_EraseRootFromParent_Done,
     /* 165397 */   // Label 2479: @165397
     /* 165397 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(165462), // Rule ID 230 //
     /* 165402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165425 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165443 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB)))  =>  (FNMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUB),
     /* 165446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 165460 */     GIR_RootConstrainSelectedInstOperands,
     /* 165461 */     // GIR_Coverage, 230,
     /* 165461 */     GIR_EraseRootFromParent_Done,
     /* 165462 */   // Label 2480: @165462
     /* 165462 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(165515), // Rule ID 227 //
     /* 165467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165490 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165496 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB))  =>  (FNMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /* 165499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 165513 */     GIR_RootConstrainSelectedInstOperands,
     /* 165514 */     // GIR_Coverage, 227,
     /* 165514 */     GIR_EraseRootFromParent_Done,
     /* 165515 */   // Label 2481: @165515
     /* 165515 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(165568), // Rule ID 226 //
     /* 165520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165543 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165549 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB))  =>  (FNMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /* 165552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 165566 */     GIR_RootConstrainSelectedInstOperands,
     /* 165567 */     // GIR_Coverage, 226,
     /* 165567 */     GIR_EraseRootFromParent_Done,
     /* 165568 */   // Label 2482: @165568
     /* 165568 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(165605), // Rule ID 166 //
     /* 165573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165594 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$RB))  =>  (FNABSD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 165594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSD),
     /* 165597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 165603 */     GIR_RootConstrainSelectedInstOperands,
     /* 165604 */     // GIR_Coverage, 166,
     /* 165604 */     GIR_EraseRootFromParent_Done,
     /* 165605 */   // Label 2483: @165605
     /* 165605 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(165642), // Rule ID 573 //
     /* 165610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 165617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165631 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$RA))  =>  (EFDNABS:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 165631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EFDNABS),
     /* 165634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 165636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 165640 */     GIR_RootConstrainSelectedInstOperands,
     /* 165641 */     // GIR_Coverage, 573,
     /* 165641 */     GIR_EraseRootFromParent_Done,
     /* 165642 */   // Label 2484: @165642
     /* 165642 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(165661), // Rule ID 168 //
     /* 165647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165654 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FNEGD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 165654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FNEGD),
     /* 165659 */     GIR_RootConstrainSelectedInstOperands,
     /* 165660 */     // GIR_Coverage, 168,
     /* 165660 */     GIR_Done,
     /* 165661 */   // Label 2485: @165661
     /* 165661 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(165680), // Rule ID 574 //
     /* 165666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 165673 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$RA)  =>  (EFDNEG:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 165673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDNEG),
     /* 165678 */     GIR_RootConstrainSelectedInstOperands,
     /* 165679 */     // GIR_Coverage, 574,
     /* 165679 */     GIR_Done,
     /* 165680 */   // Label 2486: @165680
     /* 165680 */   GIM_Reject,
     /* 165681 */ // Label 2472: @165681
     /* 165681 */ GIM_Reject,
     /* 165682 */ // Label 2452: @165682
     /* 165682 */ GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(166089),
     /* 165687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 165690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 165694 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(165763), // Rule ID 1009 //
     /* 165699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 165710 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 165713 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /* 165718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 165722 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 165726 */     GIM_CheckType, /*MI*/1, /*Op*/4, /*Type*/GILLT_s128,
     /* 165730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/4, // MIs[2]
     /* 165734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 165742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165744 */     // (fneg:{ *:[f128] } (intrinsic_wo_chain:{ *:[f128] } 10601:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 165744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQPO),
     /* 165747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 165753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RA
     /* 165757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RB
     /* 165761 */     GIR_RootConstrainSelectedInstOperands,
     /* 165762 */     // GIR_Coverage, 1009,
     /* 165762 */     GIR_EraseRootFromParent_Done,
     /* 165763 */   // Label 2488: @165763
     /* 165763 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(165820), // Rule ID 1008 //
     /* 165768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 165779 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 165782 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /* 165787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 165791 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 165795 */     GIM_CheckType, /*MI*/1, /*Op*/4, /*Type*/GILLT_s128,
     /* 165799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165801 */     // (fneg:{ *:[f128] } (intrinsic_wo_chain:{ *:[f128] } 10601:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 165801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQPO),
     /* 165804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/4, // RSTi
     /* 165810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RA
     /* 165814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RB
     /* 165818 */     GIR_RootConstrainSelectedInstOperands,
     /* 165819 */     // GIR_Coverage, 1008,
     /* 165819 */     GIR_EraseRootFromParent_Done,
     /* 165820 */   // Label 2489: @165820
     /* 165820 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(165881), // Rule ID 1000 //
     /* 165825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 165840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 165844 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 165848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 165860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165862 */     // (fneg:{ *:[f128] } (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 165862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQP),
     /* 165865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 165871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 165875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 165879 */     GIR_RootConstrainSelectedInstOperands,
     /* 165880 */     // GIR_Coverage, 1000,
     /* 165880 */     GIR_EraseRootFromParent_Done,
     /* 165881 */   // Label 2490: @165881
     /* 165881 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(165942), // Rule ID 999 //
     /* 165886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 165901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 165905 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 165909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 165921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165923 */     // (fneg:{ *:[f128] } (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 165923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQP),
     /* 165926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 165932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 165936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 165940 */     GIR_RootConstrainSelectedInstOperands,
     /* 165941 */     // GIR_Coverage, 999,
     /* 165941 */     GIR_EraseRootFromParent_Done,
     /* 165942 */   // Label 2491: @165942
     /* 165942 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(165991), // Rule ID 998 //
     /* 165947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 165962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 165966 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 165970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165972 */     // (fneg:{ *:[f128] } (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 165972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQP),
     /* 165975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RSTi
     /* 165981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 165985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 165989 */     GIR_RootConstrainSelectedInstOperands,
     /* 165990 */     // GIR_Coverage, 998,
     /* 165990 */     GIR_EraseRootFromParent_Done,
     /* 165991 */   // Label 2492: @165991
     /* 165991 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(166040), // Rule ID 997 //
     /* 165996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166015 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166021 */     // (fneg:{ *:[f128] } (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQP),
     /* 166024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RSTi
     /* 166030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 166034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 166038 */     GIR_RootConstrainSelectedInstOperands,
     /* 166039 */     // GIR_Coverage, 997,
     /* 166039 */     GIR_EraseRootFromParent_Done,
     /* 166040 */   // Label 2493: @166040
     /* 166040 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(166073), // Rule ID 981 //
     /* 166045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 166056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166062 */     // (fneg:{ *:[f128] } (fabs:{ *:[f128] } f128:{ *:[f128] }:$RB))  =>  (XSNABSQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 166062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSQP),
     /* 166065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 166071 */     GIR_RootConstrainSelectedInstOperands,
     /* 166072 */     // GIR_Coverage, 981,
     /* 166072 */     GIR_EraseRootFromParent_Done,
     /* 166073 */   // Label 2494: @166073
     /* 166073 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(166088), // Rule ID 982 //
     /* 166078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166081 */     // (fneg:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSNEGQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 166081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSNEGQP),
     /* 166086 */     GIR_RootConstrainSelectedInstOperands,
     /* 166087 */     // GIR_Coverage, 982,
     /* 166087 */     GIR_Done,
     /* 166088 */   // Label 2495: @166088
     /* 166088 */   GIM_Reject,
     /* 166089 */ // Label 2487: @166089
     /* 166089 */ GIM_Reject,
     /* 166090 */ // Label 2453: @166090
     /* 166090 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(166375),
     /* 166095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166102 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(166163), // Rule ID 803 //
     /* 166107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166126 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166144 */     // (fneg:{ *:[v2f64] } (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi)))  =>  (XVNMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBADP),
     /* 166147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166161 */     GIR_RootConstrainSelectedInstOperands,
     /* 166162 */     // GIR_Coverage, 803,
     /* 166162 */     GIR_EraseRootFromParent_Done,
     /* 166163 */   // Label 2497: @166163
     /* 166163 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(166224), // Rule ID 802 //
     /* 166168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166205 */     // (fneg:{ *:[v2f64] } (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi)))  =>  (XVNMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBADP),
     /* 166208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166222 */     GIR_RootConstrainSelectedInstOperands,
     /* 166223 */     // GIR_Coverage, 802,
     /* 166223 */     GIR_EraseRootFromParent_Done,
     /* 166224 */   // Label 2498: @166224
     /* 166224 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(166273), // Rule ID 800 //
     /* 166229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166248 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166254 */     // (fneg:{ *:[v2f64] } (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi))  =>  (XVNMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDADP),
     /* 166257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 166263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166271 */     GIR_RootConstrainSelectedInstOperands,
     /* 166272 */     // GIR_Coverage, 800,
     /* 166272 */     GIR_EraseRootFromParent_Done,
     /* 166273 */   // Label 2499: @166273
     /* 166273 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(166322), // Rule ID 799 //
     /* 166278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166297 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166303 */     // (fneg:{ *:[v2f64] } (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi))  =>  (XVNMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDADP),
     /* 166306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 166312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166320 */     GIR_RootConstrainSelectedInstOperands,
     /* 166321 */     // GIR_Coverage, 799,
     /* 166321 */     GIR_EraseRootFromParent_Done,
     /* 166322 */   // Label 2500: @166322
     /* 166322 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(166355), // Rule ID 848 //
     /* 166327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 166338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166344 */     // (fneg:{ *:[v2f64] } (fabs:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB))  =>  (XVNABSDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 166344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNABSDP),
     /* 166347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 166353 */     GIR_RootConstrainSelectedInstOperands,
     /* 166354 */     // GIR_Coverage, 848,
     /* 166354 */     GIR_EraseRootFromParent_Done,
     /* 166355 */   // Label 2501: @166355
     /* 166355 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(166374), // Rule ID 850 //
     /* 166360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166363 */     // (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVNEGDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 166363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVNEGDP),
     /* 166368 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166372 */     GIR_RootConstrainSelectedInstOperands,
     /* 166373 */     // GIR_Coverage, 850,
     /* 166373 */     GIR_Done,
     /* 166374 */   // Label 2502: @166374
     /* 166374 */   GIM_Reject,
     /* 166375 */ // Label 2496: @166375
     /* 166375 */ GIM_Reject,
     /* 166376 */ // Label 2454: @166376
     /* 166376 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(166693),
     /* 166381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166384 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(166449), // Rule ID 805 //
     /* 166389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166412 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166430 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi)))  =>  (XVNMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 166430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBASP),
     /* 166433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166447 */     GIR_RootConstrainSelectedInstOperands,
     /* 166448 */     // GIR_Coverage, 805,
     /* 166448 */     GIR_EraseRootFromParent_Done,
     /* 166449 */   // Label 2504: @166449
     /* 166449 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(166514), // Rule ID 804 //
     /* 166454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166477 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166495 */     // (fneg:{ *:[v4f32] } (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi)))  =>  (XVNMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 166495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBASP),
     /* 166498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166512 */     GIR_RootConstrainSelectedInstOperands,
     /* 166513 */     // GIR_Coverage, 804,
     /* 166513 */     GIR_EraseRootFromParent_Done,
     /* 166514 */   // Label 2505: @166514
     /* 166514 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(166567), // Rule ID 801 //
     /* 166519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166542 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166548 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi))  =>  (XVNMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 166548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDASP),
     /* 166551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 166557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166565 */     GIR_RootConstrainSelectedInstOperands,
     /* 166566 */     // GIR_Coverage, 801,
     /* 166566 */     GIR_EraseRootFromParent_Done,
     /* 166567 */   // Label 2506: @166567
     /* 166567 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(166604), // Rule ID 849 //
     /* 166572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 166587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166593 */     // (fneg:{ *:[v4f32] } (fabs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB))  =>  (XVNABSSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 166593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNABSSP),
     /* 166596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 166602 */     GIR_RootConstrainSelectedInstOperands,
     /* 166603 */     // GIR_Coverage, 849,
     /* 166603 */     GIR_EraseRootFromParent_Done,
     /* 166604 */   // Label 2507: @166604
     /* 166604 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(166627), // Rule ID 851 //
     /* 166609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166616 */     // (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVNEGSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 166616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVNEGSP),
     /* 166621 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166625 */     GIR_RootConstrainSelectedInstOperands,
     /* 166626 */     // GIR_Coverage, 851,
     /* 166626 */     GIR_Done,
     /* 166627 */   // Label 2508: @166627
     /* 166627 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(166692), // Rule ID 293 //
     /* 166632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 166635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 166639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166655 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166673 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RB)))  =>  (VNMSUBFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)
     /* 166673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNMSUBFP),
     /* 166676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 166678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 166682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RC
     /* 166686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RB
     /* 166690 */     GIR_RootConstrainSelectedInstOperands,
     /* 166691 */     // GIR_Coverage, 293,
     /* 166691 */     GIR_EraseRootFromParent_Done,
     /* 166692 */   // Label 2509: @166692
     /* 166692 */   GIM_Reject,
     /* 166693 */ // Label 2503: @166693
     /* 166693 */ GIM_Reject,
     /* 166694 */ // Label 2455: @166694
     /* 166694 */ GIM_Reject,
     /* 166695 */ // Label 46: @166695
     /* 166695 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2512*/ GIMT_Encode4(166858),
     /* 166706 */ /*GILLT_s64*//*Label 2510*/ GIMT_Encode4(166714),
     /* 166710 */ /*GILLT_s128*//*Label 2511*/ GIMT_Encode4(166789),
     /* 166714 */ // Label 2510: @166714
     /* 166714 */ GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(166788),
     /* 166719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 166722 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(166745), // Rule ID 1903 //
     /* 166727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 166730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166734 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, VSFRC:{ *:[i32] })
     /* 166734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166744 */     // GIR_Coverage, 1903,
     /* 166744 */     GIR_Done,
     /* 166745 */   // Label 2514: @166745
     /* 166745 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(166764), // Rule ID 560 //
     /* 166750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 166753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 166757 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$RB)  =>  (EFDCFS:{ *:[f64] } f32:{ *:[f32] }:$RB)
     /* 166757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFS),
     /* 166762 */     GIR_RootConstrainSelectedInstOperands,
     /* 166763 */     // GIR_Coverage, 560,
     /* 166763 */     GIR_Done,
     /* 166764 */   // Label 2515: @166764
     /* 166764 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(166787), // Rule ID 1263 //
     /* 166769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 166772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 166776 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, F8RC:{ *:[i32] })
     /* 166776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /* 166786 */     // GIR_Coverage, 1263,
     /* 166786 */     GIR_Done,
     /* 166787 */   // Label 2516: @166787
     /* 166787 */   GIM_Reject,
     /* 166788 */ // Label 2513: @166788
     /* 166788 */ GIM_Reject,
     /* 166789 */ // Label 2511: @166789
     /* 166789 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(166811), // Rule ID 1011 //
     /* 166794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 166800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 166804 */   // (fpextend:{ *:[f128] } f64:{ *:[f64] }:$RB)  =>  (XSCVDPQP:{ *:[f128] } f64:{ *:[f64] }:$RB)
     /* 166804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSCVDPQP),
     /* 166809 */   GIR_RootConstrainSelectedInstOperands,
     /* 166810 */   // GIR_Coverage, 1011,
     /* 166810 */   GIR_Done,
     /* 166811 */ // Label 2517: @166811
     /* 166811 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(166857), // Rule ID 2257 //
     /* 166816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 166822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 166826 */   // (fpextend:{ *:[f128] } f32:{ *:[f32] }:$src)  =>  (XSCVDPQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, VFRC:{ *:[i32] }))
     /* 166826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166838 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 166842 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 166847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPQP),
     /* 166850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166855 */   GIR_RootConstrainSelectedInstOperands,
     /* 166856 */   // GIR_Coverage, 2257,
     /* 166856 */   GIR_EraseRootFromParent_Done,
     /* 166857 */ // Label 2518: @166857
     /* 166857 */ GIM_Reject,
     /* 166858 */ // Label 2512: @166858
     /* 166858 */ GIM_Reject,
     /* 166859 */ // Label 47: @166859
     /* 166859 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2521*/ GIMT_Encode4(167015),
     /* 166870 */ /*GILLT_s32*//*Label 2519*/ GIMT_Encode4(166878),
     /* 166874 */ /*GILLT_s64*//*Label 2520*/ GIMT_Encode4(166992),
     /* 166878 */ // Label 2519: @166878
     /* 166878 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(166900), // Rule ID 958 //
     /* 166883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 166886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 166889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 166893 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$XB)  =>  (XSRSP:{ *:[f32] } f64:{ *:[f64] }:$XB)
     /* 166893 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRSP),
     /* 166898 */   GIR_RootConstrainSelectedInstOperands,
     /* 166899 */   // GIR_Coverage, 958,
     /* 166899 */   GIR_Done,
     /* 166900 */ // Label 2522: @166900
     /* 166900 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(166943), // Rule ID 2255 //
     /* 166905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 166911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 166915 */   // (fpround:{ *:[f32] } f128:{ *:[f128] }:$src)  =>  (XSRSP:{ *:[f32] } (XSCVQPDPO:{ *:[f64] } ?:{ *:[f128] }:$src))
     /* 166915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDPO),
     /* 166922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166927 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 166931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSP),
     /* 166936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166941 */   GIR_RootConstrainSelectedInstOperands,
     /* 166942 */   // GIR_Coverage, 2255,
     /* 166942 */   GIR_EraseRootFromParent_Done,
     /* 166943 */ // Label 2523: @166943
     /* 166943 */ GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(166969), // Rule ID 158 //
     /* 166948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 166951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 166954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 166958 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$RB)  =>  (FRSP:{ *:[f32] } f64:{ *:[f64] }:$RB)
     /* 166958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRSP),
     /* 166963 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166967 */   GIR_RootConstrainSelectedInstOperands,
     /* 166968 */   // GIR_Coverage, 158,
     /* 166968 */   GIR_Done,
     /* 166969 */ // Label 2524: @166969
     /* 166969 */ GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(166991), // Rule ID 581 //
     /* 166974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 166977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 166980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 166984 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$RB)  =>  (EFSCFD:{ *:[f32] } f64:{ *:[f64] }:$RB)
     /* 166984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFD),
     /* 166989 */   GIR_RootConstrainSelectedInstOperands,
     /* 166990 */   // GIR_Coverage, 581,
     /* 166990 */   GIR_Done,
     /* 166991 */ // Label 2525: @166991
     /* 166991 */ GIM_Reject,
     /* 166992 */ // Label 2520: @166992
     /* 166992 */ GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(167014), // Rule ID 2253 //
     /* 166997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167007 */   // (fpround:{ *:[f64] } f128:{ *:[f128] }:$src)  =>  (XSCVQPDP:{ *:[f64] } ?:{ *:[f128] }:$src)
     /* 167007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDP),
     /* 167012 */   GIR_RootConstrainSelectedInstOperands,
     /* 167013 */   // GIR_Coverage, 2253,
     /* 167013 */   GIR_Done,
     /* 167014 */ // Label 2526: @167014
     /* 167014 */ GIM_Reject,
     /* 167015 */ // Label 2521: @167015
     /* 167015 */ GIM_Reject,
     /* 167016 */ // Label 48: @167016
     /* 167016 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2531*/ GIMT_Encode4(167278),
     /* 167027 */ /*GILLT_s32*//*Label 2527*/ GIMT_Encode4(167047),
     /* 167031 */ /*GILLT_s64*//*Label 2528*/ GIMT_Encode4(167155), GIMT_Encode4(0),
     /* 167039 */ /*GILLT_v2s64*//*Label 2529*/ GIMT_Encode4(167199),
     /* 167043 */ /*GILLT_v4s32*//*Label 2530*/ GIMT_Encode4(167226),
     /* 167047 */ // Label 2527: @167047
     /* 167047 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(167110), // Rule ID 2243 //
     /* 167052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167062 */   // (fp_to_sint:{ *:[i32] } f128:{ *:[f128] }:$src)  =>  (MFVSRWZ:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f64] } (XSCVQPSWZ:{ *:[f128] } ?:{ *:[f128] }:$src), VFRC:{ *:[i32] }))
     /* 167062 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167065 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVQPSWZ),
     /* 167069 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167074 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167080 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167083 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167087 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167092 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 167095 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 167103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167108 */   GIR_RootConstrainSelectedInstOperands,
     /* 167109 */   // GIR_Coverage, 2243,
     /* 167109 */   GIR_EraseRootFromParent_Done,
     /* 167110 */ // Label 2532: @167110
     /* 167110 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(167132), // Rule ID 566 //
     /* 167115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167125 */   // (fp_to_sint:{ *:[i32] } f64:{ *:[f64] }:$RB)  =>  (EFDCTSIZ:{ *:[i32] } f64:{ *:[f64] }:$RB)
     /* 167125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCTSIZ),
     /* 167130 */   GIR_RootConstrainSelectedInstOperands,
     /* 167131 */   // GIR_Coverage, 566,
     /* 167131 */   GIR_Done,
     /* 167132 */ // Label 2533: @167132
     /* 167132 */ GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(167154), // Rule ID 587 //
     /* 167137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167147 */   // (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$RB)  =>  (EFSCTSIZ:{ *:[i32] } f32:{ *:[f32] }:$RB)
     /* 167147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCTSIZ),
     /* 167152 */   GIR_RootConstrainSelectedInstOperands,
     /* 167153 */   // GIR_Coverage, 587,
     /* 167153 */   GIR_Done,
     /* 167154 */ // Label 2534: @167154
     /* 167154 */ GIM_Reject,
     /* 167155 */ // Label 2528: @167155
     /* 167155 */ GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(167198), // Rule ID 2239 //
     /* 167160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 167170 */   // (fp_to_sint:{ *:[i64] } f128:{ *:[f128] }:$src)  =>  (MFVRD:{ *:[i64] } (XSCVQPSDZ:{ *:[v4i32] } ?:{ *:[f128] }:$src))
     /* 167170 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 167173 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPSDZ),
     /* 167177 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167182 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVRD),
     /* 167191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167193 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167196 */   GIR_RootConstrainSelectedInstOperands,
     /* 167197 */   // GIR_Coverage, 2239,
     /* 167197 */   GIR_EraseRootFromParent_Done,
     /* 167198 */ // Label 2535: @167198
     /* 167198 */ GIM_Reject,
     /* 167199 */ // Label 2529: @167199
     /* 167199 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(167225), // Rule ID 874 //
     /* 167204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167214 */   // (fp_to_sint:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSXDS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /* 167214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSXDS),
     /* 167219 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167223 */   GIR_RootConstrainSelectedInstOperands,
     /* 167224 */   // GIR_Coverage, 874,
     /* 167224 */   GIR_Done,
     /* 167225 */ // Label 2536: @167225
     /* 167225 */ GIM_Reject,
     /* 167226 */ // Label 2530: @167226
     /* 167226 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(167277),
     /* 167231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167234 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(167257), // Rule ID 882 //
     /* 167239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167246 */     // (fp_to_sint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPSXWS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /* 167246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSPSXWS),
     /* 167251 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167255 */     GIR_RootConstrainSelectedInstOperands,
     /* 167256 */     // GIR_Coverage, 882,
     /* 167256 */     GIR_Done,
     /* 167257 */   // Label 2538: @167257
     /* 167257 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(167276), // Rule ID 1409 //
     /* 167262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167269 */     // (fp_to_sint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VCTSXS_0:{ *:[v4i32] } ?:{ *:[v4f32] }:$vA)
     /* 167269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTSXS_0),
     /* 167274 */     GIR_RootConstrainSelectedInstOperands,
     /* 167275 */     // GIR_Coverage, 1409,
     /* 167275 */     GIR_Done,
     /* 167276 */   // Label 2539: @167276
     /* 167276 */   GIM_Reject,
     /* 167277 */ // Label 2537: @167277
     /* 167277 */ GIM_Reject,
     /* 167278 */ // Label 2531: @167278
     /* 167278 */ GIM_Reject,
     /* 167279 */ // Label 49: @167279
     /* 167279 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2544*/ GIMT_Encode4(167541),
     /* 167290 */ /*GILLT_s32*//*Label 2540*/ GIMT_Encode4(167310),
     /* 167294 */ /*GILLT_s64*//*Label 2541*/ GIMT_Encode4(167418), GIMT_Encode4(0),
     /* 167302 */ /*GILLT_v2s64*//*Label 2542*/ GIMT_Encode4(167462),
     /* 167306 */ /*GILLT_v4s32*//*Label 2543*/ GIMT_Encode4(167489),
     /* 167310 */ // Label 2540: @167310
     /* 167310 */ GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(167373), // Rule ID 2245 //
     /* 167315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167325 */   // (fp_to_uint:{ *:[i32] } f128:{ *:[f128] }:$src)  =>  (MFVSRWZ:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f64] } (XSCVQPUWZ:{ *:[f128] } ?:{ *:[f128] }:$src), VFRC:{ *:[i32] }))
     /* 167325 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167328 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVQPUWZ),
     /* 167332 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167337 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167343 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167346 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167350 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167355 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 167358 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 167366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167371 */   GIR_RootConstrainSelectedInstOperands,
     /* 167372 */   // GIR_Coverage, 2245,
     /* 167372 */   GIR_EraseRootFromParent_Done,
     /* 167373 */ // Label 2545: @167373
     /* 167373 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(167395), // Rule ID 568 //
     /* 167378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167388 */   // (fp_to_uint:{ *:[i32] } f64:{ *:[f64] }:$RB)  =>  (EFDCTUIZ:{ *:[i32] } f64:{ *:[f64] }:$RB)
     /* 167388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCTUIZ),
     /* 167393 */   GIR_RootConstrainSelectedInstOperands,
     /* 167394 */   // GIR_Coverage, 568,
     /* 167394 */   GIR_Done,
     /* 167395 */ // Label 2546: @167395
     /* 167395 */ GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(167417), // Rule ID 589 //
     /* 167400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167410 */   // (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$RB)  =>  (EFSCTUIZ:{ *:[i32] } f32:{ *:[f32] }:$RB)
     /* 167410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCTUIZ),
     /* 167415 */   GIR_RootConstrainSelectedInstOperands,
     /* 167416 */   // GIR_Coverage, 589,
     /* 167416 */   GIR_Done,
     /* 167417 */ // Label 2547: @167417
     /* 167417 */ GIM_Reject,
     /* 167418 */ // Label 2541: @167418
     /* 167418 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(167461), // Rule ID 2241 //
     /* 167423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 167433 */   // (fp_to_uint:{ *:[i64] } f128:{ *:[f128] }:$src)  =>  (MFVRD:{ *:[i64] } (XSCVQPUDZ:{ *:[v4i32] } ?:{ *:[f128] }:$src))
     /* 167433 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 167436 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPUDZ),
     /* 167440 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167445 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVRD),
     /* 167454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167459 */   GIR_RootConstrainSelectedInstOperands,
     /* 167460 */   // GIR_Coverage, 2241,
     /* 167460 */   GIR_EraseRootFromParent_Done,
     /* 167461 */ // Label 2548: @167461
     /* 167461 */ GIM_Reject,
     /* 167462 */ // Label 2542: @167462
     /* 167462 */ GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(167488), // Rule ID 877 //
     /* 167467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167477 */   // (fp_to_uint:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPUXDS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /* 167477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVDPUXDS),
     /* 167482 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167486 */   GIR_RootConstrainSelectedInstOperands,
     /* 167487 */   // GIR_Coverage, 877,
     /* 167487 */   GIR_Done,
     /* 167488 */ // Label 2549: @167488
     /* 167488 */ GIM_Reject,
     /* 167489 */ // Label 2543: @167489
     /* 167489 */ GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(167540),
     /* 167494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167497 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(167520), // Rule ID 885 //
     /* 167502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167509 */     // (fp_to_uint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPUXWS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /* 167509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSPUXWS),
     /* 167514 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167518 */     GIR_RootConstrainSelectedInstOperands,
     /* 167519 */     // GIR_Coverage, 885,
     /* 167519 */     GIR_Done,
     /* 167520 */   // Label 2551: @167520
     /* 167520 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(167539), // Rule ID 1410 //
     /* 167525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167532 */     // (fp_to_uint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VCTUXS_0:{ *:[v4i32] } ?:{ *:[v4f32] }:$vA)
     /* 167532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTUXS_0),
     /* 167537 */     GIR_RootConstrainSelectedInstOperands,
     /* 167538 */     // GIR_Coverage, 1410,
     /* 167538 */     GIR_Done,
     /* 167539 */   // Label 2552: @167539
     /* 167539 */   GIM_Reject,
     /* 167540 */ // Label 2550: @167540
     /* 167540 */ GIM_Reject,
     /* 167541 */ // Label 2544: @167541
     /* 167541 */ GIM_Reject,
     /* 167542 */ // Label 50: @167542
     /* 167542 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2558*/ GIMT_Encode4(167788),
     /* 167553 */ /*GILLT_s32*//*Label 2553*/ GIMT_Encode4(167573),
     /* 167557 */ /*GILLT_s64*//*Label 2554*/ GIMT_Encode4(167596),
     /* 167561 */ /*GILLT_s128*//*Label 2555*/ GIMT_Encode4(167619),
     /* 167565 */ /*GILLT_v2s64*//*Label 2556*/ GIMT_Encode4(167709),
     /* 167569 */ /*GILLT_v4s32*//*Label 2557*/ GIMT_Encode4(167736),
     /* 167573 */ // Label 2553: @167573
     /* 167573 */ GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(167595), // Rule ID 583 //
     /* 167578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167588 */   // (sint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$RB)  =>  (EFSCFSI:{ *:[f32] } i32:{ *:[i32] }:$RB)
     /* 167588 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFSI),
     /* 167593 */   GIR_RootConstrainSelectedInstOperands,
     /* 167594 */   // GIR_Coverage, 583,
     /* 167594 */   GIR_Done,
     /* 167595 */ // Label 2559: @167595
     /* 167595 */ GIM_Reject,
     /* 167596 */ // Label 2554: @167596
     /* 167596 */ GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(167618), // Rule ID 562 //
     /* 167601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 167611 */   // (sint_to_fp:{ *:[f64] } i32:{ *:[i32] }:$RB)  =>  (EFDCFSI:{ *:[f64] } i32:{ *:[i32] }:$RB)
     /* 167611 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFSI),
     /* 167616 */   GIR_RootConstrainSelectedInstOperands,
     /* 167617 */   // GIR_Coverage, 562,
     /* 167617 */   GIR_Done,
     /* 167618 */ // Label 2560: @167618
     /* 167618 */ GIM_Reject,
     /* 167619 */ // Label 2555: @167619
     /* 167619 */ GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(167665), // Rule ID 2134 //
     /* 167624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167634 */   // (sint_to_fp:{ *:[f128] } i64:{ *:[i64] }:$src)  =>  (XSCVSDQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[i64] }:$src, VFRC:{ *:[i32] }))
     /* 167634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167646 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167650 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSDQP),
     /* 167658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 167660 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167663 */   GIR_RootConstrainSelectedInstOperands,
     /* 167664 */   // GIR_Coverage, 2134,
     /* 167664 */   GIR_EraseRootFromParent_Done,
     /* 167665 */ // Label 2561: @167665
     /* 167665 */ GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(167708), // Rule ID 2144 //
     /* 167670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167680 */   // (sint_to_fp:{ *:[f128] } i32:{ *:[i32] }:$src)  =>  (XSCVSDQP:{ *:[f128] } (MTVSRWA:{ *:[f64] } ?:{ *:[i32] }:$src))
     /* 167680 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167683 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRWA),
     /* 167687 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167692 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSDQP),
     /* 167701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 167703 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167706 */   GIR_RootConstrainSelectedInstOperands,
     /* 167707 */   // GIR_Coverage, 2144,
     /* 167707 */   GIR_EraseRootFromParent_Done,
     /* 167708 */ // Label 2562: @167708
     /* 167708 */ GIM_Reject,
     /* 167709 */ // Label 2556: @167709
     /* 167709 */ GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(167735), // Rule ID 887 //
     /* 167714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167724 */   // (sint_to_fp:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVSXDDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)
     /* 167724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSXDDP),
     /* 167729 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167733 */   GIR_RootConstrainSelectedInstOperands,
     /* 167734 */   // GIR_Coverage, 887,
     /* 167734 */   GIR_Done,
     /* 167735 */ // Label 2563: @167735
     /* 167735 */ GIM_Reject,
     /* 167736 */ // Label 2557: @167736
     /* 167736 */ GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(167787),
     /* 167741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167744 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(167767), // Rule ID 890 //
     /* 167749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167756 */     // (sint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVSXWSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)
     /* 167756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSXWSP),
     /* 167761 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167765 */     GIR_RootConstrainSelectedInstOperands,
     /* 167766 */     // GIR_Coverage, 890,
     /* 167766 */     GIR_Done,
     /* 167767 */   // Label 2565: @167767
     /* 167767 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(167786), // Rule ID 1411 //
     /* 167772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167779 */     // (sint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA)  =>  (VCFSX_0:{ *:[v4f32] } ?:{ *:[v4i32] }:$vA)
     /* 167779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCFSX_0),
     /* 167784 */     GIR_RootConstrainSelectedInstOperands,
     /* 167785 */     // GIR_Coverage, 1411,
     /* 167785 */     GIR_Done,
     /* 167786 */   // Label 2566: @167786
     /* 167786 */   GIM_Reject,
     /* 167787 */ // Label 2564: @167787
     /* 167787 */ GIM_Reject,
     /* 167788 */ // Label 2558: @167788
     /* 167788 */ GIM_Reject,
     /* 167789 */ // Label 51: @167789
     /* 167789 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2572*/ GIMT_Encode4(168035),
     /* 167800 */ /*GILLT_s32*//*Label 2567*/ GIMT_Encode4(167820),
     /* 167804 */ /*GILLT_s64*//*Label 2568*/ GIMT_Encode4(167843),
     /* 167808 */ /*GILLT_s128*//*Label 2569*/ GIMT_Encode4(167866),
     /* 167812 */ /*GILLT_v2s64*//*Label 2570*/ GIMT_Encode4(167956),
     /* 167816 */ /*GILLT_v4s32*//*Label 2571*/ GIMT_Encode4(167983),
     /* 167820 */ // Label 2567: @167820
     /* 167820 */ GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(167842), // Rule ID 585 //
     /* 167825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167835 */   // (uint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$RB)  =>  (EFSCFUI:{ *:[f32] } i32:{ *:[i32] }:$RB)
     /* 167835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFUI),
     /* 167840 */   GIR_RootConstrainSelectedInstOperands,
     /* 167841 */   // GIR_Coverage, 585,
     /* 167841 */   GIR_Done,
     /* 167842 */ // Label 2573: @167842
     /* 167842 */ GIM_Reject,
     /* 167843 */ // Label 2568: @167843
     /* 167843 */ GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(167865), // Rule ID 564 //
     /* 167848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 167858 */   // (uint_to_fp:{ *:[f64] } i32:{ *:[i32] }:$RB)  =>  (EFDCFUI:{ *:[f64] } i32:{ *:[i32] }:$RB)
     /* 167858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFUI),
     /* 167863 */   GIR_RootConstrainSelectedInstOperands,
     /* 167864 */   // GIR_Coverage, 564,
     /* 167864 */   GIR_Done,
     /* 167865 */ // Label 2574: @167865
     /* 167865 */ GIM_Reject,
     /* 167866 */ // Label 2569: @167866
     /* 167866 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(167912), // Rule ID 2140 //
     /* 167871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167881 */   // (uint_to_fp:{ *:[f128] } i64:{ *:[i64] }:$src)  =>  (XSCVUDQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[i64] }:$src, VFRC:{ *:[i32] }))
     /* 167881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167893 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUDQP),
     /* 167905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 167907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167910 */   GIR_RootConstrainSelectedInstOperands,
     /* 167911 */   // GIR_Coverage, 2140,
     /* 167911 */   GIR_EraseRootFromParent_Done,
     /* 167912 */ // Label 2575: @167912
     /* 167912 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(167955), // Rule ID 2148 //
     /* 167917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167927 */   // (uint_to_fp:{ *:[f128] } i32:{ *:[i32] }:$src)  =>  (XSCVUDQP:{ *:[f128] } (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$src))
     /* 167927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /* 167934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167939 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUDQP),
     /* 167948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 167950 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167953 */   GIR_RootConstrainSelectedInstOperands,
     /* 167954 */   // GIR_Coverage, 2148,
     /* 167954 */   GIR_EraseRootFromParent_Done,
     /* 167955 */ // Label 2576: @167955
     /* 167955 */ GIM_Reject,
     /* 167956 */ // Label 2570: @167956
     /* 167956 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(167982), // Rule ID 892 //
     /* 167961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167971 */   // (uint_to_fp:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVUXDDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)
     /* 167971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVUXDDP),
     /* 167976 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167980 */   GIR_RootConstrainSelectedInstOperands,
     /* 167981 */   // GIR_Coverage, 892,
     /* 167981 */   GIR_Done,
     /* 167982 */ // Label 2577: @167982
     /* 167982 */ GIM_Reject,
     /* 167983 */ // Label 2571: @167983
     /* 167983 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(168034),
     /* 167988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167991 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(168014), // Rule ID 895 //
     /* 167996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168003 */     // (uint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVUXWSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)
     /* 168003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVUXWSP),
     /* 168008 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168012 */     GIR_RootConstrainSelectedInstOperands,
     /* 168013 */     // GIR_Coverage, 895,
     /* 168013 */     GIR_Done,
     /* 168014 */   // Label 2579: @168014
     /* 168014 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(168033), // Rule ID 1412 //
     /* 168019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 168022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168026 */     // (uint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA)  =>  (VCFUX_0:{ *:[v4f32] } ?:{ *:[v4i32] }:$vA)
     /* 168026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCFUX_0),
     /* 168031 */     GIR_RootConstrainSelectedInstOperands,
     /* 168032 */     // GIR_Coverage, 1412,
     /* 168032 */     GIR_Done,
     /* 168033 */   // Label 2580: @168033
     /* 168033 */   GIM_Reject,
     /* 168034 */ // Label 2578: @168034
     /* 168034 */ GIM_Reject,
     /* 168035 */ // Label 2572: @168035
     /* 168035 */ GIM_Reject,
     /* 168036 */ // Label 52: @168036
     /* 168036 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2586*/ GIMT_Encode4(168327),
     /* 168047 */ /*GILLT_s32*//*Label 2581*/ GIMT_Encode4(168067),
     /* 168051 */ /*GILLT_s64*//*Label 2582*/ GIMT_Encode4(168179),
     /* 168055 */ /*GILLT_s128*//*Label 2583*/ GIMT_Encode4(168250),
     /* 168059 */ /*GILLT_v2s64*//*Label 2584*/ GIMT_Encode4(168273),
     /* 168063 */ /*GILLT_v4s32*//*Label 2585*/ GIMT_Encode4(168300),
     /* 168067 */ // Label 2581: @168067
     /* 168067 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(168178),
     /* 168072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168075 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(168139), // Rule ID 1677 //
     /* 168080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 168087 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSABSDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 168087 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168090 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168094 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168099 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 168103 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSABSDP),
     /* 168115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 168138 */     // GIR_Coverage, 1677,
     /* 168138 */     GIR_EraseRootFromParent_Done,
     /* 168139 */   // Label 2588: @168139
     /* 168139 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(168158), // Rule ID 163 //
     /* 168144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168151 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FABSS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 168151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FABSS),
     /* 168156 */     GIR_RootConstrainSelectedInstOperands,
     /* 168157 */     // GIR_Coverage, 163,
     /* 168157 */     GIR_Done,
     /* 168158 */   // Label 2589: @168158
     /* 168158 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(168177), // Rule ID 577 //
     /* 168163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 168166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 168170 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$RA)  =>  (EFSABS:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 168170 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSABS),
     /* 168175 */     GIR_RootConstrainSelectedInstOperands,
     /* 168176 */     // GIR_Coverage, 577,
     /* 168176 */     GIR_Done,
     /* 168177 */   // Label 2590: @168177
     /* 168177 */   GIM_Reject,
     /* 168178 */ // Label 2587: @168178
     /* 168178 */ GIM_Reject,
     /* 168179 */ // Label 2582: @168179
     /* 168179 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(168249),
     /* 168184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168187 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(168210), // Rule ID 839 //
     /* 168192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168199 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSABSDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 168199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSABSDP),
     /* 168204 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168208 */     GIR_RootConstrainSelectedInstOperands,
     /* 168209 */     // GIR_Coverage, 839,
     /* 168209 */     GIR_Done,
     /* 168210 */   // Label 2592: @168210
     /* 168210 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(168229), // Rule ID 164 //
     /* 168215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168222 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FABSD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 168222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FABSD),
     /* 168227 */     GIR_RootConstrainSelectedInstOperands,
     /* 168228 */     // GIR_Coverage, 164,
     /* 168228 */     GIR_Done,
     /* 168229 */   // Label 2593: @168229
     /* 168229 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(168248), // Rule ID 556 //
     /* 168234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 168237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 168241 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$RA)  =>  (EFDABS:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 168241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDABS),
     /* 168246 */     GIR_RootConstrainSelectedInstOperands,
     /* 168247 */     // GIR_Coverage, 556,
     /* 168247 */     GIR_Done,
     /* 168248 */   // Label 2594: @168248
     /* 168248 */   GIM_Reject,
     /* 168249 */ // Label 2591: @168249
     /* 168249 */ GIM_Reject,
     /* 168250 */ // Label 2583: @168250
     /* 168250 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(168272), // Rule ID 980 //
     /* 168255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 168258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 168261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168265 */   // (fabs:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSABSQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 168265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSABSQP),
     /* 168270 */   GIR_RootConstrainSelectedInstOperands,
     /* 168271 */   // GIR_Coverage, 980,
     /* 168271 */   GIR_Done,
     /* 168272 */ // Label 2595: @168272
     /* 168272 */ GIM_Reject,
     /* 168273 */ // Label 2584: @168273
     /* 168273 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(168299), // Rule ID 844 //
     /* 168278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168288 */   // (fabs:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVABSDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 168288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVABSDP),
     /* 168293 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168297 */   GIR_RootConstrainSelectedInstOperands,
     /* 168298 */   // GIR_Coverage, 844,
     /* 168298 */   GIR_Done,
     /* 168299 */ // Label 2596: @168299
     /* 168299 */ GIM_Reject,
     /* 168300 */ // Label 2585: @168300
     /* 168300 */ GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(168326), // Rule ID 845 //
     /* 168305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168315 */   // (fabs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVABSSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 168315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVABSSP),
     /* 168320 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168324 */   GIR_RootConstrainSelectedInstOperands,
     /* 168325 */   // GIR_Coverage, 845,
     /* 168325 */   GIR_Done,
     /* 168326 */ // Label 2597: @168326
     /* 168326 */ GIM_Reject,
     /* 168327 */ // Label 2586: @168327
     /* 168327 */ GIM_Reject,
     /* 168328 */ // Label 53: @168328
     /* 168328 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2603*/ GIMT_Encode4(168643),
     /* 168339 */ /*GILLT_s32*//*Label 2598*/ GIMT_Encode4(168359),
     /* 168343 */ /*GILLT_s64*//*Label 2599*/ GIMT_Encode4(168443),
     /* 168347 */ /*GILLT_s128*//*Label 2600*/ GIMT_Encode4(168553),
     /* 168351 */ /*GILLT_v2s64*//*Label 2601*/ GIMT_Encode4(168583),
     /* 168355 */ /*GILLT_v4s32*//*Label 2602*/ GIMT_Encode4(168613),
     /* 168359 */ // Label 2598: @168359
     /* 168359 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(168442),
     /* 168364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168367 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(168393), // Rule ID 169 //
     /* 168372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168382 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$RB, f32:{ *:[f32] }:$RA)  =>  (FCPSGNS:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 168382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGNS),
     /* 168385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168387 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 168389 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 168391 */     GIR_RootConstrainSelectedInstOperands,
     /* 168392 */     // GIR_Coverage, 169,
     /* 168392 */     GIR_EraseRootFromParent_Done,
     /* 168393 */   // Label 2605: @168393
     /* 168393 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(168441), // Rule ID 1275 //
     /* 168398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168408 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$frB, f64:{ *:[f64] }:$frA)  =>  (FCPSGNS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } ?:{ *:[f64] }:$frA, F4RC:{ *:[i32] }), ?:{ *:[f32] }:$frB)
     /* 168408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 168411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168420 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // frA
     /* 168424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGNS),
     /* 168432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168437 */     GIR_RootToRootCopy, /*OpIdx*/1, // frB
     /* 168439 */     GIR_RootConstrainSelectedInstOperands,
     /* 168440 */     // GIR_Coverage, 1275,
     /* 168440 */     GIR_EraseRootFromParent_Done,
     /* 168441 */   // Label 2606: @168441
     /* 168441 */   GIM_Reject,
     /* 168442 */ // Label 2604: @168442
     /* 168442 */ GIM_Reject,
     /* 168443 */ // Label 2599: @168443
     /* 168443 */ GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(168552),
     /* 168448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168451 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(168477), // Rule ID 843 //
     /* 168456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168466 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XA)  =>  (XSCPSGNDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 168466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCPSGNDP),
     /* 168469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 168471 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 168473 */     GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 168475 */     GIR_RootConstrainSelectedInstOperands,
     /* 168476 */     // GIR_Coverage, 843,
     /* 168476 */     GIR_EraseRootFromParent_Done,
     /* 168477 */   // Label 2608: @168477
     /* 168477 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(168503), // Rule ID 170 //
     /* 168482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168492 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$RB, f64:{ *:[f64] }:$RA)  =>  (FCPSGND:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 168492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGND),
     /* 168495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168497 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 168499 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 168501 */     GIR_RootConstrainSelectedInstOperands,
     /* 168502 */     // GIR_Coverage, 170,
     /* 168502 */     GIR_EraseRootFromParent_Done,
     /* 168503 */   // Label 2609: @168503
     /* 168503 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(168551), // Rule ID 1274 //
     /* 168508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168518 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$frB, f32:{ *:[f32] }:$frA)  =>  (FCPSGND:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$frA, F8RC:{ *:[i32] }), ?:{ *:[f64] }:$frB)
     /* 168518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // frA
     /* 168534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGND),
     /* 168542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168547 */     GIR_RootToRootCopy, /*OpIdx*/1, // frB
     /* 168549 */     GIR_RootConstrainSelectedInstOperands,
     /* 168550 */     // GIR_Coverage, 1274,
     /* 168550 */     GIR_EraseRootFromParent_Done,
     /* 168551 */   // Label 2610: @168551
     /* 168551 */   GIM_Reject,
     /* 168552 */ // Label 2607: @168552
     /* 168552 */ GIM_Reject,
     /* 168553 */ // Label 2600: @168553
     /* 168553 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(168582), // Rule ID 979 //
     /* 168558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 168561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 168564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 168567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168571 */   // (fcopysign:{ *:[f128] } f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RA)  =>  (XSCPSGNQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 168571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCPSGNQP),
     /* 168574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168576 */   GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 168578 */   GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 168580 */   GIR_RootConstrainSelectedInstOperands,
     /* 168581 */   // GIR_Coverage, 979,
     /* 168581 */   GIR_EraseRootFromParent_Done,
     /* 168582 */ // Label 2611: @168582
     /* 168582 */ GIM_Reject,
     /* 168583 */ // Label 2601: @168583
     /* 168583 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(168612), // Rule ID 846 //
     /* 168588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168601 */   // (fcopysign:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XA)  =>  (XVCPSGNDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 168601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCPSGNDP),
     /* 168604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 168606 */   GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 168608 */   GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 168610 */   GIR_RootConstrainSelectedInstOperands,
     /* 168611 */   // GIR_Coverage, 846,
     /* 168611 */   GIR_EraseRootFromParent_Done,
     /* 168612 */ // Label 2612: @168612
     /* 168612 */ GIM_Reject,
     /* 168613 */ // Label 2602: @168613
     /* 168613 */ GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(168642), // Rule ID 847 //
     /* 168618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168631 */   // (fcopysign:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XA)  =>  (XVCPSGNSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 168631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCPSGNSP),
     /* 168634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 168636 */   GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 168638 */   GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 168640 */   GIR_RootConstrainSelectedInstOperands,
     /* 168641 */   // GIR_Coverage, 847,
     /* 168641 */   GIR_EraseRootFromParent_Done,
     /* 168642 */ // Label 2613: @168642
     /* 168642 */ GIM_Reject,
     /* 168643 */ // Label 2603: @168643
     /* 168643 */ GIM_Reject,
     /* 168644 */ // Label 54: @168644
     /* 168644 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(6), /*)*//*default:*//*Label 2616*/ GIMT_Encode4(168723),
     /* 168655 */ /*GILLT_v2s64*//*Label 2614*/ GIMT_Encode4(168663),
     /* 168659 */ /*GILLT_v4s32*//*Label 2615*/ GIMT_Encode4(168693),
     /* 168663 */ // Label 2614: @168663
     /* 168663 */ GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(168692), // Rule ID 1676 //
     /* 168668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168681 */   // (fminnum:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$src1, v2f64:{ *:[v2f64] }:$src2)  =>  (XVMINDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$src1, ?:{ *:[v2f64] }:$src2)
     /* 168681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMINDP),
     /* 168686 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168690 */   GIR_RootConstrainSelectedInstOperands,
     /* 168691 */   // GIR_Coverage, 1676,
     /* 168691 */   GIR_Done,
     /* 168692 */ // Label 2617: @168692
     /* 168692 */ GIM_Reject,
     /* 168693 */ // Label 2615: @168693
     /* 168693 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(168722), // Rule ID 1672 //
     /* 168698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168711 */   // (fminnum:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src1, v4f32:{ *:[v4f32] }:$src2)  =>  (XVMINSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$src1, ?:{ *:[v4f32] }:$src2)
     /* 168711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMINSP),
     /* 168716 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168720 */   GIR_RootConstrainSelectedInstOperands,
     /* 168721 */   // GIR_Coverage, 1672,
     /* 168721 */   GIR_Done,
     /* 168722 */ // Label 2618: @168722
     /* 168722 */ GIM_Reject,
     /* 168723 */ // Label 2616: @168723
     /* 168723 */ GIM_Reject,
     /* 168724 */ // Label 55: @168724
     /* 168724 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(6), /*)*//*default:*//*Label 2621*/ GIMT_Encode4(168803),
     /* 168735 */ /*GILLT_v2s64*//*Label 2619*/ GIMT_Encode4(168743),
     /* 168739 */ /*GILLT_v4s32*//*Label 2620*/ GIMT_Encode4(168773),
     /* 168743 */ // Label 2619: @168743
     /* 168743 */ GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(168772), // Rule ID 1674 //
     /* 168748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168761 */   // (fmaxnum:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$src1, v2f64:{ *:[v2f64] }:$src2)  =>  (XVMAXDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$src1, ?:{ *:[v2f64] }:$src2)
     /* 168761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMAXDP),
     /* 168766 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168770 */   GIR_RootConstrainSelectedInstOperands,
     /* 168771 */   // GIR_Coverage, 1674,
     /* 168771 */   GIR_Done,
     /* 168772 */ // Label 2622: @168772
     /* 168772 */ GIM_Reject,
     /* 168773 */ // Label 2620: @168773
     /* 168773 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(168802), // Rule ID 1670 //
     /* 168778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168791 */   // (fmaxnum:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src1, v4f32:{ *:[v4f32] }:$src2)  =>  (XVMAXSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$src1, ?:{ *:[v4f32] }:$src2)
     /* 168791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMAXSP),
     /* 168796 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168800 */   GIR_RootConstrainSelectedInstOperands,
     /* 168801 */   // GIR_Coverage, 1670,
     /* 168801 */   GIR_Done,
     /* 168802 */ // Label 2623: @168802
     /* 168802 */ GIM_Reject,
     /* 168803 */ // Label 2621: @168803
     /* 168803 */ GIM_Reject,
     /* 168804 */ // Label 56: @168804
     /* 168804 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2626*/ GIMT_Encode4(169385),
     /* 168815 */ /*GILLT_s32*//*Label 2624*/ GIMT_Encode4(168823),
     /* 168819 */ /*GILLT_s64*//*Label 2625*/ GIMT_Encode4(169230),
     /* 168823 */ // Label 2624: @168823
     /* 168823 */ GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(169229),
     /* 168828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 168838 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(168948), // Rule ID 1682 //
     /* 168843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 168854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 168858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 168862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 168866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 168870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 168872 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 168872 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168875 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168879 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168884 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 168888 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168893 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168896 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168900 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168905 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 168909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 168921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168926 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168929 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 168947 */     // GIR_Coverage, 1682,
     /* 168947 */     GIR_EraseRootFromParent_Done,
     /* 168948 */   // Label 2628: @168948
     /* 168948 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(169046), // Rule ID 1680 //
     /* 168953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 168964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 168968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168970 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 168970 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168973 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168977 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168982 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 168986 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168991 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168994 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168998 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169003 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169007 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169024 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169027 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169045 */     // GIR_Coverage, 1680,
     /* 169045 */     GIR_EraseRootFromParent_Done,
     /* 169046 */   // Label 2629: @169046
     /* 169046 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(169144), // Rule ID 1681 //
     /* 169051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169068 */     // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169068 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169071 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169075 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169080 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169084 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169089 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169092 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169096 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169101 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169105 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169122 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169125 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169143 */     // GIR_Coverage, 1681,
     /* 169143 */     GIR_EraseRootFromParent_Done,
     /* 169144 */   // Label 2630: @169144
     /* 169144 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(169228), // Rule ID 1679 //
     /* 169149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169152 */     // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169152 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169155 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169159 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169164 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 169168 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169185 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169189 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169206 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169209 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169227 */     // GIR_Coverage, 1679,
     /* 169227 */     GIR_EraseRootFromParent_Done,
     /* 169228 */   // Label 2631: @169228
     /* 169228 */   GIM_Reject,
     /* 169229 */ // Label 2627: @169229
     /* 169229 */ GIM_Reject,
     /* 169230 */ // Label 2625: @169230
     /* 169230 */ GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(169384),
     /* 169235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 169238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 169241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169245 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(169294), // Rule ID 1690 //
     /* 169250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 169269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 169277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169279 */     // (fminnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 169292 */     GIR_RootConstrainSelectedInstOperands,
     /* 169293 */     // GIR_Coverage, 1690,
     /* 169293 */     GIR_EraseRootFromParent_Done,
     /* 169294 */   // Label 2633: @169294
     /* 169294 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(169329), // Rule ID 1688 //
     /* 169299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169316 */     // (fminnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), f64:{ *:[f64] }:$B)  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169325 */     GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 169327 */     GIR_RootConstrainSelectedInstOperands,
     /* 169328 */     // GIR_Coverage, 1688,
     /* 169328 */     GIR_EraseRootFromParent_Done,
     /* 169329 */   // Label 2634: @169329
     /* 169329 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(169364), // Rule ID 1689 //
     /* 169334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169351 */     // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169356 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 169358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169362 */     GIR_RootConstrainSelectedInstOperands,
     /* 169363 */     // GIR_Coverage, 1689,
     /* 169363 */     GIR_EraseRootFromParent_Done,
     /* 169364 */   // Label 2635: @169364
     /* 169364 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(169383), // Rule ID 1687 //
     /* 169369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169372 */     // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B)  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169377 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 169381 */     GIR_RootConstrainSelectedInstOperands,
     /* 169382 */     // GIR_Coverage, 1687,
     /* 169382 */     GIR_Done,
     /* 169383 */   // Label 2636: @169383
     /* 169383 */   GIM_Reject,
     /* 169384 */ // Label 2632: @169384
     /* 169384 */ GIM_Reject,
     /* 169385 */ // Label 2626: @169385
     /* 169385 */ GIM_Reject,
     /* 169386 */ // Label 57: @169386
     /* 169386 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2639*/ GIMT_Encode4(169967),
     /* 169397 */ /*GILLT_s32*//*Label 2637*/ GIMT_Encode4(169405),
     /* 169401 */ /*GILLT_s64*//*Label 2638*/ GIMT_Encode4(169812),
     /* 169405 */ // Label 2637: @169405
     /* 169405 */ GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(169811),
     /* 169410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169420 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(169530), // Rule ID 1686 //
     /* 169425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 169444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 169452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169454 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169454 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169457 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169461 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169466 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 169470 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169475 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169478 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169482 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169491 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169508 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169511 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169529 */     // GIR_Coverage, 1686,
     /* 169529 */     GIR_EraseRootFromParent_Done,
     /* 169530 */   // Label 2641: @169530
     /* 169530 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(169628), // Rule ID 1684 //
     /* 169535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169552 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169552 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169555 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169559 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169564 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 169568 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169573 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169576 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169580 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169585 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169589 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169606 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169609 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169627 */     // GIR_Coverage, 1684,
     /* 169627 */     GIR_EraseRootFromParent_Done,
     /* 169628 */   // Label 2642: @169628
     /* 169628 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(169726), // Rule ID 1685 //
     /* 169633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169650 */     // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169650 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169653 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169657 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169662 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169666 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169671 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169674 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169678 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169683 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169704 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169707 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169725 */     // GIR_Coverage, 1685,
     /* 169725 */     GIR_EraseRootFromParent_Done,
     /* 169726 */   // Label 2643: @169726
     /* 169726 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(169810), // Rule ID 1683 //
     /* 169731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169734 */     // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169734 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169737 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169741 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169746 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 169750 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169755 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169758 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169762 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169767 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169771 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169788 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169791 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169809 */     // GIR_Coverage, 1683,
     /* 169809 */     GIR_EraseRootFromParent_Done,
     /* 169810 */   // Label 2644: @169810
     /* 169810 */   GIM_Reject,
     /* 169811 */ // Label 2640: @169811
     /* 169811 */ GIM_Reject,
     /* 169812 */ // Label 2638: @169812
     /* 169812 */ GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(169966),
     /* 169817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 169820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 169823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169827 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(169876), // Rule ID 1694 //
     /* 169832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 169851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 169859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169861 */     // (fmaxnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 169874 */     GIR_RootConstrainSelectedInstOperands,
     /* 169875 */     // GIR_Coverage, 1694,
     /* 169875 */     GIR_EraseRootFromParent_Done,
     /* 169876 */   // Label 2646: @169876
     /* 169876 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(169911), // Rule ID 1692 //
     /* 169881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169898 */     // (fmaxnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), f64:{ *:[f64] }:$B)  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169907 */     GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 169909 */     GIR_RootConstrainSelectedInstOperands,
     /* 169910 */     // GIR_Coverage, 1692,
     /* 169910 */     GIR_EraseRootFromParent_Done,
     /* 169911 */   // Label 2647: @169911
     /* 169911 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(169946), // Rule ID 1693 //
     /* 169916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169933 */     // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169938 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 169940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169944 */     GIR_RootConstrainSelectedInstOperands,
     /* 169945 */     // GIR_Coverage, 1693,
     /* 169945 */     GIR_EraseRootFromParent_Done,
     /* 169946 */   // Label 2648: @169946
     /* 169946 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(169965), // Rule ID 1691 //
     /* 169951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169954 */     // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B)  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169959 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 169963 */     GIR_RootConstrainSelectedInstOperands,
     /* 169964 */     // GIR_Coverage, 1691,
     /* 169964 */     GIR_Done,
     /* 169965 */   // Label 2649: @169965
     /* 169965 */   GIM_Reject,
     /* 169966 */ // Label 2645: @169966
     /* 169966 */ GIM_Reject,
     /* 169967 */ // Label 2639: @169967
     /* 169967 */ GIM_Reject,
     /* 169968 */ // Label 58: @169968
     /* 169968 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2654*/ GIMT_Encode4(170147),
     /* 169979 */ /*GILLT_v2s64*//*Label 2650*/ GIMT_Encode4(169995),
     /* 169983 */ /*GILLT_v4s32*//*Label 2651*/ GIMT_Encode4(170069),
     /* 169987 */ /*GILLT_v8s16*//*Label 2652*/ GIMT_Encode4(170095),
     /* 169991 */ /*GILLT_v16s8*//*Label 2653*/ GIMT_Encode4(170121),
     /* 169995 */ // Label 2650: @169995
     /* 169995 */ GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(170068), // Rule ID 1926 //
     /* 170000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170013 */   // (smin:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMINSD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170013 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170016 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170020 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170025 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170029 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170034 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170037 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170041 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170046 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170050 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSD),
     /* 170058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170060 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170063 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170066 */   GIR_RootConstrainSelectedInstOperands,
     /* 170067 */   // GIR_Coverage, 1926,
     /* 170067 */   GIR_EraseRootFromParent_Done,
     /* 170068 */ // Label 2655: @170068
     /* 170068 */ GIM_Reject,
     /* 170069 */ // Label 2651: @170069
     /* 170069 */ GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(170094), // Rule ID 1356 //
     /* 170074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170087 */   // (smin:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMINSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSW),
     /* 170092 */   GIR_RootConstrainSelectedInstOperands,
     /* 170093 */   // GIR_Coverage, 1356,
     /* 170093 */   GIR_Done,
     /* 170094 */ // Label 2656: @170094
     /* 170094 */ GIM_Reject,
     /* 170095 */ // Label 2652: @170095
     /* 170095 */ GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(170120), // Rule ID 1354 //
     /* 170100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170113 */   // (smin:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMINSH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170113 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSH),
     /* 170118 */   GIR_RootConstrainSelectedInstOperands,
     /* 170119 */   // GIR_Coverage, 1354,
     /* 170119 */   GIR_Done,
     /* 170120 */ // Label 2657: @170120
     /* 170120 */ GIM_Reject,
     /* 170121 */ // Label 2653: @170121
     /* 170121 */ GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(170146), // Rule ID 1352 //
     /* 170126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170139 */   // (smin:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMINSB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSB),
     /* 170144 */   GIR_RootConstrainSelectedInstOperands,
     /* 170145 */   // GIR_Coverage, 1352,
     /* 170145 */   GIR_Done,
     /* 170146 */ // Label 2658: @170146
     /* 170146 */ GIM_Reject,
     /* 170147 */ // Label 2654: @170147
     /* 170147 */ GIM_Reject,
     /* 170148 */ // Label 59: @170148
     /* 170148 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2663*/ GIMT_Encode4(170327),
     /* 170159 */ /*GILLT_v2s64*//*Label 2659*/ GIMT_Encode4(170175),
     /* 170163 */ /*GILLT_v4s32*//*Label 2660*/ GIMT_Encode4(170249),
     /* 170167 */ /*GILLT_v8s16*//*Label 2661*/ GIMT_Encode4(170275),
     /* 170171 */ /*GILLT_v16s8*//*Label 2662*/ GIMT_Encode4(170301),
     /* 170175 */ // Label 2659: @170175
     /* 170175 */ GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(170248), // Rule ID 1924 //
     /* 170180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170193 */   // (smax:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMAXSD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170193 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170196 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170200 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170205 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170209 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170226 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170230 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSD),
     /* 170238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170240 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170246 */   GIR_RootConstrainSelectedInstOperands,
     /* 170247 */   // GIR_Coverage, 1924,
     /* 170247 */   GIR_EraseRootFromParent_Done,
     /* 170248 */ // Label 2664: @170248
     /* 170248 */ GIM_Reject,
     /* 170249 */ // Label 2660: @170249
     /* 170249 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(170274), // Rule ID 1350 //
     /* 170254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170267 */   // (smax:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMAXSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSW),
     /* 170272 */   GIR_RootConstrainSelectedInstOperands,
     /* 170273 */   // GIR_Coverage, 1350,
     /* 170273 */   GIR_Done,
     /* 170274 */ // Label 2665: @170274
     /* 170274 */ GIM_Reject,
     /* 170275 */ // Label 2661: @170275
     /* 170275 */ GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(170300), // Rule ID 1348 //
     /* 170280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170293 */   // (smax:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMAXSH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSH),
     /* 170298 */   GIR_RootConstrainSelectedInstOperands,
     /* 170299 */   // GIR_Coverage, 1348,
     /* 170299 */   GIR_Done,
     /* 170300 */ // Label 2666: @170300
     /* 170300 */ GIM_Reject,
     /* 170301 */ // Label 2662: @170301
     /* 170301 */ GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(170326), // Rule ID 1346 //
     /* 170306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170319 */   // (smax:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMAXSB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSB),
     /* 170324 */   GIR_RootConstrainSelectedInstOperands,
     /* 170325 */   // GIR_Coverage, 1346,
     /* 170325 */   GIR_Done,
     /* 170326 */ // Label 2667: @170326
     /* 170326 */ GIM_Reject,
     /* 170327 */ // Label 2663: @170327
     /* 170327 */ GIM_Reject,
     /* 170328 */ // Label 60: @170328
     /* 170328 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2672*/ GIMT_Encode4(170507),
     /* 170339 */ /*GILLT_v2s64*//*Label 2668*/ GIMT_Encode4(170355),
     /* 170343 */ /*GILLT_v4s32*//*Label 2669*/ GIMT_Encode4(170429),
     /* 170347 */ /*GILLT_v8s16*//*Label 2670*/ GIMT_Encode4(170455),
     /* 170351 */ /*GILLT_v16s8*//*Label 2671*/ GIMT_Encode4(170481),
     /* 170355 */ // Label 2668: @170355
     /* 170355 */ GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(170428), // Rule ID 1927 //
     /* 170360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170373 */   // (umin:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMINUD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170373 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170376 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170380 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170385 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170389 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170394 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170397 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170401 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170406 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170410 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUD),
     /* 170418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170420 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170426 */   GIR_RootConstrainSelectedInstOperands,
     /* 170427 */   // GIR_Coverage, 1927,
     /* 170427 */   GIR_EraseRootFromParent_Done,
     /* 170428 */ // Label 2673: @170428
     /* 170428 */ GIM_Reject,
     /* 170429 */ // Label 2669: @170429
     /* 170429 */ GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(170454), // Rule ID 1355 //
     /* 170434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170447 */   // (umin:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMINUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUW),
     /* 170452 */   GIR_RootConstrainSelectedInstOperands,
     /* 170453 */   // GIR_Coverage, 1355,
     /* 170453 */   GIR_Done,
     /* 170454 */ // Label 2674: @170454
     /* 170454 */ GIM_Reject,
     /* 170455 */ // Label 2670: @170455
     /* 170455 */ GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(170480), // Rule ID 1353 //
     /* 170460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170473 */   // (umin:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMINUH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUH),
     /* 170478 */   GIR_RootConstrainSelectedInstOperands,
     /* 170479 */   // GIR_Coverage, 1353,
     /* 170479 */   GIR_Done,
     /* 170480 */ // Label 2675: @170480
     /* 170480 */ GIM_Reject,
     /* 170481 */ // Label 2671: @170481
     /* 170481 */ GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(170506), // Rule ID 1351 //
     /* 170486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170499 */   // (umin:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMINUB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUB),
     /* 170504 */   GIR_RootConstrainSelectedInstOperands,
     /* 170505 */   // GIR_Coverage, 1351,
     /* 170505 */   GIR_Done,
     /* 170506 */ // Label 2676: @170506
     /* 170506 */ GIM_Reject,
     /* 170507 */ // Label 2672: @170507
     /* 170507 */ GIM_Reject,
     /* 170508 */ // Label 61: @170508
     /* 170508 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2681*/ GIMT_Encode4(170687),
     /* 170519 */ /*GILLT_v2s64*//*Label 2677*/ GIMT_Encode4(170535),
     /* 170523 */ /*GILLT_v4s32*//*Label 2678*/ GIMT_Encode4(170609),
     /* 170527 */ /*GILLT_v8s16*//*Label 2679*/ GIMT_Encode4(170635),
     /* 170531 */ /*GILLT_v16s8*//*Label 2680*/ GIMT_Encode4(170661),
     /* 170535 */ // Label 2677: @170535
     /* 170535 */ GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(170608), // Rule ID 1925 //
     /* 170540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170553 */   // (umax:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMAXUD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170553 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170556 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170560 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170565 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170569 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170586 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170590 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUD),
     /* 170598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170600 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170603 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170606 */   GIR_RootConstrainSelectedInstOperands,
     /* 170607 */   // GIR_Coverage, 1925,
     /* 170607 */   GIR_EraseRootFromParent_Done,
     /* 170608 */ // Label 2682: @170608
     /* 170608 */ GIM_Reject,
     /* 170609 */ // Label 2678: @170609
     /* 170609 */ GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(170634), // Rule ID 1349 //
     /* 170614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170627 */   // (umax:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMAXUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUW),
     /* 170632 */   GIR_RootConstrainSelectedInstOperands,
     /* 170633 */   // GIR_Coverage, 1349,
     /* 170633 */   GIR_Done,
     /* 170634 */ // Label 2683: @170634
     /* 170634 */ GIM_Reject,
     /* 170635 */ // Label 2679: @170635
     /* 170635 */ GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(170660), // Rule ID 1347 //
     /* 170640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170653 */   // (umax:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMAXUH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUH),
     /* 170658 */   GIR_RootConstrainSelectedInstOperands,
     /* 170659 */   // GIR_Coverage, 1347,
     /* 170659 */   GIR_Done,
     /* 170660 */ // Label 2684: @170660
     /* 170660 */ GIM_Reject,
     /* 170661 */ // Label 2680: @170661
     /* 170661 */ GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(170686), // Rule ID 1345 //
     /* 170666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170679 */   // (umax:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMAXUB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170679 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUB),
     /* 170684 */   GIR_RootConstrainSelectedInstOperands,
     /* 170685 */   // GIR_Coverage, 1345,
     /* 170685 */   GIR_Done,
     /* 170686 */ // Label 2685: @170686
     /* 170686 */ GIM_Reject,
     /* 170687 */ // Label 2681: @170687
     /* 170687 */ GIM_Reject,
     /* 170688 */ // Label 62: @170688
     /* 170688 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2688*/ GIMT_Encode4(170989),
     /* 170699 */ /*GILLT_s32*//*Label 2686*/ GIMT_Encode4(170707),
     /* 170703 */ /*GILLT_s64*//*Label 2687*/ GIMT_Encode4(170848),
     /* 170707 */ // Label 2686: @170707
     /* 170707 */ GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(170767), // Rule ID 2032 //
     /* 170712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 170715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 170718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 170722 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$S)  =>  (MFVSRWZ:{ *:[i32] } (FCTIW:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 170722 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 170725 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 170729 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170734 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 170738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /* 170747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170752 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 170760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 170762 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170765 */   GIR_RootConstrainSelectedInstOperands,
     /* 170766 */   // GIR_Coverage, 2032,
     /* 170766 */   GIR_EraseRootFromParent_Done,
     /* 170767 */ // Label 2689: @170767
     /* 170767 */ GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(170847), // Rule ID 2033 //
     /* 170772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 170775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 170782 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$S)  =>  (MFVSRWZ:{ *:[i32] } (FCTIW:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 170782 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170785 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170789 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170794 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 170798 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 170803 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 170806 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 170810 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170815 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 170818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170820 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170823 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /* 170827 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170832 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 170840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 170842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170845 */   GIR_RootConstrainSelectedInstOperands,
     /* 170846 */   // GIR_Coverage, 2033,
     /* 170846 */   GIR_EraseRootFromParent_Done,
     /* 170847 */ // Label 2690: @170847
     /* 170847 */ GIM_Reject,
     /* 170848 */ // Label 2687: @170848
     /* 170848 */ GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(170908), // Rule ID 2030 //
     /* 170853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 170856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 170859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 170863 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 170863 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 170866 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 170870 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170875 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 170879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 170888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170893 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 170901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 170903 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170906 */   GIR_RootConstrainSelectedInstOperands,
     /* 170907 */   // GIR_Coverage, 2030,
     /* 170907 */   GIR_EraseRootFromParent_Done,
     /* 170908 */ // Label 2691: @170908
     /* 170908 */ GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(170988), // Rule ID 2031 //
     /* 170913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 170916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 170923 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 170923 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170926 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170930 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170935 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 170939 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 170944 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 170947 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 170951 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170956 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 170959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170961 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170964 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 170968 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170973 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 170981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 170983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170986 */   GIR_RootConstrainSelectedInstOperands,
     /* 170987 */   // GIR_Coverage, 2031,
     /* 170987 */   GIR_EraseRootFromParent_Done,
     /* 170988 */ // Label 2692: @170988
     /* 170988 */ GIM_Reject,
     /* 170989 */ // Label 2688: @170989
     /* 170989 */ GIM_Reject,
     /* 170990 */ // Label 63: @170990
     /* 170990 */ GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(171154),
     /* 170995 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170998 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2696*/ GIMT_Encode4(171153),
     /* 171009 */   /*GILLT_s32*//*Label 2694*/ GIMT_Encode4(171017),
     /* 171013 */   /*GILLT_s64*//*Label 2695*/ GIMT_Encode4(171095),
     /* 171017 */   // Label 2694: @171017
     /* 171017 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(171094), // Rule ID 2035 //
     /* 171022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171029 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 171029 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171032 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171036 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171041 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171045 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 171050 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171053 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171057 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171062 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 171065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 171074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171079 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 171087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171092 */     GIR_RootConstrainSelectedInstOperands,
     /* 171093 */     // GIR_Coverage, 2035,
     /* 171093 */     GIR_EraseRootFromParent_Done,
     /* 171094 */   // Label 2697: @171094
     /* 171094 */   GIM_Reject,
     /* 171095 */   // Label 2695: @171095
     /* 171095 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(171152), // Rule ID 2034 //
     /* 171100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171107 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 171107 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171110 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171114 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 171132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171137 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 171145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171150 */     GIR_RootConstrainSelectedInstOperands,
     /* 171151 */     // GIR_Coverage, 2034,
     /* 171151 */     GIR_EraseRootFromParent_Done,
     /* 171152 */   // Label 2698: @171152
     /* 171152 */   GIM_Reject,
     /* 171153 */   // Label 2696: @171153
     /* 171153 */   GIM_Reject,
     /* 171154 */ // Label 2693: @171154
     /* 171154 */ GIM_Reject,
     /* 171155 */ // Label 64: @171155
     /* 171155 */ GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(171170), // Rule ID 15 //
     /* 171160 */   // MIs[0] LI
     /* 171160 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 171163 */   // (br (bb:{ *:[Other] }):$LI)  =>  (B (bb:{ *:[Other] }):$LI)
     /* 171163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::B),
     /* 171168 */   GIR_RootConstrainSelectedInstOperands,
     /* 171169 */   // GIR_Coverage, 15,
     /* 171169 */   GIR_Done,
     /* 171170 */ // Label 2699: @171170
     /* 171170 */ GIM_Reject,
     /* 171171 */ // Label 65: @171171
     /* 171171 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(8), /*)*//*default:*//*Label 2702*/ GIMT_Encode4(171288),
     /* 171182 */ /*GILLT_v8s16*//*Label 2700*/ GIMT_Encode4(171190),
     /* 171186 */ /*GILLT_v16s8*//*Label 2701*/ GIMT_Encode4(171253),
     /* 171190 */ // Label 2700: @171190
     /* 171190 */ GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(171252), // Rule ID 3487 //
     /* 171195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32),
     /* 171198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171204 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171211 */   // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vDi, i32:{ *:[i32] }:$rA, i32:{ *:[i32] }:$rB)  =>  (VINSHLX:{ *:[v8i16] } ?:{ *:[v8i16] }:$vDi, (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$rB, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), ?:{ *:[i32] }:$rA)
     /* 171211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 171214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 171218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171223 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rB
     /* 171227 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 171230 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 171233 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/30,
     /* 171236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHLX),
     /* 171241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 171243 */   GIR_RootToRootCopy, /*OpIdx*/1, // vDi
     /* 171245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171248 */   GIR_RootToRootCopy, /*OpIdx*/2, // rA
     /* 171250 */   GIR_RootConstrainSelectedInstOperands,
     /* 171251 */   // GIR_Coverage, 3487,
     /* 171251 */   GIR_EraseRootFromParent_Done,
     /* 171252 */ // Label 2703: @171252
     /* 171252 */ GIM_Reject,
     /* 171253 */ // Label 2701: @171253
     /* 171253 */ GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(171287), // Rule ID 3486 //
     /* 171258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32),
     /* 171261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171267 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171274 */   // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vDi, i32:{ *:[i32] }:$rA, i32:{ *:[i32] }:$rB)  =>  (VINSBLX:{ *:[v16i8] } ?:{ *:[v16i8] }:$vDi, ?:{ *:[i32] }:$rB, ?:{ *:[i32] }:$rA)
     /* 171274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBLX),
     /* 171277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 171279 */   GIR_RootToRootCopy, /*OpIdx*/1, // vDi
     /* 171281 */   GIR_RootToRootCopy, /*OpIdx*/3, // rB
     /* 171283 */   GIR_RootToRootCopy, /*OpIdx*/2, // rA
     /* 171285 */   GIR_RootConstrainSelectedInstOperands,
     /* 171286 */   // GIR_Coverage, 3486,
     /* 171286 */   GIR_EraseRootFromParent_Done,
     /* 171287 */ // Label 2704: @171287
     /* 171287 */ GIM_Reject,
     /* 171288 */ // Label 2702: @171288
     /* 171288 */ GIM_Reject,
     /* 171289 */ // Label 66: @171289
     /* 171289 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2711*/ GIMT_Encode4(171466),
     /* 171300 */ /*GILLT_s32*//*Label 2705*/ GIMT_Encode4(171328),
     /* 171304 */ /*GILLT_s64*//*Label 2706*/ GIMT_Encode4(171351), GIMT_Encode4(0),
     /* 171312 */ /*GILLT_v2s64*//*Label 2707*/ GIMT_Encode4(171374),
     /* 171316 */ /*GILLT_v4s32*//*Label 2708*/ GIMT_Encode4(171397),
     /* 171320 */ /*GILLT_v8s16*//*Label 2709*/ GIMT_Encode4(171420),
     /* 171324 */ /*GILLT_v16s8*//*Label 2710*/ GIMT_Encode4(171443),
     /* 171328 */ // Label 2705: @171328
     /* 171328 */ GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(171350), // Rule ID 134 //
     /* 171333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /* 171336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171343 */   // (cttz:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (CNTTZW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 171343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTTZW),
     /* 171348 */   GIR_RootConstrainSelectedInstOperands,
     /* 171349 */   // GIR_Coverage, 134,
     /* 171349 */   GIR_Done,
     /* 171350 */ // Label 2712: @171350
     /* 171350 */ GIM_Reject,
     /* 171351 */ // Label 2706: @171351
     /* 171351 */ GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(171373), // Rule ID 684 //
     /* 171356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /* 171359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171366 */   // (cttz:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (CNTTZD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 171366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTTZD),
     /* 171371 */   GIR_RootConstrainSelectedInstOperands,
     /* 171372 */   // GIR_Coverage, 684,
     /* 171372 */   GIR_Done,
     /* 171373 */ // Label 2713: @171373
     /* 171373 */ GIM_Reject,
     /* 171374 */ // Label 2707: @171374
     /* 171374 */ GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(171396), // Rule ID 535 //
     /* 171379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 171385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171389 */   // (cttz:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VCTZD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 171389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZD),
     /* 171394 */   GIR_RootConstrainSelectedInstOperands,
     /* 171395 */   // GIR_Coverage, 535,
     /* 171395 */   GIR_Done,
     /* 171396 */ // Label 2714: @171396
     /* 171396 */ GIM_Reject,
     /* 171397 */ // Label 2708: @171397
     /* 171397 */ GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(171419), // Rule ID 534 //
     /* 171402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171412 */   // (cttz:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VCTZW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 171412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZW),
     /* 171417 */   GIR_RootConstrainSelectedInstOperands,
     /* 171418 */   // GIR_Coverage, 534,
     /* 171418 */   GIR_Done,
     /* 171419 */ // Label 2715: @171419
     /* 171419 */ GIM_Reject,
     /* 171420 */ // Label 2709: @171420
     /* 171420 */ GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(171442), // Rule ID 533 //
     /* 171425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171435 */   // (cttz:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VCTZH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 171435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZH),
     /* 171440 */   GIR_RootConstrainSelectedInstOperands,
     /* 171441 */   // GIR_Coverage, 533,
     /* 171441 */   GIR_Done,
     /* 171442 */ // Label 2716: @171442
     /* 171442 */ GIM_Reject,
     /* 171443 */ // Label 2710: @171443
     /* 171443 */ GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(171465), // Rule ID 532 //
     /* 171448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171458 */   // (cttz:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VCTZB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 171458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZB),
     /* 171463 */   GIR_RootConstrainSelectedInstOperands,
     /* 171464 */   // GIR_Coverage, 532,
     /* 171464 */   GIR_Done,
     /* 171465 */ // Label 2717: @171465
     /* 171465 */ GIM_Reject,
     /* 171466 */ // Label 2711: @171466
     /* 171466 */ GIM_Reject,
     /* 171467 */ // Label 67: @171467
     /* 171467 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2724*/ GIMT_Encode4(171638),
     /* 171478 */ /*GILLT_s32*//*Label 2718*/ GIMT_Encode4(171506),
     /* 171482 */ /*GILLT_s64*//*Label 2719*/ GIMT_Encode4(171526), GIMT_Encode4(0),
     /* 171490 */ /*GILLT_v2s64*//*Label 2720*/ GIMT_Encode4(171546),
     /* 171494 */ /*GILLT_v4s32*//*Label 2721*/ GIMT_Encode4(171569),
     /* 171498 */ /*GILLT_v8s16*//*Label 2722*/ GIMT_Encode4(171592),
     /* 171502 */ /*GILLT_v16s8*//*Label 2723*/ GIMT_Encode4(171615),
     /* 171506 */ // Label 2718: @171506
     /* 171506 */ GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(171525), // Rule ID 133 //
     /* 171511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171518 */   // (ctlz:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (CNTLZW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 171518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 171523 */   GIR_RootConstrainSelectedInstOperands,
     /* 171524 */   // GIR_Coverage, 133,
     /* 171524 */   GIR_Done,
     /* 171525 */ // Label 2725: @171525
     /* 171525 */ GIM_Reject,
     /* 171526 */ // Label 2719: @171526
     /* 171526 */ GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(171545), // Rule ID 683 //
     /* 171531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171538 */   // (ctlz:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (CNTLZD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 171538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 171543 */   GIR_RootConstrainSelectedInstOperands,
     /* 171544 */   // GIR_Coverage, 683,
     /* 171544 */   GIR_Done,
     /* 171545 */ // Label 2726: @171545
     /* 171545 */ GIM_Reject,
     /* 171546 */ // Label 2720: @171546
     /* 171546 */ GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(171568), // Rule ID 482 //
     /* 171551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 171557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171561 */   // (ctlz:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VCLZD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 171561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZD),
     /* 171566 */   GIR_RootConstrainSelectedInstOperands,
     /* 171567 */   // GIR_Coverage, 482,
     /* 171567 */   GIR_Done,
     /* 171568 */ // Label 2727: @171568
     /* 171568 */ GIM_Reject,
     /* 171569 */ // Label 2721: @171569
     /* 171569 */ GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(171591), // Rule ID 481 //
     /* 171574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171584 */   // (ctlz:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VCLZW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 171584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZW),
     /* 171589 */   GIR_RootConstrainSelectedInstOperands,
     /* 171590 */   // GIR_Coverage, 481,
     /* 171590 */   GIR_Done,
     /* 171591 */ // Label 2728: @171591
     /* 171591 */ GIM_Reject,
     /* 171592 */ // Label 2722: @171592
     /* 171592 */ GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(171614), // Rule ID 480 //
     /* 171597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171607 */   // (ctlz:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VCLZH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 171607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZH),
     /* 171612 */   GIR_RootConstrainSelectedInstOperands,
     /* 171613 */   // GIR_Coverage, 480,
     /* 171613 */   GIR_Done,
     /* 171614 */ // Label 2729: @171614
     /* 171614 */ GIM_Reject,
     /* 171615 */ // Label 2723: @171615
     /* 171615 */ GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(171637), // Rule ID 479 //
     /* 171620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171630 */   // (ctlz:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VCLZB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 171630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZB),
     /* 171635 */   GIR_RootConstrainSelectedInstOperands,
     /* 171636 */   // GIR_Coverage, 479,
     /* 171636 */   GIR_Done,
     /* 171637 */ // Label 2730: @171637
     /* 171637 */ GIM_Reject,
     /* 171638 */ // Label 2724: @171638
     /* 171638 */ GIM_Reject,
     /* 171639 */ // Label 68: @171639
     /* 171639 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2737*/ GIMT_Encode4(171810),
     /* 171650 */ /*GILLT_s32*//*Label 2731*/ GIMT_Encode4(171678),
     /* 171654 */ /*GILLT_s64*//*Label 2732*/ GIMT_Encode4(171698), GIMT_Encode4(0),
     /* 171662 */ /*GILLT_v2s64*//*Label 2733*/ GIMT_Encode4(171718),
     /* 171666 */ /*GILLT_v4s32*//*Label 2734*/ GIMT_Encode4(171741),
     /* 171670 */ /*GILLT_v8s16*//*Label 2735*/ GIMT_Encode4(171764),
     /* 171674 */ /*GILLT_v16s8*//*Label 2736*/ GIMT_Encode4(171787),
     /* 171678 */ // Label 2731: @171678
     /* 171678 */ GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(171697), // Rule ID 688 //
     /* 171683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171690 */   // (ctpop:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (POPCNTW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 171690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::POPCNTW),
     /* 171695 */   GIR_RootConstrainSelectedInstOperands,
     /* 171696 */   // GIR_Coverage, 688,
     /* 171696 */   GIR_Done,
     /* 171697 */ // Label 2738: @171697
     /* 171697 */ GIM_Reject,
     /* 171698 */ // Label 2732: @171698
     /* 171698 */ GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(171717), // Rule ID 685 //
     /* 171703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171710 */   // (ctpop:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (POPCNTD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 171710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::POPCNTD),
     /* 171715 */   GIR_RootConstrainSelectedInstOperands,
     /* 171716 */   // GIR_Coverage, 685,
     /* 171716 */   GIR_Done,
     /* 171717 */ // Label 2739: @171717
     /* 171717 */ GIM_Reject,
     /* 171718 */ // Label 2733: @171718
     /* 171718 */ GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(171740), // Rule ID 486 //
     /* 171723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 171729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171733 */   // (ctpop:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VPOPCNTD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 171733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTD),
     /* 171738 */   GIR_RootConstrainSelectedInstOperands,
     /* 171739 */   // GIR_Coverage, 486,
     /* 171739 */   GIR_Done,
     /* 171740 */ // Label 2740: @171740
     /* 171740 */ GIM_Reject,
     /* 171741 */ // Label 2734: @171741
     /* 171741 */ GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(171763), // Rule ID 485 //
     /* 171746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171756 */   // (ctpop:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VPOPCNTW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 171756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTW),
     /* 171761 */   GIR_RootConstrainSelectedInstOperands,
     /* 171762 */   // GIR_Coverage, 485,
     /* 171762 */   GIR_Done,
     /* 171763 */ // Label 2741: @171763
     /* 171763 */ GIM_Reject,
     /* 171764 */ // Label 2735: @171764
     /* 171764 */ GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(171786), // Rule ID 484 //
     /* 171769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171779 */   // (ctpop:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VPOPCNTH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 171779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTH),
     /* 171784 */   GIR_RootConstrainSelectedInstOperands,
     /* 171785 */   // GIR_Coverage, 484,
     /* 171785 */   GIR_Done,
     /* 171786 */ // Label 2742: @171786
     /* 171786 */ GIM_Reject,
     /* 171787 */ // Label 2736: @171787
     /* 171787 */ GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(171809), // Rule ID 483 //
     /* 171792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171802 */   // (ctpop:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VPOPCNTB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 171802 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTB),
     /* 171807 */   GIR_RootConstrainSelectedInstOperands,
     /* 171808 */   // GIR_Coverage, 483,
     /* 171808 */   GIR_Done,
     /* 171809 */ // Label 2743: @171809
     /* 171809 */ GIM_Reject,
     /* 171810 */ // Label 2737: @171810
     /* 171810 */ GIM_Reject,
     /* 171811 */ // Label 69: @171811
     /* 171811 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 2750*/ GIMT_Encode4(172074),
     /* 171822 */ /*GILLT_s32*//*Label 2744*/ GIMT_Encode4(171846),
     /* 171826 */ /*GILLT_s64*//*Label 2745*/ GIMT_Encode4(171869),
     /* 171830 */ /*GILLT_s128*//*Label 2746*/ GIMT_Encode4(171892),
     /* 171834 */ /*GILLT_v2s64*//*Label 2747*/ GIMT_Encode4(171960),
     /* 171838 */ /*GILLT_v4s32*//*Label 2748*/ GIMT_Encode4(171983),
     /* 171842 */ /*GILLT_v8s16*//*Label 2749*/ GIMT_Encode4(172006),
     /* 171846 */ // Label 2744: @171846
     /* 171846 */ GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(171868), // Rule ID 1137 //
     /* 171851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 171854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171861 */   // (bswap:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (BRW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 171861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BRW),
     /* 171866 */   GIR_RootConstrainSelectedInstOperands,
     /* 171867 */   // GIR_Coverage, 1137,
     /* 171867 */   GIR_Done,
     /* 171868 */ // Label 2751: @171868
     /* 171868 */ GIM_Reject,
     /* 171869 */ // Label 2745: @171869
     /* 171869 */ GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(171891), // Rule ID 1138 //
     /* 171874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 171877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171884 */   // (bswap:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (BRD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 171884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BRD),
     /* 171889 */   GIR_RootConstrainSelectedInstOperands,
     /* 171890 */   // GIR_Coverage, 1138,
     /* 171890 */   GIR_Done,
     /* 171891 */ // Label 2752: @171891
     /* 171891 */ GIM_Reject,
     /* 171892 */ // Label 2746: @171892
     /* 171892 */ GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(171959), // Rule ID 2169 //
     /* 171897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 171900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 171903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171907 */   // (bswap:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXBRQ:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$A, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 171907 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 171910 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171914 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171919 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 171923 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 171928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 171931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBRQ),
     /* 171935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171940 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171950 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171953 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171958 */   // GIR_Coverage, 2169,
     /* 171958 */   GIR_EraseRootFromParent_Done,
     /* 171959 */ // Label 2753: @171959
     /* 171959 */ GIM_Reject,
     /* 171960 */ // Label 2747: @171960
     /* 171960 */ GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(171982), // Rule ID 1034 //
     /* 171965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 171968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 171971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 171975 */   // (bswap:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XXBRD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XB)
     /* 171975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXBRD),
     /* 171980 */   GIR_RootConstrainSelectedInstOperands,
     /* 171981 */   // GIR_Coverage, 1034,
     /* 171981 */   GIR_Done,
     /* 171982 */ // Label 2754: @171982
     /* 171982 */ GIM_Reject,
     /* 171983 */ // Label 2748: @171983
     /* 171983 */ GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(172005), // Rule ID 1033 //
     /* 171988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 171991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 171998 */   // (bswap:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XXBRW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB)
     /* 171998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXBRW),
     /* 172003 */   GIR_RootConstrainSelectedInstOperands,
     /* 172004 */   // GIR_Coverage, 1033,
     /* 172004 */   GIR_Done,
     /* 172005 */ // Label 2755: @172005
     /* 172005 */ GIM_Reject,
     /* 172006 */ // Label 2749: @172006
     /* 172006 */ GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(172073), // Rule ID 2168 //
     /* 172011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 172014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172021 */   // (bswap:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXBRH:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 172021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 172024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172033 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172037 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 172042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 172045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBRH),
     /* 172049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172054 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 172057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172064 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 172067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172072 */   // GIR_Coverage, 2168,
     /* 172072 */   GIR_EraseRootFromParent_Done,
     /* 172073 */ // Label 2756: @172073
     /* 172073 */ GIM_Reject,
     /* 172074 */ // Label 2750: @172074
     /* 172074 */ GIM_Reject,
     /* 172075 */ // Label 70: @172075
     /* 172075 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2759*/ GIMT_Encode4(208080),
     /* 172086 */ /*GILLT_s32*//*Label 2757*/ GIMT_Encode4(172094),
     /* 172090 */ /*GILLT_s64*//*Label 2758*/ GIMT_Encode4(182389),
     /* 172094 */ // Label 2757: @172094
     /* 172094 */ GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(182388),
     /* 172099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 172106 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(177262), // Rule ID 4881 //
     /* 172111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 172114 */     // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$A)  =>  (RLDICL_32:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), 0:{ *:[i32] }, 32:{ *:[i32] })
     /* 172114 */     GIR_MakeTempReg, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172118 */     GIR_BuildMI, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172123 */     GIR_AddTempRegister, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172130 */     GIR_AddImm, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 172141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 192(*/0xC0, 0x01/*)*/,
     /* 172144 */     GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172148 */     GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172153 */     GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172160 */     GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/,
     /* 172165 */     GIR_AddImm, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 172176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 191(*/0xBF, 0x01/*)*/,
     /* 172179 */     GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172183 */     GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172188 */     GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172195 */     GIR_AddImm, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 172206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 172209 */     GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172213 */     GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172218 */     GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172225 */     GIR_AddSimpleTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 172230 */     GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 172241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 172244 */     GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172248 */     GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172253 */     GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172260 */     GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 172271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 172274 */     GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172278 */     GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172283 */     GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172290 */     GIR_AddSimpleTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 172295 */     GIR_AddImm, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 172306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 172309 */     GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172313 */     GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172318 */     GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172325 */     GIR_Copy, /*NewInsnID*//* 186(*/0xBA, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172330 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/1,
     /* 172334 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/0,
     /* 172338 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/30,
     /* 172342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 172345 */     GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172349 */     GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172354 */     GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172361 */     GIR_AddSimpleTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 172366 */     GIR_AddSimpleTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 172371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 172374 */     GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172378 */     GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172383 */     GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172390 */     GIR_AddImm, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 172401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 172404 */     GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172408 */     GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172413 */     GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172420 */     GIR_AddSimpleTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 172425 */     GIR_AddImm, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 172436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 172439 */     GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172443 */     GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172448 */     GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172455 */     GIR_Copy, /*NewInsnID*//* 182(*/0xB6, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172460 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/31,
     /* 172464 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/1,
     /* 172468 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/31,
     /* 172472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 182(*/0xB6, 0x01/*)*/,
     /* 172475 */     GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172479 */     GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172484 */     GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172491 */     GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 172496 */     GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 172501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 172504 */     GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172508 */     GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 172513 */     GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172520 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 172525 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 172530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 172533 */     GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172537 */     GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172542 */     GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172549 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 172554 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/2,
     /* 172558 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/0,
     /* 172562 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/29,
     /* 172566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 172569 */     GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172573 */     GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172578 */     GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172585 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 172590 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 172595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 172598 */     GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172602 */     GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172607 */     GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172614 */     GIR_AddImm, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 172625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 172628 */     GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172632 */     GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172637 */     GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172644 */     GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 172649 */     GIR_AddImm, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 172660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 172663 */     GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172667 */     GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172672 */     GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172679 */     GIR_AddImm, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 172690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 172693 */     GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172697 */     GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172702 */     GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172709 */     GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 172714 */     GIR_AddImm, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 172725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 172728 */     GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172732 */     GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172737 */     GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172744 */     GIR_Copy, /*NewInsnID*//* 173(*/0xAD, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172749 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/1,
     /* 172753 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/0,
     /* 172757 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/30,
     /* 172761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 172764 */     GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172768 */     GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172773 */     GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172780 */     GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 172785 */     GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 172790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 172793 */     GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172797 */     GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172802 */     GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172809 */     GIR_AddImm, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 172820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 172823 */     GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172827 */     GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172832 */     GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172839 */     GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 172844 */     GIR_AddImm, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 172855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 170(*/0xAA, 0x01/*)*/,
     /* 172858 */     GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172862 */     GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172867 */     GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172874 */     GIR_Copy, /*NewInsnID*//* 169(*/0xA9, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172879 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 172883 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/1,
     /* 172887 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 172891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 172894 */     GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172898 */     GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172903 */     GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172910 */     GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 172915 */     GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 172920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 172923 */     GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172927 */     GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 172932 */     GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172939 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 172944 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 172949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 172952 */     GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172956 */     GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172961 */     GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172968 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 172973 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/30,
     /* 172977 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/2,
     /* 172981 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/31,
     /* 172985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 172988 */     GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172992 */     GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172997 */     GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173004 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 173009 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 173014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 173017 */     GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173021 */     GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173026 */     GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173033 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 173038 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 173043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 173046 */     GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173050 */     GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173055 */     GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173062 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 173067 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/4,
     /* 173071 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/0,
     /* 173075 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/27,
     /* 173079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 163(*/0xA3, 0x01/*)*/,
     /* 173082 */     GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173086 */     GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173091 */     GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173098 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 173103 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 173108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 173111 */     GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173115 */     GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173120 */     GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173127 */     GIR_AddImm, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 173138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 173141 */     GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173145 */     GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173150 */     GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173157 */     GIR_AddSimpleTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 173162 */     GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 173173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 173176 */     GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173180 */     GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173185 */     GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173192 */     GIR_AddImm, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 173203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 173206 */     GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173210 */     GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173215 */     GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173222 */     GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 173227 */     GIR_AddImm, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 173238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 173241 */     GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173245 */     GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173250 */     GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173257 */     GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 173271 */     GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173275 */     GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173280 */     GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173287 */     GIR_AddSimpleTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 173292 */     GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 173306 */     GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173310 */     GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173315 */     GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173322 */     GIR_Copy, /*NewInsnID*//* 155(*/0x9B, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173327 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/1,
     /* 173331 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/0,
     /* 173335 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/30,
     /* 173339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 173342 */     GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173346 */     GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173351 */     GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173358 */     GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 173363 */     GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 173368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 154(*/0x9A, 0x01/*)*/,
     /* 173371 */     GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173375 */     GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173380 */     GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173387 */     GIR_AddImm, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 173401 */     GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173405 */     GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173410 */     GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173417 */     GIR_AddSimpleTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 173422 */     GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 173436 */     GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173440 */     GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173445 */     GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173452 */     GIR_Copy, /*NewInsnID*//* 151(*/0x97, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173457 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/31,
     /* 173461 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/1,
     /* 173465 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/31,
     /* 173469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 173472 */     GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173476 */     GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173481 */     GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173488 */     GIR_AddSimpleTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 173493 */     GIR_AddSimpleTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 173498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 173501 */     GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173505 */     GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173510 */     GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173517 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 173522 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 173527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 173530 */     GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173534 */     GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173539 */     GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173546 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 173551 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/2,
     /* 173555 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/0,
     /* 173559 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/29,
     /* 173563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 173566 */     GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173570 */     GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173575 */     GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173582 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 173587 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 173592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 173595 */     GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173599 */     GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173604 */     GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173611 */     GIR_AddImm, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 173622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 173625 */     GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173629 */     GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173634 */     GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173641 */     GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 173646 */     GIR_AddImm, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 173657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 173660 */     GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173664 */     GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173669 */     GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173676 */     GIR_AddImm, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 173690 */     GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173694 */     GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173699 */     GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173706 */     GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 173711 */     GIR_AddImm, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 173725 */     GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173729 */     GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173734 */     GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173741 */     GIR_Copy, /*NewInsnID*//* 142(*/0x8E, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173746 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/1,
     /* 173750 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/0,
     /* 173754 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/30,
     /* 173758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 173761 */     GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173765 */     GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173770 */     GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173777 */     GIR_AddSimpleTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/,
     /* 173782 */     GIR_AddSimpleTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 173787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 141(*/0x8D, 0x01/*)*/,
     /* 173790 */     GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173794 */     GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173799 */     GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173806 */     GIR_AddImm, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 173820 */     GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173824 */     GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173829 */     GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173836 */     GIR_AddSimpleTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 173841 */     GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 173855 */     GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173859 */     GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173864 */     GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173871 */     GIR_Copy, /*NewInsnID*//* 138(*/0x8A, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173876 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/31,
     /* 173880 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/1,
     /* 173884 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/31,
     /* 173888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 173891 */     GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173895 */     GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173900 */     GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173907 */     GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 173912 */     GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 173917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 137(*/0x89, 0x01/*)*/,
     /* 173920 */     GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173924 */     GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173929 */     GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173936 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 173941 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 173946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 173949 */     GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173953 */     GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173958 */     GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173965 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 173970 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/30,
     /* 173974 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/2,
     /* 173978 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/31,
     /* 173982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 173985 */     GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173989 */     GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173994 */     GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174001 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 174006 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 174011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 174014 */     GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174018 */     GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174023 */     GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174030 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 174035 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 174040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 174043 */     GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174047 */     GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174052 */     GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174059 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 174064 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/28,
     /* 174068 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/4,
     /* 174072 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/31,
     /* 174076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 174079 */     GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174083 */     GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174088 */     GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174095 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 174100 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 174105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 174108 */     GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174112 */     GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174117 */     GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174124 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 174129 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 174134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 130(*/0x82, 0x01/*)*/,
     /* 174137 */     GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174141 */     GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174146 */     GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174153 */     GIR_AddImm, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 174164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 174167 */     GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s32,
     /* 174170 */     GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174175 */     GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174181 */     GIR_AddSimpleTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 174186 */     GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 174197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 174200 */     GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s32,
     /* 174203 */     GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174207 */     GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174212 */     GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(52428),
     /* 174222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 174224 */     GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 174227 */     GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174231 */     GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174236 */     GIR_AddSimpleTempRegister, /*InsnID*/126, /*TempRegID*/126,
     /* 174239 */     GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(52428),
     /* 174249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 174251 */     GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 174254 */     GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174258 */     GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174263 */     GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(43690),
     /* 174273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 174275 */     GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s32,
     /* 174278 */     GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174282 */     GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174287 */     GIR_AddSimpleTempRegister, /*InsnID*/124, /*TempRegID*/124,
     /* 174290 */     GIR_AddImm, /*InsnID*/124, /*Imm*/GIMT_Encode8(43690),
     /* 174300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 174302 */     GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s32,
     /* 174305 */     GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174309 */     GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174314 */     GIR_Copy, /*NewInsnID*/123, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174318 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/1,
     /* 174321 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/0,
     /* 174324 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/30,
     /* 174327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/123,
     /* 174329 */     GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s32,
     /* 174332 */     GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174336 */     GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174341 */     GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/122,
     /* 174344 */     GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/123,
     /* 174347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 174349 */     GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s32,
     /* 174352 */     GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174356 */     GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174361 */     GIR_AddImm, /*InsnID*/121, /*Imm*/GIMT_Encode8(21845),
     /* 174371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 174373 */     GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s32,
     /* 174376 */     GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174380 */     GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174385 */     GIR_AddSimpleTempRegister, /*InsnID*/120, /*TempRegID*/120,
     /* 174388 */     GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(21845),
     /* 174398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 174400 */     GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s32,
     /* 174403 */     GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174407 */     GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174412 */     GIR_Copy, /*NewInsnID*/119, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174416 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/31,
     /* 174419 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/1,
     /* 174422 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/31,
     /* 174425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 174427 */     GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s32,
     /* 174430 */     GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174434 */     GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174439 */     GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/118,
     /* 174442 */     GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/119,
     /* 174445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 174447 */     GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 174450 */     GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174454 */     GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174459 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/117,
     /* 174462 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/121,
     /* 174465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 174467 */     GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 174470 */     GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174474 */     GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174479 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 174482 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/2,
     /* 174485 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/0,
     /* 174488 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/29,
     /* 174491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 174493 */     GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s32,
     /* 174496 */     GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174500 */     GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174505 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/115,
     /* 174508 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/125,
     /* 174511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 174513 */     GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s32,
     /* 174516 */     GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174520 */     GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174525 */     GIR_AddImm, /*InsnID*/114, /*Imm*/GIMT_Encode8(13107),
     /* 174535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/114,
     /* 174537 */     GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s32,
     /* 174540 */     GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174544 */     GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174549 */     GIR_AddSimpleTempRegister, /*InsnID*/113, /*TempRegID*/113,
     /* 174552 */     GIR_AddImm, /*InsnID*/113, /*Imm*/GIMT_Encode8(13107),
     /* 174562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 174564 */     GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s32,
     /* 174567 */     GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174571 */     GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174576 */     GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(43690),
     /* 174586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 174588 */     GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s32,
     /* 174591 */     GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174595 */     GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174600 */     GIR_AddSimpleTempRegister, /*InsnID*/111, /*TempRegID*/111,
     /* 174603 */     GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(43690),
     /* 174613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 174615 */     GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s32,
     /* 174618 */     GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174622 */     GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174627 */     GIR_Copy, /*NewInsnID*/110, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174631 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/1,
     /* 174634 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/0,
     /* 174637 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/30,
     /* 174640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 174642 */     GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s32,
     /* 174645 */     GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174649 */     GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174654 */     GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/109,
     /* 174657 */     GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/110,
     /* 174660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 174662 */     GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s32,
     /* 174665 */     GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174669 */     GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174674 */     GIR_AddImm, /*InsnID*/108, /*Imm*/GIMT_Encode8(21845),
     /* 174684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 174686 */     GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s32,
     /* 174689 */     GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174693 */     GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174698 */     GIR_AddSimpleTempRegister, /*InsnID*/107, /*TempRegID*/107,
     /* 174701 */     GIR_AddImm, /*InsnID*/107, /*Imm*/GIMT_Encode8(21845),
     /* 174711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 174713 */     GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s32,
     /* 174716 */     GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174720 */     GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174725 */     GIR_Copy, /*NewInsnID*/106, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174729 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/31,
     /* 174732 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/1,
     /* 174735 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/31,
     /* 174738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 174740 */     GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 174743 */     GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174747 */     GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174752 */     GIR_AddSimpleTempRegister, /*InsnID*/105, /*TempRegID*/105,
     /* 174755 */     GIR_AddSimpleTempRegister, /*InsnID*/105, /*TempRegID*/106,
     /* 174758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 174760 */     GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 174763 */     GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174767 */     GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174772 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 174775 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/108,
     /* 174778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 174780 */     GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s32,
     /* 174783 */     GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174787 */     GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174792 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/103,
     /* 174795 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/30,
     /* 174798 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/2,
     /* 174801 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/31,
     /* 174804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 174806 */     GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s32,
     /* 174809 */     GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174813 */     GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174818 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 174821 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/112,
     /* 174824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/102,
     /* 174826 */     GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s32,
     /* 174829 */     GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174833 */     GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174838 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 174841 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/114,
     /* 174844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 174846 */     GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s32,
     /* 174849 */     GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174853 */     GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174858 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 174861 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/4,
     /* 174864 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/0,
     /* 174867 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/27,
     /* 174870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 174872 */     GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s32,
     /* 174875 */     GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174879 */     GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174884 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 174887 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/127,
     /* 174890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 174892 */     GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 174895 */     GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174899 */     GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174904 */     GIR_AddImm, /*InsnID*/98, /*Imm*/GIMT_Encode8(3855),
     /* 174914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 174916 */     GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 174919 */     GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174923 */     GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174928 */     GIR_AddSimpleTempRegister, /*InsnID*/97, /*TempRegID*/97,
     /* 174931 */     GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(3855),
     /* 174941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 174943 */     GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s32,
     /* 174946 */     GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174950 */     GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174955 */     GIR_AddImm, /*InsnID*/96, /*Imm*/GIMT_Encode8(52428),
     /* 174965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 174967 */     GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s32,
     /* 174970 */     GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174974 */     GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174979 */     GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/95,
     /* 174982 */     GIR_AddImm, /*InsnID*/95, /*Imm*/GIMT_Encode8(52428),
     /* 174992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/95,
     /* 174994 */     GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s32,
     /* 174997 */     GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175001 */     GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175006 */     GIR_AddImm, /*InsnID*/94, /*Imm*/GIMT_Encode8(43690),
     /* 175016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 175018 */     GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s32,
     /* 175021 */     GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175025 */     GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175030 */     GIR_AddSimpleTempRegister, /*InsnID*/93, /*TempRegID*/93,
     /* 175033 */     GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 175043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 175045 */     GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s32,
     /* 175048 */     GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175052 */     GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175057 */     GIR_Copy, /*NewInsnID*/92, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175061 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/1,
     /* 175064 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/0,
     /* 175067 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/30,
     /* 175070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 175072 */     GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s32,
     /* 175075 */     GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175079 */     GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175084 */     GIR_AddSimpleTempRegister, /*InsnID*/91, /*TempRegID*/91,
     /* 175087 */     GIR_AddSimpleTempRegister, /*InsnID*/91, /*TempRegID*/92,
     /* 175090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 175092 */     GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s32,
     /* 175095 */     GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175099 */     GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175104 */     GIR_AddImm, /*InsnID*/90, /*Imm*/GIMT_Encode8(21845),
     /* 175114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 175116 */     GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 175119 */     GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175123 */     GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175128 */     GIR_AddSimpleTempRegister, /*InsnID*/89, /*TempRegID*/89,
     /* 175131 */     GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 175141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 175143 */     GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 175146 */     GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175150 */     GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175155 */     GIR_Copy, /*NewInsnID*/88, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175159 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/31,
     /* 175162 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/1,
     /* 175165 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/31,
     /* 175168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 175170 */     GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s32,
     /* 175173 */     GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175177 */     GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175182 */     GIR_AddSimpleTempRegister, /*InsnID*/87, /*TempRegID*/87,
     /* 175185 */     GIR_AddSimpleTempRegister, /*InsnID*/87, /*TempRegID*/88,
     /* 175188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 175190 */     GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s32,
     /* 175193 */     GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175197 */     GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175202 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 175205 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/90,
     /* 175208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/86,
     /* 175210 */     GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s32,
     /* 175213 */     GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175217 */     GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175222 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 175225 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/2,
     /* 175228 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/0,
     /* 175231 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/29,
     /* 175234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 175236 */     GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s32,
     /* 175239 */     GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175243 */     GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175248 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 175251 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/94,
     /* 175254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 175256 */     GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s32,
     /* 175259 */     GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175263 */     GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175268 */     GIR_AddImm, /*InsnID*/83, /*Imm*/GIMT_Encode8(13107),
     /* 175278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 175280 */     GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s32,
     /* 175283 */     GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175287 */     GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175292 */     GIR_AddSimpleTempRegister, /*InsnID*/82, /*TempRegID*/82,
     /* 175295 */     GIR_AddImm, /*InsnID*/82, /*Imm*/GIMT_Encode8(13107),
     /* 175305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 175307 */     GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s32,
     /* 175310 */     GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175314 */     GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175319 */     GIR_AddImm, /*InsnID*/81, /*Imm*/GIMT_Encode8(43690),
     /* 175329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 175331 */     GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s32,
     /* 175334 */     GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175338 */     GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175343 */     GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/80,
     /* 175346 */     GIR_AddImm, /*InsnID*/80, /*Imm*/GIMT_Encode8(43690),
     /* 175356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 175358 */     GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s32,
     /* 175361 */     GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175365 */     GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175370 */     GIR_Copy, /*NewInsnID*/79, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175374 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/1,
     /* 175377 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/0,
     /* 175380 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/30,
     /* 175383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 175385 */     GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s32,
     /* 175388 */     GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175392 */     GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175397 */     GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/78,
     /* 175400 */     GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/79,
     /* 175403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 175405 */     GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s32,
     /* 175408 */     GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175412 */     GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175417 */     GIR_AddImm, /*InsnID*/77, /*Imm*/GIMT_Encode8(21845),
     /* 175427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 175429 */     GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s32,
     /* 175432 */     GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175436 */     GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175441 */     GIR_AddSimpleTempRegister, /*InsnID*/76, /*TempRegID*/76,
     /* 175444 */     GIR_AddImm, /*InsnID*/76, /*Imm*/GIMT_Encode8(21845),
     /* 175454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 175456 */     GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s32,
     /* 175459 */     GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175463 */     GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175468 */     GIR_Copy, /*NewInsnID*/75, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175472 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/31,
     /* 175475 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/1,
     /* 175478 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/31,
     /* 175481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 175483 */     GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 175486 */     GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175490 */     GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175495 */     GIR_AddSimpleTempRegister, /*InsnID*/74, /*TempRegID*/74,
     /* 175498 */     GIR_AddSimpleTempRegister, /*InsnID*/74, /*TempRegID*/75,
     /* 175501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 175503 */     GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 175506 */     GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175510 */     GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175515 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 175518 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/77,
     /* 175521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 175523 */     GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s32,
     /* 175526 */     GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175530 */     GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175535 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/72,
     /* 175538 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/30,
     /* 175541 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/2,
     /* 175544 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/31,
     /* 175547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 175549 */     GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s32,
     /* 175552 */     GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175556 */     GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175561 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 175564 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/81,
     /* 175567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/71,
     /* 175569 */     GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s32,
     /* 175572 */     GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175576 */     GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175581 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 175584 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/83,
     /* 175587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 175589 */     GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s32,
     /* 175592 */     GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175596 */     GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175601 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 175604 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/28,
     /* 175607 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/4,
     /* 175610 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/31,
     /* 175613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 175615 */     GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s32,
     /* 175618 */     GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175622 */     GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175627 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 175630 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/96,
     /* 175633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 175635 */     GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 175638 */     GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175642 */     GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175647 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/67,
     /* 175650 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/98,
     /* 175653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 175655 */     GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 175658 */     GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175662 */     GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175667 */     GIR_AddImm, /*InsnID*/66, /*Imm*/GIMT_Encode8(61680),
     /* 175677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 175679 */     GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s32,
     /* 175682 */     GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175686 */     GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175691 */     GIR_AddSimpleTempRegister, /*InsnID*/65, /*TempRegID*/65,
     /* 175694 */     GIR_AddImm, /*InsnID*/65, /*Imm*/GIMT_Encode8(61680),
     /* 175704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 175706 */     GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s32,
     /* 175709 */     GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175713 */     GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175718 */     GIR_AddImm, /*InsnID*/64, /*Imm*/GIMT_Encode8(52428),
     /* 175728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/64,
     /* 175730 */     GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s32,
     /* 175733 */     GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175737 */     GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175742 */     GIR_AddSimpleTempRegister, /*InsnID*/63, /*TempRegID*/63,
     /* 175745 */     GIR_AddImm, /*InsnID*/63, /*Imm*/GIMT_Encode8(52428),
     /* 175755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 175757 */     GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s32,
     /* 175760 */     GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175764 */     GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175769 */     GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(43690),
     /* 175779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 175781 */     GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s32,
     /* 175784 */     GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175788 */     GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175793 */     GIR_AddSimpleTempRegister, /*InsnID*/61, /*TempRegID*/61,
     /* 175796 */     GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(43690),
     /* 175806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 175808 */     GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 175811 */     GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175815 */     GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175820 */     GIR_Copy, /*NewInsnID*/60, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175824 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/1,
     /* 175827 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/0,
     /* 175830 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/30,
     /* 175833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 175835 */     GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 175838 */     GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175842 */     GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175847 */     GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/59,
     /* 175850 */     GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/60,
     /* 175853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 175855 */     GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s32,
     /* 175858 */     GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175862 */     GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175867 */     GIR_AddImm, /*InsnID*/58, /*Imm*/GIMT_Encode8(21845),
     /* 175877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 175879 */     GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s32,
     /* 175882 */     GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175886 */     GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175891 */     GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/57,
     /* 175894 */     GIR_AddImm, /*InsnID*/57, /*Imm*/GIMT_Encode8(21845),
     /* 175904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/57,
     /* 175906 */     GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s32,
     /* 175909 */     GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175913 */     GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175918 */     GIR_Copy, /*NewInsnID*/56, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175922 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 175925 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/1,
     /* 175928 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 175931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 175933 */     GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s32,
     /* 175936 */     GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175940 */     GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175945 */     GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/55,
     /* 175948 */     GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/56,
     /* 175951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 175953 */     GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s32,
     /* 175956 */     GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175960 */     GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175965 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 175968 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/58,
     /* 175971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 175973 */     GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s32,
     /* 175976 */     GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175980 */     GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175985 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/53,
     /* 175988 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/2,
     /* 175991 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/0,
     /* 175994 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/29,
     /* 175997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 175999 */     GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s32,
     /* 176002 */     GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176006 */     GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176011 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 176014 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/62,
     /* 176017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 176019 */     GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 176022 */     GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176026 */     GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176031 */     GIR_AddImm, /*InsnID*/51, /*Imm*/GIMT_Encode8(13107),
     /* 176041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 176043 */     GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 176046 */     GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176050 */     GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176055 */     GIR_AddSimpleTempRegister, /*InsnID*/50, /*TempRegID*/50,
     /* 176058 */     GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(13107),
     /* 176068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 176070 */     GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s32,
     /* 176073 */     GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176077 */     GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176082 */     GIR_AddImm, /*InsnID*/49, /*Imm*/GIMT_Encode8(43690),
     /* 176092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 176094 */     GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s32,
     /* 176097 */     GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176101 */     GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176106 */     GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
     /* 176109 */     GIR_AddImm, /*InsnID*/48, /*Imm*/GIMT_Encode8(43690),
     /* 176119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
     /* 176121 */     GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s32,
     /* 176124 */     GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176128 */     GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176133 */     GIR_Copy, /*NewInsnID*/47, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176137 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/1,
     /* 176140 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/0,
     /* 176143 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/30,
     /* 176146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 176148 */     GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s32,
     /* 176151 */     GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176155 */     GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176160 */     GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/46,
     /* 176163 */     GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/47,
     /* 176166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 176168 */     GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s32,
     /* 176171 */     GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176175 */     GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176180 */     GIR_AddImm, /*InsnID*/45, /*Imm*/GIMT_Encode8(21845),
     /* 176190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 176192 */     GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s32,
     /* 176195 */     GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176199 */     GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176204 */     GIR_AddSimpleTempRegister, /*InsnID*/44, /*TempRegID*/44,
     /* 176207 */     GIR_AddImm, /*InsnID*/44, /*Imm*/GIMT_Encode8(21845),
     /* 176217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 176219 */     GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s32,
     /* 176222 */     GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176226 */     GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176231 */     GIR_Copy, /*NewInsnID*/43, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176235 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/31,
     /* 176238 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/1,
     /* 176241 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/31,
     /* 176244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 176246 */     GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s32,
     /* 176249 */     GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176253 */     GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176258 */     GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/42,
     /* 176261 */     GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/43,
     /* 176264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 176266 */     GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s32,
     /* 176269 */     GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176273 */     GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176278 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 176281 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/45,
     /* 176284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 176286 */     GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s32,
     /* 176289 */     GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176293 */     GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176298 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 176301 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/30,
     /* 176304 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/2,
     /* 176307 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/31,
     /* 176310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 176312 */     GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 176315 */     GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176319 */     GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176324 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
     /* 176327 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/49,
     /* 176330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 176332 */     GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 176335 */     GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176339 */     GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176344 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 176347 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/51,
     /* 176350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 176352 */     GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s32,
     /* 176355 */     GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176359 */     GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176364 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
     /* 176367 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/4,
     /* 176370 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/0,
     /* 176373 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/27,
     /* 176376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 176378 */     GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s32,
     /* 176381 */     GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176385 */     GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176390 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 176393 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/64,
     /* 176396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
     /* 176398 */     GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s32,
     /* 176401 */     GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176405 */     GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176410 */     GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(3855),
     /* 176420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 176422 */     GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s32,
     /* 176425 */     GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176429 */     GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176434 */     GIR_AddSimpleTempRegister, /*InsnID*/34, /*TempRegID*/34,
     /* 176437 */     GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(3855),
     /* 176447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 176449 */     GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s32,
     /* 176452 */     GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176456 */     GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176461 */     GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(52428),
     /* 176471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 176473 */     GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 176476 */     GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176480 */     GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176485 */     GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
     /* 176488 */     GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(52428),
     /* 176498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 176500 */     GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 176503 */     GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176507 */     GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176512 */     GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(43690),
     /* 176522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 176524 */     GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s32,
     /* 176527 */     GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176531 */     GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176536 */     GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
     /* 176539 */     GIR_AddImm, /*InsnID*/30, /*Imm*/GIMT_Encode8(43690),
     /* 176549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 176551 */     GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s32,
     /* 176554 */     GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176558 */     GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176563 */     GIR_Copy, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176567 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/1,
     /* 176570 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/0,
     /* 176573 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/30,
     /* 176576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
     /* 176578 */     GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s32,
     /* 176581 */     GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176585 */     GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176590 */     GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
     /* 176593 */     GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/29,
     /* 176596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 176598 */     GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s32,
     /* 176601 */     GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176605 */     GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176610 */     GIR_AddImm, /*InsnID*/27, /*Imm*/GIMT_Encode8(21845),
     /* 176620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 176622 */     GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s32,
     /* 176625 */     GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176629 */     GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176634 */     GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
     /* 176637 */     GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(21845),
     /* 176647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 176649 */     GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s32,
     /* 176652 */     GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176656 */     GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176661 */     GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176665 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/31,
     /* 176668 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/1,
     /* 176671 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/31,
     /* 176674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 176676 */     GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s32,
     /* 176679 */     GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176683 */     GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176688 */     GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
     /* 176691 */     GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/25,
     /* 176694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 176696 */     GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 176699 */     GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176703 */     GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176708 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
     /* 176711 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/27,
     /* 176714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 176716 */     GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 176719 */     GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176723 */     GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176728 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 176731 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/2,
     /* 176734 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
     /* 176737 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/29,
     /* 176740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 176742 */     GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s32,
     /* 176745 */     GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176749 */     GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176754 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/21,
     /* 176757 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/31,
     /* 176760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 176762 */     GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s32,
     /* 176765 */     GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176769 */     GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176774 */     GIR_AddImm, /*InsnID*/20, /*Imm*/GIMT_Encode8(13107),
     /* 176784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
     /* 176786 */     GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s32,
     /* 176789 */     GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176793 */     GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176798 */     GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
     /* 176801 */     GIR_AddImm, /*InsnID*/19, /*Imm*/GIMT_Encode8(13107),
     /* 176811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 176813 */     GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s32,
     /* 176816 */     GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176820 */     GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176825 */     GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(43690),
     /* 176835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 176837 */     GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s32,
     /* 176840 */     GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176844 */     GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176849 */     GIR_AddSimpleTempRegister, /*InsnID*/17, /*TempRegID*/17,
     /* 176852 */     GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(43690),
     /* 176862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 176864 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 176867 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176871 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176876 */     GIR_Copy, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176880 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
     /* 176883 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
     /* 176886 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/30,
     /* 176889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 176891 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 176894 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176898 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176903 */     GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
     /* 176906 */     GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/16,
     /* 176909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 176911 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s32,
     /* 176914 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176918 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176923 */     GIR_AddImm, /*InsnID*/14, /*Imm*/GIMT_Encode8(21845),
     /* 176933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 176935 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 176938 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176942 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176947 */     GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
     /* 176950 */     GIR_AddImm, /*InsnID*/13, /*Imm*/GIMT_Encode8(21845),
     /* 176960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 176962 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 176965 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176969 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176974 */     GIR_Copy, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176978 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/31,
     /* 176981 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/1,
     /* 176984 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/31,
     /* 176987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 176989 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /* 176992 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176996 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177001 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 177004 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/12,
     /* 177007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 177009 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /* 177012 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177016 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177021 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 177024 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/14,
     /* 177027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 177029 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /* 177032 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177036 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177041 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 177044 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/30,
     /* 177047 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/2,
     /* 177050 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/31,
     /* 177053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 177055 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 177058 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177062 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177067 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 177070 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/18,
     /* 177073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 177075 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 177078 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177082 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177087 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 177090 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/20,
     /* 177093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 177095 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 177098 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177102 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177107 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 177110 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/28,
     /* 177113 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/4,
     /* 177116 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
     /* 177119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 177121 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 177124 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177128 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177133 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 177136 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/33,
     /* 177139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 177141 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 177144 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177148 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177153 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 177156 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/35,
     /* 177159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 177161 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 177164 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177168 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177173 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 177176 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/24,
     /* 177179 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 177182 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/31,
     /* 177185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 177187 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177190 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 177194 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177199 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 177202 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/66,
     /* 177205 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
     /* 177208 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
     /* 177211 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 177214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 177216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 177223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177228 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 177231 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 177235 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 177238 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 177241 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 177244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32),
     /* 177249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 177251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 177260 */     GIR_RootConstrainSelectedInstOperands,
     /* 177261 */     // GIR_Coverage, 4881,
     /* 177261 */     GIR_EraseRootFromParent_Done,
     /* 177262 */   // Label 2761: @177262
     /* 177262 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(182387), // Rule ID 4882 //
     /* 177267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In32BitMode),
     /* 177270 */     // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$A)  =>  (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] })
     /* 177270 */     GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177274 */     GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177279 */     GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177286 */     GIR_AddImm, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 177297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 191(*/0xBF, 0x01/*)*/,
     /* 177300 */     GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177304 */     GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177309 */     GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177316 */     GIR_AddSimpleTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 177321 */     GIR_AddImm, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 177332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 177335 */     GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177339 */     GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177344 */     GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177351 */     GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 177362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 177365 */     GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177369 */     GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177374 */     GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177381 */     GIR_AddSimpleTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 177386 */     GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 177397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 177400 */     GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177404 */     GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177409 */     GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177416 */     GIR_AddImm, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 177427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 177430 */     GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177434 */     GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177439 */     GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177446 */     GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 177451 */     GIR_AddImm, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 177462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 177465 */     GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177469 */     GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177474 */     GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177481 */     GIR_Copy, /*NewInsnID*//* 185(*/0xB9, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177486 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/1,
     /* 177490 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/0,
     /* 177494 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/30,
     /* 177498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 177501 */     GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177505 */     GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177510 */     GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177517 */     GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 177522 */     GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 177527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 177530 */     GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177534 */     GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177539 */     GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177546 */     GIR_AddImm, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 177557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 177560 */     GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177564 */     GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177569 */     GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177576 */     GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 177581 */     GIR_AddImm, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 177592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 182(*/0xB6, 0x01/*)*/,
     /* 177595 */     GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177599 */     GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177604 */     GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177611 */     GIR_Copy, /*NewInsnID*//* 181(*/0xB5, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177616 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 177620 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/1,
     /* 177624 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 177628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 177631 */     GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177635 */     GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177640 */     GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177647 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 177652 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 177657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 177660 */     GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177664 */     GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177669 */     GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177676 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 177681 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 177686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 177689 */     GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177693 */     GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177698 */     GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177705 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 177710 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/2,
     /* 177714 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/0,
     /* 177718 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/29,
     /* 177722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 177725 */     GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177729 */     GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177734 */     GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177741 */     GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 177746 */     GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 177751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 177754 */     GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177758 */     GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177763 */     GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177770 */     GIR_AddImm, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 177781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 177784 */     GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177788 */     GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177793 */     GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177800 */     GIR_AddSimpleTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 177805 */     GIR_AddImm, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 177816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 177819 */     GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177823 */     GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177828 */     GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177835 */     GIR_AddImm, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 177846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 177849 */     GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177853 */     GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177858 */     GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177865 */     GIR_AddSimpleTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 177870 */     GIR_AddImm, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 177881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 177884 */     GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177888 */     GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177893 */     GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177900 */     GIR_Copy, /*NewInsnID*//* 172(*/0xAC, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177905 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/1,
     /* 177909 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/0,
     /* 177913 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/30,
     /* 177917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 177920 */     GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177924 */     GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177929 */     GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177936 */     GIR_AddSimpleTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 177941 */     GIR_AddSimpleTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 177946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 177949 */     GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177953 */     GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177958 */     GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177965 */     GIR_AddImm, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 177976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 170(*/0xAA, 0x01/*)*/,
     /* 177979 */     GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177983 */     GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177988 */     GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177995 */     GIR_AddSimpleTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 178000 */     GIR_AddImm, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 178014 */     GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178018 */     GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178023 */     GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178030 */     GIR_Copy, /*NewInsnID*//* 168(*/0xA8, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178035 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/31,
     /* 178039 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/1,
     /* 178043 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/31,
     /* 178047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 178050 */     GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178054 */     GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178059 */     GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178066 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 178071 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 178076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 178079 */     GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178083 */     GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178088 */     GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178095 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 178100 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 178105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 178108 */     GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178112 */     GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178117 */     GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178124 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 178129 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/30,
     /* 178133 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/2,
     /* 178137 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/31,
     /* 178141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 178144 */     GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178148 */     GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178153 */     GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178160 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 178165 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 178170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 178173 */     GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178177 */     GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178182 */     GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178189 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 178194 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 178199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 163(*/0xA3, 0x01/*)*/,
     /* 178202 */     GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178206 */     GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178211 */     GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178218 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 178223 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/4,
     /* 178227 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/0,
     /* 178231 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/27,
     /* 178235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 178238 */     GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178242 */     GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178247 */     GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178254 */     GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 178259 */     GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 178264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 178267 */     GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178271 */     GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178276 */     GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178283 */     GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 178294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 178297 */     GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178301 */     GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178306 */     GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178313 */     GIR_AddSimpleTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 178318 */     GIR_AddImm, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 178329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 178332 */     GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178336 */     GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178341 */     GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178348 */     GIR_AddImm, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 178359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 178362 */     GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178366 */     GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178371 */     GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178378 */     GIR_AddSimpleTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 178383 */     GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 178394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 178397 */     GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178401 */     GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178406 */     GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178413 */     GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 178427 */     GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178431 */     GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178436 */     GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178443 */     GIR_AddSimpleTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 178448 */     GIR_AddImm, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 178462 */     GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178466 */     GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178471 */     GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178478 */     GIR_Copy, /*NewInsnID*//* 154(*/0x9A, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178483 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/1,
     /* 178487 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/0,
     /* 178491 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/30,
     /* 178495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 154(*/0x9A, 0x01/*)*/,
     /* 178498 */     GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178502 */     GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178507 */     GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178514 */     GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 178519 */     GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 178524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 178527 */     GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178531 */     GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178536 */     GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178543 */     GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 178557 */     GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178561 */     GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178566 */     GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178573 */     GIR_AddSimpleTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 178578 */     GIR_AddImm, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 178592 */     GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178596 */     GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178601 */     GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178608 */     GIR_Copy, /*NewInsnID*//* 150(*/0x96, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178613 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/31,
     /* 178617 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/1,
     /* 178621 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/31,
     /* 178625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 178628 */     GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178632 */     GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178637 */     GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178644 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 178649 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 178654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 178657 */     GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178661 */     GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178666 */     GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178673 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 178678 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 178683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 178686 */     GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178690 */     GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178695 */     GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178702 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 178707 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/2,
     /* 178711 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/0,
     /* 178715 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/29,
     /* 178719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 178722 */     GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178726 */     GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178731 */     GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178738 */     GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 178743 */     GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 178748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 178751 */     GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178755 */     GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178760 */     GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178767 */     GIR_AddImm, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 178778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 178781 */     GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178785 */     GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178790 */     GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178797 */     GIR_AddSimpleTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 178802 */     GIR_AddImm, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 178813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 178816 */     GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178820 */     GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178825 */     GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178832 */     GIR_AddImm, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 178846 */     GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178850 */     GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178855 */     GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178862 */     GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 178867 */     GIR_AddImm, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 178881 */     GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178885 */     GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178890 */     GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178897 */     GIR_Copy, /*NewInsnID*//* 141(*/0x8D, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178902 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/1,
     /* 178906 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/0,
     /* 178910 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/30,
     /* 178914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 141(*/0x8D, 0x01/*)*/,
     /* 178917 */     GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178921 */     GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178926 */     GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178933 */     GIR_AddSimpleTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 178938 */     GIR_AddSimpleTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/,
     /* 178943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 178946 */     GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178950 */     GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178955 */     GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178962 */     GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 178976 */     GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178980 */     GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178985 */     GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178992 */     GIR_AddSimpleTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 178997 */     GIR_AddImm, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 179008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 179011 */     GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179015 */     GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179020 */     GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179027 */     GIR_Copy, /*NewInsnID*//* 137(*/0x89, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179032 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/31,
     /* 179036 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/1,
     /* 179040 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/31,
     /* 179044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 137(*/0x89, 0x01/*)*/,
     /* 179047 */     GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179051 */     GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179056 */     GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179063 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 179068 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 179073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 179076 */     GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179080 */     GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179085 */     GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179092 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 179097 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 179102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 179105 */     GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179109 */     GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179114 */     GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179121 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 179126 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/30,
     /* 179130 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/2,
     /* 179134 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/31,
     /* 179138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 179141 */     GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179145 */     GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179150 */     GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179157 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 179162 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 179167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 179170 */     GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179174 */     GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179179 */     GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179186 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 179191 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 179196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 179199 */     GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179203 */     GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179208 */     GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179215 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 179220 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/28,
     /* 179224 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/4,
     /* 179228 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/31,
     /* 179232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 179235 */     GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179239 */     GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179244 */     GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179251 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 179256 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 179261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 130(*/0x82, 0x01/*)*/,
     /* 179264 */     GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179268 */     GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179273 */     GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179280 */     GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 179285 */     GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 179290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 179293 */     GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s32,
     /* 179296 */     GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179301 */     GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179307 */     GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 179318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 179321 */     GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s32,
     /* 179324 */     GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179328 */     GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179333 */     GIR_AddSimpleTempRegister, /*InsnID*/127, /*TempRegID*/127,
     /* 179336 */     GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(61680),
     /* 179346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 179348 */     GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 179351 */     GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179355 */     GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179360 */     GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(52428),
     /* 179370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 179372 */     GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 179375 */     GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179379 */     GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179384 */     GIR_AddSimpleTempRegister, /*InsnID*/125, /*TempRegID*/125,
     /* 179387 */     GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(52428),
     /* 179397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 179399 */     GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s32,
     /* 179402 */     GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179406 */     GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179411 */     GIR_AddImm, /*InsnID*/124, /*Imm*/GIMT_Encode8(43690),
     /* 179421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 179423 */     GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s32,
     /* 179426 */     GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179430 */     GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179435 */     GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/123,
     /* 179438 */     GIR_AddImm, /*InsnID*/123, /*Imm*/GIMT_Encode8(43690),
     /* 179448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/123,
     /* 179450 */     GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s32,
     /* 179453 */     GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179457 */     GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179462 */     GIR_Copy, /*NewInsnID*/122, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179466 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/1,
     /* 179469 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/0,
     /* 179472 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/30,
     /* 179475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 179477 */     GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s32,
     /* 179480 */     GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179484 */     GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179489 */     GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/121,
     /* 179492 */     GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/122,
     /* 179495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 179497 */     GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s32,
     /* 179500 */     GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179504 */     GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179509 */     GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(21845),
     /* 179519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 179521 */     GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s32,
     /* 179524 */     GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179528 */     GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179533 */     GIR_AddSimpleTempRegister, /*InsnID*/119, /*TempRegID*/119,
     /* 179536 */     GIR_AddImm, /*InsnID*/119, /*Imm*/GIMT_Encode8(21845),
     /* 179546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 179548 */     GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s32,
     /* 179551 */     GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179555 */     GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179560 */     GIR_Copy, /*NewInsnID*/118, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179564 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/31,
     /* 179567 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/1,
     /* 179570 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/31,
     /* 179573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 179575 */     GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 179578 */     GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179582 */     GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179587 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/117,
     /* 179590 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/118,
     /* 179593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 179595 */     GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 179598 */     GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179602 */     GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179607 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 179610 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/120,
     /* 179613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 179615 */     GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s32,
     /* 179618 */     GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179622 */     GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179627 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/115,
     /* 179630 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/2,
     /* 179633 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/0,
     /* 179636 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/29,
     /* 179639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 179641 */     GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s32,
     /* 179644 */     GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179648 */     GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179653 */     GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/114,
     /* 179656 */     GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/124,
     /* 179659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/114,
     /* 179661 */     GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s32,
     /* 179664 */     GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179668 */     GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179673 */     GIR_AddImm, /*InsnID*/113, /*Imm*/GIMT_Encode8(13107),
     /* 179683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 179685 */     GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s32,
     /* 179688 */     GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179692 */     GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179697 */     GIR_AddSimpleTempRegister, /*InsnID*/112, /*TempRegID*/112,
     /* 179700 */     GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(13107),
     /* 179710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 179712 */     GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s32,
     /* 179715 */     GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179719 */     GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179724 */     GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(43690),
     /* 179734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 179736 */     GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s32,
     /* 179739 */     GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179743 */     GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179748 */     GIR_AddSimpleTempRegister, /*InsnID*/110, /*TempRegID*/110,
     /* 179751 */     GIR_AddImm, /*InsnID*/110, /*Imm*/GIMT_Encode8(43690),
     /* 179761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 179763 */     GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s32,
     /* 179766 */     GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179770 */     GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179775 */     GIR_Copy, /*NewInsnID*/109, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179779 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/1,
     /* 179782 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/0,
     /* 179785 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/30,
     /* 179788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 179790 */     GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s32,
     /* 179793 */     GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179797 */     GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179802 */     GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/108,
     /* 179805 */     GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/109,
     /* 179808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 179810 */     GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s32,
     /* 179813 */     GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179817 */     GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179822 */     GIR_AddImm, /*InsnID*/107, /*Imm*/GIMT_Encode8(21845),
     /* 179832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 179834 */     GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s32,
     /* 179837 */     GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179841 */     GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179846 */     GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/106,
     /* 179849 */     GIR_AddImm, /*InsnID*/106, /*Imm*/GIMT_Encode8(21845),
     /* 179859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 179861 */     GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 179864 */     GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179868 */     GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179873 */     GIR_Copy, /*NewInsnID*/105, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179877 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/31,
     /* 179880 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/1,
     /* 179883 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/31,
     /* 179886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 179888 */     GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 179891 */     GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179895 */     GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179900 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 179903 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/105,
     /* 179906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 179908 */     GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s32,
     /* 179911 */     GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179915 */     GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179920 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/103,
     /* 179923 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/107,
     /* 179926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 179928 */     GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s32,
     /* 179931 */     GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179935 */     GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179940 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 179943 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/30,
     /* 179946 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/2,
     /* 179949 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/31,
     /* 179952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/102,
     /* 179954 */     GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s32,
     /* 179957 */     GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179961 */     GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179966 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 179969 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/111,
     /* 179972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 179974 */     GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s32,
     /* 179977 */     GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179981 */     GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179986 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 179989 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/113,
     /* 179992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 179994 */     GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s32,
     /* 179997 */     GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180001 */     GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180006 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 180009 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/4,
     /* 180012 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/0,
     /* 180015 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/27,
     /* 180018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 180020 */     GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 180023 */     GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180027 */     GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180032 */     GIR_AddSimpleTempRegister, /*InsnID*/98, /*TempRegID*/98,
     /* 180035 */     GIR_AddSimpleTempRegister, /*InsnID*/98, /*TempRegID*/126,
     /* 180038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 180040 */     GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 180043 */     GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180047 */     GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180052 */     GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(3855),
     /* 180062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 180064 */     GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s32,
     /* 180067 */     GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180071 */     GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180076 */     GIR_AddSimpleTempRegister, /*InsnID*/96, /*TempRegID*/96,
     /* 180079 */     GIR_AddImm, /*InsnID*/96, /*Imm*/GIMT_Encode8(3855),
     /* 180089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 180091 */     GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s32,
     /* 180094 */     GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180098 */     GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180103 */     GIR_AddImm, /*InsnID*/95, /*Imm*/GIMT_Encode8(52428),
     /* 180113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/95,
     /* 180115 */     GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s32,
     /* 180118 */     GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180122 */     GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180127 */     GIR_AddSimpleTempRegister, /*InsnID*/94, /*TempRegID*/94,
     /* 180130 */     GIR_AddImm, /*InsnID*/94, /*Imm*/GIMT_Encode8(52428),
     /* 180140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 180142 */     GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s32,
     /* 180145 */     GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180149 */     GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180154 */     GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 180164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 180166 */     GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s32,
     /* 180169 */     GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180173 */     GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180178 */     GIR_AddSimpleTempRegister, /*InsnID*/92, /*TempRegID*/92,
     /* 180181 */     GIR_AddImm, /*InsnID*/92, /*Imm*/GIMT_Encode8(43690),
     /* 180191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 180193 */     GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s32,
     /* 180196 */     GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180200 */     GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180205 */     GIR_Copy, /*NewInsnID*/91, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180209 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/1,
     /* 180212 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/0,
     /* 180215 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/30,
     /* 180218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 180220 */     GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s32,
     /* 180223 */     GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180227 */     GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180232 */     GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/90,
     /* 180235 */     GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/91,
     /* 180238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 180240 */     GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 180243 */     GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180247 */     GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180252 */     GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 180262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 180264 */     GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 180267 */     GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180271 */     GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180276 */     GIR_AddSimpleTempRegister, /*InsnID*/88, /*TempRegID*/88,
     /* 180279 */     GIR_AddImm, /*InsnID*/88, /*Imm*/GIMT_Encode8(21845),
     /* 180289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 180291 */     GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s32,
     /* 180294 */     GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180298 */     GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180303 */     GIR_Copy, /*NewInsnID*/87, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180307 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/31,
     /* 180310 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/1,
     /* 180313 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/31,
     /* 180316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 180318 */     GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s32,
     /* 180321 */     GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180325 */     GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180330 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 180333 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/87,
     /* 180336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/86,
     /* 180338 */     GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s32,
     /* 180341 */     GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180345 */     GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180350 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 180353 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/89,
     /* 180356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 180358 */     GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s32,
     /* 180361 */     GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180365 */     GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180370 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 180373 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/2,
     /* 180376 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/0,
     /* 180379 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/29,
     /* 180382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 180384 */     GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s32,
     /* 180387 */     GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180391 */     GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180396 */     GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/83,
     /* 180399 */     GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/93,
     /* 180402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 180404 */     GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s32,
     /* 180407 */     GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180411 */     GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180416 */     GIR_AddImm, /*InsnID*/82, /*Imm*/GIMT_Encode8(13107),
     /* 180426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 180428 */     GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s32,
     /* 180431 */     GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180435 */     GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180440 */     GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/81,
     /* 180443 */     GIR_AddImm, /*InsnID*/81, /*Imm*/GIMT_Encode8(13107),
     /* 180453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 180455 */     GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s32,
     /* 180458 */     GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180462 */     GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180467 */     GIR_AddImm, /*InsnID*/80, /*Imm*/GIMT_Encode8(43690),
     /* 180477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 180479 */     GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s32,
     /* 180482 */     GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180486 */     GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180491 */     GIR_AddSimpleTempRegister, /*InsnID*/79, /*TempRegID*/79,
     /* 180494 */     GIR_AddImm, /*InsnID*/79, /*Imm*/GIMT_Encode8(43690),
     /* 180504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 180506 */     GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s32,
     /* 180509 */     GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180513 */     GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180518 */     GIR_Copy, /*NewInsnID*/78, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180522 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/1,
     /* 180525 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/0,
     /* 180528 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/30,
     /* 180531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 180533 */     GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s32,
     /* 180536 */     GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180540 */     GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180545 */     GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/77,
     /* 180548 */     GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/78,
     /* 180551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 180553 */     GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s32,
     /* 180556 */     GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180560 */     GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180565 */     GIR_AddImm, /*InsnID*/76, /*Imm*/GIMT_Encode8(21845),
     /* 180575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 180577 */     GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s32,
     /* 180580 */     GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180584 */     GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180589 */     GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*/75,
     /* 180592 */     GIR_AddImm, /*InsnID*/75, /*Imm*/GIMT_Encode8(21845),
     /* 180602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 180604 */     GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 180607 */     GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180611 */     GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180616 */     GIR_Copy, /*NewInsnID*/74, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180620 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/31,
     /* 180623 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/1,
     /* 180626 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/31,
     /* 180629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 180631 */     GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 180634 */     GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180638 */     GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180643 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 180646 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/74,
     /* 180649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 180651 */     GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s32,
     /* 180654 */     GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180658 */     GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180663 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/72,
     /* 180666 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/76,
     /* 180669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 180671 */     GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s32,
     /* 180674 */     GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180678 */     GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180683 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 180686 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/30,
     /* 180689 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/2,
     /* 180692 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/31,
     /* 180695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/71,
     /* 180697 */     GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s32,
     /* 180700 */     GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180704 */     GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180709 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 180712 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/80,
     /* 180715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 180717 */     GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s32,
     /* 180720 */     GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180724 */     GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180729 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 180732 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/82,
     /* 180735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 180737 */     GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s32,
     /* 180740 */     GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180744 */     GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180749 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 180752 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/28,
     /* 180755 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/4,
     /* 180758 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/31,
     /* 180761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 180763 */     GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 180766 */     GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180770 */     GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180775 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/67,
     /* 180778 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/95,
     /* 180781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 180783 */     GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 180786 */     GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180790 */     GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180795 */     GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/66,
     /* 180798 */     GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/97,
     /* 180801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 180803 */     GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s32,
     /* 180806 */     GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180810 */     GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180815 */     GIR_AddImm, /*InsnID*/65, /*Imm*/GIMT_Encode8(61680),
     /* 180825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 180827 */     GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s32,
     /* 180830 */     GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180834 */     GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180839 */     GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/64,
     /* 180842 */     GIR_AddImm, /*InsnID*/64, /*Imm*/GIMT_Encode8(61680),
     /* 180852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/64,
     /* 180854 */     GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s32,
     /* 180857 */     GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180861 */     GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180866 */     GIR_AddImm, /*InsnID*/63, /*Imm*/GIMT_Encode8(52428),
     /* 180876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 180878 */     GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s32,
     /* 180881 */     GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180885 */     GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180890 */     GIR_AddSimpleTempRegister, /*InsnID*/62, /*TempRegID*/62,
     /* 180893 */     GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(52428),
     /* 180903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 180905 */     GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s32,
     /* 180908 */     GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180912 */     GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180917 */     GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(43690),
     /* 180927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 180929 */     GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 180932 */     GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180936 */     GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180941 */     GIR_AddSimpleTempRegister, /*InsnID*/60, /*TempRegID*/60,
     /* 180944 */     GIR_AddImm, /*InsnID*/60, /*Imm*/GIMT_Encode8(43690),
     /* 180954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 180956 */     GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 180959 */     GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180963 */     GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180968 */     GIR_Copy, /*NewInsnID*/59, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180972 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/1,
     /* 180975 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/0,
     /* 180978 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/30,
     /* 180981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 180983 */     GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s32,
     /* 180986 */     GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180990 */     GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180995 */     GIR_AddSimpleTempRegister, /*InsnID*/58, /*TempRegID*/58,
     /* 180998 */     GIR_AddSimpleTempRegister, /*InsnID*/58, /*TempRegID*/59,
     /* 181001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 181003 */     GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s32,
     /* 181006 */     GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181010 */     GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181015 */     GIR_AddImm, /*InsnID*/57, /*Imm*/GIMT_Encode8(21845),
     /* 181025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/57,
     /* 181027 */     GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s32,
     /* 181030 */     GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181034 */     GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181039 */     GIR_AddSimpleTempRegister, /*InsnID*/56, /*TempRegID*/56,
     /* 181042 */     GIR_AddImm, /*InsnID*/56, /*Imm*/GIMT_Encode8(21845),
     /* 181052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 181054 */     GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s32,
     /* 181057 */     GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181061 */     GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181066 */     GIR_Copy, /*NewInsnID*/55, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181070 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/31,
     /* 181073 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/1,
     /* 181076 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/31,
     /* 181079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 181081 */     GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s32,
     /* 181084 */     GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181088 */     GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181093 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 181096 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/55,
     /* 181099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 181101 */     GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s32,
     /* 181104 */     GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181108 */     GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181113 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/53,
     /* 181116 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/57,
     /* 181119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 181121 */     GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s32,
     /* 181124 */     GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181128 */     GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181133 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 181136 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/2,
     /* 181139 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/0,
     /* 181142 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/29,
     /* 181145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 181147 */     GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 181150 */     GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181154 */     GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181159 */     GIR_AddSimpleTempRegister, /*InsnID*/51, /*TempRegID*/51,
     /* 181162 */     GIR_AddSimpleTempRegister, /*InsnID*/51, /*TempRegID*/61,
     /* 181165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 181167 */     GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 181170 */     GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181174 */     GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181179 */     GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(13107),
     /* 181189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 181191 */     GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s32,
     /* 181194 */     GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181198 */     GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181203 */     GIR_AddSimpleTempRegister, /*InsnID*/49, /*TempRegID*/49,
     /* 181206 */     GIR_AddImm, /*InsnID*/49, /*Imm*/GIMT_Encode8(13107),
     /* 181216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 181218 */     GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s32,
     /* 181221 */     GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181225 */     GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181230 */     GIR_AddImm, /*InsnID*/48, /*Imm*/GIMT_Encode8(43690),
     /* 181240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
     /* 181242 */     GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s32,
     /* 181245 */     GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181249 */     GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181254 */     GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
     /* 181257 */     GIR_AddImm, /*InsnID*/47, /*Imm*/GIMT_Encode8(43690),
     /* 181267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 181269 */     GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s32,
     /* 181272 */     GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181276 */     GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181281 */     GIR_Copy, /*NewInsnID*/46, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181285 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/1,
     /* 181288 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/0,
     /* 181291 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/30,
     /* 181294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 181296 */     GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s32,
     /* 181299 */     GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181303 */     GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181308 */     GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/45,
     /* 181311 */     GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/46,
     /* 181314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 181316 */     GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s32,
     /* 181319 */     GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181323 */     GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181328 */     GIR_AddImm, /*InsnID*/44, /*Imm*/GIMT_Encode8(21845),
     /* 181338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 181340 */     GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s32,
     /* 181343 */     GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181347 */     GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181352 */     GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
     /* 181355 */     GIR_AddImm, /*InsnID*/43, /*Imm*/GIMT_Encode8(21845),
     /* 181365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 181367 */     GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s32,
     /* 181370 */     GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181374 */     GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181379 */     GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181383 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/31,
     /* 181386 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/1,
     /* 181389 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/31,
     /* 181392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 181394 */     GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s32,
     /* 181397 */     GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181401 */     GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181406 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 181409 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/42,
     /* 181412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 181414 */     GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s32,
     /* 181417 */     GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181421 */     GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181426 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 181429 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/44,
     /* 181432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 181434 */     GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 181437 */     GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181441 */     GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181446 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
     /* 181449 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/30,
     /* 181452 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/2,
     /* 181455 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/31,
     /* 181458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 181460 */     GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 181463 */     GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181467 */     GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181472 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 181475 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/48,
     /* 181478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 181480 */     GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s32,
     /* 181483 */     GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181487 */     GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181492 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
     /* 181495 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/50,
     /* 181498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 181500 */     GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s32,
     /* 181503 */     GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181507 */     GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181512 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 181515 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/4,
     /* 181518 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/0,
     /* 181521 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/27,
     /* 181524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
     /* 181526 */     GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s32,
     /* 181529 */     GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181533 */     GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181538 */     GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
     /* 181541 */     GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/63,
     /* 181544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 181546 */     GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s32,
     /* 181549 */     GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181553 */     GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181558 */     GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(3855),
     /* 181568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 181570 */     GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s32,
     /* 181573 */     GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181577 */     GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181582 */     GIR_AddSimpleTempRegister, /*InsnID*/33, /*TempRegID*/33,
     /* 181585 */     GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(3855),
     /* 181595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 181597 */     GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 181600 */     GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181604 */     GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181609 */     GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(52428),
     /* 181619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 181621 */     GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 181624 */     GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181628 */     GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181633 */     GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
     /* 181636 */     GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(52428),
     /* 181646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 181648 */     GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s32,
     /* 181651 */     GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181655 */     GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181660 */     GIR_AddImm, /*InsnID*/30, /*Imm*/GIMT_Encode8(43690),
     /* 181670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 181672 */     GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s32,
     /* 181675 */     GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181679 */     GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181684 */     GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
     /* 181687 */     GIR_AddImm, /*InsnID*/29, /*Imm*/GIMT_Encode8(43690),
     /* 181697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
     /* 181699 */     GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s32,
     /* 181702 */     GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181706 */     GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181711 */     GIR_Copy, /*NewInsnID*/28, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181715 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/1,
     /* 181718 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/0,
     /* 181721 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/30,
     /* 181724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 181726 */     GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s32,
     /* 181729 */     GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181733 */     GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181738 */     GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/27,
     /* 181741 */     GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/28,
     /* 181744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 181746 */     GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s32,
     /* 181749 */     GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181753 */     GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181758 */     GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(21845),
     /* 181768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 181770 */     GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s32,
     /* 181773 */     GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181777 */     GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181782 */     GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
     /* 181785 */     GIR_AddImm, /*InsnID*/25, /*Imm*/GIMT_Encode8(21845),
     /* 181795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 181797 */     GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s32,
     /* 181800 */     GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181804 */     GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181809 */     GIR_Copy, /*NewInsnID*/24, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181813 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/31,
     /* 181816 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/1,
     /* 181819 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/31,
     /* 181822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 181824 */     GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 181827 */     GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181831 */     GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181836 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
     /* 181839 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/24,
     /* 181842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 181844 */     GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 181847 */     GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181851 */     GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181856 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 181859 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/26,
     /* 181862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 181864 */     GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s32,
     /* 181867 */     GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181871 */     GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181876 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/21,
     /* 181879 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/2,
     /* 181882 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/0,
     /* 181885 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/29,
     /* 181888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 181890 */     GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s32,
     /* 181893 */     GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181897 */     GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181902 */     GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
     /* 181905 */     GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/30,
     /* 181908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
     /* 181910 */     GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s32,
     /* 181913 */     GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181917 */     GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181922 */     GIR_AddImm, /*InsnID*/19, /*Imm*/GIMT_Encode8(13107),
     /* 181932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 181934 */     GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s32,
     /* 181937 */     GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181941 */     GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181946 */     GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
     /* 181949 */     GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(13107),
     /* 181959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 181961 */     GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s32,
     /* 181964 */     GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181968 */     GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181973 */     GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(43690),
     /* 181983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 181985 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 181988 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181992 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181997 */     GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
     /* 182000 */     GIR_AddImm, /*InsnID*/16, /*Imm*/GIMT_Encode8(43690),
     /* 182010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 182012 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 182015 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182019 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182024 */     GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182028 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/1,
     /* 182031 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/0,
     /* 182034 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/30,
     /* 182037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 182039 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s32,
     /* 182042 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182046 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182051 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 182054 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
     /* 182057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 182059 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 182062 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182066 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182071 */     GIR_AddImm, /*InsnID*/13, /*Imm*/GIMT_Encode8(21845),
     /* 182081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 182083 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 182086 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182090 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182095 */     GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
     /* 182098 */     GIR_AddImm, /*InsnID*/12, /*Imm*/GIMT_Encode8(21845),
     /* 182108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 182110 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /* 182113 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182117 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182122 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182126 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/31,
     /* 182129 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/1,
     /* 182132 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/31,
     /* 182135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 182137 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /* 182140 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182144 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182149 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 182152 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/11,
     /* 182155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 182157 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /* 182160 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182164 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182169 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 182172 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/13,
     /* 182175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 182177 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 182180 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182184 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182189 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 182192 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/30,
     /* 182195 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/2,
     /* 182198 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/31,
     /* 182201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 182203 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 182206 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182210 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182215 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 182218 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/17,
     /* 182221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 182223 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 182226 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182230 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182235 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 182238 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/19,
     /* 182241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 182243 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 182246 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182250 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182255 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 182258 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/28,
     /* 182261 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/4,
     /* 182264 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/31,
     /* 182267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 182269 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 182272 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182276 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182281 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 182284 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/32,
     /* 182287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 182289 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 182292 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182296 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182301 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 182304 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/34,
     /* 182307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 182309 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 182312 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182316 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182321 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 182324 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/24,
     /* 182327 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 182330 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 182333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 182342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 182350 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/65,
     /* 182353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 182356 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 182359 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 182362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 182367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 182369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 182376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 182379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/24,
     /* 182382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 182385 */     GIR_RootConstrainSelectedInstOperands,
     /* 182386 */     // GIR_Coverage, 4882,
     /* 182386 */     GIR_EraseRootFromParent_Done,
     /* 182387 */   // Label 2762: @182387
     /* 182387 */   GIM_Reject,
     /* 182388 */ // Label 2760: @182388
     /* 182388 */ GIM_Reject,
     /* 182389 */ // Label 2758: @182389
     /* 182389 */ GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(208079), // Rule ID 4883 //
     /* 182394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 182397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182401 */   // (bitreverse:{ *:[i64] } i64:{ *:[i64] }:$A)  =>  (OR8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] }))
     /* 182401 */   GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182405 */   GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182410 */   GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182417 */   GIR_AddImm, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 182431 */   GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182435 */   GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182440 */   GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182447 */   GIR_AddSimpleTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 182452 */   GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 182466 */   GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182470 */   GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182475 */   GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 182485 */   GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182489 */   GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182494 */   GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182501 */   GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 182506 */   GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 182511 */   GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/1,
     /* 182515 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182521 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182527 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 182533 */   GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182537 */   GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182542 */   GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182549 */   GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 182554 */   GIR_AddImm8, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Imm*/32,
     /* 182558 */   GIR_AddImm8, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Imm*/31,
     /* 182562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 182565 */   GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182569 */   GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 182574 */   GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182581 */   GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 182586 */   GIR_AddImm, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 182600 */   GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182604 */   GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 182609 */   GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182616 */   GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 182621 */   GIR_AddImm, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 182635 */   GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182639 */   GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182644 */   GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182651 */   GIR_AddImm, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 182662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 182665 */   GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182669 */   GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182674 */   GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182681 */   GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 182686 */   GIR_AddImm, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 182697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 182700 */   GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182704 */   GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182709 */   GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 182719 */   GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182723 */   GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182728 */   GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182735 */   GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 182740 */   GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 182745 */   GIR_AddImm8, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Imm*/1,
     /* 182749 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182755 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182761 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 182767 */   GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182771 */   GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182776 */   GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182783 */   GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 182788 */   GIR_AddImm8, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/32,
     /* 182792 */   GIR_AddImm8, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/31,
     /* 182796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 182799 */   GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s64,
     /* 182802 */   GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 182807 */   GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182813 */   GIR_AddSimpleTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 182818 */   GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 182829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 182832 */   GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s64,
     /* 182835 */   GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 182839 */   GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182844 */   GIR_AddSimpleTempRegister, /*InsnID*/127, /*TempRegID*/127,
     /* 182847 */   GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(52428),
     /* 182857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 182859 */   GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 182862 */   GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182866 */   GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182871 */   GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(43690),
     /* 182881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 182883 */   GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 182886 */   GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182890 */   GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182895 */   GIR_AddSimpleTempRegister, /*InsnID*/125, /*TempRegID*/125,
     /* 182898 */   GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(43690),
     /* 182908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 182910 */   GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s64,
     /* 182913 */   GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182917 */   GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 182924 */   GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s64,
     /* 182927 */   GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182931 */   GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182936 */   GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/123,
     /* 182939 */   GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/124,
     /* 182942 */   GIR_AddImm8, /*InsnID*/123, /*Imm*/1,
     /* 182945 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182950 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182955 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 182960 */   GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s64,
     /* 182963 */   GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182967 */   GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182972 */   GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/122,
     /* 182975 */   GIR_AddImm8, /*InsnID*/122, /*Imm*/32,
     /* 182978 */   GIR_AddImm8, /*InsnID*/122, /*Imm*/31,
     /* 182981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 182983 */   GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s64,
     /* 182986 */   GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 182990 */   GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182995 */   GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/121,
     /* 182998 */   GIR_AddImm, /*InsnID*/121, /*Imm*/GIMT_Encode8(43690),
     /* 183008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 183010 */   GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s64,
     /* 183013 */   GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183017 */   GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183022 */   GIR_AddSimpleTempRegister, /*InsnID*/120, /*TempRegID*/120,
     /* 183025 */   GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(43690),
     /* 183035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 183037 */   GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s64,
     /* 183040 */   GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183044 */   GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183049 */   GIR_Copy, /*NewInsnID*/119, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 183053 */   GIR_AddImm8, /*InsnID*/119, /*Imm*/1,
     /* 183056 */   GIR_AddImm8, /*InsnID*/119, /*Imm*/62,
     /* 183059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 183061 */   GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s64,
     /* 183064 */   GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183068 */   GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183073 */   GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/118,
     /* 183076 */   GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/119,
     /* 183079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 183081 */   GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 183084 */   GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183088 */   GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183093 */   GIR_AddImm, /*InsnID*/117, /*Imm*/GIMT_Encode8(21845),
     /* 183103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 183105 */   GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 183108 */   GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183112 */   GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183117 */   GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 183120 */   GIR_AddImm, /*InsnID*/116, /*Imm*/GIMT_Encode8(21845),
     /* 183130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 183132 */   GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s64,
     /* 183135 */   GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183139 */   GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 183146 */   GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s64,
     /* 183149 */   GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183153 */   GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183158 */   GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/114,
     /* 183161 */   GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/115,
     /* 183164 */   GIR_AddImm8, /*InsnID*/114, /*Imm*/1,
     /* 183167 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183172 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183177 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183182 */   GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s64,
     /* 183185 */   GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183189 */   GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183194 */   GIR_AddSimpleTempRegister, /*InsnID*/113, /*TempRegID*/113,
     /* 183197 */   GIR_AddImm8, /*InsnID*/113, /*Imm*/32,
     /* 183200 */   GIR_AddImm8, /*InsnID*/113, /*Imm*/31,
     /* 183203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 183205 */   GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s64,
     /* 183208 */   GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183212 */   GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183217 */   GIR_AddSimpleTempRegister, /*InsnID*/112, /*TempRegID*/112,
     /* 183220 */   GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(21845),
     /* 183230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 183232 */   GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s64,
     /* 183235 */   GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183239 */   GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183244 */   GIR_AddSimpleTempRegister, /*InsnID*/111, /*TempRegID*/111,
     /* 183247 */   GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(21845),
     /* 183257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 183259 */   GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s64,
     /* 183262 */   GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 183266 */   GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183271 */   GIR_Copy, /*NewInsnID*/110, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 183275 */   GIR_AddImm8, /*InsnID*/110, /*Imm*/63,
     /* 183278 */   GIR_AddImm8, /*InsnID*/110, /*Imm*/1,
     /* 183281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 183283 */   GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s64,
     /* 183286 */   GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183290 */   GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183295 */   GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/109,
     /* 183298 */   GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/110,
     /* 183301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 183303 */   GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s64,
     /* 183306 */   GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 183310 */   GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183315 */   GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/108,
     /* 183318 */   GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/117,
     /* 183321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 183323 */   GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s64,
     /* 183326 */   GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183330 */   GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183335 */   GIR_AddSimpleTempRegister, /*InsnID*/107, /*TempRegID*/107,
     /* 183338 */   GIR_AddImm8, /*InsnID*/107, /*Imm*/2,
     /* 183341 */   GIR_AddImm8, /*InsnID*/107, /*Imm*/61,
     /* 183344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 183346 */   GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s64,
     /* 183349 */   GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183353 */   GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183358 */   GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/106,
     /* 183361 */   GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/126,
     /* 183364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 183366 */   GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 183369 */   GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183373 */   GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183378 */   GIR_AddImm, /*InsnID*/105, /*Imm*/GIMT_Encode8(13107),
     /* 183388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 183390 */   GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 183393 */   GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183397 */   GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183402 */   GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 183405 */   GIR_AddImm, /*InsnID*/104, /*Imm*/GIMT_Encode8(13107),
     /* 183415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 183417 */   GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s64,
     /* 183420 */   GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183424 */   GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 183431 */   GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s64,
     /* 183434 */   GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183438 */   GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183443 */   GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 183446 */   GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/103,
     /* 183449 */   GIR_AddImm8, /*InsnID*/102, /*Imm*/1,
     /* 183452 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183457 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183462 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183467 */   GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s64,
     /* 183470 */   GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183474 */   GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183479 */   GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 183482 */   GIR_AddImm8, /*InsnID*/101, /*Imm*/32,
     /* 183485 */   GIR_AddImm8, /*InsnID*/101, /*Imm*/31,
     /* 183488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 183490 */   GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s64,
     /* 183493 */   GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183497 */   GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183502 */   GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 183505 */   GIR_AddImm, /*InsnID*/100, /*Imm*/GIMT_Encode8(13107),
     /* 183515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 183517 */   GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s64,
     /* 183520 */   GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183524 */   GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183529 */   GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 183532 */   GIR_AddImm, /*InsnID*/99, /*Imm*/GIMT_Encode8(13107),
     /* 183542 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 183544 */   GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 183547 */   GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183551 */   GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183556 */   GIR_AddImm, /*InsnID*/98, /*Imm*/GIMT_Encode8(43690),
     /* 183566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 183568 */   GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 183571 */   GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183575 */   GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183580 */   GIR_AddSimpleTempRegister, /*InsnID*/97, /*TempRegID*/97,
     /* 183583 */   GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(43690),
     /* 183593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 183595 */   GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s64,
     /* 183598 */   GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183602 */   GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 183609 */   GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s64,
     /* 183612 */   GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183616 */   GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183621 */   GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/95,
     /* 183624 */   GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/96,
     /* 183627 */   GIR_AddImm8, /*InsnID*/95, /*Imm*/1,
     /* 183630 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183635 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183640 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183645 */   GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s64,
     /* 183648 */   GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183652 */   GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183657 */   GIR_AddSimpleTempRegister, /*InsnID*/94, /*TempRegID*/94,
     /* 183660 */   GIR_AddImm8, /*InsnID*/94, /*Imm*/32,
     /* 183663 */   GIR_AddImm8, /*InsnID*/94, /*Imm*/31,
     /* 183666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 183668 */   GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s64,
     /* 183671 */   GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183675 */   GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183680 */   GIR_AddSimpleTempRegister, /*InsnID*/93, /*TempRegID*/93,
     /* 183683 */   GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 183693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 183695 */   GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s64,
     /* 183698 */   GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183702 */   GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183707 */   GIR_AddSimpleTempRegister, /*InsnID*/92, /*TempRegID*/92,
     /* 183710 */   GIR_AddImm, /*InsnID*/92, /*Imm*/GIMT_Encode8(43690),
     /* 183720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 183722 */   GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s64,
     /* 183725 */   GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183729 */   GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183734 */   GIR_Copy, /*NewInsnID*/91, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 183738 */   GIR_AddImm8, /*InsnID*/91, /*Imm*/1,
     /* 183741 */   GIR_AddImm8, /*InsnID*/91, /*Imm*/62,
     /* 183744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 183746 */   GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s64,
     /* 183749 */   GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183753 */   GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183758 */   GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/90,
     /* 183761 */   GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/91,
     /* 183764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 183766 */   GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 183769 */   GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183773 */   GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183778 */   GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 183788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 183790 */   GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 183793 */   GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183797 */   GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183802 */   GIR_AddSimpleTempRegister, /*InsnID*/88, /*TempRegID*/88,
     /* 183805 */   GIR_AddImm, /*InsnID*/88, /*Imm*/GIMT_Encode8(21845),
     /* 183815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 183817 */   GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s64,
     /* 183820 */   GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183824 */   GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 183831 */   GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s64,
     /* 183834 */   GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183838 */   GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183843 */   GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 183846 */   GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/87,
     /* 183849 */   GIR_AddImm8, /*InsnID*/86, /*Imm*/1,
     /* 183852 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183857 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183862 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183867 */   GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s64,
     /* 183870 */   GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183874 */   GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183879 */   GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 183882 */   GIR_AddImm8, /*InsnID*/85, /*Imm*/32,
     /* 183885 */   GIR_AddImm8, /*InsnID*/85, /*Imm*/31,
     /* 183888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 183890 */   GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s64,
     /* 183893 */   GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183897 */   GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183902 */   GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 183905 */   GIR_AddImm, /*InsnID*/84, /*Imm*/GIMT_Encode8(21845),
     /* 183915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 183917 */   GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s64,
     /* 183920 */   GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183924 */   GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183929 */   GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/83,
     /* 183932 */   GIR_AddImm, /*InsnID*/83, /*Imm*/GIMT_Encode8(21845),
     /* 183942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 183944 */   GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s64,
     /* 183947 */   GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 183951 */   GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183956 */   GIR_Copy, /*NewInsnID*/82, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 183960 */   GIR_AddImm8, /*InsnID*/82, /*Imm*/63,
     /* 183963 */   GIR_AddImm8, /*InsnID*/82, /*Imm*/1,
     /* 183966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 183968 */   GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s64,
     /* 183971 */   GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183975 */   GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183980 */   GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/81,
     /* 183983 */   GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/82,
     /* 183986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 183988 */   GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s64,
     /* 183991 */   GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 183995 */   GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184000 */   GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/80,
     /* 184003 */   GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/89,
     /* 184006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 184008 */   GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s64,
     /* 184011 */   GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 184015 */   GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184020 */   GIR_AddSimpleTempRegister, /*InsnID*/79, /*TempRegID*/79,
     /* 184023 */   GIR_AddImm8, /*InsnID*/79, /*Imm*/62,
     /* 184026 */   GIR_AddImm8, /*InsnID*/79, /*Imm*/2,
     /* 184029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 184031 */   GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s64,
     /* 184034 */   GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184038 */   GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184043 */   GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/78,
     /* 184046 */   GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/98,
     /* 184049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 184051 */   GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s64,
     /* 184054 */   GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 184058 */   GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184063 */   GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/77,
     /* 184066 */   GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/105,
     /* 184069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 184071 */   GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s64,
     /* 184074 */   GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184078 */   GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184083 */   GIR_AddSimpleTempRegister, /*InsnID*/76, /*TempRegID*/76,
     /* 184086 */   GIR_AddImm8, /*InsnID*/76, /*Imm*/4,
     /* 184089 */   GIR_AddImm8, /*InsnID*/76, /*Imm*/59,
     /* 184092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 184094 */   GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s64,
     /* 184097 */   GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184101 */   GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184106 */   GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*/75,
     /* 184109 */   GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 184113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 184115 */   GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 184118 */   GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184122 */   GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184127 */   GIR_AddImm, /*InsnID*/74, /*Imm*/GIMT_Encode8(3855),
     /* 184137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 184139 */   GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 184142 */   GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184146 */   GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184151 */   GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 184154 */   GIR_AddImm, /*InsnID*/73, /*Imm*/GIMT_Encode8(3855),
     /* 184164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 184166 */   GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s64,
     /* 184169 */   GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184173 */   GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 184180 */   GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s64,
     /* 184183 */   GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184187 */   GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184192 */   GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 184195 */   GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/72,
     /* 184198 */   GIR_AddImm8, /*InsnID*/71, /*Imm*/1,
     /* 184201 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184206 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184211 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184216 */   GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s64,
     /* 184219 */   GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184223 */   GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184228 */   GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 184231 */   GIR_AddImm8, /*InsnID*/70, /*Imm*/32,
     /* 184234 */   GIR_AddImm8, /*InsnID*/70, /*Imm*/31,
     /* 184237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 184239 */   GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s64,
     /* 184242 */   GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184246 */   GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184251 */   GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 184254 */   GIR_AddImm, /*InsnID*/69, /*Imm*/GIMT_Encode8(3855),
     /* 184264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 184266 */   GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s64,
     /* 184269 */   GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184273 */   GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184278 */   GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 184281 */   GIR_AddImm, /*InsnID*/68, /*Imm*/GIMT_Encode8(3855),
     /* 184291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 184293 */   GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 184296 */   GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184300 */   GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184305 */   GIR_AddImm, /*InsnID*/67, /*Imm*/GIMT_Encode8(52428),
     /* 184315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 184317 */   GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 184320 */   GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184324 */   GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184329 */   GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/66,
     /* 184332 */   GIR_AddImm, /*InsnID*/66, /*Imm*/GIMT_Encode8(52428),
     /* 184342 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 184344 */   GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s64,
     /* 184347 */   GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184351 */   GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 184358 */   GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s64,
     /* 184361 */   GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184365 */   GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184370 */   GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/64,
     /* 184373 */   GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/65,
     /* 184376 */   GIR_AddImm8, /*InsnID*/64, /*Imm*/1,
     /* 184379 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184384 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184389 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184394 */   GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s64,
     /* 184397 */   GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184401 */   GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184406 */   GIR_AddSimpleTempRegister, /*InsnID*/63, /*TempRegID*/63,
     /* 184409 */   GIR_AddImm8, /*InsnID*/63, /*Imm*/32,
     /* 184412 */   GIR_AddImm8, /*InsnID*/63, /*Imm*/31,
     /* 184415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 184417 */   GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s64,
     /* 184420 */   GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184424 */   GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184429 */   GIR_AddSimpleTempRegister, /*InsnID*/62, /*TempRegID*/62,
     /* 184432 */   GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(52428),
     /* 184442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 184444 */   GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s64,
     /* 184447 */   GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184451 */   GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184456 */   GIR_AddSimpleTempRegister, /*InsnID*/61, /*TempRegID*/61,
     /* 184459 */   GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(52428),
     /* 184469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 184471 */   GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 184474 */   GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184478 */   GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184483 */   GIR_AddImm, /*InsnID*/60, /*Imm*/GIMT_Encode8(43690),
     /* 184493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 184495 */   GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 184498 */   GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184502 */   GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184507 */   GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/59,
     /* 184510 */   GIR_AddImm, /*InsnID*/59, /*Imm*/GIMT_Encode8(43690),
     /* 184520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 184522 */   GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s64,
     /* 184525 */   GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184529 */   GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 184536 */   GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s64,
     /* 184539 */   GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184543 */   GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184548 */   GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/57,
     /* 184551 */   GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/58,
     /* 184554 */   GIR_AddImm8, /*InsnID*/57, /*Imm*/1,
     /* 184557 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184562 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184567 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184572 */   GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s64,
     /* 184575 */   GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184579 */   GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184584 */   GIR_AddSimpleTempRegister, /*InsnID*/56, /*TempRegID*/56,
     /* 184587 */   GIR_AddImm8, /*InsnID*/56, /*Imm*/32,
     /* 184590 */   GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 184593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 184595 */   GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s64,
     /* 184598 */   GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184602 */   GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184607 */   GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/55,
     /* 184610 */   GIR_AddImm, /*InsnID*/55, /*Imm*/GIMT_Encode8(43690),
     /* 184620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 184622 */   GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s64,
     /* 184625 */   GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184629 */   GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184634 */   GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 184637 */   GIR_AddImm, /*InsnID*/54, /*Imm*/GIMT_Encode8(43690),
     /* 184647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 184649 */   GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s64,
     /* 184652 */   GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184656 */   GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184661 */   GIR_Copy, /*NewInsnID*/53, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 184665 */   GIR_AddImm8, /*InsnID*/53, /*Imm*/1,
     /* 184668 */   GIR_AddImm8, /*InsnID*/53, /*Imm*/62,
     /* 184671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 184673 */   GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s64,
     /* 184676 */   GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184680 */   GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184685 */   GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 184688 */   GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/53,
     /* 184691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 184693 */   GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 184696 */   GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184700 */   GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184705 */   GIR_AddImm, /*InsnID*/51, /*Imm*/GIMT_Encode8(21845),
     /* 184715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 184717 */   GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 184720 */   GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184724 */   GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184729 */   GIR_AddSimpleTempRegister, /*InsnID*/50, /*TempRegID*/50,
     /* 184732 */   GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(21845),
     /* 184742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 184744 */   GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s64,
     /* 184747 */   GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184751 */   GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 184758 */   GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s64,
     /* 184761 */   GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184765 */   GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184770 */   GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
     /* 184773 */   GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
     /* 184776 */   GIR_AddImm8, /*InsnID*/48, /*Imm*/1,
     /* 184779 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184784 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184789 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184794 */   GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s64,
     /* 184797 */   GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184801 */   GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184806 */   GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
     /* 184809 */   GIR_AddImm8, /*InsnID*/47, /*Imm*/32,
     /* 184812 */   GIR_AddImm8, /*InsnID*/47, /*Imm*/31,
     /* 184815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 184817 */   GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s64,
     /* 184820 */   GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184824 */   GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184829 */   GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/46,
     /* 184832 */   GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(21845),
     /* 184842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 184844 */   GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s64,
     /* 184847 */   GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184851 */   GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184856 */   GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/45,
     /* 184859 */   GIR_AddImm, /*InsnID*/45, /*Imm*/GIMT_Encode8(21845),
     /* 184869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 184871 */   GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s64,
     /* 184874 */   GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 184878 */   GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184883 */   GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 184887 */   GIR_AddImm8, /*InsnID*/44, /*Imm*/63,
     /* 184890 */   GIR_AddImm8, /*InsnID*/44, /*Imm*/1,
     /* 184893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 184895 */   GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s64,
     /* 184898 */   GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184902 */   GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184907 */   GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
     /* 184910 */   GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
     /* 184913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 184915 */   GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s64,
     /* 184918 */   GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 184922 */   GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184927 */   GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/42,
     /* 184930 */   GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/51,
     /* 184933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 184935 */   GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s64,
     /* 184938 */   GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184942 */   GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184947 */   GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 184950 */   GIR_AddImm8, /*InsnID*/41, /*Imm*/2,
     /* 184953 */   GIR_AddImm8, /*InsnID*/41, /*Imm*/61,
     /* 184956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 184958 */   GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s64,
     /* 184961 */   GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184965 */   GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184970 */   GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 184973 */   GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/60,
     /* 184976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 184978 */   GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 184981 */   GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184985 */   GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184990 */   GIR_AddImm, /*InsnID*/39, /*Imm*/GIMT_Encode8(13107),
     /* 185000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 185002 */   GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 185005 */   GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185009 */   GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185014 */   GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 185017 */   GIR_AddImm, /*InsnID*/38, /*Imm*/GIMT_Encode8(13107),
     /* 185027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 185029 */   GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s64,
     /* 185032 */   GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185036 */   GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 185043 */   GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s64,
     /* 185046 */   GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185050 */   GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185055 */   GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 185058 */   GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/37,
     /* 185061 */   GIR_AddImm8, /*InsnID*/36, /*Imm*/1,
     /* 185064 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185069 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185074 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185079 */   GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s64,
     /* 185082 */   GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185086 */   GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185091 */   GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
     /* 185094 */   GIR_AddImm8, /*InsnID*/35, /*Imm*/32,
     /* 185097 */   GIR_AddImm8, /*InsnID*/35, /*Imm*/31,
     /* 185100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 185102 */   GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s64,
     /* 185105 */   GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185109 */   GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185114 */   GIR_AddSimpleTempRegister, /*InsnID*/34, /*TempRegID*/34,
     /* 185117 */   GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(13107),
     /* 185127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 185129 */   GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s64,
     /* 185132 */   GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185136 */   GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185141 */   GIR_AddSimpleTempRegister, /*InsnID*/33, /*TempRegID*/33,
     /* 185144 */   GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(13107),
     /* 185154 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 185156 */   GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 185159 */   GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185163 */   GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185168 */   GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(43690),
     /* 185178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 185180 */   GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 185183 */   GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185187 */   GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185192 */   GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
     /* 185195 */   GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(43690),
     /* 185205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 185207 */   GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s64,
     /* 185210 */   GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185214 */   GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 185221 */   GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s64,
     /* 185224 */   GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185228 */   GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185233 */   GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
     /* 185236 */   GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/30,
     /* 185239 */   GIR_AddImm8, /*InsnID*/29, /*Imm*/1,
     /* 185242 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185247 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185252 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185257 */   GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s64,
     /* 185260 */   GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185264 */   GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185269 */   GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
     /* 185272 */   GIR_AddImm8, /*InsnID*/28, /*Imm*/32,
     /* 185275 */   GIR_AddImm8, /*InsnID*/28, /*Imm*/31,
     /* 185278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 185280 */   GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s64,
     /* 185283 */   GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185287 */   GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185292 */   GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/27,
     /* 185295 */   GIR_AddImm, /*InsnID*/27, /*Imm*/GIMT_Encode8(43690),
     /* 185305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 185307 */   GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s64,
     /* 185310 */   GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185314 */   GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185319 */   GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
     /* 185322 */   GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(43690),
     /* 185332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 185334 */   GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s64,
     /* 185337 */   GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185341 */   GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185346 */   GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 185350 */   GIR_AddImm8, /*InsnID*/25, /*Imm*/1,
     /* 185353 */   GIR_AddImm8, /*InsnID*/25, /*Imm*/62,
     /* 185356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 185358 */   GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s64,
     /* 185361 */   GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185365 */   GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185370 */   GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
     /* 185373 */   GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/25,
     /* 185376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 185378 */   GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 185381 */   GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185385 */   GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185390 */   GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(21845),
     /* 185400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 185402 */   GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 185405 */   GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185409 */   GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185414 */   GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 185417 */   GIR_AddImm, /*InsnID*/22, /*Imm*/GIMT_Encode8(21845),
     /* 185427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 185429 */   GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s64,
     /* 185432 */   GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185436 */   GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 185443 */   GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s64,
     /* 185446 */   GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185450 */   GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185455 */   GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
     /* 185458 */   GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
     /* 185461 */   GIR_AddImm8, /*InsnID*/20, /*Imm*/1,
     /* 185464 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185469 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185474 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185479 */   GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s64,
     /* 185482 */   GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185486 */   GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185491 */   GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
     /* 185494 */   GIR_AddImm8, /*InsnID*/19, /*Imm*/32,
     /* 185497 */   GIR_AddImm8, /*InsnID*/19, /*Imm*/31,
     /* 185500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 185502 */   GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s64,
     /* 185505 */   GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185509 */   GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185514 */   GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
     /* 185517 */   GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(21845),
     /* 185527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 185529 */   GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s64,
     /* 185532 */   GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185536 */   GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185541 */   GIR_AddSimpleTempRegister, /*InsnID*/17, /*TempRegID*/17,
     /* 185544 */   GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(21845),
     /* 185554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 185556 */   GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s64,
     /* 185559 */   GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185563 */   GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185568 */   GIR_Copy, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 185572 */   GIR_AddImm8, /*InsnID*/16, /*Imm*/63,
     /* 185575 */   GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
     /* 185578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 185580 */   GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s64,
     /* 185583 */   GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185587 */   GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185592 */   GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
     /* 185595 */   GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/16,
     /* 185598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 185600 */   GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s64,
     /* 185603 */   GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185607 */   GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185612 */   GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 185615 */   GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/23,
     /* 185618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 185620 */   GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s64,
     /* 185623 */   GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185627 */   GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185632 */   GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
     /* 185635 */   GIR_AddImm8, /*InsnID*/13, /*Imm*/62,
     /* 185638 */   GIR_AddImm8, /*InsnID*/13, /*Imm*/2,
     /* 185641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 185643 */   GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s64,
     /* 185646 */   GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185650 */   GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185655 */   GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
     /* 185658 */   GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/32,
     /* 185661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 185663 */   GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s64,
     /* 185666 */   GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185670 */   GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185675 */   GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 185678 */   GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/39,
     /* 185681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 185683 */   GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s64,
     /* 185686 */   GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185690 */   GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185695 */   GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 185698 */   GIR_AddImm8, /*InsnID*/10, /*Imm*/60,
     /* 185701 */   GIR_AddImm8, /*InsnID*/10, /*Imm*/4,
     /* 185704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 185706 */   GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s64,
     /* 185709 */   GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185713 */   GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185718 */   GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 185721 */   GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/67,
     /* 185724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 185726 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s64,
     /* 185729 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185733 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185738 */   GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 185741 */   GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/74,
     /* 185744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 185746 */   GIR_MakeTempReg, /*TempRegID*//* 273(*/0x91, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 185750 */   GIR_BuildMI, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185755 */   GIR_AddTempRegister, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*TempRegID*//* 273(*/0x91, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185762 */   GIR_AddImm, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 185773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 274(*/0x92, 0x02/*)*/,
     /* 185776 */   GIR_MakeTempReg, /*TempRegID*//* 272(*/0x90, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 185780 */   GIR_BuildMI, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185785 */   GIR_AddTempRegister, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*TempRegID*//* 272(*/0x90, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185792 */   GIR_AddSimpleTempRegister, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*TempRegID*//* 273(*/0x91, 0x02/*)*/,
     /* 185797 */   GIR_AddImm, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 185808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 273(*/0x91, 0x02/*)*/,
     /* 185811 */   GIR_MakeTempReg, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 185815 */   GIR_BuildMI, /*InsnID*//* 272(*/0x90, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185820 */   GIR_AddTempRegister, /*InsnID*//* 272(*/0x90, 0x02/*)*/, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 272(*/0x90, 0x02/*)*/,
     /* 185830 */   GIR_MakeTempReg, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 185834 */   GIR_BuildMI, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185839 */   GIR_AddTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185846 */   GIR_AddSimpleTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/,
     /* 185851 */   GIR_AddSimpleTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 272(*/0x90, 0x02/*)*/,
     /* 185856 */   GIR_AddImm8, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Imm*/1,
     /* 185860 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185866 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185872 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185878 */   GIR_MakeTempReg, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 185882 */   GIR_BuildMI, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185887 */   GIR_AddTempRegister, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185894 */   GIR_AddSimpleTempRegister, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/,
     /* 185899 */   GIR_AddImm8, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Imm*/32,
     /* 185903 */   GIR_AddImm8, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Imm*/31,
     /* 185907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 270(*/0x8E, 0x02/*)*/,
     /* 185910 */   GIR_MakeTempReg, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 185914 */   GIR_BuildMI, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185919 */   GIR_AddTempRegister, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185926 */   GIR_AddSimpleTempRegister, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/,
     /* 185931 */   GIR_AddImm, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 185942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 269(*/0x8D, 0x02/*)*/,
     /* 185945 */   GIR_MakeTempReg, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 185949 */   GIR_BuildMI, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185954 */   GIR_AddTempRegister, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185961 */   GIR_AddSimpleTempRegister, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/,
     /* 185966 */   GIR_AddImm, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 185977 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 268(*/0x8C, 0x02/*)*/,
     /* 185980 */   GIR_MakeTempReg, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 185984 */   GIR_BuildMI, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185989 */   GIR_AddTempRegister, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185996 */   GIR_AddImm, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 267(*/0x8B, 0x02/*)*/,
     /* 186010 */   GIR_MakeTempReg, /*TempRegID*//* 265(*/0x89, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186014 */   GIR_BuildMI, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186019 */   GIR_AddTempRegister, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegID*//* 265(*/0x89, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186026 */   GIR_AddSimpleTempRegister, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/,
     /* 186031 */   GIR_AddImm, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186042 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 266(*/0x8A, 0x02/*)*/,
     /* 186045 */   GIR_MakeTempReg, /*TempRegID*//* 264(*/0x88, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186049 */   GIR_BuildMI, /*InsnID*//* 265(*/0x89, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186054 */   GIR_AddTempRegister, /*InsnID*//* 265(*/0x89, 0x02/*)*/, /*TempRegID*//* 264(*/0x88, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 265(*/0x89, 0x02/*)*/,
     /* 186064 */   GIR_MakeTempReg, /*TempRegID*//* 263(*/0x87, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186068 */   GIR_BuildMI, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186073 */   GIR_AddTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 263(*/0x87, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186080 */   GIR_AddSimpleTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 264(*/0x88, 0x02/*)*/,
     /* 186085 */   GIR_AddSimpleTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 265(*/0x89, 0x02/*)*/,
     /* 186090 */   GIR_AddImm8, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Imm*/1,
     /* 186094 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186100 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186106 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186112 */   GIR_MakeTempReg, /*TempRegID*//* 262(*/0x86, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186116 */   GIR_BuildMI, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186121 */   GIR_AddTempRegister, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*TempRegID*//* 262(*/0x86, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186128 */   GIR_AddSimpleTempRegister, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*TempRegID*//* 263(*/0x87, 0x02/*)*/,
     /* 186133 */   GIR_AddImm8, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Imm*/32,
     /* 186137 */   GIR_AddImm8, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Imm*/31,
     /* 186141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 263(*/0x87, 0x02/*)*/,
     /* 186144 */   GIR_MakeTempReg, /*TempRegID*//* 261(*/0x85, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186148 */   GIR_BuildMI, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186153 */   GIR_AddTempRegister, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*TempRegID*//* 261(*/0x85, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186160 */   GIR_AddSimpleTempRegister, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*TempRegID*//* 262(*/0x86, 0x02/*)*/,
     /* 186165 */   GIR_AddImm, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 262(*/0x86, 0x02/*)*/,
     /* 186179 */   GIR_MakeTempReg, /*TempRegID*//* 260(*/0x84, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186183 */   GIR_BuildMI, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186188 */   GIR_AddTempRegister, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*TempRegID*//* 260(*/0x84, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186195 */   GIR_AddSimpleTempRegister, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*TempRegID*//* 261(*/0x85, 0x02/*)*/,
     /* 186200 */   GIR_AddImm, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 261(*/0x85, 0x02/*)*/,
     /* 186214 */   GIR_MakeTempReg, /*TempRegID*//* 259(*/0x83, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186218 */   GIR_BuildMI, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186223 */   GIR_AddTempRegister, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*TempRegID*//* 259(*/0x83, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186230 */   GIR_AddImm, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 260(*/0x84, 0x02/*)*/,
     /* 186244 */   GIR_MakeTempReg, /*TempRegID*//* 258(*/0x82, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186248 */   GIR_BuildMI, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186253 */   GIR_AddTempRegister, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*TempRegID*//* 258(*/0x82, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186260 */   GIR_AddSimpleTempRegister, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*TempRegID*//* 259(*/0x83, 0x02/*)*/,
     /* 186265 */   GIR_AddImm, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 259(*/0x83, 0x02/*)*/,
     /* 186279 */   GIR_MakeTempReg, /*TempRegID*//* 257(*/0x81, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186283 */   GIR_BuildMI, /*InsnID*//* 258(*/0x82, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186288 */   GIR_AddTempRegister, /*InsnID*//* 258(*/0x82, 0x02/*)*/, /*TempRegID*//* 257(*/0x81, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 258(*/0x82, 0x02/*)*/,
     /* 186298 */   GIR_MakeTempReg, /*TempRegID*//* 256(*/0x80, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186302 */   GIR_BuildMI, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186307 */   GIR_AddTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 256(*/0x80, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186314 */   GIR_AddSimpleTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 257(*/0x81, 0x02/*)*/,
     /* 186319 */   GIR_AddSimpleTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 258(*/0x82, 0x02/*)*/,
     /* 186324 */   GIR_AddImm8, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Imm*/1,
     /* 186328 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186334 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186340 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186346 */   GIR_MakeTempReg, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186350 */   GIR_BuildMI, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186355 */   GIR_AddTempRegister, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186362 */   GIR_AddSimpleTempRegister, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*TempRegID*//* 256(*/0x80, 0x02/*)*/,
     /* 186367 */   GIR_AddImm8, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Imm*/32,
     /* 186371 */   GIR_AddImm8, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Imm*/31,
     /* 186375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 256(*/0x80, 0x02/*)*/,
     /* 186378 */   GIR_MakeTempReg, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186382 */   GIR_BuildMI, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186387 */   GIR_AddTempRegister, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186394 */   GIR_AddSimpleTempRegister, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/,
     /* 186399 */   GIR_AddImm, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 255(*/0xFF, 0x01/*)*/,
     /* 186413 */   GIR_MakeTempReg, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186417 */   GIR_BuildMI, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186422 */   GIR_AddTempRegister, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186429 */   GIR_AddSimpleTempRegister, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/,
     /* 186434 */   GIR_AddImm, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 254(*/0xFE, 0x01/*)*/,
     /* 186448 */   GIR_MakeTempReg, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186452 */   GIR_BuildMI, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186457 */   GIR_AddTempRegister, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186464 */   GIR_Copy, /*NewInsnID*//* 253(*/0xFD, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 186469 */   GIR_AddImm8, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Imm*/1,
     /* 186473 */   GIR_AddImm8, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Imm*/62,
     /* 186477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 253(*/0xFD, 0x01/*)*/,
     /* 186480 */   GIR_MakeTempReg, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186484 */   GIR_BuildMI, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 186489 */   GIR_AddTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186496 */   GIR_AddSimpleTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/,
     /* 186501 */   GIR_AddSimpleTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/,
     /* 186506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 252(*/0xFC, 0x01/*)*/,
     /* 186509 */   GIR_MakeTempReg, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186513 */   GIR_BuildMI, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186518 */   GIR_AddTempRegister, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186525 */   GIR_AddImm, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 251(*/0xFB, 0x01/*)*/,
     /* 186539 */   GIR_MakeTempReg, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186543 */   GIR_BuildMI, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186548 */   GIR_AddTempRegister, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186555 */   GIR_AddSimpleTempRegister, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/,
     /* 186560 */   GIR_AddImm, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 250(*/0xFA, 0x01/*)*/,
     /* 186574 */   GIR_MakeTempReg, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186578 */   GIR_BuildMI, /*InsnID*//* 249(*/0xF9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186583 */   GIR_AddTempRegister, /*InsnID*//* 249(*/0xF9, 0x01/*)*/, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 249(*/0xF9, 0x01/*)*/,
     /* 186593 */   GIR_MakeTempReg, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186597 */   GIR_BuildMI, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186602 */   GIR_AddTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186609 */   GIR_AddSimpleTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/,
     /* 186614 */   GIR_AddSimpleTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/,
     /* 186619 */   GIR_AddImm8, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Imm*/1,
     /* 186623 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186629 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186635 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186641 */   GIR_MakeTempReg, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186645 */   GIR_BuildMI, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186650 */   GIR_AddTempRegister, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186657 */   GIR_AddSimpleTempRegister, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/,
     /* 186662 */   GIR_AddImm8, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Imm*/32,
     /* 186666 */   GIR_AddImm8, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Imm*/31,
     /* 186670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 247(*/0xF7, 0x01/*)*/,
     /* 186673 */   GIR_MakeTempReg, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186677 */   GIR_BuildMI, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186682 */   GIR_AddTempRegister, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186689 */   GIR_AddSimpleTempRegister, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/,
     /* 186694 */   GIR_AddImm, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 246(*/0xF6, 0x01/*)*/,
     /* 186708 */   GIR_MakeTempReg, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186712 */   GIR_BuildMI, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186717 */   GIR_AddTempRegister, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186724 */   GIR_AddSimpleTempRegister, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/,
     /* 186729 */   GIR_AddImm, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 245(*/0xF5, 0x01/*)*/,
     /* 186743 */   GIR_MakeTempReg, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186747 */   GIR_BuildMI, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 186752 */   GIR_AddTempRegister, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186759 */   GIR_Copy, /*NewInsnID*//* 244(*/0xF4, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 186764 */   GIR_AddImm8, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Imm*/63,
     /* 186768 */   GIR_AddImm8, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Imm*/1,
     /* 186772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 244(*/0xF4, 0x01/*)*/,
     /* 186775 */   GIR_MakeTempReg, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186779 */   GIR_BuildMI, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 186784 */   GIR_AddTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186791 */   GIR_AddSimpleTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/,
     /* 186796 */   GIR_AddSimpleTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/,
     /* 186801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 243(*/0xF3, 0x01/*)*/,
     /* 186804 */   GIR_MakeTempReg, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186808 */   GIR_BuildMI, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 186813 */   GIR_AddTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186820 */   GIR_AddSimpleTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/,
     /* 186825 */   GIR_AddSimpleTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/,
     /* 186830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 242(*/0xF2, 0x01/*)*/,
     /* 186833 */   GIR_MakeTempReg, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186837 */   GIR_BuildMI, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186842 */   GIR_AddTempRegister, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186849 */   GIR_AddSimpleTempRegister, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/,
     /* 186854 */   GIR_AddImm8, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Imm*/2,
     /* 186858 */   GIR_AddImm8, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Imm*/61,
     /* 186862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 241(*/0xF1, 0x01/*)*/,
     /* 186865 */   GIR_MakeTempReg, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186869 */   GIR_BuildMI, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 186874 */   GIR_AddTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186881 */   GIR_AddSimpleTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/,
     /* 186886 */   GIR_AddSimpleTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 260(*/0x84, 0x02/*)*/,
     /* 186891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 240(*/0xF0, 0x01/*)*/,
     /* 186894 */   GIR_MakeTempReg, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186898 */   GIR_BuildMI, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186903 */   GIR_AddTempRegister, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186910 */   GIR_AddImm, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 186921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 239(*/0xEF, 0x01/*)*/,
     /* 186924 */   GIR_MakeTempReg, /*TempRegID*//* 237(*/0xED, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186928 */   GIR_BuildMI, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186933 */   GIR_AddTempRegister, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegID*//* 237(*/0xED, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186940 */   GIR_AddSimpleTempRegister, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/,
     /* 186945 */   GIR_AddImm, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 186956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 238(*/0xEE, 0x01/*)*/,
     /* 186959 */   GIR_MakeTempReg, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186963 */   GIR_BuildMI, /*InsnID*//* 237(*/0xED, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186968 */   GIR_AddTempRegister, /*InsnID*//* 237(*/0xED, 0x01/*)*/, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 237(*/0xED, 0x01/*)*/,
     /* 186978 */   GIR_MakeTempReg, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186982 */   GIR_BuildMI, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186987 */   GIR_AddTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186994 */   GIR_AddSimpleTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/,
     /* 186999 */   GIR_AddSimpleTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 237(*/0xED, 0x01/*)*/,
     /* 187004 */   GIR_AddImm8, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Imm*/1,
     /* 187008 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187014 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187020 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187026 */   GIR_MakeTempReg, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187030 */   GIR_BuildMI, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187035 */   GIR_AddTempRegister, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187042 */   GIR_AddSimpleTempRegister, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/,
     /* 187047 */   GIR_AddImm8, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Imm*/32,
     /* 187051 */   GIR_AddImm8, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Imm*/31,
     /* 187055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 235(*/0xEB, 0x01/*)*/,
     /* 187058 */   GIR_MakeTempReg, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187062 */   GIR_BuildMI, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187067 */   GIR_AddTempRegister, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187074 */   GIR_AddSimpleTempRegister, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/,
     /* 187079 */   GIR_AddImm, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 187090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 234(*/0xEA, 0x01/*)*/,
     /* 187093 */   GIR_MakeTempReg, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187097 */   GIR_BuildMI, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187102 */   GIR_AddTempRegister, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187109 */   GIR_AddSimpleTempRegister, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/,
     /* 187114 */   GIR_AddImm, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 187125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 233(*/0xE9, 0x01/*)*/,
     /* 187128 */   GIR_MakeTempReg, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187132 */   GIR_BuildMI, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187137 */   GIR_AddTempRegister, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187144 */   GIR_AddImm, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 232(*/0xE8, 0x01/*)*/,
     /* 187158 */   GIR_MakeTempReg, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187162 */   GIR_BuildMI, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187167 */   GIR_AddTempRegister, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187174 */   GIR_AddSimpleTempRegister, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/,
     /* 187179 */   GIR_AddImm, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 231(*/0xE7, 0x01/*)*/,
     /* 187193 */   GIR_MakeTempReg, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187197 */   GIR_BuildMI, /*InsnID*//* 230(*/0xE6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187202 */   GIR_AddTempRegister, /*InsnID*//* 230(*/0xE6, 0x01/*)*/, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 230(*/0xE6, 0x01/*)*/,
     /* 187212 */   GIR_MakeTempReg, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187216 */   GIR_BuildMI, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187221 */   GIR_AddTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187228 */   GIR_AddSimpleTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/,
     /* 187233 */   GIR_AddSimpleTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/,
     /* 187238 */   GIR_AddImm8, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Imm*/1,
     /* 187242 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187248 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187254 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187260 */   GIR_MakeTempReg, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187264 */   GIR_BuildMI, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187269 */   GIR_AddTempRegister, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187276 */   GIR_AddSimpleTempRegister, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/,
     /* 187281 */   GIR_AddImm8, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Imm*/32,
     /* 187285 */   GIR_AddImm8, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Imm*/31,
     /* 187289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 228(*/0xE4, 0x01/*)*/,
     /* 187292 */   GIR_MakeTempReg, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187296 */   GIR_BuildMI, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187301 */   GIR_AddTempRegister, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187308 */   GIR_AddSimpleTempRegister, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/,
     /* 187313 */   GIR_AddImm, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 227(*/0xE3, 0x01/*)*/,
     /* 187327 */   GIR_MakeTempReg, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187331 */   GIR_BuildMI, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187336 */   GIR_AddTempRegister, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187343 */   GIR_AddSimpleTempRegister, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/,
     /* 187348 */   GIR_AddImm, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 226(*/0xE2, 0x01/*)*/,
     /* 187362 */   GIR_MakeTempReg, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187366 */   GIR_BuildMI, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187371 */   GIR_AddTempRegister, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187378 */   GIR_Copy, /*NewInsnID*//* 225(*/0xE1, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 187383 */   GIR_AddImm8, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Imm*/1,
     /* 187387 */   GIR_AddImm8, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Imm*/62,
     /* 187391 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 225(*/0xE1, 0x01/*)*/,
     /* 187394 */   GIR_MakeTempReg, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187398 */   GIR_BuildMI, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187403 */   GIR_AddTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187410 */   GIR_AddSimpleTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/,
     /* 187415 */   GIR_AddSimpleTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/,
     /* 187420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 224(*/0xE0, 0x01/*)*/,
     /* 187423 */   GIR_MakeTempReg, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187427 */   GIR_BuildMI, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187432 */   GIR_AddTempRegister, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187439 */   GIR_AddImm, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 223(*/0xDF, 0x01/*)*/,
     /* 187453 */   GIR_MakeTempReg, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187457 */   GIR_BuildMI, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187462 */   GIR_AddTempRegister, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187469 */   GIR_AddSimpleTempRegister, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/,
     /* 187474 */   GIR_AddImm, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 222(*/0xDE, 0x01/*)*/,
     /* 187488 */   GIR_MakeTempReg, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187492 */   GIR_BuildMI, /*InsnID*//* 221(*/0xDD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187497 */   GIR_AddTempRegister, /*InsnID*//* 221(*/0xDD, 0x01/*)*/, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 221(*/0xDD, 0x01/*)*/,
     /* 187507 */   GIR_MakeTempReg, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187511 */   GIR_BuildMI, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187516 */   GIR_AddTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187523 */   GIR_AddSimpleTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/,
     /* 187528 */   GIR_AddSimpleTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/,
     /* 187533 */   GIR_AddImm8, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Imm*/1,
     /* 187537 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187543 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187549 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187555 */   GIR_MakeTempReg, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187559 */   GIR_BuildMI, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187564 */   GIR_AddTempRegister, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187571 */   GIR_AddSimpleTempRegister, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/,
     /* 187576 */   GIR_AddImm8, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Imm*/32,
     /* 187580 */   GIR_AddImm8, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Imm*/31,
     /* 187584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 219(*/0xDB, 0x01/*)*/,
     /* 187587 */   GIR_MakeTempReg, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187591 */   GIR_BuildMI, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187596 */   GIR_AddTempRegister, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187603 */   GIR_AddSimpleTempRegister, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/,
     /* 187608 */   GIR_AddImm, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 218(*/0xDA, 0x01/*)*/,
     /* 187622 */   GIR_MakeTempReg, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187626 */   GIR_BuildMI, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187631 */   GIR_AddTempRegister, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187638 */   GIR_AddSimpleTempRegister, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/,
     /* 187643 */   GIR_AddImm, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 217(*/0xD9, 0x01/*)*/,
     /* 187657 */   GIR_MakeTempReg, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187661 */   GIR_BuildMI, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 187666 */   GIR_AddTempRegister, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187673 */   GIR_Copy, /*NewInsnID*//* 216(*/0xD8, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 187678 */   GIR_AddImm8, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Imm*/63,
     /* 187682 */   GIR_AddImm8, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Imm*/1,
     /* 187686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 216(*/0xD8, 0x01/*)*/,
     /* 187689 */   GIR_MakeTempReg, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187693 */   GIR_BuildMI, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187698 */   GIR_AddTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187705 */   GIR_AddSimpleTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/,
     /* 187710 */   GIR_AddSimpleTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/,
     /* 187715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 215(*/0xD7, 0x01/*)*/,
     /* 187718 */   GIR_MakeTempReg, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187722 */   GIR_BuildMI, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 187727 */   GIR_AddTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187734 */   GIR_AddSimpleTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/,
     /* 187739 */   GIR_AddSimpleTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/,
     /* 187744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 214(*/0xD6, 0x01/*)*/,
     /* 187747 */   GIR_MakeTempReg, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187751 */   GIR_BuildMI, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 187756 */   GIR_AddTempRegister, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187763 */   GIR_AddSimpleTempRegister, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/,
     /* 187768 */   GIR_AddImm8, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Imm*/62,
     /* 187772 */   GIR_AddImm8, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Imm*/2,
     /* 187776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 213(*/0xD5, 0x01/*)*/,
     /* 187779 */   GIR_MakeTempReg, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187783 */   GIR_BuildMI, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187788 */   GIR_AddTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187795 */   GIR_AddSimpleTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/,
     /* 187800 */   GIR_AddSimpleTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/,
     /* 187805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 212(*/0xD4, 0x01/*)*/,
     /* 187808 */   GIR_MakeTempReg, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187812 */   GIR_BuildMI, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 187817 */   GIR_AddTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187824 */   GIR_AddSimpleTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/,
     /* 187829 */   GIR_AddSimpleTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/,
     /* 187834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 211(*/0xD3, 0x01/*)*/,
     /* 187837 */   GIR_MakeTempReg, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187841 */   GIR_BuildMI, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187846 */   GIR_AddTempRegister, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187853 */   GIR_AddSimpleTempRegister, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/,
     /* 187858 */   GIR_AddImm8, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Imm*/4,
     /* 187862 */   GIR_AddImm8, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Imm*/59,
     /* 187866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 210(*/0xD2, 0x01/*)*/,
     /* 187869 */   GIR_MakeTempReg, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187873 */   GIR_BuildMI, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187878 */   GIR_AddTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187885 */   GIR_AddSimpleTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/,
     /* 187890 */   GIR_AddSimpleTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/,
     /* 187895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 209(*/0xD1, 0x01/*)*/,
     /* 187898 */   GIR_MakeTempReg, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187902 */   GIR_BuildMI, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187907 */   GIR_AddTempRegister, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187914 */   GIR_AddImm, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 187925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 208(*/0xD0, 0x01/*)*/,
     /* 187928 */   GIR_MakeTempReg, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187932 */   GIR_BuildMI, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187937 */   GIR_AddTempRegister, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187944 */   GIR_AddSimpleTempRegister, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/,
     /* 187949 */   GIR_AddImm, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 187960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 207(*/0xCF, 0x01/*)*/,
     /* 187963 */   GIR_MakeTempReg, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187967 */   GIR_BuildMI, /*InsnID*//* 206(*/0xCE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187972 */   GIR_AddTempRegister, /*InsnID*//* 206(*/0xCE, 0x01/*)*/, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 206(*/0xCE, 0x01/*)*/,
     /* 187982 */   GIR_MakeTempReg, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187986 */   GIR_BuildMI, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187991 */   GIR_AddTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187998 */   GIR_AddSimpleTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/,
     /* 188003 */   GIR_AddSimpleTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/,
     /* 188008 */   GIR_AddImm8, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Imm*/1,
     /* 188012 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188018 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188024 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188030 */   GIR_MakeTempReg, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188034 */   GIR_BuildMI, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188039 */   GIR_AddTempRegister, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188046 */   GIR_AddSimpleTempRegister, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/,
     /* 188051 */   GIR_AddImm8, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Imm*/32,
     /* 188055 */   GIR_AddImm8, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Imm*/31,
     /* 188059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 204(*/0xCC, 0x01/*)*/,
     /* 188062 */   GIR_MakeTempReg, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188066 */   GIR_BuildMI, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188071 */   GIR_AddTempRegister, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188078 */   GIR_AddSimpleTempRegister, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/,
     /* 188083 */   GIR_AddImm, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 188094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 203(*/0xCB, 0x01/*)*/,
     /* 188097 */   GIR_MakeTempReg, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188101 */   GIR_BuildMI, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188106 */   GIR_AddTempRegister, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188113 */   GIR_AddSimpleTempRegister, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/,
     /* 188118 */   GIR_AddImm, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 188129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 202(*/0xCA, 0x01/*)*/,
     /* 188132 */   GIR_MakeTempReg, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188136 */   GIR_BuildMI, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188141 */   GIR_AddTempRegister, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188148 */   GIR_AddImm, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 201(*/0xC9, 0x01/*)*/,
     /* 188162 */   GIR_MakeTempReg, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188166 */   GIR_BuildMI, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188171 */   GIR_AddTempRegister, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188178 */   GIR_AddSimpleTempRegister, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/,
     /* 188183 */   GIR_AddImm, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 200(*/0xC8, 0x01/*)*/,
     /* 188197 */   GIR_MakeTempReg, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188201 */   GIR_BuildMI, /*InsnID*//* 199(*/0xC7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188206 */   GIR_AddTempRegister, /*InsnID*//* 199(*/0xC7, 0x01/*)*/, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 199(*/0xC7, 0x01/*)*/,
     /* 188216 */   GIR_MakeTempReg, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188220 */   GIR_BuildMI, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188225 */   GIR_AddTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188232 */   GIR_AddSimpleTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/,
     /* 188237 */   GIR_AddSimpleTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/,
     /* 188242 */   GIR_AddImm8, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Imm*/1,
     /* 188246 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188252 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188258 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188264 */   GIR_MakeTempReg, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188268 */   GIR_BuildMI, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188273 */   GIR_AddTempRegister, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188280 */   GIR_AddSimpleTempRegister, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/,
     /* 188285 */   GIR_AddImm8, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Imm*/32,
     /* 188289 */   GIR_AddImm8, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Imm*/31,
     /* 188293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 197(*/0xC5, 0x01/*)*/,
     /* 188296 */   GIR_MakeTempReg, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188300 */   GIR_BuildMI, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188305 */   GIR_AddTempRegister, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188312 */   GIR_AddSimpleTempRegister, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/,
     /* 188317 */   GIR_AddImm, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 196(*/0xC4, 0x01/*)*/,
     /* 188331 */   GIR_MakeTempReg, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188335 */   GIR_BuildMI, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188340 */   GIR_AddTempRegister, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188347 */   GIR_AddSimpleTempRegister, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/,
     /* 188352 */   GIR_AddImm, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 195(*/0xC3, 0x01/*)*/,
     /* 188366 */   GIR_MakeTempReg, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188370 */   GIR_BuildMI, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188375 */   GIR_AddTempRegister, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188382 */   GIR_AddImm, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 194(*/0xC2, 0x01/*)*/,
     /* 188396 */   GIR_MakeTempReg, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188400 */   GIR_BuildMI, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188405 */   GIR_AddTempRegister, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188412 */   GIR_AddSimpleTempRegister, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/,
     /* 188417 */   GIR_AddImm, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 193(*/0xC1, 0x01/*)*/,
     /* 188431 */   GIR_MakeTempReg, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188435 */   GIR_BuildMI, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188440 */   GIR_AddTempRegister, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 192(*/0xC0, 0x01/*)*/,
     /* 188450 */   GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188454 */   GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188459 */   GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188466 */   GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/,
     /* 188471 */   GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/,
     /* 188476 */   GIR_AddImm8, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/1,
     /* 188480 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188486 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188492 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188498 */   GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188502 */   GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188507 */   GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188514 */   GIR_AddSimpleTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 188519 */   GIR_AddImm8, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/32,
     /* 188523 */   GIR_AddImm8, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/31,
     /* 188527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 188530 */   GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188534 */   GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188539 */   GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188546 */   GIR_AddSimpleTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 188551 */   GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 188565 */   GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188569 */   GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188574 */   GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188581 */   GIR_AddSimpleTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 188586 */   GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 188600 */   GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188604 */   GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188609 */   GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188616 */   GIR_Copy, /*NewInsnID*//* 187(*/0xBB, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 188621 */   GIR_AddImm8, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/1,
     /* 188625 */   GIR_AddImm8, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/62,
     /* 188629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 188632 */   GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188636 */   GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188641 */   GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188648 */   GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 188653 */   GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 188658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 188661 */   GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188665 */   GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188670 */   GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188677 */   GIR_AddImm, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 188688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 188691 */   GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188695 */   GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188700 */   GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188707 */   GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 188712 */   GIR_AddImm, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 188723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 188726 */   GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188730 */   GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188735 */   GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 188745 */   GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188749 */   GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188754 */   GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188761 */   GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 188766 */   GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 188771 */   GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/1,
     /* 188775 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188781 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188787 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188793 */   GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188797 */   GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188802 */   GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188809 */   GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 188814 */   GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/32,
     /* 188818 */   GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 188822 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 188825 */   GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188829 */   GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188834 */   GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188841 */   GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 188846 */   GIR_AddImm, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 188857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 188860 */   GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188864 */   GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188869 */   GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188876 */   GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 188881 */   GIR_AddImm, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 188892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 188895 */   GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188899 */   GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 188904 */   GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188911 */   GIR_Copy, /*NewInsnID*//* 178(*/0xB2, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 188916 */   GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/63,
     /* 188920 */   GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/1,
     /* 188924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 188927 */   GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188931 */   GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188936 */   GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188943 */   GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 188948 */   GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 188953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 188956 */   GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188960 */   GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 188965 */   GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188972 */   GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 188977 */   GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 188982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 188985 */   GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188989 */   GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188994 */   GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189001 */   GIR_AddSimpleTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 189006 */   GIR_AddImm8, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/2,
     /* 189010 */   GIR_AddImm8, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/61,
     /* 189014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 189017 */   GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189021 */   GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189026 */   GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189033 */   GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 189038 */   GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/,
     /* 189043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 189046 */   GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189050 */   GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189055 */   GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189062 */   GIR_AddImm, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 189076 */   GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189080 */   GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189085 */   GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189092 */   GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 189097 */   GIR_AddImm, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 189111 */   GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189115 */   GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189120 */   GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 189130 */   GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189134 */   GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189139 */   GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189146 */   GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 189151 */   GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 189156 */   GIR_AddImm8, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/1,
     /* 189160 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189166 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189172 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189178 */   GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189182 */   GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189187 */   GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189194 */   GIR_AddSimpleTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 189199 */   GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/32,
     /* 189203 */   GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 189207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 189210 */   GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189214 */   GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189219 */   GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189226 */   GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 189231 */   GIR_AddImm, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 189245 */   GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189249 */   GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189254 */   GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189261 */   GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 189266 */   GIR_AddImm, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 189280 */   GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189284 */   GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189289 */   GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189296 */   GIR_AddImm, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 189310 */   GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189314 */   GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189319 */   GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189326 */   GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 189331 */   GIR_AddImm, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189342 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 189345 */   GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189349 */   GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189354 */   GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 189364 */   GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189368 */   GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189373 */   GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189380 */   GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 189385 */   GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 189390 */   GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/1,
     /* 189394 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189400 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189406 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189412 */   GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189416 */   GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189421 */   GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189428 */   GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 189433 */   GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/32,
     /* 189437 */   GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/31,
     /* 189441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 189444 */   GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189448 */   GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189453 */   GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189460 */   GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 189465 */   GIR_AddImm, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 189479 */   GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189483 */   GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189488 */   GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189495 */   GIR_AddSimpleTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 189500 */   GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 189514 */   GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189518 */   GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189523 */   GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189530 */   GIR_Copy, /*NewInsnID*//* 159(*/0x9F, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 189535 */   GIR_AddImm8, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/1,
     /* 189539 */   GIR_AddImm8, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/62,
     /* 189543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 189546 */   GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189550 */   GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189555 */   GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189562 */   GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 189567 */   GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 189572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 189575 */   GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189579 */   GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189584 */   GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189591 */   GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189602 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 189605 */   GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189609 */   GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189614 */   GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189621 */   GIR_AddSimpleTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 189626 */   GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 189640 */   GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189644 */   GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189649 */   GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 189659 */   GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189663 */   GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189668 */   GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189675 */   GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 189680 */   GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 189685 */   GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/1,
     /* 189689 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189695 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189701 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189707 */   GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189711 */   GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189716 */   GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189723 */   GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 189728 */   GIR_AddImm8, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/32,
     /* 189732 */   GIR_AddImm8, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/31,
     /* 189736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 189739 */   GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189743 */   GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189748 */   GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189755 */   GIR_AddSimpleTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 189760 */   GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 189774 */   GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189778 */   GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189783 */   GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189790 */   GIR_AddSimpleTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 189795 */   GIR_AddImm, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 189809 */   GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189813 */   GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 189818 */   GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189825 */   GIR_Copy, /*NewInsnID*//* 150(*/0x96, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 189830 */   GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/63,
     /* 189834 */   GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/1,
     /* 189838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 189841 */   GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189845 */   GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189850 */   GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189857 */   GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 189862 */   GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 189867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 189870 */   GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189874 */   GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 189879 */   GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189886 */   GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 189891 */   GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 189896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 189899 */   GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189903 */   GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 189908 */   GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189915 */   GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 189920 */   GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/62,
     /* 189924 */   GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/2,
     /* 189928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 189931 */   GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189935 */   GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189940 */   GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189947 */   GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 189952 */   GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 189957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 189960 */   GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189964 */   GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 189969 */   GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189976 */   GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 189981 */   GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 189986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 189989 */   GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189993 */   GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 189998 */   GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190005 */   GIR_AddSimpleTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 190010 */   GIR_AddImm8, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/60,
     /* 190014 */   GIR_AddImm8, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/4,
     /* 190018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 190021 */   GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190025 */   GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 190030 */   GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190037 */   GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 190042 */   GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/,
     /* 190047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 190050 */   GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190054 */   GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 190059 */   GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190066 */   GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 190071 */   GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/,
     /* 190076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 190079 */   GIR_MakeTempReg, /*TempRegID*//* 407(*/0x97, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190083 */   GIR_BuildMI, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190088 */   GIR_AddTempRegister, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*TempRegID*//* 407(*/0x97, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190095 */   GIR_AddImm, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 408(*/0x98, 0x03/*)*/,
     /* 190109 */   GIR_MakeTempReg, /*TempRegID*//* 406(*/0x96, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190113 */   GIR_BuildMI, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190118 */   GIR_AddTempRegister, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*TempRegID*//* 406(*/0x96, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190125 */   GIR_AddSimpleTempRegister, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*TempRegID*//* 407(*/0x97, 0x03/*)*/,
     /* 190130 */   GIR_AddImm, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 407(*/0x97, 0x03/*)*/,
     /* 190144 */   GIR_MakeTempReg, /*TempRegID*//* 405(*/0x95, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190148 */   GIR_BuildMI, /*InsnID*//* 406(*/0x96, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190153 */   GIR_AddTempRegister, /*InsnID*//* 406(*/0x96, 0x03/*)*/, /*TempRegID*//* 405(*/0x95, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 406(*/0x96, 0x03/*)*/,
     /* 190163 */   GIR_MakeTempReg, /*TempRegID*//* 404(*/0x94, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190167 */   GIR_BuildMI, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190172 */   GIR_AddTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 404(*/0x94, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190179 */   GIR_AddSimpleTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 405(*/0x95, 0x03/*)*/,
     /* 190184 */   GIR_AddSimpleTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 406(*/0x96, 0x03/*)*/,
     /* 190189 */   GIR_AddImm8, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Imm*/1,
     /* 190193 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190199 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190205 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190211 */   GIR_MakeTempReg, /*TempRegID*//* 403(*/0x93, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190215 */   GIR_BuildMI, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190220 */   GIR_AddTempRegister, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*TempRegID*//* 403(*/0x93, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190227 */   GIR_AddSimpleTempRegister, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*TempRegID*//* 404(*/0x94, 0x03/*)*/,
     /* 190232 */   GIR_AddImm8, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Imm*/32,
     /* 190236 */   GIR_AddImm8, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Imm*/31,
     /* 190240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 404(*/0x94, 0x03/*)*/,
     /* 190243 */   GIR_MakeTempReg, /*TempRegID*//* 402(*/0x92, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190247 */   GIR_BuildMI, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190252 */   GIR_AddTempRegister, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*TempRegID*//* 402(*/0x92, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190259 */   GIR_AddSimpleTempRegister, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*TempRegID*//* 403(*/0x93, 0x03/*)*/,
     /* 190264 */   GIR_AddImm, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 403(*/0x93, 0x03/*)*/,
     /* 190278 */   GIR_MakeTempReg, /*TempRegID*//* 401(*/0x91, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190282 */   GIR_BuildMI, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190287 */   GIR_AddTempRegister, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*TempRegID*//* 401(*/0x91, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190294 */   GIR_AddSimpleTempRegister, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*TempRegID*//* 402(*/0x92, 0x03/*)*/,
     /* 190299 */   GIR_AddImm, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 402(*/0x92, 0x03/*)*/,
     /* 190313 */   GIR_MakeTempReg, /*TempRegID*//* 400(*/0x90, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190317 */   GIR_BuildMI, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190322 */   GIR_AddTempRegister, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*TempRegID*//* 400(*/0x90, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190329 */   GIR_AddImm, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 401(*/0x91, 0x03/*)*/,
     /* 190343 */   GIR_MakeTempReg, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190347 */   GIR_BuildMI, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190352 */   GIR_AddTempRegister, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190359 */   GIR_AddSimpleTempRegister, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*TempRegID*//* 400(*/0x90, 0x03/*)*/,
     /* 190364 */   GIR_AddImm, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 400(*/0x90, 0x03/*)*/,
     /* 190378 */   GIR_MakeTempReg, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190382 */   GIR_BuildMI, /*InsnID*//* 399(*/0x8F, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190387 */   GIR_AddTempRegister, /*InsnID*//* 399(*/0x8F, 0x03/*)*/, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 399(*/0x8F, 0x03/*)*/,
     /* 190397 */   GIR_MakeTempReg, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190401 */   GIR_BuildMI, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190406 */   GIR_AddTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190413 */   GIR_AddSimpleTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/,
     /* 190418 */   GIR_AddSimpleTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/,
     /* 190423 */   GIR_AddImm8, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Imm*/1,
     /* 190427 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190433 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190439 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190445 */   GIR_MakeTempReg, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190449 */   GIR_BuildMI, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190454 */   GIR_AddTempRegister, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190461 */   GIR_AddSimpleTempRegister, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/,
     /* 190466 */   GIR_AddImm8, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Imm*/32,
     /* 190470 */   GIR_AddImm8, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Imm*/31,
     /* 190474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 397(*/0x8D, 0x03/*)*/,
     /* 190477 */   GIR_MakeTempReg, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190481 */   GIR_BuildMI, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190486 */   GIR_AddTempRegister, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190493 */   GIR_AddSimpleTempRegister, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/,
     /* 190498 */   GIR_AddImm, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 396(*/0x8C, 0x03/*)*/,
     /* 190512 */   GIR_MakeTempReg, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190516 */   GIR_BuildMI, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190521 */   GIR_AddTempRegister, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190528 */   GIR_AddSimpleTempRegister, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/,
     /* 190533 */   GIR_AddImm, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 395(*/0x8B, 0x03/*)*/,
     /* 190547 */   GIR_MakeTempReg, /*TempRegID*//* 393(*/0x89, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190551 */   GIR_BuildMI, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190556 */   GIR_AddTempRegister, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*TempRegID*//* 393(*/0x89, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190563 */   GIR_AddImm, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 394(*/0x8A, 0x03/*)*/,
     /* 190577 */   GIR_MakeTempReg, /*TempRegID*//* 392(*/0x88, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190581 */   GIR_BuildMI, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190586 */   GIR_AddTempRegister, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*TempRegID*//* 392(*/0x88, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190593 */   GIR_AddSimpleTempRegister, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*TempRegID*//* 393(*/0x89, 0x03/*)*/,
     /* 190598 */   GIR_AddImm, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 393(*/0x89, 0x03/*)*/,
     /* 190612 */   GIR_MakeTempReg, /*TempRegID*//* 391(*/0x87, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190616 */   GIR_BuildMI, /*InsnID*//* 392(*/0x88, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190621 */   GIR_AddTempRegister, /*InsnID*//* 392(*/0x88, 0x03/*)*/, /*TempRegID*//* 391(*/0x87, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 392(*/0x88, 0x03/*)*/,
     /* 190631 */   GIR_MakeTempReg, /*TempRegID*//* 390(*/0x86, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190635 */   GIR_BuildMI, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190640 */   GIR_AddTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 390(*/0x86, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190647 */   GIR_AddSimpleTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 391(*/0x87, 0x03/*)*/,
     /* 190652 */   GIR_AddSimpleTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 392(*/0x88, 0x03/*)*/,
     /* 190657 */   GIR_AddImm8, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Imm*/1,
     /* 190661 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190667 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190673 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190679 */   GIR_MakeTempReg, /*TempRegID*//* 389(*/0x85, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190683 */   GIR_BuildMI, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190688 */   GIR_AddTempRegister, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*TempRegID*//* 389(*/0x85, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190695 */   GIR_AddSimpleTempRegister, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*TempRegID*//* 390(*/0x86, 0x03/*)*/,
     /* 190700 */   GIR_AddImm8, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Imm*/32,
     /* 190704 */   GIR_AddImm8, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Imm*/31,
     /* 190708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 390(*/0x86, 0x03/*)*/,
     /* 190711 */   GIR_MakeTempReg, /*TempRegID*//* 388(*/0x84, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190715 */   GIR_BuildMI, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190720 */   GIR_AddTempRegister, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*TempRegID*//* 388(*/0x84, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190727 */   GIR_AddSimpleTempRegister, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*TempRegID*//* 389(*/0x85, 0x03/*)*/,
     /* 190732 */   GIR_AddImm, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 389(*/0x85, 0x03/*)*/,
     /* 190746 */   GIR_MakeTempReg, /*TempRegID*//* 387(*/0x83, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190750 */   GIR_BuildMI, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190755 */   GIR_AddTempRegister, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*TempRegID*//* 387(*/0x83, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190762 */   GIR_AddSimpleTempRegister, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*TempRegID*//* 388(*/0x84, 0x03/*)*/,
     /* 190767 */   GIR_AddImm, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 388(*/0x84, 0x03/*)*/,
     /* 190781 */   GIR_MakeTempReg, /*TempRegID*//* 386(*/0x82, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190785 */   GIR_BuildMI, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190790 */   GIR_AddTempRegister, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*TempRegID*//* 386(*/0x82, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190797 */   GIR_Copy, /*NewInsnID*//* 387(*/0x83, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 190802 */   GIR_AddImm8, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Imm*/1,
     /* 190806 */   GIR_AddImm8, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Imm*/62,
     /* 190810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 387(*/0x83, 0x03/*)*/,
     /* 190813 */   GIR_MakeTempReg, /*TempRegID*//* 385(*/0x81, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190817 */   GIR_BuildMI, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 190822 */   GIR_AddTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 385(*/0x81, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190829 */   GIR_AddSimpleTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 386(*/0x82, 0x03/*)*/,
     /* 190834 */   GIR_AddSimpleTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 387(*/0x83, 0x03/*)*/,
     /* 190839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 386(*/0x82, 0x03/*)*/,
     /* 190842 */   GIR_MakeTempReg, /*TempRegID*//* 384(*/0x80, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190846 */   GIR_BuildMI, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190851 */   GIR_AddTempRegister, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*TempRegID*//* 384(*/0x80, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190858 */   GIR_AddImm, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 190869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 385(*/0x81, 0x03/*)*/,
     /* 190872 */   GIR_MakeTempReg, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 190876 */   GIR_BuildMI, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190881 */   GIR_AddTempRegister, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190888 */   GIR_AddSimpleTempRegister, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*TempRegID*//* 384(*/0x80, 0x03/*)*/,
     /* 190893 */   GIR_AddImm, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 190904 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 384(*/0x80, 0x03/*)*/,
     /* 190907 */   GIR_MakeTempReg, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190911 */   GIR_BuildMI, /*InsnID*//* 383(*/0xFF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190916 */   GIR_AddTempRegister, /*InsnID*//* 383(*/0xFF, 0x02/*)*/, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 383(*/0xFF, 0x02/*)*/,
     /* 190926 */   GIR_MakeTempReg, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190930 */   GIR_BuildMI, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190935 */   GIR_AddTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190942 */   GIR_AddSimpleTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/,
     /* 190947 */   GIR_AddSimpleTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/,
     /* 190952 */   GIR_AddImm8, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Imm*/1,
     /* 190956 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190962 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190968 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190974 */   GIR_MakeTempReg, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190978 */   GIR_BuildMI, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190983 */   GIR_AddTempRegister, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190990 */   GIR_AddSimpleTempRegister, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/,
     /* 190995 */   GIR_AddImm8, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Imm*/32,
     /* 190999 */   GIR_AddImm8, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Imm*/31,
     /* 191003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 381(*/0xFD, 0x02/*)*/,
     /* 191006 */   GIR_MakeTempReg, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191010 */   GIR_BuildMI, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191015 */   GIR_AddTempRegister, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191022 */   GIR_AddSimpleTempRegister, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/,
     /* 191027 */   GIR_AddImm, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 380(*/0xFC, 0x02/*)*/,
     /* 191041 */   GIR_MakeTempReg, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191045 */   GIR_BuildMI, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191050 */   GIR_AddTempRegister, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191057 */   GIR_AddSimpleTempRegister, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/,
     /* 191062 */   GIR_AddImm, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 379(*/0xFB, 0x02/*)*/,
     /* 191076 */   GIR_MakeTempReg, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191080 */   GIR_BuildMI, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 191085 */   GIR_AddTempRegister, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191092 */   GIR_Copy, /*NewInsnID*//* 378(*/0xFA, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 191097 */   GIR_AddImm8, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Imm*/63,
     /* 191101 */   GIR_AddImm8, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Imm*/1,
     /* 191105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 378(*/0xFA, 0x02/*)*/,
     /* 191108 */   GIR_MakeTempReg, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191112 */   GIR_BuildMI, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191117 */   GIR_AddTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191124 */   GIR_AddSimpleTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/,
     /* 191129 */   GIR_AddSimpleTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/,
     /* 191134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 377(*/0xF9, 0x02/*)*/,
     /* 191137 */   GIR_MakeTempReg, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191141 */   GIR_BuildMI, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 191146 */   GIR_AddTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191153 */   GIR_AddSimpleTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/,
     /* 191158 */   GIR_AddSimpleTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 385(*/0x81, 0x03/*)*/,
     /* 191163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 376(*/0xF8, 0x02/*)*/,
     /* 191166 */   GIR_MakeTempReg, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191170 */   GIR_BuildMI, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191175 */   GIR_AddTempRegister, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191182 */   GIR_AddSimpleTempRegister, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/,
     /* 191187 */   GIR_AddImm8, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Imm*/2,
     /* 191191 */   GIR_AddImm8, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Imm*/61,
     /* 191195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 375(*/0xF7, 0x02/*)*/,
     /* 191198 */   GIR_MakeTempReg, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191202 */   GIR_BuildMI, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191207 */   GIR_AddTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191214 */   GIR_AddSimpleTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/,
     /* 191219 */   GIR_AddSimpleTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/,
     /* 191224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 374(*/0xF6, 0x02/*)*/,
     /* 191227 */   GIR_MakeTempReg, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191231 */   GIR_BuildMI, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191236 */   GIR_AddTempRegister, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191243 */   GIR_AddImm, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 373(*/0xF5, 0x02/*)*/,
     /* 191257 */   GIR_MakeTempReg, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191261 */   GIR_BuildMI, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191266 */   GIR_AddTempRegister, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191273 */   GIR_AddSimpleTempRegister, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/,
     /* 191278 */   GIR_AddImm, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 372(*/0xF4, 0x02/*)*/,
     /* 191292 */   GIR_MakeTempReg, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191296 */   GIR_BuildMI, /*InsnID*//* 371(*/0xF3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191301 */   GIR_AddTempRegister, /*InsnID*//* 371(*/0xF3, 0x02/*)*/, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 371(*/0xF3, 0x02/*)*/,
     /* 191311 */   GIR_MakeTempReg, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191315 */   GIR_BuildMI, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191320 */   GIR_AddTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191327 */   GIR_AddSimpleTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/,
     /* 191332 */   GIR_AddSimpleTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/,
     /* 191337 */   GIR_AddImm8, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Imm*/1,
     /* 191341 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191347 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191353 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191359 */   GIR_MakeTempReg, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191363 */   GIR_BuildMI, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191368 */   GIR_AddTempRegister, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191375 */   GIR_AddSimpleTempRegister, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/,
     /* 191380 */   GIR_AddImm8, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Imm*/32,
     /* 191384 */   GIR_AddImm8, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Imm*/31,
     /* 191388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 369(*/0xF1, 0x02/*)*/,
     /* 191391 */   GIR_MakeTempReg, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191395 */   GIR_BuildMI, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191400 */   GIR_AddTempRegister, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191407 */   GIR_AddSimpleTempRegister, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/,
     /* 191412 */   GIR_AddImm, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 368(*/0xF0, 0x02/*)*/,
     /* 191426 */   GIR_MakeTempReg, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191430 */   GIR_BuildMI, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191435 */   GIR_AddTempRegister, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191442 */   GIR_AddSimpleTempRegister, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/,
     /* 191447 */   GIR_AddImm, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 367(*/0xEF, 0x02/*)*/,
     /* 191461 */   GIR_MakeTempReg, /*TempRegID*//* 365(*/0xED, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191465 */   GIR_BuildMI, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191470 */   GIR_AddTempRegister, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*TempRegID*//* 365(*/0xED, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191477 */   GIR_AddImm, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 366(*/0xEE, 0x02/*)*/,
     /* 191491 */   GIR_MakeTempReg, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191495 */   GIR_BuildMI, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191500 */   GIR_AddTempRegister, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191507 */   GIR_AddSimpleTempRegister, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*TempRegID*//* 365(*/0xED, 0x02/*)*/,
     /* 191512 */   GIR_AddImm, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 365(*/0xED, 0x02/*)*/,
     /* 191526 */   GIR_MakeTempReg, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191530 */   GIR_BuildMI, /*InsnID*//* 364(*/0xEC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191535 */   GIR_AddTempRegister, /*InsnID*//* 364(*/0xEC, 0x02/*)*/, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191542 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 364(*/0xEC, 0x02/*)*/,
     /* 191545 */   GIR_MakeTempReg, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191549 */   GIR_BuildMI, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191554 */   GIR_AddTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191561 */   GIR_AddSimpleTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/,
     /* 191566 */   GIR_AddSimpleTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/,
     /* 191571 */   GIR_AddImm8, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Imm*/1,
     /* 191575 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191581 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191587 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191593 */   GIR_MakeTempReg, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191597 */   GIR_BuildMI, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191602 */   GIR_AddTempRegister, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191609 */   GIR_AddSimpleTempRegister, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/,
     /* 191614 */   GIR_AddImm8, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Imm*/32,
     /* 191618 */   GIR_AddImm8, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Imm*/31,
     /* 191622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 362(*/0xEA, 0x02/*)*/,
     /* 191625 */   GIR_MakeTempReg, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191629 */   GIR_BuildMI, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191634 */   GIR_AddTempRegister, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191641 */   GIR_AddSimpleTempRegister, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/,
     /* 191646 */   GIR_AddImm, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 361(*/0xE9, 0x02/*)*/,
     /* 191660 */   GIR_MakeTempReg, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191664 */   GIR_BuildMI, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191669 */   GIR_AddTempRegister, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191676 */   GIR_AddSimpleTempRegister, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/,
     /* 191681 */   GIR_AddImm, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 360(*/0xE8, 0x02/*)*/,
     /* 191695 */   GIR_MakeTempReg, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191699 */   GIR_BuildMI, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191704 */   GIR_AddTempRegister, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191711 */   GIR_Copy, /*NewInsnID*//* 359(*/0xE7, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 191716 */   GIR_AddImm8, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Imm*/1,
     /* 191720 */   GIR_AddImm8, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Imm*/62,
     /* 191724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 359(*/0xE7, 0x02/*)*/,
     /* 191727 */   GIR_MakeTempReg, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191731 */   GIR_BuildMI, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191736 */   GIR_AddTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191743 */   GIR_AddSimpleTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/,
     /* 191748 */   GIR_AddSimpleTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/,
     /* 191753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 358(*/0xE6, 0x02/*)*/,
     /* 191756 */   GIR_MakeTempReg, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191760 */   GIR_BuildMI, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191765 */   GIR_AddTempRegister, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191772 */   GIR_AddImm, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 357(*/0xE5, 0x02/*)*/,
     /* 191786 */   GIR_MakeTempReg, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191790 */   GIR_BuildMI, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191795 */   GIR_AddTempRegister, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191802 */   GIR_AddSimpleTempRegister, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/,
     /* 191807 */   GIR_AddImm, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 356(*/0xE4, 0x02/*)*/,
     /* 191821 */   GIR_MakeTempReg, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191825 */   GIR_BuildMI, /*InsnID*//* 355(*/0xE3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191830 */   GIR_AddTempRegister, /*InsnID*//* 355(*/0xE3, 0x02/*)*/, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 355(*/0xE3, 0x02/*)*/,
     /* 191840 */   GIR_MakeTempReg, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191844 */   GIR_BuildMI, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191849 */   GIR_AddTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191856 */   GIR_AddSimpleTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/,
     /* 191861 */   GIR_AddSimpleTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/,
     /* 191866 */   GIR_AddImm8, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Imm*/1,
     /* 191870 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191876 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191882 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191888 */   GIR_MakeTempReg, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191892 */   GIR_BuildMI, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191897 */   GIR_AddTempRegister, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191904 */   GIR_AddSimpleTempRegister, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/,
     /* 191909 */   GIR_AddImm8, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Imm*/32,
     /* 191913 */   GIR_AddImm8, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Imm*/31,
     /* 191917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 353(*/0xE1, 0x02/*)*/,
     /* 191920 */   GIR_MakeTempReg, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191924 */   GIR_BuildMI, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191929 */   GIR_AddTempRegister, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191936 */   GIR_AddSimpleTempRegister, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/,
     /* 191941 */   GIR_AddImm, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 352(*/0xE0, 0x02/*)*/,
     /* 191955 */   GIR_MakeTempReg, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191959 */   GIR_BuildMI, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191964 */   GIR_AddTempRegister, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191971 */   GIR_AddSimpleTempRegister, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/,
     /* 191976 */   GIR_AddImm, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 351(*/0xDF, 0x02/*)*/,
     /* 191990 */   GIR_MakeTempReg, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191994 */   GIR_BuildMI, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 191999 */   GIR_AddTempRegister, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192006 */   GIR_Copy, /*NewInsnID*//* 350(*/0xDE, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 192011 */   GIR_AddImm8, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Imm*/63,
     /* 192015 */   GIR_AddImm8, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Imm*/1,
     /* 192019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 350(*/0xDE, 0x02/*)*/,
     /* 192022 */   GIR_MakeTempReg, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192026 */   GIR_BuildMI, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192031 */   GIR_AddTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192038 */   GIR_AddSimpleTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/,
     /* 192043 */   GIR_AddSimpleTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/,
     /* 192048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 349(*/0xDD, 0x02/*)*/,
     /* 192051 */   GIR_MakeTempReg, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192055 */   GIR_BuildMI, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 192060 */   GIR_AddTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192067 */   GIR_AddSimpleTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/,
     /* 192072 */   GIR_AddSimpleTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/,
     /* 192077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 348(*/0xDC, 0x02/*)*/,
     /* 192080 */   GIR_MakeTempReg, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192084 */   GIR_BuildMI, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 192089 */   GIR_AddTempRegister, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192096 */   GIR_AddSimpleTempRegister, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/,
     /* 192101 */   GIR_AddImm8, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Imm*/62,
     /* 192105 */   GIR_AddImm8, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Imm*/2,
     /* 192109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 347(*/0xDB, 0x02/*)*/,
     /* 192112 */   GIR_MakeTempReg, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192116 */   GIR_BuildMI, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192121 */   GIR_AddTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192128 */   GIR_AddSimpleTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/,
     /* 192133 */   GIR_AddSimpleTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/,
     /* 192138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 346(*/0xDA, 0x02/*)*/,
     /* 192141 */   GIR_MakeTempReg, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192145 */   GIR_BuildMI, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 192150 */   GIR_AddTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192157 */   GIR_AddSimpleTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/,
     /* 192162 */   GIR_AddSimpleTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/,
     /* 192167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 345(*/0xD9, 0x02/*)*/,
     /* 192170 */   GIR_MakeTempReg, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192174 */   GIR_BuildMI, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192179 */   GIR_AddTempRegister, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192186 */   GIR_AddSimpleTempRegister, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/,
     /* 192191 */   GIR_AddImm8, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Imm*/4,
     /* 192195 */   GIR_AddImm8, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Imm*/59,
     /* 192199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 344(*/0xD8, 0x02/*)*/,
     /* 192202 */   GIR_MakeTempReg, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192206 */   GIR_BuildMI, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192211 */   GIR_AddTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192218 */   GIR_AddSimpleTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/,
     /* 192223 */   GIR_AddSimpleTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 401(*/0x91, 0x03/*)*/,
     /* 192228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 343(*/0xD7, 0x02/*)*/,
     /* 192231 */   GIR_MakeTempReg, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192235 */   GIR_BuildMI, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192240 */   GIR_AddTempRegister, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192247 */   GIR_AddImm, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 342(*/0xD6, 0x02/*)*/,
     /* 192261 */   GIR_MakeTempReg, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192265 */   GIR_BuildMI, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192270 */   GIR_AddTempRegister, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192277 */   GIR_AddSimpleTempRegister, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/,
     /* 192282 */   GIR_AddImm, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 341(*/0xD5, 0x02/*)*/,
     /* 192296 */   GIR_MakeTempReg, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192300 */   GIR_BuildMI, /*InsnID*//* 340(*/0xD4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192305 */   GIR_AddTempRegister, /*InsnID*//* 340(*/0xD4, 0x02/*)*/, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 340(*/0xD4, 0x02/*)*/,
     /* 192315 */   GIR_MakeTempReg, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192319 */   GIR_BuildMI, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192324 */   GIR_AddTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192331 */   GIR_AddSimpleTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/,
     /* 192336 */   GIR_AddSimpleTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/,
     /* 192341 */   GIR_AddImm8, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Imm*/1,
     /* 192345 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192351 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192357 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192363 */   GIR_MakeTempReg, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192367 */   GIR_BuildMI, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192372 */   GIR_AddTempRegister, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192379 */   GIR_AddSimpleTempRegister, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/,
     /* 192384 */   GIR_AddImm8, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Imm*/32,
     /* 192388 */   GIR_AddImm8, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Imm*/31,
     /* 192392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 338(*/0xD2, 0x02/*)*/,
     /* 192395 */   GIR_MakeTempReg, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192399 */   GIR_BuildMI, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192404 */   GIR_AddTempRegister, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192411 */   GIR_AddSimpleTempRegister, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/,
     /* 192416 */   GIR_AddImm, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 337(*/0xD1, 0x02/*)*/,
     /* 192430 */   GIR_MakeTempReg, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192434 */   GIR_BuildMI, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192439 */   GIR_AddTempRegister, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192446 */   GIR_AddSimpleTempRegister, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/,
     /* 192451 */   GIR_AddImm, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 336(*/0xD0, 0x02/*)*/,
     /* 192465 */   GIR_MakeTempReg, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192469 */   GIR_BuildMI, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192474 */   GIR_AddTempRegister, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192481 */   GIR_AddImm, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 335(*/0xCF, 0x02/*)*/,
     /* 192495 */   GIR_MakeTempReg, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192499 */   GIR_BuildMI, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192504 */   GIR_AddTempRegister, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192511 */   GIR_AddSimpleTempRegister, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/,
     /* 192516 */   GIR_AddImm, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 334(*/0xCE, 0x02/*)*/,
     /* 192530 */   GIR_MakeTempReg, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192534 */   GIR_BuildMI, /*InsnID*//* 333(*/0xCD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192539 */   GIR_AddTempRegister, /*InsnID*//* 333(*/0xCD, 0x02/*)*/, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 333(*/0xCD, 0x02/*)*/,
     /* 192549 */   GIR_MakeTempReg, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192553 */   GIR_BuildMI, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192558 */   GIR_AddTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192565 */   GIR_AddSimpleTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/,
     /* 192570 */   GIR_AddSimpleTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/,
     /* 192575 */   GIR_AddImm8, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Imm*/1,
     /* 192579 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192585 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192591 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192597 */   GIR_MakeTempReg, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192601 */   GIR_BuildMI, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192606 */   GIR_AddTempRegister, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192613 */   GIR_AddSimpleTempRegister, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/,
     /* 192618 */   GIR_AddImm8, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Imm*/32,
     /* 192622 */   GIR_AddImm8, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Imm*/31,
     /* 192626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 331(*/0xCB, 0x02/*)*/,
     /* 192629 */   GIR_MakeTempReg, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192633 */   GIR_BuildMI, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192638 */   GIR_AddTempRegister, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192645 */   GIR_AddSimpleTempRegister, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/,
     /* 192650 */   GIR_AddImm, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 330(*/0xCA, 0x02/*)*/,
     /* 192664 */   GIR_MakeTempReg, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192668 */   GIR_BuildMI, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192673 */   GIR_AddTempRegister, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192680 */   GIR_AddSimpleTempRegister, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/,
     /* 192685 */   GIR_AddImm, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 329(*/0xC9, 0x02/*)*/,
     /* 192699 */   GIR_MakeTempReg, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192703 */   GIR_BuildMI, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192708 */   GIR_AddTempRegister, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192715 */   GIR_AddImm, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 328(*/0xC8, 0x02/*)*/,
     /* 192729 */   GIR_MakeTempReg, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192733 */   GIR_BuildMI, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192738 */   GIR_AddTempRegister, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192745 */   GIR_AddSimpleTempRegister, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/,
     /* 192750 */   GIR_AddImm, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 327(*/0xC7, 0x02/*)*/,
     /* 192764 */   GIR_MakeTempReg, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192768 */   GIR_BuildMI, /*InsnID*//* 326(*/0xC6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192773 */   GIR_AddTempRegister, /*InsnID*//* 326(*/0xC6, 0x02/*)*/, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 326(*/0xC6, 0x02/*)*/,
     /* 192783 */   GIR_MakeTempReg, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192787 */   GIR_BuildMI, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192792 */   GIR_AddTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192799 */   GIR_AddSimpleTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/,
     /* 192804 */   GIR_AddSimpleTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/,
     /* 192809 */   GIR_AddImm8, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Imm*/1,
     /* 192813 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192819 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192825 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192831 */   GIR_MakeTempReg, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192835 */   GIR_BuildMI, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192840 */   GIR_AddTempRegister, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192847 */   GIR_AddSimpleTempRegister, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/,
     /* 192852 */   GIR_AddImm8, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Imm*/32,
     /* 192856 */   GIR_AddImm8, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Imm*/31,
     /* 192860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 324(*/0xC4, 0x02/*)*/,
     /* 192863 */   GIR_MakeTempReg, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192867 */   GIR_BuildMI, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192872 */   GIR_AddTempRegister, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192879 */   GIR_AddSimpleTempRegister, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/,
     /* 192884 */   GIR_AddImm, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 323(*/0xC3, 0x02/*)*/,
     /* 192898 */   GIR_MakeTempReg, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192902 */   GIR_BuildMI, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192907 */   GIR_AddTempRegister, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192914 */   GIR_AddSimpleTempRegister, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/,
     /* 192919 */   GIR_AddImm, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 322(*/0xC2, 0x02/*)*/,
     /* 192933 */   GIR_MakeTempReg, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192937 */   GIR_BuildMI, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192942 */   GIR_AddTempRegister, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192949 */   GIR_Copy, /*NewInsnID*//* 321(*/0xC1, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 192954 */   GIR_AddImm8, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Imm*/1,
     /* 192958 */   GIR_AddImm8, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Imm*/62,
     /* 192962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 321(*/0xC1, 0x02/*)*/,
     /* 192965 */   GIR_MakeTempReg, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192969 */   GIR_BuildMI, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192974 */   GIR_AddTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192981 */   GIR_AddSimpleTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/,
     /* 192986 */   GIR_AddSimpleTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/,
     /* 192991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 320(*/0xC0, 0x02/*)*/,
     /* 192994 */   GIR_MakeTempReg, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192998 */   GIR_BuildMI, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193003 */   GIR_AddTempRegister, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193010 */   GIR_AddImm, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 319(*/0xBF, 0x02/*)*/,
     /* 193024 */   GIR_MakeTempReg, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193028 */   GIR_BuildMI, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193033 */   GIR_AddTempRegister, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193040 */   GIR_AddSimpleTempRegister, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/,
     /* 193045 */   GIR_AddImm, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193056 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 318(*/0xBE, 0x02/*)*/,
     /* 193059 */   GIR_MakeTempReg, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193063 */   GIR_BuildMI, /*InsnID*//* 317(*/0xBD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193068 */   GIR_AddTempRegister, /*InsnID*//* 317(*/0xBD, 0x02/*)*/, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 317(*/0xBD, 0x02/*)*/,
     /* 193078 */   GIR_MakeTempReg, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193082 */   GIR_BuildMI, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193087 */   GIR_AddTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193094 */   GIR_AddSimpleTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/,
     /* 193099 */   GIR_AddSimpleTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/,
     /* 193104 */   GIR_AddImm8, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Imm*/1,
     /* 193108 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193114 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193120 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193126 */   GIR_MakeTempReg, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193130 */   GIR_BuildMI, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193135 */   GIR_AddTempRegister, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193142 */   GIR_AddSimpleTempRegister, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/,
     /* 193147 */   GIR_AddImm8, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Imm*/32,
     /* 193151 */   GIR_AddImm8, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Imm*/31,
     /* 193155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 315(*/0xBB, 0x02/*)*/,
     /* 193158 */   GIR_MakeTempReg, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193162 */   GIR_BuildMI, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193167 */   GIR_AddTempRegister, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193174 */   GIR_AddSimpleTempRegister, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/,
     /* 193179 */   GIR_AddImm, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 314(*/0xBA, 0x02/*)*/,
     /* 193193 */   GIR_MakeTempReg, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193197 */   GIR_BuildMI, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193202 */   GIR_AddTempRegister, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193209 */   GIR_AddSimpleTempRegister, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/,
     /* 193214 */   GIR_AddImm, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 313(*/0xB9, 0x02/*)*/,
     /* 193228 */   GIR_MakeTempReg, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193232 */   GIR_BuildMI, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 193237 */   GIR_AddTempRegister, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193244 */   GIR_Copy, /*NewInsnID*//* 312(*/0xB8, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 193249 */   GIR_AddImm8, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Imm*/63,
     /* 193253 */   GIR_AddImm8, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Imm*/1,
     /* 193257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 312(*/0xB8, 0x02/*)*/,
     /* 193260 */   GIR_MakeTempReg, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193264 */   GIR_BuildMI, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193269 */   GIR_AddTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193276 */   GIR_AddSimpleTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/,
     /* 193281 */   GIR_AddSimpleTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/,
     /* 193286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 311(*/0xB7, 0x02/*)*/,
     /* 193289 */   GIR_MakeTempReg, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193293 */   GIR_BuildMI, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 193298 */   GIR_AddTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193305 */   GIR_AddSimpleTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/,
     /* 193310 */   GIR_AddSimpleTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/,
     /* 193315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 310(*/0xB6, 0x02/*)*/,
     /* 193318 */   GIR_MakeTempReg, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193322 */   GIR_BuildMI, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193327 */   GIR_AddTempRegister, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193334 */   GIR_AddSimpleTempRegister, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/,
     /* 193339 */   GIR_AddImm8, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Imm*/2,
     /* 193343 */   GIR_AddImm8, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Imm*/61,
     /* 193347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 309(*/0xB5, 0x02/*)*/,
     /* 193350 */   GIR_MakeTempReg, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193354 */   GIR_BuildMI, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193359 */   GIR_AddTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193366 */   GIR_AddSimpleTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/,
     /* 193371 */   GIR_AddSimpleTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/,
     /* 193376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 308(*/0xB4, 0x02/*)*/,
     /* 193379 */   GIR_MakeTempReg, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193383 */   GIR_BuildMI, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193388 */   GIR_AddTempRegister, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193395 */   GIR_AddImm, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 307(*/0xB3, 0x02/*)*/,
     /* 193409 */   GIR_MakeTempReg, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193413 */   GIR_BuildMI, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193418 */   GIR_AddTempRegister, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193425 */   GIR_AddSimpleTempRegister, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/,
     /* 193430 */   GIR_AddImm, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 306(*/0xB2, 0x02/*)*/,
     /* 193444 */   GIR_MakeTempReg, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193448 */   GIR_BuildMI, /*InsnID*//* 305(*/0xB1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193453 */   GIR_AddTempRegister, /*InsnID*//* 305(*/0xB1, 0x02/*)*/, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 305(*/0xB1, 0x02/*)*/,
     /* 193463 */   GIR_MakeTempReg, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193467 */   GIR_BuildMI, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193472 */   GIR_AddTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193479 */   GIR_AddSimpleTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/,
     /* 193484 */   GIR_AddSimpleTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/,
     /* 193489 */   GIR_AddImm8, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Imm*/1,
     /* 193493 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193499 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193505 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193511 */   GIR_MakeTempReg, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193515 */   GIR_BuildMI, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193520 */   GIR_AddTempRegister, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193527 */   GIR_AddSimpleTempRegister, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/,
     /* 193532 */   GIR_AddImm8, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Imm*/32,
     /* 193536 */   GIR_AddImm8, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Imm*/31,
     /* 193540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 303(*/0xAF, 0x02/*)*/,
     /* 193543 */   GIR_MakeTempReg, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193547 */   GIR_BuildMI, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193552 */   GIR_AddTempRegister, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193559 */   GIR_AddSimpleTempRegister, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/,
     /* 193564 */   GIR_AddImm, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 302(*/0xAE, 0x02/*)*/,
     /* 193578 */   GIR_MakeTempReg, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193582 */   GIR_BuildMI, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193587 */   GIR_AddTempRegister, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193594 */   GIR_AddSimpleTempRegister, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/,
     /* 193599 */   GIR_AddImm, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 301(*/0xAD, 0x02/*)*/,
     /* 193613 */   GIR_MakeTempReg, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193617 */   GIR_BuildMI, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193622 */   GIR_AddTempRegister, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193629 */   GIR_AddImm, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 300(*/0xAC, 0x02/*)*/,
     /* 193643 */   GIR_MakeTempReg, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193647 */   GIR_BuildMI, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193652 */   GIR_AddTempRegister, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193659 */   GIR_AddSimpleTempRegister, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/,
     /* 193664 */   GIR_AddImm, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 299(*/0xAB, 0x02/*)*/,
     /* 193678 */   GIR_MakeTempReg, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193682 */   GIR_BuildMI, /*InsnID*//* 298(*/0xAA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193687 */   GIR_AddTempRegister, /*InsnID*//* 298(*/0xAA, 0x02/*)*/, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 298(*/0xAA, 0x02/*)*/,
     /* 193697 */   GIR_MakeTempReg, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193701 */   GIR_BuildMI, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193706 */   GIR_AddTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193713 */   GIR_AddSimpleTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/,
     /* 193718 */   GIR_AddSimpleTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/,
     /* 193723 */   GIR_AddImm8, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Imm*/1,
     /* 193727 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193733 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193739 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193745 */   GIR_MakeTempReg, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193749 */   GIR_BuildMI, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193754 */   GIR_AddTempRegister, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193761 */   GIR_AddSimpleTempRegister, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/,
     /* 193766 */   GIR_AddImm8, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Imm*/32,
     /* 193770 */   GIR_AddImm8, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Imm*/31,
     /* 193774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 296(*/0xA8, 0x02/*)*/,
     /* 193777 */   GIR_MakeTempReg, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193781 */   GIR_BuildMI, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193786 */   GIR_AddTempRegister, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193793 */   GIR_AddSimpleTempRegister, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/,
     /* 193798 */   GIR_AddImm, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193809 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 295(*/0xA7, 0x02/*)*/,
     /* 193812 */   GIR_MakeTempReg, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193816 */   GIR_BuildMI, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193821 */   GIR_AddTempRegister, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193828 */   GIR_AddSimpleTempRegister, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/,
     /* 193833 */   GIR_AddImm, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 294(*/0xA6, 0x02/*)*/,
     /* 193847 */   GIR_MakeTempReg, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193851 */   GIR_BuildMI, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193856 */   GIR_AddTempRegister, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193863 */   GIR_Copy, /*NewInsnID*//* 293(*/0xA5, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 193868 */   GIR_AddImm8, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Imm*/1,
     /* 193872 */   GIR_AddImm8, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Imm*/62,
     /* 193876 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 293(*/0xA5, 0x02/*)*/,
     /* 193879 */   GIR_MakeTempReg, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193883 */   GIR_BuildMI, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193888 */   GIR_AddTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193895 */   GIR_AddSimpleTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/,
     /* 193900 */   GIR_AddSimpleTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/,
     /* 193905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 292(*/0xA4, 0x02/*)*/,
     /* 193908 */   GIR_MakeTempReg, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193912 */   GIR_BuildMI, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193917 */   GIR_AddTempRegister, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193924 */   GIR_AddImm, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 291(*/0xA3, 0x02/*)*/,
     /* 193938 */   GIR_MakeTempReg, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193942 */   GIR_BuildMI, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193947 */   GIR_AddTempRegister, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193954 */   GIR_AddSimpleTempRegister, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/,
     /* 193959 */   GIR_AddImm, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 290(*/0xA2, 0x02/*)*/,
     /* 193973 */   GIR_MakeTempReg, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193977 */   GIR_BuildMI, /*InsnID*//* 289(*/0xA1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193982 */   GIR_AddTempRegister, /*InsnID*//* 289(*/0xA1, 0x02/*)*/, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 289(*/0xA1, 0x02/*)*/,
     /* 193992 */   GIR_MakeTempReg, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193996 */   GIR_BuildMI, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194001 */   GIR_AddTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194008 */   GIR_AddSimpleTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/,
     /* 194013 */   GIR_AddSimpleTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/,
     /* 194018 */   GIR_AddImm8, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Imm*/1,
     /* 194022 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194028 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194034 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194040 */   GIR_MakeTempReg, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194044 */   GIR_BuildMI, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194049 */   GIR_AddTempRegister, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194056 */   GIR_AddSimpleTempRegister, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/,
     /* 194061 */   GIR_AddImm8, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Imm*/32,
     /* 194065 */   GIR_AddImm8, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Imm*/31,
     /* 194069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 287(*/0x9F, 0x02/*)*/,
     /* 194072 */   GIR_MakeTempReg, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194076 */   GIR_BuildMI, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194081 */   GIR_AddTempRegister, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194088 */   GIR_AddSimpleTempRegister, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/,
     /* 194093 */   GIR_AddImm, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 286(*/0x9E, 0x02/*)*/,
     /* 194107 */   GIR_MakeTempReg, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194111 */   GIR_BuildMI, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194116 */   GIR_AddTempRegister, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194123 */   GIR_AddSimpleTempRegister, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/,
     /* 194128 */   GIR_AddImm, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 285(*/0x9D, 0x02/*)*/,
     /* 194142 */   GIR_MakeTempReg, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194146 */   GIR_BuildMI, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 194151 */   GIR_AddTempRegister, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194158 */   GIR_Copy, /*NewInsnID*//* 284(*/0x9C, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 194163 */   GIR_AddImm8, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Imm*/63,
     /* 194167 */   GIR_AddImm8, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Imm*/1,
     /* 194171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 284(*/0x9C, 0x02/*)*/,
     /* 194174 */   GIR_MakeTempReg, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194178 */   GIR_BuildMI, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194183 */   GIR_AddTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194190 */   GIR_AddSimpleTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/,
     /* 194195 */   GIR_AddSimpleTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/,
     /* 194200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 283(*/0x9B, 0x02/*)*/,
     /* 194203 */   GIR_MakeTempReg, /*TempRegID*//* 281(*/0x99, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194207 */   GIR_BuildMI, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 194212 */   GIR_AddTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 281(*/0x99, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194219 */   GIR_AddSimpleTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/,
     /* 194224 */   GIR_AddSimpleTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/,
     /* 194229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 282(*/0x9A, 0x02/*)*/,
     /* 194232 */   GIR_MakeTempReg, /*TempRegID*//* 280(*/0x98, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194236 */   GIR_BuildMI, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 194241 */   GIR_AddTempRegister, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*TempRegID*//* 280(*/0x98, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194248 */   GIR_AddSimpleTempRegister, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*TempRegID*//* 281(*/0x99, 0x02/*)*/,
     /* 194253 */   GIR_AddImm8, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Imm*/62,
     /* 194257 */   GIR_AddImm8, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Imm*/2,
     /* 194261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 281(*/0x99, 0x02/*)*/,
     /* 194264 */   GIR_MakeTempReg, /*TempRegID*//* 279(*/0x97, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194268 */   GIR_BuildMI, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194273 */   GIR_AddTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 279(*/0x97, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194280 */   GIR_AddSimpleTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 280(*/0x98, 0x02/*)*/,
     /* 194285 */   GIR_AddSimpleTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/,
     /* 194290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 280(*/0x98, 0x02/*)*/,
     /* 194293 */   GIR_MakeTempReg, /*TempRegID*//* 278(*/0x96, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194297 */   GIR_BuildMI, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 194302 */   GIR_AddTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 278(*/0x96, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194309 */   GIR_AddSimpleTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 279(*/0x97, 0x02/*)*/,
     /* 194314 */   GIR_AddSimpleTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/,
     /* 194319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 279(*/0x97, 0x02/*)*/,
     /* 194322 */   GIR_MakeTempReg, /*TempRegID*//* 277(*/0x95, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194326 */   GIR_BuildMI, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 194331 */   GIR_AddTempRegister, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*TempRegID*//* 277(*/0x95, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194338 */   GIR_AddSimpleTempRegister, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*TempRegID*//* 278(*/0x96, 0x02/*)*/,
     /* 194343 */   GIR_AddImm8, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Imm*/60,
     /* 194347 */   GIR_AddImm8, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Imm*/4,
     /* 194351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 278(*/0x96, 0x02/*)*/,
     /* 194354 */   GIR_MakeTempReg, /*TempRegID*//* 276(*/0x94, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194358 */   GIR_BuildMI, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194363 */   GIR_AddTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 276(*/0x94, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194370 */   GIR_AddSimpleTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 277(*/0x95, 0x02/*)*/,
     /* 194375 */   GIR_AddSimpleTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/,
     /* 194380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 277(*/0x95, 0x02/*)*/,
     /* 194383 */   GIR_MakeTempReg, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194387 */   GIR_BuildMI, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 194392 */   GIR_AddTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194399 */   GIR_AddSimpleTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 276(*/0x94, 0x02/*)*/,
     /* 194404 */   GIR_AddSimpleTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/,
     /* 194409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 276(*/0x94, 0x02/*)*/,
     /* 194412 */   GIR_MakeTempReg, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194416 */   GIR_BuildMI, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194421 */   GIR_AddTempRegister, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194428 */   GIR_AddImm, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 548(*/0xA4, 0x04/*)*/,
     /* 194442 */   GIR_MakeTempReg, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194446 */   GIR_BuildMI, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194451 */   GIR_AddTempRegister, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194458 */   GIR_AddSimpleTempRegister, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/,
     /* 194463 */   GIR_AddImm, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 547(*/0xA3, 0x04/*)*/,
     /* 194477 */   GIR_MakeTempReg, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194481 */   GIR_BuildMI, /*InsnID*//* 546(*/0xA2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194486 */   GIR_AddTempRegister, /*InsnID*//* 546(*/0xA2, 0x04/*)*/, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 546(*/0xA2, 0x04/*)*/,
     /* 194496 */   GIR_MakeTempReg, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194500 */   GIR_BuildMI, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194505 */   GIR_AddTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194512 */   GIR_AddSimpleTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/,
     /* 194517 */   GIR_AddSimpleTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/,
     /* 194522 */   GIR_AddImm8, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Imm*/1,
     /* 194526 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194532 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194538 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194544 */   GIR_MakeTempReg, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194548 */   GIR_BuildMI, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194553 */   GIR_AddTempRegister, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194560 */   GIR_AddSimpleTempRegister, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/,
     /* 194565 */   GIR_AddImm8, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Imm*/32,
     /* 194569 */   GIR_AddImm8, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Imm*/31,
     /* 194573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 544(*/0xA0, 0x04/*)*/,
     /* 194576 */   GIR_MakeTempReg, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194580 */   GIR_BuildMI, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194585 */   GIR_AddTempRegister, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194592 */   GIR_AddSimpleTempRegister, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/,
     /* 194597 */   GIR_AddImm, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194608 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 543(*/0x9F, 0x04/*)*/,
     /* 194611 */   GIR_MakeTempReg, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194615 */   GIR_BuildMI, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194620 */   GIR_AddTempRegister, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194627 */   GIR_AddSimpleTempRegister, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/,
     /* 194632 */   GIR_AddImm, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 542(*/0x9E, 0x04/*)*/,
     /* 194646 */   GIR_MakeTempReg, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194650 */   GIR_BuildMI, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194655 */   GIR_AddTempRegister, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194662 */   GIR_AddImm, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 541(*/0x9D, 0x04/*)*/,
     /* 194676 */   GIR_MakeTempReg, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194680 */   GIR_BuildMI, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194685 */   GIR_AddTempRegister, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194692 */   GIR_AddSimpleTempRegister, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/,
     /* 194697 */   GIR_AddImm, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 540(*/0x9C, 0x04/*)*/,
     /* 194711 */   GIR_MakeTempReg, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194715 */   GIR_BuildMI, /*InsnID*//* 539(*/0x9B, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194720 */   GIR_AddTempRegister, /*InsnID*//* 539(*/0x9B, 0x04/*)*/, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194727 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 539(*/0x9B, 0x04/*)*/,
     /* 194730 */   GIR_MakeTempReg, /*TempRegID*//* 537(*/0x99, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194734 */   GIR_BuildMI, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194739 */   GIR_AddTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 537(*/0x99, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194746 */   GIR_AddSimpleTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/,
     /* 194751 */   GIR_AddSimpleTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/,
     /* 194756 */   GIR_AddImm8, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Imm*/1,
     /* 194760 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194766 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194772 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194778 */   GIR_MakeTempReg, /*TempRegID*//* 536(*/0x98, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194782 */   GIR_BuildMI, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194787 */   GIR_AddTempRegister, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*TempRegID*//* 536(*/0x98, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194794 */   GIR_AddSimpleTempRegister, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*TempRegID*//* 537(*/0x99, 0x04/*)*/,
     /* 194799 */   GIR_AddImm8, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Imm*/32,
     /* 194803 */   GIR_AddImm8, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Imm*/31,
     /* 194807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 537(*/0x99, 0x04/*)*/,
     /* 194810 */   GIR_MakeTempReg, /*TempRegID*//* 535(*/0x97, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194814 */   GIR_BuildMI, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194819 */   GIR_AddTempRegister, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*TempRegID*//* 535(*/0x97, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194826 */   GIR_AddSimpleTempRegister, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*TempRegID*//* 536(*/0x98, 0x04/*)*/,
     /* 194831 */   GIR_AddImm, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 536(*/0x98, 0x04/*)*/,
     /* 194845 */   GIR_MakeTempReg, /*TempRegID*//* 534(*/0x96, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194849 */   GIR_BuildMI, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194854 */   GIR_AddTempRegister, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*TempRegID*//* 534(*/0x96, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194861 */   GIR_AddSimpleTempRegister, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*TempRegID*//* 535(*/0x97, 0x04/*)*/,
     /* 194866 */   GIR_AddImm, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 535(*/0x97, 0x04/*)*/,
     /* 194880 */   GIR_MakeTempReg, /*TempRegID*//* 533(*/0x95, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194884 */   GIR_BuildMI, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194889 */   GIR_AddTempRegister, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*TempRegID*//* 533(*/0x95, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194896 */   GIR_AddImm, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 194907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 534(*/0x96, 0x04/*)*/,
     /* 194910 */   GIR_MakeTempReg, /*TempRegID*//* 532(*/0x94, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194914 */   GIR_BuildMI, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194919 */   GIR_AddTempRegister, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*TempRegID*//* 532(*/0x94, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194926 */   GIR_AddSimpleTempRegister, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*TempRegID*//* 533(*/0x95, 0x04/*)*/,
     /* 194931 */   GIR_AddImm, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 194942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 533(*/0x95, 0x04/*)*/,
     /* 194945 */   GIR_MakeTempReg, /*TempRegID*//* 531(*/0x93, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194949 */   GIR_BuildMI, /*InsnID*//* 532(*/0x94, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194954 */   GIR_AddTempRegister, /*InsnID*//* 532(*/0x94, 0x04/*)*/, /*TempRegID*//* 531(*/0x93, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 532(*/0x94, 0x04/*)*/,
     /* 194964 */   GIR_MakeTempReg, /*TempRegID*//* 530(*/0x92, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194968 */   GIR_BuildMI, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194973 */   GIR_AddTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 530(*/0x92, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194980 */   GIR_AddSimpleTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 531(*/0x93, 0x04/*)*/,
     /* 194985 */   GIR_AddSimpleTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 532(*/0x94, 0x04/*)*/,
     /* 194990 */   GIR_AddImm8, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Imm*/1,
     /* 194994 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195000 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195006 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195012 */   GIR_MakeTempReg, /*TempRegID*//* 529(*/0x91, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195016 */   GIR_BuildMI, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195021 */   GIR_AddTempRegister, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*TempRegID*//* 529(*/0x91, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195028 */   GIR_AddSimpleTempRegister, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*TempRegID*//* 530(*/0x92, 0x04/*)*/,
     /* 195033 */   GIR_AddImm8, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Imm*/32,
     /* 195037 */   GIR_AddImm8, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Imm*/31,
     /* 195041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 530(*/0x92, 0x04/*)*/,
     /* 195044 */   GIR_MakeTempReg, /*TempRegID*//* 528(*/0x90, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195048 */   GIR_BuildMI, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195053 */   GIR_AddTempRegister, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*TempRegID*//* 528(*/0x90, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195060 */   GIR_AddSimpleTempRegister, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*TempRegID*//* 529(*/0x91, 0x04/*)*/,
     /* 195065 */   GIR_AddImm, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 529(*/0x91, 0x04/*)*/,
     /* 195079 */   GIR_MakeTempReg, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195083 */   GIR_BuildMI, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195088 */   GIR_AddTempRegister, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195095 */   GIR_AddSimpleTempRegister, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*TempRegID*//* 528(*/0x90, 0x04/*)*/,
     /* 195100 */   GIR_AddImm, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 528(*/0x90, 0x04/*)*/,
     /* 195114 */   GIR_MakeTempReg, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195118 */   GIR_BuildMI, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195123 */   GIR_AddTempRegister, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195130 */   GIR_Copy, /*NewInsnID*//* 527(*/0x8F, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 195135 */   GIR_AddImm8, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Imm*/1,
     /* 195139 */   GIR_AddImm8, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Imm*/62,
     /* 195143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 527(*/0x8F, 0x04/*)*/,
     /* 195146 */   GIR_MakeTempReg, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195150 */   GIR_BuildMI, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195155 */   GIR_AddTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195162 */   GIR_AddSimpleTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/,
     /* 195167 */   GIR_AddSimpleTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/,
     /* 195172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 526(*/0x8E, 0x04/*)*/,
     /* 195175 */   GIR_MakeTempReg, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195179 */   GIR_BuildMI, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195184 */   GIR_AddTempRegister, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195191 */   GIR_AddImm, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 525(*/0x8D, 0x04/*)*/,
     /* 195205 */   GIR_MakeTempReg, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195209 */   GIR_BuildMI, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195214 */   GIR_AddTempRegister, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195221 */   GIR_AddSimpleTempRegister, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/,
     /* 195226 */   GIR_AddImm, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 524(*/0x8C, 0x04/*)*/,
     /* 195240 */   GIR_MakeTempReg, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195244 */   GIR_BuildMI, /*InsnID*//* 523(*/0x8B, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195249 */   GIR_AddTempRegister, /*InsnID*//* 523(*/0x8B, 0x04/*)*/, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 523(*/0x8B, 0x04/*)*/,
     /* 195259 */   GIR_MakeTempReg, /*TempRegID*//* 521(*/0x89, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195263 */   GIR_BuildMI, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195268 */   GIR_AddTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 521(*/0x89, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195275 */   GIR_AddSimpleTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/,
     /* 195280 */   GIR_AddSimpleTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/,
     /* 195285 */   GIR_AddImm8, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Imm*/1,
     /* 195289 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195295 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195301 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195307 */   GIR_MakeTempReg, /*TempRegID*//* 520(*/0x88, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195311 */   GIR_BuildMI, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195316 */   GIR_AddTempRegister, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*TempRegID*//* 520(*/0x88, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195323 */   GIR_AddSimpleTempRegister, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*TempRegID*//* 521(*/0x89, 0x04/*)*/,
     /* 195328 */   GIR_AddImm8, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Imm*/32,
     /* 195332 */   GIR_AddImm8, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Imm*/31,
     /* 195336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 521(*/0x89, 0x04/*)*/,
     /* 195339 */   GIR_MakeTempReg, /*TempRegID*//* 519(*/0x87, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195343 */   GIR_BuildMI, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195348 */   GIR_AddTempRegister, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*TempRegID*//* 519(*/0x87, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195355 */   GIR_AddSimpleTempRegister, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*TempRegID*//* 520(*/0x88, 0x04/*)*/,
     /* 195360 */   GIR_AddImm, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 520(*/0x88, 0x04/*)*/,
     /* 195374 */   GIR_MakeTempReg, /*TempRegID*//* 518(*/0x86, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195378 */   GIR_BuildMI, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195383 */   GIR_AddTempRegister, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*TempRegID*//* 518(*/0x86, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195390 */   GIR_AddSimpleTempRegister, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*TempRegID*//* 519(*/0x87, 0x04/*)*/,
     /* 195395 */   GIR_AddImm, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 519(*/0x87, 0x04/*)*/,
     /* 195409 */   GIR_MakeTempReg, /*TempRegID*//* 517(*/0x85, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195413 */   GIR_BuildMI, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 195418 */   GIR_AddTempRegister, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*TempRegID*//* 517(*/0x85, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195425 */   GIR_Copy, /*NewInsnID*//* 518(*/0x86, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 195430 */   GIR_AddImm8, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Imm*/63,
     /* 195434 */   GIR_AddImm8, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Imm*/1,
     /* 195438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 518(*/0x86, 0x04/*)*/,
     /* 195441 */   GIR_MakeTempReg, /*TempRegID*//* 516(*/0x84, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195445 */   GIR_BuildMI, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195450 */   GIR_AddTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 516(*/0x84, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195457 */   GIR_AddSimpleTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 517(*/0x85, 0x04/*)*/,
     /* 195462 */   GIR_AddSimpleTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 518(*/0x86, 0x04/*)*/,
     /* 195467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 517(*/0x85, 0x04/*)*/,
     /* 195470 */   GIR_MakeTempReg, /*TempRegID*//* 515(*/0x83, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195474 */   GIR_BuildMI, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 195479 */   GIR_AddTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 515(*/0x83, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195486 */   GIR_AddSimpleTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 516(*/0x84, 0x04/*)*/,
     /* 195491 */   GIR_AddSimpleTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/,
     /* 195496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 516(*/0x84, 0x04/*)*/,
     /* 195499 */   GIR_MakeTempReg, /*TempRegID*//* 514(*/0x82, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195503 */   GIR_BuildMI, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195508 */   GIR_AddTempRegister, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*TempRegID*//* 514(*/0x82, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195515 */   GIR_AddSimpleTempRegister, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*TempRegID*//* 515(*/0x83, 0x04/*)*/,
     /* 195520 */   GIR_AddImm8, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Imm*/2,
     /* 195524 */   GIR_AddImm8, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Imm*/61,
     /* 195528 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 515(*/0x83, 0x04/*)*/,
     /* 195531 */   GIR_MakeTempReg, /*TempRegID*//* 513(*/0x81, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195535 */   GIR_BuildMI, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195540 */   GIR_AddTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 513(*/0x81, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195547 */   GIR_AddSimpleTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 514(*/0x82, 0x04/*)*/,
     /* 195552 */   GIR_AddSimpleTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 534(*/0x96, 0x04/*)*/,
     /* 195557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 514(*/0x82, 0x04/*)*/,
     /* 195560 */   GIR_MakeTempReg, /*TempRegID*//* 512(*/0x80, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195564 */   GIR_BuildMI, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195569 */   GIR_AddTempRegister, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*TempRegID*//* 512(*/0x80, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195576 */   GIR_AddImm, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195587 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 513(*/0x81, 0x04/*)*/,
     /* 195590 */   GIR_MakeTempReg, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195594 */   GIR_BuildMI, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195599 */   GIR_AddTempRegister, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195606 */   GIR_AddSimpleTempRegister, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*TempRegID*//* 512(*/0x80, 0x04/*)*/,
     /* 195611 */   GIR_AddImm, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 512(*/0x80, 0x04/*)*/,
     /* 195625 */   GIR_MakeTempReg, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195629 */   GIR_BuildMI, /*InsnID*//* 511(*/0xFF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195634 */   GIR_AddTempRegister, /*InsnID*//* 511(*/0xFF, 0x03/*)*/, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 511(*/0xFF, 0x03/*)*/,
     /* 195644 */   GIR_MakeTempReg, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195648 */   GIR_BuildMI, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195653 */   GIR_AddTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195660 */   GIR_AddSimpleTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/,
     /* 195665 */   GIR_AddSimpleTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/,
     /* 195670 */   GIR_AddImm8, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Imm*/1,
     /* 195674 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195680 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195686 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195692 */   GIR_MakeTempReg, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195696 */   GIR_BuildMI, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195701 */   GIR_AddTempRegister, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195708 */   GIR_AddSimpleTempRegister, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/,
     /* 195713 */   GIR_AddImm8, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Imm*/32,
     /* 195717 */   GIR_AddImm8, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Imm*/31,
     /* 195721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 509(*/0xFD, 0x03/*)*/,
     /* 195724 */   GIR_MakeTempReg, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195728 */   GIR_BuildMI, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195733 */   GIR_AddTempRegister, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195740 */   GIR_AddSimpleTempRegister, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/,
     /* 195745 */   GIR_AddImm, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 508(*/0xFC, 0x03/*)*/,
     /* 195759 */   GIR_MakeTempReg, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195763 */   GIR_BuildMI, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195768 */   GIR_AddTempRegister, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195775 */   GIR_AddSimpleTempRegister, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/,
     /* 195780 */   GIR_AddImm, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 507(*/0xFB, 0x03/*)*/,
     /* 195794 */   GIR_MakeTempReg, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195798 */   GIR_BuildMI, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195803 */   GIR_AddTempRegister, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195810 */   GIR_AddImm, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 506(*/0xFA, 0x03/*)*/,
     /* 195824 */   GIR_MakeTempReg, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195828 */   GIR_BuildMI, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195833 */   GIR_AddTempRegister, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195840 */   GIR_AddSimpleTempRegister, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/,
     /* 195845 */   GIR_AddImm, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 505(*/0xF9, 0x03/*)*/,
     /* 195859 */   GIR_MakeTempReg, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195863 */   GIR_BuildMI, /*InsnID*//* 504(*/0xF8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195868 */   GIR_AddTempRegister, /*InsnID*//* 504(*/0xF8, 0x03/*)*/, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 504(*/0xF8, 0x03/*)*/,
     /* 195878 */   GIR_MakeTempReg, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195882 */   GIR_BuildMI, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195887 */   GIR_AddTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195894 */   GIR_AddSimpleTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/,
     /* 195899 */   GIR_AddSimpleTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/,
     /* 195904 */   GIR_AddImm8, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Imm*/1,
     /* 195908 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195914 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195920 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195926 */   GIR_MakeTempReg, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195930 */   GIR_BuildMI, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195935 */   GIR_AddTempRegister, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195942 */   GIR_AddSimpleTempRegister, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/,
     /* 195947 */   GIR_AddImm8, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Imm*/32,
     /* 195951 */   GIR_AddImm8, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Imm*/31,
     /* 195955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 502(*/0xF6, 0x03/*)*/,
     /* 195958 */   GIR_MakeTempReg, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195962 */   GIR_BuildMI, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195967 */   GIR_AddTempRegister, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195974 */   GIR_AddSimpleTempRegister, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/,
     /* 195979 */   GIR_AddImm, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 501(*/0xF5, 0x03/*)*/,
     /* 195993 */   GIR_MakeTempReg, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195997 */   GIR_BuildMI, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196002 */   GIR_AddTempRegister, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196009 */   GIR_AddSimpleTempRegister, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/,
     /* 196014 */   GIR_AddImm, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 196025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 500(*/0xF4, 0x03/*)*/,
     /* 196028 */   GIR_MakeTempReg, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196032 */   GIR_BuildMI, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196037 */   GIR_AddTempRegister, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196044 */   GIR_Copy, /*NewInsnID*//* 499(*/0xF3, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 196049 */   GIR_AddImm8, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Imm*/1,
     /* 196053 */   GIR_AddImm8, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Imm*/62,
     /* 196057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 499(*/0xF3, 0x03/*)*/,
     /* 196060 */   GIR_MakeTempReg, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196064 */   GIR_BuildMI, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196069 */   GIR_AddTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196076 */   GIR_AddSimpleTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/,
     /* 196081 */   GIR_AddSimpleTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/,
     /* 196086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 498(*/0xF2, 0x03/*)*/,
     /* 196089 */   GIR_MakeTempReg, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196093 */   GIR_BuildMI, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196098 */   GIR_AddTempRegister, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196105 */   GIR_AddImm, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 497(*/0xF1, 0x03/*)*/,
     /* 196119 */   GIR_MakeTempReg, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196123 */   GIR_BuildMI, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196128 */   GIR_AddTempRegister, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196135 */   GIR_AddSimpleTempRegister, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/,
     /* 196140 */   GIR_AddImm, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 496(*/0xF0, 0x03/*)*/,
     /* 196154 */   GIR_MakeTempReg, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196158 */   GIR_BuildMI, /*InsnID*//* 495(*/0xEF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196163 */   GIR_AddTempRegister, /*InsnID*//* 495(*/0xEF, 0x03/*)*/, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196170 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 495(*/0xEF, 0x03/*)*/,
     /* 196173 */   GIR_MakeTempReg, /*TempRegID*//* 493(*/0xED, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196177 */   GIR_BuildMI, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196182 */   GIR_AddTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 493(*/0xED, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196189 */   GIR_AddSimpleTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/,
     /* 196194 */   GIR_AddSimpleTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/,
     /* 196199 */   GIR_AddImm8, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Imm*/1,
     /* 196203 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196209 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196215 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196221 */   GIR_MakeTempReg, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196225 */   GIR_BuildMI, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196230 */   GIR_AddTempRegister, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196237 */   GIR_AddSimpleTempRegister, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*TempRegID*//* 493(*/0xED, 0x03/*)*/,
     /* 196242 */   GIR_AddImm8, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Imm*/32,
     /* 196246 */   GIR_AddImm8, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Imm*/31,
     /* 196250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 493(*/0xED, 0x03/*)*/,
     /* 196253 */   GIR_MakeTempReg, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196257 */   GIR_BuildMI, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196262 */   GIR_AddTempRegister, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196269 */   GIR_AddSimpleTempRegister, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/,
     /* 196274 */   GIR_AddImm, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 492(*/0xEC, 0x03/*)*/,
     /* 196288 */   GIR_MakeTempReg, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196292 */   GIR_BuildMI, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196297 */   GIR_AddTempRegister, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196304 */   GIR_AddSimpleTempRegister, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/,
     /* 196309 */   GIR_AddImm, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 491(*/0xEB, 0x03/*)*/,
     /* 196323 */   GIR_MakeTempReg, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196327 */   GIR_BuildMI, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 196332 */   GIR_AddTempRegister, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196339 */   GIR_Copy, /*NewInsnID*//* 490(*/0xEA, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 196344 */   GIR_AddImm8, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Imm*/63,
     /* 196348 */   GIR_AddImm8, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Imm*/1,
     /* 196352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 490(*/0xEA, 0x03/*)*/,
     /* 196355 */   GIR_MakeTempReg, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196359 */   GIR_BuildMI, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196364 */   GIR_AddTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196371 */   GIR_AddSimpleTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/,
     /* 196376 */   GIR_AddSimpleTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/,
     /* 196381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 489(*/0xE9, 0x03/*)*/,
     /* 196384 */   GIR_MakeTempReg, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196388 */   GIR_BuildMI, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 196393 */   GIR_AddTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196400 */   GIR_AddSimpleTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/,
     /* 196405 */   GIR_AddSimpleTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/,
     /* 196410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 488(*/0xE8, 0x03/*)*/,
     /* 196413 */   GIR_MakeTempReg, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196417 */   GIR_BuildMI, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 196422 */   GIR_AddTempRegister, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196429 */   GIR_AddSimpleTempRegister, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/,
     /* 196434 */   GIR_AddImm8, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Imm*/62,
     /* 196438 */   GIR_AddImm8, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Imm*/2,
     /* 196442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 487(*/0xE7, 0x03/*)*/,
     /* 196445 */   GIR_MakeTempReg, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196449 */   GIR_BuildMI, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196454 */   GIR_AddTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196461 */   GIR_AddSimpleTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/,
     /* 196466 */   GIR_AddSimpleTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/,
     /* 196471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 486(*/0xE6, 0x03/*)*/,
     /* 196474 */   GIR_MakeTempReg, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196478 */   GIR_BuildMI, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 196483 */   GIR_AddTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196490 */   GIR_AddSimpleTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/,
     /* 196495 */   GIR_AddSimpleTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 513(*/0x81, 0x04/*)*/,
     /* 196500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 485(*/0xE5, 0x03/*)*/,
     /* 196503 */   GIR_MakeTempReg, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196507 */   GIR_BuildMI, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196512 */   GIR_AddTempRegister, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196519 */   GIR_AddSimpleTempRegister, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/,
     /* 196524 */   GIR_AddImm8, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Imm*/4,
     /* 196528 */   GIR_AddImm8, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Imm*/59,
     /* 196532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 484(*/0xE4, 0x03/*)*/,
     /* 196535 */   GIR_MakeTempReg, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196539 */   GIR_BuildMI, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196544 */   GIR_AddTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196551 */   GIR_AddSimpleTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/,
     /* 196556 */   GIR_AddSimpleTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/,
     /* 196561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 483(*/0xE3, 0x03/*)*/,
     /* 196564 */   GIR_MakeTempReg, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196568 */   GIR_BuildMI, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196573 */   GIR_AddTempRegister, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196580 */   GIR_AddImm, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 196591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 482(*/0xE2, 0x03/*)*/,
     /* 196594 */   GIR_MakeTempReg, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196598 */   GIR_BuildMI, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196603 */   GIR_AddTempRegister, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196610 */   GIR_AddSimpleTempRegister, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/,
     /* 196615 */   GIR_AddImm, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 196626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 481(*/0xE1, 0x03/*)*/,
     /* 196629 */   GIR_MakeTempReg, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196633 */   GIR_BuildMI, /*InsnID*//* 480(*/0xE0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196638 */   GIR_AddTempRegister, /*InsnID*//* 480(*/0xE0, 0x03/*)*/, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 480(*/0xE0, 0x03/*)*/,
     /* 196648 */   GIR_MakeTempReg, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196652 */   GIR_BuildMI, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196657 */   GIR_AddTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196664 */   GIR_AddSimpleTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/,
     /* 196669 */   GIR_AddSimpleTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/,
     /* 196674 */   GIR_AddImm8, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Imm*/1,
     /* 196678 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196684 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196690 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196696 */   GIR_MakeTempReg, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196700 */   GIR_BuildMI, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196705 */   GIR_AddTempRegister, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196712 */   GIR_AddSimpleTempRegister, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/,
     /* 196717 */   GIR_AddImm8, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Imm*/32,
     /* 196721 */   GIR_AddImm8, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Imm*/31,
     /* 196725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 478(*/0xDE, 0x03/*)*/,
     /* 196728 */   GIR_MakeTempReg, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196732 */   GIR_BuildMI, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196737 */   GIR_AddTempRegister, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196744 */   GIR_AddSimpleTempRegister, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/,
     /* 196749 */   GIR_AddImm, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 196760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 477(*/0xDD, 0x03/*)*/,
     /* 196763 */   GIR_MakeTempReg, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196767 */   GIR_BuildMI, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196772 */   GIR_AddTempRegister, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196779 */   GIR_AddSimpleTempRegister, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/,
     /* 196784 */   GIR_AddImm, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 196795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 476(*/0xDC, 0x03/*)*/,
     /* 196798 */   GIR_MakeTempReg, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196802 */   GIR_BuildMI, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196807 */   GIR_AddTempRegister, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196814 */   GIR_AddImm, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 196825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 475(*/0xDB, 0x03/*)*/,
     /* 196828 */   GIR_MakeTempReg, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196832 */   GIR_BuildMI, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196837 */   GIR_AddTempRegister, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196844 */   GIR_AddSimpleTempRegister, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/,
     /* 196849 */   GIR_AddImm, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 196860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 474(*/0xDA, 0x03/*)*/,
     /* 196863 */   GIR_MakeTempReg, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196867 */   GIR_BuildMI, /*InsnID*//* 473(*/0xD9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196872 */   GIR_AddTempRegister, /*InsnID*//* 473(*/0xD9, 0x03/*)*/, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 473(*/0xD9, 0x03/*)*/,
     /* 196882 */   GIR_MakeTempReg, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196886 */   GIR_BuildMI, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196891 */   GIR_AddTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196898 */   GIR_AddSimpleTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/,
     /* 196903 */   GIR_AddSimpleTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/,
     /* 196908 */   GIR_AddImm8, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Imm*/1,
     /* 196912 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196918 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196924 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196930 */   GIR_MakeTempReg, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196934 */   GIR_BuildMI, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196939 */   GIR_AddTempRegister, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196946 */   GIR_AddSimpleTempRegister, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/,
     /* 196951 */   GIR_AddImm8, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Imm*/32,
     /* 196955 */   GIR_AddImm8, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Imm*/31,
     /* 196959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 471(*/0xD7, 0x03/*)*/,
     /* 196962 */   GIR_MakeTempReg, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196966 */   GIR_BuildMI, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196971 */   GIR_AddTempRegister, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196978 */   GIR_AddSimpleTempRegister, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/,
     /* 196983 */   GIR_AddImm, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 196994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 470(*/0xD6, 0x03/*)*/,
     /* 196997 */   GIR_MakeTempReg, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197001 */   GIR_BuildMI, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197006 */   GIR_AddTempRegister, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197013 */   GIR_AddSimpleTempRegister, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/,
     /* 197018 */   GIR_AddImm, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 197029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 469(*/0xD5, 0x03/*)*/,
     /* 197032 */   GIR_MakeTempReg, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197036 */   GIR_BuildMI, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197041 */   GIR_AddTempRegister, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197048 */   GIR_AddImm, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 468(*/0xD4, 0x03/*)*/,
     /* 197062 */   GIR_MakeTempReg, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197066 */   GIR_BuildMI, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197071 */   GIR_AddTempRegister, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197078 */   GIR_AddSimpleTempRegister, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/,
     /* 197083 */   GIR_AddImm, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 467(*/0xD3, 0x03/*)*/,
     /* 197097 */   GIR_MakeTempReg, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197101 */   GIR_BuildMI, /*InsnID*//* 466(*/0xD2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197106 */   GIR_AddTempRegister, /*InsnID*//* 466(*/0xD2, 0x03/*)*/, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 466(*/0xD2, 0x03/*)*/,
     /* 197116 */   GIR_MakeTempReg, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197120 */   GIR_BuildMI, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197125 */   GIR_AddTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197132 */   GIR_AddSimpleTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/,
     /* 197137 */   GIR_AddSimpleTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/,
     /* 197142 */   GIR_AddImm8, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Imm*/1,
     /* 197146 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197152 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197158 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197164 */   GIR_MakeTempReg, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197168 */   GIR_BuildMI, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197173 */   GIR_AddTempRegister, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197180 */   GIR_AddSimpleTempRegister, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/,
     /* 197185 */   GIR_AddImm8, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Imm*/32,
     /* 197189 */   GIR_AddImm8, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Imm*/31,
     /* 197193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 464(*/0xD0, 0x03/*)*/,
     /* 197196 */   GIR_MakeTempReg, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197200 */   GIR_BuildMI, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197205 */   GIR_AddTempRegister, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197212 */   GIR_AddSimpleTempRegister, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/,
     /* 197217 */   GIR_AddImm, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 463(*/0xCF, 0x03/*)*/,
     /* 197231 */   GIR_MakeTempReg, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197235 */   GIR_BuildMI, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197240 */   GIR_AddTempRegister, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197247 */   GIR_AddSimpleTempRegister, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/,
     /* 197252 */   GIR_AddImm, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 462(*/0xCE, 0x03/*)*/,
     /* 197266 */   GIR_MakeTempReg, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197270 */   GIR_BuildMI, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197275 */   GIR_AddTempRegister, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197282 */   GIR_Copy, /*NewInsnID*//* 461(*/0xCD, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 197287 */   GIR_AddImm8, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Imm*/1,
     /* 197291 */   GIR_AddImm8, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Imm*/62,
     /* 197295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 461(*/0xCD, 0x03/*)*/,
     /* 197298 */   GIR_MakeTempReg, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197302 */   GIR_BuildMI, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197307 */   GIR_AddTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197314 */   GIR_AddSimpleTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/,
     /* 197319 */   GIR_AddSimpleTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/,
     /* 197324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 460(*/0xCC, 0x03/*)*/,
     /* 197327 */   GIR_MakeTempReg, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197331 */   GIR_BuildMI, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197336 */   GIR_AddTempRegister, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197343 */   GIR_AddImm, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 459(*/0xCB, 0x03/*)*/,
     /* 197357 */   GIR_MakeTempReg, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197361 */   GIR_BuildMI, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197366 */   GIR_AddTempRegister, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197373 */   GIR_AddSimpleTempRegister, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/,
     /* 197378 */   GIR_AddImm, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 458(*/0xCA, 0x03/*)*/,
     /* 197392 */   GIR_MakeTempReg, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197396 */   GIR_BuildMI, /*InsnID*//* 457(*/0xC9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197401 */   GIR_AddTempRegister, /*InsnID*//* 457(*/0xC9, 0x03/*)*/, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 457(*/0xC9, 0x03/*)*/,
     /* 197411 */   GIR_MakeTempReg, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197415 */   GIR_BuildMI, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197420 */   GIR_AddTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197427 */   GIR_AddSimpleTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/,
     /* 197432 */   GIR_AddSimpleTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/,
     /* 197437 */   GIR_AddImm8, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Imm*/1,
     /* 197441 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197447 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197453 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197459 */   GIR_MakeTempReg, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197463 */   GIR_BuildMI, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197468 */   GIR_AddTempRegister, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197475 */   GIR_AddSimpleTempRegister, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/,
     /* 197480 */   GIR_AddImm8, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Imm*/32,
     /* 197484 */   GIR_AddImm8, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Imm*/31,
     /* 197488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 455(*/0xC7, 0x03/*)*/,
     /* 197491 */   GIR_MakeTempReg, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197495 */   GIR_BuildMI, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197500 */   GIR_AddTempRegister, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197507 */   GIR_AddSimpleTempRegister, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/,
     /* 197512 */   GIR_AddImm, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 454(*/0xC6, 0x03/*)*/,
     /* 197526 */   GIR_MakeTempReg, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197530 */   GIR_BuildMI, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197535 */   GIR_AddTempRegister, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197542 */   GIR_AddSimpleTempRegister, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/,
     /* 197547 */   GIR_AddImm, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 453(*/0xC5, 0x03/*)*/,
     /* 197561 */   GIR_MakeTempReg, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197565 */   GIR_BuildMI, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 197570 */   GIR_AddTempRegister, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197577 */   GIR_Copy, /*NewInsnID*//* 452(*/0xC4, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 197582 */   GIR_AddImm8, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Imm*/63,
     /* 197586 */   GIR_AddImm8, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Imm*/1,
     /* 197590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 452(*/0xC4, 0x03/*)*/,
     /* 197593 */   GIR_MakeTempReg, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197597 */   GIR_BuildMI, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197602 */   GIR_AddTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197609 */   GIR_AddSimpleTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/,
     /* 197614 */   GIR_AddSimpleTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/,
     /* 197619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 451(*/0xC3, 0x03/*)*/,
     /* 197622 */   GIR_MakeTempReg, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197626 */   GIR_BuildMI, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 197631 */   GIR_AddTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197638 */   GIR_AddSimpleTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/,
     /* 197643 */   GIR_AddSimpleTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/,
     /* 197648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 450(*/0xC2, 0x03/*)*/,
     /* 197651 */   GIR_MakeTempReg, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197655 */   GIR_BuildMI, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197660 */   GIR_AddTempRegister, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197667 */   GIR_AddSimpleTempRegister, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/,
     /* 197672 */   GIR_AddImm8, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Imm*/2,
     /* 197676 */   GIR_AddImm8, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Imm*/61,
     /* 197680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 449(*/0xC1, 0x03/*)*/,
     /* 197683 */   GIR_MakeTempReg, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197687 */   GIR_BuildMI, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197692 */   GIR_AddTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197699 */   GIR_AddSimpleTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/,
     /* 197704 */   GIR_AddSimpleTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/,
     /* 197709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 448(*/0xC0, 0x03/*)*/,
     /* 197712 */   GIR_MakeTempReg, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197716 */   GIR_BuildMI, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197721 */   GIR_AddTempRegister, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197728 */   GIR_AddImm, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 197739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 447(*/0xBF, 0x03/*)*/,
     /* 197742 */   GIR_MakeTempReg, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197746 */   GIR_BuildMI, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197751 */   GIR_AddTempRegister, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197758 */   GIR_AddSimpleTempRegister, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/,
     /* 197763 */   GIR_AddImm, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 197774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 446(*/0xBE, 0x03/*)*/,
     /* 197777 */   GIR_MakeTempReg, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197781 */   GIR_BuildMI, /*InsnID*//* 445(*/0xBD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197786 */   GIR_AddTempRegister, /*InsnID*//* 445(*/0xBD, 0x03/*)*/, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 445(*/0xBD, 0x03/*)*/,
     /* 197796 */   GIR_MakeTempReg, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197800 */   GIR_BuildMI, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197805 */   GIR_AddTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197812 */   GIR_AddSimpleTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/,
     /* 197817 */   GIR_AddSimpleTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/,
     /* 197822 */   GIR_AddImm8, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Imm*/1,
     /* 197826 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197832 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197838 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197844 */   GIR_MakeTempReg, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197848 */   GIR_BuildMI, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197853 */   GIR_AddTempRegister, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197860 */   GIR_AddSimpleTempRegister, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/,
     /* 197865 */   GIR_AddImm8, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Imm*/32,
     /* 197869 */   GIR_AddImm8, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Imm*/31,
     /* 197873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 443(*/0xBB, 0x03/*)*/,
     /* 197876 */   GIR_MakeTempReg, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197880 */   GIR_BuildMI, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197885 */   GIR_AddTempRegister, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197892 */   GIR_AddSimpleTempRegister, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/,
     /* 197897 */   GIR_AddImm, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 197908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 442(*/0xBA, 0x03/*)*/,
     /* 197911 */   GIR_MakeTempReg, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197915 */   GIR_BuildMI, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197920 */   GIR_AddTempRegister, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197927 */   GIR_AddSimpleTempRegister, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/,
     /* 197932 */   GIR_AddImm, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 197943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 441(*/0xB9, 0x03/*)*/,
     /* 197946 */   GIR_MakeTempReg, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197950 */   GIR_BuildMI, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197955 */   GIR_AddTempRegister, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197962 */   GIR_AddImm, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 440(*/0xB8, 0x03/*)*/,
     /* 197976 */   GIR_MakeTempReg, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197980 */   GIR_BuildMI, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197985 */   GIR_AddTempRegister, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197992 */   GIR_AddSimpleTempRegister, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/,
     /* 197997 */   GIR_AddImm, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 439(*/0xB7, 0x03/*)*/,
     /* 198011 */   GIR_MakeTempReg, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198015 */   GIR_BuildMI, /*InsnID*//* 438(*/0xB6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198020 */   GIR_AddTempRegister, /*InsnID*//* 438(*/0xB6, 0x03/*)*/, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 438(*/0xB6, 0x03/*)*/,
     /* 198030 */   GIR_MakeTempReg, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198034 */   GIR_BuildMI, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198039 */   GIR_AddTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198046 */   GIR_AddSimpleTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/,
     /* 198051 */   GIR_AddSimpleTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/,
     /* 198056 */   GIR_AddImm8, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Imm*/1,
     /* 198060 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198066 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198072 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198078 */   GIR_MakeTempReg, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198082 */   GIR_BuildMI, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198087 */   GIR_AddTempRegister, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198094 */   GIR_AddSimpleTempRegister, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/,
     /* 198099 */   GIR_AddImm8, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Imm*/32,
     /* 198103 */   GIR_AddImm8, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Imm*/31,
     /* 198107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 436(*/0xB4, 0x03/*)*/,
     /* 198110 */   GIR_MakeTempReg, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198114 */   GIR_BuildMI, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198119 */   GIR_AddTempRegister, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198126 */   GIR_AddSimpleTempRegister, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/,
     /* 198131 */   GIR_AddImm, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 435(*/0xB3, 0x03/*)*/,
     /* 198145 */   GIR_MakeTempReg, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198149 */   GIR_BuildMI, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198154 */   GIR_AddTempRegister, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198161 */   GIR_AddSimpleTempRegister, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/,
     /* 198166 */   GIR_AddImm, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 434(*/0xB2, 0x03/*)*/,
     /* 198180 */   GIR_MakeTempReg, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198184 */   GIR_BuildMI, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198189 */   GIR_AddTempRegister, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198196 */   GIR_Copy, /*NewInsnID*//* 433(*/0xB1, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 198201 */   GIR_AddImm8, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Imm*/1,
     /* 198205 */   GIR_AddImm8, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Imm*/62,
     /* 198209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 433(*/0xB1, 0x03/*)*/,
     /* 198212 */   GIR_MakeTempReg, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198216 */   GIR_BuildMI, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198221 */   GIR_AddTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198228 */   GIR_AddSimpleTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/,
     /* 198233 */   GIR_AddSimpleTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/,
     /* 198238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 432(*/0xB0, 0x03/*)*/,
     /* 198241 */   GIR_MakeTempReg, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198245 */   GIR_BuildMI, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198250 */   GIR_AddTempRegister, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198257 */   GIR_AddImm, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 431(*/0xAF, 0x03/*)*/,
     /* 198271 */   GIR_MakeTempReg, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198275 */   GIR_BuildMI, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 198280 */   GIR_AddTempRegister, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198287 */   GIR_AddSimpleTempRegister, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/,
     /* 198292 */   GIR_AddImm, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 430(*/0xAE, 0x03/*)*/,
     /* 198306 */   GIR_MakeTempReg, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198310 */   GIR_BuildMI, /*InsnID*//* 429(*/0xAD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198315 */   GIR_AddTempRegister, /*InsnID*//* 429(*/0xAD, 0x03/*)*/, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 429(*/0xAD, 0x03/*)*/,
     /* 198325 */   GIR_MakeTempReg, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198329 */   GIR_BuildMI, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198334 */   GIR_AddTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198341 */   GIR_AddSimpleTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/,
     /* 198346 */   GIR_AddSimpleTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/,
     /* 198351 */   GIR_AddImm8, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Imm*/1,
     /* 198355 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198361 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198367 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198373 */   GIR_MakeTempReg, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198377 */   GIR_BuildMI, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198382 */   GIR_AddTempRegister, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198389 */   GIR_AddSimpleTempRegister, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/,
     /* 198394 */   GIR_AddImm8, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Imm*/32,
     /* 198398 */   GIR_AddImm8, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Imm*/31,
     /* 198402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 427(*/0xAB, 0x03/*)*/,
     /* 198405 */   GIR_MakeTempReg, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198409 */   GIR_BuildMI, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198414 */   GIR_AddTempRegister, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198421 */   GIR_AddSimpleTempRegister, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/,
     /* 198426 */   GIR_AddImm, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 426(*/0xAA, 0x03/*)*/,
     /* 198440 */   GIR_MakeTempReg, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198444 */   GIR_BuildMI, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198449 */   GIR_AddTempRegister, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198456 */   GIR_AddSimpleTempRegister, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/,
     /* 198461 */   GIR_AddImm, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 425(*/0xA9, 0x03/*)*/,
     /* 198475 */   GIR_MakeTempReg, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198479 */   GIR_BuildMI, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198484 */   GIR_AddTempRegister, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198491 */   GIR_Copy, /*NewInsnID*//* 424(*/0xA8, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 198496 */   GIR_AddImm8, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Imm*/63,
     /* 198500 */   GIR_AddImm8, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Imm*/1,
     /* 198504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 424(*/0xA8, 0x03/*)*/,
     /* 198507 */   GIR_MakeTempReg, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198511 */   GIR_BuildMI, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198516 */   GIR_AddTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198523 */   GIR_AddSimpleTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/,
     /* 198528 */   GIR_AddSimpleTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/,
     /* 198533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 423(*/0xA7, 0x03/*)*/,
     /* 198536 */   GIR_MakeTempReg, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198540 */   GIR_BuildMI, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 198545 */   GIR_AddTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198552 */   GIR_AddSimpleTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/,
     /* 198557 */   GIR_AddSimpleTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/,
     /* 198562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 422(*/0xA6, 0x03/*)*/,
     /* 198565 */   GIR_MakeTempReg, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198569 */   GIR_BuildMI, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198574 */   GIR_AddTempRegister, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198581 */   GIR_AddSimpleTempRegister, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/,
     /* 198586 */   GIR_AddImm8, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Imm*/62,
     /* 198590 */   GIR_AddImm8, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Imm*/2,
     /* 198594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 421(*/0xA5, 0x03/*)*/,
     /* 198597 */   GIR_MakeTempReg, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198601 */   GIR_BuildMI, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198606 */   GIR_AddTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198613 */   GIR_AddSimpleTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/,
     /* 198618 */   GIR_AddSimpleTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/,
     /* 198623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 420(*/0xA4, 0x03/*)*/,
     /* 198626 */   GIR_MakeTempReg, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198630 */   GIR_BuildMI, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 198635 */   GIR_AddTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198642 */   GIR_AddSimpleTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/,
     /* 198647 */   GIR_AddSimpleTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/,
     /* 198652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 419(*/0xA3, 0x03/*)*/,
     /* 198655 */   GIR_MakeTempReg, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198659 */   GIR_BuildMI, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198664 */   GIR_AddTempRegister, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198671 */   GIR_AddSimpleTempRegister, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/,
     /* 198676 */   GIR_AddImm8, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Imm*/60,
     /* 198680 */   GIR_AddImm8, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Imm*/4,
     /* 198684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 418(*/0xA2, 0x03/*)*/,
     /* 198687 */   GIR_MakeTempReg, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198691 */   GIR_BuildMI, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198696 */   GIR_AddTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198703 */   GIR_AddSimpleTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/,
     /* 198708 */   GIR_AddSimpleTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/,
     /* 198713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 417(*/0xA1, 0x03/*)*/,
     /* 198716 */   GIR_MakeTempReg, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198720 */   GIR_BuildMI, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 198725 */   GIR_AddTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198732 */   GIR_AddSimpleTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/,
     /* 198737 */   GIR_AddSimpleTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/,
     /* 198742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 416(*/0xA0, 0x03/*)*/,
     /* 198745 */   GIR_MakeTempReg, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198749 */   GIR_BuildMI, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198754 */   GIR_AddTempRegister, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198761 */   GIR_AddSimpleTempRegister, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/,
     /* 198766 */   GIR_AddImm8, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Imm*/32,
     /* 198770 */   GIR_AddImm8, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Imm*/32,
     /* 198774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 415(*/0x9F, 0x03/*)*/,
     /* 198777 */   GIR_MakeTempReg, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 198781 */   GIR_BuildMI, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198786 */   GIR_AddTempRegister, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198793 */   GIR_AddImm, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 198804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 683(*/0xAB, 0x05/*)*/,
     /* 198807 */   GIR_MakeTempReg, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 198811 */   GIR_BuildMI, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 198816 */   GIR_AddTempRegister, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198823 */   GIR_AddSimpleTempRegister, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/,
     /* 198828 */   GIR_AddImm, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 198839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 682(*/0xAA, 0x05/*)*/,
     /* 198842 */   GIR_MakeTempReg, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 198846 */   GIR_BuildMI, /*InsnID*//* 681(*/0xA9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198851 */   GIR_AddTempRegister, /*InsnID*//* 681(*/0xA9, 0x05/*)*/, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 681(*/0xA9, 0x05/*)*/,
     /* 198861 */   GIR_MakeTempReg, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 198865 */   GIR_BuildMI, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198870 */   GIR_AddTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198877 */   GIR_AddSimpleTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/,
     /* 198882 */   GIR_AddSimpleTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/,
     /* 198887 */   GIR_AddImm8, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Imm*/1,
     /* 198891 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198897 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198903 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198909 */   GIR_MakeTempReg, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 198913 */   GIR_BuildMI, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198918 */   GIR_AddTempRegister, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198925 */   GIR_AddSimpleTempRegister, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/,
     /* 198930 */   GIR_AddImm8, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Imm*/32,
     /* 198934 */   GIR_AddImm8, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Imm*/31,
     /* 198938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 679(*/0xA7, 0x05/*)*/,
     /* 198941 */   GIR_MakeTempReg, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 198945 */   GIR_BuildMI, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198950 */   GIR_AddTempRegister, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198957 */   GIR_AddSimpleTempRegister, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/,
     /* 198962 */   GIR_AddImm, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 198973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 678(*/0xA6, 0x05/*)*/,
     /* 198976 */   GIR_MakeTempReg, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 198980 */   GIR_BuildMI, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198985 */   GIR_AddTempRegister, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198992 */   GIR_AddSimpleTempRegister, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/,
     /* 198997 */   GIR_AddImm, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 199008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 677(*/0xA5, 0x05/*)*/,
     /* 199011 */   GIR_MakeTempReg, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199015 */   GIR_BuildMI, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199020 */   GIR_AddTempRegister, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199027 */   GIR_AddImm, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 676(*/0xA4, 0x05/*)*/,
     /* 199041 */   GIR_MakeTempReg, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199045 */   GIR_BuildMI, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199050 */   GIR_AddTempRegister, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199057 */   GIR_AddSimpleTempRegister, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/,
     /* 199062 */   GIR_AddImm, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 675(*/0xA3, 0x05/*)*/,
     /* 199076 */   GIR_MakeTempReg, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199080 */   GIR_BuildMI, /*InsnID*//* 674(*/0xA2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199085 */   GIR_AddTempRegister, /*InsnID*//* 674(*/0xA2, 0x05/*)*/, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 674(*/0xA2, 0x05/*)*/,
     /* 199095 */   GIR_MakeTempReg, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199099 */   GIR_BuildMI, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199104 */   GIR_AddTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199111 */   GIR_AddSimpleTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/,
     /* 199116 */   GIR_AddSimpleTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/,
     /* 199121 */   GIR_AddImm8, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Imm*/1,
     /* 199125 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199131 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199137 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199143 */   GIR_MakeTempReg, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199147 */   GIR_BuildMI, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199152 */   GIR_AddTempRegister, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199159 */   GIR_AddSimpleTempRegister, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/,
     /* 199164 */   GIR_AddImm8, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Imm*/32,
     /* 199168 */   GIR_AddImm8, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Imm*/31,
     /* 199172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 672(*/0xA0, 0x05/*)*/,
     /* 199175 */   GIR_MakeTempReg, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199179 */   GIR_BuildMI, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199184 */   GIR_AddTempRegister, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199191 */   GIR_AddSimpleTempRegister, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/,
     /* 199196 */   GIR_AddImm, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 671(*/0x9F, 0x05/*)*/,
     /* 199210 */   GIR_MakeTempReg, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199214 */   GIR_BuildMI, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199219 */   GIR_AddTempRegister, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199226 */   GIR_AddSimpleTempRegister, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/,
     /* 199231 */   GIR_AddImm, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 670(*/0x9E, 0x05/*)*/,
     /* 199245 */   GIR_MakeTempReg, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199249 */   GIR_BuildMI, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199254 */   GIR_AddTempRegister, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199261 */   GIR_AddImm, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199272 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 669(*/0x9D, 0x05/*)*/,
     /* 199275 */   GIR_MakeTempReg, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199279 */   GIR_BuildMI, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199284 */   GIR_AddTempRegister, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199291 */   GIR_AddSimpleTempRegister, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/,
     /* 199296 */   GIR_AddImm, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 668(*/0x9C, 0x05/*)*/,
     /* 199310 */   GIR_MakeTempReg, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199314 */   GIR_BuildMI, /*InsnID*//* 667(*/0x9B, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199319 */   GIR_AddTempRegister, /*InsnID*//* 667(*/0x9B, 0x05/*)*/, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 667(*/0x9B, 0x05/*)*/,
     /* 199329 */   GIR_MakeTempReg, /*TempRegID*//* 665(*/0x99, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199333 */   GIR_BuildMI, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199338 */   GIR_AddTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 665(*/0x99, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199345 */   GIR_AddSimpleTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/,
     /* 199350 */   GIR_AddSimpleTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/,
     /* 199355 */   GIR_AddImm8, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Imm*/1,
     /* 199359 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199365 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199371 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199377 */   GIR_MakeTempReg, /*TempRegID*//* 664(*/0x98, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199381 */   GIR_BuildMI, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199386 */   GIR_AddTempRegister, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*TempRegID*//* 664(*/0x98, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199393 */   GIR_AddSimpleTempRegister, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*TempRegID*//* 665(*/0x99, 0x05/*)*/,
     /* 199398 */   GIR_AddImm8, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Imm*/32,
     /* 199402 */   GIR_AddImm8, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Imm*/31,
     /* 199406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 665(*/0x99, 0x05/*)*/,
     /* 199409 */   GIR_MakeTempReg, /*TempRegID*//* 663(*/0x97, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199413 */   GIR_BuildMI, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199418 */   GIR_AddTempRegister, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*TempRegID*//* 663(*/0x97, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199425 */   GIR_AddSimpleTempRegister, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*TempRegID*//* 664(*/0x98, 0x05/*)*/,
     /* 199430 */   GIR_AddImm, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 664(*/0x98, 0x05/*)*/,
     /* 199444 */   GIR_MakeTempReg, /*TempRegID*//* 662(*/0x96, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199448 */   GIR_BuildMI, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199453 */   GIR_AddTempRegister, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*TempRegID*//* 662(*/0x96, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199460 */   GIR_AddSimpleTempRegister, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*TempRegID*//* 663(*/0x97, 0x05/*)*/,
     /* 199465 */   GIR_AddImm, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 663(*/0x97, 0x05/*)*/,
     /* 199479 */   GIR_MakeTempReg, /*TempRegID*//* 661(*/0x95, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199483 */   GIR_BuildMI, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199488 */   GIR_AddTempRegister, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*TempRegID*//* 661(*/0x95, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199495 */   GIR_Copy, /*NewInsnID*//* 662(*/0x96, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 199500 */   GIR_AddImm8, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Imm*/1,
     /* 199504 */   GIR_AddImm8, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Imm*/62,
     /* 199508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 662(*/0x96, 0x05/*)*/,
     /* 199511 */   GIR_MakeTempReg, /*TempRegID*//* 660(*/0x94, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199515 */   GIR_BuildMI, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 199520 */   GIR_AddTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 660(*/0x94, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199527 */   GIR_AddSimpleTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 661(*/0x95, 0x05/*)*/,
     /* 199532 */   GIR_AddSimpleTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 662(*/0x96, 0x05/*)*/,
     /* 199537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 661(*/0x95, 0x05/*)*/,
     /* 199540 */   GIR_MakeTempReg, /*TempRegID*//* 659(*/0x93, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199544 */   GIR_BuildMI, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199549 */   GIR_AddTempRegister, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*TempRegID*//* 659(*/0x93, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199556 */   GIR_AddImm, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 660(*/0x94, 0x05/*)*/,
     /* 199570 */   GIR_MakeTempReg, /*TempRegID*//* 658(*/0x92, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199574 */   GIR_BuildMI, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199579 */   GIR_AddTempRegister, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*TempRegID*//* 658(*/0x92, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199586 */   GIR_AddSimpleTempRegister, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*TempRegID*//* 659(*/0x93, 0x05/*)*/,
     /* 199591 */   GIR_AddImm, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199602 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 659(*/0x93, 0x05/*)*/,
     /* 199605 */   GIR_MakeTempReg, /*TempRegID*//* 657(*/0x91, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199609 */   GIR_BuildMI, /*InsnID*//* 658(*/0x92, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199614 */   GIR_AddTempRegister, /*InsnID*//* 658(*/0x92, 0x05/*)*/, /*TempRegID*//* 657(*/0x91, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199621 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 658(*/0x92, 0x05/*)*/,
     /* 199624 */   GIR_MakeTempReg, /*TempRegID*//* 656(*/0x90, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199628 */   GIR_BuildMI, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199633 */   GIR_AddTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 656(*/0x90, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199640 */   GIR_AddSimpleTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 657(*/0x91, 0x05/*)*/,
     /* 199645 */   GIR_AddSimpleTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 658(*/0x92, 0x05/*)*/,
     /* 199650 */   GIR_AddImm8, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Imm*/1,
     /* 199654 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199660 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199666 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199672 */   GIR_MakeTempReg, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199676 */   GIR_BuildMI, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199681 */   GIR_AddTempRegister, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199688 */   GIR_AddSimpleTempRegister, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*TempRegID*//* 656(*/0x90, 0x05/*)*/,
     /* 199693 */   GIR_AddImm8, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Imm*/32,
     /* 199697 */   GIR_AddImm8, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Imm*/31,
     /* 199701 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 656(*/0x90, 0x05/*)*/,
     /* 199704 */   GIR_MakeTempReg, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199708 */   GIR_BuildMI, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199713 */   GIR_AddTempRegister, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199720 */   GIR_AddSimpleTempRegister, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/,
     /* 199725 */   GIR_AddImm, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 655(*/0x8F, 0x05/*)*/,
     /* 199739 */   GIR_MakeTempReg, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199743 */   GIR_BuildMI, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199748 */   GIR_AddTempRegister, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199755 */   GIR_AddSimpleTempRegister, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/,
     /* 199760 */   GIR_AddImm, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 654(*/0x8E, 0x05/*)*/,
     /* 199774 */   GIR_MakeTempReg, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199778 */   GIR_BuildMI, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 199783 */   GIR_AddTempRegister, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199790 */   GIR_Copy, /*NewInsnID*//* 653(*/0x8D, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 199795 */   GIR_AddImm8, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Imm*/63,
     /* 199799 */   GIR_AddImm8, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Imm*/1,
     /* 199803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 653(*/0x8D, 0x05/*)*/,
     /* 199806 */   GIR_MakeTempReg, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199810 */   GIR_BuildMI, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 199815 */   GIR_AddTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199822 */   GIR_AddSimpleTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/,
     /* 199827 */   GIR_AddSimpleTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/,
     /* 199832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 652(*/0x8C, 0x05/*)*/,
     /* 199835 */   GIR_MakeTempReg, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199839 */   GIR_BuildMI, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 199844 */   GIR_AddTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199851 */   GIR_AddSimpleTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/,
     /* 199856 */   GIR_AddSimpleTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 660(*/0x94, 0x05/*)*/,
     /* 199861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 651(*/0x8B, 0x05/*)*/,
     /* 199864 */   GIR_MakeTempReg, /*TempRegID*//* 649(*/0x89, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199868 */   GIR_BuildMI, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199873 */   GIR_AddTempRegister, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegID*//* 649(*/0x89, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199880 */   GIR_AddSimpleTempRegister, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/,
     /* 199885 */   GIR_AddImm8, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Imm*/2,
     /* 199889 */   GIR_AddImm8, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Imm*/61,
     /* 199893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 650(*/0x8A, 0x05/*)*/,
     /* 199896 */   GIR_MakeTempReg, /*TempRegID*//* 648(*/0x88, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199900 */   GIR_BuildMI, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 199905 */   GIR_AddTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 648(*/0x88, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199912 */   GIR_AddSimpleTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 649(*/0x89, 0x05/*)*/,
     /* 199917 */   GIR_AddSimpleTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/,
     /* 199922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 649(*/0x89, 0x05/*)*/,
     /* 199925 */   GIR_MakeTempReg, /*TempRegID*//* 647(*/0x87, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199929 */   GIR_BuildMI, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199934 */   GIR_AddTempRegister, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*TempRegID*//* 647(*/0x87, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199941 */   GIR_AddImm, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 199952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 648(*/0x88, 0x05/*)*/,
     /* 199955 */   GIR_MakeTempReg, /*TempRegID*//* 646(*/0x86, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199959 */   GIR_BuildMI, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199964 */   GIR_AddTempRegister, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*TempRegID*//* 646(*/0x86, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199971 */   GIR_AddSimpleTempRegister, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*TempRegID*//* 647(*/0x87, 0x05/*)*/,
     /* 199976 */   GIR_AddImm, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 199987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 647(*/0x87, 0x05/*)*/,
     /* 199990 */   GIR_MakeTempReg, /*TempRegID*//* 645(*/0x85, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199994 */   GIR_BuildMI, /*InsnID*//* 646(*/0x86, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199999 */   GIR_AddTempRegister, /*InsnID*//* 646(*/0x86, 0x05/*)*/, /*TempRegID*//* 645(*/0x85, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 646(*/0x86, 0x05/*)*/,
     /* 200009 */   GIR_MakeTempReg, /*TempRegID*//* 644(*/0x84, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200013 */   GIR_BuildMI, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200018 */   GIR_AddTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 644(*/0x84, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200025 */   GIR_AddSimpleTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 645(*/0x85, 0x05/*)*/,
     /* 200030 */   GIR_AddSimpleTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 646(*/0x86, 0x05/*)*/,
     /* 200035 */   GIR_AddImm8, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Imm*/1,
     /* 200039 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200045 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200051 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200057 */   GIR_MakeTempReg, /*TempRegID*//* 643(*/0x83, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200061 */   GIR_BuildMI, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200066 */   GIR_AddTempRegister, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*TempRegID*//* 643(*/0x83, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200073 */   GIR_AddSimpleTempRegister, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*TempRegID*//* 644(*/0x84, 0x05/*)*/,
     /* 200078 */   GIR_AddImm8, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Imm*/32,
     /* 200082 */   GIR_AddImm8, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Imm*/31,
     /* 200086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 644(*/0x84, 0x05/*)*/,
     /* 200089 */   GIR_MakeTempReg, /*TempRegID*//* 642(*/0x82, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200093 */   GIR_BuildMI, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200098 */   GIR_AddTempRegister, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*TempRegID*//* 642(*/0x82, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200105 */   GIR_AddSimpleTempRegister, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*TempRegID*//* 643(*/0x83, 0x05/*)*/,
     /* 200110 */   GIR_AddImm, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 200121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 643(*/0x83, 0x05/*)*/,
     /* 200124 */   GIR_MakeTempReg, /*TempRegID*//* 641(*/0x81, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200128 */   GIR_BuildMI, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200133 */   GIR_AddTempRegister, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*TempRegID*//* 641(*/0x81, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200140 */   GIR_AddSimpleTempRegister, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*TempRegID*//* 642(*/0x82, 0x05/*)*/,
     /* 200145 */   GIR_AddImm, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 200156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 642(*/0x82, 0x05/*)*/,
     /* 200159 */   GIR_MakeTempReg, /*TempRegID*//* 640(*/0x80, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 200163 */   GIR_BuildMI, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200168 */   GIR_AddTempRegister, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*TempRegID*//* 640(*/0x80, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200175 */   GIR_AddImm, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 641(*/0x81, 0x05/*)*/,
     /* 200189 */   GIR_MakeTempReg, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200193 */   GIR_BuildMI, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200198 */   GIR_AddTempRegister, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200205 */   GIR_AddSimpleTempRegister, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*TempRegID*//* 640(*/0x80, 0x05/*)*/,
     /* 200210 */   GIR_AddImm, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 640(*/0x80, 0x05/*)*/,
     /* 200224 */   GIR_MakeTempReg, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200228 */   GIR_BuildMI, /*InsnID*//* 639(*/0xFF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200233 */   GIR_AddTempRegister, /*InsnID*//* 639(*/0xFF, 0x04/*)*/, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 639(*/0xFF, 0x04/*)*/,
     /* 200243 */   GIR_MakeTempReg, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200247 */   GIR_BuildMI, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200252 */   GIR_AddTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200259 */   GIR_AddSimpleTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/,
     /* 200264 */   GIR_AddSimpleTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/,
     /* 200269 */   GIR_AddImm8, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Imm*/1,
     /* 200273 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200279 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200285 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200291 */   GIR_MakeTempReg, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200295 */   GIR_BuildMI, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200300 */   GIR_AddTempRegister, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200307 */   GIR_AddSimpleTempRegister, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/,
     /* 200312 */   GIR_AddImm8, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Imm*/32,
     /* 200316 */   GIR_AddImm8, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Imm*/31,
     /* 200320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 637(*/0xFD, 0x04/*)*/,
     /* 200323 */   GIR_MakeTempReg, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200327 */   GIR_BuildMI, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200332 */   GIR_AddTempRegister, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200339 */   GIR_AddSimpleTempRegister, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/,
     /* 200344 */   GIR_AddImm, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 636(*/0xFC, 0x04/*)*/,
     /* 200358 */   GIR_MakeTempReg, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200362 */   GIR_BuildMI, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200367 */   GIR_AddTempRegister, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200374 */   GIR_AddSimpleTempRegister, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/,
     /* 200379 */   GIR_AddImm, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 635(*/0xFB, 0x04/*)*/,
     /* 200393 */   GIR_MakeTempReg, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200397 */   GIR_BuildMI, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200402 */   GIR_AddTempRegister, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200409 */   GIR_Copy, /*NewInsnID*//* 634(*/0xFA, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 200414 */   GIR_AddImm8, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Imm*/1,
     /* 200418 */   GIR_AddImm8, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Imm*/62,
     /* 200422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 634(*/0xFA, 0x04/*)*/,
     /* 200425 */   GIR_MakeTempReg, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200429 */   GIR_BuildMI, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200434 */   GIR_AddTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200441 */   GIR_AddSimpleTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/,
     /* 200446 */   GIR_AddSimpleTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/,
     /* 200451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 633(*/0xF9, 0x04/*)*/,
     /* 200454 */   GIR_MakeTempReg, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200458 */   GIR_BuildMI, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200463 */   GIR_AddTempRegister, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200470 */   GIR_AddImm, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 632(*/0xF8, 0x04/*)*/,
     /* 200484 */   GIR_MakeTempReg, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200488 */   GIR_BuildMI, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200493 */   GIR_AddTempRegister, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200500 */   GIR_AddSimpleTempRegister, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/,
     /* 200505 */   GIR_AddImm, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 631(*/0xF7, 0x04/*)*/,
     /* 200519 */   GIR_MakeTempReg, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200523 */   GIR_BuildMI, /*InsnID*//* 630(*/0xF6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200528 */   GIR_AddTempRegister, /*InsnID*//* 630(*/0xF6, 0x04/*)*/, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 630(*/0xF6, 0x04/*)*/,
     /* 200538 */   GIR_MakeTempReg, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200542 */   GIR_BuildMI, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200547 */   GIR_AddTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200554 */   GIR_AddSimpleTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/,
     /* 200559 */   GIR_AddSimpleTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/,
     /* 200564 */   GIR_AddImm8, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Imm*/1,
     /* 200568 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200574 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200580 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200586 */   GIR_MakeTempReg, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200590 */   GIR_BuildMI, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200595 */   GIR_AddTempRegister, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200602 */   GIR_AddSimpleTempRegister, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/,
     /* 200607 */   GIR_AddImm8, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Imm*/32,
     /* 200611 */   GIR_AddImm8, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Imm*/31,
     /* 200615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 628(*/0xF4, 0x04/*)*/,
     /* 200618 */   GIR_MakeTempReg, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200622 */   GIR_BuildMI, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200627 */   GIR_AddTempRegister, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200634 */   GIR_AddSimpleTempRegister, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/,
     /* 200639 */   GIR_AddImm, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200650 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 627(*/0xF3, 0x04/*)*/,
     /* 200653 */   GIR_MakeTempReg, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200657 */   GIR_BuildMI, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200662 */   GIR_AddTempRegister, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200669 */   GIR_AddSimpleTempRegister, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/,
     /* 200674 */   GIR_AddImm, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 626(*/0xF2, 0x04/*)*/,
     /* 200688 */   GIR_MakeTempReg, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200692 */   GIR_BuildMI, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 200697 */   GIR_AddTempRegister, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200704 */   GIR_Copy, /*NewInsnID*//* 625(*/0xF1, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 200709 */   GIR_AddImm8, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Imm*/63,
     /* 200713 */   GIR_AddImm8, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Imm*/1,
     /* 200717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 625(*/0xF1, 0x04/*)*/,
     /* 200720 */   GIR_MakeTempReg, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200724 */   GIR_BuildMI, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200729 */   GIR_AddTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200736 */   GIR_AddSimpleTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/,
     /* 200741 */   GIR_AddSimpleTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/,
     /* 200746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 624(*/0xF0, 0x04/*)*/,
     /* 200749 */   GIR_MakeTempReg, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200753 */   GIR_BuildMI, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 200758 */   GIR_AddTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200765 */   GIR_AddSimpleTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/,
     /* 200770 */   GIR_AddSimpleTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/,
     /* 200775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 623(*/0xEF, 0x04/*)*/,
     /* 200778 */   GIR_MakeTempReg, /*TempRegID*//* 621(*/0xED, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200782 */   GIR_BuildMI, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 200787 */   GIR_AddTempRegister, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegID*//* 621(*/0xED, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200794 */   GIR_AddSimpleTempRegister, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/,
     /* 200799 */   GIR_AddImm8, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Imm*/62,
     /* 200803 */   GIR_AddImm8, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Imm*/2,
     /* 200807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 622(*/0xEE, 0x04/*)*/,
     /* 200810 */   GIR_MakeTempReg, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200814 */   GIR_BuildMI, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200819 */   GIR_AddTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200826 */   GIR_AddSimpleTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 621(*/0xED, 0x04/*)*/,
     /* 200831 */   GIR_AddSimpleTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 641(*/0x81, 0x05/*)*/,
     /* 200836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 621(*/0xED, 0x04/*)*/,
     /* 200839 */   GIR_MakeTempReg, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200843 */   GIR_BuildMI, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 200848 */   GIR_AddTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200855 */   GIR_AddSimpleTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/,
     /* 200860 */   GIR_AddSimpleTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 648(*/0x88, 0x05/*)*/,
     /* 200865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 620(*/0xEC, 0x04/*)*/,
     /* 200868 */   GIR_MakeTempReg, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200872 */   GIR_BuildMI, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200877 */   GIR_AddTempRegister, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200884 */   GIR_AddSimpleTempRegister, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/,
     /* 200889 */   GIR_AddImm8, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Imm*/4,
     /* 200893 */   GIR_AddImm8, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Imm*/59,
     /* 200897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 619(*/0xEB, 0x04/*)*/,
     /* 200900 */   GIR_MakeTempReg, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200904 */   GIR_BuildMI, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200909 */   GIR_AddTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200916 */   GIR_AddSimpleTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/,
     /* 200921 */   GIR_AddSimpleTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/,
     /* 200926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 618(*/0xEA, 0x04/*)*/,
     /* 200929 */   GIR_MakeTempReg, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200933 */   GIR_BuildMI, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200938 */   GIR_AddTempRegister, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200945 */   GIR_AddImm, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 200956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 617(*/0xE9, 0x04/*)*/,
     /* 200959 */   GIR_MakeTempReg, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200963 */   GIR_BuildMI, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200968 */   GIR_AddTempRegister, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200975 */   GIR_AddSimpleTempRegister, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/,
     /* 200980 */   GIR_AddImm, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 200991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 616(*/0xE8, 0x04/*)*/,
     /* 200994 */   GIR_MakeTempReg, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200998 */   GIR_BuildMI, /*InsnID*//* 615(*/0xE7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201003 */   GIR_AddTempRegister, /*InsnID*//* 615(*/0xE7, 0x04/*)*/, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 615(*/0xE7, 0x04/*)*/,
     /* 201013 */   GIR_MakeTempReg, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201017 */   GIR_BuildMI, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201022 */   GIR_AddTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201029 */   GIR_AddSimpleTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/,
     /* 201034 */   GIR_AddSimpleTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/,
     /* 201039 */   GIR_AddImm8, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Imm*/1,
     /* 201043 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201049 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201055 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201061 */   GIR_MakeTempReg, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201065 */   GIR_BuildMI, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201070 */   GIR_AddTempRegister, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201077 */   GIR_AddSimpleTempRegister, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/,
     /* 201082 */   GIR_AddImm8, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Imm*/32,
     /* 201086 */   GIR_AddImm8, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Imm*/31,
     /* 201090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 613(*/0xE5, 0x04/*)*/,
     /* 201093 */   GIR_MakeTempReg, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201097 */   GIR_BuildMI, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201102 */   GIR_AddTempRegister, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201109 */   GIR_AddSimpleTempRegister, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/,
     /* 201114 */   GIR_AddImm, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 201125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 612(*/0xE4, 0x04/*)*/,
     /* 201128 */   GIR_MakeTempReg, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201132 */   GIR_BuildMI, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201137 */   GIR_AddTempRegister, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201144 */   GIR_AddSimpleTempRegister, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/,
     /* 201149 */   GIR_AddImm, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 201160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 611(*/0xE3, 0x04/*)*/,
     /* 201163 */   GIR_MakeTempReg, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201167 */   GIR_BuildMI, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201172 */   GIR_AddTempRegister, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201179 */   GIR_AddImm, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 610(*/0xE2, 0x04/*)*/,
     /* 201193 */   GIR_MakeTempReg, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201197 */   GIR_BuildMI, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201202 */   GIR_AddTempRegister, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201209 */   GIR_AddSimpleTempRegister, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/,
     /* 201214 */   GIR_AddImm, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 609(*/0xE1, 0x04/*)*/,
     /* 201228 */   GIR_MakeTempReg, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201232 */   GIR_BuildMI, /*InsnID*//* 608(*/0xE0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201237 */   GIR_AddTempRegister, /*InsnID*//* 608(*/0xE0, 0x04/*)*/, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 608(*/0xE0, 0x04/*)*/,
     /* 201247 */   GIR_MakeTempReg, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201251 */   GIR_BuildMI, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201256 */   GIR_AddTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201263 */   GIR_AddSimpleTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/,
     /* 201268 */   GIR_AddSimpleTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/,
     /* 201273 */   GIR_AddImm8, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Imm*/1,
     /* 201277 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201283 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201289 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201295 */   GIR_MakeTempReg, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201299 */   GIR_BuildMI, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201304 */   GIR_AddTempRegister, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201311 */   GIR_AddSimpleTempRegister, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/,
     /* 201316 */   GIR_AddImm8, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Imm*/32,
     /* 201320 */   GIR_AddImm8, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Imm*/31,
     /* 201324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 606(*/0xDE, 0x04/*)*/,
     /* 201327 */   GIR_MakeTempReg, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201331 */   GIR_BuildMI, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201336 */   GIR_AddTempRegister, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201343 */   GIR_AddSimpleTempRegister, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/,
     /* 201348 */   GIR_AddImm, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 605(*/0xDD, 0x04/*)*/,
     /* 201362 */   GIR_MakeTempReg, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201366 */   GIR_BuildMI, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201371 */   GIR_AddTempRegister, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201378 */   GIR_AddSimpleTempRegister, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/,
     /* 201383 */   GIR_AddImm, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 604(*/0xDC, 0x04/*)*/,
     /* 201397 */   GIR_MakeTempReg, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201401 */   GIR_BuildMI, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201406 */   GIR_AddTempRegister, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201413 */   GIR_AddImm, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 603(*/0xDB, 0x04/*)*/,
     /* 201427 */   GIR_MakeTempReg, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201431 */   GIR_BuildMI, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201436 */   GIR_AddTempRegister, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201443 */   GIR_AddSimpleTempRegister, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/,
     /* 201448 */   GIR_AddImm, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 602(*/0xDA, 0x04/*)*/,
     /* 201462 */   GIR_MakeTempReg, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201466 */   GIR_BuildMI, /*InsnID*//* 601(*/0xD9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201471 */   GIR_AddTempRegister, /*InsnID*//* 601(*/0xD9, 0x04/*)*/, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 601(*/0xD9, 0x04/*)*/,
     /* 201481 */   GIR_MakeTempReg, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201485 */   GIR_BuildMI, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201490 */   GIR_AddTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201497 */   GIR_AddSimpleTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/,
     /* 201502 */   GIR_AddSimpleTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/,
     /* 201507 */   GIR_AddImm8, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Imm*/1,
     /* 201511 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201517 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201523 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201529 */   GIR_MakeTempReg, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201533 */   GIR_BuildMI, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201538 */   GIR_AddTempRegister, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201545 */   GIR_AddSimpleTempRegister, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/,
     /* 201550 */   GIR_AddImm8, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Imm*/32,
     /* 201554 */   GIR_AddImm8, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Imm*/31,
     /* 201558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 599(*/0xD7, 0x04/*)*/,
     /* 201561 */   GIR_MakeTempReg, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201565 */   GIR_BuildMI, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201570 */   GIR_AddTempRegister, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201577 */   GIR_AddSimpleTempRegister, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/,
     /* 201582 */   GIR_AddImm, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 598(*/0xD6, 0x04/*)*/,
     /* 201596 */   GIR_MakeTempReg, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201600 */   GIR_BuildMI, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201605 */   GIR_AddTempRegister, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201612 */   GIR_AddSimpleTempRegister, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/,
     /* 201617 */   GIR_AddImm, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 597(*/0xD5, 0x04/*)*/,
     /* 201631 */   GIR_MakeTempReg, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201635 */   GIR_BuildMI, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201640 */   GIR_AddTempRegister, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201647 */   GIR_Copy, /*NewInsnID*//* 596(*/0xD4, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 201652 */   GIR_AddImm8, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Imm*/1,
     /* 201656 */   GIR_AddImm8, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Imm*/62,
     /* 201660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 596(*/0xD4, 0x04/*)*/,
     /* 201663 */   GIR_MakeTempReg, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201667 */   GIR_BuildMI, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201672 */   GIR_AddTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201679 */   GIR_AddSimpleTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/,
     /* 201684 */   GIR_AddSimpleTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/,
     /* 201689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 595(*/0xD3, 0x04/*)*/,
     /* 201692 */   GIR_MakeTempReg, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201696 */   GIR_BuildMI, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201701 */   GIR_AddTempRegister, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201708 */   GIR_AddImm, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 201719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 594(*/0xD2, 0x04/*)*/,
     /* 201722 */   GIR_MakeTempReg, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201726 */   GIR_BuildMI, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201731 */   GIR_AddTempRegister, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201738 */   GIR_AddSimpleTempRegister, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/,
     /* 201743 */   GIR_AddImm, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 201754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 593(*/0xD1, 0x04/*)*/,
     /* 201757 */   GIR_MakeTempReg, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201761 */   GIR_BuildMI, /*InsnID*//* 592(*/0xD0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201766 */   GIR_AddTempRegister, /*InsnID*//* 592(*/0xD0, 0x04/*)*/, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 592(*/0xD0, 0x04/*)*/,
     /* 201776 */   GIR_MakeTempReg, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201780 */   GIR_BuildMI, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201785 */   GIR_AddTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201792 */   GIR_AddSimpleTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/,
     /* 201797 */   GIR_AddSimpleTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/,
     /* 201802 */   GIR_AddImm8, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Imm*/1,
     /* 201806 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201812 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201818 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201824 */   GIR_MakeTempReg, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201828 */   GIR_BuildMI, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201833 */   GIR_AddTempRegister, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201840 */   GIR_AddSimpleTempRegister, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/,
     /* 201845 */   GIR_AddImm8, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Imm*/32,
     /* 201849 */   GIR_AddImm8, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Imm*/31,
     /* 201853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 590(*/0xCE, 0x04/*)*/,
     /* 201856 */   GIR_MakeTempReg, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201860 */   GIR_BuildMI, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201865 */   GIR_AddTempRegister, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201872 */   GIR_AddSimpleTempRegister, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/,
     /* 201877 */   GIR_AddImm, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 201888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 589(*/0xCD, 0x04/*)*/,
     /* 201891 */   GIR_MakeTempReg, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201895 */   GIR_BuildMI, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201900 */   GIR_AddTempRegister, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201907 */   GIR_AddSimpleTempRegister, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/,
     /* 201912 */   GIR_AddImm, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 201923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 588(*/0xCC, 0x04/*)*/,
     /* 201926 */   GIR_MakeTempReg, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201930 */   GIR_BuildMI, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 201935 */   GIR_AddTempRegister, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201942 */   GIR_Copy, /*NewInsnID*//* 587(*/0xCB, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 201947 */   GIR_AddImm8, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Imm*/63,
     /* 201951 */   GIR_AddImm8, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Imm*/1,
     /* 201955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 587(*/0xCB, 0x04/*)*/,
     /* 201958 */   GIR_MakeTempReg, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201962 */   GIR_BuildMI, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201967 */   GIR_AddTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201974 */   GIR_AddSimpleTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/,
     /* 201979 */   GIR_AddSimpleTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/,
     /* 201984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 586(*/0xCA, 0x04/*)*/,
     /* 201987 */   GIR_MakeTempReg, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201991 */   GIR_BuildMI, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 201996 */   GIR_AddTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202003 */   GIR_AddSimpleTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/,
     /* 202008 */   GIR_AddSimpleTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/,
     /* 202013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 585(*/0xC9, 0x04/*)*/,
     /* 202016 */   GIR_MakeTempReg, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202020 */   GIR_BuildMI, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202025 */   GIR_AddTempRegister, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202032 */   GIR_AddSimpleTempRegister, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/,
     /* 202037 */   GIR_AddImm8, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Imm*/2,
     /* 202041 */   GIR_AddImm8, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Imm*/61,
     /* 202045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 584(*/0xC8, 0x04/*)*/,
     /* 202048 */   GIR_MakeTempReg, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202052 */   GIR_BuildMI, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202057 */   GIR_AddTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202064 */   GIR_AddSimpleTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/,
     /* 202069 */   GIR_AddSimpleTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/,
     /* 202074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 583(*/0xC7, 0x04/*)*/,
     /* 202077 */   GIR_MakeTempReg, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202081 */   GIR_BuildMI, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202086 */   GIR_AddTempRegister, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202093 */   GIR_AddImm, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 582(*/0xC6, 0x04/*)*/,
     /* 202107 */   GIR_MakeTempReg, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202111 */   GIR_BuildMI, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202116 */   GIR_AddTempRegister, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202123 */   GIR_AddSimpleTempRegister, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/,
     /* 202128 */   GIR_AddImm, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 581(*/0xC5, 0x04/*)*/,
     /* 202142 */   GIR_MakeTempReg, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202146 */   GIR_BuildMI, /*InsnID*//* 580(*/0xC4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202151 */   GIR_AddTempRegister, /*InsnID*//* 580(*/0xC4, 0x04/*)*/, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 580(*/0xC4, 0x04/*)*/,
     /* 202161 */   GIR_MakeTempReg, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202165 */   GIR_BuildMI, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202170 */   GIR_AddTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202177 */   GIR_AddSimpleTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/,
     /* 202182 */   GIR_AddSimpleTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/,
     /* 202187 */   GIR_AddImm8, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Imm*/1,
     /* 202191 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202197 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202203 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202209 */   GIR_MakeTempReg, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202213 */   GIR_BuildMI, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202218 */   GIR_AddTempRegister, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202225 */   GIR_AddSimpleTempRegister, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/,
     /* 202230 */   GIR_AddImm8, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Imm*/32,
     /* 202234 */   GIR_AddImm8, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Imm*/31,
     /* 202238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 578(*/0xC2, 0x04/*)*/,
     /* 202241 */   GIR_MakeTempReg, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202245 */   GIR_BuildMI, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202250 */   GIR_AddTempRegister, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202257 */   GIR_AddSimpleTempRegister, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/,
     /* 202262 */   GIR_AddImm, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 577(*/0xC1, 0x04/*)*/,
     /* 202276 */   GIR_MakeTempReg, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202280 */   GIR_BuildMI, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202285 */   GIR_AddTempRegister, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202292 */   GIR_AddSimpleTempRegister, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/,
     /* 202297 */   GIR_AddImm, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 576(*/0xC0, 0x04/*)*/,
     /* 202311 */   GIR_MakeTempReg, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202315 */   GIR_BuildMI, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202320 */   GIR_AddTempRegister, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202327 */   GIR_AddImm, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 575(*/0xBF, 0x04/*)*/,
     /* 202341 */   GIR_MakeTempReg, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202345 */   GIR_BuildMI, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202350 */   GIR_AddTempRegister, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202357 */   GIR_AddSimpleTempRegister, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/,
     /* 202362 */   GIR_AddImm, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 574(*/0xBE, 0x04/*)*/,
     /* 202376 */   GIR_MakeTempReg, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202380 */   GIR_BuildMI, /*InsnID*//* 573(*/0xBD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202385 */   GIR_AddTempRegister, /*InsnID*//* 573(*/0xBD, 0x04/*)*/, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 573(*/0xBD, 0x04/*)*/,
     /* 202395 */   GIR_MakeTempReg, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202399 */   GIR_BuildMI, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202404 */   GIR_AddTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202411 */   GIR_AddSimpleTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/,
     /* 202416 */   GIR_AddSimpleTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/,
     /* 202421 */   GIR_AddImm8, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Imm*/1,
     /* 202425 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202431 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202437 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202443 */   GIR_MakeTempReg, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202447 */   GIR_BuildMI, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202452 */   GIR_AddTempRegister, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202459 */   GIR_AddSimpleTempRegister, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/,
     /* 202464 */   GIR_AddImm8, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Imm*/32,
     /* 202468 */   GIR_AddImm8, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Imm*/31,
     /* 202472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 571(*/0xBB, 0x04/*)*/,
     /* 202475 */   GIR_MakeTempReg, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202479 */   GIR_BuildMI, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202484 */   GIR_AddTempRegister, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202491 */   GIR_AddSimpleTempRegister, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/,
     /* 202496 */   GIR_AddImm, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 570(*/0xBA, 0x04/*)*/,
     /* 202510 */   GIR_MakeTempReg, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202514 */   GIR_BuildMI, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202519 */   GIR_AddTempRegister, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202526 */   GIR_AddSimpleTempRegister, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/,
     /* 202531 */   GIR_AddImm, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202542 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 569(*/0xB9, 0x04/*)*/,
     /* 202545 */   GIR_MakeTempReg, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202549 */   GIR_BuildMI, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202554 */   GIR_AddTempRegister, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202561 */   GIR_Copy, /*NewInsnID*//* 568(*/0xB8, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 202566 */   GIR_AddImm8, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Imm*/1,
     /* 202570 */   GIR_AddImm8, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Imm*/62,
     /* 202574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 568(*/0xB8, 0x04/*)*/,
     /* 202577 */   GIR_MakeTempReg, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202581 */   GIR_BuildMI, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202586 */   GIR_AddTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202593 */   GIR_AddSimpleTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/,
     /* 202598 */   GIR_AddSimpleTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/,
     /* 202603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 567(*/0xB7, 0x04/*)*/,
     /* 202606 */   GIR_MakeTempReg, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202610 */   GIR_BuildMI, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202615 */   GIR_AddTempRegister, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202622 */   GIR_AddImm, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 566(*/0xB6, 0x04/*)*/,
     /* 202636 */   GIR_MakeTempReg, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202640 */   GIR_BuildMI, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202645 */   GIR_AddTempRegister, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202652 */   GIR_AddSimpleTempRegister, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/,
     /* 202657 */   GIR_AddImm, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 565(*/0xB5, 0x04/*)*/,
     /* 202671 */   GIR_MakeTempReg, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202675 */   GIR_BuildMI, /*InsnID*//* 564(*/0xB4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202680 */   GIR_AddTempRegister, /*InsnID*//* 564(*/0xB4, 0x04/*)*/, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 564(*/0xB4, 0x04/*)*/,
     /* 202690 */   GIR_MakeTempReg, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202694 */   GIR_BuildMI, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202699 */   GIR_AddTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202706 */   GIR_AddSimpleTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/,
     /* 202711 */   GIR_AddSimpleTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/,
     /* 202716 */   GIR_AddImm8, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Imm*/1,
     /* 202720 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202726 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202732 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202738 */   GIR_MakeTempReg, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202742 */   GIR_BuildMI, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202747 */   GIR_AddTempRegister, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202754 */   GIR_AddSimpleTempRegister, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/,
     /* 202759 */   GIR_AddImm8, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Imm*/32,
     /* 202763 */   GIR_AddImm8, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Imm*/31,
     /* 202767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 562(*/0xB2, 0x04/*)*/,
     /* 202770 */   GIR_MakeTempReg, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202774 */   GIR_BuildMI, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202779 */   GIR_AddTempRegister, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202786 */   GIR_AddSimpleTempRegister, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/,
     /* 202791 */   GIR_AddImm, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 561(*/0xB1, 0x04/*)*/,
     /* 202805 */   GIR_MakeTempReg, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202809 */   GIR_BuildMI, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202814 */   GIR_AddTempRegister, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202821 */   GIR_AddSimpleTempRegister, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/,
     /* 202826 */   GIR_AddImm, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 560(*/0xB0, 0x04/*)*/,
     /* 202840 */   GIR_MakeTempReg, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202844 */   GIR_BuildMI, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 202849 */   GIR_AddTempRegister, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202856 */   GIR_Copy, /*NewInsnID*//* 559(*/0xAF, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 202861 */   GIR_AddImm8, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Imm*/63,
     /* 202865 */   GIR_AddImm8, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Imm*/1,
     /* 202869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 559(*/0xAF, 0x04/*)*/,
     /* 202872 */   GIR_MakeTempReg, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202876 */   GIR_BuildMI, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202881 */   GIR_AddTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202888 */   GIR_AddSimpleTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/,
     /* 202893 */   GIR_AddSimpleTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/,
     /* 202898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 558(*/0xAE, 0x04/*)*/,
     /* 202901 */   GIR_MakeTempReg, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202905 */   GIR_BuildMI, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 202910 */   GIR_AddTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202917 */   GIR_AddSimpleTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/,
     /* 202922 */   GIR_AddSimpleTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/,
     /* 202927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 557(*/0xAD, 0x04/*)*/,
     /* 202930 */   GIR_MakeTempReg, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202934 */   GIR_BuildMI, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 202939 */   GIR_AddTempRegister, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202946 */   GIR_AddSimpleTempRegister, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/,
     /* 202951 */   GIR_AddImm8, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Imm*/62,
     /* 202955 */   GIR_AddImm8, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Imm*/2,
     /* 202959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 556(*/0xAC, 0x04/*)*/,
     /* 202962 */   GIR_MakeTempReg, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202966 */   GIR_BuildMI, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202971 */   GIR_AddTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202978 */   GIR_AddSimpleTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/,
     /* 202983 */   GIR_AddSimpleTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/,
     /* 202988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 555(*/0xAB, 0x04/*)*/,
     /* 202991 */   GIR_MakeTempReg, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202995 */   GIR_BuildMI, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 203000 */   GIR_AddTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203007 */   GIR_AddSimpleTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/,
     /* 203012 */   GIR_AddSimpleTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/,
     /* 203017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 554(*/0xAA, 0x04/*)*/,
     /* 203020 */   GIR_MakeTempReg, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203024 */   GIR_BuildMI, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 203029 */   GIR_AddTempRegister, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203036 */   GIR_AddSimpleTempRegister, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/,
     /* 203041 */   GIR_AddImm8, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Imm*/60,
     /* 203045 */   GIR_AddImm8, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Imm*/4,
     /* 203049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 553(*/0xA9, 0x04/*)*/,
     /* 203052 */   GIR_MakeTempReg, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203056 */   GIR_BuildMI, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 203061 */   GIR_AddTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203068 */   GIR_AddSimpleTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/,
     /* 203073 */   GIR_AddSimpleTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/,
     /* 203078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 552(*/0xA8, 0x04/*)*/,
     /* 203081 */   GIR_MakeTempReg, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203085 */   GIR_BuildMI, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 203090 */   GIR_AddTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203097 */   GIR_AddSimpleTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/,
     /* 203102 */   GIR_AddSimpleTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/,
     /* 203107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 551(*/0xA7, 0x04/*)*/,
     /* 203110 */   GIR_MakeTempReg, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203114 */   GIR_BuildMI, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 203119 */   GIR_AddTempRegister, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203126 */   GIR_AddSimpleTempRegister, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/,
     /* 203131 */   GIR_AddImm8, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Imm*/32,
     /* 203135 */   GIR_AddImm8, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Imm*/32,
     /* 203139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 550(*/0xA6, 0x04/*)*/,
     /* 203142 */   GIR_MakeTempReg, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203146 */   GIR_BuildMI, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203151 */   GIR_AddTempRegister, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203158 */   GIR_AddImm, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 818(*/0xB2, 0x06/*)*/,
     /* 203172 */   GIR_MakeTempReg, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203176 */   GIR_BuildMI, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203181 */   GIR_AddTempRegister, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203188 */   GIR_AddSimpleTempRegister, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/,
     /* 203193 */   GIR_AddImm, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 817(*/0xB1, 0x06/*)*/,
     /* 203207 */   GIR_MakeTempReg, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203211 */   GIR_BuildMI, /*InsnID*//* 816(*/0xB0, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203216 */   GIR_AddTempRegister, /*InsnID*//* 816(*/0xB0, 0x06/*)*/, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 816(*/0xB0, 0x06/*)*/,
     /* 203226 */   GIR_MakeTempReg, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203230 */   GIR_BuildMI, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203235 */   GIR_AddTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203242 */   GIR_AddSimpleTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/,
     /* 203247 */   GIR_AddSimpleTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/,
     /* 203252 */   GIR_AddImm8, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Imm*/1,
     /* 203256 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203262 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203268 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203274 */   GIR_MakeTempReg, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203278 */   GIR_BuildMI, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203283 */   GIR_AddTempRegister, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203290 */   GIR_AddSimpleTempRegister, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/,
     /* 203295 */   GIR_AddImm8, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Imm*/32,
     /* 203299 */   GIR_AddImm8, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Imm*/31,
     /* 203303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 814(*/0xAE, 0x06/*)*/,
     /* 203306 */   GIR_MakeTempReg, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203310 */   GIR_BuildMI, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203315 */   GIR_AddTempRegister, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203322 */   GIR_AddSimpleTempRegister, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/,
     /* 203327 */   GIR_AddImm, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 813(*/0xAD, 0x06/*)*/,
     /* 203341 */   GIR_MakeTempReg, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203345 */   GIR_BuildMI, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203350 */   GIR_AddTempRegister, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203357 */   GIR_AddSimpleTempRegister, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/,
     /* 203362 */   GIR_AddImm, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 812(*/0xAC, 0x06/*)*/,
     /* 203376 */   GIR_MakeTempReg, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203380 */   GIR_BuildMI, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203385 */   GIR_AddTempRegister, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203392 */   GIR_AddImm, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 811(*/0xAB, 0x06/*)*/,
     /* 203406 */   GIR_MakeTempReg, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203410 */   GIR_BuildMI, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203415 */   GIR_AddTempRegister, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203422 */   GIR_AddSimpleTempRegister, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/,
     /* 203427 */   GIR_AddImm, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 810(*/0xAA, 0x06/*)*/,
     /* 203441 */   GIR_MakeTempReg, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203445 */   GIR_BuildMI, /*InsnID*//* 809(*/0xA9, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203450 */   GIR_AddTempRegister, /*InsnID*//* 809(*/0xA9, 0x06/*)*/, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 809(*/0xA9, 0x06/*)*/,
     /* 203460 */   GIR_MakeTempReg, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203464 */   GIR_BuildMI, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203469 */   GIR_AddTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203476 */   GIR_AddSimpleTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/,
     /* 203481 */   GIR_AddSimpleTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/,
     /* 203486 */   GIR_AddImm8, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Imm*/1,
     /* 203490 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203496 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203502 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203508 */   GIR_MakeTempReg, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203512 */   GIR_BuildMI, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203517 */   GIR_AddTempRegister, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203524 */   GIR_AddSimpleTempRegister, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/,
     /* 203529 */   GIR_AddImm8, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Imm*/32,
     /* 203533 */   GIR_AddImm8, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Imm*/31,
     /* 203537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 807(*/0xA7, 0x06/*)*/,
     /* 203540 */   GIR_MakeTempReg, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203544 */   GIR_BuildMI, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203549 */   GIR_AddTempRegister, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203556 */   GIR_AddSimpleTempRegister, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/,
     /* 203561 */   GIR_AddImm, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 806(*/0xA6, 0x06/*)*/,
     /* 203575 */   GIR_MakeTempReg, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203579 */   GIR_BuildMI, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203584 */   GIR_AddTempRegister, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203591 */   GIR_AddSimpleTempRegister, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/,
     /* 203596 */   GIR_AddImm, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 805(*/0xA5, 0x06/*)*/,
     /* 203610 */   GIR_MakeTempReg, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203614 */   GIR_BuildMI, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203619 */   GIR_AddTempRegister, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203626 */   GIR_AddImm, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 804(*/0xA4, 0x06/*)*/,
     /* 203640 */   GIR_MakeTempReg, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203644 */   GIR_BuildMI, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203649 */   GIR_AddTempRegister, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203656 */   GIR_AddSimpleTempRegister, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/,
     /* 203661 */   GIR_AddImm, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 803(*/0xA3, 0x06/*)*/,
     /* 203675 */   GIR_MakeTempReg, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203679 */   GIR_BuildMI, /*InsnID*//* 802(*/0xA2, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203684 */   GIR_AddTempRegister, /*InsnID*//* 802(*/0xA2, 0x06/*)*/, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 802(*/0xA2, 0x06/*)*/,
     /* 203694 */   GIR_MakeTempReg, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203698 */   GIR_BuildMI, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203703 */   GIR_AddTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203710 */   GIR_AddSimpleTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/,
     /* 203715 */   GIR_AddSimpleTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/,
     /* 203720 */   GIR_AddImm8, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Imm*/1,
     /* 203724 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203730 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203736 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203742 */   GIR_MakeTempReg, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203746 */   GIR_BuildMI, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203751 */   GIR_AddTempRegister, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203758 */   GIR_AddSimpleTempRegister, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/,
     /* 203763 */   GIR_AddImm8, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Imm*/32,
     /* 203767 */   GIR_AddImm8, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Imm*/31,
     /* 203771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 800(*/0xA0, 0x06/*)*/,
     /* 203774 */   GIR_MakeTempReg, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203778 */   GIR_BuildMI, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203783 */   GIR_AddTempRegister, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203790 */   GIR_AddSimpleTempRegister, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/,
     /* 203795 */   GIR_AddImm, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 799(*/0x9F, 0x06/*)*/,
     /* 203809 */   GIR_MakeTempReg, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203813 */   GIR_BuildMI, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203818 */   GIR_AddTempRegister, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203825 */   GIR_AddSimpleTempRegister, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/,
     /* 203830 */   GIR_AddImm, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 798(*/0x9E, 0x06/*)*/,
     /* 203844 */   GIR_MakeTempReg, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203848 */   GIR_BuildMI, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203853 */   GIR_AddTempRegister, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203860 */   GIR_Copy, /*NewInsnID*//* 797(*/0x9D, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 203865 */   GIR_AddImm8, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Imm*/1,
     /* 203869 */   GIR_AddImm8, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Imm*/62,
     /* 203873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 797(*/0x9D, 0x06/*)*/,
     /* 203876 */   GIR_MakeTempReg, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203880 */   GIR_BuildMI, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 203885 */   GIR_AddTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203892 */   GIR_AddSimpleTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/,
     /* 203897 */   GIR_AddSimpleTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/,
     /* 203902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 796(*/0x9C, 0x06/*)*/,
     /* 203905 */   GIR_MakeTempReg, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203909 */   GIR_BuildMI, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203914 */   GIR_AddTempRegister, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203921 */   GIR_AddImm, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 203932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 795(*/0x9B, 0x06/*)*/,
     /* 203935 */   GIR_MakeTempReg, /*TempRegID*//* 793(*/0x99, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203939 */   GIR_BuildMI, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203944 */   GIR_AddTempRegister, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegID*//* 793(*/0x99, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203951 */   GIR_AddSimpleTempRegister, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/,
     /* 203956 */   GIR_AddImm, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 203967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 794(*/0x9A, 0x06/*)*/,
     /* 203970 */   GIR_MakeTempReg, /*TempRegID*//* 792(*/0x98, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203974 */   GIR_BuildMI, /*InsnID*//* 793(*/0x99, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203979 */   GIR_AddTempRegister, /*InsnID*//* 793(*/0x99, 0x06/*)*/, /*TempRegID*//* 792(*/0x98, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 793(*/0x99, 0x06/*)*/,
     /* 203989 */   GIR_MakeTempReg, /*TempRegID*//* 791(*/0x97, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203993 */   GIR_BuildMI, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203998 */   GIR_AddTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 791(*/0x97, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204005 */   GIR_AddSimpleTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 792(*/0x98, 0x06/*)*/,
     /* 204010 */   GIR_AddSimpleTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 793(*/0x99, 0x06/*)*/,
     /* 204015 */   GIR_AddImm8, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Imm*/1,
     /* 204019 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204025 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204031 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204037 */   GIR_MakeTempReg, /*TempRegID*//* 790(*/0x96, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204041 */   GIR_BuildMI, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204046 */   GIR_AddTempRegister, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*TempRegID*//* 790(*/0x96, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204053 */   GIR_AddSimpleTempRegister, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*TempRegID*//* 791(*/0x97, 0x06/*)*/,
     /* 204058 */   GIR_AddImm8, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Imm*/32,
     /* 204062 */   GIR_AddImm8, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Imm*/31,
     /* 204066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 791(*/0x97, 0x06/*)*/,
     /* 204069 */   GIR_MakeTempReg, /*TempRegID*//* 789(*/0x95, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204073 */   GIR_BuildMI, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204078 */   GIR_AddTempRegister, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*TempRegID*//* 789(*/0x95, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204085 */   GIR_AddSimpleTempRegister, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*TempRegID*//* 790(*/0x96, 0x06/*)*/,
     /* 204090 */   GIR_AddImm, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 790(*/0x96, 0x06/*)*/,
     /* 204104 */   GIR_MakeTempReg, /*TempRegID*//* 788(*/0x94, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204108 */   GIR_BuildMI, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204113 */   GIR_AddTempRegister, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*TempRegID*//* 788(*/0x94, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204120 */   GIR_AddSimpleTempRegister, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*TempRegID*//* 789(*/0x95, 0x06/*)*/,
     /* 204125 */   GIR_AddImm, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 789(*/0x95, 0x06/*)*/,
     /* 204139 */   GIR_MakeTempReg, /*TempRegID*//* 787(*/0x93, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204143 */   GIR_BuildMI, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 204148 */   GIR_AddTempRegister, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*TempRegID*//* 787(*/0x93, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204155 */   GIR_Copy, /*NewInsnID*//* 788(*/0x94, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 204160 */   GIR_AddImm8, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Imm*/63,
     /* 204164 */   GIR_AddImm8, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Imm*/1,
     /* 204168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 788(*/0x94, 0x06/*)*/,
     /* 204171 */   GIR_MakeTempReg, /*TempRegID*//* 786(*/0x92, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204175 */   GIR_BuildMI, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204180 */   GIR_AddTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 786(*/0x92, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204187 */   GIR_AddSimpleTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 787(*/0x93, 0x06/*)*/,
     /* 204192 */   GIR_AddSimpleTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 788(*/0x94, 0x06/*)*/,
     /* 204197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 787(*/0x93, 0x06/*)*/,
     /* 204200 */   GIR_MakeTempReg, /*TempRegID*//* 785(*/0x91, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204204 */   GIR_BuildMI, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 204209 */   GIR_AddTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 785(*/0x91, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204216 */   GIR_AddSimpleTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 786(*/0x92, 0x06/*)*/,
     /* 204221 */   GIR_AddSimpleTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/,
     /* 204226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 786(*/0x92, 0x06/*)*/,
     /* 204229 */   GIR_MakeTempReg, /*TempRegID*//* 784(*/0x90, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204233 */   GIR_BuildMI, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204238 */   GIR_AddTempRegister, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*TempRegID*//* 784(*/0x90, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204245 */   GIR_AddSimpleTempRegister, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*TempRegID*//* 785(*/0x91, 0x06/*)*/,
     /* 204250 */   GIR_AddImm8, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Imm*/2,
     /* 204254 */   GIR_AddImm8, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Imm*/61,
     /* 204258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 785(*/0x91, 0x06/*)*/,
     /* 204261 */   GIR_MakeTempReg, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204265 */   GIR_BuildMI, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204270 */   GIR_AddTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204277 */   GIR_AddSimpleTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 784(*/0x90, 0x06/*)*/,
     /* 204282 */   GIR_AddSimpleTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/,
     /* 204287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 784(*/0x90, 0x06/*)*/,
     /* 204290 */   GIR_MakeTempReg, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204294 */   GIR_BuildMI, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204299 */   GIR_AddTempRegister, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204306 */   GIR_AddImm, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 783(*/0x8F, 0x06/*)*/,
     /* 204320 */   GIR_MakeTempReg, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204324 */   GIR_BuildMI, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204329 */   GIR_AddTempRegister, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204336 */   GIR_AddSimpleTempRegister, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/,
     /* 204341 */   GIR_AddImm, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 782(*/0x8E, 0x06/*)*/,
     /* 204355 */   GIR_MakeTempReg, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204359 */   GIR_BuildMI, /*InsnID*//* 781(*/0x8D, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204364 */   GIR_AddTempRegister, /*InsnID*//* 781(*/0x8D, 0x06/*)*/, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 781(*/0x8D, 0x06/*)*/,
     /* 204374 */   GIR_MakeTempReg, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204378 */   GIR_BuildMI, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204383 */   GIR_AddTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204390 */   GIR_AddSimpleTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/,
     /* 204395 */   GIR_AddSimpleTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/,
     /* 204400 */   GIR_AddImm8, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Imm*/1,
     /* 204404 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204410 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204416 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204422 */   GIR_MakeTempReg, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204426 */   GIR_BuildMI, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204431 */   GIR_AddTempRegister, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204438 */   GIR_AddSimpleTempRegister, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/,
     /* 204443 */   GIR_AddImm8, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Imm*/32,
     /* 204447 */   GIR_AddImm8, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Imm*/31,
     /* 204451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 779(*/0x8B, 0x06/*)*/,
     /* 204454 */   GIR_MakeTempReg, /*TempRegID*//* 777(*/0x89, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204458 */   GIR_BuildMI, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204463 */   GIR_AddTempRegister, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegID*//* 777(*/0x89, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204470 */   GIR_AddSimpleTempRegister, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/,
     /* 204475 */   GIR_AddImm, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 778(*/0x8A, 0x06/*)*/,
     /* 204489 */   GIR_MakeTempReg, /*TempRegID*//* 776(*/0x88, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204493 */   GIR_BuildMI, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204498 */   GIR_AddTempRegister, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*TempRegID*//* 776(*/0x88, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204505 */   GIR_AddSimpleTempRegister, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*TempRegID*//* 777(*/0x89, 0x06/*)*/,
     /* 204510 */   GIR_AddImm, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 777(*/0x89, 0x06/*)*/,
     /* 204524 */   GIR_MakeTempReg, /*TempRegID*//* 775(*/0x87, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204528 */   GIR_BuildMI, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204533 */   GIR_AddTempRegister, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*TempRegID*//* 775(*/0x87, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204540 */   GIR_AddImm, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 776(*/0x88, 0x06/*)*/,
     /* 204554 */   GIR_MakeTempReg, /*TempRegID*//* 774(*/0x86, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204558 */   GIR_BuildMI, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204563 */   GIR_AddTempRegister, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*TempRegID*//* 774(*/0x86, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204570 */   GIR_AddSimpleTempRegister, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*TempRegID*//* 775(*/0x87, 0x06/*)*/,
     /* 204575 */   GIR_AddImm, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 775(*/0x87, 0x06/*)*/,
     /* 204589 */   GIR_MakeTempReg, /*TempRegID*//* 773(*/0x85, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204593 */   GIR_BuildMI, /*InsnID*//* 774(*/0x86, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204598 */   GIR_AddTempRegister, /*InsnID*//* 774(*/0x86, 0x06/*)*/, /*TempRegID*//* 773(*/0x85, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204605 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 774(*/0x86, 0x06/*)*/,
     /* 204608 */   GIR_MakeTempReg, /*TempRegID*//* 772(*/0x84, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204612 */   GIR_BuildMI, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204617 */   GIR_AddTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 772(*/0x84, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204624 */   GIR_AddSimpleTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 773(*/0x85, 0x06/*)*/,
     /* 204629 */   GIR_AddSimpleTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 774(*/0x86, 0x06/*)*/,
     /* 204634 */   GIR_AddImm8, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Imm*/1,
     /* 204638 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204644 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204650 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204656 */   GIR_MakeTempReg, /*TempRegID*//* 771(*/0x83, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204660 */   GIR_BuildMI, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204665 */   GIR_AddTempRegister, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*TempRegID*//* 771(*/0x83, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204672 */   GIR_AddSimpleTempRegister, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*TempRegID*//* 772(*/0x84, 0x06/*)*/,
     /* 204677 */   GIR_AddImm8, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Imm*/32,
     /* 204681 */   GIR_AddImm8, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Imm*/31,
     /* 204685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 772(*/0x84, 0x06/*)*/,
     /* 204688 */   GIR_MakeTempReg, /*TempRegID*//* 770(*/0x82, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204692 */   GIR_BuildMI, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204697 */   GIR_AddTempRegister, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*TempRegID*//* 770(*/0x82, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204704 */   GIR_AddSimpleTempRegister, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*TempRegID*//* 771(*/0x83, 0x06/*)*/,
     /* 204709 */   GIR_AddImm, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 771(*/0x83, 0x06/*)*/,
     /* 204723 */   GIR_MakeTempReg, /*TempRegID*//* 769(*/0x81, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204727 */   GIR_BuildMI, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204732 */   GIR_AddTempRegister, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*TempRegID*//* 769(*/0x81, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204739 */   GIR_AddSimpleTempRegister, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*TempRegID*//* 770(*/0x82, 0x06/*)*/,
     /* 204744 */   GIR_AddImm, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 770(*/0x82, 0x06/*)*/,
     /* 204758 */   GIR_MakeTempReg, /*TempRegID*//* 768(*/0x80, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204762 */   GIR_BuildMI, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204767 */   GIR_AddTempRegister, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*TempRegID*//* 768(*/0x80, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204774 */   GIR_Copy, /*NewInsnID*//* 769(*/0x81, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 204779 */   GIR_AddImm8, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Imm*/1,
     /* 204783 */   GIR_AddImm8, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Imm*/62,
     /* 204787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 769(*/0x81, 0x06/*)*/,
     /* 204790 */   GIR_MakeTempReg, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204794 */   GIR_BuildMI, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204799 */   GIR_AddTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204806 */   GIR_AddSimpleTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 768(*/0x80, 0x06/*)*/,
     /* 204811 */   GIR_AddSimpleTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 769(*/0x81, 0x06/*)*/,
     /* 204816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 768(*/0x80, 0x06/*)*/,
     /* 204819 */   GIR_MakeTempReg, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 204823 */   GIR_BuildMI, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204828 */   GIR_AddTempRegister, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204835 */   GIR_AddImm, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 767(*/0xFF, 0x05/*)*/,
     /* 204849 */   GIR_MakeTempReg, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 204853 */   GIR_BuildMI, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204858 */   GIR_AddTempRegister, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204865 */   GIR_AddSimpleTempRegister, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/,
     /* 204870 */   GIR_AddImm, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 766(*/0xFE, 0x05/*)*/,
     /* 204884 */   GIR_MakeTempReg, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204888 */   GIR_BuildMI, /*InsnID*//* 765(*/0xFD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204893 */   GIR_AddTempRegister, /*InsnID*//* 765(*/0xFD, 0x05/*)*/, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 765(*/0xFD, 0x05/*)*/,
     /* 204903 */   GIR_MakeTempReg, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204907 */   GIR_BuildMI, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204912 */   GIR_AddTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204919 */   GIR_AddSimpleTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/,
     /* 204924 */   GIR_AddSimpleTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/,
     /* 204929 */   GIR_AddImm8, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Imm*/1,
     /* 204933 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204939 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204945 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204951 */   GIR_MakeTempReg, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204955 */   GIR_BuildMI, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204960 */   GIR_AddTempRegister, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204967 */   GIR_AddSimpleTempRegister, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/,
     /* 204972 */   GIR_AddImm8, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Imm*/32,
     /* 204976 */   GIR_AddImm8, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Imm*/31,
     /* 204980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 763(*/0xFB, 0x05/*)*/,
     /* 204983 */   GIR_MakeTempReg, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204987 */   GIR_BuildMI, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204992 */   GIR_AddTempRegister, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204999 */   GIR_AddSimpleTempRegister, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/,
     /* 205004 */   GIR_AddImm, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 205015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 762(*/0xFA, 0x05/*)*/,
     /* 205018 */   GIR_MakeTempReg, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205022 */   GIR_BuildMI, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205027 */   GIR_AddTempRegister, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205034 */   GIR_AddSimpleTempRegister, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/,
     /* 205039 */   GIR_AddImm, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 205050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 761(*/0xF9, 0x05/*)*/,
     /* 205053 */   GIR_MakeTempReg, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205057 */   GIR_BuildMI, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 205062 */   GIR_AddTempRegister, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205069 */   GIR_Copy, /*NewInsnID*//* 760(*/0xF8, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 205074 */   GIR_AddImm8, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Imm*/63,
     /* 205078 */   GIR_AddImm8, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Imm*/1,
     /* 205082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 760(*/0xF8, 0x05/*)*/,
     /* 205085 */   GIR_MakeTempReg, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205089 */   GIR_BuildMI, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205094 */   GIR_AddTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205101 */   GIR_AddSimpleTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/,
     /* 205106 */   GIR_AddSimpleTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/,
     /* 205111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 759(*/0xF7, 0x05/*)*/,
     /* 205114 */   GIR_MakeTempReg, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205118 */   GIR_BuildMI, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 205123 */   GIR_AddTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205130 */   GIR_AddSimpleTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/,
     /* 205135 */   GIR_AddSimpleTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/,
     /* 205140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 758(*/0xF6, 0x05/*)*/,
     /* 205143 */   GIR_MakeTempReg, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205147 */   GIR_BuildMI, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 205152 */   GIR_AddTempRegister, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205159 */   GIR_AddSimpleTempRegister, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/,
     /* 205164 */   GIR_AddImm8, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Imm*/62,
     /* 205168 */   GIR_AddImm8, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Imm*/2,
     /* 205172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 757(*/0xF5, 0x05/*)*/,
     /* 205175 */   GIR_MakeTempReg, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205179 */   GIR_BuildMI, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205184 */   GIR_AddTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205191 */   GIR_AddSimpleTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/,
     /* 205196 */   GIR_AddSimpleTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 776(*/0x88, 0x06/*)*/,
     /* 205201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 756(*/0xF4, 0x05/*)*/,
     /* 205204 */   GIR_MakeTempReg, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205208 */   GIR_BuildMI, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 205213 */   GIR_AddTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205220 */   GIR_AddSimpleTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/,
     /* 205225 */   GIR_AddSimpleTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/,
     /* 205230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 755(*/0xF3, 0x05/*)*/,
     /* 205233 */   GIR_MakeTempReg, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205237 */   GIR_BuildMI, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205242 */   GIR_AddTempRegister, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205249 */   GIR_AddSimpleTempRegister, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/,
     /* 205254 */   GIR_AddImm8, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Imm*/4,
     /* 205258 */   GIR_AddImm8, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Imm*/59,
     /* 205262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 754(*/0xF2, 0x05/*)*/,
     /* 205265 */   GIR_MakeTempReg, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205269 */   GIR_BuildMI, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205274 */   GIR_AddTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205281 */   GIR_AddSimpleTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/,
     /* 205286 */   GIR_AddSimpleTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/,
     /* 205291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 753(*/0xF1, 0x05/*)*/,
     /* 205294 */   GIR_MakeTempReg, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205298 */   GIR_BuildMI, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 205303 */   GIR_AddTempRegister, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205310 */   GIR_AddImm, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 752(*/0xF0, 0x05/*)*/,
     /* 205324 */   GIR_MakeTempReg, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205328 */   GIR_BuildMI, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 205333 */   GIR_AddTempRegister, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205340 */   GIR_AddSimpleTempRegister, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/,
     /* 205345 */   GIR_AddImm, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 751(*/0xEF, 0x05/*)*/,
     /* 205359 */   GIR_MakeTempReg, /*TempRegID*//* 749(*/0xED, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205363 */   GIR_BuildMI, /*InsnID*//* 750(*/0xEE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205368 */   GIR_AddTempRegister, /*InsnID*//* 750(*/0xEE, 0x05/*)*/, /*TempRegID*//* 749(*/0xED, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 750(*/0xEE, 0x05/*)*/,
     /* 205378 */   GIR_MakeTempReg, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205382 */   GIR_BuildMI, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205387 */   GIR_AddTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205394 */   GIR_AddSimpleTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 749(*/0xED, 0x05/*)*/,
     /* 205399 */   GIR_AddSimpleTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/,
     /* 205404 */   GIR_AddImm8, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Imm*/1,
     /* 205408 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205414 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205420 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205426 */   GIR_MakeTempReg, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205430 */   GIR_BuildMI, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205435 */   GIR_AddTempRegister, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205442 */   GIR_AddSimpleTempRegister, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/,
     /* 205447 */   GIR_AddImm8, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Imm*/32,
     /* 205451 */   GIR_AddImm8, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Imm*/31,
     /* 205455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 748(*/0xEC, 0x05/*)*/,
     /* 205458 */   GIR_MakeTempReg, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205462 */   GIR_BuildMI, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 205467 */   GIR_AddTempRegister, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205474 */   GIR_AddSimpleTempRegister, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/,
     /* 205479 */   GIR_AddImm, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 747(*/0xEB, 0x05/*)*/,
     /* 205493 */   GIR_MakeTempReg, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205497 */   GIR_BuildMI, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205502 */   GIR_AddTempRegister, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205509 */   GIR_AddSimpleTempRegister, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/,
     /* 205514 */   GIR_AddImm, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 746(*/0xEA, 0x05/*)*/,
     /* 205528 */   GIR_MakeTempReg, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205532 */   GIR_BuildMI, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 205537 */   GIR_AddTempRegister, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205544 */   GIR_AddImm, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 205555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 745(*/0xE9, 0x05/*)*/,
     /* 205558 */   GIR_MakeTempReg, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205562 */   GIR_BuildMI, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 205567 */   GIR_AddTempRegister, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205574 */   GIR_AddSimpleTempRegister, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/,
     /* 205579 */   GIR_AddImm, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 205590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 744(*/0xE8, 0x05/*)*/,
     /* 205593 */   GIR_MakeTempReg, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205597 */   GIR_BuildMI, /*InsnID*//* 743(*/0xE7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205602 */   GIR_AddTempRegister, /*InsnID*//* 743(*/0xE7, 0x05/*)*/, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 743(*/0xE7, 0x05/*)*/,
     /* 205612 */   GIR_MakeTempReg, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205616 */   GIR_BuildMI, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205621 */   GIR_AddTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205628 */   GIR_AddSimpleTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/,
     /* 205633 */   GIR_AddSimpleTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/,
     /* 205638 */   GIR_AddImm8, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Imm*/1,
     /* 205642 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205648 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205654 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205660 */   GIR_MakeTempReg, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205664 */   GIR_BuildMI, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205669 */   GIR_AddTempRegister, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205676 */   GIR_AddSimpleTempRegister, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/,
     /* 205681 */   GIR_AddImm8, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Imm*/32,
     /* 205685 */   GIR_AddImm8, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Imm*/31,
     /* 205689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 741(*/0xE5, 0x05/*)*/,
     /* 205692 */   GIR_MakeTempReg, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205696 */   GIR_BuildMI, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 205701 */   GIR_AddTempRegister, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205708 */   GIR_AddSimpleTempRegister, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/,
     /* 205713 */   GIR_AddImm, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 205724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 740(*/0xE4, 0x05/*)*/,
     /* 205727 */   GIR_MakeTempReg, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205731 */   GIR_BuildMI, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205736 */   GIR_AddTempRegister, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205743 */   GIR_AddSimpleTempRegister, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/,
     /* 205748 */   GIR_AddImm, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 205759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 739(*/0xE3, 0x05/*)*/,
     /* 205762 */   GIR_MakeTempReg, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205766 */   GIR_BuildMI, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 205771 */   GIR_AddTempRegister, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205778 */   GIR_AddImm, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 205789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 738(*/0xE2, 0x05/*)*/,
     /* 205792 */   GIR_MakeTempReg, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205796 */   GIR_BuildMI, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 205801 */   GIR_AddTempRegister, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205808 */   GIR_AddSimpleTempRegister, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/,
     /* 205813 */   GIR_AddImm, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 205824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 737(*/0xE1, 0x05/*)*/,
     /* 205827 */   GIR_MakeTempReg, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205831 */   GIR_BuildMI, /*InsnID*//* 736(*/0xE0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205836 */   GIR_AddTempRegister, /*InsnID*//* 736(*/0xE0, 0x05/*)*/, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 736(*/0xE0, 0x05/*)*/,
     /* 205846 */   GIR_MakeTempReg, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205850 */   GIR_BuildMI, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205855 */   GIR_AddTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205862 */   GIR_AddSimpleTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/,
     /* 205867 */   GIR_AddSimpleTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/,
     /* 205872 */   GIR_AddImm8, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Imm*/1,
     /* 205876 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205882 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205888 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205894 */   GIR_MakeTempReg, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205898 */   GIR_BuildMI, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205903 */   GIR_AddTempRegister, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205910 */   GIR_AddSimpleTempRegister, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/,
     /* 205915 */   GIR_AddImm8, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Imm*/32,
     /* 205919 */   GIR_AddImm8, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Imm*/31,
     /* 205923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 734(*/0xDE, 0x05/*)*/,
     /* 205926 */   GIR_MakeTempReg, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205930 */   GIR_BuildMI, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 205935 */   GIR_AddTempRegister, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205942 */   GIR_AddSimpleTempRegister, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/,
     /* 205947 */   GIR_AddImm, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 205958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 733(*/0xDD, 0x05/*)*/,
     /* 205961 */   GIR_MakeTempReg, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205965 */   GIR_BuildMI, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205970 */   GIR_AddTempRegister, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205977 */   GIR_AddSimpleTempRegister, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/,
     /* 205982 */   GIR_AddImm, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 205993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 732(*/0xDC, 0x05/*)*/,
     /* 205996 */   GIR_MakeTempReg, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206000 */   GIR_BuildMI, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206005 */   GIR_AddTempRegister, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206012 */   GIR_Copy, /*NewInsnID*//* 731(*/0xDB, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 206017 */   GIR_AddImm8, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Imm*/1,
     /* 206021 */   GIR_AddImm8, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Imm*/62,
     /* 206025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 731(*/0xDB, 0x05/*)*/,
     /* 206028 */   GIR_MakeTempReg, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206032 */   GIR_BuildMI, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206037 */   GIR_AddTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206044 */   GIR_AddSimpleTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/,
     /* 206049 */   GIR_AddSimpleTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/,
     /* 206054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 730(*/0xDA, 0x05/*)*/,
     /* 206057 */   GIR_MakeTempReg, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206061 */   GIR_BuildMI, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206066 */   GIR_AddTempRegister, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206073 */   GIR_AddImm, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206084 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 729(*/0xD9, 0x05/*)*/,
     /* 206087 */   GIR_MakeTempReg, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206091 */   GIR_BuildMI, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 206096 */   GIR_AddTempRegister, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206103 */   GIR_AddSimpleTempRegister, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/,
     /* 206108 */   GIR_AddImm, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 728(*/0xD8, 0x05/*)*/,
     /* 206122 */   GIR_MakeTempReg, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206126 */   GIR_BuildMI, /*InsnID*//* 727(*/0xD7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206131 */   GIR_AddTempRegister, /*InsnID*//* 727(*/0xD7, 0x05/*)*/, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 727(*/0xD7, 0x05/*)*/,
     /* 206141 */   GIR_MakeTempReg, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206145 */   GIR_BuildMI, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206150 */   GIR_AddTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206157 */   GIR_AddSimpleTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/,
     /* 206162 */   GIR_AddSimpleTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/,
     /* 206167 */   GIR_AddImm8, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Imm*/1,
     /* 206171 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206177 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206183 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 206189 */   GIR_MakeTempReg, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206193 */   GIR_BuildMI, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206198 */   GIR_AddTempRegister, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206205 */   GIR_AddSimpleTempRegister, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/,
     /* 206210 */   GIR_AddImm8, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Imm*/32,
     /* 206214 */   GIR_AddImm8, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Imm*/31,
     /* 206218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 725(*/0xD5, 0x05/*)*/,
     /* 206221 */   GIR_MakeTempReg, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206225 */   GIR_BuildMI, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206230 */   GIR_AddTempRegister, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206237 */   GIR_AddSimpleTempRegister, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/,
     /* 206242 */   GIR_AddImm, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 724(*/0xD4, 0x05/*)*/,
     /* 206256 */   GIR_MakeTempReg, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206260 */   GIR_BuildMI, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206265 */   GIR_AddTempRegister, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206272 */   GIR_AddSimpleTempRegister, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/,
     /* 206277 */   GIR_AddImm, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 723(*/0xD3, 0x05/*)*/,
     /* 206291 */   GIR_MakeTempReg, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206295 */   GIR_BuildMI, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 206300 */   GIR_AddTempRegister, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206307 */   GIR_Copy, /*NewInsnID*//* 722(*/0xD2, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 206312 */   GIR_AddImm8, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Imm*/63,
     /* 206316 */   GIR_AddImm8, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Imm*/1,
     /* 206320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 722(*/0xD2, 0x05/*)*/,
     /* 206323 */   GIR_MakeTempReg, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206327 */   GIR_BuildMI, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206332 */   GIR_AddTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206339 */   GIR_AddSimpleTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/,
     /* 206344 */   GIR_AddSimpleTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/,
     /* 206349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 721(*/0xD1, 0x05/*)*/,
     /* 206352 */   GIR_MakeTempReg, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206356 */   GIR_BuildMI, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 206361 */   GIR_AddTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206368 */   GIR_AddSimpleTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/,
     /* 206373 */   GIR_AddSimpleTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/,
     /* 206378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 720(*/0xD0, 0x05/*)*/,
     /* 206381 */   GIR_MakeTempReg, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206385 */   GIR_BuildMI, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206390 */   GIR_AddTempRegister, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206397 */   GIR_AddSimpleTempRegister, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/,
     /* 206402 */   GIR_AddImm8, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Imm*/2,
     /* 206406 */   GIR_AddImm8, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Imm*/61,
     /* 206410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 719(*/0xCF, 0x05/*)*/,
     /* 206413 */   GIR_MakeTempReg, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206417 */   GIR_BuildMI, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206422 */   GIR_AddTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206429 */   GIR_AddSimpleTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/,
     /* 206434 */   GIR_AddSimpleTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/,
     /* 206439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 718(*/0xCE, 0x05/*)*/,
     /* 206442 */   GIR_MakeTempReg, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206446 */   GIR_BuildMI, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206451 */   GIR_AddTempRegister, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206458 */   GIR_AddImm, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 717(*/0xCD, 0x05/*)*/,
     /* 206472 */   GIR_MakeTempReg, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206476 */   GIR_BuildMI, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 206481 */   GIR_AddTempRegister, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206488 */   GIR_AddSimpleTempRegister, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/,
     /* 206493 */   GIR_AddImm, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 716(*/0xCC, 0x05/*)*/,
     /* 206507 */   GIR_MakeTempReg, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206511 */   GIR_BuildMI, /*InsnID*//* 715(*/0xCB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206516 */   GIR_AddTempRegister, /*InsnID*//* 715(*/0xCB, 0x05/*)*/, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 715(*/0xCB, 0x05/*)*/,
     /* 206526 */   GIR_MakeTempReg, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206530 */   GIR_BuildMI, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206535 */   GIR_AddTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206542 */   GIR_AddSimpleTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/,
     /* 206547 */   GIR_AddSimpleTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/,
     /* 206552 */   GIR_AddImm8, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Imm*/1,
     /* 206556 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206562 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206568 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 206574 */   GIR_MakeTempReg, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206578 */   GIR_BuildMI, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206583 */   GIR_AddTempRegister, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206590 */   GIR_AddSimpleTempRegister, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/,
     /* 206595 */   GIR_AddImm8, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Imm*/32,
     /* 206599 */   GIR_AddImm8, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Imm*/31,
     /* 206603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 713(*/0xC9, 0x05/*)*/,
     /* 206606 */   GIR_MakeTempReg, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206610 */   GIR_BuildMI, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206615 */   GIR_AddTempRegister, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206622 */   GIR_AddSimpleTempRegister, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/,
     /* 206627 */   GIR_AddImm, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 712(*/0xC8, 0x05/*)*/,
     /* 206641 */   GIR_MakeTempReg, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206645 */   GIR_BuildMI, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206650 */   GIR_AddTempRegister, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206657 */   GIR_AddSimpleTempRegister, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/,
     /* 206662 */   GIR_AddImm, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 711(*/0xC7, 0x05/*)*/,
     /* 206676 */   GIR_MakeTempReg, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206680 */   GIR_BuildMI, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206685 */   GIR_AddTempRegister, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206692 */   GIR_AddImm, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 710(*/0xC6, 0x05/*)*/,
     /* 206706 */   GIR_MakeTempReg, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206710 */   GIR_BuildMI, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 206715 */   GIR_AddTempRegister, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206722 */   GIR_AddSimpleTempRegister, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/,
     /* 206727 */   GIR_AddImm, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 709(*/0xC5, 0x05/*)*/,
     /* 206741 */   GIR_MakeTempReg, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206745 */   GIR_BuildMI, /*InsnID*//* 708(*/0xC4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206750 */   GIR_AddTempRegister, /*InsnID*//* 708(*/0xC4, 0x05/*)*/, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 708(*/0xC4, 0x05/*)*/,
     /* 206760 */   GIR_MakeTempReg, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206764 */   GIR_BuildMI, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206769 */   GIR_AddTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206776 */   GIR_AddSimpleTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/,
     /* 206781 */   GIR_AddSimpleTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/,
     /* 206786 */   GIR_AddImm8, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Imm*/1,
     /* 206790 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206796 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206802 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 206808 */   GIR_MakeTempReg, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206812 */   GIR_BuildMI, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206817 */   GIR_AddTempRegister, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206824 */   GIR_AddSimpleTempRegister, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/,
     /* 206829 */   GIR_AddImm8, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Imm*/32,
     /* 206833 */   GIR_AddImm8, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Imm*/31,
     /* 206837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 706(*/0xC2, 0x05/*)*/,
     /* 206840 */   GIR_MakeTempReg, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206844 */   GIR_BuildMI, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206849 */   GIR_AddTempRegister, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206856 */   GIR_AddSimpleTempRegister, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/,
     /* 206861 */   GIR_AddImm, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 705(*/0xC1, 0x05/*)*/,
     /* 206875 */   GIR_MakeTempReg, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206879 */   GIR_BuildMI, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206884 */   GIR_AddTempRegister, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206891 */   GIR_AddSimpleTempRegister, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/,
     /* 206896 */   GIR_AddImm, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 704(*/0xC0, 0x05/*)*/,
     /* 206910 */   GIR_MakeTempReg, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206914 */   GIR_BuildMI, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206919 */   GIR_AddTempRegister, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206926 */   GIR_Copy, /*NewInsnID*//* 703(*/0xBF, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 206931 */   GIR_AddImm8, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Imm*/1,
     /* 206935 */   GIR_AddImm8, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Imm*/62,
     /* 206939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 703(*/0xBF, 0x05/*)*/,
     /* 206942 */   GIR_MakeTempReg, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206946 */   GIR_BuildMI, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206951 */   GIR_AddTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206958 */   GIR_AddSimpleTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/,
     /* 206963 */   GIR_AddSimpleTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/,
     /* 206968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 702(*/0xBE, 0x05/*)*/,
     /* 206971 */   GIR_MakeTempReg, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206975 */   GIR_BuildMI, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206980 */   GIR_AddTempRegister, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206987 */   GIR_AddImm, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 701(*/0xBD, 0x05/*)*/,
     /* 207001 */   GIR_MakeTempReg, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 207005 */   GIR_BuildMI, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 207010 */   GIR_AddTempRegister, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207017 */   GIR_AddSimpleTempRegister, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/,
     /* 207022 */   GIR_AddImm, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 700(*/0xBC, 0x05/*)*/,
     /* 207036 */   GIR_MakeTempReg, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207040 */   GIR_BuildMI, /*InsnID*//* 699(*/0xBB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207045 */   GIR_AddTempRegister, /*InsnID*//* 699(*/0xBB, 0x05/*)*/, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 699(*/0xBB, 0x05/*)*/,
     /* 207055 */   GIR_MakeTempReg, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207059 */   GIR_BuildMI, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 207064 */   GIR_AddTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207071 */   GIR_AddSimpleTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/,
     /* 207076 */   GIR_AddSimpleTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/,
     /* 207081 */   GIR_AddImm8, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Imm*/1,
     /* 207085 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207091 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207097 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207103 */   GIR_MakeTempReg, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207107 */   GIR_BuildMI, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 207112 */   GIR_AddTempRegister, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207119 */   GIR_AddSimpleTempRegister, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/,
     /* 207124 */   GIR_AddImm8, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Imm*/32,
     /* 207128 */   GIR_AddImm8, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Imm*/31,
     /* 207132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 697(*/0xB9, 0x05/*)*/,
     /* 207135 */   GIR_MakeTempReg, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207139 */   GIR_BuildMI, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 207144 */   GIR_AddTempRegister, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207151 */   GIR_AddSimpleTempRegister, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/,
     /* 207156 */   GIR_AddImm, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 696(*/0xB8, 0x05/*)*/,
     /* 207170 */   GIR_MakeTempReg, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207174 */   GIR_BuildMI, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 207179 */   GIR_AddTempRegister, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207186 */   GIR_AddSimpleTempRegister, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/,
     /* 207191 */   GIR_AddImm, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 695(*/0xB7, 0x05/*)*/,
     /* 207205 */   GIR_MakeTempReg, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207209 */   GIR_BuildMI, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207214 */   GIR_AddTempRegister, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207221 */   GIR_Copy, /*NewInsnID*//* 694(*/0xB6, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 207226 */   GIR_AddImm8, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Imm*/63,
     /* 207230 */   GIR_AddImm8, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Imm*/1,
     /* 207234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 694(*/0xB6, 0x05/*)*/,
     /* 207237 */   GIR_MakeTempReg, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207241 */   GIR_BuildMI, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207246 */   GIR_AddTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207253 */   GIR_AddSimpleTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/,
     /* 207258 */   GIR_AddSimpleTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/,
     /* 207263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 693(*/0xB5, 0x05/*)*/,
     /* 207266 */   GIR_MakeTempReg, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207270 */   GIR_BuildMI, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 207275 */   GIR_AddTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207282 */   GIR_AddSimpleTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/,
     /* 207287 */   GIR_AddSimpleTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/,
     /* 207292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 692(*/0xB4, 0x05/*)*/,
     /* 207295 */   GIR_MakeTempReg, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207299 */   GIR_BuildMI, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207304 */   GIR_AddTempRegister, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207311 */   GIR_AddSimpleTempRegister, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/,
     /* 207316 */   GIR_AddImm8, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Imm*/62,
     /* 207320 */   GIR_AddImm8, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Imm*/2,
     /* 207324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 691(*/0xB3, 0x05/*)*/,
     /* 207327 */   GIR_MakeTempReg, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207331 */   GIR_BuildMI, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207336 */   GIR_AddTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207343 */   GIR_AddSimpleTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/,
     /* 207348 */   GIR_AddSimpleTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/,
     /* 207353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 690(*/0xB2, 0x05/*)*/,
     /* 207356 */   GIR_MakeTempReg, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207360 */   GIR_BuildMI, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 207365 */   GIR_AddTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207372 */   GIR_AddSimpleTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/,
     /* 207377 */   GIR_AddSimpleTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/,
     /* 207382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 689(*/0xB1, 0x05/*)*/,
     /* 207385 */   GIR_MakeTempReg, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207389 */   GIR_BuildMI, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207394 */   GIR_AddTempRegister, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207401 */   GIR_AddSimpleTempRegister, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/,
     /* 207406 */   GIR_AddImm8, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Imm*/60,
     /* 207410 */   GIR_AddImm8, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Imm*/4,
     /* 207414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 688(*/0xB0, 0x05/*)*/,
     /* 207417 */   GIR_MakeTempReg, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207421 */   GIR_BuildMI, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207426 */   GIR_AddTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207433 */   GIR_AddSimpleTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/,
     /* 207438 */   GIR_AddSimpleTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/,
     /* 207443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 687(*/0xAF, 0x05/*)*/,
     /* 207446 */   GIR_MakeTempReg, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207450 */   GIR_BuildMI, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 207455 */   GIR_AddTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207462 */   GIR_AddSimpleTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/,
     /* 207467 */   GIR_AddSimpleTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/,
     /* 207472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 686(*/0xAE, 0x05/*)*/,
     /* 207475 */   GIR_MakeTempReg, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207479 */   GIR_BuildMI, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207484 */   GIR_AddTempRegister, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207491 */   GIR_AddSimpleTempRegister, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/,
     /* 207496 */   GIR_AddImm8, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Imm*/32,
     /* 207500 */   GIR_AddImm8, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Imm*/32,
     /* 207504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 685(*/0xAD, 0x05/*)*/,
     /* 207507 */   GIR_MakeTempReg, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 207511 */   GIR_BuildMI, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207516 */   GIR_AddTempRegister, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207523 */   GIR_AddTempSubRegister, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207532 */   GIR_ConstrainOperandRC, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207538 */   GIR_ConstrainOperandRC, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207544 */   GIR_MakeTempReg, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 207548 */   GIR_BuildMI, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207553 */   GIR_AddTempRegister, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207560 */   GIR_AddTempSubRegister, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207569 */   GIR_ConstrainOperandRC, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207575 */   GIR_ConstrainOperandRC, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207581 */   GIR_MakeTempReg, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207585 */   GIR_BuildMI, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207590 */   GIR_AddTempRegister, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207597 */   GIR_AddTempSubRegister, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207606 */   GIR_ConstrainOperandRC, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207612 */   GIR_ConstrainOperandRC, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207618 */   GIR_MakeTempReg, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207622 */   GIR_BuildMI, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 207627 */   GIR_AddTempRegister, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207634 */   GIR_AddSimpleTempRegister, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/,
     /* 207639 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/24,
     /* 207643 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/0,
     /* 207647 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/31,
     /* 207651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 413(*/0x9D, 0x03/*)*/,
     /* 207654 */   GIR_MakeTempReg, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207658 */   GIR_BuildMI, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 207663 */   GIR_AddTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207670 */   GIR_AddSimpleTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/,
     /* 207675 */   GIR_AddSimpleTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/,
     /* 207680 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/8,
     /* 207684 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/8,
     /* 207688 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/15,
     /* 207692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 412(*/0x9C, 0x03/*)*/,
     /* 207695 */   GIR_MakeTempReg, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207699 */   GIR_BuildMI, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 207704 */   GIR_AddTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207711 */   GIR_AddSimpleTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/,
     /* 207716 */   GIR_AddSimpleTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/,
     /* 207721 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/8,
     /* 207725 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/24,
     /* 207729 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/31,
     /* 207733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 411(*/0x9B, 0x03/*)*/,
     /* 207736 */   GIR_MakeTempReg, /*TempRegID*//* 409(*/0x99, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 207740 */   GIR_BuildMI, /*InsnID*//* 410(*/0x9A, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207745 */   GIR_AddTempRegister, /*InsnID*//* 410(*/0x9A, 0x03/*)*/, /*TempRegID*//* 409(*/0x99, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 410(*/0x9A, 0x03/*)*/,
     /* 207755 */   GIR_MakeTempReg, /*TempRegID*//* 408(*/0x98, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 207759 */   GIR_BuildMI, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 207764 */   GIR_AddTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 408(*/0x98, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207771 */   GIR_AddSimpleTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 409(*/0x99, 0x03/*)*/,
     /* 207776 */   GIR_AddSimpleTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/,
     /* 207781 */   GIR_AddImm8, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Imm*/1,
     /* 207785 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207791 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207797 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207803 */   GIR_MakeTempReg, /*TempRegID*//* 274(*/0x92, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 207807 */   GIR_BuildMI, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207812 */   GIR_AddTempRegister, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*TempRegID*//* 274(*/0x92, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207819 */   GIR_AddTempSubRegister, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207828 */   GIR_ConstrainOperandRC, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207834 */   GIR_ConstrainOperandRC, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207840 */   GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 207844 */   GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207849 */   GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207856 */   GIR_AddTempSubRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207865 */   GIR_ConstrainOperandRC, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207871 */   GIR_ConstrainOperandRC, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207877 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 207880 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207884 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207889 */   GIR_AddTempSubRegister, /*InsnID*/7, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207896 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207901 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207906 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 207909 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 207913 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207918 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 207921 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/24,
     /* 207924 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 207927 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
     /* 207930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 207932 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 207935 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 207939 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207944 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 207947 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 207951 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/8,
     /* 207954 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/8,
     /* 207957 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/15,
     /* 207960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 207962 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 207965 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 207969 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207974 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 207977 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*//* 274(*/0x92, 0x02/*)*/,
     /* 207981 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/8,
     /* 207984 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/24,
     /* 207987 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/31,
     /* 207990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 207992 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 207995 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207999 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 208006 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208009 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 208013 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208018 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 208021 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 208024 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 208027 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208032 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208037 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 208042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 208049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208054 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208057 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 208060 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 208063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 208068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 208070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208073 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*//* 408(*/0x98, 0x03/*)*/,
     /* 208077 */   GIR_RootConstrainSelectedInstOperands,
     /* 208078 */   // GIR_Coverage, 4883,
     /* 208078 */   GIR_EraseRootFromParent_Done,
     /* 208079 */ // Label 2763: @208079
     /* 208079 */ GIM_Reject,
     /* 208080 */ // Label 2759: @208080
     /* 208080 */ GIM_Reject,
     /* 208081 */ // Label 71: @208081
     /* 208081 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2769*/ GIMT_Encode4(208355),
     /* 208092 */ /*GILLT_s32*//*Label 2764*/ GIMT_Encode4(208112),
     /* 208096 */ /*GILLT_s64*//*Label 2765*/ GIMT_Encode4(208205),
     /* 208100 */ /*GILLT_s128*//*Label 2766*/ GIMT_Encode4(208253),
     /* 208104 */ /*GILLT_v2s64*//*Label 2767*/ GIMT_Encode4(208284),
     /* 208108 */ /*GILLT_v4s32*//*Label 2768*/ GIMT_Encode4(208307),
     /* 208112 */ // Label 2764: @208112
     /* 208112 */ GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(208204),
     /* 208117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208120 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(208184), // Rule ID 1704 //
     /* 208125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208132 */     // (fceil:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 208132 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208135 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208139 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208144 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 208148 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIP),
     /* 208160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208165 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208183 */     // GIR_Coverage, 1704,
     /* 208183 */     GIR_EraseRootFromParent_Done,
     /* 208184 */   // Label 2771: @208184
     /* 208184 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(208203), // Rule ID 146 //
     /* 208189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208196 */     // (fceil:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIPS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 208196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIPS),
     /* 208201 */     GIR_RootConstrainSelectedInstOperands,
     /* 208202 */     // GIR_Coverage, 146,
     /* 208202 */     GIR_Done,
     /* 208203 */   // Label 2772: @208203
     /* 208203 */   GIM_Reject,
     /* 208204 */ // Label 2770: @208204
     /* 208204 */ GIM_Reject,
     /* 208205 */ // Label 2765: @208205
     /* 208205 */ GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(208252),
     /* 208210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208213 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(208232), // Rule ID 909 //
     /* 208218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208225 */     // (fceil:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 208225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIP),
     /* 208230 */     GIR_RootConstrainSelectedInstOperands,
     /* 208231 */     // GIR_Coverage, 909,
     /* 208231 */     GIR_Done,
     /* 208232 */   // Label 2774: @208232
     /* 208232 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(208251), // Rule ID 144 //
     /* 208237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 208244 */     // (fceil:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIPD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 208244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIPD),
     /* 208249 */     GIR_RootConstrainSelectedInstOperands,
     /* 208250 */     // GIR_Coverage, 144,
     /* 208250 */     GIR_Done,
     /* 208251 */   // Label 2775: @208251
     /* 208251 */   GIM_Reject,
     /* 208252 */ // Label 2773: @208252
     /* 208252 */ GIM_Reject,
     /* 208253 */ // Label 2766: @208253
     /* 208253 */ GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(208283), // Rule ID 2159 //
     /* 208258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208268 */   // (fceil:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 2:{ *:[i32] })
     /* 208268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 208271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 208273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208276 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 208278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 208281 */   GIR_RootConstrainSelectedInstOperands,
     /* 208282 */   // GIR_Coverage, 2159,
     /* 208282 */   GIR_EraseRootFromParent_Done,
     /* 208283 */ // Label 2776: @208283
     /* 208283 */ GIM_Reject,
     /* 208284 */ // Label 2767: @208284
     /* 208284 */ GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(208306), // Rule ID 917 //
     /* 208289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208299 */   // (fceil:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 208299 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIP),
     /* 208304 */   GIR_RootConstrainSelectedInstOperands,
     /* 208305 */   // GIR_Coverage, 917,
     /* 208305 */   GIR_Done,
     /* 208306 */ // Label 2777: @208306
     /* 208306 */ GIM_Reject,
     /* 208307 */ // Label 2768: @208307
     /* 208307 */ GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(208354),
     /* 208312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208315 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(208334), // Rule ID 925 //
     /* 208320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208327 */     // (fceil:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 208327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIP),
     /* 208332 */     GIR_RootConstrainSelectedInstOperands,
     /* 208333 */     // GIR_Coverage, 925,
     /* 208333 */     GIR_Done,
     /* 208334 */   // Label 2779: @208334
     /* 208334 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(208353), // Rule ID 1414 //
     /* 208339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 208342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208346 */     // (fceil:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIP:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 208346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIP),
     /* 208351 */     GIR_RootConstrainSelectedInstOperands,
     /* 208352 */     // GIR_Coverage, 1414,
     /* 208352 */     GIR_Done,
     /* 208353 */   // Label 2780: @208353
     /* 208353 */   GIM_Reject,
     /* 208354 */ // Label 2778: @208354
     /* 208354 */ GIM_Reject,
     /* 208355 */ // Label 2769: @208355
     /* 208355 */ GIM_Reject,
     /* 208356 */ // Label 72: @208356
     /* 208356 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2786*/ GIMT_Encode4(208572),
     /* 208367 */ /*GILLT_s32*//*Label 2781*/ GIMT_Encode4(208387),
     /* 208371 */ /*GILLT_s64*//*Label 2782*/ GIMT_Encode4(208439),
     /* 208375 */ /*GILLT_s128*//*Label 2783*/ GIMT_Encode4(208495),
     /* 208379 */ /*GILLT_v2s64*//*Label 2784*/ GIMT_Encode4(208518),
     /* 208383 */ /*GILLT_v4s32*//*Label 2785*/ GIMT_Encode4(208545),
     /* 208387 */ // Label 2781: @208387
     /* 208387 */ GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(208438),
     /* 208392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208395 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(208414), // Rule ID 960 //
     /* 208400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 208403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208407 */     // (fsqrt:{ *:[f32] } f32:{ *:[f32] }:$XB)  =>  (XSSQRTSP:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 208407 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTSP),
     /* 208412 */     GIR_RootConstrainSelectedInstOperands,
     /* 208413 */     // GIR_Coverage, 960,
     /* 208413 */     GIR_Done,
     /* 208414 */   // Label 2788: @208414
     /* 208414 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(208437), // Rule ID 162 //
     /* 208419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208426 */     // (fsqrt:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FSQRTS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 208426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRTS),
     /* 208431 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208435 */     GIR_RootConstrainSelectedInstOperands,
     /* 208436 */     // GIR_Coverage, 162,
     /* 208436 */     GIR_Done,
     /* 208437 */   // Label 2789: @208437
     /* 208437 */   GIM_Reject,
     /* 208438 */ // Label 2787: @208438
     /* 208438 */ GIM_Reject,
     /* 208439 */ // Label 2782: @208439
     /* 208439 */ GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(208494),
     /* 208444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208447 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(208470), // Rule ID 809 //
     /* 208452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208459 */     // (fsqrt:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSSQRTDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 208459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTDP),
     /* 208464 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208468 */     GIR_RootConstrainSelectedInstOperands,
     /* 208469 */     // GIR_Coverage, 809,
     /* 208469 */     GIR_Done,
     /* 208470 */   // Label 2791: @208470
     /* 208470 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(208493), // Rule ID 160 //
     /* 208475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 208482 */     // (fsqrt:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FSQRT:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 208482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRT),
     /* 208487 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208491 */     GIR_RootConstrainSelectedInstOperands,
     /* 208492 */     // GIR_Coverage, 160,
     /* 208492 */     GIR_Done,
     /* 208493 */   // Label 2792: @208493
     /* 208493 */   GIM_Reject,
     /* 208494 */ // Label 2790: @208494
     /* 208494 */ GIM_Reject,
     /* 208495 */ // Label 2783: @208495
     /* 208495 */ GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(208517), // Rule ID 992 //
     /* 208500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208510 */   // (fsqrt:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSSQRTQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 208510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQP),
     /* 208515 */   GIR_RootConstrainSelectedInstOperands,
     /* 208516 */   // GIR_Coverage, 992,
     /* 208516 */   GIR_Done,
     /* 208517 */ // Label 2793: @208517
     /* 208517 */ GIM_Reject,
     /* 208518 */ // Label 2784: @208518
     /* 208518 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(208544), // Rule ID 820 //
     /* 208523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208533 */   // (fsqrt:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVSQRTDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 208533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTDP),
     /* 208538 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208542 */   GIR_RootConstrainSelectedInstOperands,
     /* 208543 */   // GIR_Coverage, 820,
     /* 208543 */   GIR_Done,
     /* 208544 */ // Label 2794: @208544
     /* 208544 */ GIM_Reject,
     /* 208545 */ // Label 2785: @208545
     /* 208545 */ GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(208571), // Rule ID 822 //
     /* 208550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208560 */   // (fsqrt:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVSQRTSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 208560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTSP),
     /* 208565 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208569 */   GIR_RootConstrainSelectedInstOperands,
     /* 208570 */   // GIR_Coverage, 822,
     /* 208570 */   GIR_Done,
     /* 208571 */ // Label 2795: @208571
     /* 208571 */ GIM_Reject,
     /* 208572 */ // Label 2786: @208572
     /* 208572 */ GIM_Reject,
     /* 208573 */ // Label 73: @208573
     /* 208573 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2801*/ GIMT_Encode4(208847),
     /* 208584 */ /*GILLT_s32*//*Label 2796*/ GIMT_Encode4(208604),
     /* 208588 */ /*GILLT_s64*//*Label 2797*/ GIMT_Encode4(208697),
     /* 208592 */ /*GILLT_s128*//*Label 2798*/ GIMT_Encode4(208745),
     /* 208596 */ /*GILLT_v2s64*//*Label 2799*/ GIMT_Encode4(208776),
     /* 208600 */ /*GILLT_v4s32*//*Label 2800*/ GIMT_Encode4(208799),
     /* 208604 */ // Label 2796: @208604
     /* 208604 */ GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(208696),
     /* 208609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208612 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(208676), // Rule ID 1702 //
     /* 208617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208624 */     // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIM:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 208624 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208627 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208631 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208636 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 208640 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIM),
     /* 208652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208657 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208675 */     // GIR_Coverage, 1702,
     /* 208675 */     GIR_EraseRootFromParent_Done,
     /* 208676 */   // Label 2803: @208676
     /* 208676 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(208695), // Rule ID 154 //
     /* 208681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208688 */     // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIMS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 208688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIMS),
     /* 208693 */     GIR_RootConstrainSelectedInstOperands,
     /* 208694 */     // GIR_Coverage, 154,
     /* 208694 */     GIR_Done,
     /* 208695 */   // Label 2804: @208695
     /* 208695 */   GIM_Reject,
     /* 208696 */ // Label 2802: @208696
     /* 208696 */ GIM_Reject,
     /* 208697 */ // Label 2797: @208697
     /* 208697 */ GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(208744),
     /* 208702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208705 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(208724), // Rule ID 907 //
     /* 208710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208717 */     // (ffloor:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIM:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 208717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIM),
     /* 208722 */     GIR_RootConstrainSelectedInstOperands,
     /* 208723 */     // GIR_Coverage, 907,
     /* 208723 */     GIR_Done,
     /* 208724 */   // Label 2806: @208724
     /* 208724 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(208743), // Rule ID 152 //
     /* 208729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 208736 */     // (ffloor:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIMD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 208736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIMD),
     /* 208741 */     GIR_RootConstrainSelectedInstOperands,
     /* 208742 */     // GIR_Coverage, 152,
     /* 208742 */     GIR_Done,
     /* 208743 */   // Label 2807: @208743
     /* 208743 */   GIM_Reject,
     /* 208744 */ // Label 2805: @208744
     /* 208744 */ GIM_Reject,
     /* 208745 */ // Label 2798: @208745
     /* 208745 */ GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(208775), // Rule ID 2161 //
     /* 208750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208760 */   // (ffloor:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 208760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 208763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 208765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208768 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 208770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 208773 */   GIR_RootConstrainSelectedInstOperands,
     /* 208774 */   // GIR_Coverage, 2161,
     /* 208774 */   GIR_EraseRootFromParent_Done,
     /* 208775 */ // Label 2808: @208775
     /* 208775 */ GIM_Reject,
     /* 208776 */ // Label 2799: @208776
     /* 208776 */ GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(208798), // Rule ID 915 //
     /* 208781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208791 */   // (ffloor:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIM:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 208791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIM),
     /* 208796 */   GIR_RootConstrainSelectedInstOperands,
     /* 208797 */   // GIR_Coverage, 915,
     /* 208797 */   GIR_Done,
     /* 208798 */ // Label 2809: @208798
     /* 208798 */ GIM_Reject,
     /* 208799 */ // Label 2800: @208799
     /* 208799 */ GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(208846),
     /* 208804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208807 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(208826), // Rule ID 923 //
     /* 208812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208819 */     // (ffloor:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIM:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 208819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIM),
     /* 208824 */     GIR_RootConstrainSelectedInstOperands,
     /* 208825 */     // GIR_Coverage, 923,
     /* 208825 */     GIR_Done,
     /* 208826 */   // Label 2811: @208826
     /* 208826 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(208845), // Rule ID 1413 //
     /* 208831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 208834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208838 */     // (ffloor:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIM:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 208838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIM),
     /* 208843 */     GIR_RootConstrainSelectedInstOperands,
     /* 208844 */     // GIR_Coverage, 1413,
     /* 208844 */     GIR_Done,
     /* 208845 */   // Label 2812: @208845
     /* 208845 */   GIM_Reject,
     /* 208846 */ // Label 2810: @208846
     /* 208846 */ GIM_Reject,
     /* 208847 */ // Label 2801: @208847
     /* 208847 */ GIM_Reject,
     /* 208848 */ // Label 74: @208848
     /* 208848 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2818*/ GIMT_Encode4(209059),
     /* 208859 */ /*GILLT_s32*//*Label 2813*/ GIMT_Encode4(208879),
     /* 208863 */ /*GILLT_s64*//*Label 2814*/ GIMT_Encode4(208947),
     /* 208867 */ /*GILLT_s128*//*Label 2815*/ GIMT_Encode4(208974),
     /* 208871 */ /*GILLT_v2s64*//*Label 2816*/ GIMT_Encode4(209005),
     /* 208875 */ /*GILLT_v4s32*//*Label 2817*/ GIMT_Encode4(209032),
     /* 208879 */ // Label 2813: @208879
     /* 208879 */ GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(208946), // Rule ID 1708 //
     /* 208884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208894 */   // (frint:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIC:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 208894 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208897 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208901 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208906 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 208910 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 208922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208927 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208937 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208940 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208945 */   // GIR_Coverage, 1708,
     /* 208945 */   GIR_EraseRootFromParent_Done,
     /* 208946 */ // Label 2819: @208946
     /* 208946 */ GIM_Reject,
     /* 208947 */ // Label 2814: @208947
     /* 208947 */ GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(208973), // Rule ID 1712 //
     /* 208952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208962 */   // (frint:{ *:[f64] } f64:{ *:[f64] }:$S)  =>  (XSRDPIC:{ *:[f64] } ?:{ *:[f64] }:$S)
     /* 208962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 208967 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208971 */   GIR_RootConstrainSelectedInstOperands,
     /* 208972 */   // GIR_Coverage, 1712,
     /* 208972 */   GIR_Done,
     /* 208973 */ // Label 2820: @208973
     /* 208973 */ GIM_Reject,
     /* 208974 */ // Label 2815: @208974
     /* 208974 */ GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(209004), // Rule ID 2163 //
     /* 208979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208989 */   // (frint:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPIX:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 208989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPIX),
     /* 208992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 208994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208997 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 208999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 209002 */   GIR_RootConstrainSelectedInstOperands,
     /* 209003 */   // GIR_Coverage, 2163,
     /* 209003 */   GIR_EraseRootFromParent_Done,
     /* 209004 */ // Label 2821: @209004
     /* 209004 */ GIM_Reject,
     /* 209005 */ // Label 2816: @209005
     /* 209005 */ GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(209031), // Rule ID 1714 //
     /* 209010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209020 */   // (frint:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$S)  =>  (XVRDPIC:{ *:[v2f64] } ?:{ *:[v2f64] }:$S)
     /* 209020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIC),
     /* 209025 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209029 */   GIR_RootConstrainSelectedInstOperands,
     /* 209030 */   // GIR_Coverage, 1714,
     /* 209030 */   GIR_Done,
     /* 209031 */ // Label 2822: @209031
     /* 209031 */ GIM_Reject,
     /* 209032 */ // Label 2817: @209032
     /* 209032 */ GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(209058), // Rule ID 1710 //
     /* 209037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209047 */   // (frint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$S)  =>  (XVRSPIC:{ *:[v4f32] } ?:{ *:[v4f32] }:$S)
     /* 209047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIC),
     /* 209052 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209056 */   GIR_RootConstrainSelectedInstOperands,
     /* 209057 */   // GIR_Coverage, 1710,
     /* 209057 */   GIR_Done,
     /* 209058 */ // Label 2823: @209058
     /* 209058 */ GIM_Reject,
     /* 209059 */ // Label 2818: @209059
     /* 209059 */ GIM_Reject,
     /* 209060 */ // Label 75: @209060
     /* 209060 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2829*/ GIMT_Encode4(209296),
     /* 209071 */ /*GILLT_s32*//*Label 2824*/ GIMT_Encode4(209091),
     /* 209075 */ /*GILLT_s64*//*Label 2825*/ GIMT_Encode4(209159),
     /* 209079 */ /*GILLT_s128*//*Label 2826*/ GIMT_Encode4(209186),
     /* 209083 */ /*GILLT_v2s64*//*Label 2827*/ GIMT_Encode4(209217),
     /* 209087 */ /*GILLT_v4s32*//*Label 2828*/ GIMT_Encode4(209244),
     /* 209091 */ // Label 2824: @209091
     /* 209091 */ GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(209158), // Rule ID 1715 //
     /* 209096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209106 */   // (fnearbyint:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIC:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 209106 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 209109 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 209113 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209118 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 209122 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 209130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 209134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209139 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 209142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 209147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209149 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209152 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209157 */   // GIR_Coverage, 1715,
     /* 209157 */   GIR_EraseRootFromParent_Done,
     /* 209158 */ // Label 2830: @209158
     /* 209158 */ GIM_Reject,
     /* 209159 */ // Label 2825: @209159
     /* 209159 */ GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(209185), // Rule ID 1716 //
     /* 209164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209174 */   // (fnearbyint:{ *:[f64] } f64:{ *:[f64] }:$S)  =>  (XSRDPIC:{ *:[f64] } ?:{ *:[f64] }:$S)
     /* 209174 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 209179 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209183 */   GIR_RootConstrainSelectedInstOperands,
     /* 209184 */   // GIR_Coverage, 1716,
     /* 209184 */   GIR_Done,
     /* 209185 */ // Label 2831: @209185
     /* 209185 */ GIM_Reject,
     /* 209186 */ // Label 2826: @209186
     /* 209186 */ GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(209216), // Rule ID 2153 //
     /* 209191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209201 */   // (fnearbyint:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 209201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 209204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 209206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209209 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 209211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 209214 */   GIR_RootConstrainSelectedInstOperands,
     /* 209215 */   // GIR_Coverage, 2153,
     /* 209215 */   GIR_EraseRootFromParent_Done,
     /* 209216 */ // Label 2832: @209216
     /* 209216 */ GIM_Reject,
     /* 209217 */ // Label 2827: @209217
     /* 209217 */ GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(209243), // Rule ID 1717 //
     /* 209222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209232 */   // (fnearbyint:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$S)  =>  (XVRDPIC:{ *:[v2f64] } ?:{ *:[v2f64] }:$S)
     /* 209232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIC),
     /* 209237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209241 */   GIR_RootConstrainSelectedInstOperands,
     /* 209242 */   // GIR_Coverage, 1717,
     /* 209242 */   GIR_Done,
     /* 209243 */ // Label 2833: @209243
     /* 209243 */ GIM_Reject,
     /* 209244 */ // Label 2828: @209244
     /* 209244 */ GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(209295),
     /* 209249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209252 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(209275), // Rule ID 1718 //
     /* 209257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209264 */     // (fnearbyint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$S)  =>  (XVRSPIC:{ *:[v4f32] } ?:{ *:[v4f32] }:$S)
     /* 209264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIC),
     /* 209269 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209273 */     GIR_RootConstrainSelectedInstOperands,
     /* 209274 */     // GIR_Coverage, 1718,
     /* 209274 */     GIR_Done,
     /* 209275 */   // Label 2835: @209275
     /* 209275 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(209294), // Rule ID 1416 //
     /* 209280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 209283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209287 */     // (fnearbyint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIN:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 209287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIN),
     /* 209292 */     GIR_RootConstrainSelectedInstOperands,
     /* 209293 */     // GIR_Coverage, 1416,
     /* 209293 */     GIR_Done,
     /* 209294 */   // Label 2836: @209294
     /* 209294 */   GIM_Reject,
     /* 209295 */ // Label 2834: @209295
     /* 209295 */ GIM_Reject,
     /* 209296 */ // Label 2829: @209296
     /* 209296 */ GIM_Reject,
     /* 209297 */ // Label 76: @209297
     /* 209297 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2842*/ GIMT_Encode4(209566),
     /* 209308 */ /*GILLT_s32*//*Label 2837*/ GIMT_Encode4(209328),
     /* 209312 */ /*GILLT_s64*//*Label 2838*/ GIMT_Encode4(209402),
     /* 209316 */ /*GILLT_s128*//*Label 2839*/ GIMT_Encode4(209480),
     /* 209320 */ /*GILLT_v2s64*//*Label 2840*/ GIMT_Encode4(209506),
     /* 209324 */ /*GILLT_v4s32*//*Label 2841*/ GIMT_Encode4(209536),
     /* 209328 */ // Label 2837: @209328
     /* 209328 */ GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(209401),
     /* 209333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209339 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(209358), // Rule ID 948 //
     /* 209344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 209347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209351 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSADDSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 209351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDSP),
     /* 209356 */     GIR_RootConstrainSelectedInstOperands,
     /* 209357 */     // GIR_Coverage, 948,
     /* 209357 */     GIR_Done,
     /* 209358 */   // Label 2844: @209358
     /* 209358 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(209381), // Rule ID 238 //
     /* 209363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 209370 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 209370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADDS),
     /* 209375 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209379 */     GIR_RootConstrainSelectedInstOperands,
     /* 209380 */     // GIR_Coverage, 238,
     /* 209380 */     GIR_Done,
     /* 209381 */   // Label 2845: @209381
     /* 209381 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(209400), // Rule ID 578 //
     /* 209386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 209393 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSADD:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 209393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSADD),
     /* 209398 */     GIR_RootConstrainSelectedInstOperands,
     /* 209399 */     // GIR_Coverage, 578,
     /* 209399 */     GIR_Done,
     /* 209400 */   // Label 2846: @209400
     /* 209400 */   GIM_Reject,
     /* 209401 */ // Label 2843: @209401
     /* 209401 */ GIM_Reject,
     /* 209402 */ // Label 2838: @209402
     /* 209402 */ GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(209479),
     /* 209407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 209413 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(209436), // Rule ID 765 //
     /* 209418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209425 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSADDDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 209425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDDP),
     /* 209430 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209434 */     GIR_RootConstrainSelectedInstOperands,
     /* 209435 */     // GIR_Coverage, 765,
     /* 209435 */     GIR_Done,
     /* 209436 */   // Label 2848: @209436
     /* 209436 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(209459), // Rule ID 236 //
     /* 209441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 209448 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 209448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADD),
     /* 209453 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209457 */     GIR_RootConstrainSelectedInstOperands,
     /* 209458 */     // GIR_Coverage, 236,
     /* 209458 */     GIR_Done,
     /* 209459 */   // Label 2849: @209459
     /* 209459 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(209478), // Rule ID 557 //
     /* 209464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 209471 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDADD:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 209471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDADD),
     /* 209476 */     GIR_RootConstrainSelectedInstOperands,
     /* 209477 */     // GIR_Coverage, 557,
     /* 209477 */     GIR_Done,
     /* 209478 */   // Label 2850: @209478
     /* 209478 */   GIM_Reject,
     /* 209479 */ // Label 2847: @209479
     /* 209479 */ GIM_Reject,
     /* 209480 */ // Label 2839: @209480
     /* 209480 */ GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(209505), // Rule ID 983 //
     /* 209485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 209494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209498 */   // (strict_fadd:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 209498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDQP),
     /* 209503 */   GIR_RootConstrainSelectedInstOperands,
     /* 209504 */   // GIR_Coverage, 983,
     /* 209504 */   GIR_Done,
     /* 209505 */ // Label 2851: @209505
     /* 209505 */ GIM_Reject,
     /* 209506 */ // Label 2840: @209506
     /* 209506 */ GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(209535), // Rule ID 769 //
     /* 209511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209524 */   // (strict_fadd:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVADDDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 209524 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDDP),
     /* 209529 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209533 */   GIR_RootConstrainSelectedInstOperands,
     /* 209534 */   // GIR_Coverage, 769,
     /* 209534 */   GIR_Done,
     /* 209535 */ // Label 2852: @209535
     /* 209535 */ GIM_Reject,
     /* 209536 */ // Label 2841: @209536
     /* 209536 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(209565), // Rule ID 771 //
     /* 209541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209554 */   // (strict_fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVADDSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 209554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDSP),
     /* 209559 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209563 */   GIR_RootConstrainSelectedInstOperands,
     /* 209564 */   // GIR_Coverage, 771,
     /* 209564 */   GIR_Done,
     /* 209565 */ // Label 2853: @209565
     /* 209565 */ GIM_Reject,
     /* 209566 */ // Label 2842: @209566
     /* 209566 */ GIM_Reject,
     /* 209567 */ // Label 77: @209567
     /* 209567 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2859*/ GIMT_Encode4(209836),
     /* 209578 */ /*GILLT_s32*//*Label 2854*/ GIMT_Encode4(209598),
     /* 209582 */ /*GILLT_s64*//*Label 2855*/ GIMT_Encode4(209672),
     /* 209586 */ /*GILLT_s128*//*Label 2856*/ GIMT_Encode4(209750),
     /* 209590 */ /*GILLT_v2s64*//*Label 2857*/ GIMT_Encode4(209776),
     /* 209594 */ /*GILLT_v4s32*//*Label 2858*/ GIMT_Encode4(209806),
     /* 209598 */ // Label 2854: @209598
     /* 209598 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(209671),
     /* 209603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209609 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(209628), // Rule ID 952 //
     /* 209614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 209617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209621 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSSUBSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 209621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBSP),
     /* 209626 */     GIR_RootConstrainSelectedInstOperands,
     /* 209627 */     // GIR_Coverage, 952,
     /* 209627 */     GIR_Done,
     /* 209628 */   // Label 2861: @209628
     /* 209628 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(209651), // Rule ID 250 //
     /* 209633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 209640 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 209640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUBS),
     /* 209645 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209649 */     GIR_RootConstrainSelectedInstOperands,
     /* 209650 */     // GIR_Coverage, 250,
     /* 209650 */     GIR_Done,
     /* 209651 */   // Label 2862: @209651
     /* 209651 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(209670), // Rule ID 596 //
     /* 209656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 209663 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSSUB:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 209663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSSUB),
     /* 209668 */     GIR_RootConstrainSelectedInstOperands,
     /* 209669 */     // GIR_Coverage, 596,
     /* 209669 */     GIR_Done,
     /* 209670 */   // Label 2863: @209670
     /* 209670 */   GIM_Reject,
     /* 209671 */ // Label 2860: @209671
     /* 209671 */ GIM_Reject,
     /* 209672 */ // Label 2855: @209672
     /* 209672 */ GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(209749),
     /* 209677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 209683 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(209706), // Rule ID 777 //
     /* 209688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209695 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSSUBDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 209695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBDP),
     /* 209700 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209704 */     GIR_RootConstrainSelectedInstOperands,
     /* 209705 */     // GIR_Coverage, 777,
     /* 209705 */     GIR_Done,
     /* 209706 */   // Label 2865: @209706
     /* 209706 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(209729), // Rule ID 248 //
     /* 209711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 209718 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 209718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUB),
     /* 209723 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209727 */     GIR_RootConstrainSelectedInstOperands,
     /* 209728 */     // GIR_Coverage, 248,
     /* 209728 */     GIR_Done,
     /* 209729 */   // Label 2866: @209729
     /* 209729 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(209748), // Rule ID 575 //
     /* 209734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 209741 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDSUB:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 209741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDSUB),
     /* 209746 */     GIR_RootConstrainSelectedInstOperands,
     /* 209747 */     // GIR_Coverage, 575,
     /* 209747 */     GIR_Done,
     /* 209748 */   // Label 2867: @209748
     /* 209748 */   GIM_Reject,
     /* 209749 */ // Label 2864: @209749
     /* 209749 */ GIM_Reject,
     /* 209750 */ // Label 2856: @209750
     /* 209750 */ GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(209775), // Rule ID 987 //
     /* 209755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 209764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209768 */   // (strict_fsub:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 209768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBQP),
     /* 209773 */   GIR_RootConstrainSelectedInstOperands,
     /* 209774 */   // GIR_Coverage, 987,
     /* 209774 */   GIR_Done,
     /* 209775 */ // Label 2868: @209775
     /* 209775 */ GIM_Reject,
     /* 209776 */ // Label 2857: @209776
     /* 209776 */ GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(209805), // Rule ID 779 //
     /* 209781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209794 */   // (strict_fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVSUBDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 209794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBDP),
     /* 209799 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209803 */   GIR_RootConstrainSelectedInstOperands,
     /* 209804 */   // GIR_Coverage, 779,
     /* 209804 */   GIR_Done,
     /* 209805 */ // Label 2869: @209805
     /* 209805 */ GIM_Reject,
     /* 209806 */ // Label 2858: @209806
     /* 209806 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(209835), // Rule ID 781 //
     /* 209811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209824 */   // (strict_fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVSUBSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 209824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBSP),
     /* 209829 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209833 */   GIR_RootConstrainSelectedInstOperands,
     /* 209834 */   // GIR_Coverage, 781,
     /* 209834 */   GIR_Done,
     /* 209835 */ // Label 2870: @209835
     /* 209835 */ GIM_Reject,
     /* 209836 */ // Label 2859: @209836
     /* 209836 */ GIM_Reject,
     /* 209837 */ // Label 78: @209837
     /* 209837 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2876*/ GIMT_Encode4(210106),
     /* 209848 */ /*GILLT_s32*//*Label 2871*/ GIMT_Encode4(209868),
     /* 209852 */ /*GILLT_s64*//*Label 2872*/ GIMT_Encode4(209942),
     /* 209856 */ /*GILLT_s128*//*Label 2873*/ GIMT_Encode4(210020),
     /* 209860 */ /*GILLT_v2s64*//*Label 2874*/ GIMT_Encode4(210046),
     /* 209864 */ /*GILLT_v4s32*//*Label 2875*/ GIMT_Encode4(210076),
     /* 209868 */ // Label 2871: @209868
     /* 209868 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(209941),
     /* 209873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209879 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(209898), // Rule ID 950 //
     /* 209884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 209887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209891 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSMULSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 209891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULSP),
     /* 209896 */     GIR_RootConstrainSelectedInstOperands,
     /* 209897 */     // GIR_Coverage, 950,
     /* 209897 */     GIR_Done,
     /* 209898 */   // Label 2878: @209898
     /* 209898 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(209921), // Rule ID 246 //
     /* 209903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 209910 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)  =>  (FMULS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)
     /* 209910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMULS),
     /* 209915 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209919 */     GIR_RootConstrainSelectedInstOperands,
     /* 209920 */     // GIR_Coverage, 246,
     /* 209920 */     GIR_Done,
     /* 209921 */   // Label 2879: @209921
     /* 209921 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(209940), // Rule ID 592 //
     /* 209926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 209933 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSMUL:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 209933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSMUL),
     /* 209938 */     GIR_RootConstrainSelectedInstOperands,
     /* 209939 */     // GIR_Coverage, 592,
     /* 209939 */     GIR_Done,
     /* 209940 */   // Label 2880: @209940
     /* 209940 */   GIM_Reject,
     /* 209941 */ // Label 2877: @209941
     /* 209941 */ GIM_Reject,
     /* 209942 */ // Label 2872: @209942
     /* 209942 */ GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(210019),
     /* 209947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 209953 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(209976), // Rule ID 767 //
     /* 209958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209965 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSMULDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 209965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULDP),
     /* 209970 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209974 */     GIR_RootConstrainSelectedInstOperands,
     /* 209975 */     // GIR_Coverage, 767,
     /* 209975 */     GIR_Done,
     /* 209976 */   // Label 2882: @209976
     /* 209976 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(209999), // Rule ID 244 //
     /* 209981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 209988 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)  =>  (FMUL:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)
     /* 209988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMUL),
     /* 209993 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209997 */     GIR_RootConstrainSelectedInstOperands,
     /* 209998 */     // GIR_Coverage, 244,
     /* 209998 */     GIR_Done,
     /* 209999 */   // Label 2883: @209999
     /* 209999 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(210018), // Rule ID 571 //
     /* 210004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 210011 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDMUL:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 210011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDMUL),
     /* 210016 */     GIR_RootConstrainSelectedInstOperands,
     /* 210017 */     // GIR_Coverage, 571,
     /* 210017 */     GIR_Done,
     /* 210018 */   // Label 2884: @210018
     /* 210018 */   GIM_Reject,
     /* 210019 */ // Label 2881: @210019
     /* 210019 */ GIM_Reject,
     /* 210020 */ // Label 2873: @210020
     /* 210020 */ GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(210045), // Rule ID 985 //
     /* 210025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 210031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 210034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 210038 */   // (strict_fmul:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210038 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULQP),
     /* 210043 */   GIR_RootConstrainSelectedInstOperands,
     /* 210044 */   // GIR_Coverage, 985,
     /* 210044 */   GIR_Done,
     /* 210045 */ // Label 2885: @210045
     /* 210045 */ GIM_Reject,
     /* 210046 */ // Label 2874: @210046
     /* 210046 */ GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(210075), // Rule ID 773 //
     /* 210051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210064 */   // (strict_fmul:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVMULDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210064 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULDP),
     /* 210069 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210073 */   GIR_RootConstrainSelectedInstOperands,
     /* 210074 */   // GIR_Coverage, 773,
     /* 210074 */   GIR_Done,
     /* 210075 */ // Label 2886: @210075
     /* 210075 */ GIM_Reject,
     /* 210076 */ // Label 2875: @210076
     /* 210076 */ GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(210105), // Rule ID 775 //
     /* 210081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210094 */   // (strict_fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVMULSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULSP),
     /* 210099 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210103 */   GIR_RootConstrainSelectedInstOperands,
     /* 210104 */   // GIR_Coverage, 775,
     /* 210104 */   GIR_Done,
     /* 210105 */ // Label 2887: @210105
     /* 210105 */ GIM_Reject,
     /* 210106 */ // Label 2876: @210106
     /* 210106 */ GIM_Reject,
     /* 210107 */ // Label 79: @210107
     /* 210107 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2893*/ GIMT_Encode4(210376),
     /* 210118 */ /*GILLT_s32*//*Label 2888*/ GIMT_Encode4(210138),
     /* 210122 */ /*GILLT_s64*//*Label 2889*/ GIMT_Encode4(210212),
     /* 210126 */ /*GILLT_s128*//*Label 2890*/ GIMT_Encode4(210290),
     /* 210130 */ /*GILLT_v2s64*//*Label 2891*/ GIMT_Encode4(210316),
     /* 210134 */ /*GILLT_v4s32*//*Label 2892*/ GIMT_Encode4(210346),
     /* 210138 */ // Label 2888: @210138
     /* 210138 */ GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(210211),
     /* 210143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210149 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(210168), // Rule ID 954 //
     /* 210154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210161 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSDIVSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVSP),
     /* 210166 */     GIR_RootConstrainSelectedInstOperands,
     /* 210167 */     // GIR_Coverage, 954,
     /* 210167 */     GIR_Done,
     /* 210168 */   // Label 2895: @210168
     /* 210168 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(210191), // Rule ID 242 //
     /* 210173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210180 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FDIVS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 210180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIVS),
     /* 210185 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210189 */     GIR_RootConstrainSelectedInstOperands,
     /* 210190 */     // GIR_Coverage, 242,
     /* 210190 */     GIR_Done,
     /* 210191 */   // Label 2896: @210191
     /* 210191 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(210210), // Rule ID 590 //
     /* 210196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 210203 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSDIV:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 210203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSDIV),
     /* 210208 */     GIR_RootConstrainSelectedInstOperands,
     /* 210209 */     // GIR_Coverage, 590,
     /* 210209 */     GIR_Done,
     /* 210210 */   // Label 2897: @210210
     /* 210210 */   GIM_Reject,
     /* 210211 */ // Label 2894: @210211
     /* 210211 */ GIM_Reject,
     /* 210212 */ // Label 2889: @210212
     /* 210212 */ GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(210289),
     /* 210217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 210220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210223 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(210246), // Rule ID 806 //
     /* 210228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210235 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSDIVDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVDP),
     /* 210240 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210244 */     GIR_RootConstrainSelectedInstOperands,
     /* 210245 */     // GIR_Coverage, 806,
     /* 210245 */     GIR_Done,
     /* 210246 */   // Label 2899: @210246
     /* 210246 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(210269), // Rule ID 240 //
     /* 210251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210258 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FDIV:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 210258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIV),
     /* 210263 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210267 */     GIR_RootConstrainSelectedInstOperands,
     /* 210268 */     // GIR_Coverage, 240,
     /* 210268 */     GIR_Done,
     /* 210269 */   // Label 2900: @210269
     /* 210269 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(210288), // Rule ID 569 //
     /* 210274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 210281 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDDIV:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 210281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDDIV),
     /* 210286 */     GIR_RootConstrainSelectedInstOperands,
     /* 210287 */     // GIR_Coverage, 569,
     /* 210287 */     GIR_Done,
     /* 210288 */   // Label 2901: @210288
     /* 210288 */   GIM_Reject,
     /* 210289 */ // Label 2898: @210289
     /* 210289 */ GIM_Reject,
     /* 210290 */ // Label 2890: @210290
     /* 210290 */ GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(210315), // Rule ID 989 //
     /* 210295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 210301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 210304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 210308 */   // (strict_fdiv:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVQP),
     /* 210313 */   GIR_RootConstrainSelectedInstOperands,
     /* 210314 */   // GIR_Coverage, 989,
     /* 210314 */   GIR_Done,
     /* 210315 */ // Label 2902: @210315
     /* 210315 */ GIM_Reject,
     /* 210316 */ // Label 2891: @210316
     /* 210316 */ GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(210345), // Rule ID 815 //
     /* 210321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210334 */   // (strict_fdiv:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVDIVDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /* 210339 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210343 */   GIR_RootConstrainSelectedInstOperands,
     /* 210344 */   // GIR_Coverage, 815,
     /* 210344 */   GIR_Done,
     /* 210345 */ // Label 2903: @210345
     /* 210345 */ GIM_Reject,
     /* 210346 */ // Label 2892: @210346
     /* 210346 */ GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(210375), // Rule ID 817 //
     /* 210351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210364 */   // (strict_fdiv:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVDIVSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /* 210369 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210373 */   GIR_RootConstrainSelectedInstOperands,
     /* 210374 */   // GIR_Coverage, 817,
     /* 210374 */   GIR_Done,
     /* 210375 */ // Label 2904: @210375
     /* 210375 */ GIM_Reject,
     /* 210376 */ // Label 2893: @210376
     /* 210376 */ GIM_Reject,
     /* 210377 */ // Label 80: @210377
     /* 210377 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2910*/ GIMT_Encode4(210934),
     /* 210388 */ /*GILLT_s32*//*Label 2905*/ GIMT_Encode4(210408),
     /* 210392 */ /*GILLT_s64*//*Label 2906*/ GIMT_Encode4(210554),
     /* 210396 */ /*GILLT_s128*//*Label 2907*/ GIMT_Encode4(210700),
     /* 210400 */ /*GILLT_v2s64*//*Label 2908*/ GIMT_Encode4(210778),
     /* 210404 */ /*GILLT_v4s32*//*Label 2909*/ GIMT_Encode4(210856),
     /* 210408 */ // Label 2905: @210408
     /* 210408 */ GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(210553),
     /* 210413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210419 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210422 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(210463), // Rule ID 964 //
     /* 210427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 210446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210448 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi))  =>  (XSMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBASP),
     /* 210451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 210457 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210459 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210461 */     GIR_RootConstrainSelectedInstOperands,
     /* 210462 */     // GIR_Coverage, 964,
     /* 210462 */     GIR_EraseRootFromParent_Done,
     /* 210463 */   // Label 2912: @210463
     /* 210463 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(210488), // Rule ID 962 //
     /* 210468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210475 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi)  =>  (XSMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDASP),
     /* 210478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210480 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 210482 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210484 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210486 */     GIR_RootConstrainSelectedInstOperands,
     /* 210487 */     // GIR_Coverage, 962,
     /* 210487 */     GIR_EraseRootFromParent_Done,
     /* 210488 */   // Label 2913: @210488
     /* 210488 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(210529), // Rule ID 224 //
     /* 210493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 210512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210514 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB))  =>  (FMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 210514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /* 210517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 210519 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 210521 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 210523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 210527 */     GIR_RootConstrainSelectedInstOperands,
     /* 210528 */     // GIR_Coverage, 224,
     /* 210528 */     GIR_EraseRootFromParent_Done,
     /* 210529 */   // Label 2914: @210529
     /* 210529 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(210552), // Rule ID 220 //
     /* 210534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210541 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)  =>  (FMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 210541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADDS),
     /* 210546 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210550 */     GIR_RootConstrainSelectedInstOperands,
     /* 210551 */     // GIR_Coverage, 220,
     /* 210551 */     GIR_Done,
     /* 210552 */   // Label 2915: @210552
     /* 210552 */   GIM_Reject,
     /* 210553 */ // Label 2911: @210553
     /* 210553 */ GIM_Reject,
     /* 210554 */ // Label 2906: @210554
     /* 210554 */ GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(210699),
     /* 210559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 210562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210565 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210568 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(210609), // Rule ID 785 //
     /* 210573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 210592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210594 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi))  =>  (XSMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBADP),
     /* 210597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 210603 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210605 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210607 */     GIR_RootConstrainSelectedInstOperands,
     /* 210608 */     // GIR_Coverage, 785,
     /* 210608 */     GIR_EraseRootFromParent_Done,
     /* 210609 */   // Label 2917: @210609
     /* 210609 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(210634), // Rule ID 783 //
     /* 210614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210621 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi)  =>  (XSMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDADP),
     /* 210624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210626 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 210628 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210630 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210632 */     GIR_RootConstrainSelectedInstOperands,
     /* 210633 */     // GIR_Coverage, 783,
     /* 210633 */     GIR_EraseRootFromParent_Done,
     /* 210634 */   // Label 2918: @210634
     /* 210634 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(210675), // Rule ID 222 //
     /* 210639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 210658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210660 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB))  =>  (FMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 210660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /* 210663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 210665 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 210667 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 210669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 210673 */     GIR_RootConstrainSelectedInstOperands,
     /* 210674 */     // GIR_Coverage, 222,
     /* 210674 */     GIR_EraseRootFromParent_Done,
     /* 210675 */   // Label 2919: @210675
     /* 210675 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(210698), // Rule ID 218 //
     /* 210680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210687 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)  =>  (FMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 210687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADD),
     /* 210692 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210696 */     GIR_RootConstrainSelectedInstOperands,
     /* 210697 */     // GIR_Coverage, 218,
     /* 210697 */     GIR_Done,
     /* 210698 */   // Label 2920: @210698
     /* 210698 */   GIM_Reject,
     /* 210699 */ // Label 2916: @210699
     /* 210699 */ GIM_Reject,
     /* 210700 */ // Label 2907: @210700
     /* 210700 */ GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(210777),
     /* 210705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 210708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 210711 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 210714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 210718 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(210755), // Rule ID 995 //
     /* 210723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 210738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210740 */     // (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQP),
     /* 210743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 210745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /* 210749 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 210751 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 210753 */     GIR_RootConstrainSelectedInstOperands,
     /* 210754 */     // GIR_Coverage, 995,
     /* 210754 */     GIR_EraseRootFromParent_Done,
     /* 210755 */   // Label 2922: @210755
     /* 210755 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(210776), // Rule ID 993 //
     /* 210760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210763 */     // (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQP),
     /* 210766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 210768 */     GIR_RootToRootCopy, /*OpIdx*/3, // RSTi
     /* 210770 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 210772 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 210774 */     GIR_RootConstrainSelectedInstOperands,
     /* 210775 */     // GIR_Coverage, 993,
     /* 210775 */     GIR_EraseRootFromParent_Done,
     /* 210776 */   // Label 2923: @210776
     /* 210776 */   GIM_Reject,
     /* 210777 */ // Label 2921: @210777
     /* 210777 */ GIM_Reject,
     /* 210778 */ // Label 2908: @210778
     /* 210778 */ GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(210855),
     /* 210783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210789 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 210792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210796 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(210833), // Rule ID 795 //
     /* 210801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210818 */     // (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi))  =>  (XVMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBADP),
     /* 210821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 210827 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210829 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210831 */     GIR_RootConstrainSelectedInstOperands,
     /* 210832 */     // GIR_Coverage, 795,
     /* 210832 */     GIR_EraseRootFromParent_Done,
     /* 210833 */   // Label 2925: @210833
     /* 210833 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(210854), // Rule ID 791 //
     /* 210838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210841 */     // (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi)  =>  (XVMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDADP),
     /* 210844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210846 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 210848 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210850 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210852 */     GIR_RootConstrainSelectedInstOperands,
     /* 210853 */     // GIR_Coverage, 791,
     /* 210853 */     GIR_EraseRootFromParent_Done,
     /* 210854 */   // Label 2926: @210854
     /* 210854 */   GIM_Reject,
     /* 210855 */ // Label 2924: @210855
     /* 210855 */ GIM_Reject,
     /* 210856 */ // Label 2909: @210856
     /* 210856 */ GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(210933),
     /* 210861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210867 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210874 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(210911), // Rule ID 797 //
     /* 210879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210896 */     // (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi))  =>  (XVMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBASP),
     /* 210899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 210905 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210907 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210909 */     GIR_RootConstrainSelectedInstOperands,
     /* 210910 */     // GIR_Coverage, 797,
     /* 210910 */     GIR_EraseRootFromParent_Done,
     /* 210911 */   // Label 2928: @210911
     /* 210911 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(210932), // Rule ID 793 //
     /* 210916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210919 */     // (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi)  =>  (XVMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDASP),
     /* 210922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210924 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 210926 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210928 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210930 */     GIR_RootConstrainSelectedInstOperands,
     /* 210931 */     // GIR_Coverage, 793,
     /* 210931 */     GIR_EraseRootFromParent_Done,
     /* 210932 */   // Label 2929: @210932
     /* 210932 */   GIM_Reject,
     /* 210933 */ // Label 2927: @210933
     /* 210933 */ GIM_Reject,
     /* 210934 */ // Label 2910: @210934
     /* 210934 */ GIM_Reject,
     /* 210935 */ // Label 81: @210935
     /* 210935 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2935*/ GIMT_Encode4(211151),
     /* 210946 */ /*GILLT_s32*//*Label 2930*/ GIMT_Encode4(210966),
     /* 210950 */ /*GILLT_s64*//*Label 2931*/ GIMT_Encode4(211018),
     /* 210954 */ /*GILLT_s128*//*Label 2932*/ GIMT_Encode4(211074),
     /* 210958 */ /*GILLT_v2s64*//*Label 2933*/ GIMT_Encode4(211097),
     /* 210962 */ /*GILLT_v4s32*//*Label 2934*/ GIMT_Encode4(211124),
     /* 210966 */ // Label 2930: @210966
     /* 210966 */ GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(211017),
     /* 210971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210974 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(210993), // Rule ID 959 //
     /* 210979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210986 */     // (strict_fsqrt:{ *:[f32] } f32:{ *:[f32] }:$XB)  =>  (XSSQRTSP:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 210986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTSP),
     /* 210991 */     GIR_RootConstrainSelectedInstOperands,
     /* 210992 */     // GIR_Coverage, 959,
     /* 210992 */     GIR_Done,
     /* 210993 */   // Label 2937: @210993
     /* 210993 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(211016), // Rule ID 161 //
     /* 210998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 211001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 211005 */     // (strict_fsqrt:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FSQRTS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 211005 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRTS),
     /* 211010 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211014 */     GIR_RootConstrainSelectedInstOperands,
     /* 211015 */     // GIR_Coverage, 161,
     /* 211015 */     GIR_Done,
     /* 211016 */   // Label 2938: @211016
     /* 211016 */   GIM_Reject,
     /* 211017 */ // Label 2936: @211017
     /* 211017 */ GIM_Reject,
     /* 211018 */ // Label 2931: @211018
     /* 211018 */ GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(211073),
     /* 211023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 211026 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(211049), // Rule ID 808 //
     /* 211031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 211038 */     // (strict_fsqrt:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSSQRTDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 211038 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTDP),
     /* 211043 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211047 */     GIR_RootConstrainSelectedInstOperands,
     /* 211048 */     // GIR_Coverage, 808,
     /* 211048 */     GIR_Done,
     /* 211049 */   // Label 2940: @211049
     /* 211049 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(211072), // Rule ID 159 //
     /* 211054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 211057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 211061 */     // (strict_fsqrt:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FSQRT:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 211061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRT),
     /* 211066 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211070 */     GIR_RootConstrainSelectedInstOperands,
     /* 211071 */     // GIR_Coverage, 159,
     /* 211071 */     GIR_Done,
     /* 211072 */   // Label 2941: @211072
     /* 211072 */   GIM_Reject,
     /* 211073 */ // Label 2939: @211073
     /* 211073 */ GIM_Reject,
     /* 211074 */ // Label 2932: @211074
     /* 211074 */ GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(211096), // Rule ID 991 //
     /* 211079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 211082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 211085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 211089 */   // (strict_fsqrt:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSSQRTQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 211089 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQP),
     /* 211094 */   GIR_RootConstrainSelectedInstOperands,
     /* 211095 */   // GIR_Coverage, 991,
     /* 211095 */   GIR_Done,
     /* 211096 */ // Label 2942: @211096
     /* 211096 */ GIM_Reject,
     /* 211097 */ // Label 2933: @211097
     /* 211097 */ GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(211123), // Rule ID 819 //
     /* 211102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 211108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 211112 */   // (strict_fsqrt:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVSQRTDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 211112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTDP),
     /* 211117 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211121 */   GIR_RootConstrainSelectedInstOperands,
     /* 211122 */   // GIR_Coverage, 819,
     /* 211122 */   GIR_Done,
     /* 211123 */ // Label 2943: @211123
     /* 211123 */ GIM_Reject,
     /* 211124 */ // Label 2934: @211124
     /* 211124 */ GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(211150), // Rule ID 821 //
     /* 211129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 211135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 211139 */   // (strict_fsqrt:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVSQRTSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 211139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTSP),
     /* 211144 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211148 */   GIR_RootConstrainSelectedInstOperands,
     /* 211149 */   // GIR_Coverage, 821,
     /* 211149 */   GIR_Done,
     /* 211150 */ // Label 2944: @211150
     /* 211150 */ GIM_Reject,
     /* 211151 */ // Label 2935: @211151
     /* 211151 */ GIM_Reject,
     /* 211152 */ // Label 82: @211152
     /* 211152 */ GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(211164), // Rule ID 72 //
     /* 211157 */   // (trap)  =>  (TRAP)
     /* 211157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::TRAP),
     /* 211162 */   GIR_RootConstrainSelectedInstOperands,
     /* 211163 */   // GIR_Coverage, 72,
     /* 211163 */   GIR_Done,
     /* 211164 */ // Label 2945: @211164
     /* 211164 */ GIM_Reject,
     /* 211165 */ // Label 83: @211165
     /* 211165 */ GIM_Reject,
     /* 211166 */ }; // Size: 211166 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const PPCSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const PPCSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
